/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/position","vs/editor/common/core/offsetRange","vs/base/common/arrays","vs/base/common/strings","vs/base/common/arraysFind","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/map","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/textLength","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/positionToOffset","vs/editor/common/core/textEdit","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],se=function(C){for(var t=[],i=0,M=C.length;i<M;i++)t[i]=ie[C[i]];return t};const Ge=this,Ze=typeof global=="object"?global:{};var $e;(function(C){C.global=Ge;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof C.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}C.Environment=t})($e||($e={}));var $e;(function(C){class t{constructor(c,$,g){this.type=c,this.detail=$,this.timestamp=g}}C.LoaderEvent=t;class i{constructor(c){this._events=[new t(1,"",c)]}record(c,$){this._events.push(new t(c,$,C.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}C.LoaderEventRecorder=i;class M{record(c,$){}getEvents(){return[]}}M.INSTANCE=new M,C.NullLoaderEventRecorder=M})($e||($e={}));var $e;(function(C){class t{static fileUriToFilePath(M,R){if(R=decodeURI(R).replace(/%23/g,"#"),M){if(/^file:\/\/\//.test(R))return R.substr(8);if(/^file:\/\//.test(R))return R.substr(5)}else if(/^file:\/\//.test(R))return R.substr(7);return R}static startsWith(M,R){return M.length>=R.length&&M.substr(0,R.length)===R}static endsWith(M,R){return M.length>=R.length&&M.substr(M.length-R.length)===R}static containsQueryString(M){return/^[^\#]*\?/gi.test(M)}static isAbsolutePath(M){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(M)}static forEachProperty(M,R){if(M){let c;for(c in M)M.hasOwnProperty(c)&&R(c,M[c])}}static isEmpty(M){let R=!0;return t.forEachProperty(M,()=>{R=!1}),R}static recursiveClone(M){if(!M||typeof M!="object"||M instanceof RegExp||!Array.isArray(M)&&Object.getPrototypeOf(M)!==Object.prototype)return M;let R=Array.isArray(M)?[]:{};return t.forEachProperty(M,(c,$)=>{$&&typeof $=="object"?R[c]=t.recursiveClone($):R[c]=$}),R}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(M){return t.startsWith(M,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=C.global.performance&&typeof C.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?C.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,C.Utilities=t})($e||($e={}));var $e;(function(C){function t(R){if(R instanceof Error)return R;const c=new Error(R.message||String(R)||"Unknown Error");return R.stack&&(c.stack=R.stack),c}C.ensureError=t;class i{static validateConfigurationOptions(c){function $(g){if(g.phase==="loading"){console.error('Loading "'+g.moduleId+'" failed'),console.error(g),console.error("Here are the modules that depend on it:"),console.error(g.neededBy);return}if(g.phase==="factory"){console.error('The factory function of "'+g.moduleId+'" has thrown an exception'),console.error(g),console.error("Here are the modules that depend on it:"),console.error(g.neededBy);return}}if(c=c||{},typeof c.baseUrl!="string"&&(c.baseUrl=""),typeof c.isBuild!="boolean"&&(c.isBuild=!1),typeof c.paths!="object"&&(c.paths={}),typeof c.config!="object"&&(c.config={}),typeof c.catchError>"u"&&(c.catchError=!1),typeof c.recordStats>"u"&&(c.recordStats=!1),typeof c.urlArgs!="string"&&(c.urlArgs=""),typeof c.onError!="function"&&(c.onError=$),Array.isArray(c.ignoreDuplicateModules)||(c.ignoreDuplicateModules=[]),c.baseUrl.length>0&&(C.Utilities.endsWith(c.baseUrl,"/")||(c.baseUrl+="/")),typeof c.cspNonce!="string"&&(c.cspNonce=""),typeof c.preferScriptTags>"u"&&(c.preferScriptTags=!1),c.nodeCachedData&&typeof c.nodeCachedData=="object"&&(typeof c.nodeCachedData.seed!="string"&&(c.nodeCachedData.seed="seed"),(typeof c.nodeCachedData.writeDelay!="number"||c.nodeCachedData.writeDelay<0)&&(c.nodeCachedData.writeDelay=1e3*7),!c.nodeCachedData.path||typeof c.nodeCachedData.path!="string")){const g=t(new Error("INVALID cached data configuration, 'path' MUST be set"));g.phase="configuration",c.onError(g),c.nodeCachedData=void 0}return c}static mergeConfigurationOptions(c=null,$=null){let g=C.Utilities.recursiveClone($||{});return C.Utilities.forEachProperty(c,(a,u)=>{a==="ignoreDuplicateModules"&&typeof g.ignoreDuplicateModules<"u"?g.ignoreDuplicateModules=g.ignoreDuplicateModules.concat(u):a==="paths"&&typeof g.paths<"u"?C.Utilities.forEachProperty(u,(o,N)=>g.paths[o]=N):a==="config"&&typeof g.config<"u"?C.Utilities.forEachProperty(u,(o,N)=>g.config[o]=N):g[a]=C.Utilities.recursiveClone(u)}),i.validateConfigurationOptions(g)}}C.ConfigurationOptionsUtil=i;class M{constructor(c,$){if(this._env=c,this.options=i.mergeConfigurationOptions($),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let g=this.options.nodeRequire.main.filename,a=Math.max(g.lastIndexOf("/"),g.lastIndexOf("\\"));this.options.baseUrl=g.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let c=0;c<this.options.ignoreDuplicateModules.length;c++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[c]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],C.Utilities.forEachProperty(this.options.paths,(c,$)=>{Array.isArray($)?this.sortedPathsRules.push({from:c,to:$}):this.sortedPathsRules.push({from:c,to:[$]})}),this.sortedPathsRules.sort((c,$)=>$.from.length-c.from.length)}cloneAndMerge(c){return new M(this._env,i.mergeConfigurationOptions(c,this.options))}getOptionsLiteral(){return this.options}_applyPaths(c){let $;for(let g=0,a=this.sortedPathsRules.length;g<a;g++)if($=this.sortedPathsRules[g],C.Utilities.startsWith(c,$.from)){let u=[];for(let o=0,N=$.to.length;o<N;o++)u.push($.to[o]+c.substr($.from.length));return u}return[c]}_addUrlArgsToUrl(c){return C.Utilities.containsQueryString(c)?c+"&"+this.options.urlArgs:c+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(c){return this.options.urlArgs?this._addUrlArgsToUrl(c):c}_addUrlArgsIfNecessaryToUrls(c){if(this.options.urlArgs)for(let $=0,g=c.length;$<g;$++)c[$]=this._addUrlArgsToUrl(c[$]);return c}moduleIdToPaths(c){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(c))return this.isBuild()?["empty:"]:["node|"+c];let $=c,g;if(!C.Utilities.endsWith($,".js")&&!C.Utilities.isAbsolutePath($)){g=this._applyPaths($);for(let a=0,u=g.length;a<u;a++)this.isBuild()&&g[a]==="empty:"||(C.Utilities.isAbsolutePath(g[a])||(g[a]=this.options.baseUrl+g[a]),!C.Utilities.endsWith(g[a],".js")&&!C.Utilities.containsQueryString(g[a])&&(g[a]=g[a]+".js"))}else!C.Utilities.endsWith($,".js")&&!C.Utilities.containsQueryString($)&&($=$+".js"),g=[$];return this._addUrlArgsIfNecessaryToUrls(g)}requireToUrl(c){let $=c;return C.Utilities.isAbsolutePath($)||($=this._applyPaths($)[0],C.Utilities.isAbsolutePath($)||($=this.options.baseUrl+$)),this._addUrlArgsIfNecessaryToUrl($)}isBuild(){return this.options.isBuild}shouldInvokeFactory(c){return!!(!this.options.isBuild||C.Utilities.isAnonymousModule(c)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[c])}isDuplicateMessageIgnoredFor(c){return this.ignoreDuplicateModulesMap.hasOwnProperty(c)}getConfigForModule(c){if(this.options.config)return this.options.config[c]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(c){this.options.onError(c)}}C.Configuration=M})($e||($e={}));var $e;(function(C){class t{constructor(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}load(u,o,N,d){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new R;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=u.getConfig().getOptionsLiteral();e?this._scriptLoader=new i:this._scriptLoader=new c(this._env)}else this._env.isNode?this._scriptLoader=new c(this._env):this._scriptLoader=new i;let b={callback:N,errorback:d};if(this._callbackMap.hasOwnProperty(o)){this._callbackMap[o].push(b);return}this._callbackMap[o]=[b],this._scriptLoader.load(u,o,()=>this.triggerCallback(o),e=>this.triggerErrorback(o,e))}triggerCallback(u){let o=this._callbackMap[u];delete this._callbackMap[u];for(let N=0;N<o.length;N++)o[N].callback()}triggerErrorback(u,o){let N=this._callbackMap[u];delete this._callbackMap[u];for(let d=0;d<N.length;d++)N[d].errorback(o)}}class i{attachListeners(u,o,N){let d=()=>{u.removeEventListener("load",b),u.removeEventListener("error",e)},b=m=>{d(),o()},e=m=>{d(),N(m)};u.addEventListener("load",b),u.addEventListener("error",e)}load(u,o,N,d){if(/^node\|/.test(o)){let b=u.getConfig().getOptionsLiteral(),e=$(u.getRecorder(),b.nodeRequire||C.global.nodeRequire),m=o.split("|"),S=null;try{S=e(m[1])}catch(j){d(j);return}u.enqueueDefineAnonymousModule([],()=>S),N()}else{let b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript"),this.attachListeners(b,N,d);const{trustedTypesPolicy:e}=u.getConfig().getOptionsLiteral();e&&(o=e.createScriptURL(o)),b.setAttribute("src",o);const{cspNonce:m}=u.getConfig().getOptionsLiteral();m&&b.setAttribute("nonce",m),document.getElementsByTagName("head")[0].appendChild(b)}}}function M(a){const{trustedTypesPolicy:u}=a.getConfig().getOptionsLiteral();try{return(u?self.eval(u.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class R{constructor(){this._cachedCanUseEval=null}_canUseEval(u){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=M(u)),this._cachedCanUseEval}load(u,o,N,d){if(/^node\|/.test(o)){const b=u.getConfig().getOptionsLiteral(),e=$(u.getRecorder(),b.nodeRequire||C.global.nodeRequire),m=o.split("|");let S=null;try{S=e(m[1])}catch(j){d(j);return}u.enqueueDefineAnonymousModule([],function(){return S}),N()}else{const{trustedTypesPolicy:b}=u.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(o)&&o.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(u)){fetch(o).then(m=>{if(m.status!==200)throw new Error(m.statusText);return m.text()}).then(m=>{m=`${m}
//# sourceURL=${o}`,(b?self.eval(b.createScript("",m)):new Function(m)).call(self),N()}).then(void 0,d);return}try{b&&(o=b.createScriptURL(o)),importScripts(o),N()}catch(m){d(m)}}}}class c{constructor(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))}_initNodeRequire(u,o){const{nodeCachedData:N}=o.getConfig().getOptionsLiteral();if(!N||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const d=this,b=u("module");function e(m){const S=m.constructor;let j=function(w){try{return m.require(w)}finally{}};return j.resolve=function(w,p){return S._resolveFilename(w,m,!1,p)},j.resolve.paths=function(w){return S._resolveLookupPaths(w,m)},j.main=process.mainModule,j.extensions=S._extensions,j.cache=S._cache,j}b.prototype._compile=function(m,S){const j=b.wrap(m.replace(/^#!.*/,"")),v=o.getRecorder(),w=d._getCachedDataPath(N,S),p={filename:S};let l;try{const A=d._fs.readFileSync(w);l=A.slice(0,16),p.cachedData=A.slice(16),v.record(60,w)}catch{v.record(61,w)}const n=new d._vm.Script(j,p),s=n.runInThisContext(p),f=d._path.dirname(S),h=e(this),L=[this.exports,h,this,S,f,process,Ze,Buffer],E=s.apply(this.exports,L);return d._handleCachedData(n,j,w,!p.cachedData,o),d._verifyCachedData(n,j,w,l,o),E}}load(u,o,N,d){const b=u.getConfig().getOptionsLiteral(),e=$(u.getRecorder(),b.nodeRequire||C.global.nodeRequire),m=b.nodeInstrumenter||function(j){return j};this._init(e),this._initNodeRequire(e,u);let S=u.getRecorder();if(/^node\|/.test(o)){let j=o.split("|"),v=null;try{v=e(j[1])}catch(w){d(w);return}u.enqueueDefineAnonymousModule([],()=>v),N()}else{o=C.Utilities.fileUriToFilePath(this._env.isWindows,o);const j=this._path.normalize(o),v=this._getElectronRendererScriptPathOrUri(j),w=!!b.nodeCachedData,p=w?this._getCachedDataPath(b.nodeCachedData,o):void 0;this._readSourceAndCachedData(j,p,S,(l,n,s,f)=>{if(l){d(l);return}let h;n.charCodeAt(0)===c._BOM?h=c._PREFIX+n.substring(1)+c._SUFFIX:h=c._PREFIX+n+c._SUFFIX,h=m(h,j);const L={filename:v,cachedData:s},E=this._createAndEvalScript(u,h,L,N,d);this._handleCachedData(E,h,p,w&&!s,u),this._verifyCachedData(E,h,p,f,u)})}}_createAndEvalScript(u,o,N,d,b){const e=u.getRecorder();e.record(31,N.filename);const m=new this._vm.Script(o,N),S=m.runInThisContext(N),j=u.getGlobalAMDDefineFunc();let v=!1;const w=function(){return v=!0,j.apply(null,arguments)};return w.amd=j.amd,S.call(C.global,u.getGlobalAMDRequireFunc(),w,N.filename,this._path.dirname(N.filename)),e.record(32,N.filename),v?d():b(new Error(`Didn't receive define call in ${N.filename}!`)),m}_getElectronRendererScriptPathOrUri(u){if(!this._env.isElectronRenderer)return u;let o=u.match(/^([a-z])\:(.*)/i);return o?`file:///${(o[1].toUpperCase()+":"+o[2]).replace(/\\/g,"/")}`:`file://${u}`}_getCachedDataPath(u,o){const N=this._crypto.createHash("md5").update(o,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),d=this._path.basename(o).replace(/\.js$/,"");return this._path.join(u.path,`${d}-${N}.code`)}_handleCachedData(u,o,N,d,b){u.cachedDataRejected?this._fs.unlink(N,e=>{b.getRecorder().record(62,N),this._createAndWriteCachedData(u,o,N,b),e&&b.getConfig().onError(e)}):d&&this._createAndWriteCachedData(u,o,N,b)}_createAndWriteCachedData(u,o,N,d){let b=Math.ceil(d.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,m=0,S;const j=()=>{setTimeout(()=>{S||(S=this._crypto.createHash("md5").update(o,"utf8").digest());const v=u.createCachedData();if(!(v.length===0||v.length===e||m>=5)){if(v.length<e){j();return}e=v.length,this._fs.writeFile(N,Buffer.concat([S,v]),w=>{w&&d.getConfig().onError(w),d.getRecorder().record(63,N),j()})}},b*Math.pow(4,m++))};j()}_readSourceAndCachedData(u,o,N,d){if(!o)this._fs.readFile(u,{encoding:"utf8"},d);else{let b,e,m,S=2;const j=v=>{v?d(v):--S===0&&d(void 0,b,e,m)};this._fs.readFile(u,{encoding:"utf8"},(v,w)=>{b=w,j(v)}),this._fs.readFile(o,(v,w)=>{!v&&w&&w.length>0?(m=w.slice(0,16),e=w.slice(16),N.record(60,o)):N.record(61,o),j()})}}_verifyCachedData(u,o,N,d,b){d&&(u.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(o,"utf8").digest();d.equals(e)||(b.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${N}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(N,m=>{m&&b.getConfig().onError(m)}))},Math.ceil(5e3*(1+Math.random()))))}}c._BOM=65279,c._PREFIX="(function (require, define, __filename, __dirname) { ",c._SUFFIX=`
});`;function $(a,u){if(u.__$__isRecorded)return u;const o=function(d){a.record(33,d);try{return u(d)}finally{a.record(34,d)}};return o.__$__isRecorded=!0,o}C.ensureRecordedNodeRequire=$;function g(a){return new t(a)}C.createScriptLoader=g})($e||($e={}));var $e;(function(C){class t{constructor(a){let u=a.lastIndexOf("/");u!==-1?this.fromModulePath=a.substr(0,u+1):this.fromModulePath=""}static _normalizeModuleId(a){let u=a,o;for(o=/\/\.\//;o.test(u);)u=u.replace(o,"/");for(u=u.replace(/^\.\//g,""),o=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;o.test(u);)u=u.replace(o,"/");return u=u.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),u}resolveModule(a){let u=a;return C.Utilities.isAbsolutePath(u)||(C.Utilities.startsWith(u,"./")||C.Utilities.startsWith(u,"../"))&&(u=t._normalizeModuleId(this.fromModulePath+u)),u}}t.ROOT=new t(""),C.ModuleIdResolver=t;class i{constructor(a,u,o,N,d,b){this.id=a,this.strId=u,this.dependencies=o,this._callback=N,this._errorback=d,this.moduleIdResolver=b,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,u){try{return{returnedValue:a.apply(C.global,u),producedError:null}}catch(o){return{returnedValue:null,producedError:o}}}static _invokeFactory(a,u,o,N){return a.shouldInvokeFactory(u)?a.shouldCatchError()?this._safeInvokeFunction(o,N):{returnedValue:o.apply(C.global,N),producedError:null}:{returnedValue:null,producedError:null}}complete(a,u,o,N){this._isComplete=!0;let d=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let b=i._invokeFactory(u,this.strId,this._callback,o);d=b.producedError,a.record(22,this.strId),!d&&typeof b.returnedValue<"u"&&(!this.exportsPassedIn||C.Utilities.isEmpty(this.exports))&&(this.exports=b.returnedValue)}else this.exports=this._callback;if(d){let b=C.ensureError(d);b.phase="factory",b.moduleId=this.strId,b.neededBy=N(this.id),this.error=b,u.onError(b)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}C.Module=i;class M{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let u=this._strModuleIdToIntModuleId.get(a);return typeof u>"u"&&(u=this._nextId++,this._strModuleIdToIntModuleId.set(a,u),this._intModuleIdToStrModuleId[u]=a),u}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class R{constructor(a){this.id=a}}R.EXPORTS=new R(0),R.MODULE=new R(1),R.REQUIRE=new R(2),C.RegularDependency=R;class c{constructor(a,u,o){this.id=a,this.pluginId=u,this.pluginParam=o}}C.PluginDependency=c;class ${constructor(a,u,o,N,d=0){this._env=a,this._scriptLoader=u,this._loaderAvailableTimestamp=d,this._defineFunc=o,this._requireFunc=N,this._moduleIdProvider=new M,this._config=new C.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new $(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,u){let o=b=>b.replace(/\\/g,"/"),N=o(a),d=u.split(/\n/);for(let b=0;b<d.length;b++){let e=d[b].match(/(.*):(\d+):(\d+)\)?$/);if(e){let m=e[1],S=e[2],j=e[3],v=Math.max(m.lastIndexOf(" ")+1,m.lastIndexOf("(")+1);if(m=m.substr(v),m=o(m),m===N){let w={line:parseInt(S,10),col:parseInt(j,10)};return w.line===1&&(w.col-=53),w}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],u=0;for(let o=0,N=this._modules2.length;o<N;o++){let d=this._modules2[o];if(!d)continue;let b=this._buildInfoPath[d.id]||null,e=this._buildInfoDefineStack[d.id]||null,m=this._buildInfoDependencies[d.id];a[u++]={id:d.strId,path:b,defineLocation:b&&e?$._findRelevantLocationInStack(b,e):null,dependencies:m,shim:null,exports:d.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new C.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=C.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,u){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let o=null;this._config.isBuild()&&(o=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:o,dependencies:a,callback:u}}defineModule(a,u,o,N,d,b=new t(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let m=new i(e,a,this._normalizeDependencies(u,b),o,N,b);this._modules2[e]=m,this._config.isBuild()&&(this._buildInfoDefineStack[e]=d,this._buildInfoDependencies[e]=(m.dependencies||[]).map(S=>this._moduleIdProvider.getStrModuleId(S.id))),this._resolve(m)}_normalizeDependency(a,u){if(a==="exports")return R.EXPORTS;if(a==="module")return R.MODULE;if(a==="require")return R.REQUIRE;let o=a.indexOf("!");if(o>=0){let N=u.resolveModule(a.substr(0,o)),d=u.resolveModule(a.substr(o+1)),b=this._moduleIdProvider.getModuleId(N+"!"+d),e=this._moduleIdProvider.getModuleId(N);return new c(b,e,d)}return new R(this._moduleIdProvider.getModuleId(u.resolveModule(a)))}_normalizeDependencies(a,u){let o=[],N=0;for(let d=0,b=a.length;d<b;d++)o[N++]=this._normalizeDependency(a[d],u);return o}_relativeRequire(a,u,o,N){if(typeof u=="string")return this.synchronousRequire(u,a);this.defineModule(C.Utilities.generateAnonymousModule(),u,o,N,null,a)}synchronousRequire(a,u=new t(a)){let o=this._normalizeDependency(a,u),N=this._modules2[o.id];if(!N)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!N.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(N.error)throw N.error;return N.exports}configure(a,u){let o=this._config.shouldRecordStats();u?this._config=new C.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!o&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let u=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),u.dependencies,u.callback,null,u.stack)}}_createLoadError(a,u){let o=this._moduleIdProvider.getStrModuleId(a),N=(this._inverseDependencies2[a]||[]).map(b=>this._moduleIdProvider.getStrModuleId(b));const d=C.ensureError(u);return d.phase="loading",d.moduleId=o,d.neededBy=N,d}_onLoadError(a,u){const o=this._createLoadError(a,u);this._modules2[a]||(this._modules2[a]=new i(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let N=[];for(let e=0,m=this._moduleIdProvider.getMaxModuleId();e<m;e++)N[e]=!1;let d=!1,b=[];for(b.push(a),N[a]=!0;b.length>0;){let e=b.shift(),m=this._modules2[e];m&&(d=m.onDependencyError(o)||d);let S=this._inverseDependencies2[e];if(S)for(let j=0,v=S.length;j<v;j++){let w=S[j];N[w]||(b.push(w),N[w]=!0)}}d||this._config.onError(o)}_hasDependencyPath(a,u){let o=this._modules2[a];if(!o)return!1;let N=[];for(let b=0,e=this._moduleIdProvider.getMaxModuleId();b<e;b++)N[b]=!1;let d=[];for(d.push(o),N[a]=!0;d.length>0;){let e=d.shift().dependencies;if(e)for(let m=0,S=e.length;m<S;m++){let j=e[m];if(j.id===u)return!0;let v=this._modules2[j.id];v&&!N[j.id]&&(N[j.id]=!0,d.push(v))}}return!1}_findCyclePath(a,u,o){if(a===u||o===50)return[a];let N=this._modules2[a];if(!N)return null;let d=N.dependencies;if(d)for(let b=0,e=d.length;b<e;b++){let m=this._findCyclePath(d[b].id,u,o+1);if(m!==null)return m.push(a),m}return null}_createRequire(a){let u=(o,N,d)=>this._relativeRequire(a,o,N,d);return u.toUrl=o=>this._config.requireToUrl(a.resolveModule(o)),u.getStats=()=>this.getLoaderEvents(),u.hasDependencyCycle=()=>this._hasDependencyCycle,u.config=(o,N=!1)=>{this.configure(o,N)},u.__$__nodeRequire=C.global.nodeRequire,u}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let u=this._moduleIdProvider.getStrModuleId(a),o=this._config.moduleIdToPaths(u),N=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(u.indexOf("/")===-1||N.test(u))&&o.push("node|"+u);let d=-1,b=e=>{if(d++,d>=o.length)this._onLoadError(a,e);else{let m=o[d],S=this.getRecorder();if(this._config.isBuild()&&m==="empty:"){this._buildInfoPath[a]=m,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}S.record(10,m),this._scriptLoader.load(this,m,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=m),S.record(11,m),this._onLoad(a)},j=>{S.record(12,m),b(j)})}};b(null)}_loadPluginDependency(a,u){if(this._modules2[u.id]||this._knownModules2[u.id])return;this._knownModules2[u.id]=!0;let o=N=>{this.defineModule(this._moduleIdProvider.getStrModuleId(u.id),[],N,null,null)};o.error=N=>{this._config.onError(this._createLoadError(u.id,N))},a.load(u.pluginParam,this._createRequire(t.ROOT),o,this._config.getOptionsLiteral())}_resolve(a){let u=a.dependencies;if(u)for(let o=0,N=u.length;o<N;o++){let d=u[o];if(d===R.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(d===R.MODULE){a.unresolvedDependenciesCount--;continue}if(d===R.REQUIRE){a.unresolvedDependenciesCount--;continue}let b=this._modules2[d.id];if(b&&b.isComplete()){if(b.error){a.onDependencyError(b.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(d.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(d.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(d.id,a.id,0)||[];e.reverse(),e.push(d.id),console.warn(e.map(m=>this._moduleIdProvider.getStrModuleId(m)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[d.id]=this._inverseDependencies2[d.id]||[],this._inverseDependencies2[d.id].push(a.id),d instanceof c){let e=this._modules2[d.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,d);continue}let m=this._inversePluginDependencies2.get(d.pluginId);m||(m=[],this._inversePluginDependencies2.set(d.pluginId,m)),m.push(d),this._loadModule(d.pluginId);continue}this._loadModule(d.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let u=this.getRecorder();if(a.isComplete())return;let o=a.dependencies,N=[];if(o)for(let m=0,S=o.length;m<S;m++){let j=o[m];if(j===R.EXPORTS){N[m]=a.exports;continue}if(j===R.MODULE){N[m]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(j===R.REQUIRE){N[m]=this._createRequire(a.moduleIdResolver);continue}let v=this._modules2[j.id];if(v){N[m]=v.exports;continue}N[m]=null}const d=m=>(this._inverseDependencies2[m]||[]).map(S=>this._moduleIdProvider.getStrModuleId(S));a.complete(u,this._config,N,d);let b=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,b)for(let m=0,S=b.length;m<S;m++){let j=b[m],v=this._modules2[j];v.unresolvedDependenciesCount--,v.unresolvedDependenciesCount===0&&this._onModuleComplete(v)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let m=0,S=e.length;m<S;m++)this._loadPluginDependency(a.exports,e[m])}}}C.ModuleManager=$})($e||($e={}));var ne,$e;(function(C){const t=new C.Environment;let i=null;const M=function(g,a,u){typeof g!="string"&&(u=a,a=g,g=null),(typeof a!="object"||!Array.isArray(a))&&(u=a,a=null),a||(a=["require","exports","module"]),g?i.defineModule(g,a,u,null,null):i.enqueueDefineAnonymousModule(a,u)};M.amd={jQuery:!0};const R=function(g,a=!1){i.configure(g,a)},c=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){R(arguments[0]);return}if(typeof arguments[0]=="string")return i.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){i.defineModule(C.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};c.config=R,c.getConfig=function(){return i.getConfig().getOptionsLiteral()},c.reset=function(){i=i.reset()},c.getBuildInfo=function(){return i.getBuildInfo()},c.getStats=function(){return i.getLoaderEvents()},c.define=M;function $(){if(typeof C.global.require<"u"||typeof require<"u"){const g=C.global.require||require;if(typeof g=="function"&&typeof g.resolve=="function"){const a=C.ensureRecordedNodeRequire(i.getRecorder(),g);C.global.nodeRequire=a,c.nodeRequire=a,c.__$__nodeRequire=a}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=c:(t.isElectronRenderer||(C.global.define=M),C.global.require=c)}C.init=$,(typeof C.global.define!="function"||!C.global.define.amd)&&(i=new C.ModuleManager(t,C.createScriptLoader(t),M,c,C.Utilities.getHighPerformanceTimestamp()),typeof C.global.require<"u"&&typeof C.global.require!="function"&&c.config(C.global.require),ne=function(){return M.apply(null,arguments)},ne.amd=M.amd,typeof doNotInitLoader>"u"&&$())})($e||($e={})),ne(ie[75],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=i;function i(g,a,u,o){if(o=o||{},(o["vs/css"]||{}).disabled){u({});return}const d=a.toUrl(g+".css");M(g,d,()=>{u({})},b=>{typeof u.error=="function"&&u.error("Could not find "+d+".")})}function M(g,a,u,o){if(R(g,a)){u();return}c(g,a,u,o)}function R(g,a){const u=window.document.getElementsByTagName("link");for(let o=0,N=u.length;o<N;o++){const d=u[o].getAttribute("data-name"),b=u[o].getAttribute("href");if(d===g||b===a)return!0}return!1}function c(g,a,u,o){const N=document.createElement("link");N.setAttribute("rel","stylesheet"),N.setAttribute("type","text/css"),N.setAttribute("data-name",g),$(g,N,u,o),N.setAttribute("href",a),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(N)}function $(g,a,u,o){const N=()=>{a.removeEventListener("load",d),a.removeEventListener("error",b)},d=e=>{N(),u()},b=e=>{N(),o(e)};a.addEventListener("load",d),a.addEventListener("error",b)}}),ne("vs/nls",["require","exports"],function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localize=o,t.localize2=N,t.getConfiguredDefaultLocale=d,t.setPseudoTranslation=b,t.create=e,t.load=m;let i=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const M="i-default";function R(S,j){let v;return j.length===0?v=S:v=S.replace(/\{(\d+)\}/g,(w,p)=>{const l=p[0],n=j[l];let s=w;return typeof n=="string"?s=n:(typeof n=="number"||typeof n=="boolean"||n===void 0||n===null)&&(s=String(n)),s}),i&&(v="\uFF3B"+v.replace(/[aouei]/g,"$&$&")+"\uFF3D"),v}function c(S,j){let v=S[j];return v||(v=S["*"],v)?v:null}function $(S){return S.charAt(S.length-1)==="/"?S:S+"/"}async function g(S,j,v){const w=$(S)+$(j)+"vscode/"+$(v),p=await fetch(w);if(p.ok)return await p.json();throw new Error(`${p.status} - ${p.statusText}`)}function a(S){return function(j,v){const w=Array.prototype.slice.call(arguments,2);return R(S[j],w)}}function u(S){return(j,v,...w)=>({value:R(S[j],w),original:R(v,w)})}function o(S,j,...v){return R(j,v)}function N(S,j,...v){const w=R(j,v);return{value:w,original:w}}function d(S){}function b(S){i=S}function e(S,j){return{localize:a(j[S]),localize2:u(j[S]),getConfiguredDefaultLocale:j.getConfiguredDefaultLocale??(v=>{})}}function m(S,j,v,w){const p=w["vs/nls"]??{};if(!S||S.length===0)return v({localize:o,localize2:N,getConfiguredDefaultLocale:()=>p.availableLanguages?.["*"]});const l=p.availableLanguages?c(p.availableLanguages,S):null,n=l===null||l===M;let s=".nls";n||(s=s+"."+l);const f=h=>{Array.isArray(h)?(h.localize=a(h),h.localize2=u(h)):(h.localize=a(h[S]),h.localize2=u(h[S])),h.getConfiguredDefaultLocale=()=>p.availableLanguages?.["*"],v(h)};typeof p.loadBundle=="function"?p.loadBundle(S,l,(h,L)=>{h?j([S+".nls"],f):f(L)}):p.translationServiceUrl&&!n?(async()=>{try{const h=await g(p.translationServiceUrl,l,S);return f(h)}catch(h){if(!l.includes("-"))return console.error(h),j([S+".nls"],f);try{const L=l.split("-")[0],E=await g(p.translationServiceUrl,L,S);return p.availableLanguages??={},p.availableLanguages["*"]=L,f(E)}catch(L){return console.error(L),j([S+".nls"],f)}}})():j([S+s],f,h=>{if(s===".nls"){console.error("Failed trying to load default language strings",h);return}console.error(`Failed to load message bundle for language ${l}. Falling back to the default language:`,h),j([S+".nls"],f)})}}),function(){const C=globalThis.MonacoEnvironment,t=C&&C.baseUrl?C.baseUrl:"../../../";function i(o,N){if(C?.createTrustedTypesPolicy)try{return C.createTrustedTypesPolicy(o,N)}catch(d){console.warn(d);return}try{return self.trustedTypes?.createPolicy(o,N)}catch(d){console.warn(d);return}}const M=i("amdLoader",{createScriptURL:o=>o,createScript:(o,...N)=>{const d=N.slice(0,-1).join(","),b=N.pop().toString();return`(function anonymous(${d}) { ${b}
})`}});function R(){try{return(M?globalThis.eval(M.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function c(){return new Promise((o,N)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return o();const d=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(d)&&d.substring(0,globalThis.origin.length)!==globalThis.origin)&&R()){fetch(d).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${d}`,(M?globalThis.eval(M.createScript("",e)):new Function(e)).call(globalThis),o()}).then(void 0,N);return}M?importScripts(M.createScriptURL(d)):importScripts(d),o()})}function $(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:M,amdModulesPattern:/^vs\//})}function g(o){c().then(()=>{$(),require([o],function(N){setTimeout(function(){const d=N.create((b,e)=>{globalThis.postMessage(b,e)},null);for(globalThis.onmessage=b=>d.onmessage(b.data,b.ports);u.length>0;){const b=u.shift();d.onmessage(b.data,b.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&$();let a=!0;const u=[];globalThis.onmessage=o=>{if(!a){u.push(o);return}a=!1,g(o.data)}}(),ne(ie[8],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=i,t.$gb=M,t.$hb=R,t.$ib=c,t.$jb=$,t.$kb=g,t.$lb=a,t.$nb=o,t.$ob=N,t.$pb=d,t.$qb=b,t.$rb=e;function i(m,S){const j=M(m,S);if(j!==-1)return m[j]}function M(m,S,j=m.length-1){for(let v=j;v>=0;v--){const w=m[v];if(S(w))return v}return-1}function R(m,S){const j=c(m,S);return j===-1?void 0:m[j]}function c(m,S,j=0,v=m.length){let w=j,p=v;for(;w<p;){const l=Math.floor((w+p)/2);S(m[l])?w=l+1:p=l}return w-1}function $(m,S){const j=g(m,S);return j===m.length?void 0:m[j]}function g(m,S,j=0,v=m.length){let w=j,p=v;for(;w<p;){const l=Math.floor((w+p)/2);S(m[l])?p=l:w=l+1}return w}function a(m,S,j=0,v=m.length){const w=g(m,S,j,v);return w===m.length?-1:w}class u{static{this.assertInvariants=!1}constructor(S){this.e=S,this.c=0}findLastMonotonous(S){if(u.assertInvariants){if(this.d){for(const v of this.e)if(this.d(v)&&!S(v))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=S}const j=c(this.e,S,this.c);return this.c=j+1,j===-1?void 0:this.e[j]}}t.$mb=u;function o(m,S){if(m.length===0)return;let j=m[0];for(let v=1;v<m.length;v++){const w=m[v];S(w,j)>0&&(j=w)}return j}function N(m,S){if(m.length===0)return;let j=m[0];for(let v=1;v<m.length;v++){const w=m[v];S(w,j)>=0&&(j=w)}return j}function d(m,S){return o(m,(j,v)=>-S(j,v))}function b(m,S){if(m.length===0)return-1;let j=0;for(let v=1;v<m.length;v++){const w=m[v];S(w,m[j])>0&&(j=v)}return j}function e(m,S){for(const j of m){const v=S(j);if(v!==void 0)return v}}}),ne(ie[36],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=i,t.$L=M,t.$M=R,t.$N=c;function i($,g){const a=Object.create(null);for(const u of $){const o=g(u);let N=a[o];N||(N=a[o]=[]),N.push(u)}return a}function M($,g){const a=[],u=[];for(const o of $)g.has(o)||a.push(o);for(const o of g)$.has(o)||u.push(o);return{removed:a,added:u}}function R($,g){const a=[],u=[];for(const[o,N]of $)g.has(o)||a.push(N);for(const[o,N]of g)$.has(o)||u.push(N);return{removed:a,added:u}}function c($,g){const a=new Set;for(const u of g)$.has(u)&&a.add(u);return a}}),ne(ie[37],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$St=t.$Rt=t.$Qt=t.$Pt=void 0;function i(g,a){const u=Math.pow(10,a);return Math.round(g*u)/u}class M{constructor(a,u,o,N=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,o))|0,this.a=i(Math.max(Math.min(1,N),0),3)}static equals(a,u){return a.r===u.r&&a.g===u.g&&a.b===u.b&&a.a===u.a}}t.$Pt=M;class R{constructor(a,u,o,N){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.l=i(Math.max(Math.min(1,o),0),3),this.a=i(Math.max(Math.min(1,N),0),3)}static equals(a,u){return a.h===u.h&&a.s===u.s&&a.l===u.l&&a.a===u.a}static fromRGBA(a){const u=a.r/255,o=a.g/255,N=a.b/255,d=a.a,b=Math.max(u,o,N),e=Math.min(u,o,N);let m=0,S=0;const j=(e+b)/2,v=b-e;if(v>0){switch(S=Math.min(j<=.5?v/(2*j):v/(2-2*j),1),b){case u:m=(o-N)/v+(o<N?6:0);break;case o:m=(N-u)/v+2;break;case N:m=(u-o)/v+4;break}m*=60,m=Math.round(m)}return new R(m,S,j,d)}static i(a,u,o){return o<0&&(o+=1),o>1&&(o-=1),o<1/6?a+(u-a)*6*o:o<1/2?u:o<2/3?a+(u-a)*(2/3-o)*6:a}static toRGBA(a){const u=a.h/360,{s:o,l:N,a:d}=a;let b,e,m;if(o===0)b=e=m=N;else{const S=N<.5?N*(1+o):N+o-N*o,j=2*N-S;b=R.i(j,S,u+1/3),e=R.i(j,S,u),m=R.i(j,S,u-1/3)}return new M(Math.round(b*255),Math.round(e*255),Math.round(m*255),d)}}t.$Qt=R;class c{constructor(a,u,o,N){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.v=i(Math.max(Math.min(1,o),0),3),this.a=i(Math.max(Math.min(1,N),0),3)}static equals(a,u){return a.h===u.h&&a.s===u.s&&a.v===u.v&&a.a===u.a}static fromRGBA(a){const u=a.r/255,o=a.g/255,N=a.b/255,d=Math.max(u,o,N),b=Math.min(u,o,N),e=d-b,m=d===0?0:e/d;let S;return e===0?S=0:d===u?S=((o-N)/e%6+6)%6:d===o?S=(N-u)/e+2:S=(u-o)/e+4,new c(Math.round(S*60),m,d,a.a)}static toRGBA(a){const{h:u,s:o,v:N,a:d}=a,b=N*o,e=b*(1-Math.abs(u/60%2-1)),m=N-b;let[S,j,v]=[0,0,0];return u<60?(S=b,j=e):u<120?(S=e,j=b):u<180?(j=b,v=e):u<240?(j=e,v=b):u<300?(S=e,v=b):u<=360&&(S=b,v=e),S=Math.round((S+m)*255),j=Math.round((j+m)*255),v=Math.round((v+m)*255),new M(S,j,v,d)}}t.$Rt=c;class ${static fromHex(a){return $.Format.CSS.parseHex(a)||$.red}static equals(a,u){return!a&&!u?!0:!a||!u?!1:a.equals(u)}get hsla(){return this.i?this.i:R.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:c.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof M)this.rgba=a;else if(a instanceof R)this.i=a,this.rgba=R.toRGBA(a);else if(a instanceof c)this.j=a,this.rgba=c.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&M.equals(this.rgba,a.rgba)&&R.equals(this.hsla,a.hsla)&&c.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=$.k(this.rgba.r),u=$.k(this.rgba.g),o=$.k(this.rgba.b),N=.2126*a+.7152*u+.0722*o;return i(N,4)}static k(a){const u=a/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(a){const u=this.getRelativeLuminance(),o=a.getRelativeLuminance();return u>o?(u+.05)/(o+.05):(o+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const u=this.getRelativeLuminance(),o=a.getRelativeLuminance();return u>o}isDarkerThan(a){const u=this.getRelativeLuminance(),o=a.getRelativeLuminance();return u<o}lighten(a){return new $(new R(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new $(new R(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:u,g:o,b:N,a:d}=this.rgba;return new $(new M(u,o,N,d*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new $(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const u=a.rgba,o=this.rgba.a,N=u.a,d=o+N*(1-o);if(d<1e-6)return $.transparent;const b=this.rgba.r*o/d+u.r*N*(1-o)/d,e=this.rgba.g*o/d+u.g*N*(1-o)/d,m=this.rgba.b*o/d+u.b*N*(1-o)/d;return new $(new M(b,e,m,d))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:u,g:o,b:N,a:d}=this.rgba;return new $(new M(a.rgba.r-d*(a.rgba.r-u),a.rgba.g-d*(a.rgba.g-o),a.rgba.b-d*(a.rgba.b-N),1))}flatten(...a){const u=a.reduceRight((o,N)=>$.o(N,o));return $.o(this,u)}static o(a,u){const o=1-a.rgba.a;return new $(new M(o*u.rgba.r+a.rgba.a*a.rgba.r,o*u.rgba.g+a.rgba.a*a.rgba.g,o*u.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this.u||(this.u=$.Format.CSS.format(this)),this.u}static getLighterColor(a,u,o){if(a.isLighterThan(u))return a;o=o||.5;const N=a.getRelativeLuminance(),d=u.getRelativeLuminance();return o=o*(d-N)/d,a.lighten(o)}static getDarkerColor(a,u,o){if(a.isDarkerThan(u))return a;o=o||.5;const N=a.getRelativeLuminance(),d=u.getRelativeLuminance();return o=o*(N-d)/N,a.darken(o)}static{this.white=new $(new M(255,255,255,1))}static{this.black=new $(new M(0,0,0,1))}static{this.red=new $(new M(255,0,0,1))}static{this.blue=new $(new M(0,0,255,1))}static{this.green=new $(new M(0,255,0,1))}static{this.cyan=new $(new M(0,255,255,1))}static{this.lightgrey=new $(new M(211,211,211,1))}static{this.transparent=new $(new M(0,0,0,0))}}t.$St=$,function(g){let a;(function(u){let o;(function(N){function d(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:g.Format.CSS.formatRGBA(n)}N.formatRGB=d;function b(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}N.formatRGBA=b;function e(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:g.Format.CSS.formatHSLA(n)}N.formatHSL=e;function m(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}N.formatHSLA=m;function S(n){const s=n.toString(16);return s.length!==2?"0"+s:s}function j(n){return`#${S(n.rgba.r)}${S(n.rgba.g)}${S(n.rgba.b)}`}N.formatHex=j;function v(n,s=!1){return s&&n.rgba.a===1?g.Format.CSS.formatHex(n):`#${S(n.rgba.r)}${S(n.rgba.g)}${S(n.rgba.b)}${S(Math.round(n.rgba.a*255))}`}N.formatHexA=v;function w(n){return n.isOpaque()?g.Format.CSS.formatHex(n):g.Format.CSS.formatRGBA(n)}N.format=w;function p(n){const s=n.length;if(s===0||n.charCodeAt(0)!==35)return null;if(s===7){const f=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),h=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),L=16*l(n.charCodeAt(5))+l(n.charCodeAt(6));return new g(new M(f,h,L,1))}if(s===9){const f=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),h=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),L=16*l(n.charCodeAt(5))+l(n.charCodeAt(6)),E=16*l(n.charCodeAt(7))+l(n.charCodeAt(8));return new g(new M(f,h,L,E/255))}if(s===4){const f=l(n.charCodeAt(1)),h=l(n.charCodeAt(2)),L=l(n.charCodeAt(3));return new g(new M(16*f+f,16*h+h,16*L+L))}if(s===5){const f=l(n.charCodeAt(1)),h=l(n.charCodeAt(2)),L=l(n.charCodeAt(3)),E=l(n.charCodeAt(4));return new g(new M(16*f+f,16*h+h,16*L+L,(16*E+E)/255))}return null}N.parseHex=p;function l(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(o=u.CSS||(u.CSS={}))})(a=g.Format||(g.Format={}))}($||(t.$St=$={}))}),ne(ie[38],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$At=void 0;class i{constructor(R,c,$,g){this.originalStart=R,this.originalLength=c,this.modifiedStart=$,this.modifiedLength=g}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$At=i}),ne(ie[3],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=M,t.$Z=R,t.$1=c,t.$2=$,t.$3=g,t.$4=u,t.$6=N,t.$7=d,t.$8=b,t.$0=m;class i{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?w.isErrorNoTelemetry(n)?new w(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}t.$W=i,t.$X=new i;function M(l){t.$X.setUnexpectedErrorHandler(l)}function R(l){if(!l||typeof l!="object")return!1;const n=l;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function c(l){u(l)||t.$X.onUnexpectedError(l)}function $(l){u(l)||t.$X.onUnexpectedExternalError(l)}function g(l){if(l instanceof Error){const{name:n,message:s}=l,f=l.stacktrace||l.stack;return{$isError:!0,name:n,message:s,stack:f,noTelemetry:w.isErrorNoTelemetry(l)}}return l}const a="Canceled";function u(l){return l instanceof o?!0:l instanceof Error&&l.name===a&&l.message===a}class o extends Error{constructor(){super(a),this.name=this.message}}t.$5=o;function N(){const l=new Error(a);return l.name=l.message,l}function d(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}function b(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}class e extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function m(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}class S extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}t.$$=S;class j extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}t.$_=j;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=v;class w extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof w)return n;const s=new w;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}t.$bb=w;class p extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype)}}t.$cb=p}),ne(ie[6],se([0,1,3,8]),function(C,t,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$9b=t.$8b=t.CompareResult=void 0,t.$sb=R,t.$tb=c,t.$ub=$,t.$vb=g,t.$wb=a,t.$xb=u,t.$yb=o,t.$zb=N,t.$Ab=d,t.$Bb=b,t.$Cb=e,t.$Db=m,t.$Eb=S,t.top=j,t.$Gb=v,t.$Hb=p,t.$Ib=l,t.$Jb=n,t.$Kb=s,t.$Lb=f,t.$Mb=h,t.$Nb=L,t.$Ob=E,t.$Pb=A,t.$Qb=y,t.$Rb=F,t.$Sb=T,t.$Tb=I,t.$Ub=k,t.$Vb=q,t.$Wb=x,t.$Xb=W,t.$Yb=Q,t.$Zb=Y,t.$1b=X,t.$2b=G,t.$3b=U,t.$4b=K,t.$5b=P,t.$6b=fe,t.$7b=ve,t.$0b=Ae;function R(B,H=0){return B[B.length-(1+H)]}function c(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}function $(B,H,V=(J,te)=>J===te){if(B===H)return!0;if(!B||!H||B.length!==H.length)return!1;for(let J=0,te=B.length;J<te;J++)if(!V(B[J],H[J]))return!1;return!0}function g(B,H){const V=B.length-1;H<V&&(B[H]=B[V]),B.pop()}function a(B,H,V){return u(B.length,J=>V(B[J],H))}function u(B,H){let V=0,J=B-1;for(;V<=J;){const te=(V+J)/2|0,he=H(te);if(he<0)V=te+1;else if(he>0)J=te-1;else return te}return-(V+1)}function o(B,H,V){if(B=B|0,B>=H.length)throw new TypeError("invalid index");const J=H[Math.floor(H.length*Math.random())],te=[],he=[],me=[];for(const we of H){const re=V(we,J);re<0?te.push(we):re>0?he.push(we):me.push(we)}return B<te.length?o(B,te,V):B<te.length+me.length?me[0]:o(B-(te.length+me.length),he,V)}function N(B,H){const V=[];let J;for(const te of B.slice(0).sort(H))!J||H(J[0],te)!==0?(J=[te],V.push(J)):J.push(te);return V}function*d(B,H){let V,J;for(const te of B)J!==void 0&&H(J,te)?V.push(te):(V&&(yield V),V=[te]),J=te;V&&(yield V)}function b(B,H){for(let V=0;V<=B.length;V++)H(V===0?void 0:B[V-1],V===B.length?void 0:B[V])}function e(B,H){for(let V=0;V<B.length;V++)H(V===0?void 0:B[V-1],B[V],V+1===B.length?void 0:B[V+1])}function m(B,H,V){const J=[];function te(we,re,ee){if(re===0&&ee.length===0)return;const ue=J[J.length-1];ue&&ue.start+ue.deleteCount===we?(ue.deleteCount+=re,ue.toInsert.push(...ee)):J.push({start:we,deleteCount:re,toInsert:ee})}let he=0,me=0;for(;;){if(he===B.length){te(he,0,H.slice(me));break}if(me===H.length){te(he,B.length-he,[]);break}const we=B[he],re=H[me],ee=V(we,re);ee===0?(he+=1,me+=1):ee<0?(te(he,1,[]),he+=1):ee>0&&(te(he,0,[re]),me+=1)}return J}function S(B,H,V){const J=m(B,H,V),te=[],he=[];for(const me of J)te.push(...B.slice(me.start,me.start+me.deleteCount)),he.push(...me.toInsert);return{removed:te,added:he}}function j(B,H,V){if(V===0)return[];const J=B.slice(0,V).sort(H);return w(B,H,J,V,B.length),J}function v(B,H,V,J,te){return V===0?Promise.resolve([]):new Promise((he,me)=>{(async()=>{const we=B.length,re=B.slice(0,V).sort(H);for(let ee=V,ue=Math.min(V+J,we);ee<we;ee=ue,ue=Math.min(ue+J,we)){if(ee>V&&await new Promise(ae=>setTimeout(ae)),te&&te.isCancellationRequested)throw new i.$5;w(B,H,re,ee,ue)}return re})().then(he,me)})}function w(B,H,V,J,te){for(const he=V.length;J<te;J++){const me=B[J];if(H(me,V[he-1])<0){V.pop();const we=(0,M.$kb)(V,re=>H(me,re)<0);V.splice(we,0,me)}}}function p(B){return B.filter(H=>!!H)}function l(B){let H=0;for(let V=0;V<B.length;V++)B[V]&&(B[H]=B[V],H+=1);B.length=H}function n(B,H,V){B.splice(V,0,B.splice(H,1)[0])}function s(B){return!Array.isArray(B)||B.length===0}function f(B){return Array.isArray(B)&&B.length>0}function h(B,H=V=>V){const V=new Set;return B.filter(J=>{const te=H(J);return V.has(te)?!1:(V.add(te),!0)})}function L(B){const H=new Set;return V=>{const J=B(V);return H.has(J)?!1:(H.add(J),!0)}}function E(B,H){return B.length>0?B[0]:H}function A(B,H){return B.length>0?B[B.length-1]:H}function y(B,H,V=(J,te)=>J===te){let J=0;for(let te=0,he=Math.min(B.length,H.length);te<he&&V(B[te],H[te]);te++)J++;return J}function F(B,H){let V=typeof H=="number"?B:0;typeof H=="number"?V=B:(V=0,H=B);const J=[];if(V<=H)for(let te=V;te<H;te++)J.push(te);else for(let te=V;te>H;te--)J.push(te);return J}function T(B,H,V){return B.reduce((J,te)=>(J[H(te)]=V?V(te):te,J),Object.create(null))}function I(B,H){return B.push(H),()=>k(B,H)}function k(B,H){const V=B.indexOf(H);if(V>-1)return B.splice(V,1),H}function q(B,H,V){const J=B.slice(0,H),te=B.slice(H);return J.concat(V,te)}function x(B,H){let V;if(typeof H=="number"){let J=H;V=()=>{const te=Math.sin(J++)*179426549;return te-Math.floor(te)}}else V=Math.random;for(let J=B.length-1;J>0;J-=1){const te=Math.floor(V()*(J+1)),he=B[J];B[J]=B[te],B[te]=he}}function W(B,H){const V=B.indexOf(H);V>-1&&(B.splice(V,1),B.unshift(H))}function Q(B,H){const V=B.indexOf(H);V>-1&&(B.splice(V,1),B.push(H))}function Y(B,H){for(const V of H)B.push(V)}function X(B,H){return Array.isArray(B)?B.map(H):H(B)}function G(B){return Array.isArray(B)?B:[B]}function U(B){return B[Math.floor(Math.random()*B.length)]}function K(B,H,V){const J=Z(B,H),te=B.length,he=V.length;B.length=te+he;for(let me=te-1;me>=J;me--)B[me+he]=B[me];for(let me=0;me<he;me++)B[me+J]=V[me]}function P(B,H,V,J){const te=Z(B,H);let he=B.splice(te,V);return he===void 0&&(he=[]),K(B,te,J),he}function Z(B,H){return H<0?Math.max(H+B.length,0):Math.min(H,B.length)}var de;(function(B){function H(he){return he<0}B.isLessThan=H;function V(he){return he<=0}B.isLessThanOrEqual=V;function J(he){return he>0}B.isGreaterThan=J;function te(he){return he===0}B.isNeitherLessOrGreaterThan=te,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(de||(t.CompareResult=de={}));function fe(B,H){return(V,J)=>H(B(V),B(J))}function ve(...B){return(H,V)=>{for(const J of B){const te=J(H,V);if(!de.isNeitherLessOrGreaterThan(te))return te}return de.neitherLessOrGreaterThan}}const r=(B,H)=>B-H;t.$8b=r;const je=(B,H)=>(0,t.$8b)(B?1:0,H?1:0);t.$9b=je;function Ae(B){return(H,V)=>-B(H,V)}class Be{constructor(H){this.g=H,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(H){let V=this.c;for(;V<this.g.length&&H(this.g[V]);)V++;const J=V===this.c?null:this.g.slice(this.c,V);return this.c=V,J}takeFromEndWhile(H){let V=this.d;for(;V>=0&&H(this.g[V]);)V--;const J=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,J}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const H=this.g[this.c];return this.c++,H}removeLast(){const H=this.g[this.d];return this.d--,H}takeCount(H){const V=this.g.slice(this.c,this.c+H);return this.c+=H,V}}t.$$b=Be;class Ee{static{this.empty=new Ee(H=>{})}constructor(H){this.iterate=H}forEach(H){this.iterate(V=>(H(V),!0))}toArray(){const H=[];return this.iterate(V=>(H.push(V),!0)),H}filter(H){return new Ee(V=>this.iterate(J=>H(J)?V(J):!0))}map(H){return new Ee(V=>this.iterate(J=>V(H(J))))}some(H){let V=!1;return this.iterate(J=>(V=H(J),!V)),V}findFirst(H){let V;return this.iterate(J=>H(J)?(V=J,!1):!0),V}findLast(H){let V;return this.iterate(J=>(H(J)&&(V=J),!0)),V}findLastMaxBy(H){let V,J=!0;return this.iterate(te=>((J||de.isGreaterThan(H(te,V)))&&(J=!1,V=te),!0)),V}}t.$_b=Ee;class De{constructor(H){this.c=H}static createSortPermutation(H,V){const J=Array.from(H.keys()).sort((te,he)=>V(H[te],H[he]));return new De(J)}apply(H){return H.map((V,J)=>H[this.c[J]])}inverse(){const H=this.c.slice();for(let V=0;V<this.c.length;V++)H[this.c[V]]=V;return new De(H)}}t.$ac=De}),ne(ie[10],se([0,1,3]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=M,t.$ed=R,t.$fd=c,t.$gd=$,t.$hd=g,t.$id=a;function M(u,o){if(!u)throw new Error(o?`Assertion failed (${o})`:"Assertion Failed")}function R(u,o="Unreachable"){throw new Error(o)}function c(u,o="unexpected state"){if(!u)throw new i.$cb(`Assertion Failed: ${o}`)}function $(u){u||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function g(u){if(!u()){debugger;u(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function a(u,o){let N=0;for(;N<u.length-1;){const d=u[N],b=u[N+1];if(!o(d,b))return!1;N++}return!0}}),ne(ie[20],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=i;function i(M,R){const c=this;let $=!1,g;return function(){if($)return g;if($=!0,R)try{g=M.apply(c,arguments)}finally{R()}else g=M.apply(c,arguments);return g}}}),ne(ie[21],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(M){function R(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}M.is=R;const c=Object.freeze([]);function $(){return c}M.empty=$;function*g(n){yield n}M.single=g;function a(n){return R(n)?n:g(n)}M.wrap=a;function u(n){return n||c}M.from=u;function*o(n){for(let s=n.length-1;s>=0;s--)yield n[s]}M.reverse=o;function N(n){return!n||n[Symbol.iterator]().next().done===!0}M.isEmpty=N;function d(n){return n[Symbol.iterator]().next().value}M.first=d;function b(n,s){for(const f of n)if(s(f))return!0;return!1}M.some=b;function e(n,s){for(const f of n)if(s(f))return f}M.find=e;function*m(n,s){for(const f of n)s(f)&&(yield f)}M.filter=m;function*S(n,s){let f=0;for(const h of n)yield s(h,f++)}M.map=S;function*j(...n){for(const s of n)yield*s}M.concat=j;function v(n,s,f){let h=f;for(const L of n)h=s(h,L);return h}M.reduce=v;function*w(n,s,f=n.length){for(s<0&&(s+=n.length),f<0?f+=n.length:f>n.length&&(f=n.length);s<f;s++)yield n[s]}M.slice=w;function p(n,s=Number.POSITIVE_INFINITY){const f=[];if(s===0)return[f,n];const h=n[Symbol.iterator]();for(let L=0;L<s;L++){const E=h.next();if(E.done)return[f,M.empty()];f.push(E.value)}return[f,{[Symbol.iterator](){return h}}]}M.consume=p;async function l(n){const s=[];for await(const f of n)s.push(f);return Promise.resolve(s)}M.asyncToArray=l})(i||(t.Iterable=i={}))}),ne(ie[39],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$Gr=t.$Fr=t.$Er=t.$Dr=t.$Cr=t.ScanCode=t.KeyCode=void 0,t.$Hr=b;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var M;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(M||(t.ScanCode=M={}));class R{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(m,S){this._keyCodeToStr[m]=S,this._strToKeyCode[S.toLowerCase()]=m}keyCodeToStr(m){return this._keyCodeToStr[m]}strToKeyCode(m){return this._strToKeyCode[m.toLowerCase()]||0}}const c=new R,$=new R,g=new R;t.$Cr=new Array(230),t.$Dr={};const a=[],u=Object.create(null),o=Object.create(null);t.$Er={lowerCaseToEnum:e=>o[e]||0,toEnum:e=>u[e]||0,toString:e=>a[e]||"None"},t.$Fr=[],t.$Gr=[];for(let e=0;e<=193;e++)t.$Fr[e]=-1;for(let e=0;e<=132;e++)t.$Gr[e]=-1;(function(){const e="",m=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],S=[],j=[];for(const v of m){const[w,p,l,n,s,f,h,L,E]=v;if(j[p]||(j[p]=!0,a[p]=l,u[l]=p,o[l.toLowerCase()]=p,w&&(t.$Fr[p]=n,n!==0&&n!==3&&n!==5&&n!==4&&n!==6&&n!==57&&(t.$Gr[n]=p))),!S[n]){if(S[n]=!0,!s)throw new Error(`String representation missing for key code ${n} around scan code ${l}`);c.define(n,s),$.define(n,L||s),g.define(n,E||L||s)}f&&(t.$Cr[f]=n),h&&(t.$Dr[h]=n)}t.$Gr[3]=46})();var N;(function(e){function m(l){return c.keyCodeToStr(l)}e.toString=m;function S(l){return c.strToKeyCode(l)}e.fromString=S;function j(l){return $.keyCodeToStr(l)}e.toUserSettingsUS=j;function v(l){return g.keyCodeToStr(l)}e.toUserSettingsGeneral=v;function w(l){return $.strToKeyCode(l)||g.strToKeyCode(l)}e.fromUserSettings=w;function p(l){if(l>=98&&l<=113)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return c.keyCodeToStr(l)}e.toElectronAccelerator=p})(N||(t.KeyCodeUtils=N={}));var d;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(d||(t.KeyMod=d={}));function b(e,m){const S=(m&65535)<<16>>>0;return(e|S)>>>0}}),ne(ie[40],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(R){this.d=R,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(R){this.c=R}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),ne(ie[22],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(c){this.element=c,this.next=i.Undefined,this.prev=i.Undefined}}class M{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let c=this.a;for(;c!==i.Undefined;){const $=c.next;c.prev=i.Undefined,c.next=i.Undefined,c=$}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(c){return this.d(c,!1)}push(c){return this.d(c,!0)}d(c,$){const g=new i(c);if(this.a===i.Undefined)this.a=g,this.b=g;else if($){const u=this.b;this.b=g,g.prev=u,u.next=g}else{const u=this.a;this.a=g,g.next=u,u.prev=g}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(g))}}shift(){if(this.a!==i.Undefined){const c=this.a.element;return this.e(this.a),c}}pop(){if(this.b!==i.Undefined){const c=this.b.element;return this.e(this.b),c}}e(c){if(c.prev!==i.Undefined&&c.next!==i.Undefined){const $=c.prev;$.next=c.next,c.next.prev=$}else c.prev===i.Undefined&&c.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):c.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):c.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let c=this.a;for(;c!==i.Undefined;)yield c.element,c=c.next}}t.$5c=M}),ne(ie[14],se([0,1]),function(C,t){"use strict";var i,M,R;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=void 0,t.$xc=c,t.$yc=$,t.$zc=g,t.$Ic=p;function c(l,n,s){let f=l.get(n);return f===void 0&&(f=s,l.set(n,f)),f}function $(l){const n=[];return l.forEach((s,f)=>{n.push(`${f} => ${s}`)}),`Map(${l.size}) {${n.join(", ")}}`}function g(l){const n=[];return l.forEach(s=>{n.push(s)}),`Set(${l.size}) {${n.join(", ")}}`}class a{constructor(n,s){this.uri=n,this.value=s}}function u(l){return Array.isArray(l)}class o{static{this.c=n=>n.toString()}constructor(n,s){if(this[i]="ResourceMap",n instanceof o)this.d=new Map(n.d),this.e=s??o.c;else if(u(n)){this.d=new Map,this.e=s??o.c;for(const[f,h]of n)this.set(f,h)}else this.d=new Map,this.e=n??o.c}set(n,s){return this.d.set(this.e(n),new a(n,s)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,s){typeof s<"u"&&(n=n.bind(s));for(const[f,h]of this.d)n(h.value,h.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}t.$Ac=o;class N{constructor(n,s){this[M]="ResourceSet",!n||typeof n=="function"?this.c=new o(n):(this.c=new o(s),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,s){this.c.forEach((f,h)=>n.call(s,h,h,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=N;var d;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(d||(t.Touch=d={}));class b{constructor(){this[R]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,s=0){const f=this.c.get(n);if(f)return s!==0&&this.m(f,s),f.value}set(n,s,f=0){let h=this.c.get(n);if(h)h.value=s,f!==0&&this.m(h,f);else{switch(h={key:n,value:s,next:void 0,previous:void 0},f){case 0:this.k(h);break;case 1:this.j(h);break;case 2:this.k(h);break;default:this.k(h);break}this.c.set(n,h),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this.c.get(n);if(s)return this.c.delete(n),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.l(n),this.f--,n.value}forEach(n,s){const f=this.g;let h=this.d;for(;h;){if(s?n.bind(s)(h.value,h.key,this):n(h.value,h.key,this),this.g!==f)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const n=this,s=this.g;let f=this.d;const h={[Symbol.iterator](){return h},next(){if(n.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const L={value:f.key,done:!1};return f=f.next,L}else return{value:void 0,done:!0}}};return h}values(){const n=this,s=this.g;let f=this.d;const h={[Symbol.iterator](){return h},next(){if(n.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const L={value:f.value,done:!1};return f=f.next,L}else return{value:void 0,done:!0}}};return h}entries(){const n=this,s=this.g;let f=this.d;const h={[Symbol.iterator](){return h},next(){if(n.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const L={value:[f.key,f.value],done:!1};return f=f.next,L}else return{value:void 0,done:!0}}};return h}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this.d,f=this.size;for(;s&&f>n;)this.c.delete(s.key),s=s.next,f--;this.d=s,this.f=f,s&&(s.previous=void 0),this.g++}i(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this.e,f=this.size;for(;s&&f>n;)this.c.delete(s.key),s=s.previous,f--;this.e=s,this.f=f,s&&(s.next=void 0),this.g++}j(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}k(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}l(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const s=n.next,f=n.previous;if(!s||!f)throw new Error("Invalid list");s.previous=f,f.next=s}n.next=void 0,n.previous=void 0,this.g++}m(n,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this.d)return;const f=n.next,h=n.previous;n===this.e?(h.next=void 0,this.e=h):(f.previous=h,h.next=f),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(s===2){if(n===this.e)return;const f=n.next,h=n.previous;n===this.d?(f.previous=void 0,this.d=f):(f.previous=h,h.next=f),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((s,f)=>{n.push([f,s])}),n}fromJSON(n){this.clear();for(const[s,f]of n)this.set(s,f)}}t.$Cc=b;class e extends b{constructor(n,s=1){super(),this.n=n,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(n){this.n=n,this.p()}get ratio(){return this.o}set ratio(n){this.o=Math.min(Math.max(0,n),1),this.p()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class m extends e{constructor(n,s=1){super(n,s)}q(n){this.h(n)}set(n,s){return super.set(n,s),this.p(),this}}t.$Dc=m;class S extends e{constructor(n,s=1){super(n,s)}q(n){this.i(n)}set(n,s){return this.n<=this.size&&!this.has(n)&&this.q(Math.round(this.n*this.o)-1),super.set(n,s),this}}t.$Ec=S;class j{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let s=this.c.get(n)||0;return s===0?!1:(s--,s===0?this.c.delete(n):this.c.set(n,s),!0)}has(n){return this.c.has(n)}}t.$Fc=j;class v{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[s,f]of n)this.set(s,f)}clear(){this.c.clear(),this.d.clear()}set(n,s){this.c.set(n,s),this.d.set(s,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const s=this.c.get(n);return s===void 0?!1:(this.c.delete(n),this.d.delete(s),!0)}forEach(n,s){this.c.forEach((f,h)=>{n.call(s,f,h,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Gc=v;class w{constructor(){this.c=new Map}add(n,s){let f=this.c.get(n);f||(f=new Set,this.c.set(n,f)),f.add(s)}delete(n,s){const f=this.c.get(n);f&&(f.delete(s),f.size===0&&this.c.delete(n))}forEach(n,s){const f=this.c.get(n);f&&f.forEach(s)}get(n){const s=this.c.get(n);return s||new Set}}t.$Hc=w;function p(l,n){if(l===n)return!0;if(l.size!==n.size)return!1;for(const[s,f]of l)if(!n.has(s)||n.get(s)!==f)return!1;for(const[s]of n)if(!l.has(s))return!1;return!0}}),ne(ie[11],se([0,1,6,36,14,20,21]),function(C,t,i,M,R,c,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Jc=void 0,t.$Kc=o,t.$Lc=N,t.$Mc=d,t.$Nc=m,t.$Oc=S,t.$Pc=j,t.$Qc=v,t.$Rc=w,t.$Sc=p,t.$3c=F;const g=!1;let a=null;class u{constructor(){this.b=new Map}static{this.a=0}c(k){let q=this.b.get(k);return q||(q={parent:null,source:null,isSingleton:!1,value:k,idx:u.a++},this.b.set(k,q)),q}trackDisposable(k){const q=this.c(k);q.source||(q.source=new Error().stack)}setParent(k,q){const x=this.c(k);x.parent=q}markAsDisposed(k){this.b.delete(k)}markAsSingleton(k){this.c(k).isSingleton=!0}f(k,q){const x=q.get(k);if(x)return x;const W=k.parent?this.f(this.c(k.parent),q):k;return q.set(k,W),W}getTrackedDisposables(){const k=new Map;return[...this.b.entries()].filter(([,x])=>x.source!==null&&!this.f(x,k).isSingleton).flatMap(([x])=>x)}computeLeakingDisposables(k=10,q){let x;if(q)x=q;else{const G=new Map,U=[...this.b.values()].filter(P=>P.source!==null&&!this.f(P,G).isSingleton);if(U.length===0)return;const K=new Set(U.map(P=>P.value));if(x=U.filter(P=>!(P.parent&&K.has(P.parent))),x.length===0)throw new Error("There are cyclic diposable chains!")}if(!x)return;function W(G){function U(P,Z){for(;P.length>0&&Z.some(de=>typeof de=="string"?de===P[0]:P[0].match(de));)P.shift()}const K=G.source.split(`
`).map(P=>P.trim().replace("at ","")).filter(P=>P!=="");return U(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const Q=new R.$Hc;for(const G of x){const U=W(G);for(let K=0;K<=U.length;K++)Q.add(U.slice(0,K).join(`
`),G)}x.sort((0,i.$6b)(G=>G.idx,i.$8b));let Y="",X=0;for(const G of x.slice(0,k)){X++;const U=W(G),K=[];for(let P=0;P<U.length;P++){let Z=U[P];Z=`(shared with ${Q.get(U.slice(0,P+1).join(`
`)).size}/${x.length} leaks) at ${Z}`;const fe=Q.get(U.slice(0,P).join(`
`)),ve=(0,M.$K)([...fe].map(r=>W(r)[P]),r=>r);delete ve[U[P]];for(const[r,je]of Object.entries(ve))K.unshift(`    - stacktraces of ${je.length} other leaks continue with ${r}`);K.unshift(Z)}Y+=`


==================== Leaking disposable ${X}/${x.length}: ${G.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return x.length>k&&(Y+=`


... and ${x.length-k} more leaking disposables

`),{leaks:x,details:Y}}}t.$Jc=u;function o(I){a=I}if(g){const I="__is_disposable_tracked__";o(new class{trackDisposable(k){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{k[I]||console.log(q)},3e3)}setParent(k,q){if(k&&k!==n.None)try{k[I]=!0}catch{}}markAsDisposed(k){if(k&&k!==n.None)try{k[I]=!0}catch{}}markAsSingleton(k){}})}function N(I){return a?.trackDisposable(I),I}function d(I){a?.markAsDisposed(I)}function b(I,k){a?.setParent(I,k)}function e(I,k){if(a)for(const q of I)a.setParent(q,k)}function m(I){return a?.markAsSingleton(I),I}function S(I){return typeof I=="object"&&I!==null&&typeof I.dispose=="function"&&I.dispose.length===0}function j(I){if($.Iterable.is(I)){const k=[];for(const q of I)if(q)try{q.dispose()}catch(x){k.push(x)}if(k.length===1)throw k[0];if(k.length>1)throw new AggregateError(k,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function v(I){for(const k of I)S(k)&&k.dispose();return[]}function w(...I){const k=p(()=>j(I));return e(I,k),k}function p(I){const k=N({dispose:(0,c.$db)(()=>{d(k),I()})});return k}class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,N(this)}dispose(){this.g||(d(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{j(this.f)}finally{this.f.clear()}}add(k){if(!k)return k;if(k===this)throw new Error("Cannot register a disposable on itself!");return b(k,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(k),k}delete(k){if(k){if(k===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(k),k.dispose()}}deleteAndLeak(k){k&&this.f.has(k)&&(this.f.delete(k),b(k,null))}}t.$Tc=l;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new l,N(this),b(this.q,this)}dispose(){d(this),this.q.dispose()}B(k){if(k===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(k)}}t.$Uc=n;class s{constructor(){this.b=!1,N(this)}get value(){return this.b?void 0:this.a}set value(k){this.b||k===this.a||(this.a?.dispose(),k&&b(k,this),this.a=k)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const k=this.a;return this.a=void 0,k&&b(k,null),k}}t.$Vc=s;class f{constructor(k){this.a=new s,this.b=!1,this.a.value=k}get value(){return this.a.value}set value(k){this.b||k===this.a.value||(this.a.value=k)}dispose(){this.b=!0,this.a.dispose()}}t.$Wc=f;class h{constructor(k){this.b=k,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Xc=h;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,N(this)}set(k){let q=k;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,d(this))},this}}t.$Yc=L;class E{constructor(){this.a=new Map}acquire(k,...q){let x=this.a.get(k);x||(x={counter:0,object:this.b(k,...q)},this.a.set(k,x));const{object:W}=x,Q=(0,c.$db)(()=>{--x.counter===0&&(this.c(k,x.object),this.a.delete(k))});return x.counter++,{object:W,dispose:Q}}}t.$Zc=E;class A{constructor(k){this.a=k}async acquire(k,...q){const x=this.a.acquire(k,...q);try{return{object:await x.object,dispose:()=>x.dispose()}}catch(W){throw x.dispose(),W}}}t.$1c=A;class y{constructor(k){this.object=k}dispose(){}}t.$2c=y;function F(I){const k=new l;try{I(k)}finally{k.dispose()}}class T{constructor(){this.a=new Map,this.b=!1,N(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{j(this.a.values())}finally{this.a.clear()}}has(k){return this.a.has(k)}get size(){return this.a.size}get(k){return this.a.get(k)}set(k,q,x=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),x||this.a.get(k)?.dispose(),this.a.set(k,q)}deleteAndDispose(k){this.a.get(k)?.dispose(),this.a.delete(k)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$4c=T}),ne(ie[23],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$be=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class M{static create(c){return new M(c)}constructor(c){this.c=i&&c===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$be=M}),ne(ie[12],se([0,1,3,20,11,22,23]),function(C,t,i,M,R,c,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$de=t.Event=void 0,t.$ee=b;const g=!1,a=!1,u=!1;var o;(function(q){q.None=()=>R.$Uc.None;function x(re){if(u){const{onDidAddListener:ee}=re,ue=m.create();let ae=0;re.onDidAddListener=()=>{++ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ue.print()),ee?.()}}}function W(re,ee){return fe(re,()=>{},0,void 0,!0,void 0,ee)}q.defer=W;function Q(re){return(ee,ue=null,ae)=>{let oe=!1,ce;return ce=re(be=>{if(!oe)return ce?ce.dispose():oe=!0,ee.call(ue,be)},null,ae),oe&&ce.dispose(),ce}}q.once=Q;function Y(re,ee,ue){return Z((ae,oe=null,ce)=>re(be=>ae.call(oe,ee(be)),null,ce),ue)}q.map=Y;function X(re,ee,ue){return Z((ae,oe=null,ce)=>re(be=>{ee(be),ae.call(oe,be)},null,ce),ue)}q.forEach=X;function G(re,ee,ue){return Z((ae,oe=null,ce)=>re(be=>ee(be)&&ae.call(oe,be),null,ce),ue)}q.filter=G;function U(re){return re}q.signal=U;function K(...re){return(ee,ue=null,ae)=>{const oe=(0,R.$Rc)(...re.map(ce=>ce(be=>ee.call(ue,be))));return de(oe,ae)}}q.any=K;function P(re,ee,ue,ae){let oe=ue;return Y(re,ce=>(oe=ee(oe,ce),oe),ae)}q.reduce=P;function Z(re,ee){let ue;const ae={onWillAddFirstListener(){ue=re(oe.fire,oe)},onDidRemoveLastListener(){ue?.dispose()}};ee||x(ae);const oe=new l(ae);return ee?.add(oe),oe.event}function de(re,ee){return ee instanceof Array?ee.push(re):ee&&ee.add(re),re}function fe(re,ee,ue=100,ae=!1,oe=!1,ce,be){let Le,Ne,Te,Ie=0,xe;const Re={leakWarningThreshold:ce,onWillAddFirstListener(){Le=re(We=>{Ie++,Ne=ee(Ne,We),ae&&!Te&&(qe.fire(Ne),Ne=void 0),xe=()=>{const He=Ne;Ne=void 0,Te=void 0,(!ae||Ie>1)&&qe.fire(He),Ie=0},typeof ue=="number"?(clearTimeout(Te),Te=setTimeout(xe,ue)):Te===void 0&&(Te=0,queueMicrotask(xe))})},onWillRemoveListener(){oe&&Ie>0&&xe?.()},onDidRemoveLastListener(){xe=void 0,Le.dispose()}};be||x(Re);const qe=new l(Re);return be?.add(qe),qe.event}q.debounce=fe;function ve(re,ee=0,ue){return q.debounce(re,(ae,oe)=>ae?(ae.push(oe),ae):[oe],ee,void 0,!0,void 0,ue)}q.accumulate=ve;function r(re,ee=(ae,oe)=>ae===oe,ue){let ae=!0,oe;return G(re,ce=>{const be=ae||!ee(ce,oe);return ae=!1,oe=ce,be},ue)}q.latch=r;function je(re,ee,ue){return[q.filter(re,ee,ue),q.filter(re,ae=>!ee(ae),ue)]}q.split=je;function Ae(re,ee=!1,ue=[],ae){let oe=ue.slice(),ce=re(Ne=>{oe?oe.push(Ne):Le.fire(Ne)});ae&&ae.add(ce);const be=()=>{oe?.forEach(Ne=>Le.fire(Ne)),oe=null},Le=new l({onWillAddFirstListener(){ce||(ce=re(Ne=>Le.fire(Ne)),ae&&ae.add(ce))},onDidAddFirstListener(){oe&&(ee?setTimeout(be):be())},onDidRemoveLastListener(){ce&&ce.dispose(),ce=null}});return ae&&ae.add(Le),Le.event}q.buffer=Ae;function Be(re,ee){return(ae,oe,ce)=>{const be=ee(new De);return re(function(Le){const Ne=be.evaluate(Le);Ne!==Ee&&ae.call(oe,Ne)},void 0,ce)}}q.chain=Be;const Ee=Symbol("HaltChainable");class De{constructor(){this.f=[]}map(ee){return this.f.push(ee),this}forEach(ee){return this.f.push(ue=>(ee(ue),ue)),this}filter(ee){return this.f.push(ue=>ee(ue)?ue:Ee),this}reduce(ee,ue){let ae=ue;return this.f.push(oe=>(ae=ee(ae,oe),ae)),this}latch(ee=(ue,ae)=>ue===ae){let ue=!0,ae;return this.f.push(oe=>{const ce=ue||!ee(oe,ae);return ue=!1,ae=oe,ce?oe:Ee}),this}evaluate(ee){for(const ue of this.f)if(ee=ue(ee),ee===Ee)break;return ee}}function B(re,ee,ue=ae=>ae){const ae=(...Le)=>be.fire(ue(...Le)),oe=()=>re.on(ee,ae),ce=()=>re.removeListener(ee,ae),be=new l({onWillAddFirstListener:oe,onDidRemoveLastListener:ce});return be.event}q.fromNodeEventEmitter=B;function H(re,ee,ue=ae=>ae){const ae=(...Le)=>be.fire(ue(...Le)),oe=()=>re.addEventListener(ee,ae),ce=()=>re.removeEventListener(ee,ae),be=new l({onWillAddFirstListener:oe,onDidRemoveLastListener:ce});return be.event}q.fromDOMEventEmitter=H;function V(re){return new Promise(ee=>Q(re)(ee))}q.toPromise=V;function J(re){const ee=new l;return re.then(ue=>{ee.fire(ue)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}q.fromPromise=J;function te(re,ee,ue){return ee(ue),re(ae=>ee(ae))}q.runAndSubscribe=te;class he{constructor(ee,ue){this._observable=ee,this.f=0,this.g=!1;const ae={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};ue||x(ae),this.emitter=new l(ae),ue&&ue.add(this.emitter)}beginUpdate(ee){this.f++}handlePossibleChange(ee){}handleChange(ee,ue){this.g=!0}endUpdate(ee){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function me(re,ee){return new he(re,ee).emitter.event}q.fromObservable=me;function we(re){return(ee,ue,ae)=>{let oe=0,ce=!1;const be={beginUpdate(){oe++},endUpdate(){oe--,oe===0&&(re.reportChanges(),ce&&(ce=!1,ee.call(ue)))},handlePossibleChange(){},handleChange(){ce=!0}};re.addObserver(be),re.reportChanges();const Le={dispose(){re.removeObserver(be)}};return ae instanceof R.$Tc?ae.add(Le):Array.isArray(ae)&&ae.push(Le),Le}}q.fromObservableLight=we})(o||(t.Event=o={}));class N{static{this.all=new Set}static{this.f=0}constructor(x){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${x}_${N.f++}`,N.all.add(this)}start(x){this.g=new $.$be,this.listenerCount=x}stop(){if(this.g){const x=this.g.elapsed();this.durations.push(x),this.elapsedOverall+=x,this.invocationCount+=1,this.g=void 0}}}t.$de=N;let d=-1;function b(q){const x=d;return d=q,{dispose(){d=x}}}class e{constructor(x,W=Math.random().toString(18).slice(2,5)){this.threshold=x,this.name=W,this.g=0}dispose(){this.f?.clear()}check(x,W){const Q=this.threshold;if(Q<=0||W<Q)return;this.f||(this.f=new Map);const Y=this.f.get(x.value)||0;if(this.f.set(x.value,Y+1),this.g-=1,this.g<=0){this.g=Q*.5;let X,G=0;for(const[U,K]of this.f)(!X||G<K)&&(X=U,G=K);console.warn(`[${this.name}] potential listener LEAK detected, having ${W} listeners already. MOST frequent listener (${G}):`),console.warn(X)}return()=>{const X=this.f.get(x.value)||0;this.f.set(x.value,X-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(x){this.value=x}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let S=0;class j{constructor(x){this.value=x,this.id=S++}}const v=2,w=(q,x)=>{if(q instanceof j)x(q);else for(let W=0;W<q.length;W++){const Q=q[W];Q&&x(Q)}},p=g?new FinalizationRegistry(q=>{typeof q=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(q))}):void 0;class l{constructor(x){this.w=0,this.f=x,this.g=d>0||this.f?.leakWarningThreshold?new e(this.f?.leakWarningThreshold??d):void 0,this.j=this.f?._profName?new N(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(a){const x=this.t;queueMicrotask(()=>{w(x,W=>W.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(x,W,Q)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),R.$Uc.None;if(this.m)return R.$Uc.None;W&&(x=x.bind(W));const Y=new j(x);let X,G;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(Y.stack=m.create(),X=this.g.check(Y.stack,this.w+1)),a&&(Y.stack=G??m.create()),this.t?this.t instanceof j?(this.u??=new s,this.t=[this.t,Y]):this.t.push(Y):(this.f?.onWillAddFirstListener?.(this),this.t=Y,this.f?.onDidAddFirstListener?.(this)),this.w++;const U=(0,R.$Sc)(()=>{p?.unregister(U),X?.(),this.x(Y)});if(Q instanceof R.$Tc?Q.add(U):Array.isArray(Q)&&Q.push(U),p){const K=new Error().stack.split(`
`).slice(2).join(`
`).trim();p.register(U,K,U)}return U},this.q}x(x){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const W=this.t,Q=W.indexOf(x);if(Q===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,W[Q]=void 0;const Y=this.u.current===this;if(this.w*v<=W.length){let X=0;for(let G=0;G<W.length;G++)W[G]?W[X++]=W[G]:Y&&(this.u.end--,X<this.u.i&&this.u.i--);W.length=X}}y(x,W){if(!x)return;const Q=this.f?.onListenerError||i.$1;if(!Q){x.value(W);return}try{x.value(W)}catch(Y){Q(Y)}}z(x){const W=x.current.t;for(;x.i<x.end;)this.y(W[x.i++],x.value);x.reset()}fire(x){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof j)this.y(this.t,x);else{const W=this.u;W.enqueue(this,x,this.t.length),this.z(W)}this.j?.stop()}hasListeners(){return this.w>0}}t.$fe=l;const n=()=>new s;t.$ge=n;class s{constructor(){this.i=-1,this.end=0}enqueue(x,W,Q){this.i=0,this.end=Q,this.current=x,this.value=W}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class f extends l{async fireAsync(x,W,Q){if(this.t)for(this.h||(this.h=new c.$5c),w(this.t,Y=>this.h.push([Y.value,x]));this.h.size>0&&!W.isCancellationRequested;){const[Y,X]=this.h.shift(),G=[],U={...X,token:W,waitUntil:K=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");Q&&(K=Q(K,Y)),G.push(K)}};try{Y(U)}catch(K){(0,i.$1)(K);continue}Object.freeze(G),await Promise.allSettled(G).then(K=>{for(const P of K)P.status==="rejected"&&(0,i.$1)(P.reason)})}}}t.$he=f;class h extends l{get isPaused(){return this.h!==0}constructor(x){super(x),this.h=0,this.s=new c.$5c,this.A=x?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const x=Array.from(this.s);this.s.clear(),super.fire(this.A(x))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(x){this.w&&(this.h!==0?this.s.push(x):super.fire(x))}}t.$ie=h;class L extends h{constructor(x){super(x),this.k=x.delay??100}fire(x){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(x)}}t.$je=L;class E extends l{constructor(x){super(x),this.h=[],this.k=x?.merge}fire(x){this.hasListeners()&&(this.h.push(x),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(W=>super.fire(W)),this.h=[]}))}}t.$ke=E;class A{constructor(){this.g=!1,this.h=[],this.f=new l({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(x){const W={event:x,listener:null};this.h.push(W),this.g&&this.m(W);const Q=()=>{this.g&&this.o(W);const Y=this.h.indexOf(W);this.h.splice(Y,1)};return(0,R.$Sc)((0,M.$db)(Q))}j(){this.g=!0,this.h.forEach(x=>this.m(x))}k(){this.g=!1,this.h.forEach(x=>this.o(x))}m(x){x.listener=x.event(W=>this.f.fire(W))}o(x){x.listener?.dispose(),x.listener=null}dispose(){this.f.dispose();for(const x of this.h)x.listener?.dispose();this.h=[]}}t.$le=A;class y{constructor(x,W,Q,Y){this.f=new R.$Tc;const X=this.f.add(new A),G=this.f.add(new R.$4c);function U(K){G.set(K,X.add(Y(K)))}for(const K of x)U(K);this.f.add(W(K=>{U(K)})),this.f.add(Q(K=>{G.deleteAndDispose(K)})),this.event=X.event}dispose(){this.f.dispose()}}t.$me=y;class F{constructor(){this.f=[]}wrapEvent(x,W,Q){return(Y,X,G)=>x(U=>{const K=this.f[this.f.length-1];if(!W){K?K.buffers.push(()=>Y.call(X,U)):Y.call(X,U);return}const P=K;if(!P){Y.call(X,W(Q,U));return}P.items??=[],P.items.push(U),P.buffers.length===0&&K.buffers.push(()=>{P.reducedResult??=Q?P.items.reduce(W,Q):P.items.reduce(W),Y.call(X,P.reducedResult)})},void 0,G)}bufferEvents(x){const W={buffers:new Array};this.f.push(W);const Q=x();return this.f.pop(),W.buffers.forEach(Y=>Y()),Q}}t.$ne=F;class T{constructor(){this.f=!1,this.g=o.None,this.h=R.$Uc.None,this.j=new l({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(x){this.g=x,this.f&&(this.h.dispose(),this.h=x(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$oe=T;class I{static const(x){return new k(x)}constructor(x){this.g=x,this.f=new l,this.onDidChange=this.f.event}get value(){return this.g}set value(x){x!==this.g&&(this.g=x,this.f.fire(void 0))}}t.$pe=I;class k{constructor(x){this.value=x,this.onDidChange=o.None}}}),ne(ie[24],se([0,1,12]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qe=t.CancellationToken=void 0,t.$re=g;const M=Object.freeze(function(a,u){const o=setTimeout(a.bind(u),0);return{dispose(){clearTimeout(o)}}});var R;(function(a){function u(o){return o===a.None||o===a.Cancelled||o instanceof c?!0:!o||typeof o!="object"?!1:typeof o.isCancellationRequested=="boolean"&&typeof o.onCancellationRequested=="function"}a.isCancellationToken=u,a.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),a.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(R||(t.CancellationToken=R={}));class c{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?M:(this.b||(this.b=new i.$fe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class ${constructor(u){this.f=void 0,this.g=void 0,this.g=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new c),this.f}cancel(){this.f?this.f instanceof c&&this.f.cancel():this.f=R.Cancelled}dispose(u=!1){u&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof c&&this.f.dispose():this.f=R.None}}t.$qe=$;function g(a){const u=new $;return a.add({dispose(){u.cancel()}}),u.token}}),ne(ie[41],se([0,1,24]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6e=t.$5e=t.$3e=void 0,t.$4e=R;class M{constructor(a){this.b=a,this.a=null}get(){if(this.a)return this.a;const a=new i.$qe,u=this.b(a.token);return this.a={promise:u,dispose:()=>{this.a=null,a.cancel(),a.dispose()}},this.a}}t.$3e=M;function R(g){return g}class c{constructor(a,u){this.a=void 0,this.b=void 0,typeof a=="function"?(this.c=a,this.d=R):(this.c=u,this.d=a.getCacheKey)}get(a){const u=this.d(a);return this.b!==u&&(this.b=u,this.a=this.c(a)),this.a}}t.$5e=c;class ${get cachedValues(){return this.a}constructor(a,u){this.a=new Map,this.b=new Map,typeof a=="function"?(this.c=a,this.d=R):(this.c=u,this.d=a.getCacheKey)}get(a){const u=this.d(a);if(this.b.has(u))return this.b.get(u);const o=this.c(a);return this.a.set(a,o),this.b.set(u,o),o}}t.$6e=$}),ne(ie[7],se([0,1,41,40]),function(C,t,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0f=t.$9f=t.$8f=t.GraphemeBreakType=t.$Xf=t.$Pf=t.$If=t.$Hf=void 0,t.$9e=R,t.$0e=$,t.$$e=a,t.$_e=u,t.$af=o,t.$bf=N,t.$cf=d,t.$df=b,t.$ef=e,t.$ff=m,t.$gf=S,t.$hf=j,t.$if=v,t.$jf=w,t.$kf=p,t.$lf=l,t.$mf=n,t.$nf=s,t.$of=f,t.$pf=h,t.$qf=L,t.$rf=E,t.$sf=A,t.$tf=y,t.$uf=F,t.$vf=T,t.$wf=I,t.$xf=k,t.$yf=q,t.$zf=x,t.$Af=W,t.$Bf=Q,t.$Cf=Y,t.$Df=X,t.$Ef=G,t.$Ff=U,t.$Gf=K,t.$Jf=fe,t.$Kf=ve,t.$Lf=r,t.$Mf=je,t.$Nf=Ee,t.$Of=B,t.$Qf=H,t.$Rf=V,t.$Sf=J,t.$Tf=te,t.$Uf=me,t.$Vf=we,t.$Wf=ee,t.$Yf=ue,t.$Zf=ae,t.$1f=oe,t.$2f=ce,t.$3f=be,t.$4f=Le,t.$5f=Ne,t.$6f=Te,t.$7f=We;function R(D){return!D||typeof D!="string"?!0:D.trim().length===0}const c=/{(\d+)}/g;function $(D,...O){return O.length===0?D:D.replace(c,function(z,_){const le=parseInt(_,10);return isNaN(le)||le<0||le>=O.length?z:O[le]})}const g=/{([^}]+)}/g;function a(D,O){return Object.keys(O).length===0?D:D.replace(g,(z,_)=>O[_]??z)}function u(D){return D.replace(/[<>"'&]/g,O=>{switch(O){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return O})}function o(D){return D.replace(/[<>&]/g,function(O){switch(O){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return O}})}function N(D){return D.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function d(D,O){let z=0,_=D.indexOf(O);for(;_!==-1;)z++,_=D.indexOf(O,_+O.length);return z}function b(D,O,z="\u2026"){return D.length<=O?D:`${D.substr(0,O)}${z}`}function e(D,O,z="\u2026"){if(D.length<=O)return D;const _=Math.ceil(O/2)-z.length/2,le=Math.floor(O/2)-z.length/2;return`${D.substr(0,_)}${z}${D.substr(D.length-le)}`}function m(D,O=" "){const z=S(D,O);return j(z,O)}function S(D,O){if(!D||!O)return D;const z=O.length;if(z===0||D.length===0)return D;let _=0;for(;D.indexOf(O,_)===_;)_=_+z;return D.substring(_)}function j(D,O){if(!D||!O)return D;const z=O.length,_=D.length;if(z===0||_===0)return D;let le=_,ge=-1;for(;ge=D.lastIndexOf(O,le-1),!(ge===-1||ge+z!==le);){if(ge===0)return"";le=ge}return D.substring(0,le)}function v(D){return D.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function w(D){return D.replace(/\*/g,"")}function p(D,O,z={}){if(!D)throw new Error("Cannot create regex from empty string");O||(D=N(D)),z.wholeWord&&(/\B/.test(D.charAt(0))||(D="\\b"+D),/\B/.test(D.charAt(D.length-1))||(D=D+"\\b"));let _="";return z.global&&(_+="g"),z.matchCase||(_+="i"),z.multiline&&(_+="m"),z.unicode&&(_+="u"),new RegExp(D,_)}function l(D){return D.source==="^"||D.source==="^$"||D.source==="$"||D.source==="^\\s*$"?!1:!!(D.exec("")&&D.lastIndex===0)}function n(D){return D.split(/\r\n|\r|\n/)}function s(D){const O=[],z=D.split(/(\r\n|\r|\n)/);for(let _=0;_<Math.ceil(z.length/2);_++)O.push(z[2*_]+(z[2*_+1]??""));return O}function f(D){for(let O=0,z=D.length;O<z;O++){const _=D.charCodeAt(O);if(_!==32&&_!==9)return O}return-1}function h(D,O=0,z=D.length){for(let _=O;_<z;_++){const le=D.charCodeAt(_);if(le!==32&&le!==9)return D.substring(O,_)}return D.substring(O,z)}function L(D,O=D.length-1){for(let z=O;z>=0;z--){const _=D.charCodeAt(z);if(_!==32&&_!==9)return z}return-1}function E(D,O,z){const _=[];let le=0;for(const ge of D.matchAll(O)){if(_.push(D.slice(le,ge.index)),ge.index===void 0)throw new Error("match.index should be defined");le=ge.index+ge[0].length,_.push(z(ge[0],...ge.slice(1),ge.index,D,ge.groups))}return _.push(D.slice(le)),Promise.all(_).then(ge=>ge.join(""))}function A(D,O){return D<O?-1:D>O?1:0}function y(D,O,z=0,_=D.length,le=0,ge=O.length){for(;z<_&&le<ge;z++,le++){const Me=D.charCodeAt(z),ye=O.charCodeAt(le);if(Me<ye)return-1;if(Me>ye)return 1}const Se=_-z,Fe=ge-le;return Se<Fe?-1:Se>Fe?1:0}function F(D,O){return T(D,O,0,D.length,0,O.length)}function T(D,O,z=0,_=D.length,le=0,ge=O.length){for(;z<_&&le<ge;z++,le++){let Me=D.charCodeAt(z),ye=O.charCodeAt(le);if(Me===ye)continue;if(Me>=128||ye>=128)return y(D.toLowerCase(),O.toLowerCase(),z,_,le,ge);k(Me)&&(Me-=32),k(ye)&&(ye-=32);const pe=Me-ye;if(pe!==0)return pe}const Se=_-z,Fe=ge-le;return Se<Fe?-1:Se>Fe?1:0}function I(D){return D>=48&&D<=57}function k(D){return D>=97&&D<=122}function q(D){return D>=65&&D<=90}function x(D,O){return D.length===O.length&&T(D,O)===0}function W(D,O){const z=O.length;return O.length>D.length?!1:T(D,O,0,z)===0}function Q(D,O){const z=Math.min(D.length,O.length);let _;for(_=0;_<z;_++)if(D.charCodeAt(_)!==O.charCodeAt(_))return _;return z}function Y(D,O){const z=Math.min(D.length,O.length);let _;const le=D.length-1,ge=O.length-1;for(_=0;_<z;_++)if(D.charCodeAt(le-_)!==O.charCodeAt(ge-_))return _;return z}function X(D){return 55296<=D&&D<=56319}function G(D){return 56320<=D&&D<=57343}function U(D,O){return(D-55296<<10)+(O-56320)+65536}function K(D,O,z){const _=D.charCodeAt(z);if(X(_)&&z+1<O){const le=D.charCodeAt(z+1);if(G(le))return U(_,le)}return _}function P(D,O){const z=D.charCodeAt(O-1);if(G(z)&&O>1){const _=D.charCodeAt(O-2);if(X(_))return U(_,z)}return z}class Z{get offset(){return this.e}constructor(O,z=0){this.c=O,this.d=O.length,this.e=z}setOffset(O){this.e=O}prevCodePoint(){const O=P(this.c,this.e);return this.e-=O>=65536?2:1,O}nextCodePoint(){const O=K(this.c,this.d,this.e);return this.e+=O>=65536?2:1,O}eol(){return this.e>=this.d}}t.$Hf=Z;class de{get offset(){return this.c.offset}constructor(O,z=0){this.c=new Z(O,z)}nextGraphemeLength(){const O=Re.getInstance(),z=this.c,_=z.offset;let le=O.getGraphemeBreakType(z.nextCodePoint());for(;!z.eol();){const ge=z.offset,Se=O.getGraphemeBreakType(z.nextCodePoint());if(Ie(le,Se)){z.setOffset(ge);break}le=Se}return z.offset-_}prevGraphemeLength(){const O=Re.getInstance(),z=this.c,_=z.offset;let le=O.getGraphemeBreakType(z.prevCodePoint());for(;z.offset>0;){const ge=z.offset,Se=O.getGraphemeBreakType(z.prevCodePoint());if(Ie(Se,le)){z.setOffset(ge);break}le=Se}return _-z.offset}eol(){return this.c.eol()}}t.$If=de;function fe(D,O){return new de(D,O).nextGraphemeLength()}function ve(D,O){return new de(D,O).prevGraphemeLength()}function r(D,O){O>0&&G(D.charCodeAt(O))&&O--;const z=O+fe(D,O);return[z-ve(D,z),z]}function je(D){const O=new de(D);let z=0;for(;!O.eol();)z++,O.nextGraphemeLength();return z}let Ae;function Be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ee(D){return Ae||(Ae=Be()),Ae.test(D)}const De=/^[\t\n\r\x20-\x7E]*$/;function B(D){return De.test(D)}t.$Pf=/[\u2028\u2029]/;function H(D){return t.$Pf.test(D)}function V(D){return D>=11904&&D<=55215||D>=63744&&D<=64255||D>=65281&&D<=65374}function J(D){return D>=127462&&D<=127487||D===8986||D===8987||D===9200||D===9203||D>=9728&&D<=10175||D===11088||D===11093||D>=127744&&D<=128591||D>=128640&&D<=128764||D>=128992&&D<=129008||D>=129280&&D<=129535||D>=129648&&D<=129782}function te(D,O,z=""){const _=D.trimStart();if(_.length<O)return _;const le=/\b/g;let ge=0;for(;le.test(_)&&!(_.length-le.lastIndex<O);)ge=le.lastIndex,le.lastIndex+=1;return ge===0?_:z+_.substring(ge).trimStart()}const he=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*me(D){let O=0;for(const z of D.matchAll(he))O!==z.index&&(yield{isCode:!1,str:D.substring(O,z.index)}),yield{isCode:!0,str:z[0]},O=z.index+z[0].length;O!==D.length&&(yield{isCode:!1,str:D.substring(O)})}function we(D){return D&&(D=D.replace(he,"")),D}const re=/\\\[.*?\\\]/g;function ee(D){return we(D).replace(re,"")}t.$Xf="\uFEFF";function ue(D){return!!(D&&D.length>0&&D.charCodeAt(0)===65279)}function ae(D){return ue(D)?D.substr(1):D}function oe(D,O){if(!D||!O||D.length<O.length)return!1;const z=O.length,_=D.toLowerCase();let le=0,ge=-1;for(;le<z;){const Se=_.indexOf(O[le],ge+1);if(Se<0)return!1;ge=Se,le++}return!0}function ce(D,O=!1){return D?(O&&(D=D.replace(/\\./g,"")),D.toLowerCase()!==D):!1}function be(D){return D.charAt(0).toUpperCase()+D.slice(1)}function Le(D,O=1){if(O===0)return"";let z=-1;do z=D.indexOf(`
`,z+1),O--;while(O>0&&z>=0);return z===-1?D:(D[z-1]==="\r"&&z--,D.substr(0,z))}function Ne(D){return D=D%(2*26),D<26?String.fromCharCode(97+D):String.fromCharCode(65+D-26)}function Te(D){return Re.getInstance().getGraphemeBreakType(D)}function Ie(D,O){return D===0?O!==5&&O!==7:D===2&&O===3?!1:D===4||D===2||D===3||O===4||O===2||O===3?!0:!(D===8&&(O===8||O===9||O===11||O===12)||(D===11||D===9)&&(O===9||O===10)||(D===12||D===10)&&O===10||O===5||O===13||O===7||D===1||D===13&&O===14||D===6&&O===6)}var xe;(function(D){D[D.Other=0]="Other",D[D.Prepend=1]="Prepend",D[D.CR=2]="CR",D[D.LF=3]="LF",D[D.Control=4]="Control",D[D.Extend=5]="Extend",D[D.Regional_Indicator=6]="Regional_Indicator",D[D.SpacingMark=7]="SpacingMark",D[D.L=8]="L",D[D.V=9]="V",D[D.T=10]="T",D[D.LV=11]="LV",D[D.LVT=12]="LVT",D[D.ZWJ=13]="ZWJ",D[D.Extended_Pictographic=14]="Extended_Pictographic"})(xe||(t.GraphemeBreakType=xe={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=qe()}getGraphemeBreakType(O){if(O<32)return O===10?3:O===13?2:4;if(O<127)return 0;const z=this.d,_=z.length/3;let le=1;for(;le<=_;)if(O<z[3*le])le=2*le;else if(O>z[3*le+1])le=2*le+1;else return z[3*le+2];return 0}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(D,O){if(D===0)return 0;const z=He(D,O);if(z!==void 0)return z;const _=new Z(O,D);return _.prevCodePoint(),_.offset}function He(D,O){const z=new Z(O,D);let _=z.prevCodePoint();for(;Je(_)||_===65039||_===8419;){if(z.offset===0)return;_=z.prevCodePoint()}if(!J(_))return;let le=z.offset;return le>0&&z.prevCodePoint()===8205&&(le=z.offset),le}function Je(D){return 127995<=D&&D<=127999}var Xe;(function(D){D[D.zwj=8205]="zwj",D[D.emojiVariantSelector=65039]="emojiVariantSelector",D[D.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),t.$8f="\xA0";class Oe{static{this.c=new M.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$5e({getCacheKey:JSON.stringify},O=>{function z(pe){const ke=new Map;for(let Pe=0;Pe<pe.length;Pe+=2)ke.set(pe[Pe],pe[Pe+1]);return ke}function _(pe,ke){const Pe=new Map(pe);for(const[Ve,ze]of ke)Pe.set(Ve,ze);return Pe}function le(pe,ke){if(!pe)return ke;const Pe=new Map;for(const[Ve,ze]of pe)ke.has(Ve)&&Pe.set(Ve,ze);return Pe}const ge=this.c.value;let Se=O.filter(pe=>!pe.startsWith("_")&&pe in ge);Se.length===0&&(Se=["_default"]);let Fe;for(const pe of Se){const ke=z(ge[pe]);Fe=le(Fe,ke)}const Me=z(ge._common),ye=_(Me,Fe);return new Oe(ye)})}static getInstance(O){return Oe.d.get(Array.from(O))}static{this.e=new M.$V(()=>Object.keys(Oe.c.value).filter(O=>!O.startsWith("_")))}static getLocales(){return Oe.e.value}constructor(O){this.f=O}isAmbiguous(O){return this.f.has(O)}getPrimaryConfusable(O){return this.f.get(O)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$9f=Oe;class Ce{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ce.c())),this.d}static isInvisibleCharacter(O){return Ce.e().has(O)}static get codePoints(){return Ce.e()}}t.$0f=Ce}),ne(ie[42],se([0,1,7]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sj=t.$qj=void 0,t.$mj=M,t.$nj=R,t.$oj=c,t.$pj=g,t.$rj=m;function M(j){return R(j,0)}function R(j,v){switch(typeof j){case"object":return j===null?c(349,v):Array.isArray(j)?a(j,v):u(j,v);case"string":return g(j,v);case"boolean":return $(j,v);case"number":return c(j,v);case"undefined":return c(937,v);default:return c(617,v)}}function c(j,v){return(v<<5)-v+j|0}function $(j,v){return c(j?433:863,v)}function g(j,v){v=c(149417,v);for(let w=0,p=j.length;w<p;w++)v=c(j.charCodeAt(w),v);return v}function a(j,v){return v=c(104579,v),j.reduce((w,p)=>R(p,w),v)}function u(j,v){return v=c(181387,v),Object.keys(j).sort().reduce((w,p)=>(w=g(p,w),R(j[p],w)),v)}class o{constructor(){this.g=0}get value(){return this.g}hash(v){return this.g=R(v,this.g),this.g}}t.$qj=o;var N;(function(j){j[j.BLOCK_SIZE=64]="BLOCK_SIZE",j[j.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(N||(N={}));function d(j,v,w=32){const p=w-v,l=~((1<<p)-1);return(j<<v|(l&j)>>>p)>>>0}function b(j,v=0,w=j.byteLength,p=0){for(let l=0;l<w;l++)j[v+l]=p}function e(j,v,w="0"){for(;j.length<v;)j=w+j;return j}function m(j,v=32){return j instanceof ArrayBuffer?Array.from(new Uint8Array(j)).map(w=>w.toString(16).padStart(2,"0")).join(""):e((j>>>0).toString(16),v/4)}class S{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(v){const w=v.length;if(w===0)return;const p=this.p;let l=this.r,n=this.u,s,f;for(n!==0?(s=n,f=-1,n=0):(s=v.charCodeAt(0),f=0);;){let h=s;if(i.$Df(s))if(f+1<w){const L=v.charCodeAt(f+1);i.$Ef(L)?(f++,h=i.$Ff(s,L)):h=65533}else{n=s;break}else i.$Ef(s)&&(h=65533);if(l=this.w(p,l,h),f++,f<w)s=v.charCodeAt(f);else break}this.r=l,this.u=n}w(v,w,p){return p<128?v[w++]=p:p<2048?(v[w++]=192|(p&1984)>>>6,v[w++]=128|(p&63)>>>0):p<65536?(v[w++]=224|(p&61440)>>>12,v[w++]=128|(p&4032)>>>6,v[w++]=128|(p&63)>>>0):(v[w++]=240|(p&1835008)>>>18,v[w++]=128|(p&258048)>>>12,v[w++]=128|(p&4032)>>>6,v[w++]=128|(p&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,v[0]=v[64],v[1]=v[65],v[2]=v[66]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,b(this.p,this.r),this.r>56&&(this.y(),b(this.p));const v=8*this.t;this.q.setUint32(56,Math.floor(v/4294967296),!1),this.q.setUint32(60,v%4294967296,!1),this.y()}y(){const v=S.g,w=this.q;for(let A=0;A<64;A+=4)v.setUint32(A,w.getUint32(A,!1),!1);for(let A=64;A<320;A+=4)v.setUint32(A,d(v.getUint32(A-12,!1)^v.getUint32(A-32,!1)^v.getUint32(A-56,!1)^v.getUint32(A-64,!1),1),!1);let p=this.h,l=this.l,n=this.m,s=this.n,f=this.o,h,L,E;for(let A=0;A<80;A++)A<20?(h=l&n|~l&s,L=1518500249):A<40?(h=l^n^s,L=1859775393):A<60?(h=l&n|l&s|n&s,L=2400959708):(h=l^n^s,L=3395469782),E=d(p,5)+h+f+L+v.getUint32(A*4,!1)&4294967295,f=s,s=n,n=d(l,30),l=p,p=E;this.h=this.h+p&4294967295,this.l=this.l+l&4294967295,this.m=this.m+n&4294967295,this.n=this.n+s&4294967295,this.o=this.o+f&4294967295}}t.$sj=S}),ne(ie[25],se([0,1,38,42]),function(C,t,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dt=t.$Bt=void 0,t.$Ct=c;class R{constructor(d){this.a=d}getElements(){const d=this.a,b=new Int32Array(d.length);for(let e=0,m=d.length;e<m;e++)b[e]=d.charCodeAt(e);return b}}t.$Bt=R;function c(N,d,b){return new o(new R(N),new R(d)).ComputeDiff(b).changes}class ${static Assert(d,b){if(!d)throw new Error(b)}}class g{static Copy(d,b,e,m,S){for(let j=0;j<S;j++)e[m+j]=d[b+j]}static Copy2(d,b,e,m,S){for(let j=0;j<S;j++)e[m+j]=d[b+j]}}var a;(function(N){N[N.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class u{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$At(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(d,b){this.b=Math.min(this.b,d),this.c=Math.min(this.c,b),this.d++}AddModifiedElement(d,b){this.b=Math.min(this.b,d),this.c=Math.min(this.c,b),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class o{constructor(d,b,e=null){this.a=e,this.b=d,this.c=b;const[m,S,j]=o.o(d),[v,w,p]=o.o(b);this.d=j&&p,this.e=m,this.f=S,this.g=v,this.h=w,this.k=[],this.m=[]}static n(d){return d.length>0&&typeof d[0]=="string"}static o(d){const b=d.getElements();if(o.n(b)){const e=new Int32Array(b.length);for(let m=0,S=b.length;m<S;m++)e[m]=(0,M.$pj)(b[m],0);return[b,e,!0]}return b instanceof Int32Array?[[],b,!1]:[[],new Int32Array(b),!1]}p(d,b){return this.f[d]!==this.h[b]?!1:this.d?this.e[d]===this.g[b]:!0}q(d,b){if(!this.p(d,b))return!1;const e=o.r(this.b,d),m=o.r(this.c,b);return e===m}static r(d,b){return typeof d.getStrictElement=="function"?d.getStrictElement(b):null}s(d,b){return this.f[d]!==this.f[b]?!1:this.d?this.e[d]===this.e[b]:!0}u(d,b){return this.h[d]!==this.h[b]?!1:this.d?this.g[d]===this.g[b]:!0}ComputeDiff(d){return this.v(0,this.f.length-1,0,this.h.length-1,d)}v(d,b,e,m,S){const j=[!1];let v=this.w(d,b,e,m,j);return S&&(v=this.z(v)),{quitEarly:j[0],changes:v}}w(d,b,e,m,S){for(S[0]=!1;d<=b&&e<=m&&this.p(d,e);)d++,e++;for(;b>=d&&m>=e&&this.p(b,m);)b--,m--;if(d>b||e>m){let n;return e<=m?($.Assert(d===b+1,"originalStart should only be one more than originalEnd"),n=[new i.$At(d,0,e,m-e+1)]):d<=b?($.Assert(e===m+1,"modifiedStart should only be one more than modifiedEnd"),n=[new i.$At(d,b-d+1,e,0)]):($.Assert(d===b+1,"originalStart should only be one more than originalEnd"),$.Assert(e===m+1,"modifiedStart should only be one more than modifiedEnd"),n=[]),n}const j=[0],v=[0],w=this.y(d,b,e,m,j,v,S),p=j[0],l=v[0];if(w!==null)return w;if(!S[0]){const n=this.w(d,p,e,l,S);let s=[];return S[0]?s=[new i.$At(p+1,b-(p+1)+1,l+1,m-(l+1)+1)]:s=this.w(p+1,b,l+1,m,S),this.H(n,s)}return[new i.$At(d,b-d+1,e,m-e+1)]}x(d,b,e,m,S,j,v,w,p,l,n,s,f,h,L,E,A,y){let F=null,T=null,I=new u,k=b,q=e,x=f[0]-E[0]-m,W=-1073741824,Q=this.k.length-1;do{const Y=x+d;Y===k||Y<q&&p[Y-1]<p[Y+1]?(n=p[Y+1],h=n-x-m,n<W&&I.MarkNextChange(),W=n,I.AddModifiedElement(n+1,h),x=Y+1-d):(n=p[Y-1]+1,h=n-x-m,n<W&&I.MarkNextChange(),W=n-1,I.AddOriginalElement(n,h+1),x=Y-1-d),Q>=0&&(p=this.k[Q],d=p[0],k=1,q=p.length-1)}while(--Q>=-1);if(F=I.getReverseChanges(),y[0]){let Y=f[0]+1,X=E[0]+1;if(F!==null&&F.length>0){const G=F[F.length-1];Y=Math.max(Y,G.getOriginalEnd()),X=Math.max(X,G.getModifiedEnd())}T=[new i.$At(Y,s-Y+1,X,L-X+1)]}else{I=new u,k=j,q=v,x=f[0]-E[0]-w,W=1073741824,Q=A?this.m.length-1:this.m.length-2;do{const Y=x+S;Y===k||Y<q&&l[Y-1]>=l[Y+1]?(n=l[Y+1]-1,h=n-x-w,n>W&&I.MarkNextChange(),W=n+1,I.AddOriginalElement(n+1,h+1),x=Y+1-S):(n=l[Y-1],h=n-x-w,n>W&&I.MarkNextChange(),W=n,I.AddModifiedElement(n+1,h+1),x=Y-1-S),Q>=0&&(l=this.m[Q],S=l[0],k=1,q=l.length-1)}while(--Q>=-1);T=I.getChanges()}return this.H(F,T)}y(d,b,e,m,S,j,v){let w=0,p=0,l=0,n=0,s=0,f=0;d--,e--,S[0]=0,j[0]=0,this.k=[],this.m=[];const h=b-d+(m-e),L=h+1,E=new Int32Array(L),A=new Int32Array(L),y=m-e,F=b-d,T=d-e,I=b-m,q=(F-y)%2===0;E[y]=d,A[F]=b,v[0]=!1;for(let x=1;x<=h/2+1;x++){let W=0,Q=0;l=this.J(y-x,x,y,L),n=this.J(y+x,x,y,L);for(let X=l;X<=n;X+=2){X===l||X<n&&E[X-1]<E[X+1]?w=E[X+1]:w=E[X-1]+1,p=w-(X-y)-T;const G=w;for(;w<b&&p<m&&this.p(w+1,p+1);)w++,p++;if(E[X]=w,w+p>W+Q&&(W=w,Q=p),!q&&Math.abs(X-F)<=x-1&&w>=A[X])return S[0]=w,j[0]=p,G<=A[X]&&1447>0&&x<=1448?this.x(y,l,n,T,F,s,f,I,E,A,w,b,S,p,m,j,q,v):null}const Y=(W-d+(Q-e)-x)/2;if(this.a!==null&&!this.a(W,Y))return v[0]=!0,S[0]=W,j[0]=Q,Y>0&&1447>0&&x<=1448?this.x(y,l,n,T,F,s,f,I,E,A,w,b,S,p,m,j,q,v):(d++,e++,[new i.$At(d,b-d+1,e,m-e+1)]);s=this.J(F-x,x,F,L),f=this.J(F+x,x,F,L);for(let X=s;X<=f;X+=2){X===s||X<f&&A[X-1]>=A[X+1]?w=A[X+1]-1:w=A[X-1],p=w-(X-F)-I;const G=w;for(;w>d&&p>e&&this.p(w,p);)w--,p--;if(A[X]=w,q&&Math.abs(X-y)<=x&&w<=E[X])return S[0]=w,j[0]=p,G>=E[X]&&1447>0&&x<=1448?this.x(y,l,n,T,F,s,f,I,E,A,w,b,S,p,m,j,q,v):null}if(x<=1447){let X=new Int32Array(n-l+2);X[0]=y-l+1,g.Copy2(E,l,X,1,n-l+1),this.k.push(X),X=new Int32Array(f-s+2),X[0]=F-s+1,g.Copy2(A,s,X,1,f-s+1),this.m.push(X)}}return this.x(y,l,n,T,F,s,f,I,E,A,w,b,S,p,m,j,q,v)}z(d){for(let b=0;b<d.length;b++){const e=d[b],m=b<d.length-1?d[b+1].originalStart:this.f.length,S=b<d.length-1?d[b+1].modifiedStart:this.h.length,j=e.originalLength>0,v=e.modifiedLength>0;for(;e.originalStart+e.originalLength<m&&e.modifiedStart+e.modifiedLength<S&&(!j||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!v||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const p=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!p)break;e.originalStart++,e.modifiedStart++}const w=[null];if(b<d.length-1&&this.I(d[b],d[b+1],w)){d[b]=w[0],d.splice(b+1,1),b--;continue}}for(let b=d.length-1;b>=0;b--){const e=d[b];let m=0,S=0;if(b>0){const n=d[b-1];m=n.originalStart+n.originalLength,S=n.modifiedStart+n.modifiedLength}const j=e.originalLength>0,v=e.modifiedLength>0;let w=0,p=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let n=1;;n++){const s=e.originalStart-n,f=e.modifiedStart-n;if(s<m||f<S||j&&!this.s(s,s+e.originalLength)||v&&!this.u(f,f+e.modifiedLength))break;const L=(s===m&&f===S?5:0)+this.G(s,e.originalLength,f,e.modifiedLength);L>p&&(p=L,w=n)}e.originalStart-=w,e.modifiedStart-=w;const l=[null];if(b>0&&this.I(d[b-1],d[b],l)){d[b-1]=l[0],d.splice(b,1),b++;continue}}if(this.d)for(let b=1,e=d.length;b<e;b++){const m=d[b-1],S=d[b],j=S.originalStart-m.originalStart-m.originalLength,v=m.originalStart,w=S.originalStart+S.originalLength,p=w-v,l=m.modifiedStart,n=S.modifiedStart+S.modifiedLength,s=n-l;if(j<5&&p<20&&s<20){const f=this.A(v,p,l,s,j);if(f){const[h,L]=f;(h!==m.originalStart+m.originalLength||L!==m.modifiedStart+m.modifiedLength)&&(m.originalLength=h-m.originalStart,m.modifiedLength=L-m.modifiedStart,S.originalStart=h+j,S.modifiedStart=L+j,S.originalLength=w-S.originalStart,S.modifiedLength=n-S.modifiedStart)}}}return d}A(d,b,e,m,S){if(b<S||m<S)return null;const j=d+b-S+1,v=e+m-S+1;let w=0,p=0,l=0;for(let n=d;n<j;n++)for(let s=e;s<v;s++){const f=this.B(n,s,S);f>0&&f>w&&(w=f,p=n,l=s)}return w>0?[p,l]:null}B(d,b,e){let m=0;for(let S=0;S<e;S++){if(!this.p(d+S,b+S))return 0;m+=this.e[d+S].length}return m}C(d){return d<=0||d>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[d])}D(d,b){if(this.C(d)||this.C(d-1))return!0;if(b>0){const e=d+b;if(this.C(e-1)||this.C(e))return!0}return!1}E(d){return d<=0||d>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[d])}F(d,b){if(this.E(d)||this.E(d-1))return!0;if(b>0){const e=d+b;if(this.E(e-1)||this.E(e))return!0}return!1}G(d,b,e,m){const S=this.D(d,b)?1:0,j=this.F(e,m)?1:0;return S+j}H(d,b){const e=[];if(d.length===0||b.length===0)return b.length>0?b:d;if(this.I(d[d.length-1],b[0],e)){const m=new Array(d.length+b.length-1);return g.Copy(d,0,m,0,d.length-1),m[d.length-1]=e[0],g.Copy(b,1,m,d.length,b.length-1),m}else{const m=new Array(d.length+b.length);return g.Copy(d,0,m,0,d.length),g.Copy(b,0,m,d.length,b.length),m}}I(d,b,e){if($.Assert(d.originalStart<=b.originalStart,"Left change is not less than or equal to right change"),$.Assert(d.modifiedStart<=b.modifiedStart,"Left change is not less than or equal to right change"),d.originalStart+d.originalLength>=b.originalStart||d.modifiedStart+d.modifiedLength>=b.modifiedStart){const m=d.originalStart;let S=d.originalLength;const j=d.modifiedStart;let v=d.modifiedLength;return d.originalStart+d.originalLength>=b.originalStart&&(S=b.originalStart+b.originalLength-d.originalStart),d.modifiedStart+d.modifiedLength>=b.modifiedStart&&(v=b.modifiedStart+b.modifiedLength-d.modifiedStart),e[0]=new i.$At(m,S,j,v),!0}else return e[0]=null,!1}J(d,b,e,m){if(d>=0&&d<m)return d;const S=e,j=m-e-1,v=b%2===0;if(d<0){const w=S%2===0;return v===w?0:1}else{const w=j%2===0;return v===w?m-1:m-2}}}t.$Dt=o}),ne(ie[26],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$f=i,t.$_f=M,t.$ag=R,t.$bg=c,t.$cg=$,t.$dg=g,t.$eg=a,t.$fg=u,t.$gg=o,t.$hg=N,t.$ig=d,t.$jg=b,t.$kg=e,t.$lg=S,t.$mg=j,t.$ng=v,t.$og=w,t.$pg=p;function i(l){return typeof l=="string"}function M(l){return Array.isArray(l)&&l.every(n=>i(n))}function R(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}function c(l){const n=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof n}function $(l){return typeof l=="number"&&!isNaN(l)}function g(l){return!!l&&typeof l[Symbol.iterator]=="function"}function a(l){return l===!0||l===!1}function u(l){return typeof l>"u"}function o(l){return!N(l)}function N(l){return u(l)||l===null}function d(l,n){if(!l)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function b(l){if(N(l))throw new Error("Assertion Failed: argument is undefined or null");return l}function e(...l){const n=[];for(let s=0;s<l.length;s++){const f=l[s];if(N(f))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(f)}return n}const m=Object.prototype.hasOwnProperty;function S(l){if(!R(l))return!1;for(const n in l)if(m.call(l,n))return!1;return!0}function j(l){return typeof l=="function"}function v(...l){return l.length>0&&l.every(j)}function w(l,n){const s=Math.min(l.length,n.length);for(let f=0;f<s;f++)p(l[f],n[f])}function p(l,n){if(i(n)){if(typeof l!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(j(n)){try{if(l instanceof n)return}catch{}if(!N(l)&&l.constructor===n||n.length===1&&n.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),ne(ie[27],se([0,1,26]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sj=R,t.$Tj=c;const M=Object.create(null);function R($,g){if((0,i.$$f)(g)){const a=M[g];if(a===void 0)throw new Error(`${$} references an unknown codicon: ${g}`);g=a}return M[$]=g,{id:$}}function c(){return M}}),ne(ie[43],se([0,1,27]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uj=void 0,t.$Uj={add:(0,i.$Sj)("add",6e4),plus:(0,i.$Sj)("plus",6e4),gistNew:(0,i.$Sj)("gist-new",6e4),repoCreate:(0,i.$Sj)("repo-create",6e4),lightbulb:(0,i.$Sj)("lightbulb",60001),lightBulb:(0,i.$Sj)("light-bulb",60001),repo:(0,i.$Sj)("repo",60002),repoDelete:(0,i.$Sj)("repo-delete",60002),gistFork:(0,i.$Sj)("gist-fork",60003),repoForked:(0,i.$Sj)("repo-forked",60003),gitPullRequest:(0,i.$Sj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Sj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Sj)("record-keys",60005),keyboard:(0,i.$Sj)("keyboard",60005),tag:(0,i.$Sj)("tag",60006),gitPullRequestLabel:(0,i.$Sj)("git-pull-request-label",60006),tagAdd:(0,i.$Sj)("tag-add",60006),tagRemove:(0,i.$Sj)("tag-remove",60006),person:(0,i.$Sj)("person",60007),personFollow:(0,i.$Sj)("person-follow",60007),personOutline:(0,i.$Sj)("person-outline",60007),personFilled:(0,i.$Sj)("person-filled",60007),gitBranch:(0,i.$Sj)("git-branch",60008),gitBranchCreate:(0,i.$Sj)("git-branch-create",60008),gitBranchDelete:(0,i.$Sj)("git-branch-delete",60008),sourceControl:(0,i.$Sj)("source-control",60008),mirror:(0,i.$Sj)("mirror",60009),mirrorPublic:(0,i.$Sj)("mirror-public",60009),star:(0,i.$Sj)("star",60010),starAdd:(0,i.$Sj)("star-add",60010),starDelete:(0,i.$Sj)("star-delete",60010),starEmpty:(0,i.$Sj)("star-empty",60010),comment:(0,i.$Sj)("comment",60011),commentAdd:(0,i.$Sj)("comment-add",60011),alert:(0,i.$Sj)("alert",60012),warning:(0,i.$Sj)("warning",60012),search:(0,i.$Sj)("search",60013),searchSave:(0,i.$Sj)("search-save",60013),logOut:(0,i.$Sj)("log-out",60014),signOut:(0,i.$Sj)("sign-out",60014),logIn:(0,i.$Sj)("log-in",60015),signIn:(0,i.$Sj)("sign-in",60015),eye:(0,i.$Sj)("eye",60016),eyeUnwatch:(0,i.$Sj)("eye-unwatch",60016),eyeWatch:(0,i.$Sj)("eye-watch",60016),circleFilled:(0,i.$Sj)("circle-filled",60017),primitiveDot:(0,i.$Sj)("primitive-dot",60017),closeDirty:(0,i.$Sj)("close-dirty",60017),debugBreakpoint:(0,i.$Sj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Sj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Sj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Sj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Sj)("primitive-square",60018),edit:(0,i.$Sj)("edit",60019),pencil:(0,i.$Sj)("pencil",60019),info:(0,i.$Sj)("info",60020),issueOpened:(0,i.$Sj)("issue-opened",60020),gistPrivate:(0,i.$Sj)("gist-private",60021),gitForkPrivate:(0,i.$Sj)("git-fork-private",60021),lock:(0,i.$Sj)("lock",60021),mirrorPrivate:(0,i.$Sj)("mirror-private",60021),close:(0,i.$Sj)("close",60022),removeClose:(0,i.$Sj)("remove-close",60022),x:(0,i.$Sj)("x",60022),repoSync:(0,i.$Sj)("repo-sync",60023),sync:(0,i.$Sj)("sync",60023),clone:(0,i.$Sj)("clone",60024),desktopDownload:(0,i.$Sj)("desktop-download",60024),beaker:(0,i.$Sj)("beaker",60025),microscope:(0,i.$Sj)("microscope",60025),vm:(0,i.$Sj)("vm",60026),deviceDesktop:(0,i.$Sj)("device-desktop",60026),file:(0,i.$Sj)("file",60027),fileText:(0,i.$Sj)("file-text",60027),more:(0,i.$Sj)("more",60028),ellipsis:(0,i.$Sj)("ellipsis",60028),kebabHorizontal:(0,i.$Sj)("kebab-horizontal",60028),mailReply:(0,i.$Sj)("mail-reply",60029),reply:(0,i.$Sj)("reply",60029),organization:(0,i.$Sj)("organization",60030),organizationFilled:(0,i.$Sj)("organization-filled",60030),organizationOutline:(0,i.$Sj)("organization-outline",60030),newFile:(0,i.$Sj)("new-file",60031),fileAdd:(0,i.$Sj)("file-add",60031),newFolder:(0,i.$Sj)("new-folder",60032),fileDirectoryCreate:(0,i.$Sj)("file-directory-create",60032),trash:(0,i.$Sj)("trash",60033),trashcan:(0,i.$Sj)("trashcan",60033),history:(0,i.$Sj)("history",60034),clock:(0,i.$Sj)("clock",60034),folder:(0,i.$Sj)("folder",60035),fileDirectory:(0,i.$Sj)("file-directory",60035),symbolFolder:(0,i.$Sj)("symbol-folder",60035),logoGithub:(0,i.$Sj)("logo-github",60036),markGithub:(0,i.$Sj)("mark-github",60036),github:(0,i.$Sj)("github",60036),terminal:(0,i.$Sj)("terminal",60037),console:(0,i.$Sj)("console",60037),repl:(0,i.$Sj)("repl",60037),zap:(0,i.$Sj)("zap",60038),symbolEvent:(0,i.$Sj)("symbol-event",60038),error:(0,i.$Sj)("error",60039),stop:(0,i.$Sj)("stop",60039),variable:(0,i.$Sj)("variable",60040),symbolVariable:(0,i.$Sj)("symbol-variable",60040),array:(0,i.$Sj)("array",60042),symbolArray:(0,i.$Sj)("symbol-array",60042),symbolModule:(0,i.$Sj)("symbol-module",60043),symbolPackage:(0,i.$Sj)("symbol-package",60043),symbolNamespace:(0,i.$Sj)("symbol-namespace",60043),symbolObject:(0,i.$Sj)("symbol-object",60043),symbolMethod:(0,i.$Sj)("symbol-method",60044),symbolFunction:(0,i.$Sj)("symbol-function",60044),symbolConstructor:(0,i.$Sj)("symbol-constructor",60044),symbolBoolean:(0,i.$Sj)("symbol-boolean",60047),symbolNull:(0,i.$Sj)("symbol-null",60047),symbolNumeric:(0,i.$Sj)("symbol-numeric",60048),symbolNumber:(0,i.$Sj)("symbol-number",60048),symbolStructure:(0,i.$Sj)("symbol-structure",60049),symbolStruct:(0,i.$Sj)("symbol-struct",60049),symbolParameter:(0,i.$Sj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Sj)("symbol-type-parameter",60050),symbolKey:(0,i.$Sj)("symbol-key",60051),symbolText:(0,i.$Sj)("symbol-text",60051),symbolReference:(0,i.$Sj)("symbol-reference",60052),goToFile:(0,i.$Sj)("go-to-file",60052),symbolEnum:(0,i.$Sj)("symbol-enum",60053),symbolValue:(0,i.$Sj)("symbol-value",60053),symbolRuler:(0,i.$Sj)("symbol-ruler",60054),symbolUnit:(0,i.$Sj)("symbol-unit",60054),activateBreakpoints:(0,i.$Sj)("activate-breakpoints",60055),archive:(0,i.$Sj)("archive",60056),arrowBoth:(0,i.$Sj)("arrow-both",60057),arrowDown:(0,i.$Sj)("arrow-down",60058),arrowLeft:(0,i.$Sj)("arrow-left",60059),arrowRight:(0,i.$Sj)("arrow-right",60060),arrowSmallDown:(0,i.$Sj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Sj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Sj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Sj)("arrow-small-up",60064),arrowUp:(0,i.$Sj)("arrow-up",60065),bell:(0,i.$Sj)("bell",60066),bold:(0,i.$Sj)("bold",60067),book:(0,i.$Sj)("book",60068),bookmark:(0,i.$Sj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Sj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Sj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Sj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Sj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Sj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Sj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Sj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Sj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Sj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Sj)("briefcase",60076),broadcast:(0,i.$Sj)("broadcast",60077),browser:(0,i.$Sj)("browser",60078),bug:(0,i.$Sj)("bug",60079),calendar:(0,i.$Sj)("calendar",60080),caseSensitive:(0,i.$Sj)("case-sensitive",60081),check:(0,i.$Sj)("check",60082),checklist:(0,i.$Sj)("checklist",60083),chevronDown:(0,i.$Sj)("chevron-down",60084),chevronLeft:(0,i.$Sj)("chevron-left",60085),chevronRight:(0,i.$Sj)("chevron-right",60086),chevronUp:(0,i.$Sj)("chevron-up",60087),chromeClose:(0,i.$Sj)("chrome-close",60088),chromeMaximize:(0,i.$Sj)("chrome-maximize",60089),chromeMinimize:(0,i.$Sj)("chrome-minimize",60090),chromeRestore:(0,i.$Sj)("chrome-restore",60091),circleOutline:(0,i.$Sj)("circle-outline",60092),circle:(0,i.$Sj)("circle",60092),debugBreakpointUnverified:(0,i.$Sj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Sj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Sj)("circle-slash",60093),circuitBoard:(0,i.$Sj)("circuit-board",60094),clearAll:(0,i.$Sj)("clear-all",60095),clippy:(0,i.$Sj)("clippy",60096),closeAll:(0,i.$Sj)("close-all",60097),cloudDownload:(0,i.$Sj)("cloud-download",60098),cloudUpload:(0,i.$Sj)("cloud-upload",60099),code:(0,i.$Sj)("code",60100),collapseAll:(0,i.$Sj)("collapse-all",60101),colorMode:(0,i.$Sj)("color-mode",60102),commentDiscussion:(0,i.$Sj)("comment-discussion",60103),creditCard:(0,i.$Sj)("credit-card",60105),dash:(0,i.$Sj)("dash",60108),dashboard:(0,i.$Sj)("dashboard",60109),database:(0,i.$Sj)("database",60110),debugContinue:(0,i.$Sj)("debug-continue",60111),debugDisconnect:(0,i.$Sj)("debug-disconnect",60112),debugPause:(0,i.$Sj)("debug-pause",60113),debugRestart:(0,i.$Sj)("debug-restart",60114),debugStart:(0,i.$Sj)("debug-start",60115),debugStepInto:(0,i.$Sj)("debug-step-into",60116),debugStepOut:(0,i.$Sj)("debug-step-out",60117),debugStepOver:(0,i.$Sj)("debug-step-over",60118),debugStop:(0,i.$Sj)("debug-stop",60119),debug:(0,i.$Sj)("debug",60120),deviceCameraVideo:(0,i.$Sj)("device-camera-video",60121),deviceCamera:(0,i.$Sj)("device-camera",60122),deviceMobile:(0,i.$Sj)("device-mobile",60123),diffAdded:(0,i.$Sj)("diff-added",60124),diffIgnored:(0,i.$Sj)("diff-ignored",60125),diffModified:(0,i.$Sj)("diff-modified",60126),diffRemoved:(0,i.$Sj)("diff-removed",60127),diffRenamed:(0,i.$Sj)("diff-renamed",60128),diff:(0,i.$Sj)("diff",60129),diffSidebyside:(0,i.$Sj)("diff-sidebyside",60129),discard:(0,i.$Sj)("discard",60130),editorLayout:(0,i.$Sj)("editor-layout",60131),emptyWindow:(0,i.$Sj)("empty-window",60132),exclude:(0,i.$Sj)("exclude",60133),extensions:(0,i.$Sj)("extensions",60134),eyeClosed:(0,i.$Sj)("eye-closed",60135),fileBinary:(0,i.$Sj)("file-binary",60136),fileCode:(0,i.$Sj)("file-code",60137),fileMedia:(0,i.$Sj)("file-media",60138),filePdf:(0,i.$Sj)("file-pdf",60139),fileSubmodule:(0,i.$Sj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Sj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Sj)("file-symlink-file",60142),fileZip:(0,i.$Sj)("file-zip",60143),files:(0,i.$Sj)("files",60144),filter:(0,i.$Sj)("filter",60145),flame:(0,i.$Sj)("flame",60146),foldDown:(0,i.$Sj)("fold-down",60147),foldUp:(0,i.$Sj)("fold-up",60148),fold:(0,i.$Sj)("fold",60149),folderActive:(0,i.$Sj)("folder-active",60150),folderOpened:(0,i.$Sj)("folder-opened",60151),gear:(0,i.$Sj)("gear",60152),gift:(0,i.$Sj)("gift",60153),gistSecret:(0,i.$Sj)("gist-secret",60154),gist:(0,i.$Sj)("gist",60155),gitCommit:(0,i.$Sj)("git-commit",60156),gitCompare:(0,i.$Sj)("git-compare",60157),compareChanges:(0,i.$Sj)("compare-changes",60157),gitMerge:(0,i.$Sj)("git-merge",60158),githubAction:(0,i.$Sj)("github-action",60159),githubAlt:(0,i.$Sj)("github-alt",60160),globe:(0,i.$Sj)("globe",60161),grabber:(0,i.$Sj)("grabber",60162),graph:(0,i.$Sj)("graph",60163),gripper:(0,i.$Sj)("gripper",60164),heart:(0,i.$Sj)("heart",60165),home:(0,i.$Sj)("home",60166),horizontalRule:(0,i.$Sj)("horizontal-rule",60167),hubot:(0,i.$Sj)("hubot",60168),inbox:(0,i.$Sj)("inbox",60169),issueReopened:(0,i.$Sj)("issue-reopened",60171),issues:(0,i.$Sj)("issues",60172),italic:(0,i.$Sj)("italic",60173),jersey:(0,i.$Sj)("jersey",60174),json:(0,i.$Sj)("json",60175),kebabVertical:(0,i.$Sj)("kebab-vertical",60176),key:(0,i.$Sj)("key",60177),law:(0,i.$Sj)("law",60178),lightbulbAutofix:(0,i.$Sj)("lightbulb-autofix",60179),linkExternal:(0,i.$Sj)("link-external",60180),link:(0,i.$Sj)("link",60181),listOrdered:(0,i.$Sj)("list-ordered",60182),listUnordered:(0,i.$Sj)("list-unordered",60183),liveShare:(0,i.$Sj)("live-share",60184),loading:(0,i.$Sj)("loading",60185),location:(0,i.$Sj)("location",60186),mailRead:(0,i.$Sj)("mail-read",60187),mail:(0,i.$Sj)("mail",60188),markdown:(0,i.$Sj)("markdown",60189),megaphone:(0,i.$Sj)("megaphone",60190),mention:(0,i.$Sj)("mention",60191),milestone:(0,i.$Sj)("milestone",60192),gitPullRequestMilestone:(0,i.$Sj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Sj)("mortar-board",60193),move:(0,i.$Sj)("move",60194),multipleWindows:(0,i.$Sj)("multiple-windows",60195),mute:(0,i.$Sj)("mute",60196),noNewline:(0,i.$Sj)("no-newline",60197),note:(0,i.$Sj)("note",60198),octoface:(0,i.$Sj)("octoface",60199),openPreview:(0,i.$Sj)("open-preview",60200),package:(0,i.$Sj)("package",60201),paintcan:(0,i.$Sj)("paintcan",60202),pin:(0,i.$Sj)("pin",60203),play:(0,i.$Sj)("play",60204),run:(0,i.$Sj)("run",60204),plug:(0,i.$Sj)("plug",60205),preserveCase:(0,i.$Sj)("preserve-case",60206),preview:(0,i.$Sj)("preview",60207),project:(0,i.$Sj)("project",60208),pulse:(0,i.$Sj)("pulse",60209),question:(0,i.$Sj)("question",60210),quote:(0,i.$Sj)("quote",60211),radioTower:(0,i.$Sj)("radio-tower",60212),reactions:(0,i.$Sj)("reactions",60213),references:(0,i.$Sj)("references",60214),refresh:(0,i.$Sj)("refresh",60215),regex:(0,i.$Sj)("regex",60216),remoteExplorer:(0,i.$Sj)("remote-explorer",60217),remote:(0,i.$Sj)("remote",60218),remove:(0,i.$Sj)("remove",60219),replaceAll:(0,i.$Sj)("replace-all",60220),replace:(0,i.$Sj)("replace",60221),repoClone:(0,i.$Sj)("repo-clone",60222),repoForcePush:(0,i.$Sj)("repo-force-push",60223),repoPull:(0,i.$Sj)("repo-pull",60224),repoPush:(0,i.$Sj)("repo-push",60225),report:(0,i.$Sj)("report",60226),requestChanges:(0,i.$Sj)("request-changes",60227),rocket:(0,i.$Sj)("rocket",60228),rootFolderOpened:(0,i.$Sj)("root-folder-opened",60229),rootFolder:(0,i.$Sj)("root-folder",60230),rss:(0,i.$Sj)("rss",60231),ruby:(0,i.$Sj)("ruby",60232),saveAll:(0,i.$Sj)("save-all",60233),saveAs:(0,i.$Sj)("save-as",60234),save:(0,i.$Sj)("save",60235),screenFull:(0,i.$Sj)("screen-full",60236),screenNormal:(0,i.$Sj)("screen-normal",60237),searchStop:(0,i.$Sj)("search-stop",60238),server:(0,i.$Sj)("server",60240),settingsGear:(0,i.$Sj)("settings-gear",60241),settings:(0,i.$Sj)("settings",60242),shield:(0,i.$Sj)("shield",60243),smiley:(0,i.$Sj)("smiley",60244),sortPrecedence:(0,i.$Sj)("sort-precedence",60245),splitHorizontal:(0,i.$Sj)("split-horizontal",60246),splitVertical:(0,i.$Sj)("split-vertical",60247),squirrel:(0,i.$Sj)("squirrel",60248),starFull:(0,i.$Sj)("star-full",60249),starHalf:(0,i.$Sj)("star-half",60250),symbolClass:(0,i.$Sj)("symbol-class",60251),symbolColor:(0,i.$Sj)("symbol-color",60252),symbolConstant:(0,i.$Sj)("symbol-constant",60253),symbolEnumMember:(0,i.$Sj)("symbol-enum-member",60254),symbolField:(0,i.$Sj)("symbol-field",60255),symbolFile:(0,i.$Sj)("symbol-file",60256),symbolInterface:(0,i.$Sj)("symbol-interface",60257),symbolKeyword:(0,i.$Sj)("symbol-keyword",60258),symbolMisc:(0,i.$Sj)("symbol-misc",60259),symbolOperator:(0,i.$Sj)("symbol-operator",60260),symbolProperty:(0,i.$Sj)("symbol-property",60261),wrench:(0,i.$Sj)("wrench",60261),wrenchSubaction:(0,i.$Sj)("wrench-subaction",60261),symbolSnippet:(0,i.$Sj)("symbol-snippet",60262),tasklist:(0,i.$Sj)("tasklist",60263),telescope:(0,i.$Sj)("telescope",60264),textSize:(0,i.$Sj)("text-size",60265),threeBars:(0,i.$Sj)("three-bars",60266),thumbsdown:(0,i.$Sj)("thumbsdown",60267),thumbsup:(0,i.$Sj)("thumbsup",60268),tools:(0,i.$Sj)("tools",60269),triangleDown:(0,i.$Sj)("triangle-down",60270),triangleLeft:(0,i.$Sj)("triangle-left",60271),triangleRight:(0,i.$Sj)("triangle-right",60272),triangleUp:(0,i.$Sj)("triangle-up",60273),twitter:(0,i.$Sj)("twitter",60274),unfold:(0,i.$Sj)("unfold",60275),unlock:(0,i.$Sj)("unlock",60276),unmute:(0,i.$Sj)("unmute",60277),unverified:(0,i.$Sj)("unverified",60278),verified:(0,i.$Sj)("verified",60279),versions:(0,i.$Sj)("versions",60280),vmActive:(0,i.$Sj)("vm-active",60281),vmOutline:(0,i.$Sj)("vm-outline",60282),vmRunning:(0,i.$Sj)("vm-running",60283),watch:(0,i.$Sj)("watch",60284),whitespace:(0,i.$Sj)("whitespace",60285),wholeWord:(0,i.$Sj)("whole-word",60286),window:(0,i.$Sj)("window",60287),wordWrap:(0,i.$Sj)("word-wrap",60288),zoomIn:(0,i.$Sj)("zoom-in",60289),zoomOut:(0,i.$Sj)("zoom-out",60290),listFilter:(0,i.$Sj)("list-filter",60291),listFlat:(0,i.$Sj)("list-flat",60292),listSelection:(0,i.$Sj)("list-selection",60293),selection:(0,i.$Sj)("selection",60293),listTree:(0,i.$Sj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Sj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Sj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Sj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Sj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Sj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Sj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Sj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Sj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Sj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Sj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Sj)("symbol-string",60301),debugReverseContinue:(0,i.$Sj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Sj)("debug-step-back",60303),debugRestartFrame:(0,i.$Sj)("debug-restart-frame",60304),debugAlt:(0,i.$Sj)("debug-alt",60305),callIncoming:(0,i.$Sj)("call-incoming",60306),callOutgoing:(0,i.$Sj)("call-outgoing",60307),menu:(0,i.$Sj)("menu",60308),expandAll:(0,i.$Sj)("expand-all",60309),feedback:(0,i.$Sj)("feedback",60310),gitPullRequestReviewer:(0,i.$Sj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Sj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Sj)("ungroup-by-ref-type",60312),account:(0,i.$Sj)("account",60313),gitPullRequestAssignee:(0,i.$Sj)("git-pull-request-assignee",60313),bellDot:(0,i.$Sj)("bell-dot",60314),debugConsole:(0,i.$Sj)("debug-console",60315),library:(0,i.$Sj)("library",60316),output:(0,i.$Sj)("output",60317),runAll:(0,i.$Sj)("run-all",60318),syncIgnored:(0,i.$Sj)("sync-ignored",60319),pinned:(0,i.$Sj)("pinned",60320),githubInverted:(0,i.$Sj)("github-inverted",60321),serverProcess:(0,i.$Sj)("server-process",60322),serverEnvironment:(0,i.$Sj)("server-environment",60323),pass:(0,i.$Sj)("pass",60324),issueClosed:(0,i.$Sj)("issue-closed",60324),stopCircle:(0,i.$Sj)("stop-circle",60325),playCircle:(0,i.$Sj)("play-circle",60326),record:(0,i.$Sj)("record",60327),debugAltSmall:(0,i.$Sj)("debug-alt-small",60328),vmConnect:(0,i.$Sj)("vm-connect",60329),cloud:(0,i.$Sj)("cloud",60330),merge:(0,i.$Sj)("merge",60331),export:(0,i.$Sj)("export",60332),graphLeft:(0,i.$Sj)("graph-left",60333),magnet:(0,i.$Sj)("magnet",60334),notebook:(0,i.$Sj)("notebook",60335),redo:(0,i.$Sj)("redo",60336),checkAll:(0,i.$Sj)("check-all",60337),pinnedDirty:(0,i.$Sj)("pinned-dirty",60338),passFilled:(0,i.$Sj)("pass-filled",60339),circleLargeFilled:(0,i.$Sj)("circle-large-filled",60340),circleLarge:(0,i.$Sj)("circle-large",60341),circleLargeOutline:(0,i.$Sj)("circle-large-outline",60341),combine:(0,i.$Sj)("combine",60342),gather:(0,i.$Sj)("gather",60342),table:(0,i.$Sj)("table",60343),variableGroup:(0,i.$Sj)("variable-group",60344),typeHierarchy:(0,i.$Sj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Sj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Sj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Sj)("git-pull-request-create",60348),runAbove:(0,i.$Sj)("run-above",60349),runBelow:(0,i.$Sj)("run-below",60350),notebookTemplate:(0,i.$Sj)("notebook-template",60351),debugRerun:(0,i.$Sj)("debug-rerun",60352),workspaceTrusted:(0,i.$Sj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Sj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Sj)("workspace-unknown",60355),terminalCmd:(0,i.$Sj)("terminal-cmd",60356),terminalDebian:(0,i.$Sj)("terminal-debian",60357),terminalLinux:(0,i.$Sj)("terminal-linux",60358),terminalPowershell:(0,i.$Sj)("terminal-powershell",60359),terminalTmux:(0,i.$Sj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Sj)("terminal-ubuntu",60361),terminalBash:(0,i.$Sj)("terminal-bash",60362),arrowSwap:(0,i.$Sj)("arrow-swap",60363),copy:(0,i.$Sj)("copy",60364),personAdd:(0,i.$Sj)("person-add",60365),filterFilled:(0,i.$Sj)("filter-filled",60366),wand:(0,i.$Sj)("wand",60367),debugLineByLine:(0,i.$Sj)("debug-line-by-line",60368),inspect:(0,i.$Sj)("inspect",60369),layers:(0,i.$Sj)("layers",60370),layersDot:(0,i.$Sj)("layers-dot",60371),layersActive:(0,i.$Sj)("layers-active",60372),compass:(0,i.$Sj)("compass",60373),compassDot:(0,i.$Sj)("compass-dot",60374),compassActive:(0,i.$Sj)("compass-active",60375),azure:(0,i.$Sj)("azure",60376),issueDraft:(0,i.$Sj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Sj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Sj)("git-pull-request-draft",60379),debugAll:(0,i.$Sj)("debug-all",60380),debugCoverage:(0,i.$Sj)("debug-coverage",60381),runErrors:(0,i.$Sj)("run-errors",60382),folderLibrary:(0,i.$Sj)("folder-library",60383),debugContinueSmall:(0,i.$Sj)("debug-continue-small",60384),beakerStop:(0,i.$Sj)("beaker-stop",60385),graphLine:(0,i.$Sj)("graph-line",60386),graphScatter:(0,i.$Sj)("graph-scatter",60387),pieChart:(0,i.$Sj)("pie-chart",60388),bracket:(0,i.$Sj)("bracket",60175),bracketDot:(0,i.$Sj)("bracket-dot",60389),bracketError:(0,i.$Sj)("bracket-error",60390),lockSmall:(0,i.$Sj)("lock-small",60391),azureDevops:(0,i.$Sj)("azure-devops",60392),verifiedFilled:(0,i.$Sj)("verified-filled",60393),newline:(0,i.$Sj)("newline",60394),layout:(0,i.$Sj)("layout",60395),layoutActivitybarLeft:(0,i.$Sj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Sj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Sj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Sj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Sj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Sj)("layout-panel-right",60401),layoutPanel:(0,i.$Sj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Sj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Sj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Sj)("layout-statusbar",60405),layoutMenubar:(0,i.$Sj)("layout-menubar",60406),layoutCentered:(0,i.$Sj)("layout-centered",60407),target:(0,i.$Sj)("target",60408),indent:(0,i.$Sj)("indent",60409),recordSmall:(0,i.$Sj)("record-small",60410),errorSmall:(0,i.$Sj)("error-small",60411),terminalDecorationError:(0,i.$Sj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Sj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Sj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Sj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Sj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Sj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Sj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Sj)("layout-sidebar-left-off",60418),blank:(0,i.$Sj)("blank",60419),heartFilled:(0,i.$Sj)("heart-filled",60420),map:(0,i.$Sj)("map",60421),mapHorizontal:(0,i.$Sj)("map-horizontal",60421),foldHorizontal:(0,i.$Sj)("fold-horizontal",60421),mapFilled:(0,i.$Sj)("map-filled",60422),mapHorizontalFilled:(0,i.$Sj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Sj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Sj)("circle-small",60423),bellSlash:(0,i.$Sj)("bell-slash",60424),bellSlashDot:(0,i.$Sj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Sj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Sj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Sj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Sj)("search-fuzzy",60429),commentDraft:(0,i.$Sj)("comment-draft",60430),send:(0,i.$Sj)("send",60431),sparkle:(0,i.$Sj)("sparkle",60432),insert:(0,i.$Sj)("insert",60433),mic:(0,i.$Sj)("mic",60434),thumbsdownFilled:(0,i.$Sj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Sj)("thumbsup-filled",60436),coffee:(0,i.$Sj)("coffee",60437),snake:(0,i.$Sj)("snake",60438),game:(0,i.$Sj)("game",60439),vr:(0,i.$Sj)("vr",60440),chip:(0,i.$Sj)("chip",60441),piano:(0,i.$Sj)("piano",60442),music:(0,i.$Sj)("music",60443),micFilled:(0,i.$Sj)("mic-filled",60444),repoFetch:(0,i.$Sj)("repo-fetch",60445),copilot:(0,i.$Sj)("copilot",60446),lightbulbSparkle:(0,i.$Sj)("lightbulb-sparkle",60447),robot:(0,i.$Sj)("robot",60448),sparkleFilled:(0,i.$Sj)("sparkle-filled",60449),diffSingle:(0,i.$Sj)("diff-single",60450),diffMultiple:(0,i.$Sj)("diff-multiple",60451),surroundWith:(0,i.$Sj)("surround-with",60452),share:(0,i.$Sj)("share",60453),gitStash:(0,i.$Sj)("git-stash",60454),gitStashApply:(0,i.$Sj)("git-stash-apply",60455),gitStashPop:(0,i.$Sj)("git-stash-pop",60456),vscode:(0,i.$Sj)("vscode",60457),vscodeInsiders:(0,i.$Sj)("vscode-insiders",60458),codeOss:(0,i.$Sj)("code-oss",60459),runCoverage:(0,i.$Sj)("run-coverage",60460),runAllCoverage:(0,i.$Sj)("run-all-coverage",60461),coverage:(0,i.$Sj)("coverage",60462),githubProject:(0,i.$Sj)("github-project",60463),mapVertical:(0,i.$Sj)("map-vertical",60464),foldVertical:(0,i.$Sj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Sj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Sj)("fold-vertical-filled",60465),goToSearch:(0,i.$Sj)("go-to-search",60466),percentage:(0,i.$Sj)("percentage",60467),sortPercentage:(0,i.$Sj)("sort-percentage",60467)}}),ne(ie[44],se([0,1,27,43]),function(C,t,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xj=t.$Wj=void 0,t.$Vj=R;function R(){return Object.values(t.$Xj)}t.$Wj={dialogError:(0,i.$Sj)("dialog-error","error"),dialogWarning:(0,i.$Sj)("dialog-warning","warning"),dialogInfo:(0,i.$Sj)("dialog-info","info"),dialogClose:(0,i.$Sj)("dialog-close","close"),treeItemExpanded:(0,i.$Sj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Sj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Sj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Sj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Sj)("tree-item-loading","loading"),menuSelection:(0,i.$Sj)("menu-selection","check"),menuSubmenu:(0,i.$Sj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Sj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Sj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Sj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Sj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Sj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Sj)("toolbar-more","more"),quickInputBack:(0,i.$Sj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Sj)("drop-down-button",60084),symbolCustomColor:(0,i.$Sj)("symbol-customcolor",60252),exportIcon:(0,i.$Sj)("export",60332),workspaceUnspecified:(0,i.$Sj)("workspace-unspecified",60355),newLine:(0,i.$Sj)("newline",60394),thumbsDownFilled:(0,i.$Sj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Sj)("thumbsup-filled",60436),gitFetch:(0,i.$Sj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Sj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Sj)("debug-breakpoint-pending",60377)},t.$Xj={...M.$Uj,...t.$Wj}}),ne(ie[15],se([0,1,26]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5n=M,t.$6n=R,t.$7n=$,t.$8n=a,t.$9n=u,t.$0n=o,t.$$n=N,t.$_n=d,t.$ao=b,t.$bo=e,t.$co=m,t.$do=S,t.$eo=j;function M(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const w=Array.isArray(v)?[]:{};return Object.entries(v).forEach(([p,l])=>{w[p]=l&&typeof l=="object"?M(l):l}),w}function R(v){if(!v||typeof v!="object")return v;const w=[v];for(;w.length>0;){const p=w.shift();Object.freeze(p);for(const l in p)if(c.call(p,l)){const n=p[l];typeof n=="object"&&!Object.isFrozen(n)&&!(0,i.$bg)(n)&&w.push(n)}}return v}const c=Object.prototype.hasOwnProperty;function $(v,w){return g(v,w,new Set)}function g(v,w,p){if((0,i.$hg)(v))return v;const l=w(v);if(typeof l<"u")return l;if(Array.isArray(v)){const n=[];for(const s of v)n.push(g(s,w,p));return n}if((0,i.$ag)(v)){if(p.has(v))throw new Error("Cannot clone recursive data-structure");p.add(v);const n={};for(const s in v)c.call(v,s)&&(n[s]=g(v[s],w,p));return p.delete(v),n}return v}function a(v,w,p=!0){return(0,i.$ag)(v)?((0,i.$ag)(w)&&Object.keys(w).forEach(l=>{l in v?p&&((0,i.$ag)(v[l])&&(0,i.$ag)(w[l])?a(v[l],w[l],p):v[l]=w[l]):v[l]=w[l]}),v):w}function u(v,w){if(v===w)return!0;if(v==null||w===null||w===void 0||typeof v!=typeof w||typeof v!="object"||Array.isArray(v)!==Array.isArray(w))return!1;let p,l;if(Array.isArray(v)){if(v.length!==w.length)return!1;for(p=0;p<v.length;p++)if(!u(v[p],w[p]))return!1}else{const n=[];for(l in v)n.push(l);n.sort();const s=[];for(l in w)s.push(l);if(s.sort(),!u(n,s))return!1;for(p=0;p<n.length;p++)if(!u(v[n[p]],w[n[p]]))return!1}return!0}function o(v){const w=new Set;return JSON.stringify(v,(p,l)=>{if((0,i.$ag)(l)||Array.isArray(l)){if(w.has(l))return"[Circular]";w.add(l)}return typeof l=="bigint"?`[BigInt ${l.toString()}]`:l})}function N(v,w){const p=Object.create(null);return!v||!w||Object.keys(w).forEach(n=>{const s=v[n],f=w[n];u(s,f)||(p[n]=f)}),p}function d(v,w){const p=w.toLowerCase(),l=Object.keys(v).find(n=>n.toLowerCase()===p);return l?v[l]:v[w]}function b(v,w){const p=Object.create(null);for(const[l,n]of Object.entries(v))w(l,n)&&(p[l]=n);return p}function e(v){let w=[];for(;Object.prototype!==v;)w=w.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return w}function m(v){const w=[];for(const p of e(v))typeof v[p]=="function"&&w.push(p);return w}function S(v,w){const p=n=>function(){const s=Array.prototype.slice.call(arguments,0);return w(n,s)},l={};for(const n of v)l[n]=p(n);return l}function j(v,w){const p={};for(const[l,n]of Object.entries(v))p[l]=w(n,l);return p}}),ne(ie[28],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.$7e=M,t.$8e=R;var i;(function(c){c[c.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",c[c.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",c[c.MAX_UINT_8=255]="MAX_UINT_8",c[c.MAX_UINT_16=65535]="MAX_UINT_16",c[c.MAX_UINT_32=4294967295]="MAX_UINT_32",c[c.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function M(c){return c<0?0:c>255?255:c|0}function R(c){return c<0?0:c>4294967295?4294967295:c|0}}),ne(ie[29],se([0,1,28]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mt=t.$Lt=void 0;class M{constructor(g){const a=(0,i.$7e)(g);this.c=a,this.a=M.d(a),this.b=new Map}static d(g){const a=new Uint8Array(256);return a.fill(g),a}set(g,a){const u=(0,i.$7e)(a);g>=0&&g<256?this.a[g]=u:this.b.set(g,u)}get(g){return g>=0&&g<256?this.a[g]:this.b.get(g)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$Lt=M;var R;(function($){$[$.False=0]="False",$[$.True=1]="True"})(R||(R={}));class c{constructor(){this.a=new M(0)}add(g){this.a.set(g,1)}has(g){return this.a.get(g)===1}clear(){return this.a.clear()}}t.$Mt=c}),ne(ie[5],se([0,1,3]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ft=t.$Et=void 0;class M{static addRange($,g){let a=0;for(;a<g.length&&g[a].endExclusive<$.start;)a++;let u=a;for(;u<g.length&&g[u].start<=$.endExclusive;)u++;if(a===u)g.splice(a,0,$);else{const o=Math.min($.start,g[a].start),N=Math.max($.endExclusive,g[u-1].endExclusive);g.splice(a,u-a,new M(o,N))}}static tryCreate($,g){if(!($>g))return new M($,g)}static ofLength($){return new M(0,$)}static ofStartAndLength($,g){return new M($,$+g)}constructor($,g){if(this.start=$,this.endExclusive=g,$>g)throw new i.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta($){return new M(this.start+$,this.endExclusive+$)}deltaStart($){return new M(this.start+$,this.endExclusive)}deltaEnd($){return new M(this.start,this.endExclusive+$)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals($){return this.start===$.start&&this.endExclusive===$.endExclusive}containsRange($){return this.start<=$.start&&$.endExclusive<=this.endExclusive}contains($){return this.start<=$&&$<this.endExclusive}join($){return new M(Math.min(this.start,$.start),Math.max(this.endExclusive,$.endExclusive))}intersect($){const g=Math.max(this.start,$.start),a=Math.min(this.endExclusive,$.endExclusive);if(g<=a)return new M(g,a)}intersects($){const g=Math.max(this.start,$.start),a=Math.min(this.endExclusive,$.endExclusive);return g<a}intersectsOrTouches($){const g=Math.max(this.start,$.start),a=Math.min(this.endExclusive,$.endExclusive);return g<=a}isBefore($){return this.endExclusive<=$.start}isAfter($){return this.start>=$.endExclusive}slice($){return $.slice(this.start,this.endExclusive)}substring($){return $.substring(this.start,this.endExclusive)}clip($){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,$))}clipCyclic($){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return $<this.start?this.endExclusive-(this.start-$)%this.length:$>=this.endExclusive?this.start+($-this.start)%this.length:$}map($){const g=[];for(let a=this.start;a<this.endExclusive;a++)g.push($(a));return g}forEach($){for(let g=this.start;g<this.endExclusive;g++)$(g)}}t.$Et=M;class R{constructor(){this.a=[]}addRange($){let g=0;for(;g<this.a.length&&this.a[g].endExclusive<$.start;)g++;let a=g;for(;a<this.a.length&&this.a[a].start<=$.endExclusive;)a++;if(g===a)this.a.splice(g,0,$);else{const u=Math.min($.start,this.a[g].start),o=Math.max($.endExclusive,this.a[a-1].endExclusive);this.a.splice(g,a-g,new M(u,o))}}toString(){return this.a.map($=>$.toString()).join(", ")}intersectsStrict($){let g=0;for(;g<this.a.length&&this.a[g].endExclusive<=$.start;)g++;return g<this.a.length&&this.a[g].start<$.endExclusive}intersectWithRange($){const g=new R;for(const a of this.a){const u=a.intersect($);u&&g.addRange(u)}return g}intersectWithRangeLength($){return this.intersectWithRange($).length}get length(){return this.a.reduce(($,g)=>$+g.length,0)}}t.$Ft=R}),ne(ie[4],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wt=void 0;class i{constructor(R,c){this.lineNumber=R,this.column=c}with(R=this.lineNumber,c=this.column){return R===this.lineNumber&&c===this.column?this:new i(R,c)}delta(R=0,c=0){return this.with(this.lineNumber+R,this.column+c)}equals(R){return i.equals(this,R)}static equals(R,c){return!R&&!c?!0:!!R&&!!c&&R.lineNumber===c.lineNumber&&R.column===c.column}isBefore(R){return i.isBefore(this,R)}static isBefore(R,c){return R.lineNumber<c.lineNumber?!0:c.lineNumber<R.lineNumber?!1:R.column<c.column}isBeforeOrEqual(R){return i.isBeforeOrEqual(this,R)}static isBeforeOrEqual(R,c){return R.lineNumber<c.lineNumber?!0:c.lineNumber<R.lineNumber?!1:R.column<=c.column}static compare(R,c){const $=R.lineNumber|0,g=c.lineNumber|0;if($===g){const a=R.column|0,u=c.column|0;return a-u}return $-g}clone(){return new i(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(R){return new i(R.lineNumber,R.column)}static isIPosition(R){return R&&typeof R.lineNumber=="number"&&typeof R.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$wt=i}),ne(ie[2],se([0,1,4]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xt=void 0;class M{constructor(c,$,g,a){c>g||c===g&&$>a?(this.startLineNumber=g,this.startColumn=a,this.endLineNumber=c,this.endColumn=$):(this.startLineNumber=c,this.startColumn=$,this.endLineNumber=g,this.endColumn=a)}isEmpty(){return M.isEmpty(this)}static isEmpty(c){return c.startLineNumber===c.endLineNumber&&c.startColumn===c.endColumn}containsPosition(c){return M.containsPosition(this,c)}static containsPosition(c,$){return!($.lineNumber<c.startLineNumber||$.lineNumber>c.endLineNumber||$.lineNumber===c.startLineNumber&&$.column<c.startColumn||$.lineNumber===c.endLineNumber&&$.column>c.endColumn)}static strictContainsPosition(c,$){return!($.lineNumber<c.startLineNumber||$.lineNumber>c.endLineNumber||$.lineNumber===c.startLineNumber&&$.column<=c.startColumn||$.lineNumber===c.endLineNumber&&$.column>=c.endColumn)}containsRange(c){return M.containsRange(this,c)}static containsRange(c,$){return!($.startLineNumber<c.startLineNumber||$.endLineNumber<c.startLineNumber||$.startLineNumber>c.endLineNumber||$.endLineNumber>c.endLineNumber||$.startLineNumber===c.startLineNumber&&$.startColumn<c.startColumn||$.endLineNumber===c.endLineNumber&&$.endColumn>c.endColumn)}strictContainsRange(c){return M.strictContainsRange(this,c)}static strictContainsRange(c,$){return!($.startLineNumber<c.startLineNumber||$.endLineNumber<c.startLineNumber||$.startLineNumber>c.endLineNumber||$.endLineNumber>c.endLineNumber||$.startLineNumber===c.startLineNumber&&$.startColumn<=c.startColumn||$.endLineNumber===c.endLineNumber&&$.endColumn>=c.endColumn)}plusRange(c){return M.plusRange(this,c)}static plusRange(c,$){let g,a,u,o;return $.startLineNumber<c.startLineNumber?(g=$.startLineNumber,a=$.startColumn):$.startLineNumber===c.startLineNumber?(g=$.startLineNumber,a=Math.min($.startColumn,c.startColumn)):(g=c.startLineNumber,a=c.startColumn),$.endLineNumber>c.endLineNumber?(u=$.endLineNumber,o=$.endColumn):$.endLineNumber===c.endLineNumber?(u=$.endLineNumber,o=Math.max($.endColumn,c.endColumn)):(u=c.endLineNumber,o=c.endColumn),new M(g,a,u,o)}intersectRanges(c){return M.intersectRanges(this,c)}static intersectRanges(c,$){let g=c.startLineNumber,a=c.startColumn,u=c.endLineNumber,o=c.endColumn;const N=$.startLineNumber,d=$.startColumn,b=$.endLineNumber,e=$.endColumn;return g<N?(g=N,a=d):g===N&&(a=Math.max(a,d)),u>b?(u=b,o=e):u===b&&(o=Math.min(o,e)),g>u||g===u&&a>o?null:new M(g,a,u,o)}equalsRange(c){return M.equalsRange(this,c)}static equalsRange(c,$){return!c&&!$?!0:!!c&&!!$&&c.startLineNumber===$.startLineNumber&&c.startColumn===$.startColumn&&c.endLineNumber===$.endLineNumber&&c.endColumn===$.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(c){return new i.$wt(c.endLineNumber,c.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(c){return new i.$wt(c.startLineNumber,c.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(c,$){return new M(this.startLineNumber,this.startColumn,c,$)}setStartPosition(c,$){return new M(c,$,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(c){return new M(c.startLineNumber,c.startColumn,c.startLineNumber,c.startColumn)}collapseToEnd(){return M.collapseToEnd(this)}static collapseToEnd(c){return new M(c.endLineNumber,c.endColumn,c.endLineNumber,c.endColumn)}delta(c){return new M(this.startLineNumber+c,this.startColumn,this.endLineNumber+c,this.endColumn)}static fromPositions(c,$=c){return new M(c.lineNumber,c.column,$.lineNumber,$.column)}static lift(c){return c?new M(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn):null}static isIRange(c){return c&&typeof c.startLineNumber=="number"&&typeof c.startColumn=="number"&&typeof c.endLineNumber=="number"&&typeof c.endColumn=="number"}static areIntersectingOrTouching(c,$){return!(c.endLineNumber<$.startLineNumber||c.endLineNumber===$.startLineNumber&&c.endColumn<$.startColumn||$.endLineNumber<c.startLineNumber||$.endLineNumber===c.startLineNumber&&$.endColumn<c.startColumn)}static areIntersecting(c,$){return!(c.endLineNumber<$.startLineNumber||c.endLineNumber===$.startLineNumber&&c.endColumn<=$.startColumn||$.endLineNumber<c.startLineNumber||$.endLineNumber===c.startLineNumber&&$.endColumn<=c.startColumn)}static compareRangesUsingStarts(c,$){if(c&&$){const u=c.startLineNumber|0,o=$.startLineNumber|0;if(u===o){const N=c.startColumn|0,d=$.startColumn|0;if(N===d){const b=c.endLineNumber|0,e=$.endLineNumber|0;if(b===e){const m=c.endColumn|0,S=$.endColumn|0;return m-S}return b-e}return N-d}return u-o}return(c?1:0)-($?1:0)}static compareRangesUsingEnds(c,$){return c.endLineNumber===$.endLineNumber?c.endColumn===$.endColumn?c.startLineNumber===$.startLineNumber?c.startColumn-$.startColumn:c.startLineNumber-$.startLineNumber:c.endColumn-$.endColumn:c.endLineNumber-$.endLineNumber}static spansMultipleLines(c){return c.endLineNumber>c.startLineNumber}toJSON(){return this}}t.$xt=M}),ne(ie[45],se([0,1,2]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yt=void 0;class M{static insert(c,$){return{range:new i.$xt(c.lineNumber,c.column,c.lineNumber,c.column),text:$,forceMoveMarkers:!0}}static delete(c){return{range:c,text:null}}static replace(c,$){return{range:c,text:$}}static replaceMove(c,$){return{range:c,text:$,forceMoveMarkers:!0}}}t.$yt=M}),ne(ie[13],se([0,1,3,5,2,8]),function(C,t,i,M,R,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pv=t.$Ov=void 0;class ${static fromRange(u){return new $(u.startLineNumber,u.endLineNumber)}static fromRangeInclusive(u){return new $(u.startLineNumber,u.endLineNumber+1)}static subtract(u,o){return o?u.startLineNumber<o.startLineNumber&&o.endLineNumberExclusive<u.endLineNumberExclusive?[new $(u.startLineNumber,o.startLineNumber),new $(o.endLineNumberExclusive,u.endLineNumberExclusive)]:o.startLineNumber<=u.startLineNumber&&u.endLineNumberExclusive<=o.endLineNumberExclusive?[]:o.endLineNumberExclusive<u.endLineNumberExclusive?[new $(Math.max(o.endLineNumberExclusive,u.startLineNumber),u.endLineNumberExclusive)]:[new $(u.startLineNumber,Math.min(o.startLineNumber,u.endLineNumberExclusive))]:[u]}static joinMany(u){if(u.length===0)return[];let o=new g(u[0].slice());for(let N=1;N<u.length;N++)o=o.getUnion(new g(u[N].slice()));return o.ranges}static join(u){if(u.length===0)throw new i.$cb("lineRanges cannot be empty");let o=u[0].startLineNumber,N=u[0].endLineNumberExclusive;for(let d=1;d<u.length;d++)o=Math.min(o,u[d].startLineNumber),N=Math.max(N,u[d].endLineNumberExclusive);return new $(o,N)}static ofLength(u,o){return new $(u,u+o)}static deserialize(u){return new $(u[0],u[1])}static invert(u,o){if(u.isEmpty)return[];const N=[];return u.startLineNumber>1&&N.push(new $(1,u.startLineNumber)),u.endLineNumberExclusive<o.getLineCount()+1&&N.push(new $(u.endLineNumberExclusive,o.getLineCount()+1)),N.filter(d=>!d.isEmpty)}static asRange(u,o){return u.isEmpty?new R.$xt(u.startLineNumber,1,u.startLineNumber,o.getLineLength(u.startLineNumber)):new R.$xt(u.startLineNumber,1,u.endLineNumberExclusive-1,o.getLineLength(u.endLineNumberExclusive-1))}constructor(u,o){if(u>o)throw new i.$cb(`startLineNumber ${u} cannot be after endLineNumberExclusive ${o}`);this.startLineNumber=u,this.endLineNumberExclusive=o}contains(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(u){return new $(this.startLineNumber+u,this.endLineNumberExclusive+u)}deltaLength(u){return new $(this.startLineNumber,this.endLineNumberExclusive+u)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(u){return new $(Math.min(this.startLineNumber,u.startLineNumber),Math.max(this.endLineNumberExclusive,u.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(u){const o=Math.max(this.startLineNumber,u.startLineNumber),N=Math.min(this.endLineNumberExclusive,u.endLineNumberExclusive);if(o<=N)return new $(o,N)}intersectsStrict(u){return this.startLineNumber<u.endLineNumberExclusive&&u.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(u){return this.startLineNumber<=u.endLineNumberExclusive&&u.startLineNumber<=this.endLineNumberExclusive}equals(u){return this.startLineNumber===u.startLineNumber&&this.endLineNumberExclusive===u.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new R.$xt(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new R.$xt(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(u){const o=[];for(let N=this.startLineNumber;N<this.endLineNumberExclusive;N++)o.push(u(N));return o}forEach(u){for(let o=this.startLineNumber;o<this.endLineNumberExclusive;o++)u(o)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}toOffsetRange(){return new M.$Et(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$Ov=$;class g{constructor(u=[]){this.c=u}get ranges(){return this.c}addRange(u){if(u.length===0)return;const o=(0,c.$kb)(this.c,d=>d.endLineNumberExclusive>=u.startLineNumber),N=(0,c.$ib)(this.c,d=>d.startLineNumber<=u.endLineNumberExclusive)+1;if(o===N)this.c.splice(o,0,u);else if(o===N-1){const d=this.c[o];this.c[o]=d.join(u)}else{const d=this.c[o].join(this.c[N-1]).join(u);this.c.splice(o,N-o,d)}}contains(u){const o=(0,c.$hb)(this.c,N=>N.startLineNumber<=u);return!!o&&o.endLineNumberExclusive>u}intersects(u){const o=(0,c.$hb)(this.c,N=>N.startLineNumber<u.endLineNumberExclusive);return!!o&&o.endLineNumberExclusive>u.startLineNumber}getUnion(u){if(this.c.length===0)return u;if(u.c.length===0)return this;const o=[];let N=0,d=0,b=null;for(;N<this.c.length||d<u.c.length;){let e=null;if(N<this.c.length&&d<u.c.length){const m=this.c[N],S=u.c[d];m.startLineNumber<S.startLineNumber?(e=m,N++):(e=S,d++)}else N<this.c.length?(e=this.c[N],N++):(e=u.c[d],d++);b===null?b=e:b.endLineNumberExclusive>=e.startLineNumber?b=new $(b.startLineNumber,Math.max(b.endLineNumberExclusive,e.endLineNumberExclusive)):(o.push(b),b=e)}return b!==null&&o.push(b),new g(o)}subtractFrom(u){const o=(0,c.$kb)(this.c,e=>e.endLineNumberExclusive>=u.startLineNumber),N=(0,c.$ib)(this.c,e=>e.startLineNumber<=u.endLineNumberExclusive)+1;if(o===N)return new g([u]);const d=[];let b=u.startLineNumber;for(let e=o;e<N;e++){const m=this.c[e];m.startLineNumber>b&&d.push(new $(b,m.startLineNumber)),b=m.endLineNumberExclusive}return b<u.endLineNumberExclusive&&d.push(new $(b,u.endLineNumberExclusive)),new g(d)}toString(){return this.c.map(u=>u.toString()).join(", ")}getIntersection(u){const o=[];let N=0,d=0;for(;N<this.c.length&&d<u.c.length;){const b=this.c[N],e=u.c[d],m=b.intersect(e);m&&!m.isEmpty&&o.push(m),b.endLineNumberExclusive<e.endLineNumberExclusive?N++:d++}return new g(o)}getWithDelta(u){return new g(this.c.map(o=>o.delta(u)))}}t.$Pv=g}),ne(ie[46],se([0,1,4,2]),function(C,t,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zt=t.SelectionDirection=void 0;var R;(function($){$[$.LTR=0]="LTR",$[$.RTL=1]="RTL"})(R||(t.SelectionDirection=R={}));class c extends M.$xt{constructor(g,a,u,o){super(g,a,u,o),this.selectionStartLineNumber=g,this.selectionStartColumn=a,this.positionLineNumber=u,this.positionColumn=o}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(g){return c.selectionsEqual(this,g)}static selectionsEqual(g,a){return g.selectionStartLineNumber===a.selectionStartLineNumber&&g.selectionStartColumn===a.selectionStartColumn&&g.positionLineNumber===a.positionLineNumber&&g.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(g,a){return this.getDirection()===0?new c(this.startLineNumber,this.startColumn,g,a):new c(g,a,this.startLineNumber,this.startColumn)}getPosition(){return new i.$wt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new i.$wt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(g,a){return this.getDirection()===0?new c(g,a,this.endLineNumber,this.endColumn):new c(this.endLineNumber,this.endColumn,g,a)}static fromPositions(g,a=g){return new c(g.lineNumber,g.column,a.lineNumber,a.column)}static fromRange(g,a){return a===0?new c(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):new c(g.endLineNumber,g.endColumn,g.startLineNumber,g.startColumn)}static liftSelection(g){return new c(g.selectionStartLineNumber,g.selectionStartColumn,g.positionLineNumber,g.positionColumn)}static selectionsArrEqual(g,a){if(g&&!a||!g&&a)return!1;if(!g&&!a)return!0;if(g.length!==a.length)return!1;for(let u=0,o=g.length;u<o;u++)if(!this.selectionsEqual(g[u],a[u]))return!1;return!0}static isISelection(g){return g&&typeof g.selectionStartLineNumber=="number"&&typeof g.selectionStartColumn=="number"&&typeof g.positionLineNumber=="number"&&typeof g.positionColumn=="number"}static createWithDirection(g,a,u,o,N){return N===0?new c(g,a,u,o):new c(u,o,g,a)}}t.$zt=c}),ne(ie[30],se([0,1,4,2]),function(C,t,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uu=void 0;class R{static{this.zero=new R(0,0)}static lengthDiffNonNegative($,g){return g.isLessThan($)?R.zero:$.lineCount===g.lineCount?new R(0,g.columnCount-$.columnCount):new R(g.lineCount-$.lineCount,g.columnCount)}static betweenPositions($,g){return $.lineNumber===g.lineNumber?new R(0,g.column-$.column):new R(g.lineNumber-$.lineNumber,g.column-1)}static ofRange($){return R.betweenPositions($.getStartPosition(),$.getEndPosition())}static ofText($){let g=0,a=0;for(const u of $)u===`
`?(g++,a=0):a++;return new R(g,a)}constructor($,g){this.lineCount=$,this.columnCount=g}isZero(){return this.lineCount===0&&this.columnCount===0}isLessThan($){return this.lineCount!==$.lineCount?this.lineCount<$.lineCount:this.columnCount<$.columnCount}isGreaterThan($){return this.lineCount!==$.lineCount?this.lineCount>$.lineCount:this.columnCount>$.columnCount}isGreaterThanOrEqualTo($){return this.lineCount!==$.lineCount?this.lineCount>$.lineCount:this.columnCount>=$.columnCount}equals($){return this.lineCount===$.lineCount&&this.columnCount===$.columnCount}compare($){return this.lineCount!==$.lineCount?this.lineCount-$.lineCount:this.columnCount-$.columnCount}add($){return $.lineCount===0?new R(this.lineCount,this.columnCount+$.columnCount):new R(this.lineCount+$.lineCount,$.columnCount)}createRange($){return this.lineCount===0?new M.$xt($.lineNumber,$.column,$.lineNumber,$.column+this.columnCount):new M.$xt($.lineNumber,$.column,$.lineNumber+this.lineCount,this.columnCount+1)}toRange(){return new M.$xt(1,1,this.lineCount+1,this.columnCount+1)}addToPosition($){return this.lineCount===0?new i.$wt($.lineNumber,$.column+this.columnCount):new i.$wt($.lineNumber+this.lineCount,this.columnCount+1)}toString(){return`${this.lineCount},${this.columnCount}`}}t.$uu=R}),ne(ie[47],se([0,1,8,5,4,2,30]),function(C,t,i,M,R,c,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qv=void 0;class g{constructor(u){this.text=u,this.a=[],this.a.push(0);for(let o=0;o<u.length;o++)u.charAt(o)===`
`&&this.a.push(o+1)}getOffset(u){return this.a[u.lineNumber-1]+u.column-1}getOffsetRange(u){return new M.$Et(this.getOffset(u.getStartPosition()),this.getOffset(u.getEndPosition()))}getPosition(u){const o=(0,i.$ib)(this.a,b=>b<=u),N=o+1,d=u-this.a[o]+1;return new R.$wt(N,d)}getRange(u){return c.$xt.fromPositions(this.getPosition(u.start),this.getPosition(u.endExclusive))}getTextLength(u){return $.$uu.ofRange(this.getRange(u))}get textLength(){const u=this.a.length-1;return new $.$uu(u,this.text.length-this.a[u])}}t.$Qv=g}),ne(ie[48],se([0,1,10,3,4,47,2,30]),function(C,t,i,M,R,c,$,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vv=t.$Uv=t.$Tv=t.$Sv=t.$Rv=void 0;class a{static single(m,S){return new a([new u(m,S)])}constructor(m){this.edits=m,(0,i.$hd)(()=>(0,i.$id)(m,(S,j)=>S.range.getEndPosition().isBeforeOrEqual(j.range.getStartPosition())))}normalize(){const m=[];for(const S of this.edits)if(m.length>0&&m[m.length-1].range.getEndPosition().equals(S.range.getStartPosition())){const j=m[m.length-1];m[m.length-1]=new u(j.range.plusRange(S.range),j.text+S.text)}else S.isEmpty||m.push(S);return new a(m)}mapPosition(m){let S=0,j=0,v=0;for(const w of this.edits){const p=w.range.getStartPosition(),l=w.range.getEndPosition();if(m.isBeforeOrEqual(p))break;const n=g.$uu.ofText(w.text);if(m.isBefore(l)){const s=new R.$wt(p.lineNumber+S,p.column+(p.lineNumber+S===j?v:0)),f=n.addToPosition(s);return o(s,f)}S+=n.lineCount-(w.range.endLineNumber-w.range.startLineNumber),n.lineCount===0?l.lineNumber!==p.lineNumber?v+=n.columnCount-(l.column-1):v+=n.columnCount-(l.column-p.column):v=n.columnCount,j=l.lineNumber+S}return new R.$wt(m.lineNumber+S,m.column+(m.lineNumber+S===j?v:0))}mapRange(m){function S(p){return p instanceof R.$wt?p:p.getStartPosition()}function j(p){return p instanceof R.$wt?p:p.getEndPosition()}const v=S(this.mapPosition(m.getStartPosition())),w=j(this.mapPosition(m.getEndPosition()));return o(v,w)}inverseMapPosition(m,S){return this.inverse(S).mapPosition(m)}inverseMapRange(m,S){return this.inverse(S).mapRange(m)}apply(m){let S="",j=new R.$wt(1,1);for(const w of this.edits){const p=w.range,l=p.getStartPosition(),n=p.getEndPosition(),s=o(j,l);s.isEmpty()||(S+=m.getValueOfRange(s)),S+=w.text,j=n}const v=o(j,m.endPositionExclusive);return v.isEmpty()||(S+=m.getValueOfRange(v)),S}applyToString(m){const S=new b(m);return this.apply(S)}inverse(m){const S=this.getNewRanges();return new a(this.edits.map((j,v)=>new u(S[v],m.getValueOfRange(j.range))))}getNewRanges(){const m=[];let S=0,j=0,v=0;for(const w of this.edits){const p=g.$uu.ofText(w.text),l=R.$wt.lift({lineNumber:w.range.startLineNumber+j,column:w.range.startColumn+(w.range.startLineNumber===S?v:0)}),n=p.createRange(l);m.push(n),j=n.endLineNumber-w.range.endLineNumber,v=n.endColumn-w.range.endColumn,S=w.range.endLineNumber}return m}}t.$Rv=a;class u{constructor(m,S){this.range=m,this.text=S}get isEmpty(){return this.range.isEmpty()&&this.text.length===0}static equals(m,S){return m.range.equalsRange(S.range)&&m.text===S.text}toSingleEditOperation(){return{range:this.range,text:this.text}}}t.$Sv=u;function o(e,m){if(e.lineNumber===m.lineNumber&&e.column===Number.MAX_SAFE_INTEGER)return $.$xt.fromPositions(m,m);if(!e.isBeforeOrEqual(m))throw new M.$cb("start must be before end");return new $.$xt(e.lineNumber,e.column,m.lineNumber,m.column)}class N{get endPositionExclusive(){return this.length.addToPosition(new R.$wt(1,1))}getValue(){return this.getValueOfRange(this.length.toRange())}}t.$Tv=N;class d extends N{constructor(m,S){(0,i.$fd)(S>=1),super(),this.c=m,this.d=S}getValueOfRange(m){if(m.startLineNumber===m.endLineNumber)return this.c(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);let S=this.c(m.startLineNumber).substring(m.startColumn-1);for(let j=m.startLineNumber+1;j<m.endLineNumber;j++)S+=`
`+this.c(j);return S+=`
`+this.c(m.endLineNumber).substring(0,m.endColumn-1),S}get length(){const m=this.c(this.d);return new g.$uu(this.d-1,m.length)}}t.$Uv=d;class b extends N{constructor(m){super(),this.value=m,this.c=new c.$Qv(this.value)}getValueOfRange(m){return this.c.getOffsetRange(m).substring(this.value)}get length(){return this.c.textLength}}t.$Vv=b}),ne(ie[49],se([0,1,14,29]),function(C,t,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nt=t.WordCharacterClass=void 0,t.$Ot=g;var R;(function(a){a[a.Regular=0]="Regular",a[a.Whitespace=1]="Whitespace",a[a.WordSeparator=2]="WordSeparator"})(R||(t.WordCharacterClass=R={}));class c extends M.$Lt{constructor(u,o){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=o,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let N=0,d=u.length;N<d;N++)this.set(u.charCodeAt(N),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(u,o){let N=null;for(const d of this.h(u)){if(d.index>o)break;N=d}return N}findNextIntlWordAtOrAfterOffset(u,o){for(const N of this.h(u))if(!(N.index<o))return N;return null}h(u){return this.e?this.f===u?this.g:(this.f=u,this.g=this.j(this.e.segment(u)),this.g):[]}j(u){const o=[];for(const N of u)this.k(N)&&o.push(N);return o}k(u){return!!u.isWordLike}}t.$Nt=c;const $=new i.$Dc(10);function g(a,u){const o=`${a}/${u.join(",")}`;let N=$.get(o);return N||(N=new c(a,u),$.set(o,N)),N}}),ne(ie[31],se([0,1,21,11,22]),function(C,t,i,M,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9s=t.$8s=void 0,t.$0s=$,t.$$s=a,t.$_s=u,t.$8s="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function c(N=""){let d="(-?\\d*\\.\\d\\w*)|([^";for(const b of t.$8s)N.indexOf(b)>=0||(d+="\\"+b);return d+="\\s]+)",new RegExp(d,"g")}t.$9s=c();function $(N){let d=t.$9s;if(N&&N instanceof RegExp)if(N.global)d=N;else{let b="g";N.ignoreCase&&(b+="i"),N.multiline&&(b+="m"),N.unicode&&(b+="u"),d=new RegExp(N.source,b)}return d.lastIndex=0,d}const g=new R.$5c;g.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(N){const d=g.unshift(N);return(0,M.$Sc)(d)}function u(N,d,b,e,m){if(d=$(d),m||(m=i.Iterable.first(g)),b.length>m.maxLen){let p=N-m.maxLen/2;return p<0?p=0:e+=p,b=b.substring(p,N+m.maxLen/2),u(N,d,b,e,m)}const S=Date.now(),j=N-1-e;let v=-1,w=null;for(let p=1;!(Date.now()-S>=m.timeBudget);p++){const l=j-m.windowSize*p;d.lastIndex=Math.max(0,l);const n=o(d,b,j,v);if(!n&&w||(w=n,l<=0))break;v=l}if(w){const p={word:w[0],startColumn:e+1+w.index,endColumn:e+1+w.index+w[0].length};return d.lastIndex=0,p}return null}function o(N,d,b,e){let m;for(;m=N.exec(d);){const S=m.index||0;if(S<=b&&N.lastIndex>=b)return m;if(e>0&&S>e)return null}return null}}),ne(ie[9],se([0,1,6,3,5]),function(C,t,i,M,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T2=t.$S2=t.$R2=t.$Q2=t.$P2=void 0;class c{static trivial(N,d){return new c([new $(R.$Et.ofLength(N.length),R.$Et.ofLength(d.length))],!1)}static trivialTimedOut(N,d){return new c([new $(R.$Et.ofLength(N.length),R.$Et.ofLength(d.length))],!0)}constructor(N,d){this.diffs=N,this.hitTimeout=d}}t.$P2=c;class ${static invert(N,d){const b=[];return(0,i.$Bb)(N,(e,m)=>{b.push($.fromOffsetPairs(e?e.getEndExclusives():g.zero,m?m.getStarts():new g(d,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+d)))}),b}static fromOffsetPairs(N,d){return new $(new R.$Et(N.offset1,d.offset1),new R.$Et(N.offset2,d.offset2))}constructor(N,d){this.seq1Range=N,this.seq2Range=d}swap(){return new $(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(N){return new $(this.seq1Range.join(N.seq1Range),this.seq2Range.join(N.seq2Range))}delta(N){return N===0?this:new $(this.seq1Range.delta(N),this.seq2Range.delta(N))}deltaStart(N){return N===0?this:new $(this.seq1Range.deltaStart(N),this.seq2Range.deltaStart(N))}deltaEnd(N){return N===0?this:new $(this.seq1Range.deltaEnd(N),this.seq2Range.deltaEnd(N))}intersectsOrTouches(N){return this.seq1Range.intersectsOrTouches(N.seq1Range)||this.seq2Range.intersectsOrTouches(N.seq2Range)}intersect(N){const d=this.seq1Range.intersect(N.seq1Range),b=this.seq2Range.intersect(N.seq2Range);if(!(!d||!b))return new $(d,b)}getStarts(){return new g(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new g(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$Q2=$;class g{static{this.zero=new g(0,0)}static{this.max=new g(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(N,d){this.offset1=N,this.offset2=d}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(N){return N===0?this:new g(this.offset1+N,this.offset2+N)}equals(N){return this.offset1===N.offset1&&this.offset2===N.offset2}}t.$R2=g;class a{static{this.instance=new a}isValid(){return!0}}t.$S2=a;class u{constructor(N){if(this.e=N,this.c=Date.now(),this.d=!0,N<=0)throw new M.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$T2=u}),ne(ie[32],se([0,1,5,9]),function(C,t,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Y2=void 0;class R{compute(u,o,N=M.$S2.instance){if(u.length===0||o.length===0)return M.$P2.trivial(u,o);const d=u,b=o;function e(s,f){for(;s<d.length&&f<b.length&&d.getElement(s)===b.getElement(f);)s++,f++;return s}let m=0;const S=new $;S.set(0,e(0,0));const j=new g;j.set(0,S.get(0)===0?null:new c(null,0,0,S.get(0)));let v=0;e:for(;;){if(m++,!N.isValid())return M.$P2.trivialTimedOut(d,b);const s=-Math.min(m,b.length+m%2),f=Math.min(m,d.length+m%2);for(v=s;v<=f;v+=2){let h=0;const L=v===f?-1:S.get(v+1),E=v===s?-1:S.get(v-1)+1;h++;const A=Math.min(Math.max(L,E),d.length),y=A-v;if(h++,A>d.length||y>b.length)continue;const F=e(A,y);S.set(v,F);const T=A===L?j.get(v+1):j.get(v-1);if(j.set(v,F!==A?new c(T,A,y,F-A):T),S.get(v)===d.length&&S.get(v)-v===b.length)break e}}let w=j.get(v);const p=[];let l=d.length,n=b.length;for(;;){const s=w?w.x+w.length:0,f=w?w.y+w.length:0;if((s!==l||f!==n)&&p.push(new M.$Q2(new i.$Et(s,l),new i.$Et(f,n))),!w)break;l=w.x,n=w.y,w=w.prev}return p.reverse(),new M.$P2(p,!1)}}t.$Y2=R;class c{constructor(u,o,N,d){this.prev=u,this.x=o,this.y=N,this.length=d}}class ${constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,o){if(u<0){if(u=-u-1,u>=this.b.length){const N=this.b;this.b=new Int32Array(N.length*2),this.b.set(N)}this.b[u]=o}else{if(u>=this.a.length){const N=this.a;this.a=new Int32Array(N.length*2),this.a.set(N)}this.a[u]=o}}}class g{constructor(){this.a=[],this.b=[]}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,o){u<0?(u=-u-1,this.b[u]=o):this.a[u]=o}}}),ne(ie[50],se([0,1,6,5,9]),function(C,t,i,M,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$32=c,t.$42=u,t.$52=o,t.$62=d,t.$72=b;function c(e,m,S){let j=S;return j=$(e,m,j),j=$(e,m,j),j=g(e,m,j),j}function $(e,m,S){if(S.length===0)return S;const j=[];j.push(S[0]);for(let w=1;w<S.length;w++){const p=j[j.length-1];let l=S[w];if(l.seq1Range.isEmpty||l.seq2Range.isEmpty){const n=l.seq1Range.start-p.seq1Range.endExclusive;let s;for(s=1;s<=n&&!(e.getElement(l.seq1Range.start-s)!==e.getElement(l.seq1Range.endExclusive-s)||m.getElement(l.seq2Range.start-s)!==m.getElement(l.seq2Range.endExclusive-s));s++);if(s--,s===n){j[j.length-1]=new R.$Q2(new M.$Et(p.seq1Range.start,l.seq1Range.endExclusive-n),new M.$Et(p.seq2Range.start,l.seq2Range.endExclusive-n));continue}l=l.delta(-s)}j.push(l)}const v=[];for(let w=0;w<j.length-1;w++){const p=j[w+1];let l=j[w];if(l.seq1Range.isEmpty||l.seq2Range.isEmpty){const n=p.seq1Range.start-l.seq1Range.endExclusive;let s;for(s=0;s<n&&!(!e.isStronglyEqual(l.seq1Range.start+s,l.seq1Range.endExclusive+s)||!m.isStronglyEqual(l.seq2Range.start+s,l.seq2Range.endExclusive+s));s++);if(s===n){j[w+1]=new R.$Q2(new M.$Et(l.seq1Range.start+n,p.seq1Range.endExclusive),new M.$Et(l.seq2Range.start+n,p.seq2Range.endExclusive));continue}s>0&&(l=l.delta(s))}v.push(l)}return j.length>0&&v.push(j[j.length-1]),v}function g(e,m,S){if(!e.getBoundaryScore||!m.getBoundaryScore)return S;for(let j=0;j<S.length;j++){const v=j>0?S[j-1]:void 0,w=S[j],p=j+1<S.length?S[j+1]:void 0,l=new M.$Et(v?v.seq1Range.endExclusive+1:0,p?p.seq1Range.start-1:e.length),n=new M.$Et(v?v.seq2Range.endExclusive+1:0,p?p.seq2Range.start-1:m.length);w.seq1Range.isEmpty?S[j]=a(w,e,m,l,n):w.seq2Range.isEmpty&&(S[j]=a(w.swap(),m,e,n,l).swap())}return S}function a(e,m,S,j,v){let p=1;for(;e.seq1Range.start-p>=j.start&&e.seq2Range.start-p>=v.start&&S.isStronglyEqual(e.seq2Range.start-p,e.seq2Range.endExclusive-p)&&p<100;)p++;p--;let l=0;for(;e.seq1Range.start+l<j.endExclusive&&e.seq2Range.endExclusive+l<v.endExclusive&&S.isStronglyEqual(e.seq2Range.start+l,e.seq2Range.endExclusive+l)&&l<100;)l++;if(p===0&&l===0)return e;let n=0,s=-1;for(let f=-p;f<=l;f++){const h=e.seq2Range.start+f,L=e.seq2Range.endExclusive+f,E=e.seq1Range.start+f,A=m.getBoundaryScore(E)+S.getBoundaryScore(h)+S.getBoundaryScore(L);A>s&&(s=A,n=f)}return e.delta(n)}function u(e,m,S){const j=[];for(const v of S){const w=j[j.length-1];if(!w){j.push(v);continue}v.seq1Range.start-w.seq1Range.endExclusive<=2||v.seq2Range.start-w.seq2Range.endExclusive<=2?j[j.length-1]=new R.$Q2(w.seq1Range.join(v.seq1Range),w.seq2Range.join(v.seq2Range)):j.push(v)}return j}function o(e,m,S){const j=R.$Q2.invert(S,e.length),v=[];let w=new R.$R2(0,0);function p(n,s){if(n.offset1<w.offset1||n.offset2<w.offset2)return;const f=e.findWordContaining(n.offset1),h=m.findWordContaining(n.offset2);if(!f||!h)return;let L=new R.$Q2(f,h);const E=L.intersect(s);let A=E.seq1Range.length,y=E.seq2Range.length;for(;j.length>0;){const F=j[0];if(!(F.seq1Range.intersects(L.seq1Range)||F.seq2Range.intersects(L.seq2Range)))break;const I=e.findWordContaining(F.seq1Range.start),k=m.findWordContaining(F.seq2Range.start),q=new R.$Q2(I,k),x=q.intersect(F);if(A+=x.seq1Range.length,y+=x.seq2Range.length,L=L.join(q),L.seq1Range.endExclusive>=F.seq1Range.endExclusive)j.shift();else break}A+y<(L.seq1Range.length+L.seq2Range.length)*2/3&&v.push(L),w=L.getEndExclusives()}for(;j.length>0;){const n=j.shift();n.seq1Range.isEmpty||(p(n.getStarts(),n),p(n.getEndExclusives().delta(-1),n))}return N(S,v)}function N(e,m){const S=[];for(;e.length>0||m.length>0;){const j=e[0],v=m[0];let w;j&&(!v||j.seq1Range.start<v.seq1Range.start)?w=e.shift():w=m.shift(),S.length>0&&S[S.length-1].seq1Range.endExclusive>=w.seq1Range.start?S[S.length-1]=S[S.length-1].join(w):S.push(w)}return S}function d(e,m,S){let j=S;if(j.length===0)return j;let v=0,w;do{w=!1;const p=[j[0]];for(let l=1;l<j.length;l++){let f=function(L,E){const A=new M.$Et(s.seq1Range.endExclusive,n.seq1Range.start);return e.getText(A).replace(/\s/g,"").length<=4&&(L.seq1Range.length+L.seq2Range.length>5||E.seq1Range.length+E.seq2Range.length>5)};const n=j[l],s=p[p.length-1];f(s,n)?(w=!0,p[p.length-1]=p[p.length-1].join(n)):p.push(n)}j=p}while(v++<10&&w);return j}function b(e,m,S){let j=S;if(j.length===0)return j;let v=0,w;do{w=!1;const l=[j[0]];for(let n=1;n<j.length;n++){let h=function(E,A){const y=new M.$Et(f.seq1Range.endExclusive,s.seq1Range.start);if(e.countLinesIn(y)>5||y.length>500)return!1;const T=e.getText(y).trim();if(T.length>20||T.split(/\r\n|\r|\n/).length>1)return!1;const I=e.countLinesIn(E.seq1Range),k=E.seq1Range.length,q=m.countLinesIn(E.seq2Range),x=E.seq2Range.length,W=e.countLinesIn(A.seq1Range),Q=A.seq1Range.length,Y=m.countLinesIn(A.seq2Range),X=A.seq2Range.length,G=2*40+50;function U(K){return Math.min(K,G)}return Math.pow(Math.pow(U(I*40+k),1.5)+Math.pow(U(q*40+x),1.5),1.5)+Math.pow(Math.pow(U(W*40+Q),1.5)+Math.pow(U(Y*40+X),1.5),1.5)>(G**1.5)**1.5*1.3};const s=j[n],f=l[l.length-1];h(f,s)?(w=!0,l[l.length-1]=l[l.length-1].join(s)):l.push(s)}j=l}while(v++<10&&w);const p=[];return(0,i.$Cb)(j,(l,n,s)=>{let f=n;function h(T){return T.length>0&&T.trim().length<=3&&n.seq1Range.length+n.seq2Range.length>100}const L=e.extendToFullLines(n.seq1Range),E=e.getText(new M.$Et(L.start,n.seq1Range.start));h(E)&&(f=f.deltaStart(-E.length));const A=e.getText(new M.$Et(n.seq1Range.endExclusive,L.endExclusive));h(A)&&(f=f.deltaEnd(A.length));const y=R.$Q2.fromOffsetPairs(l?l.getEndExclusives():R.$R2.zero,s?s.getStarts():R.$R2.max),F=f.intersect(y);p.length>0&&F.getStarts().equals(p[p.length-1].getEndExclusives())?p[p.length-1]=p[p.length-1].join(F):p.push(F)}),p}}),ne(ie[51],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$22=void 0;class i{constructor(c,$){this.a=c,this.b=$}getElement(c){return this.a[c]}get length(){return this.a.length}getBoundaryScore(c){const $=c===0?0:M(this.b[c-1]),g=c===this.b.length?0:M(this.b[c]);return 1e3-($+g)}getText(c){return this.b.slice(c.start,c.endExclusive).join(`
`)}isStronglyEqual(c,$){return this.b[c]===this.b[$]}}t.$22=i;function M(R){let c=0;for(;c<R.length&&(R.charCodeAt(c)===32||R.charCodeAt(c)===9);)c++;return c}}),ne(ie[16],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$W2=t.$U2=void 0,t.$V2=M;class i{constructor($,g){this.width=$,this.height=g,this.a=[],this.a=new Array($*g)}get($,g){return this.a[$+g*this.width]}set($,g,a){this.a[$+g*this.width]=a}}t.$U2=i;function M(c){return c===32||c===9}class R{static{this.a=new Map}static b($){let g=this.a.get($);return g===void 0&&(g=this.a.size,this.a.set($,g)),g}constructor($,g,a){this.range=$,this.lines=g,this.source=a,this.d=[];let u=0;for(let o=$.startLineNumber-1;o<$.endLineNumberExclusive-1;o++){const N=g[o];for(let b=0;b<N.length;b++){u++;const e=N[b],m=R.b(e);this.d[m]=(this.d[m]||0)+1}u++;const d=R.b(`
`);this.d[d]=(this.d[d]||0)+1}this.c=u}computeSimilarity($){let g=0;const a=Math.max(this.d.length,$.d.length);for(let u=0;u<a;u++)g+=Math.abs((this.d[u]??0)-($.d[u]??0));return 1-g/(this.c+$.c)}}t.$W2=R}),ne(ie[52],se([0,1,5,9,16]),function(C,t,i,M,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$X2=void 0;class c{compute(g,a,u=M.$S2.instance,o){if(g.length===0||a.length===0)return M.$P2.trivial(g,a);const N=new R.$U2(g.length,a.length),d=new R.$U2(g.length,a.length),b=new R.$U2(g.length,a.length);for(let p=0;p<g.length;p++)for(let l=0;l<a.length;l++){if(!u.isValid())return M.$P2.trivialTimedOut(g,a);const n=p===0?0:N.get(p-1,l),s=l===0?0:N.get(p,l-1);let f;g.getElement(p)===a.getElement(l)?(p===0||l===0?f=0:f=N.get(p-1,l-1),p>0&&l>0&&d.get(p-1,l-1)===3&&(f+=b.get(p-1,l-1)),f+=o?o(p,l):1):f=-1;const h=Math.max(n,s,f);if(h===f){const L=p>0&&l>0?b.get(p-1,l-1):0;b.set(p,l,L+1),d.set(p,l,3)}else h===n?(b.set(p,l,0),d.set(p,l,1)):h===s&&(b.set(p,l,0),d.set(p,l,2));N.set(p,l,h)}const e=[];let m=g.length,S=a.length;function j(p,l){(p+1!==m||l+1!==S)&&e.push(new M.$Q2(new i.$Et(p+1,m),new i.$Et(l+1,S))),m=p,S=l}let v=g.length-1,w=a.length-1;for(;v>=0&&w>=0;)d.get(v,w)===3?(j(v,w),v--,w--):d.get(v,w)===1?v--:w--;return j(-1,-1),e.reverse(),new M.$P2(e,!1)}}t.$X2=c}),ne(ie[33],se([0,1,8,5,4,2,16]),function(C,t,i,M,R,c,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Z2=void 0;class g{constructor(e,m,S){this.lines=e,this.considerWhitespaceChanges=S,this.b=[],this.c=[],this.d=[];let j=!1;m.start>0&&m.endExclusive>=e.length&&(m=new M.$Et(m.start-1,m.endExclusive),j=!0),this.lineRange=m,this.c[0]=0;for(let v=this.lineRange.start;v<this.lineRange.endExclusive;v++){let w=e[v],p=0;if(j)p=w.length,w="",j=!1;else if(!S){const l=w.trimStart();p=w.length-l.length,w=l.trimEnd()}this.d.push(p);for(let l=0;l<w.length;l++)this.b.push(w.charCodeAt(l));v<e.length-1&&(this.b.push(10),this.c[v-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new M.$Et(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(m=>String.fromCharCode(m)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const m=d(e>0?this.b[e-1]:-1),S=d(e<this.b.length?this.b[e]:-1);if(m===7&&S===8)return 0;if(m===8)return 150;let j=0;return m!==S&&(j+=10,m===0&&S===1&&(j+=1)),j+=N(m),j+=N(S),j}translateOffset(e){if(this.lineRange.isEmpty)return new R.$wt(this.lineRange.start+1,1);const m=(0,i.$ib)(this.c,S=>S<=e);return new R.$wt(this.lineRange.start+m+1,e-this.c[m]+this.d[m]+1)}translateRange(e){return c.$xt.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!a(this.b[e]))return;let m=e;for(;m>0&&a(this.b[m-1]);)m--;let S=e;for(;S<this.b.length&&a(this.b[S]);)S++;return new M.$Et(m,S)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,m){return this.b[e]===this.b[m]}extendToFullLines(e){const m=(0,i.$hb)(this.c,j=>j<=e.start)??0,S=(0,i.$jb)(this.c,j=>e.endExclusive<=j)??this.b.length;return new M.$Et(m,S)}}t.$Z2=g;function a(b){return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57}var u;(function(b){b[b.WordLower=0]="WordLower",b[b.WordUpper=1]="WordUpper",b[b.WordNumber=2]="WordNumber",b[b.End=3]="End",b[b.Other=4]="Other",b[b.Separator=5]="Separator",b[b.Space=6]="Space",b[b.LineBreakCR=7]="LineBreakCR",b[b.LineBreakLF=8]="LineBreakLF"})(u||(u={}));const o={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function N(b){return o[b]}function d(b){return b===10?8:b===13?7:(0,$.$V2)(b)?6:b>=97&&b<=122?0:b>=65&&b<=90?1:b>=48&&b<=57?2:b===-1?3:b===44||b===59?5:4}}),ne(ie[34],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1v=t.$Zv=void 0;class i{constructor(c,$,g){this.changes=c,this.moves=$,this.hitTimeout=g}}t.$Zv=i;class M{constructor(c,$){this.lineRangeMapping=c,this.changes=$}flip(){return new M(this.lineRangeMapping.flip(),this.changes.map(c=>c.flip()))}}t.$1v=M}),ne(ie[17],se([0,1,3,13,2,48]),function(C,t,i,M,R,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yv=t.$Xv=t.$Wv=void 0;class ${static inverse(o,N,d){const b=[];let e=1,m=1;for(const j of o){const v=new $(new M.$Ov(e,j.original.startLineNumber),new M.$Ov(m,j.modified.startLineNumber));v.modified.isEmpty||b.push(v),e=j.original.endLineNumberExclusive,m=j.modified.endLineNumberExclusive}const S=new $(new M.$Ov(e,N+1),new M.$Ov(m,d+1));return S.modified.isEmpty||b.push(S),b}static clip(o,N,d){const b=[];for(const e of o){const m=e.original.intersect(N),S=e.modified.intersect(d);m&&!m.isEmpty&&S&&!S.isEmpty&&b.push(new $(m,S))}return b}constructor(o,N){this.original=o,this.modified=N}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new $(this.modified,this.original)}join(o){return new $(this.original.join(o.original),this.modified.join(o.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}toRangeMapping(){const o=this.original.toInclusiveRange(),N=this.modified.toInclusiveRange();if(o&&N)return new a(o,N);if(this.original.startLineNumber===1||this.modified.startLineNumber===1){if(!(this.modified.startLineNumber===1&&this.original.startLineNumber===1))throw new i.$cb("not a valid diff");return new a(new R.$xt(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new R.$xt(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1))}else return new a(new R.$xt(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),new R.$xt(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER))}}t.$Wv=$;class g extends ${static fromRangeMappings(o){const N=M.$Ov.join(o.map(b=>M.$Ov.fromRangeInclusive(b.originalRange))),d=M.$Ov.join(o.map(b=>M.$Ov.fromRangeInclusive(b.modifiedRange)));return new g(N,d,o)}constructor(o,N,d){super(o,N),this.innerChanges=d}flip(){return new g(this.modified,this.original,this.innerChanges?.map(o=>o.flip()))}withInnerChangesFromLineRanges(){return new g(this.original,this.modified,[this.toRangeMapping()])}}t.$Xv=g;class a{constructor(o,N){this.originalRange=o,this.modifiedRange=N}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new a(this.modifiedRange,this.originalRange)}toTextEdit(o){const N=o.getValueOfRange(this.modifiedRange);return new c.$Sv(this.originalRange,N)}}t.$Yv=a}),ne(ie[53],se([0,1,9,17,6,8,14,13,5,33,16,32]),function(C,t,i,M,R,c,$,g,a,u,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$12=d;function d(w,p,l,n,s,f){let{moves:h,excludedChanges:L}=e(w,p,l,f);if(!f.isValid())return[];const E=w.filter(y=>!L.has(y)),A=m(E,n,s,p,l,f);return(0,R.$Zb)(h,A),h=j(h),h=h.filter(y=>{const F=y.original.toOffsetRange().slice(p).map(I=>I.trim());return F.join(`
`).length>=15&&b(F,I=>I.length>=2)>=2}),h=v(w,h),h}function b(w,p){let l=0;for(const n of w)p(n)&&l++;return l}function e(w,p,l,n){const s=[],f=w.filter(E=>E.modified.isEmpty&&E.original.length>=3).map(E=>new o.$W2(E.original,p,E)),h=new Set(w.filter(E=>E.original.isEmpty&&E.modified.length>=3).map(E=>new o.$W2(E.modified,l,E))),L=new Set;for(const E of f){let A=-1,y;for(const F of h){const T=E.computeSimilarity(F);T>A&&(A=T,y=F)}if(A>.9&&y&&(h.delete(y),s.push(new M.$Wv(E.range,y.range)),L.add(E.source),L.add(y.source)),!n.isValid())return{moves:s,excludedChanges:L}}return{moves:s,excludedChanges:L}}function m(w,p,l,n,s,f){const h=[],L=new $.$Hc;for(const T of w)for(let I=T.original.startLineNumber;I<T.original.endLineNumberExclusive-2;I++){const k=`${p[I-1]}:${p[I+1-1]}:${p[I+2-1]}`;L.add(k,{range:new g.$Ov(I,I+3)})}const E=[];w.sort((0,R.$6b)(T=>T.modified.startLineNumber,R.$8b));for(const T of w){let I=[];for(let k=T.modified.startLineNumber;k<T.modified.endLineNumberExclusive-2;k++){const q=`${l[k-1]}:${l[k+1-1]}:${l[k+2-1]}`,x=new g.$Ov(k,k+3),W=[];L.forEach(q,({range:Q})=>{for(const X of I)if(X.originalLineRange.endLineNumberExclusive+1===Q.endLineNumberExclusive&&X.modifiedLineRange.endLineNumberExclusive+1===x.endLineNumberExclusive){X.originalLineRange=new g.$Ov(X.originalLineRange.startLineNumber,Q.endLineNumberExclusive),X.modifiedLineRange=new g.$Ov(X.modifiedLineRange.startLineNumber,x.endLineNumberExclusive),W.push(X);return}const Y={modifiedLineRange:x,originalLineRange:Q};E.push(Y),W.push(Y)}),I=W}if(!f.isValid())return[]}E.sort((0,R.$0b)((0,R.$6b)(T=>T.modifiedLineRange.length,R.$8b)));const A=new g.$Pv,y=new g.$Pv;for(const T of E){const I=T.modifiedLineRange.startLineNumber-T.originalLineRange.startLineNumber,k=A.subtractFrom(T.modifiedLineRange),q=y.subtractFrom(T.originalLineRange).getWithDelta(I),x=k.getIntersection(q);for(const W of x.ranges){if(W.length<3)continue;const Q=W,Y=W.delta(-I);h.push(new M.$Wv(Y,Q)),A.addRange(Q),y.addRange(Y)}}h.sort((0,R.$6b)(T=>T.original.startLineNumber,R.$8b));const F=new c.$mb(w);for(let T=0;T<h.length;T++){const I=h[T],k=F.findLastMonotonous(U=>U.original.startLineNumber<=I.original.startLineNumber),q=(0,c.$hb)(w,U=>U.modified.startLineNumber<=I.modified.startLineNumber),x=Math.max(I.original.startLineNumber-k.original.startLineNumber,I.modified.startLineNumber-q.modified.startLineNumber),W=F.findLastMonotonous(U=>U.original.startLineNumber<I.original.endLineNumberExclusive),Q=(0,c.$hb)(w,U=>U.modified.startLineNumber<I.modified.endLineNumberExclusive),Y=Math.max(W.original.endLineNumberExclusive-I.original.endLineNumberExclusive,Q.modified.endLineNumberExclusive-I.modified.endLineNumberExclusive);let X;for(X=0;X<x;X++){const U=I.original.startLineNumber-X-1,K=I.modified.startLineNumber-X-1;if(U>n.length||K>s.length||A.contains(K)||y.contains(U)||!S(n[U-1],s[K-1],f))break}X>0&&(y.addRange(new g.$Ov(I.original.startLineNumber-X,I.original.startLineNumber)),A.addRange(new g.$Ov(I.modified.startLineNumber-X,I.modified.startLineNumber)));let G;for(G=0;G<Y;G++){const U=I.original.endLineNumberExclusive+G,K=I.modified.endLineNumberExclusive+G;if(U>n.length||K>s.length||A.contains(K)||y.contains(U)||!S(n[U-1],s[K-1],f))break}G>0&&(y.addRange(new g.$Ov(I.original.endLineNumberExclusive,I.original.endLineNumberExclusive+G)),A.addRange(new g.$Ov(I.modified.endLineNumberExclusive,I.modified.endLineNumberExclusive+G))),(X>0||G>0)&&(h[T]=new M.$Wv(new g.$Ov(I.original.startLineNumber-X,I.original.endLineNumberExclusive+G),new g.$Ov(I.modified.startLineNumber-X,I.modified.endLineNumberExclusive+G)))}return h}function S(w,p,l){if(w.trim()===p.trim())return!0;if(w.length>300&&p.length>300)return!1;const s=new N.$Y2().compute(new u.$Z2([w],new a.$Et(0,1),!1),new u.$Z2([p],new a.$Et(0,1),!1),l);let f=0;const h=i.$Q2.invert(s.diffs,w.length);for(const y of h)y.seq1Range.forEach(F=>{(0,o.$V2)(w.charCodeAt(F))||f++});function L(y){let F=0;for(let T=0;T<w.length;T++)(0,o.$V2)(y.charCodeAt(T))||F++;return F}const E=L(w.length>p.length?w:p);return f/E>.6&&E>10}function j(w){if(w.length===0)return w;w.sort((0,R.$6b)(l=>l.original.startLineNumber,R.$8b));const p=[w[0]];for(let l=1;l<w.length;l++){const n=p[p.length-1],s=w[l],f=s.original.startLineNumber-n.original.endLineNumberExclusive,h=s.modified.startLineNumber-n.modified.endLineNumberExclusive;if(f>=0&&h>=0&&f+h<=2){p[p.length-1]=n.join(s);continue}p.push(s)}return p}function v(w,p){const l=new c.$mb(w);return p=p.filter(n=>{const s=l.findLastMonotonous(L=>L.original.startLineNumber<n.original.endLineNumberExclusive)||new M.$Wv(new g.$Ov(1,1),new g.$Ov(1,1)),f=(0,c.$hb)(w,L=>L.modified.startLineNumber<n.modified.endLineNumberExclusive);return s!==f}),p}}),ne(ie[54],se([0,1,6,10,13,5,2,9,52,32,53,50,51,33,34,17]),function(C,t,i,M,R,c,$,g,a,u,o,N,d,b,e,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$82=void 0,t.$92=j,t.$02=v;class S{constructor(){this.e=new a.$X2,this.f=new u.$Y2}computeDiff(p,l,n){if(p.length<=1&&(0,i.$ub)(p,l,(G,U)=>G===U))return new e.$Zv([],[],!1);if(p.length===1&&p[0].length===0||l.length===1&&l[0].length===0)return new e.$Zv([new m.$Xv(new R.$Ov(1,p.length+1),new R.$Ov(1,l.length+1),[new m.$Yv(new $.$xt(1,1,p.length,p[p.length-1].length+1),new $.$xt(1,1,l.length,l[l.length-1].length+1))])],[],!1);const s=n.maxComputationTimeMs===0?g.$S2.instance:new g.$T2(n.maxComputationTimeMs),f=!n.ignoreTrimWhitespace,h=new Map;function L(G){let U=h.get(G);return U===void 0&&(U=h.size,h.set(G,U)),U}const E=p.map(G=>L(G.trim())),A=l.map(G=>L(G.trim())),y=new d.$22(E,p),F=new d.$22(A,l),T=y.length+F.length<1700?this.e.compute(y,F,s,(G,U)=>p[G]===l[U]?l[U].length===0?.1:1+Math.log(1+l[U].length):.99):this.f.compute(y,F);let I=T.diffs,k=T.hitTimeout;I=(0,N.$32)(y,F,I),I=(0,N.$62)(y,F,I);const q=[],x=G=>{if(f)for(let U=0;U<G;U++){const K=W+U,P=Q+U;if(p[K]!==l[P]){const Z=this.j(p,l,new g.$Q2(new c.$Et(K,K+1),new c.$Et(P,P+1)),s,f);for(const de of Z.mappings)q.push(de);Z.hitTimeout&&(k=!0)}}};let W=0,Q=0;for(const G of I){(0,M.$hd)(()=>G.seq1Range.start-W===G.seq2Range.start-Q);const U=G.seq1Range.start-W;x(U),W=G.seq1Range.endExclusive,Q=G.seq2Range.endExclusive;const K=this.j(p,l,G,s,f);K.hitTimeout&&(k=!0);for(const P of K.mappings)q.push(P)}x(p.length-W);const Y=j(q,p,l);let X=[];return n.computeMoves&&(X=this.h(Y,p,l,E,A,s,f)),(0,M.$hd)(()=>{function G(K,P){if(K.lineNumber<1||K.lineNumber>P.length)return!1;const Z=P[K.lineNumber-1];return!(K.column<1||K.column>Z.length+1)}function U(K,P){return!(K.startLineNumber<1||K.startLineNumber>P.length+1||K.endLineNumberExclusive<1||K.endLineNumberExclusive>P.length+1)}for(const K of Y){if(!K.innerChanges)return!1;for(const P of K.innerChanges)if(!(G(P.modifiedRange.getStartPosition(),l)&&G(P.modifiedRange.getEndPosition(),l)&&G(P.originalRange.getStartPosition(),p)&&G(P.originalRange.getEndPosition(),p)))return!1;if(!U(K.modified,l)||!U(K.original,p))return!1}return!0}),new e.$Zv(Y,X,k)}h(p,l,n,s,f,h,L){return(0,o.$12)(p,l,n,s,f,h).map(y=>{const F=this.j(l,n,new g.$Q2(y.original.toOffsetRange(),y.modified.toOffsetRange()),h,L),T=j(F.mappings,l,n,!0);return new e.$1v(y,T)})}j(p,l,n,s,f){const h=new b.$Z2(p,n.seq1Range,f),L=new b.$Z2(l,n.seq2Range,f),E=h.length+L.length<500?this.e.compute(h,L,s):this.f.compute(h,L,s);let A=E.diffs;return A=(0,N.$32)(h,L,A),A=(0,N.$52)(h,L,A),A=(0,N.$42)(h,L,A),A=(0,N.$72)(h,L,A),{mappings:A.map(F=>new m.$Yv(h.translateRange(F.seq1Range),L.translateRange(F.seq2Range))),hitTimeout:E.hitTimeout}}}t.$82=S;function j(w,p,l,n=!1){const s=[];for(const f of(0,i.$Ab)(w.map(h=>v(h,p,l)),(h,L)=>h.original.overlapOrTouch(L.original)||h.modified.overlapOrTouch(L.modified))){const h=f[0],L=f[f.length-1];s.push(new m.$Xv(h.original.join(L.original),h.modified.join(L.modified),f.map(E=>E.innerChanges[0])))}return(0,M.$hd)(()=>!n&&s.length>0&&(s[0].modified.startLineNumber!==s[0].original.startLineNumber||l.length-s[s.length-1].modified.endLineNumberExclusive!==p.length-s[s.length-1].original.endLineNumberExclusive)?!1:(0,M.$id)(s,(f,h)=>h.original.startLineNumber-f.original.endLineNumberExclusive===h.modified.startLineNumber-f.modified.endLineNumberExclusive&&f.original.endLineNumberExclusive<h.original.startLineNumber&&f.modified.endLineNumberExclusive<h.modified.startLineNumber)),s}function v(w,p,l){let n=0,s=0;w.modifiedRange.endColumn===1&&w.originalRange.endColumn===1&&w.originalRange.startLineNumber+n<=w.originalRange.endLineNumber&&w.modifiedRange.startLineNumber+n<=w.modifiedRange.endLineNumber&&(s=-1),w.modifiedRange.startColumn-1>=l[w.modifiedRange.startLineNumber-1].length&&w.originalRange.startColumn-1>=p[w.originalRange.startLineNumber-1].length&&w.originalRange.startLineNumber<=w.originalRange.endLineNumber+s&&w.modifiedRange.startLineNumber<=w.modifiedRange.endLineNumber+s&&(n=1);const f=new R.$Ov(w.originalRange.startLineNumber+n,w.originalRange.endLineNumber+1+s),h=new R.$Ov(w.modifiedRange.startLineNumber+n,w.modifiedRange.endLineNumber+1+s);return new m.$Xv(f,h,[w])}}),ne(ie[35],se([0,1,25,34,17,7,2,10,13]),function(C,t,i,M,R,c,$,g,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3v=t.$2v=void 0;const u=3;class o{computeDiff(n,s,f){const L=new j(n,s,{maxComputationTime:f.maxComputationTimeMs,shouldIgnoreTrimWhitespace:f.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),E=[];let A=null;for(const y of L.changes){let F;y.originalEndLineNumber===0?F=new a.$Ov(y.originalStartLineNumber+1,y.originalStartLineNumber+1):F=new a.$Ov(y.originalStartLineNumber,y.originalEndLineNumber+1);let T;y.modifiedEndLineNumber===0?T=new a.$Ov(y.modifiedStartLineNumber+1,y.modifiedStartLineNumber+1):T=new a.$Ov(y.modifiedStartLineNumber,y.modifiedEndLineNumber+1);let I=new R.$Xv(F,T,y.charChanges?.map(k=>new R.$Yv(new $.$xt(k.originalStartLineNumber,k.originalStartColumn,k.originalEndLineNumber,k.originalEndColumn),new $.$xt(k.modifiedStartLineNumber,k.modifiedStartColumn,k.modifiedEndLineNumber,k.modifiedEndColumn))));A&&(A.modified.endLineNumberExclusive===I.modified.startLineNumber||A.original.endLineNumberExclusive===I.original.startLineNumber)&&(I=new R.$Xv(A.original.join(I.original),A.modified.join(I.modified),A.innerChanges&&I.innerChanges?A.innerChanges.concat(I.innerChanges):void 0),E.pop()),E.push(I),A=I}return(0,g.$hd)(()=>(0,g.$id)(E,(y,F)=>F.original.startLineNumber-y.original.endLineNumberExclusive===F.modified.startLineNumber-y.modified.endLineNumberExclusive&&y.original.endLineNumberExclusive<F.original.startLineNumber&&y.modified.endLineNumberExclusive<F.modified.startLineNumber)),new M.$Zv(E,[],L.quitEarly)}}t.$2v=o;function N(l,n,s,f){return new i.$Dt(l,n,s).ComputeDiff(f)}class d{constructor(n){const s=[],f=[];for(let h=0,L=n.length;h<L;h++)s[h]=v(n[h],1),f[h]=w(n[h],1);this.lines=n,this.a=s,this.b=f}getElements(){const n=[];for(let s=0,f=this.lines.length;s<f;s++)n[s]=this.lines[s].substring(this.a[s]-1,this.b[s]-1);return n}getStrictElement(n){return this.lines[n]}getStartLineNumber(n){return n+1}getEndLineNumber(n){return n+1}createCharSequence(n,s,f){const h=[],L=[],E=[];let A=0;for(let y=s;y<=f;y++){const F=this.lines[y],T=n?this.a[y]:1,I=n?this.b[y]:F.length+1;for(let k=T;k<I;k++)h[A]=F.charCodeAt(k-1),L[A]=y+1,E[A]=k,A++;!n&&y<f&&(h[A]=10,L[A]=y+1,E[A]=F.length+1,A++)}return new b(h,L,E)}}class b{constructor(n,s,f){this.a=n,this.b=s,this.d=f}toString(){return"["+this.a.map((n,s)=>(n===10?"\\n":String.fromCharCode(n))+`-(${this.b[s]},${this.d[s]})`).join(", ")+"]"}e(n,s){if(n<0||n>=s.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(n){return n>0&&n===this.b.length?this.getEndLineNumber(n-1):(this.e(n,this.b),this.b[n])}getEndLineNumber(n){return n===-1?this.getStartLineNumber(n+1):(this.e(n,this.b),this.a[n]===10?this.b[n]+1:this.b[n])}getStartColumn(n){return n>0&&n===this.d.length?this.getEndColumn(n-1):(this.e(n,this.d),this.d[n])}getEndColumn(n){return n===-1?this.getStartColumn(n+1):(this.e(n,this.d),this.a[n]===10?1:this.d[n]+1)}}class e{constructor(n,s,f,h,L,E,A,y){this.originalStartLineNumber=n,this.originalStartColumn=s,this.originalEndLineNumber=f,this.originalEndColumn=h,this.modifiedStartLineNumber=L,this.modifiedStartColumn=E,this.modifiedEndLineNumber=A,this.modifiedEndColumn=y}static createFromDiffChange(n,s,f){const h=s.getStartLineNumber(n.originalStart),L=s.getStartColumn(n.originalStart),E=s.getEndLineNumber(n.originalStart+n.originalLength-1),A=s.getEndColumn(n.originalStart+n.originalLength-1),y=f.getStartLineNumber(n.modifiedStart),F=f.getStartColumn(n.modifiedStart),T=f.getEndLineNumber(n.modifiedStart+n.modifiedLength-1),I=f.getEndColumn(n.modifiedStart+n.modifiedLength-1);return new e(h,L,E,A,y,F,T,I)}}function m(l){if(l.length<=1)return l;const n=[l[0]];let s=n[0];for(let f=1,h=l.length;f<h;f++){const L=l[f],E=L.originalStart-(s.originalStart+s.originalLength),A=L.modifiedStart-(s.modifiedStart+s.modifiedLength);Math.min(E,A)<u?(s.originalLength=L.originalStart+L.originalLength-s.originalStart,s.modifiedLength=L.modifiedStart+L.modifiedLength-s.modifiedStart):(n.push(L),s=L)}return n}class S{constructor(n,s,f,h,L){this.originalStartLineNumber=n,this.originalEndLineNumber=s,this.modifiedStartLineNumber=f,this.modifiedEndLineNumber=h,this.charChanges=L}static createFromDiffResult(n,s,f,h,L,E,A){let y,F,T,I,k;if(s.originalLength===0?(y=f.getStartLineNumber(s.originalStart)-1,F=0):(y=f.getStartLineNumber(s.originalStart),F=f.getEndLineNumber(s.originalStart+s.originalLength-1)),s.modifiedLength===0?(T=h.getStartLineNumber(s.modifiedStart)-1,I=0):(T=h.getStartLineNumber(s.modifiedStart),I=h.getEndLineNumber(s.modifiedStart+s.modifiedLength-1)),E&&s.originalLength>0&&s.originalLength<20&&s.modifiedLength>0&&s.modifiedLength<20&&L()){const q=f.createCharSequence(n,s.originalStart,s.originalStart+s.originalLength-1),x=h.createCharSequence(n,s.modifiedStart,s.modifiedStart+s.modifiedLength-1);if(q.getElements().length>0&&x.getElements().length>0){let W=N(q,x,L,!0).changes;A&&(W=m(W)),k=[];for(let Q=0,Y=W.length;Q<Y;Q++)k.push(e.createFromDiffChange(W[Q],q,x))}}return new S(y,F,T,I,k)}}class j{constructor(n,s,f){this.a=f.shouldComputeCharChanges,this.b=f.shouldPostProcessCharChanges,this.d=f.shouldIgnoreTrimWhitespace,this.e=f.shouldMakePrettyDiff,this.f=n,this.g=s,this.h=new d(n),this.j=new d(s),this.k=p(f.maxComputationTime),this.l=p(f.maxComputationTime===0?0:Math.min(f.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const n=N(this.h,this.j,this.k,this.e),s=n.changes,f=n.quitEarly;if(this.d){const A=[];for(let y=0,F=s.length;y<F;y++)A.push(S.createFromDiffResult(this.d,s[y],this.h,this.j,this.l,this.a,this.b));return{quitEarly:f,changes:A}}const h=[];let L=0,E=0;for(let A=-1,y=s.length;A<y;A++){const F=A+1<y?s[A+1]:null,T=F?F.originalStart:this.f.length,I=F?F.modifiedStart:this.g.length;for(;L<T&&E<I;){const k=this.f[L],q=this.g[E];if(k!==q){{let x=v(k,1),W=v(q,1);for(;x>1&&W>1;){const Q=k.charCodeAt(x-2),Y=q.charCodeAt(W-2);if(Q!==Y)break;x--,W--}(x>1||W>1)&&this.m(h,L+1,1,x,E+1,1,W)}{let x=w(k,1),W=w(q,1);const Q=k.length+1,Y=q.length+1;for(;x<Q&&W<Y;){const X=k.charCodeAt(x-1),G=k.charCodeAt(W-1);if(X!==G)break;x++,W++}(x<Q||W<Y)&&this.m(h,L+1,x,Q,E+1,W,Y)}}L++,E++}F&&(h.push(S.createFromDiffResult(this.d,F,this.h,this.j,this.l,this.a,this.b)),L+=F.originalLength,E+=F.modifiedLength)}return{quitEarly:f,changes:h}}m(n,s,f,h,L,E,A){if(this.n(n,s,f,h,L,E,A))return;let y;this.a&&(y=[new e(s,f,s,h,L,E,L,A)]),n.push(new S(s,s,L,L,y))}n(n,s,f,h,L,E,A){const y=n.length;if(y===0)return!1;const F=n[y-1];return F.originalEndLineNumber===0||F.modifiedEndLineNumber===0?!1:F.originalEndLineNumber===s&&F.modifiedEndLineNumber===L?(this.a&&F.charChanges&&F.charChanges.push(new e(s,f,s,h,L,E,L,A)),!0):F.originalEndLineNumber+1===s&&F.modifiedEndLineNumber+1===L?(F.originalEndLineNumber=s,F.modifiedEndLineNumber=L,this.a&&F.charChanges&&F.charChanges.push(new e(s,f,s,h,L,E,L,A)),!0):!1}}t.$3v=j;function v(l,n){const s=c.$of(l);return s===-1?n:s+1}function w(l,n){const s=c.$qf(l);return s===-1?n:s+2}function p(l){if(l===0)return()=>!0;const n=Date.now();return()=>Date.now()-n<l}}),ne(ie[55],se([0,1,35,54]),function(C,t,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$2=void 0,t.$$2={getLegacy:()=>new i.$2v,getDefault:()=>new M.$82}}),ne(ie[56],se([0,1,37]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_2=N;function M(d){const b=[];for(const e of d){const m=Number(e);(m||m===0&&e.replace(/\s/g,"")!=="")&&b.push(m)}return b}function R(d,b,e,m){return{red:d/255,blue:e/255,green:b/255,alpha:m}}function c(d,b){const e=b.index,m=b[0].length;if(!e)return;const S=d.positionAt(e);return{startLineNumber:S.lineNumber,startColumn:S.column,endLineNumber:S.lineNumber,endColumn:S.column+m}}function $(d,b){if(!d)return;const e=i.$St.Format.CSS.parseHex(b);if(e)return{range:d,color:R(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function g(d,b,e){if(!d||b.length!==1)return;const S=b[0].values(),j=M(S);return{range:d,color:R(j[0],j[1],j[2],e?j[3]:1)}}function a(d,b,e){if(!d||b.length!==1)return;const S=b[0].values(),j=M(S),v=new i.$St(new i.$Qt(j[0],j[1]/100,j[2]/100,e?j[3]:1));return{range:d,color:R(v.rgba.r,v.rgba.g,v.rgba.b,v.rgba.a)}}function u(d,b){return typeof d=="string"?[...d.matchAll(b)]:d.findMatches(b)}function o(d){const b=[],m=u(d,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(m.length>0)for(const S of m){const j=S.filter(l=>l!==void 0),v=j[1],w=j[2];if(!w)continue;let p;if(v==="rgb"){const l=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;p=g(c(d,S),u(w,l),!1)}else if(v==="rgba"){const l=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;p=g(c(d,S),u(w,l),!0)}else if(v==="hsl"){const l=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;p=a(c(d,S),u(w,l),!1)}else if(v==="hsla"){const l=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;p=a(c(d,S),u(w,l),!0)}else v==="#"&&(p=$(c(d,S),v+w));p&&b.push(p)}return b}function N(d){return!d||typeof d.getValue!="function"||typeof d.positionAt!="function"?[]:o(d)}}),ne(ie[57],se([0,1,29]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K2=t.$J2=t.State=void 0,t.$L2=d;var M;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(M||(t.State=M={}));class R{constructor(e,m,S){const j=new Uint8Array(e*m);for(let v=0,w=e*m;v<w;v++)j[v]=S;this.a=j,this.rows=e,this.cols=m}get(e,m){return this.a[e*this.cols+m]}set(e,m,S){this.a[e*this.cols+m]=S}}class c{constructor(e){let m=0,S=0;for(let v=0,w=e.length;v<w;v++){const[p,l,n]=e[v];l>m&&(m=l),p>S&&(S=p),n>S&&(S=n)}m++,S++;const j=new R(S,m,0);for(let v=0,w=e.length;v<w;v++){const[p,l,n]=e[v];j.set(p,l,n)}this.a=j,this.b=m}nextState(e,m){return m<0||m>=this.b?0:this.a.get(e,m)}}t.$J2=c;let $=null;function g(){return $===null&&($=new c([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),$}var a;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let u=null;function o(){if(u===null){u=new i.$Lt(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<b.length;m++)u.set(b.charCodeAt(m),1);const e=".,;:";for(let m=0;m<e.length;m++)u.set(e.charCodeAt(m),2)}return u}class N{static a(e,m,S,j,v){let w=v-1;do{const p=m.charCodeAt(w);if(e.get(p)!==2)break;w--}while(w>j);if(j>0){const p=m.charCodeAt(j-1),l=m.charCodeAt(w);(p===40&&l===41||p===91&&l===93||p===123&&l===125)&&w--}return{range:{startLineNumber:S,startColumn:j+1,endLineNumber:S,endColumn:w+2},url:m.substring(j,w+1)}}static computeLinks(e,m=g()){const S=o(),j=[];for(let v=1,w=e.getLineCount();v<=w;v++){const p=e.getLineContent(v),l=p.length;let n=0,s=0,f=0,h=1,L=!1,E=!1,A=!1,y=!1;for(;n<l;){let F=!1;const T=p.charCodeAt(n);if(h===13){let I;switch(T){case 40:L=!0,I=0;break;case 41:I=L?0:1;break;case 91:A=!0,E=!0,I=0;break;case 93:A=!1,I=E?0:1;break;case 123:y=!0,I=0;break;case 125:I=y?0:1;break;case 39:case 34:case 96:f===T?I=1:f===39||f===34||f===96?I=0:I=1;break;case 42:I=f===42?1:0;break;case 124:I=f===124?1:0;break;case 32:I=A?0:1;break;default:I=S.get(T)}I===1&&(j.push(N.a(S,p,v,s,n)),F=!0)}else if(h===12){let I;T===91?(E=!0,I=0):I=S.get(T),I===1?F=!0:h=13}else h=m.nextState(h,T),h===0&&(F=!0);F&&(h=1,L=!1,E=!1,y=!1,s=n+1,f=T),n++}h===13&&j.push(N.a(S,p,v,s,l))}return j}}t.$K2=N;function d(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:N.computeLinks(b)}}),ne(ie[58],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$M2=void 0;class i{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new i}navigateValueSet(R,c,$,g,a){if(R&&c){const u=this.a(c,a);if(u)return{range:R,value:u}}if($&&g){const u=this.a(g,a);if(u)return{range:$,value:u}}return null}a(R,c){const $=this.b(R,c);return $!==null?$:this.d(R,c)}b(R,c){const $=Math.pow(10,R.length-(R.lastIndexOf(".")+1));let g=Number(R);const a=parseFloat(R);return!isNaN(g)&&!isNaN(a)&&g===a?g===0&&!c?null:(g=Math.floor(g*$),g+=c?$:-$,String(g/$)):null}d(R,c){return this.e(this.c,R,c)}e(R,c,$){let g=null;for(let a=0,u=R.length;g===null&&a<u;a++)g=this.f(R[a],c,$);return g}f(R,c,$){let g=R.indexOf(c);return g>=0?(g+=$?1:-1,g<0?g=R.length-1:g%=R.length,R[g]):null}}t.$M2=i}),ne(ie[59],se([0,1,15]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mv=t.$Lv=t.$Kv=t.ModelConstants=t.PositionAffinity=t.TrackedRangeStickiness=t.$Iv=t.$Hv=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0,t.$Jv=e,t.$Nv=p;var M;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(M||(t.OverviewRulerLane=M={}));var R;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=3]="Right"})(R||(t.GlyphMarginLane=R={}));var c;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(c||(t.MinimapPosition=c={}));var $;(function(l){l[l.Normal=1]="Normal",l[l.Underlined=2]="Underlined"})($||(t.MinimapSectionHeaderStyle=$={}));var g;(function(l){l[l.Both=0]="Both",l[l.Right=1]="Right",l[l.Left=2]="Left",l[l.None=3]="None"})(g||(t.InjectedTextCursorStops=g={}));var a;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(a||(t.EndOfLinePreference=a={}));var u;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(u||(t.DefaultEndOfLine=u={}));var o;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(o||(t.EndOfLineSequence=o={}));class N{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(n){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,n.tabSize|0),n.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,n.indentSize|0),this.a=!1),this.insertSpaces=!!n.insertSpaces,this.defaultEOL=n.defaultEOL|0,this.trimAutoWhitespace=!!n.trimAutoWhitespace,this.bracketPairColorizationOptions=n.bracketPairColorizationOptions}equals(n){return this.tabSize===n.tabSize&&this.a===n.a&&this.indentSize===n.indentSize&&this.insertSpaces===n.insertSpaces&&this.defaultEOL===n.defaultEOL&&this.trimAutoWhitespace===n.trimAutoWhitespace&&(0,i.$9n)(this.bracketPairColorizationOptions,n.bracketPairColorizationOptions)}createChangeEvent(n){return{tabSize:this.tabSize!==n.tabSize,indentSize:this.indentSize!==n.indentSize,insertSpaces:this.insertSpaces!==n.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==n.trimAutoWhitespace}}}t.$Hv=N;class d{constructor(n,s){this._findMatchBrand=void 0,this.range=n,this.matches=s}}t.$Iv=d;var b;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(t.TrackedRangeStickiness=b={}));function e(l){return l&&typeof l.read=="function"}var m;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right",l[l.None=2]="None",l[l.LeftOfInjectedText=3]="LeftOfInjectedText",l[l.RightOfInjectedText=4]="RightOfInjectedText"})(m||(t.PositionAffinity=m={}));var S;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(S||(t.ModelConstants=S={}));class j{constructor(n,s,f,h,L,E){this.identifier=n,this.range=s,this.text=f,this.forceMoveMarkers=h,this.isAutoWhitespaceEdit=L,this._isTracked=E}}t.$Kv=j;class v{constructor(n,s,f){this.regex=n,this.wordSeparators=s,this.simpleSearch=f}}t.$Lv=v;class w{constructor(n,s,f){this.reverseEdits=n,this.changes=s,this.trimAutoWhitespaceLineNumbers=f}}t.$Mv=w;function p(l){return!l.isTooLargeForSyncing()&&!l.isForSimpleWidget}}),ne(ie[60],se([0,1,6,28]),function(C,t,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8v=t.$7v=t.$6v=void 0;class R{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,u){a=(0,M.$8e)(a);const o=this.a,N=this.b,d=u.length;return d===0?!1:(this.a=new Uint32Array(o.length+d),this.a.set(o.subarray(0,a),0),this.a.set(o.subarray(a),a+d),this.a.set(u,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(N.subarray(0,this.c[0]+1)),!0)}setValue(a,u){return a=(0,M.$8e)(a),u=(0,M.$8e)(u),this.a[a]===u?!1:(this.a[a]=u,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,u){a=(0,M.$8e)(a),u=(0,M.$8e)(u);const o=this.a,N=this.b;if(a>=o.length)return!1;const d=o.length-a;return u>=d&&(u=d),u===0?!1:(this.a=new Uint32Array(o.length-u),this.a.set(o.subarray(0,a),0),this.a.set(o.subarray(a+u),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set(N.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,M.$8e)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let u=this.c[0]+1;u===0&&(this.b[0]=this.a[0],u++),a>=this.a.length&&(a=this.a.length-1);for(let o=u;o<=a;o++)this.b[o]=this.b[o-1]+this.a[o];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let u=0,o=this.a.length-1,N=0,d=0,b=0;for(;u<=o;)if(N=u+(o-u)/2|0,d=this.b[N],b=d-this.a[N],a<b)o=N-1;else if(a>=d)u=N+1;else break;return new $(N,a-b)}}t.$6v=R;class c{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const u=this.e[a],o=u>0?this.d[u-1]:0;return new $(u,a-o)}removeValues(a,u){this.a.splice(a,u),this.f(a)}insertValues(a,u){this.a=(0,i.$Vb)(this.a,a,u),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,u=this.a.length;a<u;a++){const o=this.a[a],N=a>0?this.d[a-1]:0;this.d[a]=N+o;for(let d=0;d<o;d++)this.e[N+d]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,u){this.a[a]!==u&&(this.a[a]=u,this.f(a))}}t.$7v=c;class ${constructor(a,u){this.index=a,this.remainder=u,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=u}}t.$8v=$}),ne(ie[61],se([0,1,7,4,60]),function(C,t,i,M,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9v=void 0;class c{constructor(g,a,u,o){this.d=g,this.f=a,this.g=u,this.h=o,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(g){g.eol&&g.eol!==this.g&&(this.g=g.eol,this.j=null);const a=g.changes;for(const u of a)this.o(u.range),this.p(new M.$wt(u.range.startLineNumber,u.range.startColumn),u.text);this.h=g.versionId,this.k=null}l(){if(!this.j){const g=this.g.length,a=this.f.length,u=new Uint32Array(a);for(let o=0;o<a;o++)u[o]=this.f[o].length+g;this.j=new R.$6v(u)}}n(g,a){this.f[g]=a,this.j&&this.j.setValue(g,this.f[g].length+this.g.length)}o(g){if(g.startLineNumber===g.endLineNumber){if(g.startColumn===g.endColumn)return;this.n(g.startLineNumber-1,this.f[g.startLineNumber-1].substring(0,g.startColumn-1)+this.f[g.startLineNumber-1].substring(g.endColumn-1));return}this.n(g.startLineNumber-1,this.f[g.startLineNumber-1].substring(0,g.startColumn-1)+this.f[g.endLineNumber-1].substring(g.endColumn-1)),this.f.splice(g.startLineNumber,g.endLineNumber-g.startLineNumber),this.j&&this.j.removeValues(g.startLineNumber,g.endLineNumber-g.startLineNumber)}p(g,a){if(a.length===0)return;const u=(0,i.$mf)(a);if(u.length===1){this.n(g.lineNumber-1,this.f[g.lineNumber-1].substring(0,g.column-1)+u[0]+this.f[g.lineNumber-1].substring(g.column-1));return}u[u.length-1]+=this.f[g.lineNumber-1].substring(g.column-1),this.n(g.lineNumber-1,this.f[g.lineNumber-1].substring(0,g.column-1)+u[0]);const o=new Uint32Array(u.length-1);for(let N=1;N<u.length;N++)this.f.splice(g.lineNumber+N-1,0,u[N]),o[N-1]=u[N].length+this.g.length;this.j&&this.j.insertValues(g.lineNumber,o)}}t.$9v=c}),ne(ie[62],se([0,1,7,49,4,2,59]),function(C,t,i,M,R,c,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XC=t.$VC=t.$SC=void 0,t.$TC=u,t.$UC=o,t.$WC=m;const g=999;class a{constructor(v,w,p,l){this.searchString=v,this.isRegex=w,this.matchCase=p,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=u(this.searchString):v=this.searchString.indexOf(`
`)>=0;let w=null;try{w=i.$kf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!w)return null;let p=!this.isRegex&&!v;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new $.$Lv(w,this.wordSeparators?(0,M.$Ot)(this.wordSeparators,[]):null,p?this.searchString:null)}}t.$SC=a;function u(j){if(!j||j.length===0)return!1;for(let v=0,w=j.length;v<w;v++){const p=j.charCodeAt(v);if(p===10)return!0;if(p===92){if(v++,v>=w)break;const l=j.charCodeAt(v);if(l===110||l===114||l===87)return!0}}return!1}function o(j,v,w){if(!w)return new $.$Iv(j,null);const p=[];for(let l=0,n=v.length;l<n;l++)p[l]=v[l];return new $.$Iv(j,p)}class N{constructor(v){const w=[];let p=0;for(let l=0,n=v.length;l<n;l++)v.charCodeAt(l)===10&&(w[p++]=l);this.a=w}findLineFeedCountBeforeOffset(v){const w=this.a;let p=0,l=w.length-1;if(l===-1||v<=w[0])return 0;for(;p<l;){const n=p+((l-p)/2>>0);w[n]>=v?l=n-1:w[n+1]>=v?(p=n,l=n):p=n+1}return p+1}}class d{static findMatches(v,w,p,l,n){const s=w.parseSearchRequest();return s?s.regex.multiline?this.b(v,p,new S(s.wordSeparators,s.regex),l,n):this.c(v,p,s,l,n):[]}static a(v,w,p,l,n,s){let f,h=0;l?(h=l.findLineFeedCountBeforeOffset(n),f=w+n+h):f=w+n;let L;if(l){const F=l.findLineFeedCountBeforeOffset(n+s.length)-h;L=f+s.length+F}else L=f+s.length;const E=v.getPositionAt(f),A=v.getPositionAt(L);return new c.$xt(E.lineNumber,E.column,A.lineNumber,A.column)}static b(v,w,p,l,n){const s=v.getOffsetAt(w.getStartPosition()),f=v.getValueInRange(w,1),h=v.getEOL()===`\r
`?new N(f):null,L=[];let E=0,A;for(p.reset(0);A=p.next(f);)if(L[E++]=o(this.a(v,s,f,h,A.index,A[0]),A,l),E>=n)return L;return L}static c(v,w,p,l,n){const s=[];let f=0;if(w.startLineNumber===w.endLineNumber){const L=v.getLineContent(w.startLineNumber).substring(w.startColumn-1,w.endColumn-1);return f=this.d(p,L,w.startLineNumber,w.startColumn-1,f,s,l,n),s}const h=v.getLineContent(w.startLineNumber).substring(w.startColumn-1);f=this.d(p,h,w.startLineNumber,w.startColumn-1,f,s,l,n);for(let L=w.startLineNumber+1;L<w.endLineNumber&&f<n;L++)f=this.d(p,v.getLineContent(L),L,0,f,s,l,n);if(f<n){const L=v.getLineContent(w.endLineNumber).substring(0,w.endColumn-1);f=this.d(p,L,w.endLineNumber,0,f,s,l,n)}return s}static d(v,w,p,l,n,s,f,h){const L=v.wordSeparators;if(!f&&v.simpleSearch){const y=v.simpleSearch,F=y.length,T=w.length;let I=-F;for(;(I=w.indexOf(y,I+F))!==-1;)if((!L||m(L,w,T,I,F))&&(s[n++]=new $.$Iv(new c.$xt(p,I+1+l,p,I+1+F+l),null),n>=h))return n;return n}const E=new S(v.wordSeparators,v.regex);let A;E.reset(0);do if(A=E.next(w),A&&(s[n++]=o(new c.$xt(p,A.index+1+l,p,A.index+1+A[0].length+l),A,f),n>=h))return n;while(A);return n}static findNextMatch(v,w,p,l){const n=w.parseSearchRequest();if(!n)return null;const s=new S(n.wordSeparators,n.regex);return n.regex.multiline?this.e(v,p,s,l):this.f(v,p,s,l)}static e(v,w,p,l){const n=new R.$wt(w.lineNumber,1),s=v.getOffsetAt(n),f=v.getLineCount(),h=v.getValueInRange(new c.$xt(n.lineNumber,n.column,f,v.getLineMaxColumn(f)),1),L=v.getEOL()===`\r
`?new N(h):null;p.reset(w.column-1);const E=p.next(h);return E?o(this.a(v,s,h,L,E.index,E[0]),E,l):w.lineNumber!==1||w.column!==1?this.e(v,new R.$wt(1,1),p,l):null}static f(v,w,p,l){const n=v.getLineCount(),s=w.lineNumber,f=v.getLineContent(s),h=this.g(p,f,s,w.column,l);if(h)return h;for(let L=1;L<=n;L++){const E=(s+L-1)%n,A=v.getLineContent(E+1),y=this.g(p,A,E+1,1,l);if(y)return y}return null}static g(v,w,p,l,n){v.reset(l-1);const s=v.next(w);return s?o(new c.$xt(p,s.index+1,p,s.index+1+s[0].length),s,n):null}static findPreviousMatch(v,w,p,l){const n=w.parseSearchRequest();if(!n)return null;const s=new S(n.wordSeparators,n.regex);return n.regex.multiline?this.h(v,p,s,l):this.j(v,p,s,l)}static h(v,w,p,l){const n=this.b(v,new c.$xt(1,1,w.lineNumber,w.column),p,l,10*g);if(n.length>0)return n[n.length-1];const s=v.getLineCount();return w.lineNumber!==s||w.column!==v.getLineMaxColumn(s)?this.h(v,new R.$wt(s,v.getLineMaxColumn(s)),p,l):null}static j(v,w,p,l){const n=v.getLineCount(),s=w.lineNumber,f=v.getLineContent(s).substring(0,w.column-1),h=this.k(p,f,s,l);if(h)return h;for(let L=1;L<=n;L++){const E=(n+s-L-1)%n,A=v.getLineContent(E+1),y=this.k(p,A,E+1,l);if(y)return y}return null}static k(v,w,p,l){let n=null,s;for(v.reset(0);s=v.next(w);)n=o(new c.$xt(p,s.index+1,p,s.index+1+s[0].length),s,l);return n}}t.$VC=d;function b(j,v,w,p,l){if(p===0)return!0;const n=v.charCodeAt(p-1);if(j.get(n)!==0||n===13||n===10)return!0;if(l>0){const s=v.charCodeAt(p);if(j.get(s)!==0)return!0}return!1}function e(j,v,w,p,l){if(p+l===w)return!0;const n=v.charCodeAt(p+l);if(j.get(n)!==0||n===13||n===10)return!0;if(l>0){const s=v.charCodeAt(p+l-1);if(j.get(s)!==0)return!0}return!1}function m(j,v,w,p,l){return b(j,v,w,p,l)&&e(j,v,w,p,l)}class S{constructor(v,w){this._wordSeparators=v,this.a=w,this.b=-1,this.c=0}reset(v){this.a.lastIndex=v,this.b=-1,this.c=0}next(v){const w=v.length;let p;do{if(this.b+this.c===w||(p=this.a.exec(v),!p))return null;const l=p.index,n=p[0].length;if(l===this.b&&n===this.c){if(n===0){i.$Gf(v,w,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=l,this.c=n,!this._wordSeparators||m(this._wordSeparators,v,w,l,n))return p}while(p);return null}}t.$XC=S}),ne(ie[63],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$a3=R;const i=new RegExp("\\bMARK:\\s*(.*)$","d"),M=/^-+|-+$/g;function R(u,o){let N=[];if(o.findRegionSectionHeaders&&o.foldingRules?.markers){const d=c(u,o);N=N.concat(d)}if(o.findMarkSectionHeaders){const d=$(u);N=N.concat(d)}return N}function c(u,o){const N=[],d=u.getLineCount();for(let b=1;b<=d;b++){const e=u.getLineContent(b),m=e.match(o.foldingRules.markers.start);if(m){const S={startLineNumber:b,startColumn:m[0].length+1,endLineNumber:b,endColumn:e.length+1};if(S.endColumn>S.startColumn){const j={range:S,...a(e.substring(m[0].length)),shouldBeInComments:!1};(j.text||j.hasSeparatorLine)&&N.push(j)}}}return N}function $(u){const o=[],N=u.getLineCount();for(let d=1;d<=N;d++){const b=u.getLineContent(d);g(b,d,o)}return o}function g(u,o,N){i.lastIndex=0;const d=i.exec(u);if(d){const b=d.indices[1][0]+1,e=d.indices[1][1]+1,m={startLineNumber:o,startColumn:b,endLineNumber:o,endColumn:e};if(m.endColumn>m.startColumn){const S={range:m,...a(d[1]),shouldBeInComments:!0};(S.text||S.hasSeparatorLine)&&N.push(S)}}}function a(u){u=u.trim();const o=u.startsWith("-");return u=u.replace(M,""),{text:u,hasSeparatorLine:o}}}),ne(ie[64],se([0,1,2,62,7,10,31]),function(C,t,i,M,R,c,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$I2=void 0;class g{static computeUnicodeHighlights(e,m,S){const j=S?S.startLineNumber:1,v=S?S.endLineNumber:e.getLineCount(),w=new o(m),p=w.getCandidateCodePoints();let l;p==="allNonBasicAscii"?l=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):l=new RegExp(`${a(Array.from(p))}`,"g");const n=new M.$XC(null,l),s=[];let f=!1,h,L=0,E=0,A=0;e:for(let y=j,F=v;y<=F;y++){const T=e.getLineContent(y),I=T.length;n.reset(0);do if(h=n.next(T),h){let k=h.index,q=h.index+h[0].length;if(k>0){const Y=T.charCodeAt(k-1);R.$Df(Y)&&k--}if(q+1<I){const Y=T.charCodeAt(q-1);R.$Df(Y)&&q++}const x=T.substring(k,q);let W=(0,$.$_s)(k+1,$.$9s,T,0);W&&W.endColumn<=k+1&&(W=null);const Q=w.shouldHighlightNonBasicASCII(x,W?W.word:null);if(Q!==0){if(Q===3?L++:Q===2?E++:Q===1?A++:(0,c.$ed)(Q),s.length>=1e3){f=!0;break e}s.push(new i.$xt(y,k+1,y,q+1))}}while(h)}return{ranges:s,hasMore:f,ambiguousCharacterCount:L,invisibleCharacterCount:E,nonBasicAsciiCharacterCount:A}}static computeUnicodeHighlightReason(e,m){const S=new o(m);switch(S.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const v=e.codePointAt(0),w=S.ambiguousCharacters.getPrimaryConfusable(v),p=R.$9f.getLocales().filter(l=>!R.$9f.getInstance(new Set([...m.allowedLocales,l])).isAmbiguous(v));return{kind:0,confusableWith:String.fromCodePoint(w),notAmbiguousInLocales:p}}case 1:return{kind:2}}}}t.$I2=g;function a(b,e){return`[${R.$bf(b.map(S=>String.fromCodePoint(S)).join(""))}]`}var u;(function(b){b[b.Ambiguous=0]="Ambiguous",b[b.Invisible=1]="Invisible",b[b.NonBasicAscii=2]="NonBasicAscii"})(u||(t.UnicodeHighlighterReasonKind=u={}));class o{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=R.$9f.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const m of R.$0f.codePoints)N(String.fromCodePoint(m))||e.add(m);if(this.b.ambiguousCharacters)for(const m of this.ambiguousCharacters.getConfusableCodePoints())e.add(m);for(const m of this.a)e.delete(m);return e}shouldHighlightNonBasicASCII(e,m){const S=e.codePointAt(0);if(this.a.has(S))return 0;if(this.b.nonBasicASCII)return 1;let j=!1,v=!1;if(m)for(const w of m){const p=w.codePointAt(0),l=R.$Of(w);j=j||l,!l&&!this.ambiguousCharacters.isAmbiguous(p)&&!R.$0f.isInvisibleCharacter(p)&&(v=!0)}return!j&&v?0:this.b.invisibleCharacters&&!N(e)&&R.$0f.isInvisibleCharacter(S)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(S)?3:0}}function N(b){return b===" "||b===`
`||b==="	"}var d;(function(b){b[b.None=0]="None",b[b.NonBasicASCII=1]="NonBasicASCII",b[b.Invisible=2]="Invisible",b[b.Ambiguous=3]="Ambiguous"})(d||(d={}))}),ne(ie[65],se([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.PartialAcceptTriggerKind=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTriggerKind=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineEditTriggerKind=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.HoverVerbosityAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var i;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(i||(t.AccessibilitySupport=i={}));var M;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(M||(t.CodeActionTriggerType=M={}));var R;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(R||(t.CompletionItemInsertTextRule=R={}));var c;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(c||(t.CompletionItemKind=c={}));var $;(function(r){r[r.Deprecated=1]="Deprecated"})($||(t.CompletionItemTag=$={}));var g;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g||(t.CompletionTriggerKind=g={}));var a;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(a||(t.ContentWidgetPositionPreference=a={}));var u;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(u||(t.CursorChangeReason=u={}));var o;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(o||(t.DefaultEndOfLine=o={}));var N;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(N||(t.DocumentHighlightKind=N={}));var d;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(d||(t.EditorAutoIndentStrategy=d={}));var b;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.ariaRequired=5]="ariaRequired",r[r.autoClosingBrackets=6]="autoClosingBrackets",r[r.autoClosingComments=7]="autoClosingComments",r[r.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",r[r.autoClosingDelete=9]="autoClosingDelete",r[r.autoClosingOvertype=10]="autoClosingOvertype",r[r.autoClosingQuotes=11]="autoClosingQuotes",r[r.autoIndent=12]="autoIndent",r[r.automaticLayout=13]="automaticLayout",r[r.autoSurround=14]="autoSurround",r[r.bracketPairColorization=15]="bracketPairColorization",r[r.guides=16]="guides",r[r.codeLens=17]="codeLens",r[r.codeLensFontFamily=18]="codeLensFontFamily",r[r.codeLensFontSize=19]="codeLensFontSize",r[r.colorDecorators=20]="colorDecorators",r[r.colorDecoratorsLimit=21]="colorDecoratorsLimit",r[r.columnSelection=22]="columnSelection",r[r.comments=23]="comments",r[r.contextmenu=24]="contextmenu",r[r.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",r[r.cursorBlinking=26]="cursorBlinking",r[r.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",r[r.cursorStyle=28]="cursorStyle",r[r.cursorSurroundingLines=29]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",r[r.cursorWidth=31]="cursorWidth",r[r.disableLayerHinting=32]="disableLayerHinting",r[r.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",r[r.domReadOnly=34]="domReadOnly",r[r.dragAndDrop=35]="dragAndDrop",r[r.dropIntoEditor=36]="dropIntoEditor",r[r.emptySelectionClipboard=37]="emptySelectionClipboard",r[r.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",r[r.extraEditorClassName=39]="extraEditorClassName",r[r.fastScrollSensitivity=40]="fastScrollSensitivity",r[r.find=41]="find",r[r.fixedOverflowWidgets=42]="fixedOverflowWidgets",r[r.folding=43]="folding",r[r.foldingStrategy=44]="foldingStrategy",r[r.foldingHighlight=45]="foldingHighlight",r[r.foldingImportsByDefault=46]="foldingImportsByDefault",r[r.foldingMaximumRegions=47]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=49]="fontFamily",r[r.fontInfo=50]="fontInfo",r[r.fontLigatures=51]="fontLigatures",r[r.fontSize=52]="fontSize",r[r.fontWeight=53]="fontWeight",r[r.fontVariations=54]="fontVariations",r[r.formatOnPaste=55]="formatOnPaste",r[r.formatOnType=56]="formatOnType",r[r.glyphMargin=57]="glyphMargin",r[r.gotoLocation=58]="gotoLocation",r[r.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",r[r.hover=60]="hover",r[r.inDiffEditor=61]="inDiffEditor",r[r.inlineSuggest=62]="inlineSuggest",r[r.inlineEdit=63]="inlineEdit",r[r.letterSpacing=64]="letterSpacing",r[r.lightbulb=65]="lightbulb",r[r.lineDecorationsWidth=66]="lineDecorationsWidth",r[r.lineHeight=67]="lineHeight",r[r.lineNumbers=68]="lineNumbers",r[r.lineNumbersMinChars=69]="lineNumbersMinChars",r[r.linkedEditing=70]="linkedEditing",r[r.links=71]="links",r[r.matchBrackets=72]="matchBrackets",r[r.minimap=73]="minimap",r[r.mouseStyle=74]="mouseStyle",r[r.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=76]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",r[r.multiCursorModifier=78]="multiCursorModifier",r[r.multiCursorPaste=79]="multiCursorPaste",r[r.multiCursorLimit=80]="multiCursorLimit",r[r.occurrencesHighlight=81]="occurrencesHighlight",r[r.overviewRulerBorder=82]="overviewRulerBorder",r[r.overviewRulerLanes=83]="overviewRulerLanes",r[r.padding=84]="padding",r[r.pasteAs=85]="pasteAs",r[r.parameterHints=86]="parameterHints",r[r.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",r[r.quickSuggestions=89]="quickSuggestions",r[r.quickSuggestionsDelay=90]="quickSuggestionsDelay",r[r.readOnly=91]="readOnly",r[r.readOnlyMessage=92]="readOnlyMessage",r[r.renameOnType=93]="renameOnType",r[r.renderControlCharacters=94]="renderControlCharacters",r[r.renderFinalNewline=95]="renderFinalNewline",r[r.renderLineHighlight=96]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=98]="renderValidationDecorations",r[r.renderWhitespace=99]="renderWhitespace",r[r.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",r[r.roundedSelection=101]="roundedSelection",r[r.rulers=102]="rulers",r[r.scrollbar=103]="scrollbar",r[r.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=105]="scrollBeyondLastLine",r[r.scrollPredominantAxis=106]="scrollPredominantAxis",r[r.selectionClipboard=107]="selectionClipboard",r[r.selectionHighlight=108]="selectionHighlight",r[r.selectOnLineNumbers=109]="selectOnLineNumbers",r[r.showFoldingControls=110]="showFoldingControls",r[r.showUnused=111]="showUnused",r[r.snippetSuggestions=112]="snippetSuggestions",r[r.smartSelect=113]="smartSelect",r[r.smoothScrolling=114]="smoothScrolling",r[r.stickyScroll=115]="stickyScroll",r[r.stickyTabStops=116]="stickyTabStops",r[r.stopRenderingLineAfter=117]="stopRenderingLineAfter",r[r.suggest=118]="suggest",r[r.suggestFontSize=119]="suggestFontSize",r[r.suggestLineHeight=120]="suggestLineHeight",r[r.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",r[r.suggestSelection=122]="suggestSelection",r[r.tabCompletion=123]="tabCompletion",r[r.tabIndex=124]="tabIndex",r[r.unicodeHighlighting=125]="unicodeHighlighting",r[r.unusualLineTerminators=126]="unusualLineTerminators",r[r.useShadowDOM=127]="useShadowDOM",r[r.useTabStops=128]="useTabStops",r[r.wordBreak=129]="wordBreak",r[r.wordSegmenterLocales=130]="wordSegmenterLocales",r[r.wordSeparators=131]="wordSeparators",r[r.wordWrap=132]="wordWrap",r[r.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=135]="wordWrapColumn",r[r.wordWrapOverride1=136]="wordWrapOverride1",r[r.wordWrapOverride2=137]="wordWrapOverride2",r[r.wrappingIndent=138]="wrappingIndent",r[r.wrappingStrategy=139]="wrappingStrategy",r[r.showDeprecated=140]="showDeprecated",r[r.inlayHints=141]="inlayHints",r[r.editorClassName=142]="editorClassName",r[r.pixelRatio=143]="pixelRatio",r[r.tabFocusMode=144]="tabFocusMode",r[r.layoutInfo=145]="layoutInfo",r[r.wrappingInfo=146]="wrappingInfo",r[r.defaultColorDecorators=147]="defaultColorDecorators",r[r.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",r[r.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(b||(t.EditorOption=b={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var m;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(m||(t.EndOfLineSequence=m={}));var S;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(S||(t.GlyphMarginLane=S={}));var j;(function(r){r[r.Increase=0]="Increase",r[r.Decrease=1]="Decrease"})(j||(t.HoverVerbosityAction=j={}));var v;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(v||(t.IndentAction=v={}));var w;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(w||(t.InjectedTextCursorStops=w={}));var p;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(p||(t.InlayHintKind=p={}));var l;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(l||(t.InlineCompletionTriggerKind=l={}));var n;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(n||(t.InlineEditTriggerKind=n={}));var s;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.F20=78]="F20",r[r.F21=79]="F21",r[r.F22=80]="F22",r[r.F23=81]="F23",r[r.F24=82]="F24",r[r.NumLock=83]="NumLock",r[r.ScrollLock=84]="ScrollLock",r[r.Semicolon=85]="Semicolon",r[r.Equal=86]="Equal",r[r.Comma=87]="Comma",r[r.Minus=88]="Minus",r[r.Period=89]="Period",r[r.Slash=90]="Slash",r[r.Backquote=91]="Backquote",r[r.BracketLeft=92]="BracketLeft",r[r.Backslash=93]="Backslash",r[r.BracketRight=94]="BracketRight",r[r.Quote=95]="Quote",r[r.OEM_8=96]="OEM_8",r[r.IntlBackslash=97]="IntlBackslash",r[r.Numpad0=98]="Numpad0",r[r.Numpad1=99]="Numpad1",r[r.Numpad2=100]="Numpad2",r[r.Numpad3=101]="Numpad3",r[r.Numpad4=102]="Numpad4",r[r.Numpad5=103]="Numpad5",r[r.Numpad6=104]="Numpad6",r[r.Numpad7=105]="Numpad7",r[r.Numpad8=106]="Numpad8",r[r.Numpad9=107]="Numpad9",r[r.NumpadMultiply=108]="NumpadMultiply",r[r.NumpadAdd=109]="NumpadAdd",r[r.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=111]="NumpadSubtract",r[r.NumpadDecimal=112]="NumpadDecimal",r[r.NumpadDivide=113]="NumpadDivide",r[r.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",r[r.ABNT_C1=115]="ABNT_C1",r[r.ABNT_C2=116]="ABNT_C2",r[r.AudioVolumeMute=117]="AudioVolumeMute",r[r.AudioVolumeUp=118]="AudioVolumeUp",r[r.AudioVolumeDown=119]="AudioVolumeDown",r[r.BrowserSearch=120]="BrowserSearch",r[r.BrowserHome=121]="BrowserHome",r[r.BrowserBack=122]="BrowserBack",r[r.BrowserForward=123]="BrowserForward",r[r.MediaTrackNext=124]="MediaTrackNext",r[r.MediaTrackPrevious=125]="MediaTrackPrevious",r[r.MediaStop=126]="MediaStop",r[r.MediaPlayPause=127]="MediaPlayPause",r[r.LaunchMediaPlayer=128]="LaunchMediaPlayer",r[r.LaunchMail=129]="LaunchMail",r[r.LaunchApp2=130]="LaunchApp2",r[r.Clear=131]="Clear",r[r.MAX_VALUE=132]="MAX_VALUE"})(s||(t.KeyCode=s={}));var f;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(f||(t.MarkerSeverity=f={}));var h;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(h||(t.MarkerTag=h={}));var L;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(L||(t.MinimapPosition=L={}));var E;(function(r){r[r.Normal=1]="Normal",r[r.Underlined=2]="Underlined"})(E||(t.MinimapSectionHeaderStyle=E={}));var A;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(A||(t.MouseTargetType=A={}));var y;(function(r){r[r.AIGenerated=1]="AIGenerated"})(y||(t.NewSymbolNameTag=y={}));var F;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(F||(t.NewSymbolNameTriggerKind=F={}));var T;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(T||(t.OverlayWidgetPositionPreference=T={}));var I;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(I||(t.OverviewRulerLane=I={}));var k;(function(r){r[r.Word=0]="Word",r[r.Line=1]="Line",r[r.Suggest=2]="Suggest"})(k||(t.PartialAcceptTriggerKind=k={}));var q;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(q||(t.PositionAffinity=q={}));var x;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(x||(t.RenderLineNumbersType=x={}));var W;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(W||(t.RenderMinimap=W={}));var Q;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(Q||(t.ScrollType=Q={}));var Y;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(Y||(t.ScrollbarVisibility=Y={}));var X;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(X||(t.SelectionDirection=X={}));var G;(function(r){r.Off="off",r.OnCode="onCode",r.On="on"})(G||(t.ShowLightbulbIconMode=G={}));var U;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(U||(t.SignatureHelpTriggerKind=U={}));var K;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(K||(t.SymbolKind=K={}));var P;(function(r){r[r.Deprecated=1]="Deprecated"})(P||(t.SymbolTag=P={}));var Z;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(Z||(t.TextEditorCursorBlinkingStyle=Z={}));var de;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(de||(t.TextEditorCursorStyle=de={}));var fe;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(fe||(t.TrackedRangeStickiness=fe={}));var ve;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(ve||(t.WrappingIndent=ve={}))}),ne(ie[66],se([0,1,12,11]),function(C,t,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3t=void 0;class R{constructor(){this.a=new Map,this.b=new Map,this.c=new i.$fe,this.onDidChange=this.c.event,this.d=null}handleChange(g){this.c.fire({changedLanguages:g,changedColorMap:!1})}register(g,a){return this.a.set(g,a),this.handleChange([g]),(0,M.$Sc)(()=>{this.a.get(g)===a&&(this.a.delete(g),this.handleChange([g]))})}get(g){return this.a.get(g)||null}registerFactory(g,a){this.b.get(g)?.dispose();const u=new c(this,g,a);return this.b.set(g,u),(0,M.$Sc)(()=>{const o=this.b.get(g);!o||o!==u||(this.b.delete(g),o.dispose())})}async getOrCreate(g){const a=this.get(g);if(a)return a;const u=this.b.get(g);return!u||u.isResolved?null:(await u.resolve(),this.get(g))}isResolved(g){if(this.get(g))return!0;const u=this.b.get(g);return!!(!u||u.isResolved)}setColorMap(g){this.d=g,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$3t=R;class c extends M.$Uc{get isResolved(){return this.c}constructor(g,a,u){super(),this.f=g,this.g=a,this.h=u,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const g=await this.h.tokenizationSupport;this.c=!0,g&&!this.a&&this.B(this.f.register(this.g,g))}}}),ne(ie[67],se([68,69]),function(C,t){return C.create("vs/base/common/platform",t)}),ne(ie[18],se([0,1,67]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=s,t.$D=y,t.$J=F,t.$g="en";let M=!1,R=!1,c=!1,$=!1,g=!1,a=!1,u=!1,o=!1,N=!1,d=!1,b,e=t.$g,m=t.$g,S,j;const v=globalThis;let w;typeof v.vscode<"u"&&typeof v.vscode.process<"u"?w=v.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(w=process);const p=typeof w?.versions?.electron=="string",l=p&&w?.type==="renderer";if(typeof w=="object"){M=w.platform==="win32",R=w.platform==="darwin",c=w.platform==="linux",$=c&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,u=p,N=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=t.$g,e=t.$g;const T=w.env.VSCODE_NLS_CONFIG;if(T)try{const I=JSON.parse(T),k=I.availableLanguages["*"];b=I.locale,m=I.osLocale,e=k||t.$g,S=I._translationsConfigFile}catch{}g=!0}else typeof navigator=="object"&&!l?(j=navigator.userAgent,M=j.indexOf("Windows")>=0,R=j.indexOf("Macintosh")>=0,o=(j.indexOf("Macintosh")>=0||j.indexOf("iPad")>=0||j.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,c=j.indexOf("Linux")>=0,d=j?.indexOf("Mobi")>=0,a=!0,b=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=b,m=navigator.language):console.error("Unable to resolve platform.");var n;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(n||(t.Platform=n={}));function s(T){switch(T){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let f=0;R?f=1:M?f=3:c&&(f=2),t.$i=M,t.$j=R,t.$k=c,t.$l=$,t.$m=g,t.$n=u,t.$o=a,t.$p=a&&typeof v.importScripts=="function",t.$q=t.$p?v.origin:void 0,t.$r=o,t.$s=d,t.$t=N,t.$u=f,t.$v=j,t.$w=e;var h;(function(T){function I(){return t.$w}T.value=I;function k(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}T.isDefaultVariant=k;function q(){return t.$w==="en"}T.isDefault=q})(h||(t.Language=h={})),t.$x=b,t.$y=m,t.$z=S,t.$A=typeof v.postMessage=="function"&&!v.importScripts,t.$B=(()=>{if(t.$A){const T=[];v.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let q=0,x=T.length;q<x;q++){const W=T[q];if(W.id===k.data.vscodeScheduleAsyncWork){T.splice(q,1),W.callback();return}}});let I=0;return k=>{const q=++I;T.push({id:q,callback:k}),v.postMessage({vscodeScheduleAsyncWork:q},"*")}}return T=>setTimeout(T)})();var L;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(L||(t.OperatingSystem=L={})),t.OS=R||o?2:M?1:3;let E=!0,A=!1;function y(){if(!A){A=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,E=new Uint16Array(T.buffer)[0]===513}return E}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function F(T){return parseFloat(T)>=20}}),ne(ie[70],se([0,1,18]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let M;const R=globalThis.vscode;if(typeof R<"u"&&typeof R.process<"u"){const c=R.process;M={get platform(){return c.platform},get arch(){return c.arch},get env(){return c.env},cwd(){return c.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=M.cwd,t.env=M.env,t.$dc=M.platform,t.$ec=M.arch}),ne(ie[71],se([0,1,70]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const M=65,R=97,c=90,$=122,g=46,a=47,u=92,o=58,N=63;class d extends Error{constructor(s,f,h){let L;typeof f=="string"&&f.indexOf("not ")===0?(L="must not be",f=f.replace(/^not /,"")):L="must be";const E=s.indexOf(".")!==-1?"property":"argument";let A=`The "${s}" ${E} ${L} of type ${f}`;A+=`. Received type ${typeof h}`,super(A),this.code="ERR_INVALID_ARG_TYPE"}}function b(n,s){if(n===null||typeof n!="object")throw new d(s,"Object",n)}function e(n,s){if(typeof n!="string")throw new d(s,"string",n)}const m=i.$dc==="win32";function S(n){return n===a||n===u}function j(n){return n===a}function v(n){return n>=M&&n<=c||n>=R&&n<=$}function w(n,s,f,h){let L="",E=0,A=-1,y=0,F=0;for(let T=0;T<=n.length;++T){if(T<n.length)F=n.charCodeAt(T);else{if(h(F))break;F=a}if(h(F)){if(!(A===T-1||y===1))if(y===2){if(L.length<2||E!==2||L.charCodeAt(L.length-1)!==g||L.charCodeAt(L.length-2)!==g){if(L.length>2){const I=L.lastIndexOf(f);I===-1?(L="",E=0):(L=L.slice(0,I),E=L.length-1-L.lastIndexOf(f)),A=T,y=0;continue}else if(L.length!==0){L="",E=0,A=T,y=0;continue}}s&&(L+=L.length>0?`${f}..`:"..",E=2)}else L.length>0?L+=`${f}${n.slice(A+1,T)}`:L=n.slice(A+1,T),E=T-A-1;A=T,y=0}else F===g&&y!==-1?++y:y=-1}return L}function p(n,s){b(s,"pathObject");const f=s.dir||s.root,h=s.base||`${s.name||""}${s.ext||""}`;return f?f===s.root?`${f}${h}`:`${f}${n}${h}`:h}t.$fc={resolve(...n){let s="",f="",h=!1;for(let L=n.length-1;L>=-1;L--){let E;if(L>=0){if(E=n[L],e(E,"path"),E.length===0)continue}else s.length===0?E=i.cwd():(E=i.env[`=${s}`]||i.cwd(),(E===void 0||E.slice(0,2).toLowerCase()!==s.toLowerCase()&&E.charCodeAt(2)===u)&&(E=`${s}\\`));const A=E.length;let y=0,F="",T=!1;const I=E.charCodeAt(0);if(A===1)S(I)&&(y=1,T=!0);else if(S(I))if(T=!0,S(E.charCodeAt(1))){let k=2,q=k;for(;k<A&&!S(E.charCodeAt(k));)k++;if(k<A&&k!==q){const x=E.slice(q,k);for(q=k;k<A&&S(E.charCodeAt(k));)k++;if(k<A&&k!==q){for(q=k;k<A&&!S(E.charCodeAt(k));)k++;(k===A||k!==q)&&(F=`\\\\${x}\\${E.slice(q,k)}`,y=k)}}}else y=1;else v(I)&&E.charCodeAt(1)===o&&(F=E.slice(0,2),y=2,A>2&&S(E.charCodeAt(2))&&(T=!0,y=3));if(F.length>0)if(s.length>0){if(F.toLowerCase()!==s.toLowerCase())continue}else s=F;if(h){if(s.length>0)break}else if(f=`${E.slice(y)}\\${f}`,h=T,T&&s.length>0)break}return f=w(f,!h,"\\",S),h?`${s}\\${f}`:`${s}${f}`||"."},normalize(n){e(n,"path");const s=n.length;if(s===0)return".";let f=0,h,L=!1;const E=n.charCodeAt(0);if(s===1)return j(E)?"\\":n;if(S(E))if(L=!0,S(n.charCodeAt(1))){let y=2,F=y;for(;y<s&&!S(n.charCodeAt(y));)y++;if(y<s&&y!==F){const T=n.slice(F,y);for(F=y;y<s&&S(n.charCodeAt(y));)y++;if(y<s&&y!==F){for(F=y;y<s&&!S(n.charCodeAt(y));)y++;if(y===s)return`\\\\${T}\\${n.slice(F)}\\`;y!==F&&(h=`\\\\${T}\\${n.slice(F,y)}`,f=y)}}}else f=1;else v(E)&&n.charCodeAt(1)===o&&(h=n.slice(0,2),f=2,s>2&&S(n.charCodeAt(2))&&(L=!0,f=3));let A=f<s?w(n.slice(f),!L,"\\",S):"";return A.length===0&&!L&&(A="."),A.length>0&&S(n.charCodeAt(s-1))&&(A+="\\"),h===void 0?L?`\\${A}`:A:L?`${h}\\${A}`:`${h}${A}`},isAbsolute(n){e(n,"path");const s=n.length;if(s===0)return!1;const f=n.charCodeAt(0);return S(f)||s>2&&v(f)&&n.charCodeAt(1)===o&&S(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,f;for(let E=0;E<n.length;++E){const A=n[E];e(A,"path"),A.length>0&&(s===void 0?s=f=A:s+=`\\${A}`)}if(s===void 0)return".";let h=!0,L=0;if(typeof f=="string"&&S(f.charCodeAt(0))){++L;const E=f.length;E>1&&S(f.charCodeAt(1))&&(++L,E>2&&(S(f.charCodeAt(2))?++L:h=!1))}if(h){for(;L<s.length&&S(s.charCodeAt(L));)L++;L>=2&&(s=`\\${s.slice(L)}`)}return t.$fc.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s)return"";const f=t.$fc.resolve(n),h=t.$fc.resolve(s);if(f===h||(n=f.toLowerCase(),s=h.toLowerCase(),n===s))return"";let L=0;for(;L<n.length&&n.charCodeAt(L)===u;)L++;let E=n.length;for(;E-1>L&&n.charCodeAt(E-1)===u;)E--;const A=E-L;let y=0;for(;y<s.length&&s.charCodeAt(y)===u;)y++;let F=s.length;for(;F-1>y&&s.charCodeAt(F-1)===u;)F--;const T=F-y,I=A<T?A:T;let k=-1,q=0;for(;q<I;q++){const W=n.charCodeAt(L+q);if(W!==s.charCodeAt(y+q))break;W===u&&(k=q)}if(q!==I){if(k===-1)return h}else{if(T>I){if(s.charCodeAt(y+q)===u)return h.slice(y+q+1);if(q===2)return h.slice(y+q)}A>I&&(n.charCodeAt(L+q)===u?k=q:q===2&&(k=3)),k===-1&&(k=0)}let x="";for(q=L+k+1;q<=E;++q)(q===E||n.charCodeAt(q)===u)&&(x+=x.length===0?"..":"\\..");return y+=k,x.length>0?`${x}${h.slice(y,F)}`:(h.charCodeAt(y)===u&&++y,h.slice(y,F))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=t.$fc.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===u){if(s.charCodeAt(1)===u){const f=s.charCodeAt(2);if(f!==N&&f!==g)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(v(s.charCodeAt(0))&&s.charCodeAt(1)===o&&s.charCodeAt(2)===u)return`\\\\?\\${s}`;return n},dirname(n){e(n,"path");const s=n.length;if(s===0)return".";let f=-1,h=0;const L=n.charCodeAt(0);if(s===1)return S(L)?n:".";if(S(L)){if(f=h=1,S(n.charCodeAt(1))){let y=2,F=y;for(;y<s&&!S(n.charCodeAt(y));)y++;if(y<s&&y!==F){for(F=y;y<s&&S(n.charCodeAt(y));)y++;if(y<s&&y!==F){for(F=y;y<s&&!S(n.charCodeAt(y));)y++;if(y===s)return n;y!==F&&(f=h=y+1)}}}}else v(L)&&n.charCodeAt(1)===o&&(f=s>2&&S(n.charCodeAt(2))?3:2,h=f);let E=-1,A=!0;for(let y=s-1;y>=h;--y)if(S(n.charCodeAt(y))){if(!A){E=y;break}}else A=!1;if(E===-1){if(f===-1)return".";E=f}return n.slice(0,E)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let f=0,h=-1,L=!0,E;if(n.length>=2&&v(n.charCodeAt(0))&&n.charCodeAt(1)===o&&(f=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let A=s.length-1,y=-1;for(E=n.length-1;E>=f;--E){const F=n.charCodeAt(E);if(S(F)){if(!L){f=E+1;break}}else y===-1&&(L=!1,y=E+1),A>=0&&(F===s.charCodeAt(A)?--A===-1&&(h=E):(A=-1,h=y))}return f===h?h=y:h===-1&&(h=n.length),n.slice(f,h)}for(E=n.length-1;E>=f;--E)if(S(n.charCodeAt(E))){if(!L){f=E+1;break}}else h===-1&&(L=!1,h=E+1);return h===-1?"":n.slice(f,h)},extname(n){e(n,"path");let s=0,f=-1,h=0,L=-1,E=!0,A=0;n.length>=2&&n.charCodeAt(1)===o&&v(n.charCodeAt(0))&&(s=h=2);for(let y=n.length-1;y>=s;--y){const F=n.charCodeAt(y);if(S(F)){if(!E){h=y+1;break}continue}L===-1&&(E=!1,L=y+1),F===g?f===-1?f=y:A!==1&&(A=1):f!==-1&&(A=-1)}return f===-1||L===-1||A===0||A===1&&f===L-1&&f===h+1?"":n.slice(f,L)},format:p.bind(null,"\\"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const f=n.length;let h=0,L=n.charCodeAt(0);if(f===1)return S(L)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(S(L)){if(h=1,S(n.charCodeAt(1))){let k=2,q=k;for(;k<f&&!S(n.charCodeAt(k));)k++;if(k<f&&k!==q){for(q=k;k<f&&S(n.charCodeAt(k));)k++;if(k<f&&k!==q){for(q=k;k<f&&!S(n.charCodeAt(k));)k++;k===f?h=k:k!==q&&(h=k+1)}}}}else if(v(L)&&n.charCodeAt(1)===o){if(f<=2)return s.root=s.dir=n,s;if(h=2,S(n.charCodeAt(2))){if(f===3)return s.root=s.dir=n,s;h=3}}h>0&&(s.root=n.slice(0,h));let E=-1,A=h,y=-1,F=!0,T=n.length-1,I=0;for(;T>=h;--T){if(L=n.charCodeAt(T),S(L)){if(!F){A=T+1;break}continue}y===-1&&(F=!1,y=T+1),L===g?E===-1?E=T:I!==1&&(I=1):E!==-1&&(I=-1)}return y!==-1&&(E===-1||I===0||I===1&&E===y-1&&E===A+1?s.base=s.name=n.slice(A,y):(s.name=n.slice(A,E),s.base=n.slice(A,y),s.ext=n.slice(E,y))),A>0&&A!==h?s.dir=n.slice(0,A-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(m){const n=/\\/g;return()=>{const s=i.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>i.cwd()})();t.$gc={resolve(...n){let s="",f=!1;for(let h=n.length-1;h>=-1&&!f;h--){const L=h>=0?n[h]:l();e(L,"path"),L.length!==0&&(s=`${L}/${s}`,f=L.charCodeAt(0)===a)}return s=w(s,!f,"/",j),f?`/${s}`:s.length>0?s:"."},normalize(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===a,f=n.charCodeAt(n.length-1)===a;return n=w(n,!s,"/",j),n.length===0?s?"/":f?"./":".":(f&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return e(n,"path"),n.length>0&&n.charCodeAt(0)===a},join(...n){if(n.length===0)return".";let s;for(let f=0;f<n.length;++f){const h=n[f];e(h,"path"),h.length>0&&(s===void 0?s=h:s+=`/${h}`)}return s===void 0?".":t.$gc.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s||(n=t.$gc.resolve(n),s=t.$gc.resolve(s),n===s))return"";const f=1,h=n.length,L=h-f,E=1,A=s.length-E,y=L<A?L:A;let F=-1,T=0;for(;T<y;T++){const k=n.charCodeAt(f+T);if(k!==s.charCodeAt(E+T))break;k===a&&(F=T)}if(T===y)if(A>y){if(s.charCodeAt(E+T)===a)return s.slice(E+T+1);if(T===0)return s.slice(E+T)}else L>y&&(n.charCodeAt(f+T)===a?F=T:T===0&&(F=0));let I="";for(T=f+F+1;T<=h;++T)(T===h||n.charCodeAt(T)===a)&&(I+=I.length===0?"..":"/..");return`${I}${s.slice(E+F)}`},toNamespacedPath(n){return n},dirname(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===a;let f=-1,h=!0;for(let L=n.length-1;L>=1;--L)if(n.charCodeAt(L)===a){if(!h){f=L;break}}else h=!1;return f===-1?s?"/":".":s&&f===1?"//":n.slice(0,f)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let f=0,h=-1,L=!0,E;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let A=s.length-1,y=-1;for(E=n.length-1;E>=0;--E){const F=n.charCodeAt(E);if(F===a){if(!L){f=E+1;break}}else y===-1&&(L=!1,y=E+1),A>=0&&(F===s.charCodeAt(A)?--A===-1&&(h=E):(A=-1,h=y))}return f===h?h=y:h===-1&&(h=n.length),n.slice(f,h)}for(E=n.length-1;E>=0;--E)if(n.charCodeAt(E)===a){if(!L){f=E+1;break}}else h===-1&&(L=!1,h=E+1);return h===-1?"":n.slice(f,h)},extname(n){e(n,"path");let s=-1,f=0,h=-1,L=!0,E=0;for(let A=n.length-1;A>=0;--A){const y=n.charCodeAt(A);if(y===a){if(!L){f=A+1;break}continue}h===-1&&(L=!1,h=A+1),y===g?s===-1?s=A:E!==1&&(E=1):s!==-1&&(E=-1)}return s===-1||h===-1||E===0||E===1&&s===h-1&&s===f+1?"":n.slice(s,h)},format:p.bind(null,"/"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const f=n.charCodeAt(0)===a;let h;f?(s.root="/",h=1):h=0;let L=-1,E=0,A=-1,y=!0,F=n.length-1,T=0;for(;F>=h;--F){const I=n.charCodeAt(F);if(I===a){if(!y){E=F+1;break}continue}A===-1&&(y=!1,A=F+1),I===g?L===-1?L=F:T!==1&&(T=1):L!==-1&&(T=-1)}if(A!==-1){const I=E===0&&f?1:E;L===-1||T===0||T===1&&L===A-1&&L===E+1?s.base=s.name=n.slice(I,A):(s.name=n.slice(I,L),s.base=n.slice(I,A),s.ext=n.slice(L,A))}return E>0?s.dir=n.slice(0,E-1):f&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=m?t.$fc.normalize:t.$gc.normalize,t.$ic=m?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=m?t.$fc.join:t.$gc.join,t.$kc=m?t.$fc.resolve:t.$gc.resolve,t.$lc=m?t.$fc.relative:t.$gc.relative,t.$mc=m?t.$fc.dirname:t.$gc.dirname,t.$nc=m?t.$fc.basename:t.$gc.basename,t.$oc=m?t.$fc.extname:t.$gc.extname,t.$pc=m?t.$fc.format:t.$gc.format,t.$qc=m?t.$fc.parse:t.$gc.parse,t.$rc=m?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=m?t.$fc.sep:t.$gc.sep,t.$tc=m?t.$fc.delimiter:t.$gc.delimiter}),ne(ie[19],se([0,1,71,18]),function(C,t,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$vc=e,t.$wc=p;const R=/^\w[\w\d+.-]*$/,c=/^\//,$=/^\/\//;function g(h,L){if(!h.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!R.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!c.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if($.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(h,L){return!h&&!L?"file":h}function u(h,L){switch(h){case"https":case"http":case"file":L?L[0]!==N&&(L=N+L):L=N;break}return L}const o="",N="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{static isUri(L){return L instanceof b?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,E,A,y,F,T=!1){typeof L=="object"?(this.scheme=L.scheme||o,this.authority=L.authority||o,this.path=L.path||o,this.query=L.query||o,this.fragment=L.fragment||o):(this.scheme=a(L,T),this.authority=E||o,this.path=u(this.scheme,A||o),this.query=y||o,this.fragment=F||o,g(this,T))}get fsPath(){return p(this,!1)}with(L){if(!L)return this;let{scheme:E,authority:A,path:y,query:F,fragment:T}=L;return E===void 0?E=this.scheme:E===null&&(E=o),A===void 0?A=this.authority:A===null&&(A=o),y===void 0?y=this.path:y===null&&(y=o),F===void 0?F=this.query:F===null&&(F=o),T===void 0?T=this.fragment:T===null&&(T=o),E===this.scheme&&A===this.authority&&y===this.path&&F===this.query&&T===this.fragment?this:new S(E,A,y,F,T)}static parse(L,E=!1){const A=d.exec(L);return A?new S(A[2]||o,f(A[4]||o),f(A[5]||o),f(A[7]||o),f(A[9]||o),E):new S(o,o,o,o,o)}static file(L){let E=o;if(M.$i&&(L=L.replace(/\\/g,N)),L[0]===N&&L[1]===N){const A=L.indexOf(N,2);A===-1?(E=L.substring(2),L=N):(E=L.substring(2,A),L=L.substring(A)||N)}return new S("file",E,L,o,o)}static from(L,E){return new S(L.scheme,L.authority,L.path,L.query,L.fragment,E)}static joinPath(L,...E){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let A;return M.$i&&L.scheme==="file"?A=b.file(i.$fc.join(p(L,!0),...E)).path:A=i.$gc.join(L.path,...E),L.with({path:A})}toString(L=!1){return l(this,L)}toJSON(){return this}static revive(L){if(L){if(L instanceof b)return L;{const E=new S(L);return E._formatted=L.external??null,E._fsPath=L._sep===m?L.fsPath??null:null,E}}else return L}}t.URI=b;function e(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}const m=M.$i?1:void 0;class S extends b{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(L=!1){return L?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const L={$mid:1};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=m),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const j={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function v(h,L,E){let A,y=-1;for(let F=0;F<h.length;F++){const T=h.charCodeAt(F);if(T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57||T===45||T===46||T===95||T===126||L&&T===47||E&&T===91||E&&T===93||E&&T===58)y!==-1&&(A+=encodeURIComponent(h.substring(y,F)),y=-1),A!==void 0&&(A+=h.charAt(F));else{A===void 0&&(A=h.substr(0,F));const I=j[T];I!==void 0?(y!==-1&&(A+=encodeURIComponent(h.substring(y,F)),y=-1),A+=I):y===-1&&(y=F)}}return y!==-1&&(A+=encodeURIComponent(h.substring(y))),A!==void 0?A:h}function w(h){let L;for(let E=0;E<h.length;E++){const A=h.charCodeAt(E);A===35||A===63?(L===void 0&&(L=h.substr(0,E)),L+=j[A]):L!==void 0&&(L+=h[E])}return L!==void 0?L:h}function p(h,L){let E;return h.authority&&h.path.length>1&&h.scheme==="file"?E=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===47&&(h.path.charCodeAt(1)>=65&&h.path.charCodeAt(1)<=90||h.path.charCodeAt(1)>=97&&h.path.charCodeAt(1)<=122)&&h.path.charCodeAt(2)===58?L?E=h.path.substr(1):E=h.path[1].toLowerCase()+h.path.substr(2):E=h.path,M.$i&&(E=E.replace(/\//g,"\\")),E}function l(h,L){const E=L?w:v;let A="",{scheme:y,authority:F,path:T,query:I,fragment:k}=h;if(y&&(A+=y,A+=":"),(F||y==="file")&&(A+=N,A+=N),F){let q=F.indexOf("@");if(q!==-1){const x=F.substr(0,q);F=F.substr(q+1),q=x.lastIndexOf(":"),q===-1?A+=E(x,!1,!1):(A+=E(x.substr(0,q),!1,!1),A+=":",A+=E(x.substr(q+1),!1,!0)),A+="@"}F=F.toLowerCase(),q=F.lastIndexOf(":"),q===-1?A+=E(F,!1,!0):(A+=E(F.substr(0,q),!1,!0),A+=F.substr(q))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const q=T.charCodeAt(1);q>=65&&q<=90&&(T=`/${String.fromCharCode(q+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const q=T.charCodeAt(0);q>=65&&q<=90&&(T=`${String.fromCharCode(q+32)}:${T.substr(2)}`)}A+=E(T,!0,!1)}return I&&(A+="?",A+=E(I,!1,!1)),k&&(A+="#",A+=L?k:v(k,!1,!1)),A}function n(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+n(h.substr(3)):h}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function f(h){return h.match(s)?h.replace(s,L=>n(L)):h}}),ne(ie[76],se([0,1,3,12,11,15,18,7]),function(C,t,i,M,R,c,$,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SimpleWorkerServer=t.SimpleWorkerClient=void 0,t.logOnceWebWorkerWarning=o,t.create=s;const a="$initialize";let u=!1;function o(f){$.$o&&(u||(u=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(f.message))}var N;(function(f){f[f.Request=0]="Request",f[f.Reply=1]="Reply",f[f.SubscribeEvent=2]="SubscribeEvent",f[f.Event=3]="Event",f[f.UnsubscribeEvent=4]="UnsubscribeEvent"})(N||(N={}));class d{constructor(h,L,E,A){this.vsWorker=h,this.req=L,this.method=E,this.args=A,this.type=0}}class b{constructor(h,L,E,A){this.vsWorker=h,this.seq=L,this.res=E,this.err=A,this.type=1}}class e{constructor(h,L,E,A){this.vsWorker=h,this.req=L,this.eventName=E,this.arg=A,this.type=2}}class m{constructor(h,L,E){this.vsWorker=h,this.req=L,this.event=E,this.type=3}}class S{constructor(h,L){this.vsWorker=h,this.req=L,this.type=4}}class j{constructor(h){this.a=-1,this.g=h,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(h){this.a=h}sendMessage(h,L){const E=String(++this.b);return new Promise((A,y)=>{this.c[E]={resolve:A,reject:y},this.o(new d(this.a,E,h,L))})}listen(h,L){let E=null;const A=new M.$fe({onWillAddFirstListener:()=>{E=String(++this.b),this.d.set(E,A),this.o(new e(this.a,E,h,L))},onDidRemoveLastListener:()=>{this.d.delete(E),this.o(new S(this.a,E)),E=null}});return A.event}handleMessage(h){!h||!h.vsWorker||this.a!==-1&&h.vsWorker!==this.a||this.h(h)}h(h){switch(h.type){case 1:return this.j(h);case 0:return this.k(h);case 2:return this.l(h);case 3:return this.m(h);case 4:return this.n(h)}}j(h){if(!this.c[h.seq]){console.warn("Got reply to unknown seq");return}const L=this.c[h.seq];if(delete this.c[h.seq],h.err){let E=h.err;h.err.$isError&&(E=new Error,E.name=h.err.name,E.message=h.err.message,E.stack=h.err.stack),L.reject(E);return}L.resolve(h.res)}k(h){const L=h.req;this.g.handleMessage(h.method,h.args).then(A=>{this.o(new b(this.a,L,A,void 0))},A=>{A.detail instanceof Error&&(A.detail=(0,i.$3)(A.detail)),this.o(new b(this.a,L,void 0,(0,i.$3)(A)))})}l(h){const L=h.req,E=this.g.handleEvent(h.eventName,h.arg)(A=>{this.o(new m(this.a,L,A))});this.f.set(L,E)}m(h){if(!this.d.has(h.req)){console.warn("Got event for unknown req");return}this.d.get(h.req).fire(h.event)}n(h){if(!this.f.has(h.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(h.req).dispose(),this.f.delete(h.req)}o(h){const L=[];if(h.type===0)for(let E=0;E<h.args.length;E++)h.args[E]instanceof ArrayBuffer&&L.push(h.args[E]);else h.type===1&&h.res instanceof ArrayBuffer&&L.push(h.res);this.g.sendMessage(h,L)}}class v extends R.$Uc{constructor(h,L,E){super();let A=null;this.a=this.B(h.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{A?.(q)})),this.c=new j({sendMessage:(q,x)=>{this.a.postMessage(q,x)},handleMessage:(q,x)=>{if(typeof E[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(E[q].apply(E,x))}catch(W){return Promise.reject(W)}},handleEvent:(q,x)=>{if(p(q)){const W=E[q].call(E,x);if(typeof W!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return W}if(w(q)){const W=E[q];if(typeof W!="function")throw new Error(`Missing event ${q} on main thread host.`);return W}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let y=null;const F=globalThis.require;typeof F<"u"&&typeof F.getConfig=="function"?y=F.getConfig():typeof globalThis.requirejs<"u"&&(y=globalThis.requirejs.s.contexts._.config);const T=(0,c.$co)(E);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(y)),L,T]);const I=(q,x)=>this.g(q,x),k=(q,x)=>this.c.listen(q,x);this.f=new Promise((q,x)=>{A=x,this.b.then(W=>{q(l(W,I,k))},W=>{x(W),this.h("Worker failed to load "+L,W)})})}getProxyObject(){return this.f}g(h,L){return new Promise((E,A)=>{this.b.then(()=>{this.c.sendMessage(h,L).then(E,A)},A)})}h(h,L){console.error(h),console.info(L)}}t.SimpleWorkerClient=v;function w(f){return f[0]==="o"&&f[1]==="n"&&g.$yf(f.charCodeAt(2))}function p(f){return/^onDynamic/.test(f)&&g.$yf(f.charCodeAt(9))}function l(f,h,L){const E=F=>function(){const T=Array.prototype.slice.call(arguments,0);return h(F,T)},A=F=>function(T){return L(F,T)},y={};for(const F of f){if(p(F)){y[F]=A(F);continue}if(w(F)){y[F]=L(F,void 0);continue}y[F]=E(F)}return y}class n{constructor(h,L){this.a=L,this.b=null,this.c=new j({sendMessage:(E,A)=>{h(E,A)},handleMessage:(E,A)=>this.d(E,A),handleEvent:(E,A)=>this.f(E,A)})}onmessage(h){this.c.handleMessage(h)}d(h,L){if(h===a)return this.g(L[0],L[1],L[2],L[3]);if(!this.b||typeof this.b[h]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+h));try{return Promise.resolve(this.b[h].apply(this.b,L))}catch(E){return Promise.reject(E)}}f(h,L){if(!this.b)throw new Error("Missing requestHandler");if(p(h)){const E=this.b[h].call(this.b,L);if(typeof E!="function")throw new Error(`Missing dynamic event ${h} on request handler.`);return E}if(w(h)){const E=this.b[h];if(typeof E!="function")throw new Error(`Missing event ${h} on request handler.`);return E}throw new Error(`Malformed event name ${h}`)}g(h,L,E,A){this.c.setWorkerId(h);const T=l(A,(I,k)=>this.c.sendMessage(I,k),(I,k)=>this.c.listen(I,k));return this.a?(this.b=this.a(T),Promise.resolve((0,c.$co)(this.b))):(L&&(typeof L.baseUrl<"u"&&delete L.baseUrl,typeof L.paths<"u"&&typeof L.paths.vs<"u"&&delete L.paths.vs,typeof L.trustedTypesPolicy<"u"&&delete L.trustedTypesPolicy,L.catchError=!0,globalThis.require.config(L)),new Promise((I,k)=>{(globalThis.require||C)([E],x=>{if(this.b=x.create(T),!this.b){k(new Error("No RequestHandler!"));return}I((0,c.$co)(this.b))},k)}))}}t.SimpleWorkerServer=n;function s(f){return new n(f,null)}}),ne(ie[72],se([68,69]),function(C,t){return C.create("vs/editor/common/languages",t)}),ne(ie[73],se([0,1,44,19,45,2,66,72]),function(C,t,i,M,R,c,$,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineEditTriggerKind=t.ExternalUriOpenerPriority=t.$iu=t.$hu=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadApplicability=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.NewSymbolNameTriggerKind=t.NewSymbolNameTag=t.$gu=t.$fu=t.SymbolKinds=t.SymbolTag=t.$du=t.SymbolKind=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.DocumentPasteTriggerKind=t.CodeActionTriggerType=t.$bu=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.PartialAcceptTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.HoverVerbosityAction=t.$au=t.$_t=t.$$t=void 0,t.$cu=f,t.$eu=L;class a{constructor(Z,de,fe){this.offset=Z,this.type=de,this.language=fe,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$$t=a;class u{constructor(Z,de){this.tokens=Z,this.endState=de,this._tokenizationResultBrand=void 0}}t.$_t=u;class o{constructor(Z,de){this.tokens=Z,this.endState=de,this._encodedTokenizationResultBrand=void 0}}t.$au=o;var N;(function(P){P[P.Increase=0]="Increase",P[P.Decrease=1]="Decrease"})(N||(t.HoverVerbosityAction=N={}));var d;(function(P){P[P.Method=0]="Method",P[P.Function=1]="Function",P[P.Constructor=2]="Constructor",P[P.Field=3]="Field",P[P.Variable=4]="Variable",P[P.Class=5]="Class",P[P.Struct=6]="Struct",P[P.Interface=7]="Interface",P[P.Module=8]="Module",P[P.Property=9]="Property",P[P.Event=10]="Event",P[P.Operator=11]="Operator",P[P.Unit=12]="Unit",P[P.Value=13]="Value",P[P.Constant=14]="Constant",P[P.Enum=15]="Enum",P[P.EnumMember=16]="EnumMember",P[P.Keyword=17]="Keyword",P[P.Text=18]="Text",P[P.Color=19]="Color",P[P.File=20]="File",P[P.Reference=21]="Reference",P[P.Customcolor=22]="Customcolor",P[P.Folder=23]="Folder",P[P.TypeParameter=24]="TypeParameter",P[P.User=25]="User",P[P.Issue=26]="Issue",P[P.Snippet=27]="Snippet"})(d||(t.CompletionItemKind=d={}));var b;(function(P){const Z=new Map;Z.set(0,i.$Xj.symbolMethod),Z.set(1,i.$Xj.symbolFunction),Z.set(2,i.$Xj.symbolConstructor),Z.set(3,i.$Xj.symbolField),Z.set(4,i.$Xj.symbolVariable),Z.set(5,i.$Xj.symbolClass),Z.set(6,i.$Xj.symbolStruct),Z.set(7,i.$Xj.symbolInterface),Z.set(8,i.$Xj.symbolModule),Z.set(9,i.$Xj.symbolProperty),Z.set(10,i.$Xj.symbolEvent),Z.set(11,i.$Xj.symbolOperator),Z.set(12,i.$Xj.symbolUnit),Z.set(13,i.$Xj.symbolValue),Z.set(15,i.$Xj.symbolEnum),Z.set(14,i.$Xj.symbolConstant),Z.set(15,i.$Xj.symbolEnum),Z.set(16,i.$Xj.symbolEnumMember),Z.set(17,i.$Xj.symbolKeyword),Z.set(27,i.$Xj.symbolSnippet),Z.set(18,i.$Xj.symbolText),Z.set(19,i.$Xj.symbolColor),Z.set(20,i.$Xj.symbolFile),Z.set(21,i.$Xj.symbolReference),Z.set(22,i.$Xj.symbolCustomColor),Z.set(23,i.$Xj.symbolFolder),Z.set(24,i.$Xj.symbolTypeParameter),Z.set(25,i.$Xj.account),Z.set(26,i.$Xj.issues);function de(r){let je=Z.get(r);return je||(console.info("No codicon found for CompletionItemKind "+r),je=i.$Xj.symbolProperty),je}P.toIcon=de;const fe=new Map;fe.set("method",0),fe.set("function",1),fe.set("constructor",2),fe.set("field",3),fe.set("variable",4),fe.set("class",5),fe.set("struct",6),fe.set("interface",7),fe.set("module",8),fe.set("property",9),fe.set("event",10),fe.set("operator",11),fe.set("unit",12),fe.set("value",13),fe.set("constant",14),fe.set("enum",15),fe.set("enum-member",16),fe.set("enumMember",16),fe.set("keyword",17),fe.set("snippet",27),fe.set("text",18),fe.set("color",19),fe.set("file",20),fe.set("reference",21),fe.set("customcolor",22),fe.set("folder",23),fe.set("type-parameter",24),fe.set("typeParameter",24),fe.set("account",25),fe.set("issue",26);function ve(r,je){let Ae=fe.get(r);return typeof Ae>"u"&&!je&&(Ae=9),Ae}P.fromString=ve})(b||(t.CompletionItemKinds=b={}));var e;(function(P){P[P.Deprecated=1]="Deprecated"})(e||(t.CompletionItemTag=e={}));var m;(function(P){P[P.None=0]="None",P[P.KeepWhitespace=1]="KeepWhitespace",P[P.InsertAsSnippet=4]="InsertAsSnippet"})(m||(t.CompletionItemInsertTextRule=m={}));var S;(function(P){P[P.Word=0]="Word",P[P.Line=1]="Line",P[P.Suggest=2]="Suggest"})(S||(t.PartialAcceptTriggerKind=S={}));var j;(function(P){P[P.Invoke=0]="Invoke",P[P.TriggerCharacter=1]="TriggerCharacter",P[P.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(j||(t.CompletionTriggerKind=j={}));var v;(function(P){P[P.Automatic=0]="Automatic",P[P.Explicit=1]="Explicit"})(v||(t.InlineCompletionTriggerKind=v={}));class w{constructor(Z,de,fe,ve){this.range=Z,this.text=de,this.completionKind=fe,this.isSnippetText=ve}equals(Z){return c.$xt.lift(this.range).equalsRange(Z.range)&&this.text===Z.text&&this.completionKind===Z.completionKind&&this.isSnippetText===Z.isSnippetText}}t.$bu=w;var p;(function(P){P[P.Invoke=1]="Invoke",P[P.Auto=2]="Auto"})(p||(t.CodeActionTriggerType=p={}));var l;(function(P){P[P.Automatic=0]="Automatic",P[P.PasteAs=1]="PasteAs"})(l||(t.DocumentPasteTriggerKind=l={}));var n;(function(P){P[P.Invoke=1]="Invoke",P[P.TriggerCharacter=2]="TriggerCharacter",P[P.ContentChange=3]="ContentChange"})(n||(t.SignatureHelpTriggerKind=n={}));var s;(function(P){P[P.Text=0]="Text",P[P.Read=1]="Read",P[P.Write=2]="Write"})(s||(t.DocumentHighlightKind=s={}));function f(P){return P&&M.URI.isUri(P.uri)&&c.$xt.isIRange(P.range)&&(c.$xt.isIRange(P.originSelectionRange)||c.$xt.isIRange(P.targetSelectionRange))}var h;(function(P){P[P.File=0]="File",P[P.Module=1]="Module",P[P.Namespace=2]="Namespace",P[P.Package=3]="Package",P[P.Class=4]="Class",P[P.Method=5]="Method",P[P.Property=6]="Property",P[P.Field=7]="Field",P[P.Constructor=8]="Constructor",P[P.Enum=9]="Enum",P[P.Interface=10]="Interface",P[P.Function=11]="Function",P[P.Variable=12]="Variable",P[P.Constant=13]="Constant",P[P.String=14]="String",P[P.Number=15]="Number",P[P.Boolean=16]="Boolean",P[P.Array=17]="Array",P[P.Object=18]="Object",P[P.Key=19]="Key",P[P.Null=20]="Null",P[P.EnumMember=21]="EnumMember",P[P.Struct=22]="Struct",P[P.Event=23]="Event",P[P.Operator=24]="Operator",P[P.TypeParameter=25]="TypeParameter"})(h||(t.SymbolKind=h={})),t.$du={17:(0,g.localize)(0,null),16:(0,g.localize)(1,null),4:(0,g.localize)(2,null),13:(0,g.localize)(3,null),8:(0,g.localize)(4,null),9:(0,g.localize)(5,null),21:(0,g.localize)(6,null),23:(0,g.localize)(7,null),7:(0,g.localize)(8,null),0:(0,g.localize)(9,null),11:(0,g.localize)(10,null),10:(0,g.localize)(11,null),19:(0,g.localize)(12,null),5:(0,g.localize)(13,null),1:(0,g.localize)(14,null),2:(0,g.localize)(15,null),20:(0,g.localize)(16,null),15:(0,g.localize)(17,null),18:(0,g.localize)(18,null),24:(0,g.localize)(19,null),3:(0,g.localize)(20,null),6:(0,g.localize)(21,null),14:(0,g.localize)(22,null),22:(0,g.localize)(23,null),25:(0,g.localize)(24,null),12:(0,g.localize)(25,null)};function L(P,Z){return(0,g.localize)(26,null,P,t.$du[Z])}var E;(function(P){P[P.Deprecated=1]="Deprecated"})(E||(t.SymbolTag=E={}));var A;(function(P){const Z=new Map;Z.set(0,i.$Xj.symbolFile),Z.set(1,i.$Xj.symbolModule),Z.set(2,i.$Xj.symbolNamespace),Z.set(3,i.$Xj.symbolPackage),Z.set(4,i.$Xj.symbolClass),Z.set(5,i.$Xj.symbolMethod),Z.set(6,i.$Xj.symbolProperty),Z.set(7,i.$Xj.symbolField),Z.set(8,i.$Xj.symbolConstructor),Z.set(9,i.$Xj.symbolEnum),Z.set(10,i.$Xj.symbolInterface),Z.set(11,i.$Xj.symbolFunction),Z.set(12,i.$Xj.symbolVariable),Z.set(13,i.$Xj.symbolConstant),Z.set(14,i.$Xj.symbolString),Z.set(15,i.$Xj.symbolNumber),Z.set(16,i.$Xj.symbolBoolean),Z.set(17,i.$Xj.symbolArray),Z.set(18,i.$Xj.symbolObject),Z.set(19,i.$Xj.symbolKey),Z.set(20,i.$Xj.symbolNull),Z.set(21,i.$Xj.symbolEnumMember),Z.set(22,i.$Xj.symbolStruct),Z.set(23,i.$Xj.symbolEvent),Z.set(24,i.$Xj.symbolOperator),Z.set(25,i.$Xj.symbolTypeParameter);function de(fe){let ve=Z.get(fe);return ve||(console.info("No codicon found for SymbolKind "+fe),ve=i.$Xj.symbolProperty),ve}P.toIcon=de})(A||(t.SymbolKinds=A={}));class y{static asEditOperation(Z){return R.$yt.replace(c.$xt.lift(Z.range),Z.text)}}t.$fu=y;class F{static{this.Comment=new F("comment")}static{this.Imports=new F("imports")}static{this.Region=new F("region")}static fromValue(Z){switch(Z){case"comment":return F.Comment;case"imports":return F.Imports;case"region":return F.Region}return new F(Z)}constructor(Z){this.value=Z}}t.$gu=F;var T;(function(P){P[P.AIGenerated=1]="AIGenerated"})(T||(t.NewSymbolNameTag=T={}));var I;(function(P){P[P.Invoke=0]="Invoke",P[P.Automatic=1]="Automatic"})(I||(t.NewSymbolNameTriggerKind=I={}));var k;(function(P){function Z(de){return!de||typeof de!="object"?!1:typeof de.id=="string"&&typeof de.title=="string"}P.is=Z})(k||(t.Command=k={}));var q;(function(P){P[P.Collapsed=0]="Collapsed",P[P.Expanded=1]="Expanded"})(q||(t.CommentThreadCollapsibleState=q={}));var x;(function(P){P[P.Unresolved=0]="Unresolved",P[P.Resolved=1]="Resolved"})(x||(t.CommentThreadState=x={}));var W;(function(P){P[P.Current=0]="Current",P[P.Outdated=1]="Outdated"})(W||(t.CommentThreadApplicability=W={}));var Q;(function(P){P[P.Editing=0]="Editing",P[P.Preview=1]="Preview"})(Q||(t.CommentMode=Q={}));var Y;(function(P){P[P.Published=0]="Published",P[P.Draft=1]="Draft"})(Y||(t.CommentState=Y={}));var X;(function(P){P[P.Type=1]="Type",P[P.Parameter=2]="Parameter"})(X||(t.InlayHintKind=X={}));class G{constructor(Z){this.b=Z,this.a=null}dispose(){this.a&&this.a.then(Z=>{Z&&Z.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$hu=G,t.$iu=new $.$3t;var U;(function(P){P[P.None=0]="None",P[P.Option=1]="Option",P[P.Default=2]="Default",P[P.Preferred=3]="Preferred"})(U||(t.ExternalUriOpenerPriority=U={}));var K;(function(P){P[P.Invoke=0]="Invoke",P[P.Automatic=1]="Automatic"})(K||(t.InlineEditTriggerKind=K={}))}),ne(ie[74],se([0,1,24,12,39,19,4,2,46,73,65]),function(C,t,i,M,R,c,$,g,a,u,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N2=void 0,t.$O2=d;class N{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,m){return(0,R.$Hr)(e,m)}}t.$N2=N;function d(){return{editor:void 0,languages:void 0,CancellationTokenSource:i.$qe,Emitter:M.$fe,KeyCode:o.KeyCode,KeyMod:N,Position:$.$wt,Range:g.$xt,Selection:a.$zt,SelectionDirection:o.SelectionDirection,MarkerSeverity:o.MarkerSeverity,MarkerTag:o.MarkerTag,Uri:c.URI,Token:u.$$t}}}),ne(ie[77],se([0,1,25,19,4,2,61,31,57,58,74,23,64,35,55,15,3,56,63]),function(C,t,i,M,R,c,$,g,a,u,o,N,d,b,e,m,S,j,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorSimpleWorker=void 0,t.create=l;class w extends $.$9v{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(s){const f=[];for(let h=0;h<this.f.length;h++){const L=this.f[h],E=this.offsetAt(new R.$wt(h+1,1)),A=L.matchAll(s);for(const y of A)(y.index||y.index===0)&&(y.index=y.index+E),f.push(y)}return f}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(s){return this.f[s-1]}getWordAtPosition(s,f){const h=(0,g.$_s)(s.column,(0,g.$0s)(f),this.f[s.lineNumber-1],0);return h?new c.$xt(s.lineNumber,h.startColumn,s.lineNumber,h.endColumn):null}getWordUntilPosition(s,f){const h=this.getWordAtPosition(s,f);return h?{word:this.f[s.lineNumber-1].substring(h.startColumn-1,s.column-1),startColumn:h.startColumn,endColumn:s.column}:{word:"",startColumn:s.column,endColumn:s.column}}words(s){const f=this.f,h=this.q.bind(this);let L=0,E="",A=0,y=[];return{*[Symbol.iterator](){for(;;)if(A<y.length){const F=E.substring(y[A].start,y[A].end);A+=1,yield F}else if(L<f.length)E=f[L],y=h(E,s),A=0,L+=1;else break}}}getLineWords(s,f){const h=this.f[s-1],L=this.q(h,f),E=[];for(const A of L)E.push({word:h.substring(A.start,A.end),startColumn:A.start+1,endColumn:A.end+1});return E}q(s,f){const h=[];let L;for(f.lastIndex=0;(L=f.exec(s))&&L[0].length!==0;)h.push({start:L.index,end:L.index+L[0].length});return h}getValueInRange(s){if(s=this.r(s),s.startLineNumber===s.endLineNumber)return this.f[s.startLineNumber-1].substring(s.startColumn-1,s.endColumn-1);const f=this.g,h=s.startLineNumber-1,L=s.endLineNumber-1,E=[];E.push(this.f[h].substring(s.startColumn-1));for(let A=h+1;A<L;A++)E.push(this.f[A]);return E.push(this.f[L].substring(0,s.endColumn-1)),E.join(f)}offsetAt(s){return s=this.s(s),this.l(),this.j.getPrefixSum(s.lineNumber-2)+(s.column-1)}positionAt(s){s=Math.floor(s),s=Math.max(0,s),this.l();const f=this.j.getIndexOf(s),h=this.f[f.index].length;return{lineNumber:1+f.index,column:1+Math.min(f.remainder,h)}}r(s){const f=this.s({lineNumber:s.startLineNumber,column:s.startColumn}),h=this.s({lineNumber:s.endLineNumber,column:s.endColumn});return f.lineNumber!==s.startLineNumber||f.column!==s.startColumn||h.lineNumber!==s.endLineNumber||h.column!==s.endColumn?{startLineNumber:f.lineNumber,startColumn:f.column,endLineNumber:h.lineNumber,endColumn:h.column}:s}s(s){if(!R.$wt.isIPosition(s))throw new Error("bad position");let{lineNumber:f,column:h}=s,L=!1;if(f<1)f=1,h=1,L=!0;else if(f>this.f.length)f=this.f.length,h=this.f[f-1].length+1,L=!0;else{const E=this.f[f-1].length+1;h<1?(h=1,L=!0):h>E&&(h=E,L=!0)}return L?{lineNumber:f,column:h}:s}}class p{constructor(s,f){this.d=s,this.f=Object.create(null),this.g=f,this.h=null}dispose(){this.f=Object.create(null)}j(s){return this.f[s]}k(){const s=[];return Object.keys(this.f).forEach(f=>s.push(this.f[f])),s}acceptNewModel(s){this.f[s.url]=new w(M.URI.parse(s.url),s.lines,s.EOL,s.versionId)}acceptModelChanged(s,f){if(!this.f[s])return;this.f[s].onEvents(f)}acceptRemovedModel(s){this.f[s]&&delete this.f[s]}async computeUnicodeHighlights(s,f,h){const L=this.j(s);return L?d.$I2.computeUnicodeHighlights(L,f,h):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async findSectionHeaders(s,f){const h=this.j(s);return h?(0,v.$a3)(h,f):[]}async computeDiff(s,f,h,L){const E=this.j(s),A=this.j(f);return!E||!A?null:p.l(E,A,h,L)}static l(s,f,h,L){const E=L==="advanced"?e.$$2.getDefault():e.$$2.getLegacy(),A=s.getLinesContent(),y=f.getLinesContent(),F=E.computeDiff(A,y,h),T=F.changes.length>0?!1:this.n(s,f);function I(k){return k.map(q=>[q.original.startLineNumber,q.original.endLineNumberExclusive,q.modified.startLineNumber,q.modified.endLineNumberExclusive,q.innerChanges?.map(x=>[x.originalRange.startLineNumber,x.originalRange.startColumn,x.originalRange.endLineNumber,x.originalRange.endColumn,x.modifiedRange.startLineNumber,x.modifiedRange.startColumn,x.modifiedRange.endLineNumber,x.modifiedRange.endColumn])])}return{identical:T,quitEarly:F.hitTimeout,changes:I(F.changes),moves:F.moves.map(k=>[k.lineRangeMapping.original.startLineNumber,k.lineRangeMapping.original.endLineNumberExclusive,k.lineRangeMapping.modified.startLineNumber,k.lineRangeMapping.modified.endLineNumberExclusive,I(k.changes)])}}static n(s,f){const h=s.getLineCount(),L=f.getLineCount();if(h!==L)return!1;for(let E=1;E<=h;E++){const A=s.getLineContent(E),y=f.getLineContent(E);if(A!==y)return!1}return!0}async computeDirtyDiff(s,f,h){const L=this.j(s),E=this.j(f);if(!L||!E)return null;const A=L.getLinesContent(),y=E.getLinesContent();return new b.$3v(A,y,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:h,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(s,f,h){const L=this.j(s);if(!L)return f;const E=[];let A;f=f.slice(0).sort((F,T)=>{if(F.range&&T.range)return c.$xt.compareRangesUsingStarts(F.range,T.range);const I=F.range?0:1,k=T.range?0:1;return I-k});let y=0;for(let F=1;F<f.length;F++)c.$xt.getEndPosition(f[y].range).equals(c.$xt.getStartPosition(f[F].range))?(f[y].range=c.$xt.fromPositions(c.$xt.getStartPosition(f[y].range),c.$xt.getEndPosition(f[F].range)),f[y].text+=f[F].text):(y++,f[y]=f[F]);f.length=y+1;for(let{range:F,text:T,eol:I}of f){if(typeof I=="number"&&(A=I),c.$xt.isEmpty(F)&&!T)continue;const k=L.getValueInRange(F);if(T=T.replace(/\r\n|\n|\r/g,L.eol),k===T)continue;if(Math.max(T.length,k.length)>p.o){E.push({range:F,text:T});continue}const q=(0,i.$Ct)(k,T,h),x=L.offsetAt(c.$xt.lift(F).getStartPosition());for(const W of q){const Q=L.positionAt(x+W.originalStart),Y=L.positionAt(x+W.originalStart+W.originalLength),X={text:T.substr(W.modifiedStart,W.modifiedLength),range:{startLineNumber:Q.lineNumber,startColumn:Q.column,endLineNumber:Y.lineNumber,endColumn:Y.column}};L.getValueInRange(X.range)!==X.text&&E.push(X)}}return typeof A=="number"&&E.push({eol:A,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),E}computeHumanReadableDiff(s,f,h){const L=this.j(s);if(!L)return f;const E=[];let A;f=f.slice(0).sort((y,F)=>{if(y.range&&F.range)return c.$xt.compareRangesUsingStarts(y.range,F.range);const T=y.range?0:1,I=F.range?0:1;return T-I});for(let{range:y,text:F,eol:T}of f){let Q=function(X,G){return new R.$wt(X.lineNumber+G.lineNumber-1,G.lineNumber===1?X.column+G.column-1:G.column)},Y=function(X,G){const U=[];for(let K=G.startLineNumber;K<=G.endLineNumber;K++){const P=X[K-1];K===G.startLineNumber&&K===G.endLineNumber?U.push(P.substring(G.startColumn-1,G.endColumn-1)):K===G.startLineNumber?U.push(P.substring(G.startColumn-1)):K===G.endLineNumber?U.push(P.substring(0,G.endColumn-1)):U.push(P)}return U};if(typeof T=="number"&&(A=T),c.$xt.isEmpty(y)&&!F)continue;const I=L.getValueInRange(y);if(F=F.replace(/\r\n|\n|\r/g,L.eol),I===F)continue;if(Math.max(F.length,I.length)>p.o){E.push({range:y,text:F});continue}const k=I.split(/\r\n|\n|\r/),q=F.split(/\r\n|\n|\r/),x=e.$$2.getDefault().computeDiff(k,q,h),W=c.$xt.lift(y).getStartPosition();for(const X of x.changes)if(X.innerChanges)for(const G of X.innerChanges)E.push({range:c.$xt.fromPositions(Q(W,G.originalRange.getStartPosition()),Q(W,G.originalRange.getEndPosition())),text:Y(q,G.modifiedRange).join(L.eol)});else throw new S.$cb("The experimental diff algorithm always produces inner changes")}return typeof A=="number"&&E.push({eol:A,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),E}async computeLinks(s){const f=this.j(s);return f?(0,a.$L2)(f):null}async computeDefaultDocumentColors(s){const f=this.j(s);return f?(0,j.$_2)(f):null}static{this.p=1e4}async textualSuggest(s,f,h,L){const E=new N.$be,A=new RegExp(h,L),y=new Set;e:for(const F of s){const T=this.j(F);if(T){for(const I of T.words(A))if(!(I===f||!isNaN(Number(I)))&&(y.add(I),y.size>p.p))break e}}return{words:Array.from(y),duration:E.elapsed()}}async computeWordRanges(s,f,h,L){const E=this.j(s);if(!E)return Object.create(null);const A=new RegExp(h,L),y=Object.create(null);for(let F=f.startLineNumber;F<f.endLineNumber;F++){const T=E.getLineWords(F,A);for(const I of T){if(!isNaN(Number(I.word)))continue;let k=y[I.word];k||(k=[],y[I.word]=k),k.push({startLineNumber:F,startColumn:I.startColumn,endLineNumber:F,endColumn:I.endColumn})}}return y}async navigateValueSet(s,f,h,L,E){const A=this.j(s);if(!A)return null;const y=new RegExp(L,E);f.startColumn===f.endColumn&&(f={startLineNumber:f.startLineNumber,startColumn:f.startColumn,endLineNumber:f.endLineNumber,endColumn:f.endColumn+1});const F=A.getValueInRange(f),T=A.getWordAtPosition({lineNumber:f.startLineNumber,column:f.startColumn},y);if(!T)return null;const I=A.getValueInRange(T);return u.$M2.INSTANCE.navigateValueSet(f,F,T,I,h)}loadForeignModule(s,f,h){const L=(y,F)=>this.d.fhr(y,F),A={host:(0,m.$do)(h,L),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(A,f),Promise.resolve((0,m.$co)(this.h))):new Promise((y,F)=>{C([s],T=>{this.h=T.create(A,f),y((0,m.$co)(this.h))},F)})}fmr(s,f){if(!this.h||typeof this.h[s]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+s));try{return Promise.resolve(this.h[s].apply(this.h,f))}catch(h){return Promise.reject(h)}}}t.EditorSimpleWorker=p;function l(n){return new p(n,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,o.$O2)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6313b2d7eda4c378748d73274af802a26b8e38ba/core/vs/base/worker/workerMain.js.map
