/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/extpath","vs/base/common/map","vs/base/common/uuid","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],re=function(K){for(var e=[],n=0,C=K.length;n<C;n++)e[n]=se[K[n]];return e};define(se[136],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=n,e.$gb=C,e.$hb=k,e.$ib=R,e.$jb=j,e.$kb=E,e.$lb=h,e.$nb=d,e.$ob=p,e.$pb=v,e.$qb=$,e.$rb=f;function n(y,w){const b=C(y,w);if(b!==-1)return y[b]}function C(y,w,b=y.length-1){for(let c=b;c>=0;c--){const m=y[c];if(w(m))return c}return-1}function k(y,w){const b=R(y,w);return b===-1?void 0:y[b]}function R(y,w,b=0,c=y.length){let m=b,S=c;for(;m<S;){const a=Math.floor((m+S)/2);w(y[a])?m=a+1:S=a}return m-1}function j(y,w){const b=E(y,w);return b===y.length?void 0:y[b]}function E(y,w,b=0,c=y.length){let m=b,S=c;for(;m<S;){const a=Math.floor((m+S)/2);w(y[a])?S=a:m=a+1}return m}function h(y,w,b=0,c=y.length){const m=E(y,w,b,c);return m===y.length?-1:m}class l{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(l.assertInvariants){if(this.d){for(const c of this.e)if(this.d(c)&&!w(c))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const b=R(this.e,w,this.c);return this.c=b+1,b===-1?void 0:this.e[b]}}e.$mb=l;function d(y,w){if(y.length===0)return;let b=y[0];for(let c=1;c<y.length;c++){const m=y[c];w(m,b)>0&&(b=m)}return b}function p(y,w){if(y.length===0)return;let b=y[0];for(let c=1;c<y.length;c++){const m=y[c];w(m,b)>=0&&(b=m)}return b}function v(y,w){return d(y,(b,c)=>-w(b,c))}function $(y,w){if(y.length===0)return-1;let b=0;for(let c=1;c<y.length;c++){const m=y[c];w(m,y[b])>0&&(b=c)}return b}function f(y,w){for(const b of y){const c=w(b);if(c!==void 0)return c}}}),define(se[137],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=n,e.$L=C,e.$M=k,e.$N=R;function n(j,E){const h=Object.create(null);for(const l of j){const d=E(l);let p=h[d];p||(p=h[d]=[]),p.push(l)}return h}function C(j,E){const h=[],l=[];for(const d of j)E.has(d)||h.push(d);for(const d of E)j.has(d)||l.push(d);return{removed:h,added:l}}function k(j,E){const h=[],l=[];for(const[d,p]of j)E.has(d)||h.push(p);for(const[d,p]of E)j.has(d)||l.push(p);return{removed:h,added:l}}function R(j,E){const h=new Set;for(const l of E)j.has(l)&&h.add(l);return h}}),define(se[138],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$St=e.$Rt=e.$Qt=e.$Pt=void 0;function n(E,h){const l=Math.pow(10,h);return Math.round(E*l)/l}class C{constructor(h,l,d,p=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,d))|0,this.a=n(Math.max(Math.min(1,p),0),3)}static equals(h,l){return h.r===l.r&&h.g===l.g&&h.b===l.b&&h.a===l.a}}e.$Pt=C;class k{constructor(h,l,d,p){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=n(Math.max(Math.min(1,l),0),3),this.l=n(Math.max(Math.min(1,d),0),3),this.a=n(Math.max(Math.min(1,p),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.l===l.l&&h.a===l.a}static fromRGBA(h){const l=h.r/255,d=h.g/255,p=h.b/255,v=h.a,$=Math.max(l,d,p),f=Math.min(l,d,p);let y=0,w=0;const b=(f+$)/2,c=$-f;if(c>0){switch(w=Math.min(b<=.5?c/(2*b):c/(2-2*b),1),$){case l:y=(d-p)/c+(d<p?6:0);break;case d:y=(p-l)/c+2;break;case p:y=(l-d)/c+4;break}y*=60,y=Math.round(y)}return new k(y,w,b,v)}static i(h,l,d){return d<0&&(d+=1),d>1&&(d-=1),d<1/6?h+(l-h)*6*d:d<1/2?l:d<2/3?h+(l-h)*(2/3-d)*6:h}static toRGBA(h){const l=h.h/360,{s:d,l:p,a:v}=h;let $,f,y;if(d===0)$=f=y=p;else{const w=p<.5?p*(1+d):p+d-p*d,b=2*p-w;$=k.i(b,w,l+1/3),f=k.i(b,w,l),y=k.i(b,w,l-1/3)}return new C(Math.round($*255),Math.round(f*255),Math.round(y*255),v)}}e.$Qt=k;class R{constructor(h,l,d,p){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=n(Math.max(Math.min(1,l),0),3),this.v=n(Math.max(Math.min(1,d),0),3),this.a=n(Math.max(Math.min(1,p),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.v===l.v&&h.a===l.a}static fromRGBA(h){const l=h.r/255,d=h.g/255,p=h.b/255,v=Math.max(l,d,p),$=Math.min(l,d,p),f=v-$,y=v===0?0:f/v;let w;return f===0?w=0:v===l?w=((d-p)/f%6+6)%6:v===d?w=(p-l)/f+2:w=(l-d)/f+4,new R(Math.round(w*60),y,v,h.a)}static toRGBA(h){const{h:l,s:d,v:p,a:v}=h,$=p*d,f=$*(1-Math.abs(l/60%2-1)),y=p-$;let[w,b,c]=[0,0,0];return l<60?(w=$,b=f):l<120?(w=f,b=$):l<180?(b=$,c=f):l<240?(b=f,c=$):l<300?(w=f,c=$):l<=360&&(w=$,c=f),w=Math.round((w+y)*255),b=Math.round((b+y)*255),c=Math.round((c+y)*255),new C(w,b,c,v)}}e.$Rt=R;class j{static fromHex(h){return j.Format.CSS.parseHex(h)||j.red}static equals(h,l){return!h&&!l?!0:!h||!l?!1:h.equals(l)}get hsla(){return this.i?this.i:k.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof C)this.rgba=h;else if(h instanceof k)this.i=h,this.rgba=k.toRGBA(h);else if(h instanceof R)this.j=h,this.rgba=R.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&C.equals(this.rgba,h.rgba)&&k.equals(this.hsla,h.hsla)&&R.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=j.k(this.rgba.r),l=j.k(this.rgba.g),d=j.k(this.rgba.b),p=.2126*h+.7152*l+.0722*d;return n(p,4)}static k(h){const l=h/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(h){const l=this.getRelativeLuminance(),d=h.getRelativeLuminance();return l>d?(l+.05)/(d+.05):(d+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const l=this.getRelativeLuminance(),d=h.getRelativeLuminance();return l>d}isDarkerThan(h){const l=this.getRelativeLuminance(),d=h.getRelativeLuminance();return l<d}lighten(h){return new j(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new j(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:l,g:d,b:p,a:v}=this.rgba;return new j(new C(l,d,p,v*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new j(new C(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const l=h.rgba,d=this.rgba.a,p=l.a,v=d+p*(1-d);if(v<1e-6)return j.transparent;const $=this.rgba.r*d/v+l.r*p*(1-d)/v,f=this.rgba.g*d/v+l.g*p*(1-d)/v,y=this.rgba.b*d/v+l.b*p*(1-d)/v;return new j(new C($,f,y,v))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:l,g:d,b:p,a:v}=this.rgba;return new j(new C(h.rgba.r-v*(h.rgba.r-l),h.rgba.g-v*(h.rgba.g-d),h.rgba.b-v*(h.rgba.b-p),1))}flatten(...h){const l=h.reduceRight((d,p)=>j.o(p,d));return j.o(this,l)}static o(h,l){const d=1-h.rgba.a;return new j(new C(d*l.rgba.r+h.rgba.a*h.rgba.r,d*l.rgba.g+h.rgba.a*h.rgba.g,d*l.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=j.Format.CSS.format(this)),this.u}static getLighterColor(h,l,d){if(h.isLighterThan(l))return h;d=d||.5;const p=h.getRelativeLuminance(),v=l.getRelativeLuminance();return d=d*(v-p)/v,h.lighten(d)}static getDarkerColor(h,l,d){if(h.isDarkerThan(l))return h;d=d||.5;const p=h.getRelativeLuminance(),v=l.getRelativeLuminance();return d=d*(p-v)/p,h.darken(d)}static{this.white=new j(new C(255,255,255,1))}static{this.black=new j(new C(0,0,0,1))}static{this.red=new j(new C(255,0,0,1))}static{this.blue=new j(new C(0,0,255,1))}static{this.green=new j(new C(0,255,0,1))}static{this.cyan=new j(new C(0,255,255,1))}static{this.lightgrey=new j(new C(211,211,211,1))}static{this.transparent=new j(new C(0,0,0,0))}}e.$St=j,function(E){let h;(function(l){let d;(function(p){function v(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:E.Format.CSS.formatRGBA(t)}p.formatRGB=v;function $(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}p.formatRGBA=$;function f(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:E.Format.CSS.formatHSLA(t)}p.formatHSL=f;function y(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}p.formatHSLA=y;function w(t){const r=t.toString(16);return r.length!==2?"0"+r:r}function b(t){return`#${w(t.rgba.r)}${w(t.rgba.g)}${w(t.rgba.b)}`}p.formatHex=b;function c(t,r=!1){return r&&t.rgba.a===1?E.Format.CSS.formatHex(t):`#${w(t.rgba.r)}${w(t.rgba.g)}${w(t.rgba.b)}${w(Math.round(t.rgba.a*255))}`}p.formatHexA=c;function m(t){return t.isOpaque()?E.Format.CSS.formatHex(t):E.Format.CSS.formatRGBA(t)}p.format=m;function S(t){const r=t.length;if(r===0||t.charCodeAt(0)!==35)return null;if(r===7){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),o=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new E(new C(s,i,o,1))}if(r===9){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),o=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),u=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new E(new C(s,i,o,u/255))}if(r===4){const s=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),o=a(t.charCodeAt(3));return new E(new C(16*s+s,16*i+i,16*o+o))}if(r===5){const s=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),o=a(t.charCodeAt(3)),u=a(t.charCodeAt(4));return new E(new C(16*s+s,16*i+i,16*o+o,(16*u+u)/255))}return null}p.parseHex=S;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(d=l.CSS||(l.CSS={}))})(h=E.Format||(E.Format={}))}(j||(e.$St=j={}))}),define(se[51],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=C,e.$4h=k,e.$5h=R;function n(j){return(E,h,l)=>{let d=null,p=null;if(typeof l.value=="function"?(d="value",p=l.value):typeof l.get=="function"&&(d="get",p=l.get),!p)throw new Error("not supported");l[d]=j(p,h)}}function C(j,E,h){let l=null,d=null;if(typeof h.value=="function"?(l="value",d=h.value,d.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(l="get",d=h.get),!d)throw new Error("not supported");const p=`$memoize$${E}`;h[l]=function(...v){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:d.apply(this,v)}),this[p]}}function k(j,E,h){return n((l,d)=>{const p=`$debounce$${d}`,v=`$debounce$result$${d}`;return function(...$){this[v]||(this[v]=h?h():void 0),clearTimeout(this[p]),E&&(this[v]=E(this[v],...$),$=[this[v]]),this[p]=setTimeout(()=>{l.apply(this,$),this[v]=h?h():void 0},j)}})}function R(j,E,h){return n((l,d)=>{const p=`$throttle$timer$${d}`,v=`$throttle$result$${d}`,$=`$throttle$lastRun$${d}`,f=`$throttle$pending$${d}`;return function(...y){if(this[v]||(this[v]=h?h():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),E&&(this[v]=E(this[v],...y)),this[f])return;const w=this[$]+j;w<=Date.now()?(this[$]=Date.now(),l.apply(this,[this[v]]),this[v]=h?h():void 0):(this[f]=!0,this[p]=setTimeout(()=>{this[f]=!1,this[$]=Date.now(),l.apply(this,[this[v]]),this[v]=h?h():void 0},w-Date.now()))}})}}),define(se[15],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=C,e.$Z=k,e.$1=R,e.$2=j,e.$3=E,e.$4=l,e.$6=p,e.$7=v,e.$8=$,e.$0=y;class n{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?m.isErrorNoTelemetry(t)?new m(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=n,e.$X=new n;function C(a){e.$X.setUnexpectedErrorHandler(a)}function k(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(a){l(a)||e.$X.onUnexpectedError(a)}function j(a){l(a)||e.$X.onUnexpectedExternalError(a)}function E(a){if(a instanceof Error){const{name:t,message:r}=a,s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:s,noTelemetry:m.isErrorNoTelemetry(a)}}return a}const h="Canceled";function l(a){return a instanceof d?!0:a instanceof Error&&a.name===h&&a.message===h}class d extends Error{constructor(){super(h),this.name=this.message}}e.$5=d;function p(){const a=new Error(h);return a.name=a.message,a}function v(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function $(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class f extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=f;function y(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class w extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=w;class b extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=b;class c extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=c;class m extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof m)return t;const r=new m;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=m;class S extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype)}}e.$cb=S}),define(se[22],re([0,1,15,136]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=k,e.$tb=R,e.$ub=j,e.$vb=E,e.$wb=h,e.$xb=l,e.$yb=d,e.$zb=p,e.$Ab=v,e.$Bb=$,e.$Cb=f,e.$Db=y,e.$Eb=w,e.top=b,e.$Gb=c,e.$Hb=S,e.$Ib=a,e.$Jb=t,e.$Kb=r,e.$Lb=s,e.$Mb=i,e.$Nb=o,e.$Ob=u,e.$Pb=g,e.$Qb=P,e.$Rb=D,e.$Sb=I,e.$Tb=O,e.$Ub=M,e.$Vb=W,e.$Wb=F,e.$Xb=T,e.$Yb=U,e.$Zb=ae,e.$1b=te,e.$2b=ce,e.$3b=J,e.$4b=V,e.$5b=q,e.$6b=H,e.$7b=oe,e.$0b=Q;function k(z,Y=0){return z[z.length-(1+Y)]}function R(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}function j(z,Y,x=(ee,X)=>ee===X){if(z===Y)return!0;if(!z||!Y||z.length!==Y.length)return!1;for(let ee=0,X=z.length;ee<X;ee++)if(!x(z[ee],Y[ee]))return!1;return!0}function E(z,Y){const x=z.length-1;Y<x&&(z[Y]=z[x]),z.pop()}function h(z,Y,x){return l(z.length,ee=>x(z[ee],Y))}function l(z,Y){let x=0,ee=z-1;for(;x<=ee;){const X=(x+ee)/2|0,ue=Y(X);if(ue<0)x=X+1;else if(ue>0)ee=X-1;else return X}return-(x+1)}function d(z,Y,x){if(z=z|0,z>=Y.length)throw new TypeError("invalid index");const ee=Y[Math.floor(Y.length*Math.random())],X=[],ue=[],he=[];for(const pe of Y){const $e=x(pe,ee);$e<0?X.push(pe):$e>0?ue.push(pe):he.push(pe)}return z<X.length?d(z,X,x):z<X.length+he.length?he[0]:d(z-(X.length+he.length),ue,x)}function p(z,Y){const x=[];let ee;for(const X of z.slice(0).sort(Y))!ee||Y(ee[0],X)!==0?(ee=[X],x.push(ee)):ee.push(X);return x}function*v(z,Y){let x,ee;for(const X of z)ee!==void 0&&Y(ee,X)?x.push(X):(x&&(yield x),x=[X]),ee=X;x&&(yield x)}function $(z,Y){for(let x=0;x<=z.length;x++)Y(x===0?void 0:z[x-1],x===z.length?void 0:z[x])}function f(z,Y){for(let x=0;x<z.length;x++)Y(x===0?void 0:z[x-1],z[x],x+1===z.length?void 0:z[x+1])}function y(z,Y,x){const ee=[];function X(pe,$e,ye){if($e===0&&ye.length===0)return;const Se=ee[ee.length-1];Se&&Se.start+Se.deleteCount===pe?(Se.deleteCount+=$e,Se.toInsert.push(...ye)):ee.push({start:pe,deleteCount:$e,toInsert:ye})}let ue=0,he=0;for(;;){if(ue===z.length){X(ue,0,Y.slice(he));break}if(he===Y.length){X(ue,z.length-ue,[]);break}const pe=z[ue],$e=Y[he],ye=x(pe,$e);ye===0?(ue+=1,he+=1):ye<0?(X(ue,1,[]),ue+=1):ye>0&&(X(ue,0,[$e]),he+=1)}return ee}function w(z,Y,x){const ee=y(z,Y,x),X=[],ue=[];for(const he of ee)X.push(...z.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:X,added:ue}}function b(z,Y,x){if(x===0)return[];const ee=z.slice(0,x).sort(Y);return m(z,Y,ee,x,z.length),ee}function c(z,Y,x,ee,X){return x===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const pe=z.length,$e=z.slice(0,x).sort(Y);for(let ye=x,Se=Math.min(x+ee,pe);ye<pe;ye=Se,Se=Math.min(Se+ee,pe)){if(ye>x&&await new Promise(ke=>setTimeout(ke)),X&&X.isCancellationRequested)throw new n.$5;m(z,Y,$e,ye,Se)}return $e})().then(ue,he)})}function m(z,Y,x,ee,X){for(const ue=x.length;ee<X;ee++){const he=z[ee];if(Y(he,x[ue-1])<0){x.pop();const pe=(0,C.$kb)(x,$e=>Y(he,$e)<0);x.splice(pe,0,he)}}}function S(z){return z.filter(Y=>!!Y)}function a(z){let Y=0;for(let x=0;x<z.length;x++)z[x]&&(z[Y]=z[x],Y+=1);z.length=Y}function t(z,Y,x){z.splice(x,0,z.splice(Y,1)[0])}function r(z){return!Array.isArray(z)||z.length===0}function s(z){return Array.isArray(z)&&z.length>0}function i(z,Y=x=>x){const x=new Set;return z.filter(ee=>{const X=Y(ee);return x.has(X)?!1:(x.add(X),!0)})}function o(z){const Y=new Set;return x=>{const ee=z(x);return Y.has(ee)?!1:(Y.add(ee),!0)}}function u(z,Y){return z.length>0?z[0]:Y}function g(z,Y){return z.length>0?z[z.length-1]:Y}function P(z,Y,x=(ee,X)=>ee===X){let ee=0;for(let X=0,ue=Math.min(z.length,Y.length);X<ue&&x(z[X],Y[X]);X++)ee++;return ee}function D(z,Y){let x=typeof Y=="number"?z:0;typeof Y=="number"?x=z:(x=0,Y=z);const ee=[];if(x<=Y)for(let X=x;X<Y;X++)ee.push(X);else for(let X=x;X>Y;X--)ee.push(X);return ee}function I(z,Y,x){return z.reduce((ee,X)=>(ee[Y(X)]=x?x(X):X,ee),Object.create(null))}function O(z,Y){return z.push(Y),()=>M(z,Y)}function M(z,Y){const x=z.indexOf(Y);if(x>-1)return z.splice(x,1),Y}function W(z,Y,x){const ee=z.slice(0,Y),X=z.slice(Y);return ee.concat(x,X)}function F(z,Y){let x;if(typeof Y=="number"){let ee=Y;x=()=>{const X=Math.sin(ee++)*179426549;return X-Math.floor(X)}}else x=Math.random;for(let ee=z.length-1;ee>0;ee-=1){const X=Math.floor(x()*(ee+1)),ue=z[ee];z[ee]=z[X],z[X]=ue}}function T(z,Y){const x=z.indexOf(Y);x>-1&&(z.splice(x,1),z.unshift(Y))}function U(z,Y){const x=z.indexOf(Y);x>-1&&(z.splice(x,1),z.push(Y))}function ae(z,Y){for(const x of Y)z.push(x)}function te(z,Y){return Array.isArray(z)?z.map(Y):Y(z)}function ce(z){return Array.isArray(z)?z:[z]}function J(z){return z[Math.floor(Math.random()*z.length)]}function V(z,Y,x){const ee=L(z,Y),X=z.length,ue=x.length;z.length=X+ue;for(let he=X-1;he>=ee;he--)z[he+ue]=z[he];for(let he=0;he<ue;he++)z[he+ee]=x[he]}function q(z,Y,x,ee){const X=L(z,Y);let ue=z.splice(X,x);return ue===void 0&&(ue=[]),V(z,X,ee),ue}function L(z,Y){return Y<0?Math.max(Y+z.length,0):Math.min(Y,z.length)}var B;(function(z){function Y(ue){return ue<0}z.isLessThan=Y;function x(ue){return ue<=0}z.isLessThanOrEqual=x;function ee(ue){return ue>0}z.isGreaterThan=ee;function X(ue){return ue===0}z.isNeitherLessOrGreaterThan=X,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(B||(e.CompareResult=B={}));function H(z,Y){return(x,ee)=>Y(z(x),z(ee))}function oe(...z){return(Y,x)=>{for(const ee of z){const X=ee(Y,x);if(!B.isNeitherLessOrGreaterThan(X))return X}return B.neitherLessOrGreaterThan}}const G=(z,Y)=>z-Y;e.$8b=G;const le=(z,Y)=>(0,e.$8b)(z?1:0,Y?1:0);e.$9b=le;function Q(z){return(Y,x)=>-z(Y,x)}class A{constructor(Y){this.g=Y,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Y){let x=this.c;for(;x<this.g.length&&Y(this.g[x]);)x++;const ee=x===this.c?null:this.g.slice(this.c,x);return this.c=x,ee}takeFromEndWhile(Y){let x=this.d;for(;x>=0&&Y(this.g[x]);)x--;const ee=x===this.d?null:this.g.slice(x+1,this.d+1);return this.d=x,ee}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Y=this.g[this.c];return this.c++,Y}removeLast(){const Y=this.g[this.d];return this.d--,Y}takeCount(Y){const x=this.g.slice(this.c,this.c+Y);return this.c+=Y,x}}e.$$b=A;class N{static{this.empty=new N(Y=>{})}constructor(Y){this.iterate=Y}forEach(Y){this.iterate(x=>(Y(x),!0))}toArray(){const Y=[];return this.iterate(x=>(Y.push(x),!0)),Y}filter(Y){return new N(x=>this.iterate(ee=>Y(ee)?x(ee):!0))}map(Y){return new N(x=>this.iterate(ee=>x(Y(ee))))}some(Y){let x=!1;return this.iterate(ee=>(x=Y(ee),!x)),x}findFirst(Y){let x;return this.iterate(ee=>Y(ee)?(x=ee,!1):!0),x}findLast(Y){let x;return this.iterate(ee=>(Y(ee)&&(x=ee),!0)),x}findLastMaxBy(Y){let x,ee=!0;return this.iterate(X=>((ee||B.isGreaterThan(Y(X,x)))&&(ee=!1,x=X),!0)),x}}e.$_b=N;class _{constructor(Y){this.c=Y}static createSortPermutation(Y,x){const ee=Array.from(Y.keys()).sort((X,ue)=>x(Y[X],Y[ue]));return new _(ee)}apply(Y){return Y.map((x,ee)=>Y[this.c[ee]])}inverse(){const Y=this.c.slice();for(let x=0;x<this.c.length;x++)Y[this.c[x]]=x;return new _(Y)}}e.$ac=_}),define(se[139],re([0,1,15]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=C,e.$ed=k,e.$fd=R,e.$gd=j,e.$hd=E,e.$id=h;function C(l,d){if(!l)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}function k(l,d="Unreachable"){throw new Error(d)}function R(l,d="unexpected state"){if(!l)throw new n.$cb(`Assertion Failed: ${d}`)}function j(l){l||(0,n.$1)(new n.$cb("Soft Assertion Failed"))}function E(l){if(!l()){debugger;l(),(0,n.$1)(new n.$cb("Assertion Failed"))}}function h(l,d){let p=0;for(;p<l.length-1;){const v=l[p],$=l[p+1];if(!d(v,$))return!1;p++}return!0}}),define(se[86],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=n;function n(C,k){const R=this;let j=!1,E;return function(){if(j)return E;if(j=!0,k)try{E=C.apply(R,arguments)}finally{k()}else E=C.apply(R,arguments);return E}}}),define(se[71],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(C){function k(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}C.is=k;const R=Object.freeze([]);function j(){return R}C.empty=j;function*E(t){yield t}C.single=E;function h(t){return k(t)?t:E(t)}C.wrap=h;function l(t){return t||R}C.from=l;function*d(t){for(let r=t.length-1;r>=0;r--)yield t[r]}C.reverse=d;function p(t){return!t||t[Symbol.iterator]().next().done===!0}C.isEmpty=p;function v(t){return t[Symbol.iterator]().next().value}C.first=v;function $(t,r){for(const s of t)if(r(s))return!0;return!1}C.some=$;function f(t,r){for(const s of t)if(r(s))return s}C.find=f;function*y(t,r){for(const s of t)r(s)&&(yield s)}C.filter=y;function*w(t,r){let s=0;for(const i of t)yield r(i,s++)}C.map=w;function*b(...t){for(const r of t)yield*r}C.concat=b;function c(t,r,s){let i=s;for(const o of t)i=r(i,o);return i}C.reduce=c;function*m(t,r,s=t.length){for(r<0&&(r+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);r<s;r++)yield t[r]}C.slice=m;function S(t,r=Number.POSITIVE_INFINITY){const s=[];if(r===0)return[s,t];const i=t[Symbol.iterator]();for(let o=0;o<r;o++){const u=i.next();if(u.done)return[s,C.empty()];s.push(u.value)}return[s,{[Symbol.iterator](){return i}}]}C.consume=S;async function a(t){const r=[];for await(const s of t)r.push(s);return Promise.resolve(r)}C.asyncToArray=a})(n||(e.Iterable=n={}))}),define(se[42],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Jn=j,e.$Kn=p,e.$Ln=v,e.$Mn=$,e.$Nn=f,e.$On=y,e.$Pn=w,e.$Qn=b,e.$Rn=c,e.$Sn=m,e.$Tn=S,e.$Un=a;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function j(t,r=!1){let s=0;const i=t.length;let o="",u=0,g=16,P=0;function D(U){let ae=0,te=0;for(;ae<U;){const ce=t.charCodeAt(s);if(ce>=48&&ce<=57)te=te*16+ce-48;else if(ce>=65&&ce<=70)te=te*16+ce-65+10;else if(ce>=97&&ce<=102)te=te*16+ce-97+10;else break;s++,ae++}return ae<U&&(te=-1),te}function I(U){s=U,o="",u=0,g=16,P=0}function O(){const U=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&l(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&l(t.charCodeAt(s)))for(s++;s<t.length&&l(t.charCodeAt(s));)s++;else return P=3,t.substring(U,s);let ae=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&l(t.charCodeAt(s))){for(s++;s<t.length&&l(t.charCodeAt(s));)s++;ae=s}else P=3;return t.substring(U,ae)}function M(){let U="",ae=s;for(;;){if(s>=i){U+=t.substring(ae,s),P=2;break}const te=t.charCodeAt(s);if(te===34){U+=t.substring(ae,s),s++;break}if(te===92){if(U+=t.substring(ae,s),s++,s>=i){P=2;break}switch(t.charCodeAt(s++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const J=D(4);J>=0?U+=String.fromCharCode(J):P=4;break}default:P=5}ae=s;continue}if(te>=0&&te<=31)if(h(te)){U+=t.substring(ae,s),P=2;break}else P=6;s++}return U}function W(){if(o="",P=0,u=s,s>=i)return u=i,g=17;let U=t.charCodeAt(s);if(E(U)){do s++,o+=String.fromCharCode(U),U=t.charCodeAt(s);while(E(U));return g=15}if(h(U))return s++,o+=String.fromCharCode(U),U===13&&t.charCodeAt(s)===10&&(s++,o+=`
`),g=14;switch(U){case 123:return s++,g=1;case 125:return s++,g=2;case 91:return s++,g=3;case 93:return s++,g=4;case 58:return s++,g=6;case 44:return s++,g=5;case 34:return s++,o=M(),g=10;case 47:{const ae=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!h(t.charCodeAt(s));)s++;return o=t.substring(ae,s),g=12}if(t.charCodeAt(s+1)===42){s+=2;const te=i-1;let ce=!1;for(;s<te;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,ce=!0;break}s++}return ce||(s++,P=1),o=t.substring(ae,s),g=13}return o+=String.fromCharCode(U),s++,g=16}case 45:if(o+=String.fromCharCode(U),s++,s===i||!l(t.charCodeAt(s)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=O(),g=11;default:for(;s<i&&F(U);)s++,U=t.charCodeAt(s);if(u!==s){switch(o=t.substring(u,s),o){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return o+=String.fromCharCode(U),s++,g=16}}function F(U){if(E(U)||h(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let U;do U=W();while(U>=12&&U<=15);return U}return{setPosition:I,getPosition:()=>s,scan:r?T:W,getToken:()=>g,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>s-u,getTokenError:()=>P}}function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var d;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(d||(d={}));function p(t,r){const s=[],i=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function P(D,I,O,M){u.value=D,u.offset=I,u.length=O,u.type=M,u.colonOffset=void 0,o=u}try{m(t,{onObjectBegin:(D,I)=>{if(r<=D)throw i;o=void 0,g=r>D,s.push("")},onObjectProperty:(D,I,O)=>{if(r<I||(P(D,I,O,"property"),s[s.length-1]=D,r<=I+O))throw i},onObjectEnd:(D,I)=>{if(r<=D)throw i;o=void 0,s.pop()},onArrayBegin:(D,I)=>{if(r<=D)throw i;o=void 0,s.push(0)},onArrayEnd:(D,I)=>{if(r<=D)throw i;o=void 0,s.pop()},onLiteralValue:(D,I,O)=>{if(r<I||(P(D,I,O,a(D)),r<=I+O))throw i},onSeparator:(D,I,O)=>{if(r<=I)throw i;if(D===":"&&o&&o.type==="property")o.colonOffset=I,g=!1,o=void 0;else if(D===","){const M=s[s.length-1];typeof M=="number"?s[s.length-1]=M+1:(g=!0,s[s.length-1]=""),o=void 0}}})}catch(D){if(D!==i)throw D}return{path:s,previousNode:o,isAtPropertyKey:g,matches:D=>{let I=0;for(let O=0;I<D.length&&O<s.length;O++)if(D[I]===s[O]||D[I]==="*")I++;else if(D[I]!=="**")return!1;return I===D.length}}}function v(t,r=[],s=R.DEFAULT){let i=null,o=[];const u=[];function g(D){Array.isArray(o)?o.push(D):i!==null&&(o[i]=D)}return m(t,{onObjectBegin:()=>{const D={};g(D),u.push(o),o=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const D=[];g(D),u.push(o),o=D,i=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:g,onError:(D,I,O)=>{r.push({error:D,offset:I,length:O})}},s),o[0]}function $(t,r=[],s=R.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(D){i.type==="property"&&(i.length=D-i.offset,i=i.parent)}function u(D){return i.children.push(D),D}m(t,{onObjectBegin:D=>{i=u({type:"object",offset:D,length:-1,parent:i,children:[]})},onObjectProperty:(D,I,O)=>{i=u({type:"property",offset:I,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:D,offset:I,length:O,parent:i})},onObjectEnd:(D,I)=>{i.length=D+I-i.offset,i=i.parent,o(D+I)},onArrayBegin:(D,I)=>{i=u({type:"array",offset:D,length:-1,parent:i,children:[]})},onArrayEnd:(D,I)=>{i.length=D+I-i.offset,i=i.parent,o(D+I)},onLiteralValue:(D,I,O)=>{u({type:a(D),offset:I,length:O,parent:i,value:D}),o(I+O)},onSeparator:(D,I,O)=>{i.type==="property"&&(D===":"?i.colonOffset=I:D===","&&o(I))},onError:(D,I,O)=>{r.push({error:D,offset:I,length:O})}},s);const P=i.children[0];return P&&delete P.parent,P}function f(t,r){if(!t)return;let s=t;for(const i of r)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const u of s.children)if(Array.isArray(u.children)&&u.children[0].value===i){s=u.children[1],o=!0;break}if(!o)return}else{const o=i;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}function y(t){if(!t.parent||!t.parent.children)return[];const r=y(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}function w(t){switch(t.type){case"array":return t.children.map(w);case"object":{const r=Object.create(null);for(const s of t.children){const i=s.children[1];i&&(r[s.children[0].value]=w(i))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function b(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}function c(t,r,s=!1){if(b(t,r,s)){const i=t.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=r;o++){const u=c(i[o],r,s);if(u)return u}return t}}function m(t,r,s=R.DEFAULT){const i=j(t,!1);function o(oe){return oe?()=>oe(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(oe){return oe?G=>oe(G,i.getTokenOffset(),i.getTokenLength()):()=>!0}const g=o(r.onObjectBegin),P=u(r.onObjectProperty),D=o(r.onObjectEnd),I=o(r.onArrayBegin),O=o(r.onArrayEnd),M=u(r.onLiteralValue),W=u(r.onSeparator),F=o(r.onComment),T=u(r.onError),U=s&&s.disallowComments,ae=s&&s.allowTrailingComma;function te(){for(;;){const oe=i.scan();switch(i.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:U||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(oe){case 12:case 13:U?ce(10):F();break;case 16:ce(1);break;case 15:case 14:break;default:return oe}}}function ce(oe,G=[],le=[]){if(T(oe),G.length+le.length>0){let Q=i.getToken();for(;Q!==17;){if(G.indexOf(Q)!==-1){te();break}else if(le.indexOf(Q)!==-1)break;Q=te()}}}function J(oe){const G=i.getTokenValue();return oe?M(G):P(G),te(),!0}function V(){switch(i.getToken()){case 11:{let oe=0;try{oe=JSON.parse(i.getTokenValue()),typeof oe!="number"&&(ce(2),oe=0)}catch{ce(2)}M(oe);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return te(),!0}function q(){return i.getToken()!==10?(ce(3,[],[2,5]),!1):(J(!1),i.getToken()===6?(W(":"),te(),H()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function L(){g(),te();let oe=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(oe||ce(4,[],[]),W(","),te(),i.getToken()===2&&ae)break}else oe&&ce(6,[],[]);q()||ce(4,[],[2,5]),oe=!0}return D(),i.getToken()!==2?ce(7,[2],[]):te(),!0}function B(){I(),te();let oe=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(oe||ce(4,[],[]),W(","),te(),i.getToken()===4&&ae)break}else oe&&ce(6,[],[]);H()||ce(4,[],[4,5]),oe=!0}return O(),i.getToken()!==4?ce(8,[4],[]):te(),!0}function H(){switch(i.getToken()){case 3:return B();case 1:return L();case 10:return J(!0);default:return V()}}return te(),i.getToken()===17?s.allowEmptyContent?!0:(ce(4,[],[]),!1):H()?(i.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}function S(t,r){const s=j(t),i=[];let o,u=0,g;do switch(g=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:u!==g&&i.push(t.substring(u,g)),r!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,r)),u=s.getPosition();break}while(o!==17);return i.join("")}function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(se[140],re([0,1,42]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=C,e.$Wn=k,e.$Xn=E,e.$Yn=h;function C(l,d,p){let v,$,f,y,w;if(d){for(y=d.offset,w=y+d.length,f=y;f>0&&!h(l,f-1);)f--;let g=w;for(;g<l.length&&!h(l,g);)g++;$=l.substring(f,g),v=j($,p)}else $=l,v=0,f=0,y=0,w=l.length;const b=E(p,l);let c=!1,m=0,S;p.insertSpaces?S=R(" ",p.tabSize||4):S="	";const a=(0,n.$Jn)($,!1);let t=!1;function r(){return b+R(S,v+m)}function s(){let g=a.scan();for(c=!1;g===15||g===14;)c=c||g===14,g=a.scan();return t=g===16||a.getTokenError()!==0,g}const i=[];function o(g,P,D){!t&&P<w&&D>y&&l.substring(P,D)!==g&&i.push({offset:P,length:D-P,content:g})}let u=s();if(u!==17){const g=a.getTokenOffset()+f,P=R(S,v);o(P,f,g)}for(;u!==17;){let g=a.getTokenOffset()+a.getTokenLength()+f,P=s(),D="";for(;!c&&(P===12||P===13);){const O=a.getTokenOffset()+f;o(" ",g,O),g=a.getTokenOffset()+a.getTokenLength()+f,D=P===12?r():"",P=s()}if(P===2)u!==1&&(m--,D=r());else if(P===4)u!==3&&(m--,D=r());else{switch(u){case 3:case 1:m++,D=r();break;case 5:case 12:D=r();break;case 13:c?D=r():D=" ";break;case 6:D=" ";break;case 10:if(P===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?D=" ":P!==5&&P!==17&&(t=!0);break;case 16:t=!0;break}c&&(P===12||P===13)&&(D=r())}const I=a.getTokenOffset()+f;o(D,g,I),u=P}return i}function k(l,d){const p=JSON.stringify(l,void 0,d.insertSpaces?d.tabSize||4:"	");return d.eol!==void 0?p.replace(/\r\n|\r|\n/g,d.eol):p}function R(l,d){let p="";for(let v=0;v<d;v++)p+=l;return p}function j(l,d){let p=0,v=0;const $=d.tabSize||4;for(;p<l.length;){const f=l.charAt(p);if(f===" ")v++;else if(f==="	")v+=$;else break;p++}return Math.floor(v/$)}function E(l,d){for(let p=0;p<d.length;p++){const v=d.charAt(p);if(v==="\r")return p+1<d.length&&d.charAt(p+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return l&&l.eol||`
`}function h(l,d){return`\r
`.indexOf(l.charAt(d))!==-1}}),define(se[103],re([0,1,42,140]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=k,e.$1n=R,e.$2n=j,e.$3n=E,e.$4n=h;function k(l,d,p){return R(l,d,void 0,p)}function R(l,d,p,v,$){const f=d.slice(),y=[],w=(0,n.$Mn)(l,y);let b,c;for(;f.length>0&&(c=f.pop(),b=(0,n.$Nn)(w,f),b===void 0&&p!==void 0);)typeof c=="string"?p={[c]:p}:p=[p];if(b)if(b.type==="object"&&typeof c=="string"&&Array.isArray(b.children)){const m=(0,n.$Nn)(b,[c]);if(m!==void 0)if(p===void 0){if(!m.parent)throw new Error("Malformed AST");const S=b.children.indexOf(m.parent);let a,t=m.parent.offset+m.parent.length;if(S>0){const r=b.children[S-1];a=r.offset+r.length}else a=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return j(l,{offset:a,length:t-a,content:""},v)}else return j(l,{offset:m.offset,length:m.length,content:JSON.stringify(p)},v);else{if(p===void 0)return[];const S=`${JSON.stringify(c)}: ${JSON.stringify(p)}`,a=$?$(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(a>0){const r=b.children[a-1];t={offset:r.offset+r.length,length:0,content:","+S}}else b.children.length===0?t={offset:b.offset+1,length:0,content:S}:t={offset:b.offset+1,length:0,content:S+","};return j(l,t,v)}}else if(b.type==="array"&&typeof c=="number"&&Array.isArray(b.children))if(p!==void 0){const m=`${JSON.stringify(p)}`;let S;if(b.children.length===0||c===0)S={offset:b.offset+1,length:0,content:b.children.length===0?m:m+","};else{const a=c===-1||c>b.children.length?b.children.length:c,t=b.children[a-1];S={offset:t.offset+t.length,length:0,content:","+m}}return j(l,S,v)}else{const m=c,S=b.children[m];let a;if(b.children.length===1)a={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===m){const t=b.children[m-1],r=t.offset+t.length,s=b.offset+b.length;a={offset:r,length:s-2-r,content:""}}else a={offset:S.offset,length:b.children[m+1].offset-S.offset,content:""};return j(l,a,v)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${b.type}`);else return p===void 0?[]:j(l,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(p)},v)}function j(l,d,p){let v=E(l,d),$=d.offset,f=d.offset+d.content.length;if(d.length===0||d.content.length===0){for(;$>0&&!(0,C.$Yn)(v,$-1);)$--;for(;f<v.length&&!(0,C.$Yn)(v,f);)f++}const y=(0,C.$Vn)(v,{offset:$,length:f-$},p);for(let b=y.length-1;b>=0;b--){const c=y[b];v=E(v,c),$=Math.min($,c.offset),f=Math.max(f,c.offset+c.length),f+=c.content.length-c.length}const w=l.length-(v.length-f)-$;return[{offset:$,length:w,content:v.substring($,f)}]}function E(l,d){return l.substring(0,d.offset)+d.content+l.substring(d.offset+d.length)}function h(l,d){const p=d.slice(0).sort(($,f)=>{const y=$.offset-f.offset;return y===0?$.length-f.length:y});let v=l.length;for(let $=p.length-1;$>=0;$--){const f=p[$];if(f.offset+f.length<=v)l=E(l,f);else throw new Error("Overlapping edit");v=f.offset}return l}}),define(se[62],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class n{constructor(k){this.d=k,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=n}),define(se[104],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(R){this.element=R,this.next=n.Undefined,this.prev=n.Undefined}}class C{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let R=this.a;for(;R!==n.Undefined;){const j=R.next;R.prev=n.Undefined,R.next=n.Undefined,R=j}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,j){const E=new n(R);if(this.a===n.Undefined)this.a=E,this.b=E;else if(j){const l=this.b;this.b=E,E.prev=l,l.next=E}else{const l=this.a;this.a=E,E.next=l,l.prev=E}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(E))}}shift(){if(this.a!==n.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==n.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==n.Undefined&&R.next!==n.Undefined){const j=R.prev;j.next=R.next,R.next.prev=j}else R.prev===n.Undefined&&R.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):R.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):R.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==n.Undefined;)yield R.element,R=R.next}}e.$5c=C}),define(se[32],re([0,1]),function(K,e){"use strict";var n,C,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=R,e.$yc=j,e.$zc=E,e.$Ic=S;function R(a,t,r){let s=a.get(t);return s===void 0&&(s=r,a.set(t,s)),s}function j(a){const t=[];return a.forEach((r,s)=>{t.push(`${s} => ${r}`)}),`Map(${a.size}) {${t.join(", ")}}`}function E(a){const t=[];return a.forEach(r=>{t.push(r)}),`Set(${a.size}) {${t.join(", ")}}`}class h{constructor(t,r){this.uri=t,this.value=r}}function l(a){return Array.isArray(a)}class d{static{this.c=t=>t.toString()}constructor(t,r){if(this[n]="ResourceMap",t instanceof d)this.d=new Map(t.d),this.e=r??d.c;else if(l(t)){this.d=new Map,this.e=r??d.c;for(const[s,i]of t)this.set(s,i)}else this.d=new Map,this.e=t??d.c}set(t,r){return this.d.set(this.e(t),new h(t,r)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,r){typeof r<"u"&&(t=t.bind(r));for(const[s,i]of this.d)t(i.value,i.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=d;class p{constructor(t,r){this[C]="ResourceSet",!t||typeof t=="function"?this.c=new d(t):(this.c=new d(r),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,r){this.c.forEach((s,i)=>t.call(r,i,i,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=p;var v;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class ${constructor(){this[k]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,r=0){const s=this.c.get(t);if(s)return r!==0&&this.m(s,r),s.value}set(t,r,s=0){let i=this.c.get(t);if(i)i.value=r,s!==0&&this.m(i,s);else{switch(i={key:t,value:r,next:void 0,previous:void 0},s){case 0:this.k(i);break;case 1:this.j(i);break;case 2:this.k(i);break;default:this.k(i);break}this.c.set(t,i),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this.c.get(t);if(r)return this.c.delete(t),this.l(r),this.f--,r.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,r){const s=this.g;let i=this.d;for(;i;){if(r?t.bind(r)(i.value,i.key,this):t(i.value,i.key,this),this.g!==s)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const t=this,r=this.g;let s=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:s.key,done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return i}values(){const t=this,r=this.g;let s=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:s.value,done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return i}entries(){const t=this,r=this.g;let s=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:[s.key,s.value],done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return i}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.d,s=this.size;for(;r&&s>t;)this.c.delete(r.key),r=r.next,s--;this.d=r,this.f=s,r&&(r.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.e,s=this.size;for(;r&&s>t;)this.c.delete(r.key),r=r.previous,s--;this.e=r,this.f=s,r&&(r.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const r=t.next,s=t.previous;if(!r||!s)throw new Error("Invalid list");r.previous=s,s.next=r}t.next=void 0,t.previous=void 0,this.g++}m(t,r){if(!this.d||!this.e)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this.d)return;const s=t.next,i=t.previous;t===this.e?(i.next=void 0,this.e=i):(s.previous=i,i.next=s),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(r===2){if(t===this.e)return;const s=t.next,i=t.previous;t===this.d?(s.previous=void 0,this.d=s):(s.previous=i,i.next=s),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((r,s)=>{t.push([s,r])}),t}fromJSON(t){this.clear();for(const[r,s]of t)this.set(r,s)}}e.$Cc=$;class f extends ${constructor(t,r=1){super(),this.n=t,this.o=Math.min(Math.max(0,r),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class y extends f{constructor(t,r=1){super(t,r)}q(t){this.h(t)}set(t,r){return super.set(t,r),this.p(),this}}e.$Dc=y;class w extends f{constructor(t,r=1){super(t,r)}q(t){this.i(t)}set(t,r){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,r),this}}e.$Ec=w;class b{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let r=this.c.get(t)||0;return r===0?!1:(r--,r===0?this.c.delete(t):this.c.set(t,r),!0)}has(t){return this.c.has(t)}}e.$Fc=b;class c{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[r,s]of t)this.set(r,s)}clear(){this.c.clear(),this.d.clear()}set(t,r){this.c.set(t,r),this.d.set(r,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const r=this.c.get(t);return r===void 0?!1:(this.c.delete(t),this.d.delete(r),!0)}forEach(t,r){this.c.forEach((s,i)=>{t.call(r,s,i,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=c;class m{constructor(){this.c=new Map}add(t,r){let s=this.c.get(t);s||(s=new Set,this.c.set(t,s)),s.add(r)}delete(t,r){const s=this.c.get(t);s&&(s.delete(r),s.size===0&&this.c.delete(t))}forEach(t,r){const s=this.c.get(t);s&&s.forEach(r)}get(t){const r=this.c.get(t);return r||new Set}}e.$Hc=m;function S(a,t){if(a===t)return!0;if(a.size!==t.size)return!1;for(const[r,s]of a)if(!t.has(r)||t.get(r)!==s)return!1;for(const[r]of t)if(!a.has(r))return!1;return!0}}),define(se[2],re([0,1,22,137,32,86,71]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=d,e.$Lc=p,e.$Mc=v,e.$Nc=y,e.$Oc=w,e.$Pc=b,e.$Qc=c,e.$Rc=m,e.$Sc=S,e.$3c=D;const E=!1;let h=null;class l{constructor(){this.b=new Map}static{this.a=0}c(M){let W=this.b.get(M);return W||(W={parent:null,source:null,isSingleton:!1,value:M,idx:l.a++},this.b.set(M,W)),W}trackDisposable(M){const W=this.c(M);W.source||(W.source=new Error().stack)}setParent(M,W){const F=this.c(M);F.parent=W}markAsDisposed(M){this.b.delete(M)}markAsSingleton(M){this.c(M).isSingleton=!0}f(M,W){const F=W.get(M);if(F)return F;const T=M.parent?this.f(this.c(M.parent),W):M;return W.set(M,T),T}getTrackedDisposables(){const M=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,M).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(M=10,W){let F;if(W)F=W;else{const ce=new Map,J=[...this.b.values()].filter(q=>q.source!==null&&!this.f(q,ce).isSingleton);if(J.length===0)return;const V=new Set(J.map(q=>q.value));if(F=J.filter(q=>!(q.parent&&V.has(q.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function T(ce){function J(q,L){for(;q.length>0&&L.some(B=>typeof B=="string"?B===q[0]:q[0].match(B));)q.shift()}const V=ce.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return J(V,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),V.reverse()}const U=new k.$Hc;for(const ce of F){const J=T(ce);for(let V=0;V<=J.length;V++)U.add(J.slice(0,V).join(`
`),ce)}F.sort((0,n.$6b)(ce=>ce.idx,n.$8b));let ae="",te=0;for(const ce of F.slice(0,M)){te++;const J=T(ce),V=[];for(let q=0;q<J.length;q++){let L=J[q];L=`(shared with ${U.get(J.slice(0,q+1).join(`
`)).size}/${F.length} leaks) at ${L}`;const H=U.get(J.slice(0,q).join(`
`)),oe=(0,C.$K)([...H].map(G=>T(G)[q]),G=>G);delete oe[J[q]];for(const[G,le]of Object.entries(oe))V.unshift(`    - stacktraces of ${le.length} other leaks continue with ${G}`);V.unshift(L)}ae+=`


==================== Leaking disposable ${te}/${F.length}: ${ce.value.constructor.name} ====================
${V.join(`
`)}
============================================================

`}return F.length>M&&(ae+=`


... and ${F.length-M} more leaking disposables

`),{leaks:F,details:ae}}}e.$Jc=l;function d(O){h=O}if(E){const O="__is_disposable_tracked__";d(new class{trackDisposable(M){const W=new Error("Potentially leaked disposable").stack;setTimeout(()=>{M[O]||console.log(W)},3e3)}setParent(M,W){if(M&&M!==t.None)try{M[O]=!0}catch{}}markAsDisposed(M){if(M&&M!==t.None)try{M[O]=!0}catch{}}markAsSingleton(M){}})}function p(O){return h?.trackDisposable(O),O}function v(O){h?.markAsDisposed(O)}function $(O,M){h?.setParent(O,M)}function f(O,M){if(h)for(const W of O)h.setParent(W,M)}function y(O){return h?.markAsSingleton(O),O}function w(O){return typeof O=="object"&&O!==null&&typeof O.dispose=="function"&&O.dispose.length===0}function b(O){if(j.Iterable.is(O)){const M=[];for(const W of O)if(W)try{W.dispose()}catch(F){M.push(F)}if(M.length===1)throw M[0];if(M.length>1)throw new AggregateError(M,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}function c(O){for(const M of O)w(M)&&M.dispose();return[]}function m(...O){const M=S(()=>b(O));return f(O,M),M}function S(O){const M=p({dispose:(0,R.$db)(()=>{v(M),O()})});return M}class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,p(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{b(this.f)}finally{this.f.clear()}}add(M){if(!M)return M;if(M===this)throw new Error("Cannot register a disposable on itself!");return $(M,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(M),M}delete(M){if(M){if(M===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(M),M.dispose()}}deleteAndLeak(M){M&&this.f.has(M)&&(this.f.delete(M),$(M,null))}}e.$Tc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,p(this),$(this.q,this)}dispose(){v(this),this.q.dispose()}B(M){if(M===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(M)}}e.$Uc=t;class r{constructor(){this.b=!1,p(this)}get value(){return this.b?void 0:this.a}set value(M){this.b||M===this.a||(this.a?.dispose(),M&&$(M,this),this.a=M)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const M=this.a;return this.a=void 0,M&&$(M,null),M}}e.$Vc=r;class s{constructor(M){this.a=new r,this.b=!1,this.a.value=M}get value(){return this.a.value}set value(M){this.b||M===this.a.value||(this.a.value=M)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=s;class i{constructor(M){this.b=M,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=i;class o{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,p(this)}set(M){let W=M;return this.unset=()=>W=void 0,this.isset=()=>W!==void 0,this.dispose=()=>{W&&(W(),W=void 0,v(this))},this}}e.$Yc=o;class u{constructor(){this.a=new Map}acquire(M,...W){let F=this.a.get(M);F||(F={counter:0,object:this.b(M,...W)},this.a.set(M,F));const{object:T}=F,U=(0,R.$db)(()=>{--F.counter===0&&(this.c(M,F.object),this.a.delete(M))});return F.counter++,{object:T,dispose:U}}}e.$Zc=u;class g{constructor(M){this.a=M}async acquire(M,...W){const F=this.a.acquire(M,...W);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(T){throw F.dispose(),T}}}e.$1c=g;class P{constructor(M){this.object=M}dispose(){}}e.$2c=P;function D(O){const M=new a;try{O(M)}finally{M.dispose()}}class I{constructor(){this.a=new Map,this.b=!1,p(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{b(this.a.values())}finally{this.a.clear()}}has(M){return this.a.has(M)}get size(){return this.a.size}get(M){return this.a.get(M)}set(M,W,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(M)?.dispose(),this.a.set(M,W)}deleteAndDispose(M){this.a.get(M)?.dispose(),this.a.delete(M)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=I}),define(se[72],re([0,1,32]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=void 0,e.$dm=k,e.$em=j;const C=new n.$Dc(1e4);function k(l){return h(l,"NFC",C)}const R=new n.$Dc(1e4);function j(l){return h(l,"NFD",R)}const E=/[^\u0000-\u0080]/;function h(l,d,p){if(!l)return l;const v=p.get(l);if(v)return v;let $;return E.test(l)?$=l.normalize(d):$=l,p.set(l,$),$}e.$fm=function(){const l=/[\u0300-\u036f]/g;return function(d){return j(d).replace(l,"")}}()}),define(se[141],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=void 0,e.$Dm=n,e.rot=C;function n(E,h,l){return Math.min(Math.max(E,h),l)}function C(E,h){return(h+E%h)%h}class k{constructor(){this.a=0}getNext(){return this.a++}}e.$Fm=k;class R{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Gm=R;class j{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const l=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Hm=j}),function(){function K(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function j(h){R.push(h,Date.now())}function E(){const h=[];for(let l=0;l<R.length;l+=2)h.push({name:R[l],startTime:R[l+1]});return h}return{mark:j,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const j of performance.getEntriesByType("mark"))R.push({name:j.name,startTime:Math.round(k+j.startTime)});return R}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function n(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=n(C))}(),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var C in n)(typeof exports=="object"?exports:K)[C]=n[C]}}(typeof self<"u"?self:this,function(){return function(K){var e={};function n(C){if(e[C])return e[C].exports;var k=e[C]={i:C,l:!1,exports:{}};return K[C].call(k.exports,k,k.exports,n),k.l=!0,k.exports}return n.m=K,n.c=e,n.d=function(C,k,R){n.o(C,k)||Object.defineProperty(C,k,{enumerable:!0,get:R})},n.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},n.t=function(C,k){if(1&k&&(C=n(C)),8&k||4&k&&typeof C=="object"&&C&&C.__esModule)return C;var R=Object.create(null);if(n.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:C}),2&k&&typeof C!="string")for(var j in C)n.d(R,j,function(E){return C[E]}.bind(null,j));return R},n.n=function(C){var k=C&&C.__esModule?function(){return C.default}:function(){return C};return n.d(k,"a",k),k},n.o=function(C,k){return Object.prototype.hasOwnProperty.call(C,k)},n.p="",n(n.s=0)}([function(K,e,n){(function(C){var k;e=K.exports=le,k=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,j=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],h=e.src=[],l=0,d=l++;h[d]="0|[1-9]\\d*";var p=l++;h[p]="[0-9]+";var v=l++;h[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=l++;h[$]="("+h[d]+")\\.("+h[d]+")\\.("+h[d]+")";var f=l++;h[f]="("+h[p]+")\\.("+h[p]+")\\.("+h[p]+")";var y=l++;h[y]="(?:"+h[d]+"|"+h[v]+")";var w=l++;h[w]="(?:"+h[p]+"|"+h[v]+")";var b=l++;h[b]="(?:-("+h[y]+"(?:\\."+h[y]+")*))";var c=l++;h[c]="(?:-?("+h[w]+"(?:\\."+h[w]+")*))";var m=l++;h[m]="[0-9A-Za-z-]+";var S=l++;h[S]="(?:\\+("+h[m]+"(?:\\."+h[m]+")*))";var a=l++,t="v?"+h[$]+h[b]+"?"+h[S]+"?";h[a]="^"+t+"$";var r="[v=\\s]*"+h[f]+h[c]+"?"+h[S]+"?",s=l++;h[s]="^"+r+"$";var i=l++;h[i]="((?:<|>)?=?)";var o=l++;h[o]=h[p]+"|x|X|\\*";var u=l++;h[u]=h[d]+"|x|X|\\*";var g=l++;h[g]="[v=\\s]*("+h[u]+")(?:\\.("+h[u]+")(?:\\.("+h[u]+")(?:"+h[b]+")?"+h[S]+"?)?)?";var P=l++;h[P]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[c]+")?"+h[S]+"?)?)?";var D=l++;h[D]="^"+h[i]+"\\s*"+h[g]+"$";var I=l++;h[I]="^"+h[i]+"\\s*"+h[P]+"$";var O=l++;h[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=l++;h[M]="(?:~>?)";var W=l++;h[W]="(\\s*)"+h[M]+"\\s+",E[W]=new RegExp(h[W],"g");var F=l++;h[F]="^"+h[M]+h[g]+"$";var T=l++;h[T]="^"+h[M]+h[P]+"$";var U=l++;h[U]="(?:\\^)";var ae=l++;h[ae]="(\\s*)"+h[U]+"\\s+",E[ae]=new RegExp(h[ae],"g");var te=l++;h[te]="^"+h[U]+h[g]+"$";var ce=l++;h[ce]="^"+h[U]+h[P]+"$";var J=l++;h[J]="^"+h[i]+"\\s*("+r+")$|^$";var V=l++;h[V]="^"+h[i]+"\\s*("+t+")$|^$";var q=l++;h[q]="(\\s*)"+h[i]+"\\s*("+r+"|"+h[g]+")",E[q]=new RegExp(h[q],"g");var L=l++;h[L]="^\\s*("+h[g]+")\\s+-\\s+("+h[g]+")\\s*$";var B=l++;h[B]="^\\s*("+h[P]+")\\s+-\\s+("+h[P]+")\\s*$";var H=l++;h[H]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)k(oe,h[oe]),E[oe]||(E[oe]=new RegExp(h[oe]));function G(Z,fe){if(Z instanceof le)return Z;if(typeof Z!="string"||Z.length>R||!(fe?E[s]:E[a]).test(Z))return null;try{return new le(Z,fe)}catch{return null}}function le(Z,fe){if(Z instanceof le){if(Z.loose===fe)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof le))return new le(Z,fe);k("SemVer",Z,fe),this.loose=fe;var ge=Z.trim().match(fe?E[s]:E[a]);if(!ge)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>j||this.major<0)throw new TypeError("Invalid major version");if(this.minor>j||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>j||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Oe=+Pe;if(Oe>=0&&Oe<j)return Oe}return Pe}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=G,e.valid=function(Z,fe){var ge=G(Z,fe);return ge?ge.version:null},e.clean=function(Z,fe){var ge=G(Z.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=le,le.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},le.prototype.toString=function(){return this.version},le.prototype.compare=function(Z){return k("SemVer.compare",this.version,this.loose,Z),Z instanceof le||(Z=new le(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},le.prototype.compareMain=function(Z){return Z instanceof le||(Z=new le(Z,this.loose)),A(this.major,Z.major)||A(this.minor,Z.minor)||A(this.patch,Z.patch)},le.prototype.comparePre=function(Z){if(Z instanceof le||(Z=new le(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],Pe=Z.prerelease[fe];if(k("prerelease compare",fe,ge,Pe),ge===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(ge===void 0)return-1;if(ge!==Pe)return A(ge,Pe)}while(++fe)},le.prototype.inc=function(Z,fe){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,fe,ge,Pe){typeof ge=="string"&&(Pe=ge,ge=void 0);try{return new le(Z,ge).inc(fe,Pe).version}catch{return null}},e.diff=function(Z,fe){if(Y(Z,fe))return null;var ge=G(Z),Pe=G(fe);if(ge.prerelease.length||Pe.prerelease.length){for(var Oe in ge)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&ge[Oe]!==Pe[Oe])return"pre"+Oe;return"prerelease"}for(var Oe in ge)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&ge[Oe]!==Pe[Oe])return Oe},e.compareIdentifiers=A;var Q=/^[0-9]+$/;function A(Z,fe){var ge=Q.test(Z),Pe=Q.test(fe);return ge&&Pe&&(Z=+Z,fe=+fe),ge&&!Pe?-1:Pe&&!ge?1:Z<fe?-1:Z>fe?1:0}function N(Z,fe,ge){return new le(Z,ge).compare(new le(fe,ge))}function _(Z,fe,ge){return N(Z,fe,ge)>0}function z(Z,fe,ge){return N(Z,fe,ge)<0}function Y(Z,fe,ge){return N(Z,fe,ge)===0}function x(Z,fe,ge){return N(Z,fe,ge)!==0}function ee(Z,fe,ge){return N(Z,fe,ge)>=0}function X(Z,fe,ge){return N(Z,fe,ge)<=0}function ue(Z,fe,ge,Pe){var Oe;switch(fe){case"===":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),Oe=Z===ge;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),Oe=Z!==ge;break;case"":case"=":case"==":Oe=Y(Z,ge,Pe);break;case"!=":Oe=x(Z,ge,Pe);break;case">":Oe=_(Z,ge,Pe);break;case">=":Oe=ee(Z,ge,Pe);break;case"<":Oe=z(Z,ge,Pe);break;case"<=":Oe=X(Z,ge,Pe);break;default:throw new TypeError("Invalid operator: "+fe)}return Oe}function he(Z,fe){if(Z instanceof he){if(Z.loose===fe)return Z;Z=Z.value}if(!(this instanceof he))return new he(Z,fe);k("comparator",Z,fe),this.loose=fe,this.parse(Z),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(Z,fe){return A(fe,Z)},e.major=function(Z,fe){return new le(Z,fe).major},e.minor=function(Z,fe){return new le(Z,fe).minor},e.patch=function(Z,fe){return new le(Z,fe).patch},e.compare=N,e.compareLoose=function(Z,fe){return N(Z,fe,!0)},e.rcompare=function(Z,fe,ge){return N(fe,Z,ge)},e.sort=function(Z,fe){return Z.sort(function(ge,Pe){return e.compare(ge,Pe,fe)})},e.rsort=function(Z,fe){return Z.sort(function(ge,Pe){return e.rcompare(ge,Pe,fe)})},e.gt=_,e.lt=z,e.eq=Y,e.neq=x,e.gte=ee,e.lte=X,e.cmp=ue,e.Comparator=he;var pe={};function $e(Z,fe){if(Z instanceof $e)return Z.loose===fe?Z:new $e(Z.raw,fe);if(Z instanceof he)return new $e(Z.value,fe);if(!(this instanceof $e))return new $e(Z,fe);if(this.loose=fe,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function ye(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function Se(Z,fe,ge,Pe,Oe,Te,Me,Fe,qe,xe,Ke,Be,He){return((fe=ye(ge)?"":ye(Pe)?">="+ge+".0.0":ye(Oe)?">="+ge+"."+Pe+".0":">="+fe)+" "+(Fe=ye(qe)?"":ye(xe)?"<"+(+qe+1)+".0.0":ye(Ke)?"<"+qe+"."+(+xe+1)+".0":Be?"<="+qe+"."+xe+"."+Ke+"-"+Be:"<="+Fe)).trim()}function ke(Z,fe){for(var ge=0;ge<Z.length;ge++)if(!Z[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<Z.length;ge++)if(k(Z[ge].semver),Z[ge].semver!==pe&&Z[ge].semver.prerelease.length>0){var Pe=Z[ge].semver;if(Pe.major===fe.major&&Pe.minor===fe.minor&&Pe.patch===fe.patch)return!0}return!1}return!0}function Re(Z,fe,ge){try{fe=new $e(fe,ge)}catch{return!1}return fe.test(Z)}function we(Z,fe,ge,Pe){var Oe,Te,Me,Fe,qe;switch(Z=new le(Z,Pe),fe=new $e(fe,Pe),ge){case">":Oe=_,Te=X,Me=z,Fe=">",qe=">=";break;case"<":Oe=z,Te=ee,Me=_,Fe="<",qe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Re(Z,fe,Pe))return!1;for(var xe=0;xe<fe.set.length;++xe){var Ke=fe.set[xe],Be=null,He=null;if(Ke.forEach(function(Xe){Xe.semver===pe&&(Xe=new he(">=0.0.0")),Be=Be||Xe,He=He||Xe,Oe(Xe.semver,Be.semver,Pe)?Be=Xe:Me(Xe.semver,He.semver,Pe)&&(He=Xe)}),Be.operator===Fe||Be.operator===qe||(!He.operator||He.operator===Fe)&&Te(Z,He.semver)||He.operator===qe&&Me(Z,He.semver))return!1}return!0}he.prototype.parse=function(Z){var fe=this.loose?E[J]:E[V],ge=Z.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+Z);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new le(ge[2],this.loose):this.semver=pe},he.prototype.toString=function(){return this.value},he.prototype.test=function(Z){return k("Comparator.test",Z,this.loose),this.semver===pe||(typeof Z=="string"&&(Z=new le(Z,this.loose)),ue(Z,this.operator,this.semver,this.loose))},he.prototype.intersects=function(Z,fe){if(!(Z instanceof he))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new $e(Z.value,fe),Re(this.value,ge,fe);if(Z.operator==="")return ge=new $e(this.value,fe),Re(Z.semver,ge,fe);var Pe=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),Oe=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),Te=this.semver.version===Z.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),Fe=ue(this.semver,"<",Z.semver,fe)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),qe=ue(this.semver,">",Z.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return Pe||Oe||Te&&Me||Fe||qe},e.Range=$e,$e.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},$e.prototype.toString=function(){return this.range},$e.prototype.parseRange=function(Z){var fe=this.loose;Z=Z.trim(),k("range",Z,fe);var ge=fe?E[B]:E[L];Z=Z.replace(ge,Se),k("hyphen replace",Z),Z=Z.replace(E[q],"$1$2$3"),k("comparator trim",Z,E[q]),Z=(Z=(Z=Z.replace(E[W],"$1~")).replace(E[ae],"$1^")).split(/\s+/).join(" ");var Pe=fe?E[J]:E[V],Oe=Z.split(" ").map(function(Te){return function(Me,Fe){return k("comp",Me),Me=function(qe,xe){return qe.trim().split(/\s+/).map(function(Ke){return function(Be,He){k("caret",Be,He);var Xe=He?E[ce]:E[te];return Be.replace(Xe,function(ne,de,me,ve,Ie){var Le;return k("caret",Be,ne,de,me,ve,Ie),ye(de)?Le="":ye(me)?Le=">="+de+".0.0 <"+(+de+1)+".0.0":ye(ve)?Le=de==="0"?">="+de+"."+me+".0 <"+de+"."+(+me+1)+".0":">="+de+"."+me+".0 <"+(+de+1)+".0.0":Ie?(k("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Le=de==="0"?me==="0"?">="+de+"."+me+"."+ve+Ie+" <"+de+"."+me+"."+(+ve+1):">="+de+"."+me+"."+ve+Ie+" <"+de+"."+(+me+1)+".0":">="+de+"."+me+"."+ve+Ie+" <"+(+de+1)+".0.0"):(k("no pr"),Le=de==="0"?me==="0"?">="+de+"."+me+"."+ve+" <"+de+"."+me+"."+(+ve+1):">="+de+"."+me+"."+ve+" <"+de+"."+(+me+1)+".0":">="+de+"."+me+"."+ve+" <"+(+de+1)+".0.0"),k("caret return",Le),Le})}(Ke,xe)}).join(" ")}(Me,Fe),k("caret",Me),Me=function(qe,xe){return qe.trim().split(/\s+/).map(function(Ke){return function(Be,He){var Xe=He?E[T]:E[F];return Be.replace(Xe,function(ne,de,me,ve,Ie){var Le;return k("tilde",Be,ne,de,me,ve,Ie),ye(de)?Le="":ye(me)?Le=">="+de+".0.0 <"+(+de+1)+".0.0":ye(ve)?Le=">="+de+"."+me+".0 <"+de+"."+(+me+1)+".0":Ie?(k("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Le=">="+de+"."+me+"."+ve+Ie+" <"+de+"."+(+me+1)+".0"):Le=">="+de+"."+me+"."+ve+" <"+de+"."+(+me+1)+".0",k("tilde return",Le),Le})}(Ke,xe)}).join(" ")}(Me,Fe),k("tildes",Me),Me=function(qe,xe){return k("replaceXRanges",qe,xe),qe.split(/\s+/).map(function(Ke){return function(Be,He){Be=Be.trim();var Xe=He?E[I]:E[D];return Be.replace(Xe,function(ne,de,me,ve,Ie,Le){k("xRange",Be,ne,de,me,ve,Ie,Le);var Qe=ye(me),Ze=Qe||ye(ve),_e=Ze||ye(Ie);return de==="="&&_e&&(de=""),Qe?ne=de===">"||de==="<"?"<0.0.0":"*":de&&_e?(Ze&&(ve=0),_e&&(Ie=0),de===">"?(de=">=",Ze?(me=+me+1,ve=0,Ie=0):_e&&(ve=+ve+1,Ie=0)):de==="<="&&(de="<",Ze?me=+me+1:ve=+ve+1),ne=de+me+"."+ve+"."+Ie):Ze?ne=">="+me+".0.0 <"+(+me+1)+".0.0":_e&&(ne=">="+me+"."+ve+".0 <"+me+"."+(+ve+1)+".0"),k("xRange return",ne),ne})}(Ke,xe)}).join(" ")}(Me,Fe),k("xrange",Me),Me=function(qe,xe){return k("replaceStars",qe,xe),qe.trim().replace(E[H],"")}(Me,Fe),k("stars",Me),Me}(Te,fe)}).join(" ").split(/\s+/);return this.loose&&(Oe=Oe.filter(function(Te){return!!Te.match(Pe)})),Oe=Oe.map(function(Te){return new he(Te,fe)})},$e.prototype.intersects=function(Z,fe){if(!(Z instanceof $e))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Pe){return Z.set.some(function(Oe){return Oe.every(function(Te){return Pe.intersects(Te,fe)})})})})},e.toComparators=function(Z,fe){return new $e(Z,fe).set.map(function(ge){return ge.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},$e.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new le(Z,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ke(this.set[fe],Z))return!0;return!1},e.satisfies=Re,e.maxSatisfying=function(Z,fe,ge){var Pe=null,Oe=null;try{var Te=new $e(fe,ge)}catch{return null}return Z.forEach(function(Me){Te.test(Me)&&(Pe&&Oe.compare(Me)!==-1||(Oe=new le(Pe=Me,ge)))}),Pe},e.minSatisfying=function(Z,fe,ge){var Pe=null,Oe=null;try{var Te=new $e(fe,ge)}catch{return null}return Z.forEach(function(Me){Te.test(Me)&&(Pe&&Oe.compare(Me)!==1||(Oe=new le(Pe=Me,ge)))}),Pe},e.validRange=function(Z,fe){try{return new $e(Z,fe).range||"*"}catch{return null}},e.ltr=function(Z,fe,ge){return we(Z,fe,"<",ge)},e.gtr=function(Z,fe,ge){return we(Z,fe,">",ge)},e.outside=we,e.prerelease=function(Z,fe){var ge=G(Z,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Z,fe,ge){return Z=new $e(Z,ge),fe=new $e(fe,ge),Z.intersects(fe)},e.coerce=function(Z){if(Z instanceof le)return Z;if(typeof Z!="string")return null;var fe=Z.match(E[O]);return fe==null?null:G((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,n(1))},function(K,e){var n,C,k=K.exports={};function R(){throw new Error("setTimeout has not been defined")}function j(){throw new Error("clearTimeout has not been defined")}function E(w){if(n===setTimeout)return setTimeout(w,0);if((n===R||!n)&&setTimeout)return n=setTimeout,setTimeout(w,0);try{return n(w,0)}catch{try{return n.call(null,w,0)}catch{return n.call(this,w,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:R}catch{n=R}try{C=typeof clearTimeout=="function"?clearTimeout:j}catch{C=j}})();var h,l=[],d=!1,p=-1;function v(){d&&h&&(d=!1,h.length?l=h.concat(l):p=-1,l.length&&$())}function $(){if(!d){var w=E(v);d=!0;for(var b=l.length;b;){for(h=l,l=[];++p<b;)h&&h[p].run();p=-1,b=l.length}h=null,d=!1,function(c){if(C===clearTimeout)return clearTimeout(c);if((C===j||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(c);try{C(c)}catch{try{return C.call(null,c)}catch{return C.call(this,c)}}}(w)}}function f(w,b){this.fun=w,this.array=b}function y(){}k.nextTick=function(w){var b=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)b[c-1]=arguments[c];l.push(new f(w,b)),l.length!==1||d||E($)},f.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=y,k.addListener=y,k.once=y,k.off=y,k.removeListener=y,k.removeAllListeners=y,k.emit=y,k.prependListener=y,k.prependOnceListener=y,k.listeners=function(w){return[]},k.binding=function(w){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(w){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(se[142],re([0,1]),function(K,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=void 0;class C{constructor(E,h,l){this.level=E,this.key=h,this.value=l,this.forward=[]}}const k=void 0;class R{constructor(E,h=2**16){this.comparator=E,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new C(this.c,k,k)}get size(){return this.f}clear(){this.e=new C(this.c,k,k),this.f=0}has(E){return!!R.g(this,E,this.comparator)}get(E){return R.g(this,E,this.comparator)?.value}set(E,h){return R.h(this,E,h,this.comparator)&&(this.f+=1),this}delete(E){const h=R.k(this,E,this.comparator);return h&&(this.f-=1),h}forEach(E,h){let l=this.e.forward[0];for(;l;)E.call(h,l.value,l.key,this),l=l.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",h=this.e.forward[0];for(;h;)E+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return E}static g(E,h,l){let d=E.e;for(let p=E.d-1;p>=0;p--)for(;d.forward[p]&&l(d.forward[p].key,h)<0;)d=d.forward[p];if(d=d.forward[0],d&&l(d.key,h)===0)return d}static h(E,h,l,d){const p=[];let v=E.e;for(let $=E.d-1;$>=0;$--){for(;v.forward[$]&&d(v.forward[$].key,h)<0;)v=v.forward[$];p[$]=v}if(v=v.forward[0],v&&d(v.key,h)===0)return v.value=l,!1;{const $=R.j(E);if($>E.d){for(let f=E.d;f<$;f++)p[f]=E.e;E.d=$}v=new C($,h,l);for(let f=0;f<$;f++)v.forward[f]=p[f].forward[f],p[f].forward[f]=v;return!0}}static j(E,h=.5){let l=1;for(;Math.random()<h&&l<E.c;)l+=1;return l}static k(E,h,l){const d=[];let p=E.e;for(let v=E.d-1;v>=0;v--){for(;p.forward[v]&&l(p.forward[v].key,h)<0;)p=p.forward[v];d[v]=p}if(p=p.forward[0],!p||l(p.key,h)!==0)return!1;for(let v=0;v<E.d&&d[v].forward[v]===p;v++)d[v].forward[v]=p.forward[v];for(;E.d>0&&E.e.forward[E.d-1]===k;)E.d-=1;return!0}}e.$Cs=R}),define(se[73],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(R){return new C(R)}constructor(R){this.c=n&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=C}),define(se[3],re([0,1,15,86,2,104,73]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=$;const E=!1,h=!1,l=!1;var d;(function(W){W.None=()=>k.$Uc.None;function F($e){if(l){const{onDidAddListener:ye}=$e,Se=y.create();let ke=0;$e.onDidAddListener=()=>{++ke===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Se.print()),ye?.()}}}function T($e,ye){return H($e,()=>{},0,void 0,!0,void 0,ye)}W.defer=T;function U($e){return(ye,Se=null,ke)=>{let Re=!1,we;return we=$e(Z=>{if(!Re)return we?we.dispose():Re=!0,ye.call(Se,Z)},null,ke),Re&&we.dispose(),we}}W.once=U;function ae($e,ye,Se){return L((ke,Re=null,we)=>$e(Z=>ke.call(Re,ye(Z)),null,we),Se)}W.map=ae;function te($e,ye,Se){return L((ke,Re=null,we)=>$e(Z=>{ye(Z),ke.call(Re,Z)},null,we),Se)}W.forEach=te;function ce($e,ye,Se){return L((ke,Re=null,we)=>$e(Z=>ye(Z)&&ke.call(Re,Z),null,we),Se)}W.filter=ce;function J($e){return $e}W.signal=J;function V(...$e){return(ye,Se=null,ke)=>{const Re=(0,k.$Rc)(...$e.map(we=>we(Z=>ye.call(Se,Z))));return B(Re,ke)}}W.any=V;function q($e,ye,Se,ke){let Re=Se;return ae($e,we=>(Re=ye(Re,we),Re),ke)}W.reduce=q;function L($e,ye){let Se;const ke={onWillAddFirstListener(){Se=$e(Re.fire,Re)},onDidRemoveLastListener(){Se?.dispose()}};ye||F(ke);const Re=new a(ke);return ye?.add(Re),Re.event}function B($e,ye){return ye instanceof Array?ye.push($e):ye&&ye.add($e),$e}function H($e,ye,Se=100,ke=!1,Re=!1,we,Z){let fe,ge,Pe,Oe=0,Te;const Me={leakWarningThreshold:we,onWillAddFirstListener(){fe=$e(qe=>{Oe++,ge=ye(ge,qe),ke&&!Pe&&(Fe.fire(ge),ge=void 0),Te=()=>{const xe=ge;ge=void 0,Pe=void 0,(!ke||Oe>1)&&Fe.fire(xe),Oe=0},typeof Se=="number"?(clearTimeout(Pe),Pe=setTimeout(Te,Se)):Pe===void 0&&(Pe=0,queueMicrotask(Te))})},onWillRemoveListener(){Re&&Oe>0&&Te?.()},onDidRemoveLastListener(){Te=void 0,fe.dispose()}};Z||F(Me);const Fe=new a(Me);return Z?.add(Fe),Fe.event}W.debounce=H;function oe($e,ye=0,Se){return W.debounce($e,(ke,Re)=>ke?(ke.push(Re),ke):[Re],ye,void 0,!0,void 0,Se)}W.accumulate=oe;function G($e,ye=(ke,Re)=>ke===Re,Se){let ke=!0,Re;return ce($e,we=>{const Z=ke||!ye(we,Re);return ke=!1,Re=we,Z},Se)}W.latch=G;function le($e,ye,Se){return[W.filter($e,ye,Se),W.filter($e,ke=>!ye(ke),Se)]}W.split=le;function Q($e,ye=!1,Se=[],ke){let Re=Se.slice(),we=$e(ge=>{Re?Re.push(ge):fe.fire(ge)});ke&&ke.add(we);const Z=()=>{Re?.forEach(ge=>fe.fire(ge)),Re=null},fe=new a({onWillAddFirstListener(){we||(we=$e(ge=>fe.fire(ge)),ke&&ke.add(we))},onDidAddFirstListener(){Re&&(ye?setTimeout(Z):Z())},onDidRemoveLastListener(){we&&we.dispose(),we=null}});return ke&&ke.add(fe),fe.event}W.buffer=Q;function A($e,ye){return(ke,Re,we)=>{const Z=ye(new _);return $e(function(fe){const ge=Z.evaluate(fe);ge!==N&&ke.call(Re,ge)},void 0,we)}}W.chain=A;const N=Symbol("HaltChainable");class _{constructor(){this.f=[]}map(ye){return this.f.push(ye),this}forEach(ye){return this.f.push(Se=>(ye(Se),Se)),this}filter(ye){return this.f.push(Se=>ye(Se)?Se:N),this}reduce(ye,Se){let ke=Se;return this.f.push(Re=>(ke=ye(ke,Re),ke)),this}latch(ye=(Se,ke)=>Se===ke){let Se=!0,ke;return this.f.push(Re=>{const we=Se||!ye(Re,ke);return Se=!1,ke=Re,we?Re:N}),this}evaluate(ye){for(const Se of this.f)if(ye=Se(ye),ye===N)break;return ye}}function z($e,ye,Se=ke=>ke){const ke=(...fe)=>Z.fire(Se(...fe)),Re=()=>$e.on(ye,ke),we=()=>$e.removeListener(ye,ke),Z=new a({onWillAddFirstListener:Re,onDidRemoveLastListener:we});return Z.event}W.fromNodeEventEmitter=z;function Y($e,ye,Se=ke=>ke){const ke=(...fe)=>Z.fire(Se(...fe)),Re=()=>$e.addEventListener(ye,ke),we=()=>$e.removeEventListener(ye,ke),Z=new a({onWillAddFirstListener:Re,onDidRemoveLastListener:we});return Z.event}W.fromDOMEventEmitter=Y;function x($e){return new Promise(ye=>U($e)(ye))}W.toPromise=x;function ee($e){const ye=new a;return $e.then(Se=>{ye.fire(Se)},()=>{ye.fire(void 0)}).finally(()=>{ye.dispose()}),ye.event}W.fromPromise=ee;function X($e,ye,Se){return ye(Se),$e(ke=>ye(ke))}W.runAndSubscribe=X;class ue{constructor(ye,Se){this._observable=ye,this.f=0,this.g=!1;const ke={onWillAddFirstListener:()=>{ye.addObserver(this)},onDidRemoveLastListener:()=>{ye.removeObserver(this)}};Se||F(ke),this.emitter=new a(ke),Se&&Se.add(this.emitter)}beginUpdate(ye){this.f++}handlePossibleChange(ye){}handleChange(ye,Se){this.g=!0}endUpdate(ye){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function he($e,ye){return new ue($e,ye).emitter.event}W.fromObservable=he;function pe($e){return(ye,Se,ke)=>{let Re=0,we=!1;const Z={beginUpdate(){Re++},endUpdate(){Re--,Re===0&&($e.reportChanges(),we&&(we=!1,ye.call(Se)))},handlePossibleChange(){},handleChange(){we=!0}};$e.addObserver(Z),$e.reportChanges();const fe={dispose(){$e.removeObserver(Z)}};return ke instanceof k.$Tc?ke.add(fe):Array.isArray(ke)&&ke.push(fe),fe}}W.fromObservableLight=pe})(d||(e.Event=d={}));class p{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${p.f++}`,p.all.add(this)}start(F){this.g=new j.$be,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$de=p;let v=-1;function $(W){const F=v;return v=W,{dispose(){v=F}}}class f{constructor(F,T=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=T,this.g=0}dispose(){this.f?.clear()}check(F,T){const U=this.threshold;if(U<=0||T<U)return;this.f||(this.f=new Map);const ae=this.f.get(F.value)||0;if(this.f.set(F.value,ae+1),this.g-=1,this.g<=0){this.g=U*.5;let te,ce=0;for(const[J,V]of this.f)(!te||ce<V)&&(te=J,ce=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${T} listeners already. MOST frequent listener (${ce}):`),console.warn(te)}return()=>{const te=this.f.get(F.value)||0;this.f.set(F.value,te-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class b{constructor(F){this.value=F,this.id=w++}}const c=2,m=(W,F)=>{if(W instanceof b)F(W);else for(let T=0;T<W.length;T++){const U=W[T];U&&F(U)}},S=E?new FinalizationRegistry(W=>{typeof W=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(W))}):void 0;class a{constructor(F){this.w=0,this.f=F,this.g=v>0||this.f?.leakWarningThreshold?new f(this.f?.leakWarningThreshold??v):void 0,this.j=this.f?._profName?new p(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(h){const F=this.t;queueMicrotask(()=>{m(F,T=>T.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,T,U)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),k.$Uc.None;if(this.m)return k.$Uc.None;T&&(F=F.bind(T));const ae=new b(F);let te,ce;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ae.stack=y.create(),te=this.g.check(ae.stack,this.w+1)),h&&(ae.stack=ce??y.create()),this.t?this.t instanceof b?(this.u??=new r,this.t=[this.t,ae]):this.t.push(ae):(this.f?.onWillAddFirstListener?.(this),this.t=ae,this.f?.onDidAddFirstListener?.(this)),this.w++;const J=(0,k.$Sc)(()=>{S?.unregister(J),te?.(),this.x(ae)});if(U instanceof k.$Tc?U.add(J):Array.isArray(U)&&U.push(J),S){const V=new Error().stack.split(`
`).slice(2).join(`
`).trim();S.register(J,V,J)}return J},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const T=this.t,U=T.indexOf(F);if(U===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,T[U]=void 0;const ae=this.u.current===this;if(this.w*c<=T.length){let te=0;for(let ce=0;ce<T.length;ce++)T[ce]?T[te++]=T[ce]:ae&&(this.u.end--,te<this.u.i&&this.u.i--);T.length=te}}y(F,T){if(!F)return;const U=this.f?.onListenerError||n.$1;if(!U){F.value(T);return}try{F.value(T)}catch(ae){U(ae)}}z(F){const T=F.current.t;for(;F.i<F.end;)this.y(T[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof b)this.y(this.t,F);else{const T=this.u;T.enqueue(this,F,this.t.length),this.z(T)}this.j?.stop()}hasListeners(){return this.w>0}}e.$fe=a;const t=()=>new r;e.$ge=t;class r{constructor(){this.i=-1,this.end=0}enqueue(F,T,U){this.i=0,this.end=U,this.current=F,this.value=T}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends a{async fireAsync(F,T,U){if(this.t)for(this.h||(this.h=new R.$5c),m(this.t,ae=>this.h.push([ae.value,F]));this.h.size>0&&!T.isCancellationRequested;){const[ae,te]=this.h.shift(),ce=[],J={...te,token:T,waitUntil:V=>{if(Object.isFrozen(ce))throw new Error("waitUntil can NOT be called asynchronous");U&&(V=U(V,ae)),ce.push(V)}};try{ae(J)}catch(V){(0,n.$1)(V);continue}Object.freeze(ce),await Promise.allSettled(ce).then(V=>{for(const q of V)q.status==="rejected"&&(0,n.$1)(q.reason)})}}}e.$he=s;class i extends a{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new R.$5c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$ie=i;class o extends i{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$je=o;class u extends a{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(T=>super.fire(T)),this.h=[]}))}}e.$ke=u;class g{constructor(){this.g=!1,this.h=[],this.f=new a({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const T={event:F,listener:null};this.h.push(T),this.g&&this.m(T);const U=()=>{this.g&&this.o(T);const ae=this.h.indexOf(T);this.h.splice(ae,1)};return(0,k.$Sc)((0,C.$db)(U))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(T=>this.f.fire(T))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$le=g;class P{constructor(F,T,U,ae){this.f=new k.$Tc;const te=this.f.add(new g),ce=this.f.add(new k.$4c);function J(V){ce.set(V,te.add(ae(V)))}for(const V of F)J(V);this.f.add(T(V=>{J(V)})),this.f.add(U(V=>{ce.deleteAndDispose(V)})),this.event=te.event}dispose(){this.f.dispose()}}e.$me=P;class D{constructor(){this.f=[]}wrapEvent(F,T,U){return(ae,te,ce)=>F(J=>{const V=this.f[this.f.length-1];if(!T){V?V.buffers.push(()=>ae.call(te,J)):ae.call(te,J);return}const q=V;if(!q){ae.call(te,T(U,J));return}q.items??=[],q.items.push(J),q.buffers.length===0&&V.buffers.push(()=>{q.reducedResult??=U?q.items.reduce(T,U):q.items.reduce(T),ae.call(te,q.reducedResult)})},void 0,ce)}bufferEvents(F){const T={buffers:new Array};this.f.push(T);const U=F();return this.f.pop(),T.buffers.forEach(ae=>ae()),U}}e.$ne=D;class I{constructor(){this.f=!1,this.g=d.None,this.h=k.$Uc.None,this.j=new a({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$oe=I;class O{static const(F){return new M(F)}constructor(F){this.g=F,this.f=new a,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$pe=O;class M{constructor(F){this.value=F,this.onDidChange=d.None}}}),define(se[23],re([0,1,3]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=e.CancellationToken=void 0,e.$re=E;const C=Object.freeze(function(h,l){const d=setTimeout(h.bind(l),0);return{dispose(){clearTimeout(d)}}});var k;(function(h){function l(d){return d===h.None||d===h.Cancelled||d instanceof R?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}h.isCancellationToken=l,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(k||(e.CancellationToken=k={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new n.$fe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class j{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=k.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=k.None}}e.$qe=j;function E(h){const l=new j;return h.add({dispose(){l.cancel()}}),l.token}}),define(se[143],re([0,1,23]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6e=e.$5e=e.$3e=void 0,e.$4e=k;class C{constructor(h){this.b=h,this.a=null}get(){if(this.a)return this.a;const h=new n.$qe,l=this.b(h.token);return this.a={promise:l,dispose:()=>{this.a=null,h.cancel(),h.dispose()}},this.a}}e.$3e=C;function k(E){return E}class R{constructor(h,l){this.a=void 0,this.b=void 0,typeof h=="function"?(this.c=h,this.d=k):(this.c=l,this.d=h.getCacheKey)}get(h){const l=this.d(h);return this.b!==l&&(this.b=l,this.a=this.c(h)),this.a}}e.$5e=R;class j{get cachedValues(){return this.a}constructor(h,l){this.a=new Map,this.b=new Map,typeof h=="function"?(this.c=h,this.d=k):(this.c=l,this.d=h.getCacheKey)}get(h){const l=this.d(h);if(this.b.has(l))return this.b.get(l);const d=this.c(h);return this.a.set(h,d),this.b.set(l,d),d}}e.$6e=j}),define(se[63],re([0,1,15,2]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=k,e.$te=R,e.$ue=j,e.$ve=E,e.$we=l,e.$xe=d,e.$ye=p,e.$ze=v,e.$Ae=$,e.$Be=f,e.$Ce=y,e.$De=w,e.$Ee=b,e.$Fe=c,e.$Ge=m;function k(S){const a=S;return a?typeof a.read=="function":!1}function R(S){const a=S;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}function j(S){const a=S;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}function E(S,a){return new h(S,a)}class h{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,n.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let r;switch(a){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const s=r.indexOf(t);s>=0&&r.splice(s,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(S,a){const t=[];let r;for(;(r=S.read())!==null;)t.push(r);return a(t)}function d(S,a,t){const r=[];let s;for(;(s=S.read())!==null&&r.length<t;)r.push(s);return s===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return S.read()}}}function p(S,a){return new Promise((t,r)=>{const s=[];v(S,{onData:i=>{a&&s.push(i)},onError:i=>{a?r(i):t(void 0)},onEnd:()=>{t(a?a(s):void 0)}})})}function v(S,a,t){S.on("error",r=>{t?.isCancellationRequested||a.onError(r)}),S.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),S.on("data",r=>{t?.isCancellationRequested||a.onData(r)})}function $(S,a){return new Promise((t,r)=>{const s=new C.$Tc,i=[],o=P=>{if(i.push(P),i.length>a)return s.dispose(),S.pause(),t({stream:S,buffer:i,ended:!1})},u=P=>(s.dispose(),r(P)),g=()=>(s.dispose(),t({stream:S,buffer:i,ended:!0}));s.add((0,C.$Sc)(()=>S.removeListener("error",u))),S.on("error",u),s.add((0,C.$Sc)(()=>S.removeListener("end",g))),S.on("end",g),s.add((0,C.$Sc)(()=>S.removeListener("data",o))),S.on("data",o)})}function f(S,a){const t=E(a);return t.end(S),t}function y(){const S=E(()=>{throw new Error("not supported")});return S.end(),S}function w(S){let a=!1;return{read:()=>a?null:(a=!0,S)}}function b(S,a,t){const r=E(t);return v(S,{onData:s=>r.write(a.data(s)),onError:s=>r.error(a.error?a.error(s):s),onEnd:()=>r.end()}),r}function c(S,a,t){let r=!1;return{read:()=>{const s=a.read();return r?s:(r=!0,s!==null?t([S,s]):S)}}}function m(S,a,t){let r=!1;const s=E(t);return v(a,{onData:i=>r?s.write(i):(r=!0,s.write(t([S,i]))),onError:i=>s.error(i),onEnd:()=>{r||(r=!0,s.write(S)),s.end()}}),s}}),define(se[17],re([0,1,62,63]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=void 0,e.$Ie=l,e.$Je=d,e.$Ke=p,e.$Le=v,e.$Me=$,e.$Ne=f,e.$Oe=y,e.$Pe=w,e.$Qe=b,e.$Re=c,e.$Se=m,e.$Te=S,e.$Ue=a,e.$Ve=t,e.$We=r,e.$Xe=s,e.$Ye=i,e.$Ze=o,e.$1e=u,e.$2e=D;const k=typeof Buffer<"u",R=new n.$V(()=>new Uint8Array(256));let j,E;class h{static alloc(O){return k?new h(Buffer.allocUnsafe(O)):new h(new Uint8Array(O))}static wrap(O){return k&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new h(O)}static fromString(O,M){return!(M?.dontUseNodeBuffer||!1)&&k?new h(Buffer.from(O)):(j||(j=new TextEncoder),new h(j.encode(O)))}static fromByteArray(O){const M=h.alloc(O.length);for(let W=0,F=O.length;W<F;W++)M.buffer[W]=O[W];return M}static concat(O,M){if(typeof M>"u"){M=0;for(let T=0,U=O.length;T<U;T++)M+=O[T].byteLength}const W=h.alloc(M);let F=0;for(let T=0,U=O.length;T<U;T++){const ae=O[T];W.set(ae,F),F+=ae.byteLength}return W}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=h.alloc(this.byteLength);return O.set(this),O}toString(){return k?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(O,M){return new h(this.buffer.subarray(O,M))}set(O,M){if(O instanceof h)this.buffer.set(O.buffer,M);else if(O instanceof Uint8Array)this.buffer.set(O,M);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),M);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return v(this.buffer,O)}writeUInt32BE(O,M){$(this.buffer,O,M)}readUInt32LE(O){return f(this.buffer,O)}writeUInt32LE(O,M){y(this.buffer,O,M)}readUInt8(O){return w(this.buffer,O)}writeUInt8(O,M){b(this.buffer,O,M)}indexOf(O,M=0){return l(this.buffer,O instanceof h?O.buffer:O,M)}}e.$He=h;function l(I,O,M=0){const W=O.byteLength,F=I.byteLength;if(W===0)return 0;if(W===1)return I.indexOf(O[0]);if(W>F-M)return-1;const T=R.value;T.fill(O.length);for(let ce=0;ce<O.length;ce++)T[O[ce]]=O.length-ce-1;let U=M+O.length-1,ae=U,te=-1;for(;U<F;)if(I[U]===O[ae]){if(ae===0){te=U;break}U--,ae--}else U+=Math.max(O.length-ae,T[I[U]]),ae=O.length-1;return te}function d(I,O){return I[O+0]<<0>>>0|I[O+1]<<8>>>0}function p(I,O,M){I[M+0]=O&255,O=O>>>8,I[M+1]=O&255}function v(I,O){return I[O]*2**24+I[O+1]*2**16+I[O+2]*2**8+I[O+3]}function $(I,O,M){I[M+3]=O,O=O>>>8,I[M+2]=O,O=O>>>8,I[M+1]=O,O=O>>>8,I[M]=O}function f(I,O){return I[O+0]<<0>>>0|I[O+1]<<8>>>0|I[O+2]<<16>>>0|I[O+3]<<24>>>0}function y(I,O,M){I[M+0]=O&255,O=O>>>8,I[M+1]=O&255,O=O>>>8,I[M+2]=O&255,O=O>>>8,I[M+3]=O&255}function w(I,O){return I[O]}function b(I,O,M){I[M]=O}function c(I){return C.$we(I,O=>h.concat(O))}function m(I){return C.$De(I)}function S(I){return C.$ye(I,O=>h.concat(O))}async function a(I){return I.ended?h.concat(I.buffer):h.concat([...I.buffer,await S(I.stream)])}function t(I){return C.$Be(I,O=>h.concat(O))}function r(I){return C.$Ee(I,{data:O=>typeof O=="string"?h.fromString(O):h.wrap(O)},O=>h.concat(O))}function s(I){return C.$ve(O=>h.concat(O),I)}function i(I,O){return C.$Fe(I,O,M=>h.concat(M))}function o(I,O){return C.$Ge(I,O,M=>h.concat(M))}function u(I){let O=0,M=0,W=0;const F=new Uint8Array(Math.floor(I.length/4*3)),T=ae=>{switch(M){case 3:F[W++]=O|ae,M=0;break;case 2:F[W++]=O|ae>>>2,O=ae<<6,M=3;break;case 1:F[W++]=O|ae>>>4,O=ae<<4,M=2;break;default:O=ae<<2,M=1}};for(let ae=0;ae<I.length;ae++){const te=I.charCodeAt(ae);if(te>=65&&te<=90)T(te-65);else if(te>=97&&te<=122)T(te-97+26);else if(te>=48&&te<=57)T(te-48+52);else if(te===43||te===45)T(62);else if(te===47||te===95)T(63);else{if(te===61)break;throw new SyntaxError(`Unexpected base64 character ${I[ae]}`)}}const U=W;for(;M>0;)T(0);return h.wrap(F).slice(0,U)}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:I},O=!0,M=!1){const W=M?P:g;let F="";const T=I.byteLength%3;let U=0;for(;U<I.byteLength-T;U+=3){const ae=I[U+0],te=I[U+1],ce=I[U+2];F+=W[ae>>>2],F+=W[(ae<<4|te>>>4)&63],F+=W[(te<<2|ce>>>6)&63],F+=W[ce&63]}if(T===1){const ae=I[U+0];F+=W[ae>>>2],F+=W[ae<<4&63],O&&(F+="==")}else if(T===2){const ae=I[U+0],te=I[U+1];F+=W[ae>>>2],F+=W[(ae<<4|te>>>4)&63],F+=W[te<<2&63],O&&(F+="=")}return F}}),define(se[25],re([0,1,143,62]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.GraphemeBreakType=e.$Xf=e.$Pf=e.$If=e.$Hf=void 0,e.$9e=k,e.$0e=j,e.$$e=h,e.$_e=l,e.$af=d,e.$bf=p,e.$cf=v,e.$df=$,e.$ef=f,e.$ff=y,e.$gf=w,e.$hf=b,e.$if=c,e.$jf=m,e.$kf=S,e.$lf=a,e.$mf=t,e.$nf=r,e.$of=s,e.$pf=i,e.$qf=o,e.$rf=u,e.$sf=g,e.$tf=P,e.$uf=D,e.$vf=I,e.$wf=O,e.$xf=M,e.$yf=W,e.$zf=F,e.$Af=T,e.$Bf=U,e.$Cf=ae,e.$Df=te,e.$Ef=ce,e.$Ff=J,e.$Gf=V,e.$Jf=H,e.$Kf=oe,e.$Lf=G,e.$Mf=le,e.$Nf=N,e.$Of=z,e.$Qf=Y,e.$Rf=x,e.$Sf=ee,e.$Tf=X,e.$Uf=he,e.$Vf=pe,e.$Wf=ye,e.$Yf=Se,e.$Zf=ke,e.$1f=Re,e.$2f=we,e.$3f=Z,e.$4f=fe,e.$5f=ge,e.$6f=Pe,e.$7f=qe;function k(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}const R=/{(\d+)}/g;function j(ne,...de){return de.length===0?ne:ne.replace(R,function(me,ve){const Ie=parseInt(ve,10);return isNaN(Ie)||Ie<0||Ie>=de.length?me:de[Ie]})}const E=/{([^}]+)}/g;function h(ne,de){return Object.keys(de).length===0?ne:ne.replace(E,(me,ve)=>de[ve]??me)}function l(ne){return ne.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}function d(ne){return ne.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}function p(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function v(ne,de){let me=0,ve=ne.indexOf(de);for(;ve!==-1;)me++,ve=ne.indexOf(de,ve+de.length);return me}function $(ne,de,me="\u2026"){return ne.length<=de?ne:`${ne.substr(0,de)}${me}`}function f(ne,de,me="\u2026"){if(ne.length<=de)return ne;const ve=Math.ceil(de/2)-me.length/2,Ie=Math.floor(de/2)-me.length/2;return`${ne.substr(0,ve)}${me}${ne.substr(ne.length-Ie)}`}function y(ne,de=" "){const me=w(ne,de);return b(me,de)}function w(ne,de){if(!ne||!de)return ne;const me=de.length;if(me===0||ne.length===0)return ne;let ve=0;for(;ne.indexOf(de,ve)===ve;)ve=ve+me;return ne.substring(ve)}function b(ne,de){if(!ne||!de)return ne;const me=de.length,ve=ne.length;if(me===0||ve===0)return ne;let Ie=ve,Le=-1;for(;Le=ne.lastIndexOf(de,Ie-1),!(Le===-1||Le+me!==Ie);){if(Le===0)return"";Ie=Le}return ne.substring(0,Ie)}function c(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function m(ne){return ne.replace(/\*/g,"")}function S(ne,de,me={}){if(!ne)throw new Error("Cannot create regex from empty string");de||(ne=p(ne)),me.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let ve="";return me.global&&(ve+="g"),me.matchCase||(ve+="i"),me.multiline&&(ve+="m"),me.unicode&&(ve+="u"),new RegExp(ne,ve)}function a(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}function t(ne){return ne.split(/\r\n|\r|\n/)}function r(ne){const de=[],me=ne.split(/(\r\n|\r|\n)/);for(let ve=0;ve<Math.ceil(me.length/2);ve++)de.push(me[2*ve]+(me[2*ve+1]??""));return de}function s(ne){for(let de=0,me=ne.length;de<me;de++){const ve=ne.charCodeAt(de);if(ve!==32&&ve!==9)return de}return-1}function i(ne,de=0,me=ne.length){for(let ve=de;ve<me;ve++){const Ie=ne.charCodeAt(ve);if(Ie!==32&&Ie!==9)return ne.substring(de,ve)}return ne.substring(de,me)}function o(ne,de=ne.length-1){for(let me=de;me>=0;me--){const ve=ne.charCodeAt(me);if(ve!==32&&ve!==9)return me}return-1}function u(ne,de,me){const ve=[];let Ie=0;for(const Le of ne.matchAll(de)){if(ve.push(ne.slice(Ie,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");Ie=Le.index+Le[0].length,ve.push(me(Le[0],...Le.slice(1),Le.index,ne,Le.groups))}return ve.push(ne.slice(Ie)),Promise.all(ve).then(Le=>Le.join(""))}function g(ne,de){return ne<de?-1:ne>de?1:0}function P(ne,de,me=0,ve=ne.length,Ie=0,Le=de.length){for(;me<ve&&Ie<Le;me++,Ie++){const _e=ne.charCodeAt(me),st=de.charCodeAt(Ie);if(_e<st)return-1;if(_e>st)return 1}const Qe=ve-me,Ze=Le-Ie;return Qe<Ze?-1:Qe>Ze?1:0}function D(ne,de){return I(ne,de,0,ne.length,0,de.length)}function I(ne,de,me=0,ve=ne.length,Ie=0,Le=de.length){for(;me<ve&&Ie<Le;me++,Ie++){let _e=ne.charCodeAt(me),st=de.charCodeAt(Ie);if(_e===st)continue;if(_e>=128||st>=128)return P(ne.toLowerCase(),de.toLowerCase(),me,ve,Ie,Le);M(_e)&&(_e-=32),M(st)&&(st-=32);const Ye=_e-st;if(Ye!==0)return Ye}const Qe=ve-me,Ze=Le-Ie;return Qe<Ze?-1:Qe>Ze?1:0}function O(ne){return ne>=48&&ne<=57}function M(ne){return ne>=97&&ne<=122}function W(ne){return ne>=65&&ne<=90}function F(ne,de){return ne.length===de.length&&I(ne,de)===0}function T(ne,de){const me=de.length;return de.length>ne.length?!1:I(ne,de,0,me)===0}function U(ne,de){const me=Math.min(ne.length,de.length);let ve;for(ve=0;ve<me;ve++)if(ne.charCodeAt(ve)!==de.charCodeAt(ve))return ve;return me}function ae(ne,de){const me=Math.min(ne.length,de.length);let ve;const Ie=ne.length-1,Le=de.length-1;for(ve=0;ve<me;ve++)if(ne.charCodeAt(Ie-ve)!==de.charCodeAt(Le-ve))return ve;return me}function te(ne){return 55296<=ne&&ne<=56319}function ce(ne){return 56320<=ne&&ne<=57343}function J(ne,de){return(ne-55296<<10)+(de-56320)+65536}function V(ne,de,me){const ve=ne.charCodeAt(me);if(te(ve)&&me+1<de){const Ie=ne.charCodeAt(me+1);if(ce(Ie))return J(ve,Ie)}return ve}function q(ne,de){const me=ne.charCodeAt(de-1);if(ce(me)&&de>1){const ve=ne.charCodeAt(de-2);if(te(ve))return J(ve,me)}return me}class L{get offset(){return this.e}constructor(de,me=0){this.c=de,this.d=de.length,this.e=me}setOffset(de){this.e=de}prevCodePoint(){const de=q(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=V(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$Hf=L;class B{get offset(){return this.c.offset}constructor(de,me=0){this.c=new L(de,me)}nextGraphemeLength(){const de=Me.getInstance(),me=this.c,ve=me.offset;let Ie=de.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Le=me.offset,Qe=de.getGraphemeBreakType(me.nextCodePoint());if(Oe(Ie,Qe)){me.setOffset(Le);break}Ie=Qe}return me.offset-ve}prevGraphemeLength(){const de=Me.getInstance(),me=this.c,ve=me.offset;let Ie=de.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Le=me.offset,Qe=de.getGraphemeBreakType(me.prevCodePoint());if(Oe(Qe,Ie)){me.setOffset(Le);break}Ie=Qe}return ve-me.offset}eol(){return this.c.eol()}}e.$If=B;function H(ne,de){return new B(ne,de).nextGraphemeLength()}function oe(ne,de){return new B(ne,de).prevGraphemeLength()}function G(ne,de){de>0&&ce(ne.charCodeAt(de))&&de--;const me=de+H(ne,de);return[me-oe(ne,me),me]}function le(ne){const de=new B(ne);let me=0;for(;!de.eol();)me++,de.nextGraphemeLength();return me}let Q;function A(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(ne){return Q||(Q=A()),Q.test(ne)}const _=/^[\t\n\r\x20-\x7E]*$/;function z(ne){return _.test(ne)}e.$Pf=/[\u2028\u2029]/;function Y(ne){return e.$Pf.test(ne)}function x(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}function ee(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}function X(ne,de,me=""){const ve=ne.trimStart();if(ve.length<de)return ve;const Ie=/\b/g;let Le=0;for(;Ie.test(ve)&&!(ve.length-Ie.lastIndex<de);)Le=Ie.lastIndex,Ie.lastIndex+=1;return Le===0?ve:me+ve.substring(Le).trimStart()}const ue=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*he(ne){let de=0;for(const me of ne.matchAll(ue))de!==me.index&&(yield{isCode:!1,str:ne.substring(de,me.index)}),yield{isCode:!0,str:me[0]},de=me.index+me[0].length;de!==ne.length&&(yield{isCode:!1,str:ne.substring(de)})}function pe(ne){return ne&&(ne=ne.replace(ue,"")),ne}const $e=/\\\[.*?\\\]/g;function ye(ne){return pe(ne).replace($e,"")}e.$Xf="\uFEFF";function Se(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}function ke(ne){return Se(ne)?ne.substr(1):ne}function Re(ne,de){if(!ne||!de||ne.length<de.length)return!1;const me=de.length,ve=ne.toLowerCase();let Ie=0,Le=-1;for(;Ie<me;){const Qe=ve.indexOf(de[Ie],Le+1);if(Qe<0)return!1;Le=Qe,Ie++}return!0}function we(ne,de=!1){return ne?(de&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}function Z(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}function fe(ne,de=1){if(de===0)return"";let me=-1;do me=ne.indexOf(`
`,me+1),de--;while(de>0&&me>=0);return me===-1?ne:(ne[me-1]==="\r"&&me--,ne.substr(0,me))}function ge(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}function Pe(ne){return Me.getInstance().getGraphemeBreakType(ne)}function Oe(ne,de){return ne===0?de!==5&&de!==7:ne===2&&de===3?!1:ne===4||ne===2||ne===3||de===4||de===2||de===3?!0:!(ne===8&&(de===8||de===9||de===11||de===12)||(ne===11||ne===9)&&(de===9||de===10)||(ne===12||ne===10)&&de===10||de===5||de===13||de===7||ne===1||ne===13&&de===14||ne===6&&de===6)}var Te;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(Te||(e.GraphemeBreakType=Te={}));class Me{static{this.c=null}static getInstance(){return Me.c||(Me.c=new Me),Me.c}constructor(){this.d=Fe()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const me=this.d,ve=me.length/3;let Ie=1;for(;Ie<=ve;)if(de<me[3*Ie])Ie=2*Ie;else if(de>me[3*Ie+1])Ie=2*Ie+1;else return me[3*Ie+2];return 0}}function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(ne,de){if(ne===0)return 0;const me=xe(ne,de);if(me!==void 0)return me;const ve=new L(de,ne);return ve.prevCodePoint(),ve.offset}function xe(ne,de){const me=new L(de,ne);let ve=me.prevCodePoint();for(;Ke(ve)||ve===65039||ve===8419;){if(me.offset===0)return;ve=me.prevCodePoint()}if(!ee(ve))return;let Ie=me.offset;return Ie>0&&me.prevCodePoint()===8205&&(Ie=me.offset),Ie}function Ke(ne){return 127995<=ne&&ne<=127999}var Be;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.$8f="\xA0";class He{static{this.c=new C.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$5e({getCacheKey:JSON.stringify},de=>{function me(Ye){const ot=new Map;for(let rt=0;rt<Ye.length;rt+=2)ot.set(Ye[rt],Ye[rt+1]);return ot}function ve(Ye,ot){const rt=new Map(Ye);for(const[ct,lt]of ot)rt.set(ct,lt);return rt}function Ie(Ye,ot){if(!Ye)return ot;const rt=new Map;for(const[ct,lt]of Ye)ot.has(ct)&&rt.set(ct,lt);return rt}const Le=this.c.value;let Qe=de.filter(Ye=>!Ye.startsWith("_")&&Ye in Le);Qe.length===0&&(Qe=["_default"]);let Ze;for(const Ye of Qe){const ot=me(Le[Ye]);Ze=Ie(Ze,ot)}const _e=me(Le._common),st=ve(_e,Ze);return new He(st)})}static getInstance(de){return He.d.get(Array.from(de))}static{this.e=new C.$V(()=>Object.keys(He.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return He.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$9f=He;class Xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Xe.c())),this.d}static isInvisibleCharacter(de){return Xe.e().has(de)}static get codePoints(){return Xe.e()}}e.$0f=Xe}),define(se[46],re([0,1,25]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sj=e.$qj=void 0,e.$mj=C,e.$nj=k,e.$oj=R,e.$pj=E,e.$rj=y;function C(b){return k(b,0)}function k(b,c){switch(typeof b){case"object":return b===null?R(349,c):Array.isArray(b)?h(b,c):l(b,c);case"string":return E(b,c);case"boolean":return j(b,c);case"number":return R(b,c);case"undefined":return R(937,c);default:return R(617,c)}}function R(b,c){return(c<<5)-c+b|0}function j(b,c){return R(b?433:863,c)}function E(b,c){c=R(149417,c);for(let m=0,S=b.length;m<S;m++)c=R(b.charCodeAt(m),c);return c}function h(b,c){return c=R(104579,c),b.reduce((m,S)=>k(S,m),c)}function l(b,c){return c=R(181387,c),Object.keys(b).sort().reduce((m,S)=>(m=E(S,m),k(b[S],m)),c)}class d{constructor(){this.g=0}get value(){return this.g}hash(c){return this.g=k(c,this.g),this.g}}e.$qj=d;var p;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function v(b,c,m=32){const S=m-c,a=~((1<<S)-1);return(b<<c|(a&b)>>>S)>>>0}function $(b,c=0,m=b.byteLength,S=0){for(let a=0;a<m;a++)b[c+a]=S}function f(b,c,m="0"){for(;b.length<c;)b=m+b;return b}function y(b,c=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(m=>m.toString(16).padStart(2,"0")).join(""):f((b>>>0).toString(16),c/4)}class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(c){const m=c.length;if(m===0)return;const S=this.p;let a=this.r,t=this.u,r,s;for(t!==0?(r=t,s=-1,t=0):(r=c.charCodeAt(0),s=0);;){let i=r;if(n.$Df(r))if(s+1<m){const o=c.charCodeAt(s+1);n.$Ef(o)?(s++,i=n.$Ff(r,o)):i=65533}else{t=r;break}else n.$Ef(r)&&(i=65533);if(a=this.w(S,a,i),s++,s<m)r=c.charCodeAt(s);else break}this.r=a,this.u=t}w(c,m,S){return S<128?c[m++]=S:S<2048?(c[m++]=192|(S&1984)>>>6,c[m++]=128|(S&63)>>>0):S<65536?(c[m++]=224|(S&61440)>>>12,c[m++]=128|(S&4032)>>>6,c[m++]=128|(S&63)>>>0):(c[m++]=240|(S&1835008)>>>18,c[m++]=128|(S&258048)>>>12,c[m++]=128|(S&4032)>>>6,c[m++]=128|(S&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,c[0]=c[64],c[1]=c[65],c[2]=c[66]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const c=8*this.t;this.q.setUint32(56,Math.floor(c/4294967296),!1),this.q.setUint32(60,c%4294967296,!1),this.y()}y(){const c=w.g,m=this.q;for(let g=0;g<64;g+=4)c.setUint32(g,m.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)c.setUint32(g,v(c.getUint32(g-12,!1)^c.getUint32(g-32,!1)^c.getUint32(g-56,!1)^c.getUint32(g-64,!1),1),!1);let S=this.h,a=this.l,t=this.m,r=this.n,s=this.o,i,o,u;for(let g=0;g<80;g++)g<20?(i=a&t|~a&r,o=1518500249):g<40?(i=a^t^r,o=1859775393):g<60?(i=a&t|a&r|t&r,o=2400959708):(i=a^t^r,o=3395469782),u=v(S,5)+i+s+o+c.getUint32(g*4,!1)&4294967295,s=r,r=t,t=v(a,30),a=S,S=u;this.h=this.h+S&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+s&4294967295}}e.$sj=w}),define(se[74],re([0,1,25]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(C||(C={})),function(k){const R="error",j="warning",E="warn",h="info",l="ignore";function d(v){return v?n.$zf(R,v)?k.Error:n.$zf(j,v)||n.$zf(E,v)?k.Warning:n.$zf(h,v)?k.Info:k.Ignore:k.Ignore}k.fromValue=d;function p(v){switch(v){case k.Error:return R;case k.Warning:return j;case k.Info:return h;default:return l}}k.toString=p}(C||(C={})),e.default=C}),define(se[144],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(se[59],re([0,1,22,25]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class k{constructor(){this.b="",this.c=0}reset($){return this.b=$,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp($){const f=$.charCodeAt(0),y=this.b.charCodeAt(this.c);return f-y}value(){return this.b[this.c]}}e.$Ai=k;class R{constructor($=!0){this.e=$}reset($){return this.b=$,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let $=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if($)this.c++;else break;else $=!1;return this}cmp($){return this.e?(0,C.$tf)($,this.b,0,$.length,this.c,this.d):(0,C.$vf)($,this.b,0,$.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Bi=R;class j{constructor($=!0,f=!0){this.f=$,this.g=f}reset($){this.d=0,this.e=0,this.b=$,this.c=$.length;for(let f=$.length-1;f>=0;f--,this.c--){const y=this.b.charCodeAt(f);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let $=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if($)this.d++;else break;else $=!1}return this}cmp($){return this.g?(0,C.$tf)($,this.b,0,$.length,this.d,this.e):(0,C.$vf)($,this.b,0,$.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ci=j;var E;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(E||(E={}));class h{constructor($,f){this.f=$,this.g=f,this.d=[],this.e=0}reset($){return this.c=$,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new j(!1,!this.f($)),this.b.reset($.path),this.b.value()&&this.d.push(3)),this.g($)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp($){if(this.d[this.e]===1)return(0,C.$uf)($,this.c.scheme);if(this.d[this.e]===2)return(0,C.$uf)($,this.c.authority);if(this.d[this.e]===3)return this.b.cmp($);if(this.d[this.e]===4)return(0,C.$sf)($,this.c.query);if(this.d[this.e]===5)return(0,C.$sf)($,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Di=h;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const $=this.right;return this.right=$.left,$.left=this,this.updateHeight(),$.updateHeight(),$}rotateRight(){const $=this.left;return this.left=$.right,$.right=this,this.updateHeight(),$.updateHeight(),$}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(d||(d={}));class p{static forUris($=()=>!1,f=()=>!1){return new p(new h($,f))}static forPaths($=!1){return new p(new j(void 0,!$))}static forStrings(){return new p(new k)}static forConfigKeys(){return new p(new R)}constructor($){this.b=$}clear(){this.c=void 0}fill($,f){if(f){const y=f.slice(0);(0,n.$Wb)(y);for(const w of y)this.set(w,$)}else{const y=$.slice(0);(0,n.$Wb)(y);for(const w of y)this.set(w[0],w[1])}}set($,f){const y=this.b.reset($);let w;this.c||(this.c=new l,this.c.segment=y.value());const b=[];for(w=this.c;;){const m=y.cmp(w.segment);if(m>0)w.left||(w.left=new l,w.left.segment=y.value()),b.push([-1,w]),w=w.left;else if(m<0)w.right||(w.right=new l,w.right.segment=y.value()),b.push([1,w]),w=w.right;else if(y.hasNext())y.next(),w.mid||(w.mid=new l,w.mid.segment=y.value()),b.push([0,w]),w=w.mid;else break}const c=w.value;w.value=f,w.key=$;for(let m=b.length-1;m>=0;m--){const S=b[m][1];S.updateHeight();const a=S.balanceFactor();if(a<-1||a>1){const t=b[m][0],r=b[m+1][0];if(t===1&&r===1)b[m][1]=S.rotateLeft();else if(t===-1&&r===-1)b[m][1]=S.rotateRight();else if(t===1&&r===-1)S.right=b[m+1][1]=b[m+1][1].rotateRight(),b[m][1]=S.rotateLeft();else if(t===-1&&r===1)S.left=b[m+1][1]=b[m+1][1].rotateLeft(),b[m][1]=S.rotateRight();else throw new Error;if(m>0)switch(b[m-1][0]){case-1:b[m-1][1].left=b[m][1];break;case 1:b[m-1][1].right=b[m][1];break;case 0:b[m-1][1].mid=b[m][1];break}else this.c=b[0][1]}}return c}get($){return this.d($)?.value}d($){const f=this.b.reset($);let y=this.c;for(;y;){const w=f.cmp(y.segment);if(w>0)y=y.left;else if(w<0)y=y.right;else if(f.hasNext())f.next(),y=y.mid;else break}return y}has($){const f=this.d($);return!(f?.value===void 0&&f?.mid===void 0)}delete($){return this.e($,!1)}deleteSuperstr($){return this.e($,!0)}e($,f){const y=this.b.reset($),w=[];let b=this.c;for(;b;){const c=y.cmp(b.segment);if(c>0)w.push([-1,b]),b=b.left;else if(c<0)w.push([1,b]),b=b.right;else if(y.hasNext())y.next(),w.push([0,b]),b=b.mid;else break}if(b){if(f?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const c=this.f(b.right);if(c.key){const{key:m,value:S,segment:a}=c;this.e(c.key,!1),b.key=m,b.value=S,b.segment=a}}else{const c=b.left??b.right;if(w.length>0){const[m,S]=w[w.length-1];switch(m){case-1:S.left=c;break;case 0:S.mid=c;break;case 1:S.right=c;break}}else this.c=c}for(let c=w.length-1;c>=0;c--){const m=w[c][1];m.updateHeight();const S=m.balanceFactor();if(S>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),w[c][1]=m.rotateLeft()):S<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),w[c][1]=m.rotateRight()),c>0)switch(w[c-1][0]){case-1:w[c-1][1].left=w[c][1];break;case 1:w[c-1][1].right=w[c][1];break;case 0:w[c-1][1].mid=w[c][1];break}else this.c=w[0][1]}}}f($){for(;$.left;)$=$.left;return $}findSubstr($){const f=this.b.reset($);let y=this.c,w;for(;y;){const b=f.cmp(y.segment);if(b>0)y=y.left;else if(b<0)y=y.right;else if(f.hasNext())f.next(),w=y.value||w,y=y.mid;else break}return y&&y.value||w}findSuperstr($){return this.g($,!1)}g($,f){const y=this.b.reset($);let w=this.c;for(;w;){const b=y.cmp(w.segment);if(b>0)w=w.left;else if(b<0)w=w.right;else if(y.hasNext())y.next(),w=w.mid;else return w.mid?this.h(w.mid):f?w.value:void 0}}hasElementOrSubtree($){return this.g($,!0)!==void 0}forEach($){for(const[f,y]of this)$(y,f)}*[Symbol.iterator](){yield*this.h(this.c)}h($){const f=[];return this.j($,f),f[Symbol.iterator]()}j($,f){$&&($.left&&this.j($.left,f),$.value&&f.push([$.key,$.value]),$.mid&&this.j($.mid,f),$.right&&this.j($.right,f))}_isBalanced(){const $=f=>{if(!f)return!0;const y=f.balanceFactor();return y<-1||y>1?!1:$(f.left)&&$(f.right)};return $(this.c)}}e.$Ei=p}),define(se[12],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$f=n,e.$_f=C,e.$ag=k,e.$bg=R,e.$cg=j,e.$dg=E,e.$eg=h,e.$fg=l,e.$gg=d,e.$hg=p,e.$ig=v,e.$jg=$,e.$kg=f,e.$lg=w,e.$mg=b,e.$ng=c,e.$og=m,e.$pg=S;function n(a){return typeof a=="string"}function C(a){return Array.isArray(a)&&a.every(t=>n(t))}function k(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function R(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}function j(a){return typeof a=="number"&&!isNaN(a)}function E(a){return!!a&&typeof a[Symbol.iterator]=="function"}function h(a){return a===!0||a===!1}function l(a){return typeof a>"u"}function d(a){return!p(a)}function p(a){return l(a)||a===null}function v(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function $(a){if(p(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function f(...a){const t=[];for(let r=0;r<a.length;r++){const s=a[r];if(p(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(s)}return t}const y=Object.prototype.hasOwnProperty;function w(a){if(!k(a))return!1;for(const t in a)if(y.call(a,t))return!1;return!0}function b(a){return typeof a=="function"}function c(...a){return a.length>0&&a.every(b)}function m(a,t){const r=Math.min(a.length,t.length);for(let s=0;s<r;s++)S(a[s],t[s])}function S(a,t){if(n(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(b(t)){try{if(a instanceof t)return}catch{}if(!p(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(se[105],re([0,1,12]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=k,e.$Tj=R;const C=Object.create(null);function k(j,E){if((0,n.$$f)(E)){const h=C[E];if(h===void 0)throw new Error(`${j} references an unknown codicon: ${E}`);E=h}return C[j]=E,{id:j}}function R(){return C}}),define(se[145],re([0,1,105]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=void 0,e.$Uj={add:(0,n.$Sj)("add",6e4),plus:(0,n.$Sj)("plus",6e4),gistNew:(0,n.$Sj)("gist-new",6e4),repoCreate:(0,n.$Sj)("repo-create",6e4),lightbulb:(0,n.$Sj)("lightbulb",60001),lightBulb:(0,n.$Sj)("light-bulb",60001),repo:(0,n.$Sj)("repo",60002),repoDelete:(0,n.$Sj)("repo-delete",60002),gistFork:(0,n.$Sj)("gist-fork",60003),repoForked:(0,n.$Sj)("repo-forked",60003),gitPullRequest:(0,n.$Sj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Sj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Sj)("record-keys",60005),keyboard:(0,n.$Sj)("keyboard",60005),tag:(0,n.$Sj)("tag",60006),gitPullRequestLabel:(0,n.$Sj)("git-pull-request-label",60006),tagAdd:(0,n.$Sj)("tag-add",60006),tagRemove:(0,n.$Sj)("tag-remove",60006),person:(0,n.$Sj)("person",60007),personFollow:(0,n.$Sj)("person-follow",60007),personOutline:(0,n.$Sj)("person-outline",60007),personFilled:(0,n.$Sj)("person-filled",60007),gitBranch:(0,n.$Sj)("git-branch",60008),gitBranchCreate:(0,n.$Sj)("git-branch-create",60008),gitBranchDelete:(0,n.$Sj)("git-branch-delete",60008),sourceControl:(0,n.$Sj)("source-control",60008),mirror:(0,n.$Sj)("mirror",60009),mirrorPublic:(0,n.$Sj)("mirror-public",60009),star:(0,n.$Sj)("star",60010),starAdd:(0,n.$Sj)("star-add",60010),starDelete:(0,n.$Sj)("star-delete",60010),starEmpty:(0,n.$Sj)("star-empty",60010),comment:(0,n.$Sj)("comment",60011),commentAdd:(0,n.$Sj)("comment-add",60011),alert:(0,n.$Sj)("alert",60012),warning:(0,n.$Sj)("warning",60012),search:(0,n.$Sj)("search",60013),searchSave:(0,n.$Sj)("search-save",60013),logOut:(0,n.$Sj)("log-out",60014),signOut:(0,n.$Sj)("sign-out",60014),logIn:(0,n.$Sj)("log-in",60015),signIn:(0,n.$Sj)("sign-in",60015),eye:(0,n.$Sj)("eye",60016),eyeUnwatch:(0,n.$Sj)("eye-unwatch",60016),eyeWatch:(0,n.$Sj)("eye-watch",60016),circleFilled:(0,n.$Sj)("circle-filled",60017),primitiveDot:(0,n.$Sj)("primitive-dot",60017),closeDirty:(0,n.$Sj)("close-dirty",60017),debugBreakpoint:(0,n.$Sj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Sj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Sj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Sj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Sj)("primitive-square",60018),edit:(0,n.$Sj)("edit",60019),pencil:(0,n.$Sj)("pencil",60019),info:(0,n.$Sj)("info",60020),issueOpened:(0,n.$Sj)("issue-opened",60020),gistPrivate:(0,n.$Sj)("gist-private",60021),gitForkPrivate:(0,n.$Sj)("git-fork-private",60021),lock:(0,n.$Sj)("lock",60021),mirrorPrivate:(0,n.$Sj)("mirror-private",60021),close:(0,n.$Sj)("close",60022),removeClose:(0,n.$Sj)("remove-close",60022),x:(0,n.$Sj)("x",60022),repoSync:(0,n.$Sj)("repo-sync",60023),sync:(0,n.$Sj)("sync",60023),clone:(0,n.$Sj)("clone",60024),desktopDownload:(0,n.$Sj)("desktop-download",60024),beaker:(0,n.$Sj)("beaker",60025),microscope:(0,n.$Sj)("microscope",60025),vm:(0,n.$Sj)("vm",60026),deviceDesktop:(0,n.$Sj)("device-desktop",60026),file:(0,n.$Sj)("file",60027),fileText:(0,n.$Sj)("file-text",60027),more:(0,n.$Sj)("more",60028),ellipsis:(0,n.$Sj)("ellipsis",60028),kebabHorizontal:(0,n.$Sj)("kebab-horizontal",60028),mailReply:(0,n.$Sj)("mail-reply",60029),reply:(0,n.$Sj)("reply",60029),organization:(0,n.$Sj)("organization",60030),organizationFilled:(0,n.$Sj)("organization-filled",60030),organizationOutline:(0,n.$Sj)("organization-outline",60030),newFile:(0,n.$Sj)("new-file",60031),fileAdd:(0,n.$Sj)("file-add",60031),newFolder:(0,n.$Sj)("new-folder",60032),fileDirectoryCreate:(0,n.$Sj)("file-directory-create",60032),trash:(0,n.$Sj)("trash",60033),trashcan:(0,n.$Sj)("trashcan",60033),history:(0,n.$Sj)("history",60034),clock:(0,n.$Sj)("clock",60034),folder:(0,n.$Sj)("folder",60035),fileDirectory:(0,n.$Sj)("file-directory",60035),symbolFolder:(0,n.$Sj)("symbol-folder",60035),logoGithub:(0,n.$Sj)("logo-github",60036),markGithub:(0,n.$Sj)("mark-github",60036),github:(0,n.$Sj)("github",60036),terminal:(0,n.$Sj)("terminal",60037),console:(0,n.$Sj)("console",60037),repl:(0,n.$Sj)("repl",60037),zap:(0,n.$Sj)("zap",60038),symbolEvent:(0,n.$Sj)("symbol-event",60038),error:(0,n.$Sj)("error",60039),stop:(0,n.$Sj)("stop",60039),variable:(0,n.$Sj)("variable",60040),symbolVariable:(0,n.$Sj)("symbol-variable",60040),array:(0,n.$Sj)("array",60042),symbolArray:(0,n.$Sj)("symbol-array",60042),symbolModule:(0,n.$Sj)("symbol-module",60043),symbolPackage:(0,n.$Sj)("symbol-package",60043),symbolNamespace:(0,n.$Sj)("symbol-namespace",60043),symbolObject:(0,n.$Sj)("symbol-object",60043),symbolMethod:(0,n.$Sj)("symbol-method",60044),symbolFunction:(0,n.$Sj)("symbol-function",60044),symbolConstructor:(0,n.$Sj)("symbol-constructor",60044),symbolBoolean:(0,n.$Sj)("symbol-boolean",60047),symbolNull:(0,n.$Sj)("symbol-null",60047),symbolNumeric:(0,n.$Sj)("symbol-numeric",60048),symbolNumber:(0,n.$Sj)("symbol-number",60048),symbolStructure:(0,n.$Sj)("symbol-structure",60049),symbolStruct:(0,n.$Sj)("symbol-struct",60049),symbolParameter:(0,n.$Sj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Sj)("symbol-type-parameter",60050),symbolKey:(0,n.$Sj)("symbol-key",60051),symbolText:(0,n.$Sj)("symbol-text",60051),symbolReference:(0,n.$Sj)("symbol-reference",60052),goToFile:(0,n.$Sj)("go-to-file",60052),symbolEnum:(0,n.$Sj)("symbol-enum",60053),symbolValue:(0,n.$Sj)("symbol-value",60053),symbolRuler:(0,n.$Sj)("symbol-ruler",60054),symbolUnit:(0,n.$Sj)("symbol-unit",60054),activateBreakpoints:(0,n.$Sj)("activate-breakpoints",60055),archive:(0,n.$Sj)("archive",60056),arrowBoth:(0,n.$Sj)("arrow-both",60057),arrowDown:(0,n.$Sj)("arrow-down",60058),arrowLeft:(0,n.$Sj)("arrow-left",60059),arrowRight:(0,n.$Sj)("arrow-right",60060),arrowSmallDown:(0,n.$Sj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Sj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Sj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Sj)("arrow-small-up",60064),arrowUp:(0,n.$Sj)("arrow-up",60065),bell:(0,n.$Sj)("bell",60066),bold:(0,n.$Sj)("bold",60067),book:(0,n.$Sj)("book",60068),bookmark:(0,n.$Sj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Sj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Sj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Sj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Sj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Sj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Sj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Sj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Sj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Sj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Sj)("briefcase",60076),broadcast:(0,n.$Sj)("broadcast",60077),browser:(0,n.$Sj)("browser",60078),bug:(0,n.$Sj)("bug",60079),calendar:(0,n.$Sj)("calendar",60080),caseSensitive:(0,n.$Sj)("case-sensitive",60081),check:(0,n.$Sj)("check",60082),checklist:(0,n.$Sj)("checklist",60083),chevronDown:(0,n.$Sj)("chevron-down",60084),chevronLeft:(0,n.$Sj)("chevron-left",60085),chevronRight:(0,n.$Sj)("chevron-right",60086),chevronUp:(0,n.$Sj)("chevron-up",60087),chromeClose:(0,n.$Sj)("chrome-close",60088),chromeMaximize:(0,n.$Sj)("chrome-maximize",60089),chromeMinimize:(0,n.$Sj)("chrome-minimize",60090),chromeRestore:(0,n.$Sj)("chrome-restore",60091),circleOutline:(0,n.$Sj)("circle-outline",60092),circle:(0,n.$Sj)("circle",60092),debugBreakpointUnverified:(0,n.$Sj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Sj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Sj)("circle-slash",60093),circuitBoard:(0,n.$Sj)("circuit-board",60094),clearAll:(0,n.$Sj)("clear-all",60095),clippy:(0,n.$Sj)("clippy",60096),closeAll:(0,n.$Sj)("close-all",60097),cloudDownload:(0,n.$Sj)("cloud-download",60098),cloudUpload:(0,n.$Sj)("cloud-upload",60099),code:(0,n.$Sj)("code",60100),collapseAll:(0,n.$Sj)("collapse-all",60101),colorMode:(0,n.$Sj)("color-mode",60102),commentDiscussion:(0,n.$Sj)("comment-discussion",60103),creditCard:(0,n.$Sj)("credit-card",60105),dash:(0,n.$Sj)("dash",60108),dashboard:(0,n.$Sj)("dashboard",60109),database:(0,n.$Sj)("database",60110),debugContinue:(0,n.$Sj)("debug-continue",60111),debugDisconnect:(0,n.$Sj)("debug-disconnect",60112),debugPause:(0,n.$Sj)("debug-pause",60113),debugRestart:(0,n.$Sj)("debug-restart",60114),debugStart:(0,n.$Sj)("debug-start",60115),debugStepInto:(0,n.$Sj)("debug-step-into",60116),debugStepOut:(0,n.$Sj)("debug-step-out",60117),debugStepOver:(0,n.$Sj)("debug-step-over",60118),debugStop:(0,n.$Sj)("debug-stop",60119),debug:(0,n.$Sj)("debug",60120),deviceCameraVideo:(0,n.$Sj)("device-camera-video",60121),deviceCamera:(0,n.$Sj)("device-camera",60122),deviceMobile:(0,n.$Sj)("device-mobile",60123),diffAdded:(0,n.$Sj)("diff-added",60124),diffIgnored:(0,n.$Sj)("diff-ignored",60125),diffModified:(0,n.$Sj)("diff-modified",60126),diffRemoved:(0,n.$Sj)("diff-removed",60127),diffRenamed:(0,n.$Sj)("diff-renamed",60128),diff:(0,n.$Sj)("diff",60129),diffSidebyside:(0,n.$Sj)("diff-sidebyside",60129),discard:(0,n.$Sj)("discard",60130),editorLayout:(0,n.$Sj)("editor-layout",60131),emptyWindow:(0,n.$Sj)("empty-window",60132),exclude:(0,n.$Sj)("exclude",60133),extensions:(0,n.$Sj)("extensions",60134),eyeClosed:(0,n.$Sj)("eye-closed",60135),fileBinary:(0,n.$Sj)("file-binary",60136),fileCode:(0,n.$Sj)("file-code",60137),fileMedia:(0,n.$Sj)("file-media",60138),filePdf:(0,n.$Sj)("file-pdf",60139),fileSubmodule:(0,n.$Sj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Sj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Sj)("file-symlink-file",60142),fileZip:(0,n.$Sj)("file-zip",60143),files:(0,n.$Sj)("files",60144),filter:(0,n.$Sj)("filter",60145),flame:(0,n.$Sj)("flame",60146),foldDown:(0,n.$Sj)("fold-down",60147),foldUp:(0,n.$Sj)("fold-up",60148),fold:(0,n.$Sj)("fold",60149),folderActive:(0,n.$Sj)("folder-active",60150),folderOpened:(0,n.$Sj)("folder-opened",60151),gear:(0,n.$Sj)("gear",60152),gift:(0,n.$Sj)("gift",60153),gistSecret:(0,n.$Sj)("gist-secret",60154),gist:(0,n.$Sj)("gist",60155),gitCommit:(0,n.$Sj)("git-commit",60156),gitCompare:(0,n.$Sj)("git-compare",60157),compareChanges:(0,n.$Sj)("compare-changes",60157),gitMerge:(0,n.$Sj)("git-merge",60158),githubAction:(0,n.$Sj)("github-action",60159),githubAlt:(0,n.$Sj)("github-alt",60160),globe:(0,n.$Sj)("globe",60161),grabber:(0,n.$Sj)("grabber",60162),graph:(0,n.$Sj)("graph",60163),gripper:(0,n.$Sj)("gripper",60164),heart:(0,n.$Sj)("heart",60165),home:(0,n.$Sj)("home",60166),horizontalRule:(0,n.$Sj)("horizontal-rule",60167),hubot:(0,n.$Sj)("hubot",60168),inbox:(0,n.$Sj)("inbox",60169),issueReopened:(0,n.$Sj)("issue-reopened",60171),issues:(0,n.$Sj)("issues",60172),italic:(0,n.$Sj)("italic",60173),jersey:(0,n.$Sj)("jersey",60174),json:(0,n.$Sj)("json",60175),kebabVertical:(0,n.$Sj)("kebab-vertical",60176),key:(0,n.$Sj)("key",60177),law:(0,n.$Sj)("law",60178),lightbulbAutofix:(0,n.$Sj)("lightbulb-autofix",60179),linkExternal:(0,n.$Sj)("link-external",60180),link:(0,n.$Sj)("link",60181),listOrdered:(0,n.$Sj)("list-ordered",60182),listUnordered:(0,n.$Sj)("list-unordered",60183),liveShare:(0,n.$Sj)("live-share",60184),loading:(0,n.$Sj)("loading",60185),location:(0,n.$Sj)("location",60186),mailRead:(0,n.$Sj)("mail-read",60187),mail:(0,n.$Sj)("mail",60188),markdown:(0,n.$Sj)("markdown",60189),megaphone:(0,n.$Sj)("megaphone",60190),mention:(0,n.$Sj)("mention",60191),milestone:(0,n.$Sj)("milestone",60192),gitPullRequestMilestone:(0,n.$Sj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Sj)("mortar-board",60193),move:(0,n.$Sj)("move",60194),multipleWindows:(0,n.$Sj)("multiple-windows",60195),mute:(0,n.$Sj)("mute",60196),noNewline:(0,n.$Sj)("no-newline",60197),note:(0,n.$Sj)("note",60198),octoface:(0,n.$Sj)("octoface",60199),openPreview:(0,n.$Sj)("open-preview",60200),package:(0,n.$Sj)("package",60201),paintcan:(0,n.$Sj)("paintcan",60202),pin:(0,n.$Sj)("pin",60203),play:(0,n.$Sj)("play",60204),run:(0,n.$Sj)("run",60204),plug:(0,n.$Sj)("plug",60205),preserveCase:(0,n.$Sj)("preserve-case",60206),preview:(0,n.$Sj)("preview",60207),project:(0,n.$Sj)("project",60208),pulse:(0,n.$Sj)("pulse",60209),question:(0,n.$Sj)("question",60210),quote:(0,n.$Sj)("quote",60211),radioTower:(0,n.$Sj)("radio-tower",60212),reactions:(0,n.$Sj)("reactions",60213),references:(0,n.$Sj)("references",60214),refresh:(0,n.$Sj)("refresh",60215),regex:(0,n.$Sj)("regex",60216),remoteExplorer:(0,n.$Sj)("remote-explorer",60217),remote:(0,n.$Sj)("remote",60218),remove:(0,n.$Sj)("remove",60219),replaceAll:(0,n.$Sj)("replace-all",60220),replace:(0,n.$Sj)("replace",60221),repoClone:(0,n.$Sj)("repo-clone",60222),repoForcePush:(0,n.$Sj)("repo-force-push",60223),repoPull:(0,n.$Sj)("repo-pull",60224),repoPush:(0,n.$Sj)("repo-push",60225),report:(0,n.$Sj)("report",60226),requestChanges:(0,n.$Sj)("request-changes",60227),rocket:(0,n.$Sj)("rocket",60228),rootFolderOpened:(0,n.$Sj)("root-folder-opened",60229),rootFolder:(0,n.$Sj)("root-folder",60230),rss:(0,n.$Sj)("rss",60231),ruby:(0,n.$Sj)("ruby",60232),saveAll:(0,n.$Sj)("save-all",60233),saveAs:(0,n.$Sj)("save-as",60234),save:(0,n.$Sj)("save",60235),screenFull:(0,n.$Sj)("screen-full",60236),screenNormal:(0,n.$Sj)("screen-normal",60237),searchStop:(0,n.$Sj)("search-stop",60238),server:(0,n.$Sj)("server",60240),settingsGear:(0,n.$Sj)("settings-gear",60241),settings:(0,n.$Sj)("settings",60242),shield:(0,n.$Sj)("shield",60243),smiley:(0,n.$Sj)("smiley",60244),sortPrecedence:(0,n.$Sj)("sort-precedence",60245),splitHorizontal:(0,n.$Sj)("split-horizontal",60246),splitVertical:(0,n.$Sj)("split-vertical",60247),squirrel:(0,n.$Sj)("squirrel",60248),starFull:(0,n.$Sj)("star-full",60249),starHalf:(0,n.$Sj)("star-half",60250),symbolClass:(0,n.$Sj)("symbol-class",60251),symbolColor:(0,n.$Sj)("symbol-color",60252),symbolConstant:(0,n.$Sj)("symbol-constant",60253),symbolEnumMember:(0,n.$Sj)("symbol-enum-member",60254),symbolField:(0,n.$Sj)("symbol-field",60255),symbolFile:(0,n.$Sj)("symbol-file",60256),symbolInterface:(0,n.$Sj)("symbol-interface",60257),symbolKeyword:(0,n.$Sj)("symbol-keyword",60258),symbolMisc:(0,n.$Sj)("symbol-misc",60259),symbolOperator:(0,n.$Sj)("symbol-operator",60260),symbolProperty:(0,n.$Sj)("symbol-property",60261),wrench:(0,n.$Sj)("wrench",60261),wrenchSubaction:(0,n.$Sj)("wrench-subaction",60261),symbolSnippet:(0,n.$Sj)("symbol-snippet",60262),tasklist:(0,n.$Sj)("tasklist",60263),telescope:(0,n.$Sj)("telescope",60264),textSize:(0,n.$Sj)("text-size",60265),threeBars:(0,n.$Sj)("three-bars",60266),thumbsdown:(0,n.$Sj)("thumbsdown",60267),thumbsup:(0,n.$Sj)("thumbsup",60268),tools:(0,n.$Sj)("tools",60269),triangleDown:(0,n.$Sj)("triangle-down",60270),triangleLeft:(0,n.$Sj)("triangle-left",60271),triangleRight:(0,n.$Sj)("triangle-right",60272),triangleUp:(0,n.$Sj)("triangle-up",60273),twitter:(0,n.$Sj)("twitter",60274),unfold:(0,n.$Sj)("unfold",60275),unlock:(0,n.$Sj)("unlock",60276),unmute:(0,n.$Sj)("unmute",60277),unverified:(0,n.$Sj)("unverified",60278),verified:(0,n.$Sj)("verified",60279),versions:(0,n.$Sj)("versions",60280),vmActive:(0,n.$Sj)("vm-active",60281),vmOutline:(0,n.$Sj)("vm-outline",60282),vmRunning:(0,n.$Sj)("vm-running",60283),watch:(0,n.$Sj)("watch",60284),whitespace:(0,n.$Sj)("whitespace",60285),wholeWord:(0,n.$Sj)("whole-word",60286),window:(0,n.$Sj)("window",60287),wordWrap:(0,n.$Sj)("word-wrap",60288),zoomIn:(0,n.$Sj)("zoom-in",60289),zoomOut:(0,n.$Sj)("zoom-out",60290),listFilter:(0,n.$Sj)("list-filter",60291),listFlat:(0,n.$Sj)("list-flat",60292),listSelection:(0,n.$Sj)("list-selection",60293),selection:(0,n.$Sj)("selection",60293),listTree:(0,n.$Sj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Sj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Sj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Sj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Sj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Sj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Sj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Sj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Sj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Sj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Sj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Sj)("symbol-string",60301),debugReverseContinue:(0,n.$Sj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Sj)("debug-step-back",60303),debugRestartFrame:(0,n.$Sj)("debug-restart-frame",60304),debugAlt:(0,n.$Sj)("debug-alt",60305),callIncoming:(0,n.$Sj)("call-incoming",60306),callOutgoing:(0,n.$Sj)("call-outgoing",60307),menu:(0,n.$Sj)("menu",60308),expandAll:(0,n.$Sj)("expand-all",60309),feedback:(0,n.$Sj)("feedback",60310),gitPullRequestReviewer:(0,n.$Sj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Sj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Sj)("ungroup-by-ref-type",60312),account:(0,n.$Sj)("account",60313),gitPullRequestAssignee:(0,n.$Sj)("git-pull-request-assignee",60313),bellDot:(0,n.$Sj)("bell-dot",60314),debugConsole:(0,n.$Sj)("debug-console",60315),library:(0,n.$Sj)("library",60316),output:(0,n.$Sj)("output",60317),runAll:(0,n.$Sj)("run-all",60318),syncIgnored:(0,n.$Sj)("sync-ignored",60319),pinned:(0,n.$Sj)("pinned",60320),githubInverted:(0,n.$Sj)("github-inverted",60321),serverProcess:(0,n.$Sj)("server-process",60322),serverEnvironment:(0,n.$Sj)("server-environment",60323),pass:(0,n.$Sj)("pass",60324),issueClosed:(0,n.$Sj)("issue-closed",60324),stopCircle:(0,n.$Sj)("stop-circle",60325),playCircle:(0,n.$Sj)("play-circle",60326),record:(0,n.$Sj)("record",60327),debugAltSmall:(0,n.$Sj)("debug-alt-small",60328),vmConnect:(0,n.$Sj)("vm-connect",60329),cloud:(0,n.$Sj)("cloud",60330),merge:(0,n.$Sj)("merge",60331),export:(0,n.$Sj)("export",60332),graphLeft:(0,n.$Sj)("graph-left",60333),magnet:(0,n.$Sj)("magnet",60334),notebook:(0,n.$Sj)("notebook",60335),redo:(0,n.$Sj)("redo",60336),checkAll:(0,n.$Sj)("check-all",60337),pinnedDirty:(0,n.$Sj)("pinned-dirty",60338),passFilled:(0,n.$Sj)("pass-filled",60339),circleLargeFilled:(0,n.$Sj)("circle-large-filled",60340),circleLarge:(0,n.$Sj)("circle-large",60341),circleLargeOutline:(0,n.$Sj)("circle-large-outline",60341),combine:(0,n.$Sj)("combine",60342),gather:(0,n.$Sj)("gather",60342),table:(0,n.$Sj)("table",60343),variableGroup:(0,n.$Sj)("variable-group",60344),typeHierarchy:(0,n.$Sj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Sj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Sj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Sj)("git-pull-request-create",60348),runAbove:(0,n.$Sj)("run-above",60349),runBelow:(0,n.$Sj)("run-below",60350),notebookTemplate:(0,n.$Sj)("notebook-template",60351),debugRerun:(0,n.$Sj)("debug-rerun",60352),workspaceTrusted:(0,n.$Sj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Sj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Sj)("workspace-unknown",60355),terminalCmd:(0,n.$Sj)("terminal-cmd",60356),terminalDebian:(0,n.$Sj)("terminal-debian",60357),terminalLinux:(0,n.$Sj)("terminal-linux",60358),terminalPowershell:(0,n.$Sj)("terminal-powershell",60359),terminalTmux:(0,n.$Sj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Sj)("terminal-ubuntu",60361),terminalBash:(0,n.$Sj)("terminal-bash",60362),arrowSwap:(0,n.$Sj)("arrow-swap",60363),copy:(0,n.$Sj)("copy",60364),personAdd:(0,n.$Sj)("person-add",60365),filterFilled:(0,n.$Sj)("filter-filled",60366),wand:(0,n.$Sj)("wand",60367),debugLineByLine:(0,n.$Sj)("debug-line-by-line",60368),inspect:(0,n.$Sj)("inspect",60369),layers:(0,n.$Sj)("layers",60370),layersDot:(0,n.$Sj)("layers-dot",60371),layersActive:(0,n.$Sj)("layers-active",60372),compass:(0,n.$Sj)("compass",60373),compassDot:(0,n.$Sj)("compass-dot",60374),compassActive:(0,n.$Sj)("compass-active",60375),azure:(0,n.$Sj)("azure",60376),issueDraft:(0,n.$Sj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Sj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Sj)("git-pull-request-draft",60379),debugAll:(0,n.$Sj)("debug-all",60380),debugCoverage:(0,n.$Sj)("debug-coverage",60381),runErrors:(0,n.$Sj)("run-errors",60382),folderLibrary:(0,n.$Sj)("folder-library",60383),debugContinueSmall:(0,n.$Sj)("debug-continue-small",60384),beakerStop:(0,n.$Sj)("beaker-stop",60385),graphLine:(0,n.$Sj)("graph-line",60386),graphScatter:(0,n.$Sj)("graph-scatter",60387),pieChart:(0,n.$Sj)("pie-chart",60388),bracket:(0,n.$Sj)("bracket",60175),bracketDot:(0,n.$Sj)("bracket-dot",60389),bracketError:(0,n.$Sj)("bracket-error",60390),lockSmall:(0,n.$Sj)("lock-small",60391),azureDevops:(0,n.$Sj)("azure-devops",60392),verifiedFilled:(0,n.$Sj)("verified-filled",60393),newline:(0,n.$Sj)("newline",60394),layout:(0,n.$Sj)("layout",60395),layoutActivitybarLeft:(0,n.$Sj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Sj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Sj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Sj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Sj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Sj)("layout-panel-right",60401),layoutPanel:(0,n.$Sj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Sj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Sj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Sj)("layout-statusbar",60405),layoutMenubar:(0,n.$Sj)("layout-menubar",60406),layoutCentered:(0,n.$Sj)("layout-centered",60407),target:(0,n.$Sj)("target",60408),indent:(0,n.$Sj)("indent",60409),recordSmall:(0,n.$Sj)("record-small",60410),errorSmall:(0,n.$Sj)("error-small",60411),terminalDecorationError:(0,n.$Sj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Sj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Sj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Sj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Sj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Sj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Sj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Sj)("layout-sidebar-left-off",60418),blank:(0,n.$Sj)("blank",60419),heartFilled:(0,n.$Sj)("heart-filled",60420),map:(0,n.$Sj)("map",60421),mapHorizontal:(0,n.$Sj)("map-horizontal",60421),foldHorizontal:(0,n.$Sj)("fold-horizontal",60421),mapFilled:(0,n.$Sj)("map-filled",60422),mapHorizontalFilled:(0,n.$Sj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$Sj)("fold-horizontal-filled",60422),circleSmall:(0,n.$Sj)("circle-small",60423),bellSlash:(0,n.$Sj)("bell-slash",60424),bellSlashDot:(0,n.$Sj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Sj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Sj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Sj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Sj)("search-fuzzy",60429),commentDraft:(0,n.$Sj)("comment-draft",60430),send:(0,n.$Sj)("send",60431),sparkle:(0,n.$Sj)("sparkle",60432),insert:(0,n.$Sj)("insert",60433),mic:(0,n.$Sj)("mic",60434),thumbsdownFilled:(0,n.$Sj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Sj)("thumbsup-filled",60436),coffee:(0,n.$Sj)("coffee",60437),snake:(0,n.$Sj)("snake",60438),game:(0,n.$Sj)("game",60439),vr:(0,n.$Sj)("vr",60440),chip:(0,n.$Sj)("chip",60441),piano:(0,n.$Sj)("piano",60442),music:(0,n.$Sj)("music",60443),micFilled:(0,n.$Sj)("mic-filled",60444),repoFetch:(0,n.$Sj)("repo-fetch",60445),copilot:(0,n.$Sj)("copilot",60446),lightbulbSparkle:(0,n.$Sj)("lightbulb-sparkle",60447),robot:(0,n.$Sj)("robot",60448),sparkleFilled:(0,n.$Sj)("sparkle-filled",60449),diffSingle:(0,n.$Sj)("diff-single",60450),diffMultiple:(0,n.$Sj)("diff-multiple",60451),surroundWith:(0,n.$Sj)("surround-with",60452),share:(0,n.$Sj)("share",60453),gitStash:(0,n.$Sj)("git-stash",60454),gitStashApply:(0,n.$Sj)("git-stash-apply",60455),gitStashPop:(0,n.$Sj)("git-stash-pop",60456),vscode:(0,n.$Sj)("vscode",60457),vscodeInsiders:(0,n.$Sj)("vscode-insiders",60458),codeOss:(0,n.$Sj)("code-oss",60459),runCoverage:(0,n.$Sj)("run-coverage",60460),runAllCoverage:(0,n.$Sj)("run-all-coverage",60461),coverage:(0,n.$Sj)("coverage",60462),githubProject:(0,n.$Sj)("github-project",60463),mapVertical:(0,n.$Sj)("map-vertical",60464),foldVertical:(0,n.$Sj)("fold-vertical",60464),mapVerticalFilled:(0,n.$Sj)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$Sj)("fold-vertical-filled",60465),goToSearch:(0,n.$Sj)("go-to-search",60466),percentage:(0,n.$Sj)("percentage",60467),sortPercentage:(0,n.$Sj)("sort-percentage",60467)}}),define(se[75],re([0,1,105,145]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=void 0,e.$Vj=k;function k(){return Object.values(e.$Xj)}e.$Wj={dialogError:(0,n.$Sj)("dialog-error","error"),dialogWarning:(0,n.$Sj)("dialog-warning","warning"),dialogInfo:(0,n.$Sj)("dialog-info","info"),dialogClose:(0,n.$Sj)("dialog-close","close"),treeItemExpanded:(0,n.$Sj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Sj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Sj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Sj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Sj)("tree-item-loading","loading"),menuSelection:(0,n.$Sj)("menu-selection","check"),menuSubmenu:(0,n.$Sj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Sj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Sj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Sj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Sj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Sj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Sj)("toolbar-more","more"),quickInputBack:(0,n.$Sj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Sj)("drop-down-button",60084),symbolCustomColor:(0,n.$Sj)("symbol-customcolor",60252),exportIcon:(0,n.$Sj)("export",60332),workspaceUnspecified:(0,n.$Sj)("workspace-unspecified",60355),newLine:(0,n.$Sj)("newline",60394),thumbsDownFilled:(0,n.$Sj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Sj)("thumbsup-filled",60436),gitFetch:(0,n.$Sj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Sj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Sj)("debug-breakpoint-pending",60377)},e.$Xj={...C.$Uj,...e.$Wj}}),define(se[35],re([0,1,12]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=C,e.$6n=k,e.$7n=j,e.$8n=h,e.$9n=l,e.$0n=d,e.$$n=p,e.$_n=v,e.$ao=$,e.$bo=f,e.$co=y,e.$do=w,e.$eo=b;function C(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const m=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([S,a])=>{m[S]=a&&typeof a=="object"?C(a):a}),m}function k(c){if(!c||typeof c!="object")return c;const m=[c];for(;m.length>0;){const S=m.shift();Object.freeze(S);for(const a in S)if(R.call(S,a)){const t=S[a];typeof t=="object"&&!Object.isFrozen(t)&&!(0,n.$bg)(t)&&m.push(t)}}return c}const R=Object.prototype.hasOwnProperty;function j(c,m){return E(c,m,new Set)}function E(c,m,S){if((0,n.$hg)(c))return c;const a=m(c);if(typeof a<"u")return a;if(Array.isArray(c)){const t=[];for(const r of c)t.push(E(r,m,S));return t}if((0,n.$ag)(c)){if(S.has(c))throw new Error("Cannot clone recursive data-structure");S.add(c);const t={};for(const r in c)R.call(c,r)&&(t[r]=E(c[r],m,S));return S.delete(c),t}return c}function h(c,m,S=!0){return(0,n.$ag)(c)?((0,n.$ag)(m)&&Object.keys(m).forEach(a=>{a in c?S&&((0,n.$ag)(c[a])&&(0,n.$ag)(m[a])?h(c[a],m[a],S):c[a]=m[a]):c[a]=m[a]}),c):m}function l(c,m){if(c===m)return!0;if(c==null||m===null||m===void 0||typeof c!=typeof m||typeof c!="object"||Array.isArray(c)!==Array.isArray(m))return!1;let S,a;if(Array.isArray(c)){if(c.length!==m.length)return!1;for(S=0;S<c.length;S++)if(!l(c[S],m[S]))return!1}else{const t=[];for(a in c)t.push(a);t.sort();const r=[];for(a in m)r.push(a);if(r.sort(),!l(t,r))return!1;for(S=0;S<t.length;S++)if(!l(c[t[S]],m[t[S]]))return!1}return!0}function d(c){const m=new Set;return JSON.stringify(c,(S,a)=>{if((0,n.$ag)(a)||Array.isArray(a)){if(m.has(a))return"[Circular]";m.add(a)}return typeof a=="bigint"?`[BigInt ${a.toString()}]`:a})}function p(c,m){const S=Object.create(null);return!c||!m||Object.keys(m).forEach(t=>{const r=c[t],s=m[t];l(r,s)||(S[t]=s)}),S}function v(c,m){const S=m.toLowerCase(),a=Object.keys(c).find(t=>t.toLowerCase()===S);return a?c[a]:c[m]}function $(c,m){const S=Object.create(null);for(const[a,t]of Object.entries(c))m(a,t)&&(S[a]=t);return S}function f(c){let m=[];for(;Object.prototype!==c;)m=m.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return m}function y(c){const m=[];for(const S of f(c))typeof c[S]=="function"&&m.push(S);return m}function w(c,m){const S=t=>function(){const r=Array.prototype.slice.call(arguments,0);return m(t,r)},a={};for(const t of c)a[t]=S(t);return a}function b(c,m){const S={};for(const[a,t]of Object.entries(c))S[a]=m(t,a);return S}}),define(se[106],re([0,1,75]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Yj=k;var C;(function(j){function E(h){return h&&typeof h=="object"&&typeof h.id=="string"}j.isThemeColor=E})(C||(e.ThemeColor=C={}));function k(j){return{id:j}}var R;(function(j){j.iconNameSegment="[A-Za-z0-9]+",j.iconNameExpression="[A-Za-z0-9-]+",j.iconModifierExpression="~[A-Za-z]+",j.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${j.iconNameExpression})(${j.iconModifierExpression})?$`);function h(c){const m=E.exec(c.id);if(!m)return h(n.$Xj.error);const[,S,a]=m,t=["codicon","codicon-"+S];return a&&t.push("codicon-modifier-"+a.substring(1)),t}j.asClassNameArray=h;function l(c){return h(c).join(" ")}j.asClassName=l;function d(c){return"."+h(c).join(".")}j.asCSSSelector=d;function p(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||C.isThemeColor(c.color))}j.isThemeIcon=p;const v=new RegExp(`^\\$\\((${j.iconNameExpression}(?:${j.iconModifierExpression})?)\\)$`);function $(c){const m=v.exec(c);if(!m)return;const[,S]=m;return{id:S}}j.fromString=$;function f(c){return{id:c}}j.fromId=f;function y(c,m){let S=c.id;const a=S.lastIndexOf("~");return a!==-1&&(S=S.substring(0,a)),m&&(S=`${S}~${m}`),{id:S}}j.modify=y;function w(c){const m=c.id.lastIndexOf("~");if(m!==-1)return c.id.substring(m+1)}j.getModifier=w;function b(c,m){return c.id===m.id&&c.color?.id===m.color?.id}j.isEqual=b})(R||(e.ThemeIcon=R={}))}),define(se[33],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=void 0,e.$Tg=C;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(k){return n.test(k)}e.$Ug=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(E){for(let h=0;h<E.length;h++)E[h]=Math.floor(Math.random()*256);return E};const R=new Uint8Array(16),j=[];for(let E=0;E<256;E++)j.push(E.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let h=0,l="";return l+=j[R[h++]],l+=j[R[h++]],l+=j[R[h++]],l+=j[R[h++]],l+="-",l+=j[R[h++]],l+=j[R[h++]],l+="-",l+=j[R[h++]],l+=j[R[h++]],l+="-",l+=j[R[h++]],l+=j[R[h++]],l+="-",l+=j[R[h++]],l+=j[R[h++]],l+=j[R[h++]],l+=j[R[h++]],l+=j[R[h++]],l+=j[R[h++]],l}}()}),define(se[146],re([0,1,87,43,86]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aW=R;async function R(j,E){if(await new Promise((d,p)=>{const v=C.createReadStream(j),$=n.createHash("sha256");v.pipe($);const f=(0,k.$db)((y,w)=>{v.removeAllListeners(),$.removeAllListeners(),y?p(y):d(w)});v.once("error",f),v.once("end",f),$.once("error",f),$.once("data",y=>f(void 0,y.toString("hex")))})!==E)throw new Error("Hash mismatch")}}),define(se[147],re([0,1,26]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=R;const C=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(j){const E=j.replace(/\-/g,":").toLowerCase();return!C.has(E)}function R(){const j=(0,n.networkInterfaces)();for(const E in j){const h=j[E];if(h){for(const{mac:l}of h)if(k(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(se[107],re([0,1,88]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xg=void 0,e.$Wg=C,e.$Yg=R;function C(E,h,l,d=1){let p=!1;return new Promise(v=>{const $=setTimeout(()=>{if(!p)return p=!0,v(0)},l);k(E,h,d,f=>{if(!p)return p=!0,clearTimeout($),v(f)})})}function k(E,h,l,d){if(h===0)return d(0);const p=new n.Socket;p.once("connect",()=>(j(p),k(E+l,h-1,l,d))),p.once("data",()=>{}),p.once("error",v=>(j(p),v.code!=="ECONNREFUSED"?k(E+l,h-1,l,d):d(E))),p.connect(E,"127.0.0.1")}e.$Xg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(E,h,l,d="127.0.0.1"){let p=!1,v,$=1;const f=n.createServer({pauseOnConnect:!0});function y(w,b){p||(p=!0,f.removeAllListeners(),f.close(),v&&clearTimeout(v),b(w))}return new Promise(w=>{v=setTimeout(()=>{y(0,w)},l),f.on("listening",()=>{y(E,w)}),f.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&$<h?(E++,$++,f.listen(E,d)):y(0,w)}),f.on("close",()=>{y(0,w)}),f.listen(E,d)})}function j(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(h){console.error(h)}}}),function(){function K(){function e(){return process.uncHostAllowlist}function n(h){const l=new Set;if(Array.isArray(h))for(const d of h)typeof d=="string"&&l.add(d);return Array.from(l)}function C(){const h=e();return h?Array.from(h):[]}function k(h){if(process.platform!=="win32")return;const l=e();if(l)if(typeof h=="string")l.add(h.toLowerCase());else for(const d of n(h))k(d)}function R(h){if(typeof h!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let d;for(const p of l){if(h.indexOf(p)!==0)continue;const $=h.indexOf("\\",p.length);if($===-1)continue;const f=h.substring(p.length,$);if(f){d=f;break}}return d}function j(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function E(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:C,addUNCHostToAllowlist:k,getUNCHost:R,disableUNCAccessRestrictions:j,isUNCAccessRestrictionsDisabled:E}}typeof define=="function"?define("vs/base/node/unc",[],function(){return K()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=K():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(se[148],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gW=e.$fW=void 0,e.$fW="vscode:contextmenu",e.$gW="vscode:onCloseContextMenu"}),define(se[149],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nW=void 0;class n{constructor(k,R){this.a=k,this.onMessage=R}send(k){try{this.a.send("vscode:message",k.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$nW=n}),define(se[150],re([11,10]),function(K,e){return K.create("vs/base/common/date",e)}),define(se[151],re([0,1,150]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=l,e.$5m=d,e.$6m=p;const C=60,k=C*60,R=k*24,j=R*7,E=R*30,h=R*365;function l(v,$,f,y){typeof v!="number"&&(v=v.getTime());const w=Math.round((new Date().getTime()-v)/1e3);if(w<-30)return(0,n.localize)(0,null,l(new Date().getTime()+w*1e3,!1));if(!y&&w<30)return(0,n.localize)(1,null);let b;return w<C?(b=w,$?b===1?f?(0,n.localize)(2,null,b):(0,n.localize)(3,null,b):f?(0,n.localize)(4,null,b):(0,n.localize)(5,null,b):b===1?f?(0,n.localize)(6,null,b):(0,n.localize)(7,null,b):f?(0,n.localize)(8,null,b):(0,n.localize)(9,null,b)):w<k?(b=Math.floor(w/C),$?b===1?f?(0,n.localize)(10,null,b):(0,n.localize)(11,null,b):f?(0,n.localize)(12,null,b):(0,n.localize)(13,null,b):b===1?f?(0,n.localize)(14,null,b):(0,n.localize)(15,null,b):f?(0,n.localize)(16,null,b):(0,n.localize)(17,null,b)):w<R?(b=Math.floor(w/k),$?b===1?f?(0,n.localize)(18,null,b):(0,n.localize)(19,null,b):f?(0,n.localize)(20,null,b):(0,n.localize)(21,null,b):b===1?f?(0,n.localize)(22,null,b):(0,n.localize)(23,null,b):f?(0,n.localize)(24,null,b):(0,n.localize)(25,null,b)):w<j?(b=Math.floor(w/R),$?b===1?(0,n.localize)(26,null,b):(0,n.localize)(27,null,b):b===1?(0,n.localize)(28,null,b):(0,n.localize)(29,null,b)):w<E?(b=Math.floor(w/j),$?b===1?f?(0,n.localize)(30,null,b):(0,n.localize)(31,null,b):f?(0,n.localize)(32,null,b):(0,n.localize)(33,null,b):b===1?f?(0,n.localize)(34,null,b):(0,n.localize)(35,null,b):f?(0,n.localize)(36,null,b):(0,n.localize)(37,null,b)):w<h?(b=Math.floor(w/E),$?b===1?f?(0,n.localize)(38,null,b):(0,n.localize)(39,null,b):f?(0,n.localize)(40,null,b):(0,n.localize)(41,null,b):b===1?f?(0,n.localize)(42,null,b):(0,n.localize)(43,null,b):f?(0,n.localize)(44,null,b):(0,n.localize)(45,null,b)):(b=Math.floor(w/h),$?b===1?f?(0,n.localize)(46,null,b):(0,n.localize)(47,null,b):f?(0,n.localize)(48,null,b):(0,n.localize)(49,null,b):b===1?f?(0,n.localize)(50,null,b):(0,n.localize)(51,null,b):f?(0,n.localize)(52,null,b):(0,n.localize)(53,null,b))}function d(v,$){const f=Math.abs(v/1e3);return f<1?$?(0,n.localize)(54,null,v):(0,n.localize)(55,null,v):f<C?$?(0,n.localize)(56,null,Math.round(v)/1e3):(0,n.localize)(57,null,Math.round(v)/1e3):f<k?$?(0,n.localize)(58,null,Math.round(v/(1e3*C))):(0,n.localize)(59,null,Math.round(v/(1e3*C))):f<R?$?(0,n.localize)(60,null,Math.round(v/(1e3*k))):(0,n.localize)(61,null,Math.round(v/(1e3*k))):(0,n.localize)(62,null,Math.round(v/(1e3*R)))}function p(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(se[152],re([11,10]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(se[47],re([0,1,22,12,152]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=h,e.$kj=l,e.$lj=d;function R(p,v){return v&&(p.stack||p.stacktrace)?k.localize(0,null,E(p),j(p.stack)||j(p.stacktrace)):E(p)}function j(p){return Array.isArray(p)?p.join(`
`):p}function E(p){return p.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${p.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?k.localize(1,null,p.message):p.message||k.localize(2,null)}function h(p=null,v=!1){if(!p)return k.localize(3,null);if(Array.isArray(p)){const $=n.$Hb(p),f=h($[0],v);return $.length>1?k.localize(4,null,f,$.length):f}if(C.$$f(p))return p;if(p.detail){const $=p.detail;if($.error)return R($.error,v);if($.exception)return R($.exception,v)}return p.stack?R(p,v):p.message?p.message:k.localize(5,null)}function l(p){const v=p;return v instanceof Error&&Array.isArray(v.actions)}function d(p,v){let $;return typeof p=="string"?$=new Error(p):$=p,$.actions=v,$}}),define(se[153],re([11,10]),function(K,e){return K.create("vs/base/common/jsonErrorMessages",e)}),define(se[154],re([0,1,153]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=C;function C(k){switch(k){case 1:return(0,n.localize)(0,null);case 2:return(0,n.localize)(1,null);case 3:return(0,n.localize)(2,null);case 4:return(0,n.localize)(3,null);case 5:return(0,n.localize)(4,null);case 6:return(0,n.localize)(5,null);case 7:return(0,n.localize)(6,null);case 8:return(0,n.localize)(7,null);case 9:return(0,n.localize)(8,null);default:return""}}}),define(se[155],re([11,10]),function(K,e){return K.create("vs/base/common/platform",e)}),define(se[4],re([0,1,155]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=r,e.$D=P,e.$J=D,e.$g="en";let C=!1,k=!1,R=!1,j=!1,E=!1,h=!1,l=!1,d=!1,p=!1,v=!1,$,f=e.$g,y=e.$g,w,b;const c=globalThis;let m;typeof c.vscode<"u"&&typeof c.vscode.process<"u"?m=c.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(m=process);const S=typeof m?.versions?.electron=="string",a=S&&m?.type==="renderer";if(typeof m=="object"){C=m.platform==="win32",k=m.platform==="darwin",R=m.platform==="linux",j=R&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,l=S,p=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,$=e.$g,f=e.$g;const I=m.env.VSCODE_NLS_CONFIG;if(I)try{const O=JSON.parse(I),M=O.availableLanguages["*"];$=O.locale,y=O.osLocale,f=M||e.$g,w=O._translationsConfigFile}catch{}E=!0}else typeof navigator=="object"&&!a?(b=navigator.userAgent,C=b.indexOf("Windows")>=0,k=b.indexOf("Macintosh")>=0,d=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=b.indexOf("Linux")>=0,v=b?.indexOf("Mobi")>=0,h=!0,$=n.getConfiguredDefaultLocale(n.localize(0,null))||e.$g,f=$,y=navigator.language):console.error("Unable to resolve platform.");var t;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let s=0;k?s=1:C?s=3:R&&(s=2),e.$i=C,e.$j=k,e.$k=R,e.$l=j,e.$m=E,e.$n=l,e.$o=h,e.$p=h&&typeof c.importScripts=="function",e.$q=e.$p?c.origin:void 0,e.$r=d,e.$s=v,e.$t=p,e.$u=s,e.$v=b,e.$w=f;var i;(function(I){function O(){return e.$w}I.value=O;function M(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}I.isDefaultVariant=M;function W(){return e.$w==="en"}I.isDefault=W})(i||(e.Language=i={})),e.$x=$,e.$y=y,e.$z=w,e.$A=typeof c.postMessage=="function"&&!c.importScripts,e.$B=(()=>{if(e.$A){const I=[];c.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let W=0,F=I.length;W<F;W++){const T=I[W];if(T.id===M.data.vscodeScheduleAsyncWork){I.splice(W,1),T.callback();return}}});let O=0;return M=>{const W=++O;I.push({id:W,callback:M}),c.postMessage({vscodeScheduleAsyncWork:W},"*")}}return I=>setTimeout(I)})();var o;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(o||(e.OperatingSystem=o={})),e.OS=k||d?2:C?1:3;let u=!0,g=!1;function P(){if(!g){g=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,u=new Uint16Array(I.buffer)[0]===513}return u}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function D(I){return parseFloat(I)>=20}}),define(se[36],re([0,1,4]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let C;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.process<"u"){const R=k.process;C={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return n.$i?"win32":n.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=C.cwd,e.env=C.env,e.$dc=C.platform,e.$ec=C.arch}),define(se[9],re([0,1,36]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const C=65,k=97,R=90,j=122,E=46,h=47,l=92,d=58,p=63;class v extends Error{constructor(r,s,i){let o;typeof s=="string"&&s.indexOf("not ")===0?(o="must not be",s=s.replace(/^not /,"")):o="must be";const u=r.indexOf(".")!==-1?"property":"argument";let g=`The "${r}" ${u} ${o} of type ${s}`;g+=`. Received type ${typeof i}`,super(g),this.code="ERR_INVALID_ARG_TYPE"}}function $(t,r){if(t===null||typeof t!="object")throw new v(r,"Object",t)}function f(t,r){if(typeof t!="string")throw new v(r,"string",t)}const y=n.$dc==="win32";function w(t){return t===h||t===l}function b(t){return t===h}function c(t){return t>=C&&t<=R||t>=k&&t<=j}function m(t,r,s,i){let o="",u=0,g=-1,P=0,D=0;for(let I=0;I<=t.length;++I){if(I<t.length)D=t.charCodeAt(I);else{if(i(D))break;D=h}if(i(D)){if(!(g===I-1||P===1))if(P===2){if(o.length<2||u!==2||o.charCodeAt(o.length-1)!==E||o.charCodeAt(o.length-2)!==E){if(o.length>2){const O=o.lastIndexOf(s);O===-1?(o="",u=0):(o=o.slice(0,O),u=o.length-1-o.lastIndexOf(s)),g=I,P=0;continue}else if(o.length!==0){o="",u=0,g=I,P=0;continue}}r&&(o+=o.length>0?`${s}..`:"..",u=2)}else o.length>0?o+=`${s}${t.slice(g+1,I)}`:o=t.slice(g+1,I),u=I-g-1;g=I,P=0}else D===E&&P!==-1?++P:P=-1}return o}function S(t,r){$(r,"pathObject");const s=r.dir||r.root,i=r.base||`${r.name||""}${r.ext||""}`;return s?s===r.root?`${s}${i}`:`${s}${t}${i}`:i}e.$fc={resolve(...t){let r="",s="",i=!1;for(let o=t.length-1;o>=-1;o--){let u;if(o>=0){if(u=t[o],f(u,"path"),u.length===0)continue}else r.length===0?u=n.cwd():(u=n.env[`=${r}`]||n.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==r.toLowerCase()&&u.charCodeAt(2)===l)&&(u=`${r}\\`));const g=u.length;let P=0,D="",I=!1;const O=u.charCodeAt(0);if(g===1)w(O)&&(P=1,I=!0);else if(w(O))if(I=!0,w(u.charCodeAt(1))){let M=2,W=M;for(;M<g&&!w(u.charCodeAt(M));)M++;if(M<g&&M!==W){const F=u.slice(W,M);for(W=M;M<g&&w(u.charCodeAt(M));)M++;if(M<g&&M!==W){for(W=M;M<g&&!w(u.charCodeAt(M));)M++;(M===g||M!==W)&&(D=`\\\\${F}\\${u.slice(W,M)}`,P=M)}}}else P=1;else c(O)&&u.charCodeAt(1)===d&&(D=u.slice(0,2),P=2,g>2&&w(u.charCodeAt(2))&&(I=!0,P=3));if(D.length>0)if(r.length>0){if(D.toLowerCase()!==r.toLowerCase())continue}else r=D;if(i){if(r.length>0)break}else if(s=`${u.slice(P)}\\${s}`,i=I,I&&r.length>0)break}return s=m(s,!i,"\\",w),i?`${r}\\${s}`:`${r}${s}`||"."},normalize(t){f(t,"path");const r=t.length;if(r===0)return".";let s=0,i,o=!1;const u=t.charCodeAt(0);if(r===1)return b(u)?"\\":t;if(w(u))if(o=!0,w(t.charCodeAt(1))){let P=2,D=P;for(;P<r&&!w(t.charCodeAt(P));)P++;if(P<r&&P!==D){const I=t.slice(D,P);for(D=P;P<r&&w(t.charCodeAt(P));)P++;if(P<r&&P!==D){for(D=P;P<r&&!w(t.charCodeAt(P));)P++;if(P===r)return`\\\\${I}\\${t.slice(D)}\\`;P!==D&&(i=`\\\\${I}\\${t.slice(D,P)}`,s=P)}}}else s=1;else c(u)&&t.charCodeAt(1)===d&&(i=t.slice(0,2),s=2,r>2&&w(t.charCodeAt(2))&&(o=!0,s=3));let g=s<r?m(t.slice(s),!o,"\\",w):"";return g.length===0&&!o&&(g="."),g.length>0&&w(t.charCodeAt(r-1))&&(g+="\\"),i===void 0?o?`\\${g}`:g:o?`${i}\\${g}`:`${i}${g}`},isAbsolute(t){f(t,"path");const r=t.length;if(r===0)return!1;const s=t.charCodeAt(0);return w(s)||r>2&&c(s)&&t.charCodeAt(1)===d&&w(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,s;for(let u=0;u<t.length;++u){const g=t[u];f(g,"path"),g.length>0&&(r===void 0?r=s=g:r+=`\\${g}`)}if(r===void 0)return".";let i=!0,o=0;if(typeof s=="string"&&w(s.charCodeAt(0))){++o;const u=s.length;u>1&&w(s.charCodeAt(1))&&(++o,u>2&&(w(s.charCodeAt(2))?++o:i=!1))}if(i){for(;o<r.length&&w(r.charCodeAt(o));)o++;o>=2&&(r=`\\${r.slice(o)}`)}return e.$fc.normalize(r)},relative(t,r){if(f(t,"from"),f(r,"to"),t===r)return"";const s=e.$fc.resolve(t),i=e.$fc.resolve(r);if(s===i||(t=s.toLowerCase(),r=i.toLowerCase(),t===r))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===l;)o++;let u=t.length;for(;u-1>o&&t.charCodeAt(u-1)===l;)u--;const g=u-o;let P=0;for(;P<r.length&&r.charCodeAt(P)===l;)P++;let D=r.length;for(;D-1>P&&r.charCodeAt(D-1)===l;)D--;const I=D-P,O=g<I?g:I;let M=-1,W=0;for(;W<O;W++){const T=t.charCodeAt(o+W);if(T!==r.charCodeAt(P+W))break;T===l&&(M=W)}if(W!==O){if(M===-1)return i}else{if(I>O){if(r.charCodeAt(P+W)===l)return i.slice(P+W+1);if(W===2)return i.slice(P+W)}g>O&&(t.charCodeAt(o+W)===l?M=W:W===2&&(M=3)),M===-1&&(M=0)}let F="";for(W=o+M+1;W<=u;++W)(W===u||t.charCodeAt(W)===l)&&(F+=F.length===0?"..":"\\..");return P+=M,F.length>0?`${F}${i.slice(P,D)}`:(i.charCodeAt(P)===l&&++P,i.slice(P,D))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$fc.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===l){if(r.charCodeAt(1)===l){const s=r.charCodeAt(2);if(s!==p&&s!==E)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(c(r.charCodeAt(0))&&r.charCodeAt(1)===d&&r.charCodeAt(2)===l)return`\\\\?\\${r}`;return t},dirname(t){f(t,"path");const r=t.length;if(r===0)return".";let s=-1,i=0;const o=t.charCodeAt(0);if(r===1)return w(o)?t:".";if(w(o)){if(s=i=1,w(t.charCodeAt(1))){let P=2,D=P;for(;P<r&&!w(t.charCodeAt(P));)P++;if(P<r&&P!==D){for(D=P;P<r&&w(t.charCodeAt(P));)P++;if(P<r&&P!==D){for(D=P;P<r&&!w(t.charCodeAt(P));)P++;if(P===r)return t;P!==D&&(s=i=P+1)}}}}else c(o)&&t.charCodeAt(1)===d&&(s=r>2&&w(t.charCodeAt(2))?3:2,i=s);let u=-1,g=!0;for(let P=r-1;P>=i;--P)if(w(t.charCodeAt(P))){if(!g){u=P;break}}else g=!1;if(u===-1){if(s===-1)return".";u=s}return t.slice(0,u)},basename(t,r){r!==void 0&&f(r,"ext"),f(t,"path");let s=0,i=-1,o=!0,u;if(t.length>=2&&c(t.charCodeAt(0))&&t.charCodeAt(1)===d&&(s=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let g=r.length-1,P=-1;for(u=t.length-1;u>=s;--u){const D=t.charCodeAt(u);if(w(D)){if(!o){s=u+1;break}}else P===-1&&(o=!1,P=u+1),g>=0&&(D===r.charCodeAt(g)?--g===-1&&(i=u):(g=-1,i=P))}return s===i?i=P:i===-1&&(i=t.length),t.slice(s,i)}for(u=t.length-1;u>=s;--u)if(w(t.charCodeAt(u))){if(!o){s=u+1;break}}else i===-1&&(o=!1,i=u+1);return i===-1?"":t.slice(s,i)},extname(t){f(t,"path");let r=0,s=-1,i=0,o=-1,u=!0,g=0;t.length>=2&&t.charCodeAt(1)===d&&c(t.charCodeAt(0))&&(r=i=2);for(let P=t.length-1;P>=r;--P){const D=t.charCodeAt(P);if(w(D)){if(!u){i=P+1;break}continue}o===-1&&(u=!1,o=P+1),D===E?s===-1?s=P:g!==1&&(g=1):s!==-1&&(g=-1)}return s===-1||o===-1||g===0||g===1&&s===o-1&&s===i+1?"":t.slice(s,o)},format:S.bind(null,"\\"),parse(t){f(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.length;let i=0,o=t.charCodeAt(0);if(s===1)return w(o)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(w(o)){if(i=1,w(t.charCodeAt(1))){let M=2,W=M;for(;M<s&&!w(t.charCodeAt(M));)M++;if(M<s&&M!==W){for(W=M;M<s&&w(t.charCodeAt(M));)M++;if(M<s&&M!==W){for(W=M;M<s&&!w(t.charCodeAt(M));)M++;M===s?i=M:M!==W&&(i=M+1)}}}}else if(c(o)&&t.charCodeAt(1)===d){if(s<=2)return r.root=r.dir=t,r;if(i=2,w(t.charCodeAt(2))){if(s===3)return r.root=r.dir=t,r;i=3}}i>0&&(r.root=t.slice(0,i));let u=-1,g=i,P=-1,D=!0,I=t.length-1,O=0;for(;I>=i;--I){if(o=t.charCodeAt(I),w(o)){if(!D){g=I+1;break}continue}P===-1&&(D=!1,P=I+1),o===E?u===-1?u=I:O!==1&&(O=1):u!==-1&&(O=-1)}return P!==-1&&(u===-1||O===0||O===1&&u===P-1&&u===g+1?r.base=r.name=t.slice(g,P):(r.name=t.slice(g,u),r.base=t.slice(g,P),r.ext=t.slice(u,P))),g>0&&g!==i?r.dir=t.slice(0,g-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(y){const t=/\\/g;return()=>{const r=n.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>n.cwd()})();e.$gc={resolve(...t){let r="",s=!1;for(let i=t.length-1;i>=-1&&!s;i--){const o=i>=0?t[i]:a();f(o,"path"),o.length!==0&&(r=`${o}/${r}`,s=o.charCodeAt(0)===h)}return r=m(r,!s,"/",b),s?`/${r}`:r.length>0?r:"."},normalize(t){if(f(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===h,s=t.charCodeAt(t.length-1)===h;return t=m(t,!r,"/",b),t.length===0?r?"/":s?"./":".":(s&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return f(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let r;for(let s=0;s<t.length;++s){const i=t[s];f(i,"path"),i.length>0&&(r===void 0?r=i:r+=`/${i}`)}return r===void 0?".":e.$gc.normalize(r)},relative(t,r){if(f(t,"from"),f(r,"to"),t===r||(t=e.$gc.resolve(t),r=e.$gc.resolve(r),t===r))return"";const s=1,i=t.length,o=i-s,u=1,g=r.length-u,P=o<g?o:g;let D=-1,I=0;for(;I<P;I++){const M=t.charCodeAt(s+I);if(M!==r.charCodeAt(u+I))break;M===h&&(D=I)}if(I===P)if(g>P){if(r.charCodeAt(u+I)===h)return r.slice(u+I+1);if(I===0)return r.slice(u+I)}else o>P&&(t.charCodeAt(s+I)===h?D=I:I===0&&(D=0));let O="";for(I=s+D+1;I<=i;++I)(I===i||t.charCodeAt(I)===h)&&(O+=O.length===0?"..":"/..");return`${O}${r.slice(u+D)}`},toNamespacedPath(t){return t},dirname(t){if(f(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===h;let s=-1,i=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===h){if(!i){s=o;break}}else i=!1;return s===-1?r?"/":".":r&&s===1?"//":t.slice(0,s)},basename(t,r){r!==void 0&&f(r,"ext"),f(t,"path");let s=0,i=-1,o=!0,u;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let g=r.length-1,P=-1;for(u=t.length-1;u>=0;--u){const D=t.charCodeAt(u);if(D===h){if(!o){s=u+1;break}}else P===-1&&(o=!1,P=u+1),g>=0&&(D===r.charCodeAt(g)?--g===-1&&(i=u):(g=-1,i=P))}return s===i?i=P:i===-1&&(i=t.length),t.slice(s,i)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===h){if(!o){s=u+1;break}}else i===-1&&(o=!1,i=u+1);return i===-1?"":t.slice(s,i)},extname(t){f(t,"path");let r=-1,s=0,i=-1,o=!0,u=0;for(let g=t.length-1;g>=0;--g){const P=t.charCodeAt(g);if(P===h){if(!o){s=g+1;break}continue}i===-1&&(o=!1,i=g+1),P===E?r===-1?r=g:u!==1&&(u=1):r!==-1&&(u=-1)}return r===-1||i===-1||u===0||u===1&&r===i-1&&r===s+1?"":t.slice(r,i)},format:S.bind(null,"/"),parse(t){f(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.charCodeAt(0)===h;let i;s?(r.root="/",i=1):i=0;let o=-1,u=0,g=-1,P=!0,D=t.length-1,I=0;for(;D>=i;--D){const O=t.charCodeAt(D);if(O===h){if(!P){u=D+1;break}continue}g===-1&&(P=!1,g=D+1),O===E?o===-1?o=D:I!==1&&(I=1):o!==-1&&(I=-1)}if(g!==-1){const O=u===0&&s?1:u;o===-1||I===0||I===1&&o===g-1&&o===u+1?r.base=r.name=t.slice(O,g):(r.name=t.slice(O,o),r.base=t.slice(O,g),r.ext=t.slice(o,g))}return u>0?r.dir=t.slice(0,u-1):s&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=y?e.$fc.normalize:e.$gc.normalize,e.$ic=y?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=y?e.$fc.join:e.$gc.join,e.$kc=y?e.$fc.resolve:e.$gc.resolve,e.$lc=y?e.$fc.relative:e.$gc.relative,e.$mc=y?e.$fc.dirname:e.$gc.dirname,e.$nc=y?e.$fc.basename:e.$gc.basename,e.$oc=y?e.$fc.extname:e.$gc.extname,e.$pc=y?e.$fc.format:e.$gc.format,e.$qc=y?e.$fc.parse:e.$gc.parse,e.$rc=y?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=y?e.$fc.sep:e.$gc.sep,e.$tc=y?e.$fc.delimiter:e.$gc.delimiter}),define(se[31],re([0,1,9,4,25,12]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=j,e.$rg=E,e.$sg=h,e.$tg=l,e.$ug=d,e.$vg=f,e.$wg=y,e.$xg=w,e.$yg=b,e.$zg=c,e.$Ag=m,e.$Bg=S,e.$Cg=a,e.$Dg=t,e.$Eg=r,e.$Fg=s,e.$Gg=u;function j(g){return g===47||g===92}function E(g){return g.replace(/[\\/]/g,n.$gc.sep)}function h(g){return g.indexOf("/")===-1&&(g=E(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}function l(g,P=n.$gc.sep){if(!g)return"";const D=g.length,I=g.charCodeAt(0);if(j(I)){if(j(g.charCodeAt(1))&&!j(g.charCodeAt(2))){let M=3;const W=M;for(;M<D&&!j(g.charCodeAt(M));M++);if(W!==M&&!j(g.charCodeAt(M+1))){for(M+=1;M<D;M++)if(j(g.charCodeAt(M)))return g.slice(0,M+1).replace(/[\\/]/g,P)}}return P}else if(b(I)&&g.charCodeAt(1)===58)return j(g.charCodeAt(2))?g.slice(0,2)+P:g.slice(0,2);let O=g.indexOf("://");if(O!==-1){for(O+=3;O<D;O++)if(j(g.charCodeAt(O)))return g.slice(0,O+1)}return""}function d(g){if(!C.$i||!g||g.length<5)return!1;let P=g.charCodeAt(0);if(P!==92||(P=g.charCodeAt(1),P!==92))return!1;let D=2;const I=D;for(;D<g.length&&(P=g.charCodeAt(D),P!==92);D++);return!(I===D||(P=g.charCodeAt(D+1),isNaN(P)||P===92))}const p=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,$=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(g,P=C.$i){const D=P?p:v;return!(!g||g.length===0||/^\s+$/.test(g)||(D.lastIndex=0,D.test(g))||P&&$.test(g)||g==="."||g===".."||P&&g[g.length-1]==="."||P&&g.length!==g.trim().length||g.length>255)}function y(g,P,D){const I=g===P;return!D||I?I:!g||!P?!1:(0,k.$zf)(g,P)}function w(g,P,D,I=n.sep){if(g===P)return!0;if(!g||!P||P.length>g.length)return!1;if(D){if(!(0,k.$Af)(g,P))return!1;if(P.length===g.length)return!0;let M=P.length;return P.charAt(P.length-1)===I&&M--,g.charAt(M)===I}return P.charAt(P.length-1)!==I&&(P+=I),g.indexOf(P)===0}function b(g){return g>=65&&g<=90||g>=97&&g<=122}function c(g,P){return C.$i&&g.endsWith(":")&&(g+=n.sep),(0,n.$ic)(g)||(g=(0,n.$jc)(P,g)),g=(0,n.$hc)(g),m(g)}function m(g){return C.$i?(g=(0,k.$hf)(g,n.sep),g.endsWith(":")&&(g+=n.sep)):(g=(0,k.$hf)(g,n.sep),g||(g=n.sep)),g}function S(g){const P=(0,n.$hc)(g);return C.$i?g.length>3?!1:a(P)&&(g.length===2||P.charCodeAt(2)===92):P===n.$gc.sep}function a(g,P=C.$i){return P?b(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}function t(g,P=C.$i){return a(g,P)?g[0]:void 0}function r(g,P,D){return P.length>g.length?-1:g===P?0:(D&&(g=g.toLowerCase(),P=P.toLowerCase()),g.indexOf(P))}function s(g){const P=g.split(":");let D,I,O;for(const M of P){const W=Number(M);(0,R.$cg)(W)?I===void 0?I=W:O===void 0&&(O=W):D=D?[D,M].join(":"):M}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:I!==void 0?I:void 0,column:O!==void 0?O:I!==void 0?1:void 0}}const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function u(g,P,D=8){let I="";for(let M=0;M<D;M++){let W;M===0&&C.$i&&!P&&(D===3||D===4)?W=o:W=i,I+=W.charAt(Math.floor(Math.random()*W.length))}let O;return P?O=`${P}-${I}`:O=I,g?(0,n.$jc)(g,O):O}}),define(se[76],re([0,1,4]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$om=R,e.$pm=j;var C;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(C||(e.Source=C={}));var k;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function R(E,...h){const l=h.reduce((v,$)=>(v[$]=!0,v),{}),d=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(v=>!l[v]).forEach(v=>{for(let $=0;$<d.length;$++)if(v.search(d[$])!==-1){delete E[v];break}})}function j(E){E&&(delete E.DEBUG,n.$j&&delete E.DYLD_LIBRARY_PATH,n.$k&&delete E.LD_PRELOAD)}}),define(se[7],re([0,1,9,4]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=f,e.$wc=S;const k=/^\w[\w\d+.-]*$/,R=/^\//,j=/^\/\//;function E(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(j.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,o){return!i&&!o?"file":i}function l(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==p&&(o=p+o):o=p;break}return o}const d="",p="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class ${static isUri(o){return o instanceof $?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,u,g,P,D,I=!1){typeof o=="object"?(this.scheme=o.scheme||d,this.authority=o.authority||d,this.path=o.path||d,this.query=o.query||d,this.fragment=o.fragment||d):(this.scheme=h(o,I),this.authority=u||d,this.path=l(this.scheme,g||d),this.query=P||d,this.fragment=D||d,E(this,I))}get fsPath(){return S(this,!1)}with(o){if(!o)return this;let{scheme:u,authority:g,path:P,query:D,fragment:I}=o;return u===void 0?u=this.scheme:u===null&&(u=d),g===void 0?g=this.authority:g===null&&(g=d),P===void 0?P=this.path:P===null&&(P=d),D===void 0?D=this.query:D===null&&(D=d),I===void 0?I=this.fragment:I===null&&(I=d),u===this.scheme&&g===this.authority&&P===this.path&&D===this.query&&I===this.fragment?this:new w(u,g,P,D,I)}static parse(o,u=!1){const g=v.exec(o);return g?new w(g[2]||d,s(g[4]||d),s(g[5]||d),s(g[7]||d),s(g[9]||d),u):new w(d,d,d,d,d)}static file(o){let u=d;if(C.$i&&(o=o.replace(/\\/g,p)),o[0]===p&&o[1]===p){const g=o.indexOf(p,2);g===-1?(u=o.substring(2),o=p):(u=o.substring(2,g),o=o.substring(g)||p)}return new w("file",u,o,d,d)}static from(o,u){return new w(o.scheme,o.authority,o.path,o.query,o.fragment,u)}static joinPath(o,...u){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return C.$i&&o.scheme==="file"?g=$.file(n.$fc.join(S(o,!0),...u)).path:g=n.$gc.join(o.path,...u),o.with({path:g})}toString(o=!1){return a(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof $)return o;{const u=new w(o);return u._formatted=o.external??null,u._fsPath=o._sep===y?o.fsPath??null:null,u}}else return o}}e.URI=$;function f(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}const y=C.$i?1:void 0;class w extends ${constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=S(this,!1)),this._fsPath}toString(o=!1){return o?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=y),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const b={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function c(i,o,u){let g,P=-1;for(let D=0;D<i.length;D++){const I=i.charCodeAt(D);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||o&&I===47||u&&I===91||u&&I===93||u&&I===58)P!==-1&&(g+=encodeURIComponent(i.substring(P,D)),P=-1),g!==void 0&&(g+=i.charAt(D));else{g===void 0&&(g=i.substr(0,D));const O=b[I];O!==void 0?(P!==-1&&(g+=encodeURIComponent(i.substring(P,D)),P=-1),g+=O):P===-1&&(P=D)}}return P!==-1&&(g+=encodeURIComponent(i.substring(P))),g!==void 0?g:i}function m(i){let o;for(let u=0;u<i.length;u++){const g=i.charCodeAt(u);g===35||g===63?(o===void 0&&(o=i.substr(0,u)),o+=b[g]):o!==void 0&&(o+=i[u])}return o!==void 0?o:i}function S(i,o){let u;return i.authority&&i.path.length>1&&i.scheme==="file"?u=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?u=i.path.substr(1):u=i.path[1].toLowerCase()+i.path.substr(2):u=i.path,C.$i&&(u=u.replace(/\//g,"\\")),u}function a(i,o){const u=o?m:c;let g="",{scheme:P,authority:D,path:I,query:O,fragment:M}=i;if(P&&(g+=P,g+=":"),(D||P==="file")&&(g+=p,g+=p),D){let W=D.indexOf("@");if(W!==-1){const F=D.substr(0,W);D=D.substr(W+1),W=F.lastIndexOf(":"),W===-1?g+=u(F,!1,!1):(g+=u(F.substr(0,W),!1,!1),g+=":",g+=u(F.substr(W+1),!1,!0)),g+="@"}D=D.toLowerCase(),W=D.lastIndexOf(":"),W===-1?g+=u(D,!1,!0):(g+=u(D.substr(0,W),!1,!0),g+=D.substr(W))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const W=I.charCodeAt(1);W>=65&&W<=90&&(I=`/${String.fromCharCode(W+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const W=I.charCodeAt(0);W>=65&&W<=90&&(I=`${String.fromCharCode(W+32)}:${I.substr(2)}`)}g+=u(I,!0,!1)}return O&&(g+="?",g+=u(O,!1,!1)),M&&(g+="#",g+=o?M:c(M,!1,!1)),g}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(r)?i.replace(r,o=>t(o)):i}}),define(se[156],re([0,1,7]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=C,e.$Zq=k,e.$1q=R,e.log=E;function C(l){const d=l;return d&&typeof d.type=="string"&&typeof d.severity=="string"}function k(l){const d=[];let p;try{const v=JSON.parse(l.arguments),$=v[v.length-1];$&&$.__$stack&&(v.pop(),p=$.__$stack),d.push(...v)}catch{d.push("Unable to log remote console arguments",l.arguments)}return{args:d,stack:p}}function R(l){if(typeof l!="string")return R(k(l).stack);const d=l;if(d){const p=j(d),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(v&&v.length===4)return{uri:n.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}function j(l){if(!l)return l;const d=l.indexOf(`
`);return d===-1?l:l.substring(0,d)}function E(l,d){const{args:p,stack:v}=k(l),$=typeof p[0]=="string"&&p.length===1;let f=j(v);f&&(f=`(${f.trim()})`);let y=[];if(typeof p[0]=="string"?f&&$?y=[`%c[${d}] %c${p[0]} %c${f}`,h("blue"),h(""),h("grey")]:y=[`%c[${d}] %c${p[0]}`,h("blue"),h(""),...p.slice(1)]:y=[`%c[${d}]%`,h("blue"),...p],f&&!$&&y.push(f),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,y)}function h(l){return`color: ${l}`}}),define(se[77],re([0,1,17,7]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=k,e.$7h=R,e.$8h=E;function k(h){return JSON.stringify(h,j)}function R(h){let l=JSON.parse(h);return l=E(l),l}function j(h,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function E(h,l=0){if(!h||l>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return C.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof n.$He||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let d=0;d<h.length;++d)h[d]=E(h[d],l+1);else for(const d in h)Object.hasOwnProperty.call(h,d)&&(h[d]=E(h[d],l+1))}return h}}),define(se[13],re([0,1,15,4,25,7,9]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Lg=e.$Kg=e.$Jg=e.Schemas=void 0,e.$Hg=h,e.$Ig=l,e.$Mg=p;var E;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})(E||(e.Schemas=E={}));function h(f,y){return R.URI.isUri(f)?(0,k.$zf)(f.scheme,y):(0,k.$Af)(f,y+":")}function l(f,...y){return y.some(w=>h(f,w))}e.$Jg="vscode-tkn",e.$Kg="tkn";class d{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(y){this.d=y}setDelegate(y){this.e=y}setServerRootPath(y,w){this.f=p(y,w)}getServerRootPath(){return this.f}get g(){return j.$gc.join(this.f,E.vscodeRemoteResource)}set(y,w,b){this.a[y]=w,this.b[y]=b}setConnectionToken(y,w){this.c[y]=w}getPreferredWebSchema(){return this.d}rewrite(y){if(this.e)try{return this.e(y)}catch(a){return n.$1(a),y}const w=y.authority;let b=this.a[w];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const c=this.b[w],m=this.c[w];let S=`path=${encodeURIComponent(y.path)}`;return typeof m=="string"&&(S+=`&${e.$Kg}=${encodeURIComponent(m)}`),R.URI.from({scheme:C.$o?this.d:E.vscodeRemoteResource,authority:`${b}:${c}`,path:this.g,query:S})}}e.$Lg=new d;function p(f,y){return j.$gc.join(y??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Ng="vs/../../extensions",e.$Og="vs/../../node_modules",e.$Pg="vs/../../node_modules.asar",e.$Qg="vs/../../node_modules.asar.unpacked",e.$Rg="vscode-app";class v{static{this.a=e.$Rg}asBrowserUri(y){const w=this.b(y,K);return this.uriToBrowserUri(w)}uriToBrowserUri(y){return y.scheme===E.vscodeRemote?e.$Lg.rewrite(y):y.scheme===E.file&&(C.$m||C.$q===`${E.vscodeFileResource}://${v.a}`)?y.with({scheme:E.vscodeFileResource,authority:y.authority||v.a,query:null,fragment:null}):y}asFileUri(y){const w=this.b(y,K);return this.uriToFileUri(w)}uriToFileUri(y){return y.scheme===E.vscodeFileResource?y.with({scheme:E.file,authority:y.authority!==v.a?y.authority:null,query:null,fragment:null}):y}b(y,w){return R.URI.isUri(y)?y:R.URI.parse(w.toUrl(y))}}e.$Sg=new v;var $;(function(f){const y=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(y.get("3"));const w="vscode-coi";function b(m){let S;typeof m=="string"?S=new URL(m).searchParams:m instanceof URL?S=m.searchParams:R.URI.isUri(m)&&(S=new URL(m.toString(!0)).searchParams);const a=S?.get(w);if(a)return y.get(a)}f.getHeadersFromQuery=b;function c(m,S,a){if(!globalThis.crossOriginIsolated)return;const t=S&&a?"3":a?"2":"1";m instanceof URLSearchParams?m.set(w,t):m[w]=t}f.addSearchParam=c})($||(e.COI=$={}))}),define(se[19],re([0,1,31,13,9,4,25,7]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=void 0,e.$Zg=h,e.$ih=d,e.$jh=v;function h($){return(0,E.$wc)($,!0)}class l{constructor(f){this.a=f}compare(f,y,w=!1){return f===y?0:(0,j.$sf)(this.getComparisonKey(f,w),this.getComparisonKey(y,w))}isEqual(f,y,w=!1){return f===y?!0:!f||!y?!1:this.getComparisonKey(f,w)===this.getComparisonKey(y,w)}getComparisonKey(f,y=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,y,w=!1){if(f.scheme===y.scheme){if(f.scheme===C.Schemas.file)return n.$xg(h(f),h(y),this.a(f))&&f.query===y.query&&(w||f.fragment===y.fragment);if((0,e.$eh)(f.authority,y.authority))return n.$xg(f.path,y.path,this.a(f),"/")&&f.query===y.query&&(w||f.fragment===y.fragment)}return!1}joinPath(f,...y){return E.URI.joinPath(f,...y)}basenameOrAuthority(f){return(0,e.$9g)(f)||f.authority}basename(f){return k.$gc.basename(f.path)}extname(f){return k.$gc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let y;return f.scheme===C.Schemas.file?y=E.URI.file(k.$mc(h(f))).path:(y=k.$gc.dirname(f.path),f.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),y="/")),f.with({path:y})}normalizePath(f){if(!f.path.length)return f;let y;return f.scheme===C.Schemas.file?y=E.URI.file(k.$hc(h(f))).path:y=k.$gc.normalize(f.path),f.with({path:y})}relativePath(f,y){if(f.scheme!==y.scheme||!(0,e.$eh)(f.authority,y.authority))return;if(f.scheme===C.Schemas.file){const c=k.$lc(h(f),h(y));return R.$i?n.$rg(c):c}let w=f.path||"/";const b=y.path||"/";if(this.a(f)){let c=0;for(const m=Math.min(w.length,b.length);c<m&&!(w.charCodeAt(c)!==b.charCodeAt(c)&&w.charAt(c).toLowerCase()!==b.charAt(c).toLowerCase());c++);w=b.substr(0,c)+w.substr(c)}return k.$gc.relative(w,b)}resolvePath(f,y){if(f.scheme===C.Schemas.file){const w=E.URI.file(k.$kc(h(f),y));return f.with({authority:w.authority,path:w.path})}return y=n.$sg(y),f.with({path:k.$gc.resolve(f.path,y)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,y){return f===y||f!==void 0&&y!==void 0&&(0,j.$zf)(f,y)}hasTrailingPathSeparator(f,y=k.sep){if(f.scheme===C.Schemas.file){const w=h(f);return w.length>n.$tg(w).length&&w[w.length-1]===y}else{const w=f.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,y=k.sep){return(0,e.$fh)(f,y)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,y=k.sep){let w=!1;if(f.scheme===C.Schemas.file){const b=h(f);w=b!==void 0&&b.length===n.$tg(b).length&&b[b.length-1]===y}else{y="/";const b=f.path;w=b.length===1&&b.charCodeAt(b.length-1)===47}return!w&&!(0,e.$fh)(f,y)?f.with({path:f.path+"/"}):f}}e.$1g=l,e.$2g=new l(()=>!1),e.$3g=new l($=>$.scheme===C.Schemas.file?!R.$k:!0),e.$4g=new l($=>!0),e.$5g=e.$2g.isEqual.bind(e.$2g),e.$6g=e.$2g.isEqualOrParent.bind(e.$2g),e.$7g=e.$2g.getComparisonKey.bind(e.$2g),e.$8g=e.$2g.basenameOrAuthority.bind(e.$2g),e.$9g=e.$2g.basename.bind(e.$2g),e.$0g=e.$2g.extname.bind(e.$2g),e.$$g=e.$2g.dirname.bind(e.$2g),e.$_g=e.$2g.joinPath.bind(e.$2g),e.$ah=e.$2g.normalizePath.bind(e.$2g),e.$bh=e.$2g.relativePath.bind(e.$2g),e.$ch=e.$2g.resolvePath.bind(e.$2g),e.$dh=e.$2g.isAbsolutePath.bind(e.$2g),e.$eh=e.$2g.isEqualAuthority.bind(e.$2g),e.$fh=e.$2g.hasTrailingPathSeparator.bind(e.$2g),e.$gh=e.$2g.removeTrailingPathSeparator.bind(e.$2g),e.$hh=e.$2g.addTrailingPathSeparator.bind(e.$2g);function d($,f){const y=[];for(let w=0;w<$.length;w++){const b=f($[w]);$.some((c,m)=>m===w?!1:(0,e.$6g)(b,f(c)))||y.push($[w])}return y}var p;(function($){$.META_DATA_LABEL="label",$.META_DATA_DESCRIPTION="description",$.META_DATA_SIZE="size",$.META_DATA_MIME="mime";function f(y){const w=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(m=>{const[S,a]=m.split(":");S&&a&&w.set(S,a)});const c=y.path.substring(0,y.path.indexOf(";"));return c&&w.set($.META_DATA_MIME,c),w}$.parseMetaData=f})(p||(e.DataUri=p={}));function v($,f,y){if(f){let w=$.path;return w&&w[0]!==k.$gc.sep&&(w=k.$gc.sep+w),$.with({scheme:y,authority:f,path:w})}return $.with({scheme:y})}}),define(se[8],re([0,1,23,15,3,2,19,4,144,62]),function(K,e,n,C,k,R,j,E,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.Promises=e.$Vh=e.$Uh=e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=void 0,e.$kh=d,e.$lh=p,e.$mh=v,e.$nh=$,e.$oh=f,e.$ph=y,e.$qh=w,e.$rh=b,e.$zh=u,e.$Ah=g,e.$Bh=P,e.$Ch=D,e.$Dh=I,e.$Sh=L,e.$1h=Y;function d(ee){return!!ee&&typeof ee.then=="function"}function p(ee){const X=new n.$qe,ue=ee(X.token),he=new Promise((pe,$e)=>{const ye=X.token.onCancellationRequested(()=>{ye.dispose(),$e(new C.$5)});Promise.resolve(ue).then(Se=>{ye.dispose(),X.dispose(),pe(Se)},Se=>{ye.dispose(),X.dispose(),$e(Se)})});return new class{cancel(){X.cancel(),X.dispose()}then(pe,$e){return he.then(pe,$e)}catch(pe){return this.then(void 0,pe)}finally(pe){return he.finally(pe)}}}function v(ee,X,ue){return new Promise((he,pe)=>{const $e=X.onCancellationRequested(()=>{$e.dispose(),he(ue)});ee.then(he,pe).finally(()=>$e.dispose())})}function $(ee,X){return new Promise((ue,he)=>{const pe=X.onCancellationRequested(()=>{pe.dispose(),he(new C.$5)});ee.then(ue,he).finally(()=>pe.dispose())})}async function f(ee){let X=-1;const ue=ee.map((he,pe)=>he.then($e=>(X=pe,$e)));try{return await Promise.race(ue)}finally{ee.forEach((he,pe)=>{pe!==X&&he.cancel()})}}function y(ee,X,ue){let he;const pe=setTimeout(()=>{he?.(void 0),ue?.()},X);return Promise.race([ee.finally(()=>clearTimeout(pe)),new Promise($e=>he=$e)])}function w(ee){return new Promise((X,ue)=>{const he=ee();d(he)?he.then(X,ue):X(he)})}function b(){let ee,X;return{promise:new Promise((he,pe)=>{ee=he,X=pe}),resolve:ee,reject:X}}class c{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const ue=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(ue,ue).then(he)})}return new Promise((ue,he)=>{this.b.then(ue,he)})}return this.a=X(),new Promise((ue,he)=>{this.a.then(pe=>{this.a=null,ue(pe)},pe=>{this.a=null,he(pe)})})}dispose(){this.f=!0}}e.$sh=c;class m{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$th=m;class S{constructor(){this.a=new Map}queue(X,ue){const pe=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(ue).finally(()=>{this.a.get(X)===pe&&this.a.delete(X)});return this.a.set(X,pe),pe}}e.$uh=S;const a=(ee,X)=>{let ue=!0;const he=setTimeout(()=>{ue=!1,X()},ee);return{isTriggered:()=>ue,dispose:()=>{clearTimeout(he),ue=!1}}},t=ee=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,ee())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class r{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,ue=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((pe,$e)=>{this.d=pe,this.f=$e}).then(()=>{if(this.b=null,this.d=null,this.g){const pe=this.g;return this.g=null,pe()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=ue===h.$ce?t(he):a(ue,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$vh=r;class s{constructor(X){this.a=new r(X),this.b=new c}trigger(X,ue){return this.a.trigger(()=>this.b.queue(X),ue)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$wh=s;class i{constructor(){this.a=!1,this.b=new Promise((X,ue)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$xh=i;class o extends i{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$yh=o;function u(ee,X){return X?new Promise((ue,he)=>{const pe=setTimeout(()=>{$e.dispose(),ue()},ee),$e=X.onCancellationRequested(()=>{clearTimeout(pe),$e.dispose(),he(new C.$5)})}):p(ue=>u(ee,ue))}function g(ee,X=0,ue){const he=setTimeout(()=>{ee(),ue&&pe.dispose()},X),pe=(0,R.$Sc)(()=>{clearTimeout(he),ue?.deleteAndLeak(pe)});return ue?.add(pe),pe}function P(ee){const X=[];let ue=0;const he=ee.length;function pe(){return ue<he?ee[ue++]():null}function $e(ye){ye!=null&&X.push(ye);const Se=pe();return Se?Se.then($e):Promise.resolve(X)}return Promise.resolve(null).then($e)}function D(ee,X=he=>!!he,ue=null){let he=0;const pe=ee.length,$e=()=>{if(he>=pe)return Promise.resolve(ue);const ye=ee[he++];return Promise.resolve(ye()).then(ke=>X(ke)?Promise.resolve(ke):$e())};return $e()}function I(ee,X=he=>!!he,ue=null){if(ee.length===0)return Promise.resolve(ue);let he=ee.length;const pe=()=>{he=-1;for(const $e of ee)$e.cancel?.()};return new Promise(($e,ye)=>{for(const Se of ee)Se.then(ke=>{--he>=0&&X(ke)?(pe(),$e(ke)):he===0&&$e(ue)}).catch(ke=>{--he>=0&&(pe(),ye(ke))})})}class O{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new k.$fe}whenIdle(){return this.size>0?k.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ue,he)=>{this.g.push({factory:X,c:ue,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const ue=X.factory();ue.then(X.c,X.e),ue.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Eh=O;class M extends O{constructor(){super(1)}}e.$Fh=M;class W{constructor(){this.a=new B,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Gh=W;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new G;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,ue=j.$2g){const he=ue.getComparisonKey(X);return this.a.get(he)?.size??0}queueFor(X,ue,he=j.$2g){const pe=he.getComparisonKey(X);let $e=this.a.get(pe);if(!$e){$e=new M;const ye=this.f++,Se=k.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(pe),this.h(),this.d?.deleteAndDispose(ye),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$4c),this.d.set(ye,Se),this.a.set(pe,$e)}return $e.queue(ue)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Hh=F;class T{constructor(X,ue){this.a=-1,typeof X=="function"&&typeof ue=="number"&&this.setIfNotSet(X,ue)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,ue){this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},ue)}setIfNotSet(X,ue){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},ue))}}e.$Ih=T;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,ue,he=globalThis){this.cancel();const pe=he.setInterval(()=>{X()},ue);this.d=(0,R.$Sc)(()=>{he.clearInterval(pe),this.d=void 0})}dispose(){this.cancel()}}e.$Jh=U;class ae{constructor(X,ue){this.b=-1,this.a=X,this.d=ue,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Kh=ae;class te{constructor(X,ue){ue%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ue}ms is not a multiple of 1000ms.`),this.a=X,this.b=ue,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Lh=te;class ce extends ae{constructor(X,ue){super(X,ue),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Mh=ce;class J extends R.$Uc{constructor(X,ue){super(),this.g=X,this.h=ue,this.a=[],this.b=this.B(new R.$Vc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ue of X)this.a.push(ue);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ae(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Nh=J,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Ph=(ee,X)=>{(0,E.$B)(()=>{if(ue)return;const he=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let ue=!1;return{dispose(){ue||(ue=!0)}}}:e.$Ph=(ee,X,ue)=>{const he=ee.requestIdleCallback(X,typeof ue=="number"?{timeout:ue}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,ee.cancelIdleCallback(he))}}},e.$Oh=ee=>(0,e.$Ph)(globalThis,ee)}();class V{constructor(X,ue){this.g=!1,this.d=()=>{try{this.j=ue()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Ph)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Qh=V;class q extends V{constructor(X){super(globalThis,X)}}e.$Rh=q;async function L(ee,X,ue){let he;for(let pe=0;pe<ue;pe++)try{return await ee()}catch($e){he=$e,await u(X)}throw he}class B{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,ue,he){return this.a={taskId:X,cancel:()=>he?.(),promise:ue},ue.then(()=>this.d(X),()=>this.d(X)),ue}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:ue,resolve:he,reject:pe}=b();this.b={run:X,promise:ue,promiseResolve:he,promiseReject:pe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Th=B;class H{constructor(X,ue=()=>Date.now()){this.d=X,this.f=ue,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$Uh=H;var oe;(function(ee){ee[ee.Resolved=0]="Resolved",ee[ee.Rejected=1]="Rejected"})(oe||(oe={}));class G{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((X,ue)=>{this.a=X,this.b=ue})}complete(X){return new Promise(ue=>{this.a(X),this.d={outcome:0,value:X},ue()})}error(X){return new Promise(ue=>{this.b(X),this.d={outcome:1,value:X},ue()})}cancel(){return this.error(new C.$5)}}e.$Vh=G;var le;(function(ee){async function X(he){let pe;const $e=await Promise.all(he.map(ye=>ye.then(Se=>Se,Se=>{pe||(pe=Se)})));if(typeof pe<"u")throw pe;return $e}ee.settled=X;function ue(he){return new Promise(async(pe,$e)=>{try{await he(pe,$e)}catch(ye){$e(ye)}})}ee.withAsyncBody=ue})(le||(e.Promises=le={}));class Q{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(ue=>(this.a=ue,this.d=!0,ue),ue=>{throw this.b=ue,this.d=!0,ue})}requireValue(){if(!this.d)throw new C.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Wh=Q;class A{constructor(X){this.b=X,this.a=new l.$V(()=>new Q(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Xh=A;var N;(function(ee){ee[ee.Initial=0]="Initial",ee[ee.DoneOK=1]="DoneOK",ee[ee.DoneError=2]="DoneError"})(N||(N={}));class _{static fromArray(X){return new _(ue=>{ue.emitMany(X)})}static fromPromise(X){return new _(async ue=>{ue.emitMany(await X)})}static fromPromises(X){return new _(async ue=>{await Promise.all(X.map(async he=>ue.emitOne(await he)))})}static merge(X){return new _(async ue=>{await Promise.all(X.map(async he=>{for await(const pe of he)ue.emitOne(pe)}))})}static{this.EMPTY=_.fromArray([])}constructor(X,ue){this.a=0,this.b=[],this.d=null,this.f=ue,this.g=new k.$fe,queueMicrotask(async()=>{const he={emitOne:pe=>this.h(pe),emitMany:pe=>this.j(pe),reject:pe=>this.l(pe)};try{await Promise.resolve(X(he)),this.k()}catch(pe){this.l(pe)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,ue){return new _(async he=>{for await(const pe of X)he.emitOne(ue(pe))})}map(X){return _.map(this,X)}static filter(X,ue){return new _(async he=>{for await(const pe of X)ue(pe)&&he.emitOne(pe)})}filter(X){return _.filter(this,X)}static coalesce(X){return _.filter(X,ue=>!!ue)}coalesce(){return _.coalesce(this)}static async toPromise(X){const ue=[];for await(const he of X)ue.push(he);return ue}toPromise(){return _.toPromise(this)}h(X){this.a===0&&(this.b.push(X),this.g.fire())}j(X){this.a===0&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(X){this.a===0&&(this.a=2,this.d=X,this.g.fire())}}e.$Yh=_;class z extends _{constructor(X,ue){super(ue),this.m=X}cancel(){this.m.cancel()}}e.$Zh=z;function Y(ee){const X=new n.$qe,ue=ee(X.token);return new z(X,async he=>{const pe=X.token.onCancellationRequested(()=>{pe.dispose(),X.dispose(),he.reject(new C.$5)});try{for await(const $e of ue){if(X.token.isCancellationRequested)return;he.emitOne($e)}pe.dispose(),X.dispose()}catch($e){pe.dispose(),X.dispose(),he.reject($e)}})}class x{constructor(X){this.a=new G,this.b=new _(pe=>{if(ue){pe.reject(ue);return}return he&&pe.emitMany(he),this.d=$e=>pe.reject($e),this.f=$e=>pe.emitOne($e),this.a.p},X);let ue,he;this.f=pe=>{he||(he=[]),he.push(pe)},this.d=pe=>{ue||(ue=pe)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$2h=x}),define(se[108],re([0,1,22,8,31,32,9,4,25]),function(K,e,n,C,k,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=void 0,e.$nk=l,e.$qk=f,e.$rk=M,e.$sk=W,e.$tk=F,e.$uk=T,e.$vk=U,e.$wk=J;function l(){return Object.create(null)}e.$ok="**",e.$pk="/";const d="[/\\\\]",p="[^/\\\\]",v=/\//g;function $(V,q){switch(V){case 0:return"";case 1:return`${p}*?`;default:return`(?:${d}|${p}+${d}${q?`|${d}${p}+`:""})*?`}}function f(V,q){if(!V)return[];const L=[];let B=!1,H=!1,oe="";for(const G of V){switch(G){case q:if(!B&&!H){L.push(oe),oe="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":H=!0;break;case"]":H=!1;break}oe+=G}return oe&&L.push(oe),L}function y(V){if(!V)return"";let q="";const L=f(V,e.$pk);if(L.every(B=>B===e.$ok))q=".*";else{let B=!1;L.forEach((H,oe)=>{if(H===e.$ok){if(B)return;q+=$(2,oe===L.length-1)}else{let G=!1,le="",Q=!1,A="";for(const N of H){if(N!=="}"&&G){le+=N;continue}if(Q&&(N!=="]"||!A)){let _;N==="-"?_=N:(N==="^"||N==="!")&&!A?_="^":N===e.$pk?_="":_=(0,h.$bf)(N),A+=_;continue}switch(N){case"{":G=!0;continue;case"[":Q=!0;continue;case"}":{const z=`(?:${f(le,",").map(Y=>y(Y)).join("|")})`;q+=z,G=!1,le="";break}case"]":{q+="["+A+"]",Q=!1,A="";break}case"?":q+=p;continue;case"*":q+=$(1);continue;default:q+=(0,h.$bf)(N)}}oe<L.length-1&&(L[oe+1]!==e.$ok||oe+2<L.length)&&(q+=d)}B=H===e.$ok})}return q}const w=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Dc(1e4),r=function(){return!1},s=function(){return null};function i(V,q){if(!V)return s;let L;typeof V!="string"?L=V.pattern:L=V,L=L.trim();const B=`${L}_${!!q.trimForExclusions}`;let H=t.get(B);if(H)return o(H,V);let oe;return w.test(L)?H=g(L.substr(4),L):(oe=b.exec(u(L,q)))?H=P(oe[1],L):(q.trimForExclusions?m:c).test(L)?H=D(L,q):(oe=S.exec(u(L,q)))?H=I(oe[1].substr(1),L,!0):(oe=a.exec(u(L,q)))?H=I(oe[1],L,!1):H=O(L),t.set(B,H),o(H,V)}function o(V,q){if(typeof q=="string")return V;const L=function(B,H){return(0,k.$xg)(B,q.base,!E.$k)?V((0,h.$gf)(B.substr(q.base.length),j.sep),H):null};return L.allBasenames=V.allBasenames,L.allPaths=V.allPaths,L.basenames=V.basenames,L.patterns=V.patterns,L}function u(V,q){return q.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function g(V,q){return function(L,B){return typeof L=="string"&&L.endsWith(V)?q:null}}function P(V,q){const L=`/${V}`,B=`\\${V}`,H=function(G,le){return typeof G!="string"?null:le?le===V?q:null:G===V||G.endsWith(L)||G.endsWith(B)?q:null},oe=[V];return H.basenames=oe,H.patterns=[q],H.allBasenames=oe,H}function D(V,q){const L=ce(V.slice(1,-1).split(",").map(le=>i(le,q)).filter(le=>le!==s),V),B=L.length;if(!B)return s;if(B===1)return L[0];const H=function(le,Q){for(let A=0,N=L.length;A<N;A++)if(L[A](le,Q))return V;return null},oe=L.find(le=>!!le.allBasenames);oe&&(H.allBasenames=oe.allBasenames);const G=L.reduce((le,Q)=>Q.allPaths?le.concat(Q.allPaths):le,[]);return G.length&&(H.allPaths=G),H}function I(V,q,L){const B=j.sep===j.$gc.sep,H=B?V:V.replace(v,j.sep),oe=j.sep+H,G=j.$gc.sep+V;let le;return L?le=function(Q,A){return typeof Q=="string"&&(Q===H||Q.endsWith(oe)||!B&&(Q===V||Q.endsWith(G)))?q:null}:le=function(Q,A){return typeof Q=="string"&&(Q===H||!B&&Q===V)?q:null},le.allPaths=[(L?"*/":"./")+V],le}function O(V){try{const q=new RegExp(`^${y(V)}$`);return function(L){return q.lastIndex=0,typeof L=="string"&&q.test(L)?V:null}}catch{return s}}function M(V,q,L){return!V||typeof q!="string"?!1:W(V)(q,void 0,L)}function W(V,q={}){if(!V)return r;if(typeof V=="string"||F(V)){const L=i(V,q);if(L===s)return r;const B=function(H,oe){return!!L(H,oe)};return L.allBasenames&&(B.allBasenames=L.allBasenames),L.allPaths&&(B.allPaths=L.allPaths),B}return ae(V,q)}function F(V){const q=V;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}function T(V){return V.allBasenames||[]}function U(V){return V.allPaths||[]}function ae(V,q){const L=ce(Object.getOwnPropertyNames(V).map(le=>te(le,V[le],q)).filter(le=>le!==s)),B=L.length;if(!B)return s;if(!L.some(le=>!!le.requiresSiblings)){if(B===1)return L[0];const le=function(N,_){let z;for(let Y=0,x=L.length;Y<x;Y++){const ee=L[Y](N,_);if(typeof ee=="string")return ee;(0,C.$kh)(ee)&&(z||(z=[]),z.push(ee))}return z?(async()=>{for(const Y of z){const x=await Y;if(typeof x=="string")return x}return null})():null},Q=L.find(N=>!!N.allBasenames);Q&&(le.allBasenames=Q.allBasenames);const A=L.reduce((N,_)=>_.allPaths?N.concat(_.allPaths):N,[]);return A.length&&(le.allPaths=A),le}const H=function(le,Q,A){let N,_;for(let z=0,Y=L.length;z<Y;z++){const x=L[z];x.requiresSiblings&&A&&(Q||(Q=(0,j.$nc)(le)),N||(N=Q.substr(0,Q.length-(0,j.$oc)(le).length)));const ee=x(le,Q,N,A);if(typeof ee=="string")return ee;(0,C.$kh)(ee)&&(_||(_=[]),_.push(ee))}return _?(async()=>{for(const z of _){const Y=await z;if(typeof Y=="string")return Y}return null})():null},oe=L.find(le=>!!le.allBasenames);oe&&(H.allBasenames=oe.allBasenames);const G=L.reduce((le,Q)=>Q.allPaths?le.concat(Q.allPaths):le,[]);return G.length&&(H.allPaths=G),H}function te(V,q,L){if(q===!1)return s;const B=i(V,L);if(B===s)return s;if(typeof q=="boolean")return B;if(q){const H=q.when;if(typeof H=="string"){const oe=(G,le,Q,A)=>{if(!A||!B(G,le))return null;const N=H.replace("$(basename)",()=>Q),_=A(N);return(0,C.$kh)(_)?_.then(z=>z?V:null):_?V:null};return oe.requiresSiblings=!0,oe}}return B}function ce(V,q){const L=V.filter(le=>!!le.basenames);if(L.length<2)return V;const B=L.reduce((le,Q)=>{const A=Q.basenames;return A?le.concat(A):le},[]);let H;if(q){H=[];for(let le=0,Q=B.length;le<Q;le++)H.push(q)}else H=L.reduce((le,Q)=>{const A=Q.patterns;return A?le.concat(A):le},[]);const oe=function(le,Q){if(typeof le!="string")return null;if(!Q){let N;for(N=le.length;N>0;N--){const _=le.charCodeAt(N-1);if(_===47||_===92)break}Q=le.substr(N)}const A=B.indexOf(Q);return A!==-1?H[A]:null};oe.basenames=B,oe.patterns=H,oe.allBasenames=B;const G=V.filter(le=>!le.basenames);return G.push(oe),G}function J(V,q){return(0,n.$ub)(V,q,(L,B)=>typeof L=="string"&&typeof B=="string"?L===B:typeof L!="string"&&typeof B!="string"?L.base===B.base&&L.pattern===B.pattern:!1)}}),define(se[48],re([0,1,22,31,9,4,19,25]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gw=h,e.$Hw=d,e.$Iw=v,e.$Jw=$,e.$Kw=b,e.$Lw=m,e.$Mw=S,e.$Nw=a,e.$Ow=t,e.$Pw=r;function h(i,o){const{os:u,tildify:g,relative:P}=o;if(P){const O=l(i,P,u);if(typeof O=="string")return O}let D=i.fsPath;if(u===1&&!R.$i?D=D.replace(/\//g,"\\"):u!==1&&R.$i&&(D=D.replace(/\\/g,"/")),u!==1&&g?.userHome){const O=g.userHome.fsPath;let M;i.scheme!==g.userHome.scheme&&i.path[0]===k.$gc.sep&&i.path[1]!==k.$gc.sep?M=g.userHome.with({path:i.path}).fsPath:M=D,D=v(M,O,u)}return(u===1?k.$fc:k.$gc).normalize(d(D,u===1))}function l(i,o,u){const g=u===1?k.$fc:k.$gc,P=u===3?j.$2g:j.$4g,D=o.getWorkspace(),I=(0,n.$Ob)(D.folders);if(!I)return;i.scheme!==I.uri.scheme&&i.path[0]===k.$gc.sep&&i.path[1]!==k.$gc.sep&&(i=I.uri.with({path:i.path}));const O=o.getWorkspaceFolder(i);if(!O)return;let M;if(P.isEqual(O.uri,i)?M="":M=P.relativePath(O.uri,i)??"",M&&(M=g.normalize(M)),D.folders.length>1&&!o.noPrefix){const W=O.name?O.name:P.basenameOrAuthority(O.uri);M=M?`${W} \u2022 ${M}`:W}return M}function d(i,o=R.$i){return(0,C.$Cg)(i,o)?i.charAt(0).toUpperCase()+i.slice(1):i}let p=Object.create(null);function v(i,o,u=R.OS){if(u===1||!i||!o)return i;let g=p.original===o?p.normalized:void 0;g||(g=o,R.$i&&(g=(0,C.$rg)(g)),g=`${(0,E.$hf)(g,k.$gc.sep)}${k.$gc.sep}`,p={original:o,normalized:g});let P=i;return R.$i&&(P=(0,C.$rg)(P)),(u===3?P.startsWith(g):(0,E.$Af)(P,g))?`~/${P.substr(g.length)}`:i}function $(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}const f="\u2026",y="\\\\",w="~";function b(i,o=k.sep){const u=new Array(i.length);let g=!1;for(let P=0;P<i.length;P++){const D=i[P];if(D===""){u[P]=`.${o}`;continue}if(!D){u[P]=D;continue}g=!0;let I="",O=D;O.indexOf(y)===0?(I=O.substr(0,O.indexOf(y)+y.length),O=O.substr(O.indexOf(y)+y.length)):O.indexOf(o)===0?(I=O.substr(0,O.indexOf(o)+o.length),O=O.substr(O.indexOf(o)+o.length)):O.indexOf(w)===0&&(I=O.substr(0,O.indexOf(w)+w.length),O=O.substr(O.indexOf(w)+w.length));const M=O.split(o);for(let W=1;g&&W<=M.length;W++)for(let F=M.length-W;g&&F>=0;F--){g=!1;let T=M.slice(F,F+W).join(o);for(let U=0;!g&&U<i.length;U++)if(U!==P&&i[U]&&i[U].indexOf(T)>-1){const ae=F+W===M.length,te=F>0&&i[U].indexOf(o)>-1?o+T:T,ce=i[U].endsWith(te);g=!ae||ce}if(!g){let U="";(M[0].endsWith(":")||I!=="")&&(F===1&&(F=0,W++,T=M[0]+o+T),F>0&&(U=M[0]+o),U=I+U),F>0&&(U=U+f+o),U=U+T,F+W<M.length&&(U=U+o+f),u[P]=U}}g&&(u[P]=D)}return u}var c;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function m(i,o=Object.create(null)){const u=[];let g=!1,P="";for(const D of i)if(D==="$"||g&&D==="{")P&&u.push({value:P,type:c.TEXT}),P="",g=!0;else if(D==="}"&&g){const I=o[P];if(typeof I=="string")I.length&&u.push({value:I,type:c.VARIABLE});else if(I){const O=u[u.length-1];(!O||O.type!==c.SEPARATOR)&&u.push({value:I.label,type:c.SEPARATOR})}P="",g=!1}else P+=D;return P&&!g&&u.push({value:P,type:c.TEXT}),u.filter((D,I)=>{if(D.type===c.SEPARATOR){const O=u[I-1],M=u[I+1];return[O,M].every(W=>W&&(W.type===c.VARIABLE||W.type===c.TEXT)&&W.value.length>0)}return!0}).map(D=>D.value).join("")}function S(i,o){return R.$j||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}function a(i,o){return R.$j||o?i.replace(/\(&&\w\)|&&/g,""):R.$i?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}function t(i){return i.replace(/&/g,"&&")}function r(i){if(i.endsWith("]")){const o=i.lastIndexOf(" [",i.length-2);if(o!==-1){const u=s(i.substring(0,o)),g=i.substring(o);return{name:u.name+g,parentPath:u.parentPath}}}return s(i)}function s(i){const o=i.indexOf("/")!==-1?k.$gc:k.$fc,u=o.basename(i),g=o.dirname(i);return u.length?{name:u,parentPath:g}:{name:g,parentPath:""}}}),define(se[157],re([0,1,17,7]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=void 0,e.$Cn=E,e.$Dn=l,e.$En=d;function k(p){return p.toJSON()}class R{constructor(v){this.a=v}transformIncoming(v){const $=this.a.transformIncoming(v);return $===v?v:k(C.URI.from($))}transformOutgoing(v){const $=this.a.transformOutgoing(v);return $===v?v:k(C.URI.from($))}transformOutgoingURI(v){const $=this.a.transformOutgoing(v);return $===v?v:C.URI.from($)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$An=R,e.$Bn=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function j(p,v,$){if(!p||$>200)return null;if(typeof p=="object"){if(p instanceof C.URI)return v.transformOutgoing(p);for(const f in p)if(Object.hasOwnProperty.call(p,f)){const y=j(p[f],v,$+1);y!==null&&(p[f]=y)}}return null}function E(p,v){const $=j(p,v,0);return $===null?p:$}function h(p,v,$,f){if(!p||f>200)return null;if(typeof p=="object"){if(p.$mid===1)return $?C.URI.revive(v.transformIncoming(p)):v.transformIncoming(p);if(p instanceof n.$He)return null;for(const y in p)if(Object.hasOwnProperty.call(p,y)){const w=h(p[y],v,$,f+1);w!==null&&(p[y]=w)}}return null}function l(p,v){const $=h(p,v,!1,0);return $===null?p:$}function d(p,v){const $=h(p,v,!0,0);return $===null?p:$}}),define(se[89],re([0,1,26,59,33,147,4]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=void 0,e.$Hn=h,e.$In=p,e.$Gn=new class{c(v){return this.a||(this.a=C.$Ei.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(v)}value(){if(this.b===void 0){let v=0,$=0;const f=(0,n.networkInterfaces)();for(const y in f){const w=f[y];if(w)for(const{mac:b,internal:c}of w)c||($+=1,this.c(b.toUpperCase())&&(v+=1))}this.b=$>0?v/$:0}return this.b}};let E;async function h(v){return E||(E=(async()=>await l(v)||k.$Ug())()),E}async function l(v){try{const $=await new Promise((y,w)=>{K(["crypto"],y,w)}),f=(0,R.$Fn)();return $.createHash("sha256").update(f,"utf8").digest("hex")}catch($){v($);return}}const d="Software\\Microsoft\\SQMClient";async function p(v){if(j.$i){const $=await new Promise((f,y)=>{K(["@vscode/windows-registry"],f,y)});try{return $.GetStringRegKey("HKEY_LOCAL_MACHINE",d,"MachineId")||""}catch(f){return v(f),""}}return""}}),define(se[21],re([0,1,43,26,158,8,31,72,9,4,19,7]),function(K,e,n,C,k,R,j,E,h,l,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=w,e.readdirSync=m,e.whenDeleted=t,e.configureFlushOnWrite=u,e.writeFileSync=P;var v;(function(te){te[te.UNLINK=0]="UNLINK",te[te.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function $(te,ce=v.UNLINK,J){if((0,j.$Bg)(te))throw new Error("rimraf - will refuse to recursively delete root");return ce===v.UNLINK?y(te):f(te,J)}async function f(te,ce=(0,j.$Gg)((0,C.tmpdir)())){try{try{await n.promises.rename(te,ce)}catch(J){return J.code==="ENOENT"?void 0:y(te)}y(ce).catch(J=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function y(te){return(0,k.promisify)(n.rm)(te,{recursive:!0,force:!0,maxRetries:3})}function w(te){if((0,j.$Bg)(te))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(te,{recursive:!0,force:!0,maxRetries:3})}async function b(te,ce){return S(await(ce?c(te):(0,k.promisify)(n.readdir)(te)))}async function c(te){try{return await(0,k.promisify)(n.readdir)(te,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const ce=[],J=await b(te);for(const V of J){let q=!1,L=!1,B=!1;try{const H=await e.Promises.lstat((0,h.$jc)(te,V));q=H.isFile(),L=H.isDirectory(),B=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}ce.push({name:V,isFile:()=>q,isDirectory:()=>L,isSymbolicLink:()=>B})}return ce}function m(te){return S(n.readdirSync(te))}function S(te){return te.map(ce=>typeof ce=="string"?l.$j?(0,E.$dm)(ce):ce:(ce.name=l.$j?(0,E.$dm)(ce.name):ce.name,ce))}async function a(te){const ce=await b(te),J=[];for(const V of ce)await r.existsDirectory((0,h.$jc)(te,V))&&J.push(V);return J}function t(te,ce=1e3){return new Promise(J=>{let V=!1;const q=setInterval(()=>{V||(V=!0,n.access(te,L=>{V=!1,L&&(clearInterval(q),J(void 0))}))},ce)})}var r;(function(te){async function ce(q){let L;try{if(L=await e.Promises.lstat(q),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(l.$i&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw H}throw B}}te.stat=ce;async function J(q){try{const{stat:L,symbolicLink:B}=await te.stat(q);return L.isFile()&&B?.dangling!==!0}catch{}return!1}te.existsFile=J;async function V(q){try{const{stat:L,symbolicLink:B}=await te.stat(q);return L.isDirectory()&&B?.dangling!==!0}catch{}return!1}te.existsDirectory=V})(r||(e.SymlinkSupport=r={}));const s=new R.$Hh;function i(te,ce,J){return s.queueFor(p.URI.file(te),()=>{const V=D(J);return new Promise((q,L)=>g(te,ce,V,B=>B?L(B):q()))},d.$3g)}let o=!0;function u(te){o=te}function g(te,ce,J,V){if(!o)return n.writeFile(te,ce,{mode:J.mode,flag:J.flag},V);n.open(te,J.flag,J.mode,(q,L)=>{if(q)return V(q);n.writeFile(L,ce,B=>{if(B)return n.close(L,()=>V(B));n.fdatasync(L,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),u(!1)),n.close(L,oe=>V(oe))))})})}function P(te,ce,J){const V=D(J);if(!o)return n.writeFileSync(te,ce,{mode:V.mode,flag:V.flag});const q=n.openSync(te,V.flag,V.mode);try{n.writeFileSync(q,ce);try{n.fdatasyncSync(q)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),u(!1)}}finally{n.closeSync(q)}}function D(te){return te?{mode:typeof te.mode=="number"?te.mode:438,flag:typeof te.flag=="string"?te.flag:"w"}:{mode:438,flag:"w"}}async function I(te,ce,J=6e4){if(te!==ce)try{l.$i&&typeof J=="number"?await O(te,ce,Date.now(),J):await(0,k.promisify)(n.rename)(te,ce)}catch(V){if(te.toLowerCase()!==ce.toLowerCase()&&V.code==="EXDEV"||te.endsWith("."))await M(te,ce,{preserveSymlinks:!1}),await $(te,v.MOVE);else throw V}}async function O(te,ce,J,V,q=0){try{return await(0,k.promisify)(n.rename)(te,ce)}catch(L){if(L.code!=="EACCES"&&L.code!=="EPERM"&&L.code!=="EBUSY")throw L;if(Date.now()-J>=V)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${L}`),L;if(q===0){let B=!1;try{const{stat:H}=await r.stat(ce);H.isFile()||(B=!0)}catch{}if(B)throw L}return await(0,R.$zh)(Math.min(100,q*10)),O(te,ce,J,V,q+1)}}async function M(te,ce,J){return F(te,ce,{root:{source:te,target:ce},options:J,handledSourcePaths:new Set})}const W=511;async function F(te,ce,J){if(J.handledSourcePaths.has(te))return;J.handledSourcePaths.add(te);const{stat:V,symbolicLink:q}=await r.stat(te);if(q){if(J.options.preserveSymlinks)try{return await ae(te,ce,J)}catch{}if(q.dangling)return}return V.isDirectory()?T(te,ce,V.mode&W,J):U(te,ce,V.mode&W)}async function T(te,ce,J,V){await e.Promises.mkdir(ce,{recursive:!0,mode:J});const q=await b(te);for(const L of q)await F((0,h.$jc)(te,L),(0,h.$jc)(ce,L),V)}async function U(te,ce,J){await e.Promises.copyFile(te,ce),await e.Promises.chmod(ce,J)}async function ae(te,ce,J){let V=await e.Promises.readlink(te);(0,j.$xg)(V,J.root.source,!l.$k)&&(V=(0,h.$jc)(J.root.target,V.substr(J.root.source.length+1))),await e.Promises.symlink(V,ce)}e.Promises=new class{get access(){return(0,k.promisify)(n.access)}get stat(){return(0,k.promisify)(n.stat)}get lstat(){return(0,k.promisify)(n.lstat)}get utimes(){return(0,k.promisify)(n.utimes)}get read(){return(te,ce,J,V,q)=>new Promise((L,B)=>{n.read(te,ce,J,V,q,(H,oe,G)=>H?B(H):L({bytesRead:oe,buffer:G}))})}get readFile(){return(0,k.promisify)(n.readFile)}get write(){return(te,ce,J,V,q)=>new Promise((L,B)=>{n.write(te,ce,J,V,q,(H,oe,G)=>H?B(H):L({bytesWritten:oe,buffer:G}))})}get appendFile(){return(0,k.promisify)(n.appendFile)}get fdatasync(){return(0,k.promisify)(n.fdatasync)}get truncate(){return(0,k.promisify)(n.truncate)}get copyFile(){return(0,k.promisify)(n.copyFile)}get open(){return(0,k.promisify)(n.open)}get close(){return(0,k.promisify)(n.close)}get symlink(){return(0,k.promisify)(n.symlink)}get readlink(){return(0,k.promisify)(n.readlink)}get chmod(){return(0,k.promisify)(n.chmod)}get mkdir(){return(0,k.promisify)(n.mkdir)}get unlink(){return(0,k.promisify)(n.unlink)}get rmdir(){return(0,k.promisify)(n.rmdir)}get realpath(){return(0,k.promisify)(n.realpath)}async exists(te){try{return await e.Promises.access(te),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return a}get writeFile(){return i}get rm(){return $}get rename(){return I}get copy(){return M}}}),define(se[109],re([0,1,43,9,4,25,21]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=E,e.$8q=h,e.$9q=l,e.$0q=d;function E(v){if(k.$k)return v;const $=(0,C.$mc)(v);if(v===$)return v;const f=((0,C.$nc)(v)||v).toLowerCase();try{const w=(0,j.readdirSync)($).filter(b=>b.toLowerCase()===f);if(w.length===1){const b=E($);if(b)return(0,C.$jc)(b,w[0])}else if(w.length>1){const b=w.indexOf(f);if(b>=0){const c=E($);if(c)return(0,C.$jc)(c,w[b])}}}catch{}return null}async function h(v,$){if(k.$k)return v;const f=(0,C.$mc)(v);if(v===f)return v;const y=((0,C.$nc)(v)||v).toLowerCase();try{if($?.isCancellationRequested)return null;const b=(await j.Promises.readdir(f)).filter(c=>c.toLowerCase()===y);if(b.length===1){const c=await h(f,$);if(c)return(0,C.$jc)(c,b[0])}else if(b.length>1){const c=b.indexOf(y);if(c>=0){const m=await h(f,$);if(m)return(0,C.$jc)(m,b[c])}}}catch{}return null}async function l(v){try{return await j.Promises.realpath(v)}catch{const f=p(v);return await j.Promises.access(f,n.constants.R_OK),f}}function d(v){try{return n.realpathSync(v)}catch{const f=p(v);return n.accessSync(f,n.constants.R_OK),f}}function p(v){return(0,R.$hf)((0,C.$hc)(v),C.sep)}}),define(se[110],re([0,1,26,9,21]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=c,e.$nm=m;const R=/^\d+$/,j=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var h;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(h||(h={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let d;process.env.PROCESSOR_ARCHITEW6432?d=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?d=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?d=1:d=0;class p{constructor(a,t,r){this.exePath=a,this.displayName=t,this.a=r}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:S=!1}={}){return S?l===0?process.env["ProgramFiles(x86)"]||null:d===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function $({useAlternateBitness:S=!1,findPreview:a=!1}={}){const t=v({useAlternateBitness:S});if(!t)return null;const r=C.$jc(t,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let s=-1,i=null;for(const g of await k.Promises.readdir(r)){let P=-1;if(a){const I=g.indexOf("-");if(I<0)continue;const O=g.substring(0,I);if(!R.test(O)||g.substring(I+1)!=="preview")continue;P=parseInt(O,10)}else{if(!R.test(g))continue;P=parseInt(g,10)}if(P<=s)continue;const D=C.$jc(r,g,"pwsh.exe");await k.SymlinkSupport.existsFile(D)&&(i=D,s=P)}if(!i)return null;const o=t.includes("x86")?" (x86)":"",u=a?" Preview":"";return new p(i,`PowerShell${u}${o}`,!0)}async function f({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const a=C.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=S?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const s of await k.Promises.readdir(a))if(t.test(s)){const i=C.$jc(a,s,"pwsh.exe");return new p(i,r)}return null}function y(){const S=C.$jc(n.homedir(),".dotnet","tools","pwsh.exe");return new p(S,".NET Core PowerShell Global Tool")}function w(){const S=C.$jc(process.env.windir,l===1&&d!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(S,"Windows PowerShell",!0)}async function*b(){let S=await $();S&&(yield S),S=await $({useAlternateBitness:!0}),S&&(yield S),S=await f(),S&&(yield S),S=y(),S&&(yield S),S=await $({findPreview:!0}),S&&(yield S),S=await f({findPreview:!0}),S&&(yield S),S=await $({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=w(),S&&(yield S)}async function*c(){for await(const S of b())await S.exists()&&(yield S)}async function m(){for await(const S of c())return S;return null}}),define(se[90],re([0,1,9,4,36,76,12,21]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$qm=h,e.$rm=l,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function h(p=k.env){return p.comspec||"cmd.exe"}function l(p){let v=[],$=!1;const f=function(y){if($){v.push(y);return}(!p.send(y,b=>{if(b&&console.error(b),$=!1,v.length>0){const c=v.slice(0);v=[],c.forEach(m=>f(m))}})||C.$i)&&($=!0)};return{send:f}}var d;(function(p){async function v($,f,y){if(n.$ic($))return $;if(f===void 0&&(f=k.cwd()),n.$mc($)!=="."||(y===void 0&&j.$$f(k.env.PATH)&&(y=k.env.PATH.split(n.$tc)),y===void 0||y.length===0))return n.$jc(f,$);async function b(c){if(await E.Promises.exists(c)){let m;try{m=await E.Promises.stat(c)}catch(S){S.message.startsWith("EACCES")&&(m=await E.Promises.lstat(c))}return m?!m.isDirectory():!1}return!1}for(const c of y){let m;if(n.$ic(c)?m=n.$jc(c,$):m=n.$jc(f,c,$),await b(m))return m;let S=m+".com";if(await b(S)||(S=m+".exe",await b(S)))return S}return n.$jc(f,$)}p.findExecutable=v})(d||(e.win32=d={}))}),define(se[111],re([0,1,49,13]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=k;function k(j){return new Promise((E,h)=>{let l;const d=new Map;function p($,f,y,w,b){const c=d.get(f);if($===j||c){const m={name:v(y),cmd:y,pid:$,ppid:f,load:w,mem:b};d.set($,m),$===j&&(l=m),c&&(c.children||(c.children=[]),c.children.push(m),c.children.length>1&&(c.children=c.children.sort((S,a)=>S.pid-a.pid)))}}function v($){const f=/--utility-sub-type=network/i,y=/--crashes-directory/i,w=/\\pipe\\winpty-control/i,b=/conhost\.exe.+--headless/i,c=/--type=([a-zA-Z-]+)/;if(y.exec($))return"electron-crash-reporter";if(w.exec($))return"winpty-agent";if(b.exec($))return"conpty-agent";let m=c.exec($);if(m&&m.length===2)return m[1]==="renderer"?"window":m[1]==="utility"?f.exec($)?"utility-network-service":"utility-process":m[1]==="extensionHost"?"extension-host":m[1];const S=/[a-zA-Z-]+\.js/g;let a="";do m=S.exec($),m&&(a+=m+" ");while(m);return a&&$.indexOf("node ")<0&&$.indexOf("node.exe")<0?`electron-nodejs (${a})`:$}if(process.platform==="win32"){const $=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substring(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substring(5):f;new Promise((f,y)=>{K(["@vscode/windows-process-tree"],f,y)}).then(f=>{f.getProcessList(j,y=>{if(!y){h(new Error(`Root process ${j} not found`));return}f.getProcessCpuUsage(y,w=>{const b=new Map;w.forEach(c=>{const m=$(c.commandLine||"");b.set(c.pid,{name:v(m),cmd:m,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),l=b.get(j),l?(b.forEach(c=>{const m=b.get(c.ppid);m&&(m.children||(m.children=[]),m.children.push(c))}),b.forEach(c=>{c.children&&(c.children=c.children.sort((m,S)=>m.pid-S.pid))}),E(l)):h(new Error(`Root process ${j} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let $=function(){let f=[l];const y=[];for(;f.length;){const b=f.shift();b&&(y.push(b.pid),b.children&&(f=f.concat(b.children)))}let w=JSON.stringify(C.$Sg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+y.join(" "),(0,n.exec)(w,{},(b,c,m)=>{if(b||m)h(b||new Error(m.toString()));else{const S=c.toString().split(`
`);for(let a=0;a<y.length;a++){const t=d.get(y[a]);t.load=parseFloat(S[a])}if(!l){h(new Error(`Root process ${j} not found`));return}E(l)}})};(0,n.exec)("which ps",{},(f,y,w)=>{if(f||w)if(process.platform!=="linux")h(f||new Error(w.toString()));else{const b=JSON.stringify(C.$Sg.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(b,{},(c,m,S)=>{c||S?h(c||new Error(S.toString())):(R(m,p),$())})}else{const b=y.toString().trim();(0,n.exec)(`${b} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,S,a)=>{m||a&&!a.includes("screen size is bogus")?h(m||new Error(a.toString())):(R(S,p),process.platform==="linux"?$():l?E(l):h(new Error(`Root process ${j} not found`)))})}})}})}function R(j,E){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=j.toString().split(`
`);for(const d of l){const p=h.exec(d.trim());p&&p.length===6&&E(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}}),define(se[112],re([0,1,26,4,110,90]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=j;async function j(p,v){return p===1?C.$i?d():R.$qm(v):h(p,v)}let E=null;function h(p,v){if(C.$k&&p===2||C.$j&&p===3)return"/bin/bash";if(!E){let $;if(C.$i)$="/bin/bash";else{if($=v.SHELL,!$)try{$=(0,n.userInfo)().shell}catch{}$||($="sh"),$==="/bin/false"&&($="/bin/bash")}E=$}return E}let l=null;async function d(){return l||(l=(await(0,k.$nm)()).exePath),l}});var Ee=this&&this.__decorate||function(K,e,n,C){var k=arguments.length,R=k<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,n):C,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(K,e,n,C);else for(var E=K.length-1;E>=0;E--)(j=K[E])&&(R=(k<3?j(R):k>3?j(e,n,R):j(e,n))||R);return k>3&&R&&Object.defineProperty(e,n,R),R};define(se[44],re([0,1,22,8,17,23,51,15,3,2,77,25,12]),function(K,e,n,C,k,R,j,E,h,l,d,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.ProxyChannel=e.$gi=e.$di=e.$ci=e.$bi=e.RequestInitiator=e.$ai=e.$0h=e.$9h=void 0,e.$$h=u,e.$_h=g,e.$ei=W,e.$fi=F;var $;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})($||($={}));function f(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(y||(y={}));function w(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(b||(b={}));function c(q){let L=0;for(let B=0;;B+=7){const H=q.read(1);if(L|=(H.buffer[0]&127)<<B,!(H.buffer[0]&128))return L}}const m=s(0);function S(q,L){if(L===0){q.write(m);return}let B=0;for(let oe=L;oe!==0;oe=oe>>>7)B++;const H=k.$He.alloc(B);for(let oe=0;L!==0;oe++)H.buffer[oe]=L&127,L=L>>>7,L>0&&(H.buffer[oe]|=128);q.write(H)}class a{constructor(L){this.b=L,this.a=0}read(L){const B=this.b.slice(this.a,this.a+L);return this.a+=B.byteLength,B}}e.$9h=a;class t{constructor(){this.a=[]}get buffer(){return k.$He.concat(this.a)}write(L){this.a.push(L)}}e.$0h=t;var r;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(r||(r={}));function s(q){const L=k.$He.alloc(1);return L.writeUInt8(q,0),L}const i={Undefined:s(r.Undefined),String:s(r.String),Buffer:s(r.Buffer),VSBuffer:s(r.VSBuffer),Array:s(r.Array),Object:s(r.Object),Uint:s(r.Int)},o=typeof Buffer<"u";function u(q,L){if(typeof L>"u")q.write(i.Undefined);else if(typeof L=="string"){const B=k.$He.fromString(L);q.write(i.String),S(q,B.byteLength),q.write(B)}else if(o&&Buffer.isBuffer(L)){const B=k.$He.wrap(L);q.write(i.Buffer),S(q,B.byteLength),q.write(B)}else if(L instanceof k.$He)q.write(i.VSBuffer),S(q,L.byteLength),q.write(L);else if(Array.isArray(L)){q.write(i.Array),S(q,L.length);for(const B of L)u(q,B)}else if(typeof L=="number"&&(L|0)===L)q.write(i.Uint),S(q,L);else{const B=k.$He.fromString(JSON.stringify(L));q.write(i.Object),S(q,B.byteLength),q.write(B)}}function g(q){switch(q.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return q.read(c(q)).toString();case r.Buffer:return q.read(c(q)).buffer;case r.VSBuffer:return q.read(c(q));case r.Array:{const B=c(q),H=[];for(let oe=0;oe<B;oe++)H.push(g(q));return H}case r.Object:return JSON.parse(q.read(c(q)).toString());case r.Int:return c(q)}}class P{constructor(L,B,H=null,oe=1e3){this.h=L,this.j=B,this.k=H,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:200})}registerChannel(L,B){this.b.set(L,B),setTimeout(()=>this.w(L),0)}m(L){switch(L.type){case 200:{const B=this.o([L.type]);this.k?.logOutgoing(B,0,1,w(L.type));return}case 201:case 202:case 204:case 203:{const B=this.o([L.type,L.id],L.data);this.k?.logOutgoing(B,L.id,1,w(L.type),L.data);return}}}o(L,B=void 0){const H=new t;return u(H,L),u(H,B),this.p(H.buffer)}p(L){try{return this.h.send(L),L.byteLength}catch{return 0}}q(L){const B=new a(L),H=g(B),oe=g(B),G=H[0];switch(G){case 100:return this.k?.logIncoming(L.byteLength,H[1],1,`${f(G)}: ${H[2]}.${H[3]}`,oe),this.s({type:G,id:H[1],channelName:H[2],name:H[3],arg:oe});case 102:return this.k?.logIncoming(L.byteLength,H[1],1,`${f(G)}: ${H[2]}.${H[3]}`,oe),this.t({type:G,id:H[1],channelName:H[2],name:H[3],arg:oe});case 101:return this.k?.logIncoming(L.byteLength,H[1],1,`${f(G)}`),this.u({type:G,id:H[1]});case 103:return this.k?.logIncoming(L.byteLength,H[1],1,`${f(G)}`),this.u({type:G,id:H[1]})}}s(L){const B=this.b.get(L.channelName);if(!B){this.v(L);return}const H=new R.$qe;let oe;try{oe=B.call(this.j,L.name,L.arg,H.token)}catch(Q){oe=Promise.reject(Q)}const G=L.id;oe.then(Q=>{this.m({id:G,data:Q,type:201})},Q=>{Q instanceof Error?this.m({id:G,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.m({id:G,data:Q,type:203})}).finally(()=>{le.dispose(),this.d.delete(L.id)});const le=(0,l.$Sc)(()=>H.cancel());this.d.set(L.id,le)}t(L){const B=this.b.get(L.channelName);if(!B){this.v(L);return}const H=L.id,G=B.listen(this.j,L.name,L.arg)(le=>this.m({id:H,data:le,type:204}));this.d.set(L.id,G)}u(L){const B=this.d.get(L.id);B&&(B.dispose(),this.d.delete(L.id))}v(L){let B=this.g.get(L.channelName);B||(B=[],this.g.set(L.channelName,B));const H=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);B.push({request:L,timeoutTimer:H})}w(L){const B=this.g.get(L);if(B){for(const H of B)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.s(H.request);break;case 102:this.t(H.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Pc)(this.d.values()),this.d.clear()}}e.$ai=P;var D;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class I{constructor(L,B=null){this.l=L,this.a=!1,this.b=b.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$fe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=B}getChannel(L){const B=this;return{call(H,oe,G){return B.a?Promise.reject(new E.$5):B.m(L,H,oe,G)},listen(H,oe){return B.a?h.Event.None:B.o(L,H,oe)}}}m(L,B,H,oe=R.CancellationToken.None){const G=this.g++,Q={id:G,type:100,channelName:L,name:B,arg:H};if(oe.isCancellationRequested)return Promise.reject(new E.$5);let A;return new Promise((_,z)=>{if(oe.isCancellationRequested)return z(new E.$5);const Y=()=>{const ue=he=>{switch(he.type){case 201:this.f.delete(G),_(he.data);break;case 202:{this.f.delete(G);const pe=new Error(he.data.message);pe.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,pe.name=he.data.name,z(pe);break}case 203:this.f.delete(G),z(he.data);break}};this.f.set(G,ue),this.p(Q)};let x=null;this.b===b.Idle?Y():(x=(0,C.$lh)(ue=>this.u()),x.then(()=>{x=null,Y()}));const ee=()=>{x?(x.cancel(),x=null):this.p({id:G,type:101}),z(new E.$5)},X=oe.onCancellationRequested(ee);A=(0,l.$Rc)((0,l.$Sc)(ee),X),this.d.add(A)}).finally(()=>{A.dispose(),this.d.delete(A)})}o(L,B,H){const oe=this.g++,le={id:oe,type:102,channelName:L,name:B,arg:H};let Q=null;const A=new h.$fe({onWillAddFirstListener:()=>{Q=(0,C.$lh)(_=>this.u()),Q.then(()=>{Q=null,this.d.add(A),this.p(le)})},onDidRemoveLastListener:()=>{Q?(Q.cancel(),Q=null):(this.d.delete(A),this.p({id:oe,type:103}))}}),N=_=>A.fire(_.data);return this.f.set(oe,N),A.event}p(L){switch(L.type){case 100:case 102:{const B=this.q([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(B,L.id,0,`${f(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const B=this.q([L.type,L.id]);this.j?.logOutgoing(B,L.id,0,f(L.type));return}}}q(L,B=void 0){const H=new t;return u(H,L),u(H,B),this.r(H.buffer)}r(L){try{return this.l.send(L),L.byteLength}catch{return 0}}s(L){const B=new a(L),H=g(B),oe=g(B),G=H[0];switch(G){case 200:return this.j?.logIncoming(L.byteLength,0,0,w(G)),this.t({type:H[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,H[1],0,w(G),oe),this.t({type:H[0],id:H[1],data:oe})}}t(L){if(L.type===200){this.b=b.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Pc)(this.d.values()),this.d.clear()}}e.$bi=I,Ee([j.$3h],I.prototype,"onDidInitializePromise",null);class O{get connections(){const L=[];return this.f.forEach(B=>L.push(B)),L}constructor(L,B,H){this.a=new Map,this.f=new Set,this.g=new h.$fe,this.onDidAddConnection=this.g.event,this.h=new h.$fe,this.onDidRemoveConnection=this.h.event,this.j=new l.$Tc,this.j.add(L(({protocol:oe,onDidClientDisconnect:G})=>{const le=h.Event.once(oe.onMessage);this.j.add(le(Q=>{const A=new a(Q),N=g(A),_=new P(oe,N,B,H),z=new I(oe,B);this.a.forEach((x,ee)=>_.registerChannel(ee,x));const Y={channelServer:_,channelClient:z,ctx:N};this.f.add(Y),this.g.fire(Y),this.j.add(G(()=>{_.dispose(),z.dispose(),this.f.delete(Y),this.h.fire(Y)}))}))}))}getChannel(L,B){const H=this;return{call(oe,G,le){let Q;if((0,v.$mg)(B)){const N=(0,n.$3b)(H.connections.filter(B));Q=N?Promise.resolve(N):h.Event.toPromise(h.Event.filter(H.onDidAddConnection,B))}else Q=B.routeCall(H,oe,G);const A=Q.then(N=>N.channelClient.getChannel(L));return W(A).call(oe,G,le)},listen(oe,G){if((0,v.$mg)(B))return H.k(L,B,oe,G);const le=B.routeEvent(H,oe,G).then(Q=>Q.channelClient.getChannel(L));return W(le).listen(oe,G)}}}k(L,B,H,oe){const G=this;let le;const Q=new h.$fe({onWillAddFirstListener:()=>{le=new l.$Tc;const A=new h.$le,N=new Map,_=Y=>{const ee=Y.channelClient.getChannel(L).listen(H,oe),X=A.add(ee);N.set(Y,X)},z=Y=>{const x=N.get(Y);x&&(x.dispose(),N.delete(Y))};G.connections.filter(B).forEach(_),h.Event.filter(G.onDidAddConnection,B)(_,void 0,le),G.onDidRemoveConnection(z,void 0,le),A.event(Q.fire,Q,le),le.add(A)},onDidRemoveLastListener:()=>{le?.dispose(),le=void 0}});return Q.event}registerChannel(L,B){this.a.set(L,B);for(const H of this.f)H.channelServer.registerChannel(L,B)}dispose(){this.j.dispose();for(const L of this.f)L.channelClient.dispose(),L.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ci=O;class M{constructor(L,B,H=null){const oe=new t;u(oe,B),L.send(oe.buffer),this.a=new I(L,H),this.d=new P(L,B,H)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,B){this.d.registerChannel(L,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.$di=M;function W(q){return{call(L,B,H){return q.then(oe=>oe.call(L,B,H))},listen(L,B){const H=new h.$oe;return q.then(oe=>H.input=oe.listen(L,B)),H.event}}}function F(q){let L=!1;return{call(B,H,oe){return L?q.call(B,H,oe):(0,C.$zh)(0).then(()=>L=!0).then(()=>q.call(B,H,oe))},listen(B,H){if(L)return q.listen(B,H);const oe=new h.$oe;return(0,C.$zh)(0).then(()=>L=!0).then(()=>oe.input=q.listen(B,H)),oe.event}}}class T{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const B of L.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await h.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.$gi=T;var U;(function(q){function L(G,le,Q){const A=G,N=Q&&Q.disableMarshalling,_=new Map;for(const z in A)H(z)&&_.set(z,h.Event.buffer(A[z],!0,void 0,le));return new class{listen(z,Y,x){const ee=_.get(Y);if(ee)return ee;const X=A[Y];if(typeof X=="function"){if(oe(Y))return X.call(A,x);if(H(Y))return _.set(Y,h.Event.buffer(A[Y],!0,void 0,le)),_.get(Y)}throw new E.$bb(`Event not found: ${Y}`)}call(z,Y,x){const ee=A[Y];if(typeof ee=="function"){if(!N&&Array.isArray(x))for(let ue=0;ue<x.length;ue++)x[ue]=(0,d.$8h)(x[ue]);let X=ee.apply(A,x);return X instanceof Promise||(X=Promise.resolve(X)),X}throw new E.$bb(`Method not found: ${Y}`)}}}q.fromService=L;function B(G,le){const Q=le&&le.disableMarshalling;return new Proxy({},{get(A,N){if(typeof N=="string")return le?.properties?.has(N)?le.properties.get(N):oe(N)?function(_){return G.listen(N,_)}:H(N)?G.listen(N):async function(..._){let z;le&&!(0,v.$hg)(le.context)?z=[le.context,..._]:z=_;const Y=await G.call(N,z);return Q?Y:(0,d.$8h)(Y)};throw new E.$bb(`Property not found: ${String(N)}`)}})}q.toService=B;function H(G){return G[0]==="o"&&G[1]==="n"&&p.$yf(G.charCodeAt(2))}function oe(G){return/^onDynamic/.test(G)&&p.$yf(G.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function te(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const L=q.toString();if(L!=="[object Object]")return L}return q}function ce(q){return Array.isArray(q)?q.map(te):te(q)}function J(q,L,B,H,oe,G,le){le=ce(le);const Q=ae[oe],A=Q[H%Q.length];let N=[`%c[${q}]%c[${String(L).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(G)?(N=N.concat(le),N.push(")")):N.push(le),console.log.apply(console,N)}class V{constructor(L,B){this.d=L,this.f=B,this.a=0,this.b=0}logOutgoing(L,B,H,oe,G){this.b+=L,J(this.d,this.b,L,B,H,oe,G)}logIncoming(L,B,H,oe,G){this.a+=L,J(this.f,this.a,L,B,H,oe,G)}}e.$hi=V}),define(se[159],re([0,1,17,3,44]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lW=e.$kW=void 0;class R{constructor(h){this.a=h,this.onMessage=C.Event.fromDOMEventEmitter(this.a,"message",l=>l.data?n.$He.wrap(l.data):n.$He.alloc(0)),h.start()}send(h){this.a.postMessage(h.buffer)}disconnect(){this.a.close()}}e.$kW=R;class j extends k.$di{constructor(h,l){const d=new R(h);super(d,l),this.b=d}dispose(){this.b.disconnect(),super.dispose()}}e.$lW=j}),define(se[113],re([0,1,17,3,2,44]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=e.$ji=e.ProtocolConstants=e.$ii=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var j;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(j||(e.SocketDiagnosticsEventType=j={}));var E;(function(i){i.enableDiagnostics=!1,i.records=[];const o=new WeakMap;let u=0;function g(D,I){if(!o.has(D)){const O=String(++u);o.set(D,O)}return o.get(D)}function P(D,I,O,M){if(!i.enableDiagnostics)return;const W=g(D,I);if(M instanceof n.$He||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const F=n.$He.alloc(M.byteLength);F.set(M),i.records.push({timestamp:Date.now(),id:W,label:I,type:O,buff:F})}else i.records.push({timestamp:Date.now(),id:W,label:I,type:O,data:M})}i.traceSocketEvent=P})(E||(e.SocketDiagnostics=E={}));var h;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h||(e.SocketCloseEventType=h={}));let l=null;function d(){return l||(l=n.$He.alloc(0)),l}class p{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(o){this.a.push(o),this.b+=o.byteLength}read(o){return this.c(o,!0)}peek(o){return this.c(o,!1)}c(o,u){if(o===0)return d();if(o>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===o){const I=this.a[0];return u&&(this.a.shift(),this.b-=o),I}if(this.a[0].byteLength>o){const I=this.a[0].slice(0,o);return u&&(this.a[0]=this.a[0].slice(o),this.b-=o),I}const g=n.$He.alloc(o);let P=0,D=0;for(;o>0;){const I=this.a[D];if(I.byteLength>o){const O=I.slice(0,o);g.set(O,P),P+=o,u&&(this.a[D]=I.slice(o),this.b-=o),o-=o}else g.set(I,P),P+=I.byteLength,u?(this.a.shift(),this.b-=I.byteLength):D++,o-=I.byteLength}return g}}e.$ii=p;var v;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(v||(v={}));function $(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(f||(e.ProtocolConstants=f={}));class y{constructor(o,u,g,P){this.type=o,this.id=u,this.ack=g,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends k.$Uc{constructor(o){super(),this.f=this.B(new C.$fe),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=o,this.b=!1,this.c=new p,this.B(this.a.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(o);this.c.byteLength>=this.g.readLen;){const u=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=u.readUInt32BE(9),this.g.messageType=u.readUInt8(0),this.g.id=u.readUInt32BE(1),this.g.ack=u.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:$(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const g=this.g.messageType,P=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",u),this.f.fire(new y(g,P,D,u)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class b{constructor(o){this.k=null,this.a=!1,this.b=!1,this.c=o,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(o){if(this.a)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=n.$He.alloc(13);u.writeUInt8(o.type,0),u.writeUInt32BE(o.id,1),u.writeUInt32BE(o.ack,5),u.writeUInt32BE(o.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:$(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",o.data),this.j(u,o.data)}g(o,u){const g=this.f===0;return this.d.push(o,u),this.f+=o.byteLength+u.byteLength,g}h(){const o=n.$He.concat(this.d,this.f);return this.d.length=0,this.f=0,o}j(o,u){this.g(o,u)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const o=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this.c.write(o)}}class c extends k.$Uc{constructor(o){super(),this.f=new C.$fe,this.onMessage=this.f.event,this.g=new C.$fe,this.onDidDispose=this.g.event,this.a=o,this.b=this.B(new b(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(u=>{u.type===1&&this.f.fire(u.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(o){this.b.write(new y(1,0,0,o))}}e.$ji=c;class m extends R.$di{static fromSocket(o,u){return new m(new c(o),u)}get onDidDispose(){return this.b.onDidDispose}constructor(o,u,g=null){super(o,u,g),this.b=o}dispose(){super.dispose();const o=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),o.end()}}e.$ki=m;class S{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new C.$fe({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(o){this.b?this.d.length>0?this.d.push(o):this.a.fire(o):this.d.push(o)}flushBuffer(){this.d=[]}}e.$li=S;class a{constructor(o){this.data=o,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let o=0,u=this.a;for(;u;)u=u.next,o++;return o}peek(){return this.a?this.a.data:null}toArray(){const o=[];let u=0,g=this.a;for(;g;)o[u++]=g.data,g=g.next;return o}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(o){const u=new a(o);if(!this.a){this.a=u,this.b=u;return}this.b.next=u,this.b=u}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const o=Date.now();for(let u=0;u<r.a;u++)this.c[u]=o-1e3*u;setInterval(()=>{for(let u=r.a;u>=1;u--)this.c[u]=this.c[u-1];this.c[0]=Date.now()},1e3)}d(){const o=Date.now(),u=(1+r.a)*1e3;let g=0;for(let P=0;P<r.a;P++)o-this.c[P]<=u&&g++;return 1-g/r.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(o){this.u=new S,this.onControlMessage=this.u.event,this.v=new S,this.onMessage=this.v.event,this.w=new S,this.onDidDispose=this.w.event,this.x=new S,this.onSocketClose=this.x.event,this.y=new S,this.onSocketTimeout=this.y.event,this.s=o.loadEstimator??r.getInstance(),this.t=o.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new k.$Tc,this.o=o.socket,this.p=this.r.add(new b(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),o.initialChunk&&this.q.acceptChunk(o.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const o=new y(5,0,0,d());this.p.write(o),this.p.flush()}sendPause(){const o=new y(7,0,0,d());this.p.write(o)}sendResume(){const o=new y(8,0,0,d());this.p.write(o)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(o,u){this.a=!0,this.r.dispose(),this.r=new k.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=o,this.p=this.r.add(new b(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),this.q.acceptChunk(u)}endAcceptReconnection(){this.a=!1,this.h=this.g;const o=new y(3,0,this.h,d());this.p.write(o);const u=this.b.toArray();for(let g=0,P=u.length;g<P;g++)this.p.write(u[g]);this.B()}acceptDisconnect(){this.w.fire()}z(o){if(o.ack>this.d){this.d=o.ack;do{const u=this.b.peek();if(u&&u.id<=o.ack)this.b.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this.g)if(o.id!==this.g+1){const u=Date.now();u-this.m>1e4&&(this.m=u,this.p.write(new y(6,0,0,d())))}else this.g=o.id,this.j=Date.now(),this.A(),this.v.fire(o.data);break}case 2:{this.u.fire(o.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const u=this.b.toArray();for(let g=0,P=u.length;g<P;g++)this.p.write(u[g]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(o){const u=++this.c;this.h=this.g;const g=new y(1,u,this.h,o);this.b.push(g),this.a||(this.p.write(g),this.B())}sendControl(o){const u=new y(2,0,0,o);this.p.write(u)}A(){if(this.g<=this.h||this.k)return;const o=Date.now()-this.j;if(o>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-o+5)}B(){if(this.c<=this.d||this.f||this.a)return;const o=this.b.peek(),u=Date.now()-o.writtenTime,g=Date.now()-this.q.lastReadTime,P=Date.now()-this.n;if(u>=2e4&&g>=2e4&&P>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:g});return}const D=Math.max(2e4-u,2e4-g,2e4-P,500);this.f=setTimeout(()=>{this.f=null,this.B()},D)}C(){if(this.g<=this.h)return;this.h=this.g;const o=new y(3,0,this.h,d());this.p.write(o)}D(){this.h=this.g;const o=new y(9,0,this.h,d());this.p.write(o)}}e.$mi=s}),define(se[37],re([0,1,14,15,13]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hW=void 0;class R{constructor(){this.a=new WeakMap}on(E,h){const l=(d,...p)=>{this.b(E,d)&&h(d,...p)};return this.a.set(h,l),n.ipcMain.on(E,l),this}once(E,h){return n.ipcMain.once(E,(l,...d)=>{this.b(E,l)&&h(l,...d)}),this}handle(E,h){return n.ipcMain.handle(E,(l,...d)=>this.b(E,l)?h(l,...d):Promise.reject(`Invalid channel '${E}' or sender for ipcMain.handle() usage.`)),this}removeHandler(E){return n.ipcMain.removeHandler(E),this}removeListener(E,h){const l=this.a.get(h);return l&&(n.ipcMain.removeListener(E,l),this.a.delete(h)),this}b(E,h){if(!E||!E.startsWith("vscode:"))return(0,C.$1)(`Refused to handle ipcMain event for channel '${E}' because the channel is unknown.`),!1;const l=h.senderFrame,d=l.url;if(!d||d==="about:blank")return!0;let p="unknown";try{p=new URL(d).host}catch{return(0,C.$1)(`Refused to handle ipcMain event for channel '${E}' because of a malformed URL '${d}'.`),!1}return p!==k.$Rg?((0,C.$1)(`Refused to handle ipcMain event for channel '${E}' because of a bad origin of '${p}'.`),!1):l.parent!==null?((0,C.$1)(`Refused to handle ipcMain event for channel '${E}' because sender of origin '${p}' is not a main frame.`),!1):!0}}e.$hW=new R}),define(se[160],re([0,1,14,37,148]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iW=R;function R(){C.$hW.on(k.$fW,(E,h,l,d,p)=>{const v=j(E,d,l);v.popup({x:p?p.x:void 0,y:p?p.y:void 0,positioningItem:p?p.positioningItem:void 0,callback:()=>{v&&E.sender.send(k.$gW,h)}})})}function j(E,h,l){const d=new n.Menu;return l.forEach(p=>{let v;p.type==="separator"?v=new n.MenuItem({type:p.type}):Array.isArray(p.submenu)?v=new n.MenuItem({submenu:j(E,h,p.submenu),label:p.label}):v=new n.MenuItem({label:p.label,type:p.type,accelerator:p.accelerator,checked:p.checked,enabled:p.enabled,visible:p.visible,click:($,f,y)=>E.sender.send(h,p.id,y)}),d.append(v)}),d}}),define(se[161],re([0,1,37,17,3,2,44,149]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oW=void 0;function h(d,p){const v=k.Event.fromNodeEventEmitter(n.$hW,p,(f,y)=>({event:f,message:y})),$=k.Event.filter(v,({event:f})=>f.sender.id===d);return k.Event.map($,({message:f})=>f&&C.$He.wrap(f))}class l extends j.$ci{static{this.b=new Map}static d(){const p=k.Event.fromNodeEventEmitter(n.$hW,"vscode:hello",({sender:v})=>v);return k.Event.map(p,v=>{const $=v.id;l.b.get($)?.dispose();const y=new k.$fe;l.b.set($,(0,R.$Sc)(()=>y.fire()));const w=h($,"vscode:message"),b=k.Event.any(k.Event.signal(h($,"vscode:disconnect")),y.event);return{protocol:new E.$nW(v,w),onDidClientDisconnect:b}})}constructor(){super(l.d())}}e.$oW=l}),define(se[114],re([0,1,37,3,33,159]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pW=void 0,e.$qW=E;class j extends R.$lW{constructor(l,d){super({addEventListener:(p,v)=>l.addListener(p,v),removeEventListener:(p,v)=>l.removeListener(p,v),postMessage:p=>l.postMessage(p),start:()=>l.start(),close:()=>l.close()},d)}}e.$pW=j;async function E(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,k.$Ug)();h.webContents.send("vscode:createMessageChannel",l);const d=C.Event.fromNodeEventEmitter(n.$hW,"vscode:createMessageChannelResult",(v,$)=>({nonce:$,port:v.ports[0]})),{port:p}=await C.Event.toPromise(C.Event.once(C.Event.filter(d,v=>v.nonce===l)));return p}}),define(se[162],re([0,1,49,8,17,23,156,15,3,2,35,90,76,44]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=e.$3q=void 0;class f extends $.$ai{constructor(b){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",c=>k.$He.wrap(Buffer.from(c,"base64")))},b),process.once("disconnect",()=>this.dispose())}}e.$3q=f;class y{constructor(b,c){this.i=b,this.j=c,this.c=new Set,this.g=new Map,this.h=new h.$fe,this.onDidProcessExit=this.h.event;const m=c&&c.timeout?c.timeout:6e4;this.b=new C.$vh(m),this.d=null,this.f=null}getChannel(b){const c=this;return{call(m,S,a){return c.k(b,m,S,a)},listen(m,S){return c.l(b,m,S)}}}k(b,c,m,S=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const a=this.n(b),t=(0,C.$lh)(i=>a.call(c,m,i)),r=S.onCancellationRequested(()=>t.cancel()),s=(0,l.$Sc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{r.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(b,c,m){if(!this.b)return h.Event.None;this.b.cancel();let S;const a=new h.$fe({onWillAddFirstListener:()=>{S=this.n(b).listen(c,m)(a.fire,a),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const b=this.j&&this.j.args?this.j.args:[],c=Object.create(null);c.env={...(0,d.$5n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(c.env={...c.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(c.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,v.$pm)(c.env),this.d=(0,n.fork)(this.i,b,c);const m=new h.$fe,a=h.Event.fromNodeEventEmitter(this.d,"message",u=>u)(u=>{if((0,j.$Yq)(u)){(0,j.log)(u,`IPC Library: ${this.j.serverName}`);return}m.fire(k.$He.wrap(Buffer.from(u,"base64")))}),t=this.j.useQueue?(0,p.$rm)(this.d):this.d,r=u=>this.d&&this.d.connected&&t.send(u.buffer.toString("base64")),s=m.event,i={send:r,onMessage:s};this.f=new $.$bi(i);const o=()=>this.o();process.once("exit",o),this.d.on("error",u=>console.warn('IPC "'+this.j.serverName+'" errored with '+u)),this.d.on("exit",(u,g)=>{process.removeListener("exit",o),a.dispose(),this.c.forEach(P=>(0,l.$Pc)(P)),this.c.clear(),u!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+u+" and signal "+g),this.b?.cancel(),this.o(),this.h.fire({code:u,signal:g})})}return this.f}n(b){let c=this.g.get(b);return c||(c=this.m.getChannel(b),this.g.set(b,c)),c}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$4q=y}),define(se[115],re([0,1,8,3,2,77,12]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=e.StorageState=e.StorageHint=void 0,e.$Yp=h;var E;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function h(v){const $=v;return $?.changed instanceof Map||$?.deleted instanceof Set}var l;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(l||(e.StorageState=l={}));class d extends k.$Uc{static{this.a=100}constructor($,f=Object.create(null)){super(),this.r=$,this.s=f,this.b=this.B(new C.$ie),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new n.$wh(d.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((f,y)=>this.w(y,f)),$.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w($,f){if(this.c===l.Closed)return;let y=!1;(0,j.$hg)(f)?y=this.f.delete($):this.f.get($)!==f&&(this.f.set($,f),y=!0),y&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,f){const y=this.f.get($);return(0,j.$hg)(y)?f:y}getBoolean($,f){const y=this.get($);return(0,j.$hg)(y)?f:y==="true"}getNumber($,f){const y=this.get($);return(0,j.$hg)(y)?f:parseInt(y,10)}getObject($,f){const y=this.get($);return(0,j.$hg)(y)?f:(0,R.$7h)(y)}async set($,f,y=!1){if(this.c===l.Closed)return;if((0,j.$hg)(f))return this.delete($,y);const w=(0,j.$ag)(f)||Array.isArray(f)?(0,R.$6h)(f):String(f);if(this.f.get($)!==w)return this.f.set($,w),this.j.set($,w),this.h.delete($),this.b.fire({key:$,external:y}),this.D()}async delete($,f=!1){if(!(this.c===l.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:f}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(!(this.c===l.Closed||this.m))return this.D($)}async D($){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$Zp=d;class p{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((f,y)=>this.a.set(y,f)),$.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$1p=p}),define(se[163],re([0,1,8,3,32,9,21]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MW=void 0;class E{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return C.Event.None}static{this.a=2e3}static{this.b=256}constructor(d,p=Object.create(null)){this.g=d,this.h=p,this.c=(0,R.$nc)(this.g),this.d=new h(this.h.logging),this.f=this.n(this.g)}async getItems(){const d=await this.f,p=new Map;return(await this.s(d,"SELECT * FROM ItemTable")).forEach($=>p.set($.key,$.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${p.size} rows`),p}async updateItems(d){const p=await this.f;return this.j(p,d)}j(d,p){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${p.insert?(0,k.$yc)(p.insert):"0"}), delete(${p.delete?(0,k.$zc)(p.delete):"0"})`),this.t(d,()=>{const v=p.insert,$=p.delete;if(v&&v.size>0){const f=[];f.push([]);let y=0;v.forEach((w,b)=>{let c=f[y];c.length>E.b&&(y++,c=[],f.push(c)),c.push(b,w)}),f.forEach(w=>{this.u(d,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,b=>b.run(w),()=>{const b=[];let c=0;return v.forEach((m,S)=>{b.push(S),c+=m.length}),`Keys: ${b.join(", ")} Length: ${c}`})})}if($&&$.size){const f=[];f.push([]);let y=0;$.forEach(w=>{let b=f[y];b.length>E.b&&(y++,b=[],f.push(b)),b.push(w)}),f.forEach(w=>{this.u(d,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,b=>b.run(w),()=>{const b=[];return $.forEach(c=>{b.push(c)}),`Keys: ${b.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const d=await this.f;return this.q(d,"VACUUM")}async close(d){this.d.trace(`[storage ${this.c}] close()`);const p=await this.f;return this.k(p,d)}k(d,p){return new Promise((v,$)=>{d.db.close(f=>(f&&this.o(d,`[storage ${this.c}] close(): ${f}`),this.g===E.IN_MEMORY_PATH?v():!d.isErroneous&&!d.isInMemory?this.l().then(v,y=>(this.d.error(`[storage ${this.c}] backup(): ${y}`),v())):typeof p=="function"?j.Promises.unlink(this.g).then(()=>this.p(this.g).then(y=>{const w=()=>this.k(y,void 0);return this.j(y,{insert:p()}).then(()=>w(),b=>(w(),Promise.reject(b)))})).then(v,$):$(f||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const d=this.m(this.g);return j.Promises.copy(this.g,d,{preserveSymlinks:!1})}m(d){return`${d}.backup`}async checkIntegrity(d){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${d})`);const p=await this.f,v=await this.r(p,d?"PRAGMA integrity_check":"PRAGMA quick_check"),$=d?v.integrity_check:v.quick_check;return p.isErroneous?`${$} (last error: ${p.lastError})`:p.isInMemory?`${$} (in-memory!)`:$}async n(d,p=!0){this.d.trace(`[storage ${this.c}] open(${d}, retryOnBusy: ${p})`);try{return await this.p(d)}catch(v){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${v}`),v.code==="SQLITE_BUSY"&&p)return await(0,n.$zh)(E.a),this.n(d,!1);try{await j.Promises.unlink(d);try{await j.Promises.rename(this.m(d),d,!1)}catch{}return await this.p(d)}catch($){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${$}`),this.p(E.IN_MEMORY_PATH)}}}o(d,p){d.isErroneous=!0,d.lastError=p,this.d.error(p)}p(d){return new Promise((p,v)=>{new Promise(($,f)=>{K(["@vscode/sqlite3"],$,f)}).then($=>{const f={db:new(this.d.isTracing?$.verbose().Database:$.Database)(d,y=>y?f.db&&y.code!=="SQLITE_CANTOPEN"?f.db.close(()=>v(y)):v(y):this.q(f,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>p(f),w=>f.db.close(()=>v(w)))),isInMemory:d===E.IN_MEMORY_PATH};f.db.on("error",y=>this.o(f,`[storage ${this.c}] Error (event): ${y}`)),this.d.isTracing&&f.db.on("trace",y=>this.d.trace(`[storage ${this.c}] Trace (event): ${y}`))},v)})}q(d,p){return new Promise((v,$)=>{d.db.exec(p,f=>f?(this.o(d,`[storage ${this.c}] exec(): ${f}`),$(f)):v())})}r(d,p){return new Promise((v,$)=>{d.db.get(p,(f,y)=>f?(this.o(d,`[storage ${this.c}] get(): ${f}`),$(f)):v(y))})}s(d,p){return new Promise((v,$)=>{d.db.all(p,(f,y)=>f?(this.o(d,`[storage ${this.c}] all(): ${f}`),$(f)):v(y))})}t(d,p){return new Promise((v,$)=>{d.db.serialize(()=>{d.db.run("BEGIN TRANSACTION"),p(),d.db.run("END TRANSACTION",f=>f?(this.o(d,`[storage ${this.c}] transaction(): ${f}`),$(f)):v())})})}u(d,p,v,$){const f=d.db.prepare(p),y=w=>{this.o(d,`[storage ${this.c}] prepare(): ${w} (${p}). Details: ${$()}`)};f.on("error",y),v(f),f.finalize(w=>{w&&y(w),f.removeListener("error",y)})}}e.$MW=E;class h{static{this.a="VSCODE_TRACE_STORAGE"}constructor(d){d&&typeof d.logTrace=="function"&&process.env[h.a]&&(this.b=d.logTrace),d&&typeof d.logError=="function"&&(this.c=d.logError)}get isTracing(){return!!this.b}trace(d){this.b?.(d)}error(d){this.c?.(d)}}}),define(se[164],re([11,10]),function(K,e){return K.create("vs/code/electron-main/app",e)}),define(se[165],re([11,10]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(se[166],re([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/contextkey",e)}),define(se[167],re([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/scanner",e)}),define(se[168],re([11,10]),function(K,e){return K.create("vs/platform/dialogs/common/dialogs",e)}),define(se[169],re([11,10]),function(K,e){return K.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(se[170],re([11,10]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(se[171],re([11,10]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(se[172],re([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(se[173],re([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(se[174],re([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(se[175],re([11,10]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(se[176],re([11,10]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(se[177],re([11,10]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(se[178],re([11,10]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(se[179],re([11,10]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(se[180],re([11,10]),function(K,e){return K.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(se[181],re([11,10]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(se[182],re([11,10]),function(K,e){return K.create("vs/platform/issue/electron-main/issueMainService",e)}),define(se[183],re([11,10]),function(K,e){return K.create("vs/platform/log/common/log",e)}),define(se[184],re([11,10]),function(K,e){return K.create("vs/platform/menubar/electron-main/menubar",e)}),define(se[185],re([11,10]),function(K,e){return K.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(se[186],re([11,10]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(se[187],re([11,10]),function(K,e){return K.create("vs/platform/shell/node/shellEnv",e)}),define(se[188],re([11,10]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(se[189],re([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(se[190],re([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalProfiles",e)}),define(se[191],re([11,10]),function(K,e){return K.create("vs/platform/update/common/update.config.contribution",e)}),define(se[192],re([11,10]),function(K,e){return K.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(se[193],re([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowImpl",e)}),define(se[194],re([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(se[195],re([11,10]),function(K,e){return K.create("vs/platform/workspace/common/workspace",e)}),define(se[196],re([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(se[197],re([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(se[198],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufb=n,e.$Vfb=C;function n(k){return k&&k.hasOwnProperty("folderUri")}function C(k){return k&&k.hasOwnProperty("workspace")}}),define(se[199],re([0,1,7]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=C,e.$qcc=k,e.$rcc=R;function C(j){return typeof j?.backupFolder=="string"}function k(j){let E=[];try{Array.isArray(j.workspaces)&&(E=j.workspaces.map(h=>({workspace:{id:h.id,configPath:n.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return E}function R(j){let E=[];try{Array.isArray(j.folders)&&(E=j.folders.map(h=>({folderUri:n.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return E}}),define(se[200],re([0,1,15,167]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.TokenType=void 0;var k;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(k||(e.TokenType=k={}));function R(...l){switch(l.length){case 1:return(0,C.localize)(0,null,l[0]);case 2:return(0,C.localize)(1,null,l[0],l[1]);case 3:return(0,C.localize)(2,null,l[0],l[1],l[2]);default:return}}const j=(0,C.localize)(3,null),E=(0,C.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(d){switch(d.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return d.isTripleEq?"===":"==";case 4:return d.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return d.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return d.lexeme;case 18:return d.lexeme;case 19:return d.lexeme;case 20:return"EOF";default:throw(0,n.$8)(`unhandled token type: ${JSON.stringify(d)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(d=>d.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(d){return this.c=d,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const p=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:p})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const p=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:p})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(d){return this.r()||this.c.charCodeAt(this.e)!==d?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(d){this.f.push({type:d,offset:this.d})}l(d){const p=this.d,v=this.c.substring(this.d,this.e),$={type:19,offset:this.d,lexeme:v};this.g.push({offset:p,lexeme:v,additionalInfo:d}),this.f.push($)}n(){this.m.lastIndex=this.d;const d=this.m.exec(this.c);if(d){this.e=this.d+d[0].length;const p=this.c.substring(this.d,this.e),v=h.b.get(p);v?this.k(v):this.f.push({type:17,lexeme:p,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let d=this.e,p=!1,v=!1;for(;;){if(d>=this.c.length){this.e=d,this.l(E);return}const f=this.c.charCodeAt(d);if(p)p=!1;else if(f===47&&!v){d++;break}else f===91?v=!0:f===92?p=!0:f===93&&(v=!1);d++}for(;d<this.c.length&&h.a.has(this.c.charCodeAt(d));)d++;this.e=d;const $=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$tj=h}),define(se[201],re([0,1,3,2]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=void 0;class k{constructor(){this.a=new n.$fe,this.b=new n.$fe,this.c=new n.$fe,this.d=new n.$fe}static{this.ChannelName="extensionhostdebugservice"}call(E,h,l){switch(h){case"close":return Promise.resolve(this.a.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(E,h,l){switch(h){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Lo=k;class R extends C.$Uc{constructor(E){super(),this.b=E}reload(E){this.b.call("reload",[E])}get onReload(){return this.b.listen("reload")}close(E){this.b.call("close",[E])}get onClose(){return this.b.listen("close")}attachSession(E,h,l){this.b.call("attach",[E,h,l])}get onAttachSession(){return this.b.listen("attach")}terminateSession(E,h){this.b.call("terminate",[E,h])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(E,h){return this.b.call("openExtensionDevelopmentHostWindow",[E,h])}}e.$Mo=R}),define(se[202],re([0,1,151,51,13,9,36,19,7]),function(K,e,n,C,k,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=void 0,e.$9m=d,e.$0m=p,e.$7m=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,R.$mc)(k.$Sg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,R.$jc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,E.$_g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$_g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,n.$6m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.$jc)(this.userDataPath,"logs",$)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$_g)(h.URI.file((0,R.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$_g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$_g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$_g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=j.env.VSCODE_PORTABLE;return $?h.URI.file((0,R.$jc)($,"argv.json")):(0,E.$_g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,R.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,R.$kc)($):(0,R.$hc)((0,R.$jc)(k.$Sg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?h.URI.file((0,R.$kc)($)):h.URI.file((0,R.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,R.$kc)($);const f=j.env.VSCODE_EXTENSIONS;if(f)return f;const y=j.env.VSCODE_PORTABLE;return y?(0,R.$jc)(y,"extensions"):(0,E.$_g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(f=>/^[^:/?#]+?:\/\//.test(f)?h.URI.parse(f):h.URI.file((0,R.$hc)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?h.URI.parse($):h.URI.file((0,R.$hc)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return d(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!e.$7m.test($))}get extensionLogLevel(){const $=[];for(const f of this.args.log||[]){const y=e.$7m.exec(f);y&&y[1]&&y[2]&&$.push([y[1],y[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,E.$_g)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=j.env.VSCODE_PORTABLE;return $?h.URI.file((0,R.$jc)($,"policy.json")):(0,E.$_g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,f,y){this.a=$,this.b=f,this.c=y,this.editSessionId=this.args.editSessionId}}e.$8m=l,Ee([C.$3h],l.prototype,"appRoot",null),Ee([C.$3h],l.prototype,"userHome",null),Ee([C.$3h],l.prototype,"userDataPath",null),Ee([C.$3h],l.prototype,"appSettingsHome",null),Ee([C.$3h],l.prototype,"tmpDir",null),Ee([C.$3h],l.prototype,"cacheHome",null),Ee([C.$3h],l.prototype,"stateResource",null),Ee([C.$3h],l.prototype,"userRoamingDataHome",null),Ee([C.$3h],l.prototype,"userDataSyncHome",null),Ee([C.$3h],l.prototype,"sync",null),Ee([C.$3h],l.prototype,"machineSettingsResource",null),Ee([C.$3h],l.prototype,"workspaceStorageHome",null),Ee([C.$3h],l.prototype,"localHistoryHome",null),Ee([C.$3h],l.prototype,"keyboardLayoutResource",null),Ee([C.$3h],l.prototype,"argvResource",null),Ee([C.$3h],l.prototype,"isExtensionDevelopment",null),Ee([C.$3h],l.prototype,"untitledWorkspacesHome",null),Ee([C.$3h],l.prototype,"builtinExtensionsPath",null),Ee([C.$3h],l.prototype,"extensionsPath",null),Ee([C.$3h],l.prototype,"extensionDevelopmentLocationURI",null),Ee([C.$3h],l.prototype,"extensionDevelopmentKind",null),Ee([C.$3h],l.prototype,"extensionTestsLocationURI",null),Ee([C.$3h],l.prototype,"debugExtensionHost",null),Ee([C.$3h],l.prototype,"logLevel",null),Ee([C.$3h],l.prototype,"extensionLogLevel",null),Ee([C.$3h],l.prototype,"serviceMachineIdResource",null),Ee([C.$3h],l.prototype,"disableTelemetry",null),Ee([C.$3h],l.prototype,"disableWorkspaceTrust",null),Ee([C.$3h],l.prototype,"useInMemorySecretStorage",null),Ee([C.$3h],l.prototype,"policyFile",null);function d(v,$){return p(v["inspect-extensions"],v["inspect-brk-extensions"],5870,$,v.debugId,v.extensionEnvironment)}function p(v,$,f,y,w,b){const m=Number($||v)||(y?null:f),S=m?!!$:!1;let a;if(b)try{a=JSON.parse(b)}catch{}return{port:m,break:S,debugId:w,env:a}}}),define(se[116],re([0,1,313,4,170]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0,e.$vm=E,e.$wm=l,e.$xm=$,e.$ym=f;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.$tm=["tunnel","serve-web"],e.$um={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,k.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,k.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,k.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,k.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,k.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,k.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const j={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(y,w,b=j){const c=y.find(u=>u.length>0&&u[0]!=="-"),m={},S=["_"],a=[],t={};let r;for(const u in w){const g=w[u];g.type==="subcommand"?u===c&&(r=g):(g.alias&&(m[u]=g.alias),g.type==="string"||g.type==="string[]"?(S.push(u),g.deprecates&&S.push(...g.deprecates)):g.type==="boolean"&&(a.push(u),g.deprecates&&a.push(...g.deprecates)),g.global&&(t[u]=g))}if(r&&c){const u=t;for(const I in r.options)u[I]=r.options[I];const g=y.filter(I=>I!==c),P=b.getSubcommandReporter?b.getSubcommandReporter(c):void 0,D=E(g,u,P);return{[c]:D,_:[]}}const s=n(y,{string:S,boolean:a,alias:m}),i={},o=s;i._=s._.map(u=>String(u)).filter(u=>u.length>0),delete o._;for(const u in w){const g=w[u];if(g.type==="subcommand")continue;g.alias&&delete o[g.alias];let P=o[u];if(g.deprecates)for(const D of g.deprecates)o.hasOwnProperty(D)&&(P||(P=o[D],P&&b.onDeprecatedOption(D,g.deprecationMessage||(0,k.localize)(39,null,u))),delete o[D]);if(typeof P<"u"){if(g.type==="string[]"){if(Array.isArray(P)||(P=[P]),!g.allowEmptyValue){const D=P.filter(I=>I.length>0);D.length!==P.length&&(b.onEmptyValue(u),P=D.length>0?D:void 0)}}else g.type==="string"&&(Array.isArray(P)?(P=P.pop(),b.onMultipleValues(u,P)):!P&&!g.allowEmptyValue&&(b.onEmptyValue(u),P=void 0));i[u]=P,g.deprecationMessage&&b.onDeprecatedOption(u,g.deprecationMessage)}delete o[u]}for(const u in o)b.onUnknownOption(u);return i}function h(y,w){let b="";return w.args&&(Array.isArray(w.args)?b=` <${w.args.join("> <")}>`:b=` <${w.args}>`),w.alias?`-${w.alias} --${y}${b}`:`--${y}${b}`}function l(y,w){const b=[];for(const c in y){const m=y[c],S=h(c,m);b.push([S,m.description])}return d(b,w)}function d(y,w){const c=y.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(w-c<25)return y.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const m=w-c-1,S=[];for(const a of y){const t=a[0],r=v(a[1],m),s=p(c-t.length-2);S.push("  "+t+s+r[0]);for(let i=1;i<r.length;i++)S.push(p(c)+r[i])}return S}function p(y){return" ".repeat(y)}function v(y,w){const b=[];for(;y.length;){const c=y.length<w?y.length:y.lastIndexOf(" ",w),m=y.slice(0,c).trim();y=y.slice(c),b.push(m)}return b}function $(y,w,b,c,m){const S=process.stdout.isTTY&&process.stdout.columns||80,a=m?.noInputFiles!==!0?`[${(0,k.localize)(40,null)}...]`:"",t=[`${y} ${b}`];t.push(""),t.push(`${(0,k.localize)(41,null)}: ${w} [${(0,k.localize)(42,null)}]${a}`),t.push(""),m?.noPipe!==!0&&(C.$i?t.push((0,k.localize)(43,null,w)):t.push((0,k.localize)(44,null,w)),t.push(""));const r={},s=[];for(const i in c){const o=c[i];if(o.type==="subcommand")o.description&&s.push({command:i,description:o.description});else if(o.description&&o.cat){let u=r[o.cat];u||(r[o.cat]=u={}),u[i]=o}}for(const i in r){const o=i,u=r[o];u&&(t.push(R[o]),t.push(...l(u,S)),t.push(""))}return s.length&&(t.push((0,k.localize)(45,null)),t.push(...d(s.map(i=>[i.command,i.description]),S)),t.push("")),t.join(`
`)}function f(y,w){return`${y||(0,k.localize)(46,null)}
${w||(0,k.localize)(47,null)}
${process.arch}`}}),define(se[203],re([0,1,88,201,116]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;class R extends C.$Lo{constructor(E){super(),this.f=E}call(E,h,l){return h==="openExtensionDevelopmentHostWindow"?this.g(l[0],l[1]):super.call(E,h,l)}async g(E,h){const l=(0,k.$vm)(E,k.$um);l.debugRenderer=h;const d=l.extensionDevelopmentPath;if(!d)return{success:!1};const[p]=await this.f.openExtensionDevelopmentHostWindow(d,{context:5,cli:l,forceProfile:l.profile,forceTempProfile:l["profile-temp"]});if(!h)return{success:!0};const v=p.win;if(!v)return{success:!0};const $=v.webContents.debugger;let f=$.isAttached()?1/0:0;const y=(0,n.createServer)(w=>{f++===0&&$.attach();let b=!1;const c=a=>{b||w.write(JSON.stringify(a)+"\0")},m=(a,t,r,s)=>c({method:t,params:r,sessionId:s});v.on("close",()=>{$.removeListener("message",m),w.end(),b=!0}),$.addListener("message",m);let S=Buffer.alloc(0);w.on("data",a=>{S=Buffer.concat([S,a]);for(let t=S.indexOf(0);t!==-1;t=S.indexOf(0)){let r;try{const s=S.slice(0,t).toString("utf8");S=S.slice(t+1),r=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}$.sendCommand(r.method,r.params,r.sessionId).then(s=>c({id:r.id,sessionId:r.sessionId,result:s})).catch(s=>c({id:r.id,sessionId:r.sessionId,error:{code:0,message:s.message}}))}}),w.on("error",a=>{console.error("error on cdp pipe:",a)}),w.on("close",()=>{b=!0,--f===0&&$.detach()})});return await new Promise(w=>y.listen(0,w)),v.on("close",()=>y.close()),{rendererDebugPort:y.address().port,success:!0}}}e.$4cc=R}),define(se[64],re([0,1,314,171,116]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=E,e.$Am=h,e.$Bm=l,e.$Cm=d;function R(p,v){const $=(m,S)=>{console.warn((0,C.localize)(0,null,m,S))},f=m=>{console.warn((0,C.localize)(1,null,m))},y=(m,S)=>{console.warn((0,C.localize)(2,null,m,S))},w=m=>({onUnknownOption:S=>{k.$tm.includes(m)||console.warn((0,C.localize)(3,null,S,m))},onMultipleValues:$,onEmptyValue:f,onDeprecatedOption:y,getSubcommandReporter:k.$tm.includes(m)?w:void 0}),b={onUnknownOption:m=>{console.warn((0,C.localize)(4,null,m))},onMultipleValues:$,onEmptyValue:f,onDeprecatedOption:y,getSubcommandReporter:w},c=(0,k.$vm)(p,k.$um,v?b:void 0);return c.goto&&c._.forEach(m=>n(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(m),(0,C.localize)(5,null))),c}function j(p){const v=p.findIndex($=>!/^-/.test($));if(v>-1)return[...p.slice(0,v),...p.slice(v+1)]}function E(p){let[,...v]=p;process.env.VSCODE_DEV&&(v=j(v)||[]);const $=!d(process.env);return R(v,$)}function h(p){let[,,...v]=p;return process.env.VSCODE_DEV&&(v=j(v)||[]),R(v,!0)}function l(p,...v){const $=p.indexOf("--");return $===-1?p.push(...v):p.splice($,0,...v),p}function d(p){return p.VSCODE_CLI==="1"}}),function(){"use strict";function K(e,n,C){function k(j,E){const h=R(j,E),l=[h];return e.isAbsolute(h)||l.unshift(C),e.resolve(...l)}function R(j,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,E);const d=j["user-data-dir"];if(d)return d;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(p,"AppData","Roaming")}break;case"darwin":l=e.join(n.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,E)}return{getUserDataPath:k}}if(typeof define=="function")define(se[204],re([117,26,36]),function(e,n,C){return K(e,n,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=K(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(se[91],re([0,1,26,202,204]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=void 0,e.$_m=j,e.$an=E;class R extends C.$8m{constructor(l,d){super(l,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,k.getUserDataPath)(l,d.nameShort)},d)}}e.$$m=R;function j(h,l){return(0,C.$0m)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,l,h.extensionEnvironment)}function E(h,l){return(0,C.$0m)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,l,h.extensionEnvironment)}}),define(se[205],re([0,1,43,26,31]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=R;function R(j){const E=(0,k.$Gg)((0,C.tmpdir)());try{return(0,n.writeFileSync)(E,""),j&&console.log(`Marker file for --wait created: ${E}`),E}catch(h){j&&console.error(`Failed to create marker file for --wait: ${h}`);return}}}),define(se[206],re([0,1,12,173]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=k;function k(j,E,h,l){try{R(j,E,h,l)}catch(d){j.error(d?.message??d)}return E}function R(j,E,h,l){const d=(p,v,$)=>{const f=p[v];if((0,n.$$f)(f)){const y=f,w=y.length;if(w>1&&y[0]==="%"&&y[w-1]==="%"){const b=y.substr(1,w-2);let c=h[b];c===void 0&&l&&(c=l[b]);const m=typeof c=="string"?c:c?.message,S=l?.[b],a=typeof S=="string"?S:S?.message;if(!m){a||j.warn(`[${E.name}]: ${(0,C.localize)(0,null,b)}`);return}if($&&(v==="title"||v==="category")&&a&&a!==m){const t={value:m,original:a};p[v]=t}else p[v]=m}}else if((0,n.$ag)(f))for(const y in f)f.hasOwnProperty(y)&&(y==="commands"?d(f,y,!0):d(f,y,$));else if(Array.isArray(f))for(let y=0;y<f.length;y++)d(f,y,$)};for(const p in E)E.hasOwnProperty(p)&&d(E,p)}}),define(se[207],re([0,1,19,74,175,208]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=h,e.$Kp=l,e.$Lp=d,e.$Mp=p,e.$Np=v,e.$Op=$,e.$Pp=f;const j=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function h(b){return b=b.trim(),b==="*"||j.test(b)}function l(b){if(!h(b))return null;if(b=b.trim(),b==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=b.match(j);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}function d(b){if(!b)return null;const c=b.majorBase,m=b.majorMustEqual,S=b.minorBase;let a=b.minorMustEqual;const t=b.patchBase;let r=b.patchMustEqual;b.hasCaret&&(c===0||(a=!1),r=!1);let s=0;if(b.preRelease){const i=E.exec(b.preRelease);if(i){const[,o,u,g]=i;s=Date.UTC(Number(o),Number(u)-1,Number(g))}}return{majorBase:c,majorMustEqual:m,minorBase:S,minorMustEqual:a,patchBase:t,patchMustEqual:r,isMinimum:b.hasGreaterEquals,notBefore:s}}function p(b,c,m){let S;typeof b=="string"?S=d(l(b)):S=b;let a;c instanceof Date?a=c.getTime():typeof c=="string"&&(a=new Date(c).getTime());let t;if(typeof m=="string"?t=d(l(m)):t=m,!S||!t)return!1;const r=S.majorBase,s=S.minorBase,i=S.patchBase;let o=t.majorBase,u=t.minorBase,g=t.patchBase;const P=t.notBefore;let D=t.majorMustEqual,I=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?r>o?!0:r<o?!1:s>u?!0:s<u||a&&a<P?!1:i>=g:(r===1&&o===0&&(!D||!I||!O)&&(o=1,u=0,g=0,D=!0,I=!1,O=!1),r<o?!1:r>o?!D:s<u?!1:s>u?!I:i<g?!1:i>g?!O:!(a&&a<P))}function v(b,c,m,S,a){const t=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return t.push([C.default.Error,k.localize(0,null)]),t;if(typeof S.name!="string")return t.push([C.default.Error,k.localize(1,null,"name")]),t;if(typeof S.version!="string")return t.push([C.default.Error,k.localize(2,null,"version")]),t;if(!S.engines)return t.push([C.default.Error,k.localize(3,null,"engines")]),t;if(typeof S.engines.vscode!="string")return t.push([C.default.Error,k.localize(4,null,"engines.vscode")]),t;if(typeof S.extensionDependencies<"u"&&!w(S.extensionDependencies))return t.push([C.default.Error,k.localize(5,null,"extensionDependencies")]),t;if(typeof S.activationEvents<"u"){if(!w(S.activationEvents))return t.push([C.default.Error,k.localize(6,null,"activationEvents")]),t;if(typeof S.main>"u"&&typeof S.browser>"u")return t.push([C.default.Error,k.localize(7,null,"activationEvents","main","browser")]),t}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&t.push([C.default.Warning,k.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return t.push([C.default.Error,k.localize(9,null,"main")]),t;{const i=(0,n.$_g)(m,S.main);(0,n.$6g)(i,m)||t.push([C.default.Warning,k.localize(10,null,i.path,m.path)])}}if(typeof S.browser<"u"){if(typeof S.browser!="string")return t.push([C.default.Error,k.localize(11,null,"browser")]),t;{const i=(0,n.$_g)(m,S.browser);(0,n.$6g)(i,m)||t.push([C.default.Warning,k.localize(12,null,i.path,m.path)])}}if(!R.valid(S.version))return t.push([C.default.Error,k.localize(13,null)]),t;const r=[];if(!$(b,c,S,a,r))for(const i of r)t.push([C.default.Error,i]);return t}function $(b,c,m,S,a){return S||typeof m.main>"u"&&typeof m.browser>"u"?!0:y(b,c,m.engines.vscode,a)}function f(b,c,m){return b==="*"||y(c,m,b)}function y(b,c,m,S=[]){const a=d(l(m));if(!a)return S.push(k.localize(14,null,m)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return S.push(k.localize(15,null,m)),!1}else if(!a.majorMustEqual)return S.push(k.localize(16,null,m)),!1;return p(b,c,a)?!0:(S.push(k.localize(17,null,b,m)),!1)}function w(b){if(!Array.isArray(b))return!1;for(let c=0,m=b.length;c<m;c++)if(typeof b[c]!="string")return!1;return!0}}),define(se[209],re([0,1,17,33]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=k;async function k(R,j,E){let h=E&&E.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const d=(await j.readFile(R.serviceMachineIdResource)).value.toString();h=(0,C.$Tg)(d)?d:null}catch{h=null}if(!h){h=(0,C.$Ug)();try{await j.writeFile(R.serviceMachineIdResource,n.$He.fromString(h))}catch{}}return E?.store("storage.serviceMachineId",h,-1,1),h}}),define(se[78],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=void 0;class n{constructor(k,R=[],j=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=j}}e.$vi=n}),define(se[210],re([0,1,78]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$As=R,e.$Bs=j;const C=[];var k;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function R(E,h,l){h instanceof n.$vi||(h=new n.$vi(h,[],!!l)),C.push([E,h])}function j(){return C}}),define(se[211],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=void 0;class n{constructor(R,j){this.key=R,this.data=j,this.incoming=new Map,this.outgoing=new Map}}e.$dr=n;class C{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const j of this.a.values())j.outgoing.size===0&&R.push(j);return R}insertEdge(R,j){const E=this.lookupOrInsertNode(R),h=this.lookupOrInsertNode(j);E.outgoing.set(h.key,h),h.incoming.set(E.key,E)}removeNode(R){const j=this.b(R);this.a.delete(j);for(const E of this.a.values())E.outgoing.delete(j),E.incoming.delete(j)}lookupOrInsertNode(R){const j=this.b(R);let E=this.a.get(j);return E||(E=new n(j,R),this.a.set(j,E)),E}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[j,E]of this.a)R.push(`${j}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,j]of this.a){const E=new Set([R]),h=this.c(j,E);if(h)return h}}c(R,j){for(const[E,h]of R.outgoing){if(j.has(E))return[...j,E].join(" -> ");j.add(E);const l=this.c(h,j);if(l)return l;j.delete(E)}}}e.$er=C}),define(se[6],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e._util=void 0,e.$yi=k,e.$zi=R;var n;(function(j){j.serviceIds=new Map,j.DI_TARGET="$di$target",j.DI_DEPENDENCIES="$di$dependencies";function E(h){return h[j.DI_DEPENDENCIES]||[]}j.getServiceDependencies=E})(n||(e._util=n={})),e.$xi=k("instantiationService");function C(j,E,h){E[n.DI_TARGET]===E?E[n.DI_DEPENDENCIES].push({id:j,index:h}):(E[n.DI_DEPENDENCIES]=[{id:j,index:h}],E[n.DI_TARGET]=E)}function k(j){if(n.serviceIds.has(j))return n.serviceIds.get(j);const E=function(h,l,d){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(E,h,d)};return E.toString=()=>j,n.serviceIds.set(j,E),E}function R(j){return j}}),define(se[79],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0,e.$jdc=(0,n.$yi)("auxiliaryWindowsMainService")}),define(se[65],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0,e.$scc=(0,n.$yi)("backupMainService")}),define(se[18],re([0,1,12,7,6]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$5i=void 0,e.$6i=R,e.$7i=j,e.$8i=h,e.$9i=l,e.$0i=d,e.$$i=p,e.$_i=v,e.$aj=f,e.$bj=y,e.$cj=w,e.$5i=(0,k.$yi)("configurationService");function R(b){return b&&typeof b=="object"&&(!b.overrideIdentifier||typeof b.overrideIdentifier=="string")&&(!b.resource||b.resource instanceof C.URI)}function j(b){return b&&typeof b=="object"&&(!b.overrideIdentifiers||Array.isArray(b.overrideIdentifiers))&&!b.overrideIdentifier&&(!b.resource||b.resource instanceof C.URI)}var E;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.USER=2]="USER",b[b.USER_LOCAL=3]="USER_LOCAL",b[b.USER_REMOTE=4]="USER_REMOTE",b[b.WORKSPACE=5]="WORKSPACE",b[b.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",b[b.DEFAULT=7]="DEFAULT",b[b.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function h(b){switch(b){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function l(b){return b.applicationValue!==void 0||b.userValue!==void 0||b.userLocalValue!==void 0||b.userRemoteValue!==void 0||b.workspaceValue!==void 0||b.workspaceFolderValue!==void 0}function d(b,c){const m=Object.create(null);for(const S in b)p(m,S,b[S],c);return m}function p(b,c,m,S){const a=c.split("."),t=a.pop();let r=b;for(let s=0;s<a.length;s++){const i=a[s];let o=r[i];switch(typeof o){case"undefined":o=r[i]=Object.create(null);break;case"object":if(o===null){S(`Ignoring ${c} as ${a.slice(0,s+1).join(".")} is null`);return}break;default:S(`Ignoring ${c} as ${a.slice(0,s+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[t]=m}catch{S(`Ignoring ${c} as ${a.join(".")} is ${JSON.stringify(r)}`)}else S(`Ignoring ${c} as ${a.join(".")} is ${JSON.stringify(r)}`)}function v(b,c){const m=c.split(".");$(b,m)}function $(b,c){const m=c.shift();if(c.length===0){delete b[m];return}if(Object.keys(b).indexOf(m)!==-1){const S=b[m];typeof S=="object"&&!Array.isArray(S)&&($(S,c),Object.keys(S).length===0&&delete b[m])}}function f(b,c,m){function S(r,s){let i=r;for(const o of s){if(typeof i!="object"||i===null)return;i=i[o]}return i}const a=c.split("."),t=S(b,a);return typeof t>"u"?m:t}function y(b,c,m){Object.keys(c).forEach(S=>{S!=="__proto__"&&(S in b?n.$ag(b[S])&&n.$ag(c[S])?y(b[S],c[S],m):m&&(b[S]=c[S]):b[S]=c[S])})}function w(b){return b.replace(/[\[\]]/g,"")}}),define(se[118],re([0,1,4,25,200,6,166,15]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$wj=e.$vj=e.ContextKeyExprType=void 0,e.$uj=l,e.$xj=r,e.$yj=s,e.$Rj=oe;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",n.$j),h.set("isLinux",n.$k),h.set("isWindows",n.$i),h.set("isWeb",n.$o),h.set("isMacNative",n.$j&&!n.$o),h.set("isEdge",n.$H),h.set("isFirefox",n.$F),h.set("isChrome",n.$E),h.set("isSafari",n.$G);function l(Q,A){if(h.get(Q)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(Q,A)}const d=Object.prototype.hasOwnProperty;var p;(function(Q){Q[Q.False=0]="False",Q[Q.True=1]="True",Q[Q.Defined=2]="Defined",Q[Q.Not=3]="Not",Q[Q.Equals=4]="Equals",Q[Q.NotEquals=5]="NotEquals",Q[Q.And=6]="And",Q[Q.Regex=7]="Regex",Q[Q.NotRegex=8]="NotRegex",Q[Q.Or=9]="Or",Q[Q.In=10]="In",Q[Q.NotIn=11]="NotIn",Q[Q.Greater=12]="Greater",Q[Q.GreaterEquals=13]="GreaterEquals",Q[Q.Smaller=14]="Smaller",Q[Q.SmallerEquals=15]="SmallerEquals"})(p||(e.ContextKeyExprType=p={}));const v={regexParsingWithErrorRecovery:!0},$=(0,j.localize)(0,null),f=(0,j.localize)(1,null),y=(0,j.localize)(2,null),w=(0,j.localize)(3,null),b=(0,j.localize)(4,null),c=(0,j.localize)(5,null),m=(0,j.localize)(6,null),S=(0,j.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(A=v){this.k=A,this.d=new k.$tj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(A){if(A===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(A).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const _=this.D(),z=_.type===17?c:void 0;throw this.h.push({message:b,offset:_.offset,lexeme:k.$tj.getLexeme(_),additionalInfo:z}),a.c}return N}catch(N){if(N!==a.c)throw N;return}}l(){return this.m()}m(){const A=[this.o()];for(;this.y(16);){const N=this.o();A.push(N)}return A.length===1?A[0]:t.or(...A)}o(){const A=[this.s()];for(;this.y(15);){const N=this.s();A.push(N)}return A.length===1?A[0]:t.and(...A)}s(){if(this.y(2)){const A=this.D();switch(A.type){case 11:return this.z(),o.INSTANCE;case 12:return this.z(),u.INSTANCE;case 0:{this.z();const N=this.l();return this.A(1,w),N?.negate()}case 17:return this.z(),M.create(A.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",A)}}return this.t()}t(){const A=this.D();switch(A.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const N=this.l();return this.A(1,w),N}case 17:{const N=A.lexeme;if(this.z(),this.y(9)){const z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),z.type!==10)throw this.B("REGEX",z);const Y=z.lexeme,x=Y.lastIndexOf("/"),ee=x===Y.length-1?void 0:this.w(Y.substring(x+1));let X;try{X=new RegExp(Y.substring(1,x),ee)}catch{throw this.B("REGEX",z)}return te.create(N,X)}switch(z.type){case 10:case 19:{const Y=[z.lexeme];this.z();let x=this.D(),ee=0;for(let $e=0;$e<z.lexeme.length;$e++)z.lexeme.charCodeAt($e)===40?ee++:z.lexeme.charCodeAt($e)===41&&ee--;for(;!this.E()&&x.type!==15&&x.type!==16;){switch(x.type){case 0:ee++;break;case 1:ee--;break;case 10:case 18:for(let $e=0;$e<x.lexeme.length;$e++)x.lexeme.charCodeAt($e)===40?ee++:z.lexeme.charCodeAt($e)===41&&ee--}if(ee<0)break;Y.push(k.$tj.getLexeme(x)),this.z(),x=this.D()}const X=Y.join(""),ue=X.lastIndexOf("/"),he=ue===X.length-1?void 0:this.w(X.substring(ue+1));let pe;try{pe=new RegExp(X.substring(1,ue),he)}catch{throw this.B("REGEX",z)}return t.regex(N,pe)}case 18:{const Y=z.lexeme;this.z();let x=null;if(!(0,C.$9e)(Y)){const ee=Y.indexOf("/"),X=Y.lastIndexOf("/");if(ee!==X&&ee>=0){const ue=Y.slice(ee+1,X),he=Y[X+1]==="i"?"i":"";try{x=new RegExp(ue,he)}catch{throw this.B("REGEX",z)}}}if(x===null)throw this.B("REGEX",z);return te.create(N,x)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const z=this.u();return t.notIn(N,z)}switch(this.D().type){case 3:{this.z();const z=this.u();if(this.x().type===18)return t.equals(N,z);switch(z){case"true":return t.has(N);case"false":return t.not(N);default:return t.equals(N,z)}}case 4:{this.z();const z=this.u();if(this.x().type===18)return t.notEquals(N,z);switch(z){case"true":return t.not(N);case"false":return t.has(N);default:return t.notEquals(N,z)}}case 5:return this.z(),U.create(N,this.u());case 6:return this.z(),ae.create(N,this.u());case 7:return this.z(),F.create(N,this.u());case 8:return this.z(),T.create(N,this.u());case 13:return this.z(),t.in(N,this.u());default:return t.has(N)}}case 20:throw this.h.push({message:m,offset:A.offset,lexeme:"",additionalInfo:S}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const A=this.D();switch(A.type){case 17:case 18:return this.z(),A.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(A){return A.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(A){return this.C(A)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(A,N){if(this.C(A))return this.z();throw this.B(N,this.D())}B(A,N,_){const z=(0,j.localize)(8,null,A,k.$tj.getLexeme(N)),Y=N.offset,x=k.$tj.getLexeme(N);return this.h.push({message:z,offset:Y,lexeme:x,additionalInfo:_}),a.c}C(A){return this.D().type===A}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$vj=a;class t{static false(){return o.INSTANCE}static true(){return u.INSTANCE}static has(A){return g.create(A)}static equals(A,N){return P.create(A,N)}static notEquals(A,N){return O.create(A,N)}static regex(A,N){return te.create(A,N)}static in(A,N){return D.create(A,N)}static notIn(A,N){return I.create(A,N)}static not(A){return M.create(A)}static and(...A){return V.create(A,null,!0)}static or(...A){return q.create(A,null,!0)}static greater(A,N){return F.create(A,N)}static greaterEquals(A,N){return T.create(A,N)}static smaller(A,N){return U.create(A,N)}static smallerEquals(A,N){return ae.create(A,N)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(A){return A==null?void 0:this.c.parse(A)}}e.$wj=t;function r(Q){const A=new a({regexParsingWithErrorRecovery:!1});return Q.map(N=>(A.parse(N),A.lexingErrors.length>0?A.lexingErrors.map(_=>({errorMessage:_.additionalInfo?(0,j.localize)(9,null,_.additionalInfo):(0,j.localize)(10,null),offset:_.offset,length:_.lexeme.length})):A.parsingErrors.length>0?A.parsingErrors.map(_=>({errorMessage:_.additionalInfo?`${_.message}. ${_.additionalInfo}`:_.message,offset:_.offset,length:_.lexeme.length})):[]))}function s(Q,A){const N=Q?Q.substituteConstants():void 0,_=A?A.substituteConstants():void 0;return!N&&!_?!0:!N||!_?!1:N.equals(_)}function i(Q,A){return Q.cmp(A)}class o{static{this.INSTANCE=new o}constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return u.INSTANCE}}e.$zj=o;class u{static{this.INSTANCE=new u}constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return o.INSTANCE}}e.$Aj=u;class g{static create(A,N=null){const _=h.get(A);return typeof _=="boolean"?_?u.INSTANCE:o.INSTANCE:new g(A,N)}constructor(A,N){this.key=A,this.c=N,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:B(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=h.get(this.key);return typeof A=="boolean"?A?u.INSTANCE:o.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Bj=g;class P{static create(A,N,_=null){if(typeof N=="boolean")return N?g.create(A,_):M.create(A,_);const z=h.get(A);return typeof z=="boolean"?N===(z?"true":"false")?u.INSTANCE:o.INSTANCE:new P(A,N,_)}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:H(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=h.get(this.c);if(typeof A=="boolean"){const N=A?"true":"false";return this.d===N?u.INSTANCE:o.INSTANCE}return this}evaluate(A){return A.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(A){return A.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Cj=P;class D{static create(A,N){return new D(A,N)}constructor(A,N){this.d=A,this.f=N,this.type=10,this.c=null}cmp(A){return A.type!==this.type?this.type-A.type:H(this.d,this.f,A.d,A.f)}equals(A){return A.type===this.type?this.d===A.d&&this.f===A.f:!1}substituteConstants(){return this}evaluate(A){const N=A.getValue(this.f),_=A.getValue(this.d);return Array.isArray(N)?N.includes(_):typeof _=="string"&&typeof N=="object"&&N!==null?d.call(N,_):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(A){return A.mapIn(this.d,this.f)}negate(){return this.c||(this.c=I.create(this.d,this.f)),this.c}}e.$Dj=D;class I{static create(A,N){return new I(A,N)}constructor(A,N){this.d=A,this.f=N,this.type=11,this.c=D.create(A,N)}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(A){return A.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ej=I;class O{static create(A,N,_=null){if(typeof N=="boolean")return N?M.create(A,_):g.create(A,_);const z=h.get(A);return typeof z=="boolean"?N===(z?"true":"false")?o.INSTANCE:u.INSTANCE:new O(A,N,_)}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:H(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=h.get(this.c);if(typeof A=="boolean"){const N=A?"true":"false";return this.d===N?o.INSTANCE:u.INSTANCE}return this}evaluate(A){return A.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(A){return A.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Fj=O;class M{static create(A,N=null){const _=h.get(A);return typeof _=="boolean"?_?o.INSTANCE:u.INSTANCE:new M(A,N)}constructor(A,N){this.c=A,this.d=N,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:B(this.c,A.c)}equals(A){return A.type===this.type?this.c===A.c:!1}substituteConstants(){const A=h.get(this.c);return typeof A=="boolean"?A?o.INSTANCE:u.INSTANCE:this}evaluate(A){return!A.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(A){return A.mapNot(this.c)}negate(){return this.d||(this.d=g.create(this.c,this)),this.d}}e.$Gj=M;function W(Q,A){if(typeof Q=="string"){const N=parseFloat(Q);isNaN(N)||(Q=N)}return typeof Q=="string"||typeof Q=="number"?A(Q):o.INSTANCE}class F{static create(A,N,_=null){return W(N,z=>new F(A,z,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:H(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Hj=F;class T{static create(A,N,_=null){return W(N,z=>new T(A,z,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:H(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Ij=T;class U{static create(A,N,_=null){return W(N,z=>new U(A,z,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:H(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Jj=U;class ae{static create(A,N,_=null){return W(N,z=>new ae(A,z,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:H(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Kj=ae;class te{static create(A,N){return new te(A,N)}constructor(A,N){this.d=A,this.f=N,this.type=7,this.c=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.d<A.d)return-1;if(this.d>A.d)return 1;const N=this.f?this.f.source:"",_=A.f?A.f.source:"";return N<_?-1:N>_?1:0}equals(A){if(A.type===this.type){const N=this.f?this.f.source:"",_=A.f?A.f.source:"";return this.d===A.d&&N===_}return!1}substituteConstants(){return this}evaluate(A){const N=A.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const A=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${A}`}keys(){return[this.d]}map(A){return A.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$Lj=te;class ce{static create(A){return new ce(A)}constructor(A){this.c=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(A){return new ce(this.c.map(A))}negate(){return this.c}}e.$Mj=ce;function J(Q){let A=null;for(let N=0,_=Q.length;N<_;N++){const z=Q[N].substituteConstants();if(Q[N]!==z&&A===null){A=[];for(let Y=0;Y<N;Y++)A[Y]=Q[Y]}A!==null&&(A[N]=z)}return A===null?Q:A}class V{static create(A,N,_){return V.d(A,N,_)}constructor(A,N){this.expr=A,this.c=N,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let N=0,_=this.expr.length;N<_;N++){const z=i(this.expr[N],A.expr[N]);if(z!==0)return z}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].equals(A.expr[N]))return!1;return!0}return!1}substituteConstants(){const A=J(this.expr);return A===this.expr?this:V.create(A,this.c,!1)}evaluate(A){for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].evaluate(A))return!1;return!0}static d(A,N,_){const z=[];let Y=!1;for(const x of A)if(x){if(x.type===1){Y=!0;continue}if(x.type===0)return o.INSTANCE;if(x.type===6){z.push(...x.expr);continue}z.push(x)}if(z.length===0&&Y)return u.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(i);for(let x=1;x<z.length;x++)z[x-1].equals(z[x])&&(z.splice(x,1),x--);if(z.length===1)return z[0];for(;z.length>1;){const x=z[z.length-1];if(x.type!==9)break;z.pop();const ee=z.pop(),X=z.length===0,ue=q.create(x.expr.map(he=>V.create([he,ee],null,_)),null,X);ue&&(z.push(ue),z.sort(i))}if(z.length===1)return z[0];if(_){for(let x=0;x<z.length;x++)for(let ee=x+1;ee<z.length;ee++)if(z[x].negate().equals(z[ee]))return o.INSTANCE;if(z.length===1)return z[0]}return new V(z,N)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const N of this.expr)A.push(...N.keys());return A}map(A){return new V(this.expr.map(N=>N.map(A)),null)}negate(){if(!this.c){const A=[];for(const N of this.expr)A.push(N.negate());this.c=q.create(A,this,!0)}return this.c}}e.$Nj=V;class q{static create(A,N,_){return q.d(A,N,_)}constructor(A,N){this.expr=A,this.c=N,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let N=0,_=this.expr.length;N<_;N++){const z=i(this.expr[N],A.expr[N]);if(z!==0)return z}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].equals(A.expr[N]))return!1;return!0}return!1}substituteConstants(){const A=J(this.expr);return A===this.expr?this:q.create(A,this.c,!1)}evaluate(A){for(let N=0,_=this.expr.length;N<_;N++)if(this.expr[N].evaluate(A))return!0;return!1}static d(A,N,_){let z=[],Y=!1;if(A){for(let x=0,ee=A.length;x<ee;x++){const X=A[x];if(X){if(X.type===0){Y=!0;continue}if(X.type===1)return u.INSTANCE;if(X.type===9){z=z.concat(X.expr);continue}z.push(X)}}if(z.length===0&&Y)return o.INSTANCE;z.sort(i)}if(z.length!==0){if(z.length===1)return z[0];for(let x=1;x<z.length;x++)z[x-1].equals(z[x])&&(z.splice(x,1),x--);if(z.length===1)return z[0];if(_){for(let x=0;x<z.length;x++)for(let ee=x+1;ee<z.length;ee++)if(z[x].negate().equals(z[ee]))return u.INSTANCE;if(z.length===1)return z[0]}return new q(z,N)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const N of this.expr)A.push(...N.keys());return A}map(A){return new q(this.expr.map(N=>N.map(A)),null)}negate(){if(!this.c){const A=[];for(const N of this.expr)A.push(N.negate());for(;A.length>1;){const N=A.shift(),_=A.shift(),z=[];for(const Y of le(N))for(const x of le(_))z.push(V.create([Y,x],null,!1));A.unshift(q.create(z,null,!1))}this.c=q.create(A,this,!0)}return this.c}}e.$Oj=q;class L extends g{static{this.d=[]}static all(){return L.d.values()}constructor(A,N,_){super(A,null),this.f=N,typeof _=="object"?L.d.push({..._,key:A}):_!==!0&&L.d.push({key:A,description:_,type:N!=null?typeof N:void 0})}bindTo(A){return A.createKey(this.key,this.f)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return P.create(this.key,A)}notEqualsTo(A){return O.create(this.key,A)}}e.$Pj=L,e.$Qj=(0,R.$yi)("contextKeyService");function B(Q,A){return Q<A?-1:Q>A?1:0}function H(Q,A,N,_){return Q<N?-1:Q>N?1:A<_?-1:A>_?1:0}function oe(Q,A){if(Q.type===0||A.type===1)return!0;if(Q.type===9)return A.type===9?G(Q.expr,A.expr):!1;if(A.type===9){for(const N of A.expr)if(oe(Q,N))return!0;return!1}if(Q.type===6){if(A.type===6)return G(A.expr,Q.expr);for(const N of Q.expr)if(oe(N,A))return!0;return!1}return Q.equals(A)}function G(Q,A){let N=0,_=0;for(;N<Q.length&&_<A.length;){const z=Q[N].cmp(A[_]);if(z<0)return!1;z===0&&N++,_++}return N===Q.length}function le(Q){return Q.type===9?Q.expr:[Q]}}),define(se[92],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$fn=e.ID=void 0,e.$gn=C,e.ID="diagnosticsService",e.$fn=(0,n.$yi)(e.ID);function C(R){return!!R.hostName&&!!R.errorMessage}class k{async getPerformanceInfo(j,E){return{}}async getSystemInfo(j,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(j,E){return""}async getWorkspaceFileExtensions(j){return{extensions:[]}}async reportWorkspaceStats(j){}}e.$hn=k}),define(se[119],re([0,1,19,74,168,6,48,4,35]),function(K,e,n,C,k,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Sw=e.$Rw=e.$Qw=void 0,e.$Tw=$,e.$Uw=f,e.$Qw=(0,R.$yi)("dialogService");var l;(function(y){y[y.Confirmation=1]="Confirmation",y[y.Prompt=2]="Prompt",y[y.Input=3]="Input"})(l||(l={}));class d{a(w){return this.d(w,l.Confirmation)}b(w){return this.d(w,l.Prompt)}c(w){return this.d(w,l.Input)}d(w,b){const c=[];switch(b){case l.Confirmation:{const m=w;m.primaryButton?c.push(m.primaryButton):c.push((0,k.localize)(0,null)),m.cancelButton?c.push(m.cancelButton):c.push((0,k.localize)(1,null));break}case l.Prompt:{const m=w;Array.isArray(m.buttons)&&m.buttons.length>0&&c.push(...m.buttons.map(S=>S.label)),m.cancelButton&&(m.cancelButton===!0?c.push((0,k.localize)(2,null)):typeof m.cancelButton=="string"?c.push(m.cancelButton):m.cancelButton.label?c.push(m.cancelButton.label):c.push((0,k.localize)(3,null))),c.length===0&&c.push((0,k.localize)(4,null));break}case l.Input:{const m=w;m.primaryButton?c.push(m.primaryButton):c.push((0,k.localize)(5,null)),m.cancelButton?c.push(m.cancelButton):c.push((0,k.localize)(6,null));break}}return c}e(w){if(typeof w=="string")return w;if(typeof w=="number")return w===C.default.Info?"info":w===C.default.Error?"error":w===C.default.Warning?"warning":"none"}f(w,b,c){const m=[...w.buttons??[]];w.cancelButton&&typeof w.cancelButton!="string"&&typeof w.cancelButton!="boolean"&&m.push(w.cancelButton);let S=m[b]?.run({checkboxChecked:c});return S instanceof Promise||(S=Promise.resolve(S)),{result:S,checkboxChecked:c}}}e.$Rw=d,e.$Sw=(0,R.$yi)("fileDialogService");var p;(function(y){y[y.SAVE=0]="SAVE",y[y.DONT_SAVE=1]="DONT_SAVE",y[y.CANCEL=2]="CANCEL"})(p||(e.ConfirmResult=p={}));const v=10;function $(y){const w=[];return w.push(...y.slice(0,v).map(b=>typeof b=="string"?b:(0,n.$9g)(b))),y.length>v&&(y.length-v===1?w.push((0,k.localize)(7,null)):w.push((0,k.localize)(8,null,y.length-v))),w.push(""),w.join(`
`)}function f(y,w){const b=(0,h.$5n)(y);let c=(b.buttons??[]).map(t=>(0,j.$Nw)(t)),m=(y.buttons||[]).map((t,r)=>r),S=0,a=b.cancelId??c.length-1;if(c.length>1){const t=typeof a=="number"?c[a]:void 0;if(E.$k||E.$j){if(typeof t=="string"&&c.length>1&&a!==1){c.splice(a,1),c.splice(1,0,t);const r=m[a];m.splice(a,1),m.splice(1,0,r),a=1}E.$k&&c.length>1&&(c=c.reverse(),m=m.reverse(),S=c.length-1,typeof t=="string"&&(a=S-1))}else if(E.$i&&typeof t=="string"&&c.length>1&&a!==c.length-1){c.splice(a,1),c.push(t);const r=m[a];m.splice(a,1),m.push(r),a=c.length-1}}return b.buttons=c,b.defaultId=S,b.cancelId=a,b.noLink=!0,b.title=b.title||w.nameLong,{options:b,buttonIndeces:m}}}),define(se[120],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$3W=e.$2W=void 0,e.$4W=R,e.$5W=j,e.$2W=(0,n.$yi)("encryptionService"),e.$3W=(0,n.$yi)("encryptionMainService");var C;(function(E){E.kwallet="kwallet",E.kwallet5="kwallet5",E.gnomeLibsecret="gnome-libsecret",E.basic="basic"})(C||(e.PasswordStoreCLIOption=C={}));var k;(function(E){E.unknown="unknown",E.basicText="basic_text",E.gnomeAny="gnome_any",E.gnomeLibsecret="gnome_libsecret",E.gnomeKeyring="gnome_keyring",E.kwallet="kwallet",E.kwallet5="kwallet5",E.kwallet6="kwallet6",E.dplib="dpapi",E.keychainAccess="keychain_access"})(k||(e.KnownStorageProvider=k={}));function R(E){return E==="kwallet"||E==="kwallet5"||E==="kwallet6"}function j(E){return E==="gnome_any"||E==="gnome_libsecret"||E==="gnome_keyring"}}),define(se[38],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=void 0,e.$Fi=(0,n.$yi)("environmentService"),e.$Gi=(0,n.$zi)(e.$Fi)}),define(se[121],re([0,1,172,6]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.ExtensionManagementErrorCode=e.$0o=e.ExtensionGalleryErrorCode=e.$9o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$3o=k,e.$4o=R,e.$5o=j,e.$6o=E,e.$7o=h,e.$8o=l,e.$Wo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Xo=new RegExp(e.$Wo),e.$Yo="__web_extension",e.$Zo="skipWalkthrough",e.$1o="extensionsSync",e.$2o="dependecyOrPackExtensionInstall";function k(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function R(c){switch(c){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function j(c,m){switch(c){case 3:return m==="x64"?"win32-x64":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function E(c,m){return m==="web"&&!c.includes("web")}function h(c,m,S){return E(m,S)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===S}function l(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}var d;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(d||(e.SortBy=d={}));var p;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var v;(function(c){c.Install="install",c.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var $;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$9o=(0,C.$yi)("extensionGalleryService");var f;(function(c){c.Timeout="Timeout",c.Cancelled="Cancelled",c.Failed="Failed",c.DownloadFailedWriting="DownloadFailedWriting"})(f||(e.ExtensionGalleryErrorCode=f={}));class y extends Error{constructor(m,S){super(m),this.code=S,this.name=S}}e.$0o=y;var w;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.DownloadSignature="DownloadSignature",c.DownloadFailedWriting="DownloadFailedWriting",c.UpdateMetadata="UpdateMetadata",c.Extract="Extract",c.Scanning="Scanning",c.ScanningExtension="ScanningExtension",c.ReadUninstalled="ReadUninstalled",c.UnsetUninstalled="UnsetUninstalled",c.Delete="Delete",c.Rename="Rename",c.IntializeDefaultProfile="IntializeDefaultProfile",c.AddToProfile="AddToProfile",c.PostInstall="PostInstall",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.NotAllowed="NotAllowed",c.Gallery="Gallery",c.Cancelled="Cancelled",c.Unknown="Unknown",c.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));class b extends Error{constructor(m,S){super(m),this.code=S,this.name=S}}e.$$o=b,e.$_o=(0,C.$yi)("extensionManagementService"),e.$ap="extensionsIdentifiers/disabled",e.$bp="extensionsIdentifiers/enabled",e.$cp=(0,C.$yi)("IGlobalExtensionEnablementService"),e.$dp=(0,C.$yi)("IExtensionTipsService"),e.$ep=(0,n.localize2)(0,"Extensions"),e.$fp=(0,n.localize2)(1,"Preferences")}),define(se[212],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=e.$$cc=void 0,e.$$cc=(0,n.$yi)("extensionHostStarter"),e.$_cc="extensionHostStarter"}),define(se[213],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N7b=e.$M7b=void 0,e.$M7b=(0,n.$yi)("externalTerminal"),e.$N7b="Terminal.app"}),define(se[214],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=void 0,e.$bdc=(0,n.$yi)("externalTerminal")}),define(se[215],re([0,1,49,51,13,9,4,76,21,90,176,213]),function(K,e,n,C,k,R,j,E,h,l,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=e.$ddc=e.$cdc=void 0;const v=d.localize(0,null);class ${async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends ${static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(n,a,l.$qm(),t)}spawnTerminal(a,t,r,s){const i=t.windowsExec||f.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const o=R.$nc(i,".exe").toLowerCase();if(o==="cmder")return a.spawn(i,s?[s]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return i.indexOf(" ")>=0&&u.push('""'),u.push(i),o==="wt"&&u.push("-d ."),new Promise((g,P)=>{const D=b(process),I=a.spawn(r,u,{cwd:s,env:D,detached:!0});I.on("error",P),I.on("exit",()=>g())})}async runInTerminal(a,t,r,s,i){const o="windowsExec"in i&&i.windowsExec?i.windowsExec:f.getDefaultTerminalWindows(),u=await f.f();return new Promise((g,P)=>{const D=`"${t} - ${v}"`,I=`"${r.join('" "')}" & pause`,O=Object.assign({},b(process),s);Object.keys(O).filter(U=>O[U]===null).forEach(U=>delete O[U]);const M={cwd:t,env:O,windowsVerbatimArguments:!0};let W,F;R.$nc(o,".exe")==="wt"?(W=o,F=["-d",".",f.b,"/c",I]):u?(W=u,F=["-d",".",o,"/c",I]):(W=f.b,F=["/c","start",D,"/wait",o,"/c",`"${I}"`]),n.spawn(W,F,M).on("error",U=>{P(c(U))}),g(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return f.d}static async f(){try{const a=await l.win32.findExecutable("wt");return await h.Promises.exists(a)?a:void 0}catch{return}}}e.$cdc=f,Ee([C.$3h],f,"f",null);class y extends ${static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,r,s,i){const o=i.osxExec||p.$N7b;return new Promise((u,g)=>{if(o===p.$N7b||o==="iTerm.app"){const P=o===p.$N7b?"TerminalHelper":"iTermHelper",I=[k.$Sg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${P}.scpt`).fsPath,"-t",a||v,"-w",t];for(const W of r)I.push("-a"),I.push(W);if(s){const W=Object.assign({},b(process),s);for(const F in W){const T=W[F];T===null?(I.push("-u"),I.push(F)):(I.push("-e"),I.push(`${F}=${T}`))}}let O="";const M=n.spawn(y.b,I);M.on("error",W=>{g(c(W))}),M.stderr.on("data",W=>{O+=W.toString()}),M.on("exit",W=>{if(W===0)u(void 0);else if(O){const F=O.split(`
`,1);g(new Error(F[0]))}else g(new Error(d.localize(1,null,P,W)))})}else g(new Error(d.localize(2,null,o)))})}spawnTerminal(a,t,r){const s=t.osxExec||p.$N7b;return new Promise((i,o)=>{const u=["-a",s];r&&u.push(r);const g=b(process),P=a.spawn("/usr/bin/open",u,{cwd:r,env:g});P.on("error",o),P.on("exit",()=>i())})}}e.$ddc=y;class w extends ${static{this.b=d.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,r,s,i){const o=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((u,g)=>{const P=[];o.then(D=>{D.indexOf("gnome-terminal")>=0?P.push("-x"):P.push("-e"),P.push("bash"),P.push("-c");const I=`${m(r)}; echo; read -p "${w.b}" -n1;`;P.push(`''${I}''`);const O=Object.assign({},b(process),s);Object.keys(O).filter(T=>O[T]===null).forEach(T=>delete O[T]);const M={cwd:t,env:O};let W="";const F=n.spawn(D,P,M);F.on("error",T=>{g(c(T))}),F.stderr.on("data",T=>{W+=T.toString()}),F.on("exit",T=>{if(T===0)u(void 0);else if(W){const U=W.split(`
`,1);g(new Error(U[0]))}else g(new Error(d.localize(4,null,D,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!j.$k)w.d=Promise.resolve("xterm");else{const a=await h.Promises.exists("/etc/debian_version");w.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return w.d}spawnTerminal(a,t,r){const s=t.linuxExec?Promise.resolve(t.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,o)=>{s.then(u=>{const g=b(process),P=a.spawn(u,[],{cwd:r,env:g});P.on("error",o),P.on("exit",()=>i())})})}}e.$edc=w;function b(S){const a={...S.env};return(0,E.$om)(a),a}function c(S){return"errno"in S&&S.errno==="ENOENT"&&"path"in S&&typeof S.path=="string"?new Error(d.localize(5,null,S.path)):S}function m(S){let a="";for(const t of S)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(se[16],re([0,1,59,9,25,12,7,178,6,4,13,62]),function(K,e,n,C,k,R,j,E,h,l,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$xl=e.FileKind=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.FileOperationResult=e.$pl=e.$ol=e.$nl=e.$ll=e.FileChangeType=e.$kl=e.FileOperation=e.$el=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$5k=void 0,e.$6k=v,e.$7k=w,e.$8k=c,e.$9k=m,e.$0k=S,e.$$k=a,e.$_k=t,e.$al=r,e.$bl=s,e.$cl=i,e.$dl=o,e.$fl=P,e.$gl=D,e.$hl=I,e.$il=O,e.$jl=M,e.$ml=ae,e.$yl=L,e.$zl=B,e.$Bl=oe,e.$5k=(0,h.$yi)("fileService");function v(G){return G.create===!0}var $;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var f;(function(G){G[G.Readonly=1]="Readonly",G[G.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var y;(function(G){G[G.UPDATED=2]="UPDATED",G[G.ADDED=4]="ADDED",G[G.DELETED=8]="DELETED"})(y||(e.FileChangeFilter=y={}));function w(G){const le=G;return!!le&&typeof le.onDidChange=="function"}var b;(function(G){G[G.None=0]="None",G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileAtomicWrite=32768]="FileAtomicWrite",G[G.FileAtomicDelete=65536]="FileAtomicDelete",G[G.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function c(G){return!!(G.capabilities&2)}function m(G){return!!(G.capabilities&8)}function S(G){return!!(G.capabilities&131072)}function a(G){return!!(G.capabilities&4)}function t(G){return!!(G.capabilities&16)}function r(G){return c(G)?!!(G.capabilities&16384):!1}function s(G){return c(G)?!!(G.capabilities&32768):!1}function i(G){return!!(G.capabilities&65536)}function o(G){return!!(G.capabilities&2048)}var u;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsStorageQuota="EntryExceedsStorageQuota",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class g extends Error{static create(le,Q){const A=new g(le.toString(),Q);return I(A,Q),A}constructor(le,Q){super(le),this.code=Q}}e.$el=g;function P(G,le){return g.create(G,le)}function D(G){return G||P((0,E.localize)(0,null),u.Unknown)}function I(G,le){return G.name=le?`${le} (FileSystemError)`:"FileSystemError",G}function O(G){if(!G)return u.Unknown;if(G instanceof g)return G.code;const le=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!le)return u.Unknown;switch(le[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}function M(G){if(G instanceof te)return G.fileOperationResult;switch(O(G)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 9;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileTooLarge:return 7;default:return 10}}var W;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(W||(e.FileOperation=W={}));class F{constructor(le,Q,A){this.resource=le,this.operation=Q,this.target=A}isOperation(le){return this.operation===le}}e.$kl=F;var T;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class U{static{this.a=null}constructor(le,Q){this.c=Q,this.b=void 0,this.d=new p.$V(()=>{const A=n.$Ei.forUris(()=>this.c);return A.fill(this.rawAdded.map(N=>[N,!0])),A}),this.f=new p.$V(()=>{const A=n.$Ei.forUris(()=>this.c);return A.fill(this.rawUpdated.map(N=>[N,!0])),A}),this.g=new p.$V(()=>{const A=n.$Ei.forUris(()=>this.c);return A.fill(this.rawDeleted.map(N=>[N,!0])),A}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const A of le){switch(A.type){case 1:this.rawAdded.push(A.resource);break;case 0:this.rawUpdated.push(A.resource);break;case 2:this.rawDeleted.push(A.resource);break}this.b!==U.a&&(typeof A.cId=="number"?this.b===void 0?this.b=A.cId:this.b!==A.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(le,...Q){return this.h(le,{includeChildren:!1},...Q)}affects(le,...Q){return this.h(le,{includeChildren:!0},...Q)}h(le,Q,...A){if(!le)return!1;const N=A.length>0;return!!((!N||A.includes(1))&&(this.d.value.get(le)||Q.includeChildren&&this.d.value.findSuperstr(le))||(!N||A.includes(0))&&(this.f.value.get(le)||Q.includeChildren&&this.f.value.findSuperstr(le))||(!N||A.includes(2))&&(this.g.value.findSubstr(le)||Q.includeChildren&&this.g.value.findSuperstr(le)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(le){return this.b===le}hasCorrelation(){return typeof this.b=="number"}}e.$ll=U;function ae(G,le,Q){return!G||!le||G===le||le.length>G.length?!1:(le.charAt(le.length-1)!==C.sep&&(le+=C.sep),Q?(0,k.$Af)(G,le):G.indexOf(le)===0)}class te extends Error{constructor(le,Q,A){super(le),this.fileOperationResult=Q,this.options=A}}e.$nl=te;class ce extends te{constructor(le,Q,A,N){super(le,Q,N),this.fileOperationResult=Q,this.size=A}}e.$ol=ce;class J extends te{constructor(le,Q,A){super(le,2,A),this.stat=Q}}e.$pl=J;var V;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(V||(e.FileOperationResult=V={})),e.$ql={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sl="files.associations",e.$tl="files.exclude",e.$ul="files.readonlyInclude",e.$vl="files.readonlyExclude",e.$wl="files.readonlyFromPermissions";var q;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(q||(e.FileKind=q={})),e.$xl="";function L(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}async function B(G,le){if(!le.hasProvider(j.URI.from({scheme:G.scheme})))return new Promise(Q=>{const A=le.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===G.scheme&&N.added&&(A.dispose(),Q())})})}class H{static{this.KB=1024}static{this.MB=H.KB*H.KB}static{this.GB=H.MB*H.KB}static{this.TB=H.GB*H.KB}static formatSize(le){return(0,R.$cg)(le)||(le=0),le<H.KB?(0,E.localize)(1,null,le.toFixed(0)):le<H.MB?(0,E.localize)(2,null,(le/H.KB).toFixed(2)):le<H.GB?(0,E.localize)(3,null,(le/H.MB).toFixed(2)):le<H.TB?(0,E.localize)(4,null,(le/H.GB).toFixed(2)):(0,E.localize)(5,null,(le/H.TB).toFixed(2))}}e.$Al=H;function oe(G){const le=typeof G=="string"||G?.scheme===d.Schemas.vscodeRemote;return typeof G!="string"&&G?.scheme===d.Schemas.file?1024*H.MB:le?10*H.MB:l.$o?50*H.MB:1024*H.MB}}),define(se[122],re([0,1,17,15,179,16]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=j;async function j(d,p,v,$,f,y){let w;try{await E(d,p,v,$,f,y)}catch(b){w=b}finally{w&&f.errorTransformer&&(w=f.errorTransformer(w)),typeof w<"u"&&v.error(w),v.end()}}async function E(d,p,v,$,f,y){h(y);const w=await d.open(p,{create:!1});try{h(y);let b=0,c=0,m=f&&typeof f.length=="number"?f.length:void 0,S=n.$He.alloc(Math.min(f.bufferSize,typeof m=="number"?m:f.bufferSize)),a=f&&typeof f.position=="number"?f.position:0,t=0;do c=await d.read(w,a,S.buffer,t,S.byteLength-t),a+=c,t+=c,b+=c,typeof m=="number"&&(m-=c),t===S.byteLength&&(await v.write($(S)),S=n.$He.alloc(Math.min(f.bufferSize,typeof m=="number"?m:f.bufferSize)),t=0);while(c>0&&(typeof m!="number"||m>0)&&h(y)&&l(b,f));if(t>0){let r=t;typeof m=="number"&&(r=Math.min(t,m)),v.write($(S.slice(0,r)))}}catch(b){throw(0,R.$gl)(b)}finally{await d.close(w)}}function h(d){if(d.isCancellationRequested)throw(0,C.$6)();return!0}function l(d,p){if(typeof p?.limits?.size=="number"&&d>p.limits.size)throw(0,R.$fl)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(se[60],re([0,1,108,2,9,4,7,16]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Pq=e.$Oq=void 0,e.$Mq=h,e.$Nq=l,e.$Rq=$,e.$Sq=f,e.$Tq=y,e.$Uq=w,e.$Vq=c,e.$Wq=m;function h(S){return typeof S.correlationId=="number"}function l(S){return S.recursive===!0}class d extends C.$Uc{static{this.a=5}constructor(a,t,r,s){super(),this.h=a,this.j=t,this.m=r,this.n=s,this.c=this.B(new C.$Vc),this.f=void 0,this.g=0}s(){const a=new C.$Tc;this.c.value=a,this.b=this.r(a),this.b.setVerboseLogging(this.m),a.add(this.b.onDidChangeFile(t=>this.h(t))),a.add(this.b.onDidLogMessage(t=>this.j(t))),a.add(this.b.onDidError(t=>this.t(t)))}t(a){this.n.restartOnError?this.g<d.a&&this.f?(this.w(`restarting watcher after error: ${a}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${a}`):this.w(a)}u(a){this.g++,this.s(),this.watch(a)}async watch(a){this.f=a,await this.b?.watch(a)}async setVerboseLogging(a){this.m=a,await this.b?.setVerboseLogging(a)}w(a){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${a}`})}y(a){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${a}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Oq=d;class p extends d{constructor(a,t,r){super(a,t,r,{type:"node.js",restartOnError:!1})}}e.$Pq=p;class v extends d{constructor(a,t,r){super(a,t,r,{type:"universal",restartOnError:!0})}}e.$Qq=v;function $(S){return S.map(a=>({type:a.type,resource:j.URI.revive(a.resource),cId:a.cId}))}function f(S){const a=new b;for(const t of S)a.processEvent(t);return a.coalesce()}function y(S,a){return typeof a=="string"&&!a.startsWith(n.$ok)&&!(0,k.$ic)(a)?{base:S,pattern:a}:a}function w(S,a){const t=[];for(const r of a)t.push((0,n.$sk)(y(S,r)));return t}class b{constructor(){this.a=new Set,this.b=new Map}c(a){return R.$k?a.resource.fsPath:a.resource.fsPath.toLowerCase()}processEvent(a){const t=this.b.get(this.c(a));let r=!1;if(t){const s=t.type,i=a.type;t.resource.fsPath!==a.resource.fsPath&&(a.type===2||a.type===1)?r=!0:s===1&&i===2?(this.b.delete(this.c(a)),this.a.delete(t)):s===2&&i===1?t.type=0:s===1&&i===0||(t.type=i)}else r=!0;r&&(this.a.add(a),this.b.set(this.c(a),a))}coalesce(){const a=[],t=[];return Array.from(this.a).filter(r=>r.type!==2?(a.push(r),!1):!0).sort((r,s)=>r.resource.fsPath.length-s.resource.fsPath.length).filter(r=>t.some(s=>(0,E.$ml)(r.resource.fsPath,s,!R.$k))?!1:(t.push(r.resource.fsPath),!0)).concat(a)}}function c(S,a){if(typeof a=="number")switch(S.type){case 1:return(a&4)===0;case 2:return(a&8)===0;case 0:return(a&2)===0}return!1}function m(S){if(typeof S=="number"){const a=[];return S&4&&a.push("Added"),S&8&&a.push("Deleted"),S&2&&a.push("Updated"),a.length===0?"<all>":`[${a.join(", ")}]`}return"<none>"}}),define(se[216],re([0,1,17,47,15,3,2,63,33,16,60]),function(K,e,n,C,k,R,j,E,h,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VP=e.$UP=void 0,e.$UP="localFilesystem";class p extends j.$Uc{constructor($,f){super(),this.a=$,this.b=f,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.$fe),this.onDidChangeFile=this.f.event,this.g=this.B(new R.$fe),this.onDidWatchError=this.g.event,this.h=(0,h.$Ug)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat($){return this.a.call("stat",[$])}readdir($){return this.a.call("readdir",[$])}async readFile($,f){const{buffer:y}=await this.a.call("readFile",[$,f]);return y}readFileStream($,f,y){const w=(0,E.$ve)(c=>n.$He.concat(c.map(m=>n.$He.wrap(m))).buffer),b=new j.$Tc;return b.add(this.a.listen("readFileStream",[$,f])(c=>{if(c instanceof n.$He)w.write(c.buffer);else{if(c==="end")w.end();else{let m;if(c instanceof Error)m=c;else{const S=c;m=(0,l.$fl)(S.message??(0,C.$jj)(S),S.code??l.FileSystemProviderErrorCode.Unknown)}w.error(m),w.end()}b.dispose()}})),b.add(y.onCancellationRequested(()=>{w.error((0,k.$6)()),w.end(),b.dispose()})),w}writeFile($,f,y){return this.a.call("writeFile",[$,n.$He.wrap(f),y])}open($,f){return this.a.call("open",[$,f])}close($){return this.a.call("close",[$])}async read($,f,y,w,b){const[c,m]=await this.a.call("read",[$,f,b]);return y.set(c.buffer.slice(0,m),w),m}write($,f,y,w,b){return this.a.call("write",[$,f,n.$He.wrap(y),w,b])}mkdir($){return this.a.call("mkdir",[$])}delete($,f){return this.a.call("delete",[$,f])}rename($,f,y){return this.a.call("rename",[$,f,y])}copy($,f,y){return this.a.call("copy",[$,f,y])}cloneFile($,f){return this.a.call("cloneFile",[$,f])}j(){this.B(this.a.listen("fileChange",[this.h])($=>{if(Array.isArray($)){const f=$;this.f.fire((0,d.$Rq)(f))}else{const f=$;this.g.fire(f)}}))}watch($,f){const y=(0,h.$Ug)();return this.a.call("watch",[this.h,y,$,f]),(0,j.$Sc)(()=>this.a.call("unwatch",[this.h,y]))}}e.$VP=p}),define(se[217],re([0,1,43,2,60,3,7,8]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;class h extends C.$Uc{constructor(){super(),this.a=this.B(new R.$fe),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$fe),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$fe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new C.$4c),this.m=new Set,this.n=5007,this.r=new E.$Vh,this.P=!1,this.B(this.f(d=>this.s(d)))}s(d){this.t(d)&&this.w(d)}t(d){return(0,k.$Mq)(d)}async watch(d){this.r.isSettled||this.r.complete(),this.r=new E.$Vh;try{this.h.clear(),this.g.clear();for(const p of d)this.t(p)?this.h.set(p.correlationId,p):this.g.add(p);for(const[p]of this.j)this.h.has(p)||(this.j.deleteAndDispose(p),this.m.delete(p));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(d=>!this.j.has(d.correlationId))])}isSuspended(d){return typeof d.correlationId!="number"?!1:this.m.has(d.correlationId)?"polling":this.j.has(d.correlationId)}async w(d){if(this.j.has(d.correlationId))return;const p=new C.$Tc;this.j.set(d.correlationId,p),await this.r.p,!p.isDisposed&&(this.z(d,p),this.u())}y(d){this.j.deleteAndDispose(d.correlationId),this.m.delete(d.correlationId),this.u()}z(d,p){this.C(d,p)?(this.N(`reusing an existing recursive watcher to monitor ${d.path}`),this.m.delete(d.correlationId)):(this.D(d,p),this.m.add(d.correlationId))}C(d,p){const v=this.M?.subscribe(d.path,($,f)=>{p.isDisposed||($?this.z(d,p):f?.type===1&&this.F(d))});return v?(p.add(v),!0):!1}D(d,p){let v=!1;const $=(f,y)=>{if(p.isDisposed)return;const w=this.G(f),b=this.G(y),c=v;v=w,!w&&(b||c)&&this.F(d)};this.N(`starting fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,n.watchFile)(d.path,{persistent:!1,interval:this.n},$)}catch(f){this.O(`fs.watchFile() failed with error ${f} on path ${d.path} (correlationId: ${d.correlationId})`)}p.add((0,C.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,n.unwatchFile)(d.path,$)}catch(f){this.O(`fs.unwatchFile() failed with error ${f} on path ${d.path} (correlationId: ${d.correlationId})`)}}))}F(d){this.N(`detected ${d.path} exists again, resuming watcher (correlationId: ${d.correlationId})`);const p={resource:j.URI.file(d.path),type:1,cId:d.correlationId};this.a.fire([p]),this.H(p,d),this.y(d)}G(d){return d.ctimeMs===0&&d.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(d,p){if(this.P){const v=` >> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`;this.I(v,p)}}I(d,p){this.P&&this.N(`${d}${typeof p.correlationId=="number"?` <${p.correlationId}> `:""}`)}J(d){return`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, filter: ${(0,k.$Wq)(d.filter)}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`}async setVerboseLogging(d){this.P=d}}e.$6q=h}),define(se[218],re([0,1,43,8,23,31,2,72,9,4,19,7,109,21,60]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0,e.$_q=w;class y extends j.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(c,m,S,a,t,r){super(),this.s=c,this.t=m,this.u=S,this.w=a,this.y=t,this.z=r,this.c=this.B(new C.$Nh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new C.$Mh(s=>this.M(s),y.b)),this.g=(0,f.$Uq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,f.$Uq)(this.s.path,this.s.includes):void 0,this.j=(0,f.$Mq)(this.s)?this.s.filter:void 0,this.m=new k.$qe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const c=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const m=await $.Promises.stat(c);if(this.m.token.isCancellationRequested)return;this.B(await this.G(c,m.isDirectory()))}catch(c){c.code!=="ENOENT"?this.O(c):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${c})`),this.D()}}D(){this.r=!0,this.w?.()}async F(c){let m=c.path;try{m=await $.Promises.realpath(c.path),c.path===m&&(m=await(0,v.$8q)(c.path,this.m.token)??c.path),c.path!==m&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${m})`)}catch{}return m}async G(c,m){const S=new j.$Tc;return this.H(c,m,S)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(c,m,S)),S}H(c,m,S){if(m)return!1;const a=p.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(r,s)=>{if(!S.isDisposed)if(r){const i=await this.G(c,m);S.isDisposed?i.dispose():S.add(i)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:a,type:s.type,cId:this.s.correlationId},!0)});return t?(S.add(t),!0):!1}async I(c,m,S){if(l.$j&&(0,R.$xg)(c,"/Volumes/",!0)){this.O(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const a=new k.$qe(this.m.token);S.add((0,j.$Sc)(()=>a.dispose(!0)));const t=new j.$Tc;S.add(t);try{const r=p.URI.file(this.s.path),s=(0,h.$nc)(c),i=(0,n.watch)(c);t.add((0,j.$Sc)(()=>{i.removeAllListeners(),i.close()})),this.Q(`Started watching: '${c}'`);const o=new Set;if(m)try{for(const g of await $.Promises.readdir(c))o.add(g)}catch(g){this.O(g)}if(a.token.isCancellationRequested)return;const u=new Map;t.add((0,j.$Sc)(()=>{for(const[,g]of u)g.dispose();u.clear()})),i.on("error",(g,P)=>{a.token.isCancellationRequested||(this.O(`Failed to watch ${c} for changes using fs.watch() (${g}, ${P})`),this.D())}),i.on("change",(g,P)=>{if(a.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${g}"] ${P}`);let D="";if(P&&(D=P.toString(),l.$j&&(D=(0,E.$dm)(D))),!(!D||g!=="change"&&g!=="rename"))if(m)if(g==="rename"){u.get(D)?.dispose();const I=setTimeout(async()=>{if(u.delete(D),D===s&&!await $.Promises.exists(c)){this.J(r);return}if(a.token.isCancellationRequested)return;const O=await this.N((0,h.$jc)(c,D));if(a.token.isCancellationRequested)return;let M;O?o.has(D)?M=0:(M=1,o.add(D)):(o.delete(D),M=2),this.L({resource:(0,d.$_g)(r,D),type:M,cId:this.s.correlationId})},y.a);u.set(D,(0,j.$Sc)(()=>clearTimeout(I)))}else{let I;o.has(D)?I=0:(I=1,o.add(D)),this.L({resource:(0,d.$_g)(r,D),type:I,cId:this.s.correlationId})}else if(g==="rename"||D!==s){const I=setTimeout(async()=>{const O=await $.Promises.exists(c);a.token.isCancellationRequested||(O?(this.L({resource:r,type:0,cId:this.s.correlationId},!0),t.add(await this.G(c,!1))):this.J(r))},y.a);t.clear(),t.add((0,j.$Sc)(()=>clearTimeout(I)))}else this.L({resource:r,type:0,cId:this.s.correlationId},!0)})}catch(r){a.token.isCancellationRequested||this.O(`Failed to watch ${c} for changes using fs.watch() (${r.toString()})`),this.D()}}J(c){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:c,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(c,m=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`),!m&&this.g.some(S=>S(c.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${c.resource.fsPath}`):!m&&this.h&&this.h.length>0&&!this.h.some(S=>S(c.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${c.resource.fsPath}`):this.f.work(c))}M(c){const m=(0,f.$Sq)(c),S=[];for(const t of m){if((0,f.$Vq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}S.push(t)}if(S.length===0)return;if(this.z)for(const t of S)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(S)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${S[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${S.length}, most recent change: ${S[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(c){if(l.$k)return $.Promises.exists(c);try{const m=(0,h.$nc)(c);return(await $.Promises.readdir((0,h.$mc)(c))).some(a=>a===m)}catch(m){return this.Q(m),!1}}setVerboseLogging(c){this.z=c}O(c){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}P(c){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}Q(c){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}R(c){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${c}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$$q=y;async function w(b,c,m,S,a=512){const t=await $.Promises.open(b,"r"),r=Buffer.allocUnsafe(a),s=new k.$qe(S);let i,o=!1;const u={path:b,excludes:[],recursive:!1},g=new y(u,void 0,P=>{(async()=>{for(const{type:D}of P)if(D===0){if(o)return;o=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:I}=await $.Promises.read(t,r,0,a,null);if(!I||s.token.isCancellationRequested)break;c(r.slice(0,I))}}catch(I){i=new Error(I),s.dispose(!0)}finally{o=!1}}})()});return await g.ready,m(),new Promise((P,D)=>{s.token.onCancellationRequested(async()=>{g.dispose();try{await $.Promises.close(t)}catch(I){i=new Error(I)}i?D(i):P()})})}}),define(se[219],re([0,1,3,108,217,4,218,31]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;class h extends k.$6q{constructor(d){super(),this.M=d,this.onDidError=n.Event.None,this.watchers=new Set}async L(d){d=this.X(d);const p=[],v=new Set(Array.from(this.watchers));for(const $ of d){const f=this.S($);f&&(0,C.$wk)(f.request.excludes,$.excludes)&&(0,C.$wk)(f.request.includes,$.includes)?v.delete(f):p.push($)}p.length&&this.N(`Request to start watching: ${p.map($=>this.J($)).join(",")}`),v.size&&this.N(`Request to stop watching: ${Array.from(v).map($=>this.J($.request)).join(",")}`);for(const $ of v)this.W($);for(const $ of p)this.U($)}S(d){for(const p of this.watchers)if(typeof d.correlationId=="number"||typeof p.request.correlationId=="number"){if(p.request.correlationId===d.correlationId)return p}else if((0,E.$wg)(p.request.path,d.path,!R.$k))return p}U(d){const p=new j.$$q(d,this.M,$=>this.a.fire($),()=>this.c.fire(d),$=>this.b.fire($),this.P),v={request:d,instance:p};this.watchers.add(v)}async stop(){await super.stop();for(const d of this.watchers)this.W(d)}W(d){this.N("stopping file watcher",d),this.watchers.delete(d),d.instance.dispose()}X(d){const p=new Map;for(const v of d){const $=R.$k?v.path:v.path.toLowerCase();let f=p.get(v.correlationId);f||(f=new Map,p.set(v.correlationId,f)),f.has($)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(v)}`),f.set($,v)}return Array.from(p.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(d){super.setVerboseLogging(d);for(const p of this.watchers)p.instance.setVerboseLogging(d)}N(d,p){this.P&&this.b.fire({type:"trace",message:this.$(d,p)})}O(d){this.b.fire({type:"warn",message:this.$(d)})}$(d,p){return p?`[File Watcher (node.js)] ${d} (${this.J(p.request)})`:`[File Watcher (node.js)] ${d}`}}e.$ar=h}),define(se[220],re([0,1,60,219]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class k extends n.$Pq{constructor(j,E,h){super(j,E,h),this.s()}r(j){return j.add(new C.$ar(void 0))}}e.$br=k}),define(se[221],re([0,1,13,44,162,60]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0;class j extends R.$Qq{constructor(h,l,d){super(h,l,d),this.s()}r(h){const l=h.add(new k.$4q(n.$Sg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(l.onDidProcessExit(({code:d,signal:p})=>this.t(`terminated by itself with code ${d}, signal: ${p} (ETERM)`))),C.ProxyChannel.toService((0,C.$fi)(l.getChannel("watcher")))}}e.$5q=j}),define(se[93],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=void 0;class n{constructor(...k){this.a=new Map;for(const[R,j]of k)this.set(R,j)}set(k,R){const j=this.a.get(k);return this.a.set(k,R),j}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.$wi=n}),define(se[222],re([0,1,8,15,2,78,211,6,93,104]),function(K,e,n,C,k,R,j,E,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=void 0;const d=!1;class p extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class v{constructor(w=new h.$wi,b=!1,c,m=d){this.i=w,this.j=b,this.k=c,this.l=m,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(E.$xi,this),this._globalGraph=m?c?._globalGraph??new j.$er(S=>S):void 0}dispose(){if(!this.f){this.f=!0,(0,k.$Pc)(this.h),this.h.clear();for(const w of this.g)(0,k.$Oc)(w)&&w.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(w){this.m();const b=new class extends v{dispose(){this.h.delete(b),super.dispose()}}(w,this.j,this,this.l);return this.h.add(b),b}invokeFunction(w,...b){this.m();const c=f.traceInvocation(this.l,w);let m=!1;try{return w({get:a=>{if(m)throw(0,C.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(a,c);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...b)}finally{m=!0,c.stop()}}createInstance(w,...b){this.m();let c,m;return w instanceof R.$vi?(c=f.traceCreation(this.l,w.ctor),m=this.o(w.ctor,w.staticArguments.concat(b),c)):(c=f.traceCreation(this.l,w),m=this.o(w,b,c)),c.stop(),m}o(w,b=[],c){const m=E._util.getServiceDependencies(w).sort((t,r)=>t.index-r.index),S=[];for(const t of m){const r=this.s(t.id,c);r||this.y(`[createInstance] ${w.name} depends on UNKNOWN service ${t.id}.`,!1),S.push(r)}const a=m.length>0?m[0].index:b.length;if(b.length!==a){console.trace(`[createInstance] First service dependency of ${w.name} at position ${a+1} conflicts with ${b.length} static arguments`);const t=a-b.length;t>0?b=b.concat(new Array(t)):b=b.slice(0,a)}return Reflect.construct(w,b.concat(S))}q(w,b){if(this.i.get(w)instanceof R.$vi)this.i.set(w,b);else if(this.k)this.k.q(w,b);else throw new Error("illegalState - setting UNKNOWN service instance")}r(w){const b=this.i.get(w);return!b&&this.k?this.k.r(w):b}s(w,b){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const c=this.r(w);return c instanceof R.$vi?this.u(w,c,b.branch(w,!0)):(b.branch(w,!1),c)}u(w,b,c){if(this.t.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.t.add(w);try{return this.v(w,b,c)}finally{this.t.delete(w)}}v(w,b,c){const m=new j.$er(t=>t.id.toString());let S=0;const a=[{id:w,desc:b,_trace:c}];for(;a.length;){const t=a.pop();if(m.lookupOrInsertNode(t),S++>1e3)throw new p(m);for(const r of E._util.getServiceDependencies(t.desc.ctor)){const s=this.r(r.id);if(s||this.y(`[createInstance] ${w} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),s instanceof R.$vi){const i={id:r.id,desc:s,_trace:t._trace.branch(r.id,!0)};m.insertEdge(t,i),a.push(i)}}}for(;;){const t=m.roots();if(t.length===0){if(!m.isEmpty())throw new p(m);break}for(const{data:r}of t){if(this.r(r.id)instanceof R.$vi){const i=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,i)}m.removeNode(r)}}return this.r(w)}w(w,b,c=[],m,S){if(this.i.get(w)instanceof R.$vi)return this.x(w,b,c,m,S,this.g);if(this.k)return this.k.w(w,b,c,m,S);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}x(w,b,c=[],m,S,a){if(m){const t=new v(void 0,this.j,this,this.l);t.c=String(w);const r=new Map,s=new n.$Rh(()=>{const i=t.o(b,c,S);for(const[o,u]of r){const g=i[o];if(typeof g=="function")for(const P of u)P.disposable=g.apply(i,P.listener)}return r.clear(),a.add(i),i});return new Proxy(Object.create(null),{get(i,o){if(!s.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let P=r.get(o);return P||(P=new l.$5c,r.set(o,P)),(I,O,M)=>{if(s.isInitialized)return s.value[o](I,O,M);{const W={listener:[I,O,M],disposable:void 0},F=P.push(W);return(0,k.$Sc)(()=>{F(),W.disposable?.dispose()})}}}if(o in i)return i[o];const u=s.value;let g=u[o];return typeof g!="function"||(g=g.bind(u),i[o]=g),g},set(i,o,u){return s.value[o]=u,!0},getPrototypeOf(i){return b.prototype}})}else{const t=this.o(b,c,S);return a.add(t),t}}y(w,b){if(b&&console.warn(w),this.j)throw new Error(w)}}e.$fr=v;var $;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})($||($={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,b){return w?new f(2,b.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(w,b){return w?new f(1,b.name):f.c}static{this.f=0}constructor(w,b){this.type=w,this.name=b,this.g=Date.now(),this.h=[]}branch(w,b){const c=new f(3,w.toString());return this.h.push([w,b,c]),c}stop(){const w=Date.now()-this.g;f.f+=w;let b=!1;function c(S,a){const t=[],r=new Array(S+1).join("	");for(const[s,i,o]of a.h)if(i&&o){b=!0,t.push(`${r}CREATES -> ${s}`);const u=c(S+1,o);u&&t.push(u)}else t.push(`${r}uses -> ${s}`);return t.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(w>2||b)&&f.all.add(m.join(`
`))}}e.$gr=f}),define(se[223],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wKb=e.IssueSource=e.IssueType=void 0;var C;(function(R){R[R.Bug=0]="Bug",R[R.PerformanceIssue=1]="PerformanceIssue",R[R.FeatureRequest=2]="FeatureRequest"})(C||(e.IssueType=C={}));var k;(function(R){R.VSCode="vscode",R.Extension="extension",R.Marketplace="marketplace"})(k||(e.IssueSource=k={})),e.$wKb=(0,n.$yi)("issueService")}),define(se[5],re([0,1,183,47,3,46,2,32,4,19,12,7,118,6]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$8j=e.LogLevel=e.$6j=e.$5j=void 0,e.$7j=y,e.log=b,e.$gk=g,e.$hk=P,e.$ik=D,e.$jk=I,e.$5j=(0,$.$yi)("logService"),e.$6j=(0,$.$yi)("loggerService");function f(){return new Date().toISOString()}function y(O){return(0,d.$cg)(O)}var w;(function(O){O[O.Off=0]="Off",O[O.Trace=1]="Trace",O[O.Debug=2]="Debug",O[O.Info=3]="Info",O[O.Warning=4]="Warning",O[O.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$8j=w.Info;function b(O,M,W){switch(M){case w.Trace:O.trace(W);break;case w.Debug:O.debug(W);break;case w.Info:O.info(W);break;case w.Warning:O.warn(W);break;case w.Error:O.error(W);break;case w.Off:break;default:throw new Error(`Invalid log level ${M}`)}}function c(O,M=!1){let W="";for(let F=0;F<O.length;F++){let T=O[F];if(T instanceof Error&&(T=(0,C.$jj)(T,M)),typeof T=="object")try{T=JSON.stringify(T)}catch{}W+=(F>0?" ":"")+T}return W}class m extends j.$Uc{constructor(){super(...arguments),this.b=e.$8j,this.c=this.B(new k.$fe),this.onDidChangeLogLevel=this.c.event}setLevel(M){this.b!==M&&(this.b=M,this.c.fire(this.b))}getLevel(){return this.b}f(M){return this.b!==w.Off&&this.b<=M}}e.$0j=m;class S extends m{constructor(M){super(),this.h=M}f(M){return this.h||super.f(M)}trace(M,...W){this.f(w.Trace)&&this.g(w.Trace,c([M,...W],!0))}debug(M,...W){this.f(w.Debug)&&this.g(w.Debug,c([M,...W]))}info(M,...W){this.f(w.Info)&&this.g(w.Info,c([M,...W]))}warn(M,...W){this.f(w.Warning)&&this.g(w.Warning,c([M,...W]))}error(M,...W){if(this.f(w.Error))if(M instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=M.stack,this.g(w.Error,c(F))}else this.g(w.Error,c([M,...W]))}flush(){}}e.$$j=S;class a extends m{constructor(M=e.$8j){super(),this.setLevel(M),this.g=!h.$i}trace(M,...W){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,M,...W):console.log(`[main ${f()}]`,M,...W))}debug(M,...W){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,M,...W):console.log(`[main ${f()}]`,M,...W))}info(M,...W){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,M,...W):console.log(`[main ${f()}]`,M,...W))}warn(M,...W){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,M,...W):console.warn(`[main ${f()}]`,M,...W))}error(M,...W){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,M,...W):console.error(`[main ${f()}]`,M,...W))}flush(){}}e.$_j=a;class t extends m{constructor(M=e.$8j,W=!0){super(),this.g=W,this.setLevel(M)}trace(M,...W){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",M,...W):console.log(M,...W))}debug(M,...W){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",M,...W):console.log(M,...W))}info(M,...W){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",M,...W):console.log(M,...W))}warn(M,...W){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",M,...W):console.log(M,...W))}error(M,...W){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",M,...W):console.error(M,...W))}flush(){}}e.$ak=t;class r extends m{constructor(M,W=e.$8j){super(),this.g=M,this.setLevel(W)}trace(M,...W){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(M),...W])}debug(M,...W){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(M),...W])}info(M,...W){this.f(w.Info)&&this.g.log(w.Info,[this.h(M),...W])}warn(M,...W){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(M),...W])}error(M,...W){this.f(w.Error)&&this.g.log(w.Error,[this.h(M),...W])}h(M){return typeof M=="string"?M:(0,C.$jj)(M,this.f(w.Trace))}flush(){}}e.$bk=r;class s extends m{constructor(M){super(),this.g=M,M.length&&this.setLevel(M[0].getLevel())}setLevel(M){for(const W of this.g)W.setLevel(M);super.setLevel(M)}trace(M,...W){for(const F of this.g)F.trace(M,...W)}debug(M,...W){for(const F of this.g)F.debug(M,...W)}info(M,...W){for(const F of this.g)F.info(M,...W)}warn(M,...W){for(const F of this.g)F.warn(M,...W)}error(M,...W){for(const F of this.g)F.error(M,...W)}flush(){for(const M of this.g)M.flush()}dispose(){for(const M of this.g)M.dispose();super.dispose()}}e.$ck=s;class i extends j.$Uc{constructor(M,W,F){if(super(),this.h=M,this.j=W,this.b=new E.$Ac,this.c=this.B(new k.$fe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new k.$fe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new k.$fe),this.onDidChangeVisibility=this.g.event,F)for(const T of F)this.b.set(T.resource,{logger:void 0,info:T})}m(M){return(0,d.$$f)(M)?[...this.b.values()].find(W=>W.info.id===M):this.b.get(M)}getLogger(M){return this.m(M)?.logger}createLogger(M,W){const F=this.n(M),T=(0,d.$$f)(M)?M:W?.id??(0,R.$mj)(F.toString()).toString(16);let U=this.b.get(F)?.logger;const ae=W?.logLevel==="always"?w.Trace:W?.logLevel;U||(U=this.s(F,ae??this.getLogLevel(F)??this.h,{...W,id:T}));const te={logger:U,info:{resource:F,id:T,logLevel:ae,name:W?.name,hidden:W?.hidden,extensionId:W?.extensionId,when:W?.when}};return this.registerLogger(te.info),this.b.set(F,te),U}n(M){return(0,d.$$f)(M)?(0,l.$_g)(this.j,`${M}.log`):M}setLogLevel(M,W){if(p.URI.isUri(M)){const F=M,T=W,U=this.b.get(F);U&&T!==U.info.logLevel&&(U.info.logLevel=T===this.h?void 0:T,U.logger?.setLevel(T),this.b.set(U.info.resource,U),this.f.fire([F,T]))}else{this.h=M;for(const[F,T]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(M,W){const F=this.m(M);F&&W!==!F.info.hidden&&(F.info.hidden=!W,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,W]))}getLogLevel(M){let W;return M&&(W=this.b.get(M)?.info.logLevel),W??this.h}registerLogger(M){const W=this.b.get(M.resource);W?W.info.hidden!==M.hidden&&this.setVisibility(M.resource,!M.hidden):(this.b.set(M.resource,{info:M,logger:void 0}),this.c.fire({added:[M],removed:[]}))}deregisterLogger(M){const W=this.b.get(M);W&&(W.logger&&W.logger.dispose(),this.b.delete(M),this.c.fire({added:[],removed:[W.info]}))}*getRegisteredLoggers(){for(const M of this.b.values())yield M.info}getRegisteredLogger(M){return this.b.get(M)?.info}dispose(){this.b.forEach(M=>M.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dk=i;class o{constructor(){this.onDidChangeLogLevel=new k.$fe().event}setLevel(M){}getLevel(){return w.Info}trace(M,...W){}debug(M,...W){}info(M,...W){}warn(M,...W){}error(M,...W){}critical(M,...W){}dispose(){}flush(){}}e.$ek=o;class u extends o{}e.$fk=u;function g(O){if(O.verbose)return w.Trace;if(typeof O.logLevel=="string"){const M=I(O.logLevel.toLowerCase());if(M!==void 0)return M}return e.$8j}function P(O){switch(O){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}function D(O){switch(O){case w.Trace:return{original:"Trace",value:n.localize(0,null)};case w.Debug:return{original:"Debug",value:n.localize(1,null)};case w.Info:return{original:"Info",value:n.localize(2,null)};case w.Warning:return{original:"Warning",value:n.localize(3,null)};case w.Error:return{original:"Error",value:n.localize(4,null)};case w.Off:return{original:"Off",value:n.localize(5,null)}}}function I(O){switch(O){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$kk=new v.$Pj("logLevel",P(w.Info))});var ie=this&&this.__param||function(K,e){return function(n,C){e(n,C,K)}};define(se[224],re([0,1,14,4,5]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;const R=n.safeStorage;let j=class{constructor(h){this.a=h,n.app.commandLine.getSwitchValue("password-store")==="basic"&&R.setUsePlainTextEncryption?.(!0)}async encrypt(h){this.a.trace("[EncryptionMainService] Encrypting value.");try{const l=JSON.stringify(R.encryptString(h));return this.a.trace("[EncryptionMainService] Encrypted value."),l}catch(l){throw this.a.error(l),l}}async decrypt(h){let l;try{if(l=JSON.parse(h),!l.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${h}`);const d=Buffer.from(l.data);this.a.trace("[EncryptionMainService] Decrypting value.");const p=R.decryptString(d);return this.a.trace("[EncryptionMainService] Decrypted value."),p}catch(d){throw this.a.error(d),d}}isEncryptionAvailable(){return Promise.resolve(R.isEncryptionAvailable())}getKeyStorageProvider(){if(C.$i)return Promise.resolve("dpapi");if(C.$j)return Promise.resolve("keychain_access");if(R.getSelectedStorageBackend)try{const h=R.getSelectedStorageBackend();return Promise.resolve(h)}catch(h){this.a.error(h)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(C.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(C.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!R.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");R.setUsePlainTextEncryption(!0)}};e.$0cc=j,e.$0cc=j=Ee([ie(0,k.$5j)],j)}),define(se[225],re([0,1,22,8,15,3,31,2,9,60,5]),function(K,e,n,C,k,R,j,E,h,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=void 0;class p extends E.$Uc{constructor($,f){super(),this.a=$,this.b=f,this.c=this.B(new R.$fe),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$fe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new C.$wh(0)),this.w=[],this.y=this.B(new C.$wh(0))}watch($,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n($,f):this.z($,f)}n($,f){const y={path:this.J($),excludes:f.excludes,includes:f.includes,recursive:f.recursive,filter:f.filter,correlationId:f.correlationId},w=(0,n.$Tb)(this.j,y);return this.r(),(0,E.$Sc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,k.$1)($))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,l.$Rq)(f)),f=>this.G(f),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const f of this.j)(0,l.$Nq)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const f of this.j)(0,l.$Nq)(f)&&$.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,f){const y={path:this.J($),excludes:f.excludes,includes:f.includes,recursive:!1,filter:f.filter,correlationId:f.correlationId},w=(0,n.$Tb)(this.w,y);return this.C(),(0,E.$Sc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,k.$1)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,l.$Rq)($)),$=>this.G($),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.H($)}H($){this.a[$.type]($.message)}I($){return(0,h.$hc)($.fsPath)}J($){const f=this.I($);return(0,j.$Ag)(f)}}e.$Xq=p}),define(se[226],re([0,1,22,8,17,23,3,46,71,2,59,13,66,19,63,177,16,122,5,15]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w,b,c,m){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;let a=class extends l.$Uc{static{S=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new j.$fe),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new j.$fe),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new j.$fe),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new j.$fe),this.onDidRunOperation=this.r.event,this.X=this.B(new j.$fe),this.Y=this.B(new j.$fe),this.onDidFilesChange=this.Y.event,this.Z=this.B(new j.$fe),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new C.$Hh)}registerProvider(r,s){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${r}`);const i=new l.$Tc;return this.h.set(r,s),this.c.fire({added:!0,scheme:r,provider:s}),i.add(s.onDidChangeFile(o=>{const u=new w.$ll(o,!this.S(s));this.X.fire(u),u.hasCorrelation()||this.Y.fire(u)})),typeof s.onDidWatchError=="function"&&i.add(s.onDidWatchError(o=>this.Z.fire(new Error(o)))),i.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:r}))),(0,l.$Sc)(()=>{this.c.fire({added:!1,scheme:r,provider:s}),this.h.delete(r),(0,l.$Pc)(i)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const s=[];this.f.fire({scheme:r,join(i){s.push(i)}}),!this.h.has(r)&&await C.Promises.settled(s)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,s){const i=this.h.get(r.scheme);return!!(i&&i.capabilities&s)}listCapabilities(){return h.Iterable.map(this.h,([r,s])=>({scheme:r,capabilities:s.capabilities}))}async j(r){if(!(0,$.$dh)(r))throw new w.$nl((0,y.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const s=this.h.get(r.scheme);if(!s){const i=new m.$bb;throw i.message=(0,y.localize)(1,null,r.toString()),i}return s}async m(r){const s=await this.j(r);if((0,w.$$k)(s)||(0,w.$8k)(s)||(0,w.$_k)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const s=await this.j(r);if((0,w.$$k)(s)||(0,w.$8k)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,s){try{return await this.s(r,s)}catch(i){throw(0,w.$il)(i)===w.FileSystemProviderErrorCode.FileNotFound?new w.$nl((0,y.localize)(2,null,this.sb(r)),1):(0,w.$gl)(i)}}async s(r,s){const i=await this.j(r),o=this.S(i),u=s?.resolveTo,g=s?.resolveSingleChildDescendants,P=s?.resolveMetadata,D=await i.stat(r);let I;return this.t(i,r,D,void 0,!!P,(O,M)=>(I||(I=d.$Ei.forUris(()=>!o),I.set(r,!0),u&&I.fill(!0,u)),I.get(O.resource)||I.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&g?M===1:!1))}async t(r,s,i,o,u,g){const{providerExtUri:P}=this.R(r),D={resource:s,name:P.basename(s),isFile:(i.type&w.FileType.File)!==0,isDirectory:(i.type&w.FileType.Directory)!==0,isSymbolicLink:(i.type&w.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&w.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((i.permissions??0)&w.FilePermission.Locked),etag:(0,w.$yl)({mtime:i.mtime,size:i.size}),children:void 0};if(D.isDirectory&&g(D,o)){try{const I=await r.readdir(s),O=await C.Promises.settled(I.map(async([M,W])=>{try{const F=P.joinPath(s,M),T=u?await r.stat(F):{type:W};return await this.t(r,F,T,I.length,u,g)}catch(F){return this.b.trace(F),null}}));D.children=(0,n.$Hb)(O)}catch(I){this.b.trace(I),D.children=[]}return D}return D}async resolveAll(r){return C.Promises.settled(r.map(async s=>{try{return{stat:await this.s(s.resource,s.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(r){const s=await this.j(r),i=await s.stat(r);return this.t(s,r,i,void 0,!0,()=>!1)}async exists(r){const s=await this.j(r);try{return!!await s.stat(r)}catch{return!1}}async canCreateFile(r,s){try{await this.u(r,s)}catch(i){return i}return!0}async u(r,s){if(!s?.overwrite&&await this.exists(r))throw new w.$nl((0,y.localize)(3,null,this.sb(r)),3,s)}async createFile(r,s=k.$He.fromString(""),i){await this.u(r,i);const o=await this.writeFile(r,s);return this.r.fire(new w.$kl(r,0,o)),o}async writeFile(r,s,i){const o=this.qb(await this.n(r),r),{providerExtUri:u}=this.R(o);let g=i;if((0,w.$bl)(o)&&!g?.atomic){const P=o.enforceAtomicWriteFile?.(r);P&&(g={...i,atomic:P})}try{await this.w(o,r,g)||await this.U(o,u.dirname(r));let D;if((0,w.$8k)(o)&&!(s instanceof k.$He))if((0,f.$te)(s)){const I=await(0,f.$Ae)(s,3);I.ended?D=k.$He.concat(I.buffer):D=I}else D=(0,f.$xe)(s,I=>k.$He.concat(I),3);else D=s;!(0,w.$$k)(o)||(0,w.$8k)(o)&&D instanceof k.$He||(0,w.$8k)(o)&&(0,w.$bl)(o)&&g?.atomic?await this.hb(o,r,g,D):await this.db(o,r,g,D instanceof k.$He?(0,k.$Se)(D):D),this.r.fire(new w.$kl(r,4))}catch(P){throw new w.$nl((0,y.localize)(4,null,this.sb(r),(0,w.$gl)(P).toString()),(0,w.$jl)(P),g)}return this.resolve(r,{resolveMetadata:!0})}async w(r,s,i){const o=!!i?.unlock;if(o&&!(r.capabilities&8192))throw new Error((0,y.localize)(5,null,this.sb(s)));if(!!i?.atomic){if(!(r.capabilities&32768))throw new Error((0,y.localize)(6,null,this.sb(s)));if(!(r.capabilities&2))throw new Error((0,y.localize)(7,null,this.sb(s)));if(o)throw new Error((0,y.localize)(8,null,this.sb(s)))}let g;try{g=await r.stat(s)}catch{return}if(g.type&w.FileType.Directory)throw new w.$nl((0,y.localize)(9,null,this.sb(s)),0,i);if(this.rb(s,g),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==w.$xl&&typeof g.mtime=="number"&&typeof g.size=="number"&&i.mtime<g.mtime&&i.etag!==(0,w.$yl)({mtime:i.mtime,size:g.size}))throw new w.$nl((0,y.localize)(10,null),3,i);return g}async readFile(r,s,i){const o=await this.m(r);return s?.atomic?this.z(o,r,s,i):this.C(o,r,s,i)}async z(r,s,i,o){return new Promise((u,g)=>{this.cb.queueFor(s,async()=>{try{const P=await this.C(r,s,i,o);u(P)}catch(P){g(P)}},this.R(r).providerExtUri)})}async C(r,s,i,o){const u=await this.D(r,s,{...i,preferUnbuffered:!0},o);return{...u,value:await(0,k.$Te)(u.value)}}async readFileStream(r,s,i){const o=await this.m(r);return this.D(o,r,s,i)}async D(r,s,i,o){const u=new R.$qe(o);let g=i;(0,w.$al)(r)&&r.enforceAtomicReadFile?.(s)&&(g={...i,atomic:!0});const P=this.J(s,g).then(I=>I,I=>{throw u.dispose(!0),I});let D;try{return typeof g?.etag=="string"&&g.etag!==w.$xl&&await P,g?.atomic&&(0,w.$al)(r)||!((0,w.$$k)(r)||(0,w.$_k)(r))||(0,w.$8k)(r)&&g?.preferUnbuffered?D=this.I(r,s,g):(0,w.$_k)(r)?D=this.G(r,s,u.token,g):D=this.H(r,s,u.token,g),D.on("end",()=>u.dispose()),D.on("error",()=>u.dispose()),{...await P,value:D}}catch(I){throw D&&await(0,f.$ye)(D),this.F(I,s,g)}}F(r,s,i){const o=(0,y.localize)(11,null,this.sb(s),(0,w.$gl)(r).toString());return r instanceof w.$pl?new w.$pl(o,r.stat,i):r instanceof w.$ol?new w.$ol(o,r.fileOperationResult,r.size,r.options):new w.$nl(o,(0,w.$jl)(r),i)}G(r,s,i,o=Object.create(null)){const u=r.readFileStream(s,o,i);return(0,f.$Ee)(u,{data:g=>g instanceof k.$He?g:k.$He.wrap(g),error:g=>this.F(g,s,o)},g=>k.$He.concat(g))}H(r,s,i,o=Object.create(null)){const u=(0,k.$Xe)();return(0,b.$Kq)(r,s,u,g=>g,{...o,bufferSize:this.a,errorTransformer:g=>this.F(g,s,o)},i),u}I(r,s,i){const o=(0,f.$ve)(u=>k.$He.concat(u));return(async()=>{try{let u;i?.atomic&&(0,w.$al)(r)?u=await r.readFile(s,{atomic:!0}):u=await r.readFile(s),typeof i?.position=="number"&&(u=u.slice(i.position)),typeof i?.length=="number"&&(u=u.slice(0,i.length)),this.L(s,u.byteLength,i),o.end(k.$He.wrap(u))}catch(u){o.error(u),o.end()}})(),o}async J(r,s){const i=await this.resolve(r,{resolveMetadata:!0});if(i.isDirectory)throw new w.$nl((0,y.localize)(12,null,this.sb(r)),0,s);if(typeof s?.etag=="string"&&s.etag!==w.$xl&&s.etag===i.etag)throw new w.$pl((0,y.localize)(13,null),i,s);return this.L(r,i.size,s),i}L(r,s,i){if(typeof i?.limits?.size=="number"&&s>i.limits.size)throw new w.$ol((0,y.localize)(14,null,this.sb(r)),7,s,i)}async canMove(r,s,i){return this.M(r,s,"move",i)}async canCopy(r,s,i){return this.M(r,s,"copy",i)}async M(r,s,i,o){if(r.toString()!==s.toString())try{const u=i==="move"?this.qb(await this.n(r),r):await this.m(r),g=this.qb(await this.n(s),s);await this.Q(u,r,g,s,i,o)}catch(u){return u}return!0}async move(r,s,i){const o=this.qb(await this.n(r),r),u=this.qb(await this.n(s),s),g=await this.N(o,r,u,s,"move",!!i),P=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new w.$kl(r,g==="move"?2:3,P)),P}async copy(r,s,i){const o=await this.m(r),u=this.qb(await this.n(s),s),g=await this.N(o,r,u,s,"copy",!!i),P=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new w.$kl(r,g==="copy"?3:2,P)),P}async N(r,s,i,o,u,g){if(s.toString()===o.toString())return u;const{exists:P,isSameResourceWithDifferentPathCase:D}=await this.Q(r,s,i,o,u,g);if(P&&!D&&g&&await this.del(o,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(o)),u==="copy"){if(r===i&&(0,w.$9k)(r))await r.copy(s,o,{overwrite:g});else{const I=await this.resolve(s);I.isDirectory?await this.P(r,I,i,o):await this.O(r,s,i,o)}return u}else return r===i?(await r.rename(s,o,{overwrite:g}),u):(await this.N(r,s,i,o,"copy",g),await this.del(s,{recursive:!0}),"copy")}async O(r,s,i,o){if((0,w.$$k)(r)&&(0,w.$$k)(i))return this.jb(r,s,i,o);if((0,w.$$k)(r)&&(0,w.$8k)(i))return this.pb(r,s,i,o);if((0,w.$8k)(r)&&(0,w.$$k)(i))return this.nb(r,s,i,o);if((0,w.$8k)(r)&&(0,w.$8k)(i))return this.lb(r,s,i,o)}async P(r,s,i,o){await i.mkdir(o),Array.isArray(s.children)&&await C.Promises.settled(s.children.map(async u=>{const g=this.R(i).providerExtUri.joinPath(o,u.name);return u.isDirectory?this.P(r,await this.resolve(u.resource),i,g):this.O(r,u.resource,i,g)}))}async Q(r,s,i,o,u,g){let P=!1;if(r===i){const{providerExtUri:I,isPathCaseSensitive:O}=this.R(r);if(O||(P=I.isEqual(s,o)),P&&u==="copy")throw new Error((0,y.localize)(15,null,this.sb(s),this.sb(o)));if(!P&&I.isEqualOrParent(o,s))throw new Error((0,y.localize)(16,null,this.sb(s),this.sb(o)))}const D=await this.exists(o);if(D&&!P){if(!g)throw new w.$nl((0,y.localize)(17,null,this.sb(s),this.sb(o)),4);if(r===i){const{providerExtUri:I}=this.R(r);if(I.isEqualOrParent(s,o))throw new Error((0,y.localize)(18,null,this.sb(s),this.sb(o)))}}return{exists:D,isSameResourceWithDifferentPathCase:P}}R(r){const s=this.S(r);return{providerExtUri:s?$.$2g:$.$4g,isPathCaseSensitive:s}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const s=this.qb(await this.j(r),r);await this.U(s,r);const i=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new w.$kl(r,0,i)),i}async U(r,s){const i=[],{providerExtUri:o}=this.R(r);for(;!o.isEqual(s,o.dirname(s));)try{if(!((await r.stat(s)).type&w.FileType.Directory))throw new Error((0,y.localize)(19,null,this.sb(s)));break}catch(u){if((0,w.$il)(u)!==w.FileSystemProviderErrorCode.FileNotFound)throw u;i.push(o.basename(s)),s=o.dirname(s)}for(let u=i.length-1;u>=0;u--){s=o.joinPath(s,i[u]);try{await r.mkdir(s)}catch(g){if((0,w.$il)(g)!==w.FileSystemProviderErrorCode.FileExists)throw g}}}async canDelete(r,s){try{await this.W(r,s)}catch(i){return i}return!0}async W(r,s){const i=this.qb(await this.j(r),r),o=!!s?.useTrash;if(o&&!(i.capabilities&4096))throw new Error((0,y.localize)(20,null,this.sb(r)));const u=s?.atomic;if(u&&!(i.capabilities&65536))throw new Error((0,y.localize)(21,null,this.sb(r)));if(o&&u)throw new Error((0,y.localize)(22,null,this.sb(r)));let g;try{g=await i.stat(r)}catch{}if(g)this.rb(r,g);else throw new w.$nl((0,y.localize)(23,null,this.sb(r)),1);if(!!!s?.recursive){const D=await this.resolve(r);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,y.localize)(24,null,this.sb(r)))}return i}async del(r,s){const i=await this.W(r,s);let o=s;if((0,w.$cl)(i)&&!o?.atomic){const D=i.enforceAtomicDelete?.(r);D&&(o={...s,atomic:D})}const u=!!o?.useTrash,g=!!o?.recursive,P=o?.atomic??!1;await i.delete(r,{recursive:g,useTrash:u,atomic:P}),this.r.fire(new w.$kl(r,1))}async cloneFile(r,s){const i=await this.j(r),o=this.qb(await this.n(s),s);if(!(i===o&&this.R(i).providerExtUri.isEqual(r,s)))return i===o&&(0,w.$0k)(i)?i.cloneFile(r,s):(await this.U(o,this.R(o).providerExtUri.dirname(s)),i===o&&(0,w.$9k)(i)?this.cb.queueFor(r,()=>i.copy(r,s,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(r,()=>this.O(i,r,o,s),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(r,s){return this.watch(r,{...s,correlationId:S.ab++})}watch(r,s={recursive:!1,excludes:[]}){const i=new l.$Tc;let o=!1,u=()=>{o=!0};i.add((0,l.$Sc)(()=>u())),(async()=>{try{const P=await this.bb(r,s);o?(0,l.$Pc)(P):u=()=>(0,l.$Pc)(P)}catch(P){this.b.error(P)}})();const g=s.correlationId;if(typeof g=="number"){const P=i.add(new j.$fe);return i.add(this.X.event(I=>{I.correlates(g)&&P.fire(I)})),{onDidChange:P.event,dispose:()=>i.dispose()}}return i}async bb(r,s){const i=await this.j(r),o=(0,E.$mj)([this.R(i).providerExtUri.getComparisonKey(r),s]);let u=this.$.get(o);return u||(u={count:0,disposable:i.watch(r,s)},this.$.set(o,u)),u.count+=1,(0,l.$Sc)(()=>{u&&(u.count--,u.count===0&&((0,l.$Pc)(u.disposable),this.$.delete(o)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,l.$Pc)(r.disposable);this.$.clear()}async db(r,s,i,o){return this.cb.queueFor(s,async()=>{const u=await r.open(s,{create:!0,unlock:i?.unlock??!1});try{(0,f.$te)(o)||(0,f.$ue)(o)?await this.eb(r,u,o):await this.fb(r,u,o)}catch(g){throw(0,w.$gl)(g)}finally{await r.close(u)}},this.R(r).providerExtUri)}async eb(r,s,i){let o=0,u;if((0,f.$ue)(i)){if(i.buffer.length>0){const g=k.$He.concat(i.buffer);await this.gb(r,s,g,g.byteLength,o,0),o+=g.byteLength}if(i.ended)return;u=i.stream}else u=i;return new Promise((g,P)=>{(0,f.$ze)(u,{onData:async D=>{u.pause();try{await this.gb(r,s,D,D.byteLength,o,0)}catch(I){return P(I)}o+=D.byteLength,setTimeout(()=>u.resume())},onError:D=>P(D),onEnd:()=>g()})})}async fb(r,s,i){let o=0,u;for(;(u=i.read())!==null;)await this.gb(r,s,u,u.byteLength,o,0),o+=u.byteLength}async gb(r,s,i,o,u,g){let P=0;for(;P<o;){const D=await r.write(s,u+P,i.buffer,g+P,o-P);P+=D}}async hb(r,s,i,o){return this.cb.queueFor(s,()=>this.ib(r,s,i,o),this.R(r).providerExtUri)}async ib(r,s,i,o){let u;o instanceof k.$He?u=o:(0,f.$te)(o)?u=await(0,k.$Te)(o):(0,f.$ue)(o)?u=await(0,k.$Ue)(o):u=(0,k.$Re)(o),await r.writeFile(s,u.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(r,s,i,o){return this.cb.queueFor(o,()=>this.kb(r,s,i,o),this.R(i).providerExtUri)}async kb(r,s,i,o){let u,g;try{u=await r.open(s,{create:!1}),g=await i.open(o,{create:!0,unlock:!1});const P=k.$He.alloc(this.a);let D=0,I=0,O=0;do O=await r.read(u,D,P.buffer,I,P.byteLength-I),await this.gb(i,g,P,O,D,I),D+=O,I+=O,I===P.byteLength&&(I=0);while(O>0)}catch(P){throw(0,w.$gl)(P)}finally{await C.Promises.settled([typeof u=="number"?r.close(u):Promise.resolve(),typeof g=="number"?i.close(g):Promise.resolve()])}}async lb(r,s,i,o){return this.cb.queueFor(o,()=>this.mb(r,s,i,o),this.R(i).providerExtUri)}async mb(r,s,i,o){return i.writeFile(o,await r.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,s,i,o){return this.cb.queueFor(o,()=>this.ob(r,s,i,o),this.R(i).providerExtUri)}async ob(r,s,i,o){const u=await i.open(o,{create:!0,unlock:!1});try{const g=await r.readFile(s);await this.gb(i,u,k.$He.wrap(g),g.byteLength,0,0)}catch(g){throw(0,w.$gl)(g)}finally{await i.close(u)}}async pb(r,s,i,o){const u=await(0,k.$Te)(this.H(r,s,R.CancellationToken.None));await this.hb(i,o,void 0,u)}qb(r,s){if(r.capabilities&2048)throw new w.$nl((0,y.localize)(25,null,this.sb(s)),6);return r}rb(r,s){if((s.permissions??0)&w.FilePermission.Readonly)throw new w.$nl((0,y.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===p.Schemas.file?r.fsPath:r.toString(!0)}};e.$Lq=a,e.$Lq=a=S=Ee([ie(0,c.$5j)],a)}),define(se[94],re([0,1,43,315,8,32,17,3,31,2,9,4,19,63,21,181,16,122,225,47,221,220]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w,b,c,m,S,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0,(()=>{try{(0,C.gracefulify)(n)}catch(r){console.error(`Error enabling graceful-fs: ${(0,m.$jj)(r)}`)}})();class t extends c.$Xq{static{this.L=!1}constructor(s,i){super(s,i),this.onDidChangeCapabilities=E.Event.None,this.P=new R.$Ac(o=>v.$3g.getComparisonKey(o)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,p.$k&&(this.M|=1024)),this.M}async stat(s){try{const{stat:i,symbolicLink:o}=await f.SymlinkSupport.stat(this.I(s));return{type:this.O(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:w.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const i=await f.Promises.readdir(this.I(s),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async u=>{try{let g;u.isSymbolicLink()?g=(await this.stat((0,v.$_g)(s,u.name))).type:g=this.O(u),o.push([u.name,g])}catch(g){this.a.trace(g)}})),o}catch(i){throw this.hb(i)}}O(s,i){let o;return i?.dangling?o=w.FileType.Unknown:s.isFile()?o=w.FileType.File:s.isDirectory()?o=w.FileType.Directory:o=w.FileType.Unknown,i&&(o|=w.FileType.SymbolicLink),o}async Q(s){const i=this.I(s);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.P.get(s);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const u=new k.$xh;return this.P.set(s,u),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(s)===u&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(s)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),u.open()})}async readFile(s,i){let o;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(s)})`),o=await this.Q(s));const u=this.I(s);return await f.Promises.readFile(u)}catch(u){throw this.hb(u)}finally{o?.dispose()}}R(s){t.L&&this.a.trace(s)}readFileStream(s,i,o){const u=(0,$.$ve)(g=>j.$He.concat(g.map(P=>j.$He.wrap(P))).buffer);return(0,b.$Kq)(this,s,u,g=>g.buffer,{...i,bufferSize:256*1024},o),u}async writeFile(s,i,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.S(s)?this.U(s,(0,v.$_g)((0,v.$$g)(s),`${(0,v.$9g)(s)}${o.atomic.postfix}`),i,o):this.W(s,i,o)}async S(s){try{const i=this.I(s),{symbolicLink:o}=await f.SymlinkSupport.stat(i);if(o)return!1}catch{}return!0}async U(s,i,o,u){const g=new l.$Tc;try{g.add(await this.Q(s)),g.add(await this.Q(i)),await this.W(i,o,u,!0);try{await this.rename(i,s,{overwrite:!0})}catch(P){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{g.dispose()}}async W(s,i,o,u){let g;try{const P=this.I(s);if(!o.create||!o.overwrite){if(await f.Promises.exists(P)){if(!o.overwrite)throw(0,w.$fl)((0,y.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,w.$fl)((0,y.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(s,{create:!0,unlock:o.unlock},u),await this.write(g,0,i,0,i.byteLength)}catch(P){throw await this.ib(s,P)}finally{typeof g=="number"&&await this.close(g)}}static{this.$=!0}static configureFlushOnWrite(s){t.$=s}async open(s,i,o){const u=this.I(s);let g;(0,w.$6k)(i)&&!o&&(g=await this.Q(s));let P;try{if((0,w.$6k)(i)&&i.unlock)try{const{stat:I}=await f.SymlinkSupport.stat(u);I.mode&128||await f.Promises.chmod(u,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}let D;if((0,w.$6k)(i)){if(p.$i)try{await f.Promises.truncate(u,0),D="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}D||(D="w")}else D="r";P=await f.Promises.open(u,D)}catch(D){throw g?.dispose(),(0,w.$6k)(i)?await this.ib(s,D):this.hb(D)}if(this.X.set(P,0),(0,w.$6k)(i)&&this.Z.set(P,s),g){const D=this.Y.get(P);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${u})`),this.Y.set(P,g),D&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${u})`),D.dispose())}return P}async close(s){const i=this.Y.get(s);try{if(this.X.delete(s),this.Z.delete(s)&&t.$)try{await f.Promises.fdatasync(s)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await f.Promises.close(s)}catch(o){throw this.hb(o)}finally{i&&(this.Y.get(s)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.Y.delete(s)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,o,u,g){const P=this.ab(s,i);let D=null;try{D=(await f.Promises.read(s,o,u,g,P)).bytesRead}catch(I){throw this.hb(I)}finally{this.bb(s,P,D)}return D}ab(s,i){return i===this.X.get(s)?null:i}bb(s,i,o){const u=this.X.get(s);typeof u=="number"&&(typeof i=="number"||(typeof o=="number"?this.X.set(s,u+o):this.X.delete(s)))}async write(s,i,o,u,g){return(0,k.$Sh)(()=>this.cb(s,i,o,u,g),100,3)}async cb(s,i,o,u,g){const P=this.ab(s,i);let D=null;try{D=(await f.Promises.write(s,o,u,g,P)).bytesWritten}catch(I){throw await this.ib(this.Z.get(s),I)}finally{this.bb(s,P,D)}return D}async mkdir(s){try{await f.Promises.mkdir(this.I(s))}catch(i){throw this.hb(i)}}async delete(s,i){try{const o=this.I(s);if(i.recursive){let u;i?.atomic!==!1&&i.atomic.postfix&&(u=(0,d.$jc)((0,d.$mc)(o),`${(0,d.$nc)(o)}${i.atomic.postfix}`)),await f.Promises.rm(o,f.RimRafMode.MOVE,u)}else try{await f.Promises.unlink(o)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let g=!1;try{const{stat:P,symbolicLink:D}=await f.SymlinkSupport.stat(o);g=P.isDirectory()&&!D}catch{}if(g)await f.Promises.rmdir(o);else throw u}else throw u}}catch(o){throw this.hb(o)}}async rename(s,i,o){const u=this.I(s),g=this.I(i);if(u!==g)try{await this.db(s,i,"move",o.overwrite),await f.Promises.rename(u,g)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(2,null,(0,d.$nc)(u),(0,d.$nc)((0,d.$mc)(g)),P.toString()))),this.hb(P)}}async copy(s,i,o){const u=this.I(s),g=this.I(i);if(u!==g)try{await this.db(s,i,"copy",o.overwrite),await f.Promises.copy(u,g,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(3,null,(0,d.$nc)(u),(0,d.$nc)((0,d.$mc)(g)),P.toString()))),this.hb(P)}}async db(s,i,o,u){const g=this.I(s),P=this.I(i);let D=!1;if(!!(this.capabilities&1024)||(D=(0,h.$wg)(g,P,!0)),D){if(o==="copy")throw(0,w.$fl)((0,y.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const O=await this.N(s);if(!O)throw(0,w.$fl)((0,y.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const M=await this.N(i);if(M){if(!u)throw(0,w.$fl)((0,y.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);O.type&w.FileType.File&&M.type&w.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,i){return this.eb(s,i,!1)}async eb(s,i,o){const u=this.I(s),g=this.I(i),P=!!(this.capabilities&1024);if((0,h.$wg)(u,g,!P))return;const D=new l.$Tc;try{D.add(await this.Q(s)),D.add(await this.Q(i)),o&&await f.Promises.mkdir((0,d.$mc)(g),{recursive:!0}),await f.Promises.copyFile(u,g)}catch(I){if(I.code==="ENOENT"&&!o)return this.eb(s,i,!0);throw this.hb(I)}finally{D.dispose()}}t(s,i,o){return new S.$5q(u=>s(u),u=>i(u),o)}F(s,i,o){return new a.$br(u=>s(u),u=>i(u),o)}hb(s){if(s instanceof w.$el)return s;let i=s,o;switch(s.code){case"ENOENT":o=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=w.FileSystemProviderErrorCode.Unknown;break;default:o=w.FileSystemProviderErrorCode.Unknown}return(0,w.$fl)(i,o)}async ib(s,i){let o=this.hb(i);if(s&&o.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await f.SymlinkSupport.stat(this.I(s));u.mode&128||(o=(0,w.$fl)(i,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return o}}e.$cr=t}),define(se[227],re([0,1,3,94,2,17,63,23]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=e.$Ms=void 0;class h extends k.$Uc{constructor(p,v){super(),this.a=p,this.b=v,this.F=new Map,this.G=new Map}call(p,v,$){const f=this.c(p);switch(v){case"stat":return this.g(f,$[0]);case"readdir":return this.h(f,$[0]);case"open":return this.r(f,$[0],$[1]);case"close":return this.s($[0]);case"read":return this.t($[0],$[1],$[2]);case"readFile":return this.j(f,$[0],$[1]);case"write":return this.u($[0],$[1],$[2],$[3],$[4]);case"writeFile":return this.n(f,$[0],$[1],$[2]);case"rename":return this.z(f,$[0],$[1],$[2]);case"copy":return this.C(f,$[0],$[1],$[2]);case"cloneFile":return this.D(f,$[0],$[1]);case"mkdir":return this.w(f,$[0]);case"delete":return this.y(f,$[0],$[1]);case"watch":return this.I(f,$[0],$[1],$[2],$[3]);case"unwatch":return this.J($[0],$[1])}throw new Error(`IPC Command ${v} not found`)}listen(p,v,$){const f=this.c(p);switch(v){case"fileChange":return this.H(f,$[0]);case"readFileStream":return this.m(f,$[0],$[1])}throw new Error(`Unknown event ${v}`)}g(p,v){const $=this.f(p,v,!0);return this.a.stat($)}h(p,v){const $=this.f(p,v);return this.a.readdir($)}async j(p,v,$){const f=this.f(p,v,!0),y=await this.a.readFile(f,$);return R.$He.wrap(y)}m(p,v,$){const f=this.f(p,v,!0),y=new E.$qe,w=new n.$fe({onDidRemoveLastListener:()=>{y.cancel()}}),b=this.a.readFileStream(f,$,y.token);return(0,j.$ze)(b,{onData:c=>w.fire(R.$He.wrap(c)),onError:c=>w.fire(c),onEnd:()=>{w.fire("end"),w.dispose(),y.dispose()}}),w.event}n(p,v,$,f){const y=this.f(p,v);return this.a.writeFile(y,$.buffer,f)}r(p,v,$){const f=this.f(p,v,!0);return this.a.open(f,$)}s(p){return this.a.close(p)}async t(p,v,$){const f=R.$He.alloc($),w=await this.a.read(p,v,f.buffer,0,$);return[f,w]}u(p,v,$,f,y){return this.a.write(p,v,$.buffer,f,y)}w(p,v){const $=this.f(p,v);return this.a.mkdir($)}y(p,v,$){const f=this.f(p,v);return this.a.delete(f,$)}z(p,v,$,f){const y=this.f(p,v),w=this.f(p,$);return this.a.rename(y,w,f)}C(p,v,$,f){const y=this.f(p,v),w=this.f(p,$);return this.a.copy(y,w,f)}D(p,v,$){const f=this.f(p,v),y=this.f(p,$);return this.a.cloneFile(f,y)}H(p,v){const $=new n.$fe({onWillAddFirstListener:()=>{this.F.set(v,this.L(p,$))},onDidRemoveLastListener:()=>{(0,k.$Pc)(this.F.get(v)),this.F.delete(v)}});return $.event}async I(p,v,$,f,y){const w=this.F.get(v);if(w){const b=this.f(p,f),c=w.watch($,b,y);this.G.set(v+$,c)}}async J(p,v){const $=p+v,f=this.G.get($);f&&((0,k.$Pc)(f),this.G.delete($))}dispose(){super.dispose();for(const[,p]of this.G)p.dispose();this.G.clear();for(const[,p]of this.F)p.dispose();this.F.clear()}}e.$Ms=h;class l extends k.$Uc{constructor(p,v,$,f){super(),this.c=p,this.f=$,this.g=f,this.a=new Map,this.b=this.B(new C.$cr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(v)}h(p){const v=this.B(new n.$fe);this.B(v.event($=>{p.fire($.map(f=>({resource:this.c.transformOutgoingURI(f.resource),type:f.type,cId:f.cId})))})),this.B(this.b.onDidChangeFile($=>v.fire($))),this.B(this.b.onDidWatchError($=>p.fire($)))}j(p){}m(p){}watch(p,v,$){const f=this.m(this.g);return Array.isArray(f)&&($.excludes=[...$.excludes,...f]),this.a.set(p,this.b.watch(v,$)),(0,k.$Sc)(()=>{(0,k.$Pc)(this.a.get(p)),this.a.delete(p)})}dispose(){for(const[,p]of this.a)p.dispose();this.a.clear(),super.dispose()}}e.$Ns=l}),define(se[228],re([0,1,14,180,4,7,16,9,227,157,47]),function(K,e,n,C,k,R,j,E,h,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=void 0;class p extends h.$Ms{constructor(f,y,w){super(f,y),this.M=w}c(f){return l.$Bn}f(f,y){return R.URI.revive(y)}async y(f,y,w){if(!w.useTrash)return super.y(f,y,w);const b=this.f(f,y),c=(0,E.$hc)(b.fsPath);try{await n.shell.trashItem(c)}catch(m){throw(0,j.$fl)(k.$i?(0,C.localize)(0,null,(0,E.$nc)(c),(0,d.$jj)(m)):(0,C.localize)(1,null,(0,E.$nc)(c),(0,d.$jj)(m)),j.FileSystemProviderErrorCode.Unknown)}}L(f,y){return new v(f,y,this.b,this.M)}}e.$fdc=p;class v extends h.$Ns{watch(f,y,w){if(w.recursive)throw(0,j.$fl)("Recursive file watching is not supported from main process for performance reasons.",j.FileSystemProviderErrorCode.Unavailable);return super.watch(f,y,w)}}}),define(se[229],re([0,1,5]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6_b=void 0;class C extends n.$$j{constructor(R=n.$8j){super(),this.m=[],this.n=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(j=>{this.n?.setLevel(j)}))}set logger(R){this.n=R;for(const{level:j,message:E}of this.m)(0,n.log)(R,j,E);this.m=[]}g(R,j){this.n?(0,n.log)(this.n,R,j):this.getLevel()<=R&&this.m.push({level:R,message:j})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$6_b=C}),define(se[230],re([0,1,7,3,5,2]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=e.$ds=e.$cs=void 0;class j extends k.$dk{constructor(p,v,$,f,y){super(v,$,f),this.r=p,this.t=y,this.B(y.listen("onDidChangeLogLevel",p)(w=>{(0,k.$7j)(w)?super.setLogLevel(w):super.setLogLevel(n.URI.revive(w[0]),w[1])})),this.B(y.listen("onDidChangeVisibility",p)(([w,b])=>super.setVisibility(n.URI.revive(w),b))),this.B(y.listen("onDidChangeLoggers",p)(({added:w,removed:b})=>{for(const c of w)super.registerLogger({...c,resource:n.URI.revive(c.resource)});for(const c of b)super.deregisterLogger(c.resource)}))}createConsoleMainLogger(){return new k.$bk({log:(p,v)=>{this.t.call("consoleLog",[p,v])}})}registerLogger(p){super.registerLogger(p),this.t.call("registerLogger",[p,this.r])}deregisterLogger(p){super.deregisterLogger(p),this.t.call("deregisterLogger",[p,this.r])}setLogLevel(p,v){super.setLogLevel(p,v),this.t.call("setLogLevel",[p,v])}setVisibility(p,v){super.setVisibility(p,v),this.t.call("setVisibility",[this.n(p),v])}s(p,v,$){return new E(this.t,p,v,$,this.r)}static setLogLevel(p,v,$){return p.call("setLogLevel",[v,$])}}e.$cs=j;class E extends k.$$j{constructor(p,v,$,f,y){super(f?.logLevel==="always"),this.r=p,this.s=v,this.m=!1,this.n=[],this.setLevel($),this.r.call("createLogger",[v,f,y]).then(()=>{this.u(this.n),this.m=!0})}g(p,v){const $=[[p,v]];this.m?this.u($):this.n.push(...$)}u(p){this.r.call("log",[this.s,p])}}class h{constructor(p,v){this.a=p,this.b=v}listen(p,v){const $=this.b(p);switch(v){case"onDidChangeLoggers":return C.Event.map(this.a.onDidChangeLoggers,f=>({added:[...f.added].map(y=>this.c(y,$)),removed:[...f.removed].map(y=>this.c(y,$))}));case"onDidChangeVisibility":return C.Event.map(this.a.onDidChangeVisibility,f=>[$.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return C.Event.map(this.a.onDidChangeLogLevel,f=>(0,k.$7j)(f)?f:[$.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${v}`)}async call(p,v,$){const f=this.b(p);switch(v){case"setLogLevel":return(0,k.$7j)($[0])?this.a.setLogLevel($[0]):this.a.setLogLevel(n.URI.revive(f.transformIncoming($[0][0])),$[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(y=>this.c(y,f)))}throw new Error(`Call not found: ${v}`)}c(p,v){return{...p,resource:v.transformOutgoingURI(p.resource)}}}e.$ds=h;class l extends R.$Uc{constructor(p,v){super(),v.call("setLogLevel",[p.getLogLevel()]),this.B(p.onDidChangeLogLevel($=>v.call("setLogLevel",[$]))),v.call("getRegisteredLoggers").then($=>{for(const f of $)p.registerLogger({...f,resource:n.URI.revive(f.resource)})}),this.B(v.listen("onDidChangeVisibility")(([$,f])=>p.setVisibility(n.URI.revive($),f))),this.B(v.listen("onDidChangeLoggers")(({added:$,removed:f})=>{for(const y of $)p.registerLogger({...y,resource:n.URI.revive(y.resource)});for(const y of f)p.deregisterLogger(y.resource)}))}}e.$es=l}),define(se[231],re([0,1,2,5]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=void 0;class k extends n.$Uc{constructor(j,E=[]){super(),this.a=new C.$ck([j,...E]),this.B(j.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...E){this.a.trace(j,...E)}debug(j,...E){this.a.debug(j,...E)}info(j,...E){this.a.info(j,...E)}warn(j,...E){this.a.warn(j,...E)}error(j,...E){this.a.error(j,...E)}flush(){this.a.flush()}}e.$aQ=k}),define(se[232],re([0,1,32,7,5]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=void 0;class R{constructor(E){this.b=E,this.a=new n.$Ac}listen(E,h,l){switch(h){case"onDidChangeLoggers":return l?this.b.getOnDidChangeLoggersEvent(l):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.b.getOnDidChangeLogLevelEvent(l):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.b.getOnDidChangeVisibilityEvent(l):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(E,h,l){switch(h){case"createLogger":this.c(C.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.e(C.URI.revive(l[0]),l[1]);case"consoleLog":return this.d(l[0],l[1]);case"setLogLevel":return(0,k.$7j)(l[0])?this.b.setLogLevel(l[0]):this.b.setLogLevel(C.URI.revive(l[0]),l[1]);case"setVisibility":return this.b.setVisibility(C.URI.revive(l[0]),l[1]);case"registerLogger":return this.b.registerLogger({...l[0],resource:C.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.b.deregisterLogger(C.URI.revive(l[0]))}throw new Error(`Call not found: ${h}`)}c(E,h,l){this.a.set(E,this.b.createLogger(E,h,l))}d(E,h){let l=console.log;switch(E){case k.LogLevel.Error:l=console.error;break;case k.LogLevel.Warning:l=console.warn;break;case k.LogLevel.Info:l=console.info;break}l.call(console,...h)}e(E,h){const l=this.a.get(E);if(!l)throw new Error("Create the logger before logging");for(const[d,p]of h)(0,k.log)(l,d,p)}}e.$aec=R}),define(se[233],re([0,1,16,5]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=void 0;var k;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(k||(k={}));async function R(l,d,p,v,$){try{const f=await new Promise((w,b)=>{K(["@vscode/spdlog"],w,b)});f.setFlushOn(k.Trace);const y=await f.createAsyncRotatingLogger(l,d,p,v);return $?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(f){console.error(f)}return null}function j(l,d,p){switch(d){case C.LogLevel.Trace:l.trace(p);break;case C.LogLevel.Debug:l.debug(p);break;case C.LogLevel.Info:l.info(p);break;case C.LogLevel.Warning:l.warn(p);break;case C.LogLevel.Error:l.error(p);break;case C.LogLevel.Off:break;default:throw new Error(`Invalid log level ${d}`)}}function E(l,d){switch(d){case C.LogLevel.Trace:l.setLevel(k.Trace);break;case C.LogLevel.Debug:l.setLevel(k.Debug);break;case C.LogLevel.Info:l.setLevel(k.Info);break;case C.LogLevel.Warning:l.setLevel(k.Warning);break;case C.LogLevel.Error:l.setLevel(k.Error);break;case C.LogLevel.Off:l.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${d}`)}}class h extends C.$$j{constructor(d,p,v,$,f){super(),this.m=[],this.setLevel(f),this.n=this.s(d,p,v,$),this.B(this.onDidChangeLogLevel(y=>{this.r&&E(this.r,y)}))}async s(d,p,v,$){const f=v?6:1,y=30/f*n.$Al.MB,w=await R(d,p,y,f,$);if(w){this.r=w,E(this.r,this.getLevel());for(const{level:b,message:c}of this.m)j(this.r,b,c);this.m=[]}}g(d,p){this.r?j(this.r,d,p):this.getLevel()<=d&&this.m.push({level:d,message:p})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$2P=h}),define(se[234],re([0,1,33,5,233]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=void 0;class R extends C.$dk{s(E,h,l){return new k.$2P((0,n.$Ug)(),E.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,h)}}e.$3P=R}),define(se[67],re([0,1,32,3,6,5,234]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=e.$Mcc=void 0,e.$Mcc=(0,k.$zi)(R.$6j);class E extends j.$3P{constructor(){super(...arguments),this.u=new n.$Ac}createLogger(l,d,p){p!==void 0&&this.u.set(this.n(l),p);try{return super.createLogger(l,d)}catch(v){throw this.u.delete(this.n(l)),v}}registerLogger(l,d){d!==void 0&&this.u.set(l.resource,d),super.registerLogger(l)}deregisterLogger(l){this.u.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const d=[];for(const p of super.getRegisteredLoggers())l===this.u.get(p.resource)&&d.push(p);return d}getOnDidChangeLogLevelEvent(l){return C.Event.filter(this.onDidChangeLogLevel,d=>(0,R.$7j)(d)||this.w(d[0],l))}getOnDidChangeVisibilityEvent(l){return C.Event.filter(this.onDidChangeVisibility,([d])=>this.w(d,l))}getOnDidChangeLoggersEvent(l){return C.Event.filter(C.Event.map(this.onDidChangeLoggers,d=>({added:[...d.added].filter(v=>this.w(v.resource,l)),removed:[...d.removed].filter(v=>this.w(v.resource,l))})),d=>d.added.length>0||d.removed.length>0)}deregisterLoggers(l){for(const[d,p]of this.u)p===l&&this.deregisterLogger(d)}w(l,d){const p=this.u.get(l);return p===void 0||p===d}dispose(){super.dispose(),this.u.clear()}}e.$Ncc=E}),define(se[235],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=n,e.$tdc=C,e.$udc=k,e.$vdc=R;function n(j){return j.submenu!==void 0}function C(j){return j.id==="vscode.menubar.separator"}function k(j){return j.uri!==void 0}function R(j){return!n(j)&&!C(j)&&!k(j)}}),define(se[39],re([0,1,3,71,2,6]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=e.$ho=void 0,e.$ho=(0,R.$yi)("policy");class j extends k.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$fe),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const d=Object.keys(this.f).length;return this.f={...l,...this.f},d!==Object.keys(this.f).length&&await this.j(l),C.Iterable.reduce(this.g.entries(),(p,[v,$])=>({...p,[v]:$}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return C.Iterable.reduce(Object.entries(this.f),(l,[d,p])=>({...l,[d]:{definition:p,value:this.g.get(d)}}),{})}}e.$io=j;class E{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$jo=E}),define(se[236],re([0,1,8,3,71,12,16,5,39]),function(K,e,n,C,k,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=void 0;function l(p,v){const $=[];for(const f of new Set(k.Iterable.concat(p.keys(),v.keys())))p.get(f)!==v.get(f)&&$.push(f);return $}let d=class extends h.$io{constructor(v,$,f){super(),this.m=v,this.n=$,this.s=f,this.c=this.B(new n.$wh(500));const y=C.Event.filter($.onDidFilesChange,w=>w.affects(v));this.B($.watch(v)),this.B(y(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const v=new Map;try{const $=await this.n.readFile(this.m),f=JSON.parse($.value.toString());if(!(0,R.$ag)(f))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(f))this.f[y]&&v.set(y,f[y])}catch($){$.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",$)}return v}async w(){const v=await this.u(),$=l(this.g,v);this.g=v,$.length>0&&this.h.fire($)}};e.$tec=d,e.$tec=d=Ee([ie(1,j.$5k),ie(2,E.$5j)],d)}),define(se[237],re([0,1,3,2,39]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=e.$4dc=void 0;class R{constructor(h){this.b=h,this.a=new C.$Tc}listen(h,l){switch(l){case"onDidChange":return n.Event.map(this.b.onDidChange,d=>d.reduce((p,v)=>({...p,[v]:this.b.getPolicyValue(v)??null}),{}),this.a)}throw new Error(`Event not found: ${l}`)}call(h,l,d){switch(l){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(d)}throw new Error(`Call not found: ${l}`)}dispose(){this.a.dispose()}}e.$4dc=R;class j extends k.$io{constructor(h,l){super(),this.a=l;for(const d in h){const{definition:p,value:v}=h[d];this.f[d]=p,v!==void 0&&this.g.set(d,v)}this.a.listen("onDidChange")(d=>{for(const p in d){const v=d[p];v===null?this.g.delete(p):this.g.set(p,v)}this.h.fire(Object.keys(d))})}async j(h){const l=await this.a.call("updatePolicyDefinitions",h);for(const d in l)this.g.set(d,l[d])}}e.$5dc=j}),define(se[238],re([0,1,39,8,2,5]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=void 0;let j=class extends n.$io{constructor(h,l){super(),this.m=h,this.n=l,this.a=new C.$sh,this.b=this.B(new k.$Vc)}async j(h){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`);const{createWatcher:l}=await new Promise((d,p)=>{K(["@vscode/policy-watcher"],d,p)});await this.a.queue(()=>new Promise((d,p)=>{try{this.b.value=l(this.n,h,v=>{this.t(v),d()})}catch(v){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",v),p(v)}}))}t(h){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const l in h){const d=h[l];d===void 0?this.g.delete(l):this.g.set(l,d)}this.h.fire(Object.keys(h))}};e.$sec=j,e.$sec=j=Ee([ie(0,R.$5j)],j)}),define(se[80],re([0,1,36]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.context<"u"){const R=k.context.configuration();if(R)C=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(C=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),!C.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(C,{version:R.version})}}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=C}),define(se[27],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$lk=(0,n.$yi)("productService"),e.$mk="vscode://schemas/vscode-product"}),define(se[239],re([0,1,8,5]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;let k=class{constructor(j,E,h){this.a=j,this.b=E,this.c=h}async inspect(j){await this.d();const E=this.a.webContents.debugger;await E.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$zh)(j);const h=await E.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),h.profile}async d(){const j=this.a.webContents.debugger;j.attach(),await j.sendCommand("Profiler.enable")}async e(){const j=this.a.webContents.debugger;await j.sendCommand("Profiler.disable"),j.detach()}};e.$idc=k,e.$idc=k=Ee([ie(2,C.$5j)],k)}),define(se[81],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0,e.$vcc=(0,n.$yi)("protocolMainService")}),define(se[45],re([0,1,139,12]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=void 0;class k{constructor(){this.a=new Map}add(j,E){n.ok(C.$$f(j)),n.ok(C.$ag(E)),n.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,E)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$fo=new k}),define(se[240],re([0,1,3,45]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=void 0,e.$go={JSONContribution:"base.contributions.json"};function k(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class R{constructor(){this.b=new n.$fe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,l){this.a[k(h)]=l,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const j=new R;C.$fo.add(e.$go.JSONContribution,j)}),define(se[52],re([0,1,22,3,12,165,18,240,45]),function(K,e,n,C,k,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.ConfigurationScope=e.$ko=e.EditPresentationTypes=void 0,e.$vo=y,e.$wo=w,e.$xo=b,e.$yo=m,e.$zo=S;var l;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$ko={Configuration:"base.contributions.configuration"};var d;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d||(e.ConfigurationScope=d={})),e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro="vscode://schemas/settings/resourceLanguage",e.$so="vscode://schemas/settings/configurationDefaults";const p=h.$fo.as(E.$go.JSONContribution);class v{constructor(){this.h=new Set,this.i=new C.$fe,this.onDidSchemaChange=this.i.event,this.j=new C.$fe,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},p.registerSchema(e.$ro,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const s=new Set;this.n(t,r,s),p.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const r=new Set;this.o(t,r),p.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const s=new Set;this.o(r,s),this.n(t,!1,s),p.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const s=[];for(const{overrides:i,source:o}of t)for(const u in i)if(r.add(u),e.$uo.test(u)){const g=this.a.get(u),P=g?.valuesSources??new Map;if(o)for(const M of Object.keys(i[u]))P.set(M,o);const D={...g?.value||{},...i[u]};this.a.set(u,{source:o,value:D,valuesSources:P});const I=(0,j.$cj)(u),O={type:"object",default:D,description:R.localize(1,null,I),$ref:e.$ro,defaultDefaultValue:D,source:k.$$f(o)?void 0:o,defaultValueSource:o};s.push(...y(u)),this.d[u]=O,this.b.properties[u]=O}else{this.a.set(u,{value:i[u],source:o});const g=this.d[u];g&&(this.w(u,g),this.r(u,g))}this.m(s)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:s,source:i}of t)for(const o in s){const u=this.a.get(o),g=k.$$f(i)?i:i?.id,P=k.$$f(u?.source)?u?.source:u?.source?.id;if(g===P)if(r.add(o),this.a.delete(o),e.$uo.test(o))delete this.d[o],delete this.b.properties[o];else{const D=this.d[o];D&&(this.w(o,D),this.r(o,D))}}this.u()}deltaConfiguration(t){let r=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,s){t.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,s),this.c.push(i),this.q(i)})}o(t,r){const s=i=>{if(i.properties)for(const o in i.properties){r.add(o);const u=this.d[o];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[o],this.s(o,i.properties[o])}i.allOf?.forEach(o=>s(o))};for(const i of t){s(i);const o=this.c.indexOf(i);o!==-1&&this.c.splice(o,1)}}p(t,r=!0,s,i,o=3,u){o=k.$hg(t.scope)?o:t.scope;const g=t.properties;if(g)for(const D in g){const I=g[D];if(r&&m(D,I)){delete g[D];continue}if(I.source=s,I.defaultDefaultValue=g[D].default,this.w(D,I),e.$uo.test(D)?I.scope=void 0:(I.scope=k.$hg(I.scope)?o:I.scope,I.restricted=k.$hg(I.restricted)?!!i?.includes(D):I.restricted),g[D].hasOwnProperty("included")&&!g[D].included){this.f[D]=g[D],delete g[D];continue}else this.d[D]=g[D],g[D].policy?.name&&this.e.set(g[D].policy.name,D);!g[D].deprecationMessage&&g[D].markdownDeprecationMessage&&(g[D].deprecationMessage=g[D].markdownDeprecationMessage),u.add(D)}const P=t.allOf;if(P)for(const D of P)this.p(D,r,s,i,o,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=s=>{const i=s.properties;if(i)for(const u in i)this.r(u,i[u]);s.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$lo.properties[t]=r,r.scope){case 1:e.$mo.properties[t]=r;break;case 2:e.$no.properties[t]=r;break;case 6:e.$oo.properties[t]=r;break;case 3:e.$po.properties[t]=r;break;case 4:e.$qo.properties[t]=r;break;case 5:e.$qo.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$lo.properties[t],r.scope){case 1:delete e.$mo.properties[t];break;case 2:delete e.$no.properties[t];break;case 6:delete e.$oo.properties[t];break;case 3:delete e.$po.properties[t];break;case 4:case 5:delete e.$qo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,s={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$ro};this.w(r,s),e.$lo.properties[r]=s,e.$mo.properties[r]=s,e.$no.properties[r]=s,e.$oo.properties[r]=s,e.$po.properties[r]=s,e.$qo.properties[r]=s}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$ro};e.$lo.patternProperties[e.$to]=t,e.$mo.patternProperties[e.$to]=t,e.$no.patternProperties[e.$to]=t,e.$oo.patternProperties[e.$to]=t,e.$po.patternProperties[e.$to]=t,e.$qo.patternProperties[e.$to]=t,this.i.fire()}w(t,r){const s=this.a.get(t);let i=s?.value,o=s?.source;k.$fg(i)&&(i=r.defaultDefaultValue,o=void 0),k.$fg(i)&&(i=b(r.type)),r.default=i,r.defaultValueSource=o}}const $="\\[([^\\]]+)\\]",f=new RegExp($,"g");e.$to=`^(${$})+$`,e.$uo=new RegExp(e.$to);function y(a){const t=[];if(e.$uo.test(a)){let r=f.exec(a);for(;r?.length;){const s=r[1].trim();s&&t.push(s),r=f.exec(a)}}return(0,n.$Mb)(t)}function w(a){return a.reduce((t,r)=>`${t}[${r}]`,"")}function b(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const c=new v;h.$fo.add(e.$ko.Configuration,c);function m(a,t){return a.trim()?e.$uo.test(a)?R.localize(7,null,a):c.getConfigurationProperties()[a]!==void 0?R.localize(8,null,a):t.policy?.name&&c.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,a,t.policy?.name,c.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function S(){const a=[],t=c.getConfigurationProperties();for(const r of Object.keys(t))a.push([r,t[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}}),define(se[123],re([0,1,22,3,42,2,32,35,12,7,18,52,45]),function(K,e,n,C,k,R,j,E,h,l,d,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0,e.$Eo=m;function $(r){return Object.isFrozen(r)?r:E.$6n(r)}class f{static createEmptyModel(s){return new f({},[],[],void 0,s)}constructor(s,i,o,u,g){this.b=s,this.c=i,this.d=o,this.raw=u,this.f=g,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof f)return i;const o=new y("",this.f);return o.parseRaw(i),o.configurationModel});this.g=s.reduce((i,o)=>o===i?o:i.merge(o),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,d.$aj)(this.contents,s):this.contents}inspect(s,i){const o=this;return{get value(){return $(o.rawConfiguration.getValue(s))},get override(){return i?$(o.rawConfiguration.getOverrideValue(s,i)):void 0},get merged(){return $(i?o.rawConfiguration.override(i).getValue(s):o.rawConfiguration.getValue(s))},get overrides(){const u=[];for(const{contents:g,identifiers:P,keys:D}of o.rawConfiguration.overrides){const I=new f(g,D,[],void 0,o.f).getValue(s);I!==void 0&&u.push({identifiers:P,value:I})}return u.length?$(u):void 0}}}getOverrideValue(s,i){const o=this.j(i);return o?s?(0,d.$aj)(o,s):o:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const o of this.overrides)o.identifiers.includes(s)&&i.push(...o.keys);return n.$Mb(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return n.$Mb(s)}override(s){let i=this.a.get(s);return i||(i=this.h(s),this.a.set(s,i)),i}merge(...s){const i=E.$5n(this.contents),o=E.$5n(this.overrides),u=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const P of s)if(g.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.i(i,P.contents);for(const D of P.overrides){const[I]=o.filter(O=>n.$ub(O.identifiers,D.identifiers));I?(this.i(I.contents,D.contents),I.keys.push(...D.keys),I.keys=n.$Mb(I.keys)):o.push(E.$5n(D))}for(const D of P.keys)u.indexOf(D)===-1&&u.push(D)}return new f(i,u,o,g.every(P=>P instanceof f)?void 0:g,this.f)}h(s){const i=this.j(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const o={};for(const u of n.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let g=this.contents[u];const P=i[u];P&&(typeof g=="object"&&typeof P=="object"?(g=E.$5n(g),this.i(g,P)):g=P),o[u]=g}return new f(o,this.keys,this.overrides,void 0,this.f)}i(s,i){for(const o of Object.keys(i)){if(o in s&&h.$ag(s[o])&&h.$ag(i[o])){this.i(s[o],i[o]);continue}s[o]=E.$5n(i[o])}}j(s){let i=null,o=null;const u=g=>{g&&(o?this.i(o,g):o=E.$5n(g))};for(const g of this.overrides)g.identifiers.length===1&&g.identifiers[0]===s?i=g.contents:g.identifiers.includes(s)&&u(g.contents);return u(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,i){this.k(s,i,!0)}setValue(s,i){this.k(s,i,!1)}removeValue(s){const i=this.keys.indexOf(s);i!==-1&&(this.keys.splice(i,1),(0,d.$_i)(this.contents,s),p.$uo.test(s)&&this.overrides.splice(this.overrides.findIndex(o=>n.$ub(o.identifiers,(0,p.$vo)(s))),1))}k(s,i,o){(0,d.$$i)(this.contents,s,i,u=>this.f.error(u)),o=o||this.keys.indexOf(s)===-1,o&&this.keys.push(s),p.$uo.test(s)&&this.overrides.push({identifiers:(0,p.$vo)(s),keys:Object.keys(this.contents[s]),contents:(0,d.$0i)(this.contents[s],u=>this.f.error(u))})}}e.$Ao=f;class y{constructor(s,i){this.f=s,this.g=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||f.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,i){if(!h.$hg(s)){const o=this.h(s);this.parseRaw(o,i)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,i){this.a=s;const{contents:o,keys:u,overrides:g,restricted:P,hasExcludedProperties:D}=this.i(s,i);this.b=new f(o,u,g,D?[s]:void 0,this.g),this.c=P||[]}h(s){let i={},o=null,u=[];const g=[],P=[];function D(O){Array.isArray(u)?u.push(O):o!==null&&(u[o]=O)}const I={onObjectBegin:()=>{const O={};D(O),g.push(u),u=O,o=null},onObjectProperty:O=>{o=O},onObjectEnd:()=>{u=g.pop()},onArrayBegin:()=>{const O=[];D(O),g.push(u),u=O,o=null},onArrayEnd:()=>{u=g.pop()},onLiteralValue:D,onError:(O,M,W)=>{P.push({error:O,offset:M,length:W})}};if(s)try{k.$Sn(s,I),i=u[0]||{}}catch(O){this.g.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return i}i(s,i){const o=v.$fo.as(p.$ko.Configuration).getConfigurationProperties(),u=this.j(s,o,!0,i);s=u.raw;const g=(0,d.$0i)(s,I=>this.g.error(`Conflict in settings file ${this.f}: ${I}`)),P=Object.keys(s),D=this.l(s,I=>this.g.error(`Conflict in settings file ${this.f}: ${I}`));return{contents:g,keys:P,overrides:D,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}j(s,i,o,u){let g=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:g};const P={},D=[];for(const I in s)if(p.$uo.test(I)&&o){const O=this.j(s[I],i,!1,u);P[I]=O.raw,g=g||O.hasExcludedProperties,D.push(...O.restricted)}else{const O=i[I],M=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&D.push(I),!u.exclude?.includes(I)&&(u.include?.includes(I)||(M===void 0||u.scopes===void 0||u.scopes.includes(M))&&!(u.skipRestricted&&O?.restricted))?P[I]=s[I]:g=!0}return{raw:P,restricted:D,hasExcludedProperties:g}}l(s,i){const o=[];for(const u of Object.keys(s))if(p.$uo.test(u)){const g={};for(const P in s[u])g[P]=s[u][P];o.push({identifiers:(0,p.$vo)(u),keys:Object.keys(g),contents:(0,d.$0i)(g,i)})}return o}}e.$Bo=y;class w extends R.$Uc{constructor(s,i,o,u,g){super(),this.c=s,this.f=i,this.g=u,this.h=g,this.b=this.B(new C.$fe),this.onDidChange=this.b.event,this.a=new y(this.c.toString(),g),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(C.Event.any(C.Event.filter(this.g.onDidFilesChange,P=>P.contains(this.c)),C.Event.filter(this.g.onDidRunOperation,P=>(P.isOperation(0)||P.isOperation(3)||P.isOperation(1)||P.isOperation(4))&&o.isEqual(P.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return f.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Co=w;class b{constructor(s,i,o,u,g,P,D,I,O,M,W,F,T){this.a=s,this.b=i,this.c=o,this.overrideIdentifiers=u,this.d=g,this.f=P,this.g=D,this.h=I,this.i=O,this.j=M,this.k=W,this.l=F,this.m=T}get value(){return $(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class c{constructor(s,i,o,u,g,P,D,I,O,M){this.j=s,this.l=i,this.m=o,this.n=u,this.p=g,this.q=P,this.r=D,this.s=I,this.t=O,this.u=M,this.h=null,this.i=new j.$Ac,this.v=null}getValue(s,i,o){return this.w(s,i,o).getValue(s)}updateValue(s,i,o={}){let u;o.resource?(u=this.t.get(o.resource),u||(u=f.createEmptyModel(this.u),this.t.set(o.resource,u))):u=this.s,i===void 0?u.removeValue(s):u.setValue(s,i),o.resource||(this.h=null)}inspect(s,i,o){const u=this.w(s,i,o),g=this.A(i.resource,o),P=i.resource?this.t.get(i.resource)||this.s:this.s,D=new Set;for(const I of u.overrides)for(const O of I.identifiers)u.getOverrideValue(s,O)!==void 0&&D.add(O);return new b(s,i,u.getValue(s),D.size?[...D]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,g||void 0,P)}keys(s){const i=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,i){this.r.set(s,i),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const o=[];if(!i){const{added:u,updated:g,removed:P}=a(this.j,s);i=[...u,...g,...P]}for(const u of i)for(const g of(0,p.$vo)(u)){const P=this.j.getKeysForOverrideIdentifier(g),D=s.getKeysForOverrideIdentifier(g),I=[...D.filter(O=>P.indexOf(O)===-1),...P.filter(O=>D.indexOf(O)===-1),...P.filter(O=>!E.$9n(this.j.override(g).getValue(O),s.override(g).getValue(O)))];o.push([g,I])}return this.updateDefaultConfiguration(s),{keys:i,overrides:o}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:o,removed:u}=a(this.l,s),g=[...i,...o,...u];return g.length&&this.updatePolicyConfiguration(s),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:o,removed:u,overrides:g}=a(this.applicationConfiguration,s),P=[...i,...o,...u];return P.length&&this.updateApplicationConfiguration(s),{keys:P,overrides:g}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:o,removed:u,overrides:g}=a(this.localUserConfiguration,s),P=[...i,...o,...u];return P.length&&this.updateLocalUserConfiguration(s),{keys:P,overrides:g}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:o,removed:u,overrides:g}=a(this.remoteUserConfiguration,s),P=[...i,...o,...u];return P.length&&this.updateRemoteUserConfiguration(s),{keys:P,overrides:g}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:o,removed:u,overrides:g}=a(this.workspaceConfiguration,s),P=[...i,...o,...u];return P.length&&this.updateWorkspaceConfiguration(s),{keys:P,overrides:g}}compareAndUpdateFolderConfiguration(s,i){const o=this.folderConfigurations.get(s),{added:u,updated:g,removed:P,overrides:D}=a(o,i),I=[...u,...g,...P];return(I.length||!o)&&this.updateFolderConfiguration(s,i),{keys:I,overrides:D}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:o,updated:u,removed:g,overrides:P}=a(i,void 0);return{keys:[...o,...u,...g],overrides:P}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,i,o){let u=this.x(i,o);return i.overrideIdentifier&&(u=u.override(i.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(u=u.merge(this.l)),u}x({resource:s},i){let o=this.y();if(i&&s){const u=i.getFolder(s);u&&(o=this.z(u.uri)||o);const g=this.t.get(s);g&&(o=o.merge(g))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let i=this.i.get(s);if(!i){const o=this.y(),u=this.r.get(s);u?(i=o.merge(u),this.i.set(s,i)):i=o}return i}A(s,i){if(i&&s){const o=i.getFolder(s);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,i)=>{const{contents:o,overrides:u,keys:g}=this.r.get(i);return s.push([i,{contents:o,overrides:u,keys:g}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(i=>s.add(i)),this.userConfiguration.keys.forEach(i=>s.add(i)),this.q.keys.forEach(i=>s.add(i)),this.r.forEach(i=>i.keys.forEach(o=>s.add(o))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.q.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.r.forEach(i=>i.getAllOverrideIdentifiers().forEach(o=>s.add(o))),[...s.values()]}D(s){const i=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this.q.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(s).forEach(u=>i.add(u))),[...i.values()]}static parse(s,i){const o=this.E(s.defaults,i),u=this.E(s.policy,i),g=this.E(s.application,i),P=this.E(s.user,i),D=this.E(s.workspace,i),I=s.folders.reduce((O,M)=>(O.set(l.URI.revive(M[0]),this.E(M[1],i)),O),new j.$Ac);return new c(o,u,g,P,f.createEmptyModel(i),D,I,f.createEmptyModel(i),new j.$Ac,i)}static E(s,i){return new f(s.contents,s.keys,s.overrides,void 0,i)}}e.$Do=c;function m(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const s=new Set,i=new Map;for(const u of r)u.keys.forEach(g=>s.add(g)),u.overrides.forEach(([g,P])=>{const D=(0,j.$xc)(i,g,new Set);P.forEach(I=>D.add(I))});const o=[];return i.forEach((u,g)=>o.push([g,[...u.values()]])),{keys:[...s.values()],overrides:o}}class S{constructor(s,i,o,u,g){this.change=s,this.f=i,this.g=o,this.h=u,this.i=g,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const P of s.keys)this.affectedKeys.add(P);for(const[,P]of s.overrides)for(const D of P)this.affectedKeys.add(D);this.d=this.a;for(const P of this.affectedKeys)this.d+=P+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=c.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,i){const o=this.a+s,u=this.d.indexOf(o);if(u<0)return!1;const g=u+o.length;if(g>=this.d.length)return!1;const P=this.d.charCodeAt(g);if(P!==this.b&&P!==this.c)return!1;if(i){const D=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.f?.workspace):void 0,I=this.g.getValue(s,i,this.h);return!E.$9n(D,I)}return!0}}e.$Fo=S;function a(r,s){const{added:i,removed:o,updated:u}=t(s?.rawConfiguration,r?.rawConfiguration),g=[],P=r?.getAllOverrideIdentifiers()||[],D=s?.getAllOverrideIdentifiers()||[];if(s){const I=D.filter(O=>!P.includes(O));for(const O of I)g.push([O,s.getKeysForOverrideIdentifier(O)])}if(r){const I=P.filter(O=>!D.includes(O));for(const O of I)g.push([O,r.getKeysForOverrideIdentifier(O)])}if(s&&r){for(const I of P)if(D.includes(I)){const O=t({contents:r.getOverrideValue(void 0,I)||{},keys:r.getKeysForOverrideIdentifier(I)},{contents:s.getOverrideValue(void 0,I)||{},keys:s.getKeysForOverrideIdentifier(I)});g.push([I,[...O.added,...O.removed,...O.updated]])}}return{added:i,removed:o,updated:u,overrides:g}}function t(r,s){const i=r?s?r.keys.filter(g=>s.keys.indexOf(g)===-1):[...r.keys]:[],o=s?r?s.keys.filter(g=>r.keys.indexOf(g)===-1):[...s.keys]:[],u=[];if(r&&s){for(const g of s.keys)if(r.keys.indexOf(g)!==-1){const P=(0,d.$aj)(s.contents,g),D=(0,d.$aj)(r.contents,g);E.$9n(P,D)||u.push(g)}}return{added:i,removed:o,updated:u}}}),define(se[241],re([0,1,22,3,2,35,12,123,52,5,39,45]),function(K,e,n,C,k,R,j,E,h,l,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=void 0;class v extends k.$Uc{get configurationModel(){return this.b}constructor(w){super(),this.c=w,this.a=this.B(new C.$fe),this.onDidChangeConfiguration=this.a.event,this.b=E.$Ao.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(p.$fo.as(h.$ko.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:b})=>this.f(Array.from(w),b))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(w,b){this.j(w,p.$fo.as(h.$ko.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}g(){return{}}h(){this.b=E.$Ao.createEmptyModel(this.c);const w=p.$fo.as(h.$ko.Configuration).getConfigurationProperties();this.j(Object.keys(w),w)}j(w,b){const c=this.g();for(const m of w){const S=c[m],a=b[m];S!==void 0?this.b.addValue(m,S):a?this.b.addValue(m,a.default):this.b.removeValue(m)}}}e.$Go=v;class ${constructor(){this.onDidChangeConfiguration=C.Event.None,this.configurationModel=E.$Ao.createEmptyModel(new l.$fk)}async initialize(){return this.configurationModel}}e.$Ho=$;let f=class extends k.$Uc{get configurationModel(){return this.b}constructor(w,b,c){super(),this.c=w,this.f=b,this.g=c,this.a=this.B(new C.$fe),this.onDidChangeConfiguration=this.a.event,this.b=E.$Ao.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const b={},c=[],m=p.$fo.as(h.$ko.Configuration).getConfigurationProperties();for(const S of w){const a=m[S];if(!a){c.push(S);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.g.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}c.push(S),b[a.policy.name]={type:a.type}}}return(0,j.$lg)(b)||await this.f.updatePolicyDefinitions(b),c}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const b=p.$fo.as(h.$ko.Configuration).getPolicyConfigurations(),c=(0,n.$Hb)(w.map(m=>b.get(m)));this.m(c,!0)}m(w,b){this.g.trace("PolicyConfiguration#update",w);const c=p.$fo.as(h.$ko.Configuration).getConfigurationProperties(),m=[],S=this.b.isEmpty();for(const a of w){const t=c[a]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(S?r!==void 0:!(0,R.$9n)(this.b.getValue(a),r))&&m.push([a,r])}else this.b.getValue(a)!==void 0&&m.push([a,void 0])}if(m.length){this.g.trace("PolicyConfiguration#changed",m);const a=this.b;this.b=E.$Ao.createEmptyModel(this.g);for(const t of a.keys)this.b.setValue(t,a.getValue(t));for(const[t,r]of m)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);b&&this.a.fire(this.b)}}};e.$Io=f,e.$Io=f=Ee([ie(1,d.$ho),ie(2,l.$5j)],f)}),define(se[242],re([0,1,22,8,17,3,42,103,2,32,35,4,19,18,123,52,241,39]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=void 0;class c extends h.$Uc{constructor(a,t,r,s){super(),this.m=a,this.n=s,this.h=this.B(new R.$fe),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new w.$Go(s)),this.c=r instanceof b.$jo?new w.$Ho:this.B(new w.$Io(this.b,r,s)),this.f=this.B(new f.$Co(this.m,{},v.$3g,t,s)),this.a=new f.$Do(this.b.configurationModel,this.c.configurationModel,f.$Ao.createEmptyModel(s),f.$Ao.createEmptyModel(s),f.$Ao.createEmptyModel(s),f.$Ao.createEmptyModel(s),new l.$Ac,f.$Ao.createEmptyModel(s),new l.$Ac,s),this.j=new m(a,t,this),this.g=this.B(new C.$Kh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:i,properties:o})=>this.s(i,o))),this.B(this.c.onDidChangeConfiguration(i=>this.t(i))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[a,t,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new f.$Do(a,t,f.$Ao.createEmptyModel(this.n),r,f.$Ao.createEmptyModel(this.n),f.$Ao.createEmptyModel(this.n),new l.$Ac,f.$Ao.createEmptyModel(this.n),new l.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(a,t){const r=typeof a=="string"?a:void 0,s=(0,$.$6i)(a)?a:(0,$.$6i)(t)?t:{};return this.a.getValue(r,s,void 0)}async updateValue(a,t,r,s,i){const o=(0,$.$7i)(r)?r:(0,$.$6i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,u=o?s:r;if(u!==void 0&&u!==3&&u!==2)throw new Error(`Unable to write ${a} to target ${u}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,n.$Mb)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const g=this.inspect(a,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(g.policyValue!==void 0)throw new Error(`Unable to write ${a} because it is configured in system policy.`);if((0,d.$9n)(t,g.defaultValue)&&(t=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const D=o.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(O=>(0,n.$ub)([...O.identifiers].sort(),D));I&&(o.overrideIdentifiers=I.identifiers)}const P=o?.overrideIdentifiers?.length?[(0,y.$wo)(o.overrideIdentifiers),a]:[a];await this.j.write(P,t),await this.reloadConfiguration()}inspect(a,t={}){return this.a.inspect(a,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const a=await this.f.loadConfiguration();this.r(a)}r(a){const t=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(a);this.u(r,t,2)}s(a,t){const r=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(a,t);this.u(s,r,7)}t(a){const t=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(a);this.u(r,t,7)}u(a,t,r){const s=new f.$Fo(a,{data:t},this.a,void 0,this.n);s.source=r,this.h.fire(s)}}e.$Jo=c;class m{constructor(a,t,r){this.b=a,this.c=t,this.d=r,this.a=new C.$Fh}write(a,t){return this.a.queue(()=>this.e(a,t))}async e(a,t){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===1)r="{}";else throw o}const s=[];if((0,j.$Ln)(r,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const i=this.f(r,a,t);r=(0,E.$4n)(r,i),await this.c.writeFile(this.b,k.$He.fromString(r))}f(a,t,r){const{tabSize:s,insertSpaces:i,eol:o}=this.h;if(!t.length){const u=JSON.stringify(r,null,i?" ".repeat(s):"	");return[{content:u,length:u.length,offset:0}]}return(0,E.$1n)(a,t,r,{tabSize:s,insertSpaces:i,eol:o})}get h(){if(!this.g){let a=p.OS===3||p.OS===2?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(a=t),this.g={eol:a,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(se[243],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=e.$gec=e.$fec=void 0,e.$fec="request",e.$gec="remoteResourceHandler";class n{async routeCall(k,R,j){if(R!==e.$fec)throw new Error(`Call not found: ${R}`);const E=j[0];if(E?.authority){const h=k.connections.find(l=>l.ctx===E.authority);if(h)return h}throw new Error("Caller not found")}routeEvent(k,R){throw new Error(`Event not found: ${R}`)}}e.$hec=n}),define(se[244],re([0,1,15,6]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.RemoteAuthorityResolverErrorCode=e.$Ll=e.$Kl=e.RemoteConnectionType=e.$Jl=void 0,e.$Nl=l,e.$Jl=(0,C.$yi)("remoteAuthorityResolverService");var k;(function(d){d[d.WebSocket=0]="WebSocket",d[d.Managed=1]="Managed"})(k||(e.RemoteConnectionType=k={}));class R{constructor(p){this.id=p,this.type=1}toString(){return`Managed(${this.id})`}}e.$Kl=R;class j{constructor(p,v){this.host=p,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ll=j;var E;(function(d){d.Unknown="Unknown",d.NotAvailable="NotAvailable",d.TemporarilyNotAvailable="TemporarilyNotAvailable",d.NoResolverFound="NoResolverFound",d.InvalidAuthority="InvalidAuthority"})(E||(e.RemoteAuthorityResolverErrorCode=E={}));class h extends n.$bb{static isNotAvailable(p){return p instanceof h&&p._code===E.NotAvailable}static isTemporarilyNotAvailable(p){return p instanceof h&&p._code===E.TemporarilyNotAvailable}static isNoResolverFound(p){return p instanceof h&&p._code===E.NoResolverFound}static isInvalidAuthority(p){return p instanceof h&&p._code===E.InvalidAuthority}static isHandled(p){return p instanceof h&&p.isHandled}constructor(p,v=E.Unknown,$){super(p),this._message=p,this._code=v,this._detail=$,this.isHandled=v===E.NotAvailable&&$===!0,Object.setPrototypeOf(this,h.prototype)}}e.$Ml=h;function l(d){const p=d.indexOf("+");return p===-1?d:d.substring(0,p)}}),define(se[245],re([0,1,8,17,23,15,3,2,13,66,73,33,113,244]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Sl=P,e.$Tl=D,e.$Ul=O;const f=30*1e3;var y;(function(Q){Q[Q.Management=1]="Management",Q[Q.ExtensionHost=2]="ExtensionHost",Q[Q.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function w(Q){switch(Q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function b(Q){const A=new k.$qe;return setTimeout(()=>A.cancel(),Q),A.token}function c(Q,A){if(Q.isCancellationRequested||A.isCancellationRequested)return k.CancellationToken.Cancelled;const N=new k.$qe;return Q.onCancellationRequested(()=>N.cancel()),A.onCancellationRequested(()=>N.cancel()),N.token}class m{get didTimeout(){return this.c==="timedout"}constructor(A){this.c="pending",this.d=new E.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$rh)(),A.isCancellationRequested?this.h():this.d.add(A.onCancellationRequested(()=>this.h()))}registerDisposable(A){this.c==="pending"?this.d.add(A):A.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(A))}reject(A){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(A))}}function S(Q,A){const N=new m(A);return N.registerDisposable(Q.onControlMessage(_=>{const z=JSON.parse(_.toString()),Y=L(z);Y?N.reject(Y):N.resolve(z)})),N.promise}function a(Q,A,N,_,z,Y,x,ee){const X=new m(ee),ue=d.$be.create(!1);return Q.info(`Creating a socket (${x})...`),l.mark(`code/willCreateSocket/${Y}`),A.connect(N,_,z,x).then(he=>{X.didTimeout?(l.mark(`code/didCreateSocketError/${Y}`),Q.info(`Creating a socket (${x}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(l.mark(`code/didCreateSocketOK/${Y}`),Q.info(`Creating a socket (${x}) was successful after ${ue.elapsed()} ms.`),X.resolve(he))},he=>{l.mark(`code/didCreateSocketError/${Y}`),Q.info(`Creating a socket (${x}) returned an error after ${ue.elapsed()} ms.`),Q.error(he),X.reject(he)}),X.promise}function t(Q,A){const N=new m(A);return Q.then(_=>{N.didTimeout||N.resolve(_)},_=>{N.didTimeout||N.reject(_)}),N.promise}async function r(Q,A,N,_){const z=G(Q,A);Q.logService.trace(`${z} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await a(Q.logService,Q.remoteSocketFactoryService,Q.connectTo,h.$Lg.getServerRootPath(),`reconnectionToken=${Q.reconnectionToken}&reconnection=${Q.reconnectionProtocol?"true":"false"}`,w(A),`renderer-${w(A)}-${Q.reconnectionToken}`,_)}catch(he){throw Q.logService.error(`${z} socketFactory.connect() failed or timed out. Error:`),Q.logService.error(he),he}Q.logService.trace(`${z} 2/6. socketFactory.connect() was successful.`);let x,ee;Q.reconnectionProtocol?(Q.reconnectionProtocol.beginAcceptReconnection(Y,null),x=Q.reconnectionProtocol,ee=!1):(x=new v.$mi({socket:Y}),ee=!0),Q.logService.trace(`${z} 3/6. sending AuthRequest control message.`);const X=await t(Q.signService.createNewMessage((0,p.$Ug)()),_),ue={type:"auth",auth:Q.connectionToken||"00000000000000000000",data:X.data};x.sendControl(C.$He.fromString(JSON.stringify(ue)));try{const he=await S(x,c(_,b(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(Q.logService.trace(`${z} 4/6. received SignRequest control message.`),!await t(Q.signService.validate(X,he.signedData),_)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const $e=await t(Q.signService.sign(he.data),_),ye={type:"connectionType",commit:Q.commit,signedData:$e,desiredConnectionType:A};return N&&(ye.args=N),Q.logService.trace(`${z} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(C.$He.fromString(JSON.stringify(ye))),{protocol:x,ownsProtocol:ee}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(Q.logService.error(`${z} the handshake timed out. Error:`),Q.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(Q.logService.error(`${z} received error control message when negotiating connection. Error:`),Q.logService.error(he)),ee&&q(x),he}}async function s(Q,A,N,_){const z=Date.now(),Y=G(Q,A),{protocol:x,ownsProtocol:ee}=await r(Q,A,N,_),X=new m(_);return X.registerDisposable(x.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),pe=L(he);pe?(Q.logService.error(`${Y} received error control message when negotiating connection. Error:`),Q.logService.error(pe),ee&&q(x),X.reject(pe)):(Q.reconnectionProtocol?.endAcceptReconnection(),Q.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${le(z)}!`),X.resolve({protocol:x,firstMessage:he}))})),X.promise}async function i(Q,A){const{protocol:N}=await s(Q,1,void 0,A);return{protocol:N}}async function o(Q,A,N){const{protocol:_,firstMessage:z}=await s(Q,2,A,N),Y=z&&z.debugPort;return{protocol:_,debugPort:Y}}async function u(Q,A,N){const _=Date.now(),z=G(Q,3),{protocol:Y}=await r(Q,3,A,N);return Q.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${le(_)}!`),Y}async function g(Q,A,N){const{connectTo:_,connectionToken:z}=await Q.addressProvider.getAddress();return{commit:Q.commit,quality:Q.quality,connectTo:_,connectionToken:z,reconnectionToken:A,reconnectionProtocol:N,remoteSocketFactoryService:Q.remoteSocketFactoryService,signService:Q.signService,logService:Q.logService}}async function P(Q,A,N){return I(Q,async _=>{const{protocol:z}=await i(_,k.CancellationToken.None);return new J(Q,A,N,_.reconnectionToken,z)})}async function D(Q,A){return I(Q,async N=>{const{protocol:_,debugPort:z}=await o(N,A,k.CancellationToken.None);return new V(Q,A,N.reconnectionToken,_,z)})}async function I(Q,A){for(let _=1;;_++)try{const z=(0,p.$Ug)(),Y=await g(Q,z,null);return await A(Y)}catch(z){if(_<5)Q.logService.error(`[remote-connection][attempt ${_}] An error occurred in initial connection! Will retry... Error:`),Q.logService.error(z);else throw Q.logService.error(`[remote-connection][attempt ${_}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),Q.logService.error(z),ce.triggerPermanentFailure(0,0,$.$Ml.isHandled(z)),z}}async function O(Q,A,N){const _=await g(Q,(0,p.$Ug)(),null);return await u(_,{host:A,port:N},k.CancellationToken.None)}function M(Q){return(0,n.$lh)(A=>new Promise((N,_)=>{const z=setTimeout(N,Q*1e3);A.onCancellationRequested(()=>{clearTimeout(z),N()})}))}var W;(function(Q){Q[Q.ConnectionLost=0]="ConnectionLost",Q[Q.ReconnectionWait=1]="ReconnectionWait",Q[Q.ReconnectionRunning=2]="ReconnectionRunning",Q[Q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",Q[Q.ConnectionGain=4]="ConnectionGain"})(W||(e.PersistentConnectionEventType=W={}));class F{constructor(A,N){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.type=0}}e.$Vl=F;class T{constructor(A,N,_,z){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.durationSeconds=_,this.c=z,this.type=1}skipWait(){this.c.cancel()}}e.$Wl=T;class U{constructor(A,N,_){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=_,this.type=2}}e.$Xl=U;class ae{constructor(A,N,_){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=_,this.type=4}}e.$Yl=ae;class te{constructor(A,N,_,z){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=_,this.handled=z,this.type=3}}e.$Zl=te;class ce extends E.$Uc{static triggerPermanentFailure(A,N,_){this._permanentFailure=!0,this.f=A,this.g=N,this.h=_,this.j.forEach(z=>z.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(A=>A.y())}static debugPauseSocketWriting(){this.j.forEach(A=>A.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ce._permanentFailure}constructor(A,N,_,z,Y){super(),this.t=A,this.u=N,this.reconnectionToken=_,this.protocol=z,this.w=Y,this.m=this.B(new j.$fe),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ae(this.reconnectionToken,0,0)),this.B(z.onSocketClose(x=>{const ee=oe(this.t,this.reconnectionToken,!0);x?x.type===0?(this.u.logService.info(`${ee} received socket close event (hadError: ${x.hadError}).`),x.error&&this.u.logService.error(x.error)):(this.u.logService.info(`${ee} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this.u.logService.error(x.event)):this.u.logService.info(`${ee} received socket close event.`),this.y()})),this.B(z.onSocketTimeout(x=>{const ee=oe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ee} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this.y()})),ce.j.push(this),this.B((0,E.$Sc)(()=>{const x=ce.j.indexOf(this);x>=0&&ce.j.splice(x,1)})),this.n&&this.D(ce.f,ce.g,ce.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const A=oe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const z=_<N.length?N[_]:N[N.length-1];try{if(z>0){const x=M(z);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z,x)),this.u.logService.info(`${A} waiting for ${z} seconds before reconnecting...`);try{await x}catch{}}if(this.n){this.u.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this.u.logService.info(`${A} resolving connection...`);const Y=await g(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${A} connecting to ${Y.connectTo}...`),await this.G(Y,b(f)),this.u.logService.info(`${A} reconnected!`),this.m.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(Y){if(Y.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this.u.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if($.$Ml.isTemporarilyNotAvailable(Y)){this.u.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((Y.code==="ETIMEDOUT"||Y.code==="ENETUNREACH"||Y.code==="ECONNREFUSED"||Y.code==="ECONNRESET")&&Y.syscall==="connect"){this.u.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((0,R.$4)(Y)){this.u.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if(Y instanceof $.$Ml){this.u.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,$.$Ml.isHandled(Y));break}this.u.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!this.n&&!this.s)}C(A,N,_){this.w?ce.triggerPermanentFailure(A,N,_):this.D(A,N,_)}D(A,N,_){this.m.fire(new te(this.reconnectionToken,A,N,_)),q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$1l=ce;class J extends ce{constructor(A,N,_,z,Y){super(1,A,z,Y,!0),this.client=this.B(new v.$ki(Y,{remoteAuthority:N,clientId:_},A.ipcLogger))}async G(A,N){await i(A,N)}}e.$2l=J;class V extends ce{constructor(A,N,_,z,Y){super(2,A,_,z,!1),this.H=N,this.debugPort=Y}async G(A,N){await o(A,this.H,N)}}e.$3l=V;function q(Q){try{Q.acceptDisconnect();const A=Q.getSocket();Q.dispose(),A.dispose()}catch(A){(0,R.$1)(A)}}function L(Q){if(Q&&Q.type==="error"){const A=new Error(`Connection error: ${Q.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function B(Q,A){for(;Q.length<A;)Q+=" ";return Q}function H(Q,A){return`[remote-connection][${B(w(Q),13)}][${A.substr(0,5)}\u2026]`}function oe(Q,A,N){return`${H(Q,A)}[${N?"reconnect":"initial"}]`}function G(Q,A){return`${oe(A,Q.reconnectionToken,!!Q.reconnectionProtocol)}[${Q.connectTo}]`}function le(Q){return`${Date.now()-Q} ms`}}),define(se[68],re([0,1,13]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=C,e.$Km=k,e.$Lm=R,e.$Mm=j;function C(h){return h.scheme===n.Schemas.vscodeRemote?h.authority:void 0}function k(h){if(!h)return;const l=h.indexOf("+");return l<0?h:h.substr(0,l)}function R(h){const{host:l,port:d}=E(h);if(typeof d>"u")throw new Error(`Invalid remote authority: ${h}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:d}}function j(h,l){let{host:d,port:p}=E(h);return typeof p>"u"&&(p=l),{host:d,port:p}}function E(h){const l=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const d=h.match(/^(\[[0-9a-z:]+\])$/);if(d)return{host:d[1],port:void 0};const p=h.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:h,port:void 0}}}),define(se[124],re([0,1,25,6,68]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Vm=e.$Um=e.$Tm=e.TargetPlatform=e.ExtensionType=e.$Sm=e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0,e.$Rm=R,e.$Wm=p,e.$Xm=v,e.$Ym=$,e.$Zm=f,e.$Nm="extensions.user.cache",e.$Om="extensions.builtin.cache",e.$Pm="undefined_publisher",e.$Qm=["ui","workspace","web"];function R(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$Sm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var j;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(j||(e.ExtensionType=j={}));var E;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class h{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,b){if(typeof w>"u"||w===null)return typeof b>"u"||b===null;if(typeof b>"u"||b===null)return!1;if(typeof w=="string"||typeof b=="string"){const c=typeof w=="string"?w:w.value,m=typeof b=="string"?b:b.value;return n.$zf(c,m)}return w._lower===b._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$Tm=h;class l{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const b of w)this.add(b)}add(w){this.c.add(h.toKey(w))}delete(w){return this.c.delete(h.toKey(w))}has(w){return this.c.has(h.toKey(w))}}e.$Um=l;class d{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(h.toKey(w))}get(w){return this.c.get(h.toKey(w))}has(w){return this.c.has(h.toKey(w))}set(w,b){this.c.set(h.toKey(w),b)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vm=d;function p(y){return v(y)}function v(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}function $(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}function f(y,w){if(w){const b=`onResolveRemoteAuthority:${(0,k.$Km)(w)}`;return!!y.activationEvents?.includes(b)}return!1}e.$1m=(0,C.$yi)("IBuiltinExtensionsScannerService")}),define(se[246],re([0,1,2,6]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=void 0,e.$Ol=(0,C.$yi)("remoteSocketFactoryService");class k{constructor(){this.a={}}register(j,E){return this.a[j]??=[],this.a[j].push(E),(0,n.$Sc)(()=>{const h=this.a[j]?.indexOf(E);typeof h=="number"&&h>=0&&this.a[j]?.splice(h,1)})}b(j){return(this.a[j.type]||[]).find(h=>h.supports(j))}connect(j,E,h,l){const d=this.b(j);if(!d)throw new Error(`No socket factory found for ${j}`);return d.connect(j,E,h,l)}}e.$Pl=k}),define(se[247],re([0,1,26,49,21,117]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=E;let j;async function E($=!1){return(j===void 0||$)&&(j=h()),j}async function h(){const $=l();if($===void 0)return!1;if($>=22e3){const f=p();if(f)return new Promise(y=>{C.execFile(f,["--status"],w=>y(!w))})}else{const f=v();if(f)try{if((await k.Promises.stat(f)).isFile())return!0}catch{}}return!1}function l(){const $=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());if($)return parseInt($[3])}function d($){const f=process.env.SystemRoot;if(f){const y=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(f,y?"Sysnative":"System32",$)}}function p(){return d("wsl.exe")}function v(){return d("lxss\\LxssManager.dll")}}),define(se[53],re([0,1,17,15,2,186,52,6,5,45]),function(K,e,n,C,k,R,j,E,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0,e.$Sp=v,e.$Tp=$,e.$Up=f,e.$Vp=y,e.$Wp=w,e.$Xp=b,e.$Qp=(0,E.$yi)("requestService");class d{constructor(a){this.b=a}toJSON(){if(!this.a){const a=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.b[t];this.a=a}return this.a}}class p extends k.$Uc{constructor(a){super(),this.b=0,this.a=a.createLogger("network",{name:(0,R.localize)(0,null),when:h.$kk.isEqualTo((0,h.$hk)(h.LogLevel.Trace)).serialize()})}async c(a,t,r){const s=`${a} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new d(t.headers??{}));try{const i=await r();return this.a.trace(`${s} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${s} - error`,t.type,(0,C.$0)(i)),i}}}e.$Rp=p;function v(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}function $(S){return S.res.statusCode===204}async function f(S){return $(S)?null:(await(0,n.$Te)(S.stream)).toString()}async function y(S){if(!v(S))throw new Error("Server returned "+S.res.statusCode);return f(S)}async function w(S){if(!v(S))throw new Error("Server returned "+S.res.statusCode);if($(S))return null;const t=(await(0,n.$Te)(S.stream)).toString();try{return JSON.parse(t)}catch(r){throw r.message+=`:
`+t,r}}function b(S){m(S)}let c;function m(S){const a=l.$fo.as(j.$ko.Configuration),t=c;c={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[c],remove:t?[t]:[]})}m(1)}),define(se[248],re([0,1,17,23]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=e.$Xr=void 0;class k{constructor(E){this.a=E}listen(E,h){throw new Error("Invalid listen")}call(E,h,l,d=C.CancellationToken.None){switch(h){case"request":return this.a.request(l[0],d).then(async({res:p,stream:v})=>{const $=await(0,n.$Te)(v);return[{statusCode:p.statusCode,headers:p.headers},$]});case"resolveProxy":return this.a.resolveProxy(l[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Xr=k;class R{constructor(E){this.a=E}async request(E,h){const[l,d]=await this.a.call("request",[E],h);return{res:l,stream:(0,n.$Ve)(d)}}async resolveProxy(E){return this.a.call("resolveProxy",[E])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Yr=R}),define(se[249],re([0,1,250,12]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=R;function k(j,E){return j.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:j.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function R(j,E,h={}){const l=(0,n.parse)(j),d=h.proxyUrl||k(l,E);if(!d)return null;const p=(0,n.parse)(d);if(!/^https?:$/.test(p.protocol||""))return null;const v={host:p.hostname||"",port:(p.port?+p.port:0)||(p.protocol==="https"?443:80),auth:p.auth,rejectUnauthorized:(0,C.$eg)(h.strictSSL)?h.strictSSL:!0};return l.protocol==="http:"?new(await new Promise(($,f)=>{K(["http-proxy-agent"],$,f)})).HttpProxyAgent(d,v):new(await new Promise(($,f)=>{K(["https-proxy-agent"],$,f)})).HttpsProxyAgent(d,v)}}),define(se[251],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=e.$Cdc=e.$Bdc=void 0,e.$Bdc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Cdc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Ddc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(se[95],re([0,1,49,9,187,23,47,15,4,33,112,64,8,141]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=y;let f;async function y(b,c,m,S){return m["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,p.$Cm)(S)&&!m["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,p.$Cm)(S)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=v.Promises.withAsyncBody(async(a,t)=>{const r=new R.$qe;let s=1e4;const i=b.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(s=(0,$.$Dm)(i,1,120)*1e3);const o=setTimeout(()=>{r.dispose(!0),t(new Error((0,k.localize)(0,null)))},s);try{a(await w(c,r.token))}catch(u){!(0,E.$4)(u)&&!r.token.isCancellationRequested?t(new Error((0,k.localize)(1,null,(0,j.$jj)(u)))):a({})}finally{clearTimeout(o),r.dispose()}})),f)}async function w(b,c){const m=process.env.ELECTRON_RUN_AS_NODE;b.trace("getUnixShellEnvironment#runAsNode",m);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;b.trace("getUnixShellEnvironment#noAttach",S);const a=(0,l.$Ug)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};b.trace("getUnixShellEnvironment#env",r);const s=await(0,d.$sm)(h.OS,r);return b.trace("getUnixShellEnvironment#shell",s),new Promise((i,o)=>{if(c.isCancellationRequested)return o(new E.$5);const u=(0,C.$nc)(s);let g,P;const D="";/^pwsh(-preview)?$/.test(u)?(g=`& '${process.execPath}' ${D} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,P=["-Login","-Command"]):u==="nu"?(g=`^'${process.execPath}' ${D} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,P=["-i","-l","-c"]):u==="xonsh"?(g=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,P=["-i","-l","-c"]):(g=`'${process.execPath}' ${D} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,u==="tcsh"||u==="csh"?P=["-ic"]:P=["-i","-l","-c"]),b.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),g);const I=(0,n.spawn)(s,[...P,g],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});c.onCancellationRequested(()=>(I.kill(),o(new E.$5))),I.on("error",W=>{b.error("getUnixShellEnvironment#errorChildProcess",(0,j.$jj)(W)),o(W)});const O=[];I.stdout.on("data",W=>O.push(W));const M=[];I.stderr.on("data",W=>M.push(W)),I.on("close",(W,F)=>{const T=Buffer.concat(O).toString("utf8");b.trace("getUnixShellEnvironment#raw",T);const U=Buffer.concat(M).toString("utf8");if(U.trim()&&b.trace("getUnixShellEnvironment#stderr",U),W||F)return o(new Error((0,k.localize)(2,null,W,F)));const ae=t.exec(T),te=ae?ae[1]:"{}";try{const ce=JSON.parse(te);m?ce.ELECTRON_RUN_AS_NODE=m:delete ce.ELECTRON_RUN_AS_NODE,S?ce.ELECTRON_NO_ATTACH_CONSOLE=S:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,b.trace("getUnixShellEnvironment#result",ce),i(ce)}catch(ce){b.error("getUnixShellEnvironment#errorCaught",(0,j.$jj)(ce)),o(ce)}})})}}),define(se[252],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v_b=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(k){try{const R=await this.c();if(R){const j=String(n.a++);return this.b.set(j,R),{id:j,data:R.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const j=this.b.get(k.id);if(!j)return!1;this.b.delete(k.id);try{return j.validate(R)==="ok"}catch{return!1}finally{j.dispose?.()}}async sign(k){try{return await this.d(k)}catch{}return k}}e.$v_b=n}),define(se[96],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=void 0,e.$Ql="signService",e.$Rl=(0,n.$yi)(e.$Ql)}),define(se[253],re([0,1,252]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=void 0;class C extends n.$v_b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(j=>new j.signer().sign(R))}h(){return new Promise((R,j)=>K(["vsda"],R,j))}}e.$rec=C}),define(se[34],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=e.$4P=void 0,e.$4P=(0,n.$yi)("stateReadService"),e.$5P=(0,n.$yi)("stateService")}),define(se[125],re([0,1,8,17,2,12,38,16,5]),function(K,e,n,C,k,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8P=e.$7P=e.$6P=e.SaveStrategy=void 0;var l;(function($){$[$.IMMEDIATE=0]="IMMEDIATE",$[$.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class d extends k.$Uc{constructor(f,y,w,b){super(),this.h=f,this.j=y,this.m=w,this.n=b,this.a=Object.create(null),this.b="",this.c=this.B(new n.$wh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(f){f.fileOperationResult!==1&&this.m.error(f)}}getItem(f,y){const w=this.a[f];return(0,R.$hg)(w)?y:w}setItem(f,y){this.setItems([{key:f,data:y}])}setItems(f){let y=!1;for(const{key:w,data:b}of f)this.a[w]!==b&&((0,R.$hg)(b)?(0,R.$fg)(this.a[w])||(this.a[w]=void 0,y=!0):(this.a[w]=b,y=!0));y&&this.s()}removeItem(f){(0,R.$fg)(this.a[f])||(this.a[f]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const f=JSON.stringify(this.a,null,4);if(f!==this.b)try{await this.n.writeFile(this.h,C.$He.fromString(f),{atomic:{postfix:".vsctmp"}}),this.b=f}catch(y){this.m.error(y)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$6P=d;let p=class extends k.$Uc{constructor(f,y,w,b){super(),this.a=this.B(new d(y.stateResource,f,w,b))}async init(){await this.a.init()}getItem(f,y){return this.a.getItem(f,y)}};e.$7P=p,e.$7P=p=Ee([ie(1,j.$Fi),ie(2,h.$5j),ie(3,E.$5k)],p);class v extends p{setItem(f,y){this.a.setItem(f,y)}setItems(f){this.a.setItems(f)}removeItem(f){this.a.removeItem(f)}close(){return this.a.close()}}e.$8P=v}),define(se[126],re([0,1,4,36,33]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=j,e.$hp=E;function R(h){if(n.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function j(h,l,d,p,v,$,f,y,w){const b=Object.create(null);b["common.machineId"]=$,b["common.sqmId"]=f,b.sessionID=(0,k.$Ug)()+Date.now(),b.commitHash=p,b.version=v,b["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,n.$h)(n.$u),b["common.nodePlatform"]=C.$dc,b["common.nodeArch"]=d,b["common.product"]=w||"desktop",y&&(b["common.msftInternal"]=y);let c=0;const m=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),n.$l&&(b["common.snap"]="true");const S=R(l);return S&&(b["common.platformDetail"]=S),b}function E(h){const l=C.env.USERDNSDOMAIN;if(!l)return!1;const d=l.toLowerCase();return h.some(p=>d===p)}}),define(se[28],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=void 0,e.$4l=(0,n.$yi)("telemetryService"),e.$5l=(0,n.$yi)("customEndpointTelemetryService"),e.$6l="telemetry.currentSessionDate",e.$7l="telemetry.firstSessionDate",e.$8l="telemetry.lastSessionDate",e.$9l="telemetry.machineId",e.$0l="telemetry.sqmId",e.$$l="telemetry",e.$_l="telemetry.telemetryLevel",e.$am="telemetry.enableCrashReporter",e.$bm="telemetry.enableTelemetry";var C;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(se[254],re([0,1,26,8,42,13,9,4,7,89,21,111,92,16,27,28]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=void 0,e.$Hs=b,e.$Is=m,e.$Js=S;const w=new Map;async function b(t,r){const s=`${t}::${r.join(":")}`,i=w.get(s);if(i)return i;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,g=new Map,P=2e4;function D(O,M,W,F){const T=M.substring(O.length+1);return C.Promises.withAsyncBody(async U=>{let ae;try{ae=await d.Promises.readdir(M,{withFileTypes:!0})}catch{U();return}if(F.count>=P){F.count+=ae.length,F.maxReached=!0,U();return}let te=ae.length;if(te===0){U();return}let ce=ae;F.count+ae.length>P&&(F.maxReached=!0,te=P-F.count,ce=ae.slice(0,te)),F.count+=ae.length;for(const J of ce)if(J.isDirectory()){if(W.includes(J.name)||await D(O,(0,j.$jc)(M,J.name),W,F),--te===0){U();return}}else{const V=J.name.lastIndexOf(".");if(V>=0){const q=J.name.substring(V+1);q&&u.set(q,(u.get(q)??0)+1)}for(const q of o)q.relativePathPattern?.test(T)!==!1&&q.filePattern.test(J.name)&&g.set(q.tag,(g.get(q.tag)??0)+1);if(--te===0){U();return}}})}const I=C.Promises.withAsyncBody(async O=>{const M={count:0,maxReached:!1};await D(t,t,r,M);const W=await S(t);O({configFiles:c(g),fileTypes:c(u),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:W})});return w.set(s,I),I}function c(t){return Array.from(t.entries(),([r,s])=>({name:r,count:s})).sort((r,s)=>s.count-r.count)}function m(){const t={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/$.$Al.GB).toFixed(2)}GB (${(n.freemem()/$.$Al.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.$Gn.value()*100)}%`},r=n.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}async function S(t){try{const r=new Map,s=(0,j.$jc)(t,".vscode","launch.json"),i=await d.Promises.readFile(s),o=[],u=(0,k.$Ln)(i.toString(),o);if(o.length)return console.log(`Unable to parse ${s}`),[];if((0,k.$Un)(u)==="object"&&u.configurations)for(const g of u.configurations){const P=g.type;P&&(r.has(P)?r.set(P,r.get(P)+1):r.set(P,1))}return c(r)}catch{return[]}}let a=class{constructor(r,s){this.c=r,this.d=s}f(r){const s=[];return s.push(`OS Version:       ${r.os}`),s.push(`CPUs:             ${r.cpus}`),s.push(`Memory (System):  ${r.memory}`),s.push(`VM:               ${r.vmHint}`),s.join(`
`)}g(r){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const i=n.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(n.totalmem()/$.$Al.GB).toFixed(2)}GB (${(n.freemem()/$.$Al.GB).toFixed(2)}GB free)`),E.$i||s.push(`Load (avg):       ${n.loadavg().map(o=>Math.round(o)).join(", ")}`),s.push(`VM:               ${Math.round(l.$Gn.value()*100)}%`),s.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${r.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(r,s){return Promise.all([(0,p.$Gs)(r.mainPID),this.k(r)]).then(async i=>{let[o,u]=i,g=this.m(r,o);return s.forEach(P=>{if((0,v.$gn)(P))g+=`
${P.errorMessage}`,u+=`
${P.errorMessage}`;else if(g+=`

Remote: ${P.hostName}`,P.processes&&(g+=`
${this.m(r,P.processes)}`),P.workspaceMetadata){u+=`
|  Remote: ${P.hostName}`;for(const D of Object.keys(P.workspaceMetadata)){const I=P.workspaceMetadata[D];let O=`${I.fileCount} files`;I.maxFilesReached&&(O=`more than ${O}`),u+=`|    Folder (${D}): ${O}`,u+=this.h(I)}}}),{processInfo:g,workspaceInfo:u}})}async getSystemInfo(r,s){const{memory:i,vmHint:o,os:u,cpus:g}=m(),P={os:u,memory:i,cpus:g,vmHint:o,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:s};return E.$i||(P.load=`${n.loadavg().map(D=>Math.round(D)).join(", ")}`),E.$k&&(P.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(P)}async getDiagnostics(r,s){const i=[];return(0,p.$Gs)(r.mainPID).then(async o=>(i.push(""),i.push(this.g(r)),i.push(""),i.push(this.m(r,o)),r.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(r))),s.forEach(u=>{if((0,v.$gn)(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.f(u.machineInfo)),u.processes&&i.push(this.m(r,u.processes)),u.workspaceMetadata)for(const g of Object.keys(u.workspaceMetadata)){const P=u.workspaceMetadata[g];let D=`${P.fileCount} files`;P.maxFilesReached&&(D=`more than ${D}`),i.push(`Folder (${g}): ${D}`),i.push(this.h(P))}}),i.push(""),i.push(""),i.join(`
`)))}h(r){const s=[];let o=0;const u=(I,O)=>{const M=` ${I}(${O})`;o+M.length>60?(s.push(g),g="|                 ",o=g.length):o+=M.length,g+=M};let g="|      File types:";const P=10,D=r.fileTypes.length>P?P:r.fileTypes.length;for(let I=0;I<D;I++){const O=r.fileTypes[I];u(O.name,O.count)}if(s.push(g),r.configFiles.length>=0&&(g="|      Conf files:",o=0,r.configFiles.forEach(I=>{u(I.name,I.count)}),s.push(g)),r.launchConfigFiles.length>0){let I="|      Launch Configs:";r.launchConfigFiles.forEach(O=>{const M=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`;I+=M}),s.push(I)}return s.join(`
`)}j(r){const s=Math.max(...Object.keys(r).map(i=>i.length));return Object.keys(r).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${r[i]}`).join(`
                  `)}k(r){const s=[],i=[];return r.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(s.push(`|  Window (${o.title})`),o.folderURIs.forEach(u=>{const g=h.URI.revive(u);if(g.scheme===R.Schemas.file){const P=g.fsPath;i.push(b(P,["node_modules",".git"]).then(D=>{let I=`${D.fileCount} files`;D.maxFilesReached&&(I=`more than ${I}`),s.push(`|    Folder (${(0,j.$nc)(P)}): ${I}`),s.push(this.h(D))}).catch(D=>{s.push(`|      Error: Unable to collect workspace stats for folder ${P} (${D.toString()})`)}))}else s.push(`|    Folder (${g.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(o=>s.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(r,s){const i=new Map;r.windows.forEach(u=>i.set(u.pid,`window [${u.id}] (${u.title})`)),r.pidToNames.forEach(({pid:u,name:g})=>i.set(u,g));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),s&&this.n(r.mainPID,i,o,s,0),o.join(`
`)}n(r,s,i,o,u){const g=u===0;let P;g?P=o.pid===r?`${this.d.applicationName} main`:"remote agent":s.has(o.pid)?P=s.get(o.pid):P=`${"  ".repeat(u)} ${o.name}`;const D=process.platform==="win32"?o.mem:n.totalmem()*(o.mem/100);i.push(`${o.load.toFixed(0).padStart(5," ")}	${(D/$.$Al.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${P}`),Array.isArray(o.children)&&o.children.forEach(I=>this.n(r,s,i,I,u+1))}async getWorkspaceFileExtensions(r){const s=new Set;for(const{uri:i}of r.folders){const o=h.URI.revive(i);if(o.scheme!==R.Schemas.file)continue;const u=o.fsPath;try{(await b(u,["node_modules",".git"])).fileTypes.forEach(P=>s.add(P.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(r){for(const{uri:s}of r.folders){const i=h.URI.revive(s);if(i.scheme!==R.Schemas.file)continue;const o=i.fsPath;try{const u=await b(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),u.fileTypes.forEach(g=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:g.name,count:g.count})}),u.launchConfigFiles.forEach(g=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:g.name,count:g.count})}),u.configFiles.forEach(g=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:g.name,count:g.count})})}catch{}}}};e.$Ks=a,e.$Ks=a=Ee([ie(0,y.$4l),ie(1,f.$lk)],a)}),define(se[255],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=e.$Gdc=void 0;class n{constructor(R){this.b=R}listen(R,j){throw new Error(`Event not found: ${j}`)}call(R,j,{eventName:E,data:h}){return this.b.forEach(l=>l.log(E,h)),Promise.resolve(null)}}e.$Gdc=n;class C{constructor(R){this.b=R}log(R,j){return this.b.call("log",{eventName:R,data:j}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Hdc=C}),define(se[54],re([0,1,35,12,68,126,28]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=void 0,e.$pp=d,e.$qp=p,e.$rp=v,e.$sp=$,e.$tp=y,e.$up=b,e.$vp=c,e.$wp=a;class E{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$ip=E;class h{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$jp=h,e.$kp=new h;class l{async publicLog(r,s,i){}async publicLogError(r,s,i){}}e.$lp=l,e.$mp="telemetry",e.$np="extensionTelemetryLog",e.$op={log:()=>null,flush:()=>Promise.resolve(null)};function d(t,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!t.enableTelemetry)}function p(t,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function v(t){const r=t.getValue(j.$_l),s=t.getValue(j.$am);if(t.getValue(j.$bm)===!1||s===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function $(t){const r={},s={},i={};w(t,i);for(let o in i){o=o.length>150?o.substr(o.length-149):o;const u=i[o];typeof u=="number"?s[o]=u:typeof u=="boolean"?s[o]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${u.length}`),r[o]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(r[o]=u)}return{properties:r,measurements:s}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function y(t){if(!t)return"none";const r=(0,k.$Km)(t);return f.has(r)?r:"other"}function w(t,r,s=0,i){if(t)for(const o of Object.getOwnPropertyNames(t)){const u=t[o],g=i?i+o:o;Array.isArray(u)?r[g]=(0,n.$0n)(u):u instanceof Date?r[g]=u.toISOString():(0,C.$ag)(u)?s<2?w(u,r,s+1,g+"."):r[g]=(0,n.$0n)(u):r[g]=u}}function b(t,r){const s=t.msftInternalDomains||[],i=r.getValue("telemetry.internalTesting");return(0,R.$hp)(s)||i}function c(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function m(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const i=[];for(const P of r)for(;;){const D=P.exec(t);if(!D)break;i.push([D.index,P.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(s="";;){const P=u.exec(t);if(!P)break;const D=i.some(([I,O])=>P.index<O&&I<u.lastIndex);!o.test(P[0])&&!D&&(s+=t.substring(g,P.index)+"<REDACTED: user-file-path>",g=u.lastIndex)}return g<t.length&&(s+=t.substr(g)),s}function S(t){if(!t)return t;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of r)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function a(t,r){return(0,n.$7n)(t,s=>{if(s instanceof E||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let i=s.replaceAll("%20"," ");i=m(i,r);for(const o of r)i=i.replace(o,"");return i=S(i),i}})}}),define(se[127],re([0,1,25,121,124,4,7,15,36,54]),function(K,e,n,C,k,R,j,E,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$yp=void 0,e.$xp=d,e.$zp=f,e.$Ap=y,e.$Bp=w,e.$Cp=b,e.$Dp=c,e.$Ep=m,e.$Fp=S,e.$Hp=a,e.$Ip=r;function d(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,n.$uf)(s.id,i.id)===0}const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const o=i.manifest?i.manifest.version:i.version,u=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,o,u)}static parse(i){const o=p.exec(i);return o&&o[1]&&o[2]?new v({id:o[1]},o[2],o[4]||void 0):null}constructor(i,o,u="undefined"){this.version=o,this.targetPlatform=u,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?d(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$yp=v;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(s){const i=$.exec(s);return i&&i[1]?[w(i[1]),i[2]]:[w(s),void 0]}function y(s,i){return`${s}.${i}`}function w(s){return s.toLowerCase()}function b(s,i){return w(y(s??k.$Pm,i))}function c(s,i){const o=[],u=g=>{for(const P of o)if(P.some(D=>d(i(D),i(g))))return P;return null};for(const g of s){const P=u(g);P?P.push(g):o.push([g])}return o}function m(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function S(s){return{id:new l.$ip(s.identifier.id),name:new l.$ip(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Gp=new k.$Tm("pprice.better-merge");function a(s,i){const o=[],u=i.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const g=u.shift();if(g&&o.every(P=>!d(P.identifier,{id:g}))){const P=s.filter(D=>d(D.identifier,{id:g}));P.length===1&&(o.push(P[0]),u.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}async function t(s,i){if(!R.$k)return!1;let o;try{o=(await s.readFile(j.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await s.readFile(j.URI.file("/usr/lib/os-release"))).value.toString()}catch(g){i.debug("Error while getting the os-release file.",(0,E.$0)(g))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(s,i){const o=await t(s,i),u=(0,C.$5o)(o?"alpine":R.$u,h.$ec);return i.debug("ComputeTargetPlatform:",u),u}}),define(se[256],re([0,1,209,54]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=k;async function k(R,j,E,h,l,d,p){const v={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${j.nameShort})`};if((0,C.$pp)(j,E)&&(0,C.$rp)(h)===3){const $=await(0,n.$0p)(E,l,d);v["X-Market-User-Id"]=$,v["VSCode-SessionId"]=p.machineId||$}return v}}),define(se[257],re([0,1,2,35,4,25,188,18,52,80,27,45,28,54]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;let f=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(b,c,m){this.k=c,this.l=m,this.d={},this.i=new n.$Tc,this.j=[],this.b=b.appenders,this.c=b.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=b.piiPaths||[],this.g=3,this.h=!!b.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,R.$bf)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.$bf)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(v.$_l)||S.affectsConfiguration(v.$bm)||S.affectsConfiguration(v.$am))&&this.m()}))}setExperimentProperty(b,c){this.d[b]=c}m(){let b=(0,$.$rp)(this.k);const c=this.l.enabledTelemetryLevels;if(c){this.h=this.sendErrorTelemetry?c.error:!1;const m=c.usage?3:c.error?2:0;b=Math.min(b,m)}this.g=b}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(b,c,m){this.g<c||(m=(0,C.$8n)(m,this.d),m=(0,$.$wp)(m,this.j),m=(0,C.$8n)(m,this.c),this.b.forEach(S=>S.log(b,m)))}publicLog(b,c){this.n(b,3,c)}publicLog2(b,c){this.publicLog(b,c)}publicLogError(b,c){this.h&&this.n(b,2,c)}publicLogError2(b,c){this.publicLogError(b,c)}};e.$3r=f,e.$3r=f=Ee([ie(1,E.$5i),ie(2,d.$lk)],f);function y(){const w=(0,j.localize)(0,null,l.default.nameLong),b=l.default.privacyStatementUrl?(0,j.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,j.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=k.$o?"":(0,j.localize)(3,null),m=(0,j.localize)(4,null),S=(0,j.localize)(5,null),a=(0,j.localize)(6,null),t=(0,j.localize)(7,null),r=`
|       | ${m} | ${S} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,j.localize)(8,null);return`
${w} ${b} ${c}

&nbsp;

${t}
${r}

&nbsp;

${s}
`}p.$fo.as(h.$ko.Configuration).registerConfiguration({id:v.$$l,order:1,type:"object",title:(0,j.localize)(9,null),properties:{[v.$_l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,j.localize)(10,null),(0,j.localize)(11,null),(0,j.localize)(12,null),(0,j.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.$fo.as(h.$ko.Configuration).registerConfiguration({id:v.$$l,order:110,type:"object",title:(0,j.localize)(14,null),properties:{[v.$bm]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,j.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,j.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,j.localize)(17,null,`\`#${v.$_l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(se[258],re([0,1,4,89,28]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=R,e.$0dc=j;async function R(E,h){let l=E.getItem(k.$9l);return(typeof l!="string"||n.$j&&l==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(l=await(0,C.$Hn)(h.error.bind(h))),l}async function j(E,h){let l=E.getItem(k.$0l);return typeof l!="string"&&(l=await(0,C.$In)(h.error.bind(h))),l}}),define(se[259],re([0,1,28,258]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=k,e.$_dc=R;async function k(j,E){const h=await(0,C.$9dc)(j,E);return j.setItem(n.$9l,h),h}async function R(j,E){const h=await(0,C.$0dc)(j,E);return j.setItem(n.$0l,h),h}}),define(se[128],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(C){C[C.Replace=1]="Replace",C[C.Append=2]="Append",C[C.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(se[260],re([0,1,4,128]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=void 0;const k=new Map([[C.EnvironmentVariableMutatorType.Append,"APPEND"],[C.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[C.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class R{constructor(d){this.collections=d,this.a=new Map,this.b=new Map,d.forEach((p,v)=>{this.d(p,v);const $=p.map.entries();let f=$.next();for(;!f.done;){const y=f.value[1],w=f.value[0];let b=this.a.get(w);if(b||(b=[],this.a.set(w,b)),b.length>0&&b[0].type===C.EnvironmentVariableMutatorType.Replace){f=$.next();continue}const c={extensionIdentifier:v,value:y.value,type:y.type,scope:y.scope,variable:y.variable,options:y.options};c.scope||delete c.scope,b.unshift(c),f=$.next()}})}async applyToProcessEnvironment(d,p,v){let $;n.$i&&($={},Object.keys(d).forEach(f=>$[f.toLowerCase()]=f));for(const[f,y]of this.getVariableMap(p)){const w=n.$i&&$[f.toLowerCase()]||f;for(const b of y){const c=v?await v(b.value):b.value;if(b.options?.applyAtProcessCreation??!0)switch(b.type){case C.EnvironmentVariableMutatorType.Append:d[w]=(d[w]||"")+c;break;case C.EnvironmentVariableMutatorType.Prepend:d[w]=c+(d[w]||"");break;case C.EnvironmentVariableMutatorType.Replace:d[w]=c;break}if(b.options?.applyAtShellIntegration??!1){const m=`VSCODE_ENV_${k.get(b.type)}`;d[m]=(d[m]?d[m]+":":"")+f+"="+this.c(c)}}}}c(d){return d.replaceAll(":","\\x3a")}diff(d,p){const v=new Map,$=new Map,f=new Map;if(d.getVariableMap(p).forEach((y,w)=>{const b=this.getVariableMap(p).get(w),c=E(y,b);c&&v.set(w,c)}),this.getVariableMap(p).forEach((y,w)=>{const b=d.getVariableMap(p).get(w),c=E(y,b);c&&f.set(w,c)}),this.getVariableMap(p).forEach((y,w)=>{const b=d.getVariableMap(p).get(w),c=h(y,b);c&&$.set(w,c)}),!(v.size===0&&$.size===0&&f.size===0))return{added:v,changed:$,removed:f}}getVariableMap(d){const p=new Map;for(const v of this.a.values()){const $=v.filter(f=>j(f,d));$.length>0&&p.set($[0].variable,$)}return p}getDescriptionMap(d){const p=new Map;for(const v of this.b.values()){const $=v.filter(f=>j(f,d,!0));for(const f of $)p.set(f.extensionIdentifier,f.description)}return p}d(d,p){if(!d.descriptionMap)return;const v=d.descriptionMap.entries();let $=v.next();for(;!$.done;){const f=$.value[1],y=$.value[0];let w=this.b.get(y);w||(w=[],this.b.set(y,w));const b={extensionIdentifier:p,scope:f.scope,description:f.description};b.scope||delete b.scope,w.push(b),$=v.next()}}}e.$us=R;function j(l,d,p=!1){return l.scope?!!(l.scope.workspaceFolder&&d?.workspaceFolder&&l.scope.workspaceFolder.index===d.workspaceFolder.index):p?d===l.scope:!0}function E(l,d){if(!d)return l;const p=new Set;d.forEach($=>p.add($.extensionIdentifier));const v=[];return l.forEach($=>{p.has($.extensionIdentifier)||v.push($)}),v.length===0?void 0:v}function h(l,d){if(!d)return;const p=new Map;d.forEach($=>p.set($.extensionIdentifier,$));const v=[];return l.forEach($=>{const f=p.get($.extensionIdentifier);f&&($.type!==f.type||$.value!==f.value||$.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index)&&v.push(f)}),v.length===0?void 0:v}}),define(se[261],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=n,e.$ps=C,e.$qs=k,e.$rs=R,e.$ss=j,e.$ts=E;function n(h){return[...h.entries()]}function C(h){return h?[...h.entries()]:[]}function k(h){return new Map(h)}function R(h){return new Map(h??[])}function j(h){return Array.from(h.entries()).map(l=>[l[0],n(l[1].map),C(l[1].descriptionMap)])}function E(h){return new Map(h.map(l=>[l[0],{map:k(l[1]),descriptionMap:R(l[2])}]))}}),define(se[262],re([0,1,8,23,3,2,5]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0;let E=class extends R.$Uc{constructor(l,d){super(),this.h=d,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new k.$fe),this.onCreateRequest=this.g.event,this.b=l===void 0?15e3:l,this.B((0,R.$Sc)(()=>{for(const p of this.f.values())(0,R.$Pc)(p)}))}createRequest(l){return new Promise((d,p)=>{const v=++this.a;this.c.set(v,d),this.g.fire({requestId:v,...l});const $=new C.$qe;(0,n.$zh)(this.b,$.token).then(()=>p(`Request ${v} timed out (${this.b}ms)`)),this.f.set(v,[(0,R.$Sc)(()=>$.cancel())])})}acceptReply(l,d){const p=this.c.get(l);p?(this.c.delete(l),(0,R.$Pc)(this.f.get(l)||[]),this.f.delete(l),p(d)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.$fs=E,e.$fs=E=Ee([ie(1,j.$5j)],E)}),define(se[129],re([0,1,6,118,45]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=e.$_r=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$$r=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$0r=void 0,e.$0r=new C.$Pj("terminalTabFocusMode",!1,!0);var R;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var j;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.MiddleClickBehavior="terminal.integrated.middleClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(j||(e.TerminalSettingId=j={}));var E;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh",a.Python="python"})(E||(e.PosixShellType=E={}));var h;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash",a.Python="python"})(h||(e.WindowsShellType=h={}));var l;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var d;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(d||(e.TerminalIpcChannels=d={}));var p;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(p||(e.ProcessPropertyType=p={})),e.$$r=(0,n.$yi)("ptyService");var v;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(v||(e.HeartbeatConstants=v={}));var $;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})($||(e.TerminalLocation=$={}));var f;(function(a){a.TerminalView="view",a.Editor="editor"})(f||(e.TerminalLocationString=f={}));var y;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(y||(e.LocalReconnectConstants=y={}));var w;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(w||(e.FlowControlConstants=w={}));var b;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(b||(e.ProfileSource=b={}));var c;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(c||(e.ShellIntegrationStatus=c={}));var m;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(m||(e.TerminalExitReason=m={})),e.$_r={Backend:"workbench.contributions.terminal.processBackend"};class S{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const r=this.b(t.remoteAuthority);if(this.a.has(r))throw new Error(`A terminal backend with remote authority '${r}' was already registered.`);this.a.set(r,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}k.$fo.add(e.$_r.Backend,new S),e.$as=(0,n.$yi)("localPtyService"),e.$bs=(0,n.$yi)("terminalLogService")}),define(se[263],re([0,1,75,7,190,106]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=j,e.$hs=l,e.$is=d,e.$js=p;function j(v,$){const f=[{name:null,description:(0,k.localize)(0,null)}];return f.push(...v.map(y=>({name:y.profileName,description:E(y)}))),$&&f.push(...$.map(y=>({name:y.title,description:h(y)}))),{values:f.map(y=>y.name),markdownDescriptions:f.map(y=>y.description)}}function E(v){let $=`$(${R.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:n.$Xj.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?$+=`
- args: "${v.args}"`:$+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&($+=`
- overrideName: ${v.overrideName}`),v.color&&($+=`
- color: ${v.color}`),v.env&&($+=`
- env: ${JSON.stringify(v.env)}`),$}function h(v){return`$(${R.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:n.$Xj.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function l(v,$){if(!v&&!$)return!0;if(typeof v=="string"&&typeof $=="string")return v===$;if(Array.isArray(v)&&Array.isArray($)){if(v.length!==$.length)return!1;for(let f=0;f<v.length;f++)if(v[f]!==$[f])return!1;return!0}return!1}function d(v,$){if(!v&&!$)return!0;if(!v||!$)return!1;if(R.ThemeIcon.isThemeIcon(v)&&R.ThemeIcon.isThemeIcon($))return v.id===$.id&&v.color===$.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof $=="object"&&"light"in $&&"dark"in $){const f=v,y=$;if((C.URI.isUri(f.light)||p(f.light))&&(C.URI.isUri(f.dark)||p(f.dark))&&(C.URI.isUri(y.light)||p(y.light))&&(C.URI.isUri(y.dark)||p(y.dark)))return f.light.path===y.light.path&&f.dark.path===y.dark.path}if(C.URI.isUri(v)&&C.URI.isUri($)||p(v)||p($)){const f=v,y=$;return f.path===y.path&&f.scheme===y.scheme}return!1}function p(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}}),define(se[264],re([0,1,75,4,189,52,45,263]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=void 0,e.$ms=$,e.$ns=y,e.$ks={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$ls={type:"string",enum:Array.from((0,n.$Vj)(),w=>w.id),markdownEnumDescriptions:Array.from((0,n.$Vj)(),w=>`$(${w.id})`)};const h={args:{description:(0,k.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,k.localize)(1,null),type:"boolean"},icon:{description:(0,k.localize)(2,null),...e.$ls},color:{description:(0,k.localize)(3,null),...e.$ks},env:{markdownDescription:(0,k.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},l={type:"object",required:["path"],properties:{path:{description:(0,k.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},d={type:"object",required:["path"],properties:{path:{description:(0,k.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function p(w){const b=w===2?"linux":w===1?"osx":"windows";return(0,k.localize)(7,null,(0,C.$h)(w),'```json\n"terminal.integrated.profile.'+b+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const v={id:"terminal",order:100,title:(0,k.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,k.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,k.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,k.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:p(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,k.localize)(12,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(13,null),type:"string"},id:{description:(0,k.localize)(14,null),type:"string"},title:{description:(0,k.localize)(15,null),type:"string"},...h}},{type:"null"},l]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:p(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(16,null),type:"string"},id:{description:(0,k.localize)(17,null),type:"string"},title:{description:(0,k.localize)(18,null),type:"string"},...h}},{type:"null"},l]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:p(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(19,null),type:"string"},id:{description:(0,k.localize)(20,null),type:"string"},title:{description:(0,k.localize)(21,null),type:"string"},...h}},{type:"null"},l]}},"terminal.integrated.useWslProfiles":{description:(0,k.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,k.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,k.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,k.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,k.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function $(){j.$fo.as(R.$ko.Configuration).registerConfiguration(v),y()}let f;function y(w,b){const c=j.$fo.as(R.$ko.Configuration);let m;w&&(m=(0,E.$gs)(w?.profiles,b));const S=f;f={id:"terminal",order:100,title:(0,k.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,k.localize)(28,null),type:["string","null"],default:null,enum:w?.os===3?m?.values:void 0,markdownEnumDescriptions:w?.os===3?m?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,k.localize)(29,null),type:["string","null"],default:null,enum:w?.os===2?m?.values:void 0,markdownEnumDescriptions:w?.os===2?m?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,k.localize)(30,null),type:["string","null"],default:null,enum:w?.os===1?m?.values:void 0,markdownEnumDescriptions:w?.os===1?m?.markdownDescriptions:void 0}}},c.updateConfigurations({add:[f],remove:S?[S]:[]})}}),define(se[265],re([0,1,26,13,35,9,4,36,25,12,21,128,261,260]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=f,e.$ws=y,e.$xs=w;function f(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let g=0;return u&&u.length===4&&(g=parseInt(u[3])),g}async function y(u,g,P,D=E.env,I=d.Promises.exists){if(R.$ic(u))return await I(u)?u:void 0;if(g===void 0&&(g=E.cwd()),R.$mc(u)!=="."){const F=R.$jc(g,u);return await I(F)?F:void 0}const M=(0,k.$_n)(D,"PATH");if(P===void 0&&(0,l.$$f)(M)&&(P=M.split(R.$tc)),P===void 0||P.length===0){const F=R.$jc(g,u);return await I(F)?F:void 0}for(const F of P){let T;if(R.$ic(F)?T=R.$jc(F,u):T=R.$jc(g,F,u),await I(T))return T;if(j.$i){let U=T+".com";if(await I(U)||(U=T+".exe",await I(U)))return U}}const W=R.$jc(g,u);return await I(W)?W:void 0}function w(u,g,P,D,I){const O=j.$i&&(!g.windowsEnableConpty||f()<18309);if(!g.shellIntegration.enabled||!u.executable||u.isFeatureTerminal&&!u.forceShellIntegration||u.ignoreShellIntegration||O)return;const M=u.args,W=E.$dc==="win32"?R.$nc(u.executable).toLowerCase():R.$nc(u.executable),F=R.$mc(C.$Sg.asFileUri("").fsPath);let T;const U={VSCODE_INJECTION:"1"};if(g.shellIntegration.nonce&&(U.VSCODE_NONCE=g.shellIntegration.nonce),j.$i){if(W==="pwsh.exe"||W==="powershell.exe")return!M||i(M)?T=m.get(c.WindowsPwsh):s(M)&&(T=m.get(c.WindowsPwshLogin)),T?(T=[...T],T[T.length-1]=(0,h.$0e)(T[T.length-1],F,""),g.shellIntegration.suggestEnabled&&(U.VSCODE_SUGGEST="1"),{newArgs:T,envMixin:U}):void 0;if(W==="bash.exe")return!M||M.length===0?T=m.get(c.Bash):o(M)&&(U.VSCODE_SHELL_LOGIN="1",b(g,U),T=m.get(c.Bash)),T?(T=[...T],T[T.length-1]=(0,h.$0e)(T[T.length-1],F),{newArgs:T,envMixin:U}):void 0;D.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args);return}switch(W){case"bash":return!M||M.length===0?T=m.get(c.Bash):o(M)&&(U.VSCODE_SHELL_LOGIN="1",b(g,U),T=m.get(c.Bash)),T?(T=[...T],T[T.length-1]=(0,h.$0e)(T[T.length-1],F),{newArgs:T,envMixin:U}):void 0;case"fish":{const ae=P?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",te=R.$jc(F,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return U.XDG_DATA_DIRS=`${ae}:${te}`,b(g,U),{newArgs:void 0,envMixin:U}}case"pwsh":return!M||i(M)?T=m.get(c.Pwsh):s(M)&&(T=m.get(c.PwshLogin)),T?(g.shellIntegration.suggestEnabled&&(U.VSCODE_SUGGEST="1"),T=[...T],T[T.length-1]=(0,h.$0e)(T[T.length-1],F,""),{newArgs:T,envMixin:U}):void 0;case"zsh":{if(!M||M.length===0?T=m.get(c.Zsh):o(M)?(T=m.get(c.ZshLogin),b(g,U)):(M===m.get(c.Zsh)||M===m.get(c.ZshLogin))&&(T=M),!T)return;T=[...T],T[T.length-1]=(0,h.$0e)(T[T.length-1],F);let ae;try{ae=n.userInfo().username}catch{ae="unknown"}const te=R.$jc(n.tmpdir(),`${ae}-${I.applicationName}-zsh`);U.ZDOTDIR=te;const ce=P?.ZDOTDIR??n.homedir()??"~";U.USER_ZDOTDIR=ce;const J=[];return J.push({source:R.$jc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:R.$jc(te,".zshrc")}),J.push({source:R.$jc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:R.$jc(te,".zprofile")}),J.push({source:R.$jc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:R.$jc(te,".zshenv")}),J.push({source:R.$jc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:R.$jc(te,".zlogin")}),{newArgs:T,envMixin:U,filesToCopy:J}}}D.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args)}function b(u,g){if(j.$j&&u.environmentVariableCollections){const P=(0,v.$ts)(u.environmentVariableCollections),I=new $.$us(P).getVariableMap({workspaceFolder:u.workspaceFolder}).get("PATH"),O=[];if(I)for(const M of I)M.type===p.EnvironmentVariableMutatorType.Prepend&&O.push(M.value);O.length>0&&(g.VSCODE_PATH_PREFIX=O.join(""))}}var c;(function(u){u.WindowsPwsh="windows-pwsh",u.WindowsPwshLogin="windows-pwsh-login",u.Pwsh="pwsh",u.PwshLogin="pwsh-login",u.Zsh="zsh",u.ZshLogin="zsh-login",u.Bash="bash"})(c||(c={}));const m=new Map;m.set(c.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),m.set(c.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),m.set(c.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),m.set(c.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),m.set(c.Zsh,["-i"]),m.set(c.ZshLogin,["-il"]),m.set(c.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],a=["--login","-l"],t=["-i","--interactive"],r=["-nol","-nologo"];function s(u){return typeof u=="string"?S.includes(u.toLowerCase()):u.length===1&&S.includes(u[0].toLowerCase())||u.length===2&&(S.includes(u[0].toLowerCase())||S.includes(u[1].toLowerCase()))&&(r.includes(u[0].toLowerCase())||r.includes(u[1].toLowerCase()))}function i(u){return typeof u=="string"?r.includes(u.toLowerCase()):u.length===0||u?.length===1&&r.includes(u[0].toLowerCase())}function o(u){return typeof u!="string"&&(u=u.filter(g=>!t.includes(g.toLowerCase()))),u==="string"&&a.includes(u.toLowerCase())||typeof u!="string"&&u.length===1&&a.includes(u[0].toLowerCase())}}),define(se[266],re([0,1,49,75,9,4,12,21,110,265,117]),function(K,e,n,C,k,R,j,E,h,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=f;var p;(function(u){u.UnixShellsPath="/etc/shells"})(p||(p={}));let v,$=!0;function f(u,g,P,D,I=process.env,O,M,W,F){return O=O||{existsFile:E.SymlinkSupport.existsFile,readFile:E.Promises.readFile},R.$i?y(P,O,I,M,D.getValue("terminal.integrated.useWslProfiles")!==!1,u&&typeof u=="object"?{...u}:D.getValue("terminal.integrated.profiles.windows"),typeof g=="string"?g:D.getValue("terminal.integrated.defaultProfile.windows"),F,W):s(O,M,P,u&&typeof u=="object"?{...u}:D.getValue(R.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof g=="string"?g:D.getValue(R.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,W,I)}async function y(u,g,P,D,I,O,M,W,F){const T=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),U=`${process.env.windir}\\${T?"Sysnative":"System32"}`;let ae=!1;(0,l.$vs)()>=16299&&(ae=!0),await m(W);const te=new Map;if(u){te.set("PowerShell",{source:"PowerShell",icon:C.$Xj.terminalPowershell,isAutoDetected:!0}),te.set("Windows PowerShell",{path:`${U}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:C.$Xj.terminalPowershell,isAutoDetected:!0}),te.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),te.set("Command Prompt",{path:`${U}\\cmd.exe`,icon:C.$Xj.terminalCmd,isAutoDetected:!0}),te.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),te.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:C.$Xj.terminalBash,isAutoDetected:!0});const J=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;te.set("Cmder",{path:`${U}\\cmd.exe`,args:["/K",J],requiresPath:process.env.CMDER_ROOT?J:{path:J,isUnsafe:!0},isAutoDetected:!0})}i(O,te);const ce=await w(te.entries(),M,g,P,D,F);if(u&&I)try{const J=await t(`${U}\\${ae?"wsl":"bash"}.exe`,M);for(const V of J)(!O||!(V.profileName in O))&&ce.push(V)}catch{$&&(D?.trace("WSL is not installed, so could not detect WSL profiles"),$=!1)}return ce}async function w(u,g,P,D=process.env,I,O){const M=[];for(const[W,F]of u)M.push(b(W,F,g,P,D,I,O));return(await Promise.all(M)).filter(W=>!!W)}async function b(u,g,P,D,I=process.env,O,M){if(g===null)return;let W,F,T;if("source"in g&&!("path"in g)){const ce=v?.get(g.source);if(!ce)return;W=ce.paths,F=g.args||ce.args,g.icon?T=c(g.icon):ce.icon&&(T=ce.icon)}else W=Array.isArray(g.path)?g.path:[g.path],F=R.$i||Array.isArray(g.args)?g.args:void 0,T=c(g.icon);let U;if(M){const ce=W.map(V=>typeof V=="string"?V:V.path),J=await M(ce);U=new Array(W.length);for(let V=0;V<W.length;V++)typeof W[V]=="string"?U[V]=J[V]:U[V]={path:J[V],isUnsafe:!0}}else U=W.slice();let ae;if(g.requiresPath){let ce;if((0,j.$$f)(g.requiresPath)?ce=g.requiresPath:(ce=g.requiresPath.path,g.requiresPath.isUnsafe&&(ae=ce)),!await D.existsFile(ce))return}const te=await o(u,P,U,D,I,F,g.env,g.overrideName,g.isAutoDetected,ae);if(!te){O?.debug("Terminal profile not validated",u,W);return}return te.isAutoDetected=g.isAutoDetected,te.icon=T,te.color=g.color,te}function c(u){return typeof u=="string"?{id:u}:u}async function m(u){if(v&&!u)return;const[g,P]=await Promise.all([S(),u||a()]);v=new Map,v.set("Git Bash",{profileName:"Git Bash",paths:g,args:["--login","-i"]}),v.set("PowerShell",{profileName:"PowerShell",paths:P,icon:C.$Xj.terminalPowershell})}async function S(){const u=new Set,g=await(0,l.$ws)("git.exe");if(g){const I=(0,d.dirname)(g);u.add((0,d.resolve)(I,"../.."))}function P(I,O){O&&I.add(O)}P(u,process.env.ProgramW6432),P(u,process.env.ProgramFiles),P(u,process.env["ProgramFiles(X86)"]),P(u,`${process.env.LocalAppData}\\Program`);const D=[];for(const I of u)D.push(`${I}\\Git\\bin\\bash.exe`,`${I}\\Git\\usr\\bin\\bash.exe`,`${I}\\usr\\bin\\bash.exe`);return D.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),D.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),D}async function a(){const u=[];for await(const g of(0,h.$mm)())u.push(g.exePath);return u}async function t(u,g){const P=[],D=await new Promise((M,W)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,T)=>{if(F)return W("Problem occurred when getting wsl distros");M(T)})});if(!D)return[];const I=new RegExp(/[\r?\n]/),O=D.split(I).filter(M=>M.trim().length>0&&M!=="");for(const M of O){if(M===""||M.startsWith("docker-desktop"))continue;const W=`${M} (WSL)`,F={profileName:W,path:u,args:["-d",`${M}`],isDefault:W===g,icon:r(M),isAutoDetected:!1};P.push(F)}return P}function r(u){return u.includes("Ubuntu")?C.$Xj.terminalUbuntu:u.includes("Debian")?C.$Xj.terminalDebian:C.$Xj.terminalLinux}async function s(u,g,P,D,I,O,M,W){const F=new Map;if(P&&await u.existsFile("/etc/shells")){const T=(await u.readFile("/etc/shells")).toString(),U=(O||T.split(`
`)).map(te=>{const ce=te.indexOf("#");return ce===-1?te:te.substring(0,ce)}).filter(te=>te.trim().length>0),ae=new Map;for(const te of U){let ce=(0,k.$nc)(te),J=ae.get(ce)||0;J++,J>1&&(ce=`${ce} (${J})`),ae.set(ce,J),F.set(ce,{path:te,isAutoDetected:!0})}}return i(D,F),await w(F.entries(),I,u,W,g,M)}function i(u,g){if(u)for(const[P,D]of Object.entries(u))D===null||typeof D!="object"||!("path"in D)&&!("source"in D)?g.delete(P):(D.icon=D.icon||g.get(P)?.icon,g.set(P,D))}async function o(u,g,P,D,I,O,M,W,F,T){if(P.length===0)return Promise.resolve(void 0);const U=P.shift();if(U==="")return o(u,g,P,D,I,O,M,W,F);const ae=typeof U!="string"&&U.isUnsafe,te=typeof U=="string"?U:U.path,ce={profileName:u,path:te,args:O,env:M,overrideName:W,isAutoDetected:F,isDefault:u===g,isUnsafePath:ae,requiresUnsafePath:T};if((0,k.$nc)(te)===te){const V=I.PATH?I.PATH.split(k.$tc):void 0,q=await(0,l.$ws)(te,void 0,V,void 0,D.existsFile);return q?(ce.path=q,ce.isFromPath=!0,ce):o(u,g,P,D,I,O)}return await D.existsFile((0,k.$hc)(te))?ce:o(u,g,P,D,I,O,M,W,F)}}),define(se[267],re([0,1,3,2,4,44,18,5,230,95,262,129,264,266,112,73]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0;var w;(function(c){c[c.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let b=class extends C.$Uc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(m,S,a,t){super(),this.M=m,this.N=S,this.O=a,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$fe),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$fe),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$fe),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$fe),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$fe),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$fe),this.onProcessData=this.D.event,this.F=this.B(new n.$fe),this.onProcessReady=this.F.event,this.G=this.B(new n.$fe),this.onProcessReplay=this.G.event,this.H=this.B(new n.$fe),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$fe),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$fe),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$fe),this.onProcessExit=this.L.event,(0,v.$ms)(),this.B(this.M),this.B((0,C.$Sc)(()=>this.W())),this.j=this.B(new d.$fs(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&n.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(k.$i)return process.env;try{return await(0,l.$Im)(this.N,this.O,{_:[]},process.env)}catch(m){return this.O.error("ptyHost was unable to resolve shell environment",m),{}}}U(){const m=this.M.start(),S=m.client;this.O.getLevel()===E.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),R.ProxyChannel.toService(S.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(m.onDidProcessExit(r=>{this.u.fire(r.code),!this.m&&!this.q.isDisposed&&(this.n<=w.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${r.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const t=R.ProxyChannel.toService(S.getChannel(p.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(r=>this.D.fire(r))),this.B(t.onProcessReady(r=>this.F.fire(r))),this.B(t.onProcessExit(r=>this.L.fire(r))),this.B(t.onDidChangeProperty(r=>this.J.fire(r))),this.B(t.onProcessReplay(r=>this.G.fire(r))),this.B(t.onProcessOrphanQuestion(r=>this.H.fire(r))),this.B(t.onDidRequestDetach(r=>this.I.fire(r))),this.B(new h.$es(this.P,S.getChannel(p.TerminalIpcChannels.Logger))),this.a=m,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[m,t]}async createProcess(m,S,a,t,r,s,i,o,u,g,P){const D=setTimeout(()=>this.$(),p.HeartbeatConstants.CreateProcessTimeout),I=await this.f.createProcess(m,S,a,t,r,s,i,o,u,g,P);return clearTimeout(D),I}updateTitle(m,S,a){return this.f.updateTitle(m,S,a)}updateIcon(m,S,a,t){return this.f.updateIcon(m,S,a,t)}attachToProcess(m){return this.f.attachToProcess(m)}detachFromProcess(m,S){return this.f.detachFromProcess(m,S)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(m){return this.f.start(m)}shutdown(m,S){return this.f.shutdown(m,S)}input(m,S){return this.f.input(m,S)}processBinary(m,S){return this.f.processBinary(m,S)}resize(m,S,a){return this.f.resize(m,S,a)}clearBuffer(m){return this.f.clearBuffer(m)}acknowledgeDataEvent(m,S){return this.f.acknowledgeDataEvent(m,S)}setUnicodeVersion(m,S){return this.f.setUnicodeVersion(m,S)}getInitialCwd(m){return this.f.getInitialCwd(m)}getCwd(m){return this.f.getCwd(m)}async getLatency(){const m=new y.$be,S=await this.f.getLatency();return m.stop(),[{label:"ptyhostservice<->ptyhost",latency:m.elapsed()},...S]}orphanQuestionReply(m){return this.f.orphanQuestionReply(m)}installAutoReply(m,S){return this.f.installAutoReply(m,S)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(m){return this.f.uninstallAutoReply(m)}getDefaultSystemShell(m){return this.g?.getDefaultSystemShell(m)??(0,f.$sm)(m??k.OS,process.env)}async getProfiles(m,S,a,t=!1){const r=await this.S();return(0,$.$ys)(S,a,t,this.N,r,void 0,this.O,this.bb.bind(this,m))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(m,S){return this.f.getWslPath(m,S)}getRevivedPtyNewId(m,S){return this.f.getRevivedPtyNewId(m,S)}setTerminalLayoutInfo(m){return this.f.setTerminalLayoutInfo(m)}async getTerminalLayoutInfo(m){return this.g?.getTerminalLayoutInfo(m)}async requestDetachInstance(m,S){return this.f.requestDetachInstance(m,S)}async acceptDetachInstanceReply(m,S){return this.f.acceptDetachInstanceReply(m,S)}async freePortKillProcess(m){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(m)}async serializeTerminalState(m){return this.f.serializeTerminalState(m)}async reviveTerminalProcesses(m,S,a){return this.f.reviveTerminalProcesses(m,S,a)}async refreshProperty(m,S){return this.f.refreshProperty(m,S)}async updateProperty(m,S,a){return this.f.updateProperty(m,S,a)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(m){this.ab(),this.s=setTimeout(()=>this.Y(),m?p.HeartbeatConstants.ConnectingBeatInterval:p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(m,S){return this.j.createRequest({workspaceId:m,originalText:S})}async acceptPtyHostResolvedVariables(m,S){this.j.acceptReply(m,S)}};e.$zs=b,e.$zs=b=Ee([ie(1,j.$5i),ie(2,E.$5j),ie(3,E.$6j)],b)}),define(se[69],re([0,1,14,3,2,4,18,6,34]),function(K,e,n,C,k,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=e.$wcc=void 0;const l="#FFFFFF",d="#1E1E1E",p="#000000",v="#FFFFFF",$="theme",f="themeBackground",y="windowSplash";var w;(function(c){c.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",c.SYSTEM_COLOR_THEME="window.systemColorTheme"})(w||(w={})),e.$wcc=(0,E.$yi)("themeMainService");let b=class extends k.$Uc{constructor(m,S){super(),this.b=m,this.c=S,this.a=this.B(new C.$fe),this.onDidChangeColorScheme=this.a.event,R.$k||this.B(this.c.onDidChangeConfiguration(a=>{(a.affectsConfiguration(w.SYSTEM_COLOR_THEME)||a.affectsConfiguration(w.DETECT_COLOR_SCHEME))&&this.f()})),this.f(),this.B(C.Event.fromNodeEventEmitter(n.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){if(R.$k||this.c.getValue(w.DETECT_COLOR_SCHEME))n.nativeTheme.themeSource="system";else switch(this.c.getValue(w.SYSTEM_COLOR_THEME)){case"dark":n.nativeTheme.themeSource="dark";break;case"light":n.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.nativeTheme.themeSource="light";break;case"vs-dark":n.nativeTheme.themeSource="dark";break;default:n.nativeTheme.themeSource="system"}break;default:n.nativeTheme.themeSource="system";break}}getColorScheme(){if(R.$i){if(n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.$j){if(n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.$k&&n.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const m=this.getColorScheme();if(m.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return m.dark?p:v;let S=this.b.getItem(f,null);if(!S)switch(this.g()){case"vs":S=l;break;case"hc-black":S=p;break;case"hc-light":S=v;break;default:S=d}return R.$j&&S.toUpperCase()===d&&(S="#171717"),S}g(){switch(this.b.getItem($,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(m,S){this.b.setItems([{key:$,data:S.baseTheme},{key:f,data:S.colorInfo.background},{key:y,data:S}]),typeof m=="number"&&this.h(m,S),this.f()}h(m,S){for(const a of n.BrowserWindow.getAllWindows())if(a.id===m){a.setBackgroundColor(S.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(y)}};e.$xcc=b,e.$xcc=b=Ee([ie(0,h.$5P),ie(1,j.$5i)],b)}),define(se[130],re([0,1,3,7,18,6,5]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ww=e.$vw=e.$sw=e.$qw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$mw=e.$lw=void 0,e.$nw=l,e.$ow=p,e.$pw=v,e.$rw=$,e.$tw=f,e.$uw=y,e.$lw=(0,R.$yi)("tunnelService"),e.$mw=(0,R.$yi)("sharedTunnelsService");var E;(function(c){c.Http="http",c.Https="https"})(E||(e.TunnelProtocol=E={}));var h;(function(c){c.ConstantPrivate="constantPrivate",c.Private="private",c.Public="public"})(h||(e.TunnelPrivacyId=h={}));function l(c){return!!c.forwardPort}var d;(function(c){c[c.Notify=1]="Notify",c[c.OpenBrowser=2]="OpenBrowser",c[c.OpenPreview=3]="OpenPreview",c[c.Silent=4]="Silent",c[c.Ignore=5]="Ignore",c[c.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function p(c){if(c.scheme!=="http"&&c.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(c.authority);if(m)return{address:m[1],port:+m[2]}}function v(c){if(c.scheme!=="http"&&c.scheme!=="https"||!c.query)return;const m=c.query.split("&");for(const S of m){const a=S.split("=")[1];if(/^https?:/.exec(a)){const t=p(C.URI.parse(a));if(t)return t}}}e.$qw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function $(c){return e.$qw.indexOf(c)>=0}e.$sw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function f(c){return e.$sw.indexOf(c)>=0}function y(c,m,S,a){if(S===1)return!1;if(S===2&&f(m)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(t?.length===4&&parseInt(t[1])>=18)return!1}return c<1024}class w{constructor(m,S,a){this.remoteAddress=m,this.localAddress=S,this.b=a,this.a=new n.$fe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$vw=w;let b=class{constructor(m,S){this.k=m,this.l=S,this.a=new n.$fe,this.onTunnelOpened=this.a.event,this.b=new n.$fe,this.onTunnelClosed=this.b.event,this.c=new n.$fe,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const m=this.l.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(m){return this.f=m,m?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this.g=m.elevation,this.i=m.privacyOptions,this.h=m.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const m=[],S=Array.from(this.e.values());for(const a of S){const t=Array.from(a.values());for(const r of t){const s=await r.value;s&&typeof s!="string"&&m.push(s)}}return m}async dispose(){for(const m of this.e.values()){for(const{value:S}of m.values())await S.then(a=>typeof a!="string"?a?.dispose():void 0);m.clear()}this.e.clear()}setEnvironmentTunnel(m,S,a,t,r){this.q(m,S,Promise.resolve({tunnelRemoteHost:m,tunnelRemotePort:S,localAddress:a,privacy:t,protocol:r,dispose:()=>Promise.resolve()}))}async getExistingTunnel(m,S){(f(m)||$(m))&&(m=e.$qw[0]);const a=this.s(m,S);if(a)return++a.refcount,a.value}openTunnel(m,S,a,t,r,s=!1,i,o){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${S}:${a} on local port ${r}.`);const u=this.f??m;if(!u)return;if(S||(S="localhost"),t||(t=this.m),this.f&&this.j.has(a)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const g=this.t(u,S,a,t,r,s,i,o);return g?g.then(P=>{if(P){if(typeof P=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(S,a),P}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(S,a);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const D=this.o(P);return(P.tunnelRemoteHost!==S||P.tunnelRemotePort!==a)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),i&&P.privacy!==i&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(D),D}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),g)}o(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const S=this.e.get(m.tunnelRemoteHost);if(S){const a=S.get(m.tunnelRemotePort);a&&(a.refcount--,await this.p(m.tunnelRemoteHost,m.tunnelRemotePort,a))}}}}async p(m,S,a){if(a.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${S}.`);const t=a.value.then(async r=>{r&&typeof r!="string"&&(await r.dispose(!0),this.b.fire({host:r.tunnelRemoteHost,port:r.tunnelRemotePort}))});return this.e.has(m)&&this.e.get(m).delete(S),t}}async closeTunnel(m,S){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${S} `);const a=this.e.get(m);if(a&&a.has(S)){const t=a.get(S);t.refcount=0,await this.p(m,S,t)}}q(m,S,a){this.e.has(m)||this.e.set(m,new Map),this.e.get(m).set(S,{refcount:1,value:a})}async r(m,S){const a=this.e.get(m);if(a){const t=a.get(S),r=t?await t.value:void 0;(!r||typeof r=="string")&&a.delete(S),a.size===0&&this.e.delete(m)}}s(m,S){const a=[m];$(m)?(a.push(...e.$qw),a.push(...e.$sw)):f(m)&&a.push(...e.$sw);const t=a.map(r=>this.e.get(r));for(const r of t){const s=r?.get(S);if(s)return s}}canTunnel(m){return!!p(m)}u(m,S,a,t,r,s,i){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${S}:${a} on local port ${t}.`);const o=a;this.j.add(o);const u=t===void 0?a:t,g={elevationRequired:r?this.isPortPrivileged(u):!1},P={remoteAddress:{host:S,port:a},localAddressPort:t,privacy:s,public:s?s!==h.Private:void 0,protocol:i},D=m.forwardPort(P,g);return D?(this.q(S,a,D),D.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(o)})):this.j.delete(o),D}};e.$ww=b,e.$ww=b=Ee([ie(0,j.$5j),ie(1,k.$5i)],b)}),define(se[50],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gX=e.$fX=e.DisablementReason=e.UpdateType=e.StateType=void 0;var C;(function(j){j.Uninitialized="uninitialized",j.Idle="idle",j.Disabled="disabled",j.CheckingForUpdates="checking for updates",j.AvailableForDownload="available for download",j.Downloading="downloading",j.Downloaded="downloaded",j.Updating="updating",j.Ready="ready"})(C||(e.StateType=C={}));var k;(function(j){j[j.Setup=0]="Setup",j[j.Archive=1]="Archive",j[j.Snap=2]="Snap"})(k||(e.UpdateType=k={}));var R;(function(j){j[j.NotBuilt=0]="NotBuilt",j[j.DisabledByEnvironment=1]="DisabledByEnvironment",j[j.ManuallyDisabled=2]="ManuallyDisabled",j[j.MissingConfiguration=3]="MissingConfiguration",j[j.InvalidConfiguration=4]="InvalidConfiguration",j[j.RunningAsAdmin=5]="RunningAsAdmin"})(R||(e.DisablementReason=R={})),e.$fX={Uninitialized:{type:"uninitialized"},Disabled:j=>({type:"disabled",reason:j}),Idle:(j,E)=>({type:"idle",updateType:j,error:E}),CheckingForUpdates:j=>({type:"checking for updates",explicit:j}),AvailableForDownload:j=>({type:"available for download",update:j}),Downloading:{type:"downloading"},Downloaded:j=>({type:"downloaded",update:j}),Updating:j=>({type:"updating",update:j}),Ready:j=>({type:"ready",update:j})},e.$gX=(0,n.$yi)("updateService")}),define(se[268],re([0,1,4,191,52,45]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.$fo.as(k.$ko.Configuration).registerConfiguration({id:"update",order:15,title:(0,C.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,C.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,C.localize)(2,null),(0,C.localize)(3,null),(0,C.localize)(4,null),(0,C.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,C.localize)(6,null),deprecationMessage:(0,C.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,C.localize)(8,null),description:(0,C.localize)(9,null),included:n.$i&&!n.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,C.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(se[269],re([0,1,3,50]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=e.$Idc=void 0;class k{constructor(E){this.a=E}listen(E,h){switch(h){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${h}`)}call(E,h,l){switch(h){case"checkForUpdates":return this.a.checkForUpdates(l);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(l)}throw new Error(`Call not found: ${h}`)}}e.$Idc=k;class R{get state(){return this.b}set state(E){this.b=E,this.a.fire(E)}constructor(E){this.c=E,this.a=new n.$fe,this.onStateChange=this.a.event,this.b=C.$fX.Uninitialized,this.c.listen("onStateChange")(h=>this.state=h),this.c.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(E){return this.c.call("checkForUpdates",E)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(E){return this.c.call("_applySpecificUpdate",E)}}e.$Jdc=R}),define(se[40],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=void 0,e.$Cl=(0,n.$yi)("IUriIdentityService")}),define(se[270],re([0,1,40,210,16,19,142,3,2]),function(K,e,n,C,k,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=void 0;class l{static{this._clock=0}constructor(v){this.uri=v,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let d=class{constructor(v){this.g=v,this.c=new h.$Tc,this.f=2**16;const $=new Map,f=y=>{let w=$.get(y.scheme);return w===void 0&&(w=v.hasProvider(y)&&!this.g.hasCapability(y,1024),$.set(y.scheme,w)),w};this.c.add(E.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(y=>{$.delete(y.scheme)})),this.extUri=new R.$1g(f),this.d=new j.$Cs((y,w)=>this.extUri.compare(y,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,R.$ah)(v));const $=this.d.get(v);return $?$.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new l(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((f,y)=>f[1].time<y[1].time?1:f[1].time>y[1].time?-1:0);l._clock=0,this.d.clear();const $=this.f*.5;for(let f=0;f<$;f++)this.d.set(v[f][0],v[f][1].touch())}};e.$Ds=d,e.$Ds=d=Ee([ie(0,k.$5k)],d),(0,C.$As)(n.$Cl,d,1)}),define(se[131],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9W=void 0,e.$9W=(0,n.$yi)("urlService")}),define(se[271],re([0,1,7]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=e.$Rdc=e.$Qdc=void 0;class C{constructor(E){this.a=E}listen(E,h){throw new Error(`Event not found: ${h}`)}call(E,h,l){switch(h){case"handleURL":return this.a.handleURL(n.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${h}`)}}e.$Qdc=C;class k{constructor(E){this.a=E}handleURL(E,h){return this.a.call("handleURL",[E.toJSON(),h])}}e.$Rdc=k;class R{constructor(E,h){this.a=E,this.b=h}async routeCall(E,h,l,d){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(l)&&l.length>0){const p=n.URI.revive(l[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",p.toString(!0)),p.query){const v=/\bwindowId=(\d+)/.exec(p.query);if(v){const $=v[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${$}"`,p.toString(!0));const f=new RegExp(`window:${$}`),y=E.connections.find(w=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",w.ctx),f.test(w.ctx)));if(y)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",p.toString(!0)),y;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",p.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",p.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(E,h,l,d)}routeEvent(E,h){throw new Error(`Event not found: ${h}`)}}e.$Sdc=R}),define(se[272],re([0,1,8,2,7,27]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$W=e.$0W=void 0;class j extends C.$Uc{constructor(){super(...arguments),this.a=new Set}open(l,d){const p=[...this.a.values()];return(0,n.$Ch)(p.map(v=>()=>v.handleURL(l,d)),void 0,!1).then(v=>v||!1)}registerHandler(l){return this.a.add(l),(0,C.$Sc)(()=>this.a.delete(l))}}e.$0W=j;let E=class extends j{constructor(l){super(),this.b=l}create(l){let{authority:d,path:p,query:v,fragment:$}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return d&&p&&p.indexOf("/")!==0&&(p=`/${p}`),k.URI.from({scheme:this.b.urlProtocol,authority:d,path:p,query:v,fragment:$})}};e.$$W=E,e.$$W=E=Ee([ie(0,R.$lk)],E)}),define(se[273],re([0,1,14,8,3,2,4,7]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class h extends R.$Uc{constructor(d,p,v,$,f,y){if(super(),this.c=p,this.f=y,this.a=[],this.b=0,d&&(y.trace("ElectronURLListener initialUrisToHandle:",d.map(c=>c.originalUrl)),this.a=d),j.$i){const c=$.isBuilt?[]:[`"${$.appRoot}"`];c.push("--open-url","--"),n.app.setAsDefaultProtocolClient(f.urlProtocol,process.execPath,c)}const w=k.Event.map(k.Event.fromNodeEventEmitter(n.app,"open-url",(c,m)=>({event:c,url:m})),({event:c,url:m})=>(c.preventDefault(),m));this.B(w(c=>{const m=this.g(c);m&&this.c.open(m,{originalUrl:c})})),v.getWindows().filter(c=>c.isReady).length>0?(y.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(y.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(k.Event.once(v.onDidSignalReadyWindow)(()=>this.h())))}g(d){try{return E.URI.parse(d)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const d=[];for(const p of this.a)await this.c.open(p.uri,{originalUrl:p.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",p.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",p.originalUrl),d.push(p));d.length!==0&&(this.a=d,(0,C.$Ah)(()=>this.h(),500,this.q))}}e.$Tdc=h}),define(se[274],re([0,1,3,2,16,59,32]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=void 0;class E extends C.$Uc{constructor(l,d,p,v,$,f){super(),this.f=l,this.g=d,this.h=p,this.j=v,this.m=$,this.n=f,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$fe),this.onDidChangeFile=this.a.event,this.b=R.$Ei.forUris(()=>!(this.capabilities&1024)),this.c=new j.$Bc(y=>this.m.extUri.getComparisonKey(this.t(y))),this.r(),this.B(v.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(y=>this.s(y)))}r(){this.c.clear();for(const l of this.j.profiles)this.c.add(l.settingsResource),this.c.add(l.keybindingsResource),this.c.add(l.tasksResource),this.c.add(l.extensionsResource)}open(l,d){return this.g.open(this.t(l),d)}close(l){return this.g.close(l)}read(l,d,p,v,$){return this.g.read(l,d,p,v,$)}write(l,d,p,v,$){return this.g.write(l,d,p,v,$)}watch(l,d){this.b.set(l,l);const p=this.g.watch(this.t(l),d);return(0,C.$Sc)(()=>{this.b.delete(l),p.dispose()})}stat(l){return this.g.stat(this.t(l))}mkdir(l){return this.g.mkdir(this.t(l))}rename(l,d,p){return this.g.rename(this.t(l),this.t(d),p)}readFile(l,d){return this.g.readFile(this.t(l),d)}readFileStream(l,d,p){return this.g.readFileStream(this.t(l),d,p)}readdir(l){return this.g.readdir(this.t(l))}enforceAtomicReadFile(l){return this.c.has(l)}writeFile(l,d,p){return this.g.writeFile(this.t(l),d,p)}enforceAtomicWriteFile(l){return this.c.has(l)?{postfix:".vsctmp"}:!1}delete(l,d){return this.g.delete(this.t(l),d)}copy(l,d,p){if((0,k.$9k)(this.g))return this.g.copy(this.t(l),this.t(d),p);throw new Error("copy not supported")}cloneFile(l,d){if((0,k.$0k)(this.g))return this.g.cloneFile(this.t(l),this.t(d));throw new Error("clone not supported")}s(l){const d=[];for(const p of l){if(p.resource.scheme!==this.f)continue;const v=this.u(p.resource);this.b.findSubstr(v)&&d.push({resource:v,type:p.type,cId:p.cId})}d.length&&(this.n.debug("User data changed"),this.a.fire(d))}t(l){return l.with({scheme:this.f})}u(l){return l.with({scheme:this.h})}}e.$uec=E}),define(se[275],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0,e.$bec="utilityProcessWorker"}),define(se[276],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0,e.$Udc=(0,n.$yi)("webviewManagerService")}),define(se[277],re([0,1,14,2,13,7]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;class j extends C.$Uc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const h=this.b.bind(this);n.protocol.registerFileProtocol(k.Schemas.vscodeWebview,h)}b(h,l){try{const d=R.URI.parse(h.url),p=j.a.get(d.path);if(typeof p=="string"){const v=`vs/workbench/contrib/webview/browser/pre/${p}`,$=k.$Sg.asFileUri(v);return l({path:$.fsPath,headers:{...k.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.$Vdc=j}),define(se[55],re([0,1,4]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MD=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$DD=void 0,e.$ED=C,e.$FD=k,e.$GD=R,e.$HD=j,e.$ID=E,e.$JD=p,e.$KD=v,e.$LD=$,e.$ND=f,e.$OD=y,e.$PD=w,e.$DD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function C(b){return typeof b.parentId=="number"}function k(b){return!!b.workspaceUri}function R(b){return!!b.folderUri}function j(b){return!!b.fileUri}function E(b){const c=v(b),m=b.getValue("window.menuBarVisibility");return m==="default"||c&&m==="compact"||n.$j&&n.$m?"classic":m}var h;(function(b){b.TITLE_BAR_STYLE="window.titleBarStyle",b.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(h||(e.TitleBarSetting=h={}));var l;(function(b){b.NATIVE="native",b.CUSTOM="custom"})(l||(e.TitlebarStyle=l={}));var d;(function(b){b.AUTO="auto",b.WINDOWED="windowed",b.NEVER="never"})(d||(e.CustomTitleBarVisibility=d={}));function p(b,c){return!0}function v(b,c){return c||(c=$(b)),c==="native"}function $(b){if(n.$o)return"custom";const c=b.getValue("window");if(c){if(n.$j&&c.nativeTabs===!0||n.$j&&c.nativeFullScreen===!1)return"native";const a=c.titleBarStyle;if(a==="native"||a==="custom")return a}return n.$k?"native":"custom"}e.$MD=35;function f(b){return!(!n.$i||n.$o||v(b))}function y(b){const c=b.getValue("window");return!c||typeof c.nativeFullScreen!="boolean"||c.nativeTabs?!0:c.nativeFullScreen!==!1}function w(b=0){return Math.pow(1.2,b)}}),define(se[82],re([0,1,14]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$mcc=e.$lcc=e.UnloadReason=e.LoadReason=void 0;var C;(function(l){l[l.INITIAL=1]="INITIAL",l[l.LOAD=2]="LOAD",l[l.RELOAD=3]="RELOAD"})(C||(e.LoadReason=C={}));var k;(function(l){l[l.CLOSE=1]="CLOSE",l[l.QUIT=2]="QUIT",l[l.RELOAD=3]="RELOAD",l[l.LOAD=4]="LOAD"})(k||(e.UnloadReason=k={}));const R=function(l=1){return{width:1024,height:768,mode:l}};e.$lcc=R;const j=function(){const p=n.screen.getPrimaryDisplay().workArea,v=Math.max(p.x+p.width/2-800/2,0),$=Math.max(p.y+p.height/2-600/2,0);return{x:v,y:$,width:800,height:600,mode:1}};e.$mcc=j;var E;(function(l){l[l.Maximized=0]="Maximized",l[l.Normal=1]="Normal",l[l.Minimized=2]="Minimized",l[l.Fullscreen=3]="Fullscreen"})(E||(e.WindowMode=E={}));var h;(function(l){l[l.UNRESPONSIVE=1]="UNRESPONSIVE",l[l.PROCESS_GONE=2]="PROCESS_GONE",l[l.LOAD=3]="LOAD"})(h||(e.WindowError=h={}))}),define(se[278],re([0,1,8,3,2]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;class R extends k.$Uc{constructor({onDidOpenMainWindow:E,onDidFocusMainWindow:h,getActiveWindowId:l}){super(),this.a=this.B(new k.$Tc),C.Event.latch(C.Event.any(E,h))(this.f,this,this.a),this.b=(0,n.$lh)(()=>l()),(async()=>{try{const p=await this.b;this.c=typeof this.c=="number"?this.c:p}catch{}finally{this.b=void 0}})()}f(E){this.b&&(this.b.cancel(),this.b=void 0),this.c=E}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$2dc=R}),define(se[30],re([0,1,195,9,59,19,7,6,13]),function(K,e,n,C,k,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Si=e.$Ri=e.WorkbenchState=e.$Li=e.$Ki=e.$Hi=void 0,e.$Ii=l,e.$Ji=d,e.$Mi=p,e.$Ni=v,e.$Oi=$,e.$Pi=y,e.$Qi=w,e.$Ti=m,e.$Yi=S,e.$Zi=a,e.$2i=t,e.$3i=r,e.$4i=s,e.$Hi=(0,E.$yi)("contextService");function l(i){const o=i;return typeof o?.id=="string"&&j.URI.isUri(o.uri)}function d(i){return typeof i?.id=="string"&&!l(i)&&!v(i)}e.$Ki={id:"ext-dev"},e.$Li={id:"empty-window"};function p(i,o){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,C.$nc)(i)}:o?e.$Ki:e.$Li;const u=i;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}function v(i){const o=i;return typeof o?.id=="string"&&j.URI.isUri(o.configPath)}function $(i){const o=i;if(o?.uri)return{id:o.id,uri:j.URI.revive(o.uri)};const u=i;if(u?.configPath)return{id:u.id,configPath:j.URI.revive(u.configPath)};if(i?.id)return{id:i.id}}var f;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function y(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}function w(i){const o=i;return!!(o&&typeof o=="object"&&j.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}class b{constructor(o,u,g,P,D){this.h=o,this.j=g,this.k=P,this.l=D,this.c=k.$Ei.forUris(this.l,()=>!0),this.folders=u}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=k.$Ei.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ri=b;class c{constructor(o,u){this.raw=u,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,R.$_g)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Si=c;function m(i){return new c({uri:i,index:0,name:(0,R.$8g)(i)},{uri:i.toString()})}e.$Ui="code-workspace",e.$Vi=`.${e.$Ui}`,e.$Wi=[{name:(0,n.localize)(0,null),extensions:[e.$Ui]}],e.$Xi="workspace.json";function S(i,o){return R.$3g.isEqualOrParent(i,o.untitledWorkspacesHome)}function a(i){let o;return j.URI.isUri(i)?o=i:o=i.configuration,o?.scheme===h.Schemas.tmp}e.$1i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$1i}function r(i,o){return!S(i,o)&&!a(i)}function s(i){return(typeof i=="string"?(0,C.$oc)(i):(0,R.$0g)(i))===e.$Vi}}),define(se[56],re([0,1,14,8,46,48,2,72,4,21,169,119,6,5,27,30]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=e.$tcc=void 0,e.$tcc=(0,v.$yi)("dialogMainService");let w=class{constructor(c,m){this.d=c,this.e=m,this.a=new Map,this.b=new Map,this.c=new C.$Fh}pickFileFolder(c,m){return this.f({...c,pickFolders:!0,pickFiles:!0,title:(0,d.localize)(0,null)},m)}pickFolder(c,m){return this.f({...c,pickFolders:!0,title:(0,d.localize)(1,null)},m)}pickFile(c,m){return this.f({...c,pickFiles:!0,title:(0,d.localize)(2,null)},m)}pickWorkspace(c,m){const S=(0,d.localize)(3,null),a=(0,R.$Nw)((0,d.localize)(4,null)),t=y.$Wi;return this.f({...c,pickFiles:!0,title:S,filters:t,buttonLabel:a},m)}async f(c,m){const S={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters,defaultPath:c.defaultPath};(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(S.properties=void 0,c.pickFiles&&c.pickFolders&&(S.properties=["multiSelections","openDirectory","openFile","createDirectory"])),S.properties||(S.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),h.$j&&S.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog(S,(m||n.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}g(c){if(c){let m=this.b.get(c.id);return m||(m=new C.$Fh,this.b.set(c.id,m)),m}else return this.c}showMessageBox(c,m){return this.g(m).queue(async()=>{const{options:S,buttonIndeces:a}=(0,p.$Uw)(c,this.e);let t;return m?t=await n.dialog.showMessageBox(m,S):t=await n.dialog.showMessageBox(S),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(c,m){const S=this.j(c,m);if(!S)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(m).queue(async()=>{let a;return m?a=await n.dialog.showSaveDialog(m,c):a=await n.dialog.showSaveDialog(c),a.filePath=this.h(a.filePath),a})}finally{(0,j.$Pc)(S)}}h(c){return c&&h.$j&&(c=(0,E.$dm)(c)),c}i(c){return c.map(m=>this.h(m))}async showOpenDialog(c,m){c.defaultPath&&(await l.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const S=this.j(c,m);if(!S)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(m).queue(async()=>{let a;return m?a=await n.dialog.showOpenDialog(m,c):a=await n.dialog.showOpenDialog(c),a.filePaths=this.i(a.filePaths),a})}finally{(0,j.$Pc)(S)}}j(c,m){if(!m)return j.$Uc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",c);let S=this.a.get(m.id);S||(S=new Set,this.a.set(m.id,S));const a=(0,k.$mj)(c);if(!S.has(a))return this.d.trace("[DialogMainService]: new file dialog lock created",c),S.add(a),(0,j.$Sc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",c),S?.delete(a),S?.size===0&&this.a.delete(m.id)})}};e.$ucc=w,e.$ucc=w=Ee([ie(0,$.$5j),ie(1,f.$lk)],w)}),define(se[279],re([0,1,3,2,77,30]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;class j extends C.$Uc{static{this.a=100}constructor(h,l){super(),this.f=h,this.g=l,this.b=this.B(new n.$fe),this.c=new Map,this.h(l.applicationStorage,this.b)}h(h,l){this.B(n.Event.debounce(h.onDidChangeStorage,(d,p)=>(d?d.push(p):d=[p],d),j.a)(d=>{d.length&&l.fire(this.j(d,h))}))}j(h,l){const d=new Map,p=new Set;return h.forEach(v=>{const $=l.get(v.key);typeof $=="string"?d.set(v.key,$):p.add(v.key)}),{changed:Array.from(d.entries()),deleted:Array.from(p.values())}}listen(h,l,d){switch(l){case"onDidChangeStorage":{const p=d.profile?(0,k.$8h)(d.profile):void 0;if(!p)return this.b.event;let v=this.c.get(p.id);return v||(v=this.B(new n.$fe),this.h(this.g.profileStorage(p),v),this.c.set(p.id,v)),v.event}}throw new Error(`Event not found: ${l}`)}async call(h,l,d){const p=d.profile?(0,k.$8h)(d.profile):void 0,v=(0,R.$Oi)(d.workspace),$=await this.m(p,v);switch(l){case"getItems":return Array.from($.items.entries());case"updateItems":{const f=d;if(f.insert)for(const[y,w]of f.insert)$.set(y,w);f.delete?.forEach(y=>$.delete(y));break}case"optimize":return $.optimize();case"isUsed":{const f=d.payload;if(typeof f=="string")return this.g.isUsed(f)}default:throw new Error(`Call not found: ${l}`)}}async m(h,l){let d;l?d=this.g.workspaceStorage(l):h?d=this.g.profileStorage(h):d=this.g.applicationStorage;try{await d.init()}catch(p){this.f.error(`StorageIPC#init: Unable to init ${l?"workspace":h?"profile":"application"} storage due to ${p}`)}return d}}e.$Fdc=j}),define(se[41],re([0,1,46,3,2,19,7,192,38,16,6,5,30,32,40,8,33,25,12]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$El=e.ProfileResourceType=void 0,e.$Dl=S,e.$Fl=a,e.$Gl=t;var m;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(m||(e.ProfileResourceType=m={}));function S(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&j.URI.isUri(o.location)&&j.URI.isUri(o.globalStorageHome)&&j.URI.isUri(o.settingsResource)&&j.URI.isUri(o.keybindingsResource)&&j.URI.isUri(o.tasksResource)&&j.URI.isUri(o.snippetsHome)&&j.URI.isUri(o.extensionsResource))}e.$El=(0,d.$yi)("IUserDataProfilesService");function a(i,o){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:j.URI.revive(i.location).with({scheme:o}),globalStorageHome:j.URI.revive(i.globalStorageHome).with({scheme:o}),settingsResource:j.URI.revive(i.settingsResource).with({scheme:o}),keybindingsResource:j.URI.revive(i.keybindingsResource).with({scheme:o}),tasksResource:j.URI.revive(i.tasksResource).with({scheme:o}),snippetsHome:j.URI.revive(i.snippetsHome).with({scheme:o}),extensionsResource:j.URI.revive(i.extensionsResource).with({scheme:o}),cacheHome:j.URI.revive(i.cacheHome).with({scheme:o}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,o,u,g,P,D){return{id:i,name:o,location:u,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:D&&P?.useDefaultFlags?.globalState?D.globalStorageHome:(0,R.$_g)(u,"globalStorage"),settingsResource:D&&P?.useDefaultFlags?.settings?D.settingsResource:(0,R.$_g)(u,"settings.json"),keybindingsResource:D&&P?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,R.$_g)(u,"keybindings.json"),tasksResource:D&&P?.useDefaultFlags?.tasks?D.tasksResource:(0,R.$_g)(u,"tasks.json"),snippetsHome:D&&P?.useDefaultFlags?.snippets?D.snippetsHome:(0,R.$_g)(u,"snippets"),extensionsResource:D&&P?.useDefaultFlags?.extensions?D.extensionsResource:(0,R.$_g)(u,"extensions.json"),cacheHome:(0,R.$_g)(g,i),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}let r=class extends k.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(o,u,g,P){super(),this.t=o,this.u=u,this.w=g,this.y=P,this.f=!0,this.h=this.B(new C.$fe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new C.$fe),this.onWillCreateProfile=this.j.event,this.m=this.B(new C.$fe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new C.$fe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new $.$Ac,emptyWindows:new Map},this.profilesHome=(0,R.$_g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$_g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(o){this.f!==o&&(this.z=void 0,this.f=o)}isEnabled(){return this.f}get C(){if(!this.z){const o=this.D(),u=[o];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,c.$$f)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}u.push(t((0,R.$9g)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},o))}}catch(D){this.y.error(D)}const g=new $.$Ac,P=new Map;if(u.length)try{const D=this.Q();if(D.workspaces)for(const[I,O]of Object.entries(D.workspaces)){const M=j.URI.parse(I),W=u.find(F=>F.id===O);W&&g.set(M,W)}if(D.emptyWindows)for(const[I,O]of Object.entries(D.emptyWindows)){const M=u.find(W=>W.id===O);M&&P.set(I,M)}}catch(D){this.y.error(D)}this.z={profiles:u,workspaces:g,emptyWindows:P}}return this.z}D(){const o=t("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...o,extensionsResource:this.S()??o.extensionsResource,isDefault:!0}}async createTransientProfile(o){const u="Temp",g=new RegExp(`${(0,b.$bf)(u)}\\s(\\d+)`);let P=0;for(const I of this.profiles){const O=g.exec(I.name),M=O?parseInt(O[1]):0;P=M>P?M:P}const D=`${u} ${P+1}`;return this.createProfile((0,n.$mj)((0,w.$Ug)()).toString(16),D,{transient:!0},o)}async createNamedProfile(o,u,g){return this.createProfile((0,n.$mj)((0,w.$Ug)()).toString(16),o,u,g)}async createProfile(o,u,g,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(o,u,g);return P&&await this.setProfileForWorkspace(P,D),D}async F(o,u,g){if(!(0,c.$$f)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(u);return P||(P=(async()=>{try{if(this.profiles.find(M=>M.name===u||M.id===o))throw new Error(`Profile with ${u} name already exists`);const I=t(o,u,(0,R.$_g)(this.profilesHome,o),this.g,g,this.defaultProfile);await this.u.createFolder(I.location);const O=[];return this.j.fire({profile:I,join(M){O.push(M)}}),await y.Promises.settled(O),this.I([I],[],[]),I}finally{this.r.delete(u)}})(),this.r.set(u,P)),P}async updateProfile(o,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let g=this.profiles.find(P=>P.id===o.id);if(!g)throw new Error(`Profile '${o.name}' does not exist`);return g=t(g.id,u.name??g.name,g.location,this.g,{shortName:u.shortName??g.shortName,icon:u.icon===null?void 0:u.icon??g.icon,transient:u.transient??g.isTransient,useDefaultFlags:u.useDefaultFlags??g.useDefaultFlags},this.defaultProfile),this.I([],[],[g]),g}async removeProfile(o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(o.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(P=>P.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);const g=[];this.m.fire({profile:u,join(P){g.push(P)}});try{await Promise.allSettled(g)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])u.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])u.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[u],[]);try{await this.u.del(u.cacheHome,{recursive:!0})}catch(P){(0,l.$jl)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(o,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=this.profiles.find(P=>P.id===u.id);if(!g)throw new Error(`Profile '${u.name}' does not exist`);this.L(o,g)}unsetWorkspace(o,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(o,void 0,u)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const o=await this.u.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(u=>u.isDirectory&&this.profiles.every(g=>!this.w.extUri.isEqual(g.location,u.resource))).map(u=>this.u.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const o=this.s.profiles.filter(u=>!this.H(u));await Promise.allSettled(o.map(u=>this.removeProfile(u)))}getProfileForWorkspace(o){const u=this.G(o);return j.URI.isUri(u)?this.s.workspaces.get(u)??this.C.workspaces.get(u):this.s.emptyWindows.get(u)??this.C.emptyWindows.get(u)}G(o){return(0,v.$Ii)(o)?o.uri:(0,v.$Ni)(o)?o.configPath:o.id}H(o){return!!([...this.s.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,o.location))||[...this.s.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,o.location))||[...this.C.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,o.location))||[...this.C.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,o.location)))}I(o,u,g){const P=[...this.profiles,...o],D=[];this.s.profiles=[];for(let I of P)I.isDefault||u.some(O=>I.id===O.id)||(I=g.find(O=>I.id===O.id)??I,I.isTransient?this.s.profiles.push(I):D.push({location:I.location,name:I.name,shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags}));this.P(D),this.z=void 0,this.J(o,u,g)}J(o,u,g){this.h.fire({added:o,removed:u,updated:g,all:this.profiles})}L(o,u,g){g=u?.isTransient?!0:g,g||this.L(o,void 0,!0);const P=this.G(o),D=g?this.s:this.C;j.URI.isUri(P)?(D.workspaces.delete(P),u&&D.workspaces.set(P,u)):(D.emptyWindows.delete(P),u&&D.emptyWindows.set(P,u)),g||this.M()}M(){const o={};for(const[g,P]of this.C.workspaces.entries())o[g.toString()]=P.id;const u={};for(const[g,P]of this.C.emptyWindows.entries())u[g.toString()]=P.id;this.R({workspaces:o,emptyWindows:u}),this.z=void 0}N(o){const u={},g=this.D();if(o.workspaces)for(const[D,I]of Object.entries(o.workspaces)){const O=j.URI.parse(I);u[D]=this.w.extUri.isEqual(O,g.location)?g.id:this.w.extUri.basename(O)}const P={};if(o.emptyWindows)for(const[D,I]of Object.entries(o.emptyWindows)){const O=j.URI.parse(I);P[D]=this.w.extUri.isEqual(O,g.location)?g.id:this.w.extUri.basename(O)}return{workspaces:u,emptyWindows:P}}O(){return[]}P(o){throw new Error("not implemented")}Q(){return{}}R(o){throw new Error("not implemented")}S(){}};e.$Hl=r,e.$Hl=r=Ee([ie(0,h.$Fi),ie(1,l.$5k),ie(2,f.$Cl),ie(3,p.$5j)],r);class s extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(o){this.a=o}Q(){return this.X}R(o){this.X=o}}e.$Il=s}),define(se[83],re([0,1,8,17,2,3,32,7,121,127,16,6,5,41,40,12,15,28]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=e.$rq=e.ExtensionsProfileScanningErrorCode=void 0;var c;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(c||(e.ExtensionsProfileScanningErrorCode=c={}));class m extends Error{constructor(s,i){super(s),this.code=i}}e.$rq=m,e.$sq=(0,p.$yi)("IExtensionsProfileScannerService");let S=class extends k.$Uc{constructor(s,i,o,u,g,P){super(),this.j=s,this.m=i,this.n=o,this.r=u,this.s=g,this.t=P,this.b=this.B(new R.$fe),this.onAddExtensions=this.b.event,this.c=this.B(new R.$fe),this.onDidAddExtensions=this.c.event,this.f=this.B(new R.$fe),this.onRemoveExtensions=this.f.event,this.g=this.B(new R.$fe),this.onDidRemoveExtensions=this.g.event,this.h=new j.$Ac}scanProfileExtensions(s,i){return this.u(s,void 0,i)}async addExtensionsToProfile(s,i,o){const u=[],g=[];try{return await this.u(i,P=>{const D=[];if(o)D.push(...P);else for(const I of P)s.some(([O])=>(0,l.$xp)(O.identifier,I.identifier)&&O.manifest.version!==I.version)?u.push(I):D.push(I);for(const[I,O]of s){const M=D.findIndex(F=>(0,l.$xp)(F.identifier,I.identifier)&&F.version===I.manifest.version),W={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:O};M===-1?(g.push(W),D.push(W)):D.splice(M,1,W)}return g.length&&this.b.fire({extensions:g,profileLocation:i}),u.length&&this.f.fire({extensions:u,profileLocation:i}),D}),g.length&&this.c.fire({extensions:g,profileLocation:i}),u.length&&this.g.fire({extensions:u,profileLocation:i}),g}catch(P){throw g.length&&this.c.fire({extensions:g,error:P,profileLocation:i}),u.length&&this.g.fire({extensions:u,error:P,profileLocation:i}),P}}async updateMetadata(s,i){const o=[];return await this.u(i,u=>{const g=[];for(const P of u){const D=s.find(([I])=>(0,l.$xp)(I.identifier,P.identifier)&&I.manifest.version===P.version);D&&(P.metadata={...P.metadata,...D[1]},o.push(P)),g.push(P)}return g}),o}async removeExtensionFromProfile(s,i){const o=[];try{await this.u(i,u=>{const g=[];for(const P of u)(0,l.$xp)(P.identifier,s.identifier)?o.push(P):g.push(P);return o.length&&this.f.fire({extensions:o,profileLocation:i}),g}),o.length&&this.g.fire({extensions:o,profileLocation:i})}catch(u){throw o.length&&this.g.fire({extensions:o,error:u,profileLocation:i}),u}}async u(s,i,o){return this.F(s).queue(async()=>{let u=[],g;try{const P=await this.m.readFile(s);g=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,d.$jl)(P)!==1)throw P;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&(g=await this.D()),!g&&o?.bailOutWhenFileNotFound)throw new m((0,w.$0)(P),"ERROR_PROFILE_NOT_FOUND")}if(g){Array.isArray(g)||this.w(s);let P=!1;for(const D of g){a(D)||this.w(s);let I;if((0,y.$$f)(D.relativeLocation)&&D.relativeLocation)I=this.z(D.relativeLocation);else if((0,y.$$f)(D.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${D.location}`);continue}else{I=E.URI.revive(D.location);const O=this.y(I);O&&(P=!0,D.relativeLocation=O)}(0,y.$fg)(D.metadata?.hasPreReleaseVersion)&&D.metadata?.preRelease&&(P=!0,D.metadata.hasPreReleaseVersion=!0),u.push({identifier:D.identifier,location:I,version:D.version,metadata:D.metadata})}P&&await this.m.writeFile(s,C.$He.fromString(JSON.stringify(g)))}if(i){u=i(u);const P=u.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(s,C.$He.fromString(JSON.stringify(P)))}return u})}w(s){const i=new m(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let o;try{o=(await this.m.readFile(s)).value.toString()}catch(g){if((0,d.$jl)(g)===1)return;throw g}this.t.info("Migrating extensions from old default profile location",s.toString());let u;try{const g=JSON.parse(o);Array.isArray(g)&&g.every(P=>a(P))?u=g:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",g)}catch(g){this.t.error(g)}if(u)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,C.$He.fromString(JSON.stringify(u)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(g){if((0,d.$jl)(g)===3)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw g}try{await this.m.del(s)}catch(g){(0,d.$jl)(g)!==1&&this.t.error(g)}try{await this.m.del(i)}catch(g){(0,d.$jl)(g)!==1&&this.t.error(g)}return u})()),this.C}F(s){let i=this.h.get(s);return i||(i=new n.$Fh,this.h.set(s,i)),i}};e.$tq=S,e.$tq=S=Ee([ie(1,d.$5k),ie(2,$.$El),ie(3,f.$Cl),ie(4,b.$4l),ie(5,v.$5j)],S);function a(r){return(0,y.$ag)(r)&&(0,h.$8o)(r.identifier)&&(t(r.location)||(0,y.$$f)(r.location)&&r.location)&&((0,y.$fg)(r.relativeLocation)||(0,y.$$f)(r.relativeLocation))&&r.version&&(0,y.$$f)(r.version)}function t(r){return r?(0,y.$$f)(r.path)&&(0,y.$$f)(r.scheme):!1}}),define(se[132],re([0,1,22,8,35,17,15,42,154,2,13,9,4,19,208,74,12,7,174,38,127,124,207,16,6,5,27,3,77,83,41,40,206]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w,b,c,m,S,a,t,r,s,i,o,u,g,P,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$yq=e.$xq=e.$wq=e.Translations=void 0,e.$zq=ae;var M;(function(ce){function J(V,q){if(V===q)return!0;const L=Object.keys(V),B=new Set;for(const H of Object.keys(q))B.add(H);if(L.length!==B.size)return!1;for(const H of L){if(V[H]!==q[H])return!1;B.delete(H)}return B.size===0}ce.equals=J})(M||(e.Translations=M={})),e.$wq=(0,s.$yi)("IExtensionsScannerService");let W=class extends l.$Uc{constructor(J,V,q,L,B,H,oe,G,le,Q,A,N){super(),this.systemExtensionsLocation=J,this.userExtensionsLocation=V,this.r=q,this.s=L,this.t=B,this.u=H,this.w=oe,this.y=G,this.z=le,this.C=Q,this.D=A,this.F=N,this.g=this.B(new u.$fe),this.onDidChangeCache=this.g.event,this.h=(0,$.$_g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(U,this.s,this.h)),this.m=this.B(this.F.createInstance(U,this.s,this.h)),this.n=this.B(this.F.createInstance(T,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,S.$Ip)(this.w,this.y)),this.G}async scanAllExtensions(J,V,q){const[L,B]=await Promise.all([this.scanSystemExtensions(J),this.scanUserExtensions(V)]),H=q?await this.scanExtensionsUnderDevelopment(J,[...L,...B]):[];return this.L(L,B,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(J){const V=[];V.push(this.M(!!J.useCache,J.language)),V.push(this.N(J.language,!!J.checkControlFile));const[q,L]=await Promise.all(V);return this.J([...q,...L],0,J,!1)}async scanUserExtensions(J){const V=J.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",V);const q=this.D.extUri.isEqual(J.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,L=await this.P(V,!!J.profileLocation,1,!J.includeUninstalled,J.language,!0,q,J.productVersion??this.R()),B=J.useCache&&!L.devMode&&L.excludeObsolete?this.m:this.n;let H;try{H=await B.scanExtensions(L)}catch(oe){if(oe instanceof P.$rq&&oe.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),H=await B.scanExtensions(L);else throw oe}return H=await this.J(H,1,J,!0),this.y.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(J,V){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(L=>L.scheme===d.Schemas.file).map(async L=>{const B=await this.P(L,!1,1,!0,J.language,!1,void 0,J.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(B)).map(oe=>(oe.type=V.find(G=>(0,S.$xp)(G.identifier,oe.identifier))?.type??oe.type,this.n.validate(oe,B)))}))).flat();return this.J(q,"development",J,!0)}return[]}async scanExistingExtension(J,V,q){const L=await this.P(J,!1,V,!0,q.language,!0,void 0,q.productVersion??this.R()),B=await this.n.scanExtension(L);return!B||!q.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(J,V,q){const L=await this.P(J,!1,V,!0,q.language,!0,void 0,q.productVersion??this.R()),B=await this.n.scanOneOrMultipleExtensions(L);return this.J(B,V,q,!0)}async scanMultipleExtensions(J,V,q){const L=[];return await Promise.all(J.map(async B=>{const H=await this.scanOneOrMultipleExtensions(B,V,q);L.push(...H)})),this.J(L,V,q,!0)}async scanMetadata(J){const V=(0,$.$_g)(J,"package.json"),q=(await this.w.readFile(V)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(J,V){const q=(0,$.$_g)(J,"package.json"),L=(await this.w.readFile(q)).value.toString(),B=JSON.parse(L);V.isMachineScoped===!1&&delete V.isMachineScoped,V.isBuiltin===!1&&delete V.isBuiltin,B.__metadata={...B.__metadata,...V},await this.w.writeFile((0,$.$_g)(J,"package.json"),R.$He.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(J){if(J instanceof P.$rq&&J.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw J}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const J=await this.scanUserExtensions({includeInvalid:!0});if(J.length)await this.u.addExtensionsToProfile(J.map(V=>[V,V.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,R.$He.fromString(JSON.stringify([])))}catch(V){(0,r.$jl)(V)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,j.$0)(V))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(J){this.y.error(J)}finally{this.H=void 0}})()),this.H}async J(J,V,q,L){return q.includeAllVersions||(J=this.L(V===0?J:void 0,V===1?J:void 0,V==="development"?J:void 0,await this.getTargetPlatform(),L)),q.includeInvalid||(J=J.filter(B=>B.isValid)),J.sort((B,H)=>{const oe=p.$nc(B.location.fsPath),G=p.$nc(H.location.fsPath);return oe<G?-1:oe>G?1:0})}L(J,V,q,L,B){const H=(G,le,Q)=>{if(G.isValid&&!le.isValid)return!1;if(G.isValid===le.isValid){if(B&&f.gt(G.manifest.version,le.manifest.version))return this.y.debug(`Skipping extension ${le.location.path} with lower version ${le.manifest.version} in favour of ${G.location.path} with version ${G.manifest.version}`),!1;if(f.eq(G.manifest.version,le.manifest.version)){if(G.type===0)return this.y.debug(`Skipping extension ${le.location.path} in favour of system extension ${G.location.path} with same version`),!1;if(G.targetPlatform===L)return this.y.debug(`Skipping extension ${le.location.path} from different target platform ${le.targetPlatform}`),!1}}return Q?this.y.warn(`Overwriting user extension ${G.location.path} with ${le.location.path}.`):this.y.debug(`Overwriting user extension ${G.location.path} with ${le.location.path}.`),!0},oe=new a.$Vm;return J?.forEach(G=>{const le=oe.get(G.identifier.id);(!le||H(le,G,!1))&&oe.set(G.identifier.id,G)}),V?.forEach(G=>{const le=oe.get(G.identifier.id);if(!le&&J&&G.type===0){this.y.debug(`Skipping obsolete system extension ${G.location.path}.`);return}(!le||H(le,G,!1))&&oe.set(G.identifier.id,G)}),q?.forEach(G=>{const le=oe.get(G.identifier.id);(!le||H(le,G,!0))&&oe.set(G.identifier.id,G),oe.set(G.identifier.id,G)}),[...oe.values()]}async M(J,V){this.y.trace("Started scanning system extensions");const q=await this.P(this.systemExtensionsLocation,!1,0,!0,V,!0,void 0,this.R()),B=await(J&&!q.devMode?this.j:this.n).scanExtensions(q);return this.y.trace("Scanned system extensions:",B.length),B}async N(J,V){const q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!q?.length)return[];this.y.trace("Started scanning dev system extensions");const L=V?await this.O():{},B=[],H=b.URI.file(p.$hc(p.$jc(d.$Sg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const G of q){const le=L[G.name]||"marketplace";switch(le){case"disabled":break;case"marketplace":B.push((0,$.$_g)(H,G.name));break;default:B.push(b.URI.file(le));break}}const oe=await Promise.all(B.map(async G=>this.n.scanExtension(await this.P(G,!1,0,!0,J,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",oe.length),(0,n.$Hb)(oe)}async O(){try{const J=await this.w.readFile(this.r);return JSON.parse(J.value.toString())}catch{return{}}}async P(J,V,q,L,B,H,oe,G){const le=await this.f(B??v.$w),Q=await this.Q(J),A=V&&!this.D.extUri.isEqual(J,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,N=A?await this.Q(A):void 0;return new F(J,Q,A,N,V,oe,q,L,H,G.version,G.date,this.C.commit,!this.z.isBuilt,B,le)}async Q(J){try{const V=await this.w.stat(J);if(typeof V.mtime=="number")return V.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$xq=W,e.$xq=W=Ee([ie(4,D.$El),ie(5,P.$sq),ie(6,r.$5k),ie(7,i.$5j),ie(8,m.$Fi),ie(9,o.$lk),ie(10,I.$Cl),ie(11,s.$xi)],W);class F{constructor(J,V,q,L,B,H,oe,G,le,Q,A,N,_,z,Y){this.location=J,this.mtime=V,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=L,this.profile=B,this.profileScanOptions=H,this.type=oe,this.excludeObsolete=G,this.validate=le,this.productVersion=Q,this.productDate=A,this.productCommit=N,this.devMode=_,this.language=z,this.translations=Y}static createNlsConfiguration(J){return{language:J.language,pseudo:J.language==="pseudo",devMode:J.devMode,translations:J.translations}}static equals(J,V){return(0,$.$5g)(J.location,V.location)&&J.mtime===V.mtime&&(0,$.$5g)(J.applicationExtensionslocation,V.applicationExtensionslocation)&&J.applicationExtensionslocationMtime===V.applicationExtensionslocationMtime&&J.profile===V.profile&&k.$9n(J.profileScanOptions,V.profileScanOptions)&&J.type===V.type&&J.excludeObsolete===V.excludeObsolete&&J.validate===V.validate&&J.productVersion===V.productVersion&&J.productDate===V.productDate&&J.productCommit===V.productCommit&&J.devMode===V.devMode&&J.language===V.language&&M.equals(J.translations,V.translations)}}e.$yq=F;let T=class extends l.$Uc{constructor(J,V,q,L,B){super(),this.f=J,this.g=V,this.h=q,this.j=L,this.m=B}async scanExtensions(J){const V=J.profile?await this.r(J):await this.n(J);let q={};if(J.excludeObsolete&&J.type===1)try{const L=(await this.j.readFile(this.f)).value.toString();q=JSON.parse(L)}catch{}return(0,w.$lg)(q)?V:V.filter(L=>!q[S.$yp.create(L).toString()])}async n(J){const V=await this.j.resolve(J.location);if(!V.children?.length)return[];const q=await Promise.all(V.children.map(async L=>{if(!L.isDirectory||J.type===1&&(0,$.$9g)(L.resource).indexOf(".")===0)return null;const B=new F(L.resource,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(B)}));return(0,n.$Hb)(q).sort((L,B)=>L.location.path<B.location.path?-1:1)}async r(J){let V=await this.s(J.location,()=>!0,J);if(J.applicationExtensionslocation&&!this.h.extUri.isEqual(J.location,J.applicationExtensionslocation)){V=V.filter(L=>!L.metadata?.isApplicationScoped);const q=await this.s(J.applicationExtensionslocation,L=>!!L.metadata?.isBuiltin||!!L.metadata?.isApplicationScoped,J);V.push(...q)}return V}async s(J,V,q){const L=await this.g.scanProfileExtensions(J,q.profileScanOptions);if(!L.length)return[];const B=await Promise.all(L.map(async H=>{if(V(H)){const oe=new F(H.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(oe,H.metadata)}return null}));return(0,n.$Hb)(B)}async scanOneOrMultipleExtensions(J){try{if(await this.j.exists((0,$.$_g)(J.location,"package.json"))){const V=await this.scanExtension(J);return V?[V]:[]}else return await this.scanExtensions(J)}catch(V){return this.m.error(`Error scanning extensions at ${J.location.path}:`,(0,j.$0)(V)),[]}}async scanExtension(J,V){try{let q=await this.scanExtensionManifest(J.location);if(q){q.publisher||(q.publisher=a.$Pm),V=V??q.__metadata,delete q.__metadata;const L=(0,S.$Cp)(q.publisher,q.name),B=V?.id?{id:L,uuid:V.id}:{id:L},H=V?.isSystem?0:J.type,oe=H===0||!!V?.isBuiltin;q=await this.t(J.location,q,F.createNlsConfiguration(J));const G={type:H,identifier:B,manifest:q,location:J.location,isBuiltin:oe,targetPlatform:V?.targetPlatform??"undefined",publisherDisplayName:V?.publisherDisplayName,metadata:V,isValid:!0,validations:[]};return J.validate?this.validate(G,J):G}}catch(q){J.type!==0&&this.m.error(q)}return null}validate(J,V){let q=!0;const L=(0,t.$Np)(V.productVersion,V.productDate,V.location,J.manifest,J.isBuiltin);for(const[B,H]of L)B===y.default.Error&&(q=!1,this.m.error(this.z(V.location,H)));return J.isValid=q,J.validations=L,J}async scanExtensionManifest(J){const V=(0,$.$_g)(J,"package.json");let q;try{q=(await this.j.readFile(V)).value.toString()}catch(B){return(0,r.$jl)(B)!==1&&this.m.error(this.z(J,(0,c.localize)(0,null,V.path,B.message))),null}let L;try{L=JSON.parse(q)}catch{const H=[];(0,E.$Ln)(q,H);for(const oe of H)this.m.error(this.z(J,(0,c.localize)(1,null,V.path,oe.offset,oe.length,(0,h.$uq)(oe.error))));return null}return(0,E.$Un)(L)!=="object"?(this.m.error(this.z(J,(0,c.localize)(2,null,V.path))),null):L}async t(J,V,q){const L=await this.u(J,V,q);if(L)try{const B=[],H=await this.w(L.default,B);if(B.length>0)return B.forEach(G=>{this.m.error(this.z(J,(0,c.localize)(3,null,L.default?.path,(0,h.$uq)(G.error))))}),V;if((0,E.$Un)(L)!=="object")return this.m.error(this.z(J,(0,c.localize)(4,null,L.default?.path))),V;const oe=L.values||Object.create(null);return(0,O.$vq)(this.m,V,oe,H)}catch{}return V}async u(J,V,q){const L=(0,$.$_g)(J,"package.nls.json"),B=(le,Q)=>{Q.forEach(A=>{this.m.error(this.z(J,(0,c.localize)(5,null,le?.path,(0,h.$uq)(A.error))))})},H=le=>{this.m.error(this.z(J,(0,c.localize)(6,null,le?.path)))},oe=`${V.publisher}.${V.name}`,G=q.translations[oe];if(G)try{const le=b.URI.file(G),Q=(await this.j.readFile(le)).value.toString(),A=[],N=(0,E.$Ln)(Q,A);return A.length>0?(B(le,A),{values:void 0,default:L}):(0,E.$Un)(N)!=="object"?(H(le),{values:void 0,default:L}):{values:N.contents?N.contents.package:void 0,default:L}}catch{return{values:void 0,default:L}}else{if(!await this.j.exists(L))return;let Q;try{Q=await this.y(J,q)}catch{return}if(!Q.localized)return{values:void 0,default:Q.original};try{const A=(await this.j.readFile(Q.localized)).value.toString(),N=[],_=(0,E.$Ln)(A,N);return N.length>0?(B(Q.localized,N),{values:void 0,default:Q.original}):(0,E.$Un)(_)!=="object"?(H(Q.localized),{values:void 0,default:Q.original}):{values:_,default:Q.original}}catch{return{values:void 0,default:Q.original}}}}async w(J,V){if(J)try{const q=(await this.j.readFile(J)).value.toString();return(0,E.$Ln)(q,V)}catch{}}y(J,V){return new Promise((q,L)=>{const B=H=>{const oe=(0,$.$_g)(J,`package.nls.${H}.json`);this.j.exists(oe).then(G=>{G&&q({localized:oe,original:(0,$.$_g)(J,"package.nls.json")});const le=H.lastIndexOf("-");le===-1?q({localized:(0,$.$_g)(J,"package.nls.json"),original:null}):(H=H.substring(0,le),B(H))})};if(V.devMode||V.pseudo||!V.language)return q({localized:(0,$.$_g)(J,"package.nls.json"),original:null});B(V.language)})}z(J,V){return`[${J.path}]: ${V}`}};T=Ee([ie(1,P.$sq),ie(2,I.$Cl),ie(3,r.$5k),ie(4,i.$5j)],T);let U=class extends T{constructor(J,V,q,L,B,H,oe){super(V,L,B,H,oe),this.G=J,this.H=q,this.D=this.B(new C.$wh(3e3)),this.F=this.B(new u.$fe),this.onDidChangeCache=this.F.event}async scanExtensions(J){const V=this.M(J),q=await this.I(V);if(this.C=J,q&&q.input&&F.equals(q.input,this.C))return this.m.debug("Using cached extensions scan result",J.location.toString()),this.D.trigger(()=>this.L()),q.result.map(B=>(B.location=b.URI.revive(B.location),B));const L=await super.scanExtensions(J);return await this.J(V,{input:J,result:L}),L}async I(J){try{const V=await this.j.readFile(J),q=JSON.parse(V.value.toString());return{result:q.result,input:(0,g.$8h)(q.input)}}catch(V){this.m.debug("Error while reading the extension cache file:",J.path,(0,j.$0)(V))}return null}async J(J,V){try{await this.j.writeFile(J,R.$He.fromString(JSON.stringify(V)))}catch(q){this.m.debug("Error while writing the extension cache file:",J.path,(0,j.$0)(q))}}async L(){if(!this.C)return;const J=this.M(this.C),V=await this.I(J);if(!V)return;const q=V.result,L=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!k.$9n(L,q))try{this.m.info("Invalidating Cache",q,L),await this.j.del(J),this.F.fire()}catch(B){this.m.error(B)}}M(J){const V=this.N(J);return this.h.extUri.joinPath(V.cacheHome,J.type===0?a.$Om:a.$Nm)}N(J){return J.type===0?this.H.defaultProfile:J.profile?this.h.extUri.isEqual(J.location,this.G.extensionsResource)?this.G:this.H.profiles.find(V=>this.h.extUri.isEqual(J.location,V.extensionsResource))??this.G:this.H.defaultProfile}};U=Ee([ie(2,D.$El),ie(3,P.$sq),ie(4,I.$Cl),ie(5,r.$5k),ie(6,i.$5j)],U);function ae(ce,J){const V=(0,S.$Ap)(ce.manifest.publisher,ce.manifest.name);return{id:V,identifier:new a.$Tm(V),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:J,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,publisherDisplayName:ce.publisherDisplayName,...ce.manifest}}class te extends W{constructor(J,V,q,L,B,H,oe,G,le,Q,A,N){super(J,V,(0,$.$_g)(q,".vscode-oss-dev","extensions","control.json"),L,B,H,oe,G,le,Q,A,N),this.S=(async()=>{if(v.$z)try{const _=await this.w.readFile(b.URI.file(v.$z));return JSON.parse(_.value.toString())}catch{}return Object.create(null)})()}f(J){return this.S}}e.$Aq=te}),define(se[280],re([0,1,5,41,40,28,83,16,38,7]),function(K,e,n,C,k,R,j,E,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=void 0;let d=class extends j.$tq{constructor(v,$,f,y,w,b){super(l.URI.file(v.extensionsPath),$,f,y,w,b)}};e.$_P=d,e.$_P=d=Ee([ie(0,h.$Gi),ie(1,E.$5k),ie(2,C.$El),ie(3,k.$Cl),ie(4,R.$4l),ie(5,n.$5j)],d)}),define(se[281],re([0,1,7,38,83,132,16,6,5,27,40,41]),function(K,e,n,C,k,R,j,E,h,l,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=void 0;let v=class extends R.$Aq{constructor(f,y,w,b,c,m,S,a){super(n.URI.file(c.builtinExtensionsPath),n.URI.file(c.extensionsPath),c.userHome,f.defaultProfile,f,y,w,b,c,m,S,a)}};e.$6dc=v,e.$6dc=v=Ee([ie(0,p.$El),ie(1,k.$sq),ie(2,j.$5k),ie(3,h.$5j),ie(4,C.$Gi),ie(5,l.$lk),ie(6,d.$Cl),ie(7,E.$xi)],v)}),define(se[282],re([0,1,14,2,13,9,4,59,7,33,37,38,5,41]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=void 0;let f=class extends C.$Uc{constructor(w,b,c){super(),this.c=w,this.f=c,this.a=E.$Ei.forPaths(!j.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(w.appRoot),this.addValidFileRoot(w.extensionsPath),this.addValidFileRoot(b.defaultProfile.globalStorageHome.with({scheme:k.Schemas.file}).fsPath),this.addValidFileRoot(w.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:w}=n.session;w.protocol.registerFileProtocol(k.Schemas.vscodeFileResource,(b,c)=>this.j(b,c)),w.protocol.interceptFileProtocol(k.Schemas.file,(b,c)=>this.h(b,c)),this.B((0,C.$Sc)(()=>{w.protocol.unregisterProtocol(k.Schemas.vscodeFileResource),w.protocol.uninterceptProtocol(k.Schemas.file)}))}addValidFileRoot(w){const b=(0,R.$hc)(w);return this.a.get(b)?C.$Uc.None:(this.a.set(b,!0),(0,C.$Sc)(()=>this.a.delete(b)))}h(w,b){const c=h.URI.parse(w.url);return this.f.error(`Refused to load resource ${c.fsPath} from ${k.Schemas.file}: protocol (original URL: ${w.url})`),b({error:-3})}j(w,b){const c=this.m(w);let m;return this.c.crossOriginIsolated&&((0,R.$nc)(c)==="workbench.html"||(0,R.$nc)(c)==="workbench-dev.html"?m=k.COI.CoopAndCoep:m=k.COI.getHeadersFromQuery(w.url)),this.a.findSubstr(c)?b({path:c,headers:m}):this.b.has((0,R.$oc)(c).toLowerCase())?b({path:c}):(this.f.error(`${k.Schemas.vscodeFileResource}: Refused to load resource ${c} from ${k.Schemas.vscodeFileResource}: protocol (original URL: ${w.url})`),b({error:-3}))}m(w){const b=h.URI.parse(w.url),c=k.$Sg.uriToFileUri(b);return(0,R.$hc)(c.fsPath)}createIPCObjectUrl(){let w;const b=h.URI.from({scheme:"vscode",path:(0,l.$Ug)()}),c=b.toString(),m=async()=>w;return d.$hW.handle(c,m),this.f.trace(`IPC Object URL: Registered new channel ${c}.`),{resource:b,update:S=>w=S,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${c}.`),d.$hW.removeHandler(c)}}}};e.$lec=f,e.$lec=f=Ee([ie(0,p.$Gi),ie(1,$.$El),ie(2,v.$5j)],f)}),define(se[97],re([0,1,8,3,2,66,12,115,6,41]),function(K,e,n,C,k,R,j,E,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$6p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$4p=e.$3p=e.$2p=void 0,e.$5p=$,e.$7p=y,e.$9p=b,e.$2p="__$__isNewStorageMarker",e.$3p="__$__targetStorageMarker",e.$4p=(0,h.$yi)("storageService");var d;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(d||(e.WillSaveStateReason=d={}));var p;(function(c){c[c.APPLICATION=-1]="APPLICATION",c[c.PROFILE=0]="PROFILE",c[c.WORKSPACE=1]="WORKSPACE"})(p||(e.StorageScope=p={}));var v;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function $(c){const m=c.get(e.$3p);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}class f extends k.$Uc{static{this.a=60*1e3}constructor(m={flushInterval:f.a}){super(),this.m=m,this.b=this.B(new C.$ie),this.c=this.B(new C.$ie),this.onDidChangeTarget=this.c.event,this.f=this.B(new C.$fe),this.onWillSaveState=this.f.event,this.h=this.B(new n.$Kh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new k.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(m,S,a){return C.Event.filter(this.b.event,t=>t.scope===m&&(S===void 0||t.key===S),a)}n(){this.j.value=(0,n.$Oh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,k.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(m,S){const{key:a,external:t}=S;if(a===e.$3p){switch(m){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:m})}else this.b.fire({scope:m,key:a,target:this.J(m)[a],external:t})}w(m){this.f.fire({reason:m})}get(m,S,a){return this.P(S)?.get(m,a)}getBoolean(m,S,a){return this.P(S)?.getBoolean(m,a)}getNumber(m,S,a){return this.P(S)?.getNumber(m,a)}getObject(m,S,a){return this.P(S)?.getObject(m,a)}storeAll(m,S){this.y(()=>{for(const a of m)this.store(a.key,a.value,a.scope,a.target,S)})}store(m,S,a,t,r=!1){if((0,j.$hg)(S)){this.remove(m,a,r);return}this.y(()=>{this.z(m,a,t),this.P(a)?.set(m,S,r)})}remove(m,S,a=!1){this.y(()=>{this.z(m,S,void 0),this.P(S)?.delete(m,a)})}y(m){this.b.pause(),this.c.pause();try{m()}finally{this.b.resume(),this.c.resume()}}keys(m,S){const a=[],t=this.J(m);for(const r of Object.keys(t))t[r]===S&&a.push(r);return a}z(m,S,a,t=!1){const r=this.J(S);typeof a=="number"?r[m]!==a&&(r[m]=a,this.P(S)?.set(e.$3p,JSON.stringify(r),t)):typeof r[m]=="number"&&(delete r[m],this.P(S)?.set(e.$3p,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(m){switch(m){case-1:return this.I;case 0:return this.G;default:return this.D}}L(m){const S=this.P(m);return S?$(S):Object.create(null)}isNew(m){return this.getBoolean(e.$2p,m)===!0}async flush(m=d.NONE){this.f.fire({reason:m});const S=this.P(-1),a=this.P(0),t=this.P(1);switch(m){case d.NONE:await n.Promises.settled([S?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case d.SHUTDOWN:await n.Promises.settled([S?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.P(-1)?.items??new Map,S=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return b(m,S,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(m){return await this.flush(),this.P(m)?.optimize()}async switch(m,S){return this.w(d.NONE),(0,l.$Dl)(m)?this.R(m,S):this.S(m,S)}M(m,S){return!(m.id===S.id||y(S)&&y(m))}N(m,S,a){this.y(()=>{const t=new Set;for(const[r,s]of m)t.add(r),S.get(r)!==s&&this.u(a,{key:r,external:!0});for(const[r]of S.items)t.has(r)||this.u(a,{key:r,external:!0})})}}e.$6p=f;function y(c){return c.isDefault||!!c.useDefaultFlags?.globalState}class w extends f{constructor(){super(),this.U=this.B(new E.$Zp(new E.$1p,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$Zp(new E.$1p,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$Zp(new E.$1p,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(m=>this.u(1,m))),this.B(this.W.onDidChangeStorage(m=>this.u(0,m))),this.B(this.U.onDidChangeStorage(m=>this.u(-1,m)))}P(m){switch(m){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(m){return!1}}e.$8p=w;async function b(c,m,S,a,t,r){const s=M=>{try{return JSON.parse(M)}catch{return M}},i=new Map,o=new Map;c.forEach((M,W)=>{i.set(W,M),o.set(W,s(M))});const u=new Map,g=new Map;m.forEach((M,W)=>{u.set(W,M),g.set(W,s(M))});const P=new Map,D=new Map;S.forEach((M,W)=>{P.set(W,M),D.set(W,s(M))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const I=[];if(i.forEach((M,W)=>{I.push({key:W,value:M})}),console.table(I),console.groupEnd(),console.log(o),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const M=[];u.forEach((W,F)=>{M.push({key:F,value:W})}),console.table(M),console.groupEnd(),console.log(g)}console.group(`Storage: Workspace (path: ${r})`);const O=[];P.forEach((M,W)=>{O.push({key:W,value:M})}),console.table(O),console.groupEnd(),console.log(D)}}),define(se[283],re([0,1,22,8,3,2,9,73,7,21,115,163,5,97,28,30,13]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=e.$Vcc=e.$Ucc=e.$Tcc=void 0;class b extends R.$Uc{static{this.a=2e3}get storage(){return this.f}constructor(s,i){super(),this.m=s,this.n=i,this.b=this.B(new k.$fe),this.onDidChangeStorage=this.b.event,this.c=this.B(new k.$fe),this.onDidCloseStorage=this.c.event,this.f=this.B(new d.$Zp(new d.$1p,{hint:d.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new C.$Vh,this.whenInit=this.h.p,this.j=d.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===d.StorageState.None)try{const s=this.B(await this.t());this.f.dispose(),this.f=s,this.B(s.onDidChangeStorage(o=>this.b.fire(o))),await this.s(s);const i=s.getBoolean($.$2p);i===void 0?s.set($.$2p,!0):i&&s.set($.$2p,!1)}catch(s){this.m.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.j=d.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===v.LogLevel.Trace?s=>this.m.trace(s):void 0,logError:s=>this.m.error(s)}}s(s){return s.init()}get items(){return this.f.items}get(s,i){return this.f.get(s,i)}set(s,i){return this.f.set(s,i)}delete(s){return this.f.delete(s)}optimize(){return this.f.optimize()}async close(){const s=new E.$be(!1);await this.w(),s.stop(),s.elapsed()>b.a&&await this.u(s),this.c.fire()}async u(s){if(this.path)try{const i=(0,n.top)(Array.from(this.f.items.entries()).map(([u,g])=>({key:u,length:g.length})),(u,g)=>g.length-u.length,5).map(u=>`${u.key}:${u.length}`).join(", "),o=(await this.n.stat(h.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${o}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=d.StorageState.Closed,await this.f.close()}}class c extends b{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,j.$jc)(this.z.globalStorageHome.with({scheme:w.Schemas.file}).fsPath,c.y)}constructor(s,i,o,u){super(o,u),this.z=s,this.C=i}async t(){return new d.$Zp(new p.$MW(this.path??p.$MW.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:d.StorageHint.STORAGE_IN_MEMORY})}}class m extends c{constructor(s,i,o,u){super(s,i,o,u)}}e.$Tcc=m;class S extends c{constructor(s,i,o,u){super(i.defaultProfile,s,o,u)}async s(s){await super.s(s),this.G(s)}G(s){s.get(f.$7l,void 0)===void 0&&s.set(f.$7l,new Date().toUTCString());const o=s.get(f.$6l,void 0),u=new Date().toUTCString();s.set(f.$8l,typeof o>"u"?null:o),s.set(f.$6l,u)}}e.$Ucc=S;class a extends b{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,j.$jc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id,a.y)}constructor(s,i,o,u,g){super(o,g),this.C=s,this.D=i,this.F=u}async t(){const{storageFilePath:s,wasCreated:i}=await this.H();return new d.$Zp(new p.$MW(s,{logging:this.r()}),{hint:this.D.useInMemoryStorage?d.StorageHint.STORAGE_IN_MEMORY:i?d.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:p.$MW.IN_MEMORY_PATH,wasCreated:!0};const s=(0,j.$jc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id),i=(0,j.$jc)(s,a.y);return await l.Promises.exists(s)?{storageFilePath:i,wasCreated:!1}:(await l.Promises.mkdir(s,{recursive:!0}),this.I(s),{storageFilePath:i,wasCreated:!0})}async I(s){let i;if((0,y.$Ii)(this.C)?i={folder:this.C.uri.toString()}:(0,y.$Ni)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const o=(0,j.$jc)(s,a.z);await l.Promises.exists(o)||await l.Promises.writeFile(o,JSON.stringify(i,void 0,2))}catch(o){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${o}`)}}}e.$Vcc=a;class t extends b{get path(){}async t(){return new d.$Zp(new d.$1p,{hint:d.StorageHint.STORAGE_IN_MEMORY})}}e.$Wcc=t}),define(se[284],re([0,1,3,2,97]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;class R extends C.$Uc{constructor(E,h,l){super(),this.b=E,this.c=h,this.f=l;const d=this.B(new C.$Vc);this.a=this.B(new n.$fe({onWillAddFirstListener:()=>d.value=this.g(),onDidRemoveLastListener:()=>d.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const E=new C.$Tc;return E.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(h,l)=>(h?h.push(l.key):h=[l.key],h),100)(h=>this.h(h))),E.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(h,l)=>{h||(h=new Map);let d=h.get(l.profile.id);return d||h.set(l.profile.id,d={profile:l.profile,keys:[],storage:l.storage}),d.keys.push(l.key),h},100)(h=>this.j(h))),E}h(E){const h=E.includes(k.$3p)?[this.c.defaultProfile]:[],l=[];if(E=E.filter(d=>d!==k.$3p),E.length){const d=(0,k.$5p)(this.b.applicationStorage.storage);l.push({profile:this.c.defaultProfile,changes:E.map(p=>({key:p,scope:0,target:d[p]}))})}this.m(h,l)}j(E){const h=[],l=new Map;for(const[d,p]of E.entries()){p.keys.includes(k.$3p)&&h.push(p.profile);const v=p.keys.filter($=>$!==k.$3p);if(v.length){const $=(0,k.$5p)(p.storage.storage);l.set(d,{profile:p.profile,changes:v.map(f=>({key:f,scope:0,target:$[f]}))})}}this.m(h,[...l.values()])}m(E,h){(E.length||h.length)&&this.a.fire({valueChanges:h,targetChanges:E})}listen(E,h,l){switch(h){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${h}`)}async call(E,h){throw new Error(`Call not found: ${h}`)}}e.$8dc=R}),define(se[285],re([0,1,7,38,16,5,34,40,41,12,125]),function(K,e,n,C,k,R,j,E,h,l,d){"use strict";var p,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$$P=e.$0P=e.$9P=void 0;let $=class extends h.$Hl{static{p=this}static{this.a="profileAssociationsMigration"}constructor(b,c,m,S,a){super(m,S,c,a),this.U=b,this.W=m}O(){return this.U.getItem(p.b,[]).map(c=>({...c,location:(0,l.$$f)(c.location)?this.w.extUri.joinPath(this.profilesHome,c.location):n.URI.revive(c.location)}))}Q(){const b=this.U.getItem(p.c,{});return this.U.getItem(p.a,!1)?b:this.N(b)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$9P=$,e.$9P=$=p=Ee([ie(0,j.$4P),ie(1,E.$Cl),ie(2,C.$Gi),ie(3,k.$5k),ie(4,R.$5j)],$);let f=v=class extends ${constructor(b,c,m,S,a){super(b,c,m,S,a),this.$=b}P(b){b.length?this.$.setItem(v.b,b.map(c=>({...c,location:this.w.extUri.basename(c.location)}))):this.$.removeItem(v.b)}O(){const b=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(b),this.$.setItem("userDataProfilesMigration",!0)),b}R(b){b.emptyWindows||b.workspaces?this.$.setItem(v.c,b):this.$.removeItem(v.c)}Q(){const b="workspaceAndProfileInfo",c=this.$.getItem(b,void 0);if(c){this.$.removeItem(b);const S=c.reduce((a,{workspace:t,profile:r})=>(a[n.URI.revive(t).toString()]=n.URI.revive(r).toString(),a),{});this.$.setItem(v.c,{workspaces:S})}const m=super.Q();return this.$.getItem(v.a,!1)||(this.R(m),this.$.setItem(v.a,!0)),m}};e.$0P=f,e.$0P=f=v=Ee([ie(0,j.$5P),ie(1,E.$Cl),ie(2,C.$Gi),ie(3,k.$5k),ie(4,R.$5j)],f);let y=class extends f{constructor(b,c,m,S){super(new d.$8P(0,c,S,m),b,c,m,S)}async init(){return await this.$.init(),super.init()}};e.$$P=y,e.$$P=y=Ee([ie(0,E.$Cl),ie(1,C.$Gi),ie(2,k.$5k),ie(3,R.$5j)],y)}),define(se[57],re([0,1,38,16,6,5,40,41,285,34]),function(K,e,n,C,k,R,j,E,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=e.$Bcc=void 0,e.$Bcc=(0,k.$zi)(E.$El);let d=class extends h.$0P{constructor(v,$,f,y,w){super(v,$,f,y,w)}getAssociatedEmptyWindows(){const v=[];for(const $ of this.C.emptyWindows.keys())v.push({id:$});return v}};e.$Ccc=d,e.$Ccc=d=Ee([ie(0,l.$5P),ie(1,j.$Cl),ie(2,n.$Gi),ie(3,C.$5k),ie(4,R.$5j)],d)}),define(se[133],re([0,1,19,7,30]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=R,e.$Ecc=j,e.$Fcc=E;async function R(h,l,d){for(const v of h){const $=v.openedWorkspace;if((0,k.$Ni)($)){const f=await d($);if(f){if(f.folders.some(y=>n.$3g.isEqualOrParent(l,y.uri)))return v}else if(n.$3g.isEqualOrParent(l,$.configPath))return v}}const p=h.filter(v=>(0,k.$Ii)(v.openedWorkspace)&&n.$3g.isEqualOrParent(l,v.openedWorkspace.uri));if(p.length)return p.sort((v,$)=>-(v.openedWorkspace.uri.path.length-$.openedWorkspace.uri.path.length))[0]}function j(h,l){for(const d of h)if((0,k.$Ni)(d.openedWorkspace)&&n.$3g.isEqual(d.openedWorkspace.configPath,l)||(0,k.$Ii)(d.openedWorkspace)&&n.$3g.isEqual(d.openedWorkspace.uri,l))return d}function E(h,l){const d=p=>l.some(v=>n.$3g.isEqual(C.URI.file(v),C.URI.file(p)));for(const p of h)if(p.config?.extensionDevelopmentPath?.some(v=>d(v)))return p}}),define(se[98],re([0,1,31,42,103,48,13,9,4,19,7,6,68,30]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wfb=void 0,e.$Xfb=f,e.$Yfb=y,e.$Zfb=w,e.$1fb=b,e.$2fb=S,e.$3fb=t,e.$4fb=r,e.$5fb=g,e.$6fb=P,e.$Wfb=(0,p.$yi)("workspacesService");function f(D){return D.hasOwnProperty("workspace")}function y(D){return D.hasOwnProperty("folderUri")}function w(D){return D.hasOwnProperty("fileUri")}function b(D){return c(D)||m(D)}function c(D){const I=D;return typeof I?.path=="string"&&(!I.name||typeof I.name=="string")}function m(D){const I=D;return typeof I?.uri=="string"&&(!I.name||typeof I.name=="string")}function S(D,I,O,M,W){if(D.scheme!==M.scheme)return{name:O,uri:D.toString(!0)};let F=I?void 0:W.relativePath(M,D);if(F!==void 0)F.length===0?F=".":h.$i&&(F=a(F));else if(D.scheme===j.Schemas.file)F=D.fsPath,h.$i&&(F=a(F));else if(W.isEqualAuthority(D.authority,M.authority))F=D.path;else return{name:O,uri:D.toString(!0)};return{name:O,path:F}}function a(D){return D=(0,R.$Hw)(D),(0,n.$ug)(D)||(D=(0,n.$rg)(D)),D}function t(D,I,O){const M=[],W=new Set,F=O.dirname(I);for(const T of D){let U;if(c(T))T.path&&(U=O.resolvePath(F,T.path));else if(m(T))try{U=d.URI.parse(T.uri),U.path[0]!==E.$gc.sep&&(U=U.with({path:E.$gc.sep+U.path}))}catch(ae){console.warn(ae)}if(U){const ae=O.getComparisonKey(U);if(!W.has(ae)){W.add(ae);const te=T.name||O.basenameOrAuthority(U);M.push(new $.$Si({uri:U,name:te,index:M.length},T))}}}return M}function r(D,I,O,M,W){const F=s(I,D),T=W.dirname(I),U=W.dirname(M),ae=[];for(const V of F.folders){const q=c(V)?W.resolvePath(T,V.path):d.URI.parse(V.uri);let L;O?L=!1:L=!c(V)||(0,E.$ic)(V.path),ae.push(S(q,L,V.name,U,W))}const te={insertSpaces:!1,tabSize:4,eol:h.$k||h.$j?`
`:`\r
`},ce=k.$1n(D,["folders"],ae,te);let J=k.$4n(D,ce);return(0,l.$eh)(F.remoteAuthority,(0,v.$Jm)(M))&&(J=k.$4n(J,k.$Zn(J,["remoteAuthority"],te))),J}function s(D,I){const O=C.$Ln(I);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(M=>b(M));else throw new Error(`${D} looks like an invalid workspace file.`);return O}function i(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function o(D){return typeof D.folderUri=="string"}function u(D){return typeof D.fileUri=="string"}function g(D,I){const O={workspaces:[],files:[]};if(D){const M=function(F,T){for(let U=0;U<F.length;U++)try{T(F[U],U)}catch(ae){I.warn(`Error restoring recent entry ${JSON.stringify(F[U])}: ${ae.toString()}. Skip entry.`)}},W=D;Array.isArray(W.entries)&&M(W.entries,F=>{const T=F.label,U=F.remoteAuthority;i(F)?O.workspaces.push({label:T,remoteAuthority:U,workspace:{id:F.workspace.id,configPath:d.URI.parse(F.workspace.configPath)}}):o(F)?O.workspaces.push({label:T,remoteAuthority:U,folderUri:d.URI.parse(F.folderUri)}):u(F)&&O.files.push({label:T,remoteAuthority:U,fileUri:d.URI.parse(F.fileUri)})})}return O}function P(D){const I={entries:[]};for(const O of D.workspaces)y(O)?I.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):I.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of D.files)I.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return I}}),define(se[99],re([0,1,87,13,4,19]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=void 0,e.$Hcc=j,e.$Icc=E,e.$Jcc=h,e.$Gcc=128/4;function j(l){function d(){let p=l.scheme===C.Schemas.file?(0,R.$Zg)(l):l.toString();return k.$k||(p=p.toLowerCase()),(0,n.createHash)("md5").update(p).digest("hex")}return{id:d(),configPath:l}}function E(l,d){function p(){if(l.scheme!==C.Schemas.file)return(0,n.createHash)("md5").update(l.toString()).digest("hex");if(!d)return;let $;return k.$k?$=d.ino:k.$j?$=d.birthtime.getTime():k.$i&&(typeof d.birthtimeMs=="number"?$=Math.floor(d.birthtimeMs):$=d.birthtime.getTime()),(0,n.createHash)("md5").update(l.fsPath).update($?String($):"").digest("hex")}const v=p();if(typeof v=="string")return{id:v,uri:l}}function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(se[100],re([0,1,87,88,26,286,17,15,3,2,9,4,33,44,113]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.$pi=e.$oi=e.$ni=void 0,e.$qi=s,e.$ri=i,e.$ti=g,e.$ui=P;class y{traceSocketEvent(I,O){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,O)}constructor(I,O=""){this.f=!0,this.debugLabel=O,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,E.$1)(M)}},this.socket.on("error",this.a),this.b=M=>{this.traceSocketEvent("close",{hadError:M}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(I){const O=M=>{this.traceSocketEvent("read",M),I(j.$He.wrap(M))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(I){const O=M=>{I({type:0,hadError:M,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(I){const O=()=>{I()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(I){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,E.$1)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,E.$1)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$ni=y;var w;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize",D[D.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var b;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})(b||(b={}));class c extends l.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(I,O){this.socket.traceSocketEvent(I,O)}constructor(I,O,M,W){super(),this.f=this.B(new h.$fe),this.g=this.B(new h.$fe),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:M?.byteLength||0,recordInflateBytes:W}),this.a=this.B(new m(this,O,M,W,this.f,(F,T)=>this.m(F,T))),this.B(this.a.onError(F=>{console.error(F),(0,E.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new f.$ii,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this.f.event(I)}onClose(I){return this.g.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){let O=0;for(;O<I.byteLength;)this.a.writeMessage(I.slice(O,Math.min(O+262144,I.byteLength)),{compressed:!0,opcode:2}),O+=262144}m(I,{compressed:O,opcode:M}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let W=2;I.byteLength<126?W+=0:I.byteLength<2**16?W+=2:W+=8;const F=j.$He.alloc(W),T=O?64:0,U=M&15;if(F.writeUInt8(128|T|U,0),I.byteLength<126)F.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){F.writeUInt8(126,1);let ae=1;F.writeUInt8(I.byteLength>>>8&255,++ae),F.writeUInt8(I.byteLength>>>0&255,++ae)}else{F.writeUInt8(127,1);let ae=1;F.writeUInt8(0,++ae),F.writeUInt8(0,++ae),F.writeUInt8(0,++ae),F.writeUInt8(0,++ae),F.writeUInt8(I.byteLength>>>24&255,++ae),F.writeUInt8(I.byteLength>>>16&255,++ae),F.writeUInt8(I.byteLength>>>8&255,++ae),F.writeUInt8(I.byteLength>>>0&255,++ae)}this.socket.write(j.$He.concat([F,I]))}end(){this.h=!0,this.socket.end()}n(I){if(I.byteLength!==0){for(this.b.acceptChunk(I);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const O=this.b.peek(this.j.readLen),M=O.readUInt8(0),W=(M&128)>>>7,F=(M&64)>>>6,T=M&15,U=O.readUInt8(1),ae=(U&128)>>>7,te=U&127;this.j.state=2,this.j.readLen=2+(ae?4:0)+(te===126?2:0)+(te===127?8:0),this.j.fin=W,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!W,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const O=this.b.read(this.j.readLen),M=O.readUInt8(1),W=(M&128)>>>7;let F=M&127,T=1;F===126?F=O.readUInt8(++T)*2**8+O.readUInt8(++T):F===127&&(F=O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*2**24+O.readUInt8(++T)*2**16+O.readUInt8(++T)*2**8+O.readUInt8(++T));let U=0;W&&(U=O.readUInt8(++T)*2**24+O.readUInt8(++T)*2**16+O.readUInt8(++T)*2**8+O.readUInt8(++T)),this.j.state=3,this.j.readLen=F,this.j.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const O=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),t(O,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$oi=c;class m extends l.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:j.$He.alloc(0)}constructor(I,O,M,W,F,T){super(),this.n=I,this.r=F,this.s=T,this.a=this.B(new h.$fe),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new h.$fe),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new h.$fe),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new S(this.n,W,M,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(U=>this.a.fire(U))),this.B(this.f.onError(U=>this.a.fire(U)))):(this.b=null,this.f=null)}writeMessage(I,O){this.g.push({data:I,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:I,options:O}=this.g.shift();if(this.f&&O.compressed){const M=await this.w(this.f,I);this.s(M,O)}else this.s(I,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(I,O){return new Promise((M,W)=>{I.write(O),I.flush(F=>M(F))})}acceptFrame(I,O,M){this.h.push({data:I,isCompressed:O,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const I=this.h.shift();if(this.b&&I.isCompressed){const O=await this.C(this.b,I.data,I.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(I.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(I,O,M){return new Promise((W,F)=>{I.write(O),M&&I.write(j.$He.fromByteArray([0,0,255,255])),I.flush(T=>W(T))})}}class S extends l.$Uc{get recordedInflateBytes(){return this.j?j.$He.concat(this.f):j.$He.alloc(0)}constructor(I,O,M,W){super(),this.h=I,this.j=O,this.a=this.B(new h.$fe),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(W),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(j.$He.wrap(F))}),M&&(this.h.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(I){this.j&&this.f.push(I.clone()),this.h.traceSocketEvent("zlibInflateWrite",I),this.b.write(I.buffer)}flush(I){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const O=j.$He.concat(this.g);this.g.length=0,I(O)})}}class a extends l.$Uc{constructor(I,O){super(),this.g=I,this.a=this.B(new h.$fe),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent("zlibDeflateData",M),this.f.push(j.$He.wrap(M))})}write(I){this.g.traceSocketEvent("zlibDeflateWrite",I.buffer),this.b.write(I.buffer)}flush(I){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let O=j.$He.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),I(O)})}}function t(D,I){if(I===0)return;const O=D.byteLength>>>2;for(let ae=0;ae<O;ae++){const te=D.readUInt32BE(ae*4);D.writeUInt32BE(te^I,ae*4)}const M=O*4,W=D.byteLength-M,F=I>>>24&255,T=I>>>16&255,U=I>>>8&255;W>=1&&D.writeUInt8(D.readUInt8(M)^F,M),W>=2&&D.writeUInt8(D.readUInt8(M+1)^T,M+1),W>=3&&D.writeUInt8(D.readUInt8(M+2)^U,M+2)}e.$pi=process.env.XDG_RUNTIME_DIR;const r={2:107,1:103};function s(){const D=(0,v.$Ug)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;const I=process.platform!=="darwin"&&e.$pi?e.$pi:(0,k.tmpdir)(),O=(0,d.$jc)(I,`vscode-ipc-${D}.sock`);return o(O),O}function i(D,I,O){const W=(0,n.createHash)("sha256").update(D).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${W}-${O}-${I}-sock`;const F=O.substr(0,4),T=I.substr(0,6);let U;return process.platform!=="darwin"&&e.$pi&&!process.env.VSCODE_PORTABLE?U=(0,d.$jc)(e.$pi,`vscode-${W}-${F}-${T}.sock`):U=(0,d.$jc)(D,`${F}-${T}.sock`),o(U),U}function o(D){const I=r[p.$u];typeof I=="number"&&D.length>=I&&console.warn(`WARNING: IPC handle "${D}" is longer than ${I} chars, try a shorter --user-data-dir`)}class u extends $.$ci{static b(I){const O=h.Event.fromNodeEventEmitter(I,"connection");return h.Event.map(O,M=>({protocol:new f.$ji(new y(M,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(M,"close"))}))}constructor(I){super(u.b(I)),this.d=I}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$si=u;function g(D){return new Promise((I,O)=>{const M=(0,C.createServer)();M.on("error",O),M.listen(D,()=>{M.removeListener("error",O),I(new u(M))})})}function P(D,I){return new Promise((O,M)=>{const W=(0,C.createConnection)(D,()=>{W.removeListener("error",M),O(f.$ki.fromSocket(new y(W,`ipc-client${I}`),I))});W.once("error",M)})}}),define(se[24],re([0,1,51,9,4,100,38,91,6]),function(K,e,n,C,k,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=e.$ncc=void 0,e.$ncc=(0,h.$zi)(j.$Fi);class l extends E.$$m{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,C.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,C.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,R.$ri)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,C.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(k.$k){for(const p in process.env)if(p.endsWith("_VSCODE_SNAP_ORIG")){const v=p.slice(0,-17);if(this.d[v])continue;process.env[v]&&(this.d[v]=process.env[v]),process.env[p]?process.env[v]=process.env[p]:delete process.env[v]}}}restoreSnapExportedVariables(){if(k.$k)for(const p in this.d)process.env[p]=this.d[p],delete this.d[p]}}e.$occ=l,Ee([n.$3h],l.prototype,"cachedLanguagesPath",null),Ee([n.$3h],l.prototype,"backupHome",null),Ee([n.$3h],l.prototype,"mainIPCHandle",null),Ee([n.$3h],l.prototype,"mainLockfile",null),Ee([n.$3h],l.prototype,"disableUpdates",null),Ee([n.$3h],l.prototype,"crossOriginIsolated",null),Ee([n.$3h],l.prototype,"codeCachePath",null),Ee([n.$3h],l.prototype,"useCodeCache",null)}),define(se[287],re([0,1,87,31,13,9,4,19,21,199,18,24,34,16,5,198,30,99]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w,b){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=void 0;let m=class{static{c=this}static{this.a="backupWorkspaces"}constructor(a,t,r,s){this.j=a,this.k=t,this.l=r,this.m=s,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=E.$3g,this.i={isEqual:(i,o)=>(0,C.$wg)(i,o,!j.$k)}}async initialize(){const a=this.m.getItem(c.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(a.emptyWindows),this.d=await this.u((0,l.$qcc)(a)),this.e=await this.v((0,l.$rcc)(a)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==$.$rl.OFF}q(){return this.s()===$.$rl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||$.$rl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(a,t){this.d.some(s=>a.workspace.id===s.workspace.id)||(this.d.push(a),this.C());const r=(0,R.$jc)(this.c,a.workspace.id);return t?this.t(r,t).then(()=>r):r}async t(a,t){if(await h.Promises.exists(a)&&await this.z(a),await h.Promises.exists(t))try{await h.Promises.rename(t,a,!1)}catch(r){this.l.error(`Backup: Could not move backup folder to new location: ${r.toString()}`)}}registerFolderBackup(a){return this.e.some(t=>this.h.isEqual(a.folderUri,t.folderUri))||(this.e.push(a),this.C()),(0,R.$jc)(this.c,this.D(a))}registerEmptyWindowBackup(a){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.backupFolder))||(this.g.push(a),this.C()),(0,R.$jc)(this.c,a.backupFolder)}async u(a){if(!Array.isArray(a))return[];const t=new Set,r=[];for(const s of a){const i=s.workspace;if(!(0,w.$Ni)(i))return[];if(!t.has(i.id)){t.add(i.id);const o=(0,R.$jc)(this.c,i.id);await this.B(o)?i.configPath.scheme!==k.Schemas.file||await h.Promises.exists(i.configPath.fsPath)?r.push(s):await this.z(o):await this.x(o)}}return r}async v(a){if(!Array.isArray(a))return[];const t=[],r=new Set;for(const s of a){const i=s.folderUri,o=this.h.getComparisonKey(i);if(!r.has(o)){r.add(o);const u=(0,R.$jc)(this.c,this.D(s));await this.B(u)?i.scheme!==k.Schemas.file||await h.Promises.exists(i.fsPath)?t.push(s):await this.z(u):await this.x(u)}}return t}async w(a){if(!Array.isArray(a))return[];const t=[],r=new Set;for(const s of a){const i=s.backupFolder;if(typeof i!="string")return[];if(!r.has(i)){r.add(i);const o=(0,R.$jc)(this.c,i);await this.B(o)?t.push(s):await this.x(o)}}return t}async x(a){try{await h.Promises.rm(a,h.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let a=(0,b.$Jcc)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.id));)a=(0,b.$Jcc)();return{backupFolder:a.id}}async z(a){const t=this.y(),r=(0,R.$jc)(this.c,t.backupFolder);try{await h.Promises.rename(a,r,!1)}catch(s){return this.l.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.d)await this.A(t)&&a.push(t);for(const t of this.e)await this.A(t)&&a.push(t);return a}A(a){let t;return(0,l.$pcc)(a)?t=(0,R.$jc)(this.c,a.backupFolder):(0,y.$Ufb)(a)?t=(0,R.$jc)(this.c,this.D(a)):t=(0,R.$jc)(this.c,a.workspace.id),this.B(t)}async B(a){try{const t=await h.Promises.readdir(a);for(const r of t)try{if((await h.Promises.readdir((0,R.$jc)(a,r))).length>0)return!0}catch{}}catch{}return!1}C(){const a={workspaces:this.d.map(({workspace:t,remoteAuthority:r})=>{const s={id:t.id,configURIPath:t.configPath.toString()};return r&&(s.remoteAuthority=r),s}),folders:this.e.map(({folderUri:t,remoteAuthority:r})=>{const s={folderUri:t.toString()};return r&&(s.remoteAuthority=r),s}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:r})=>{const s={backupFolder:t};return r&&(s.remoteAuthority=r),s})};this.m.setItem(c.a,a)}D(a){const t=a.folderUri;let r;return t.scheme===k.Schemas.file?r=j.$k?t.fsPath:t.fsPath.toLowerCase():r=t.toString().toLowerCase(),(0,n.createHash)("md5").update(r).digest("hex")}};e.$3cc=m,e.$3cc=m=c=Ee([ie(0,p.$ncc),ie(1,d.$5i),ie(2,f.$5j),ie(3,v.$5P)],m)}),define(se[20],re([0,1,14,37,8,3,2,4,36,12,6,5,34,24]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=e.LifecycleMainPhase=e.ShutdownReason=e.$Rcc=void 0,e.$Rcc=(0,d.$yi)("lifecycleMainService");var y;(function(c){c[c.QUIT=1]="QUIT",c[c.KILL=2]="KILL"})(y||(e.ShutdownReason=y={}));var w;(function(c){c[c.Starting=1]="Starting",c[c.Ready=2]="Ready",c[c.AfterWindowOpen=3]="AfterWindowOpen",c[c.Eventually=4]="Eventually"})(w||(e.LifecycleMainPhase=w={}));let b=class extends j.$Uc{static{f=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(m,S,a){super(),this.F=m,this.G=S,this.H=a,this.c=this.B(new R.$fe),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.$fe),this.onWillShutdown=this.f.event,this.g=this.B(new R.$fe),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.$fe),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(f.b),this.m&&this.G.removeItem(f.b)}J(){const m=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),E.$j&&this.t===0&&this.L(1))};n.app.addListener("before-quit",m);const S=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!E.$j)&&n.app.quit()};n.app.addListener("window-all-closed",S),n.app.once("will-quit",a=>{this.S("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.app.removeListener("before-quit",m),n.app.removeListener("window-all-closed",S),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.app.quit()})})}L(m){if(this.y)return this.y;const S=this.F;this.S("Lifecycle#onWillShutdown.fire()");const a=[];return this.f.fire({reason:m,join(t,r){S.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(r.finally(()=>{S.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await k.Promises.settled(a)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(m){if(m<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===m)return;this.S(`lifecycle (main): phase changed (value: ${m})`),this.n=m;const S=this.C.get(this.n);S&&(S.open(),this.C.delete(this.n))}async when(m){if(m<=this.n)return;let S=this.C.get(m);S||(S=new k.$xh,this.C.set(m,S)),await S.wait()}registerWindow(m){const S=new j.$Tc;this.t++,S.add(m.onWillLoad(t=>this.g.fire({window:m,workspace:t.workspace,reason:t.reason})));const a=(0,l.$jg)(m.win);S.add(R.Event.fromNodeEventEmitter(a,"close")(t=>{const r=m.id;if(this.r.has(r)){this.r.delete(r);return}this.S(`Lifecycle#window.on('close') - window ID ${m.id}`),t.preventDefault(),this.unload(m,1).then(s=>{if(s){this.r.delete(r);return}this.r.add(r),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${r}`),this.h.fire(m),m.close()})})),S.add(R.Event.fromNodeEventEmitter(a,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${m.id}`),this.t--,S.dispose(),this.t===0&&(!E.$j||this.j)&&this.L(1)}))}registerAuxWindow(m){const S=(0,l.$jg)(m.win),a=new j.$Tc;a.add(R.Event.fromNodeEventEmitter(S,"close")(t=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${m.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),t.preventDefault())})),a.add(R.Event.fromNodeEventEmitter(S,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${m.id}`),a.dispose()}))}async reload(m,S){await this.unload(m,3)||m.reload(S)}unload(m,S){const a=this.z.get(m.id);if(a)return a;const t=this.M(m,S).finally(()=>{this.z.delete(m.id)});return this.z.set(m.id,t),t}async M(m,S){if(!m.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${m.id}`);const a=this.j?2:S,t=await this.P(m,a);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${m.id})`),this.N(t)):(await this.Q(m,a),!1)}N(m){return m?(this.O(!0),this.j=!1,!0):!1}O(m){this.w&&(this.w(m),this.w=void 0,this.u=void 0)}P(m,S){return new Promise(a=>{const t=this.s++,r=`vscode:ok${t}`,s=`vscode:cancel${t}`;C.$hW.once(r,()=>{a(!1)}),C.$hW.once(s,()=>{a(!0)}),m.send("vscode:onBeforeUnload",{okChannel:r,cancelChannel:s,reason:S})})}Q(m,S){return new Promise(a=>{const r=`vscode:reply${this.s++}`;C.$hW.once(r,()=>a()),m.send("vscode:onWillUnload",{replyChannel:r,reason:S})})}quit(m){return this.R(m).then(S=>{if(!S&&m)try{if(E.$i){const a=(0,h.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.F.error(a)}return S})}R(m){return this.S(`Lifecycle#quit() - begin (willRestart: ${m})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(m&&this.G.setItem(f.b,!0),this.u=new Promise(S=>{this.w=S,this.S("Lifecycle#quit() - calling app.quit()"),n.app.quit()}),this.u)}S(m){this.H.args["enable-smoke-test-driver"]?this.F.info(m):this.F.trace(m)}setRelaunchHandler(m){this.D=m}async relaunch(m){this.S("Lifecycle#relaunch()");const S=process.argv.slice(1);if(m?.addArgs&&S.push(...m.addArgs),m?.removeArgs)for(const r of m.removeArgs){const s=S.indexOf(r);s>=0&&S.splice(s,1)}const a=()=>{this.D?.handleRelaunch(m)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.app.relaunch({args:S}))};n.app.once("quit",a),await this.quit(!0)&&n.app.removeListener("quit",a)}async kill(m){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,k.$zh)(1e3),(async()=>{for(const S of n.BrowserWindow.getAllWindows())if(S&&!S.isDestroyed()){let a;S.webContents&&!S.webContents.isDestroyed()?a=new Promise(t=>S.once("closed",t)):a=Promise.resolve(),S.destroy(),await a}})()]),n.app.exit(m)}};e.$Scc=b,e.$Scc=b=f=Ee([ie(0,p.$5j),ie(1,v.$5P),ie(2,$.$ncc)],b)}),define(se[288],re([0,1,4,3,2,6,20]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=e.$ndc=void 0,e.$ndc=(0,R.$yi)("keyboardLayoutMainService");let E=class extends k.$Uc{constructor(d){super(),this.a=this.B(new C.$fe),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,d.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const d=await new Promise((p,v)=>{K(["native-keymap"],p,v)});this.c=h(d),n.$t||d.onDidChangeKeyboardLayout(()=>{this.c=h(d),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$odc=E,e.$odc=E=Ee([ie(0,j.$Rcc)],E);function h(l){const d=l.getKeyMap(),p=l.getCurrentKeyboardLayout();return{keyboardMapping:d,keyboardLayoutInfo:p}}}),define(se[289],re([0,1,250,8,17,15,12,18,38,95,5,53,249,286]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=void 0,e.$2r=w;let f=class extends p.$Rp{constructor(c,m,S,a){super(a),this.m=c,this.n=m,this.r=S,this.s(),this.B(c.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const c=this.m.getValue("http");this.f=c?.proxy,this.g=!!c?.proxyStrictSSL,this.h=c?.proxyAuthorization}async request(c,m){const{f:S,g:a}=this;let t;try{t=await(0,l.$Im)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,R.$0)(i)))}const r={...process.env,...t},s=c.agent?c.agent:await(0,v.$Zr)(c.url||"",r,{proxyUrl:S,strictSSL:a});return c.agent=s,c.strictSSL=a,this.h&&(c.headers={...c.headers||{},"Proxy-Authorization":this.h}),this.c(c.isChromiumNetwork?"electron":"node",c,()=>w(c,m))}async resolveProxy(c){}async loadCertificates(){return(await new Promise((m,S)=>{K(["@vscode/proxy-agent"],m,S)})).loadSystemCertificates({log:this.r})}};e.$1r=f,e.$1r=f=Ee([ie(0,E.$5i),ie(1,h.$Gi),ie(2,d.$5j),ie(3,d.$6j)],f);async function y(b){return((0,n.parse)(b.url).protocol==="https:"?await new Promise((S,a)=>{K(["https"],S,a)}):await new Promise((S,a)=>{K(["http"],S,a)})).request}async function w(b,c){return C.Promises.withAsyncBody(async(m,S)=>{const a=(0,n.parse)(b.url),t=b.getRawRequest?b.getRawRequest(b):await y(b),r={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,j.$eg)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(r.auth=b.user+":"+b.password);const s=t(r,i=>{const o=(0,j.$cg)(b.followRedirects)?b.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&o>0&&i.headers.location)w({...b,url:i.headers.location,followRedirects:o-1},c).then(m,S);else{let u=i;!b.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(u=i.pipe((0,$.createGunzip)())),m({res:i,stream:(0,k.$We)(u)})}});s.on("error",S),b.timeout&&s.setTimeout(b.timeout),b.isChromiumNetwork&&s.removeHeader("Content-Length"),b.data&&typeof b.data=="string"&&s.write(b.data),s.end(),c.onCancellationRequested(()=>{s.abort(),S(new R.$5)})})}}),define(se[290],re([0,1,14,289]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=void 0;function k(j){return n.net.request}class R extends C.$1r{request(E,h){return super.request({...E||{},getRawRequest:k,isChromiumNetwork:!0},h)}}e.$qec=R}),define(se[84],re([0,1,7,3,2,38,16,6,20,5,97,283,41,57,40,13]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=e.$Zcc=e.$Ycc=e.$Xcc=void 0,e.$Xcc=(0,E.$yi)("storageMainService");let w=class extends k.$Uc{constructor(m,S,a,t,r,s){super(),this.c=m,this.f=S,this.g=a,this.h=t,this.j=r,this.m=s,this.a=void 0,this.b=this.B(new C.$fe),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(m=>{m.window.profile&&this.profileStorage(m.window.profile).init(),m.workspace&&this.workspaceStorage(m.workspace).init()})),this.B(this.h.onWillShutdown(m=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=m.reason,m.join("applicationStorage",this.applicationStorage.close());for(const[,S]of this.t)m.join("profileStorage",S.close());for(const[,S]of this.w)m.join("workspaceStorage",S.close())})),this.B(this.g.onWillCreateProfile(m=>{m.join((async()=>{await this.j.exists(m.profile.globalStorageHome)||await this.j.createFolder(m.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(m=>{const S=this.t.get(m.profile.id);S&&m.join(S.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const m=new p.$Ucc(this.n(),this.g,this.c,this.j);return this.B(C.Event.once(m.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),m}profileStorage(m){if((0,d.$7p)(m))return this.applicationStorage;let S=this.t.get(m.id);if(!S){this.c.trace(`StorageMainService: creating profile storage (${m.name})`),S=this.B(this.u(m)),this.t.set(m.id,S);const a=this.B(S.onDidChangeStorage(t=>this.b.fire({...t,storage:S,profile:m})));this.B(C.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${m.name})`),this.t.delete(m.id),a.dispose()}))}return S}u(m){return this.a===2?new p.$Wcc(this.c,this.j):new p.$Tcc(m,this.n(),this.c,this.j)}workspaceStorage(m){let S=this.w.get(m.id);return S||(this.c.trace(`StorageMainService: creating workspace storage (${m.id})`),S=this.B(this.y(m)),this.w.set(m.id,S),this.B(C.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${m.id})`),this.w.delete(m.id)}))),S}y(m){return this.a===2?new p.$Wcc(this.c,this.j):new p.$Vcc(m,this.n(),this.c,this.f,this.j)}isUsed(m){const S=n.URI.file(m);for(const a of[this.applicationStorage,...this.t.values(),...this.w.values()])if(a.path&&this.m.extUri.isEqualOrParent(n.URI.file(a.path),S))return!0;return!1}};e.$Ycc=w,e.$Ycc=w=Ee([ie(0,l.$5j),ie(1,R.$Fi),ie(2,$.$Bcc),ie(3,h.$Rcc),ie(4,j.$5k),ie(5,f.$Cl)],w),e.$Zcc=(0,E.$yi)("applicationStorageMainService");let b=class extends d.$6p{constructor(m,S){super(),this.s=m,this.U=S,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(m){if(m===-1)return this.U.applicationStorage.storage}Q(m){if(m===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$1cc=b,e.$1cc=b=Ee([ie(0,v.$El),ie(1,e.$Xcc)],b)}),define(se[291],re([0,1,88,26,107,100,8,2,4,18,5,27,245,246,96,130,17]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=e.$oec=e.$nec=e.$mec=void 0;async function b(t,r,s,i,o){let u;for(let g=3;g&&(u?.dispose(),u=await new c(t,r,s,i,o).waitForReady(),!(o&&k.$Xg[o]||!k.$Xg[u.tunnelLocalPort]));g--);return u}class c extends E.$Uc{constructor(r,s,i,o,u){super(),this.m=s,this.n=u,this.privacy=y.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=n.createServer(),this.c=new j.$xh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=g=>this.r(g),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=o,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,s=(0,y.$tw)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,k.$Yg)(r,2,1e3,s),o=null;return this.b.listen(i,this.m),await this.c.wait(),o=this.b.address(),o||(i=0,this.b.listen(i,this.m),await this.c.wait(),o=this.b.address()),this.tunnelLocalPort=o.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${o.port}`,this}async r(r){r.pause();const s=(0,y.$rw)(this.tunnelRemoteHost)||(0,y.$tw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,v.$Ul)(this.a,s,this.tunnelRemotePort),o=i.getSocket(),u=i.readEntireBuffer();i.dispose(),u.byteLength>0&&r.write(u.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),o.end()}),r.on("close",()=>o.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),o instanceof R.$ni?o.socket.destroy():o.end()}),o instanceof R.$ni?this.t(r,o):this.s(r,o),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),o.end()})}s(r,s){s.onClose(()=>r.destroy()),s.onEnd(()=>r.end()),s.onData(i=>r.write(i.buffer)),r.on("data",i=>s.write(w.$He.wrap(i))),r.resume()}t(r,s){const i=s.socket;i.on("end",()=>r.end()),i.on("close",()=>r.end()),i.on("error",()=>{r.destroy()}),i.pipe(r),r.pipe(i)}}e.$mec=c;let m=class extends y.$ww{constructor(r,s,i,o,u){super(s,u),this.v=r,this.w=i,this.y=o}isPortPrivileged(r){return(0,y.$uw)(r,this.m,h.OS,C.release())}t(r,s,i,o,u,g,P,D){const I=this.s(s,i);if(I)return++I.refcount,I.value;if((0,y.$nw)(r))return this.u(r,s,i,u,g,P,D);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${i} on local port ${u}.`);const O={commit:this.y.commit,quality:this.y.quality,addressProvider:r,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},M=b(O,o,s,i,u);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,i,M),M}}};e.$nec=m,e.$nec=m=Ee([ie(0,$.$Ol),ie(1,d.$5j),ie(2,f.$Rl),ie(3,p.$lk),ie(4,l.$5i)],m);let S=class extends m{constructor(r,s,i,o,u){super(r,s,i,o,u)}};e.$oec=S,e.$oec=S=Ee([ie(0,$.$Ol),ie(1,d.$5j),ie(2,f.$Rl),ie(3,p.$lk),ie(4,l.$5i)],S);let a=class extends E.$Uc{constructor(r,s,i,o,u){super(),this.b=r,this.c=s,this.f=i,this.g=o,this.h=u,this.a=new Map}async openTunnel(r,s,i,o,u,g,P,D,I){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${o} on local port ${g}.`),!this.a.has(r)){const O=new S(this.b,this.c,this.g,this.f,this.h);this.B(O),this.a.set(r,O),O.onTunnelClosed(async()=>{(await O.tunnels).length===0&&(O.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(s,i,o,u,g,P,D,I)}};e.$pec=a,e.$pec=a=Ee([ie(0,$.$Ol),ie(1,d.$5j),ie(2,p.$lk),ie(3,f.$Rl),ie(4,l.$5i)],a)}),define(se[101],re([0,1,8,23,3,18,24,20,5,27,53,50]),function(K,e,n,C,k,R,j,E,h,l,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=void 0,e.$Kdc=v;function v(f,y,w){return`${w.updateUrl}/api/update/${f}/${y}/${w.commit}`}let $=class{get state(){return this.b}d(y){this.j.info("update#setState",y.type),this.b=y,this.c.fire(y)}constructor(y,w,b,c,m,S){this.f=y,this.g=w,this.h=b,this.i=c,this.j=m,this.k=S,this.b=p.$fX.Uninitialized,this.c=new k.$fe,this.onStateChange=this.c.event,y.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(p.$fX.Disabled(0));return}if(this.h.disableUpdates){this.d(p.$fX.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(p.$fX.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const y=this.g.getValue("update.mode"),w=this.m(y);if(!w){this.d(p.$fX.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(w),!this.a){this.d(p.$fX.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const b=new URL(this.a);b.searchParams.set("prss","true"),this.a=b.toString()}if(this.d(p.$fX.Idle(this.q())),y==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}y==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,b=>this.j.error(b))}m(y){return y==="none"?void 0:this.k.quality}n(y=60*60*1e3){return(0,n.$zh)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(y){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(y)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(y){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(y=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},C.CancellationToken.None)).res.statusCode===204}catch(w){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(w);return}}async _applySpecificUpdate(y){}q(){return 1}r(){}};e.$Ldc=$,e.$Ldc=$=Ee([ie(0,E.$Rcc),ie(1,R.$5i),ie(2,j.$ncc),ie(3,d.$Qp),ie(4,h.$5j),ie(5,l.$lk)],$)}),define(se[292],re([0,1,14,51,3,46,2,18,24,20,5,27,53,28,50,101]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=void 0;let w=class extends y.$Ldc{get v(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"error",(c,m)=>m)}get w(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get y(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",(c,m,S,a)=>({version:S,productVersion:S,timestamp:a}))}constructor(c,m,S,a,t,r,s){super(c,m,a,t,r,s),this.z=S,this.u=new j.$Tc,c.setRelaunchHandler(this)}handleRelaunch(c){return c?.addArgs||c?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(c){this.z.publicLog2("update:error",{messageHash:String((0,R.$mj)(String(c)))}),this.j.error("UpdateService error:",c);const m=this.state.type==="checking for updates"&&this.state.explicit?c:void 0;this.d(f.$fX.Idle(1,m))}s(c){let m;this.k.darwinUniversalAssetId?m=this.k.darwinUniversalAssetId:m=process.arch==="x64"?"darwin":"darwin-arm64";const S=(0,y.$Kdc)(m,c,this.k);try{n.autoUpdater.setFeedURL({url:S})}catch(a){this.j.error("Failed to set update feed URL",a);return}return S}t(c){this.d(f.$fX.CheckingForUpdates(c)),n.autoUpdater.checkForUpdates()}E(){this.state.type==="checking for updates"&&this.d(f.$fX.Downloading)}F(c){this.state.type==="downloading"&&(this.d(f.$fX.Downloaded(c)),this.z.publicLog2("update:downloaded",{version:c.version}),this.d(f.$fX.Ready(c)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$fX.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$Mdc=w,Ee([C.$3h],w.prototype,"v",null),Ee([C.$3h],w.prototype,"w",null),Ee([C.$3h],w.prototype,"x",null),Ee([C.$3h],w.prototype,"y",null),e.$Mdc=w=Ee([ie(0,l.$Rcc),ie(1,E.$5i),ie(2,$.$4l),ie(3,h.$ncc),ie(4,v.$Qp),ie(5,d.$5j),ie(6,p.$lk)],w)}),define(se[293],re([0,1,49,43,8,3,9,24,20,5,28,50]),function(K,e,n,C,k,R,j,E,h,l,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;let v=class{get state(){return this.a}d(y){this.g.info("update#setState",y.type),this.a=y,this.b.fire(y)}constructor(y,w,b){if(this.f=y,this.g=b,this.a=p.$fX.Uninitialized,this.b=new R.$fe,this.onStateChange=this.b.event,w.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(p.$fX.Idle(this.k())),this.h(30*1e3).then(void 0,c=>this.g.error(c))}h(y=60*60*1e3){return(0,k.$zh)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(y){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(y)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(y){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(y=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(y){}};v=Ee([ie(0,h.$Rcc),ie(1,E.$ncc),ie(2,l.$5j)],v);let $=class extends v{constructor(y,w,b,c,m,S){super(b,c,m),this.o=y,this.p=w,this.q=S;const a=(0,C.watch)(j.$mc(this.o)),t=R.Event.fromNodeEventEmitter(a,"change",(o,u)=>u),r=R.Event.filter(t,o=>o==="current"),i=R.Event.debounce(r,(o,u)=>u,2e3)(()=>this.checkForUpdates(!1));b.onWillShutdown(()=>{i.dispose(),a.close()})}m(){this.d(p.$fX.CheckingForUpdates(!1)),this.u().then(y=>{y?this.d(p.$fX.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(p.$fX.Idle(2)))},y=>{this.g.error(y),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(p.$fX.Idle(2,y.message||y))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+j.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const y=await new Promise((b,c)=>(0,C.realpath)(`${j.$mc(this.o)}/current`,(m,S)=>m?c(m):b(S))),w=j.$nc(y);return this.p!==w}isLatestVersion(){return this.u().then(void 0,y=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$Odc=$,e.$Odc=$=Ee([ie(2,h.$Rcc),ie(3,E.$ncc),ie(4,l.$5j),ie(5,d.$4l)],$)}),define(se[29],re([0,1,14,4,6,82,55,69,27,18,24,9,138]),function(K,e,n,C,k,R,j,E,h,l,d,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$ycc=void 0,e.$zcc=f,e.$Acc=y,e.$ycc=(0,k.$yi)("windowsMainService");var $;(function(b){b[b.CLI=0]="CLI",b[b.DOCK=1]="DOCK",b[b.MENU=2]="MENU",b[b.DIALOG=3]="DIALOG",b[b.DESKTOP=4]="DESKTOP",b[b.API=5]="API"})($||(e.OpenContext=$={}));function f(b,c,m){const S=b.get(E.$wcc),a=b.get(h.$lk),t=b.get(l.$5i),r=b.get(d.$ncc),s=t.getValue("window"),i={backgroundColor:S.getBackgroundColor(),minWidth:j.$DD.WIDTH,minHeight:j.$DD.HEIGHT,title:a.nameLong,show:c.mode!==0&&c.mode!==3,x:c.x,y:c.y,width:c.width,height:c.height,webPreferences:{...m,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,j.$PD)(c.zoomLevel??s?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(C.$k?i.icon=(0,p.$jc)(r.appRoot,"resources/linux/code.png"):C.$i&&!r.isBuilt&&(i.icon=(0,p.$jc)(r.appRoot,"resources/win32/code_150x150.png")),C.$j&&(i.acceptFirstMouse=!0,s?.clickThroughInactive===!1&&(i.acceptFirstMouse=!1)),C.$j&&!(0,j.$OD)(t)&&(i.fullscreenable=!1),C.$j&&s?.nativeTabs===!0&&(i.tabbingIdentifier=a.nameShort),!(0,j.$KD)(t)&&(i.titleBarStyle="hidden",C.$j||(i.frame=!1),(0,j.$ND)(t))){const g=S.getWindowSplash()?.colorInfo.titleBarBackground??S.getBackgroundColor(),P=v.$St.fromHex(g).isDarker()?"#FFFFFF":"#000000";i.titleBarOverlay={height:29,color:g,symbolColor:P}}return i}function y(b){let c,m=Number.MIN_VALUE;for(const S of b)S.lastFocusTime>m&&(m=S.lastFocusTime,c=S);return c}var w;(function(b){function c(S,a,t=n.screen.getAllDisplays()){if(S.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,a),typeof a.x!="number"||typeof a.y!="number"||typeof a.width!="number"||typeof a.height!="number"){S.trace("window#validateWindowState: unexpected type of state values");return}if(a.width<=0||a.height<=0){S.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const i=m(t[0]);if(S.trace("window#validateWindowState: single monitor working area",i),i){let o=function(){!a||typeof a.x!="number"||typeof a.y!="number"||!i||(a.x<i.x&&(a.x=i.x),a.y<i.y&&(a.y=i.y))};o(),a.width>i.width&&(a.width=i.width),a.height>i.height&&(a.height=i.height),a.x>i.x+i.width-128&&(a.x=i.x+i.width-a.width),a.y>i.y+i.height-128&&(a.y=i.y+i.height-a.height),o()}return a}if(a.display&&a.mode===3){const i=t.find(o=>o.id===a.display);if(i&&typeof i.bounds?.x=="number"&&typeof i.bounds?.y=="number"){S.trace("window#validateWindowState: restoring fullscreen to previous display");const o=(0,R.$lcc)(3);return o.x=i.bounds.x,o.y=i.bounds.y,o}}let r,s;try{r=n.screen.getDisplayMatching({x:a.x,y:a.y,width:a.width,height:a.height}),s=m(r),S.trace("window#validateWindowState: multi-monitor working area",s)}catch(i){S.error("window#validateWindowState: error finding display for window state",i)}if(r&&s&&a.x+a.width>s.x&&a.y+a.height>s.y&&a.x<s.x+s.width&&a.y<s.y+s.height)return a;S.trace("window#validateWindowState: state is outside of the multi-monitor working area")}b.validateWindowState=c;function m(S){if(S.workArea.width>0&&S.workArea.height>0)return S.workArea;if(S.bounds.width>0&&S.bounds.height>0)return S.bounds}})(w||(e.WindowStateValidator=w={}))}),define(se[294],re([0,1,14,23,3,46,2,33,120,5,84,29]),function(K,e,n,C,k,R,j,E,h,l,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=void 0;var v;(function(f){f[f.Initial=1]="Initial",f[f.StoredCredentialsUsed=2]="StoredCredentialsUsed",f[f.LoginDialogShown=3]="LoginDialogShown"})(v||(v={}));let $=class extends j.$Uc{constructor(y,w,b,c){super(),this.g=y,this.h=w,this.j=b,this.m=c,this.a="proxy-credentials://",this.b=void 0,this.c=v.Initial,this.f=void 0,this.n()}n(){const y=k.Event.fromNodeEventEmitter(n.app,"login",(w,b,c,m,S)=>({event:w,webContents:b,req:c,authInfo:m,callback:S}));this.B(y(this.r,this))}async r({event:y,authInfo:w,req:b,callback:c}){if(!w.isProxy)return;if(!this.b&&this.c===v.LoginDialogShown&&b.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}y.preventDefault();let m;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),m=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(w);try{m=await this.b}finally{this.b=void 0}}c(m?.username,m?.password)}async s(y){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.t(y);if(w)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(y){this.g.trace("auth#doResolveProxyCredentials - enter",y);const w=String((0,R.$mj)({scheme:y.scheme,host:y.host,port:y.port}));let b,c;try{const t=this.m.get(this.a+w,-1);if(t){const r=JSON.parse(await this.j.decrypt(t));b=r.username,c=r.password}}catch(t){this.g.error(t)}if(this.c!==v.StoredCredentialsUsed&&typeof b=="string"&&typeof c=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=v.StoredCredentialsUsed,{username:b,password:c};const m=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!m){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${m.id} to handle proxy login`);const S={authInfo:y,username:this.f?.username??b,password:this.f?.password??c,replyChannel:`vscode:proxyAuthResponse:${(0,E.$Ug)()}`};m.sendWhenReady("vscode:openProxyAuthenticationDialog",C.CancellationToken.None,S),this.c=v.LoginDialogShown;const a=await new Promise(t=>{const r=async(s,i,o)=>{if(i===S.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${m.id}`),m.win?.webContents.off("ipc-message",r),o){const u={username:o.username,password:o.password};try{if(o.remember){const g=await this.j.encrypt(JSON.stringify(u));this.m.store(this.a+w,g,-1,1)}else this.m.remove(this.a+w,-1)}catch(g){this.g.error(g)}t({username:u.username,password:u.password})}else t(void 0)};m.win?.webContents.on("ipc-message",r)});return this.f=a,a}};e.$2cc=$,e.$2cc=$=Ee([ie(0,l.$5j),ie(1,p.$ycc),ie(2,h.$3W),ie(3,d.$Zcc)],$)}),define(se[295],re([0,1,14,22,4,7,21,18,64,6,5,131,29]),function(K,e,n,C,k,R,j,E,h,l,d,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=e.$qdc=e.ID=void 0,e.ID="launchMainService",e.$qdc=(0,l.$yi)(e.ID);let $=class{constructor(y,w,b,c){this.a=y,this.b=w,this.c=b,this.d=c}async start(y,w){this.a.trace("Received data from other instance: ",y,w),k.$j&&n.app.focus({steal:!0});const b=this.e(y);if(b.length){let c=Promise.resolve();if(this.b.getWindowCount()===0){const m=(0,C.$Ob)(await this.b.openEmptyWindow({context:4}));m&&(c=m.ready())}c.then(()=>{for(const{uri:m,originalUrl:S}of b)this.c.open(m,{originalUrl:S})})}else return this.f(y,w)}e(y){return y["open-url"]&&y._urls&&y._urls.length>0?(0,C.$Hb)(y._urls.map(w=>{try{return{uri:R.URI.parse(w),originalUrl:w}}catch{return null}})):[]}async f(y,w){const b=(0,h.$Cm)(w)?0:4;let c=[];const m=y.wait&&y.waitMarkerFilePath?R.URI.file(y.waitMarkerFilePath):void 0,S=y.remote||void 0,a={context:b,cli:y,userEnv:y["preserve-env"]||b===0?w:void 0,waitMarkerFileURI:m,remoteAuthority:S,forceProfile:y.profile,forceTempProfile:y["profile-temp"]};if(y.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(y.extensionDevelopmentPath,a);else if(!y._.length&&!y["folder-uri"]&&!y["file-uri"]){let t=!1;if(y["new-window"]||a.forceProfile||a.forceTempProfile)t=!0;else if(y["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!k.$j}if(t)c=await this.b.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const r=this.b.getLastActiveWindow();r?(this.b.openExistingWindow(r,a),c=[r]):c=await this.b.open({...a,forceEmpty:!0})}}else c=await this.b.open({...a,forceNewWindow:y["new-window"],preferNewWindow:!y["reuse-window"]&&!y.wait,forceReuseWindow:y["reuse-window"],diffMode:y.diff,mergeMode:y.merge,addMode:y.add,noRecentEntry:!!y["skip-add-to-recently-opened"],gotoLineMode:y.goto});if(m&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,j.whenDeleted)(m.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$rdc=$,e.$rdc=$=Ee([ie(0,d.$5j),ie(1,v.$ycc),ie(2,p.$9W),ie(3,E.$5i)],$)}),define(se[296],re([0,1,2,20,57,30,8,29]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=void 0;let h=class extends n.$Uc{constructor(d,p,v){super(),this.a=p,this.b=v,this.B(d.onWillLoadWindow($=>{$.reason===2&&this.c($.window)})),this.B(d.onBeforeCloseWindow($=>this.c($))),this.B(new j.$Kh(()=>this.g(),30*1e3)).schedule()}async c(d){const p=this.f(d),v=this.a.getProfileForWorkspace(p);v?.isTransient&&(this.a.unsetWorkspace(p,v.isTransient),v.isTransient&&await this.a.cleanUpTransientProfiles())}f(d){return d.openedWorkspace??(0,R.$Mi)(d.backupPath,d.isExtensionDevelopmentHost)}g(){const d=this.a.getAssociatedEmptyWindows();if(d.length===0)return;const p=this.b.getWindows().map(v=>this.f(v));for(const v of d)p.some($=>$.id===v.id)||this.a.unsetWorkspace(v,!1)}};e.$7dc=h,e.$7dc=h=Ee([ie(0,C.$Rcc),ie(1,k.$Bcc),ie(2,E.$ycc)],h)}),define(se[61],re([0,1,14,2,3,5,316,8,13,29,74,28,20,76,35,4,102]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=e.$5cc=void 0;function c(a){return typeof a.responseWindowId=="number"}let m=class extends C.$Uc{static{b=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(b.b.values())}constructor(t,r,s){super(),this.w=t,this.y=r,this.z=s,this.c=String(++b.a),this.f=this.B(new k.$fe),this.onStdout=this.f.event,this.g=this.B(new k.$fe),this.onStderr=this.g.event,this.h=this.B(new k.$fe),this.onMessage=this.h.event,this.j=this.B(new k.$fe),this.onSpawn=this.j.event,this.m=this.B(new k.$fe),this.onExit=this.m.event,this.n=this.B(new k.$fe),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(t,r){let s;switch(this.t?.correlationId?s=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:s=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,r){case d.default.Error:this.w.error(s);break;case d.default.Warning:this.w.warn(s);break;case d.default.Info:this.w.trace(s);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",d.default.Error),!1):!0}start(t){const r=this.F(t);return r&&t.payload&&this.postMessage(t.payload)&&this.C("payload sent via postMessage()",d.default.Info),r}F(t){if(!this.D())return!1;this.t=t;const r=`${this.t.type}-${this.c}`,s=h.$Sg.asFileUri("bootstrap-fork.js").fsPath,i=this.t.args??[],o=this.t.execArgv??[],u=this.t.allowLoadingUnsignedLibraries,g=this.t.forceAllocationsToV8Sandbox,P="pipe",D=this.G(t);return this.C("creating new...",d.default.Info),this.r=n.utilityProcess.fork(s,i,{serviceName:r,env:D,execArgv:o,allowLoadingUnsignedLibraries:u,forceAllocationsToV8Sandbox:g,stdio:P}),this.H(this.r,this.t,r),!0}G(t){const r=t.env?{...t.env}:{...(0,f.$5n)(process.env)};r.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(r.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),r.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,y.$i&&((0,w.isUNCAccessRestrictionsDisabled)()?r.NODE_DISABLE_UNC_ACCESS_CHECKS="1":r.NODE_UNC_HOST_ALLOWLIST=(0,w.getUNCHostAllowlist)().join("\\")),(0,$.$pm)(r);for(const s of Object.keys(r))r[s]=String(r[s]);return r}H(t,r,s){if(t.stdout){const i=new j.StringDecoder("utf-8");this.B(k.Event.fromNodeEventEmitter(t.stdout,"data")(o=>this.f.fire(typeof o=="string"?o:i.write(o))))}if(t.stderr){const i=new j.StringDecoder("utf-8");this.B(k.Event.fromNodeEventEmitter(t.stderr,"data")(o=>this.g.fire(typeof o=="string"?o:i.write(o))))}this.B(k.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(k.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&b.b.set(t.pid,{pid:t.pid,name:c(r)?`${r.type} [${r.responseWindowId}]`:r.type}),this.C("successfully created",d.default.Info),this.j.fire(t.pid)})),this.B(k.Event.fromNodeEventEmitter(t,"exit")(i=>{const o=this.I(i)?0:i;this.C(`received exit event with code ${o}`,d.default.Info),this.m.fire({pid:this.s,code:o,signal:"unknown"}),this.J()})),this.B(k.Event.fromNodeEventEmitter(n.app,"child-process-gone",(i,o)=>({event:i,details:o}))(({details:i})=>{i.type==="Utility"&&i.name===s&&!this.I(i.exitCode)&&(this.C(`crashed with code ${i.exitCode} and reason '${i.reason}'`,d.default.Error),this.y.publicLog2("utilityprocesscrash",{type:r.type,reason:i.reason,code:i.exitCode}),this.n.fire({pid:this.s,code:i.exitCode,reason:i.reason}),this.J())}))}once(t,r){const s=this.B(this.h.event(i=>{i===t&&(s.dispose(),r())}))}postMessage(t,r){return this.r?(this.r.postMessage(t,r),!0):!1}connect(t){const{port1:r,port2:s}=new n.MessageChannelMain;return this.postMessage(t,[s]),r}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",d.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",d.default.Info),this.r.kill()?(this.C("successfully killed the process",d.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",d.default.Warning)}I(t){return t===0?!0:this.u&&t===15}J(){typeof this.s=="number"&&b.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.C("waiting to exit...",d.default.Info),await Promise.race([k.Event.toPromise(this.onExit),(0,E.$zh)(t)]),this.r&&(this.C(`did not exit within ${t}ms, will kill it now...`,d.default.Info),this.kill()))}};e.$5cc=m,e.$5cc=m=b=Ee([ie(0,R.$5j),ie(1,p.$4l),ie(2,v.$Rcc)],m);let S=class extends m{constructor(t,r,s,i){super(t,s,i),this.L=r}start(t){const r=this.L.getWindowById(t.responseWindowId);if(!r?.win||r.win.isDestroyed()||r.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",d.default.Error),!0;if(!super.F(t))return!1;this.M(r.win,t);const i=this.connect(t.payload);return r.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}M(t,r){r.windowLifecycleBound&&(this.B(k.Event.filter(this.z.onWillLoadWindow,s=>s.window.win===t)(()=>this.kill())),this.B(k.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$6cc=S,e.$6cc=S=Ee([ie(0,R.$5j),ie(1,l.$ycc),ie(2,p.$4l),ie(3,v.$Rcc)],S)}),define(se[297],re([0,1,15,3,5,20,8,61,29,28]),function(K,e,n,C,k,R,j,E,h,l){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=void 0;let p=class{static{d=this}static{this.a=0}constructor($,f,y,w){this.d=$,this.f=f,this.g=y,this.h=w,this.b=new Map,this.c=!1,this.f.onWillShutdown(b=>{this.c=!0,b.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i($){const f=this.b.get($);if(!f)throw new Error("Unknown extension host!");return f}onDynamicStdout($){return this.i($).onStdout}onDynamicStderr($){return this.i($).onStderr}onDynamicMessage($){return this.i($).onMessage}onDynamicExit($){return this.i($).onExit}async createExtensionHost(){if(this.c)throw(0,n.$6)();const $=String(++d.a),f=new E.$6cc(this.d,this.g,this.h,this.f);return this.b.set($,f),f.onExit(({pid:y,code:w,signal:b})=>{this.d.info(`Extension host with pid ${y} exited with code: ${w}, signal: ${b}.`),setTimeout(()=>{f.dispose(),this.b.delete($)}),setTimeout(()=>{try{process.kill(y,0),this.d.error(`Extension host with pid ${y} still exists, forcefully killing it...`),process.kill(y)}catch{}},1e3)}),{id:$}}async start($,f){if(this.c)throw(0,n.$6)();const y=this.i($);return y.start({...f,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:f.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:$}),{pid:await C.Event.toPromise(y.onSpawn)}}async enableInspectPort($){if(this.c)throw(0,n.$6)();const f=this.b.get($);return f?f.enableInspectPort():!1}async kill($){if(this.c)throw(0,n.$6)();const f=this.b.get($);f&&f.kill()}async _killAllNow(){for(const[,$]of this.b)$.kill()}async _waitForAllExit($){const f=[];for(const[,y]of this.b)f.push(y.waitForExit($));return j.Promises.settled(f).then(()=>{})}};e.$adc=p,e.$adc=p=d=Ee([ie(0,k.$5j),ie(1,R.$Rcc),ie(2,h.$ycc),ie(3,l.$4l)],p)}),define(se[298],re([0,1,37,8,2,24,20,5,41,39,67,61,54,91,12,251]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;let w=class extends k.$Uc{constructor(c,m,S,a,t,r,s,i){super(),this.f=c,this.g=m,this.h=S,this.j=a,this.m=t,this.n=r,this.r=s,this.s=i,this.a=new C.$xh,this.b=void 0,this.c=void 0,this.y=void 0,this.z=void 0,this.t()}t(){n.$hW.on(y.$Cdc.request,(c,m)=>this.u(c,m,y.$Cdc.response)),n.$hW.on(y.$Ddc.request,(c,m)=>this.u(c,m,y.$Ddc.response)),this.B(this.m.onWillShutdown(()=>this.w()))}async u(c,m,S){this.n.trace(`[SharedProcess] onWindowConnection for: ${S}`),this.a.isOpen()||this.a.open(),await this.whenReady();const a=await this.connect(S);if(c.sender.isDestroyed())return a.close();c.sender.postMessage(S,m,[a])}w(){this.n.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(y.$Bdc.exit),this.b=void 0}whenReady(){return this.y||(this.y=(async()=>{await this.C;const c=new C.$Vh;this.b?.once(y.$Bdc.initDone,()=>c.complete()),await c.p,this.c?.dispose(),this.n.trace("[SharedProcess] Overall ready")})()),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D();const c=new C.$Vh;this.b?.once(y.$Bdc.ipcReady,()=>c.complete()),await c.p,this.n.trace("[SharedProcess] IPC ready")})()),this.z}D(){this.b=this.B(new p.$5cc(this.n,v.$kp,this.m)),this.c=this.b.onMessage(S=>{typeof S.warning=="string"?this.n.warn(S.warning):typeof S.error=="string"&&this.n.error(S.error)});const c=(0,$.$an)(this.h.args,this.h.isBuilt);let m;c.port&&(m=["--nolazy"],c.break?m.push(`--inspect-brk=${c.port}`):m.push(`--inspect=${c.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.F(),execArgv:m})}F(){return{machineId:this.f,sqmId:this.g,codeCachePath:this.h.codeCachePath,profiles:{home:this.j.profilesHome,all:this.j.profiles},args:this.h.args,logLevel:this.r.getLogLevel(),loggers:this.r.getRegisteredLoggers(),policiesData:this.s.serialize()}}async connect(c){return await this.C,(0,f.$jg)(this.b).connect(c)}};e.$Edc=w,e.$Edc=w=Ee([ie(2,R.$ncc),ie(3,h.$El),ie(4,j.$Rcc),ie(5,E.$5j),ie(6,d.$Mcc),ie(7,l.$ho)],w)}),define(se[299],re([0,1,24,91,20,5,54,61,114,37,2,3,35,18,13]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;let y=class extends d.$Uc{constructor(b,c,m,S,a){super(),this.f=b,this.g=c,this.h=m,this.j=S,this.m=a,this.a=void 0,this.b=new p.$fe,this.onRequestConnection=this.b.event,this.c=new p.$fe,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),l.$hW.on("vscode:createPtyHostMessageChannel",(t,r)=>this.r(t,r)),this.B((0,d.$Sc)(()=>{l.$hW.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new E.$5cc(this.m,j.$kp,this.j);const b=(0,C.$_m)(this.h.args,this.h.isBuilt),c=b.port?["--nolazy",`--inspect${b.break?"-brk":""}=${b.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:c,args:["--logsPath",this.h.logsHome.with({scheme:f.Schemas.file}).fsPath],env:this.n()});const m=this.a.connect(),S=new h.$pW(m,"ptyHost"),a=new d.$Tc;return a.add(S),a.add((0,d.$Sc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:S,store:a,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const b={...(0,v.$5n)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},c=this.g.getValue("terminal.integrated.developer.ptyHost.latency");c&&typeof c=="number"&&(b.VSCODE_LATENCY=String(c));const m=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return m&&typeof m=="number"&&(b.VSCODE_STARTUP_DELAY=String(m)),this.h.restoreSnapExportedVariables(),b}r(b,c){this.b.fire();const m=this.a.connect();if(b.sender.isDestroyed()){m.close();return}b.sender.postMessage("vscode:createPtyHostMessageChannelResult",c,[m])}};e.$eec=y,e.$eec=y=Ee([ie(1,$.$5i),ie(2,n.$ncc),ie(3,k.$Rcc),ie(4,R.$5j)],y)}),define(se[300],re([0,1,2,6,5,29,61,28,46,3,8,20]),function(K,e,n,C,k,R,j,E,h,l,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=e.$cec=void 0,e.$cec=(0,C.$yi)("utilityProcessWorker");let v=class extends n.$Uc{constructor(y,w,b,c){super(),this.b=y,this.c=w,this.f=b,this.g=c,this.a=new Map}async createWorker(y){const w=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${w})`);const b=this.h(y);this.a.has(b)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${w})`),this.disposeWorker(y));const c=new $(this.b,this.c,this.f,this.g,y);if(!c.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(b,c);const m=new d.$Vh;return l.Event.once(c.onDidTerminate)(S=>{S.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${S.code}, signal: ${S.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${S.code}, signal: ${S.signal}`),this.a.delete(b),m.complete({reason:S})}),m.p}h(y){return(0,h.$mj)({moduleId:y.process.moduleId,windowId:y.reply.windowId})}async disposeWorker(y){const w=this.h(y),b=this.a.get(w);b&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),b.kill(),this.a.delete(w))}};e.$dec=v,e.$dec=v=Ee([ie(0,k.$5j),ie(1,R.$ycc),ie(2,E.$4l),ie(3,p.$Rcc)],v);let $=class extends n.$Uc{constructor(y,w,b,c,m){super(),this.c=y,this.f=w,this.g=b,this.h=c,this.j=m,this.a=this.B(new l.$fe),this.onDidTerminate=this.a.event,this.b=new j.$6cc(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(y=>this.a.fire({code:y.code,signal:y.signal}))),this.B(this.b.onCrash(y=>this.a.fire({code:y.code,signal:"ECRASH"})))}spawn(){const w=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:w,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};$=Ee([ie(0,k.$5j),ie(1,R.$ycc),ie(2,E.$4l),ie(3,p.$Rcc)],$)}),define(se[301],re([0,1,14,3,2,277,29]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=void 0;let E=class extends k.$Uc{constructor(l){super(),this.b=l,this.a=this.B(new C.$fe),this.onFoundInFrame=this.a.event,this.B(new R.$Vdc)}async setIgnoreMenuShortcuts(l,d){let p;if(typeof l.windowId=="number"){const{windowId:v}=l,$=this.b.getWindowById(v);if(!$?.win)throw new Error(`Invalid windowId: ${v}`);p=$.win.webContents}else{const{webContentsId:v}=l;if(p=n.webContents.fromId(v),!p)throw new Error(`Invalid webContentsId: ${v}`)}p.isDestroyed()||p.setIgnoreMenuShortcuts(d)}async findInFrame(l,d,p,v){const f=this.c(l,d);if(typeof f.findInFrame=="function"){f.findInFrame(p,{findNext:v.findNext,forward:v.forward});const y=(w,b)=>{b.finalUpdate&&(this.a.fire(b),f.removeListener("found-in-frame",y))};f.on("found-in-frame",y)}}async stopFindInFrame(l,d,p){const $=this.c(l,d);typeof $.stopFindInFrame=="function"&&$.stopFindInFrame(p.keepSelection?"keepSelection":"clearSelection")}c(l,d){const p=this.b.getWindowById(l.windowId);if(!p?.win)throw new Error(`Invalid windowId: ${l}`);const v=p.win.webContents.mainFrame.framesInSubtree.find($=>$.name===d);if(!v)throw new Error(`Unknown frame: ${d}`);return v}};e.$Wdc=E,e.$Wdc=E=Ee([ie(0,j.$ycc)],E)}),define(se[302],re([0,1,14,2,4,19,7,18,20,5,34,29,82,30]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=void 0,e.$Ydc=w,e.$Zdc=c;let y=class extends C.$Uc{static{f=this}static{this.a="windowsState"}get state(){return this.b}constructor(a,t,r,s,i){super(),this.g=a,this.h=t,this.j=r,this.m=s,this.n=i,this.b=w(this.h.getItem(f.a)),this.c=void 0,this.f=!1,this.r()}r(){n.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(a=>this.u(a)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(a=>this.u(a))}s(){this.f=!0,this.t()}t(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(o=>!o.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const r=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);r&&(t.lastPluginDevelopmentHostWindow=this.w(r),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?k.$j&&!r.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const o=this.w(i);return o.uiState.mode===3&&(a.has(o.uiState.display)?k.$j&&o.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(o.uiState.mode=1):a.add(o.uiState.display)),o}));const s=c(t);this.h.setItem(f.a,s),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",s)}u(a){if(this.j.quitRequested)return;const t=this.w(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this.b.openedWindows.forEach(r=>{const s=(0,$.$Ni)(a.openedWorkspace)&&r.workspace?.id===a.openedWorkspace.id,i=(0,$.$Ii)(a.openedWorkspace)&&r.folderUri&&R.$3g.isEqual(r.folderUri,a.openedWorkspace.uri);(s||i)&&(r.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(a){return{windowId:a.id,workspace:(0,$.$Ni)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,$.$Ii)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.z(a),r=this.n.getValue("window");if(t.mode===3){let s;t.hasDefaultState?s=!!(r?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(r.newWindowDimensions)>=0):s=!!(this.j.wasRestarted||r?.restoreFullscreen),s||(t.mode=1)}return t}z(a){const t=this.g.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const g=a.workspace;if((0,$.$Ni)(g)){const D=this.state.openedWindows.filter(I=>I.workspace&&I.workspace.id===g.id).map(I=>I.uiState);if(D.length)return D[0]}if((0,$.$Ii)(g)){const D=this.state.openedWindows.filter(I=>I.folderUri&&R.$3g.isEqual(I.folderUri,g.uri)).map(I=>I.uiState);if(D.length)return D[0]}else if(a.backupPath){const D=this.state.openedWindows.filter(I=>I.backupPath===a.backupPath).map(I=>I.uiState);if(D.length)return D[0]}const P=this.c||this.state.lastActiveWindow;if(!t&&P)return P.uiState}let r;const s=n.screen.getAllDisplays();if(s.length===1)r=s[0];else{if(k.$j){const g=n.screen.getCursorScreenPoint();r=n.screen.getDisplayNearestPoint(g)}!r&&t&&(r=n.screen.getDisplayMatching(t.getBounds())),r||(r=n.screen.getPrimaryDisplay()||s[0])}let i=(0,v.$lcc)();i.x=Math.round(r.bounds.x+r.bounds.width/2-i.width/2),i.y=Math.round(r.bounds.y+r.bounds.height/2-i.height/2);const o=this.n.getValue("window");let u=!0;if(o?.newWindowDimensions){if(o.newWindowDimensions==="maximized")i.mode=0,u=!1;else if(o.newWindowDimensions==="fullscreen")i.mode=3,u=!1;else if((o.newWindowDimensions==="inherit"||o.newWindowDimensions==="offset")&&t){const g=t.serializeWindowState();g.mode===3?i.mode=3:i={...g,zoomLevel:void 0},u=i.mode!==3&&o.newWindowDimensions==="offset"}}return u&&(i=this.C(i)),i.hasDefaultState=!0,i}C(a){if(this.g.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.g.getWindows().map(r=>r.getBounds());for(;t.some(r=>r.x===a.x||r.y===a.y);)a.x+=30,a.y+=30;return a}};e.$Xdc=y,e.$Xdc=y=f=Ee([ie(0,p.$ycc),ie(1,d.$5P),ie(2,h.$Rcc),ie(3,l.$5j),ie(4,E.$5i)],y);function w(S){const a={openedWindows:[]},t=S||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=b(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=b(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(r=>b(r))),a}function b(S){const a={uiState:S.uiState};return S.backupPath&&(a.backupPath=S.backupPath),S.remoteAuthority&&(a.remoteAuthority=S.remoteAuthority),S.folder&&(a.folderUri=j.URI.parse(S.folder)),S.workspaceIdentifier&&(a.workspace={id:S.workspaceIdentifier.id,configPath:j.URI.parse(S.workspaceIdentifier.configURIPath)}),a}function c(S){return{lastActiveWindow:S.lastActiveWindow&&m(S.lastActiveWindow),lastPluginDevelopmentHostWindow:S.lastPluginDevelopmentHostWindow&&m(S.lastPluginDevelopmentHostWindow),openedWindows:S.openedWindows.map(a=>m(a))}}function m(S){return{workspaceIdentifier:S.workspace&&{id:S.workspace.id,configURIPath:S.workspace.configPath.toString()},folder:S.folderUri&&S.folderUri.toString(),backupPath:S.backupPath,remoteAuthority:S.remoteAuthority,uiState:S.uiState}}}),define(se[58],re([0,1,14,3,42,2,13,9,19,21,197,65,56,24,6,5,57,133,30,98,99]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w,b,c,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=e.$Kcc=void 0,e.$Kcc=(0,f.$yi)("workspacesManagementMainService");let a=class extends R.$Uc{constructor(r,s,i,o,u){super(),this.g=r,this.h=s,this.j=i,this.m=o,this.n=u,this.a=this.B(new C.$fe),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new C.$fe),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const r=(await l.Promises.readdir(this.c.with({scheme:j.Schemas.file}).fsPath)).map(s=>(0,h.$_g)(this.c,s,c.$Xi));for(const s of r){const i=(0,S.$Hcc)(s),o=await this.resolveLocalWorkspace(s);o?this.f.push({workspace:i,remoteAuthority:o.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(r){r.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${r}).`)}}resolveLocalWorkspace(r){return this.r(r,s=>l.Promises.readFile(s,"utf8"))}r(r,s){if(this.s(r)&&r.scheme===j.Schemas.file)try{const i=s(r.fsPath);return i instanceof Promise?i.then(o=>this.t(r,o),o=>{}):this.t(r,i)}catch{return}}s(r){return(0,c.$Yi)(r,this.g)||(0,c.$4i)(r)}t(r,s){try{const i=this.u(r,s),o=(0,S.$Hcc)(r);return{id:o.id,configPath:o.configPath,folders:(0,m.$3fb)(i.folders,o.configPath,h.$3g),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(r,s){const i=(0,k.$Ln)(s);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(o=>(0,m.$1fb)(o));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(r,s){const{workspace:i,storedWorkspace:o}=this.w(r,s),u=i.configPath.fsPath;return await l.Promises.mkdir((0,E.$mc)(u),{recursive:!0}),await l.Promises.writeFile(u,JSON.stringify(o,null,"	")),this.f.push({workspace:i,remoteAuthority:s}),i}w(r=[],s){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),o=(0,h.$_g)(this.c,i),u=(0,h.$_g)(o,c.$Xi),g=[];for(const P of r)g.push((0,m.$2fb)(P.uri,!0,P.name,o,h.$3g));return{workspace:(0,S.$Hcc)(u),storedWorkspace:{folders:g,remoteAuthority:s}}}async getWorkspaceIdentifier(r){return(0,S.$Hcc)(r)}isUntitledWorkspace(r){return(0,c.$Yi)(r.configPath,this.g)}async deleteUntitledWorkspace(r){this.isUntitledWorkspace(r)&&(await this.y(r),this.j.isEnabled()&&this.j.unsetWorkspace(r),this.a.fire(r))}async y(r){const s=(0,h.$Zg)(r.configPath);try{await l.Promises.rm((0,E.$mc)(s));const i=(0,E.$jc)(this.g.workspaceStorageHome.with({scheme:j.Schemas.file}).fsPath,r.id);await l.Promises.exists(i)&&await l.Promises.writeFile((0,E.$jc)(i,"obsolete"),""),this.f=this.f.filter(o=>o.workspace.id!==r.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${s} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(r,s,i){if(!r||!r.win||!r.isReady||!await this.z(r,s,i))return;const u=await this.C(r,(0,S.$Hcc)(i));if(u)return this.b.fire({window:r,workspace:u.workspace}),u}async z(r,s,i){return i?(0,c.$Ni)(r.openedWorkspace)&&h.$3g.isEqual(r.openedWorkspace.configPath,i)?!1:(0,b.$Ecc)(s,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,d.localize)(0,null)],message:(0,d.localize)(1,null,(0,h.$9g)(i)),detail:(0,d.localize)(2,null)},n.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(r,s){if(!r.config)return;r.focus();let i;return r.config.extensionDevelopmentPath||(r.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:r.remoteAuthority},r.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:r.remoteAuthority})),(0,c.$Ni)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&await this.deleteUntitledWorkspace(r.openedWorkspace),r.config.workspace=s,r.config.backupPath=i,{workspace:s,backupPath:i}}};e.$Lcc=a,e.$Lcc=a=Ee([ie(0,$.$ncc),ie(1,y.$5j),ie(2,w.$Bcc),ie(3,p.$scc),ie(4,v.$tcc)],a)}),define(se[134],re([0,1,14,37,23,6,29,30,58,12,5,61]),function(K,e,n,C,k,R,j,E,h,l,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=e.$8cc=e.ID=void 0,e.ID="diagnosticsMainService",e.$8cc=(0,R.$yi)(e.ID);let v=class{constructor(f,y,w){this.a=f,this.b=y,this.c=w}async getRemoteDiagnostics(f){const y=this.a.getWindows();return(await Promise.all(y.map(async b=>{const c=b.remoteAuthority;if(!c)return;const m=`vscode:getDiagnosticInfoResponse${b.id}`,S={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?await this.f(b):void 0};return new Promise(a=>{b.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:m,args:S}),C.$hW.once(m,(t,r)=>{r||a({hostName:c,errorMessage:`Unable to resolve connection to '${c}'.`}),a(r)}),setTimeout(()=>{a({hostName:c,errorMessage:`Connection to '${c}' could not be established`})},5e3)})}))).filter(b=>!!b)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const f=[];for(const w of n.BrowserWindow.getAllWindows()){const b=this.a.getWindowById(w.id);b?f.push(await this.d(b)):f.push(this.e(w))}const y=[];for(const{pid:w,name:b}of p.$5cc.getAll())y.push({pid:w,name:b});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,pidToNames:y,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(f){const y=await this.f(f),w=(0,l.$jg)(f.win);return this.e(w,y,f.remoteAuthority)}e(f,y=[],w){return{id:f.id,pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:y,remoteAuthority:w}}async f(f){const y=[],w=f.openedWorkspace;if((0,E.$Ii)(w))y.push(w.uri);else if((0,E.$Ni)(w)){const b=await this.b.resolveLocalWorkspace(w.configPath);b&&b.folders.forEach(m=>{y.push(m.uri)})}return y}};e.$9cc=v,e.$9cc=v=Ee([ie(0,j.$ycc),ie(1,h.$Kcc),ie(2,d.$5j)],v)}),define(se[70],re([0,1,49,14,26,158,51,3,2,13,9,4,7,109,89,21,107,185,56,24,6,20,5,27,69,29,30,58,17,247,239,79,15]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w,b,c,m,S,a,t,r,s,i,o,u,g,P,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=e.$kdc=void 0,e.$kdc=(0,S.$yi)("nativeHostMainService");let M=class extends h.$Uc{constructor(F,T,U,ae,te,ce,J,V,q){super(),this.a=F,this.b=T,this.c=U,this.f=ae,this.g=te,this.h=ce,this.j=J,this.m=V,this.n=q,this.onDidOpenMainWindow=E.Event.map(this.a.onDidOpenWindow,L=>L.id),this.onDidTriggerWindowSystemContextMenu=E.Event.any(E.Event.map(this.a.onDidTriggerSystemContextMenu,({window:L,x:B,y:H})=>({windowId:L.id,x:B,y:H})),E.Event.map(this.b.onDidTriggerSystemContextMenu,({window:L,x:B,y:H})=>({windowId:L.id,x:B,y:H}))),this.onDidMaximizeWindow=E.Event.any(E.Event.map(this.a.onDidMaximizeWindow,L=>L.id),E.Event.map(this.b.onDidMaximizeWindow,L=>L.id)),this.onDidUnmaximizeWindow=E.Event.any(E.Event.map(this.a.onDidUnmaximizeWindow,L=>L.id),E.Event.map(this.b.onDidUnmaximizeWindow,L=>L.id)),this.onDidChangeWindowFullScreen=E.Event.any(E.Event.map(this.a.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen})),E.Event.map(this.b.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen}))),this.onDidBlurMainWindow=E.Event.filter(E.Event.fromNodeEventEmitter(C.app,"browser-window-blur",(L,B)=>B.id),L=>!!this.a.getWindowById(L)),this.onDidFocusMainWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),L=>!!L),L=>L.id),E.Event.filter(E.Event.fromNodeEventEmitter(C.app,"browser-window-focus",(L,B)=>B.id),L=>!!this.a.getWindowById(L))),this.onDidBlurMainOrAuxiliaryWindow=E.Event.any(this.onDidBlurMainWindow,E.Event.map(E.Event.filter(E.Event.fromNodeEventEmitter(C.app,"browser-window-blur",(L,B)=>this.b.getWindowByWebContents(B.webContents)),L=>!!L),L=>L.id)),this.onDidFocusMainOrAuxiliaryWindow=E.Event.any(this.onDidFocusMainWindow,E.Event.map(E.Event.filter(E.Event.fromNodeEventEmitter(C.app,"browser-window-focus",(L,B)=>this.b.getWindowByWebContents(B.webContents)),L=>!!L),L=>L.id)),this.onDidResumeOS=E.Event.fromNodeEventEmitter(C.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new E.$fe),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(C.screen,"display-metrics-changed",(L,B,H)=>H),L=>!(Array.isArray(L)&&L.length===1&&L[0]==="workArea")),E.Event.fromNodeEventEmitter(C.screen,"display-added"),E.Event.fromNodeEventEmitter(C.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(F,T){const U=this.a.getWindows().map(te=>({id:te.id,workspace:te.openedWorkspace??(0,o.$Mi)(te.backupPath,te.isExtensionDevelopmentHost),title:te.win?.getTitle()??"",filename:te.getRepresentedFilename(),dirty:te.isDocumentEdited()})),ae=[];return T.includeAuxiliaryWindows&&ae.push(...this.b.getWindows().map(te=>({id:te.id,parentId:te.parentId,title:te.win?.getTitle()??"",filename:te.getRepresentedFilename()}))),[...U,...ae]}async getWindowCount(F){return this.a.getWindowCount()}async getActiveWindowId(F){const T=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(T)return T.id}openWindow(F,T,U){return Array.isArray(T)?this.s(F,T,U):this.t(F,T)}async s(F,T,U=Object.create(null)){T.length>0&&await this.a.open({context:5,contextWindowId:F,urisToOpen:T,cli:this.g.args,forceNewWindow:U.forceNewWindow,forceReuseWindow:U.forceReuseWindow,preferNewWindow:U.preferNewWindow,diffMode:U.diffMode,mergeMode:U.mergeMode,addMode:U.addMode,gotoLineMode:U.gotoLineMode,noRecentEntry:U.noRecentEntry,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:U.remoteAuthority||void 0,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile})}async t(F,T){await this.a.openEmptyWindow({context:5,contextWindowId:F},T)}async toggleFullScreen(F,T){this.C(T?.targetWindowId,F)?.toggleFullScreen()}async handleTitleDoubleClick(F,T){this.C(T?.targetWindowId,F)?.handleTitleDoubleClick()}async getCursorScreenPoint(F){const T=C.screen.getCursorScreenPoint(),U=C.screen.getDisplayNearestPoint(T);return{point:T,display:U.bounds}}async isMaximized(F,T){return this.C(T?.targetWindowId,F)?.win?.isMaximized()??!1}async maximizeWindow(F,T){this.C(T?.targetWindowId,F)?.win?.maximize()}async unmaximizeWindow(F,T){this.C(T?.targetWindowId,F)?.win?.unmaximize()}async minimizeWindow(F,T){this.C(T?.targetWindowId,F)?.win?.minimize()}async moveWindowTop(F,T){this.C(T?.targetWindowId,F)?.win?.moveTop()}async positionWindow(F,T,U){const ae=this.C(U?.targetWindowId,F);if(ae?.win){if(ae.win.isFullScreen()){const te=E.Event.toPromise(E.Event.once(E.Event.fromNodeEventEmitter(ae.win,"leave-full-screen")));ae.win.setFullScreen(!1),await te}ae.win.setBounds(T)}}async updateWindowControls(F,T){this.C(T?.targetWindowId,F)?.updateWindowControls(T)}async focusWindow(F,T){this.C(T?.targetWindowId,F)?.focus({force:T?.force??!1})}async setMinimumSize(F,T,U){const ae=this.D(F);if(ae?.win){const[te,ce]=ae.win.getSize(),[J,V]=ae.win.getMinimumSize(),[q,L]=[T??J,U??V],[B,H]=[Math.max(te,q),Math.max(ce,L)];(J!==q||V!==L)&&ae.win.setMinimumSize(q,L),(te!==B||ce!==H)&&ae.win.setSize(B,H)}}async saveWindowSplash(F,T){this.m.saveWindowSplash(F,T)}async installShellCommand(F){const{source:T,target:U}=await this.u();try{const{symbolicLink:ae}=await y.SymlinkSupport.stat(T);if(ae&&!ae.dangling){const te=await(0,$.$9q)(T);if(U===te)return}await y.Promises.unlink(T)}catch(ae){if(ae.code!=="ENOENT")throw ae}try{await y.Promises.symlink(U,T)}catch(ae){if(ae.code!=="EACCES"&&ae.code!=="ENOENT")throw ae;const{response:te}=await this.showMessageBox(F,{type:"info",message:(0,b.localize)(0,null,this.j.nameShort),buttons:[(0,b.localize)(1,null),(0,b.localize)(2,null)]});if(te===1)throw new O.$5;try{const ce=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${U}' '${T}'\\" with administrator privileges"`;await(0,R.promisify)(n.exec)(ce)}catch{throw new Error((0,b.localize)(3,null,T))}}}async uninstallShellCommand(F){const{source:T}=await this.u();try{await y.Promises.unlink(T)}catch(U){switch(U.code){case"EACCES":{const{response:ae}=await this.showMessageBox(F,{type:"info",message:(0,b.localize)(4,null,this.j.nameShort),buttons:[(0,b.localize)(5,null),(0,b.localize)(6,null)]});if(ae===1)throw new O.$5;try{const te=`osascript -e "do shell script \\"rm '${T}'\\" with administrator privileges"`;await(0,R.promisify)(n.exec)(te)}catch{throw new Error((0,b.localize)(7,null,T))}break}case"ENOENT":break;default:throw U}}}async u(){const F=(0,d.$kc)(this.g.appRoot,"bin","code"),T=`/usr/local/bin/${this.j.applicationName}`;if(!await y.Promises.exists(F))throw new Error((0,b.localize)(8,null,F));return{source:T,target:F}}async showMessageBox(F,T){const U=this.C(T?.targetWindowId,F);return this.c.showMessageBox(T,U?.win??void 0)}async showSaveDialog(F,T){const U=this.C(T?.targetWindowId,F);return this.c.showSaveDialog(T,U?.win??void 0)}async showOpenDialog(F,T){const U=this.C(T?.targetWindowId,F);return this.c.showOpenDialog(T,U?.win??void 0)}async pickFileFolderAndOpen(F,T){const U=await this.c.pickFileFolder(T);U&&await this.w(await Promise.all(U.map(async ae=>await y.SymlinkSupport.existsDirectory(ae)?{folderUri:v.URI.file(ae)}:{fileUri:v.URI.file(ae)})),T,F)}async pickFolderAndOpen(F,T){const U=await this.c.pickFolder(T);U&&await this.w(U.map(ae=>({folderUri:v.URI.file(ae)})),T,F)}async pickFileAndOpen(F,T){const U=await this.c.pickFile(T);U&&await this.w(U.map(ae=>({fileUri:v.URI.file(ae)})),T,F)}async pickWorkspaceAndOpen(F,T){const U=await this.c.pickWorkspace(T);U&&await this.w(U.map(ae=>({workspaceUri:v.URI.file(ae)})),T,F)}async w(F,T,U){await this.a.open({context:3,contextWindowId:U,cli:this.g.args,urisToOpen:F,forceNewWindow:T.forceNewWindow})}async showItemInFolder(F,T){C.shell.showItemInFolder(T)}async setRepresentedFilename(F,T,U){this.C(U?.targetWindowId,F)?.setRepresentedFilename(T)}async setDocumentEdited(F,T,U){this.C(U?.targetWindowId,F)?.setDocumentEdited(T)}async openExternal(F,T){return this.g.unsetSnapExportedVariables(),C.shell.openExternal(T),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(F,T){return C.shell.trashItem(T)}async isAdmin(){let F;return p.$i?F=(await new Promise((T,U)=>{K(["native-is-elevated"],T,U)}))():F=process.getuid?.()===0,F}async writeElevated(F,T,U,ae){const te=await new Promise((ce,J)=>{K(["@vscode/sudo-prompt"],ce,J)});return new Promise((ce,J)=>{const V=[`"${this.z}"`];ae?.unlock&&V.push("--file-chmod"),V.push("--file-write",`"${T.fsPath}"`,`"${U.fsPath}"`);const q={name:this.j.nameLong.replace("-",""),icns:p.$j&&this.g.isBuilt?(0,d.$jc)((0,d.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};te.exec(V.join(" "),q,(L,B,H)=>{B&&this.h.trace(`[sudo-prompt] received stdout: ${B}`),H&&this.h.trace(`[sudo-prompt] received stderr: ${H}`),L?J(L):ce(void 0)})})}async isRunningUnderARM64Translation(){return p.$k||p.$i?!1:C.app.runningUnderARM64Translation}get z(){return p.$i?this.g.isBuilt?(0,d.$jc)((0,d.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,d.$jc)(this.g.appRoot,"scripts","code-cli.bat"):p.$k?this.g.isBuilt?(0,d.$jc)((0,d.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,d.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,d.$jc)(this.g.appRoot,"bin","code"):(0,d.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return f.$Gn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return p.$i&&(0,P.$hdc)()}async killProcess(F,T,U){process.kill(T,U)}async readClipboardText(F,T){return C.clipboard.readText(T)}async writeClipboardText(F,T,U){return C.clipboard.writeText(T,U)}async readClipboardFindText(F){return C.clipboard.readFindText()}async writeClipboardFindText(F,T){return C.clipboard.writeFindText(T)}async writeClipboardBuffer(F,T,U,ae){return C.clipboard.writeBuffer(T,Buffer.from(U.buffer),ae)}async readClipboardBuffer(F,T){return g.$He.wrap(C.clipboard.readBuffer(T))}async hasClipboard(F,T,U){return C.clipboard.has(T,U)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){C.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){C.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){C.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){C.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){C.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,T){this.D(F)?.updateTouchBar(T)}async notifyReady(F){this.D(F)?.setReady()}async relaunch(F,T){return this.f.relaunch(T)}async reload(F,T){const U=this.D(F);if(U){if((0,o.$Ni)(U.openedWorkspace)){const ae=U.openedWorkspace.configPath;if(ae.scheme===l.Schemas.file&&(await this.n.resolveLocalWorkspace(ae))?.transient)return this.openWindow(U.id,{forceReuseWindow:!0})}return this.f.reload(U,T?.disableExtensions!==void 0?{_:[],"disable-extensions":T.disableExtensions}:void 0)}}async closeWindow(F,T){return this.C(T?.targetWindowId,F)?.win?.close()}async quit(F){const T=this.a.getLastActiveWindow();T?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&T.win?T.win.close():this.f.quit()}async exit(F,T){await this.f.kill(T)}async resolveProxy(F,T){return this.D(F)?.win?.webContents?.session?.resolveProxy(T)}async loadCertificates(F){return(await new Promise((U,ae)=>{K(["@vscode/proxy-agent"],U,ae)})).loadSystemCertificates({log:this.h})}findFreePort(F,T,U,ae,te=1){return(0,w.$Wg)(T,U,ae,te)}async openDevTools(F,T){this.C(T?.targetWindowId,F)?.win?.webContents.openDevTools(T?.mode?{mode:T.mode,activate:T.activate}:void 0)}async toggleDevTools(F,T){this.C(T?.targetWindowId,F)?.win?.webContents.toggleDevTools()}async profileRenderer(F,T,U){const ae=this.D(F);if(!ae||!ae.win)throw new Error;return await new D.$idc(ae.win,T,this.h).inspect(U)}async windowsGetStringRegKey(F,T,U,ae){if(!p.$i)return;const te=await new Promise((ce,J)=>{K(["@vscode/windows-registry"],ce,J)});try{return te.GetStringRegKey(T,U,ae)}catch{return}}C(F,T){return this.D(F)??this.F(F)??this.D(T)}D(F){if(typeof F=="number")return this.a.getWindowById(F)}F(F){if(typeof F!="number")return;const T=C.webContents.fromId(F);if(T)return this.b.getWindowByWebContents(T)}};e.$ldc=M,Ee([j.$3h],M.prototype,"z",null),e.$ldc=M=Ee([ie(0,i.$ycc),ie(1,I.$jdc),ie(2,c.$tcc),ie(3,a.$Rcc),ie(4,m.$ncc),ie(5,t.$5j),ie(6,r.$lk),ie(7,s.$wcc),ie(8,u.$Kcc)],M)}),define(se[303],re([0,1,14,26,8,23,31,2,13,4,111,37,182,92,134,56,24,5,70,80,27,81,34,61,55,29]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w,b,c,m,S,a,t,r,s,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=void 0;const u="issue.processExplorerWindowState";let g=class{static{o=this}static{this.a="#1E1E1E"}constructor(I,O,M,W,F,T,U,ae,te,ce,J){this.g=I,this.h=O,this.i=M,this.j=W,this.k=F,this.l=T,this.m=U,this.n=ae,this.o=te,this.p=ce,this.q=J,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){p.$hW.on("vscode:listProcesses",async I=>{const O=[];try{O.push({name:(0,v.localize)(0,null),rootProcess:await(0,d.$Gs)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(W=>{(0,$.$gn)(W)?O.push({name:W.hostName,rootProcess:W}):W.processes&&O.push({name:W.hostName,rootProcess:W.processes})})}catch(M){this.i.error(`Listing processes failed: ${M}`)}this.t(I,"vscode:listProcessesResponse",O)}),p.$hW.on("vscode:workbenchCommand",(I,O)=>{const{id:M,from:W,args:F}=O;let T;switch(W){case"processExplorer":T=this.f;break;default:throw new Error(`Unexpected command source: ${W}`)}T?.webContents.send("vscode:runAction",{id:M,from:W,args:F})}),p.$hW.on("vscode:closeProcessExplorer",I=>{this.d?.close()}),p.$hW.on("vscode:pidToNameRequest",async I=>{const O=await this.k.getMainDiagnostics(),M=[];for(const W of O.windows)M.push([W.pid,`window [${W.id}] (${W.title})`]);for(const{pid:W,name:F}of r.$5cc.getAll())M.push([W,F]);this.t(I,"vscode:pidToNameResponse",M)})}async openReporter(I){if(this.b)this.b&&this.s(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const O=new E.$Tc,M=O.add(this.n.createIPCObjectUrl()),W=this.v(this.c,700,800);this.b=this.u(W,M,{backgroundColor:I.styles.backgroundColor,title:(0,v.localize)(1,null),zoomLevel:I.zoomLevel,alwaysOnTop:!1},"issue-reporter"),M.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:I,disableExtensions:!!this.h.disableExtensions,os:{type:(0,C.type)(),arch:(0,C.arch)(),release:(0,C.release)()},product:m.default}),this.b.loadURL(h.$Sg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,O.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,O.dispose())})}}async openProcessExplorer(I){if(!this.d&&(this.f=n.BrowserWindow.getFocusedWindow(),this.f)){const O=new E.$Tc,M=O.add(this.n.createIPCObjectUrl()),W=this.p.getItem(u,void 0),F=P(W)?W:this.v(this.f,800,500);this.d=this.u(F,M,{backgroundColor:I.styles.backgroundColor,title:(0,v.localize)(2,null),zoomLevel:I.zoomLevel,alwaysOnTop:!0},"process-explorer"),M.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:I,product:m.default}),this.d.loadURL(h.$Sg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,O.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,O.dispose())});const T=()=>{if(!this.d)return;const U=this.d.getSize(),ae=this.d.getPosition();if(!U||!ae)return;const te={width:U[0],height:U[1],x:ae[0],y:ae[1]};this.p.setItem(u,te)};this.d.on("moved",T),this.d.on("resized",T)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const I=await n.contentTracing.stopRecording(`${(0,j.$Gg)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,v.localize)(3,null),detail:(0,v.localize)(4,null,I),buttons:[(0,v.localize)(5,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,I)}async getSystemStatus(){const[I,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(I,O)}async $getSystemInfo(){const[I,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(I,O)}async $getPerformanceInfo(){try{const[I,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(I,O)}catch(I){throw this.i.warn("issueService#getPerformanceInfo ",I.message),I}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(I){this.i.error(I)}}async $showConfirmCloseDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,v.localize)(6,null),buttons:[(0,v.localize)(7,null),(0,v.localize)(8,null)]},this.b);I===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,v.localize)(9,null),buttons:[(0,v.localize)(10,null),(0,v.localize)(11,null)]},this.b);return I===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const I=this.q.getWindowById(this.c.id);if(!I)throw new Error("Window not found");return I}async $sendReporterMenu(I,O){const M=this.issueReporterWindowCheck(),W="vscode:triggerReporterMenu",F=new R.$qe;return M.sendWhenReady(W,F.token,{replyChannel:W,extensionId:I,extensionName:O}),await(0,k.$ph)(new Promise(U=>p.$hW.once(`vscode:triggerReporterMenuResponse:${I}`,(ae,te)=>U(te))),5e3,()=>{this.i.error(`Error: Extension ${I} timed out waiting for menu response`),F.cancel()})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(I){I.isMinimized()&&I.restore(),I.focus()}t(I,O,...M){I.sender.isDestroyed()||I.sender.send(O,...M)}u(I,O,M,W){const F=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:I.width,height:I.height,minWidth:300,minHeight:200,x:I.x,y:I.y,title:M.title,backgroundColor:M.backgroundColor||o.a,webPreferences:{preload:h.$Sg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${O.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$PD)(M.zoomLevel),sandbox:!0},alwaysOnTop:M.alwaysOnTop,experimentalDarkMode:!0});return F.setMenuBarVisibility(!1),F}v(I,O,M){let W;const F=n.screen.getAllDisplays();if(F.length===1)W=F[0];else{if(l.$j){const ae=n.screen.getCursorScreenPoint();W=n.screen.getDisplayNearestPoint(ae)}!W&&I&&(W=n.screen.getDisplayMatching(I.getBounds())),W||(W=n.screen.getPrimaryDisplay()||F[0])}const T=W.bounds,U={width:O,height:M,x:T.x+T.width/2-O/2,y:T.y+T.height/2-M/2};return T.width>0&&T.height>0&&(U.x<T.x&&(U.x=T.x),U.y<T.y&&(U.y=T.y),U.x>T.x+T.width&&(U.x=T.x),U.y>T.y+T.height&&(U.y=T.y),U.width>T.width&&(U.width=T.width),U.height>T.height&&(U.height=T.height)),U}};e.$mdc=g,e.$mdc=g=o=Ee([ie(1,w.$ncc),ie(2,b.$5j),ie(3,$.$fn),ie(4,f.$8cc),ie(5,y.$tcc),ie(6,c.$kdc),ie(7,a.$vcc),ie(8,S.$lk),ie(9,t.$5P),ie(10,i.$ycc)],g);function P(D){return typeof D!="object"||D===null?!1:"x"in D&&"y"in D&&"width"in D&&"height"in D}}),define(se[304],re([0,1,23,18,24,20,5,70,27,53,28,50,101]),function(K,e,n,C,k,R,j,E,h,l,d,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;let $=class extends v.$Ldc{constructor(y,w,b,c,m,S,a,t){super(y,w,c,m,S,t),this.e=b,this.u=a}s(y){return(0,v.$Kdc)(`linux-${process.arch}`,y,this.k)}t(y){this.a&&(this.d(p.$fX.CheckingForUpdates(y)),this.i.request({url:this.a},n.CancellationToken.None).then(l.$Wp).then(w=>{!w||!w.url||!w.version||!w.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!y}),this.d(p.$fX.Idle(1))):this.d(p.$fX.AvailableForDownload(w))}).then(void 0,w=>{this.j.error(w);const b=y?w.message||w:void 0;this.d(p.$fX.Idle(1,b))}))}async o(y){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):y.update.url&&this.u.openExternal(void 0,y.update.url),this.d(p.$fX.Idle(1))}};e.$Ndc=$,e.$Ndc=$=Ee([ie(0,R.$Rcc),ie(1,C.$5i),ie(2,d.$4l),ie(3,k.$ncc),ie(4,l.$Qp),ie(5,j.$5j),ie(6,E.$kdc),ie(7,h.$lk)],$)}),define(se[305],re([0,1,49,43,26,8,23,51,46,9,7,146,21,18,24,16,20,5,70,27,53,28,50,101]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w,b,c,m,S,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;async function s(g,P=1e3){for(;!g();)await(0,R.$zh)(P)}let i;function o(){return typeof i>"u"&&(i=C.existsSync(l.$jc(l.$mc(process.execPath),"unins000.exe"))?0:1),i}let u=class extends r.$Ldc{get cachePath(){const P=l.$jc((0,k.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return v.Promises.mkdir(P,{recursive:!0}).then(()=>P)}constructor(P,D,I,O,M,W,F,T,U){super(P,D,O,M,W,U),this.u=I,this.v=F,this.w=T,P.setRelaunchHandler(this)}handleRelaunch(P){return P?.addArgs||P?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$fX.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(P){let D=`win32-${process.arch}`;return o()===1?D+="-archive":this.k.target==="user"&&(D+="-user"),(0,r.$Kdc)(D,P,this.k)}t(P){this.a&&(this.d(t.$fX.CheckingForUpdates(P)),this.i.request({url:this.a},j.CancellationToken.None).then(S.$Wp).then(D=>{const I=o();return!D||!D.url||!D.version||!D.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!P}),this.d(t.$fX.Idle(I)),Promise.resolve(null)):I===1?(this.d(t.$fX.AvailableForDownload(D)),Promise.resolve(null)):(this.d(t.$fX.Downloading),this.C(D.version).then(()=>this.B(D.version).then(O=>v.Promises.exists(O).then(M=>{if(M)return Promise.resolve(O);const W=`${O}.tmp`;return this.i.request({url:D.url},j.CancellationToken.None).then(F=>this.v.writeFile(d.URI.file(W),F.stream)).then(D.sha256hash?()=>(0,p.$aW)(W,D.sha256hash):()=>{}).then(()=>v.Promises.rename(W,O,!1)).then(()=>O)})).then(O=>{this.e={packagePath:O},this.d(t.$fX.Downloaded(D)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(t.$fX.Ready(D))})))}).then(void 0,D=>{this.u.publicLog2("update:error",{messageHash:String((0,h.$mj)(String(D)))}),this.j.error(D);const I=P?D.message||D:void 0;this.d(t.$fX.Idle(o(),I))}))}async o(P){P.update.url&&this.w.openExternal(void 0,P.update.url),this.d(t.$fX.Idle(o()))}async B(P){const D=await this.cachePath;return l.$jc(D,`CodeSetup-${this.k.quality}-${P}.exe`)}async C(P=null){const D=P?W=>!new RegExp(`${this.k.quality}-${P}\\.exe$`).test(W):()=>!0,I=await this.cachePath,M=(await v.Promises.readdir(I)).filter(D).map(async W=>{try{await v.Promises.unlink(l.$jc(I,W))}catch{}});await Promise.all(M)}async p(){if(this.state.type!=="downloaded"||!this.e)return Promise.resolve(void 0);const P=this.state.update;this.d(t.$fX.Updating(P));const D=await this.cachePath;this.e.updateFilePath=l.$jc(D,`CodeSetup-${this.k.quality}-${P.version}.flag`),await v.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$fX.Idle(o()))});const O=`${this.k.win32MutexName}-ready`,M=await new Promise((W,F)=>{K(["@vscode/windows-mutex"],W,F)});s(()=>M.isActive(O)).then(()=>this.d(t.$fX.Ready(P)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?C.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return o()}async _applySpecificUpdate(P){if(this.state.type!=="idle")return;const D=this.g.getValue("update.enableWindowsBackgroundUpdates"),I={version:"unknown",productVersion:"unknown"};this.d(t.$fX.Downloading),this.e={packagePath:P},this.d(t.$fX.Downloaded(I)),D?this.k.target==="user"&&this.p():this.d(t.$fX.Ready(I))}};e.$Pdc=u,Ee([E.$3h],u.prototype,"cachePath",null),e.$Pdc=u=Ee([ie(0,w.$Rcc),ie(1,$.$5i),ie(2,a.$4l),ie(3,f.$ncc),ie(4,S.$Qp),ie(5,b.$5j),ie(6,y.$5k),ie(7,c.$kdc),ie(8,m.$lk)],u)}),define(se[135],re([0,1,14,8,23,47,3,2,13,66,4,7,193,26,65,18,56,24,64,16,20,5,27,81,256,84,28,106,69,55,29,30,58,82,39,34,57,67,22,6]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w,b,c,m,S,a,t,r,s,i,o,u,g,P,D,I,O,M,W,F,T,U,ae,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=e.$Occ=void 0;var ce;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(ce||(ce={}));class J extends E.$Uc{get lastFocusTime(){return this.j}get win(){return this.m}n(L){this.m=L,this.B(j.Event.fromNodeEventEmitter(L,"maximize")(()=>this.b.fire())),this.B(j.Event.fromNodeEventEmitter(L,"unmaximize")(()=>this.c.fire())),this.B(j.Event.fromNodeEventEmitter(L,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(j.Event.fromNodeEventEmitter(L,"focus")(()=>{this.j=Date.now()})),this.B(j.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(j.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const B=!(0,P.$KD)(this.r);if(d.$j&&B&&L.setSheetOffset((0,d.$J)((0,$.release)())?28:22),B&&(d.$i&&(0,P.$ND)(this.r)||d.$j)){const H=this.s.getItem(J.D);H?this.updateWindowControls({height:H}):this.updateWindowControls({height:P.$MD})}d.$i&&B&&L.hookWindowMessage(278,()=>{const[oe,G]=L.getPosition(),le=n.screen.getCursorScreenPoint(),Q=le.x-oe,A=le.y-G;return!(Q>30&&A>=0&&A<=Math.max(L.getBounds().height*.15,35))||(L.setEnabled(!1),L.setEnabled(!0),this.f.fire({x:Q,y:A})),0}),this.t.args["open-devtools"]===!0&&L.webContents.openDevTools(),d.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(L,B,H,oe){super(),this.r=L,this.s=B,this.t=H,this.u=oe,this.a=this.B(new j.$fe),this.onDidClose=this.a.event,this.b=this.B(new j.$fe),this.onDidMaximize=this.b.event,this.c=this.B(new j.$fe),this.onDidUnmaximize=this.c.event,this.f=this.B(new j.$fe),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new j.$fe),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new j.$fe),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,P.$ND)(this.r),this.G=void 0,this.H=void 0}w(L,B=n.screen.getAllDisplays().length>0){const H=this.r.getValue("window"),oe=d.$j&&H?.nativeTabs===!0;(d.$j||d.$i)&&B&&(!oe||n.BrowserWindow.getAllWindows().length===1)&&[L.width,L.height,L.x,L.y].every(G=>typeof G=="number")&&this.m?.setBounds({width:L.width,height:L.height,x:L.x,y:L.y}),(L.mode===0||L.mode===3)&&(this.m?.maximize(),L.mode===3&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(L){d.$j?this.win?.setRepresentedFilename(L):this.z=L}getRepresentedFilename(){return d.$j?this.win?.getRepresentedFilename():this.z}setDocumentEdited(L){d.$j&&this.win?.setDocumentEdited(L),this.C=L}isDocumentEdited(){return d.$j?!!this.win?.isDocumentEdited():!!this.C}focus(L){d.$j&&L?.force&&n.app.focus({steal:!0});const B=this.win;B&&(B.isMinimized()&&B.restore(),B.focus())}handleTitleDoubleClick(){const L=this.win;if(L)if(d.$j)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":L.minimize();break;case"None":break;case"Maximize":default:L.isMaximized()?L.unmaximize():L.maximize()}else L.isMaximized()?L.unmaximize():L.maximize()}static{this.D="windowControlHeight"}updateWindowControls(L){const B=this.win;if(B){if(L.height&&this.s.setItem(V.D,L.height),d.$i&&this.F)B.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(d.$j&&L.height!==void 0){const H=(L.height-15)/2;H?B.setWindowButtonPosition({x:H,y:H}):B.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(L,B){(0,P.$OD)(this.r)?this.J(L,B):this.M(L)}get isFullScreen(){if(d.$j&&typeof this.G=="boolean")return this.G;const L=this.win,B=L?.isFullScreen(),H=L?.isSimpleFullScreen();return!!(B||H)}J(L,B){const H=this.win;H?.isSimpleFullScreen()&&H?.setSimpleFullScreen(!1),this.L(L,B)}L(L,B){if(d.$j){this.G=L;const oe=this.H=new C.$Vh;(async()=>{const G=await Promise.race([oe.p,(0,C.$zh)(1e4).then(()=>!1)]);this.H===oe&&(this.G=void 0,this.H=void 0,!G&&L&&B&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(L)}M(L){const B=this.win;B?.isFullScreen()&&this.L(!1,!1),B?.setSimpleFullScreen(L),B?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$Occ=J;let V=class extends J{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const L=this.hb.profiles.find(B=>B.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.hb.getProfileForWorkspace(this.config.workspace??(0,I.$Mi)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(L,B,H,oe,G,le,Q,A,N,_,z,Y,x,ee,X,ue,he,pe,$e,ye,Se){super(_,ye,oe,B),this.fb=H,this.gb=G,this.hb=le,this.ib=Q,this.jb=A,this.kb=N,this.lb=z,this.mb=Y,this.nb=x,this.ob=ee,this.pb=X,this.qb=ue,this.rb=he,this.sb=pe,this.tb=$e,this.N=this.B(new j.$fe),this.onWillLoad=this.N.event,this.O=this.B(new j.$fe),this.onDidSignalReady=this.O.event,this.P=this.B(new j.$fe),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=0;{const[ke,Re]=this.Eb(L.state);this.U=ke,this.u.trace("window#ctor: using window state",ke);const we=Se.invokeFunction(D.$zcc,this.U,{preload:h.$Sg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,l.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.BrowserWindow(we),(0,l.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m),this.w(this.U,Re),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=2;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.X.push(L)})}get isReady(){return this.ub===2}get whenClosedOrLoaded(){return new Promise(L=>{function B(){H.dispose(),oe.dispose(),L()}const H=this.onDidClose(()=>B()),oe=this.onWillLoad(()=>B())})}vb(){this.B(j.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(1))),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(B,H)=>H)(B=>this.yb(2,{...B}))),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(B,H,oe)=>({exitCode:H,reason:oe}))(({exitCode:B,reason:H})=>this.yb(3,{reason:H,exitCode:B}))),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(B=>B.preventDefault())),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(B=>this.Bb(B))),this.B(this.mb.onDidDeleteUntitledWorkspace(B=>this.Ab(B)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(B,H)=>{const oe=await this.xb();H({cancel:!1,requestHeaders:Object.assign(B.requestHeaders,oe)})})}xb(){return this.wb||(this.wb=(0,s.$$p)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(L,B){switch(L){case 2:this.u.error(`CodeWindow: renderer process gone (reason: ${B?.reason||"<unknown>"}, code: ${B?.exitCode||"<unknown>"})`);break;case 1:this.u.error("CodeWindow: detected unresponsive");break;case 3:this.u.error(`CodeWindow: failed to load (reason: ${B?.reason||"<unknown>"}, code: ${B?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:L,reason:B?.reason,code:B?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:H,checkboxChecked:oe}=await this.pb.showMessageBox({type:"warning",buttons:[(0,v.localize)(0,null),(0,v.localize)(1,null),(0,v.localize)(2,null)],message:(0,v.localize)(3,null),detail:(0,v.localize)(4,null),checkboxLabel:this.S?.workspace?(0,v.localize)(5,null):void 0},this.m);if(H!==2){const G=H===0;await this.zb(G,oe)}}else if(L===2){let H;B?H=(0,v.localize)(7,null,B.reason,B.exitCode??"<unknown>"):H=(0,v.localize)(6,null);const{response:oe,checkboxChecked:G}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,v.localize)(8,null):(0,v.localize)(9,null),(0,v.localize)(10,null)],message:H,detail:this.S?.workspace?(0,v.localize)(11,null):(0,v.localize)(12,null),checkboxLabel:this.S?.workspace?(0,v.localize)(13,null):void 0},this.m),le=oe===0;await this.zb(le,G)}break}}async zb(L,B){const H=this.S?.workspace;if(B&&H)try{const oe=this.kb.workspaceStorage(H);await oe.init(),oe.delete("memento/workbench.parts.editor"),await oe.close()}catch(oe){this.u.error(oe)}this.P.fire();try{if(L&&this.S){let oe,G;(0,I.$Ii)(H)?oe={folderUri:H.uri}:(0,I.$Ni)(H)?oe={workspaceUri:H.configPath}:G=!0,(0,ae.$Ob)(await this.tb.open({context:5,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:oe?[oe]:void 0,forceEmpty:G,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(L){this.S?.workspace?.id===L.id&&(this.S.workspace=void 0)}Bb(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const B=this.Gb();B!==this.W&&(this.W=B,this.Hb(B))}if(!L||L.affectsConfiguration("http.proxy")){let B=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;B?.endsWith("/")&&(B=B.substr(0,B.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((B||"").indexOf("@")===-1&&(B!==this.Z||H!==this.$)){this.Z=B,this.$=H;const oe=B||"",G=H?`${H},<local>`:"<local>";this.u.trace(`Setting proxy to '${oe}', bypassing '${G}'`),this.m.webContents.session.setProxy({proxyRules:oe,proxyBypassRules:G,pacScript:""}),typeof n.app.setProxy=="function"&&n.app.setProxy({proxyRules:oe,proxyBypassRules:G,pacScript:""})}}}addTabbedWindow(L){d.$j&&L.win&&this.m.addTabbedWindow(L.win)}load(L,B=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!B.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),B.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(L,B),this.ub===0?this.S=L:this.db=L,this.ub=1,this.m.loadURL(h.$Sg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const H=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new C.$Kh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:L.workspace,reason:B.isReload?3:H?2:1})}Cb(L,B){const H=(this.S??this.db)?.userEnv;if(H){const oe=(0,c.$Cm)(H)&&!(0,c.$Cm)(L.userEnv),G=this.isExtensionDevelopmentHost;(oe||G)&&(L.userEnv={...H,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),B.disableExtensions!==void 0&&(L["disable-extensions"]=B.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.m.isMaximized(),L.partsSplash=this.lb.getWindowSplash(),L.zoomLevel=this.Jb(),L.isCustomZoomLevel=typeof this.ab=="number",L.isCustomZoomLevel&&L.partsSplash&&(L.partsSplash.zoomLevel=L.zoomLevel),(0,l.mark)("code/willOpenNewWindow"),L.perfMarks=(0,l.getMarks)(),this.bb.update(L)}async reload(L){const B=Object.assign({},this.S);B.workspace=await this.Db(B),delete B.filesToOpenOrCreate,delete B.filesToDiff,delete B.filesToMerge,delete B.filesToWait,this.isExtensionDevelopmentHost&&L&&(B.verbose=L.verbose,B.debugId=L.debugId,B.extensionEnvironment=L.extensionEnvironment,B["inspect-extensions"]=L["inspect-extensions"],B["inspect-brk-extensions"]=L["inspect-brk-extensions"],B["extensions-dir"]=L["extensions-dir"]),B.accessibilitySupport=n.app.isAccessibilitySupportEnabled(),B.isInitialStartup=!1,B.policiesData=this.gb.serialize(),B.continueOn=this.t.continueOn,B.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},B.logLevel=this.fb.getLogLevel(),B.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(B,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async Db(L){if((0,I.$Ni)(L.workspace)){const B=L.workspace.configPath;if(B.scheme===h.Schemas.file&&!await this.ib.exists(B))return}else if((0,I.$Ii)(L.workspace)){const B=L.workspace.uri;if(B.scheme===h.Schemas.file&&!await this.ib.exists(B))return}return L.workspace}serializeWindowState(){if(!this.m)return(0,M.$lcc)();if(this.isFullScreen){let H;try{H=n.screen.getDisplayMatching(this.getBounds())}catch{}const oe=(0,M.$lcc)();return{mode:3,display:H?H.id:void 0,width:this.U.width||oe.width,height:this.U.height||oe.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const L=Object.create(null);let B;if(!d.$j&&this.m.isMaximized()?B=0:B=1,B===0?L.mode=0:L.mode=1,B===1||B===0){let H;B===1?H=this.getBounds():H=this.m.getNormalBounds(),L.x=H.x,L.y=H.y,L.width=H.width,L.height=H.height}return L.zoomLevel=this.ab,L}Eb(L){(0,l.mark)("code/willRestoreCodeWindowState");let B=!1;if(L){this.ab=L.zoomLevel;try{const H=n.screen.getAllDisplays();B=H.length>1,L=D.WindowStateValidator.validateWindowState(this.u,L,H)}catch(H){this.u.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}}return(0,l.mark)("code/didRestoreCodeWindowState"),[L||(0,M.$lcc)(),B]}getBounds(){const[L,B]=this.m.getPosition(),[H,oe]=this.m.getSize();return{x:L,y:B,width:H,height:oe}}I(L,B){super.I(L,B),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let L=(0,P.$ID)(this.r);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Hb(L,B=!0){d.$j||(L==="toggle"&&B&&this.send("vscode:showInfoMessage",(0,v.localize)(14,null)),L==="hidden"?setTimeout(()=>{this.Ib(L)}):this.Ib(L))}Ib(L){const B=this.isFullScreen;switch(L){case"classic":this.m.setMenuBarVisibility(!B),this.m.autoHideMenuBar=B;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(L){this.ab=L}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(L,B,...H){this.isReady?this.send(L,...H):this.ready().then(()=>{B.isCancellationRequested||this.send(L,...H)})}send(L,...B){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.m.webContents.send(L,...B)}catch(H){this.u.warn(`Error sending IPC message to channel '${L}' of window ${this.Q}: ${(0,R.$jj)(H)}`)}}}updateTouchBar(L){d.$j&&this.Y.forEach((B,H)=>{const oe=L[H];B.segments=this.Mb(oe)})}Kb(){if(d.$j){for(let L=0;L<10;L++){const B=this.Lb();this.Y.push(B)}this.m.setTouchBar(new n.TouchBar({items:this.Y}))}}Lb(L=[]){const B=this.Mb(L),H=new n.TouchBar.TouchBarSegmentedControl({segments:B,mode:"buttons",segmentStyle:"automatic",change:oe=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:H.segments[oe].id,from:"touchbar"})}});return H}Mb(L=[]){return L.map(H=>{let oe;H.icon&&!u.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===h.Schemas.file&&(oe=n.nativeImage.createFromPath(p.URI.revive(H.icon.dark).fsPath),oe.isEmpty()&&(oe=void 0));let G;return typeof H.title=="string"?G=H.title:G=H.title.value,{id:H.id,label:oe?void 0:G,icon:oe}})}matches(L){return this.m?.webContents.id===L.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$Pcc=V,e.$Pcc=V=Ee([ie(1,a.$5j),ie(2,U.$Mcc),ie(3,b.$ncc),ie(4,W.$ho),ie(5,T.$Bcc),ie(6,m.$5k),ie(7,i.$Zcc),ie(8,i.$Xcc),ie(9,y.$5i),ie(10,g.$wcc),ie(11,O.$Kcc),ie(12,f.$scc),ie(13,o.$4l),ie(14,w.$tcc),ie(15,S.$Rcc),ie(16,t.$lk),ie(17,r.$vcc),ie(18,D.$ycc),ie(19,F.$5P),ie(20,te.$xi)],V)}),define(se[306],re([0,1,14,4,18,24,20,5,34,55,135]),function(K,e,n,C,k,R,j,E,h,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=void 0;let p=class extends d.$Occ{get win(){return super.win||this.tryClaimWindow(),super.win}constructor($,f,y,w,b,c){super(w,b,f,y),this.O=$,this.P=c,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow($){this.q.isDisposed||this.O.isDestroyed()||(this.Q(),$&&!this.N&&(this.N=!0,this.w({x:$.x,y:$.y,width:$.width,height:$.height,mode:$.show===!1?0:1})))}Q(){if(this.m)return;const $=n.BrowserWindow.fromWebContents(this.O);$&&(this.u.trace("[aux window] Claimed browser window instance"),this.n($),$.setMenu(null),(C.$i||C.$k)&&(0,l.$KD)(this.r)&&$.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches($){return this.O.id===$.id}};e.$Qcc=p,e.$Qcc=p=Ee([ie(1,R.$ncc),ie(2,E.$5j),ie(3,k.$5i),ie(4,h.$5P),ie(5,j.$Rcc)],p)}),define(se[307],re([0,1,14,3,2,13,37,306,6,5,82,29]),function(K,e,n,C,k,R,j,E,h,l,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;let v=class extends k.$Uc{constructor(f,y){super(),this.h=f,this.j=y,this.a=this.B(new C.$fe),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new C.$fe),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new C.$fe),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new C.$fe),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(f,y)=>{const w=this.getWindowByWebContents(y.webContents);if(w)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),w.tryClaimWindow();else{const b=new k.$Tc;b.add(C.Event.fromNodeEventEmitter(y.webContents,"did-create-window",(c,m)=>({browserWindow:c,details:m}))(({browserWindow:c,details:m})=>{const S=this.getWindowByWebContents(c.webContents);S&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),S.tryClaimWindow(m.options))})),b.add(C.Event.fromNodeEventEmitter(y,"closed")(()=>b.dispose()))}}),j.$hW.handle("vscode:registerAuxiliaryWindow",async(f,y)=>{const w=this.getWindowByWebContents(f.sender);return w&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),w.parentId=y),f.sender.id})}createWindow(f){return this.h.invokeFunction(p.$zcc,this.n(f),{preload:R.$Sg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(f){const y={},w=f.features.split(",");for(const c of w){const[m,S]=c.split("=");switch(m){case"width":y.width=parseInt(S,10);break;case"height":y.height=parseInt(S,10);break;case"left":y.x=parseInt(S,10);break;case"top":y.y=parseInt(S,10);break;case"window-maximized":y.mode=0;break;case"window-fullscreen":y.mode=3;break}}const b=p.WindowStateValidator.validateWindowState(this.j,y)??(0,d.$mcc)();return this.j.trace("[aux window] using window state",b),b}registerWindow(f){const y=new k.$Tc,w=this.h.createInstance(E.$Qcc,f);this.g.set(w.id,w),y.add((0,k.$Sc)(()=>this.g.delete(w.id))),y.add(w.onDidMaximize(()=>this.a.fire(w))),y.add(w.onDidUnmaximize(()=>this.b.fire(w))),y.add(w.onDidEnterFullScreen(()=>this.c.fire({window:w,fullscreen:!0}))),y.add(w.onDidLeaveFullScreen(()=>this.c.fire({window:w,fullscreen:!1}))),y.add(w.onDidTriggerSystemContextMenu(({x:b,y:c})=>this.f.fire({window:w,x:b,y:c}))),C.Event.once(w.onDidClose)(()=>y.dispose())}getWindowByWebContents(f){const y=this.g.get(f.id);return y?.matches(f)?y:void 0}getFocusedWindow(){const f=n.BrowserWindow.getFocusedWindow();if(f)return this.getWindowByWebContents(f.webContents)}getLastActiveWindow(){return(0,p.$Acc)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$iec=v,e.$iec=v=Ee([ie(0,h.$xi),ie(1,l.$5j)],v)}),define(se[85],re([0,1,14,22,8,3,48,2,13,4,19,7,21,196,6,20,5,84,98,30,58,32,56]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w,b,c,m,S,a,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=e.$wdc=void 0,e.$wdc=(0,f.$yi)("workspacesHistoryMainService");let s=class extends E.$Uc{static{r=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(o,u,g,P,D){super(),this.f=o,this.g=u,this.h=g,this.j=P,this.m=D,this.c=this.B(new R.$fe),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new k.$wh(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(o=>this.addRecentlyOpened([{workspace:o.workspace,remoteAuthority:o.window.remoteAuthority}])))}async addRecentlyOpened(o){let u=[],g=[];for(const D of o)if((0,c.$Xfb)(D))!this.g.isUntitledWorkspace(D.workspace)&&!this.w(u,D.workspace)&&u.push(D);else if((0,c.$Yfb)(D))this.y(u,D.folderUri)||u.push(D);else{const I=this.z(g,D.fileUri),O=D.fileUri.scheme===h.Schemas.file&&r.G.indexOf((0,d.$9g)(D.fileUri))>=0;!I&&!O&&(g.push(D),l.$i&&D.fileUri.scheme===h.Schemas.file&&n.app.addRecentDocument(D.fileUri.fsPath))}const P=await this.r({workspaces:u,files:g});u=P.workspaces,g=P.files,u.length>r.a&&(u.length=r.a),g.length>r.a&&(g.length=r.a),await this.t({workspaces:u,files:g}),this.c.fire(),l.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(o){const u=I=>{const O=this.u(I);for(const M of o)if(d.$3g.isEqual(M,O))return!1;return!0},g=await this.getRecentlyOpened(),P=g.workspaces.filter(u),D=g.files.filter(u);(P.length!==g.workspaces.length||D.length!==g.files.length)&&(await this.t({files:D,workspaces:P}),this.c.fire(),l.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(o){if(o?.confirm){const{response:u}=await this.m.showMessageBox({type:"warning",buttons:[(0,$.localize)(0,null),(0,$.localize)(1,null)],message:(0,$.localize)(2,null),detail:(0,$.localize)(3,null),cancelId:1});if(u!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(o){const u=new a.$Ac(D=>d.$3g.getComparisonKey(D));if(o?.workspaces)for(const D of o.workspaces)u.set(this.u(D),D);const g=new a.$Ac(D=>d.$3g.getComparisonKey(D));if(o?.files)for(const D of o.files)g.set(this.u(D),D);const P=await this.s();for(const D of P.workspaces){const I=u.get(this.u(D));I?I.label=I.label??D.label:u.set(this.u(D),D)}for(const D of P.files){const I=g.get(this.u(D));I?I.label=I.label??D.label:g.set(this.u(D),D)}return{workspaces:[...u.values()],files:[...g.values()]}}async s(){await this.j.whenReady;let o;const u=this.j.get(r.b,-1);if(typeof u=="string")try{o=JSON.parse(u)}catch(g){this.f.error("Unexpected error parsing opened paths list",g)}return(0,c.$5fb)(o,this.f)}async t(o){await this.j.whenReady,this.j.store(r.b,JSON.stringify((0,c.$6fb)(o)),-1,1)}u(o){return(0,c.$Yfb)(o)?o.folderUri:(0,c.$Zfb)(o)?o.fileUri:o.workspace.configPath}w(o,u){return!!o.find(g=>(0,c.$Xfb)(g)&&g.workspace.id===u.id)}y(o,u){return!!o.find(g=>(0,c.$Yfb)(g)&&d.$3g.isEqual(g.folderUri,u))}z(o,u){return!!o.find(g=>d.$3g.isEqual(g.fileUri,u))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async I(){l.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!l.$i)return;const o=[];if(o.push({type:"tasks",items:[{type:"task",title:(0,$.localize)(4,null),description:(0,$.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const u=[];for(const D of n.app.getJumpListSettings().removedItems){const I=D.args;if(I){const O=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(I);O&&u.push(p.URI.parse(O[2]))}}await this.removeRecentlyOpened(u);let g=!1;const P=(0,C.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,r.F).map(D=>{const I=(0,c.$Xfb)(D)?D.workspace:D.folderUri,{title:O,description:M}=this.L(I,D.label);let W;return p.URI.isUri(I)?W=`--folder-uri "${I.toString()}"`:(g=!0,W=`--file-uri "${I.configPath.toString()}"`),{type:"task",title:O.substr(0,255),description:M.substr(0,255),program:process.execPath,args:W,iconPath:"explorer.exe",iconIndex:0}}));P.length>0&&o.push({type:"custom",name:g?(0,$.localize)(6,null):(0,$.localize)(7,null),items:P})}o.push({type:"recent"});try{const u=n.app.setJumpList(o);u&&u!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${u}`)}catch(u){this.f.warn("updateWindowsJumpList#setJumpList",u)}}L(o,u){if(u)return{title:(0,j.$Pw)(u).name,description:u};if(p.URI.isUri(o))return{title:(0,d.$9g)(o),description:this.M(o)};if(this.g.isUntitledWorkspace(o))return{title:(0,$.localize)(8,null),description:""};let g=(0,d.$9g)(o.configPath);return g.endsWith(m.$Ui)&&(g=g.substr(0,g.length-m.$Ui.length-1)),{title:(0,$.localize)(9,null,g),description:this.M(o.configPath)}}M(o){return o.scheme==="file"?(0,j.$Hw)(o.fsPath):o.toString()}async N(){if(!l.$j)return;n.app.clearRecentDocuments();const o=await this.getRecentlyOpened(),u=[];let g=0;for(let D=0;D<o.workspaces.length&&g<r.C;D++){const I=this.u(o.workspaces[D]);if(I.scheme===h.Schemas.file){const O=(0,d.$Zg)(I);await v.Promises.exists(O)&&(u.push(O),g++)}}const P=[];for(let D=0;D<o.files.length&&g<r.D;D++){const I=this.u(o.files[D]);if(I.scheme===h.Schemas.file){const O=(0,d.$Zg)(I);if(r.G.includes((0,d.$9g)(I))||u.includes(O))continue;await v.Promises.exists(O)&&(P.push(O),g++)}}P.reverse().forEach(D=>n.app.addRecentDocument(D)),u.reverse().forEach(D=>n.app.addRecentDocument(D))}};e.$xdc=s,e.$xdc=s=r=Ee([ie(0,w.$5j),ie(1,S.$Kcc),ie(2,y.$Rcc),ie(3,b.$Zcc),ie(4,t.$tcc)],s)}),define(se[308],re([0,1,14,8,23,48,4,7,184,79,18,24,20,5,235,70,27,34,28,50,55,29,85]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w,b,c,m,S,a,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;const s="menu";let i=class{static{r=this}static{this.a="lastKnownMenubarData"}constructor(g,P,D,I,O,M,W,F,T,U,ae,te){this.n=g,this.o=P,this.p=D,this.q=I,this.r=O,this.s=M,this.t=W,this.u=F,this.v=T,this.w=U,this.x=ae,this.y=te,this.m=Object.create(null),this.g=new C.$Kh(()=>this.F(),0),this.h=new C.$Kh(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(j.$j||(0,S.$KD)(P))&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const g=this.t.getItem(r.a);g&&(g.menus&&(this.k=g.menus),g.keybindings&&(this.l=g.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(M,W,F)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:W?.id})},this.m["workbench.action.newWindow"]=(M,W,F)=>this.p.openEmptyWindow({context:2,contextWindowId:W?.id}),this.m["workbench.action.files.openFileFolder"]=(M,W,F)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:s}}),this.m["workbench.action.files.openFolder"]=(M,W,F)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:s}}),this.m["workbench.action.openWorkspace"]=(M,W,F)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:s}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const g=this.x.youTubeUrl;g&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(g,"openYouTubeUrl"));const P=this.x.requestFeatureUrl;P&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(P,"openUserVoiceUrl"));const D=this.x.reportIssueUrl;D&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(D,"openReportIssues"));const I=this.x.licenseUrl;I&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(j.$w){const M=I.indexOf("?")>0?"&":"?";this.ab(`${I}${M}lang=${j.$w}`,"openLicenseUrl")}else this.ab(I,"openLicenseUrl")});const O=this.x.privacyStatementUrl;O&&I&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(O,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(g=>this.G(g)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const g=this.o.getValue("window.enableMenuBarMnemonics");return typeof g!="boolean"?!0:g}get D(){if(!j.$j)return!1;const g=this.o.getValue("window.nativeTabs");return typeof g!="boolean"?!1:g}updateMenu(g,P){this.k=g.menus,this.l=g.keybindings,this.t.setItem(r.a,g),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(g){j.$j&&(g.oldCount===0&&g.newCount>0||g.oldCount>0&&g.newCount===0)&&(this.d=g.newCount===0,this.E())}H(){if(!j.$j)return;const g=n.BrowserWindow.getFocusedWindow();this.f=!g||!!this.y.getWindowByWebContents(g.webContents),this.E()}I(){const g=n.Menu.getApplicationMenu();if(g&&this.j.push(g),Object.keys(this.k).length===0){this.J(j.$j?new n.Menu:null);return}const P=new n.Menu;let D;if(j.$j){const O=new n.Menu;D=new n.MenuItem({label:this.x.nameShort,submenu:O}),this.K(O),P.append(D)}if(j.$j&&!this.c){this.c=!0;const O=new n.Menu;O.append(new n.MenuItem({label:this.cb(h.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),n.app.dock.setMenu(O)}if(this.M("File")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(1,null)),submenu:O});this.O(O,"File"),P.append(M)}if(this.M("Edit")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(2,null)),submenu:O});this.O(O,"Edit"),P.append(M)}if(this.M("Selection")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(3,null)),submenu:O});this.O(O,"Selection"),P.append(M)}if(this.M("View")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(4,null)),submenu:O});this.O(O,"View"),P.append(M)}if(this.M("Go")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(5,null)),submenu:O});this.O(O,"Go"),P.append(M)}if(this.M("Run")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(6,null)),submenu:O});this.O(O,"Run"),P.append(M)}if(this.M("Terminal")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(7,null)),submenu:O});this.O(O,"Terminal"),P.append(M)}let I;if(this.M("Window")){const O=new n.Menu;I=new n.MenuItem({label:this.cb(h.localize(8,null)),submenu:O,role:"window"}),this.U(O)}if(I&&P.append(I),this.M("Help")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(9,null)),submenu:O,role:"help"});this.O(O,"Help"),P.append(M)}P.items&&P.items.length>0?this.J(P):this.J(null),this.h.schedule()}J(g){if(n.Menu.setApplicationMenu(g),g)for(const P of this.y.getWindows())P.win?.setMenu(null)}K(g){const P=this.W(h.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),D=this.V();let I;if(this.M("Preferences")){const te=new n.Menu;this.O(te,"Preferences"),I=new n.MenuItem({label:this.cb(h.localize(11,null)),submenu:te})}const O=new n.Menu,M=new n.MenuItem({label:h.localize(12,null),role:"services",submenu:O}),W=new n.MenuItem({label:h.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),F=new n.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),T=new n.MenuItem({label:h.localize(15,null),role:"unhide"}),U=new n.MenuItem(this.$("workbench.action.quit",{label:h.localize(16,null,this.x.nameLong),click:async(te,ce,J)=>{const V=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||V?.win?.isMinimized())&&await this.L(J)&&this.w.quit(void 0)}})),ae=[P];ae.push(...D),I&&ae.push(o(),I),ae.push(o(),M,o(),W,F,T,o(),U),ae.forEach(te=>g.append(te))}async L(g){if(this.p.getWindowCount()===0)return!0;const P=this.o.getValue("window.confirmBeforeClose");if(P==="always"||P==="keyboardOnly"&&this.S(g)){const{response:D}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return D===0}return!0}M(g){if(!j.$j&&!(0,S.$KD)(this.o))return!1;switch(g){case"File":case"Help":if(j.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[g];case"Window":if(j.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[g]}}N(g,P){P.forEach(D=>{if((0,f.$tdc)(D))g.append(o());else if((0,f.$sdc)(D)){const I=new n.Menu,O=new n.MenuItem({label:this.cb(D.label),submenu:I});this.N(I,D.submenu.items),g.append(O)}else(0,f.$udc)(D)?g.append(this.Q(D)):(0,f.$vdc)(D)&&(D.id==="workbench.action.showAboutDialog"&&this.P(g),j.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[D.id]?g.append(new n.MenuItem(this.$(D.id,{label:this.cb(D.label),click:this.m[D.id]}))):g.append(this.W(D.label,D.id,!1,D.checked)):g.append(this.W(D.label,D.id,D.enabled!==!1,!!D.checked)):g.append(this.W(D.label,D.id,D.enabled!==!1,!!D.checked)))})}O(g,P){this.k&&this.k[P]&&this.N(g,this.k[P].items)}P(g){const P=this.V();P.length&&(P.forEach(D=>g.append(D)),g.append(o()))}Q(g){const P=E.URI.revive(g.uri),D=g.id,I=D==="openRecentFile"?{fileUri:P}:D==="openRecentWorkspace"?{workspaceUri:P}:{folderUri:P};return new n.MenuItem(this.$(D,{label:g.label,click:async(O,M,W)=>{const F=this.R(W);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[I],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:g.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([P])}},!1))}R(g){return!!(g&&(!j.$j&&(g.ctrlKey||g.shiftKey)||j.$j&&(g.metaKey||g.altKey)))}S(g){return!!(g.triggeredByAccelerator||g.altKey||g.ctrlKey||g.metaKey||g.shiftKey)}T(g,P,D){const I={label:this.cb(g),role:D,enabled:!0};return new n.MenuItem(this.Z(P,I))}U(g){const P=new n.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),D=new n.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),I=new n.MenuItem({label:h.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),O=this.W(h.localize(23,null),"workbench.action.switchWindow"),M=[];this.D&&(M.push(o()),M.push(this.W(h.localize(24,null),"workbench.action.newWindowTab")),M.push(this.T(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.T(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.T(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.T(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[P,D,o(),O,...M,o(),I].forEach(W=>g.append(W))}V(){switch(this.n.state.type){case"idle":return[new n.MenuItem({label:this.cb(h.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new n.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new n.MenuItem({label:this.cb(h.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new n.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return j.$j?[]:[new n.MenuItem({label:this.cb(h.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new n.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new n.MenuItem({label:this.cb(h.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(g,P,D,I){const O=this.cb(g),M=typeof P=="function"?P:(ae,te,ce)=>{const J=ae?ae.userSettingsLabel:null;let V=P;Array.isArray(P)&&(V=this.R(ce)?P[1]:P[0]),J&&ce.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:J}):this.Y({type:"commandId",commandId:V})},W=typeof D=="boolean"?D:this.p.getWindowCount()>0,F=typeof I=="boolean"?I:!1,T={label:O,click:M,enabled:W};F&&(T.type="checkbox",T.checked=F);let U;return typeof P=="string"?U=P:Array.isArray(P)&&(U=P[0]),j.$j&&(U==="editor.action.clipboardCutAction"?T.role="cut":U==="editor.action.clipboardCopyAction"?T.role="copy":U==="editor.action.clipboardPasteAction"&&(T.role="paste"),U==="undo"?T.click=this.X(M,{inDevTools:ae=>ae.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):U==="redo"?T.click=this.X(M,{inDevTools:ae=>ae.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):U==="editor.action.selectAll"&&(T.click=this.X(M,{inDevTools:ae=>ae.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.Z(U,T))}X(g,P){return(D,I,O)=>{const M=n.BrowserWindow.getFocusedWindow();if(!M)return P.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return P.inDevTools(M.webContents.devToolsWebContents);g(D,I||M,O)}}Y(g){let P=n.BrowserWindow.getFocusedWindow();if(P){const I=this.y.getWindowByWebContents(P.webContents);I&&(P=this.p.getWindowById(I.parentId)?.win??null)}if(!P){const I=this.p.getLastActiveWindow();I?.win?.isMinimized()&&(P=I.win)}const D=P?this.p.getWindowById(P.id):void 0;if(D){if(this.v.trace("menubar#runActionInRenderer",g),j.$j&&!this.q.isBuilt&&!D.isReady&&(g.type==="commandId"&&g.commandId==="workbench.action.toggleDevTools"||g.type!=="commandId"&&g.userSettingsLabel==="alt+cmd+i"))return!1;if(g.type==="commandId"){const I={id:g.commandId,from:"menu"};D.sendWhenReady("vscode:runAction",k.CancellationToken.None,I)}else{const I={userSettingsLabel:g.userSettingsLabel};D.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,I)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",g),!1}Z(g,P){const D=typeof g=="string"?this.l[g]:void 0;if(D?.label){if(D.isNative!==!1)P.accelerator=D.label,P.userSettingsLabel=D.userSettingsLabel;else if(typeof P.label=="string"){const I=P.label.indexOf("[");I>=0?P.label=`${P.label.substr(0,I)} [${D.label}]`:P.label=`${P.label} [${D.label}]`}}else P.accelerator=void 0;return P}$(g,P,D=!P.accelerator){D&&(P=this.Z(g,P));const I=P.click;return P.click=(O,M,W)=>{this.bb(g),I?.(O,M,W)},P}ab(g,P){this.w.openExternal(void 0,g),this.bb(P)}bb(g){this.r.publicLog2("workbenchActionExecuted",{id:g,from:s})}cb(g){return(0,R.$Mw)(g,!this.C)}};e.$ydc=i,e.$ydc=i=r=Ee([ie(0,m.$gX),ie(1,d.$5i),ie(2,a.$ycc),ie(3,p.$ncc),ie(4,c.$4l),ie(5,t.$wdc),ie(6,b.$5P),ie(7,v.$Rcc),ie(8,$.$5j),ie(9,y.$kdc),ie(10,w.$lk),ie(11,l.$jdc)],i);function o(){return new n.MenuItem({type:"separator"})}}),define(se[309],re([0,1,6,20,5,308]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=e.$zdc=void 0,e.$zdc=(0,n.$yi)("menubarMainService");let j=class{constructor(h,l,d){this.b=h,this.c=l,this.d=d,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(R.$ydc)}async updateMenubar(h,l){this.d.trace("menubarService#updateMenubar",h),(await this.a).updateMenu(l,h)}};e.$Adc=j,e.$Adc=j=Ee([ie(0,n.$xi),ie(1,C.$Rcc),ie(2,k.$5j)],j)}),define(se[310],re([0,1,14,21,102,26,22,23,3,31,48,2,13,9,66,4,36,19,12,7,194,65,18,56,24,16,6,20,5,80,81,68,34,55,135,29,133,302,30,99,85,58,69,39,57,67,79]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w,b,c,m,S,a,t,r,s,i,o,u,g,P,D,I,O,M,W,F,T,U,ae,te,ce,J,V,q,L,B,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;function oe(Q){return(0,ae.$Ni)(Q?.workspace)}function G(Q){return(0,ae.$Ii)(Q?.workspace)}let le=class extends p.$Uc{constructor(A,N,_,z,Y,x,ee,X,ue,he,pe,$e,ye,Se,ke,Re,we,Z,fe,ge){super(),this.s=A,this.t=N,this.u=_,this.w=z,this.z=Y,this.C=x,this.D=ee,this.F=X,this.G=ue,this.H=he,this.I=pe,this.J=$e,this.L=ye,this.M=Se,this.N=ke,this.O=Re,this.P=we,this.Q=Z,this.R=fe,this.S=ge,this.a=this.B(new h.$fe),this.onDidOpenWindow=this.a.event,this.b=this.B(new h.$fe),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new h.$fe),this.onDidDestroyWindow=this.c.event,this.f=this.B(new h.$fe),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new h.$fe),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new h.$fe),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new h.$fe),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new h.$fe),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new U.$Xdc(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(A=>this.b.fire(A.window))),this.B(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const N=new p.$Tc;if(N.add(h.Event.any(A.onDidClose,A.onDidDestroy)(()=>N.dispose())),A.config.extensionDevelopmentPath)for(const _ of A.config.extensionDevelopmentPath)N.add(this.Q.addValidFileRoot(_));A.config.extensionTestsPath&&N.add(this.Q.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,N){const _=this.F.args,z=N?.remoteAuthority||void 0,Y=!0,x=N?.forceReuseWindow,ee=!x;return this.open({...A,cli:_,forceEmpty:Y,forceNewWindow:ee,forceReuseWindow:x,remoteAuthority:z})}openExistingWindow(A,N){A.focus(),this.W(N,[A])}async open(A){this.w.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const N=[],_=[],z=[],Y=[],x=[];let ee,X=0;const ue=await this.cb(A);this.w.trace("windowsManager#open pathsToOpen",ue);for(const Se of ue)G(Se)?A.addMode?N.push(Se):_.push(Se):oe(Se)?z.push(Se):Se.fileUri?(ee||(ee={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Se.remoteAuthority}),ee.filesToOpenOrCreate.push(Se)):Se.backupPath?x.push({backupFolder:(0,$.$nc)(Se.backupPath),remoteAuthority:Se.remoteAuthority}):X++;A.diffMode&&ee&&ee.filesToOpenOrCreate.length>=2&&(ee.filesToDiff=ee.filesToOpenOrCreate.slice(0,2),ee.filesToOpenOrCreate=[]),A.mergeMode&&ee&&ee.filesToOpenOrCreate.length===4&&(ee.filesToMerge=ee.filesToOpenOrCreate.slice(0,4),ee.filesToOpenOrCreate=[],ee.filesToDiff=[]),ee&&A.waitMarkerFileURI&&(ee.filesToWait={paths:(0,j.$Hb)([...ee.filesToDiff,ee.filesToMerge[3],...ee.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(Y.push(...this.M.getUntitledWorkspaces()),z.push(...Y),x.push(...this.I.getEmptyWindowBackups())):x.length=0;const{windows:he,filesOpenedInWindow:pe}=await this.X(A,z,_,x,X,ee,N);if(this.w.trace(`windowsManager#open used window count ${he.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${_.length}, emptyToRestore: ${x.length}, emptyToOpen: ${X})`),he.length>1)if(pe)pe.focus();else{const Se=this.r.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let ke=!0,Re=!0;if(Se){const we=he.filter(Z=>this.r.state.lastActiveWindow&&Z.backupPath===this.r.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),ke=!1,Re=!1)}if(ke)for(let we=he.length-1;we>=0;we--){const Z=he[we];if(!(Z.openedWorkspace&&Y.some(fe=>Z.openedWorkspace&&fe.workspace.id===Z.openedWorkspace.id)||Z.backupPath&&x.some(fe=>Z.backupPath&&fe.backupFolder===(0,$.$nc)(Z.backupPath)))){Z.focus(),Re=!1;break}}Re&&he[he.length-1].focus()}const $e=ee&&ee.filesToDiff.length>0,ye=ee&&ee.filesToMerge.length>0;if(!he.some(Se=>Se.isExtensionDevelopmentHost)&&!$e&&!ye&&!A.noRecentEntry){const Se=[];for(const ke of ue)oe(ke)&&!ke.transient?Se.push({label:ke.label,workspace:ke.workspace,remoteAuthority:ke.remoteAuthority}):G(ke)?Se.push({label:ke.label,folderUri:ke.workspace.uri,remoteAuthority:ke.remoteAuthority}):ke.fileUri&&Se.push({label:ke.label,fileUri:ke.fileUri,remoteAuthority:ke.remoteAuthority});this.L.addRecentlyOpened(Se)}return this.W(A,he),he}W(A,N){const _=A.waitMarkerFileURI;A.context===0&&_&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.P.del(_)}catch{}})()}async X(A,N,_,z,Y,x,ee){const X=[];let ue;function he(we,Z){X.push(we),Z&&(ue=we,x=void 0)}let{openFolderInNewWindow:pe,openFilesInNewWindow:$e}=this.ob(A);if(!A.initialStartup&&ee.length>0){const we=ee[0].remoteAuthority,Z=this.ub(we);Z&&he(this.$(Z,ee.map(fe=>fe.workspace.uri)))}const ye=_.length+N.length+z.length;if(x&&ye===0){const we=x.filesToOpenOrCreate[0]||x.filesToDiff[0]||x.filesToMerge[3],Z=this.getWindows().filter(ge=>x&&(0,b.$eh)(ge.remoteAuthority,x.remoteAuthority));let fe;we?.fileUri&&!$e&&((A.context===4||A.context===0||A.context===1)&&(fe=await(0,T.$Dcc)(Z,we.fileUri,async ge=>ge.configPath.scheme===v.Schemas.file?this.M.resolveLocalWorkspace(ge.configPath):void 0)),fe||(fe=this.vb(Z))),fe?(0,ae.$Ni)(fe.openedWorkspace)?N.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):(0,ae.$Ii)(fe.openedWorkspace)?_.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):he(this.Y(A,fe,x),!0):he(await this.pb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:x,forceNewWindow:!0,remoteAuthority:x.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile}),!0)}const Se=(0,j.$Mb)(N,we=>we.workspace.id);if(Se.length>0){const we=(0,j.$Hb)(Se.map(Z=>(0,T.$Ecc)(this.getWindows(),Z.workspace.configPath)));if(we.length>0){const Z=we[0],fe=(0,b.$eh)(x?.remoteAuthority,Z.remoteAuthority)?x:void 0;he(this.Y(A,Z,fe),!!fe),pe=!0}for(const Z of Se){if(we.some(Pe=>Pe.openedWorkspace&&Pe.openedWorkspace.id===Z.workspace.id))continue;const fe=Z.remoteAuthority,ge=(0,b.$eh)(x?.remoteAuthority,fe)?x:void 0;he(await this.bb(A,Z,pe,ge),!!ge),pe=!0}}const ke=(0,j.$Mb)(_,we=>b.$3g.getComparisonKey(we.workspace.uri));if(ke.length>0){const we=(0,j.$Hb)(ke.map(Z=>(0,T.$Ecc)(this.getWindows(),Z.workspace.uri)));if(we.length>0){const Z=we[0],fe=(0,b.$eh)(x?.remoteAuthority,Z.remoteAuthority)?x:void 0;he(this.Y(A,Z,fe),!!fe),pe=!0}for(const Z of ke){if(we.some(Pe=>(0,ae.$Ii)(Pe.openedWorkspace)&&b.$3g.isEqual(Pe.openedWorkspace.uri,Z.workspace.uri)))continue;const fe=Z.remoteAuthority,ge=(0,b.$eh)(x?.remoteAuthority,fe)?x:void 0;he(await this.bb(A,Z,pe,ge),!!ge),pe=!0}}const Re=(0,j.$Mb)(z,we=>we.backupFolder);if(Re.length>0)for(const we of Re){const Z=we.remoteAuthority,fe=(0,b.$eh)(x?.remoteAuthority,Z)?x:void 0;he(await this.ab(A,!0,Z,fe,we),!!fe),pe=!0}if(X.length===0||x){x&&!Y&&Y++;const we=x?x.remoteAuthority:A.remoteAuthority;for(let Z=0;Z<Y;Z++)he(await this.ab(A,pe,we,x),!!x),pe=!0}return{windows:(0,j.$Mb)(X),filesOpenedInWindow:ue}}Y(A,N,_){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),this.Z(N);const z={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",E.CancellationToken.None,z),N}Z(A){let N=A;const _=n.BrowserWindow.getFocusedWindow();if(_&&_.id!==A.id){const z=this.S.getWindowByWebContents(_.webContents);z&&z.parentId===A.id&&(N=z)}N.focus()}$(A,N){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),A.focus();const _={foldersToAdd:N};return A.sendWhenReady("vscode:addFolders",E.CancellationToken.None,_),A}ab(A,N,_,z,Y){this.w.trace("windowsManager#doOpenEmpty",{restore:!!Y,remoteAuthority:_,filesToOpen:z,forceNewWindow:N});let x;return!N&&typeof A.contextWindowId=="number"&&(x=this.getWindowById(A.contextWindowId)),this.pb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:_,forceNewWindow:N,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:z,windowToUse:x,emptyWindowBackupInfo:Y,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}bb(A,N,_,z,Y){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:z}),!_&&!Y&&typeof A.contextWindowId=="number"&&(Y=this.getWindowById(A.contextWindowId)),this.pb({workspace:N.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:z,windowToUse:Y,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}async cb(A){let N,_=!1,z=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(N=await this.db(A),_=!0):A.forceEmpty?N=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(N=await this.eb(A.cli),N.length===0&&N.push(Object.create(null)),_=!0):(N=await this.gb(),N.length===0&&N.push(Object.create(null)),z=!0),!A.addMode&&_){const Y=N.filter(x=>G(x));if(Y.length>1){const x=Y[0].remoteAuthority;if(Y.every(ee=>(0,b.$eh)(ee.remoteAuthority,x))){const ee=await this.M.createUntitledWorkspace(Y.map(X=>({uri:X.workspace.uri})));N.push({workspace:ee,remoteAuthority:x}),N=N.filter(X=>!G(X))}}}if(A.initialStartup&&!z&&this.J.getValue("window")?.restoreWindows==="preserve"){const Y=await this.gb();N.unshift(...Y.filter(x=>oe(x)||G(x)||x.backupPath))}return N}async db(A){const N={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority},_=await Promise.all((0,j.$Hb)(A.urisToOpen||[]).map(async z=>{const Y=await this.ib(z,N);if(Y)return Y.label=z.label,Y;const x=this.kb(z);this.O.showMessageBox({type:"info",buttons:[(0,S.localize)(0,null)],message:x.scheme===v.Schemas.file?(0,S.localize)(1,null):(0,S.localize)(2,null),detail:x.scheme===v.Schemas.file?(0,S.localize)(3,null,(0,d.$Gw)(x,{os:y.OS,tildify:this.F})):(0,S.localize)(4,null,x.toString(!0))},n.BrowserWindow.getFocusedWindow()??void 0)}));return(0,j.$Hb)(_)}async eb(A){const N=[],_={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},z=A["folder-uri"];if(z){const ee=await Promise.all(z.map(X=>{const ue=this.fb(X);if(ue)return this.ib({folderUri:ue},_)}));N.push(...(0,j.$Hb)(ee))}const Y=A["file-uri"];if(Y){const ee=await Promise.all(Y.map(X=>{const ue=this.fb(X);if(ue)return this.ib((0,ae.$4i)(X)?{workspaceUri:ue}:{fileUri:ue},_)}));N.push(...(0,j.$Hb)(ee))}const x=await Promise.all(A._.map(ee=>_.remoteAuthority?this.nb(ee,_):this.lb(ee,_)));return N.push(...(0,j.$Hb)(x)),N}fb(A){try{const N=m.URI.parse(A);if(!N.scheme){this.w.error(`Invalid URI input string, scheme missing: ${A}`);return}return N.path?N:N.with({path:"/"})}catch(N){this.w.error(`Invalid URI input string: ${A}, ${N.message}`)}}async gb(){const A=this.hb();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];A!=="one"&&N.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&N.push(this.r.state.lastActiveWindow);const _=await Promise.all(N.map(async z=>{if(z.workspace){const Y=await this.ib({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});if(oe(Y))return Y}else if(z.folderUri){const Y=await this.ib({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});if(G(Y))return Y}else if(A!=="folders"&&z.backupPath)return{backupPath:z.backupPath,remoteAuthority:z.remoteAuthority}}));return(0,j.$Hb)(_)}}}hb(){let A;return this.H.wasRestarted?A="all":(A=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}async ib(A,N=Object.create(null)){const _=this.kb(A);return _.scheme===v.Schemas.file?((0,M.$HD)(A)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.lb(_.fsPath,N)):this.jb(A,N)}jb(A,N){let _=this.kb(A);const z=(0,I.$Jm)(_)||N.remoteAuthority;if(_=(0,b.$gh)((0,b.$ah)(_)),(0,M.$HD)(A)){if(N.gotoLineMode){const{path:Y,line:x,column:ee}=(0,l.$Fg)(_.path);return{fileUri:_.with({path:Y}),options:{selection:x?{startLineNumber:x,startColumn:ee||1}:void 0},remoteAuthority:z}}return{fileUri:_,remoteAuthority:z}}else if((0,M.$FD)(A))return{workspace:(0,te.$Hcc)(_),remoteAuthority:z};return{workspace:(0,te.$Icc)(_),remoteAuthority:z}}kb(A){return(0,M.$FD)(A)?A.workspaceUri:(0,M.$GD)(A)?A.folderUri:A.fileUri}async lb(A,N,_){let z,Y;N.gotoLineMode&&({path:A,line:z,column:Y}=(0,l.$Fg)(A)),A=(0,l.$zg)((0,$.$hc)(A),(0,w.cwd)());try{const x=await C.Promises.stat(A);if(x.isFile()){if(!N.forceOpenWorkspaceAsFile){const ee=await this.M.resolveLocalWorkspace(m.URI.file(A));if(ee)return ee.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:ee.id,configPath:ee.configPath},type:i.FileType.File,exists:!0,remoteAuthority:ee.remoteAuthority,transient:ee.transient}}return{fileUri:m.URI.file(A),type:i.FileType.File,exists:!0,options:{selection:z?{startLineNumber:z,startColumn:Y||1}:void 0}}}else{if(x.isDirectory())return{workspace:(0,te.$Icc)(m.URI.file(A),x),type:i.FileType.Directory,exists:!0};if(!y.$i&&A==="/dev/null")return{fileUri:m.URI.file(A),type:i.FileType.File,exists:!0}}}catch(x){if(x.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!_)return this.mb(A,N);const ee=m.URI.file(A);if(this.L.removeRecentlyOpened([ee]),N.ignoreFileNotFound)return{fileUri:ee,type:i.FileType.File,exists:!1}}}async mb(A,N){const _=m.URI.file(A),{response:z,checkboxChecked:Y}=await this.O.showMessageBox({type:"warning",buttons:[(0,S.localize)(5,null),(0,S.localize)(6,null),(0,S.localize)(7,null)],message:(0,S.localize)(8,null,_.authority),detail:(0,S.localize)(9,null,(0,d.$Gw)(_,{os:y.OS,tildify:this.F})),checkboxLabel:(0,S.localize)(10,null,_.authority),cancelId:1});if(z===0){if((0,k.addUNCHostToAllowlist)(_.authority),Y){const x={channel:"vscode:configureAllowedUNCHost",args:_.authority};this.sendToFocused(x.channel,x.args),this.sendToOpeningWindow(x.channel,x.args)}return this.lb(A,N,!0)}if(z===2)return n.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(A,N)}nb(A,N){const _=A.charCodeAt(0),z=N.remoteAuthority;let Y,x;N.gotoLineMode&&({path:A,line:Y,column:x}=(0,l.$Fg)(A)),_!==47&&((0,l.$yg)(_)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,l.$rg)(A)),A=`/${A}`);const ee=m.URI.from({scheme:v.Schemas.vscodeRemote,authority:z,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,ae.$4i)(A))return N.forceOpenWorkspaceAsFile?{fileUri:ee,options:{selection:Y?{startLineNumber:Y,startColumn:x||1}:void 0},remoteAuthority:N.remoteAuthority}:{workspace:(0,te.$Hcc)(ee),remoteAuthority:z};if(N.gotoLineMode||$.$gc.basename(A).indexOf(".")!==-1)return{fileUri:ee,options:{selection:Y?{startLineNumber:Y,startColumn:x||1}:void 0},remoteAuthority:z}}return{workspace:(0,te.$Icc)(ee),remoteAuthority:z}}ob(A){const N=this.J.getValue("window"),_=N?.openFoldersInNewWindow||"default",z=N?.openFilesInNewWindow||"off";let Y=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(_==="on"||_==="off")&&(Y=_==="on");let x=!1;return A.forceNewWindow||A.forceReuseWindow?x=!!A.forceNewWindow&&!A.forceReuseWindow:(y.$j?A.context===1&&(x=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(x=!0),!A.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(x=z==="on")),{openFolderInNewWindow:!!Y,openFilesInNewWindow:x}}async openExtensionDevelopmentHostWindow(A,N){const _=(0,T.$Fcc)(this.getWindows(),A);if(_)return this.H.reload(_,N.cli),_.focus(),[_];let z=N.cli["folder-uri"]||[],Y=N.cli["file-uri"]||[],x=N.cli._;if(!x.length&&!z.length&&!Y.length&&!N.cli.extensionTestsPath){const ue=this.r.state.lastPluginDevelopmentHostWindow,he=ue?.workspace??ue?.folderUri;he&&(m.URI.isUri(he)?he.scheme===v.Schemas.file?x=[he.fsPath]:z=[he.toString()]:he.configPath.scheme===v.Schemas.file?x=[(0,b.$Zg)(he.configPath)]:Y=[he.configPath.toString()])}let ee=N.remoteAuthority;for(const ue of A)if(ue.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const he=m.URI.parse(ue),pe=(0,I.$Jm)(he);pe&&(ee?(0,b.$eh)(pe,ee)||this.w.error("more than one extension development path authority"):ee=pe)}x=x.filter(ue=>{const he=m.URI.file(ue);return(0,T.$Ecc)(this.getWindows(),he)?!1:(0,b.$eh)((0,I.$Jm)(he),ee)}),z=z.filter(ue=>{const he=this.fb(ue);return he&&(0,T.$Ecc)(this.getWindows(),he)?!1:he?(0,b.$eh)((0,I.$Jm)(he),ee):!1}),Y=Y.filter(ue=>{const he=this.fb(ue);return he&&(0,T.$Ecc)(this.getWindows(),he)?!1:he?(0,b.$eh)((0,I.$Jm)(he),ee):!1}),N.cli._=x,N.cli["folder-uri"]=z,N.cli["file-uri"]=Y;const X={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:!x.length&&!z.length&&!Y.length,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:ee,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile};return this.open(X)}async pb(A){const N=this.J.getValue("window"),_=this.getLastActiveWindow(),z=_?.profile??this.G.defaultProfile;let Y;!A.forceNewWindow&&!A.forceNewTabbedWindow&&(Y=A.windowToUse||_,Y&&Y.focus());const x={...this.F.args,...A.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,$.$jc)(this.F.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:z},homeDir:this.F.userHome.with({scheme:v.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:v.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.u,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:v.Schemas.file}).fsPath,product:P.default,isInitialStartup:A.initialStartup,perfMarks:(0,f.getMarks)(),os:{release:(0,R.release)(),hostname:(0,R.hostname)(),arch:(0,R.arch)()},autoDetectHighContrast:N?.autoDetectHighContrast??!0,autoDetectColorScheme:N?.autoDetectColorScheme??!1,accessibilitySupport:n.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(Y){const ee=Y.config;!x.extensionDevelopmentPath&&ee?.extensionDevelopmentPath&&(x.extensionDevelopmentPath=ee.extensionDevelopmentPath,x.extensionDevelopmentKind=ee.extensionDevelopmentKind,x["enable-proposed-api"]=ee["enable-proposed-api"],x.verbose=ee.verbose,x["inspect-extensions"]=ee["inspect-extensions"],x["inspect-brk-extensions"]=ee["inspect-brk-extensions"],x.debugId=ee.debugId,x.extensionEnvironment=ee.extensionEnvironment,x["extensions-dir"]=ee["extensions-dir"],x["disable-extensions"]=ee["disable-extensions"]),x.loggers={global:x.loggers.global,window:ee?.loggers.window??x.loggers.window}}else{const ee=this.r.getNewWindowState(x);(0,f.mark)("code/willCreateCodeWindow");const X=Y=this.N.createInstance(W.$Pcc,{state:ee,extensionDevelopmentPath:x.extensionDevelopmentPath,isExtensionTestHost:!!x.extensionTestsPath});(0,f.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(X),this.n.set(X.id,X),this.a.fire(X),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const ue=new p.$Tc;ue.add(X.onDidSignalReady(()=>this.b.fire(X))),ue.add(h.Event.once(X.onDidClose)(()=>this.sb(X,ue))),ue.add(h.Event.once(X.onDidDestroy)(()=>this.tb(X))),ue.add(X.onDidMaximize(()=>this.g.fire(X))),ue.add(X.onDidUnmaximize(()=>this.h.fire(X))),ue.add(X.onDidEnterFullScreen(()=>this.j.fire({window:X,fullscreen:!0}))),ue.add(X.onDidLeaveFullScreen(()=>this.j.fire({window:X,fullscreen:!1}))),ue.add(X.onDidTriggerSystemContextMenu(({x:pe,y:$e})=>this.m.fire({window:X,x:pe,y:$e})));const he=(0,c.$jg)(X.win?.webContents);he.removeAllListeners("devtools-reload-page"),ue.add(h.Event.fromNodeEventEmitter(he,"devtools-reload-page")(()=>this.H.reload(X))),this.H.registerWindow(X)}return x.windowId=Y.id,Y.isReady?this.H.unload(Y,4).then(async ee=>{ee||await this.qb(Y,x,A,z)}):await this.qb(Y,x,A,z),Y}async qb(A,N,_,z){if(N.extensionDevelopmentPath||((0,ae.$Ni)(N.workspace)?N.backupPath=this.I.registerWorkspaceBackup({workspace:N.workspace,remoteAuthority:N.remoteAuthority}):(0,ae.$Ii)(N.workspace)?N.backupPath=this.I.registerFolderBackup({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority}):N.backupPath=this.I.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,te.$Jcc)().id,remoteAuthority:N.remoteAuthority})),this.G.isEnabled()){const Y=N.workspace??(0,ae.$Mi)(N.backupPath,!1),x=this.rb(_,Y,z),ee=x instanceof Promise?await x:x;N.profiles.profile=ee,N.extensionDevelopmentPath||await this.G.setProfileForWorkspace(Y,ee)}A.load(N)}rb(A,N,_){return A.forceProfile?this.G.profiles.find(z=>z.name===A.forceProfile)??this.G.createNamedProfile(A.forceProfile):A.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(N)??_}sb(A,N){this.n.delete(A.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),N.dispose()}tb(A){this.n.delete(A.id),this.c.fire(A)}getFocusedWindow(){const A=n.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(A){return this.vb(this.getWindows().filter(N=>(0,b.$eh)(N.remoteAuthority,A)))}vb(A){return(0,F.$Acc)(A)}sendToFocused(A,...N){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,E.CancellationToken.None,...N)}sendToOpeningWindow(A,...N){this.B(h.Event.once(this.onDidSignalReadyWindow)(_=>{_.sendWhenReady(A,E.CancellationToken.None,...N)}))}sendToAll(A,N,_){for(const z of this.getWindows())_&&_.indexOf(z.id)>=0||z.sendWhenReady(A,E.CancellationToken.None,N)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(A){return this.n.get(A)}getWindowByWebContents(A){const N=n.BrowserWindow.fromWebContents(A);if(!N)return;const _=this.getWindowById(N.id);return _?.matches(A)?_:void 0}};e.$1dc=le,e.$1dc=le=Ee([ie(3,g.$5j),ie(4,B.$Mcc),ie(5,O.$5P),ie(6,q.$ho),ie(7,s.$ncc),ie(8,L.$Bcc),ie(9,u.$Rcc),ie(10,a.$scc),ie(11,t.$5i),ie(12,ce.$wdc),ie(13,J.$Kcc),ie(14,o.$xi),ie(15,r.$tcc),ie(16,i.$5k),ie(17,D.$vcc),ie(18,V.$wcc),ie(19,H.$jdc)],le)}),define(se[311],re([0,1,65,29,85,58]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;let j=class{constructor(h,l,d,p){this.a=h,this.b=l,this.c=d,this.d=p,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(h,l){const d=this.b.getWindowById(h);if(d)return this.a.enterWorkspace(d,this.b.getWindows(),l)}createUntitledWorkspace(h,l,d){return this.a.createUntitledWorkspace(l,d)}deleteUntitledWorkspace(h,l){return this.a.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(h,l){return this.a.getWorkspaceIdentifier(l)}getRecentlyOpened(h){return this.c.getRecentlyOpened()}addRecentlyOpened(h,l){return this.c.addRecentlyOpened(l)}removeRecentlyOpened(h,l){return this.c.removeRecentlyOpened(l)}clearRecentlyOpened(h){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$3dc=j,e.$3dc=j=Ee([ie(0,R.$Kcc),ie(1,C.$ycc),ie(2,k.$wdc),ie(3,n.$scc)],j)}),define(se[312],re([0,1,14,102,37,26,17,47,15,31,3,42,48,2,13,9,4,12,7,33,160,44,161,114,294,164,65,287,18,203,92,134,56,120,224,24,64,95,212,297,214,215,216,16,228,94,78,6,93,223,303,288,295,20,5,309,70,27,68,298,96,34,279,84,126,28,255,257,54,50,269,292,304,293,305,131,271,272,273,276,301,55,29,310,278,30,98,85,311,58,39,237,57,248,53,83,132,281,296,284,8,259,280,232,67,300,275,22,129,299,267,243,62,79,307,72]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w,b,c,m,S,a,t,r,s,i,o,u,g,P,D,I,O,M,W,F,T,U,ae,te,ce,J,V,q,L,B,H,oe,G,le,Q,A,N,_,z,Y,x,ee,X,ue,he,pe,$e,ye,Se,ke,Re,we,Z,fe,ge,Pe,Oe,Te,Me,Fe,qe,xe,Ke,Be,He,Xe,ne,de,me,ve,Ie,Le,Qe,Ze,_e,st,Ye,ot,rt,ct,lt,Et,kt,Pt,ut,mt,jt,It,Dt,ht,Ct,wt,ft,At,Rt,dt,Ot,pt,Mt,bt){"use strict";var gt;Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;let $t=class extends $.$Uc{static{gt=this}static{this.a={[f.Schemas.file]:"security.promptForLocalFileProtocolHandling",[f.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(je,De,Ae,be,Ce,ze,Ue,Ge,We,Ne,Ve,Je){super(),this.g=je,this.h=De,this.j=Ae,this.m=be,this.n=Ce,this.s=ze,this.t=Ue,this.u=Ge,this.w=We,this.y=Ne,this.z=Ve,this.C=Je,this.D(),this.F()}D(){const je=We=>We?.startsWith(`${f.Schemas.vscodeWebview}://`),De=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((We,Ne,Ve,Je)=>je(Je.requestingUrl)?Ve(De.has(Ne)):Ve(!1)),n.session.defaultSession.setPermissionCheckHandler((We,Ne,Ve,Je)=>je(Je.requestingUrl)?De.has(Ne):!1);const Ae=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,f.Schemas.vscodeManagedRemoteResource,"devtools"]),be=We=>{for(let Ne=We;Ne;Ne=Ne.parent)if(Ne.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},Ce=We=>We.resourceType==="xhr"||be(We.frame),ze=We=>{const Ne=We.frame;if(!Ne||!this.b)return!1;const Ve=n.BrowserWindow.getAllWindows();for(const Je of Ve)if(Ne.processId===Je.webContents.mainFrame.processId)return!0;return!1},Ue=(We,Ne)=>{if(We.path!=="/index.html")return!0;const Ve=Ne.frame;if(!Ve||!this.b)return!1;for(const Je of this.b.getWindows())if(Je.win&&Ve.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((We,Ne)=>{const Ve=c.URI.parse(We.url);return Ve.scheme===f.Schemas.vscodeWebview&&!Ue(Ve,We)?(this.m.error("Blocked vscode-webview request",We.url),Ne({cancel:!0})):Ve.scheme===f.Schemas.vscodeFileResource&&!ze(We)?(this.m.error("Blocked vscode-file request",We.url),Ne({cancel:!0})):Ve.path.endsWith(".svg")&&!Ae.has(Ve.scheme)?Ne({cancel:!Ce(We)}):Ne({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((We,Ne)=>{const Ve=We.responseHeaders,Je=Ve["content-type"]||Ve["Content-Type"];if(Je&&Array.isArray(Je)){const et=c.URI.parse(We.url);if(et.path.endsWith(".svg")&&Ae.has(et.scheme))return Ve["Content-Type"]=["image/svg+xml"],Ne({cancel:!1,responseHeaders:Ve});if(!et.path.endsWith(f.Schemas.vscodeRemoteResource)&&Je.some(nt=>nt.toLowerCase().includes("image/svg")))return Ne({cancel:!Ce(We)})}return Ne({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((We,Ne)=>{if(We.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Ve=We.responseHeaders??Object.create(null);if(Ve["Access-Control-Allow-Origin"]===void 0)return Ve["Access-Control-Allow-Origin"]=["*"],Ne({cancel:!1,responseHeaders:Ve})}return Ne({cancel:!1})});const Ge=n.session.defaultSession;typeof Ge.setCodeCachePath=="function"&&this.s.codeCachePath&&Ge.setCodeCachePath((0,y.$jc)(this.s.codeCachePath,"chrome")),w.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,C.disableUNCAccessRestrictions)():(0,C.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,h.setUnexpectedErrorHandler)(Ae=>this.H(Ae)),process.on("uncaughtException",Ae=>{(0,h.$Z)(Ae)||(0,h.$1)(Ae)}),process.on("unhandledRejection",Ae=>(0,h.$1)(Ae)),this.t.onWillShutdown(()=>this.dispose()),(0,S.$iW)(),n.app.on("accessibility-support-changed",(Ae,be)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",be)}),n.app.on("activate",async(Ae,be)=>{this.m.trace("app#activate"),be||await this.b?.openEmptyWindow({context:1})}),n.app.on("web-contents-created",(Ae,be)=>{be?.opener?.url.startsWith(`${f.Schemas.vscodeFileResource}://${f.$Rg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(be)),be.on("will-navigate",Ce=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ce.preventDefault()}),be.setWindowOpenHandler(Ce=>Ce.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Ce)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ce.url}}`),this.f?.openExternal(void 0,Ce.url),{action:"deny"}))});let je=[],De;n.app.on("open-file",(Ae,be)=>{be=(0,bt.$dm)(be),this.m.trace("app#open-file: ",be),Ae.preventDefault(),je.push((0,ve.$4i)(be)?{workspaceUri:c.URI.file(be)}:{fileUri:c.URI.file(be)}),De!==void 0&&(clearTimeout(De),De=void 0),De=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:je,gotoLineMode:!1,preferNewWindow:!0}),je=[],De=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),k.$hW.handle("vscode:fetchShellEnv",Ae=>{const be=this.b?.getWindowByWebContents(Ae.sender);let Ce,ze;return be?.config?(Ce=be.config,ze={...process.env,...be.config.userEnv}):(Ce=this.s.args,ze=process.env),this.X(Ce,ze,!1)}),k.$hW.handle("vscode:writeNlsFile",(Ae,be,Ce)=>{const ze=this.G([be]);if(!ze||typeof Ce!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(ze,j.$He.fromString(Ce))}),k.$hW.handle("vscode:readNlsFile",async(Ae,...be)=>{const Ce=this.G(be);if(!Ce)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ce)).value.toString()}),k.$hW.on("vscode:toggleDevTools",Ae=>Ae.sender.toggleDevTools()),k.$hW.on("vscode:openDevTools",Ae=>Ae.sender.openDevTools()),k.$hW.on("vscode:reloadWindow",Ae=>Ae.sender.reload()),k.$hW.handle("vscode:notifyZoomLevel",async(Ae,be)=>{const Ce=this.b?.getWindowByWebContents(Ae.sender);Ce&&Ce.notifyZoomLevel(be)})}G(je){let De;for(const Ae of je)typeof Ae=="string"&&(typeof De!="string"?De=Ae:De=(0,y.$jc)(De,Ae));if(!(typeof De!="string"||!(0,y.$ic)(De)||!(0,l.$xg)(De,this.s.cachedLanguagesPath,!w.$k)))return c.URI.file(De)}H(je){if(je){const De={message:`[uncaught exception in main]: ${je.message}`,stack:je.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(De))}this.m.error(`[uncaught exception in main]: ${je}`),je.stack&&this.m.error(je.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const je=this.z.win32AppUserModelId;w.$i&&je&&n.app.setAppUserModelId(je);try{w.$j&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.m.error(Ne)}const De=new t.$oW;this.t.onWillShutdown(Ne=>{Ne.reason===2&&De.dispose()}),this.m.trace("Resolving machine identifier...");const[Ae,be]=await Promise.all([(0,mt.$$dc)(this.w,this.m),(0,mt.$_dc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Ae}`);const{sharedProcessReady:Ce,sharedProcessClient:ze}=this.P(Ae,be),Ue=await this.Q(Ae,be,Ce);this.B(Ue.createInstance(s.$2cc)),this.B(Ue.createInstance(kt.$7dc)),Ue.invokeFunction(Ne=>this.R(Ne,De,ze));const Ge=await Ue.invokeFunction(Ne=>this.I(Ne,De));this.J(De),this.t.phase=2,await Ue.invokeFunction(Ne=>this.S(Ne,Ge)),this.t.phase=3,this.U(),this.B(new ut.$Kh(()=>{this.B((0,ut.$Oh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(je,De){const Ae=this.b=je.get(ne.$ycc),be=je.get(Fe.$9W),Ce=this.f=je.get(x.$kdc),ze=je.get(O.$tcc),Ue=this;be.registerHandler({async handleURL(et,nt){return Ue.O(Ae,ze,be,et,nt)}});const Ge=this.B(new me.$2dc({onDidOpenMainWindow:Ce.onDidOpenMainWindow,onDidFocusMainWindow:Ce.onDidFocusMainWindow,getActiveWindowId:()=>Ce.getActiveWindowId(-1)})),We=new a.$gi(et=>Ge.getActiveClientId().then(nt=>et===nt)),Ne=new qe.$Sdc(We,this.m),Ve=De.getChannel("urlHandler",Ne);be.registerHandler(new qe.$Rdc(Ve));const Je=await this.L(Ae,ze);return this.B(new Ke.$Tdc(Je?.urls,be,Ae,this.s,this.z,this.m)),Je}J(je){const De=()=>({statusCode:404,data:"Not found"}),Ae=new Ot.$V(()=>je.getChannel(dt.$gec,new dt.$hec));n.protocol.registerBufferProtocol(f.Schemas.vscodeManagedRemoteResource,(be,Ce)=>{const ze=c.URI.parse(be.url);if(!ze.authority.startsWith("window:"))return Ce(De());Ae.value.call(dt.$fec,[ze]).then(Ue=>Ce({...Ue,data:Buffer.from(Ue.body,"base64")}),Ue=>{this.m.warn("error dispatching remote resource call",Ue),Ce({statusCode:500,data:String(Ue)})})})}async L(je,De){const Ae=this.s.args["open-url"]?this.s.args._urls||[]:[];Ae.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ae);const be=global.getOpenUrls()||[];if(be.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",be),Ae.length+be.length===0)return;const Ce=[...Ae,...be].map(Ge=>{try{return{uri:c.URI.parse(Ge),originalUrl:Ge}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ge);return}}),ze=[],Ue=[];for(const Ge of Ce){if(!Ge)continue;const We=this.N(Ge.uri);if(We)if(await this.M(We,je,De)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ge.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ge.uri.toString(!0),We),ze.push(We);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ge.uri.toString(!0)),Ue.push(Ge)}return{urls:Ue,openables:ze}}async M(je,De,Ae){let be,Ce;if((0,Xe.$FD)(je)?(be=je.workspaceUri,Ce=(0,i.localize)(0,null,be.scheme===f.Schemas.file?(0,v.$Gw)(be,{os:w.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)):(0,Xe.$GD)(je)?(be=je.folderUri,Ce=(0,i.localize)(1,null,be.scheme===f.Schemas.file?(0,v.$Gw)(be,{os:w.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)):(be=je.fileUri,Ce=(0,i.localize)(2,null,be.scheme===f.Schemas.file?(0,v.$Gw)(be,{os:w.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)),be.scheme!==f.Schemas.file&&be.scheme!==f.Schemas.vscodeRemote||this.u.getValue(gt.a[be.scheme])===!1)return!1;const{response:Ue,checkboxChecked:Ge}=await Ae.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Ce,detail:(0,i.localize)(5,null),checkboxLabel:be.scheme===f.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(Ue!==0)return!0;if(Ge){const We={channel:"vscode:disablePromptForProtocolHandling",args:be.scheme===f.Schemas.file?"local":"remote"};De.sendToFocused(We.channel,We.args),De.sendToOpeningWindow(We.channel,We.args)}return!1}N(je){if(je.path){if(je.authority===f.Schemas.file){const De=c.URI.file(je.fsPath);return(0,ve.$4i)(De)?{workspaceUri:De}:{fileUri:De}}else if(je.authority===f.Schemas.vscodeRemote){const De=je.path.indexOf(y.$gc.sep,1);if(De!==-1){const Ae=je.path.substring(1,De),be=je.path.substring(De);let Ce=je.query;const ze=new URLSearchParams(je.query);ze.get("windowId")==="_blank"&&(ze.delete("windowId"),Ce=ze.toString());const Ue=c.URI.from({scheme:f.Schemas.vscodeRemote,authority:Ae,path:be,query:Ce,fragment:je.fragment});return(0,ve.$4i)(be)?{workspaceUri:Ue}:/:[\d]+$/.test(be)?{fileUri:Ue}:{folderUri:Ue}}}}}async O(je,De,Ae,be,Ce){this.m.trace("app#handleProtocolUrl():",be.toString(!0),Ce),be.scheme===this.z.urlProtocol&&be.path==="workspace"&&(be=be.with({authority:"file",path:c.URI.parse(be.query).path,query:""}));let ze=!1;const Ue=new URLSearchParams(be.query);Ue.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",be.toString(!0)),Ue.delete("windowId"),be=be.with({query:Ue.toString()}),ze=!0):w.$j&&je.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",be.toString(!0)),ze=!0);const Ge=Ue.get("continueOn");Ge!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",be.toString(!0)),Ue.delete("continueOn"),be=be.with({query:Ue.toString()}),this.s.continueOn=Ge??void 0);const We=this.N(be);return We?await this.M(We,je,De)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",be.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",We,be.toString(!0)),(0,wt.$Ob)(await je.open({context:5,cli:{...this.s.args},urisToOpen:[We],forceNewWindow:ze,gotoLineMode:!0}))?.focus(),!0):ze?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",be.toString(!0)),await(0,wt.$Ob)(await je.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,X.$Jm)(be)}))?.ready(),Ae.open(be,Ce)):(this.m.trace("app#handleProtocolUrl(): not handled",be.toString(!0),Ce),!1)}P(je,De){const Ae=this.B(this.j.createInstance(ue.$Edc,je,De)),be=(async()=>{this.m.trace("Main->SharedProcess#connect");const ze=await Ae.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new r.$pW(ze,"main")})();return{sharedProcessReady:(async()=>(await Ae.whenReady(),be))(),sharedProcessClient:be}}async Q(je,De,Ae){const be=new G.$wi;switch(process.platform){case"win32":be.set(fe.$gX,new H.$vi(Me.$Pdc));break;case"linux":w.$l?be.set(fe.$gX,new H.$vi(Te.$Odc,[process.env.SNAP,process.env.SNAP_REVISION])):be.set(fe.$gX,new H.$vi(Oe.$Ndc));break;case"darwin":be.set(fe.$gX,new H.$vi(Pe.$Mdc));break}be.set(ne.$ycc,new H.$vi(de.$1dc,[je,De,this.h],!1)),be.set(pt.$jdc,new H.$vi(Mt.$iec,void 0,!1));const Ce=new O.$ucc(this.m,this.z);be.set(O.$tcc,Ce),be.set(N.$qdc,new H.$vi(N.$rdc,void 0,!1)),be.set(I.$8cc,new H.$vi(I.$9cc,void 0,!1)),be.set(D.$fn,a.ProxyChannel.toService((0,a.$ei)(Ae.then(Ne=>Ne.getChannel("diagnostics"))))),be.set(le.$wKb,new H.$vi(Q.$mdc,[this.h])),be.set(M.$3W,new H.$vi(W.$0cc)),be.set(A.$ndc,new H.$vi(A.$odc)),be.set(x.$kdc,new H.$vi(x.$ldc,void 0,!1)),be.set(Be.$Udc,new H.$vi(He.$Wdc)),be.set(Y.$zdc,new H.$vi(Y.$Adc)),be.set(ae.$$cc,new H.$vi(te.$adc)),be.set(ye.$Xcc,new H.$vi(ye.$Ycc)),be.set(ye.$Zcc,new H.$vi(ye.$1cc));const ze=new At.$eec({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),Ue=new Rt.$zs(ze,this.u,this.m,this.n);be.set(ft.$as,Ue),w.$i?be.set(ce.$bdc,new H.$vi(J.$cdc)):w.$j?be.set(ce.$bdc,new H.$vi(J.$ddc)):w.$k&&be.set(ce.$bdc,new H.$vi(J.$edc));const Ge=new u.$3cc(this.s,this.u,this.m,this.w);be.set(o.$scc,Ge);const We=new Ze.$Lcc(this.s,this.m,this.C,Ge,Ce);if(be.set(Ze.$Kcc,We),be.set(Ie.$Wfb,new H.$vi(Qe.$3dc,void 0,!1)),be.set(Le.$wdc,new H.$vi(Le.$xdc,void 0,!1)),be.set(Fe.$9W,new H.$vi(xe.$$W,void 0,!1)),(0,Z.$pp)(this.z,this.s)){const Ne=(0,Z.$up)(this.z,this.u),Ve=(0,a.$ei)(Ae.then(at=>at.getChannel("telemetryAppender"))),Je=new Re.$Hdc(Ve),et=(0,Se.$gp)((0,R.release)(),(0,R.hostname)(),process.arch,this.z.commit,this.z.version,je,De,Ne),nt=(0,Z.$vp)(this.s),tt={appenders:[Je],commonProperties:et,piiPaths:nt,sendErrorTelemetry:!0};be.set(ke.$4l,new H.$vi(we.$3r,[tt],!1))}else be.set(ke.$4l,Z.$kp);return be.set(ct.$sq,new H.$vi(jt.$_P,void 0,!0)),be.set(lt.$wq,new H.$vi(Et.$6dc,void 0,!0)),be.set(ht.$cec,new H.$vi(ht.$dec,void 0,!0)),await ut.Promises.settled([Ge.initialize(),We.initialize()]),this.j.createChild(be)}R(je,De,Ae){const be=this.B(new $.$Tc),Ce=a.ProxyChannel.fromService(je.get(N.$qdc),be,{disableMarshalling:!0});this.g.registerChannel("launch",Ce);const ze=a.ProxyChannel.fromService(je.get(I.$8cc),be,{disableMarshalling:!0});this.g.registerChannel("diagnostics",ze);const Ue=be.add(new st.$4dc(je.get(_e.$ho)));De.registerChannel("policy",Ue),Ae.then(it=>it.registerChannel("policy",Ue));const Ge=this.y.getProvider(f.Schemas.file);(0,b.$ig)(Ge instanceof B.$cr);const We=be.add(new L.$fdc(Ge,this.m,this.s));De.registerChannel(V.$UP,We),Ae.then(it=>it.registerChannel(V.$UP,We));const Ne=a.ProxyChannel.fromService(je.get(Ye.$Bcc),be);De.registerChannel("userDataProfiles",Ne),Ae.then(it=>it.registerChannel("userDataProfiles",Ne));const Ve=new ot.$Xr(je.get(rt.$Qp));Ae.then(it=>it.registerChannel("request",Ve));const Je=new ge.$Idc(je.get(fe.$gX));De.registerChannel("update",Je);const et=a.ProxyChannel.fromService(je.get(le.$wKb),be);De.registerChannel("issue",et);const nt=a.ProxyChannel.fromService(je.get(M.$3W),be);De.registerChannel("encryption",nt);const tt=a.ProxyChannel.fromService(je.get(he.$Rl),be);De.registerChannel("sign",tt);const at=a.ProxyChannel.fromService(je.get(A.$ndc),be);De.registerChannel("keyboardLayout",at),this.f=je.get(x.$kdc);const yt=a.ProxyChannel.fromService(this.f,be);De.registerChannel("nativeHost",yt),Ae.then(it=>it.registerChannel("nativeHost",yt));const Lt=a.ProxyChannel.fromService(je.get(Ie.$Wfb),be);De.registerChannel("workspaces",Lt);const Ft=a.ProxyChannel.fromService(je.get(Y.$zdc),be);De.registerChannel("menubar",Ft);const Wt=a.ProxyChannel.fromService(je.get(Fe.$9W),be);De.registerChannel("url",Wt);const Nt=a.ProxyChannel.fromService(je.get(Be.$Udc),be);De.registerChannel("webview",Nt);const vt=be.add(new $e.$Fdc(this.m,je.get(ye.$Xcc)));De.registerChannel("storage",vt),Ae.then(it=>it.registerChannel("storage",vt));const Tt=be.add(new Pt.$8dc(je.get(ye.$Xcc),je.get(Ye.$Bcc),this.m));Ae.then(it=>it.registerChannel("profileStorageListener",Tt));const zt=a.ProxyChannel.fromService(je.get(ft.$as),be);De.registerChannel(ft.TerminalIpcChannels.LocalPty,zt);const Bt=a.ProxyChannel.fromService(je.get(ce.$bdc),be);De.registerChannel("externalTerminal",Bt);const St=new It.$aec(je.get(Dt.$Mcc));De.registerChannel("logger",St),Ae.then(it=>it.registerChannel("logger",St));const qt=new P.$4cc(je.get(ne.$ycc));De.registerChannel("extensionhostdebugservice",qt);const Ut=a.ProxyChannel.fromService(je.get(ae.$$cc),be);De.registerChannel(ae.$_cc,Ut);const Ht=a.ProxyChannel.fromService(je.get(ht.$cec),be);De.registerChannel(Ct.$bec,Ht)}async S(je,De){const Ae=this.b=je.get(ne.$ycc);this.c=je.get(pt.$jdc);const be=(0,T.$Cm)(process.env)?0:4,Ce=this.s.args;if(De){if(De.openables.length>0)return Ae.open({context:be,cli:Ce,urisToOpen:De.openables,gotoLineMode:!0,initialStartup:!0});if(De.urls.length>0)for(const tt of De.urls){const at=new URLSearchParams(tt.uri.query);if(at.get("windowId")==="_blank")return at.delete("windowId"),tt.originalUrl=tt.uri.toString(!0),tt.uri=tt.uri.with({query:at.toString()}),Ae.open({context:be,cli:Ce,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const ze=global.macOpenFiles,Ue=Ce._.length,Ge=!!Ce["folder-uri"],We=!!Ce["file-uri"],Ne=Ce["skip-add-to-recently-opened"]===!0,Ve=Ce.wait&&Ce.waitMarkerFilePath?c.URI.file(Ce.waitMarkerFilePath):void 0,Je=Ce.remote||void 0,et=Ce.profile,nt=Ce["profile-temp"];if(!Ue&&!Ge&&!We){if(Ce["new-window"]||et||nt)return Ae.open({context:be,cli:Ce,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ne,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Je,forceProfile:et,forceTempProfile:nt});if(ze.length)return Ae.open({context:1,cli:Ce,urisToOpen:ze.map(tt=>(tt=(0,bt.$dm)(tt),(0,ve.$4i)(tt)?{workspaceUri:c.URI.file(tt)}:{fileUri:c.URI.file(tt)})),noRecentEntry:Ne,waitMarkerFileURI:Ve,initialStartup:!0})}return Ae.open({context:be,cli:Ce,forceNewWindow:Ce["new-window"],diffMode:Ce.diff,mergeMode:Ce.merge,noRecentEntry:Ne,waitMarkerFileURI:Ve,gotoLineMode:Ce.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:et,forceTempProfile:nt})}U(){this.W(),n.protocol.registerHttpProtocol(f.Schemas.vscodeRemoteResource,(je,De)=>{De({url:je.url.replace(/^vscode-remote-resource:/,"http:"),method:je.method})}),this.X(this.s.args,process.env,!0),this.Y(),w.$j&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const je=this.z.win32MutexName;if(w.$i&&je)try{const De=await new Promise((be,Ce)=>{K(["@vscode/windows-mutex"],be,Ce)}),Ae=new De.Mutex(je);d.Event.once(this.t.onWillShutdown)(()=>Ae.release())}catch(De){this.m.error(De)}}async X(je,De,Ae){try{return await(0,U.$Im)(this.u,this.m,je,De)}catch(be){const Ce=(0,E.$jj)(be);Ae?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ce):this.m.error(Ce)}return{}}async Y(){try{const De=(await this.y.readFile(this.s.argvResource)).value.toString(),Ae=JSON.parse((0,p.$Tn)(De)),Ce=(0,Z.$rp)(this.u)>=1;if(Ae["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ce},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,m.$Ug)()}"`,"}"],Ue=De.substring(0,De.length-2).concat(`,
`,ze.join(`
`));await this.y.writeFile(this.s.argvResource,j.$He.fromString(Ue))}else{const ze=De.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ce},`);ze!==De&&await this.y.writeFile(this.s.argvResource,j.$He.fromString(ze))}}catch(je){this.m.error(je)}}};e.$jec=$t,e.$jec=$t=gt=Ee([ie(2,oe.$xi),ie(3,z.$5j),ie(4,z.$6j),ie(5,F.$ncc),ie(6,_.$Rcc),ie(7,g.$5i),ie(8,pe.$5P),ie(9,q.$5k),ie(10,ee.$lk),ie(11,Ye.$Bcc)],$t)}),define(se[317],re([0,1,14,43,7,22,8,47,15,31,3,48,13,9,66,4,36,25,21,44,100,312,10,18,242,254,24,64,205,16,226,94,78,222,93,20,229,5,80,27,81,282,130,291,53,290,96,253,34,54,69,57,39,238,236,2,40,270,67,231,119,125,274,102,268]),function(K,e,n,C,k,R,j,E,h,l,d,p,v,$,f,y,w,b,c,m,S,a,t,r,s,i,o,u,g,P,D,I,O,M,W,F,T,U,ae,te,ce,J,V,q,L,B,H,oe,G,le,Q,A,N,_,z,Y,x,ee,X,ue,he,pe,$e,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Se{main(){try{this.a()}catch(we){console.error(we.message),n.app.exit(1)}}async a(){(0,h.setUnexpectedErrorHandler)(Fe=>console.error(Fe));const[we,Z,fe,ge,Pe,Oe,Te,Me]=this.b();try{try{await this.d(fe,Me,ge,Pe,Te)}catch(Fe){throw this.g(fe,Te,Fe),Fe}await we.invokeFunction(async Fe=>{const qe=Fe.get(U.$5j),xe=Fe.get(F.$Rcc),Ke=Fe.get(P.$5k),Be=Fe.get(U.$6j),He=await this.f(qe,fe,xe,we,Te,!0);return c.Promises.writeFile(fe.mainLockfile,String(process.pid)).catch(Xe=>{qe.warn(`app#startup(): Error writing main lockfile: ${Xe.stack}`)}),Oe.logger=Be.createLogger("main",{name:(0,t.localize)(0,null)}),d.Event.once(xe.onWillShutdown)(Xe=>{Ke.dispose(),ge.dispose(),Xe.join("instanceLockfile",c.Promises.unlink(fe.mainLockfile).catch(()=>{}))}),we.createInstance(a.$jec,He,Z).startup()})}catch(Fe){we.invokeFunction(this.j,Fe)}}b(){const we=new W.$wi,Z=new Y.$Tc;process.once("exit",()=>Z.dispose());const fe={_serviceBrand:void 0,...ae.default};we.set(te.$lk,fe);const ge=new o.$occ(this.k(),fe),Pe=this.c(ge);we.set(o.$ncc,ge);const Oe=new X.$Ncc((0,U.$gk)(ge),ge.logsHome);we.set(X.$Mcc,Oe);const Te=new T.$6_b(Oe.getLogLevel()),Me=Z.add(new ue.$aQ(Te,[new U.$_j(Oe.getLogLevel())]));we.set(U.$5j,Me);const Fe=new D.$Lq(Me);we.set(P.$5k,Fe);const qe=new I.$cr(Me);Fe.registerProvider(v.Schemas.file,qe);const xe=new ee.$Ds(Fe);we.set(x.$Cl,xe);const Ke=new pe.$8P(1,ge,Me,Fe);we.set(G.$4P,Ke),we.set(G.$5P,Ke);const Be=new A.$Ccc(Ke,xe,ge,Fe,Me);we.set(A.$Bcc,Be),Fe.registerProvider(v.Schemas.vscodeUserData,new $e.$uec(v.Schemas.file,qe,v.Schemas.vscodeUserData,Be,xe,Me));const He=y.$i&&fe.win32RegValueName?Z.add(new _.$sec(Me,fe.win32RegValueName)):ge.policyFile?Z.add(new z.$tec(ge.policyFile,Fe,Me)):new N.$jo;we.set(N.$ho,He);const Xe=new s.$Jo(Be.defaultProfile.settingsResource,Fe,He,Me);return we.set(r.$5i,Xe),we.set(F.$Rcc,new O.$vi(F.$Scc,void 0,!1)),we.set(L.$Qp,new O.$vi(B.$qec,void 0,!0)),we.set(Q.$wcc,new O.$vi(Q.$xcc)),we.set(H.$Rl,new O.$vi(oe.$rec,void 0,!1)),we.set(V.$lw,new O.$vi(q.$oec)),we.set(ce.$vcc,new J.$lec(ge,Be,Me)),[new M.$fr(we,!0),Pe,ge,Xe,Ke,Te,fe,Be]}c(we){const Z={VSCODE_IPC_HOOK:we.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(fe=>{const ge=process.env[fe];typeof ge=="string"&&(Z[fe]=ge)}),Object.assign(process.env,Z),Z}async d(we,Z,fe,ge,Pe){await j.Promises.settled([Promise.all([this.e(we.extensionsPath),we.codeCachePath,we.logsHome.with({scheme:v.Schemas.file}).fsPath,Z.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath,we.workspaceStorageHome.with({scheme:v.Schemas.file}).fsPath,we.localHistoryHome.with({scheme:v.Schemas.file}).fsPath,we.backupHome].map(Oe=>Oe?c.Promises.mkdir(Oe,{recursive:!0}):void 0)),ge.init(),fe.initialize()]),Z.init()}e(we){if(y.$i){const Z=(0,ye.getUNCHost)(we);Z&&(0,ye.addUNCHostToAllowlist)(Z)}return we}async f(we,Z,fe,ge,Pe,Oe){let Te;try{(0,f.mark)("code/willStartMainServer"),Te=await(0,S.$ti)(Z.mainIPCHandle),(0,f.mark)("code/didStartMainServer"),d.Event.once(fe.onWillShutdown)(()=>Te.dispose())}catch(Me){if(Me.code!=="EADDRINUSE")throw this.g(Z,Pe,Me),Me;let Fe;try{Fe=await(0,S.$ui)(Z.mainIPCHandle,"main")}catch(Be){if(!Oe||y.$i||Be.code!=="ECONNREFUSED")throw Be.code==="EPERM"&&this.h((0,t.localize)(1,null,Pe.nameShort),(0,t.localize)(2,null),Pe),Be;try{(0,C.unlinkSync)(Z.mainIPCHandle)}catch(He){throw we.warn("Could not delete obsolete instance handle",He),He}return this.f(we,Z,fe,ge,Pe,!1)}if(Z.extensionTestsLocationURI&&!Z.debugExtensionHost.break){const Be=`Running extension tests from the command line is currently only supported if no other instance of ${Pe.nameShort} is running.`;throw we.error(Be),Fe.dispose(),new Error(Be)}let qe;!Z.args.wait&&!Z.args.status&&(qe=setTimeout(()=>{this.h((0,t.localize)(3,null,Pe.nameShort),(0,t.localize)(4,null),Pe)},1e4));const xe=m.ProxyChannel.toService(Fe.getChannel("launch"),{disableMarshalling:!0}),Ke=m.ProxyChannel.toService(Fe.getChannel("diagnostics"),{disableMarshalling:!0});if(Z.args.status)return ge.invokeFunction(async()=>{const Be=new i.$Ks(le.$kp,Pe),He=await Ke.getMainDiagnostics(),Xe=await Ke.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),ne=await Be.getDiagnostics(He,Xe);throw console.log(ne),new h.$ab});throw y.$i&&await this.i(xe,we),we.trace("Sending env to running instance..."),await xe.start(Z.args,process.env),Fe.dispose(),qe&&clearTimeout(qe),new h.$ab("Sent env to running instance. Terminating...")}if(Z.args.status)throw console.log((0,t.localize)(5,null,Pe.nameShort)),new h.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),Te}g(we,Z,fe){if(fe.code==="EACCES"||fe.code==="EPERM"){const ge=(0,R.$Hb)([we.userDataPath,we.extensionsPath,S.$pi]).map(Pe=>(0,p.$Gw)(k.URI.file(Pe),{os:y.OS,tildify:we}));this.h((0,t.localize)(6,null),(0,t.localize)(7,null,(0,E.$jj)(fe),ge.join(`
`)),Z)}}h(we,Z,fe){n.dialog.showMessageBoxSync((0,he.$Uw)({type:"warning",buttons:[(0,t.localize)(8,null)],message:we,detail:Z},fe).options)}async i(we,Z){if(y.$i){const fe=await we.getMainProcessId();Z.trace("Sending some foreground love to the running instance:",fe);try{(await new Promise((ge,Pe)=>{K(["windows-foreground-love"],ge,Pe)})).allowSetForegroundWindow(fe)}catch(ge){Z.error(ge)}}}j(we,Z){const fe=we.get(U.$5j),ge=we.get(F.$Rcc);let Pe=0;Z&&(Z.isExpected?Z.message&&fe.trace(Z.message):(Pe=1,Z.stack?fe.error(Z.stack):fe.error(`Startup error: ${Z.toString()}`))),ge.kill(Pe)}k(){const we=this.l((0,u.$zm)(process.argv));if(we.wait&&!we.waitMarkerFilePath){const Z=(0,g.$kec)(we.verbose);Z&&((0,u.$Bm)(process.argv,"--waitMarkerFilePath",Z),we.waitMarkerFilePath=Z)}return we}l(we){if(we["open-url"]&&(we._urls=we._,we._=[]),!we.remote){const Z=this.m(we._,we.goto);we._=Z}return we}m(we,Z){const fe=(0,w.cwd)(),ge=we.map(Te=>{let Me=String(Te),Fe;Z&&(Fe=(0,l.$Fg)(Me),Me=Fe.path),Me&&(Me=this.n(fe,Me));const qe=(0,l.$zg)(Me,fe),xe=(0,$.$nc)(qe);return xe&&!(0,l.$vg)(xe)?null:Z&&Fe?(Fe.path=qe,this.o(Fe)):qe}),Pe=y.$i||y.$j,Oe=(0,R.$Mb)(ge,Te=>Te&&Pe?Te.toLowerCase():Te||"");return(0,R.$Hb)(Oe)}n(we,Z){return y.$i&&(Z=(0,b.$hf)(Z,'"')),Z=(0,b.$ff)((0,b.$ff)(Z," "),"	"),y.$i&&(Z=(0,$.$kc)(we,Z),Z=(0,b.$hf)(Z,".")),Z}o(we){const Z=[we.path];return typeof we.line=="number"&&Z.push(String(we.line)),typeof we.column=="number"&&Z.push(String(we.column)),Z.join(":")}}new Se().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6313b2d7eda4c378748d73274af802a26b8e38ba/core/vs/code/electron-main/main.js.map
