/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/path","vs/base/common/uri","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/nls!vs/platform/terminal/node/ptyHostMain","vs/base/common/async","vs/nls","vs/base/common/decorators","vs/base/common/process","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/network","os","vs/platform/instantiation/common/instantiation","vs/base/common/lazy","vs/base/common/resources","vs/base/node/pfs","vs/base/common/map","child_process","vs/base/parts/ipc/common/ipc","vs/platform/terminal/common/terminal","vs/base/common/functional","vs/base/common/objects","vs/base/parts/sandbox/node/electronTypes","vs/base/common/extpath","vs/base/common/processes","vs/base/node/processes","vs/platform/contextkey/common/contextkey","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/node/terminalEnvironment","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/symbols","vs/base/common/ternarySearchTree","vs/base/common/uuid","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/terminal/node/ptyService","vs/nls!vs/platform/terminal/node/terminalProcess","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/files/common/files","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/terminal/common/capabilities/bufferMarkCapability","vs/platform/terminal/common/capabilities/commandDetection/promptInputModel","vs/platform/terminal/common/capabilities/commandDetection/terminalCommand","vs/platform/terminal/common/capabilities/commandDetectionCapability","vs/platform/terminal/common/capabilities/cwdDetectionCapability","vs/platform/terminal/common/capabilities/partialCommandDetectionCapability","vs/platform/terminal/common/capabilities/terminalCapabilityStore","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalAutoResponder","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalProcess","vs/platform/terminal/common/terminalStrings","vs/platform/terminal/common/xterm/shellIntegrationAddon","vs/platform/terminal/node/heartbeatService","vs/platform/terminal/node/windowsShellHelper","vs/platform/terminal/node/terminalProcess","vs/platform/terminal/node/ptyService","fs","util","minimist","node-pty","@xterm/headless","vs/base/common/performance","vs/platform/terminal/node/ptyHostMain"],ge=function(ae){for(var e=[],y=0,S=ae.length;y<S;y++)e[y]=fe[ae[y]];return e};define(fe[40],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=y,e.$gb=S,e.$hb=E,e.$ib=A,e.$jb=j,e.$kb=k,e.$lb=h,e.$nb=p,e.$ob=l,e.$pb=P,e.$qb=a,e.$rb=c;function y(g,f){const s=S(g,f);if(s!==-1)return g[s]}function S(g,f,s=g.length-1){for(let n=s;n>=0;n--){const $=g[n];if(f($))return n}return-1}function E(g,f){const s=A(g,f);return s===-1?void 0:g[s]}function A(g,f,s=0,n=g.length){let $=s,v=n;for(;$<v;){const i=Math.floor(($+v)/2);f(g[i])?$=i+1:v=i}return $-1}function j(g,f){const s=k(g,f);return s===g.length?void 0:g[s]}function k(g,f,s=0,n=g.length){let $=s,v=n;for(;$<v;){const i=Math.floor(($+v)/2);f(g[i])?v=i:$=i+1}return $}function h(g,f,s=0,n=g.length){const $=k(g,f,s,n);return $===g.length?-1:$}class r{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(r.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!f(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const s=A(this.e,f,this.c);return this.c=s+1,s===-1?void 0:this.e[s]}}e.$mb=r;function p(g,f){if(g.length===0)return;let s=g[0];for(let n=1;n<g.length;n++){const $=g[n];f($,s)>0&&(s=$)}return s}function l(g,f){if(g.length===0)return;let s=g[0];for(let n=1;n<g.length;n++){const $=g[n];f($,s)>=0&&(s=$)}return s}function P(g,f){return p(g,(s,n)=>-f(s,n))}function a(g,f){if(g.length===0)return-1;let s=0;for(let n=1;n<g.length;n++){const $=g[n];f($,g[s])>0&&(s=n)}return s}function c(g,f){for(const s of g){const n=f(s);if(n!==void 0)return n}}}),define(fe[41],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=y,e.$L=S,e.$M=E,e.$N=A;function y(j,k){const h=Object.create(null);for(const r of j){const p=k(r);let l=h[p];l||(l=h[p]=[]),l.push(r)}return h}function S(j,k){const h=[],r=[];for(const p of j)k.has(p)||h.push(p);for(const p of k)j.has(p)||r.push(p);return{removed:h,added:r}}function E(j,k){const h=[],r=[];for(const[p,l]of j)k.has(p)||h.push(l);for(const[p,l]of k)j.has(p)||r.push(l);return{removed:h,added:r}}function A(j,k){const h=new Set;for(const r of k)j.has(r)&&h.add(r);return h}}),define(fe[14],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=S,e.$4h=E,e.$5h=A;function y(j){return(k,h,r)=>{let p=null,l=null;if(typeof r.value=="function"?(p="value",l=r.value):typeof r.get=="function"&&(p="get",l=r.get),!l)throw new Error("not supported");r[p]=j(l,h)}}function S(j,k,h){let r=null,p=null;if(typeof h.value=="function"?(r="value",p=h.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(r="get",p=h.get),!p)throw new Error("not supported");const l=`$memoize$${k}`;h[r]=function(...P){return this.hasOwnProperty(l)||Object.defineProperty(this,l,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,P)}),this[l]}}function E(j,k,h){return y((r,p)=>{const l=`$debounce$${p}`,P=`$debounce$result$${p}`;return function(...a){this[P]||(this[P]=h?h():void 0),clearTimeout(this[l]),k&&(this[P]=k(this[P],...a),a=[this[P]]),this[l]=setTimeout(()=>{r.apply(this,a),this[P]=h?h():void 0},j)}})}function A(j,k,h){return y((r,p)=>{const l=`$throttle$timer$${p}`,P=`$throttle$result$${p}`,a=`$throttle$lastRun$${p}`,c=`$throttle$pending$${p}`;return function(...g){if(this[P]||(this[P]=h?h():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),k&&(this[P]=k(this[P],...g)),this[c])return;const f=this[a]+j;f<=Date.now()?(this[a]=Date.now(),r.apply(this,[this[P]]),this[P]=h?h():void 0):(this[c]=!0,this[l]=setTimeout(()=>{this[c]=!1,this[a]=Date.now(),r.apply(this,[this[P]]),this[P]=h?h():void 0},f-Date.now()))}})}}),define(fe[7],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=S,e.$Z=E,e.$1=A,e.$2=j,e.$3=k,e.$4=r,e.$6=l,e.$7=P,e.$8=a,e.$0=g;class y{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?$.isErrorNoTelemetry(t)?new $(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=y,e.$X=new y;function S(i){e.$X.setUnexpectedErrorHandler(i)}function E(i){if(!i||typeof i!="object")return!1;const t=i;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function A(i){r(i)||e.$X.onUnexpectedError(i)}function j(i){r(i)||e.$X.onUnexpectedExternalError(i)}function k(i){if(i instanceof Error){const{name:t,message:o}=i,L=i.stacktrace||i.stack;return{$isError:!0,name:t,message:o,stack:L,noTelemetry:$.isErrorNoTelemetry(i)}}return i}const h="Canceled";function r(i){return i instanceof p?!0:i instanceof Error&&i.name===h&&i.message===h}class p extends Error{constructor(){super(h),this.name=this.message}}e.$5=p;function l(){const i=new Error(h);return i.name=i.message,i}function P(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function a(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class c extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=c;function g(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class s extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=s;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class $ extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof $)return t;const o=new $;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=$;class v extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,v.prototype)}}e.$cb=v}),define(fe[16],ge([0,1,7,40]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=E,e.$tb=A,e.$ub=j,e.$vb=k,e.$wb=h,e.$xb=r,e.$yb=p,e.$zb=l,e.$Ab=P,e.$Bb=a,e.$Cb=c,e.$Db=g,e.$Eb=f,e.top=s,e.$Gb=n,e.$Hb=v,e.$Ib=i,e.$Jb=t,e.$Kb=o,e.$Lb=L,e.$Mb=m,e.$Nb=M,e.$Ob=C,e.$Pb=b,e.$Qb=U,e.$Rb=K,e.$Sb=F,e.$Tb=O,e.$Ub=d,e.$Vb=I,e.$Wb=w,e.$Xb=D,e.$Yb=Y,e.$Zb=te,e.$1b=V,e.$2b=ee,e.$3b=oe,e.$4b=ue,e.$5b=X,e.$6b=_,e.$7b=de,e.$0b=x;function E(N,G=0){return N[N.length-(1+G)]}function A(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}function j(N,G,W=(H,R)=>H===R){if(N===G)return!0;if(!N||!G||N.length!==G.length)return!1;for(let H=0,R=N.length;H<R;H++)if(!W(N[H],G[H]))return!1;return!0}function k(N,G){const W=N.length-1;G<W&&(N[G]=N[W]),N.pop()}function h(N,G,W){return r(N.length,H=>W(N[H],G))}function r(N,G){let W=0,H=N-1;for(;W<=H;){const R=(W+H)/2|0,J=G(R);if(J<0)W=R+1;else if(J>0)H=R-1;else return R}return-(W+1)}function p(N,G,W){if(N=N|0,N>=G.length)throw new TypeError("invalid index");const H=G[Math.floor(G.length*Math.random())],R=[],J=[],ie=[];for(const ce of G){const se=W(ce,H);se<0?R.push(ce):se>0?J.push(ce):ie.push(ce)}return N<R.length?p(N,R,W):N<R.length+ie.length?ie[0]:p(N-(R.length+ie.length),J,W)}function l(N,G){const W=[];let H;for(const R of N.slice(0).sort(G))!H||G(H[0],R)!==0?(H=[R],W.push(H)):H.push(R);return W}function*P(N,G){let W,H;for(const R of N)H!==void 0&&G(H,R)?W.push(R):(W&&(yield W),W=[R]),H=R;W&&(yield W)}function a(N,G){for(let W=0;W<=N.length;W++)G(W===0?void 0:N[W-1],W===N.length?void 0:N[W])}function c(N,G){for(let W=0;W<N.length;W++)G(W===0?void 0:N[W-1],N[W],W+1===N.length?void 0:N[W+1])}function g(N,G,W){const H=[];function R(ce,se,he){if(se===0&&he.length===0)return;const $e=H[H.length-1];$e&&$e.start+$e.deleteCount===ce?($e.deleteCount+=se,$e.toInsert.push(...he)):H.push({start:ce,deleteCount:se,toInsert:he})}let J=0,ie=0;for(;;){if(J===N.length){R(J,0,G.slice(ie));break}if(ie===G.length){R(J,N.length-J,[]);break}const ce=N[J],se=G[ie],he=W(ce,se);he===0?(J+=1,ie+=1):he<0?(R(J,1,[]),J+=1):he>0&&(R(J,0,[se]),ie+=1)}return H}function f(N,G,W){const H=g(N,G,W),R=[],J=[];for(const ie of H)R.push(...N.slice(ie.start,ie.start+ie.deleteCount)),J.push(...ie.toInsert);return{removed:R,added:J}}function s(N,G,W){if(W===0)return[];const H=N.slice(0,W).sort(G);return $(N,G,H,W,N.length),H}function n(N,G,W,H,R){return W===0?Promise.resolve([]):new Promise((J,ie)=>{(async()=>{const ce=N.length,se=N.slice(0,W).sort(G);for(let he=W,$e=Math.min(W+H,ce);he<ce;he=$e,$e=Math.min($e+H,ce)){if(he>W&&await new Promise(we=>setTimeout(we)),R&&R.isCancellationRequested)throw new y.$5;$(N,G,se,he,$e)}return se})().then(J,ie)})}function $(N,G,W,H,R){for(const J=W.length;H<R;H++){const ie=N[H];if(G(ie,W[J-1])<0){W.pop();const ce=(0,S.$kb)(W,se=>G(ie,se)<0);W.splice(ce,0,ie)}}}function v(N){return N.filter(G=>!!G)}function i(N){let G=0;for(let W=0;W<N.length;W++)N[W]&&(N[G]=N[W],G+=1);N.length=G}function t(N,G,W){N.splice(W,0,N.splice(G,1)[0])}function o(N){return!Array.isArray(N)||N.length===0}function L(N){return Array.isArray(N)&&N.length>0}function m(N,G=W=>W){const W=new Set;return N.filter(H=>{const R=G(H);return W.has(R)?!1:(W.add(R),!0)})}function M(N){const G=new Set;return W=>{const H=N(W);return G.has(H)?!1:(G.add(H),!0)}}function C(N,G){return N.length>0?N[0]:G}function b(N,G){return N.length>0?N[N.length-1]:G}function U(N,G,W=(H,R)=>H===R){let H=0;for(let R=0,J=Math.min(N.length,G.length);R<J&&W(N[R],G[R]);R++)H++;return H}function K(N,G){let W=typeof G=="number"?N:0;typeof G=="number"?W=N:(W=0,G=N);const H=[];if(W<=G)for(let R=W;R<G;R++)H.push(R);else for(let R=W;R>G;R--)H.push(R);return H}function F(N,G,W){return N.reduce((H,R)=>(H[G(R)]=W?W(R):R,H),Object.create(null))}function O(N,G){return N.push(G),()=>d(N,G)}function d(N,G){const W=N.indexOf(G);if(W>-1)return N.splice(W,1),G}function I(N,G,W){const H=N.slice(0,G),R=N.slice(G);return H.concat(W,R)}function w(N,G){let W;if(typeof G=="number"){let H=G;W=()=>{const R=Math.sin(H++)*179426549;return R-Math.floor(R)}}else W=Math.random;for(let H=N.length-1;H>0;H-=1){const R=Math.floor(W()*(H+1)),J=N[H];N[H]=N[R],N[R]=J}}function D(N,G){const W=N.indexOf(G);W>-1&&(N.splice(W,1),N.unshift(G))}function Y(N,G){const W=N.indexOf(G);W>-1&&(N.splice(W,1),N.push(G))}function te(N,G){for(const W of G)N.push(W)}function V(N,G){return Array.isArray(N)?N.map(G):G(N)}function ee(N){return Array.isArray(N)?N:[N]}function oe(N){return N[Math.floor(Math.random()*N.length)]}function ue(N,G,W){const H=q(N,G),R=N.length,J=W.length;N.length=R+J;for(let ie=R-1;ie>=H;ie--)N[ie+J]=N[ie];for(let ie=0;ie<J;ie++)N[ie+H]=W[ie]}function X(N,G,W,H){const R=q(N,G);let J=N.splice(R,W);return J===void 0&&(J=[]),ue(N,R,H),J}function q(N,G){return G<0?Math.max(G+N.length,0):Math.min(G,N.length)}var Z;(function(N){function G(J){return J<0}N.isLessThan=G;function W(J){return J<=0}N.isLessThanOrEqual=W;function H(J){return J>0}N.isGreaterThan=H;function R(J){return J===0}N.isNeitherLessOrGreaterThan=R,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(Z||(e.CompareResult=Z={}));function _(N,G){return(W,H)=>G(N(W),N(H))}function de(...N){return(G,W)=>{for(const H of N){const R=H(G,W);if(!Z.isNeitherLessOrGreaterThan(R))return R}return Z.neitherLessOrGreaterThan}}const B=(N,G)=>N-G;e.$8b=B;const le=(N,G)=>(0,e.$8b)(N?1:0,G?1:0);e.$9b=le;function x(N){return(G,W)=>-N(G,W)}class u{constructor(G){this.g=G,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(G){let W=this.c;for(;W<this.g.length&&G(this.g[W]);)W++;const H=W===this.c?null:this.g.slice(this.c,W);return this.c=W,H}takeFromEndWhile(G){let W=this.d;for(;W>=0&&G(this.g[W]);)W--;const H=W===this.d?null:this.g.slice(W+1,this.d+1);return this.d=W,H}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const G=this.g[this.c];return this.c++,G}removeLast(){const G=this.g[this.d];return this.d--,G}takeCount(G){const W=this.g.slice(this.c,this.c+G);return this.c+=G,W}}e.$$b=u;class z{static{this.empty=new z(G=>{})}constructor(G){this.iterate=G}forEach(G){this.iterate(W=>(G(W),!0))}toArray(){const G=[];return this.iterate(W=>(G.push(W),!0)),G}filter(G){return new z(W=>this.iterate(H=>G(H)?W(H):!0))}map(G){return new z(W=>this.iterate(H=>W(G(H))))}some(G){let W=!1;return this.iterate(H=>(W=G(H),!W)),W}findFirst(G){let W;return this.iterate(H=>G(H)?(W=H,!1):!0),W}findLast(G){let W;return this.iterate(H=>(G(H)&&(W=H),!0)),W}findLastMaxBy(G){let W,H=!0;return this.iterate(R=>((H||Z.isGreaterThan(G(R,W)))&&(H=!1,W=R),!0)),W}}e.$_b=z;class ne{constructor(G){this.c=G}static createSortPermutation(G,W){const H=Array.from(G.keys()).sort((R,J)=>W(G[R],G[J]));return new ne(H)}apply(G){return G.map((W,H)=>G[this.c[H]])}inverse(){const G=this.c.slice();for(let W=0;W<this.c.length;W++)G[this.c[W]]=W;return new ne(G)}}e.$ac=ne}),define(fe[42],ge([0,1,7]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=S,e.$ed=E,e.$fd=A,e.$gd=j,e.$hd=k,e.$id=h;function S(r,p){if(!r)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}function E(r,p="Unreachable"){throw new Error(p)}function A(r,p="unexpected state"){if(!r)throw new y.$cb(`Assertion Failed: ${p}`)}function j(r){r||(0,y.$1)(new y.$cb("Soft Assertion Failed"))}function k(r){if(!r()){debugger;r(),(0,y.$1)(new y.$cb("Assertion Failed"))}}function h(r,p){let l=0;for(;l<r.length-1;){const P=r[l],a=r[l+1];if(!p(P,a))return!1;l++}return!0}}),define(fe[29],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=y;function y(S,E){const A=this;let j=!1,k;return function(){if(j)return k;if(j=!0,E)try{k=S.apply(A,arguments)}finally{E()}else k=S.apply(A,arguments);return k}}}),define(fe[43],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(S){function E(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}S.is=E;const A=Object.freeze([]);function j(){return A}S.empty=j;function*k(t){yield t}S.single=k;function h(t){return E(t)?t:k(t)}S.wrap=h;function r(t){return t||A}S.from=r;function*p(t){for(let o=t.length-1;o>=0;o--)yield t[o]}S.reverse=p;function l(t){return!t||t[Symbol.iterator]().next().done===!0}S.isEmpty=l;function P(t){return t[Symbol.iterator]().next().value}S.first=P;function a(t,o){for(const L of t)if(o(L))return!0;return!1}S.some=a;function c(t,o){for(const L of t)if(o(L))return L}S.find=c;function*g(t,o){for(const L of t)o(L)&&(yield L)}S.filter=g;function*f(t,o){let L=0;for(const m of t)yield o(m,L++)}S.map=f;function*s(...t){for(const o of t)yield*o}S.concat=s;function n(t,o,L){let m=L;for(const M of t)m=o(m,M);return m}S.reduce=n;function*$(t,o,L=t.length){for(o<0&&(o+=t.length),L<0?L+=t.length:L>t.length&&(L=t.length);o<L;o++)yield t[o]}S.slice=$;function v(t,o=Number.POSITIVE_INFINITY){const L=[];if(o===0)return[L,t];const m=t[Symbol.iterator]();for(let M=0;M<o;M++){const C=m.next();if(C.done)return[L,S.empty()];L.push(C.value)}return[L,{[Symbol.iterator](){return m}}]}S.consume=v;async function i(t){const o=[];for await(const L of t)o.push(L);return Promise.resolve(o)}S.asyncToArray=i})(y||(e.Iterable=y={}))}),define(fe[22],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class y{constructor(E){this.d=E,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(E){this.c=E}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=y}),define(fe[44],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class y{static{this.Undefined=new y(void 0)}constructor(A){this.element=A,this.next=y.Undefined,this.prev=y.Undefined}}class S{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let A=this.a;for(;A!==y.Undefined;){const j=A.next;A.prev=y.Undefined,A.next=y.Undefined,A=j}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,j){const k=new y(A);if(this.a===y.Undefined)this.a=k,this.b=k;else if(j){const r=this.b;this.b=k,k.prev=r,r.next=k}else{const r=this.a;this.a=k,k.next=r,r.prev=k}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(k))}}shift(){if(this.a!==y.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==y.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==y.Undefined&&A.next!==y.Undefined){const j=A.prev;j.next=A.next,A.next.prev=j}else A.prev===y.Undefined&&A.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):A.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):A.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==y.Undefined;)yield A.element,A=A.next}}e.$5c=S}),define(fe[25],ge([0,1]),function(ae,e){"use strict";var y,S,E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=A,e.$yc=j,e.$zc=k,e.$Ic=v;function A(i,t,o){let L=i.get(t);return L===void 0&&(L=o,i.set(t,L)),L}function j(i){const t=[];return i.forEach((o,L)=>{t.push(`${L} => ${o}`)}),`Map(${i.size}) {${t.join(", ")}}`}function k(i){const t=[];return i.forEach(o=>{t.push(o)}),`Set(${i.size}) {${t.join(", ")}}`}class h{constructor(t,o){this.uri=t,this.value=o}}function r(i){return Array.isArray(i)}class p{static{this.c=t=>t.toString()}constructor(t,o){if(this[y]="ResourceMap",t instanceof p)this.d=new Map(t.d),this.e=o??p.c;else if(r(t)){this.d=new Map,this.e=o??p.c;for(const[L,m]of t)this.set(L,m)}else this.d=new Map,this.e=t??p.c}set(t,o){return this.d.set(this.e(t),new h(t,o)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,o){typeof o<"u"&&(t=t.bind(o));for(const[L,m]of this.d)t(m.value,m.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=p;class l{constructor(t,o){this[S]="ResourceSet",!t||typeof t=="function"?this.c=new p(t):(this.c=new p(o),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,o){this.c.forEach((L,m)=>t.call(o,m,m,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=l;var P;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(P||(e.Touch=P={}));class a{constructor(){this[E]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,o=0){const L=this.c.get(t);if(L)return o!==0&&this.m(L,o),L.value}set(t,o,L=0){let m=this.c.get(t);if(m)m.value=o,L!==0&&this.m(m,L);else{switch(m={key:t,value:o,next:void 0,previous:void 0},L){case 0:this.k(m);break;case 1:this.j(m);break;case 2:this.k(m);break;default:this.k(m);break}this.c.set(t,m),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this.c.get(t);if(o)return this.c.delete(t),this.l(o),this.f--,o.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,o){const L=this.g;let m=this.d;for(;m;){if(o?t.bind(o)(m.value,m.key,this):t(m.value,m.key,this),this.g!==L)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const t=this,o=this.g;let L=this.d;const m={[Symbol.iterator](){return m},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(L){const M={value:L.key,done:!1};return L=L.next,M}else return{value:void 0,done:!0}}};return m}values(){const t=this,o=this.g;let L=this.d;const m={[Symbol.iterator](){return m},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(L){const M={value:L.value,done:!1};return L=L.next,M}else return{value:void 0,done:!0}}};return m}entries(){const t=this,o=this.g;let L=this.d;const m={[Symbol.iterator](){return m},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(L){const M={value:[L.key,L.value],done:!1};return L=L.next,M}else return{value:void 0,done:!0}}};return m}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this.d,L=this.size;for(;o&&L>t;)this.c.delete(o.key),o=o.next,L--;this.d=o,this.f=L,o&&(o.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this.e,L=this.size;for(;o&&L>t;)this.c.delete(o.key),o=o.previous,L--;this.e=o,this.f=L,o&&(o.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const o=t.next,L=t.previous;if(!o||!L)throw new Error("Invalid list");o.previous=L,L.next=o}t.next=void 0,t.previous=void 0,this.g++}m(t,o){if(!this.d||!this.e)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this.d)return;const L=t.next,m=t.previous;t===this.e?(m.next=void 0,this.e=m):(L.previous=m,m.next=L),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(o===2){if(t===this.e)return;const L=t.next,m=t.previous;t===this.d?(L.previous=void 0,this.d=L):(L.previous=m,m.next=L),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((o,L)=>{t.push([L,o])}),t}fromJSON(t){this.clear();for(const[o,L]of t)this.set(o,L)}}e.$Cc=a;class c extends a{constructor(t,o=1){super(),this.n=t,this.o=Math.min(Math.max(0,o),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class g extends c{constructor(t,o=1){super(t,o)}q(t){this.h(t)}set(t,o){return super.set(t,o),this.p(),this}}e.$Dc=g;class f extends c{constructor(t,o=1){super(t,o)}q(t){this.i(t)}set(t,o){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,o),this}}e.$Ec=f;class s{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let o=this.c.get(t)||0;return o===0?!1:(o--,o===0?this.c.delete(t):this.c.set(t,o),!0)}has(t){return this.c.has(t)}}e.$Fc=s;class n{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[o,L]of t)this.set(o,L)}clear(){this.c.clear(),this.d.clear()}set(t,o){this.c.set(t,o),this.d.set(o,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const o=this.c.get(t);return o===void 0?!1:(this.c.delete(t),this.d.delete(o),!0)}forEach(t,o){this.c.forEach((L,m)=>{t.call(o,L,m,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=n;class ${constructor(){this.c=new Map}add(t,o){let L=this.c.get(t);L||(L=new Set,this.c.set(t,L)),L.add(o)}delete(t,o){const L=this.c.get(t);L&&(L.delete(o),L.size===0&&this.c.delete(t))}forEach(t,o){const L=this.c.get(t);L&&L.forEach(o)}get(t){const o=this.c.get(t);return o||new Set}}e.$Hc=$;function v(i,t){if(i===t)return!0;if(i.size!==t.size)return!1;for(const[o,L]of i)if(!t.has(o)||t.get(o)!==L)return!1;for(const[o]of t)if(!i.has(o))return!1;return!0}}),define(fe[2],ge([0,1,16,41,25,29,43]),function(ae,e,y,S,E,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=p,e.$Lc=l,e.$Mc=P,e.$Nc=g,e.$Oc=f,e.$Pc=s,e.$Qc=n,e.$Rc=$,e.$Sc=v,e.$3c=K;const k=!1;let h=null;class r{constructor(){this.b=new Map}static{this.a=0}c(d){let I=this.b.get(d);return I||(I={parent:null,source:null,isSingleton:!1,value:d,idx:r.a++},this.b.set(d,I)),I}trackDisposable(d){const I=this.c(d);I.source||(I.source=new Error().stack)}setParent(d,I){const w=this.c(d);w.parent=I}markAsDisposed(d){this.b.delete(d)}markAsSingleton(d){this.c(d).isSingleton=!0}f(d,I){const w=I.get(d);if(w)return w;const D=d.parent?this.f(this.c(d.parent),I):d;return I.set(d,D),D}getTrackedDisposables(){const d=new Map;return[...this.b.entries()].filter(([,w])=>w.source!==null&&!this.f(w,d).isSingleton).flatMap(([w])=>w)}computeLeakingDisposables(d=10,I){let w;if(I)w=I;else{const ee=new Map,oe=[...this.b.values()].filter(X=>X.source!==null&&!this.f(X,ee).isSingleton);if(oe.length===0)return;const ue=new Set(oe.map(X=>X.value));if(w=oe.filter(X=>!(X.parent&&ue.has(X.parent))),w.length===0)throw new Error("There are cyclic diposable chains!")}if(!w)return;function D(ee){function oe(X,q){for(;X.length>0&&q.some(Z=>typeof Z=="string"?Z===X[0]:X[0].match(Z));)X.shift()}const ue=ee.source.split(`
`).map(X=>X.trim().replace("at ","")).filter(X=>X!=="");return oe(ue,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ue.reverse()}const Y=new E.$Hc;for(const ee of w){const oe=D(ee);for(let ue=0;ue<=oe.length;ue++)Y.add(oe.slice(0,ue).join(`
`),ee)}w.sort((0,y.$6b)(ee=>ee.idx,y.$8b));let te="",V=0;for(const ee of w.slice(0,d)){V++;const oe=D(ee),ue=[];for(let X=0;X<oe.length;X++){let q=oe[X];q=`(shared with ${Y.get(oe.slice(0,X+1).join(`
`)).size}/${w.length} leaks) at ${q}`;const _=Y.get(oe.slice(0,X).join(`
`)),de=(0,S.$K)([..._].map(B=>D(B)[X]),B=>B);delete de[oe[X]];for(const[B,le]of Object.entries(de))ue.unshift(`    - stacktraces of ${le.length} other leaks continue with ${B}`);ue.unshift(q)}te+=`


==================== Leaking disposable ${V}/${w.length}: ${ee.value.constructor.name} ====================
${ue.join(`
`)}
============================================================

`}return w.length>d&&(te+=`


... and ${w.length-d} more leaking disposables

`),{leaks:w,details:te}}}e.$Jc=r;function p(O){h=O}if(k){const O="__is_disposable_tracked__";p(new class{trackDisposable(d){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[O]||console.log(I)},3e3)}setParent(d,I){if(d&&d!==t.None)try{d[O]=!0}catch{}}markAsDisposed(d){if(d&&d!==t.None)try{d[O]=!0}catch{}}markAsSingleton(d){}})}function l(O){return h?.trackDisposable(O),O}function P(O){h?.markAsDisposed(O)}function a(O,d){h?.setParent(O,d)}function c(O,d){if(h)for(const I of O)h.setParent(I,d)}function g(O){return h?.markAsSingleton(O),O}function f(O){return typeof O=="object"&&O!==null&&typeof O.dispose=="function"&&O.dispose.length===0}function s(O){if(j.Iterable.is(O)){const d=[];for(const I of O)if(I)try{I.dispose()}catch(w){d.push(w)}if(d.length===1)throw d[0];if(d.length>1)throw new AggregateError(d,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}function n(O){for(const d of O)f(d)&&d.dispose();return[]}function $(...O){const d=v(()=>s(O));return c(O,d),d}function v(O){const d=l({dispose:(0,A.$db)(()=>{P(d),O()})});return d}class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,l(this)}dispose(){this.g||(P(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{s(this.f)}finally{this.f.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return a(d,this),this.g?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(d),d}delete(d){if(d){if(d===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(d),d.dispose()}}deleteAndLeak(d){d&&this.f.has(d)&&(this.f.delete(d),a(d,null))}}e.$Tc=i;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new i,l(this),a(this.q,this)}dispose(){P(this),this.q.dispose()}B(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(d)}}e.$Uc=t;class o{constructor(){this.b=!1,l(this)}get value(){return this.b?void 0:this.a}set value(d){this.b||d===this.a||(this.a?.dispose(),d&&a(d,this),this.a=d)}clear(){this.value=void 0}dispose(){this.b=!0,P(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const d=this.a;return this.a=void 0,d&&a(d,null),d}}e.$Vc=o;class L{constructor(d){this.a=new o,this.b=!1,this.a.value=d}get value(){return this.a.value}set value(d){this.b||d===this.a.value||(this.a.value=d)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=L;class m{constructor(d){this.b=d,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=m;class M{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,l(this)}set(d){let I=d;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,P(this))},this}}e.$Yc=M;class C{constructor(){this.a=new Map}acquire(d,...I){let w=this.a.get(d);w||(w={counter:0,object:this.b(d,...I)},this.a.set(d,w));const{object:D}=w,Y=(0,A.$db)(()=>{--w.counter===0&&(this.c(d,w.object),this.a.delete(d))});return w.counter++,{object:D,dispose:Y}}}e.$Zc=C;class b{constructor(d){this.a=d}async acquire(d,...I){const w=this.a.acquire(d,...I);try{return{object:await w.object,dispose:()=>w.dispose()}}catch(D){throw w.dispose(),D}}}e.$1c=b;class U{constructor(d){this.object=d}dispose(){}}e.$2c=U;function K(O){const d=new i;try{O(d)}finally{d.dispose()}}class F{constructor(){this.a=new Map,this.b=!1,l(this)}dispose(){P(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{s(this.a.values())}finally{this.a.clear()}}has(d){return this.a.has(d)}get size(){return this.a.size}get(d){return this.a.get(d)}set(d,I,w=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),w||this.a.get(d)?.dispose(),this.a.set(d,I)}deleteAndDispose(d){this.a.get(d)?.dispose(),this.a.delete(d)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=F}),define(fe[45],ge([0,1,25]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=void 0,e.$dm=E,e.$em=j;const S=new y.$Dc(1e4);function E(r){return h(r,"NFC",S)}const A=new y.$Dc(1e4);function j(r){return h(r,"NFD",A)}const k=/[^\u0000-\u0080]/;function h(r,p,l){if(!r)return r;const P=l.get(r);if(P)return P;let a;return k.test(r)?a=r.normalize(p):a=r,l.set(r,a),a}e.$fm=function(){const r=/[\u0300-\u036f]/g;return function(p){return j(p).replace(r,"")}}()}),function(){function ae(E){const A=[];typeof E=="number"&&A.push("code/timeOrigin",E);function j(h){A.push(h,Date.now())}function k(){const h=[];for(let r=0;r<A.length;r+=2)h.push({name:A[r],startTime:A[r+1]});return h}return{mark:j,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ae():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const j of performance.getEntriesByType("mark"))A.push({name:j.name,startTime:Math.round(E+j.startTime)});return A}};if(typeof process=="object"){const E=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ae(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),ae()}function y(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var S;typeof global=="object"?S=global:typeof self=="object"?S=self:S={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(S)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(S):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),S.perf=y(S))}(),define(fe[46],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class S{static create(A){return new S(A)}constructor(A){this.c=y&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=S}),define(fe[4],ge([0,1,7,29,2,44,46]),function(ae,e,y,S,E,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=a;const k=!1,h=!1,r=!1;var p;(function(I){I.None=()=>E.$Uc.None;function w(se){if(r){const{onDidAddListener:he}=se,$e=g.create();let we=0;se.onDidAddListener=()=>{++we===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),he?.()}}}function D(se,he){return _(se,()=>{},0,void 0,!0,void 0,he)}I.defer=D;function Y(se){return(he,$e=null,we)=>{let pe=!1,ve;return ve=se(Ee=>{if(!pe)return ve?ve.dispose():pe=!0,he.call($e,Ee)},null,we),pe&&ve.dispose(),ve}}I.once=Y;function te(se,he,$e){return q((we,pe=null,ve)=>se(Ee=>we.call(pe,he(Ee)),null,ve),$e)}I.map=te;function V(se,he,$e){return q((we,pe=null,ve)=>se(Ee=>{he(Ee),we.call(pe,Ee)},null,ve),$e)}I.forEach=V;function ee(se,he,$e){return q((we,pe=null,ve)=>se(Ee=>he(Ee)&&we.call(pe,Ee),null,ve),$e)}I.filter=ee;function oe(se){return se}I.signal=oe;function ue(...se){return(he,$e=null,we)=>{const pe=(0,E.$Rc)(...se.map(ve=>ve(Ee=>he.call($e,Ee))));return Z(pe,we)}}I.any=ue;function X(se,he,$e,we){let pe=$e;return te(se,ve=>(pe=he(pe,ve),pe),we)}I.reduce=X;function q(se,he){let $e;const we={onWillAddFirstListener(){$e=se(pe.fire,pe)},onDidRemoveLastListener(){$e?.dispose()}};he||w(we);const pe=new i(we);return he?.add(pe),pe.event}function Z(se,he){return he instanceof Array?he.push(se):he&&he.add(se),se}function _(se,he,$e=100,we=!1,pe=!1,ve,Ee){let Pe,ke,je,Ue=0,Ne;const De={leakWarningThreshold:ve,onWillAddFirstListener(){Pe=se(We=>{Ue++,ke=he(ke,We),we&&!je&&(Fe.fire(ke),ke=void 0),Ne=()=>{const He=ke;ke=void 0,je=void 0,(!we||Ue>1)&&Fe.fire(He),Ue=0},typeof $e=="number"?(clearTimeout(je),je=setTimeout(Ne,$e)):je===void 0&&(je=0,queueMicrotask(Ne))})},onWillRemoveListener(){pe&&Ue>0&&Ne?.()},onDidRemoveLastListener(){Ne=void 0,Pe.dispose()}};Ee||w(De);const Fe=new i(De);return Ee?.add(Fe),Fe.event}I.debounce=_;function de(se,he=0,$e){return I.debounce(se,(we,pe)=>we?(we.push(pe),we):[pe],he,void 0,!0,void 0,$e)}I.accumulate=de;function B(se,he=(we,pe)=>we===pe,$e){let we=!0,pe;return ee(se,ve=>{const Ee=we||!he(ve,pe);return we=!1,pe=ve,Ee},$e)}I.latch=B;function le(se,he,$e){return[I.filter(se,he,$e),I.filter(se,we=>!he(we),$e)]}I.split=le;function x(se,he=!1,$e=[],we){let pe=$e.slice(),ve=se(ke=>{pe?pe.push(ke):Pe.fire(ke)});we&&we.add(ve);const Ee=()=>{pe?.forEach(ke=>Pe.fire(ke)),pe=null},Pe=new i({onWillAddFirstListener(){ve||(ve=se(ke=>Pe.fire(ke)),we&&we.add(ve))},onDidAddFirstListener(){pe&&(he?setTimeout(Ee):Ee())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return we&&we.add(Pe),Pe.event}I.buffer=x;function u(se,he){return(we,pe,ve)=>{const Ee=he(new ne);return se(function(Pe){const ke=Ee.evaluate(Pe);ke!==z&&we.call(pe,ke)},void 0,ve)}}I.chain=u;const z=Symbol("HaltChainable");class ne{constructor(){this.f=[]}map(he){return this.f.push(he),this}forEach(he){return this.f.push($e=>(he($e),$e)),this}filter(he){return this.f.push($e=>he($e)?$e:z),this}reduce(he,$e){let we=$e;return this.f.push(pe=>(we=he(we,pe),we)),this}latch(he=($e,we)=>$e===we){let $e=!0,we;return this.f.push(pe=>{const ve=$e||!he(pe,we);return $e=!1,we=pe,ve?pe:z}),this}evaluate(he){for(const $e of this.f)if(he=$e(he),he===z)break;return he}}function N(se,he,$e=we=>we){const we=(...Pe)=>Ee.fire($e(...Pe)),pe=()=>se.on(he,we),ve=()=>se.removeListener(he,we),Ee=new i({onWillAddFirstListener:pe,onDidRemoveLastListener:ve});return Ee.event}I.fromNodeEventEmitter=N;function G(se,he,$e=we=>we){const we=(...Pe)=>Ee.fire($e(...Pe)),pe=()=>se.addEventListener(he,we),ve=()=>se.removeEventListener(he,we),Ee=new i({onWillAddFirstListener:pe,onDidRemoveLastListener:ve});return Ee.event}I.fromDOMEventEmitter=G;function W(se){return new Promise(he=>Y(se)(he))}I.toPromise=W;function H(se){const he=new i;return se.then($e=>{he.fire($e)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}I.fromPromise=H;function R(se,he,$e){return he($e),se(we=>he(we))}I.runAndSubscribe=R;class J{constructor(he,$e){this._observable=he,this.f=0,this.g=!1;const we={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};$e||w(we),this.emitter=new i(we),$e&&$e.add(this.emitter)}beginUpdate(he){this.f++}handlePossibleChange(he){}handleChange(he,$e){this.g=!0}endUpdate(he){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ie(se,he){return new J(se,he).emitter.event}I.fromObservable=ie;function ce(se){return(he,$e,we)=>{let pe=0,ve=!1;const Ee={beginUpdate(){pe++},endUpdate(){pe--,pe===0&&(se.reportChanges(),ve&&(ve=!1,he.call($e)))},handlePossibleChange(){},handleChange(){ve=!0}};se.addObserver(Ee),se.reportChanges();const Pe={dispose(){se.removeObserver(Ee)}};return we instanceof E.$Tc?we.add(Pe):Array.isArray(we)&&we.push(Pe),Pe}}I.fromObservableLight=ce})(p||(e.Event=p={}));class l{static{this.all=new Set}static{this.f=0}constructor(w){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${w}_${l.f++}`,l.all.add(this)}start(w){this.g=new j.$be,this.listenerCount=w}stop(){if(this.g){const w=this.g.elapsed();this.durations.push(w),this.elapsedOverall+=w,this.invocationCount+=1,this.g=void 0}}}e.$de=l;let P=-1;function a(I){const w=P;return P=I,{dispose(){P=w}}}class c{constructor(w,D=Math.random().toString(18).slice(2,5)){this.threshold=w,this.name=D,this.g=0}dispose(){this.f?.clear()}check(w,D){const Y=this.threshold;if(Y<=0||D<Y)return;this.f||(this.f=new Map);const te=this.f.get(w.value)||0;if(this.f.set(w.value,te+1),this.g-=1,this.g<=0){this.g=Y*.5;let V,ee=0;for(const[oe,ue]of this.f)(!V||ee<ue)&&(V=oe,ee=ue);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${ee}):`),console.warn(V)}return()=>{const V=this.f.get(w.value)||0;this.f.set(w.value,V-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(w){this.value=w}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let f=0;class s{constructor(w){this.value=w,this.id=f++}}const n=2,$=(I,w)=>{if(I instanceof s)w(I);else for(let D=0;D<I.length;D++){const Y=I[D];Y&&w(Y)}},v=k?new FinalizationRegistry(I=>{typeof I=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(I))}):void 0;class i{constructor(w){this.w=0,this.f=w,this.g=P>0||this.f?.leakWarningThreshold?new c(this.f?.leakWarningThreshold??P):void 0,this.j=this.f?._profName?new l(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(h){const w=this.t;queueMicrotask(()=>{$(w,D=>D.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(w,D,Y)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),E.$Uc.None;if(this.m)return E.$Uc.None;D&&(w=w.bind(D));const te=new s(w);let V,ee;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(te.stack=g.create(),V=this.g.check(te.stack,this.w+1)),h&&(te.stack=ee??g.create()),this.t?this.t instanceof s?(this.u??=new o,this.t=[this.t,te]):this.t.push(te):(this.f?.onWillAddFirstListener?.(this),this.t=te,this.f?.onDidAddFirstListener?.(this)),this.w++;const oe=(0,E.$Sc)(()=>{v?.unregister(oe),V?.(),this.x(te)});if(Y instanceof E.$Tc?Y.add(oe):Array.isArray(Y)&&Y.push(oe),v){const ue=new Error().stack.split(`
`).slice(2).join(`
`).trim();v.register(oe,ue,oe)}return oe},this.q}x(w){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const D=this.t,Y=D.indexOf(w);if(Y===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,D[Y]=void 0;const te=this.u.current===this;if(this.w*n<=D.length){let V=0;for(let ee=0;ee<D.length;ee++)D[ee]?D[V++]=D[ee]:te&&(this.u.end--,V<this.u.i&&this.u.i--);D.length=V}}y(w,D){if(!w)return;const Y=this.f?.onListenerError||y.$1;if(!Y){w.value(D);return}try{w.value(D)}catch(te){Y(te)}}z(w){const D=w.current.t;for(;w.i<w.end;)this.y(D[w.i++],w.value);w.reset()}fire(w){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof s)this.y(this.t,w);else{const D=this.u;D.enqueue(this,w,this.t.length),this.z(D)}this.j?.stop()}hasListeners(){return this.w>0}}e.$fe=i;const t=()=>new o;e.$ge=t;class o{constructor(){this.i=-1,this.end=0}enqueue(w,D,Y){this.i=0,this.end=Y,this.current=w,this.value=D}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class L extends i{async fireAsync(w,D,Y){if(this.t)for(this.h||(this.h=new A.$5c),$(this.t,te=>this.h.push([te.value,w]));this.h.size>0&&!D.isCancellationRequested;){const[te,V]=this.h.shift(),ee=[],oe={...V,token:D,waitUntil:ue=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");Y&&(ue=Y(ue,te)),ee.push(ue)}};try{te(oe)}catch(ue){(0,y.$1)(ue);continue}Object.freeze(ee),await Promise.allSettled(ee).then(ue=>{for(const X of ue)X.status==="rejected"&&(0,y.$1)(X.reason)})}}}e.$he=L;class m extends i{get isPaused(){return this.h!==0}constructor(w){super(w),this.h=0,this.s=new A.$5c,this.A=w?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const w=Array.from(this.s);this.s.clear(),super.fire(this.A(w))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(w){this.w&&(this.h!==0?this.s.push(w):super.fire(w))}}e.$ie=m;class M extends m{constructor(w){super(w),this.k=w.delay??100}fire(w){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(w)}}e.$je=M;class C extends i{constructor(w){super(w),this.h=[],this.k=w?.merge}fire(w){this.hasListeners()&&(this.h.push(w),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(D=>super.fire(D)),this.h=[]}))}}e.$ke=C;class b{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(w){const D={event:w,listener:null};this.h.push(D),this.g&&this.m(D);const Y=()=>{this.g&&this.o(D);const te=this.h.indexOf(D);this.h.splice(te,1)};return(0,E.$Sc)((0,S.$db)(Y))}j(){this.g=!0,this.h.forEach(w=>this.m(w))}k(){this.g=!1,this.h.forEach(w=>this.o(w))}m(w){w.listener=w.event(D=>this.f.fire(D))}o(w){w.listener?.dispose(),w.listener=null}dispose(){this.f.dispose();for(const w of this.h)w.listener?.dispose();this.h=[]}}e.$le=b;class U{constructor(w,D,Y,te){this.f=new E.$Tc;const V=this.f.add(new b),ee=this.f.add(new E.$4c);function oe(ue){ee.set(ue,V.add(te(ue)))}for(const ue of w)oe(ue);this.f.add(D(ue=>{oe(ue)})),this.f.add(Y(ue=>{ee.deleteAndDispose(ue)})),this.event=V.event}dispose(){this.f.dispose()}}e.$me=U;class K{constructor(){this.f=[]}wrapEvent(w,D,Y){return(te,V,ee)=>w(oe=>{const ue=this.f[this.f.length-1];if(!D){ue?ue.buffers.push(()=>te.call(V,oe)):te.call(V,oe);return}const X=ue;if(!X){te.call(V,D(Y,oe));return}X.items??=[],X.items.push(oe),X.buffers.length===0&&ue.buffers.push(()=>{X.reducedResult??=Y?X.items.reduce(D,Y):X.items.reduce(D),te.call(V,X.reducedResult)})},void 0,ee)}bufferEvents(w){const D={buffers:new Array};this.f.push(D);const Y=w();return this.f.pop(),D.buffers.forEach(te=>te()),Y}}e.$ne=K;class F{constructor(){this.f=!1,this.g=p.None,this.h=E.$Uc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(w){this.g=w,this.f&&(this.h.dispose(),this.h=w(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$oe=F;class O{static const(w){return new d(w)}constructor(w){this.g=w,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(w){w!==this.g&&(this.g=w,this.f.fire(void 0))}}e.$pe=O;class d{constructor(w){this.value=w,this.onDidChange=p.None}}}),define(fe[17],ge([0,1,4]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=e.CancellationToken=void 0,e.$re=k;const S=Object.freeze(function(h,r){const p=setTimeout(h.bind(r),0);return{dispose(){clearTimeout(p)}}});var E;(function(h){function r(p){return p===h.None||p===h.Cancelled||p instanceof A?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}h.isCancellationToken=r,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:S})})(E||(e.CancellationToken=E={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?S:(this.b||(this.b=new y.$fe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class j{constructor(r){this.f=void 0,this.g=void 0,this.g=r&&r.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=E.Cancelled}dispose(r=!1){r&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=E.None}}e.$qe=j;function k(h){const r=new j;return h.add({dispose(){r.cancel()}}),r.token}}),define(fe[47],ge([0,1,17]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6e=e.$5e=e.$3e=void 0,e.$4e=E;class S{constructor(h){this.b=h,this.a=null}get(){if(this.a)return this.a;const h=new y.$qe,r=this.b(h.token);return this.a={promise:r,dispose:()=>{this.a=null,h.cancel(),h.dispose()}},this.a}}e.$3e=S;function E(k){return k}class A{constructor(h,r){this.a=void 0,this.b=void 0,typeof h=="function"?(this.c=h,this.d=E):(this.c=r,this.d=h.getCacheKey)}get(h){const r=this.d(h);return this.b!==r&&(this.b=r,this.a=this.c(h)),this.a}}e.$5e=A;class j{get cachedValues(){return this.a}constructor(h,r){this.a=new Map,this.b=new Map,typeof h=="function"?(this.c=h,this.d=E):(this.c=r,this.d=h.getCacheKey)}get(h){const r=this.d(h);if(this.b.has(r))return this.b.get(r);const p=this.c(h);return this.a.set(h,p),this.b.set(r,p),p}}e.$6e=j}),define(fe[48],ge([0,1,7,2]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=E,e.$te=A,e.$ue=j,e.$ve=k,e.$we=r,e.$xe=p,e.$ye=l,e.$ze=P,e.$Ae=a,e.$Be=c,e.$Ce=g,e.$De=f,e.$Ee=s,e.$Fe=n,e.$Ge=$;function E(v){const i=v;return i?typeof i.read=="function":!1}function A(v){const i=v;return i?[i.on,i.pause,i.resume,i.destroy].every(t=>typeof t=="function"):!1}function j(v){const i=v;return i?A(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function k(v,i){return new h(v,i)}class h{constructor(i,t){this.e=i,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(t=>t(i))}h(i){this.c.error.length===0?(0,y.$1)(i):this.c.error.slice(0).forEach(t=>t(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,t){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(i,t){if(this.a.destroyed)return;let o;switch(i){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const L=o.indexOf(t);L>=0&&o.splice(L,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function r(v,i){const t=[];let o;for(;(o=v.read())!==null;)t.push(o);return i(t)}function p(v,i,t){const o=[];let L;for(;(L=v.read())!==null&&o.length<t;)o.push(L);return L===null&&o.length>0?i(o):{read:()=>{if(o.length>0)return o.shift();if(typeof L<"u"){const m=L;return L=void 0,m}return v.read()}}}function l(v,i){return new Promise((t,o)=>{const L=[];P(v,{onData:m=>{i&&L.push(m)},onError:m=>{i?o(m):t(void 0)},onEnd:()=>{t(i?i(L):void 0)}})})}function P(v,i,t){v.on("error",o=>{t?.isCancellationRequested||i.onError(o)}),v.on("end",()=>{t?.isCancellationRequested||i.onEnd()}),v.on("data",o=>{t?.isCancellationRequested||i.onData(o)})}function a(v,i){return new Promise((t,o)=>{const L=new S.$Tc,m=[],M=U=>{if(m.push(U),m.length>i)return L.dispose(),v.pause(),t({stream:v,buffer:m,ended:!1})},C=U=>(L.dispose(),o(U)),b=()=>(L.dispose(),t({stream:v,buffer:m,ended:!0}));L.add((0,S.$Sc)(()=>v.removeListener("error",C))),v.on("error",C),L.add((0,S.$Sc)(()=>v.removeListener("end",b))),v.on("end",b),L.add((0,S.$Sc)(()=>v.removeListener("data",M))),v.on("data",M)})}function c(v,i){const t=k(i);return t.end(v),t}function g(){const v=k(()=>{throw new Error("not supported")});return v.end(),v}function f(v){let i=!1;return{read:()=>i?null:(i=!0,v)}}function s(v,i,t){const o=k(t);return P(v,{onData:L=>o.write(i.data(L)),onError:L=>o.error(i.error?i.error(L):L),onEnd:()=>o.end()}),o}function n(v,i,t){let o=!1;return{read:()=>{const L=i.read();return o?L:(o=!0,L!==null?t([v,L]):v)}}}function $(v,i,t){let o=!1;const L=k(t);return P(i,{onData:m=>o?L.write(m):(o=!0,L.write(t([v,m]))),onError:m=>L.error(m),onEnd:()=>{o||(o=!0,L.write(v)),L.end()}}),L}}),define(fe[18],ge([0,1,22,48]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=void 0,e.$Ie=r,e.$Je=p,e.$Ke=l,e.$Le=P,e.$Me=a,e.$Ne=c,e.$Oe=g,e.$Pe=f,e.$Qe=s,e.$Re=n,e.$Se=$,e.$Te=v,e.$Ue=i,e.$Ve=t,e.$We=o,e.$Xe=L,e.$Ye=m,e.$Ze=M,e.$1e=C,e.$2e=K;const E=typeof Buffer<"u",A=new y.$V(()=>new Uint8Array(256));let j,k;class h{static alloc(O){return E?new h(Buffer.allocUnsafe(O)):new h(new Uint8Array(O))}static wrap(O){return E&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new h(O)}static fromString(O,d){return!(d?.dontUseNodeBuffer||!1)&&E?new h(Buffer.from(O)):(j||(j=new TextEncoder),new h(j.encode(O)))}static fromByteArray(O){const d=h.alloc(O.length);for(let I=0,w=O.length;I<w;I++)d.buffer[I]=O[I];return d}static concat(O,d){if(typeof d>"u"){d=0;for(let D=0,Y=O.length;D<Y;D++)d+=O[D].byteLength}const I=h.alloc(d);let w=0;for(let D=0,Y=O.length;D<Y;D++){const te=O[D];I.set(te,w),w+=te.byteLength}return I}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=h.alloc(this.byteLength);return O.set(this),O}toString(){return E?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(O,d){return new h(this.buffer.subarray(O,d))}set(O,d){if(O instanceof h)this.buffer.set(O.buffer,d);else if(O instanceof Uint8Array)this.buffer.set(O,d);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),d);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return P(this.buffer,O)}writeUInt32BE(O,d){a(this.buffer,O,d)}readUInt32LE(O){return c(this.buffer,O)}writeUInt32LE(O,d){g(this.buffer,O,d)}readUInt8(O){return f(this.buffer,O)}writeUInt8(O,d){s(this.buffer,O,d)}indexOf(O,d=0){return r(this.buffer,O instanceof h?O.buffer:O,d)}}e.$He=h;function r(F,O,d=0){const I=O.byteLength,w=F.byteLength;if(I===0)return 0;if(I===1)return F.indexOf(O[0]);if(I>w-d)return-1;const D=A.value;D.fill(O.length);for(let ee=0;ee<O.length;ee++)D[O[ee]]=O.length-ee-1;let Y=d+O.length-1,te=Y,V=-1;for(;Y<w;)if(F[Y]===O[te]){if(te===0){V=Y;break}Y--,te--}else Y+=Math.max(O.length-te,D[F[Y]]),te=O.length-1;return V}function p(F,O){return F[O+0]<<0>>>0|F[O+1]<<8>>>0}function l(F,O,d){F[d+0]=O&255,O=O>>>8,F[d+1]=O&255}function P(F,O){return F[O]*2**24+F[O+1]*2**16+F[O+2]*2**8+F[O+3]}function a(F,O,d){F[d+3]=O,O=O>>>8,F[d+2]=O,O=O>>>8,F[d+1]=O,O=O>>>8,F[d]=O}function c(F,O){return F[O+0]<<0>>>0|F[O+1]<<8>>>0|F[O+2]<<16>>>0|F[O+3]<<24>>>0}function g(F,O,d){F[d+0]=O&255,O=O>>>8,F[d+1]=O&255,O=O>>>8,F[d+2]=O&255,O=O>>>8,F[d+3]=O&255}function f(F,O){return F[O]}function s(F,O,d){F[d]=O}function n(F){return S.$we(F,O=>h.concat(O))}function $(F){return S.$De(F)}function v(F){return S.$ye(F,O=>h.concat(O))}async function i(F){return F.ended?h.concat(F.buffer):h.concat([...F.buffer,await v(F.stream)])}function t(F){return S.$Be(F,O=>h.concat(O))}function o(F){return S.$Ee(F,{data:O=>typeof O=="string"?h.fromString(O):h.wrap(O)},O=>h.concat(O))}function L(F){return S.$ve(O=>h.concat(O),F)}function m(F,O){return S.$Fe(F,O,d=>h.concat(d))}function M(F,O){return S.$Ge(F,O,d=>h.concat(d))}function C(F){let O=0,d=0,I=0;const w=new Uint8Array(Math.floor(F.length/4*3)),D=te=>{switch(d){case 3:w[I++]=O|te,d=0;break;case 2:w[I++]=O|te>>>2,O=te<<6,d=3;break;case 1:w[I++]=O|te>>>4,O=te<<4,d=2;break;default:O=te<<2,d=1}};for(let te=0;te<F.length;te++){const V=F.charCodeAt(te);if(V>=65&&V<=90)D(V-65);else if(V>=97&&V<=122)D(V-97+26);else if(V>=48&&V<=57)D(V-48+52);else if(V===43||V===45)D(62);else if(V===47||V===95)D(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${F[te]}`)}}const Y=I;for(;d>0;)D(0);return h.wrap(w).slice(0,Y)}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",U="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function K({buffer:F},O=!0,d=!1){const I=d?U:b;let w="";const D=F.byteLength%3;let Y=0;for(;Y<F.byteLength-D;Y+=3){const te=F[Y+0],V=F[Y+1],ee=F[Y+2];w+=I[te>>>2],w+=I[(te<<4|V>>>4)&63],w+=I[(V<<2|ee>>>6)&63],w+=I[ee&63]}if(D===1){const te=F[Y+0];w+=I[te>>>2],w+=I[te<<4&63],O&&(w+="==")}else if(D===2){const te=F[Y+0],V=F[Y+1];w+=I[te>>>2],w+=I[(te<<4|V>>>4)&63],w+=I[V<<2&63],O&&(w+="=")}return w}}),define(fe[9],ge([0,1,47,22]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.GraphemeBreakType=e.$Xf=e.$Pf=e.$If=e.$Hf=void 0,e.$9e=E,e.$0e=j,e.$$e=h,e.$_e=r,e.$af=p,e.$bf=l,e.$cf=P,e.$df=a,e.$ef=c,e.$ff=g,e.$gf=f,e.$hf=s,e.$if=n,e.$jf=$,e.$kf=v,e.$lf=i,e.$mf=t,e.$nf=o,e.$of=L,e.$pf=m,e.$qf=M,e.$rf=C,e.$sf=b,e.$tf=U,e.$uf=K,e.$vf=F,e.$wf=O,e.$xf=d,e.$yf=I,e.$zf=w,e.$Af=D,e.$Bf=Y,e.$Cf=te,e.$Df=V,e.$Ef=ee,e.$Ff=oe,e.$Gf=ue,e.$Jf=_,e.$Kf=de,e.$Lf=B,e.$Mf=le,e.$Nf=z,e.$Of=N,e.$Qf=G,e.$Rf=W,e.$Sf=H,e.$Tf=R,e.$Uf=ie,e.$Vf=ce,e.$Wf=he,e.$Yf=$e,e.$Zf=we,e.$1f=pe,e.$2f=ve,e.$3f=Ee,e.$4f=Pe,e.$5f=ke,e.$6f=je,e.$7f=We;function E(T){return!T||typeof T!="string"?!0:T.trim().length===0}const A=/{(\d+)}/g;function j(T,...Q){return Q.length===0?T:T.replace(A,function(re,me){const ye=parseInt(me,10);return isNaN(ye)||ye<0||ye>=Q.length?re:Q[ye]})}const k=/{([^}]+)}/g;function h(T,Q){return Object.keys(Q).length===0?T:T.replace(k,(re,me)=>Q[me]??re)}function r(T){return T.replace(/[<>"'&]/g,Q=>{switch(Q){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Q})}function p(T){return T.replace(/[<>&]/g,function(Q){switch(Q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Q}})}function l(T){return T.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function P(T,Q){let re=0,me=T.indexOf(Q);for(;me!==-1;)re++,me=T.indexOf(Q,me+Q.length);return re}function a(T,Q,re="\u2026"){return T.length<=Q?T:`${T.substr(0,Q)}${re}`}function c(T,Q,re="\u2026"){if(T.length<=Q)return T;const me=Math.ceil(Q/2)-re.length/2,ye=Math.floor(Q/2)-re.length/2;return`${T.substr(0,me)}${re}${T.substr(T.length-ye)}`}function g(T,Q=" "){const re=f(T,Q);return s(re,Q)}function f(T,Q){if(!T||!Q)return T;const re=Q.length;if(re===0||T.length===0)return T;let me=0;for(;T.indexOf(Q,me)===me;)me=me+re;return T.substring(me)}function s(T,Q){if(!T||!Q)return T;const re=Q.length,me=T.length;if(re===0||me===0)return T;let ye=me,Ce=-1;for(;Ce=T.lastIndexOf(Q,ye-1),!(Ce===-1||Ce+re!==ye);){if(Ce===0)return"";ye=Ce}return T.substring(0,ye)}function n(T){return T.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function $(T){return T.replace(/\*/g,"")}function v(T,Q,re={}){if(!T)throw new Error("Cannot create regex from empty string");Q||(T=l(T)),re.wholeWord&&(/\B/.test(T.charAt(0))||(T="\\b"+T),/\B/.test(T.charAt(T.length-1))||(T=T+"\\b"));let me="";return re.global&&(me+="g"),re.matchCase||(me+="i"),re.multiline&&(me+="m"),re.unicode&&(me+="u"),new RegExp(T,me)}function i(T){return T.source==="^"||T.source==="^$"||T.source==="$"||T.source==="^\\s*$"?!1:!!(T.exec("")&&T.lastIndex===0)}function t(T){return T.split(/\r\n|\r|\n/)}function o(T){const Q=[],re=T.split(/(\r\n|\r|\n)/);for(let me=0;me<Math.ceil(re.length/2);me++)Q.push(re[2*me]+(re[2*me+1]??""));return Q}function L(T){for(let Q=0,re=T.length;Q<re;Q++){const me=T.charCodeAt(Q);if(me!==32&&me!==9)return Q}return-1}function m(T,Q=0,re=T.length){for(let me=Q;me<re;me++){const ye=T.charCodeAt(me);if(ye!==32&&ye!==9)return T.substring(Q,me)}return T.substring(Q,re)}function M(T,Q=T.length-1){for(let re=Q;re>=0;re--){const me=T.charCodeAt(re);if(me!==32&&me!==9)return re}return-1}function C(T,Q,re){const me=[];let ye=0;for(const Ce of T.matchAll(Q)){if(me.push(T.slice(ye,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");ye=Ce.index+Ce[0].length,me.push(re(Ce[0],...Ce.slice(1),Ce.index,T,Ce.groups))}return me.push(T.slice(ye)),Promise.all(me).then(Ce=>Ce.join(""))}function b(T,Q){return T<Q?-1:T>Q?1:0}function U(T,Q,re=0,me=T.length,ye=0,Ce=Q.length){for(;re<me&&ye<Ce;re++,ye++){const Me=T.charCodeAt(re),Ae=Q.charCodeAt(ye);if(Me<Ae)return-1;if(Me>Ae)return 1}const Le=me-re,Oe=Ce-ye;return Le<Oe?-1:Le>Oe?1:0}function K(T,Q){return F(T,Q,0,T.length,0,Q.length)}function F(T,Q,re=0,me=T.length,ye=0,Ce=Q.length){for(;re<me&&ye<Ce;re++,ye++){let Me=T.charCodeAt(re),Ae=Q.charCodeAt(ye);if(Me===Ae)continue;if(Me>=128||Ae>=128)return U(T.toLowerCase(),Q.toLowerCase(),re,me,ye,Ce);d(Me)&&(Me-=32),d(Ae)&&(Ae-=32);const Se=Me-Ae;if(Se!==0)return Se}const Le=me-re,Oe=Ce-ye;return Le<Oe?-1:Le>Oe?1:0}function O(T){return T>=48&&T<=57}function d(T){return T>=97&&T<=122}function I(T){return T>=65&&T<=90}function w(T,Q){return T.length===Q.length&&F(T,Q)===0}function D(T,Q){const re=Q.length;return Q.length>T.length?!1:F(T,Q,0,re)===0}function Y(T,Q){const re=Math.min(T.length,Q.length);let me;for(me=0;me<re;me++)if(T.charCodeAt(me)!==Q.charCodeAt(me))return me;return re}function te(T,Q){const re=Math.min(T.length,Q.length);let me;const ye=T.length-1,Ce=Q.length-1;for(me=0;me<re;me++)if(T.charCodeAt(ye-me)!==Q.charCodeAt(Ce-me))return me;return re}function V(T){return 55296<=T&&T<=56319}function ee(T){return 56320<=T&&T<=57343}function oe(T,Q){return(T-55296<<10)+(Q-56320)+65536}function ue(T,Q,re){const me=T.charCodeAt(re);if(V(me)&&re+1<Q){const ye=T.charCodeAt(re+1);if(ee(ye))return oe(me,ye)}return me}function X(T,Q){const re=T.charCodeAt(Q-1);if(ee(re)&&Q>1){const me=T.charCodeAt(Q-2);if(V(me))return oe(me,re)}return re}class q{get offset(){return this.e}constructor(Q,re=0){this.c=Q,this.d=Q.length,this.e=re}setOffset(Q){this.e=Q}prevCodePoint(){const Q=X(this.c,this.e);return this.e-=Q>=65536?2:1,Q}nextCodePoint(){const Q=ue(this.c,this.d,this.e);return this.e+=Q>=65536?2:1,Q}eol(){return this.e>=this.d}}e.$Hf=q;class Z{get offset(){return this.c.offset}constructor(Q,re=0){this.c=new q(Q,re)}nextGraphemeLength(){const Q=De.getInstance(),re=this.c,me=re.offset;let ye=Q.getGraphemeBreakType(re.nextCodePoint());for(;!re.eol();){const Ce=re.offset,Le=Q.getGraphemeBreakType(re.nextCodePoint());if(Ue(ye,Le)){re.setOffset(Ce);break}ye=Le}return re.offset-me}prevGraphemeLength(){const Q=De.getInstance(),re=this.c,me=re.offset;let ye=Q.getGraphemeBreakType(re.prevCodePoint());for(;re.offset>0;){const Ce=re.offset,Le=Q.getGraphemeBreakType(re.prevCodePoint());if(Ue(Le,ye)){re.setOffset(Ce);break}ye=Le}return me-re.offset}eol(){return this.c.eol()}}e.$If=Z;function _(T,Q){return new Z(T,Q).nextGraphemeLength()}function de(T,Q){return new Z(T,Q).prevGraphemeLength()}function B(T,Q){Q>0&&ee(T.charCodeAt(Q))&&Q--;const re=Q+_(T,Q);return[re-de(T,re),re]}function le(T){const Q=new Z(T);let re=0;for(;!Q.eol();)re++,Q.nextGraphemeLength();return re}let x;function u(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function z(T){return x||(x=u()),x.test(T)}const ne=/^[\t\n\r\x20-\x7E]*$/;function N(T){return ne.test(T)}e.$Pf=/[\u2028\u2029]/;function G(T){return e.$Pf.test(T)}function W(T){return T>=11904&&T<=55215||T>=63744&&T<=64255||T>=65281&&T<=65374}function H(T){return T>=127462&&T<=127487||T===8986||T===8987||T===9200||T===9203||T>=9728&&T<=10175||T===11088||T===11093||T>=127744&&T<=128591||T>=128640&&T<=128764||T>=128992&&T<=129008||T>=129280&&T<=129535||T>=129648&&T<=129782}function R(T,Q,re=""){const me=T.trimStart();if(me.length<Q)return me;const ye=/\b/g;let Ce=0;for(;ye.test(me)&&!(me.length-ye.lastIndex<Q);)Ce=ye.lastIndex,ye.lastIndex+=1;return Ce===0?me:re+me.substring(Ce).trimStart()}const J=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ie(T){let Q=0;for(const re of T.matchAll(J))Q!==re.index&&(yield{isCode:!1,str:T.substring(Q,re.index)}),yield{isCode:!0,str:re[0]},Q=re.index+re[0].length;Q!==T.length&&(yield{isCode:!1,str:T.substring(Q)})}function ce(T){return T&&(T=T.replace(J,"")),T}const se=/\\\[.*?\\\]/g;function he(T){return ce(T).replace(se,"")}e.$Xf="\uFEFF";function $e(T){return!!(T&&T.length>0&&T.charCodeAt(0)===65279)}function we(T){return $e(T)?T.substr(1):T}function pe(T,Q){if(!T||!Q||T.length<Q.length)return!1;const re=Q.length,me=T.toLowerCase();let ye=0,Ce=-1;for(;ye<re;){const Le=me.indexOf(Q[ye],Ce+1);if(Le<0)return!1;Ce=Le,ye++}return!0}function ve(T,Q=!1){return T?(Q&&(T=T.replace(/\\./g,"")),T.toLowerCase()!==T):!1}function Ee(T){return T.charAt(0).toUpperCase()+T.slice(1)}function Pe(T,Q=1){if(Q===0)return"";let re=-1;do re=T.indexOf(`
`,re+1),Q--;while(Q>0&&re>=0);return re===-1?T:(T[re-1]==="\r"&&re--,T.substr(0,re))}function ke(T){return T=T%(2*26),T<26?String.fromCharCode(97+T):String.fromCharCode(65+T-26)}function je(T){return De.getInstance().getGraphemeBreakType(T)}function Ue(T,Q){return T===0?Q!==5&&Q!==7:T===2&&Q===3?!1:T===4||T===2||T===3||Q===4||Q===2||Q===3?!0:!(T===8&&(Q===8||Q===9||Q===11||Q===12)||(T===11||T===9)&&(Q===9||Q===10)||(T===12||T===10)&&Q===10||Q===5||Q===13||Q===7||T===1||T===13&&Q===14||T===6&&Q===6)}var Ne;(function(T){T[T.Other=0]="Other",T[T.Prepend=1]="Prepend",T[T.CR=2]="CR",T[T.LF=3]="LF",T[T.Control=4]="Control",T[T.Extend=5]="Extend",T[T.Regional_Indicator=6]="Regional_Indicator",T[T.SpacingMark=7]="SpacingMark",T[T.L=8]="L",T[T.V=9]="V",T[T.T=10]="T",T[T.LV=11]="LV",T[T.LVT=12]="LVT",T[T.ZWJ=13]="ZWJ",T[T.Extended_Pictographic=14]="Extended_Pictographic"})(Ne||(e.GraphemeBreakType=Ne={}));class De{static{this.c=null}static getInstance(){return De.c||(De.c=new De),De.c}constructor(){this.d=Fe()}getGraphemeBreakType(Q){if(Q<32)return Q===10?3:Q===13?2:4;if(Q<127)return 0;const re=this.d,me=re.length/3;let ye=1;for(;ye<=me;)if(Q<re[3*ye])ye=2*ye;else if(Q>re[3*ye+1])ye=2*ye+1;else return re[3*ye+2];return 0}}function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(T,Q){if(T===0)return 0;const re=He(T,Q);if(re!==void 0)return re;const me=new q(Q,T);return me.prevCodePoint(),me.offset}function He(T,Q){const re=new q(Q,T);let me=re.prevCodePoint();for(;Xe(me)||me===65039||me===8419;){if(re.offset===0)return;me=re.prevCodePoint()}if(!H(me))return;let ye=re.offset;return ye>0&&re.prevCodePoint()===8205&&(ye=re.offset),ye}function Xe(T){return 127995<=T&&T<=127999}var Ge;(function(T){T[T.zwj=8205]="zwj",T[T.emojiVariantSelector=65039]="emojiVariantSelector",T[T.enclosingKeyCap=8419]="enclosingKeyCap"})(Ge||(Ge={})),e.$8f="\xA0";class Te{static{this.c=new S.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new y.$5e({getCacheKey:JSON.stringify},Q=>{function re(Se){const Re=new Map;for(let Ie=0;Ie<Se.length;Ie+=2)Re.set(Se[Ie],Se[Ie+1]);return Re}function me(Se,Re){const Ie=new Map(Se);for(const[qe,Ve]of Re)Ie.set(qe,Ve);return Ie}function ye(Se,Re){if(!Se)return Re;const Ie=new Map;for(const[qe,Ve]of Se)Re.has(qe)&&Ie.set(qe,Ve);return Ie}const Ce=this.c.value;let Le=Q.filter(Se=>!Se.startsWith("_")&&Se in Ce);Le.length===0&&(Le=["_default"]);let Oe;for(const Se of Le){const Re=re(Ce[Se]);Oe=ye(Oe,Re)}const Me=re(Ce._common),Ae=me(Me,Oe);return new Te(Ae)})}static getInstance(Q){return Te.d.get(Array.from(Q))}static{this.e=new S.$V(()=>Object.keys(Te.c.value).filter(Q=>!Q.startsWith("_")))}static getLocales(){return Te.e.value}constructor(Q){this.f=Q}isAmbiguous(Q){return this.f.has(Q)}getPrimaryConfusable(Q){return this.f.get(Q)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$9f=Te;class Be{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Be.c())),this.d}static isInvisibleCharacter(Q){return Be.e().has(Q)}static get codePoints(){return Be.e()}}e.$0f=Be}),define(fe[49],ge([0,1,9]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sj=e.$qj=void 0,e.$mj=S,e.$nj=E,e.$oj=A,e.$pj=k,e.$rj=g;function S(s){return E(s,0)}function E(s,n){switch(typeof s){case"object":return s===null?A(349,n):Array.isArray(s)?h(s,n):r(s,n);case"string":return k(s,n);case"boolean":return j(s,n);case"number":return A(s,n);case"undefined":return A(937,n);default:return A(617,n)}}function A(s,n){return(n<<5)-n+s|0}function j(s,n){return A(s?433:863,n)}function k(s,n){n=A(149417,n);for(let $=0,v=s.length;$<v;$++)n=A(s.charCodeAt($),n);return n}function h(s,n){return n=A(104579,n),s.reduce(($,v)=>E(v,$),n)}function r(s,n){return n=A(181387,n),Object.keys(s).sort().reduce(($,v)=>($=k(v,$),E(s[v],$)),n)}class p{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=E(n,this.g),this.g}}e.$qj=p;var l;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(l||(l={}));function P(s,n,$=32){const v=$-n,i=~((1<<v)-1);return(s<<n|(i&s)>>>v)>>>0}function a(s,n=0,$=s.byteLength,v=0){for(let i=0;i<$;i++)s[n+i]=v}function c(s,n,$="0"){for(;s.length<n;)s=$+s;return s}function g(s,n=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map($=>$.toString(16).padStart(2,"0")).join(""):c((s>>>0).toString(16),n/4)}class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const $=n.length;if($===0)return;const v=this.p;let i=this.r,t=this.u,o,L;for(t!==0?(o=t,L=-1,t=0):(o=n.charCodeAt(0),L=0);;){let m=o;if(y.$Df(o))if(L+1<$){const M=n.charCodeAt(L+1);y.$Ef(M)?(L++,m=y.$Ff(o,M)):m=65533}else{t=o;break}else y.$Ef(o)&&(m=65533);if(i=this.w(v,i,m),L++,L<$)o=n.charCodeAt(L);else break}this.r=i,this.u=t}w(n,$,v){return v<128?n[$++]=v:v<2048?(n[$++]=192|(v&1984)>>>6,n[$++]=128|(v&63)>>>0):v<65536?(n[$++]=224|(v&61440)>>>12,n[$++]=128|(v&4032)>>>6,n[$++]=128|(v&63)>>>0):(n[$++]=240|(v&1835008)>>>18,n[$++]=128|(v&258048)>>>12,n[$++]=128|(v&4032)>>>6,n[$++]=128|(v&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,a(this.p,this.r),this.r>56&&(this.y(),a(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=f.g,$=this.q;for(let b=0;b<64;b+=4)n.setUint32(b,$.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)n.setUint32(b,P(n.getUint32(b-12,!1)^n.getUint32(b-32,!1)^n.getUint32(b-56,!1)^n.getUint32(b-64,!1),1),!1);let v=this.h,i=this.l,t=this.m,o=this.n,L=this.o,m,M,C;for(let b=0;b<80;b++)b<20?(m=i&t|~i&o,M=1518500249):b<40?(m=i^t^o,M=1859775393):b<60?(m=i&t|i&o|t&o,M=2400959708):(m=i^t^o,M=3395469782),C=P(v,5)+m+L+M+n.getUint32(b*4,!1)&4294967295,L=o,o=t,t=P(i,30),i=v,v=C;this.h=this.h+v&4294967295,this.l=this.l+i&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+L&4294967295}}e.$sj=f}),define(fe[50],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(fe[51],ge([0,1,16,9]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class E{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const c=a.charCodeAt(0),g=this.b.charCodeAt(this.c);return c-g}value(){return this.b[this.c]}}e.$Ai=E;class A{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,S.$tf)(a,this.b,0,a.length,this.c,this.d):(0,S.$vf)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Bi=A;class j{constructor(a=!0,c=!0){this.f=a,this.g=c}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let c=a.length-1;c>=0;c--,this.c--){const g=this.b.charCodeAt(c);if(!(g===47||this.f&&g===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const c=this.b.charCodeAt(this.e);if(c===47||this.f&&c===92)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,S.$tf)(a,this.b,0,a.length,this.d,this.e):(0,S.$vf)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ci=j;var k;(function(P){P[P.Scheme=1]="Scheme",P[P.Authority=2]="Authority",P[P.Path=3]="Path",P[P.Query=4]="Query",P[P.Fragment=5]="Fragment"})(k||(k={}));class h{constructor(a,c){this.f=a,this.g=c,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new j(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(3)),this.g(a)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===1)return(0,S.$uf)(a,this.c.scheme);if(this.d[this.e]===2)return(0,S.$uf)(a,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(a);if(this.d[this.e]===4)return(0,S.$sf)(a,this.c.query);if(this.d[this.e]===5)return(0,S.$sf)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Di=h;class r{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(P){P[P.Left=-1]="Left",P[P.Mid=0]="Mid",P[P.Right=1]="Right"})(p||(p={}));class l{static forUris(a=()=>!1,c=()=>!1){return new l(new h(a,c))}static forPaths(a=!1){return new l(new j(void 0,!a))}static forStrings(){return new l(new E)}static forConfigKeys(){return new l(new A)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,c){if(c){const g=c.slice(0);(0,y.$Wb)(g);for(const f of g)this.set(f,a)}else{const g=a.slice(0);(0,y.$Wb)(g);for(const f of g)this.set(f[0],f[1])}}set(a,c){const g=this.b.reset(a);let f;this.c||(this.c=new r,this.c.segment=g.value());const s=[];for(f=this.c;;){const $=g.cmp(f.segment);if($>0)f.left||(f.left=new r,f.left.segment=g.value()),s.push([-1,f]),f=f.left;else if($<0)f.right||(f.right=new r,f.right.segment=g.value()),s.push([1,f]),f=f.right;else if(g.hasNext())g.next(),f.mid||(f.mid=new r,f.mid.segment=g.value()),s.push([0,f]),f=f.mid;else break}const n=f.value;f.value=c,f.key=a;for(let $=s.length-1;$>=0;$--){const v=s[$][1];v.updateHeight();const i=v.balanceFactor();if(i<-1||i>1){const t=s[$][0],o=s[$+1][0];if(t===1&&o===1)s[$][1]=v.rotateLeft();else if(t===-1&&o===-1)s[$][1]=v.rotateRight();else if(t===1&&o===-1)v.right=s[$+1][1]=s[$+1][1].rotateRight(),s[$][1]=v.rotateLeft();else if(t===-1&&o===1)v.left=s[$+1][1]=s[$+1][1].rotateLeft(),s[$][1]=v.rotateRight();else throw new Error;if($>0)switch(s[$-1][0]){case-1:s[$-1][1].left=s[$][1];break;case 1:s[$-1][1].right=s[$][1];break;case 0:s[$-1][1].mid=s[$][1];break}else this.c=s[0][1]}}return n}get(a){return this.d(a)?.value}d(a){const c=this.b.reset(a);let g=this.c;for(;g;){const f=c.cmp(g.segment);if(f>0)g=g.left;else if(f<0)g=g.right;else if(c.hasNext())c.next(),g=g.mid;else break}return g}has(a){const c=this.d(a);return!(c?.value===void 0&&c?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,c){const g=this.b.reset(a),f=[];let s=this.c;for(;s;){const n=g.cmp(s.segment);if(n>0)f.push([-1,s]),s=s.left;else if(n<0)f.push([1,s]),s=s.right;else if(g.hasNext())g.next(),f.push([0,s]),s=s.mid;else break}if(s){if(c?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const n=this.f(s.right);if(n.key){const{key:$,value:v,segment:i}=n;this.e(n.key,!1),s.key=$,s.value=v,s.segment=i}}else{const n=s.left??s.right;if(f.length>0){const[$,v]=f[f.length-1];switch($){case-1:v.left=n;break;case 0:v.mid=n;break;case 1:v.right=n;break}}else this.c=n}for(let n=f.length-1;n>=0;n--){const $=f[n][1];$.updateHeight();const v=$.balanceFactor();if(v>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),f[n][1]=$.rotateLeft()):v<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),f[n][1]=$.rotateRight()),n>0)switch(f[n-1][0]){case-1:f[n-1][1].left=f[n][1];break;case 1:f[n-1][1].right=f[n][1];break;case 0:f[n-1][1].mid=f[n][1];break}else this.c=f[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const c=this.b.reset(a);let g=this.c,f;for(;g;){const s=c.cmp(g.segment);if(s>0)g=g.left;else if(s<0)g=g.right;else if(c.hasNext())c.next(),f=g.value||f,g=g.mid;else break}return g&&g.value||f}findSuperstr(a){return this.g(a,!1)}g(a,c){const g=this.b.reset(a);let f=this.c;for(;f;){const s=g.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(g.hasNext())g.next(),f=f.mid;else return f.mid?this.h(f.mid):c?f.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[c,g]of this)a(g,c)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const c=[];return this.j(a,c),c[Symbol.iterator]()}j(a,c){a&&(a.left&&this.j(a.left,c),a.value&&c.push([a.key,a.value]),a.mid&&this.j(a.mid,c),a.right&&this.j(a.right,c))}_isBalanced(){const a=c=>{if(!c)return!0;const g=c.balanceFactor();return g<-1||g>1?!1:a(c.left)&&a(c.right)};return a(this.c)}}e.$Ei=l}),define(fe[10],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$f=y,e.$_f=S,e.$ag=E,e.$bg=A,e.$cg=j,e.$dg=k,e.$eg=h,e.$fg=r,e.$gg=p,e.$hg=l,e.$ig=P,e.$jg=a,e.$kg=c,e.$lg=f,e.$mg=s,e.$ng=n,e.$og=$,e.$pg=v;function y(i){return typeof i=="string"}function S(i){return Array.isArray(i)&&i.every(t=>y(t))}function E(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function A(i){const t=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof t}function j(i){return typeof i=="number"&&!isNaN(i)}function k(i){return!!i&&typeof i[Symbol.iterator]=="function"}function h(i){return i===!0||i===!1}function r(i){return typeof i>"u"}function p(i){return!l(i)}function l(i){return r(i)||i===null}function P(i,t){if(!i)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function a(i){if(l(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function c(...i){const t=[];for(let o=0;o<i.length;o++){const L=i[o];if(l(L))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(L)}return t}const g=Object.prototype.hasOwnProperty;function f(i){if(!E(i))return!1;for(const t in i)if(g.call(i,t))return!1;return!0}function s(i){return typeof i=="function"}function n(...i){return i.length>0&&i.every(s)}function $(i,t){const o=Math.min(i.length,t.length);for(let L=0;L<o;L++)v(i[L],t[L])}function v(i,t){if(y(t)){if(typeof i!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(s(t)){try{if(i instanceof t)return}catch{}if(!l(i)&&i.constructor===t||t.length===1&&t.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(fe[30],ge([0,1,10]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=S,e.$6n=E,e.$7n=j,e.$8n=h,e.$9n=r,e.$0n=p,e.$$n=l,e.$_n=P,e.$ao=a,e.$bo=c,e.$co=g,e.$do=f,e.$eo=s;function S(n){if(!n||typeof n!="object"||n instanceof RegExp)return n;const $=Array.isArray(n)?[]:{};return Object.entries(n).forEach(([v,i])=>{$[v]=i&&typeof i=="object"?S(i):i}),$}function E(n){if(!n||typeof n!="object")return n;const $=[n];for(;$.length>0;){const v=$.shift();Object.freeze(v);for(const i in v)if(A.call(v,i)){const t=v[i];typeof t=="object"&&!Object.isFrozen(t)&&!(0,y.$bg)(t)&&$.push(t)}}return n}const A=Object.prototype.hasOwnProperty;function j(n,$){return k(n,$,new Set)}function k(n,$,v){if((0,y.$hg)(n))return n;const i=$(n);if(typeof i<"u")return i;if(Array.isArray(n)){const t=[];for(const o of n)t.push(k(o,$,v));return t}if((0,y.$ag)(n)){if(v.has(n))throw new Error("Cannot clone recursive data-structure");v.add(n);const t={};for(const o in n)A.call(n,o)&&(t[o]=k(n[o],$,v));return v.delete(n),t}return n}function h(n,$,v=!0){return(0,y.$ag)(n)?((0,y.$ag)($)&&Object.keys($).forEach(i=>{i in n?v&&((0,y.$ag)(n[i])&&(0,y.$ag)($[i])?h(n[i],$[i],v):n[i]=$[i]):n[i]=$[i]}),n):$}function r(n,$){if(n===$)return!0;if(n==null||$===null||$===void 0||typeof n!=typeof $||typeof n!="object"||Array.isArray(n)!==Array.isArray($))return!1;let v,i;if(Array.isArray(n)){if(n.length!==$.length)return!1;for(v=0;v<n.length;v++)if(!r(n[v],$[v]))return!1}else{const t=[];for(i in n)t.push(i);t.sort();const o=[];for(i in $)o.push(i);if(o.sort(),!r(t,o))return!1;for(v=0;v<t.length;v++)if(!r(n[t[v]],$[t[v]]))return!1}return!0}function p(n){const $=new Set;return JSON.stringify(n,(v,i)=>{if((0,y.$ag)(i)||Array.isArray(i)){if($.has(i))return"[Circular]";$.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function l(n,$){const v=Object.create(null);return!n||!$||Object.keys($).forEach(t=>{const o=n[t],L=$[t];r(o,L)||(v[t]=L)}),v}function P(n,$){const v=$.toLowerCase(),i=Object.keys(n).find(t=>t.toLowerCase()===v);return i?n[i]:n[$]}function a(n,$){const v=Object.create(null);for(const[i,t]of Object.entries(n))$(i,t)&&(v[i]=t);return v}function c(n){let $=[];for(;Object.prototype!==n;)$=$.concat(Object.getOwnPropertyNames(n)),n=Object.getPrototypeOf(n);return $}function g(n){const $=[];for(const v of c(n))typeof n[v]=="function"&&$.push(v);return $}function f(n,$){const v=t=>function(){const o=Array.prototype.slice.call(arguments,0);return $(t,o)},i={};for(const t of n)i[t]=v(t);return i}function s(n,$){const v={};for(const[i,t]of Object.entries(n))v[i]=$(t,i);return v}}),define(fe[52],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=void 0,e.$Tg=S;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function S(E){return y.test(E)}e.$Ug=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(k){for(let h=0;h<k.length;h++)k[h]=Math.floor(Math.random()*256);return k};const A=new Uint8Array(16),j=[];for(let k=0;k<256;k++)j.push(k.toString(16).padStart(2,"0"));return function(){E(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let h=0,r="";return r+=j[A[h++]],r+=j[A[h++]],r+=j[A[h++]],r+=j[A[h++]],r+="-",r+=j[A[h++]],r+=j[A[h++]],r+="-",r+=j[A[h++]],r+=j[A[h++]],r+="-",r+=j[A[h++]],r+=j[A[h++]],r+="-",r+=j[A[h++]],r+=j[A[h++]],r+=j[A[h++]],r+=j[A[h++]],r+=j[A[h++]],r+=j[A[h++]],r}}()}),define(fe[31],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tW=y;function y(S){return!!S.parentPort}}),define(fe[53],ge([13,11]),function(ae,e){return ae.create("vs/base/common/date",e)}),define(fe[54],ge([0,1,53]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=r,e.$5m=p,e.$6m=l;const S=60,E=S*60,A=E*24,j=A*7,k=A*30,h=A*365;function r(P,a,c,g){typeof P!="number"&&(P=P.getTime());const f=Math.round((new Date().getTime()-P)/1e3);if(f<-30)return(0,y.localize)(0,null,r(new Date().getTime()+f*1e3,!1));if(!g&&f<30)return(0,y.localize)(1,null);let s;return f<S?(s=f,a?s===1?c?(0,y.localize)(2,null,s):(0,y.localize)(3,null,s):c?(0,y.localize)(4,null,s):(0,y.localize)(5,null,s):s===1?c?(0,y.localize)(6,null,s):(0,y.localize)(7,null,s):c?(0,y.localize)(8,null,s):(0,y.localize)(9,null,s)):f<E?(s=Math.floor(f/S),a?s===1?c?(0,y.localize)(10,null,s):(0,y.localize)(11,null,s):c?(0,y.localize)(12,null,s):(0,y.localize)(13,null,s):s===1?c?(0,y.localize)(14,null,s):(0,y.localize)(15,null,s):c?(0,y.localize)(16,null,s):(0,y.localize)(17,null,s)):f<A?(s=Math.floor(f/E),a?s===1?c?(0,y.localize)(18,null,s):(0,y.localize)(19,null,s):c?(0,y.localize)(20,null,s):(0,y.localize)(21,null,s):s===1?c?(0,y.localize)(22,null,s):(0,y.localize)(23,null,s):c?(0,y.localize)(24,null,s):(0,y.localize)(25,null,s)):f<j?(s=Math.floor(f/A),a?s===1?(0,y.localize)(26,null,s):(0,y.localize)(27,null,s):s===1?(0,y.localize)(28,null,s):(0,y.localize)(29,null,s)):f<k?(s=Math.floor(f/j),a?s===1?c?(0,y.localize)(30,null,s):(0,y.localize)(31,null,s):c?(0,y.localize)(32,null,s):(0,y.localize)(33,null,s):s===1?c?(0,y.localize)(34,null,s):(0,y.localize)(35,null,s):c?(0,y.localize)(36,null,s):(0,y.localize)(37,null,s)):f<h?(s=Math.floor(f/k),a?s===1?c?(0,y.localize)(38,null,s):(0,y.localize)(39,null,s):c?(0,y.localize)(40,null,s):(0,y.localize)(41,null,s):s===1?c?(0,y.localize)(42,null,s):(0,y.localize)(43,null,s):c?(0,y.localize)(44,null,s):(0,y.localize)(45,null,s)):(s=Math.floor(f/h),a?s===1?c?(0,y.localize)(46,null,s):(0,y.localize)(47,null,s):c?(0,y.localize)(48,null,s):(0,y.localize)(49,null,s):s===1?c?(0,y.localize)(50,null,s):(0,y.localize)(51,null,s):c?(0,y.localize)(52,null,s):(0,y.localize)(53,null,s))}function p(P,a){const c=Math.abs(P/1e3);return c<1?a?(0,y.localize)(54,null,P):(0,y.localize)(55,null,P):c<S?a?(0,y.localize)(56,null,Math.round(P)/1e3):(0,y.localize)(57,null,Math.round(P)/1e3):c<E?a?(0,y.localize)(58,null,Math.round(P/(1e3*S))):(0,y.localize)(59,null,Math.round(P/(1e3*S))):c<A?a?(0,y.localize)(60,null,Math.round(P/(1e3*E))):(0,y.localize)(61,null,Math.round(P/(1e3*E))):(0,y.localize)(62,null,Math.round(P/(1e3*A)))}function l(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(fe[55],ge([13,11]),function(ae,e){return ae.create("vs/base/common/errorMessage",e)}),define(fe[56],ge([0,1,16,10,55]),function(ae,e,y,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=h,e.$kj=r,e.$lj=p;function A(l,P){return P&&(l.stack||l.stacktrace)?E.localize(0,null,k(l),j(l.stack)||j(l.stacktrace)):k(l)}function j(l){return Array.isArray(l)?l.join(`
`):l}function k(l){return l.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${l.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof l.code=="string"&&typeof l.errno=="number"&&typeof l.syscall=="string"?E.localize(1,null,l.message):l.message||E.localize(2,null)}function h(l=null,P=!1){if(!l)return E.localize(3,null);if(Array.isArray(l)){const a=y.$Hb(l),c=h(a[0],P);return a.length>1?E.localize(4,null,c,a.length):c}if(S.$$f(l))return l;if(l.detail){const a=l.detail;if(a.error)return A(a.error,P);if(a.exception)return A(a.exception,P)}return l.stack?A(l,P):l.message?l.message:E.localize(5,null)}function r(l){const P=l;return P instanceof Error&&Array.isArray(P.actions)}function p(l,P){let a;return typeof l=="string"?a=new Error(l):a=l,a.actions=P,a}}),define(fe[57],ge([13,11]),function(ae,e){return ae.create("vs/base/common/platform",e)}),define(fe[3],ge([0,1,57]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=o,e.$D=U,e.$J=K,e.$g="en";let S=!1,E=!1,A=!1,j=!1,k=!1,h=!1,r=!1,p=!1,l=!1,P=!1,a,c=e.$g,g=e.$g,f,s;const n=globalThis;let $;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?$=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&($=process);const v=typeof $?.versions?.electron=="string",i=v&&$?.type==="renderer";if(typeof $=="object"){S=$.platform==="win32",E=$.platform==="darwin",A=$.platform==="linux",j=A&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,r=v,l=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,a=e.$g,c=e.$g;const F=$.env.VSCODE_NLS_CONFIG;if(F)try{const O=JSON.parse(F),d=O.availableLanguages["*"];a=O.locale,g=O.osLocale,c=d||e.$g,f=O._translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!i?(s=navigator.userAgent,S=s.indexOf("Windows")>=0,E=s.indexOf("Macintosh")>=0,p=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=s.indexOf("Linux")>=0,P=s?.indexOf("Mobi")>=0,h=!0,a=y.getConfiguredDefaultLocale(y.localize(0,null))||e.$g,c=a,g=navigator.language):console.error("Unable to resolve platform.");var t;(function(F){F[F.Web=0]="Web",F[F.Mac=1]="Mac",F[F.Linux=2]="Linux",F[F.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(F){switch(F){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let L=0;E?L=1:S?L=3:A&&(L=2),e.$i=S,e.$j=E,e.$k=A,e.$l=j,e.$m=k,e.$n=r,e.$o=h,e.$p=h&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=p,e.$s=P,e.$t=l,e.$u=L,e.$v=s,e.$w=c;var m;(function(F){function O(){return e.$w}F.value=O;function d(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}F.isDefaultVariant=d;function I(){return e.$w==="en"}F.isDefault=I})(m||(e.Language=m={})),e.$x=a,e.$y=g,e.$z=f,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const F=[];n.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let I=0,w=F.length;I<w;I++){const D=F[I];if(D.id===d.data.vscodeScheduleAsyncWork){F.splice(I,1),D.callback();return}}});let O=0;return d=>{const I=++O;F.push({id:I,callback:d}),n.postMessage({vscodeScheduleAsyncWork:I},"*")}}return F=>setTimeout(F)})();var M;(function(F){F[F.Windows=1]="Windows",F[F.Macintosh=2]="Macintosh",F[F.Linux=3]="Linux"})(M||(e.OperatingSystem=M={})),e.OS=E||p?2:S?1:3;let C=!0,b=!1;function U(){if(!b){b=!0;const F=new Uint8Array(2);F[0]=1,F[1]=2,C=new Uint16Array(F.buffer)[0]===513}return C}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function K(F){return parseFloat(F)>=20}}),define(fe[15],ge([0,1,3]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let S;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.process<"u"){const A=E.process;S={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?S={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:S={get platform(){return y.$i?"win32":y.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=S.cwd,e.env=S.env,e.$dc=S.platform,e.$ec=S.arch}),define(fe[5],ge([0,1,15]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const S=65,E=97,A=90,j=122,k=46,h=47,r=92,p=58,l=63;class P extends Error{constructor(o,L,m){let M;typeof L=="string"&&L.indexOf("not ")===0?(M="must not be",L=L.replace(/^not /,"")):M="must be";const C=o.indexOf(".")!==-1?"property":"argument";let b=`The "${o}" ${C} ${M} of type ${L}`;b+=`. Received type ${typeof m}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function a(t,o){if(t===null||typeof t!="object")throw new P(o,"Object",t)}function c(t,o){if(typeof t!="string")throw new P(o,"string",t)}const g=y.$dc==="win32";function f(t){return t===h||t===r}function s(t){return t===h}function n(t){return t>=S&&t<=A||t>=E&&t<=j}function $(t,o,L,m){let M="",C=0,b=-1,U=0,K=0;for(let F=0;F<=t.length;++F){if(F<t.length)K=t.charCodeAt(F);else{if(m(K))break;K=h}if(m(K)){if(!(b===F-1||U===1))if(U===2){if(M.length<2||C!==2||M.charCodeAt(M.length-1)!==k||M.charCodeAt(M.length-2)!==k){if(M.length>2){const O=M.lastIndexOf(L);O===-1?(M="",C=0):(M=M.slice(0,O),C=M.length-1-M.lastIndexOf(L)),b=F,U=0;continue}else if(M.length!==0){M="",C=0,b=F,U=0;continue}}o&&(M+=M.length>0?`${L}..`:"..",C=2)}else M.length>0?M+=`${L}${t.slice(b+1,F)}`:M=t.slice(b+1,F),C=F-b-1;b=F,U=0}else K===k&&U!==-1?++U:U=-1}return M}function v(t,o){a(o,"pathObject");const L=o.dir||o.root,m=o.base||`${o.name||""}${o.ext||""}`;return L?L===o.root?`${L}${m}`:`${L}${t}${m}`:m}e.$fc={resolve(...t){let o="",L="",m=!1;for(let M=t.length-1;M>=-1;M--){let C;if(M>=0){if(C=t[M],c(C,"path"),C.length===0)continue}else o.length===0?C=y.cwd():(C=y.env[`=${o}`]||y.cwd(),(C===void 0||C.slice(0,2).toLowerCase()!==o.toLowerCase()&&C.charCodeAt(2)===r)&&(C=`${o}\\`));const b=C.length;let U=0,K="",F=!1;const O=C.charCodeAt(0);if(b===1)f(O)&&(U=1,F=!0);else if(f(O))if(F=!0,f(C.charCodeAt(1))){let d=2,I=d;for(;d<b&&!f(C.charCodeAt(d));)d++;if(d<b&&d!==I){const w=C.slice(I,d);for(I=d;d<b&&f(C.charCodeAt(d));)d++;if(d<b&&d!==I){for(I=d;d<b&&!f(C.charCodeAt(d));)d++;(d===b||d!==I)&&(K=`\\\\${w}\\${C.slice(I,d)}`,U=d)}}}else U=1;else n(O)&&C.charCodeAt(1)===p&&(K=C.slice(0,2),U=2,b>2&&f(C.charCodeAt(2))&&(F=!0,U=3));if(K.length>0)if(o.length>0){if(K.toLowerCase()!==o.toLowerCase())continue}else o=K;if(m){if(o.length>0)break}else if(L=`${C.slice(U)}\\${L}`,m=F,F&&o.length>0)break}return L=$(L,!m,"\\",f),m?`${o}\\${L}`:`${o}${L}`||"."},normalize(t){c(t,"path");const o=t.length;if(o===0)return".";let L=0,m,M=!1;const C=t.charCodeAt(0);if(o===1)return s(C)?"\\":t;if(f(C))if(M=!0,f(t.charCodeAt(1))){let U=2,K=U;for(;U<o&&!f(t.charCodeAt(U));)U++;if(U<o&&U!==K){const F=t.slice(K,U);for(K=U;U<o&&f(t.charCodeAt(U));)U++;if(U<o&&U!==K){for(K=U;U<o&&!f(t.charCodeAt(U));)U++;if(U===o)return`\\\\${F}\\${t.slice(K)}\\`;U!==K&&(m=`\\\\${F}\\${t.slice(K,U)}`,L=U)}}}else L=1;else n(C)&&t.charCodeAt(1)===p&&(m=t.slice(0,2),L=2,o>2&&f(t.charCodeAt(2))&&(M=!0,L=3));let b=L<o?$(t.slice(L),!M,"\\",f):"";return b.length===0&&!M&&(b="."),b.length>0&&f(t.charCodeAt(o-1))&&(b+="\\"),m===void 0?M?`\\${b}`:b:M?`${m}\\${b}`:`${m}${b}`},isAbsolute(t){c(t,"path");const o=t.length;if(o===0)return!1;const L=t.charCodeAt(0);return f(L)||o>2&&n(L)&&t.charCodeAt(1)===p&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,L;for(let C=0;C<t.length;++C){const b=t[C];c(b,"path"),b.length>0&&(o===void 0?o=L=b:o+=`\\${b}`)}if(o===void 0)return".";let m=!0,M=0;if(typeof L=="string"&&f(L.charCodeAt(0))){++M;const C=L.length;C>1&&f(L.charCodeAt(1))&&(++M,C>2&&(f(L.charCodeAt(2))?++M:m=!1))}if(m){for(;M<o.length&&f(o.charCodeAt(M));)M++;M>=2&&(o=`\\${o.slice(M)}`)}return e.$fc.normalize(o)},relative(t,o){if(c(t,"from"),c(o,"to"),t===o)return"";const L=e.$fc.resolve(t),m=e.$fc.resolve(o);if(L===m||(t=L.toLowerCase(),o=m.toLowerCase(),t===o))return"";let M=0;for(;M<t.length&&t.charCodeAt(M)===r;)M++;let C=t.length;for(;C-1>M&&t.charCodeAt(C-1)===r;)C--;const b=C-M;let U=0;for(;U<o.length&&o.charCodeAt(U)===r;)U++;let K=o.length;for(;K-1>U&&o.charCodeAt(K-1)===r;)K--;const F=K-U,O=b<F?b:F;let d=-1,I=0;for(;I<O;I++){const D=t.charCodeAt(M+I);if(D!==o.charCodeAt(U+I))break;D===r&&(d=I)}if(I!==O){if(d===-1)return m}else{if(F>O){if(o.charCodeAt(U+I)===r)return m.slice(U+I+1);if(I===2)return m.slice(U+I)}b>O&&(t.charCodeAt(M+I)===r?d=I:I===2&&(d=3)),d===-1&&(d=0)}let w="";for(I=M+d+1;I<=C;++I)(I===C||t.charCodeAt(I)===r)&&(w+=w.length===0?"..":"\\..");return U+=d,w.length>0?`${w}${m.slice(U,K)}`:(m.charCodeAt(U)===r&&++U,m.slice(U,K))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$fc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===r){if(o.charCodeAt(1)===r){const L=o.charCodeAt(2);if(L!==l&&L!==k)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(n(o.charCodeAt(0))&&o.charCodeAt(1)===p&&o.charCodeAt(2)===r)return`\\\\?\\${o}`;return t},dirname(t){c(t,"path");const o=t.length;if(o===0)return".";let L=-1,m=0;const M=t.charCodeAt(0);if(o===1)return f(M)?t:".";if(f(M)){if(L=m=1,f(t.charCodeAt(1))){let U=2,K=U;for(;U<o&&!f(t.charCodeAt(U));)U++;if(U<o&&U!==K){for(K=U;U<o&&f(t.charCodeAt(U));)U++;if(U<o&&U!==K){for(K=U;U<o&&!f(t.charCodeAt(U));)U++;if(U===o)return t;U!==K&&(L=m=U+1)}}}}else n(M)&&t.charCodeAt(1)===p&&(L=o>2&&f(t.charCodeAt(2))?3:2,m=L);let C=-1,b=!0;for(let U=o-1;U>=m;--U)if(f(t.charCodeAt(U))){if(!b){C=U;break}}else b=!1;if(C===-1){if(L===-1)return".";C=L}return t.slice(0,C)},basename(t,o){o!==void 0&&c(o,"ext"),c(t,"path");let L=0,m=-1,M=!0,C;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===p&&(L=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,U=-1;for(C=t.length-1;C>=L;--C){const K=t.charCodeAt(C);if(f(K)){if(!M){L=C+1;break}}else U===-1&&(M=!1,U=C+1),b>=0&&(K===o.charCodeAt(b)?--b===-1&&(m=C):(b=-1,m=U))}return L===m?m=U:m===-1&&(m=t.length),t.slice(L,m)}for(C=t.length-1;C>=L;--C)if(f(t.charCodeAt(C))){if(!M){L=C+1;break}}else m===-1&&(M=!1,m=C+1);return m===-1?"":t.slice(L,m)},extname(t){c(t,"path");let o=0,L=-1,m=0,M=-1,C=!0,b=0;t.length>=2&&t.charCodeAt(1)===p&&n(t.charCodeAt(0))&&(o=m=2);for(let U=t.length-1;U>=o;--U){const K=t.charCodeAt(U);if(f(K)){if(!C){m=U+1;break}continue}M===-1&&(C=!1,M=U+1),K===k?L===-1?L=U:b!==1&&(b=1):L!==-1&&(b=-1)}return L===-1||M===-1||b===0||b===1&&L===M-1&&L===m+1?"":t.slice(L,M)},format:v.bind(null,"\\"),parse(t){c(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const L=t.length;let m=0,M=t.charCodeAt(0);if(L===1)return f(M)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(f(M)){if(m=1,f(t.charCodeAt(1))){let d=2,I=d;for(;d<L&&!f(t.charCodeAt(d));)d++;if(d<L&&d!==I){for(I=d;d<L&&f(t.charCodeAt(d));)d++;if(d<L&&d!==I){for(I=d;d<L&&!f(t.charCodeAt(d));)d++;d===L?m=d:d!==I&&(m=d+1)}}}}else if(n(M)&&t.charCodeAt(1)===p){if(L<=2)return o.root=o.dir=t,o;if(m=2,f(t.charCodeAt(2))){if(L===3)return o.root=o.dir=t,o;m=3}}m>0&&(o.root=t.slice(0,m));let C=-1,b=m,U=-1,K=!0,F=t.length-1,O=0;for(;F>=m;--F){if(M=t.charCodeAt(F),f(M)){if(!K){b=F+1;break}continue}U===-1&&(K=!1,U=F+1),M===k?C===-1?C=F:O!==1&&(O=1):C!==-1&&(O=-1)}return U!==-1&&(C===-1||O===0||O===1&&C===U-1&&C===b+1?o.base=o.name=t.slice(b,U):(o.name=t.slice(b,C),o.base=t.slice(b,U),o.ext=t.slice(C,U))),b>0&&b!==m?o.dir=t.slice(0,b-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(g){const t=/\\/g;return()=>{const o=y.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>y.cwd()})();e.$gc={resolve(...t){let o="",L=!1;for(let m=t.length-1;m>=-1&&!L;m--){const M=m>=0?t[m]:i();c(M,"path"),M.length!==0&&(o=`${M}/${o}`,L=M.charCodeAt(0)===h)}return o=$(o,!L,"/",s),L?`/${o}`:o.length>0?o:"."},normalize(t){if(c(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===h,L=t.charCodeAt(t.length-1)===h;return t=$(t,!o,"/",s),t.length===0?o?"/":L?"./":".":(L&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return c(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let o;for(let L=0;L<t.length;++L){const m=t[L];c(m,"path"),m.length>0&&(o===void 0?o=m:o+=`/${m}`)}return o===void 0?".":e.$gc.normalize(o)},relative(t,o){if(c(t,"from"),c(o,"to"),t===o||(t=e.$gc.resolve(t),o=e.$gc.resolve(o),t===o))return"";const L=1,m=t.length,M=m-L,C=1,b=o.length-C,U=M<b?M:b;let K=-1,F=0;for(;F<U;F++){const d=t.charCodeAt(L+F);if(d!==o.charCodeAt(C+F))break;d===h&&(K=F)}if(F===U)if(b>U){if(o.charCodeAt(C+F)===h)return o.slice(C+F+1);if(F===0)return o.slice(C+F)}else M>U&&(t.charCodeAt(L+F)===h?K=F:F===0&&(K=0));let O="";for(F=L+K+1;F<=m;++F)(F===m||t.charCodeAt(F)===h)&&(O+=O.length===0?"..":"/..");return`${O}${o.slice(C+K)}`},toNamespacedPath(t){return t},dirname(t){if(c(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===h;let L=-1,m=!0;for(let M=t.length-1;M>=1;--M)if(t.charCodeAt(M)===h){if(!m){L=M;break}}else m=!1;return L===-1?o?"/":".":o&&L===1?"//":t.slice(0,L)},basename(t,o){o!==void 0&&c(o,"ext"),c(t,"path");let L=0,m=-1,M=!0,C;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,U=-1;for(C=t.length-1;C>=0;--C){const K=t.charCodeAt(C);if(K===h){if(!M){L=C+1;break}}else U===-1&&(M=!1,U=C+1),b>=0&&(K===o.charCodeAt(b)?--b===-1&&(m=C):(b=-1,m=U))}return L===m?m=U:m===-1&&(m=t.length),t.slice(L,m)}for(C=t.length-1;C>=0;--C)if(t.charCodeAt(C)===h){if(!M){L=C+1;break}}else m===-1&&(M=!1,m=C+1);return m===-1?"":t.slice(L,m)},extname(t){c(t,"path");let o=-1,L=0,m=-1,M=!0,C=0;for(let b=t.length-1;b>=0;--b){const U=t.charCodeAt(b);if(U===h){if(!M){L=b+1;break}continue}m===-1&&(M=!1,m=b+1),U===k?o===-1?o=b:C!==1&&(C=1):o!==-1&&(C=-1)}return o===-1||m===-1||C===0||C===1&&o===m-1&&o===L+1?"":t.slice(o,m)},format:v.bind(null,"/"),parse(t){c(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const L=t.charCodeAt(0)===h;let m;L?(o.root="/",m=1):m=0;let M=-1,C=0,b=-1,U=!0,K=t.length-1,F=0;for(;K>=m;--K){const O=t.charCodeAt(K);if(O===h){if(!U){C=K+1;break}continue}b===-1&&(U=!1,b=K+1),O===k?M===-1?M=K:F!==1&&(F=1):M!==-1&&(F=-1)}if(b!==-1){const O=C===0&&L?1:C;M===-1||F===0||F===1&&M===b-1&&M===C+1?o.base=o.name=t.slice(O,b):(o.name=t.slice(O,M),o.base=t.slice(O,b),o.ext=t.slice(M,b))}return C>0?o.dir=t.slice(0,C-1):L&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=g?e.$fc.normalize:e.$gc.normalize,e.$ic=g?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=g?e.$fc.join:e.$gc.join,e.$kc=g?e.$fc.resolve:e.$gc.resolve,e.$lc=g?e.$fc.relative:e.$gc.relative,e.$mc=g?e.$fc.dirname:e.$gc.dirname,e.$nc=g?e.$fc.basename:e.$gc.basename,e.$oc=g?e.$fc.extname:e.$gc.extname,e.$pc=g?e.$fc.format:e.$gc.format,e.$qc=g?e.$fc.parse:e.$gc.parse,e.$rc=g?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=g?e.$fc.sep:e.$gc.sep,e.$tc=g?e.$fc.delimiter:e.$gc.delimiter}),define(fe[32],ge([0,1,5,3,9,10]),function(ae,e,y,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=j,e.$rg=k,e.$sg=h,e.$tg=r,e.$ug=p,e.$vg=c,e.$wg=g,e.$xg=f,e.$yg=s,e.$zg=n,e.$Ag=$,e.$Bg=v,e.$Cg=i,e.$Dg=t,e.$Eg=o,e.$Fg=L,e.$Gg=C;function j(b){return b===47||b===92}function k(b){return b.replace(/[\\/]/g,y.$gc.sep)}function h(b){return b.indexOf("/")===-1&&(b=k(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}function r(b,U=y.$gc.sep){if(!b)return"";const K=b.length,F=b.charCodeAt(0);if(j(F)){if(j(b.charCodeAt(1))&&!j(b.charCodeAt(2))){let d=3;const I=d;for(;d<K&&!j(b.charCodeAt(d));d++);if(I!==d&&!j(b.charCodeAt(d+1))){for(d+=1;d<K;d++)if(j(b.charCodeAt(d)))return b.slice(0,d+1).replace(/[\\/]/g,U)}}return U}else if(s(F)&&b.charCodeAt(1)===58)return j(b.charCodeAt(2))?b.slice(0,2)+U:b.slice(0,2);let O=b.indexOf("://");if(O!==-1){for(O+=3;O<K;O++)if(j(b.charCodeAt(O)))return b.slice(0,O+1)}return""}function p(b){if(!S.$i||!b||b.length<5)return!1;let U=b.charCodeAt(0);if(U!==92||(U=b.charCodeAt(1),U!==92))return!1;let K=2;const F=K;for(;K<b.length&&(U=b.charCodeAt(K),U!==92);K++);return!(F===K||(U=b.charCodeAt(K+1),isNaN(U)||U===92))}const l=/[\\/:\*\?"<>\|]/g,P=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(b,U=S.$i){const K=U?l:P;return!(!b||b.length===0||/^\s+$/.test(b)||(K.lastIndex=0,K.test(b))||U&&a.test(b)||b==="."||b===".."||U&&b[b.length-1]==="."||U&&b.length!==b.trim().length||b.length>255)}function g(b,U,K){const F=b===U;return!K||F?F:!b||!U?!1:(0,E.$zf)(b,U)}function f(b,U,K,F=y.sep){if(b===U)return!0;if(!b||!U||U.length>b.length)return!1;if(K){if(!(0,E.$Af)(b,U))return!1;if(U.length===b.length)return!0;let d=U.length;return U.charAt(U.length-1)===F&&d--,b.charAt(d)===F}return U.charAt(U.length-1)!==F&&(U+=F),b.indexOf(U)===0}function s(b){return b>=65&&b<=90||b>=97&&b<=122}function n(b,U){return S.$i&&b.endsWith(":")&&(b+=y.sep),(0,y.$ic)(b)||(b=(0,y.$jc)(U,b)),b=(0,y.$hc)(b),$(b)}function $(b){return S.$i?(b=(0,E.$hf)(b,y.sep),b.endsWith(":")&&(b+=y.sep)):(b=(0,E.$hf)(b,y.sep),b||(b=y.sep)),b}function v(b){const U=(0,y.$hc)(b);return S.$i?b.length>3?!1:i(U)&&(b.length===2||U.charCodeAt(2)===92):U===y.$gc.sep}function i(b,U=S.$i){return U?s(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}function t(b,U=S.$i){return i(b,U)?b[0]:void 0}function o(b,U,K){return U.length>b.length?-1:b===U?0:(K&&(b=b.toLowerCase(),U=U.toLowerCase()),b.indexOf(U))}function L(b){const U=b.split(":");let K,F,O;for(const d of U){const I=Number(d);(0,A.$cg)(I)?F===void 0?F=I:O===void 0&&(O=I):K=K?[K,d].join(":"):d}if(!K)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:K,line:F!==void 0?F:void 0,column:O!==void 0?O:F!==void 0?1:void 0}}const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",M="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function C(b,U,K=8){let F="";for(let d=0;d<K;d++){let I;d===0&&S.$i&&!U&&(K===3||K===4)?I=M:I=m,F+=I.charAt(Math.floor(Math.random()*I.length))}let O;return U?O=`${U}-${F}`:O=F,b?(0,y.$jc)(b,O):O}}),define(fe[33],ge([0,1,3]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$om=A,e.$pm=j;var S;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(S||(e.Source=S={}));var E;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(E||(e.TerminateResponseCode=E={}));function A(k,...h){const r=h.reduce((P,a)=>(P[a]=!0,P),{}),p=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(P=>!r[P]).forEach(P=>{for(let a=0;a<p.length;a++)if(P.search(p[a])!==-1){delete k[P];break}})}function j(k){k&&(delete k.DEBUG,y.$j&&delete k.DYLD_LIBRARY_PATH,y.$k&&delete k.LD_PRELOAD)}}),define(fe[6],ge([0,1,5,3]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=c,e.$wc=v;const E=/^\w[\w\d+.-]*$/,A=/^\//,j=/^\/\//;function k(m,M){if(!m.scheme&&M)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${m.authority}", path: "${m.path}", query: "${m.query}", fragment: "${m.fragment}"}`);if(m.scheme&&!E.test(m.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(m.path){if(m.authority){if(!A.test(m.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(j.test(m.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(m,M){return!m&&!M?"file":m}function r(m,M){switch(m){case"https":case"http":case"file":M?M[0]!==l&&(M=l+M):M=l;break}return M}const p="",l="/",P=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(M){return M instanceof a?!0:M?typeof M.authority=="string"&&typeof M.fragment=="string"&&typeof M.path=="string"&&typeof M.query=="string"&&typeof M.scheme=="string"&&typeof M.fsPath=="string"&&typeof M.with=="function"&&typeof M.toString=="function":!1}constructor(M,C,b,U,K,F=!1){typeof M=="object"?(this.scheme=M.scheme||p,this.authority=M.authority||p,this.path=M.path||p,this.query=M.query||p,this.fragment=M.fragment||p):(this.scheme=h(M,F),this.authority=C||p,this.path=r(this.scheme,b||p),this.query=U||p,this.fragment=K||p,k(this,F))}get fsPath(){return v(this,!1)}with(M){if(!M)return this;let{scheme:C,authority:b,path:U,query:K,fragment:F}=M;return C===void 0?C=this.scheme:C===null&&(C=p),b===void 0?b=this.authority:b===null&&(b=p),U===void 0?U=this.path:U===null&&(U=p),K===void 0?K=this.query:K===null&&(K=p),F===void 0?F=this.fragment:F===null&&(F=p),C===this.scheme&&b===this.authority&&U===this.path&&K===this.query&&F===this.fragment?this:new f(C,b,U,K,F)}static parse(M,C=!1){const b=P.exec(M);return b?new f(b[2]||p,L(b[4]||p),L(b[5]||p),L(b[7]||p),L(b[9]||p),C):new f(p,p,p,p,p)}static file(M){let C=p;if(S.$i&&(M=M.replace(/\\/g,l)),M[0]===l&&M[1]===l){const b=M.indexOf(l,2);b===-1?(C=M.substring(2),M=l):(C=M.substring(2,b),M=M.substring(b)||l)}return new f("file",C,M,p,p)}static from(M,C){return new f(M.scheme,M.authority,M.path,M.query,M.fragment,C)}static joinPath(M,...C){if(!M.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return S.$i&&M.scheme==="file"?b=a.file(y.$fc.join(v(M,!0),...C)).path:b=y.$gc.join(M.path,...C),M.with({path:b})}toString(M=!1){return i(this,M)}toJSON(){return this}static revive(M){if(M){if(M instanceof a)return M;{const C=new f(M);return C._formatted=M.external??null,C._fsPath=M._sep===g?M.fsPath??null:null,C}}else return M}}e.URI=a;function c(m){return!m||typeof m!="object"?!1:typeof m.scheme=="string"&&(typeof m.authority=="string"||typeof m.authority>"u")&&(typeof m.path=="string"||typeof m.path>"u")&&(typeof m.query=="string"||typeof m.query>"u")&&(typeof m.fragment=="string"||typeof m.fragment>"u")}const g=S.$i?1:void 0;class f extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(M=!1){return M?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const M={$mid:1};return this._fsPath&&(M.fsPath=this._fsPath,M._sep=g),this._formatted&&(M.external=this._formatted),this.path&&(M.path=this.path),this.scheme&&(M.scheme=this.scheme),this.authority&&(M.authority=this.authority),this.query&&(M.query=this.query),this.fragment&&(M.fragment=this.fragment),M}}const s={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(m,M,C){let b,U=-1;for(let K=0;K<m.length;K++){const F=m.charCodeAt(K);if(F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57||F===45||F===46||F===95||F===126||M&&F===47||C&&F===91||C&&F===93||C&&F===58)U!==-1&&(b+=encodeURIComponent(m.substring(U,K)),U=-1),b!==void 0&&(b+=m.charAt(K));else{b===void 0&&(b=m.substr(0,K));const O=s[F];O!==void 0?(U!==-1&&(b+=encodeURIComponent(m.substring(U,K)),U=-1),b+=O):U===-1&&(U=K)}}return U!==-1&&(b+=encodeURIComponent(m.substring(U))),b!==void 0?b:m}function $(m){let M;for(let C=0;C<m.length;C++){const b=m.charCodeAt(C);b===35||b===63?(M===void 0&&(M=m.substr(0,C)),M+=s[b]):M!==void 0&&(M+=m[C])}return M!==void 0?M:m}function v(m,M){let C;return m.authority&&m.path.length>1&&m.scheme==="file"?C=`//${m.authority}${m.path}`:m.path.charCodeAt(0)===47&&(m.path.charCodeAt(1)>=65&&m.path.charCodeAt(1)<=90||m.path.charCodeAt(1)>=97&&m.path.charCodeAt(1)<=122)&&m.path.charCodeAt(2)===58?M?C=m.path.substr(1):C=m.path[1].toLowerCase()+m.path.substr(2):C=m.path,S.$i&&(C=C.replace(/\//g,"\\")),C}function i(m,M){const C=M?$:n;let b="",{scheme:U,authority:K,path:F,query:O,fragment:d}=m;if(U&&(b+=U,b+=":"),(K||U==="file")&&(b+=l,b+=l),K){let I=K.indexOf("@");if(I!==-1){const w=K.substr(0,I);K=K.substr(I+1),I=w.lastIndexOf(":"),I===-1?b+=C(w,!1,!1):(b+=C(w.substr(0,I),!1,!1),b+=":",b+=C(w.substr(I+1),!1,!0)),b+="@"}K=K.toLowerCase(),I=K.lastIndexOf(":"),I===-1?b+=C(K,!1,!0):(b+=C(K.substr(0,I),!1,!0),b+=K.substr(I))}if(F){if(F.length>=3&&F.charCodeAt(0)===47&&F.charCodeAt(2)===58){const I=F.charCodeAt(1);I>=65&&I<=90&&(F=`/${String.fromCharCode(I+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===58){const I=F.charCodeAt(0);I>=65&&I<=90&&(F=`${String.fromCharCode(I+32)}:${F.substr(2)}`)}b+=C(F,!0,!1)}return O&&(b+="?",b+=C(O,!1,!1)),d&&(b+="#",b+=M?d:n(d,!1,!1)),b}function t(m){try{return decodeURIComponent(m)}catch{return m.length>3?m.substr(0,3)+t(m.substr(3)):m}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L(m){return m.match(o)?m.replace(o,M=>t(M)):m}}),define(fe[58],ge([0,1,6]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=S,e.$Zq=E,e.$1q=A,e.log=k;function S(r){const p=r;return p&&typeof p.type=="string"&&typeof p.severity=="string"}function E(r){const p=[];let l;try{const P=JSON.parse(r.arguments),a=P[P.length-1];a&&a.__$stack&&(P.pop(),l=a.__$stack),p.push(...P)}catch{p.push("Unable to log remote console arguments",r.arguments)}return{args:p,stack:l}}function A(r){if(typeof r!="string")return A(E(r).stack);const p=r;if(p){const l=j(p),P=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(l||"");if(P&&P.length===4)return{uri:y.URI.file(P[1]),line:Number(P[2]),column:Number(P[3])}}}function j(r){if(!r)return r;const p=r.indexOf(`
`);return p===-1?r:r.substring(0,p)}function k(r,p){const{args:l,stack:P}=E(r),a=typeof l[0]=="string"&&l.length===1;let c=j(P);c&&(c=`(${c.trim()})`);let g=[];if(typeof l[0]=="string"?c&&a?g=[`%c[${p}] %c${l[0]} %c${c}`,h("blue"),h(""),h("grey")]:g=[`%c[${p}] %c${l[0]}`,h("blue"),h(""),...l.slice(1)]:g=[`%c[${p}]%`,h("blue"),...l],c&&!a&&g.push(c),typeof console[r.severity]!="function")throw new Error("Unknown console method");console[r.severity].apply(console,g)}function h(r){return`color: ${r}`}}),define(fe[59],ge([0,1,18,6]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=E,e.$7h=A,e.$8h=k;function E(h){return JSON.stringify(h,j)}function A(h){let r=JSON.parse(h);return r=k(r),r}function j(h,r){return r instanceof RegExp?{$mid:2,source:r.source,flags:r.flags}:r}function k(h,r=0){if(!h||r>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return S.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof y.$He||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let p=0;p<h.length;++p)h[p]=k(h[p],r+1);else for(const p in h)Object.hasOwnProperty.call(h,p)&&(h[p]=k(h[p],r+1))}return h}}),define(fe[19],ge([0,1,7,3,9,6,5]),function(ae,e,y,S,E,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Lg=e.$Kg=e.$Jg=e.Schemas=void 0,e.$Hg=h,e.$Ig=r,e.$Mg=l;var k;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting"})(k||(e.Schemas=k={}));function h(c,g){return A.URI.isUri(c)?(0,E.$zf)(c.scheme,g):(0,E.$Af)(c,g+":")}function r(c,...g){return g.some(f=>h(c,f))}e.$Jg="vscode-tkn",e.$Kg="tkn";class p{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g,f){this.f=l(g,f)}getServerRootPath(){return this.f}get g(){return j.$gc.join(this.f,k.vscodeRemoteResource)}set(g,f,s){this.a[g]=f,this.b[g]=s}setConnectionToken(g,f){this.c[g]=f}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)try{return this.e(g)}catch(i){return y.$1(i),g}const f=g.authority;let s=this.a[f];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const n=this.b[f],$=this.c[f];let v=`path=${encodeURIComponent(g.path)}`;return typeof $=="string"&&(v+=`&${e.$Kg}=${encodeURIComponent($)}`),A.URI.from({scheme:S.$o?this.d:k.vscodeRemoteResource,authority:`${s}:${n}`,path:this.g,query:v})}}e.$Lg=new p;function l(c,g){return j.$gc.join(g??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.$Ng="vs/../../extensions",e.$Og="vs/../../node_modules",e.$Pg="vs/../../node_modules.asar",e.$Qg="vs/../../node_modules.asar.unpacked",e.$Rg="vscode-app";class P{static{this.a=e.$Rg}asBrowserUri(g){const f=this.b(g,ae);return this.uriToBrowserUri(f)}uriToBrowserUri(g){return g.scheme===k.vscodeRemote?e.$Lg.rewrite(g):g.scheme===k.file&&(S.$m||S.$q===`${k.vscodeFileResource}://${P.a}`)?g.with({scheme:k.vscodeFileResource,authority:g.authority||P.a,query:null,fragment:null}):g}asFileUri(g){const f=this.b(g,ae);return this.uriToFileUri(f)}uriToFileUri(g){return g.scheme===k.vscodeFileResource?g.with({scheme:k.file,authority:g.authority!==P.a?g.authority:null,query:null,fragment:null}):g}b(g,f){return A.URI.isUri(g)?g:A.URI.parse(f.toUrl(g))}}e.$Sg=new P;var a;(function(c){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(g.get("3"));const f="vscode-coi";function s($){let v;typeof $=="string"?v=new URL($).searchParams:$ instanceof URL?v=$.searchParams:A.URI.isUri($)&&(v=new URL($.toString(!0)).searchParams);const i=v?.get(f);if(i)return g.get(i)}c.getHeadersFromQuery=s;function n($,v,i){if(!globalThis.crossOriginIsolated)return;const t=v&&i?"3":i?"2":"1";$ instanceof URLSearchParams?$.set(f,t):$[f]=t}c.addSearchParam=n})(a||(e.COI=a={}))}),define(fe[23],ge([0,1,32,19,5,3,9,6]),function(ae,e,y,S,E,A,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=void 0,e.$Zg=h,e.$ih=p,e.$jh=P;function h(a){return(0,k.$wc)(a,!0)}class r{constructor(c){this.a=c}compare(c,g,f=!1){return c===g?0:(0,j.$sf)(this.getComparisonKey(c,f),this.getComparisonKey(g,f))}isEqual(c,g,f=!1){return c===g?!0:!c||!g?!1:this.getComparisonKey(c,f)===this.getComparisonKey(g,f)}getComparisonKey(c,g=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,g,f=!1){if(c.scheme===g.scheme){if(c.scheme===S.Schemas.file)return y.$xg(h(c),h(g),this.a(c))&&c.query===g.query&&(f||c.fragment===g.fragment);if((0,e.$eh)(c.authority,g.authority))return y.$xg(c.path,g.path,this.a(c),"/")&&c.query===g.query&&(f||c.fragment===g.fragment)}return!1}joinPath(c,...g){return k.URI.joinPath(c,...g)}basenameOrAuthority(c){return(0,e.$9g)(c)||c.authority}basename(c){return E.$gc.basename(c.path)}extname(c){return E.$gc.extname(c.path)}dirname(c){if(c.path.length===0)return c;let g;return c.scheme===S.Schemas.file?g=k.URI.file(E.$mc(h(c))).path:(g=E.$gc.dirname(c.path),c.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),g="/")),c.with({path:g})}normalizePath(c){if(!c.path.length)return c;let g;return c.scheme===S.Schemas.file?g=k.URI.file(E.$hc(h(c))).path:g=E.$gc.normalize(c.path),c.with({path:g})}relativePath(c,g){if(c.scheme!==g.scheme||!(0,e.$eh)(c.authority,g.authority))return;if(c.scheme===S.Schemas.file){const n=E.$lc(h(c),h(g));return A.$i?y.$rg(n):n}let f=c.path||"/";const s=g.path||"/";if(this.a(c)){let n=0;for(const $=Math.min(f.length,s.length);n<$&&!(f.charCodeAt(n)!==s.charCodeAt(n)&&f.charAt(n).toLowerCase()!==s.charAt(n).toLowerCase());n++);f=s.substr(0,n)+f.substr(n)}return E.$gc.relative(f,s)}resolvePath(c,g){if(c.scheme===S.Schemas.file){const f=k.URI.file(E.$kc(h(c),g));return c.with({authority:f.authority,path:f.path})}return g=y.$sg(g),c.with({path:E.$gc.resolve(c.path,g)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,g){return c===g||c!==void 0&&g!==void 0&&(0,j.$zf)(c,g)}hasTrailingPathSeparator(c,g=E.sep){if(c.scheme===S.Schemas.file){const f=h(c);return f.length>y.$tg(f).length&&f[f.length-1]===g}else{const f=c.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,g=E.sep){return(0,e.$fh)(c,g)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,g=E.sep){let f=!1;if(c.scheme===S.Schemas.file){const s=h(c);f=s!==void 0&&s.length===y.$tg(s).length&&s[s.length-1]===g}else{g="/";const s=c.path;f=s.length===1&&s.charCodeAt(s.length-1)===47}return!f&&!(0,e.$fh)(c,g)?c.with({path:c.path+"/"}):c}}e.$1g=r,e.$2g=new r(()=>!1),e.$3g=new r(a=>a.scheme===S.Schemas.file?!A.$k:!0),e.$4g=new r(a=>!0),e.$5g=e.$2g.isEqual.bind(e.$2g),e.$6g=e.$2g.isEqualOrParent.bind(e.$2g),e.$7g=e.$2g.getComparisonKey.bind(e.$2g),e.$8g=e.$2g.basenameOrAuthority.bind(e.$2g),e.$9g=e.$2g.basename.bind(e.$2g),e.$0g=e.$2g.extname.bind(e.$2g),e.$$g=e.$2g.dirname.bind(e.$2g),e.$_g=e.$2g.joinPath.bind(e.$2g),e.$ah=e.$2g.normalizePath.bind(e.$2g),e.$bh=e.$2g.relativePath.bind(e.$2g),e.$ch=e.$2g.resolvePath.bind(e.$2g),e.$dh=e.$2g.isAbsolutePath.bind(e.$2g),e.$eh=e.$2g.isEqualAuthority.bind(e.$2g),e.$fh=e.$2g.hasTrailingPathSeparator.bind(e.$2g),e.$gh=e.$2g.removeTrailingPathSeparator.bind(e.$2g),e.$hh=e.$2g.addTrailingPathSeparator.bind(e.$2g);function p(a,c){const g=[];for(let f=0;f<a.length;f++){const s=c(a[f]);a.some((n,$)=>$===f?!1:(0,e.$6g)(s,c(n)))||g.push(a[f])}return g}var l;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function c(g){const f=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach($=>{const[v,i]=$.split(":");v&&i&&f.set(v,i)});const n=g.path.substring(0,g.path.indexOf(";"));return n&&f.set(a.META_DATA_MIME,n),f}a.parseMetaData=c})(l||(e.DataUri=l={}));function P(a,c,g){if(c){let f=a.path;return f&&f[0]!==E.$gc.sep&&(f=E.$gc.sep+f),a.with({scheme:g,authority:c,path:f})}return a.with({scheme:g})}}),define(fe[12],ge([0,1,17,7,4,2,23,3,50,22]),function(ae,e,y,S,E,A,j,k,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.Promises=e.$Vh=e.$Uh=e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=void 0,e.$kh=p,e.$lh=l,e.$mh=P,e.$nh=a,e.$oh=c,e.$ph=g,e.$qh=f,e.$rh=s,e.$zh=C,e.$Ah=b,e.$Bh=U,e.$Ch=K,e.$Dh=F,e.$Sh=q,e.$1h=G;function p(H){return!!H&&typeof H.then=="function"}function l(H){const R=new y.$qe,J=H(R.token),ie=new Promise((ce,se)=>{const he=R.token.onCancellationRequested(()=>{he.dispose(),se(new S.$5)});Promise.resolve(J).then($e=>{he.dispose(),R.dispose(),ce($e)},$e=>{he.dispose(),R.dispose(),se($e)})});return new class{cancel(){R.cancel(),R.dispose()}then(ce,se){return ie.then(ce,se)}catch(ce){return this.then(void 0,ce)}finally(ce){return ie.finally(ce)}}}function P(H,R,J){return new Promise((ie,ce)=>{const se=R.onCancellationRequested(()=>{se.dispose(),ie(J)});H.then(ie,ce).finally(()=>se.dispose())})}function a(H,R){return new Promise((J,ie)=>{const ce=R.onCancellationRequested(()=>{ce.dispose(),ie(new S.$5)});H.then(J,ie).finally(()=>ce.dispose())})}async function c(H){let R=-1;const J=H.map((ie,ce)=>ie.then(se=>(R=ce,se)));try{return await Promise.race(J)}finally{H.forEach((ie,ce)=>{ce!==R&&ie.cancel()})}}function g(H,R,J){let ie;const ce=setTimeout(()=>{ie?.(void 0),J?.()},R);return Promise.race([H.finally(()=>clearTimeout(ce)),new Promise(se=>ie=se)])}function f(H){return new Promise((R,J)=>{const ie=H();p(ie)?ie.then(R,J):R(ie)})}function s(){let H,R;return{promise:new Promise((ie,ce)=>{H=ie,R=ce}),resolve:H,reject:R}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(R){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=R,!this.b){const J=()=>{if(this.b=null,this.f)return;const ie=this.queue(this.d);return this.d=null,ie};this.b=new Promise(ie=>{this.a.then(J,J).then(ie)})}return new Promise((J,ie)=>{this.b.then(J,ie)})}return this.a=R(),new Promise((J,ie)=>{this.a.then(ce=>{this.a=null,J(ce)},ce=>{this.a=null,ie(ce)})})}dispose(){this.f=!0}}e.$sh=n;class ${constructor(){this.a=Promise.resolve(null)}queue(R){return this.a=this.a.then(()=>R(),()=>R())}}e.$th=$;class v{constructor(){this.a=new Map}queue(R,J){const ce=(this.a.get(R)??Promise.resolve()).catch(()=>{}).then(J).finally(()=>{this.a.get(R)===ce&&this.a.delete(R)});return this.a.set(R,ce),ce}}e.$uh=v;const i=(H,R)=>{let J=!0;const ie=setTimeout(()=>{J=!1,R()},H);return{isTriggered:()=>J,dispose:()=>{clearTimeout(ie),J=!1}}},t=H=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,H())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};class o{constructor(R){this.defaultDelay=R,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(R,J=this.defaultDelay){this.g=R,this.h(),this.b||(this.b=new Promise((ce,se)=>{this.d=ce,this.f=se}).then(()=>{if(this.b=null,this.d=null,this.g){const ce=this.g;return this.g=null,ce()}}));const ie=()=>{this.a=null,this.d?.(null)};return this.a=J===h.$ce?t(ie):i(J,ie),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new S.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$vh=o;class L{constructor(R){this.a=new o(R),this.b=new n}trigger(R,J){return this.a.trigger(()=>this.b.queue(R),J)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$wh=L;class m{constructor(){this.a=!1,this.b=new Promise((R,J)=>{this.d=R})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$xh=m;class M extends m{constructor(R){super(),this.f=setTimeout(()=>this.open(),R)}open(){clearTimeout(this.f),super.open()}}e.$yh=M;function C(H,R){return R?new Promise((J,ie)=>{const ce=setTimeout(()=>{se.dispose(),J()},H),se=R.onCancellationRequested(()=>{clearTimeout(ce),se.dispose(),ie(new S.$5)})}):l(J=>C(H,J))}function b(H,R=0,J){const ie=setTimeout(()=>{H(),J&&ce.dispose()},R),ce=(0,A.$Sc)(()=>{clearTimeout(ie),J?.deleteAndLeak(ce)});return J?.add(ce),ce}function U(H){const R=[];let J=0;const ie=H.length;function ce(){return J<ie?H[J++]():null}function se(he){he!=null&&R.push(he);const $e=ce();return $e?$e.then(se):Promise.resolve(R)}return Promise.resolve(null).then(se)}function K(H,R=ie=>!!ie,J=null){let ie=0;const ce=H.length,se=()=>{if(ie>=ce)return Promise.resolve(J);const he=H[ie++];return Promise.resolve(he()).then(we=>R(we)?Promise.resolve(we):se())};return se()}function F(H,R=ie=>!!ie,J=null){if(H.length===0)return Promise.resolve(J);let ie=H.length;const ce=()=>{ie=-1;for(const se of H)se.cancel?.()};return new Promise((se,he)=>{for(const $e of H)$e.then(we=>{--ie>=0&&R(we)?(ce(),se(we)):ie===0&&se(J)}).catch(we=>{--ie>=0&&(ce(),he(we))})})}class O{constructor(R){this.a=0,this.b=!1,this.f=R,this.g=[],this.d=0,this.h=new E.$fe}whenIdle(){return this.size>0?E.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(R){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((J,ie)=>{this.g.push({factory:R,c:J,e:ie}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const R=this.g.shift();this.d++;const J=R.factory();J.then(R.c,R.e),J.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Eh=O;class d extends O{constructor(){super(1)}}e.$Fh=d;class I{constructor(){this.a=new Z,this.b=0}queue(R){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,R())):this.a.run(this.b++,R())}}e.$Gh=I;class w{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const R=new B;return this.b.add(R),R.p}g(){for(const[,R]of this.a)if(R.size>0)return!1;return!0}queueSize(R,J=j.$2g){const ie=J.getComparisonKey(R);return this.a.get(ie)?.size??0}queueFor(R,J,ie=j.$2g){const ce=ie.getComparisonKey(R);let se=this.a.get(ce);if(!se){se=new d;const he=this.f++,$e=E.Event.once(se.onDrained)(()=>{se?.dispose(),this.a.delete(ce),this.h(),this.d?.deleteAndDispose(he),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$4c),this.d.set(he,$e),this.a.set(ce,se)}return se.queue(J)}h(){this.g()&&this.j()}j(){for(const R of this.b)R.complete();this.b.clear()}dispose(){for(const[,R]of this.a)R.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Hh=w;class D{constructor(R,J){this.a=-1,typeof R=="function"&&typeof J=="number"&&this.setIfNotSet(R,J)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(R,J){this.cancel(),this.a=setTimeout(()=>{this.a=-1,R()},J)}setIfNotSet(R,J){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,R()},J))}}e.$Ih=D;class Y{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(R,J,ie=globalThis){this.cancel();const ce=ie.setInterval(()=>{R()},J);this.d=(0,A.$Sc)(()=>{ie.clearInterval(ce),this.d=void 0})}dispose(){this.cancel()}}e.$Jh=Y;class te{constructor(R,J){this.b=-1,this.a=R,this.d=J,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(R=this.d){this.cancel(),this.b=setTimeout(this.f,R)}get delay(){return this.d}set delay(R){this.d=R}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Kh=te;class V{constructor(R,J){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.a=R,this.b=J,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(R=this.b){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(R/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Lh=V;class ee extends te{constructor(R,J){super(R,J),this.j=[]}work(R){this.j.push(R),this.isScheduled()||this.schedule()}h(){const R=this.j;this.j=[],this.a?.(R)}dispose(){this.j=[],super.dispose()}}e.$Mh=ee;class oe extends A.$Uc{constructor(R,J){super(),this.g=R,this.h=J,this.a=[],this.b=this.B(new A.$Vc),this.f=!1}get pending(){return this.a.length}work(R){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+R.length>this.g.maxBufferedWork)return!1}else if(this.pending+R.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const J of R)this.a.push(J);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new te(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Nh=oe,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Ph=(H,R)=>{(0,k.$B)(()=>{if(J)return;const ie=Date.now()+15;R(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.$Ph=(H,R,J)=>{const ie=H.requestIdleCallback(R,typeof J=="number"?{timeout:J}:void 0);let ce=!1;return{dispose(){ce||(ce=!0,H.cancelIdleCallback(ie))}}},e.$Oh=H=>(0,e.$Ph)(globalThis,H)}();class ue{constructor(R,J){this.g=!1,this.d=()=>{try{this.j=J()}catch(ie){this.l=ie}finally{this.g=!0}},this.f=(0,e.$Ph)(R,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Qh=ue;class X extends ue{constructor(R){super(globalThis,R)}}e.$Rh=X;async function q(H,R,J){let ie;for(let ce=0;ce<J;ce++)try{return await H()}catch(se){ie=se,await C(R)}throw ie}class Z{isRunning(R){return typeof R=="number"?this.a?.taskId===R:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(R,J,ie){return this.a={taskId:R,cancel:()=>ie?.(),promise:J},J.then(()=>this.d(R),()=>this.d(R)),J}d(R){this.a&&R===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const R=this.b;this.b=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}queue(R){if(this.b)this.b.run=R;else{const{promise:J,resolve:ie,reject:ce}=s();this.b={run:R,promise:J,promiseResolve:ie,promiseReject:ce}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Th=Z;class _{constructor(R,J=()=>Date.now()){this.d=R,this.f=J,this.a=0,this.b=0}increment(){const R=this.f();return R-this.a>this.d&&(this.a=R,this.b=0),this.b++,this.b}}e.$Uh=_;var de;(function(H){H[H.Resolved=0]="Resolved",H[H.Rejected=1]="Rejected"})(de||(de={}));class B{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((R,J)=>{this.a=R,this.b=J})}complete(R){return new Promise(J=>{this.a(R),this.d={outcome:0,value:R},J()})}error(R){return new Promise(J=>{this.b(R),this.d={outcome:1,value:R},J()})}cancel(){return this.error(new S.$5)}}e.$Vh=B;var le;(function(H){async function R(ie){let ce;const se=await Promise.all(ie.map(he=>he.then($e=>$e,$e=>{ce||(ce=$e)})));if(typeof ce<"u")throw ce;return se}H.settled=R;function J(ie){return new Promise(async(ce,se)=>{try{await ie(ce,se)}catch(he){se(he)}})}H.withAsyncBody=J})(le||(e.Promises=le={}));class x{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(R){this.a=void 0,this.b=void 0,this.d=!1,this.promise=R.then(J=>(this.a=J,this.d=!0,J),J=>{throw this.b=J,this.d=!0,J})}requireValue(){if(!this.d)throw new S.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Wh=x;class u{constructor(R){this.b=R,this.a=new r.$V(()=>new x(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Xh=u;var z;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(z||(z={}));class ne{static fromArray(R){return new ne(J=>{J.emitMany(R)})}static fromPromise(R){return new ne(async J=>{J.emitMany(await R)})}static fromPromises(R){return new ne(async J=>{await Promise.all(R.map(async ie=>J.emitOne(await ie)))})}static merge(R){return new ne(async J=>{await Promise.all(R.map(async ie=>{for await(const ce of ie)J.emitOne(ce)}))})}static{this.EMPTY=ne.fromArray([])}constructor(R,J){this.a=0,this.b=[],this.d=null,this.f=J,this.g=new E.$fe,queueMicrotask(async()=>{const ie={emitOne:ce=>this.h(ce),emitMany:ce=>this.j(ce),reject:ce=>this.l(ce)};try{await Promise.resolve(R(ie)),this.k()}catch(ce){this.l(ce)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(R<this.b.length)return{done:!1,value:this.b[R++]};if(this.a===1)return{done:!0,value:void 0};await E.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(R,J){return new ne(async ie=>{for await(const ce of R)ie.emitOne(J(ce))})}map(R){return ne.map(this,R)}static filter(R,J){return new ne(async ie=>{for await(const ce of R)J(ce)&&ie.emitOne(ce)})}filter(R){return ne.filter(this,R)}static coalesce(R){return ne.filter(R,J=>!!J)}coalesce(){return ne.coalesce(this)}static async toPromise(R){const J=[];for await(const ie of R)J.push(ie);return J}toPromise(){return ne.toPromise(this)}h(R){this.a===0&&(this.b.push(R),this.g.fire())}j(R){this.a===0&&(this.b=this.b.concat(R),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(R){this.a===0&&(this.a=2,this.d=R,this.g.fire())}}e.$Yh=ne;class N extends ne{constructor(R,J){super(J),this.m=R}cancel(){this.m.cancel()}}e.$Zh=N;function G(H){const R=new y.$qe,J=H(R.token);return new N(R,async ie=>{const ce=R.token.onCancellationRequested(()=>{ce.dispose(),R.dispose(),ie.reject(new S.$5)});try{for await(const se of J){if(R.token.isCancellationRequested)return;ie.emitOne(se)}ce.dispose(),R.dispose()}catch(se){ce.dispose(),R.dispose(),ie.reject(se)}})}class W{constructor(R){this.a=new B,this.b=new ne(ce=>{if(J){ce.reject(J);return}return ie&&ce.emitMany(ie),this.d=se=>ce.reject(se),this.f=se=>ce.emitOne(se),this.a.p},R);let J,ie;this.f=ce=>{ie||(ie=[]),ie.push(ce)},this.d=ce=>{J||(J=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(R){this.d(R),this.a.complete()}emitOne(R){this.f(R)}}e.$2h=W}),define(fe[60],ge([0,1,18,6]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=void 0,e.$Cn=k,e.$Dn=r,e.$En=p;function E(l){return l.toJSON()}class A{constructor(P){this.a=P}transformIncoming(P){const a=this.a.transformIncoming(P);return a===P?P:E(S.URI.from(a))}transformOutgoing(P){const a=this.a.transformOutgoing(P);return a===P?P:E(S.URI.from(a))}transformOutgoingURI(P){const a=this.a.transformOutgoing(P);return a===P?P:S.URI.from(a)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.$An=A,e.$Bn=new class{transformIncoming(l){return l}transformOutgoing(l){return l}transformOutgoingURI(l){return l}transformOutgoingScheme(l){return l}};function j(l,P,a){if(!l||a>200)return null;if(typeof l=="object"){if(l instanceof S.URI)return P.transformOutgoing(l);for(const c in l)if(Object.hasOwnProperty.call(l,c)){const g=j(l[c],P,a+1);g!==null&&(l[c]=g)}}return null}function k(l,P){const a=j(l,P,0);return a===null?l:a}function h(l,P,a,c){if(!l||c>200)return null;if(typeof l=="object"){if(l.$mid===1)return a?S.URI.revive(P.transformIncoming(l)):P.transformIncoming(l);if(l instanceof y.$He)return null;for(const g in l)if(Object.hasOwnProperty.call(l,g)){const f=h(l[g],P,a,c+1);f!==null&&(l[g]=f)}}return null}function r(l,P){const a=h(l,P,!1,0);return a===null?l:a}function p(l,P){const a=h(l,P,!0,0);return a===null?l:a}}),define(fe[24],ge([0,1,106,20,107,12,32,45,5,3,23,6]),function(ae,e,y,S,E,A,j,k,h,r,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=f,e.readdirSync=$,e.whenDeleted=t,e.configureFlushOnWrite=C,e.writeFileSync=U;var P;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(P||(e.RimRafMode=P={}));async function a(V,ee=P.UNLINK,oe){if((0,j.$Bg)(V))throw new Error("rimraf - will refuse to recursively delete root");return ee===P.UNLINK?g(V):c(V,oe)}async function c(V,ee=(0,j.$Gg)((0,S.tmpdir)())){try{try{await y.promises.rename(V,ee)}catch(oe){return oe.code==="ENOENT"?void 0:g(V)}g(ee).catch(oe=>{})}catch(oe){if(oe.code!=="ENOENT")throw oe}}async function g(V){return(0,E.promisify)(y.rm)(V,{recursive:!0,force:!0,maxRetries:3})}function f(V){if((0,j.$Bg)(V))throw new Error("rimraf - will refuse to recursively delete root");y.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}async function s(V,ee){return v(await(ee?n(V):(0,E.promisify)(y.readdir)(V)))}async function n(V){try{return await(0,E.promisify)(y.readdir)(V,{withFileTypes:!0})}catch(ue){console.warn("[node.js fs] readdir with filetypes failed with error: ",ue)}const ee=[],oe=await s(V);for(const ue of oe){let X=!1,q=!1,Z=!1;try{const _=await e.Promises.lstat((0,h.$jc)(V,ue));X=_.isFile(),q=_.isDirectory(),Z=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}ee.push({name:ue,isFile:()=>X,isDirectory:()=>q,isSymbolicLink:()=>Z})}return ee}function $(V){return v(y.readdirSync(V))}function v(V){return V.map(ee=>typeof ee=="string"?r.$j?(0,k.$dm)(ee):ee:(ee.name=r.$j?(0,k.$dm)(ee.name):ee.name,ee))}async function i(V){const ee=await s(V),oe=[];for(const ue of ee)await o.existsDirectory((0,h.$jc)(V,ue))&&oe.push(ue);return oe}function t(V,ee=1e3){return new Promise(oe=>{let ue=!1;const X=setInterval(()=>{ue||(ue=!0,y.access(V,q=>{ue=!1,q&&(clearInterval(X),oe(void 0))}))},ee)})}var o;(function(V){async function ee(X){let q;try{if(q=await e.Promises.lstat(X),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(r.$i&&Z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw _}throw Z}}V.stat=ee;async function oe(X){try{const{stat:q,symbolicLink:Z}=await V.stat(X);return q.isFile()&&Z?.dangling!==!0}catch{}return!1}V.existsFile=oe;async function ue(X){try{const{stat:q,symbolicLink:Z}=await V.stat(X);return q.isDirectory()&&Z?.dangling!==!0}catch{}return!1}V.existsDirectory=ue})(o||(e.SymlinkSupport=o={}));const L=new A.$Hh;function m(V,ee,oe){return L.queueFor(l.URI.file(V),()=>{const ue=K(oe);return new Promise((X,q)=>b(V,ee,ue,Z=>Z?q(Z):X()))},p.$3g)}let M=!0;function C(V){M=V}function b(V,ee,oe,ue){if(!M)return y.writeFile(V,ee,{mode:oe.mode,flag:oe.flag},ue);y.open(V,oe.flag,oe.mode,(X,q)=>{if(X)return ue(X);y.writeFile(q,ee,Z=>{if(Z)return y.close(q,()=>ue(Z));y.fdatasync(q,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),C(!1)),y.close(q,de=>ue(de))))})})}function U(V,ee,oe){const ue=K(oe);if(!M)return y.writeFileSync(V,ee,{mode:ue.mode,flag:ue.flag});const X=y.openSync(V,ue.flag,ue.mode);try{y.writeFileSync(X,ee);try{y.fdatasyncSync(X)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),C(!1)}}finally{y.closeSync(X)}}function K(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function F(V,ee,oe=6e4){if(V!==ee)try{r.$i&&typeof oe=="number"?await O(V,ee,Date.now(),oe):await(0,E.promisify)(y.rename)(V,ee)}catch(ue){if(V.toLowerCase()!==ee.toLowerCase()&&ue.code==="EXDEV"||V.endsWith("."))await d(V,ee,{preserveSymlinks:!1}),await a(V,P.MOVE);else throw ue}}async function O(V,ee,oe,ue,X=0){try{return await(0,E.promisify)(y.rename)(V,ee)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-oe>=ue)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${q}`),q;if(X===0){let Z=!1;try{const{stat:_}=await o.stat(ee);_.isFile()||(Z=!0)}catch{}if(Z)throw q}return await(0,A.$zh)(Math.min(100,X*10)),O(V,ee,oe,ue,X+1)}}async function d(V,ee,oe){return w(V,ee,{root:{source:V,target:ee},options:oe,handledSourcePaths:new Set})}const I=511;async function w(V,ee,oe){if(oe.handledSourcePaths.has(V))return;oe.handledSourcePaths.add(V);const{stat:ue,symbolicLink:X}=await o.stat(V);if(X){if(oe.options.preserveSymlinks)try{return await te(V,ee,oe)}catch{}if(X.dangling)return}return ue.isDirectory()?D(V,ee,ue.mode&I,oe):Y(V,ee,ue.mode&I)}async function D(V,ee,oe,ue){await e.Promises.mkdir(ee,{recursive:!0,mode:oe});const X=await s(V);for(const q of X)await w((0,h.$jc)(V,q),(0,h.$jc)(ee,q),ue)}async function Y(V,ee,oe){await e.Promises.copyFile(V,ee),await e.Promises.chmod(ee,oe)}async function te(V,ee,oe){let ue=await e.Promises.readlink(V);(0,j.$xg)(ue,oe.root.source,!r.$k)&&(ue=(0,h.$jc)(oe.root.target,ue.substr(oe.root.source.length+1))),await e.Promises.symlink(ue,ee)}e.Promises=new class{get access(){return(0,E.promisify)(y.access)}get stat(){return(0,E.promisify)(y.stat)}get lstat(){return(0,E.promisify)(y.lstat)}get utimes(){return(0,E.promisify)(y.utimes)}get read(){return(V,ee,oe,ue,X)=>new Promise((q,Z)=>{y.read(V,ee,oe,ue,X,(_,de,B)=>_?Z(_):q({bytesRead:de,buffer:B}))})}get readFile(){return(0,E.promisify)(y.readFile)}get write(){return(V,ee,oe,ue,X)=>new Promise((q,Z)=>{y.write(V,ee,oe,ue,X,(_,de,B)=>_?Z(_):q({bytesWritten:de,buffer:B}))})}get appendFile(){return(0,E.promisify)(y.appendFile)}get fdatasync(){return(0,E.promisify)(y.fdatasync)}get truncate(){return(0,E.promisify)(y.truncate)}get copyFile(){return(0,E.promisify)(y.copyFile)}get open(){return(0,E.promisify)(y.open)}get close(){return(0,E.promisify)(y.close)}get symlink(){return(0,E.promisify)(y.symlink)}get readlink(){return(0,E.promisify)(y.readlink)}get chmod(){return(0,E.promisify)(y.chmod)}get mkdir(){return(0,E.promisify)(y.mkdir)}get unlink(){return(0,E.promisify)(y.unlink)}get rmdir(){return(0,E.promisify)(y.rmdir)}get realpath(){return(0,E.promisify)(y.realpath)}async exists(V){try{return await e.Promises.access(V),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return i}get writeFile(){return m}get rm(){return a}get rename(){return F}get copy(){return d}}}),define(fe[61],ge([0,1,20,5,24]),function(ae,e,y,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=n,e.$nm=$;const A=/^\d+$/,j=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var h;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(h||(h={}));let r;switch(process.arch){case"ia32":r=1;break;case"arm":case"arm64":r=2;break;default:r=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class l{constructor(i,t,o){this.exePath=i,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await E.SymlinkSupport.existsFile(this.exePath)),this.a}}function P({useAlternateBitness:v=!1}={}){return v?r===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function a({useAlternateBitness:v=!1,findPreview:i=!1}={}){const t=P({useAlternateBitness:v});if(!t)return null;const o=S.$jc(t,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(o))return null;let L=-1,m=null;for(const b of await E.Promises.readdir(o)){let U=-1;if(i){const F=b.indexOf("-");if(F<0)continue;const O=b.substring(0,F);if(!A.test(O)||b.substring(F+1)!=="preview")continue;U=parseInt(O,10)}else{if(!A.test(b))continue;U=parseInt(b,10)}if(U<=L)continue;const K=S.$jc(o,b,"pwsh.exe");await E.SymlinkSupport.existsFile(K)&&(m=K,L=U)}if(!m)return null;const M=t.includes("x86")?" (x86)":"",C=i?" Preview":"";return new l(m,`PowerShell${C}${M}`,!0)}async function c({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const i=S.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=v?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const L of await E.Promises.readdir(i))if(t.test(L)){const m=S.$jc(i,L,"pwsh.exe");return new l(m,o)}return null}function g(){const v=S.$jc(y.homedir(),".dotnet","tools","pwsh.exe");return new l(v,".NET Core PowerShell Global Tool")}function f(){const v=S.$jc(process.env.windir,r===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new l(v,"Windows PowerShell",!0)}async function*s(){let v=await a();v&&(yield v),v=await a({useAlternateBitness:!0}),v&&(yield v),v=await c(),v&&(yield v),v=g(),v&&(yield v),v=await a({findPreview:!0}),v&&(yield v),v=await c({findPreview:!0}),v&&(yield v),v=await a({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=f(),v&&(yield v)}async function*n(){for await(const v of s())await v.exists()&&(yield v)}async function $(){for await(const v of n())return v;return null}}),define(fe[34],ge([0,1,5,3,15,33,10,24]),function(ae,e,y,S,E,A,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$qm=h,e.$rm=r,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function h(l=E.env){return l.comspec||"cmd.exe"}function r(l){let P=[],a=!1;const c=function(g){if(a){P.push(g);return}(!l.send(g,s=>{if(s&&console.error(s),a=!1,P.length>0){const n=P.slice(0);P=[],n.forEach($=>c($))}})||S.$i)&&(a=!0)};return{send:c}}var p;(function(l){async function P(a,c,g){if(y.$ic(a))return a;if(c===void 0&&(c=E.cwd()),y.$mc(a)!=="."||(g===void 0&&j.$$f(E.env.PATH)&&(g=E.env.PATH.split(y.$tc)),g===void 0||g.length===0))return y.$jc(c,a);async function s(n){if(await k.Promises.exists(n)){let $;try{$=await k.Promises.stat(n)}catch(v){v.message.startsWith("EACCES")&&($=await k.Promises.lstat(n))}return $?!$.isDirectory():!1}return!1}for(const n of g){let $;if(y.$ic(n)?$=y.$jc(n,a):$=y.$jc(c,n,a),await s($))return $;let v=$+".com";if(await s(v)||(v=$+".exe",await s(v)))return v}return y.$jc(c,a)}l.findExecutable=P})(p||(e.win32=p={}))}),define(fe[62],ge([0,1,26,19]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=E;function E(j){return new Promise((k,h)=>{let r;const p=new Map;function l(a,c,g,f,s){const n=p.get(c);if(a===j||n){const $={name:P(g),cmd:g,pid:a,ppid:c,load:f,mem:s};p.set(a,$),a===j&&(r=$),n&&(n.children||(n.children=[]),n.children.push($),n.children.length>1&&(n.children=n.children.sort((v,i)=>v.pid-i.pid)))}}function P(a){const c=/--utility-sub-type=network/i,g=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,s=/conhost\.exe.+--headless/i,n=/--type=([a-zA-Z-]+)/;if(g.exec(a))return"electron-crash-reporter";if(f.exec(a))return"winpty-agent";if(s.exec(a))return"conpty-agent";let $=n.exec(a);if($&&$.length===2)return $[1]==="renderer"?"window":$[1]==="utility"?c.exec(a)?"utility-network-service":"utility-process":$[1]==="extensionHost"?"extension-host":$[1];const v=/[a-zA-Z-]+\.js/g;let i="";do $=v.exec(a),$&&(i+=$+" ");while($);return i&&a.indexOf("node ")<0&&a.indexOf("node.exe")<0?`electron-nodejs (${i})`:a}if(process.platform==="win32"){const a=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substring(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substring(5):c;new Promise((c,g)=>{ae(["@vscode/windows-process-tree"],c,g)}).then(c=>{c.getProcessList(j,g=>{if(!g){h(new Error(`Root process ${j} not found`));return}c.getProcessCpuUsage(g,f=>{const s=new Map;f.forEach(n=>{const $=a(n.commandLine||"");s.set(n.pid,{name:P($),cmd:$,pid:n.pid,ppid:n.ppid,load:n.cpu||0,mem:n.memory||0})}),r=s.get(j),r?(s.forEach(n=>{const $=s.get(n.ppid);$&&($.children||($.children=[]),$.children.push(n))}),s.forEach(n=>{n.children&&(n.children=n.children.sort(($,v)=>$.pid-v.pid))}),k(r)):h(new Error(`Root process ${j} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let a=function(){let c=[r];const g=[];for(;c.length;){const s=c.shift();s&&(g.push(s.pid),s.children&&(c=c.concat(s.children)))}let f=JSON.stringify(S.$Sg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+g.join(" "),(0,y.exec)(f,{},(s,n,$)=>{if(s||$)h(s||new Error($.toString()));else{const v=n.toString().split(`
`);for(let i=0;i<g.length;i++){const t=p.get(g[i]);t.load=parseFloat(v[i])}if(!r){h(new Error(`Root process ${j} not found`));return}k(r)}})};(0,y.exec)("which ps",{},(c,g,f)=>{if(c||f)if(process.platform!=="linux")h(c||new Error(f.toString()));else{const s=JSON.stringify(S.$Sg.asFileUri("vs/base/node/ps.sh").fsPath);(0,y.exec)(s,{},(n,$,v)=>{n||v?h(n||new Error(v.toString())):(A($,l),a())})}else{const s=g.toString().trim();(0,y.exec)(`${s} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},($,v,i)=>{$||i&&!i.includes("screen size is bogus")?h($||new Error(i.toString())):(A(v,l),process.platform==="linux"?a():r?k(r):h(new Error(`Root process ${j} not found`)))})}})}})}function A(j,k){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,r=j.toString().split(`
`);for(const p of r){const l=h.exec(p.trim());l&&l.length===6&&k(parseInt(l[1]),parseInt(l[2]),l[5],parseFloat(l[3]),parseFloat(l[4]))}}}),define(fe[63],ge([0,1,20,3,61,34]),function(ae,e,y,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=j;async function j(l,P){return l===1?S.$i?p():A.$qm(P):h(l,P)}let k=null;function h(l,P){if(S.$k&&l===2||S.$j&&l===3)return"/bin/bash";if(!k){let a;if(S.$i)a="/bin/bash";else{if(a=P.SHELL,!a)try{a=(0,y.userInfo)().shell}catch{}a||(a="sh"),a==="/bin/false"&&(a="/bin/bash")}k=a}return k}let r=null;async function p(){return r||(r=(await(0,E.$nm)()).exePath),r}});var be=this&&this.__decorate||function(ae,e,y,S){var E=arguments.length,A=E<3?e:S===null?S=Object.getOwnPropertyDescriptor(e,y):S,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ae,e,y,S);else for(var k=ae.length-1;k>=0;k--)(j=ae[k])&&(A=(E<3?j(A):E>3?j(e,y,A):j(e,y))||A);return E>3&&A&&Object.defineProperty(e,y,A),A};define(fe[27],ge([0,1,16,12,18,17,14,7,4,2,59,9,10]),function(ae,e,y,S,E,A,j,k,h,r,p,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.ProxyChannel=e.$gi=e.$di=e.$ci=e.$bi=e.RequestInitiator=e.$ai=e.$0h=e.$9h=void 0,e.$$h=C,e.$_h=b,e.$ei=I,e.$fi=w;var a;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(a||(a={}));function c(X){switch(X){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(g||(g={}));function f(X){switch(X){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(s||(s={}));function n(X){let q=0;for(let Z=0;;Z+=7){const _=X.read(1);if(q|=(_.buffer[0]&127)<<Z,!(_.buffer[0]&128))return q}}const $=L(0);function v(X,q){if(q===0){X.write($);return}let Z=0;for(let de=q;de!==0;de=de>>>7)Z++;const _=E.$He.alloc(Z);for(let de=0;q!==0;de++)_.buffer[de]=q&127,q=q>>>7,q>0&&(_.buffer[de]|=128);X.write(_)}class i{constructor(q){this.b=q,this.a=0}read(q){const Z=this.b.slice(this.a,this.a+q);return this.a+=Z.byteLength,Z}}e.$9h=i;class t{constructor(){this.a=[]}get buffer(){return E.$He.concat(this.a)}write(q){this.a.push(q)}}e.$0h=t;var o;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(o||(o={}));function L(X){const q=E.$He.alloc(1);return q.writeUInt8(X,0),q}const m={Undefined:L(o.Undefined),String:L(o.String),Buffer:L(o.Buffer),VSBuffer:L(o.VSBuffer),Array:L(o.Array),Object:L(o.Object),Uint:L(o.Int)},M=typeof Buffer<"u";function C(X,q){if(typeof q>"u")X.write(m.Undefined);else if(typeof q=="string"){const Z=E.$He.fromString(q);X.write(m.String),v(X,Z.byteLength),X.write(Z)}else if(M&&Buffer.isBuffer(q)){const Z=E.$He.wrap(q);X.write(m.Buffer),v(X,Z.byteLength),X.write(Z)}else if(q instanceof E.$He)X.write(m.VSBuffer),v(X,q.byteLength),X.write(q);else if(Array.isArray(q)){X.write(m.Array),v(X,q.length);for(const Z of q)C(X,Z)}else if(typeof q=="number"&&(q|0)===q)X.write(m.Uint),v(X,q);else{const Z=E.$He.fromString(JSON.stringify(q));X.write(m.Object),v(X,Z.byteLength),X.write(Z)}}function b(X){switch(X.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return X.read(n(X)).toString();case o.Buffer:return X.read(n(X)).buffer;case o.VSBuffer:return X.read(n(X));case o.Array:{const Z=n(X),_=[];for(let de=0;de<Z;de++)_.push(b(X));return _}case o.Object:return JSON.parse(X.read(n(X)).toString());case o.Int:return n(X)}}class U{constructor(q,Z,_=null,de=1e3){this.h=q,this.j=Z,this.k=_,this.l=de,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(B=>this.q(B)),this.m({type:200})}registerChannel(q,Z){this.b.set(q,Z),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case 200:{const Z=this.o([q.type]);this.k?.logOutgoing(Z,0,1,f(q.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([q.type,q.id],q.data);this.k?.logOutgoing(Z,q.id,1,f(q.type),q.data);return}}}o(q,Z=void 0){const _=new t;return C(_,q),C(_,Z),this.p(_.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const Z=new i(q),_=b(Z),de=b(Z),B=_[0];switch(B){case 100:return this.k?.logIncoming(q.byteLength,_[1],1,`${c(B)}: ${_[2]}.${_[3]}`,de),this.s({type:B,id:_[1],channelName:_[2],name:_[3],arg:de});case 102:return this.k?.logIncoming(q.byteLength,_[1],1,`${c(B)}: ${_[2]}.${_[3]}`,de),this.t({type:B,id:_[1],channelName:_[2],name:_[3],arg:de});case 101:return this.k?.logIncoming(q.byteLength,_[1],1,`${c(B)}`),this.u({type:B,id:_[1]});case 103:return this.k?.logIncoming(q.byteLength,_[1],1,`${c(B)}`),this.u({type:B,id:_[1]})}}s(q){const Z=this.b.get(q.channelName);if(!Z){this.v(q);return}const _=new A.$qe;let de;try{de=Z.call(this.j,q.name,q.arg,_.token)}catch(x){de=Promise.reject(x)}const B=q.id;de.then(x=>{this.m({id:B,data:x,type:201})},x=>{x instanceof Error?this.m({id:B,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split?x.stack.split(`
`):x.stack:void 0},type:202}):this.m({id:B,data:x,type:203})}).finally(()=>{le.dispose(),this.d.delete(q.id)});const le=(0,r.$Sc)(()=>_.cancel());this.d.set(q.id,le)}t(q){const Z=this.b.get(q.channelName);if(!Z){this.v(q);return}const _=q.id,B=Z.listen(this.j,q.name,q.arg)(le=>this.m({id:_,data:le,type:204}));this.d.set(q.id,B)}u(q){const Z=this.d.get(q.id);Z&&(Z.dispose(),this.d.delete(q.id))}v(q){let Z=this.g.get(q.channelName);Z||(Z=[],this.g.set(q.channelName,Z));const _=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:q,timeoutTimer:_})}w(q){const Z=this.g.get(q);if(Z){for(const _ of Z)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.s(_.request);break;case 102:this.t(_.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,r.$Pc)(this.d.values()),this.d.clear()}}e.$ai=U;var K;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})(K||(e.RequestInitiator=K={}));class F{constructor(q,Z=null){this.l=q,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$fe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(_=>this.s(_)),this.j=Z}getChannel(q){const Z=this;return{call(_,de,B){return Z.a?Promise.reject(new k.$5):Z.m(q,_,de,B)},listen(_,de){return Z.a?h.Event.None:Z.o(q,_,de)}}}m(q,Z,_,de=A.CancellationToken.None){const B=this.g++,x={id:B,type:100,channelName:q,name:Z,arg:_};if(de.isCancellationRequested)return Promise.reject(new k.$5);let u;return new Promise((ne,N)=>{if(de.isCancellationRequested)return N(new k.$5);const G=()=>{const J=ie=>{switch(ie.type){case 201:this.f.delete(B),ne(ie.data);break;case 202:{this.f.delete(B);const ce=new Error(ie.data.message);ce.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,ce.name=ie.data.name,N(ce);break}case 203:this.f.delete(B),N(ie.data);break}};this.f.set(B,J),this.p(x)};let W=null;this.b===s.Idle?G():(W=(0,S.$lh)(J=>this.u()),W.then(()=>{W=null,G()}));const H=()=>{W?(W.cancel(),W=null):this.p({id:B,type:101}),N(new k.$5)},R=de.onCancellationRequested(H);u=(0,r.$Rc)((0,r.$Sc)(H),R),this.d.add(u)}).finally(()=>{u.dispose(),this.d.delete(u)})}o(q,Z,_){const de=this.g++,le={id:de,type:102,channelName:q,name:Z,arg:_};let x=null;const u=new h.$fe({onWillAddFirstListener:()=>{x=(0,S.$lh)(ne=>this.u()),x.then(()=>{x=null,this.d.add(u),this.p(le)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.d.delete(u),this.p({id:de,type:103}))}}),z=ne=>u.fire(ne.data);return this.f.set(de,z),u.event}p(q){switch(q.type){case 100:case 102:{const Z=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(Z,q.id,0,`${c(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const Z=this.q([q.type,q.id]);this.j?.logOutgoing(Z,q.id,0,c(q.type));return}}}q(q,Z=void 0){const _=new t;return C(_,q),C(_,Z),this.r(_.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const Z=new i(q),_=b(Z),de=b(Z),B=_[0];switch(B){case 200:return this.j?.logIncoming(q.byteLength,0,0,f(B)),this.t({type:_[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,_[1],0,f(B),de),this.t({type:_[0],id:_[1],data:de})}}t(q){if(q.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,r.$Pc)(this.d.values()),this.d.clear()}}e.$bi=F,be([j.$3h],F.prototype,"onDidInitializePromise",null);class O{get connections(){const q=[];return this.f.forEach(Z=>q.push(Z)),q}constructor(q,Z,_){this.a=new Map,this.f=new Set,this.g=new h.$fe,this.onDidAddConnection=this.g.event,this.h=new h.$fe,this.onDidRemoveConnection=this.h.event,this.j=new r.$Tc,this.j.add(q(({protocol:de,onDidClientDisconnect:B})=>{const le=h.Event.once(de.onMessage);this.j.add(le(x=>{const u=new i(x),z=b(u),ne=new U(de,z,Z,_),N=new F(de,Z);this.a.forEach((W,H)=>ne.registerChannel(H,W));const G={channelServer:ne,channelClient:N,ctx:z};this.f.add(G),this.g.fire(G),this.j.add(B(()=>{ne.dispose(),N.dispose(),this.f.delete(G),this.h.fire(G)}))}))}))}getChannel(q,Z){const _=this;return{call(de,B,le){let x;if((0,P.$mg)(Z)){const z=(0,y.$3b)(_.connections.filter(Z));x=z?Promise.resolve(z):h.Event.toPromise(h.Event.filter(_.onDidAddConnection,Z))}else x=Z.routeCall(_,de,B);const u=x.then(z=>z.channelClient.getChannel(q));return I(u).call(de,B,le)},listen(de,B){if((0,P.$mg)(Z))return _.k(q,Z,de,B);const le=Z.routeEvent(_,de,B).then(x=>x.channelClient.getChannel(q));return I(le).listen(de,B)}}}k(q,Z,_,de){const B=this;let le;const x=new h.$fe({onWillAddFirstListener:()=>{le=new r.$Tc;const u=new h.$le,z=new Map,ne=G=>{const H=G.channelClient.getChannel(q).listen(_,de),R=u.add(H);z.set(G,R)},N=G=>{const W=z.get(G);W&&(W.dispose(),z.delete(G))};B.connections.filter(Z).forEach(ne),h.Event.filter(B.onDidAddConnection,Z)(ne,void 0,le),B.onDidRemoveConnection(N,void 0,le),u.event(x.fire,x,le),le.add(u)},onDidRemoveLastListener:()=>{le?.dispose(),le=void 0}});return x.event}registerChannel(q,Z){this.a.set(q,Z);for(const _ of this.f)_.channelServer.registerChannel(q,Z)}dispose(){this.j.dispose();for(const q of this.f)q.channelClient.dispose(),q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ci=O;class d{constructor(q,Z,_=null){const de=new t;C(de,Z),q.send(de.buffer),this.a=new F(q,_),this.d=new U(q,Z,_)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,Z){this.d.registerChannel(q,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.$di=d;function I(X){return{call(q,Z,_){return X.then(de=>de.call(q,Z,_))},listen(q,Z){const _=new h.$oe;return X.then(de=>_.input=de.listen(q,Z)),_.event}}}function w(X){let q=!1;return{call(Z,_,de){return q?X.call(Z,_,de):(0,S.$zh)(0).then(()=>q=!0).then(()=>X.call(Z,_,de))},listen(Z,_){if(q)return X.listen(Z,_);const de=new h.$oe;return(0,S.$zh)(0).then(()=>q=!0).then(()=>de.input=X.listen(Z,_)),de.event}}}class D{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const Z of q.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await h.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.$gi=D;var Y;(function(X){function q(B,le,x){const u=B,z=x&&x.disableMarshalling,ne=new Map;for(const N in u)_(N)&&ne.set(N,h.Event.buffer(u[N],!0,void 0,le));return new class{listen(N,G,W){const H=ne.get(G);if(H)return H;const R=u[G];if(typeof R=="function"){if(de(G))return R.call(u,W);if(_(G))return ne.set(G,h.Event.buffer(u[G],!0,void 0,le)),ne.get(G)}throw new k.$bb(`Event not found: ${G}`)}call(N,G,W){const H=u[G];if(typeof H=="function"){if(!z&&Array.isArray(W))for(let J=0;J<W.length;J++)W[J]=(0,p.$8h)(W[J]);let R=H.apply(u,W);return R instanceof Promise||(R=Promise.resolve(R)),R}throw new k.$bb(`Method not found: ${G}`)}}}X.fromService=q;function Z(B,le){const x=le&&le.disableMarshalling;return new Proxy({},{get(u,z){if(typeof z=="string")return le?.properties?.has(z)?le.properties.get(z):de(z)?function(ne){return B.listen(z,ne)}:_(z)?B.listen(z):async function(...ne){let N;le&&!(0,P.$hg)(le.context)?N=[le.context,...ne]:N=ne;const G=await B.call(z,N);return x?G:(0,p.$8h)(G)};throw new k.$bb(`Property not found: ${String(z)}`)}})}X.toService=Z;function _(B){return B[0]==="o"&&B[1]==="n"&&l.$yf(B.charCodeAt(2))}function de(B){return/^onDynamic/.test(B)&&l.$yf(B.charCodeAt(9))}})(Y||(e.ProxyChannel=Y={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const q=X.toString();if(q!=="[object Object]")return q}return X}function ee(X){return Array.isArray(X)?X.map(V):V(X)}function oe(X,q,Z,_,de,B,le){le=ee(le);const x=te[de],u=x[_%x.length];let z=[`%c[${X}]%c[${String(q).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${u}`];/\($/.test(B)?(z=z.concat(le),z.push(")")):z.push(le),console.log.apply(console,z)}class ue{constructor(q,Z){this.d=q,this.f=Z,this.a=0,this.b=0}logOutgoing(q,Z,_,de,B){this.b+=q,oe(this.d,this.b,q,Z,_,de,B)}logIncoming(q,Z,_,de,B){this.a+=q,oe(this.f,this.a,q,Z,_,de,B)}}e.$hi=ue}),define(fe[64],ge([0,1,26,12,18,17,58,7,4,2,30,34,33,27]),function(ae,e,y,S,E,A,j,k,h,r,p,l,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=e.$3q=void 0;class c extends a.$ai{constructor(s){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",n=>E.$He.wrap(Buffer.from(n,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.$3q=c;class g{constructor(s,n){this.i=s,this.j=n,this.c=new Set,this.g=new Map,this.h=new h.$fe,this.onDidProcessExit=this.h.event;const $=n&&n.timeout?n.timeout:6e4;this.b=new S.$vh($),this.d=null,this.f=null}getChannel(s){const n=this;return{call($,v,i){return n.k(s,$,v,i)},listen($,v){return n.l(s,$,v)}}}k(s,n,$,v=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(k.$6());this.b.cancel();const i=this.n(s),t=(0,S.$lh)(m=>i.call(n,$,m)),o=v.onCancellationRequested(()=>t.cancel()),L=(0,r.$Sc)(()=>t.cancel());return this.c.add(L),t.finally(()=>{o.dispose(),this.c.delete(L),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(s,n,$){if(!this.b)return h.Event.None;this.b.cancel();let v;const i=new h.$fe({onWillAddFirstListener:()=>{v=this.n(s).listen(n,$)(i.fire,i),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const s=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,p.$5n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(C=>!/^--inspect(-brk)?=/.test(C)).filter(C=>!C.startsWith("--vscode-"))),(0,P.$pm)(n.env),this.d=(0,y.fork)(this.i,s,n);const $=new h.$fe,i=h.Event.fromNodeEventEmitter(this.d,"message",C=>C)(C=>{if((0,j.$Yq)(C)){(0,j.log)(C,`IPC Library: ${this.j.serverName}`);return}$.fire(E.$He.wrap(Buffer.from(C,"base64")))}),t=this.j.useQueue?(0,l.$rm)(this.d):this.d,o=C=>this.d&&this.d.connected&&t.send(C.buffer.toString("base64")),L=$.event,m={send:o,onMessage:L};this.f=new a.$bi(m);const M=()=>this.o();process.once("exit",M),this.d.on("error",C=>console.warn('IPC "'+this.j.serverName+'" errored with '+C)),this.d.on("exit",(C,b)=>{process.removeListener("exit",M),i.dispose(),this.c.forEach(U=>(0,r.$Pc)(U)),this.c.clear(),C!==0&&b!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+C+" and signal "+b),this.b?.cancel(),this.o(),this.h.fire({code:C,signal:b})})}return this.f}n(s){let n=this.g.get(s);return n||(n=this.m.getChannel(s),this.g.set(s,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$4q=g}),define(fe[65],ge([0,1,31,18,27,4,10,16]),function(ae,e,y,S,E,A,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uW=void 0,e.$vW=p;class h{constructor(P){this.a=P,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",a=>a.data?S.$He.wrap(a.data):S.$He.alloc(0)),P.start()}send(P){this.a.postMessage(P.buffer)}disconnect(){this.a.close()}}class r extends E.$ci{static b(P){(0,j.$ig)((0,y.$tW)(process),"Electron Utility Process");const a=new A.$fe;return process.parentPort.on("message",c=>{if(P?.handledClientConnection(c))return;const g=(0,k.$Ob)(c.ports);g&&a.fire(g)}),A.Event.map(a.event,c=>({protocol:new h(c),onDidClientDisconnect:A.Event.fromNodeEventEmitter(c,"close")}))}constructor(P){super(r.b(P))}}e.$uW=r;function p(l,P,a){const c=g=>{g.data===P&&(l.removeListener("message",c),a())};l.on("message",c)}}),define(fe[66],ge([13,11]),function(ae,e){return ae.create("vs/platform/contextkey/common/contextkey",e)}),define(fe[67],ge([13,11]),function(ae,e){return ae.create("vs/platform/contextkey/common/scanner",e)}),define(fe[68],ge([13,11]),function(ae,e){return ae.create("vs/platform/environment/node/argv",e)}),define(fe[69],ge([13,11]),function(ae,e){return ae.create("vs/platform/files/common/files",e)}),define(fe[70],ge([13,11]),function(ae,e){return ae.create("vs/platform/log/common/log",e)}),define(fe[71],ge([13,11]),function(ae,e){return ae.create("vs/platform/terminal/node/ptyService",e)}),define(fe[72],ge([13,11]),function(ae,e){return ae.create("vs/platform/terminal/node/terminalProcess",e)}),define(fe[73],ge([0,1,7,67]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.TokenType=void 0;var E;(function(r){r[r.LParen=0]="LParen",r[r.RParen=1]="RParen",r[r.Neg=2]="Neg",r[r.Eq=3]="Eq",r[r.NotEq=4]="NotEq",r[r.Lt=5]="Lt",r[r.LtEq=6]="LtEq",r[r.Gt=7]="Gt",r[r.GtEq=8]="GtEq",r[r.RegexOp=9]="RegexOp",r[r.RegexStr=10]="RegexStr",r[r.True=11]="True",r[r.False=12]="False",r[r.In=13]="In",r[r.Not=14]="Not",r[r.And=15]="And",r[r.Or=16]="Or",r[r.Str=17]="Str",r[r.QuotedStr=18]="QuotedStr",r[r.Error=19]="Error",r[r.EOF=20]="EOF"})(E||(e.TokenType=E={}));function A(...r){switch(r.length){case 1:return(0,S.localize)(0,null,r[0]);case 2:return(0,S.localize)(1,null,r[0],r[1]);case 3:return(0,S.localize)(2,null,r[0],r[1],r[2]);default:return}}const j=(0,S.localize)(3,null),k=(0,S.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(p){switch(p.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return p.isTripleEq?"===":"==";case 4:return p.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return p.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return p.lexeme;case 18:return p.lexeme;case 19:return p.lexeme;case 20:return"EOF";default:throw(0,y.$8)(`unhandled token type: ${JSON.stringify(p)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(p=>p.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(p){return this.c=p,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const l=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:l})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const l=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:l})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(p){return this.r()||this.c.charCodeAt(this.e)!==p?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(p){this.f.push({type:p,offset:this.d})}l(p){const l=this.d,P=this.c.substring(this.d,this.e),a={type:19,offset:this.d,lexeme:P};this.g.push({offset:l,lexeme:P,additionalInfo:p}),this.f.push(a)}n(){this.m.lastIndex=this.d;const p=this.m.exec(this.c);if(p){this.e=this.d+p[0].length;const l=this.c.substring(this.d,this.e),P=h.b.get(l);P?this.k(P):this.f.push({type:17,lexeme:l,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let p=this.e,l=!1,P=!1;for(;;){if(p>=this.c.length){this.e=p,this.l(k);return}const c=this.c.charCodeAt(p);if(l)l=!1;else if(c===47&&!P){p++;break}else c===91?P=!0:c===92?l=!0:c===93&&(P=!1);p++}for(;p<this.c.length&&h.a.has(this.c.charCodeAt(p));)p++;this.e=p;const a=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:a,offset:this.d})}r(){return this.e>=this.c.length}}e.$tj=h}),define(fe[74],ge([0,1,54,14,19,5,15,23,6]),function(ae,e,y,S,E,A,j,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=void 0,e.$9m=p,e.$0m=l,e.$7m=/^([^.]+\..+)[:=](.+)$/;class r{get appRoot(){return(0,A.$mc)(E.$Sg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,A.$jc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,k.$_g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:E.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,k.$_g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const a=(0,y.$6m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$jc)(this.userDataPath,"logs",a)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.$_g)(h.URI.file((0,A.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.$_g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.$_g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.$_g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const a=j.env.VSCODE_PORTABLE;return a?h.URI.file((0,A.$jc)(a,"argv.json")):(0,k.$_g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,A.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const a=this.args["builtin-extensions-dir"];return a?(0,A.$kc)(a):(0,A.$hc)((0,A.$jc)(E.$Sg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const a=this.args["extensions-download-dir"];return a?h.URI.file((0,A.$kc)(a)):h.URI.file((0,A.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const a=this.args["extensions-dir"];if(a)return(0,A.$kc)(a);const c=j.env.VSCODE_EXTENSIONS;if(c)return c;const g=j.env.VSCODE_PORTABLE;return g?(0,A.$jc)(g,"extensions"):(0,k.$_g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const a=this.args.extensionDevelopmentPath;if(Array.isArray(a))return a.map(c=>/^[^:/?#]+?:\/\//.test(c)?h.URI.parse(c):h.URI.file((0,A.$hc)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(a=>a==="ui"||a==="workspace"||a==="web"?a:"workspace")}get extensionTestsLocationURI(){const a=this.args.extensionTestsPath;if(a)return/^[^:/?#]+?:\/\//.test(a)?h.URI.parse(a):h.URI.file((0,A.$hc)(a))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const a=this.args["disable-extension"];if(a){if(typeof a=="string")return[a];if(Array.isArray(a)&&a.length>0)return a}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(a=>!e.$7m.test(a))}get extensionLogLevel(){const a=[];for(const c of this.args.log||[]){const g=e.$7m.exec(c);g&&g[1]&&g[2]&&a.push([g[1],g[2]])}return a.length?a:void 0}get serviceMachineIdResource(){return(0,k.$_g)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const a=j.env.VSCODE_PORTABLE;return a?h.URI.file((0,A.$jc)(a,"policy.json")):(0,k.$_g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(a){this.args.continueOn=a}get args(){return this.a}constructor(a,c,g){this.a=a,this.b=c,this.c=g,this.editSessionId=this.args.editSessionId}}e.$8m=r,be([S.$3h],r.prototype,"appRoot",null),be([S.$3h],r.prototype,"userHome",null),be([S.$3h],r.prototype,"userDataPath",null),be([S.$3h],r.prototype,"appSettingsHome",null),be([S.$3h],r.prototype,"tmpDir",null),be([S.$3h],r.prototype,"cacheHome",null),be([S.$3h],r.prototype,"stateResource",null),be([S.$3h],r.prototype,"userRoamingDataHome",null),be([S.$3h],r.prototype,"userDataSyncHome",null),be([S.$3h],r.prototype,"sync",null),be([S.$3h],r.prototype,"machineSettingsResource",null),be([S.$3h],r.prototype,"workspaceStorageHome",null),be([S.$3h],r.prototype,"localHistoryHome",null),be([S.$3h],r.prototype,"keyboardLayoutResource",null),be([S.$3h],r.prototype,"argvResource",null),be([S.$3h],r.prototype,"isExtensionDevelopment",null),be([S.$3h],r.prototype,"untitledWorkspacesHome",null),be([S.$3h],r.prototype,"builtinExtensionsPath",null),be([S.$3h],r.prototype,"extensionsPath",null),be([S.$3h],r.prototype,"extensionDevelopmentLocationURI",null),be([S.$3h],r.prototype,"extensionDevelopmentKind",null),be([S.$3h],r.prototype,"extensionTestsLocationURI",null),be([S.$3h],r.prototype,"debugExtensionHost",null),be([S.$3h],r.prototype,"logLevel",null),be([S.$3h],r.prototype,"extensionLogLevel",null),be([S.$3h],r.prototype,"serviceMachineIdResource",null),be([S.$3h],r.prototype,"disableTelemetry",null),be([S.$3h],r.prototype,"disableWorkspaceTrust",null),be([S.$3h],r.prototype,"useInMemorySecretStorage",null),be([S.$3h],r.prototype,"policyFile",null);function p(P,a){return l(P["inspect-extensions"],P["inspect-brk-extensions"],5870,a,P.debugId,P.extensionEnvironment)}function l(P,a,c,g,f,s){const $=Number(a||P)||(g?null:c),v=$?!!a:!1;let i;if(s)try{i=JSON.parse(s)}catch{}return{port:$,break:v,debugId:f,env:i}}}),define(fe[75],ge([0,1,108,3,68]),function(ae,e,y,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0,e.$vm=k,e.$wm=r,e.$xm=a,e.$ym=c;const A={o:(0,E.localize)(0,null),e:(0,E.localize)(1,null),t:(0,E.localize)(2,null)};e.$tm=["tunnel","serve-web"],e.$um={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,E.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,E.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,E.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,E.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,E.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,E.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,E.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,E.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,E.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,E.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,E.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,E.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,E.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,E.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,E.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,E.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,E.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,E.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,E.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,E.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,E.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,E.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,E.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,E.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,E.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,E.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,E.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,E.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,E.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,E.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,E.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,E.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const j={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(g,f,s=j){const n=g.find(C=>C.length>0&&C[0]!=="-"),$={},v=["_"],i=[],t={};let o;for(const C in f){const b=f[C];b.type==="subcommand"?C===n&&(o=b):(b.alias&&($[C]=b.alias),b.type==="string"||b.type==="string[]"?(v.push(C),b.deprecates&&v.push(...b.deprecates)):b.type==="boolean"&&(i.push(C),b.deprecates&&i.push(...b.deprecates)),b.global&&(t[C]=b))}if(o&&n){const C=t;for(const F in o.options)C[F]=o.options[F];const b=g.filter(F=>F!==n),U=s.getSubcommandReporter?s.getSubcommandReporter(n):void 0,K=k(b,C,U);return{[n]:K,_:[]}}const L=y(g,{string:v,boolean:i,alias:$}),m={},M=L;m._=L._.map(C=>String(C)).filter(C=>C.length>0),delete M._;for(const C in f){const b=f[C];if(b.type==="subcommand")continue;b.alias&&delete M[b.alias];let U=M[C];if(b.deprecates)for(const K of b.deprecates)M.hasOwnProperty(K)&&(U||(U=M[K],U&&s.onDeprecatedOption(K,b.deprecationMessage||(0,E.localize)(39,null,C))),delete M[K]);if(typeof U<"u"){if(b.type==="string[]"){if(Array.isArray(U)||(U=[U]),!b.allowEmptyValue){const K=U.filter(F=>F.length>0);K.length!==U.length&&(s.onEmptyValue(C),U=K.length>0?K:void 0)}}else b.type==="string"&&(Array.isArray(U)?(U=U.pop(),s.onMultipleValues(C,U)):!U&&!b.allowEmptyValue&&(s.onEmptyValue(C),U=void 0));m[C]=U,b.deprecationMessage&&s.onDeprecatedOption(C,b.deprecationMessage)}delete M[C]}for(const C in M)s.onUnknownOption(C);return m}function h(g,f){let s="";return f.args&&(Array.isArray(f.args)?s=` <${f.args.join("> <")}>`:s=` <${f.args}>`),f.alias?`-${f.alias} --${g}${s}`:`--${g}${s}`}function r(g,f){const s=[];for(const n in g){const $=g[n],v=h(n,$);s.push([v,$.description])}return p(s,f)}function p(g,f){const n=g.reduce((i,t)=>Math.max(i,t[0].length),12)+2+1;if(f-n<25)return g.reduce((i,t)=>i.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const $=f-n-1,v=[];for(const i of g){const t=i[0],o=P(i[1],$),L=l(n-t.length-2);v.push("  "+t+L+o[0]);for(let m=1;m<o.length;m++)v.push(l(n)+o[m])}return v}function l(g){return" ".repeat(g)}function P(g,f){const s=[];for(;g.length;){const n=g.length<f?g.length:g.lastIndexOf(" ",f),$=g.slice(0,n).trim();g=g.slice(n),s.push($)}return s}function a(g,f,s,n,$){const v=process.stdout.isTTY&&process.stdout.columns||80,i=$?.noInputFiles!==!0?`[${(0,E.localize)(40,null)}...]`:"",t=[`${g} ${s}`];t.push(""),t.push(`${(0,E.localize)(41,null)}: ${f} [${(0,E.localize)(42,null)}]${i}`),t.push(""),$?.noPipe!==!0&&(S.$i?t.push((0,E.localize)(43,null,f)):t.push((0,E.localize)(44,null,f)),t.push(""));const o={},L=[];for(const m in n){const M=n[m];if(M.type==="subcommand")M.description&&L.push({command:m,description:M.description});else if(M.description&&M.cat){let C=o[M.cat];C||(o[M.cat]=C={}),C[m]=M}}for(const m in o){const M=m,C=o[M];C&&(t.push(A[M]),t.push(...r(C,v)),t.push(""))}return L.length&&(t.push((0,E.localize)(45,null)),t.push(...p(L.map(m=>[m.command,m.description]),v)),t.push("")),t.join(`
`)}function c(g,f){return`${g||(0,E.localize)(46,null)}
${f||(0,E.localize)(47,null)}
${process.arch}`}}),function(){"use strict";function ae(e,y,S){function E(j,k){const h=A(j,k),r=[h];return e.isAbsolute(h)||r.unshift(S),e.resolve(...r)}function A(j,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let r=process.env.VSCODE_APPDATA;if(r)return e.join(r,k);const p=j["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(r=process.env.APPDATA,!r){const l=process.env.USERPROFILE;if(typeof l!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");r=e.join(l,"AppData","Roaming")}break;case"darwin":r=e.join(y.homedir(),"Library","Application Support");break;case"linux":r=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(r,k)}return{getUserDataPath:E}}if(typeof define=="function")define(fe[76],ge([77,20,15]),function(e,y,S){return ae(e,y,S.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("os");module.exports=ae(e,y,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(fe[78],ge([0,1,20,74,76]),function(ae,e,y,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=void 0,e.$_m=j,e.$an=k;class A extends S.$8m{constructor(r,p){super(r,{homeDir:(0,y.homedir)(),tmpDir:(0,y.tmpdir)(),userDataDir:(0,E.getUserDataPath)(r,p.nameShort)},p)}}e.$$m=A;function j(h,r){return(0,S.$0m)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,r,h.extensionEnvironment)}function k(h,r){return(0,S.$0m)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,r,h.extensionEnvironment)}}),define(fe[21],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e._util=void 0,e.$yi=E,e.$zi=A;var y;(function(j){j.serviceIds=new Map,j.DI_TARGET="$di$target",j.DI_DEPENDENCIES="$di$dependencies";function k(h){return h[j.DI_DEPENDENCIES]||[]}j.getServiceDependencies=k})(y||(e._util=y={})),e.$xi=E("instantiationService");function S(j,k,h){k[y.DI_TARGET]===k?k[y.DI_DEPENDENCIES].push({id:j,index:h}):(k[y.DI_DEPENDENCIES]=[{id:j,index:h}],k[y.DI_TARGET]=k)}function E(j){if(y.serviceIds.has(j))return y.serviceIds.get(j);const k=function(h,r,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");S(k,h,p)};return k.toString=()=>j,y.serviceIds.set(j,k),k}function A(j){return j}}),define(fe[35],ge([0,1,3,9,73,21,66,7]),function(ae,e,y,S,E,A,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$wj=e.$vj=e.ContextKeyExprType=void 0,e.$uj=r,e.$xj=o,e.$yj=L,e.$Rj=de;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",y.$j),h.set("isLinux",y.$k),h.set("isWindows",y.$i),h.set("isWeb",y.$o),h.set("isMacNative",y.$j&&!y.$o),h.set("isEdge",y.$H),h.set("isFirefox",y.$F),h.set("isChrome",y.$E),h.set("isSafari",y.$G);function r(x,u){if(h.get(x)!==void 0)throw(0,k.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(x,u)}const p=Object.prototype.hasOwnProperty;var l;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(l||(e.ContextKeyExprType=l={}));const P={regexParsingWithErrorRecovery:!0},a=(0,j.localize)(0,null),c=(0,j.localize)(1,null),g=(0,j.localize)(2,null),f=(0,j.localize)(3,null),s=(0,j.localize)(4,null),n=(0,j.localize)(5,null),$=(0,j.localize)(6,null),v=(0,j.localize)(7,null);class i{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(u=P){this.k=u,this.d=new E.$tj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(u){if(u===""){this.h.push({message:a,offset:0,lexeme:"",additionalInfo:c});return}this.f=this.d.reset(u).scan(),this.g=0,this.h=[];try{const z=this.l();if(!this.E()){const ne=this.D(),N=ne.type===17?n:void 0;throw this.h.push({message:s,offset:ne.offset,lexeme:E.$tj.getLexeme(ne),additionalInfo:N}),i.c}return z}catch(z){if(z!==i.c)throw z;return}}l(){return this.m()}m(){const u=[this.o()];for(;this.y(16);){const z=this.o();u.push(z)}return u.length===1?u[0]:t.or(...u)}o(){const u=[this.s()];for(;this.y(15);){const z=this.s();u.push(z)}return u.length===1?u[0]:t.and(...u)}s(){if(this.y(2)){const u=this.D();switch(u.type){case 11:return this.z(),M.INSTANCE;case 12:return this.z(),C.INSTANCE;case 0:{this.z();const z=this.l();return this.A(1,f),z?.negate()}case 17:return this.z(),d.create(u.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",u)}}return this.t()}t(){const u=this.D();switch(u.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const z=this.l();return this.A(1,f),z}case 17:{const z=u.lexeme;if(this.z(),this.y(9)){const N=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),N.type!==10)throw this.B("REGEX",N);const G=N.lexeme,W=G.lastIndexOf("/"),H=W===G.length-1?void 0:this.w(G.substring(W+1));let R;try{R=new RegExp(G.substring(1,W),H)}catch{throw this.B("REGEX",N)}return V.create(z,R)}switch(N.type){case 10:case 19:{const G=[N.lexeme];this.z();let W=this.D(),H=0;for(let se=0;se<N.lexeme.length;se++)N.lexeme.charCodeAt(se)===40?H++:N.lexeme.charCodeAt(se)===41&&H--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:H++;break;case 1:H--;break;case 10:case 18:for(let se=0;se<W.lexeme.length;se++)W.lexeme.charCodeAt(se)===40?H++:N.lexeme.charCodeAt(se)===41&&H--}if(H<0)break;G.push(E.$tj.getLexeme(W)),this.z(),W=this.D()}const R=G.join(""),J=R.lastIndexOf("/"),ie=J===R.length-1?void 0:this.w(R.substring(J+1));let ce;try{ce=new RegExp(R.substring(1,J),ie)}catch{throw this.B("REGEX",N)}return t.regex(z,ce)}case 18:{const G=N.lexeme;this.z();let W=null;if(!(0,S.$9e)(G)){const H=G.indexOf("/"),R=G.lastIndexOf("/");if(H!==R&&H>=0){const J=G.slice(H+1,R),ie=G[R+1]==="i"?"i":"";try{W=new RegExp(J,ie)}catch{throw this.B("REGEX",N)}}}if(W===null)throw this.B("REGEX",N);return V.create(z,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,g);const N=this.u();return t.notIn(z,N)}switch(this.D().type){case 3:{this.z();const N=this.u();if(this.x().type===18)return t.equals(z,N);switch(N){case"true":return t.has(z);case"false":return t.not(z);default:return t.equals(z,N)}}case 4:{this.z();const N=this.u();if(this.x().type===18)return t.notEquals(z,N);switch(N){case"true":return t.not(z);case"false":return t.has(z);default:return t.notEquals(z,N)}}case 5:return this.z(),Y.create(z,this.u());case 6:return this.z(),te.create(z,this.u());case 7:return this.z(),w.create(z,this.u());case 8:return this.z(),D.create(z,this.u());case 13:return this.z(),t.in(z,this.u());default:return t.has(z)}}case 20:throw this.h.push({message:$,offset:u.offset,lexeme:"",additionalInfo:v}),i.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const u=this.D();switch(u.type){case 17:case 18:return this.z(),u.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(u){return u.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(u){return this.C(u)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(u,z){if(this.C(u))return this.z();throw this.B(z,this.D())}B(u,z,ne){const N=(0,j.localize)(8,null,u,E.$tj.getLexeme(z)),G=z.offset,W=E.$tj.getLexeme(z);return this.h.push({message:N,offset:G,lexeme:W,additionalInfo:ne}),i.c}C(u){return this.D().type===u}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$vj=i;class t{static false(){return M.INSTANCE}static true(){return C.INSTANCE}static has(u){return b.create(u)}static equals(u,z){return U.create(u,z)}static notEquals(u,z){return O.create(u,z)}static regex(u,z){return V.create(u,z)}static in(u,z){return K.create(u,z)}static notIn(u,z){return F.create(u,z)}static not(u){return d.create(u)}static and(...u){return ue.create(u,null,!0)}static or(...u){return X.create(u,null,!0)}static greater(u,z){return w.create(u,z)}static greaterEquals(u,z){return D.create(u,z)}static smaller(u,z){return Y.create(u,z)}static smallerEquals(u,z){return te.create(u,z)}static{this.c=new i({regexParsingWithErrorRecovery:!1})}static deserialize(u){return u==null?void 0:this.c.parse(u)}}e.$wj=t;function o(x){const u=new i({regexParsingWithErrorRecovery:!1});return x.map(z=>(u.parse(z),u.lexingErrors.length>0?u.lexingErrors.map(ne=>({errorMessage:ne.additionalInfo?(0,j.localize)(9,null,ne.additionalInfo):(0,j.localize)(10,null),offset:ne.offset,length:ne.lexeme.length})):u.parsingErrors.length>0?u.parsingErrors.map(ne=>({errorMessage:ne.additionalInfo?`${ne.message}. ${ne.additionalInfo}`:ne.message,offset:ne.offset,length:ne.lexeme.length})):[]))}function L(x,u){const z=x?x.substituteConstants():void 0,ne=u?u.substituteConstants():void 0;return!z&&!ne?!0:!z||!ne?!1:z.equals(ne)}function m(x,u){return x.cmp(u)}class M{static{this.INSTANCE=new M}constructor(){this.type=0}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}substituteConstants(){return this}evaluate(u){return!1}serialize(){return"false"}keys(){return[]}map(u){return this}negate(){return C.INSTANCE}}e.$zj=M;class C{static{this.INSTANCE=new C}constructor(){this.type=1}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}substituteConstants(){return this}evaluate(u){return!0}serialize(){return"true"}keys(){return[]}map(u){return this}negate(){return M.INSTANCE}}e.$Aj=C;class b{static create(u,z=null){const ne=h.get(u);return typeof ne=="boolean"?ne?C.INSTANCE:M.INSTANCE:new b(u,z)}constructor(u,z){this.key=u,this.c=z,this.type=2}cmp(u){return u.type!==this.type?this.type-u.type:Z(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}substituteConstants(){const u=h.get(this.key);return typeof u=="boolean"?u?C.INSTANCE:M.INSTANCE:this}evaluate(u){return!!u.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(u){return u.mapDefined(this.key)}negate(){return this.c||(this.c=d.create(this.key,this)),this.c}}e.$Bj=b;class U{static create(u,z,ne=null){if(typeof z=="boolean")return z?b.create(u,ne):d.create(u,ne);const N=h.get(u);return typeof N=="boolean"?z===(N?"true":"false")?C.INSTANCE:M.INSTANCE:new U(u,z,ne)}constructor(u,z,ne){this.c=u,this.d=z,this.f=ne,this.type=4}cmp(u){return u.type!==this.type?this.type-u.type:_(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){const u=h.get(this.c);if(typeof u=="boolean"){const z=u?"true":"false";return this.d===z?C.INSTANCE:M.INSTANCE}return this}evaluate(u){return u.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(u){return u.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Cj=U;class K{static create(u,z){return new K(u,z)}constructor(u,z){this.d=u,this.f=z,this.type=10,this.c=null}cmp(u){return u.type!==this.type?this.type-u.type:_(this.d,this.f,u.d,u.f)}equals(u){return u.type===this.type?this.d===u.d&&this.f===u.f:!1}substituteConstants(){return this}evaluate(u){const z=u.getValue(this.f),ne=u.getValue(this.d);return Array.isArray(z)?z.includes(ne):typeof ne=="string"&&typeof z=="object"&&z!==null?p.call(z,ne):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(u){return u.mapIn(this.d,this.f)}negate(){return this.c||(this.c=F.create(this.d,this.f)),this.c}}e.$Dj=K;class F{static create(u,z){return new F(u,z)}constructor(u,z){this.d=u,this.f=z,this.type=11,this.c=K.create(u,z)}cmp(u){return u.type!==this.type?this.type-u.type:this.c.cmp(u.c)}equals(u){return u.type===this.type?this.c.equals(u.c):!1}substituteConstants(){return this}evaluate(u){return!this.c.evaluate(u)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(u){return u.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ej=F;class O{static create(u,z,ne=null){if(typeof z=="boolean")return z?d.create(u,ne):b.create(u,ne);const N=h.get(u);return typeof N=="boolean"?z===(N?"true":"false")?M.INSTANCE:C.INSTANCE:new O(u,z,ne)}constructor(u,z,ne){this.c=u,this.d=z,this.f=ne,this.type=5}cmp(u){return u.type!==this.type?this.type-u.type:_(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){const u=h.get(this.c);if(typeof u=="boolean"){const z=u?"true":"false";return this.d===z?M.INSTANCE:C.INSTANCE}return this}evaluate(u){return u.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(u){return u.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Fj=O;class d{static create(u,z=null){const ne=h.get(u);return typeof ne=="boolean"?ne?M.INSTANCE:C.INSTANCE:new d(u,z)}constructor(u,z){this.c=u,this.d=z,this.type=3}cmp(u){return u.type!==this.type?this.type-u.type:Z(this.c,u.c)}equals(u){return u.type===this.type?this.c===u.c:!1}substituteConstants(){const u=h.get(this.c);return typeof u=="boolean"?u?M.INSTANCE:C.INSTANCE:this}evaluate(u){return!u.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(u){return u.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$Gj=d;function I(x,u){if(typeof x=="string"){const z=parseFloat(x);isNaN(z)||(x=z)}return typeof x=="string"||typeof x=="number"?u(x):M.INSTANCE}class w{static create(u,z,ne=null){return I(z,N=>new w(u,N,ne))}constructor(u,z,ne){this.c=u,this.d=z,this.f=ne,this.type=12}cmp(u){return u.type!==this.type?this.type-u.type:_(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){return this}evaluate(u){return typeof this.d=="string"?!1:parseFloat(u.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(u){return u.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Hj=w;class D{static create(u,z,ne=null){return I(z,N=>new D(u,N,ne))}constructor(u,z,ne){this.c=u,this.d=z,this.f=ne,this.type=13}cmp(u){return u.type!==this.type?this.type-u.type:_(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){return this}evaluate(u){return typeof this.d=="string"?!1:parseFloat(u.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(u){return u.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Ij=D;class Y{static create(u,z,ne=null){return I(z,N=>new Y(u,N,ne))}constructor(u,z,ne){this.c=u,this.d=z,this.f=ne,this.type=14}cmp(u){return u.type!==this.type?this.type-u.type:_(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){return this}evaluate(u){return typeof this.d=="string"?!1:parseFloat(u.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(u){return u.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Jj=Y;class te{static create(u,z,ne=null){return I(z,N=>new te(u,N,ne))}constructor(u,z,ne){this.c=u,this.d=z,this.f=ne,this.type=15}cmp(u){return u.type!==this.type?this.type-u.type:_(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){return this}evaluate(u){return typeof this.d=="string"?!1:parseFloat(u.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(u){return u.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Kj=te;class V{static create(u,z){return new V(u,z)}constructor(u,z){this.d=u,this.f=z,this.type=7,this.c=null}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.d<u.d)return-1;if(this.d>u.d)return 1;const z=this.f?this.f.source:"",ne=u.f?u.f.source:"";return z<ne?-1:z>ne?1:0}equals(u){if(u.type===this.type){const z=this.f?this.f.source:"",ne=u.f?u.f.source:"";return this.d===u.d&&z===ne}return!1}substituteConstants(){return this}evaluate(u){const z=u.getValue(this.d);return this.f?this.f.test(z):!1}serialize(){const u=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${u}`}keys(){return[this.d]}map(u){return u.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ee.create(this)),this.c}}e.$Lj=V;class ee{static create(u){return new ee(u)}constructor(u){this.c=u,this.type=8}cmp(u){return u.type!==this.type?this.type-u.type:this.c.cmp(u.c)}equals(u){return u.type===this.type?this.c.equals(u.c):!1}substituteConstants(){return this}evaluate(u){return!this.c.evaluate(u)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(u){return new ee(this.c.map(u))}negate(){return this.c}}e.$Mj=ee;function oe(x){let u=null;for(let z=0,ne=x.length;z<ne;z++){const N=x[z].substituteConstants();if(x[z]!==N&&u===null){u=[];for(let G=0;G<z;G++)u[G]=x[G]}u!==null&&(u[z]=N)}return u===null?x:u}class ue{static create(u,z,ne){return ue.d(u,z,ne)}constructor(u,z){this.expr=u,this.c=z,this.type=6}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let z=0,ne=this.expr.length;z<ne;z++){const N=m(this.expr[z],u.expr[z]);if(N!==0)return N}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let z=0,ne=this.expr.length;z<ne;z++)if(!this.expr[z].equals(u.expr[z]))return!1;return!0}return!1}substituteConstants(){const u=oe(this.expr);return u===this.expr?this:ue.create(u,this.c,!1)}evaluate(u){for(let z=0,ne=this.expr.length;z<ne;z++)if(!this.expr[z].evaluate(u))return!1;return!0}static d(u,z,ne){const N=[];let G=!1;for(const W of u)if(W){if(W.type===1){G=!0;continue}if(W.type===0)return M.INSTANCE;if(W.type===6){N.push(...W.expr);continue}N.push(W)}if(N.length===0&&G)return C.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(m);for(let W=1;W<N.length;W++)N[W-1].equals(N[W])&&(N.splice(W,1),W--);if(N.length===1)return N[0];for(;N.length>1;){const W=N[N.length-1];if(W.type!==9)break;N.pop();const H=N.pop(),R=N.length===0,J=X.create(W.expr.map(ie=>ue.create([ie,H],null,ne)),null,R);J&&(N.push(J),N.sort(m))}if(N.length===1)return N[0];if(ne){for(let W=0;W<N.length;W++)for(let H=W+1;H<N.length;H++)if(N[W].negate().equals(N[H]))return M.INSTANCE;if(N.length===1)return N[0]}return new ue(N,z)}}serialize(){return this.expr.map(u=>u.serialize()).join(" && ")}keys(){const u=[];for(const z of this.expr)u.push(...z.keys());return u}map(u){return new ue(this.expr.map(z=>z.map(u)),null)}negate(){if(!this.c){const u=[];for(const z of this.expr)u.push(z.negate());this.c=X.create(u,this,!0)}return this.c}}e.$Nj=ue;class X{static create(u,z,ne){return X.d(u,z,ne)}constructor(u,z){this.expr=u,this.c=z,this.type=9}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let z=0,ne=this.expr.length;z<ne;z++){const N=m(this.expr[z],u.expr[z]);if(N!==0)return N}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let z=0,ne=this.expr.length;z<ne;z++)if(!this.expr[z].equals(u.expr[z]))return!1;return!0}return!1}substituteConstants(){const u=oe(this.expr);return u===this.expr?this:X.create(u,this.c,!1)}evaluate(u){for(let z=0,ne=this.expr.length;z<ne;z++)if(this.expr[z].evaluate(u))return!0;return!1}static d(u,z,ne){let N=[],G=!1;if(u){for(let W=0,H=u.length;W<H;W++){const R=u[W];if(R){if(R.type===0){G=!0;continue}if(R.type===1)return C.INSTANCE;if(R.type===9){N=N.concat(R.expr);continue}N.push(R)}}if(N.length===0&&G)return M.INSTANCE;N.sort(m)}if(N.length!==0){if(N.length===1)return N[0];for(let W=1;W<N.length;W++)N[W-1].equals(N[W])&&(N.splice(W,1),W--);if(N.length===1)return N[0];if(ne){for(let W=0;W<N.length;W++)for(let H=W+1;H<N.length;H++)if(N[W].negate().equals(N[H]))return C.INSTANCE;if(N.length===1)return N[0]}return new X(N,z)}}serialize(){return this.expr.map(u=>u.serialize()).join(" || ")}keys(){const u=[];for(const z of this.expr)u.push(...z.keys());return u}map(u){return new X(this.expr.map(z=>z.map(u)),null)}negate(){if(!this.c){const u=[];for(const z of this.expr)u.push(z.negate());for(;u.length>1;){const z=u.shift(),ne=u.shift(),N=[];for(const G of le(z))for(const W of le(ne))N.push(ue.create([G,W],null,!1));u.unshift(X.create(N,null,!1))}this.c=X.create(u,this,!0)}return this.c}}e.$Oj=X;class q extends b{static{this.d=[]}static all(){return q.d.values()}constructor(u,z,ne){super(u,null),this.f=z,typeof ne=="object"?q.d.push({...ne,key:u}):ne!==!0&&q.d.push({key:u,description:ne,type:z!=null?typeof z:void 0})}bindTo(u){return u.createKey(this.key,this.f)}getValue(u){return u.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(u){return U.create(this.key,u)}notEqualsTo(u){return O.create(this.key,u)}}e.$Pj=q,e.$Qj=(0,A.$yi)("contextKeyService");function Z(x,u){return x<u?-1:x>u?1:0}function _(x,u,z,ne){return x<z?-1:x>z?1:u<ne?-1:u>ne?1:0}function de(x,u){if(x.type===0||u.type===1)return!0;if(x.type===9)return u.type===9?B(x.expr,u.expr):!1;if(u.type===9){for(const z of u.expr)if(de(x,z))return!0;return!1}if(x.type===6){if(u.type===6)return B(u.expr,x.expr);for(const z of x.expr)if(de(z,u))return!0;return!1}return x.equals(u)}function B(x,u){let z=0,ne=0;for(;z<x.length&&ne<u.length;){const N=x[z].cmp(u[ne]);if(N<0)return!1;N===0&&z++,ne++}return z===x.length}function le(x){return x.type===9?x.expr:[x]}}),define(fe[79],ge([0,1,51,5,9,10,6,69,21,3,19,22]),function(ae,e,y,S,E,A,j,k,h,r,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$xl=e.FileKind=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.FileOperationResult=e.$pl=e.$ol=e.$nl=e.$ll=e.FileChangeType=e.$kl=e.FileOperation=e.$el=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$5k=void 0,e.$6k=P,e.$7k=f,e.$8k=n,e.$9k=$,e.$0k=v,e.$$k=i,e.$_k=t,e.$al=o,e.$bl=L,e.$cl=m,e.$dl=M,e.$fl=U,e.$gl=K,e.$hl=F,e.$il=O,e.$jl=d,e.$ml=te,e.$yl=q,e.$zl=Z,e.$Bl=de,e.$5k=(0,h.$yi)("fileService");function P(B){return B.create===!0}var a;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(a||(e.FileType=a={}));var c;(function(B){B[B.Readonly=1]="Readonly",B[B.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var g;(function(B){B[B.UPDATED=2]="UPDATED",B[B.ADDED=4]="ADDED",B[B.DELETED=8]="DELETED"})(g||(e.FileChangeFilter=g={}));function f(B){const le=B;return!!le&&typeof le.onDidChange=="function"}var s;(function(B){B[B.None=0]="None",B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileAtomicWrite=32768]="FileAtomicWrite",B[B.FileAtomicDelete=65536]="FileAtomicDelete",B[B.FileClone=131072]="FileClone"})(s||(e.FileSystemProviderCapabilities=s={}));function n(B){return!!(B.capabilities&2)}function $(B){return!!(B.capabilities&8)}function v(B){return!!(B.capabilities&131072)}function i(B){return!!(B.capabilities&4)}function t(B){return!!(B.capabilities&16)}function o(B){return n(B)?!!(B.capabilities&16384):!1}function L(B){return n(B)?!!(B.capabilities&32768):!1}function m(B){return!!(B.capabilities&65536)}function M(B){return!!(B.capabilities&2048)}var C;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsStorageQuota="EntryExceedsStorageQuota",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(C||(e.FileSystemProviderErrorCode=C={}));class b extends Error{static create(le,x){const u=new b(le.toString(),x);return F(u,x),u}constructor(le,x){super(le),this.code=x}}e.$el=b;function U(B,le){return b.create(B,le)}function K(B){return B||U((0,k.localize)(0,null),C.Unknown)}function F(B,le){return B.name=le?`${le} (FileSystemError)`:"FileSystemError",B}function O(B){if(!B)return C.Unknown;if(B instanceof b)return B.code;const le=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!le)return C.Unknown;switch(le[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}function d(B){if(B instanceof V)return B.fileOperationResult;switch(O(B)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 9;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileTooLarge:return 7;default:return 10}}var I;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class w{constructor(le,x,u){this.resource=le,this.operation=x,this.target=u}isOperation(le){return this.operation===le}}e.$kl=w;var D;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(D||(e.FileChangeType=D={}));class Y{static{this.a=null}constructor(le,x){this.c=x,this.b=void 0,this.d=new l.$V(()=>{const u=y.$Ei.forUris(()=>this.c);return u.fill(this.rawAdded.map(z=>[z,!0])),u}),this.f=new l.$V(()=>{const u=y.$Ei.forUris(()=>this.c);return u.fill(this.rawUpdated.map(z=>[z,!0])),u}),this.g=new l.$V(()=>{const u=y.$Ei.forUris(()=>this.c);return u.fill(this.rawDeleted.map(z=>[z,!0])),u}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const u of le){switch(u.type){case 1:this.rawAdded.push(u.resource);break;case 0:this.rawUpdated.push(u.resource);break;case 2:this.rawDeleted.push(u.resource);break}this.b!==Y.a&&(typeof u.cId=="number"?this.b===void 0?this.b=u.cId:this.b!==u.cId&&(this.b=Y.a):this.b!==void 0&&(this.b=Y.a))}}contains(le,...x){return this.h(le,{includeChildren:!1},...x)}affects(le,...x){return this.h(le,{includeChildren:!0},...x)}h(le,x,...u){if(!le)return!1;const z=u.length>0;return!!((!z||u.includes(1))&&(this.d.value.get(le)||x.includeChildren&&this.d.value.findSuperstr(le))||(!z||u.includes(0))&&(this.f.value.get(le)||x.includeChildren&&this.f.value.findSuperstr(le))||(!z||u.includes(2))&&(this.g.value.findSubstr(le)||x.includeChildren&&this.g.value.findSuperstr(le)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(le){return this.b===le}hasCorrelation(){return typeof this.b=="number"}}e.$ll=Y;function te(B,le,x){return!B||!le||B===le||le.length>B.length?!1:(le.charAt(le.length-1)!==S.sep&&(le+=S.sep),x?(0,E.$Af)(B,le):B.indexOf(le)===0)}class V extends Error{constructor(le,x,u){super(le),this.fileOperationResult=x,this.options=u}}e.$nl=V;class ee extends V{constructor(le,x,u,z){super(le,x,z),this.fileOperationResult=x,this.size=u}}e.$ol=ee;class oe extends V{constructor(le,x,u){super(le,2,u),this.stat=x}}e.$pl=oe;var ue;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ue||(e.FileOperationResult=ue={})),e.$ql={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sl="files.associations",e.$tl="files.exclude",e.$ul="files.readonlyInclude",e.$vl="files.readonlyExclude",e.$wl="files.readonlyFromPermissions";var X;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$xl="";function q(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}async function Z(B,le){if(!le.hasProvider(j.URI.from({scheme:B.scheme})))return new Promise(x=>{const u=le.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===B.scheme&&z.added&&(u.dispose(),x())})})}class _{static{this.KB=1024}static{this.MB=_.KB*_.KB}static{this.GB=_.MB*_.KB}static{this.TB=_.GB*_.KB}static formatSize(le){return(0,A.$cg)(le)||(le=0),le<_.KB?(0,k.localize)(1,null,le.toFixed(0)):le<_.MB?(0,k.localize)(2,null,(le/_.KB).toFixed(2)):le<_.GB?(0,k.localize)(3,null,(le/_.MB).toFixed(2)):le<_.TB?(0,k.localize)(4,null,(le/_.GB).toFixed(2)):(0,k.localize)(5,null,(le/_.TB).toFixed(2))}}e.$Al=_;function de(B){const le=typeof B=="string"||B?.scheme===p.Schemas.vscodeRemote;return typeof B!="string"&&B?.scheme===p.Schemas.file?1024*_.MB:le?10*_.MB:r.$o?50*_.MB:1024*_.MB}}),define(fe[8],ge([0,1,70,56,4,49,2,25,3,23,10,6,35,21]),function(ae,e,y,S,E,A,j,k,h,r,p,l,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$8j=e.LogLevel=e.$6j=e.$5j=void 0,e.$7j=g,e.log=s,e.$gk=b,e.$hk=U,e.$ik=K,e.$jk=F,e.$5j=(0,a.$yi)("logService"),e.$6j=(0,a.$yi)("loggerService");function c(){return new Date().toISOString()}function g(O){return(0,p.$cg)(O)}var f;(function(O){O[O.Off=0]="Off",O[O.Trace=1]="Trace",O[O.Debug=2]="Debug",O[O.Info=3]="Info",O[O.Warning=4]="Warning",O[O.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$8j=f.Info;function s(O,d,I){switch(d){case f.Trace:O.trace(I);break;case f.Debug:O.debug(I);break;case f.Info:O.info(I);break;case f.Warning:O.warn(I);break;case f.Error:O.error(I);break;case f.Off:break;default:throw new Error(`Invalid log level ${d}`)}}function n(O,d=!1){let I="";for(let w=0;w<O.length;w++){let D=O[w];if(D instanceof Error&&(D=(0,S.$jj)(D,d)),typeof D=="object")try{D=JSON.stringify(D)}catch{}I+=(w>0?" ":"")+D}return I}class $ extends j.$Uc{constructor(){super(...arguments),this.b=e.$8j,this.c=this.B(new E.$fe),this.onDidChangeLogLevel=this.c.event}setLevel(d){this.b!==d&&(this.b=d,this.c.fire(this.b))}getLevel(){return this.b}f(d){return this.b!==f.Off&&this.b<=d}}e.$0j=$;class v extends ${constructor(d){super(),this.h=d}f(d){return this.h||super.f(d)}trace(d,...I){this.f(f.Trace)&&this.g(f.Trace,n([d,...I],!0))}debug(d,...I){this.f(f.Debug)&&this.g(f.Debug,n([d,...I]))}info(d,...I){this.f(f.Info)&&this.g(f.Info,n([d,...I]))}warn(d,...I){this.f(f.Warning)&&this.g(f.Warning,n([d,...I]))}error(d,...I){if(this.f(f.Error))if(d instanceof Error){const w=Array.prototype.slice.call(arguments);w[0]=d.stack,this.g(f.Error,n(w))}else this.g(f.Error,n([d,...I]))}flush(){}}e.$$j=v;class i extends ${constructor(d=e.$8j){super(),this.setLevel(d),this.g=!h.$i}trace(d,...I){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,d,...I):console.log(`[main ${c()}]`,d,...I))}debug(d,...I){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,d,...I):console.log(`[main ${c()}]`,d,...I))}info(d,...I){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,d,...I):console.log(`[main ${c()}]`,d,...I))}warn(d,...I){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,d,...I):console.warn(`[main ${c()}]`,d,...I))}error(d,...I){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,d,...I):console.error(`[main ${c()}]`,d,...I))}flush(){}}e.$_j=i;class t extends ${constructor(d=e.$8j,I=!0){super(),this.g=I,this.setLevel(d)}trace(d,...I){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",d,...I):console.log(d,...I))}debug(d,...I){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",d,...I):console.log(d,...I))}info(d,...I){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",d,...I):console.log(d,...I))}warn(d,...I){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",d,...I):console.log(d,...I))}error(d,...I){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",d,...I):console.error(d,...I))}flush(){}}e.$ak=t;class o extends ${constructor(d,I=e.$8j){super(),this.g=d,this.setLevel(I)}trace(d,...I){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(d),...I])}debug(d,...I){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(d),...I])}info(d,...I){this.f(f.Info)&&this.g.log(f.Info,[this.h(d),...I])}warn(d,...I){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(d),...I])}error(d,...I){this.f(f.Error)&&this.g.log(f.Error,[this.h(d),...I])}h(d){return typeof d=="string"?d:(0,S.$jj)(d,this.f(f.Trace))}flush(){}}e.$bk=o;class L extends ${constructor(d){super(),this.g=d,d.length&&this.setLevel(d[0].getLevel())}setLevel(d){for(const I of this.g)I.setLevel(d);super.setLevel(d)}trace(d,...I){for(const w of this.g)w.trace(d,...I)}debug(d,...I){for(const w of this.g)w.debug(d,...I)}info(d,...I){for(const w of this.g)w.info(d,...I)}warn(d,...I){for(const w of this.g)w.warn(d,...I)}error(d,...I){for(const w of this.g)w.error(d,...I)}flush(){for(const d of this.g)d.flush()}dispose(){for(const d of this.g)d.dispose();super.dispose()}}e.$ck=L;class m extends j.$Uc{constructor(d,I,w){if(super(),this.h=d,this.j=I,this.b=new k.$Ac,this.c=this.B(new E.$fe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new E.$fe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new E.$fe),this.onDidChangeVisibility=this.g.event,w)for(const D of w)this.b.set(D.resource,{logger:void 0,info:D})}m(d){return(0,p.$$f)(d)?[...this.b.values()].find(I=>I.info.id===d):this.b.get(d)}getLogger(d){return this.m(d)?.logger}createLogger(d,I){const w=this.n(d),D=(0,p.$$f)(d)?d:I?.id??(0,A.$mj)(w.toString()).toString(16);let Y=this.b.get(w)?.logger;const te=I?.logLevel==="always"?f.Trace:I?.logLevel;Y||(Y=this.s(w,te??this.getLogLevel(w)??this.h,{...I,id:D}));const V={logger:Y,info:{resource:w,id:D,logLevel:te,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(V.info),this.b.set(w,V),Y}n(d){return(0,p.$$f)(d)?(0,r.$_g)(this.j,`${d}.log`):d}setLogLevel(d,I){if(l.URI.isUri(d)){const w=d,D=I,Y=this.b.get(w);Y&&D!==Y.info.logLevel&&(Y.info.logLevel=D===this.h?void 0:D,Y.logger?.setLevel(D),this.b.set(Y.info.resource,Y),this.f.fire([w,D]))}else{this.h=d;for(const[w,D]of this.b.entries())this.b.get(w)?.info.logLevel===void 0&&D.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(d,I){const w=this.m(d);w&&I!==!w.info.hidden&&(w.info.hidden=!I,this.b.set(w.info.resource,w),this.g.fire([w.info.resource,I]))}getLogLevel(d){let I;return d&&(I=this.b.get(d)?.info.logLevel),I??this.h}registerLogger(d){const I=this.b.get(d.resource);I?I.info.hidden!==d.hidden&&this.setVisibility(d.resource,!d.hidden):(this.b.set(d.resource,{info:d,logger:void 0}),this.c.fire({added:[d],removed:[]}))}deregisterLogger(d){const I=this.b.get(d);I&&(I.logger&&I.logger.dispose(),this.b.delete(d),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const d of this.b.values())yield d.info}getRegisteredLogger(d){return this.b.get(d)?.info}dispose(){this.b.forEach(d=>d.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dk=m;class M{constructor(){this.onDidChangeLogLevel=new E.$fe().event}setLevel(d){}getLevel(){return f.Info}trace(d,...I){}debug(d,...I){}info(d,...I){}warn(d,...I){}error(d,...I){}critical(d,...I){}dispose(){}flush(){}}e.$ek=M;class C extends M{}e.$fk=C;function b(O){if(O.verbose)return f.Trace;if(typeof O.logLevel=="string"){const d=F(O.logLevel.toLowerCase());if(d!==void 0)return d}return e.$8j}function U(O){switch(O){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}function K(O){switch(O){case f.Trace:return{original:"Trace",value:y.localize(0,null)};case f.Debug:return{original:"Debug",value:y.localize(1,null)};case f.Info:return{original:"Info",value:y.localize(2,null)};case f.Warning:return{original:"Warning",value:y.localize(3,null)};case f.Error:return{original:"Error",value:y.localize(4,null)};case f.Off:return{original:"Off",value:y.localize(5,null)}}}function F(O){switch(O){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$kk=new P.$Pj("logLevel",U(f.Info))}),define(fe[80],ge([0,1,6,4,8,2]),function(ae,e,y,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=e.$ds=e.$cs=void 0;class j extends E.$dk{constructor(l,P,a,c,g){super(P,a,c),this.r=l,this.t=g,this.B(g.listen("onDidChangeLogLevel",l)(f=>{(0,E.$7j)(f)?super.setLogLevel(f):super.setLogLevel(y.URI.revive(f[0]),f[1])})),this.B(g.listen("onDidChangeVisibility",l)(([f,s])=>super.setVisibility(y.URI.revive(f),s))),this.B(g.listen("onDidChangeLoggers",l)(({added:f,removed:s})=>{for(const n of f)super.registerLogger({...n,resource:y.URI.revive(n.resource)});for(const n of s)super.deregisterLogger(n.resource)}))}createConsoleMainLogger(){return new E.$bk({log:(l,P)=>{this.t.call("consoleLog",[l,P])}})}registerLogger(l){super.registerLogger(l),this.t.call("registerLogger",[l,this.r])}deregisterLogger(l){super.deregisterLogger(l),this.t.call("deregisterLogger",[l,this.r])}setLogLevel(l,P){super.setLogLevel(l,P),this.t.call("setLogLevel",[l,P])}setVisibility(l,P){super.setVisibility(l,P),this.t.call("setVisibility",[this.n(l),P])}s(l,P,a){return new k(this.t,l,P,a,this.r)}static setLogLevel(l,P,a){return l.call("setLogLevel",[P,a])}}e.$cs=j;class k extends E.$$j{constructor(l,P,a,c,g){super(c?.logLevel==="always"),this.r=l,this.s=P,this.m=!1,this.n=[],this.setLevel(a),this.r.call("createLogger",[P,c,g]).then(()=>{this.u(this.n),this.m=!0})}g(l,P){const a=[[l,P]];this.m?this.u(a):this.n.push(...a)}u(l){this.r.call("log",[this.s,l])}}class h{constructor(l,P){this.a=l,this.b=P}listen(l,P){const a=this.b(l);switch(P){case"onDidChangeLoggers":return S.Event.map(this.a.onDidChangeLoggers,c=>({added:[...c.added].map(g=>this.c(g,a)),removed:[...c.removed].map(g=>this.c(g,a))}));case"onDidChangeVisibility":return S.Event.map(this.a.onDidChangeVisibility,c=>[a.transformOutgoingURI(c[0]),c[1]]);case"onDidChangeLogLevel":return S.Event.map(this.a.onDidChangeLogLevel,c=>(0,E.$7j)(c)?c:[a.transformOutgoingURI(c[0]),c[1]])}throw new Error(`Event not found: ${P}`)}async call(l,P,a){const c=this.b(l);switch(P){case"setLogLevel":return(0,E.$7j)(a[0])?this.a.setLogLevel(a[0]):this.a.setLogLevel(y.URI.revive(c.transformIncoming(a[0][0])),a[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(g=>this.c(g,c)))}throw new Error(`Call not found: ${P}`)}c(l,P){return{...l,resource:P.transformOutgoingURI(l.resource)}}}e.$ds=h;class r extends A.$Uc{constructor(l,P){super(),P.call("setLogLevel",[l.getLogLevel()]),this.B(l.onDidChangeLogLevel(a=>P.call("setLogLevel",[a]))),P.call("getRegisteredLoggers").then(a=>{for(const c of a)l.registerLogger({...c,resource:y.URI.revive(c.resource)})}),this.B(P.listen("onDidChangeVisibility")(([a,c])=>l.setVisibility(y.URI.revive(a),c))),this.B(P.listen("onDidChangeLoggers")(({added:a,removed:c})=>{for(const g of a)l.registerLogger({...g,resource:y.URI.revive(g.resource)});for(const g of c)l.deregisterLogger(g.resource)}))}}e.$es=r}),define(fe[81],ge([0,1,2,8]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=void 0;class E extends y.$Uc{constructor(j,k=[]){super(),this.a=new S.$ck([j,...k]),this.B(j.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...k){this.a.trace(j,...k)}debug(j,...k){this.a.debug(j,...k)}info(j,...k){this.a.info(j,...k)}warn(j,...k){this.a.warn(j,...k)}error(j,...k){this.a.error(j,...k)}flush(){this.a.flush()}}e.$aQ=E}),define(fe[82],ge([0,1,79,8]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=void 0;var E;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(E||(E={}));async function A(r,p,l,P,a){try{const c=await new Promise((f,s)=>{ae(["@vscode/spdlog"],f,s)});c.setFlushOn(E.Trace);const g=await c.createAsyncRotatingLogger(r,p,l,P);return a?g.clearFormatters():g.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),g}catch(c){console.error(c)}return null}function j(r,p,l){switch(p){case S.LogLevel.Trace:r.trace(l);break;case S.LogLevel.Debug:r.debug(l);break;case S.LogLevel.Info:r.info(l);break;case S.LogLevel.Warning:r.warn(l);break;case S.LogLevel.Error:r.error(l);break;case S.LogLevel.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function k(r,p){switch(p){case S.LogLevel.Trace:r.setLevel(E.Trace);break;case S.LogLevel.Debug:r.setLevel(E.Debug);break;case S.LogLevel.Info:r.setLevel(E.Info);break;case S.LogLevel.Warning:r.setLevel(E.Warning);break;case S.LogLevel.Error:r.setLevel(E.Error);break;case S.LogLevel.Off:r.setLevel(E.Off);break;default:throw new Error(`Invalid log level ${p}`)}}class h extends S.$$j{constructor(p,l,P,a,c){super(),this.m=[],this.setLevel(c),this.n=this.s(p,l,P,a),this.B(this.onDidChangeLogLevel(g=>{this.r&&k(this.r,g)}))}async s(p,l,P,a){const c=P?6:1,g=30/c*y.$Al.MB,f=await A(p,l,g,c,a);if(f){this.r=f,k(this.r,this.getLevel());for(const{level:s,message:n}of this.m)j(this.r,s,n);this.m=[]}}g(p,l){this.r?j(this.r,p,l):this.getLevel()<=p&&this.m.push({level:p,message:l})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$2P=h}),define(fe[83],ge([0,1,52,8,82]),function(ae,e,y,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=void 0;class A extends S.$dk{s(k,h,r){return new E.$2P((0,y.$Ug)(),k.fsPath,!r?.donotRotate,!!r?.donotUseFormatters,h)}}e.$3P=A}),define(fe[84],ge([0,1,15]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let S;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.context<"u"){const A=E.context.configuration();if(A)S=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(S=globalThis._VSCODE_PRODUCT_JSON,y.env.VSCODE_DEV&&Object.assign(S,{nameShort:`${S.nameShort} Dev`,nameLong:`${S.nameLong} Dev`,dataFolderName:`${S.dataFolderName}-dev`,serverDataFolderName:S.serverDataFolderName?`${S.serverDataFolderName}-dev`:void 0}),!S.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(S,{version:A.version})}}else S={},Object.keys(S).length===0&&Object.assign(S,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=S}),define(fe[85],ge([0,1,21]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$lk=(0,y.$yi)("productService"),e.$mk="vscode://schemas/vscode-product"}),define(fe[86],ge([0,1,42,10]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=void 0;class E{constructor(){this.a=new Map}add(j,k){y.ok(S.$$f(j)),y.ok(S.$ag(k)),y.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,k)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$fo=new E}),define(fe[87],ge([0,1,4,2]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zub=void 0;class E extends S.$Uc{constructor(j){super(),this.f=j,this.type=4,this.a=new Map,this.b=new Map,this.c=this.B(new y.$fe),this.onMarkAdded=this.c.event}*markers(){for(const j of this.a.values())yield j;for(const j of this.b.values())yield j}addMark(j){const k=j?.marker||this.f.registerMarker(),h=j?.id;k&&(h?(this.a.set(h,k),k.onDispose(()=>this.a.delete(h))):(this.b.set(k.id,k),k.onDispose(()=>this.b.delete(k.id))),this.c.fire({marker:k,id:h,hidden:j?.hidden,hoverMessage:j?.hoverMessage}))}getMark(j){return this.a.get(j)}}e.$Zub=E});var ze=this&&this.__param||function(ae,e){return function(y,S){e(y,S,ae)}};define(fe[88],ge([0,1,4,2,8,14]),function(ae,e,y,S,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=void 0;var j;(function(h){h[h.Unknown=0]="Unknown",h[h.Input=1]="Input",h[h.Execute=2]="Execute"})(j||(j={}));let k=class extends S.$Uc{get value(){return this.j}get cursorIndex(){return this.m}get ghostTextIndex(){return this.n}constructor(r,p,l,P){super(),this.w=r,this.z=P,this.a=0,this.c=0,this.h="",this.j="",this.m=0,this.n=-1,this.r=this.B(new y.$fe),this.onDidStartInput=this.r.event,this.s=this.B(new y.$fe),this.onDidChangeInput=this.s.event,this.t=this.B(new y.$fe),this.onDidFinishInput=this.t.event,this.u=this.B(new y.$fe),this.onDidInterrupt=this.u.event,this.B(y.Event.any(this.w.onCursorMove,this.w.onData,this.w.onWriteParsed)(()=>this.G())),this.B(this.w.onData(a=>this.I(a))),this.B(p(a=>this.D(a))),this.B(l(()=>this.F())),this.B(this.onDidStartInput(()=>this.C("PromptInputModel#onDidStartInput"))),this.B(this.onDidChangeInput(()=>this.C("PromptInputModel#onDidChangeInput"))),this.B(this.onDidFinishInput(()=>this.C("PromptInputModel#onDidFinishInput"))),this.B(this.onDidInterrupt(()=>this.C("PromptInputModel#onDidInterrupt")))}C(r){this.z.getLevel()===E.LogLevel.Trace&&this.z.trace(r,this.getCombinedString())}setContinuationPrompt(r){this.g=r,this.G()}setLastPromptLine(r){this.f=r,this.G()}setConfidentCommandLine(r){this.j!==r&&(this.j=r,this.m=-1,this.n=-1,this.s.fire(this.Q()))}getCombinedString(){const r=this.j.replaceAll(`
`,"\u23CE");if(this.m===-1)return r;let p=`${r.substring(0,this.cursorIndex)}|`;return this.ghostTextIndex!==-1?(p+=`${r.substring(this.cursorIndex,this.ghostTextIndex)}[`,p+=`${r.substring(this.ghostTextIndex)}]`):p+=r.substring(this.cursorIndex),p}D(r){this.a!==1&&(this.a=1,this.b=r.marker,this.c=this.w.buffer.active.cursorX,this.j="",this.m=0,this.r.fire(this.Q()),this.s.fire(this.Q()),this.f&&this.c!==this.f.length&&this.w.buffer.active.getLine(this.b.line)?.translateToString(!0).startsWith(this.f)&&(this.c=this.f.length,this.G()))}F(){if(this.a===2)return;this.m=-1,this.n!==-1&&(this.j=this.j.substring(0,this.n),this.n=-1);const r=this.Q();this.h===""&&(this.h="",this.u.fire(r)),this.a=2,this.t.fire(r),this.s.fire(r)}G(){try{this.H()}catch(r){this.z.error("Error while syncing prompt input model",r)}}H(){if(this.a!==1)return;const r=this.b?.line;if(r===void 0)return;const p=this.w.buffer.active;let l=p.getLine(r);const P=l?.translateToString(!0,this.c);if(!l||P===void 0){this.z.trace("PromptInputModel#_sync: no line");return}const a=p.baseY+p.cursorY;let c=P,g=a===r?this.O(this.c,p,l):P.trimEnd().length+1,f=-1;a===r&&p.cursorX>1&&(f=this.J(p,l,g));for(let s=r+1;s<=a;s++){l=p.getLine(s);const n=l?.translateToString(!0);if(n&&l)if(this.g===void 0||this.M(n)){const $=this.L(n);if(c+=`
${$}`,a===s){const v=this.N(l,n),i=this.O(v,p,l);g+=i}else g+=$.length+1}else break}for(let s=a+1;s<p.baseY+this.w.rows;s++){l=p.getLine(s);const n=l?.translateToString(!0);if(n&&l)if(this.g===void 0||this.M(n))c+=`
${this.L(n)}`;else break;else break}this.z.getLevel()===E.LogLevel.Trace&&this.z.trace(`PromptInputModel#_sync: ${this.getCombinedString()}`);{let s=this.j.length-this.j.trimEnd().length;this.h==="\x7F"&&(this.h="",g===this.m-1&&(this.j.trimEnd().length>c.trimEnd().length&&c.trimEnd().length<=g?s=Math.max(this.j.length-1-c.trimEnd().length,0):s=Math.max(s-1,0))),this.h==="\x1B[3~"&&(this.h="",g===this.m&&(s=Math.max(s-1,0)));const n=c.split(`
`),$=n.length>1,v=c.trimEnd();if(!$){v.length<c.length&&(this.h===" "&&(this.h="",g>v.length&&g>this.m&&s++),s=Math.max(g-v.length,s,0));const i=g===0?"":c[g-1];s>0&&g===this.m+1&&this.h!==""&&i!==" "&&(s=this.j.length-this.m)}if($){n[n.length-1]=n.at(-1)?.trimEnd()??"";const i=(n.length-1)*(this.g?.length??0);s=Math.max(0,g-c.length-i)}c=n.map(i=>i.trimEnd()).join(`
`)+" ".repeat(s)}(this.j!==c||this.m!==g||this.n!==f)&&(this.j=c,this.m=g,this.n=f,this.s.fire(this.Q()))}I(r){this.h=r}J(r,p,l){let P=-1,a=!1,c=r.cursorX;for(;c>0;){const g=p.getCell(--c);if(!g)break;if(g.getChars().trim().length>0){a=!this.P(g);break}}if(a){let g=0,f=r.cursorX;for(;f<p.length;){const s=p.getCell(f++);if(!s||s.getCode()===0)break;if(this.P(s)){P=l+g;break}g+=s.getChars().length}}return P}L(r){return this.M(r)&&(r=r.substring(this.g.length)),r}M(r){return!!(this.g&&r.startsWith(this.g))}N(r,p){if(!this.g||!p.startsWith(this.g))return 0;let l="",P=0;for(;l!==this.g;)l+=r.getCell(P++).getChars();return P}O(r,p,l){return l?.translateToString(!0,r,p.cursorX).length??0}P(r){return!!(r.isItalic()||r.isDim())}Q(){return Object.freeze({value:this.j,cursorIndex:this.m,ghostTextIndex:this.n})}};e.$6r=k,be([(0,A.$5h)(0)],k.prototype,"G",null),e.$6r=k=be([ze(3,E.$5j)],k)}),define(fe[89],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=e.$7r=void 0;class y{get command(){return this.b.command}get commandLineConfidence(){return this.b.commandLineConfidence}get isTrusted(){return this.b.isTrusted}get timestamp(){return this.b.timestamp}get duration(){return this.b.duration}get promptStartMarker(){return this.b.promptStartMarker}get marker(){return this.b.marker}get endMarker(){return this.b.endMarker}set endMarker(p){this.b.endMarker=p}get executedMarker(){return this.b.executedMarker}get aliases(){return this.b.aliases}get wasReplayed(){return this.b.wasReplayed}get cwd(){return this.b.cwd}get exitCode(){return this.b.exitCode}get commandStartLineContent(){return this.b.commandStartLineContent}get markProperties(){return this.b.markProperties}get executedX(){return this.b.executedX}get startX(){return this.b.startX}constructor(p,l){this.a=p,this.b=l}static deserialize(p,l,P){const a=p.buffer.normal,c=l.startLine!==void 0?p.registerMarker(l.startLine-(a.baseY+a.cursorY)):void 0;if(!c)return;const g=l.promptStartLine!==void 0?p.registerMarker(l.promptStartLine-(a.baseY+a.cursorY)):void 0,f=l.endLine!==void 0?p.registerMarker(l.endLine-(a.baseY+a.cursorY)):void 0,s=l.executedLine!==void 0?p.registerMarker(l.executedLine-(a.baseY+a.cursorY)):void 0;return new y(p,{command:P?"":l.command,commandLineConfidence:l.commandLineConfidence??"low",isTrusted:l.isTrusted,promptStartMarker:g,marker:c,startX:l.startX,endMarker:f,executedMarker:s,executedX:l.executedX,timestamp:l.timestamp,duration:l.duration,cwd:l.cwd,commandStartLineContent:l.commandStartLineContent,exitCode:l.exitCode,markProperties:l.markProperties,aliases:void 0,wasReplayed:!0})}serialize(p){return{promptStartLine:this.promptStartMarker?.line,startLine:this.marker?.line,startX:void 0,endLine:this.endMarker?.line,executedLine:this.executedMarker?.line,executedX:this.executedX,command:p?"":this.command,commandLineConfidence:p?"low":this.commandLineConfidence,isTrusted:this.isTrusted,cwd:this.cwd,exitCode:this.exitCode,commandStartLineContent:this.commandStartLineContent,timestamp:this.timestamp,duration:this.duration,markProperties:this.markProperties}}extractCommandLine(){return E(this.a.buffer.active,this.a.cols,this.marker,this.startX,this.executedMarker,this.executedX)}getOutput(){if(!this.executedMarker||!this.endMarker)return;const p=this.executedMarker.line,l=this.endMarker.line;if(p===l)return;let P="",a;for(let c=p;c<l;c++)a=this.a.buffer.active.getLine(c),a&&(P+=a.translateToString(!a.isWrapped)+(a.isWrapped?"":`
`));return P===""?void 0:P}getOutputMatch(p){if(!this.executedMarker||!this.endMarker)return;const l=this.endMarker.line;if(l===-1)return;const P=this.a.buffer.active,a=Math.max(this.executedMarker.line,0),c=p.lineMatcher,g=typeof c=="string"?1:p.length||j(c),f=[];let s;if(p.anchor==="bottom")for(let n=l-(p.offset||0);n>=a;n--){let $=n;const v=n;for(;$>=a&&P.getLine($)?.isWrapped;)$--;if(n=$,f.unshift(A(P,$,v,this.a.cols)),s||(s=f[0].match(c)),f.length>=g)break}else for(let n=a+(p.offset||0);n<l;n++){const $=n;let v=n;for(;v+1<l&&P.getLine(v+1)?.isWrapped;)v++;if(n=v,f.push(A(P,$,v,this.a.cols)),s||(s=f[f.length-1].match(c)),f.length>=g)break}return s?{regexMatch:s,outputLines:f}:void 0}hasOutput(){return!this.executedMarker?.isDisposed&&!this.endMarker?.isDisposed&&!!(this.executedMarker&&this.endMarker&&this.executedMarker.line<this.endMarker.line)}getPromptRowCount(){return k(this,this.a.buffer.active)}getCommandRowCount(){return h(this)}}e.$7r=y;class S{constructor(p){this.c=p}serialize(p){if(this.commandStartMarker)return{promptStartLine:this.promptStartMarker?.line,startLine:this.commandStartMarker.line,startX:this.commandStartX,endLine:void 0,executedLine:void 0,executedX:void 0,command:"",commandLineConfidence:"low",isTrusted:!0,cwd:p,exitCode:void 0,commandStartLineContent:void 0,timestamp:0,duration:0,markProperties:void 0}}promoteToFullCommand(p,l,P,a){if(l===void 0&&this.command===void 0&&(this.command=""),this.command!==void 0&&!this.command.startsWith("\\")||P)return new y(this.c,{command:P?"":this.command||"",commandLineConfidence:P?"low":this.commandLineConfidence||"low",isTrusted:!!this.isTrusted,promptStartMarker:this.promptStartMarker,marker:this.commandStartMarker,startX:this.commandStartX,endMarker:this.commandFinishedMarker,executedMarker:this.commandExecutedMarker,executedX:this.commandExecutedX,timestamp:Date.now(),duration:this.b||0,cwd:p,exitCode:l,commandStartLineContent:this.commandStartLineContent,markProperties:a})}markExecutedTime(){this.a===void 0&&(this.a=Date.now())}markFinishedTime(){this.b===void 0&&this.a!==void 0&&(this.b=Date.now()-this.a)}extractCommandLine(){return E(this.c.buffer.active,this.c.cols,this.commandStartMarker,this.commandStartX,this.commandExecutedMarker,this.commandExecutedX)}getPromptRowCount(){return k(this,this.c.buffer.active)}getCommandRowCount(){return h(this)}}e.$8r=S;function E(r,p,l,P,a,c){if(!l||!a||P===void 0||c===void 0)return"";let g="";for(let f=l.line;f<=a.line;f++){const s=r.getLine(f);s&&(g+=s.translateToString(!0,f===l.line?P:0,f===a.line?c:p))}return g}function A(r,p,l,P){const a=Math.max(2048/P*2);l=Math.min(l,p+a);let c="";for(let g=p;g<=l;g++){const f=r.getLine(g);f&&(c+=f.translateToString(!0,0,P))}return c}function j(r){if(!r.multiline)return 1;const p=r.source;let l=1,P=p.indexOf("\\n");for(;P!==-1;)l++,P=p.indexOf("\\n",P+1);return l}function k(r,p){const l="hasOutput"in r?r.marker:r.commandStartMarker;if(!l||!r.promptStartMarker)return 1;let P=1,a=r.promptStartMarker.line;for(;a<l.line&&(p.getLine(a)?.translateToString(!0)??"").length===0;)a++;return P=l.line-a+1,P}function h(r){const p="hasOutput"in r?r.marker:r.commandStartMarker,l="hasOutput"in r?r.executedMarker:r.commandExecutedMarker;if(!p||!l)return 1;let a=Math.max(l.line,p.line)-p.line+1;return("hasOutput"in r?r.executedX:r.commandExecutedX)===0&&a--,a}}),define(fe[90],ge([0,1,12,14,4,2,8,89,88]),function(ae,e,y,S,E,A,j,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vub=void 0,e.$Wub=a;let r=class extends A.$Uc{get promptInputModel(){return this.c}get commands(){return this.f}get executingCommand(){return this.n.command}get executingCommandObject(){if(this.n.commandStartMarker)return{marker:this.n.commandStartMarker}}get currentCommand(){return this.n}get cwd(){return this.g}get promptTerminator(){return this.h}get D(){return!!(this.n.commandStartMarker&&!this.n.commandExecutedMarker)}get hasInput(){if(!(!this.D||!this.n?.commandStartMarker)){if(this.M.buffer.active.baseY+this.M.buffer.active.cursorY===this.n.commandStartMarker?.line){const s=this.M.buffer.active.getLine(this.M.buffer.active.cursorY)?.translateToString(!0,this.n.commandStartX);return s===void 0?void 0:s.length>0}return!0}}constructor(s,n){super(),this.M=s,this.N=n,this.type=2,this.f=[],this.n=new k.$8r(this.M),this.r=[],this.t=!1,this.F=this.B(new E.$fe),this.onCommandStarted=this.F.event,this.G=this.B(new E.$fe),this.onBeforeCommandFinished=this.G.event,this.H=this.B(new E.$fe),this.onCommandFinished=this.H.event,this.I=this.B(new E.$fe),this.onCommandExecuted=this.I.event,this.J=this.B(new E.$fe),this.onCommandInvalidated=this.J.event,this.L=this.B(new E.$fe),this.onCurrentCommandInvalidated=this.L.event,this.c=this.B(new h.$6r(this.M,this.onCommandStarted,this.onCommandExecuted,this.N)),this.B(this.onCommandExecuted(v=>{if(v.commandLineConfidence!=="high"){const i=v;v.command=i.extractCommandLine(),v.commandLineConfidence="low","getOutput"in i?i.promptStartMarker&&i.marker&&i.executedMarker&&v.command.indexOf(`
`)===-1&&i.startX!==void 0&&i.startX>0&&(v.commandLineConfidence="medium"):i.promptStartMarker&&i.commandStartMarker&&i.commandExecutedMarker&&v.command.indexOf(`
`)===-1&&i.commandStartX!==void 0&&i.commandStartX>0&&(v.commandLineConfidence="medium")}}));const $=this;this.z=new class{get onCurrentCommandInvalidatedEmitter(){return $.L}get onCommandStartedEmitter(){return $.F}get onCommandExecutedEmitter(){return $.I}get dimensions(){return $.s}get isCommandStorageDisabled(){return $.t}get commandMarkers(){return $.r}set commandMarkers(v){$.r=v}get clearCommandsInViewport(){return $.Q.bind($)}commitCommandFinished(){$.w?.flush(),$.w=void 0}},this.C=this.B(new A.$Wc(new p(this.M,this,this.z,this.N))),this.s={cols:this.M.cols,rows:this.M.rows},this.B(this.M.onResize(v=>this.O(v))),this.B(this.M.onCursorMove(()=>this.P()))}O(s){this.C.value.preHandleResize?.(s),this.s.cols=s.cols,this.s.rows=s.rows}P(){this.M.buffer.active===this.M.buffer.normal&&this.n.commandStartMarker&&this.M.buffer.active.baseY+this.M.buffer.active.cursorY<this.n.commandStartMarker.line&&(this.Q(),this.n.isInvalid=!0,this.L.fire({reason:"windows"}))}Q(){let s=0;for(let n=this.f.length-1;n>=0;n--){const $=this.f[n].marker?.line;if($&&$<this.M.buffer.active.baseY)break;s++}s>0&&this.J.fire(this.f.splice(this.f.length-s,s))}setContinuationPrompt(s){this.c.setContinuationPrompt(s)}setPromptTerminator(s,n){this.N.debug("CommandDetectionCapability#setPromptTerminator",s),this.h=s,this.c.setLastPromptLine(n)}setCwd(s){this.g=s}setIsWindowsPty(s){if(s&&!(this.C.value instanceof P)){const n=this;this.C.value=new P(this.M,this,new class{get onCurrentCommandInvalidatedEmitter(){return n.L}get onCommandStartedEmitter(){return n.F}get onCommandExecutedEmitter(){return n.I}get dimensions(){return n.s}get isCommandStorageDisabled(){return n.t}get commandMarkers(){return n.r}set commandMarkers($){n.r=$}get clearCommandsInViewport(){return n.Q.bind(n)}commitCommandFinished(){n.w?.flush(),n.w=void 0}},this.N)}else!s&&!(this.C.value instanceof p)&&(this.C.value=new p(this.M,this,this.z,this.N))}setIsCommandStorageDisabled(){this.t=!0}getCommandForLine(s){if(this.n.promptStartMarker&&s>=this.n.promptStartMarker?.line)return this.n;if(this.f.length!==0&&!((this.f[0].promptStartMarker??this.f[0].marker).line>s)){for(let n=this.commands.length-1;n>=0;n--)if((this.commands[n].promptStartMarker??this.commands[n].marker).line<=s)return this.commands[n]}}getCwdForLine(s){if(this.n.promptStartMarker&&s>=this.n.promptStartMarker?.line)return this.g;const n=this.getCommandForLine(s);if(n&&"cwd"in n)return n.cwd}handlePromptStart(s){const n=this.commands.at(-1);n?.endMarker&&n?.executedMarker&&n.endMarker.line===n.executedMarker.line&&(this.N.debug("CommandDetectionCapability#handlePromptStart adjusted commandFinished",`${n.endMarker.line} -> ${n.executedMarker.line+1}`),n.endMarker=g(this.M,n.executedMarker,1)),this.n.promptStartMarker=s?.marker||(n?.endMarker?g(this.M,n.endMarker):this.M.registerMarker(0)),this.N.debug("CommandDetectionCapability#handlePromptStart",this.M.buffer.active.cursorX,this.n.promptStartMarker?.line)}handleContinuationStart(){this.n.currentContinuationMarker=this.M.registerMarker(0),this.N.debug("CommandDetectionCapability#handleContinuationStart",this.n.currentContinuationMarker)}handleContinuationEnd(){if(!this.n.currentContinuationMarker){this.N.warn("CommandDetectionCapability#handleContinuationEnd Received continuation end without start");return}this.n.continuations||(this.n.continuations=[]),this.n.continuations.push({marker:this.n.currentContinuationMarker,end:this.M.buffer.active.cursorX}),this.n.currentContinuationMarker=void 0,this.N.debug("CommandDetectionCapability#handleContinuationEnd",this.n.continuations[this.n.continuations.length-1])}handleRightPromptStart(){this.n.commandRightPromptStartX=this.M.buffer.active.cursorX,this.N.debug("CommandDetectionCapability#handleRightPromptStart",this.n.commandRightPromptStartX)}handleRightPromptEnd(){this.n.commandRightPromptEndX=this.M.buffer.active.cursorX,this.N.debug("CommandDetectionCapability#handleRightPromptEnd",this.n.commandRightPromptEndX)}handleCommandStart(s){if(this.u=s,this.n.cwd=this.g,this.n.commandStartMarker=s?.marker||this.n.commandStartMarker,this.n.commandStartMarker?.line===this.M.buffer.active.cursorY){this.n.commandStartX=this.M.buffer.active.cursorX,this.N.debug("CommandDetectionCapability#handleCommandStart",this.n.commandStartX,this.n.commandStartMarker?.line);return}this.C.value.handleCommandStart(s)}handleGenericCommand(s){s?.markProperties?.disableCommandStorage&&this.setIsCommandStorageDisabled(),this.handlePromptStart(s),this.handleCommandStart(s),this.handleCommandExecuted(s),this.handleCommandFinished(void 0,s)}handleCommandExecuted(s){this.C.value.handleCommandExecuted(s),this.n.markExecutedTime()}handleCommandFinished(s,n){if(this.n.markFinishedTime(),this.C.value.preHandleCommandFinished?.(),this.N.debug("CommandDetectionCapability#handleCommandFinished",this.M.buffer.active.cursorX,n?.marker?.line,this.n.command,this.n),s===void 0){const v=this.commands.length>0?this.commands[this.commands.length-1]:void 0;this.n.command&&this.n.command.length>0&&v?.command===this.n.command&&(s=v.exitCode)}if(this.n.commandStartMarker===void 0||!this.M.buffer.active)return;this.n.commandFinishedMarker=n?.marker||this.M.registerMarker(0),this.C.value.postHandleCommandFinished?.();const $=this.n.promoteToFullCommand(this.g,s,this.u?.ignoreCommandLine??!1,n?.markProperties);$&&(this.f.push($),this.w=new y.$Kh(()=>{this.G.fire($),this.n.isInvalid||(this.N.debug("CommandDetectionCapability#onCommandFinished",$),this.H.fire($))},50),this.w.schedule()),this.n=new k.$8r(this.M),this.u=void 0}setCommandLine(s,n){this.N.debug("CommandDetectionCapability#setCommandLine",s,n),this.n.command=s,this.n.commandLineConfidence="high",this.n.isTrusted=n,n&&this.c.setConfidentCommandLine(s)}serialize(){const s=this.commands.map($=>$.serialize(this.t)),n=this.n.serialize(this.g);return n&&s.push(n),{isWindowsPty:this.C.value instanceof P,commands:s}}deserialize(s){s.isWindowsPty&&this.setIsWindowsPty(s.isWindowsPty);const n=this.M.buffer.normal;for(const $ of s.commands){if(!$.endLine){const i=$.startLine!==void 0?this.M.registerMarker($.startLine-(n.baseY+n.cursorY)):void 0;if(!i)continue;this.n.commandStartMarker=$.startLine!==void 0?this.M.registerMarker($.startLine-(n.baseY+n.cursorY)):void 0,this.n.commandStartX=$.startX,this.n.promptStartMarker=$.promptStartLine!==void 0?this.M.registerMarker($.promptStartLine-(n.baseY+n.cursorY)):void 0,this.g=$.cwd,this.F.fire({marker:i});continue}const v=k.$7r.deserialize(this.M,$,this.t);v&&(this.f.push(v),this.N.debug("CommandDetectionCapability#onCommandFinished",v),this.H.fire(v))}}};e.$Vub=r,be([(0,S.$4h)(500)],r.prototype,"P",null),e.$Vub=r=be([ze(1,j.$5j)],r);class p extends A.$Uc{constructor(s,n,$,v){super(),this.c=s,this.f=n,this.g=$,this.h=v,this.B(s.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&$.clearCommandsInViewport(),!1)))}handleCommandStart(s){this.g.commitCommandFinished();const n=this.f.currentCommand;n.commandStartX=this.c.buffer.active.cursorX,n.commandStartMarker=s?.marker||this.c.registerMarker(0),n.commandExecutedMarker?.dispose(),n.commandExecutedMarker=void 0,n.commandExecutedX=void 0;for(const $ of this.g.commandMarkers)$.dispose();this.g.commandMarkers.length=0,this.g.onCommandStartedEmitter.fire({marker:s?.marker||n.commandStartMarker,markProperties:s?.markProperties}),this.h.debug("CommandDetectionCapability#handleCommandStart",n.commandStartX,n.commandStartMarker?.line)}handleCommandExecuted(s){const n=this.f.currentCommand;if(n.commandExecutedMarker=s?.marker||this.c.registerMarker(0),n.commandExecutedX=this.c.buffer.active.cursorX,this.h.debug("CommandDetectionCapability#handleCommandExecuted",n.commandExecutedX,n.commandExecutedMarker?.line),!n.commandStartMarker||!n.commandExecutedMarker||n.commandStartX===void 0)return;n.command=this.g.isCommandStorageDisabled?"":this.c.buffer.active.getLine(n.commandStartMarker.line)?.translateToString(!0,n.commandStartX,n.commandRightPromptStartX).trim();let $=n.commandStartMarker.line+1;const v=n.commandExecutedMarker.line;for(;$<v;$++){const i=this.c.buffer.active.getLine($);if(i){const t=n.continuations?.find(L=>L.marker.line===$);t&&(n.command+=`
`);const o=t?.end??0;n.command+=i.translateToString(!0,o)}}$===v&&(n.command+=this.c.buffer.active.getLine(v)?.translateToString(!0,void 0,n.commandExecutedX)||""),this.g.onCommandExecutedEmitter.fire(n)}}var l;(function(f){f[f.MaxCheckLineCount=10]="MaxCheckLineCount",f[f.Interval=20]="Interval",f[f.MaximumPollCount=10]="MaximumPollCount"})(l||(l={}));let P=class extends A.$Uc{constructor(s,n,$,v){super(),this.n=s,this.r=n,this.s=$,this.t=v,this.c=this.B(new A.$Vc),this.g=0,this.h=0,this.B(s.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&this.s.clearCommandsInViewport(),!1))),this.B(this.r.onBeforeCommandFinished(i=>{(i.command.trim().toLowerCase()==="clear"||i.command.trim().toLowerCase()==="cls")&&(this.f?.cancel(),this.f=void 0,this.s.clearCommandsInViewport(),this.r.currentCommand.isInvalid=!0,this.s.onCurrentCommandInvalidatedEmitter.fire({reason:"windows"}))}))}preHandleResize(s){const n=this.n.buffer.active.baseY,$=s.rows-this.s.dimensions.rows;$>0&&this.D().then(()=>{const v=Math.min($,n);for(let i=this.r.commands.length-1;i>=0;i--){const t=this.r.commands[i];if(!t.marker||t.marker.line<n||t.commandStartLineContent===void 0)break;const o=this.n.buffer.active.getLine(t.marker.line);if(!o||o.translateToString(!0)===t.commandStartLineContent)continue;const L=t.marker.line-v;this.n.buffer.active.getLine(L)?.translateToString(!0)===t.commandStartLineContent&&this.n._core._bufferService.buffer.lines.onDeleteEmitter.fire({index:this.n.buffer.active.baseY,amount:v})}})}handleCommandStart(){this.r.currentCommand.commandStartX=this.n.buffer.active.cursorX,this.s.commandMarkers.length=0;const s=this.r.currentCommand.commandStartMarker=this.r.currentCommand.promptStartMarker?g(this.n,this.r.currentCommand.promptStartMarker):this.n.registerMarker(0);this.r.currentCommand.commandStartX=0,this.g=0,this.h=0,this.f=new y.$Kh(()=>this.u(s),20),this.f.schedule()}u(s){if(this.q.isDisposed)return;const n=this.n.buffer.active;let $=this.g;for(;$<10&&s.line+$<n.baseY+this.n.rows;){if(this.C()){const v=this.F(s.line+$);if(v){const i=typeof v=="string"?v:v.prompt;if(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0),typeof v=="object"&&v.likelySingleLine){this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted promptStart",`${this.r.currentCommand.promptStartMarker?.line} -> ${this.r.currentCommand.commandStartMarker.line}`),this.r.currentCommand.promptStartMarker?.dispose(),this.r.currentCommand.promptStartMarker=g(this.n,this.r.currentCommand.commandStartMarker);const t=this.r.commands.at(-1);t&&this.r.currentCommand.commandStartMarker.line!==t.endMarker?.line&&(t.endMarker?.dispose(),t.endMarker=g(this.n,this.r.currentCommand.commandStartMarker))}this.r.currentCommand.commandStartX=i.length,this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted commandStart",`${s.line} -> ${this.r.currentCommand.commandStartMarker.line}:${this.r.currentCommand.commandStartX}`),this.w();return}}$++}$<10?(this.g=$,++this.h<10?this.f?.schedule():this.w()):this.w()}w(){if(this.f&&(this.h=10,this.f.flush(),this.f=void 0),this.s.commitCommandFinished(),this.r.currentCommand.commandExecutedMarker||(this.c.value=this.n.onCursorMove(()=>{if(this.s.commandMarkers.length===0||this.s.commandMarkers[this.s.commandMarkers.length-1].line!==this.n.buffer.active.cursorY){const s=this.n.registerMarker(0);s&&this.s.commandMarkers.push(s)}})),this.r.currentCommand.commandStartMarker){const s=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);s&&(this.r.currentCommand.commandStartLineContent=s.translateToString(!0))}this.s.onCommandStartedEmitter.fire({marker:this.r.currentCommand.commandStartMarker}),this.t.debug("CommandDetectionCapability#_handleCommandStartWindows",this.r.currentCommand.commandStartX,this.r.currentCommand.commandStartMarker?.line)}handleCommandExecuted(s){this.f&&this.w(),this.c.clear(),this.z(),this.r.currentCommand.commandExecutedX=this.n.buffer.active.cursorX,this.s.onCommandExecutedEmitter.fire(this.r.currentCommand),this.t.debug("CommandDetectionCapability#handleCommandExecuted",this.r.currentCommand.commandExecutedX,this.r.currentCommand.commandExecutedMarker?.line)}preHandleCommandFinished(){this.r.currentCommand.commandExecutedMarker||(this.s.commandMarkers.length===0&&(this.r.currentCommand.commandStartMarker||(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0)),this.r.currentCommand.commandStartMarker&&this.s.commandMarkers.push(this.r.currentCommand.commandStartMarker)),this.z())}postHandleCommandFinished(){const s=this.r.currentCommand,n=s.command,$=s.commandStartMarker?.line,v=s.commandExecutedMarker?.line;if(!n||n.length===0||$===void 0||$===-1||v===void 0||v===-1)return;let i=0,t=!1;for(let o=$;o<=v;o++){const L=this.n.buffer.active.getLine(o);if(!L)break;const m=L.translateToString(!0);for(let M=0;M<m.length;M++){for(;n.length<i&&n[i]===" ";)i++;if(m[M]===n[i]&&i++,i===n.length){const C=M>=this.n.cols-1;s.commandExecutedMarker=this.n.registerMarker(o-(this.n.buffer.active.baseY+this.n.buffer.active.cursorY)+(C?1:0)),s.commandExecutedX=C?0:M+1,t=!0;break}}if(t)break}}z(){if(this.s.commandMarkers.length!==0){if(this.s.commandMarkers=this.s.commandMarkers.sort((s,n)=>s.line-n.line),this.r.currentCommand.commandStartMarker=this.s.commandMarkers[0],this.r.currentCommand.commandStartMarker){const s=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);s&&(this.r.currentCommand.commandStartLineContent=s.translateToString(!0))}this.r.currentCommand.commandExecutedMarker=this.s.commandMarkers[this.s.commandMarkers.length-1],this.s.onCommandExecutedEmitter.fire(this.r.currentCommand)}}C(){const s=this.r.commands.at(-1);if(!s)return!0;const n=this.n.buffer.active.baseY+this.n.buffer.active.cursorY,$=(s.endMarker?s.endMarker.line:s.marker?.line)??-1;return n>$}D(){const s=this.n.buffer.active.cursorX,n=this.n.buffer.active.cursorY;let $=0;return new Promise((v,i)=>{const t=setInterval(()=>{if(s!==this.n.buffer.active.cursorX||n!==this.n.buffer.active.cursorY){v(),clearInterval(t);return}$+=10,$>1e3&&(clearInterval(t),v())},10)})}F(s=this.n.buffer.active.baseY+this.n.buffer.active.cursorY){const n=this.n.buffer.active.getLine(s);if(!n)return;const $=n.translateToString(!0);if(!$)return;const v=$.match(/(?<prompt>(\(.+\)\s)?(?:PS.+>\s?))/)?.groups?.prompt;if(v){const m=this.G(v,$,">");if(m)return{prompt:m,likelySingleLine:!0}}const i=$.match(/.*\u276f(?=[^\u276f]*$)/g)?.[0];if(i){const m=this.G(i,$,"\u276F");if(m)return m}const t=$.match(/^(?<prompt>\$)/)?.groups?.prompt;if(t){const m=this.G(t,$,"$");if(m)return m}const o=$.match(/^(?<prompt>>>> )/g)?.groups?.prompt;if(o)return{prompt:o,likelySingleLine:!0};if(this.r.promptTerminator&&$.trim().endsWith(this.r.promptTerminator)){const m=this.G($,$,this.r.promptTerminator);if(m)return m}const L=$.match(/^(?<prompt>(\(.+\)\s)?(?:[A-Z]:\\.*>))/);return L?.groups?.prompt?{prompt:L.groups.prompt,likelySingleLine:!0}:void 0}G(s,n,$){if(s)return n===s&&s.endsWith($)&&(s+=" "),s}};P=be([ze(3,j.$5j)],P);function a(f,s,n,$){if(!$)return;const v=s.executedMarker,i=s.endMarker;if(!v||!i)return;const t=v.line,o=i.line,L=$.length,m=[];if($.anchor==="bottom")for(let M=o-($.offset||0);M>=t;M--){let C=M;const b=M;for(;C>=t&&f.getLine(C)?.isWrapped;)C--;M=C,m.unshift(c(f,C,b,n)),m.length>L&&m.pop()}else for(let M=t+($.offset||0);M<o;M++){const C=M;let b=M;for(;b+1<o&&f.getLine(b+1)?.isWrapped;)b++;M=b,m.push(c(f,C,b,n)),m.length===L&&m.shift()}return m}function c(f,s,n,$){const v=Math.max(2048/$*2);n=Math.min(n,s+v);let i="";for(let t=s;t<=n;t++){const o=f.getLine(t);o&&(i+=o.translateToString(!0,0,$))}return i}function g(f,s,n=0){return f.registerMarker(s.line-(f.buffer.active.baseY+f.buffer.active.cursorY)+n)}}),define(fe[91],ge([0,1,4,2]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xub=void 0;class E extends S.$Uc{constructor(){super(...arguments),this.type=0,this.a="",this.b=new Map,this.c=this.B(new y.$fe),this.onDidChangeCwd=this.c.event}get cwds(){return Array.from(this.b.keys())}getCwd(){return this.a}updateCwd(j){const k=this.a!==j;this.a=j;const h=this.b.get(this.a)||0;this.b.delete(this.a),this.b.set(this.a,h+1),k&&this.c.fire(j)}}e.$Xub=E}),define(fe[92],ge([0,1,4,2]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yub=void 0;var E;(function(j){j[j.MinimumPromptLength=2]="MinimumPromptLength"})(E||(E={}));class A extends S.$Tc{get commands(){return this.a}constructor(k){super(),this.c=k,this.type=3,this.a=[],this.b=this.add(new y.$fe),this.onCommandFinished=this.b.event,this.add(this.c.onData(h=>this.h(h))),this.add(this.c.parser.registerCsiHandler({final:"J"},h=>(h.length>=1&&(h[0]===2||h[0]===3)&&this.m(),!1)))}h(k){k==="\r"&&this.j()}j(){if(this.c&&this.c.buffer.active.cursorX>=2){const k=this.c.registerMarker(0);k&&(this.a.push(k),this.b.fire(k))}}m(){let k=0;for(let h=this.a.length-1;h>=0&&!(this.a[h].line<this.c.buffer.active.baseY);h--)k++;this.a.splice(this.a.length-k,k)}}e.$Yub=A}),define(fe[93],ge([0,1,4,2]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uub=e.$Tub=void 0;class E extends S.$Uc{constructor(){super(...arguments),this.a=new Map,this.b=this.B(new y.$fe),this.onDidRemoveCapabilityType=this.b.event,this.f=this.B(new y.$fe),this.onDidAddCapabilityType=this.f.event,this.g=this.B(new y.$fe),this.onDidRemoveCapability=this.g.event,this.h=this.B(new y.$fe),this.onDidAddCapability=this.h.event}get items(){return this.a.keys()}add(k,h){this.a.set(k,h),this.f.fire(k),this.h.fire({id:k,capability:h})}get(k){return this.a.get(k)}remove(k){const h=this.a.get(k);h&&(this.a.delete(k),this.b.fire(k),this.h.fire({id:k,capability:h}))}has(k){return this.a.has(k)}}e.$Tub=E;class A extends S.$Uc{constructor(){super(...arguments),this._stores=[],this.a=this.B(new y.$fe),this.onDidRemoveCapabilityType=this.a.event,this.b=this.B(new y.$fe),this.onDidAddCapabilityType=this.b.event,this.f=this.B(new y.$fe),this.onDidRemoveCapability=this.f.event,this.g=this.B(new y.$fe),this.onDidAddCapability=this.g.event}get items(){return this.h()}*h(){for(const k of this._stores)for(const h of k.items)yield h}has(k){for(const h of this._stores)for(const r of h.items)if(r===k)return!0;return!1}get(k){for(const h of this._stores){const r=h.get(k);if(r)return r}}add(k){this._stores.push(k);for(const h of k.items)this.b.fire(h),this.g.fire({id:h,capability:k.get(h)});this.B(k.onDidAddCapabilityType(h=>this.b.fire(h))),this.B(k.onDidAddCapability(h=>this.g.fire(h))),this.B(k.onDidRemoveCapabilityType(h=>this.a.fire(h))),this.B(k.onDidRemoveCapability(h=>this.f.fire(h)))}}e.$Uub=A}),define(fe[36],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var y;(function(S){S[S.Replace=1]="Replace",S[S.Append=2]="Append",S[S.Prepend=3]="Prepend"})(y||(e.EnvironmentVariableMutatorType=y={}))}),define(fe[94],ge([0,1,3,36]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=void 0;const E=new Map([[S.EnvironmentVariableMutatorType.Append,"APPEND"],[S.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[S.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class A{constructor(p){this.collections=p,this.a=new Map,this.b=new Map,p.forEach((l,P)=>{this.d(l,P);const a=l.map.entries();let c=a.next();for(;!c.done;){const g=c.value[1],f=c.value[0];let s=this.a.get(f);if(s||(s=[],this.a.set(f,s)),s.length>0&&s[0].type===S.EnvironmentVariableMutatorType.Replace){c=a.next();continue}const n={extensionIdentifier:P,value:g.value,type:g.type,scope:g.scope,variable:g.variable,options:g.options};n.scope||delete n.scope,s.unshift(n),c=a.next()}})}async applyToProcessEnvironment(p,l,P){let a;y.$i&&(a={},Object.keys(p).forEach(c=>a[c.toLowerCase()]=c));for(const[c,g]of this.getVariableMap(l)){const f=y.$i&&a[c.toLowerCase()]||c;for(const s of g){const n=P?await P(s.value):s.value;if(s.options?.applyAtProcessCreation??!0)switch(s.type){case S.EnvironmentVariableMutatorType.Append:p[f]=(p[f]||"")+n;break;case S.EnvironmentVariableMutatorType.Prepend:p[f]=n+(p[f]||"");break;case S.EnvironmentVariableMutatorType.Replace:p[f]=n;break}if(s.options?.applyAtShellIntegration??!1){const $=`VSCODE_ENV_${E.get(s.type)}`;p[$]=(p[$]?p[$]+":":"")+c+"="+this.c(n)}}}}c(p){return p.replaceAll(":","\\x3a")}diff(p,l){const P=new Map,a=new Map,c=new Map;if(p.getVariableMap(l).forEach((g,f)=>{const s=this.getVariableMap(l).get(f),n=k(g,s);n&&P.set(f,n)}),this.getVariableMap(l).forEach((g,f)=>{const s=p.getVariableMap(l).get(f),n=k(g,s);n&&c.set(f,n)}),this.getVariableMap(l).forEach((g,f)=>{const s=p.getVariableMap(l).get(f),n=h(g,s);n&&a.set(f,n)}),!(P.size===0&&a.size===0&&c.size===0))return{added:P,changed:a,removed:c}}getVariableMap(p){const l=new Map;for(const P of this.a.values()){const a=P.filter(c=>j(c,p));a.length>0&&l.set(a[0].variable,a)}return l}getDescriptionMap(p){const l=new Map;for(const P of this.b.values()){const a=P.filter(c=>j(c,p,!0));for(const c of a)l.set(c.extensionIdentifier,c.description)}return l}d(p,l){if(!p.descriptionMap)return;const P=p.descriptionMap.entries();let a=P.next();for(;!a.done;){const c=a.value[1],g=a.value[0];let f=this.b.get(g);f||(f=[],this.b.set(g,f));const s={extensionIdentifier:l,scope:c.scope,description:c.description};s.scope||delete s.scope,f.push(s),a=P.next()}}}e.$us=A;function j(r,p,l=!1){return r.scope?!!(r.scope.workspaceFolder&&p?.workspaceFolder&&r.scope.workspaceFolder.index===p.workspaceFolder.index):l?p===r.scope:!0}function k(r,p){if(!p)return r;const l=new Set;p.forEach(a=>l.add(a.extensionIdentifier));const P=[];return r.forEach(a=>{l.has(a.extensionIdentifier)||P.push(a)}),P.length===0?void 0:P}function h(r,p){if(!p)return;const l=new Map;p.forEach(a=>l.set(a.extensionIdentifier,a));const P=[];return r.forEach(a=>{const c=l.get(a.extensionIdentifier);c&&(a.type!==c.type||a.value!==c.value||a.scope?.workspaceFolder?.index!==c.scope?.workspaceFolder?.index)&&P.push(c)}),P.length===0?void 0:P}}),define(fe[95],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=y,e.$ps=S,e.$qs=E,e.$rs=A,e.$ss=j,e.$ts=k;function y(h){return[...h.entries()]}function S(h){return h?[...h.entries()]:[]}function E(h){return new Map(h)}function A(h){return new Map(h??[])}function j(h){return Array.from(h.entries()).map(r=>[r[0],y(r[1].map),S(r[1].descriptionMap)])}function k(h){return new Map(h.map(r=>[r[0],{map:E(r[1]),descriptionMap:A(r[2])}]))}}),define(fe[96],ge([0,1,12,17,4,2,8]),function(ae,e,y,S,E,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0;let k=class extends A.$Uc{constructor(r,p){super(),this.h=p,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new E.$fe),this.onCreateRequest=this.g.event,this.b=r===void 0?15e3:r,this.B((0,A.$Sc)(()=>{for(const l of this.f.values())(0,A.$Pc)(l)}))}createRequest(r){return new Promise((p,l)=>{const P=++this.a;this.c.set(P,p),this.g.fire({requestId:P,...r});const a=new S.$qe;(0,y.$zh)(this.b,a.token).then(()=>l(`Request ${P} timed out (${this.b}ms)`)),this.f.set(P,[(0,A.$Sc)(()=>a.cancel())])})}acceptReply(r,p){const l=this.c.get(r);l?(this.c.delete(r),(0,A.$Pc)(this.f.get(r)||[]),this.f.delete(r),l(p)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${r}`)}};e.$fs=k,e.$fs=k=be([ze(1,j.$5j)],k)}),define(fe[28],ge([0,1,21,35,86]),function(ae,e,y,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=e.$_r=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$$r=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$0r=void 0,e.$0r=new S.$Pj("terminalTabFocusMode",!1,!0);var A;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(A||(e.TerminalSettingPrefix=A={}));var j;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(j||(e.TerminalSettingId=j={}));var k;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(k||(e.PosixShellType=k={}));var h;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})(h||(e.WindowsShellType=h={}));var r;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(r||(e.TitleEventSource=r={}));var p;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(p||(e.TerminalIpcChannels=p={}));var l;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(l||(e.ProcessPropertyType=l={})),e.$$r=(0,y.$yi)("ptyService");var P;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(P||(e.HeartbeatConstants=P={}));var a;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(a||(e.TerminalLocation=a={}));var c;(function(i){i.TerminalView="view",i.Editor="editor"})(c||(e.TerminalLocationString=c={}));var g;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(g||(e.LocalReconnectConstants=g={}));var f;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(f||(e.FlowControlConstants=f={}));var s;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(s||(e.ProfileSource=s={}));var n;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(n||(e.ShellIntegrationStatus=n={}));var $;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})($||(e.TerminalExitReason=$={})),e.$_r={Backend:"workbench.contributions.terminal.processBackend"};class v{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}E.$fo.add(e.$_r.Backend,new v),e.$as=(0,y.$yi)("localPtyService"),e.$bs=(0,y.$yi)("terminalLogService")}),define(fe[97],ge([0,1,12,2,3]),function(ae,e,y,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kjc=void 0;class A extends S.$Uc{constructor(k,h,r,p){super(),this.a=0,this.b=!1,this.c=!1,this.B(k.onProcessData(l=>{if(this.b||this.c)return;const P=typeof l=="string"?l:l.data;for(let a=0;a<P.length;a++)P[a]===h[this.a]?this.a++:this.f(),this.a===h.length&&(p.debug(`Auto reply match: "${h}", response: "${r}"`),k.input(r),this.c=!0,(0,y.$zh)(1e3).then(()=>this.c=!1),this.f())}))}f(){this.a=0}handleResize(){E.$i&&(this.b=!0)}handleInput(){this.b=!1}}e.$kjc=A}),define(fe[98],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0vb=void 0;class y{constructor(E){this.b=E,this.a=new Map}dispose(){for(const E of this.a.values())E.dispose()}startBuffering(E,A,j=5){const k=A(h=>{const r=typeof h=="string"?h:h.data;let p=this.a.get(E);if(p){p.data.push(r);return}const l=setTimeout(()=>this.flushBuffer(E),j);p={data:[r],timeoutId:l,dispose:()=>{clearTimeout(l),this.flushBuffer(E),k.dispose()}},this.a.set(E,p)});return k}stopBuffering(E){this.a.get(E)?.dispose()}flushBuffer(E){const A=this.a.get(E);A&&(this.a.delete(E),this.b(E,A.data.join("")))}}e.$0vb=y}),define(fe[37],ge([0,1,3]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CP=S,e.$DP=E,e.$EP=A,e.$FP=j;function S(k){let h=k;h.includes("\\")&&(h=h.replace(/\\/g,"\\\\"));const r=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return h=h.replace(r,""),`'${h}'`}function E(k,h,r){if(!k)return"";if(!h)return k;h.match(/[\/\\]$/)&&(h=h.slice(0,h.length-1));const p=k.replace(/\\/g,"/").toLowerCase(),l=h.replace(/\\/g,"/").toLowerCase();return p.includes(l)?`~${r}${k.slice(h.length+1)}`:k}function A(k){return k.match(/^['"].*['"]$/)&&(k=k.substring(1,k.length-1)),y.OS===1&&k&&k[1]===":"?k[0].toUpperCase()+k.substring(1):k}function j(k){return!k.strictEnv}}),define(fe[99],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=S;var y;(function(E){E[E.WriteMaxChunkSize=50]="WriteMaxChunkSize"})(y||(y={}));function S(E){const A=[];let j=0;for(let k=0;k<E.length-1;k++)(k-j+1>=50||E[k+1]==="\x1B")&&(A.push(E.substring(j,k+1)),j=k+1,k++);return j!==E.length&&A.push(E.substring(j)),A}}),define(fe[100],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Ub=y;function y(S,E={}){let A="";return E.excludeLeadingNewLine||(A+=`\r
`),A+="\x1B[0m\x1B[7m * ",E.loudFormatting?A+="\x1B[0;104m":A+="\x1B[0m",A+=` ${S} \x1B[0m
\r`,A}}),define(fe[101],ge([0,1,2,93,90,91,92,4,87,6,37,9]),function(ae,e,y,S,E,A,j,k,h,r,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ub=e.ShellIntegrationOscPs=void 0,e.$2ub=s,e.$3ub=n,e.$4ub=$;var P;(function(v){v[v.FinalTerm=133]="FinalTerm",v[v.VSCode=633]="VSCode",v[v.ITerm=1337]="ITerm",v[v.SetCwd=7]="SetCwd",v[v.SetWindowsFriendlyCwd=9]="SetWindowsFriendlyCwd"})(P||(e.ShellIntegrationOscPs=P={}));var a;(function(v){v.PromptStart="A",v.CommandStart="B",v.CommandExecuted="C",v.CommandFinished="D"})(a||(a={}));var c;(function(v){v.PromptStart="A",v.CommandStart="B",v.CommandExecuted="C",v.CommandFinished="D",v.CommandLine="E",v.ContinuationStart="F",v.ContinuationEnd="G",v.RightPromptStart="H",v.RightPromptEnd="I",v.Property="P",v.SetMark="SetMark"})(c||(c={}));var g;(function(v){v.SetMark="SetMark",v.CurrentDir="CurrentDir"})(g||(g={}));class f extends y.$Uc{get status(){return this.g}constructor(i,t,o,L){super(),this.j=i,this.m=t,this.n=o,this.r=L,this.capabilities=this.B(new S.$Tub),this.b=!1,this.f=[],this.g=0,this.h=new k.$fe,this.onDidChangeStatus=this.h.event,this.B((0,y.$Sc)(()=>{this.z(),this.s()}))}s(){(0,y.$Pc)(this.f),this.f.length=0}activate(i){this.a=i,this.capabilities.add(3,this.B(new j.$Yub(this.a))),this.B(i.parser.registerOscHandler(633,t=>this.w(t))),this.B(i.parser.registerOscHandler(1337,t=>this.H(t))),this.f.push(i.parser.registerOscHandler(133,t=>this.t(t))),this.B(i.parser.registerOscHandler(7,t=>this.J(t))),this.B(i.parser.registerOscHandler(9,t=>this.I(t))),this.y()}getMarkerId(i,t){this.N(i).getMark(t)}t(i){const t=this.u(i);return this.g===0&&(this.g=1,this.h.fire(this.g)),t}u(i){if(!this.a)return!1;const[t,...o]=i.split(";");switch(t){case"A":return this.M(this.a).handlePromptStart(),!0;case"B":return this.M(this.a).handleCommandStart({ignoreCommandLine:!0}),!0;case"C":return this.M(this.a).handleCommandExecuted(),!0;case"D":{const L=o.length===1?parseInt(o[0]):void 0;return this.M(this.a).handleCommandFinished(L),!0}}return!1}w(i){const t=this.C(i);return!this.b&&t&&(this.n?.publicLog2("terminal/shellIntegrationActivationSucceeded"),this.b=!0,this.z()),this.g!==2&&(this.g=2,this.h.fire(this.g)),t}async y(){!this.n||this.m||(this.c=setTimeout(()=>{!this.capabilities.get(2)&&!this.capabilities.get(0)&&(this.n?.publicLog2("terminal/shellIntegrationActivationTimeout"),this.r.warn("Shell integration failed to add capabilities within 10 seconds")),this.b=!0},1e4))}z(){this.c!==void 0&&(clearTimeout(this.c),this.c=void 0)}C(i){if(!this.a)return!1;const t=i.indexOf(";"),o=t===-1?i:i.substring(0,t),L=t===-1?[]:i.substring(t+1).split(";");switch(o){case"A":return this.M(this.a).handlePromptStart(),!0;case"B":return this.M(this.a).handleCommandStart(),!0;case"C":return this.M(this.a).handleCommandExecuted(),!0;case"D":{const m=L[0],M=m!==void 0?parseInt(m):void 0;return this.M(this.a).handleCommandFinished(M),!0}case"E":{const m=L[0],M=L[1];let C;return m!==void 0?C=s(m):C="",this.M(this.a).setCommandLine(C,M===this.j),!0}case"F":return this.M(this.a).handleContinuationStart(),!0;case"G":return this.M(this.a).handleContinuationEnd(),!0;case"H":return this.M(this.a).handleRightPromptStart(),!0;case"I":return this.M(this.a).handleRightPromptEnd(),!0;case"P":{const m=L[0],M=m!==void 0?s(m):"",{key:C,value:b}=n(M);if(b===void 0)return!0;switch(C){case"ContinuationPrompt":return this.D((0,l.$Wf)(b)),!0;case"Cwd":return this.G(b),!0;case"IsWindows":return this.M(this.a).setIsWindowsPty(b==="True"),!0;case"Prompt":{const U=b.replace(/\x1b\[[0-9;]*m/g,"");return this.F(U),!0}case"Task":return this.N(this.a),this.capabilities.get(2)?.setIsCommandStorageDisabled(),!0}}case"SetMark":return this.N(this.a).addMark($(L)),!0}return!1}D(i){this.a&&this.M(this.a).setContinuationPrompt(i)}F(i){if(!this.a)return;const t=i.substring(i.lastIndexOf(`
`)+1),o=t.substring(t.lastIndexOf(" "));o&&this.M(this.a).setPromptTerminator(o,t)}G(i){i=(0,p.$EP)(i),this.L().updateCwd(i),this.capabilities.get(2)?.setCwd(i)}H(i){if(!this.a)return!1;const[t]=i.split(";");switch(t){case"SetMark":this.N(this.a).addMark();default:{const{key:o,value:L}=n(t);if(L===void 0)return!0;switch(o){case"CurrentDir":return this.G(L),!0}}}return!1}I(i){if(!this.a)return!1;const[t,...o]=i.split(";");switch(t){case"9":return o.length&&this.G(o[0]),!0}return!1}J(i){if(!this.a)return!1;const[t]=i.split(";");if(t.match(/^file:\/\/.*\//)){const o=r.URI.parse(t);if(o.path&&o.path.length>0)return this.G(o.path),!0}return!1}serialize(){return!this.a||!this.capabilities.has(2)?{isWindowsPty:!1,commands:[]}:this.M(this.a).serialize()}deserialize(i){if(!this.a)throw new Error("Cannot restore commands before addon is activated");this.M(this.a).deserialize(i)}L(){let i=this.capabilities.get(0);return i||(i=this.B(new A.$Xub),this.capabilities.add(0,i)),i}M(i){let t=this.capabilities.get(2);return t||(t=this.B(new E.$Vub(i,this.r)),this.capabilities.add(2,t)),t}N(i){let t=this.capabilities.get(4);return t||(t=this.B(new h.$Zub(i)),this.capabilities.add(4,t)),t}}e.$1ub=f;function s(v){return v.replaceAll(/\\(\\|x([0-9a-f]{2}))/gi,(i,t,o)=>o?String.fromCharCode(parseInt(o,16)):t)}function n(v){const i=v.indexOf("=");return i===-1?{key:v,value:void 0}:{key:v.substring(0,i),value:v.substring(1+i)}}function $(v){let i,t=!1;for(const o of v)o!==void 0&&(o==="Hidden"&&(t=!0),o.startsWith("Id=")&&(i=o.substring(3)));return{id:i,hidden:t}}}),define(fe[38],ge([0,1,5,14,4,2,62,8]),function(ae,e,y,S,E,A,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mjc=e.$ljc=void 0;var h;(function(p){p[p.InactiveThrottleDuration=5e3]="InactiveThrottleDuration",p[p.ActiveDebounceDuration=1e3]="ActiveDebounceDuration"})(h||(h={})),e.$ljc=[];let r=class extends A.$Uc{set hasChildProcesses(l){this.a!==l&&(this.a=l,this.f.debug("ChildProcessMonitor: Has child processes changed",l),this.b.fire(l))}get hasChildProcesses(){return this.a}constructor(l,P){super(),this.c=l,this.f=P,this.a=!1,this.b=this.B(new E.$fe),this.onDidChangeHasChildProcesses=this.b.event}handleInput(){this.g()}handleOutput(){this.h()}async g(){if(!this.q.isDisposed)try{const l=await(0,j.$Gs)(this.c);this.hasChildProcesses=this.j(l)}catch(l){this.f.debug("ChildProcessMonitor: Fetching process tree failed",l)}}h(){this.g()}j(l){if(!l.children)return!1;if(l.children.length===1){const P=l.children[0];let a;if(P.cmd.startsWith('"'))a=P.cmd.substring(1,P.cmd.indexOf('"',1));else{const c=P.cmd.indexOf(" ");c===-1?a=P.cmd:a=P.cmd.substring(0,c)}return e.$ljc.indexOf((0,y.$qc)(a).name)===-1}return l.children.length>0}};e.$mjc=r,be([(0,S.$4h)(1e3)],r.prototype,"g",null),be([(0,S.$5h)(5e3)],r.prototype,"h",null),e.$mjc=r=be([ze(1,k.$5j)],r)}),define(fe[102],ge([0,1,4,2,28]),function(ae,e,y,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$njc=void 0;class A extends S.$Uc{constructor(){super(),this.a=this.B(new y.$fe),this.onBeat=this.a.event;const k=setInterval(()=>{this.a.fire()},E.HeartbeatConstants.BeatInterval);this.B((0,S.$Sc)(()=>clearInterval(k)))}}e.$njc=A}),define(fe[39],ge([0,1,20,19,30,5,3,15,9,10,24,36,95,94]),function(ae,e,y,S,E,A,j,k,h,r,p,l,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=c,e.$ws=g,e.$xs=f;function c(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(y.release());let b=0;return C&&C.length===4&&(b=parseInt(C[3])),b}async function g(C,b,U,K=k.env,F=p.Promises.exists){if(A.$ic(C))return await F(C)?C:void 0;if(b===void 0&&(b=k.cwd()),A.$mc(C)!=="."){const w=A.$jc(b,C);return await F(w)?w:void 0}const d=(0,E.$_n)(K,"PATH");if(U===void 0&&(0,r.$$f)(d)&&(U=d.split(A.$tc)),U===void 0||U.length===0){const w=A.$jc(b,C);return await F(w)?w:void 0}for(const w of U){let D;if(A.$ic(w)?D=A.$jc(w,C):D=A.$jc(b,w,C),await F(D))return D;if(j.$i){let Y=D+".com";if(await F(Y)||(Y=D+".exe",await F(Y)))return Y}}const I=A.$jc(b,C);return await F(I)?I:void 0}function f(C,b,U,K,F){const O=j.$i&&(!b.windowsEnableConpty||c()<18309);if(!b.shellIntegration.enabled||!C.executable||C.isFeatureTerminal&&!C.forceShellIntegration||C.ignoreShellIntegration||O)return;const d=C.args,I=k.$dc==="win32"?A.$nc(C.executable).toLowerCase():A.$nc(C.executable),w=A.$mc(S.$Sg.asFileUri("").fsPath);let D;const Y={VSCODE_INJECTION:"1"};if(b.shellIntegration.nonce&&(Y.VSCODE_NONCE=b.shellIntegration.nonce),j.$i){if(I==="pwsh.exe"||I==="powershell.exe")return!d||m(d)?D=$.get(n.WindowsPwsh):L(d)&&(D=$.get(n.WindowsPwshLogin)),D?(D=[...D],D[D.length-1]=(0,h.$0e)(D[D.length-1],w,""),b.shellIntegration.suggestEnabled&&(Y.VSCODE_SUGGEST="1"),{newArgs:D,envMixin:Y}):void 0;if(I==="bash.exe")return!d||d.length===0?D=$.get(n.Bash):M(d)&&(Y.VSCODE_SHELL_LOGIN="1",s(b,Y),D=$.get(n.Bash)),D?(D=[...D],D[D.length-1]=(0,h.$0e)(D[D.length-1],w),{newArgs:D,envMixin:Y}):void 0;K.warn(`Shell integration cannot be enabled for executable "${C.executable}" and args`,C.args);return}switch(I){case"bash":return!d||d.length===0?D=$.get(n.Bash):M(d)&&(Y.VSCODE_SHELL_LOGIN="1",s(b,Y),D=$.get(n.Bash)),D?(D=[...D],D[D.length-1]=(0,h.$0e)(D[D.length-1],w),{newArgs:D,envMixin:Y}):void 0;case"fish":{const te=U?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",V=A.$jc(w,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return Y.XDG_DATA_DIRS=`${te}:${V}`,s(b,Y),{newArgs:void 0,envMixin:Y}}case"pwsh":return!d||m(d)?D=$.get(n.Pwsh):L(d)&&(D=$.get(n.PwshLogin)),D?(b.shellIntegration.suggestEnabled&&(Y.VSCODE_SUGGEST="1"),D=[...D],D[D.length-1]=(0,h.$0e)(D[D.length-1],w,""),{newArgs:D,envMixin:Y}):void 0;case"zsh":{if(!d||d.length===0?D=$.get(n.Zsh):M(d)?(D=$.get(n.ZshLogin),s(b,Y)):(d===$.get(n.Zsh)||d===$.get(n.ZshLogin))&&(D=d),!D)return;D=[...D],D[D.length-1]=(0,h.$0e)(D[D.length-1],w);let te;try{te=y.userInfo().username}catch{te="unknown"}const V=A.$jc(y.tmpdir(),`${te}-${F.applicationName}-zsh`);Y.ZDOTDIR=V;const ee=U?.ZDOTDIR??y.homedir()??"~";Y.USER_ZDOTDIR=ee;const oe=[];return oe.push({source:A.$jc(w,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.$jc(V,".zshrc")}),oe.push({source:A.$jc(w,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.$jc(V,".zprofile")}),oe.push({source:A.$jc(w,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.$jc(V,".zshenv")}),oe.push({source:A.$jc(w,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.$jc(V,".zlogin")}),{newArgs:D,envMixin:Y,filesToCopy:oe}}}K.warn(`Shell integration cannot be enabled for executable "${C.executable}" and args`,C.args)}function s(C,b){if(j.$j&&C.environmentVariableCollections){const U=(0,P.$ts)(C.environmentVariableCollections),F=new a.$us(U).getVariableMap({workspaceFolder:C.workspaceFolder}).get("PATH"),O=[];if(F)for(const d of F)d.type===l.EnvironmentVariableMutatorType.Prepend&&O.push(d.value);O.length>0&&(b.VSCODE_PATH_PREFIX=O.join(""))}}var n;(function(C){C.WindowsPwsh="windows-pwsh",C.WindowsPwshLogin="windows-pwsh-login",C.Pwsh="pwsh",C.PwshLogin="pwsh-login",C.Zsh="zsh",C.ZshLogin="zsh-login",C.Bash="bash"})(n||(n={}));const $=new Map;$.set(n.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),$.set(n.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),$.set(n.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),$.set(n.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),$.set(n.Zsh,["-i"]),$.set(n.ZshLogin,["-il"]),$.set(n.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const v=["-login","-l"],i=["--login","-l"],t=["-i","--interactive"],o=["-nol","-nologo"];function L(C){return typeof C=="string"?v.includes(C.toLowerCase()):C.length===1&&v.includes(C[0].toLowerCase())||C.length===2&&(v.includes(C[0].toLowerCase())||v.includes(C[1].toLowerCase()))&&(o.includes(C[0].toLowerCase())||o.includes(C[1].toLowerCase()))}function m(C){return typeof C=="string"?o.includes(C.toLowerCase()):C.length===0||C?.length===1&&o.includes(C[0].toLowerCase())}function M(C){return typeof C!="string"&&(C=C.filter(b=>!t.includes(b.toLowerCase()))),C==="string"&&i.includes(C.toLowerCase())||typeof C!="string"&&C.length===1&&i.includes(C[0].toLowerCase())}}),define(fe[103],ge([0,1,12,14,4,2,3]),function(ae,e,y,S,E,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ojc=void 0;const k=["cmd.exe","powershell.exe","pwsh.exe","bash.exe","wsl.exe","ubuntu.exe","ubuntu1804.exe","kali.exe","debian.exe","opensuse-42.exe","sles-12.exe"];let h;class r extends A.$Uc{get shellType(){return this.b}get shellTitle(){return this.c}get onShellNameChanged(){return this.f.event}get onShellTypeChanged(){return this.g.event}constructor(l){if(super(),this.h=l,this.c="",this.f=new E.$fe,this.g=new E.$fe,!j.$i)throw new Error(`WindowsShellHelper cannot be instantiated on ${j.$u}`);this.j()}async j(){this.q.isDisposed||this.checkShell()}async checkShell(){j.$i&&(await(0,y.$zh)(300),this.getShellName().then(l=>{const P=this.getShellType(l);P!==this.b&&(this.g.fire(P),this.f.fire(l),this.b=P,this.c=l)}))}m(l){if(!l)return"";if(k.indexOf(l.name)===-1||!l.children||l.children.length===0)return l.name;let P=0;for(;P<l.children.length;P++){const a=l.children[P];if(!a.children||a.children.length===0||a.children[0].name!=="conhost.exe")break}return P>=l.children.length?l.name:this.m(l.children[P])}async getShellName(){return this.q.isDisposed?Promise.resolve(""):this.a?this.a:(h||(h=await new Promise((l,P)=>{ae(["@vscode/windows-process-tree"],l,P)})),this.a=new Promise(l=>{h.getProcessTree(this.h,P=>{const a=this.m(P);this.a=void 0,l(a)})}),this.a)}getShellType(l){switch(l.toLowerCase()){case"cmd.exe":return"cmd";case"powershell.exe":case"pwsh.exe":return"pwsh";case"bash.exe":case"git-cmd.exe":return"gitbash";case"wsl.exe":case"ubuntu.exe":case"ubuntu1804.exe":case"kali.exe":case"debian.exe":case"opensuse-42.exe":case"sles-12.exe":return"wsl";default:return l.match(/python(\d(\.\d{0,2})?)?\.exe/)?"python":void 0}}}e.$ojc=r,be([(0,S.$4h)(500)],r.prototype,"checkShell",null)}),define(fe[104],ge([0,1,26,12,4,2,5,3,6,24,72,8,85,38,39,103,109,99]),function(ae,e,y,S,E,A,j,k,h,r,p,l,P,a,c,g,f,s){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$pjc=void 0;var $;(function(L){L[L.DataFlushTimeout=250]="DataFlushTimeout",L[L.MaximumShutdownTime=5e3]="MaximumShutdownTime"})($||($={}));var v;(function(L){L[L.KillSpawnThrottleInterval=250]="KillSpawnThrottleInterval",L[L.KillSpawnSpacingDuration=50]="KillSpawnSpacingDuration",L[L.WriteInterval=5]="WriteInterval"})(v||(v={}));const i=new Map([["bash","bash"],["csh","csh"],["fish","fish"],["ksh","ksh"],["sh","sh"],["pwsh","pwsh"],["python","python"],["zsh","zsh"]]);let t=class extends A.$Uc{static{n=this}static{this.b=0}get exitMessage(){return this.h}get currentTitle(){return this.t?.shellTitle||this.n}get shellType(){return k.$i?this.t?.shellType:i.get(this.n)}get hasChildProcesses(){return this.u?.hasChildProcesses||!1}constructor(m,M,C,b,U,K,F,O,d){super(),this.shellLaunchConfig=m,this.N=K,this.O=F,this.P=O,this.Q=d,this.id=0,this.shouldPersist=!1,this.a={cwd:"",initialCwd:"",fixedDimensions:{cols:void 0,rows:void 0},title:"",shellType:void 0,hasChildProcesses:!0,resolvedShellLaunchConfig:{},overrideDimensions:void 0,failedShellIntegrationActivation:!1,usedShellIntegrationInjection:void 0},this.n="",this.w=null,this.y=[],this.G=!1,this.H=0,this.I=this.B(new E.$fe),this.onProcessData=this.I.event,this.J=this.B(new E.$fe),this.onProcessReady=this.J.event,this.L=this.B(new E.$fe),this.onDidChangeProperty=this.L.event,this.M=this.B(new E.$fe),this.onProcessExit=this.M.event;let I;k.$i?I=j.$nc(this.shellLaunchConfig.executable||""):I="xterm-256color",this.D=M,this.a.initialCwd=this.D,this.a.cwd=this.D;const w=this.O.windowsEnableConpty&&process.platform==="win32"&&(0,c.$vs)()>=18309;this.F={name:I,cwd:M,env:U,cols:C,rows:b,useConpty:w,conptyInheritCursor:w&&!!m.initialText},k.$i&&(w&&C===0&&b===0&&this.shellLaunchConfig.executable?.endsWith("Git\\bin\\bash.exe")&&(this.C=new o,this.B(this.C.onTrigger(D=>{this.C?.dispose(),this.C=void 0,D.cols&&D.rows&&this.resize(D.cols,D.rows)}))),this.onProcessReady(D=>{this.t=this.B(new g.$ojc(D.pid)),this.B(this.t.onShellTypeChanged(Y=>this.L.fire({type:"shellType",value:Y}))),this.B(this.t.onShellNameChanged(Y=>this.L.fire({type:"title",value:Y})))})),this.B((0,A.$Sc)(()=>{this.w&&(clearInterval(this.w),this.w=null)}))}async start(){const M=(await Promise.all([this.R(),this.S()])).find(b=>b!==void 0);if(M)return M;let C;if(this.O.shellIntegration.enabled)if(C=(0,c.$xs)(this.shellLaunchConfig,this.O,this.F.env,this.P,this.Q),C){if(this.L.fire({type:"usedShellIntegrationInjection",value:!0}),C.envMixin)for(const[b,U]of Object.entries(C.envMixin))this.F.env||={},this.F.env[b]=U;if(C.filesToCopy)for(const b of C.filesToCopy){await r.Promises.mkdir(j.$mc(b.dest),{recursive:!0});try{await r.Promises.copyFile(b.source,b.dest)}catch{}}}else this.L.fire({type:"failedShellIntegrationActivation",value:!0});try{return await this.U(this.shellLaunchConfig,this.F,C),C?.newArgs?{injectedArgs:C.newArgs}:void 0}catch(b){return this.P.trace("node-pty.node-pty.IPty#spawn native exception",b),{message:`A native exception occurred during launch (${b.message})`}}}async R(){try{if(!(await r.Promises.stat(this.D)).isDirectory())return{message:(0,p.localize)(0,null,this.D.toString())}}catch(m){if(m?.code==="ENOENT")return{message:(0,p.localize)(1,null,this.D.toString())}}this.L.fire({type:"initialCwd",value:this.D})}async S(){const m=this.shellLaunchConfig;if(!m.executable)throw new Error("IShellLaunchConfig.executable not set");const M=m.cwd instanceof h.URI?m.cwd.path:m.cwd,C=m.env&&m.env.PATH?m.env.PATH.split(j.$tc):void 0,b=await(0,c.$ws)(m.executable,M,C,this.N);if(!b)return{message:(0,p.localize)(2,null,m.executable)};try{const U=await r.Promises.stat(b);if(!U.isFile()&&!U.isSymbolicLink())return{message:(0,p.localize)(3,null,m.executable)};m.executable=b}catch(U){if(U?.code!=="EACCES")throw U}}async U(m,M,C){const b=C?.newArgs||m.args||[];await this.Z(),this.P.trace("node-pty.IPty#spawn",m.executable,b,M);const U=(0,f.spawn)(m.executable,b,M);this.m=U,this.u=this.B(new a.$mjc(U.pid,this.P)),this.u.onDidChangeHasChildProcesses(K=>this.L.fire({type:"hasChildProcesses",value:K})),this.s=new Promise(K=>{this.onProcessReady(()=>K())}),U.onData(K=>{this.H+=K.length,!this.G&&this.H>1e5&&(this.P.trace(`Flow control: Pause (${this.H} > 100000)`),this.G=!0,U.pause()),this.P.trace("node-pty.IPty#onData",K),this.I.fire(K),this.j&&this.X(),this.t?.checkShell(),this.u?.handleOutput()}),U.onExit(K=>{this.g=K.exitCode,this.X()}),this.$(U.pid),this.W(U)}W(m){setTimeout(()=>this.ab(m)),k.$i||(this.w=setInterval(()=>{this.n!==m.process&&this.ab(m)},200))}X(){this.P.getLevel()===l.LogLevel.Trace&&this.P.trace("TerminalProcess#_queueProcessExit",new Error().stack?.replace(/^Error/,"")),this.j&&clearTimeout(this.j),this.j=setTimeout(()=>{this.j=void 0,this.Y()},250)}async Y(){if(await this.s,!this.q.isDisposed){try{this.m&&(await this.Z(),this.P.trace("node-pty.IPty#kill"),this.m.kill())}catch{}this.M.fire(this.g||0),this.dispose()}}async Z(){if(!(!k.$i||!("useConpty"in this.F)||!this.F.useConpty)){for(;Date.now()-n.b<250;)this.P.trace("Throttling kill/spawn call"),await(0,S.$zh)(250-(Date.now()-n.b)+50);n.b=Date.now()}}$(m){this.J.fire({pid:m,cwd:this.D,windowsPty:this.getWindowsPty()})}ab(m){if(this.q.isDisposed)return;this.n=m.process,this.L.fire({type:"title",value:this.n});const M=this.currentTitle.replace(/ \(figterm\)$/g,"");M.toLowerCase().startsWith("python")?this.L.fire({type:"shellType",value:"python"}):this.L.fire({type:"shellType",value:i.get(M)})}shutdown(m){this.P.getLevel()===l.LogLevel.Trace&&this.P.trace("TerminalProcess#shutdown",new Error().stack?.replace(/^Error/,"")),m&&!k.$i?this.Y():!this.j&&!this.q.isDisposed&&(this.X(),setTimeout(()=>{this.j&&!this.q.isDisposed&&(this.j=void 0,this.Y())},5e3))}input(m,M=!1){this.q.isDisposed||!this.m||(this.y.push(...(0,s.$9r)(m).map(C=>({isBinary:M,data:C}))),this.bb())}async processBinary(m){this.input(m,!0)}async refreshProperty(m){switch(m){case"cwd":{const M=await this.getCwd();return M!==this.a.cwd&&(this.a.cwd=M,this.L.fire({type:"cwd",value:this.a.cwd})),M}case"initialCwd":{const M=await this.getInitialCwd();return M!==this.a.initialCwd&&(this.a.initialCwd=M,this.L.fire({type:"initialCwd",value:this.a.initialCwd})),M}case"title":return this.currentTitle;default:return this.shellType}}async updateProperty(m,M){m==="fixedDimensions"&&(this.a.fixedDimensions=M)}bb(){if(!(this.z!==void 0||this.y.length===0)){if(this.cb(),this.y.length===0){this.z=void 0;return}this.z=setTimeout(()=>{this.z=void 0,this.bb()},5)}}cb(){const m=this.y.shift();this.P.trace("node-pty.IPty#write",m.data),m.isBinary?this.m.write(Buffer.from(m.data,"binary")):this.m.write(m.data),this.u?.handleInput()}resize(m,M){if(!this.q.isDisposed&&!(typeof m!="number"||typeof M!="number"||isNaN(m)||isNaN(M))&&this.m){if(m=Math.max(m,1),M=Math.max(M,1),this.C){this.C.cols=m,this.C.rows=M;return}this.P.trace("node-pty.IPty#resize",m,M);try{this.m.resize(m,M)}catch(C){if(this.P.trace("node-pty.IPty#resize exception "+C.message),this.g!==void 0&&C.message!=="ioctl(2) failed, EBADF"&&C.message!=="Cannot resize a pty that has already exited")throw C}}}clearBuffer(){this.m?.clear()}acknowledgeDataEvent(m){this.H=Math.max(this.H-m,0),this.P.trace(`Flow control: Ack ${m} chars (unacknowledged: ${this.H})`),this.G&&this.H<5e3&&(this.P.trace(`Flow control: Resume (${this.H} < 5000)`),this.m?.resume(),this.G=!1)}clearUnacknowledgedChars(){this.H=0,this.P.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this.G&&(this.m?.resume(),this.G=!1)}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve(this.D)}async getCwd(){if(k.$j)return new Promise(m=>{if(!this.m){m(this.D);return}this.P.trace("node-pty.IPty#pid"),(0,y.exec)("lsof -OPln -p "+this.m.pid+" | grep cwd",{env:{...process.env,LANG:"en_US.UTF-8"}},(M,C,b)=>{!M&&C!==""?m(C.substring(C.indexOf("/"),C.length-1)):(this.P.error("lsof did not run successfully, it may not be on the $PATH?",M,C,b),m(this.D))})});if(k.$k){if(!this.m)return this.D;this.P.trace("node-pty.IPty#pid");try{return await r.Promises.readlink(`/proc/${this.m.pid}/cwd`)}catch{return this.D}}return this.D}getWindowsPty(){return k.$i?{backend:"useConpty"in this.F&&this.F.useConpty?"conpty":"winpty",buildNumber:(0,c.$vs)()}:void 0}};e.$pjc=t,e.$pjc=t=n=be([ze(7,l.$5j),ze(8,P.$lk)],t);class o extends A.$Uc{get onTrigger(){return this.b.event}constructor(){super(),this.b=this.B(new E.$fe),this.a=setTimeout(()=>{this.b.fire({rows:this.rows,cols:this.cols})},1e3),this.B((0,A.$Sc)(()=>clearTimeout(this.a)))}}}),define(fe[105],ge([0,1,26,12,4,2,3,63,8,96,28,98,37,110,39,104,71,38,97,7,101,100,77,14,111]),function(ae,e,y,S,E,A,j,k,h,r,p,l,P,a,c,g,f,s,n,$,v,i,t,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rjc=void 0,e.$qjc=m;function m(I,w,D){if(typeof D.value!="function")throw new Error("not supported");const Y="value",te=D.value;D[Y]=async function(...V){this.traceRpcArgs.logService.getLevel()===h.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Request] PtyService#${te.name}(${V.map(oe=>JSON.stringify(oe)).join(", ")})`),this.traceRpcArgs.simulatedLatency&&await(0,S.$zh)(this.traceRpcArgs.simulatedLatency);let ee;try{ee=await te.apply(this,V)}catch(oe){throw this.traceRpcArgs.logService.error(`[RPC Response] PtyService#${te.name}`,oe),oe}return this.traceRpcArgs.logService.getLevel()===h.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Response] PtyService#${te.name}`,ee),ee}}let M,C;class b extends A.$Uc{H(w,D){return D(Y=>{this.I.getLevel()===h.LogLevel.Trace&&this.I.trace(`[RPC Event] PtyService#${w}.fire(${JSON.stringify(Y)})`)}),D}get traceRpcArgs(){return{logService:this.I,simulatedLatency:this.M}}constructor(w,D,Y,te){super(),this.I=w,this.J=D,this.L=Y,this.M=te,this.a=new Map,this.b=new Map,this.g=new Map,this.j=new Map,this.n=0,this.u=this.B(new E.$fe),this.onHeartbeat=this.H("_onHeartbeat",this.u.event),this.w=this.B(new E.$fe),this.onProcessData=this.H("_onProcessData",this.w.event),this.y=this.B(new E.$fe),this.onProcessReplay=this.H("_onProcessReplay",this.y.event),this.z=this.B(new E.$fe),this.onProcessReady=this.H("_onProcessReady",this.z.event),this.C=this.B(new E.$fe),this.onProcessExit=this.H("_onProcessExit",this.C.event),this.D=this.B(new E.$fe),this.onProcessOrphanQuestion=this.H("_onProcessOrphanQuestion",this.D.event),this.F=this.B(new E.$fe),this.onDidRequestDetach=this.H("_onDidRequestDetach",this.F.event),this.G=this.B(new E.$fe),this.onDidChangeProperty=this.H("_onDidChangeProperty",this.G.event),this.B((0,A.$Sc)(()=>{for(const V of this.a.values())V.shutdown(!0);this.a.clear()})),this.f=this.B(new r.$fs(void 0,this.I)),this.f.onCreateRequest(this.F.fire,this.F)}async refreshIgnoreProcessNames(w){s.$ljc.length=0,s.$ljc.push(...w)}async requestDetachInstance(w,D){return this.f.createRequest({workspaceId:w,instanceId:D})}async acceptDetachInstanceReply(w,D){let Y;const te=this.a.get(D);te&&(Y=await this.S(D,te)),this.f.acceptReply(w,Y)}async freePortKillProcess(w){const Y=(await new Promise((te,V)=>{(0,y.exec)(j.$i?`netstat -ano | findstr "${w}"`:`lsof -nP -iTCP -sTCP:LISTEN | grep ${w}`,{},(ee,oe)=>{if(ee)return V("Problem occurred when listing active processes");te(oe)})})).split(/\r?\n/).filter(te=>!!te.trim());if(Y.length>=1){const te=/\s+(\d+)(?:\s+|$)/,V=Y[0].match(te)?.[1];if(V)try{process.kill(Number.parseInt(V))}catch{}else throw new Error(`Processes for port ${w} were not found`);return{port:w,processId:V}}throw new Error(`Could not kill process with port ${w}`)}async serializeTerminalState(w){const D=[];for(const[te,V]of this.a.entries())V.hasWrittenData&&w.indexOf(te)!==-1&&D.push(S.Promises.withAsyncBody(async ee=>{ee({id:te,shellLaunchConfig:V.shellLaunchConfig,processDetails:await this.S(te,V),processLaunchConfig:V.processLaunchOptions,unicodeVersion:V.unicodeVersion,replayEvent:await V.serializeNormalBuffer(),timestamp:Date.now()})}));const Y={version:1,state:await Promise.all(D)};return JSON.stringify(Y)}async reviveTerminalProcesses(w,D,Y){const te=[];for(const V of D)te.push(this.N(w,V));await Promise.all(te)}async N(w,D){const Y=(0,f.localize)(0,null),te=await this.createProcess({...D.shellLaunchConfig,cwd:D.processDetails.cwd,color:D.processDetails.color,icon:D.processDetails.icon,name:D.processDetails.titleSource===p.TitleEventSource.Api?D.processDetails.title:void 0,initialText:D.replayEvent.events[0].data+(0,i.$9Ub)(Y,{loudFormatting:!0})},D.processDetails.cwd,D.replayEvent.events[0].cols,D.replayEvent.events[0].rows,D.unicodeVersion,D.processLaunchConfig.env,D.processLaunchConfig.executableEnv,D.processLaunchConfig.options,!0,D.processDetails.workspaceId,D.processDetails.workspaceName,!0,D.replayEvent.events[0].data),V=this.R(w,D.id);this.g.set(V,{newId:te,state:D}),this.I.info(`Revived process, old id ${V} -> new id ${te}`)}async shutdownAll(){this.dispose()}async createProcess(w,D,Y,te,V,ee,oe,ue,X,q,Z,_,de){if(w.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const B=++this.n,le=new g.$pjc(w,D,Y,te,ee,oe,ue,this.I,this.J),x={env:ee,executableEnv:oe,options:ue},u=new K(B,le,q,Z,X,Y,te,x,V,this.L,this.I,_&&typeof w.initialText=="string"?w.initialText:void 0,de,w.icon,w.color,w.name,w.fixedDimensions);return le.onProcessExit(z=>{u.dispose(),this.a.delete(B),this.C.fire({id:B,event:z})}),u.onProcessData(z=>this.w.fire({id:B,event:z})),u.onProcessReplay(z=>this.y.fire({id:B,event:z})),u.onProcessReady(z=>this.z.fire({id:B,event:z})),u.onProcessOrphanQuestion(()=>this.D.fire({id:B})),u.onDidChangeProperty(z=>this.G.fire({id:B,property:z})),u.onPersistentProcessReady(()=>{for(const z of this.j.entries())u.installAutoReply(z[0],z[1])}),this.a.set(B,u),B}async attachToProcess(w){try{await this.U(w).attach(),this.I.info(`Persistent process reconnection "${w}"`)}catch(D){throw this.I.warn(`Persistent process reconnection "${w}" failed`,D.message),D}}async updateTitle(w,D,Y){this.U(w).setTitle(D,Y)}async updateIcon(w,D,Y,te){this.U(w).setIcon(D,Y,te)}async clearBuffer(w){this.U(w).clearBuffer()}async refreshProperty(w,D){return this.U(w).refreshProperty(D)}async updateProperty(w,D,Y){return this.U(w).updateProperty(D,Y)}async detachFromProcess(w,D){return this.U(w).detach(D)}async reduceConnectionGraceTime(){for(const w of this.a.values())w.reduceGraceTime()}async listProcesses(){const w=Array.from(this.a.entries()).filter(([te,V])=>V.shouldPersistTerminal);this.I.info(`Listing ${w.length} persistent terminals, ${this.a.size} total terminals`);const D=w.map(async([te,V])=>this.S(te,V));return(await Promise.all(D)).filter(te=>te.isOrphan)}async getPerformanceMarks(){return L.getMarks()}async start(w){const D=this.a.get(w);return D?D.start():{message:`Could not find pty with id "${w}"`}}async shutdown(w,D){return this.a.get(w)?.shutdown(D)}async input(w,D){return this.U(w).input(D)}async processBinary(w,D){return this.U(w).writeBinary(D)}async resize(w,D,Y){return this.U(w).resize(D,Y)}async getInitialCwd(w){return this.U(w).getInitialCwd()}async getCwd(w){return this.U(w).getCwd()}async acknowledgeDataEvent(w,D){return this.U(w).acknowledgeDataEvent(D)}async setUnicodeVersion(w,D){return this.U(w).setUnicodeVersion(D)}async getLatency(){return[]}async orphanQuestionReply(w){return this.U(w).orphanQuestionReply()}async installAutoReply(w,D){this.j.set(w,D);for(const Y of this.a.values())Y.installAutoReply(w,D)}async uninstallAllAutoReplies(){for(const w of this.j.keys())for(const D of this.a.values())D.uninstallAutoReply(w)}async uninstallAutoReply(w){for(const D of this.a.values())D.uninstallAutoReply(w)}async getDefaultSystemShell(w=j.OS){return(0,k.$sm)(w,process.env)}async getEnvironment(){return{...process.env}}async getWslPath(w,D){if(D==="win-to-unix"){if(!j.$i)return w;if((0,c.$vs)()<17063)return w.replace(/\\/g,"/");const Y=this.O();return Y?new Promise(te=>{(0,y.execFile)(Y,["-e","wslpath",w],{},(ee,oe,ue)=>{te(ee?w:(0,P.$CP)(oe.trim()))}).stdin.end()}):w}if(D==="unix-to-win"&&j.$i){if((0,c.$vs)()<17063)return w;const Y=this.O();return Y?new Promise(te=>{(0,y.execFile)(Y,["-e","wslpath","-w",w],{},(ee,oe,ue)=>{te(ee?w:oe.trim())}).stdin.end()}):w}return w}O(){const w=(0,c.$vs)()>=16299,D=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),Y=process.env.SystemRoot;if(Y)return(0,t.join)(Y,D?"Sysnative":"System32",w?"wsl.exe":"bash.exe")}async getRevivedPtyNewId(w,D){try{return this.g.get(this.R(w,D))?.newId}catch(Y){this.I.warn(`Couldn't find terminal ID ${w}-${D}`,Y.message)}}async setTerminalLayoutInfo(w){this.b.set(w.workspaceId,w)}async getTerminalLayoutInfo(w){L.mark("code/willGetTerminalLayoutInfo");const D=this.b.get(w.workspaceId);if(D){const Y=new Set,V=(await Promise.all(D.tabs.map(async ee=>this.P(w.workspaceId,ee,Y)))).filter(ee=>ee.terminals.length>0);return L.mark("code/didGetTerminalLayoutInfo"),{tabs:V}}L.mark("code/didGetTerminalLayoutInfo")}async P(w,D,Y){const V=(await Promise.all(D.terminals.map(ee=>this.Q(w,ee,Y)))).filter(ee=>ee.terminal!==null);return{isActive:D.isActive,activePersistentProcessId:D.activePersistentProcessId,terminals:V}}async Q(w,D,Y){try{const te=this.R(w,D.terminal),V=this.g.get(te)?.newId;this.I.info(`Expanding terminal instance, old id ${te} -> new id ${V}`),this.g.delete(te);const ee=V??D.terminal;if(Y.has(ee))throw new Error(`Terminal ${ee} has already been expanded`);Y.add(ee);const oe=this.U(ee);return{terminal:{...oe&&await this.S(D.terminal,oe,V!==void 0),id:ee},relativeSize:D.relativeSize}}catch(te){return this.I.warn("Couldn't get layout info, a terminal was probably disconnected",te.message),this.I.debug("Reattach to wrong terminal debug info - layout info by id",D),this.I.debug("Reattach to wrong terminal debug info - _revivePtyIdMap",Array.from(this.g.values())),this.I.debug("Reattach to wrong terminal debug info - _ptys ids",Array.from(this.a.keys())),{terminal:null,relativeSize:D.relativeSize}}}R(w,D){return`${w}-${D}`}async S(w,D,Y=!1){L.mark(`code/willBuildProcessDetails/${w}`);const[te,V]=await Promise.all([D.getCwd(),Y?!0:D.isOrphaned()]),ee={id:w,title:D.title,titleSource:D.titleSource,pid:D.pid,workspaceId:D.workspaceId,workspaceName:D.workspaceName,cwd:te,isOrphan:V,icon:D.icon,color:D.color,fixedDimensions:D.fixedDimensions,environmentVariableCollections:D.processLaunchOptions.options.environmentVariableCollections,reconnectionProperties:D.shellLaunchConfig.reconnectionProperties,waitOnExit:D.shellLaunchConfig.waitOnExit,hideFromUser:D.shellLaunchConfig.hideFromUser,isFeatureTerminal:D.shellLaunchConfig.isFeatureTerminal,type:D.shellLaunchConfig.type,hasChildProcesses:D.hasChildProcesses,shellIntegrationNonce:D.processLaunchOptions.options.shellIntegration.nonce};return L.mark(`code/didBuildProcessDetails/${w}`),ee}U(w){const D=this.a.get(w);if(!D)throw new $.$bb("Could not find pty on pty host");return D}}e.$rjc=b,be([o.$3h],b.prototype,"traceRpcArgs",null),be([m],b.prototype,"refreshIgnoreProcessNames",null),be([m],b.prototype,"requestDetachInstance",null),be([m],b.prototype,"acceptDetachInstanceReply",null),be([m],b.prototype,"freePortKillProcess",null),be([m],b.prototype,"serializeTerminalState",null),be([m],b.prototype,"reviveTerminalProcesses",null),be([m],b.prototype,"shutdownAll",null),be([m],b.prototype,"createProcess",null),be([m],b.prototype,"attachToProcess",null),be([m],b.prototype,"updateTitle",null),be([m],b.prototype,"updateIcon",null),be([m],b.prototype,"clearBuffer",null),be([m],b.prototype,"refreshProperty",null),be([m],b.prototype,"updateProperty",null),be([m],b.prototype,"detachFromProcess",null),be([m],b.prototype,"reduceConnectionGraceTime",null),be([m],b.prototype,"listProcesses",null),be([m],b.prototype,"getPerformanceMarks",null),be([m],b.prototype,"start",null),be([m],b.prototype,"shutdown",null),be([m],b.prototype,"input",null),be([m],b.prototype,"processBinary",null),be([m],b.prototype,"resize",null),be([m],b.prototype,"getInitialCwd",null),be([m],b.prototype,"getCwd",null),be([m],b.prototype,"acknowledgeDataEvent",null),be([m],b.prototype,"setUnicodeVersion",null),be([m],b.prototype,"getLatency",null),be([m],b.prototype,"orphanQuestionReply",null),be([m],b.prototype,"installAutoReply",null),be([m],b.prototype,"uninstallAllAutoReplies",null),be([m],b.prototype,"uninstallAutoReply",null),be([m],b.prototype,"getDefaultSystemShell",null),be([m],b.prototype,"getEnvironment",null),be([m],b.prototype,"getWslPath",null),be([m],b.prototype,"getRevivedPtyNewId",null),be([m],b.prototype,"setTerminalLayoutInfo",null),be([m],b.prototype,"getTerminalLayoutInfo",null);var U;(function(I){I.None="None",I.ReplayOnly="ReplayOnly",I.Session="Session"})(U||(U={}));class K extends A.$Uc{get pid(){return this.L}get shellLaunchConfig(){return this.W.shellLaunchConfig}get hasWrittenData(){return this.j.value!=="None"}get title(){return this.N||this.W.currentTitle}get titleSource(){return this.O}get icon(){return this.Y}get color(){return this.Z}get fixedDimensions(){return this.R}get hasChildProcesses(){return this.W.hasChildProcesses}setTitle(w,D){D===p.TitleEventSource.Api&&(this.j.setValue("Session","setTitle"),this.P.freeRawReviveBuffer()),this.N=w,this.O=D}setIcon(w,D,Y){(!this.Y||"id"in D&&"id"in this.Y&&D.id!==this.Y.id||!this.color||Y!==this.Z)&&(this.P.freeRawReviveBuffer(),w&&this.j.setValue("Session","setIcon")),this.Y=D,this.Z=Y}S(w){this.R=w}constructor(w,D,Y,te,V,ee,oe,ue,X,q,Z,_,de,B,le,x,u){super(),this.U=w,this.W=D,this.workspaceId=Y,this.workspaceName=te,this.shouldPersistTerminal=V,this.processLaunchOptions=ue,this.unicodeVersion=X,this.X=Z,this.Y=B,this.Z=le,this.b=new Map,this.f=new Map,this.g=!1,this.w=new S.$Fh,this.C=this.B(new E.$fe),this.onProcessReplay=this.C.event,this.D=this.B(new E.$fe),this.onProcessReady=this.D.event,this.F=this.B(new E.$fe),this.onPersistentProcessReady=this.F.event,this.G=this.B(new E.$fe),this.onProcessData=this.G.event,this.H=this.B(new E.$fe),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new E.$fe),this.onDidChangeProperty=this.I.event,this.J=!1,this.L=-1,this.M="",this.O=p.TitleEventSource.Process,this.j=new F(`Persistent process "${this.U}" interaction state`,"None",this.X),this.Q=_!==void 0,this.P=new O(ee,oe,q.scrollback,X,_,ue.options.shellIntegration.nonce,V?de:void 0,this.X),x&&this.setTitle(x,p.TitleEventSource.Api),this.R=u,this.n=null,this.u=0,this.y=this.B(new S.$Lh(()=>{this.X.info(`Persistent process "${this.U}": The reconnection grace time of ${d(q.graceTime)} has expired, shutting down pid "${this.L}"`),this.shutdown(!0)},q.graceTime)),this.z=this.B(new S.$Lh(()=>{this.X.info(`Persistent process "${this.U}": The short reconnection grace time of ${d(q.shortGraceTime)} has expired, shutting down pid ${this.L}`),this.shutdown(!0)},q.shortGraceTime)),this.B(this.W.onProcessExit(()=>this.a.stopBuffering(this.U))),this.B(this.W.onProcessReady(z=>{this.L=z.pid,this.M=z.cwd,this.D.fire(z)})),this.B(this.W.onDidChangeProperty(z=>{this.I.fire(z)})),this.a=new l.$0vb((z,ne)=>this.G.fire(ne)),this.B(this.a.startBuffering(this.U,this.W.onProcessData)),this.B(this.onProcessData(z=>this.P.handleData(z))),this.B((0,A.$Sc)(()=>{for(const z of this.b.values())z.dispose();this.b.clear()}))}async attach(){!this.y.isScheduled()&&!this.z.isScheduled()&&this.X.warn(`Persistent process "${this.U}": Process had no disconnect runners but was an orphan`),this.y.cancel(),this.z.cancel()}async detach(w){this.shouldPersistTerminal&&(this.j.value!=="None"||w)?this.y.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this.P.generateReplayEvent(!0,this.j.value!=="Session")}async refreshProperty(w){return this.W.refreshProperty(w)}async updateProperty(w,D){if(w==="fixedDimensions")return this.S(D)}async start(){if(!this.g){const w=await this.W.start();return w&&"message"in w||(this.g=!0,this.Q?this.triggerReplay():this.F.fire()),w}this.D.fire({pid:this.L,cwd:this.M,windowsPty:this.W.getWindowsPty()}),this.I.fire({type:"title",value:this.W.currentTitle}),this.I.fire({type:"shellType",value:this.W.shellType}),this.triggerReplay()}shutdown(w){return this.W.shutdown(w)}input(w){if(this.j.setValue("Session","input"),this.P.freeRawReviveBuffer(),!this.J){for(const D of this.b.values())D.handleInput();return this.W.input(w)}}writeBinary(w){return this.W.processBinary(w)}resize(w,D){if(!this.J){this.P.handleResize(w,D),this.a.flushBuffer(this.U);for(const Y of this.b.values())Y.handleResize();return this.W.resize(w,D)}}async clearBuffer(){this.P.clearBuffer(),this.W.clearBuffer()}setUnicodeVersion(w){this.unicodeVersion=w,this.P.setUnicodeVersion?.(w)}acknowledgeDataEvent(w){if(!this.J)return this.W.acknowledgeDataEvent(w)}getInitialCwd(){return this.W.getInitialCwd()}getCwd(){return this.W.getCwd()}async triggerReplay(){this.j.value==="None"&&this.j.setValue("ReplayOnly","triggerReplay");const w=await this.P.generateReplayEvent();let D=0;for(const Y of w.events)D+=Y.data.length;this.X.info(`Persistent process "${this.U}": Replaying ${D} chars and ${w.events.length} size events`),this.C.fire(w),this.W.clearUnacknowledgedChars(),this.F.fire()}installAutoReply(w,D){this.b.get(w)?.dispose(),this.b.set(w,new n.$kjc(this.W,w,D,this.X))}uninstallAutoReply(w){this.b.get(w)?.dispose(),this.b.delete(w)}sendCommandResult(w,D,Y){this.f.get(w)&&this.f.delete(w)}orphanQuestionReply(){if(this.u=Date.now(),this.n){const w=this.n;this.n=null,w.open()}}reduceGraceTime(){this.z.isScheduled()||this.y.isScheduled()&&this.z.schedule()}async isOrphaned(){return await this.w.queue(async()=>this.$())}async $(){return this.y.isScheduled()||this.z.isScheduled()?!0:(this.n||(this.n=new S.$yh(4e3),this.u=0,this.H.fire()),await this.n.wait(),Date.now()-this.u>500)}}class F{get value(){return this.b}setValue(w,D){this.b!==w&&(this.b=w,this.f(D))}constructor(w,D,Y){this.a=w,this.b=D,this.d=Y,this.f("initialized")}f(w){this.d.debug(`MutationLogger "${this.a}" set to "${this.b}", reason: ${w}`)}}class O{constructor(w,D,Y,te,V,ee,oe,ue){this.f=oe,this.a=new a.Terminal({cols:w,rows:D,scrollback:Y,allowProposedApi:!0}),V&&this.a.writeln(V),this.setUnicodeVersion(te),this.b=new v.$1ub(ee,!0,void 0,ue),this.a.loadAddon(this.b)}freeRawReviveBuffer(){this.f=void 0}handleData(w){this.a.write(w)}handleResize(w,D){this.a.resize(w,D)}clearBuffer(){this.a.clear()}async generateReplayEvent(w,D){const Y=new(await this._getSerializeConstructor());this.a.loadAddon(Y);const te={scrollback:this.a.options.scrollback};w&&(te.excludeAltBuffer=!0,te.excludeModes=!0);let V;return D&&this.f?V=this.f:V=Y.serialize(te),{events:[{cols:this.a.cols,rows:this.a.rows,data:V}],commands:this.b.serialize()}}async setUnicodeVersion(w){this.a.unicode.activeVersion!==w&&(w==="11"?(this.d=new(await this._getUnicode11Constructor()),this.a.loadAddon(this.d)):(this.d?.dispose(),this.d=void 0),this.a.unicode.activeVersion=w)}async _getUnicode11Constructor(){return C||(C=(await new Promise((w,D)=>{ae(["@xterm/addon-unicode11"],w,D)})).Unicode11Addon),C}async _getSerializeConstructor(){return M||(M=(await new Promise((w,D)=>{ae(["@xterm/addon-serialize"],w,D)})).SerializeAddon),M}}function d(I){let w=0,D=0,Y=0;I>=1e3&&(Y=Math.floor(I/1e3),I-=Y*1e3),Y>=60&&(D=Math.floor(Y/60),Y-=D*60),D>=60&&(w=Math.floor(D/60),D-=w*60);const te=w?`${w}h`:"",V=D?`${D}m`:"",ee=Y?`${Y}s`:"",oe=I?`${I}ms`:"";return`${te}${V}${ee}${oe}`}}),define(fe[112],ge([0,1,60,27,64,65,11,75,78,8,80,81,83,84,28,102,105,31,12,2]),function(ae,e,y,S,E,A,j,k,h,r,p,l,P,a,c,g,f,s,n,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v();async function v(){const i=parseInt(process.env.VSCODE_STARTUP_DELAY??"0"),t=parseInt(process.env.VSCODE_LATENCY??"0"),o={graceTime:parseInt(process.env.VSCODE_RECONNECT_GRACE_TIME||"0"),shortGraceTime:parseInt(process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME||"0"),scrollback:parseInt(process.env.VSCODE_RECONNECT_SCROLLBACK||"100")};delete process.env.VSCODE_RECONNECT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SCROLLBACK,delete process.env.VSCODE_LATENCY,delete process.env.VSCODE_STARTUP_DELAY,i&&await(0,n.$zh)(i);const L=(0,s.$tW)(process);let m;L?m=new A.$uW:m=new E.$3q(c.TerminalIpcChannels.PtyHost);const M={_serviceBrand:void 0,...a.default},C=new h.$$m((0,k.$vm)(process.argv,k.$um),M),b=new P.$3P((0,r.$gk)(C),C.logsHome);m.registerChannel(c.TerminalIpcChannels.Logger,new p.$ds(b,()=>y.$Bn));const U=b.createLogger("ptyhost",{name:(0,j.localize)(0,null)}),K=new l.$aQ(U);i&&K.warn(`Pty Host startup is delayed ${i}ms`),t&&K.warn(`Pty host is simulating ${t}ms latency`);const F=new $.$Tc,O=new g.$njc;m.registerChannel(c.TerminalIpcChannels.Heartbeat,S.ProxyChannel.fromService(O,F));const d=new f.$rjc(K,M,o,t),I=S.ProxyChannel.fromService(d,F);m.registerChannel(c.TerminalIpcChannels.PtyHost,I),L&&m.registerChannel(c.TerminalIpcChannels.PtyHostWindow,I),process.once("exit",()=>{K.trace("Pty host exiting"),K.dispose(),O.dispose(),d.dispose()})}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6313b2d7eda4c378748d73274af802a26b8e38ba/core/vs/platform/terminal/node/ptyHostMain.js.map
