/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/registry/common/platform","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/base/common/severity","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/common/marshalling","vs/platform/configuration/common/configuration","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ie=function(le){for(var e=[],C=0,O=le.length;C<O;C++)e[C]=Se[le[C]];return e};define(Se[69],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=O,e.$4h=M,e.$5h=N;function C(R){return(w,m,E)=>{let T=null,S=null;if(typeof E.value=="function"?(T="value",S=E.value):typeof E.get=="function"&&(T="get",S=E.get),!S)throw new Error("not supported");E[T]=R(S,m)}}function O(R,w,m){let E=null,T=null;if(typeof m.value=="function"?(E="value",T=m.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(E="get",T=m.get),!T)throw new Error("not supported");const S=`$memoize$${w}`;m[E]=function(...l){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,l)}),this[S]}}function M(R,w,m){return C((E,T)=>{const S=`$debounce$${T}`,l=`$debounce$result$${T}`;return function(...b){this[l]||(this[l]=m?m():void 0),clearTimeout(this[S]),w&&(this[l]=w(this[l],...b),b=[this[l]]),this[S]=setTimeout(()=>{E.apply(this,b),this[l]=m?m():void 0},R)}})}function N(R,w,m){return C((E,T)=>{const S=`$throttle$timer$${T}`,l=`$throttle$result$${T}`,b=`$throttle$lastRun$${T}`,g=`$throttle$pending$${T}`;return function(...r){if(this[l]||(this[l]=m?m():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),w&&(this[l]=w(this[l],...r)),this[g])return;const s=this[b]+R;s<=Date.now()?(this[b]=Date.now(),E.apply(this,[this[l]]),this[l]=m?m():void 0):(this[g]=!0,this[S]=setTimeout(()=>{this[g]=!1,this[b]=Date.now(),E.apply(this,[this[l]]),this[l]=m?m():void 0},s-Date.now()))}})}}),define(Se[125],Ie([1,0,18]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=M,e.$8c=N,e.$9c=R,e.$0c=w,e.$$c=m,e.$_c=E;const O=(b,g)=>b===g;e.$6c=O;function M(b=e.$6c){return(g,r)=>C.$ub(g,r,b)}function N(){return(b,g)=>JSON.stringify(b)===JSON.stringify(g)}function R(){return(b,g)=>b.equals(g)}function w(b,g,r){return!b||!g?b===g:r(b,g)}function m(b,g){if(b===g)return!0;if(Array.isArray(b)&&Array.isArray(g)){if(b.length!==g.length)return!1;for(let r=0;r<b.length;r++)if(!m(b[r],g[r]))return!1;return!0}if(b&&typeof b=="object"&&g&&typeof g=="object"&&Object.getPrototypeOf(b)===Object.prototype&&Object.getPrototypeOf(g)===Object.prototype){const r=b,s=g,o=Object.keys(r),i=Object.keys(s),n=new Set(i);if(o.length!==i.length)return!1;for(const c of o)if(!n.has(c)||!m(r[c],s[c]))return!1;return!0}return!1}function E(b){return JSON.stringify(l(b))}let T=0;const S=new WeakMap;function l(b){if(Array.isArray(b))return b.map(l);if(b&&typeof b=="object")if(Object.getPrototypeOf(b)===Object.prototype){const g=b,r=Object.create(null);for(const s of Object.keys(g).sort())r[s]=l(g[s]);return r}else{let g=S.get(b);return g===void 0&&(g=T++,S.set(b,g)),g+"----2b76a038c20c4bcc"}return b}}),define(Se[91],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SO=e.$RO=void 0;class C{constructor(M){this.a=M,this.b=0}nextId(){return this.a+ ++this.b}}e.$RO=C,e.$SO=new C("id#")}),define(Se[126],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Jn=R,e.$Kn=S,e.$Ln=l,e.$Mn=b,e.$Nn=g,e.$On=r,e.$Pn=s,e.$Qn=o,e.$Rn=i,e.$Sn=n,e.$Tn=c,e.$Un=u;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var M;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(M||(e.ParseErrorCode=M={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function R(t,f=!1){let a=0;const d=t.length;let $="",p=0,v=16,y=0;function h(q){let A=0,z=0;for(;A<q;){const G=t.charCodeAt(a);if(G>=48&&G<=57)z=z*16+G-48;else if(G>=65&&G<=70)z=z*16+G-65+10;else if(G>=97&&G<=102)z=z*16+G-97+10;else break;a++,A++}return A<q&&(z=-1),z}function D(q){a=q,$="",p=0,v=16,y=0}function k(){const q=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&E(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&E(t.charCodeAt(a)))for(a++;a<t.length&&E(t.charCodeAt(a));)a++;else return y=3,t.substring(q,a);let A=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&E(t.charCodeAt(a))){for(a++;a<t.length&&E(t.charCodeAt(a));)a++;A=a}else y=3;return t.substring(q,A)}function I(){let q="",A=a;for(;;){if(a>=d){q+=t.substring(A,a),y=2;break}const z=t.charCodeAt(a);if(z===34){q+=t.substring(A,a),a++;break}if(z===92){if(q+=t.substring(A,a),a++,a>=d){y=2;break}switch(t.charCodeAt(a++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const ie=h(4);ie>=0?q+=String.fromCharCode(ie):y=4;break}default:y=5}A=a;continue}if(z>=0&&z<=31)if(m(z)){q+=t.substring(A,a),y=2;break}else y=6;a++}return q}function P(){if($="",y=0,p=a,a>=d)return p=d,v=17;let q=t.charCodeAt(a);if(w(q)){do a++,$+=String.fromCharCode(q),q=t.charCodeAt(a);while(w(q));return v=15}if(m(q))return a++,$+=String.fromCharCode(q),q===13&&t.charCodeAt(a)===10&&(a++,$+=`
`),v=14;switch(q){case 123:return a++,v=1;case 125:return a++,v=2;case 91:return a++,v=3;case 93:return a++,v=4;case 58:return a++,v=6;case 44:return a++,v=5;case 34:return a++,$=I(),v=10;case 47:{const A=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<d&&!m(t.charCodeAt(a));)a++;return $=t.substring(A,a),v=12}if(t.charCodeAt(a+1)===42){a+=2;const z=d-1;let G=!1;for(;a<z;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,G=!0;break}a++}return G||(a++,y=1),$=t.substring(A,a),v=13}return $+=String.fromCharCode(q),a++,v=16}case 45:if($+=String.fromCharCode(q),a++,a===d||!E(t.charCodeAt(a)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return $+=k(),v=11;default:for(;a<d&&V(q);)a++,q=t.charCodeAt(a);if(p!==a){switch($=t.substring(p,a),$){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return $+=String.fromCharCode(q),a++,v=16}}function V(q){if(w(q)||m(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let q;do q=P();while(q>=12&&q<=15);return q}return{setPosition:D,getPosition:()=>a,scan:f?W:P,getToken:()=>v,getTokenValue:()=>$,getTokenOffset:()=>p,getTokenLength:()=>a-p,getTokenError:()=>y}}function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function S(t,f){const a=[],d=new Object;let $;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function y(h,D,k,I){p.value=h,p.offset=D,p.length=k,p.type=I,p.colonOffset=void 0,$=p}try{n(t,{onObjectBegin:(h,D)=>{if(f<=h)throw d;$=void 0,v=f>h,a.push("")},onObjectProperty:(h,D,k)=>{if(f<D||(y(h,D,k,"property"),a[a.length-1]=h,f<=D+k))throw d},onObjectEnd:(h,D)=>{if(f<=h)throw d;$=void 0,a.pop()},onArrayBegin:(h,D)=>{if(f<=h)throw d;$=void 0,a.push(0)},onArrayEnd:(h,D)=>{if(f<=h)throw d;$=void 0,a.pop()},onLiteralValue:(h,D,k)=>{if(f<D||(y(h,D,k,u(h)),f<=D+k))throw d},onSeparator:(h,D,k)=>{if(f<=D)throw d;if(h===":"&&$&&$.type==="property")$.colonOffset=D,v=!1,$=void 0;else if(h===","){const I=a[a.length-1];typeof I=="number"?a[a.length-1]=I+1:(v=!0,a[a.length-1]=""),$=void 0}}})}catch(h){if(h!==d)throw h}return{path:a,previousNode:$,isAtPropertyKey:v,matches:h=>{let D=0;for(let k=0;D<h.length&&k<a.length;k++)if(h[D]===a[k]||h[D]==="*")D++;else if(h[D]!=="**")return!1;return D===h.length}}}function l(t,f=[],a=N.DEFAULT){let d=null,$=[];const p=[];function v(h){Array.isArray($)?$.push(h):d!==null&&($[d]=h)}return n(t,{onObjectBegin:()=>{const h={};v(h),p.push($),$=h,d=null},onObjectProperty:h=>{d=h},onObjectEnd:()=>{$=p.pop()},onArrayBegin:()=>{const h=[];v(h),p.push($),$=h,d=null},onArrayEnd:()=>{$=p.pop()},onLiteralValue:v,onError:(h,D,k)=>{f.push({error:h,offset:D,length:k})}},a),$[0]}function b(t,f=[],a=N.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function $(h){d.type==="property"&&(d.length=h-d.offset,d=d.parent)}function p(h){return d.children.push(h),h}n(t,{onObjectBegin:h=>{d=p({type:"object",offset:h,length:-1,parent:d,children:[]})},onObjectProperty:(h,D,k)=>{d=p({type:"property",offset:D,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:h,offset:D,length:k,parent:d})},onObjectEnd:(h,D)=>{d.length=h+D-d.offset,d=d.parent,$(h+D)},onArrayBegin:(h,D)=>{d=p({type:"array",offset:h,length:-1,parent:d,children:[]})},onArrayEnd:(h,D)=>{d.length=h+D-d.offset,d=d.parent,$(h+D)},onLiteralValue:(h,D,k)=>{p({type:u(h),offset:D,length:k,parent:d,value:h}),$(D+k)},onSeparator:(h,D,k)=>{d.type==="property"&&(h===":"?d.colonOffset=D:h===","&&$(D))},onError:(h,D,k)=>{f.push({error:h,offset:D,length:k})}},a);const y=d.children[0];return y&&delete y.parent,y}function g(t,f){if(!t)return;let a=t;for(const d of f)if(typeof d=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let $=!1;for(const p of a.children)if(Array.isArray(p.children)&&p.children[0].value===d){a=p.children[1],$=!0;break}if(!$)return}else{const $=d;if(a.type!=="array"||$<0||!Array.isArray(a.children)||$>=a.children.length)return;a=a.children[$]}return a}function r(t){if(!t.parent||!t.parent.children)return[];const f=r(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;f.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&f.push(a)}return f}function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const f=Object.create(null);for(const a of t.children){const d=a.children[1];d&&(f[a.children[0].value]=s(d))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,f,a=!1){return f>=t.offset&&f<t.offset+t.length||a&&f===t.offset+t.length}function i(t,f,a=!1){if(o(t,f,a)){const d=t.children;if(Array.isArray(d))for(let $=0;$<d.length&&d[$].offset<=f;$++){const p=i(d[$],f,a);if(p)return p}return t}}function n(t,f,a=N.DEFAULT){const d=R(t,!1);function $(Ce){return Ce?()=>Ce(d.getTokenOffset(),d.getTokenLength()):()=>!0}function p(Ce){return Ce?se=>Ce(se,d.getTokenOffset(),d.getTokenLength()):()=>!0}const v=$(f.onObjectBegin),y=p(f.onObjectProperty),h=$(f.onObjectEnd),D=$(f.onArrayBegin),k=$(f.onArrayEnd),I=p(f.onLiteralValue),P=p(f.onSeparator),V=$(f.onComment),W=p(f.onError),q=a&&a.disallowComments,A=a&&a.allowTrailingComma;function z(){for(;;){const Ce=d.scan();switch(d.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:q||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(Ce){case 12:case 13:q?G(10):V();break;case 16:G(1);break;case 15:case 14:break;default:return Ce}}}function G(Ce,se=[],Oe=[]){if(W(Ce),se.length+Oe.length>0){let ne=d.getToken();for(;ne!==17;){if(se.indexOf(ne)!==-1){z();break}else if(Oe.indexOf(ne)!==-1)break;ne=z()}}}function ie(Ce){const se=d.getTokenValue();return Ce?I(se):y(se),z(),!0}function de(){switch(d.getToken()){case 11:{let Ce=0;try{Ce=JSON.parse(d.getTokenValue()),typeof Ce!="number"&&(G(2),Ce=0)}catch{G(2)}I(Ce);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return z(),!0}function ye(){return d.getToken()!==10?(G(3,[],[2,5]),!1):(ie(!1),d.getToken()===6?(P(":"),z(),ue()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function Ee(){v(),z();let Ce=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(Ce||G(4,[],[]),P(","),z(),d.getToken()===2&&A)break}else Ce&&G(6,[],[]);ye()||G(4,[],[2,5]),Ce=!0}return h(),d.getToken()!==2?G(7,[2],[]):z(),!0}function ge(){D(),z();let Ce=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(Ce||G(4,[],[]),P(","),z(),d.getToken()===4&&A)break}else Ce&&G(6,[],[]);ue()||G(4,[],[4,5]),Ce=!0}return k(),d.getToken()!==4?G(8,[4],[]):z(),!0}function ue(){switch(d.getToken()){case 3:return ge();case 1:return Ee();case 10:return ie(!0);default:return de()}}return z(),d.getToken()===17?a.allowEmptyContent?!0:(G(4,[],[]),!1):ue()?(d.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}function c(t,f){const a=R(t),d=[];let $,p=0,v;do switch(v=a.getPosition(),$=a.scan(),$){case 12:case 13:case 17:p!==v&&d.push(t.substring(p,v)),f!==void 0&&d.push(a.getTokenValue().replace(/[^\r\n]/g,f)),p=a.getPosition();break}while($!==17);return d.join("")}function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(le,e){typeof define=="function"&&define.amd?define(Se[127],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(ke,we){for(var me=0;me<we.length;me++){var Q=we[me];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(ke,Q.key,Q)}}function C(ke,we,me){return we&&e(ke.prototype,we),me&&e(ke,me),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function O(ke,we){if(ke){if(typeof ke=="string")return M(ke,we);var me=Object.prototype.toString.call(ke).slice(8,-1);if(me==="Object"&&ke.constructor&&(me=ke.constructor.name),me==="Map"||me==="Set")return Array.from(ke);if(me==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(me))return M(ke,we)}}function M(ke,we){(we==null||we>ke.length)&&(we=ke.length);for(var me=0,Q=new Array(we);me<we;me++)Q[me]=ke[me];return Q}function N(ke,we){var me=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(me)return(me=me.call(ke)).next.bind(me);if(Array.isArray(ke)||(me=O(ke))||we&&ke&&typeof ke.length=="number"){me&&(ke=me);var Q=0;return function(){return Q>=ke.length?{done:!0}:{done:!1,value:ke[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=R();function w(ke){le.defaults=ke}var m=/[&<>"']/,E=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(we){return l[we]};function g(ke,we){if(we){if(m.test(ke))return ke.replace(E,b)}else if(T.test(ke))return ke.replace(S,b);return ke}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(ke){return ke.replace(r,function(we,me){return me=me.toLowerCase(),me==="colon"?":":me.charAt(0)==="#"?me.charAt(1)==="x"?String.fromCharCode(parseInt(me.substring(2),16)):String.fromCharCode(+me.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(ke,we){ke=typeof ke=="string"?ke:ke.source,we=we||"";var me={replace:function(Y,he){return he=he.source||he,he=he.replace(o,"$1"),ke=ke.replace(Y,he),me},getRegex:function(){return new RegExp(ke,we)}};return me}var n=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(ke,we,me){if(ke){var Q;try{Q=decodeURIComponent(s(me)).replace(n,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}we&&!c.test(me)&&(me=$(we,me));try{me=encodeURI(me).replace(/%25/g,"%")}catch{return null}return me}var t={},f=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function $(ke,we){t[" "+ke]||(f.test(ke)?t[" "+ke]=ke+"/":t[" "+ke]=h(ke,"/",!0)),ke=t[" "+ke];var me=ke.indexOf(":")===-1;return we.substring(0,2)==="//"?me?we:ke.replace(a,"$1")+we:we.charAt(0)==="/"?me?we:ke.replace(d,"$1")+we:ke+we}var p={exec:function(){}};function v(ke){for(var we=1,me,Q;we<arguments.length;we++){me=arguments[we];for(Q in me)Object.prototype.hasOwnProperty.call(me,Q)&&(ke[Q]=me[Q])}return ke}function y(ke,we){var me=ke.replace(/\|/g,function(he,ce,Ne){for(var fe=!1,Pe=ce;--Pe>=0&&Ne[Pe]==="\\";)fe=!fe;return fe?"|":" |"}),Q=me.split(/ \|/),Y=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>we)Q.splice(we);else for(;Q.length<we;)Q.push("");for(;Y<Q.length;Y++)Q[Y]=Q[Y].trim().replace(/\\\|/g,"|");return Q}function h(ke,we,me){var Q=ke.length;if(Q===0)return"";for(var Y=0;Y<Q;){var he=ke.charAt(Q-Y-1);if(he===we&&!me)Y++;else if(he!==we&&me)Y++;else break}return ke.slice(0,Q-Y)}function D(ke,we){if(ke.indexOf(we[1])===-1)return-1;for(var me=ke.length,Q=0,Y=0;Y<me;Y++)if(ke[Y]==="\\")Y++;else if(ke[Y]===we[0])Q++;else if(ke[Y]===we[1]&&(Q--,Q<0))return Y;return-1}function k(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(ke,we){if(we<1)return"";for(var me="";we>1;)we&1&&(me+=ke),we>>=1,ke+=ke;return me+ke}function P(ke,we,me,Q){var Y=we.href,he=we.title?g(we.title):null,ce=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){Q.state.inLink=!0;var Ne={type:"link",raw:me,href:Y,title:he,text:ce,tokens:Q.inlineTokens(ce)};return Q.state.inLink=!1,Ne}return{type:"image",raw:me,href:Y,title:he,text:g(ce)}}function V(ke,we){var me=ke.match(/^(\s+)(?:```)/);if(me===null)return we;var Q=me[1];return we.split(`
`).map(function(Y){var he=Y.match(/^\s+/);if(he===null)return Y;var ce=he[0];return ce.length>=Q.length?Y.slice(Q.length):Y}).join(`
`)}var W=function(){function ke(me){this.options=me||le.defaults}var we=ke.prototype;return we.space=function(Q){var Y=this.rules.block.newline.exec(Q);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},we.code=function(Q){var Y=this.rules.block.code.exec(Q);if(Y){var he=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?he:h(he,`
`)}}},we.fences=function(Q){var Y=this.rules.block.fences.exec(Q);if(Y){var he=Y[0],ce=V(he,Y[3]||"");return{type:"code",raw:he,lang:Y[2]?Y[2].trim():Y[2],text:ce}}},we.heading=function(Q){var Y=this.rules.block.heading.exec(Q);if(Y){var he=Y[2].trim();if(/#$/.test(he)){var ce=h(he,"#");(this.options.pedantic||!ce||/ $/.test(ce))&&(he=ce.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:he,tokens:this.lexer.inline(he)}}},we.hr=function(Q){var Y=this.rules.block.hr.exec(Q);if(Y)return{type:"hr",raw:Y[0]}},we.blockquote=function(Q){var Y=this.rules.block.blockquote.exec(Q);if(Y){var he=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},we.list=function(Q){var Y=this.rules.block.list.exec(Q);if(Y){var he,ce,Ne,fe,Pe,Ae,Ue,B,L,K,H,ee,re=Y[1].trim(),Te=re.length>1,Be={type:"list",raw:"",ordered:Te,start:Te?+re.slice(0,-1):"",loose:!1,items:[]};re=Te?"\\d{1,9}\\"+re.slice(-1):"\\"+re,this.options.pedantic&&(re=Te?re:"[*+-]");for(var He=new RegExp("^( {0,3}"+re+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(ee=!1,!(!(Y=He.exec(Q))||this.rules.block.hr.test(Q)));){if(he=Y[0],Q=Q.substring(he.length),B=Y[2].split(`
`,1)[0],L=Q.split(`
`,1)[0],this.options.pedantic?(fe=2,H=B.trimLeft()):(fe=Y[2].search(/[^ ]/),fe=fe>4?1:fe,H=B.slice(fe),fe+=Y[1].length),Ae=!1,!B&&/^ *$/.test(L)&&(he+=L+`
`,Q=Q.substring(L.length+1),ee=!0),!ee)for(var _e=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,fe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}#");Q&&(K=Q.split(`
`,1)[0],B=K,this.options.pedantic&&(B=B.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(B)||tt.test(B)||_e.test(B)||xe.test(Q)));){if(B.search(/[^ ]/)>=fe||!B.trim())H+=`
`+B.slice(fe);else if(!Ae)H+=`
`+B;else break;!Ae&&!B.trim()&&(Ae=!0),he+=K+`
`,Q=Q.substring(K.length+1)}Be.loose||(Ue?Be.loose=!0:/\n *\n *$/.test(he)&&(Ue=!0)),this.options.gfm&&(ce=/^\[[ xX]\] /.exec(H),ce&&(Ne=ce[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:he,task:!!ce,checked:Ne,loose:!1,text:H}),Be.raw+=he}Be.items[Be.items.length-1].raw=he.trimRight(),Be.items[Be.items.length-1].text=H.trimRight(),Be.raw=Be.raw.trimRight();var it=Be.items.length;for(Pe=0;Pe<it;Pe++){this.lexer.state.top=!1,Be.items[Pe].tokens=this.lexer.blockTokens(Be.items[Pe].text,[]);var ot=Be.items[Pe].tokens.filter(function(je){return je.type==="space"}),gt=ot.every(function(je){for(var rt=je.raw.split(""),Z=0,X=N(rt),$e;!($e=X()).done;){var Ke=$e.value;if(Ke===`
`&&(Z+=1),Z>1)return!0}return!1});!Be.loose&&ot.length&&gt&&(Be.loose=!0,Be.items[Pe].loose=!0)}return Be}},we.html=function(Q){var Y=this.rules.block.html.exec(Q);if(Y){var he={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var ce=this.options.sanitizer?this.options.sanitizer(Y[0]):g(Y[0]);he.type="paragraph",he.text=ce,he.tokens=this.lexer.inline(ce)}return he}},we.def=function(Q){var Y=this.rules.block.def.exec(Q);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var he=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:Y[0],href:Y[2],title:Y[3]}}},we.table=function(Q){var Y=this.rules.block.table.exec(Q);if(Y){var he={type:"table",header:y(Y[1]).map(function(Ue){return{text:Ue}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=Y[0];var ce=he.align.length,Ne,fe,Pe,Ae;for(Ne=0;Ne<ce;Ne++)/^ *-+: *$/.test(he.align[Ne])?he.align[Ne]="right":/^ *:-+: *$/.test(he.align[Ne])?he.align[Ne]="center":/^ *:-+ *$/.test(he.align[Ne])?he.align[Ne]="left":he.align[Ne]=null;for(ce=he.rows.length,Ne=0;Ne<ce;Ne++)he.rows[Ne]=y(he.rows[Ne],he.header.length).map(function(Ue){return{text:Ue}});for(ce=he.header.length,fe=0;fe<ce;fe++)he.header[fe].tokens=this.lexer.inline(he.header[fe].text);for(ce=he.rows.length,fe=0;fe<ce;fe++)for(Ae=he.rows[fe],Pe=0;Pe<Ae.length;Pe++)Ae[Pe].tokens=this.lexer.inline(Ae[Pe].text);return he}}},we.lheading=function(Q){var Y=this.rules.block.lheading.exec(Q);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},we.paragraph=function(Q){var Y=this.rules.block.paragraph.exec(Q);if(Y){var he=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:he,tokens:this.lexer.inline(he)}}},we.text=function(Q){var Y=this.rules.block.text.exec(Q);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},we.escape=function(Q){var Y=this.rules.inline.escape.exec(Q);if(Y)return{type:"escape",raw:Y[0],text:g(Y[1])}},we.tag=function(Q){var Y=this.rules.inline.tag.exec(Q);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):g(Y[0]):Y[0]}},we.link=function(Q){var Y=this.rules.inline.link.exec(Q);if(Y){var he=Y[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var ce=h(he.slice(0,-1),"\\");if((he.length-ce.length)%2===0)return}else{var Ne=D(Y[2],"()");if(Ne>-1){var fe=Y[0].indexOf("!")===0?5:4,Pe=fe+Y[1].length+Ne;Y[2]=Y[2].substring(0,Ne),Y[0]=Y[0].substring(0,Pe).trim(),Y[3]=""}}var Ae=Y[2],Ue="";if(this.options.pedantic){var B=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);B&&(Ae=B[1],Ue=B[3])}else Ue=Y[3]?Y[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(he)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),P(Y,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Ue&&Ue.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},we.reflink=function(Q,Y){var he;if((he=this.rules.inline.reflink.exec(Q))||(he=this.rules.inline.nolink.exec(Q))){var ce=(he[2]||he[1]).replace(/\s+/g," ");if(ce=Y[ce.toLowerCase()],!ce||!ce.href){var Ne=he[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return P(he,ce,he[0],this.lexer)}},we.emStrong=function(Q,Y,he){he===void 0&&(he="");var ce=this.rules.inline.emStrong.lDelim.exec(Q);if(ce&&!(ce[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=ce[1]||ce[2]||"";if(!Ne||Ne&&(he===""||this.rules.inline.punctuation.exec(he))){var fe=ce[0].length-1,Pe,Ae,Ue=fe,B=0,L=ce[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(L.lastIndex=0,Y=Y.slice(-1*Q.length+fe);(ce=L.exec(Y))!=null;)if(Pe=ce[1]||ce[2]||ce[3]||ce[4]||ce[5]||ce[6],!!Pe){if(Ae=Pe.length,ce[3]||ce[4]){Ue+=Ae;continue}else if((ce[5]||ce[6])&&fe%3&&!((fe+Ae)%3)){B+=Ae;continue}if(Ue-=Ae,!(Ue>0)){if(Ae=Math.min(Ae,Ae+Ue+B),Math.min(fe,Ae)%2){var K=Q.slice(1,fe+ce.index+Ae);return{type:"em",raw:Q.slice(0,fe+ce.index+Ae+1),text:K,tokens:this.lexer.inlineTokens(K)}}var H=Q.slice(2,fe+ce.index+Ae-1);return{type:"strong",raw:Q.slice(0,fe+ce.index+Ae+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},we.codespan=function(Q){var Y=this.rules.inline.code.exec(Q);if(Y){var he=Y[2].replace(/\n/g," "),ce=/[^ ]/.test(he),Ne=/^ /.test(he)&&/ $/.test(he);return ce&&Ne&&(he=he.substring(1,he.length-1)),he=g(he,!0),{type:"codespan",raw:Y[0],text:he}}},we.br=function(Q){var Y=this.rules.inline.br.exec(Q);if(Y)return{type:"br",raw:Y[0]}},we.del=function(Q){var Y=this.rules.inline.del.exec(Q);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},we.autolink=function(Q,Y){var he=this.rules.inline.autolink.exec(Q);if(he){var ce,Ne;return he[2]==="@"?(ce=g(this.options.mangle?Y(he[1]):he[1]),Ne="mailto:"+ce):(ce=g(he[1]),Ne=ce),{type:"link",raw:he[0],text:ce,href:Ne,tokens:[{type:"text",raw:ce,text:ce}]}}},we.url=function(Q,Y){var he;if(he=this.rules.inline.url.exec(Q)){var ce,Ne;if(he[2]==="@")ce=g(this.options.mangle?Y(he[0]):he[0]),Ne="mailto:"+ce;else{var fe;do fe=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(fe!==he[0]);ce=g(he[0]),he[1]==="www."?Ne="http://"+ce:Ne=ce}return{type:"link",raw:he[0],text:ce,href:Ne,tokens:[{type:"text",raw:ce,text:ce}]}}},we.inlineText=function(Q,Y){var he=this.rules.inline.text.exec(Q);if(he){var ce;return this.lexer.state.inRawBlock?ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):g(he[0]):he[0]:ce=g(this.options.smartypants?Y(he[0]):he[0]),{type:"text",raw:he[0],text:ce}}},ke}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=i(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=i(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=i(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=i(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=i(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=i(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=v({},q),q.gfm=v({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=i(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=i(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=v({},q.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:i(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var A={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};A._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",A.punctuation=i(A.punctuation).replace(/punctuation/g,A._punctuation).getRegex(),A.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,A.escapedEmSt=/\\\*|\\_/g,A._comment=i(q._comment).replace("(?:-->|$)","-->").getRegex(),A.emStrong.lDelim=i(A.emStrong.lDelim).replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimAst=i(A.emStrong.rDelimAst,"g").replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimUnd=i(A.emStrong.rDelimUnd,"g").replace(/punct/g,A._punctuation).getRegex(),A._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,A._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,A._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,A.autolink=i(A.autolink).replace("scheme",A._scheme).replace("email",A._email).getRegex(),A._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,A.tag=i(A.tag).replace("comment",A._comment).replace("attribute",A._attribute).getRegex(),A._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,A._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,A._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,A.link=i(A.link).replace("label",A._label).replace("href",A._href).replace("title",A._title).getRegex(),A.reflink=i(A.reflink).replace("label",A._label).replace("ref",q._label).getRegex(),A.nolink=i(A.nolink).replace("ref",q._label).getRegex(),A.reflinkSearch=i(A.reflinkSearch,"g").replace("reflink",A.reflink).replace("nolink",A.nolink).getRegex(),A.normal=v({},A),A.pedantic=v({},A.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",A._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",A._label).getRegex()}),A.gfm=v({},A.normal,{escape:i(A.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),A.gfm.url=i(A.gfm.url,"i").replace("email",A.gfm._extended_email).getRegex(),A.breaks=v({},A.gfm,{br:i(A.br).replace("{2,}","*").getRegex(),text:i(A.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(ke){var we="",me,Q,Y=ke.length;for(me=0;me<Y;me++)Q=ke.charCodeAt(me),Math.random()>.5&&(Q="x"+Q.toString(16)),we+="&#"+Q+";";return we}var ie=function(){function ke(me){this.tokens=[],this.tokens.links=Object.create(null),this.options=me||le.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:q.normal,inline:A.normal};this.options.pedantic?(Q.block=q.pedantic,Q.inline=A.pedantic):this.options.gfm&&(Q.block=q.gfm,this.options.breaks?Q.inline=A.breaks:Q.inline=A.gfm),this.tokenizer.rules=Q}ke.lex=function(Q,Y){var he=new ke(Y);return he.lex(Q)},ke.lexInline=function(Q,Y){var he=new ke(Y);return he.inlineTokens(Q)};var we=ke.prototype;return we.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},we.blockTokens=function(Q,Y){var he=this;Y===void 0&&(Y=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(Ue,B,L){return B+"    ".repeat(L.length)});for(var ce,Ne,fe,Pe;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ue){return(ce=Ue.call({lexer:he},Q,Y))?(Q=Q.substring(ce.raw.length),Y.push(ce),!0):!1}))){if(ce=this.tokenizer.space(Q)){Q=Q.substring(ce.raw.length),ce.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(ce);continue}if(ce=this.tokenizer.code(Q)){Q=Q.substring(ce.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+ce.raw,Ne.text+=`
`+ce.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(ce);continue}if(ce=this.tokenizer.fences(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.heading(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.hr(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.blockquote(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.list(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.html(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.def(Q)){Q=Q.substring(ce.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+ce.raw,Ne.text+=`
`+ce.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[ce.tag]||(this.tokens.links[ce.tag]={href:ce.href,title:ce.title});continue}if(ce=this.tokenizer.table(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.lheading(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(fe=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ue=1/0,B=Q.slice(1),L=void 0;he.options.extensions.startBlock.forEach(function(K){L=K.call({lexer:this},B),typeof L=="number"&&L>=0&&(Ue=Math.min(Ue,L))}),Ue<1/0&&Ue>=0&&(fe=Q.substring(0,Ue+1))}(),this.state.top&&(ce=this.tokenizer.paragraph(fe))){Ne=Y[Y.length-1],Pe&&Ne.type==="paragraph"?(Ne.raw+=`
`+ce.raw,Ne.text+=`
`+ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(ce),Pe=fe.length!==Q.length,Q=Q.substring(ce.raw.length);continue}if(ce=this.tokenizer.text(Q)){Q=Q.substring(ce.raw.length),Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+ce.raw,Ne.text+=`
`+ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(ce);continue}if(Q){var Ae="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,Y},we.inline=function(Q,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:Q,tokens:Y}),Y},we.inlineTokens=function(Q,Y){var he=this;Y===void 0&&(Y=[]);var ce,Ne,fe,Pe=Q,Ae,Ue,B;if(this.tokens.links){var L=Object.keys(this.tokens.links);if(L.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)L.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Ae.index)+"["+I("a",Ae[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Ae.index)+"["+I("a",Ae[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Ae.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(Ue||(B=""),Ue=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(ce=H.call({lexer:he},Q,Y))?(Q=Q.substring(ce.raw.length),Y.push(ce),!0):!1}))){if(ce=this.tokenizer.escape(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.tag(Q)){Q=Q.substring(ce.raw.length),Ne=Y[Y.length-1],Ne&&ce.type==="text"&&Ne.type==="text"?(Ne.raw+=ce.raw,Ne.text+=ce.text):Y.push(ce);continue}if(ce=this.tokenizer.link(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(ce.raw.length),Ne=Y[Y.length-1],Ne&&ce.type==="text"&&Ne.type==="text"?(Ne.raw+=ce.raw,Ne.text+=ce.text):Y.push(ce);continue}if(ce=this.tokenizer.emStrong(Q,Pe,B)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.codespan(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.br(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.del(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.autolink(Q,G)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(!this.state.inLink&&(ce=this.tokenizer.url(Q,G))){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(fe=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ee=Q.slice(1),re=void 0;he.options.extensions.startInline.forEach(function(Te){re=Te.call({lexer:this},ee),typeof re=="number"&&re>=0&&(H=Math.min(H,re))}),H<1/0&&H>=0&&(fe=Q.substring(0,H+1))}(),ce=this.tokenizer.inlineText(fe,z)){Q=Q.substring(ce.raw.length),ce.raw.slice(-1)!=="_"&&(B=ce.raw.slice(-1)),Ue=!0,Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=ce.raw,Ne.text+=ce.text):Y.push(ce);continue}if(Q){var K="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return Y},C(ke,null,[{key:"rules",get:function(){return{block:q,inline:A}}}]),ke}(),de=function(){function ke(me){this.options=me||le.defaults}var we=ke.prototype;return we.code=function(Q,Y,he){var ce=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(Q,ce);Ne!=null&&Ne!==Q&&(he=!0,Q=Ne)}return Q=Q.replace(/\n$/,"")+`
`,ce?'<pre><code class="'+this.options.langPrefix+g(ce,!0)+'">'+(he?Q:g(Q,!0))+`</code></pre>
`:"<pre><code>"+(he?Q:g(Q,!0))+`</code></pre>
`},we.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},we.html=function(Q){return Q},we.heading=function(Q,Y,he,ce){if(this.options.headerIds){var Ne=this.options.headerPrefix+ce.slug(he);return"<h"+Y+' id="'+Ne+'">'+Q+"</h"+Y+`>
`}return"<h"+Y+">"+Q+"</h"+Y+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(Q,Y,he){var ce=Y?"ol":"ul",Ne=Y&&he!==1?' start="'+he+'"':"";return"<"+ce+Ne+`>
`+Q+"</"+ce+`>
`},we.listitem=function(Q){return"<li>"+Q+`</li>
`},we.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(Q){return"<p>"+Q+`</p>
`},we.table=function(Q,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+Y+`</table>
`},we.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},we.tablecell=function(Q,Y){var he=Y.header?"th":"td",ce=Y.align?"<"+he+' align="'+Y.align+'">':"<"+he+">";return ce+Q+("</"+he+`>
`)},we.strong=function(Q){return"<strong>"+Q+"</strong>"},we.em=function(Q){return"<em>"+Q+"</em>"},we.codespan=function(Q){return"<code>"+Q+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(Q){return"<del>"+Q+"</del>"},we.link=function(Q,Y,he){if(Q=u(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var ce='<a href="'+g(Q)+'"';return Y&&(ce+=' title="'+Y+'"'),ce+=">"+he+"</a>",ce},we.image=function(Q,Y,he){if(Q=u(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var ce='<img src="'+Q+'" alt="'+he+'"';return Y&&(ce+=' title="'+Y+'"'),ce+=this.options.xhtml?"/>":">",ce},we.text=function(Q){return Q},ke}(),ye=function(){function ke(){}var we=ke.prototype;return we.strong=function(Q){return Q},we.em=function(Q){return Q},we.codespan=function(Q){return Q},we.del=function(Q){return Q},we.html=function(Q){return Q},we.text=function(Q){return Q},we.link=function(Q,Y,he){return""+he},we.image=function(Q,Y,he){return""+he},we.br=function(){return""},ke}(),Ee=function(){function ke(){this.seen={}}var we=ke.prototype;return we.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(Q,Y){var he=Q,ce=0;if(this.seen.hasOwnProperty(he)){ce=this.seen[Q];do ce++,he=Q+"-"+ce;while(this.seen.hasOwnProperty(he))}return Y||(this.seen[Q]=ce,this.seen[he]=0),he},we.slug=function(Q,Y){Y===void 0&&(Y={});var he=this.serialize(Q);return this.getNextSafeSlug(he,Y.dryrun)},ke}(),ge=function(){function ke(me){this.options=me||le.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new Ee}ke.parse=function(Q,Y){var he=new ke(Y);return he.parse(Q)},ke.parseInline=function(Q,Y){var he=new ke(Y);return he.parseInline(Q)};var we=ke.prototype;return we.parse=function(Q,Y){Y===void 0&&(Y=!0);var he="",ce,Ne,fe,Pe,Ae,Ue,B,L,K,H,ee,re,Te,Be,He,_e,xe,et,tt,it=Q.length;for(ce=0;ce<it;ce++){if(H=Q[ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(tt=this.options.extensions.renderers[H.type].call({parser:this},H),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){he+=tt||"";continue}switch(H.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(H.tokens),H.depth,s(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(L="",B="",Pe=H.header.length,Ne=0;Ne<Pe;Ne++)B+=this.renderer.tablecell(this.parseInline(H.header[Ne].tokens),{header:!0,align:H.align[Ne]});for(L+=this.renderer.tablerow(B),K="",Pe=H.rows.length,Ne=0;Ne<Pe;Ne++){for(Ue=H.rows[Ne],B="",Ae=Ue.length,fe=0;fe<Ae;fe++)B+=this.renderer.tablecell(this.parseInline(Ue[fe].tokens),{header:!1,align:H.align[fe]});K+=this.renderer.tablerow(B)}he+=this.renderer.table(L,K);continue}case"blockquote":{K=this.parse(H.tokens),he+=this.renderer.blockquote(K);continue}case"list":{for(ee=H.ordered,re=H.start,Te=H.loose,Pe=H.items.length,K="",Ne=0;Ne<Pe;Ne++)He=H.items[Ne],_e=He.checked,xe=He.task,Be="",He.task&&(et=this.renderer.checkbox(_e),Te?He.tokens.length>0&&He.tokens[0].type==="paragraph"?(He.tokens[0].text=et+" "+He.tokens[0].text,He.tokens[0].tokens&&He.tokens[0].tokens.length>0&&He.tokens[0].tokens[0].type==="text"&&(He.tokens[0].tokens[0].text=et+" "+He.tokens[0].tokens[0].text)):He.tokens.unshift({type:"text",text:et}):Be+=et),Be+=this.parse(He.tokens,Te),K+=this.renderer.listitem(Be,xe,_e);he+=this.renderer.list(K,ee,re);continue}case"html":{he+=this.renderer.html(H.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(K=H.tokens?this.parseInline(H.tokens):H.text;ce+1<it&&Q[ce+1].type==="text";)H=Q[++ce],K+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);he+=Y?this.renderer.paragraph(K):K;continue}default:{var ot='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(ot);return}else throw new Error(ot)}}}return he},we.parseInline=function(Q,Y){Y=Y||this.renderer;var he="",ce,Ne,fe,Pe=Q.length;for(ce=0;ce<Pe;ce++){if(Ne=Q[ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(fe=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),fe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){he+=fe||"";continue}switch(Ne.type){case"escape":{he+=Y.text(Ne.text);break}case"html":{he+=Y.html(Ne.text);break}case"link":{he+=Y.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,Y));break}case"image":{he+=Y.image(Ne.href,Ne.title,Ne.text);break}case"strong":{he+=Y.strong(this.parseInline(Ne.tokens,Y));break}case"em":{he+=Y.em(this.parseInline(Ne.tokens,Y));break}case"codespan":{he+=Y.codespan(Ne.text);break}case"br":{he+=Y.br();break}case"del":{he+=Y.del(this.parseInline(Ne.tokens,Y));break}case"text":{he+=Y.text(Ne.text);break}default:{var Ae='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return he},ke}();function ue(ke,we,me){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof we=="function"&&(me=we,we=null),we=v({},ue.defaults,we||{}),k(we),me){var Q=we.highlight,Y;try{Y=ie.lex(ke,we)}catch(Pe){return me(Pe)}var he=function(Ae){var Ue;if(!Ae)try{we.walkTokens&&ue.walkTokens(Y,we.walkTokens),Ue=ge.parse(Y,we)}catch(B){Ae=B}return we.highlight=Q,Ae?me(Ae):me(null,Ue)};if(!Q||Q.length<3||(delete we.highlight,!Y.length))return he();var ce=0;ue.walkTokens(Y,function(Pe){Pe.type==="code"&&(ce++,setTimeout(function(){Q(Pe.text,Pe.lang,function(Ae,Ue){if(Ae)return he(Ae);Ue!=null&&Ue!==Pe.text&&(Pe.text=Ue,Pe.escaped=!0),ce--,ce===0&&he()})},0))}),ce===0&&he();return}function Ne(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+g(Pe.message+"",!0)+"</pre>";throw Pe}try{var fe=ie.lex(ke,we);if(we.walkTokens){if(we.async)return Promise.all(ue.walkTokens(fe,we.walkTokens)).then(function(){return ge.parse(fe,we)}).catch(Ne);ue.walkTokens(fe,we.walkTokens)}return ge.parse(fe,we)}catch(Pe){Ne(Pe)}}ue.options=ue.setOptions=function(ke){return v(ue.defaults,ke),w(ue.defaults),ue},ue.getDefaults=R,ue.defaults=le.defaults,ue.use=function(){for(var ke=arguments.length,we=new Array(ke),me=0;me<ke;me++)we[me]=arguments[me];var Q=v.apply(void 0,[{}].concat(we)),Y=ue.defaults.extensions||{renderers:{},childTokens:{}},he;we.forEach(function(ce){if(ce.extensions&&(he=!0,ce.extensions.forEach(function(fe){if(!fe.name)throw new Error("extension name required");if(fe.renderer){var Pe=Y.renderers?Y.renderers[fe.name]:null;Pe?Y.renderers[fe.name]=function(){for(var Ae=arguments.length,Ue=new Array(Ae),B=0;B<Ae;B++)Ue[B]=arguments[B];var L=fe.renderer.apply(this,Ue);return L===!1&&(L=Pe.apply(this,Ue)),L}:Y.renderers[fe.name]=fe.renderer}if(fe.tokenizer){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[fe.level]?Y[fe.level].unshift(fe.tokenizer):Y[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?Y.startBlock?Y.startBlock.push(fe.start):Y.startBlock=[fe.start]:fe.level==="inline"&&(Y.startInline?Y.startInline.push(fe.start):Y.startInline=[fe.start]))}fe.childTokens&&(Y.childTokens[fe.name]=fe.childTokens)})),ce.renderer&&function(){var fe=ue.defaults.renderer||new de,Pe=function(B){var L=fe[B];fe[B]=function(){for(var K=arguments.length,H=new Array(K),ee=0;ee<K;ee++)H[ee]=arguments[ee];var re=ce.renderer[B].apply(fe,H);return re===!1&&(re=L.apply(fe,H)),re}};for(var Ae in ce.renderer)Pe(Ae);Q.renderer=fe}(),ce.tokenizer&&function(){var fe=ue.defaults.tokenizer||new W,Pe=function(B){var L=fe[B];fe[B]=function(){for(var K=arguments.length,H=new Array(K),ee=0;ee<K;ee++)H[ee]=arguments[ee];var re=ce.tokenizer[B].apply(fe,H);return re===!1&&(re=L.apply(fe,H)),re}};for(var Ae in ce.tokenizer)Pe(Ae);Q.tokenizer=fe}(),ce.walkTokens){var Ne=ue.defaults.walkTokens;Q.walkTokens=function(fe){var Pe=[];return Pe.push(ce.walkTokens.call(this,fe)),Ne&&(Pe=Pe.concat(Ne.call(this,fe))),Pe}}he&&(Q.extensions=Y),ue.setOptions(Q)})},ue.walkTokens=function(ke,we){for(var me=[],Q=function(){var Ne=he.value;switch(me=me.concat(we.call(ue,Ne)),Ne.type){case"table":{for(var fe=N(Ne.header),Pe;!(Pe=fe()).done;){var Ae=Pe.value;me=me.concat(ue.walkTokens(Ae.tokens,we))}for(var Ue=N(Ne.rows),B;!(B=Ue()).done;)for(var L=B.value,K=N(L),H;!(H=K()).done;){var ee=H.value;me=me.concat(ue.walkTokens(ee.tokens,we))}break}case"list":{me=me.concat(ue.walkTokens(Ne.items,we));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[Ne.type]?ue.defaults.extensions.childTokens[Ne.type].forEach(function(re){me=me.concat(ue.walkTokens(Ne[re],we))}):Ne.tokens&&(me=me.concat(ue.walkTokens(Ne.tokens,we)))}},Y=N(ke),he;!(he=Y()).done;)Q();return me},ue.parseInline=function(ke,we){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");we=v({},ue.defaults,we||{}),k(we);try{var me=ie.lexInline(ke,we);return we.walkTokens&&ue.walkTokens(me,we.walkTokens),ge.parseInline(me,we)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+g(Q.message+"",!0)+"</pre>";throw Q}},ue.Parser=ge,ue.parser=ge.parse,ue.Renderer=de,ue.TextRenderer=ye,ue.Lexer=ie,ue.lexer=ie.lex,ue.Tokenizer=W,ue.Slugger=Ee,ue.parse=ue;var Ce=ue.options,se=ue.setOptions,Oe=ue.use,ne=ue.walkTokens,j=ue.parseInline,x=ue,ve=ge.parse,Fe=ie.lex;le.Lexer=ie,le.Parser=ge,le.Renderer=de,le.Slugger=Ee,le.TextRenderer=ye,le.Tokenizer=W,le.getDefaults=R,le.lexer=Fe,le.marked=ue,le.options=Ce,le.parse=x,le.parseInline=j,le.parser=ve,le.setOptions=se,le.use=Oe,le.walkTokens=ne,Object.defineProperty(le,"__esModule",{value:!0})}),define(Se[128],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=C;function C(r){const s=N(r);if(s&&s.length>0)return new Uint32Array(s)}let O=0;const M=new Uint32Array(10);function N(r){if(O=0,R(r,S,4352),O>0||(R(r,l,4449),O>0)||(R(r,b,4520),O>0)||(R(r,g,12593),O))return M.subarray(0,O);if(r>=44032&&r<=55203){const s=r-44032,o=s%588,i=Math.floor(s/588),n=Math.floor(o/28),c=o%28-1;if(i<S.length?R(i,S,0):4352+i-12593<g.length&&R(4352+i,g,12593),n<l.length?R(n,l,0):4449+n-12593<g.length&&R(4449+n-12593,g,12593),c>=0&&(c<b.length?R(c,b,0):4520+c-12593<g.length&&R(4520+c-12593,g,12593)),O>0)return M.subarray(0,O)}}function R(r,s,o){r>=o&&r<o+s.length&&w(s[r-o])}function w(r){r!==0&&(M[O++]=r&255,r>>8&&(M[O++]=r>>8&255),r>>16&&(M[O++]=r>>16&255))}var m;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var E;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(E||(E={}));var T;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(T||(T={}));const S=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),b=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),g=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Se[129],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=void 0,e.$Dm=C,e.rot=O;function C(w,m,E){return Math.min(Math.max(w,m),E)}function O(w,m){return(m+w%m)%m}class M{constructor(){this.a=0}getNext(){return this.a++}}e.$Fm=M;class N{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Gm=N;class R{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const E=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Hm=R}),define(Se[130],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=N,e.$cd=l;class C{constructor(g,r,s){this.owner=g,this.debugNameSource=r,this.referenceFn=s}getDebugName(g){return N(g,this)}}e.$ad=C;const O=new Map,M=new WeakMap;function N(b,g){const r=M.get(b);if(r)return r;const s=R(b,g);if(s){let o=O.get(s)??0;o++,O.set(s,o);const i=o===1?s:`${s}#${o}`;return M.set(b,i),i}}function R(b,g){const r=M.get(b);if(r)return r;const s=g.owner?T(g.owner)+".":"";let o;const i=g.debugNameSource;if(i!==void 0)if(typeof i=="function"){if(o=i(),o!==void 0)return s+o}else return s+i;const n=g.referenceFn;if(n!==void 0&&(o=l(n),o!==void 0))return s+o;if(g.owner!==void 0){const c=w(g.owner,b);if(c!==void 0)return s+c}}function w(b,g){for(const r in b)if(b[r]===g)return r}const m=new Map,E=new WeakMap;function T(b){const g=E.get(b);if(g)return g;const r=S(b);let s=m.get(r)??0;s++,m.set(r,s);const o=s===1?r:`${r}#${s}`;return E.set(b,o),o}function S(b){const g=b.constructor;return g?g.name:"Object"}function l(b){const g=b.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(g);return(s?s[1]:void 0)?.trim()}}),define(Se[131],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=O,e.$Id=M;let C;function O(r){C=r}function M(){return C}class N{constructor(){this.a=0,this.d=new WeakMap}b(s){return R([w(b("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[w(" "),E(T(s.oldValue,70),{color:"red",strikeThrough:!0}),w(" "),E(T(s.newValue,60),{color:"green"})]:[w(" (unchanged)")]:[w(" "),E(T(s.newValue,60),{color:"green"}),w(" (initial)")]}handleObservableChanged(s,o){console.log(...this.b([m("observable value changed"),E(s.debugName,{color:"BlueViolet"}),...this.c(o)]))}formatChanges(s){if(s.size!==0)return E(" (changed deps: "+[...s].map(o=>o.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const o=s.handleChange;this.d.set(s,new Set),s.handleChange=(i,n)=>(this.d.get(s).add(i),o.apply(s,[i,n]))}handleDerivedRecomputed(s,o){const i=this.d.get(s);console.log(...this.b([m("derived recomputed"),E(s.debugName,{color:"BlueViolet"}),...this.c(o),this.formatChanges(i),{data:[{fn:s._computeFn}]}])),i.clear()}handleFromEventObservableTriggered(s,o){console.log(...this.b([m("observable from event triggered"),E(s.debugName,{color:"BlueViolet"}),...this.c(o),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const o=s.handleChange;this.d.set(s,new Set),s.handleChange=(i,n)=>(this.d.get(s).add(i),o.apply(s,[i,n]))}handleAutorunTriggered(s){const o=this.d.get(s);console.log(...this.b([m("autorun"),E(s.debugName,{color:"BlueViolet"}),this.formatChanges(o),{data:[{fn:s._runFn}]}])),o.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let o=s.getDebugName();o===void 0&&(o=""),console.log(...this.b([m("transaction"),E(o,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=N;function R(r){const s=new Array,o=[];let i="";function n(u){if("length"in u)for(const t of u)t&&n(t);else"text"in u?(i+=`%c${u.text}`,s.push(u.style),u.data&&o.push(...u.data)):"data"in u&&o.push(...u.data)}n(r);const c=[i,...s];return c.push(...o),c}function w(r){return E(r,{color:"black"})}function m(r){return E(g(`${r}: `,10),{color:"black",bold:!0})}function E(r,s={color:"black"}){function o(n){return Object.entries(n).reduce((c,[u,t])=>`${c}${u}:${t};`,"")}const i={color:s.color};return s.strikeThrough&&(i["text-decoration"]="line-through"),s.bold&&(i["font-weight"]="bold"),{text:r,style:o(i)}}function T(r,s){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=s?`"${r}"`:`"${r.substr(0,s-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?S(r,s):l(r,s);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function S(r,s){let o="[ ",i=!0;for(const n of r){if(i||(o+=", "),o.length-5>s){o+="...";break}i=!1,o+=`${T(n,s-o.length)}`}return o+=" ]",o}function l(r,s){let o="{ ",i=!0;for(const[n,c]of Object.entries(r)){if(i||(o+=", "),o.length-5>s){o+="...";break}i=!1,o+=`${n}: ${T(c,s-o.length)}`}return o+=" }",o}function b(r,s){let o="";for(let i=1;i<=s;i++)o+=r;return o}function g(r,s){for(;r.length<s;)r+=" ";return r}}),define(Se[132],Ie([1,0,125,130,131]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$2d=e.$Wd=e.$Vd=void 0,e.$Sd=R,e.$Td=m,e.$Ud=T,e.$Xd=b,e.$Yd=r,e.$Zd=s,e.$1d=o,e.$3d=n,e.$4d=c,e.$6d=t;let N;function R(a){N=a}let w;function m(a){w=a}let E;function T(a){E=a}class S{get TChange(){return null}reportChanges(){this.get()}read(d){return d?d.readObservable(this):this.get()}map(d,$){const p=$===void 0?void 0:d,v=$===void 0?d:$;return E({owner:p,debugName:()=>{const y=(0,O.$cd)(v);if(y!==void 0)return y;const D=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(v.toString());if(D)return`${this.debugName}.${D[2]}`;if(!p)return`${this.debugName} (mapped)`},debugReferenceFn:v},y=>v(this.read(y),y))}recomputeInitiallyAndOnChange(d,$){return d.add(N(this,$)),this}keepObserved(d){return d.add(w(this)),this}get a(){return this.get()}}e.$Vd=S;class l extends S{constructor(){super(...arguments),this.b=new Set}addObserver(d){const $=this.b.size;this.b.add(d),$===0&&this.c()}removeObserver(d){this.b.delete(d)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Wd=l;function b(a,d){const $=new i(a,d);try{a($)}finally{$.finish()}}let g;function r(a){if(g)a(g);else{const d=new i(a,void 0);g=d;try{a(d)}finally{d.finish(),g=void 0}}}async function s(a,d){const $=new i(a,d);try{await a($)}finally{$.finish()}}function o(a,d,$){a?d(a):b(d,$)}class i{constructor(d,$){this._fn=d,this.b=$,this.a=[],(0,M.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,O.$cd)(this._fn)}updateObserver(d,$){this.a.push({observer:d,observable:$}),d.beginUpdate($)}finish(){const d=this.a;for(let $=0;$<d.length;$++){const{observer:p,observable:v}=d[$];p.endUpdate(v)}this.a=null,(0,M.$Id)()?.handleEndTransaction()}}e.$2d=i;function n(a,d){let $;return typeof a=="string"?$=new O.$ad(void 0,a,void 0):$=new O.$ad(a,void 0,void 0),new u($,d,C.$6c)}function c(a,d){return new u(new O.$ad(a.owner,a.debugName,void 0),d,a.equalsFn??C.$6c)}class u extends l{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(d,$,p){super(),this.e=d,this.g=p,this.d=$}get(){return this.d}set(d,$,p){if(p===void 0&&this.g(this.d,d))return;let v;$||($=v=new i(()=>{},()=>`Setting ${this.debugName}`));try{const y=this.d;this.h(d),(0,M.$Id)()?.handleObservableChanged(this,{oldValue:y,newValue:d,change:p,didChange:!0,hadValue:!0});for(const h of this.b)$.updateObserver(h,this),h.handleChange(this,p)}finally{v&&v.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(d){this.d=d}}e.$5d=u;function t(a,d){let $;return typeof a=="string"?$=new O.$ad(void 0,a,void 0):$=new O.$ad(a,void 0,void 0),new f($,d,C.$6c)}class f extends u{h(d){this.d!==d&&(this.d&&this.d.dispose(),this.d=d)}dispose(){this.d?.dispose()}}e.$7d=f}),function(){function le(M){const N=[];typeof M=="number"&&N.push("code/timeOrigin",M);function R(m){N.push(m,Date.now())}function w(){const m=[];for(let E=0;E<N.length;E+=2)m.push({name:N[E],startTime:N[E+1]});return m}return{mark:R,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const R of performance.getEntriesByType("mark"))N.push({name:R.name,startTime:Math.round(M+R.startTime)});return N}};if(typeof process=="object"){const M=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function C(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=C(O))}(),define(Se[133],Ie([1,0,42]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BO=void 0;const O=Symbol("unset");class M{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||C.Iterable.empty()}insert(m,E,T){this.d(m,S=>S._value=E,T)}mutate(m,E){this.d(m,T=>T._value=E(T._value===O?void 0:T._value))}mutatePath(m,E){this.d(m,()=>{},T=>E(T))}delete(m){const E=this.c(m);if(!E)return;let T=E.length-1;const S=E[T].node._value;if(S!==O){for(this.b--,E[T].node._value=O;T>0;T--){const{node:l,part:b}=E[T];if(l.children?.size||l._value!==O)break;E[T-1].node.children.delete(b)}return S}}*deleteRecursive(m){const E=this.c(m);if(!E)return;const T=E[E.length-1].node;for(let S=E.length-1;S>0;S--){const l=E[S-1];if(l.node.children.delete(E[S].part),l.node.children.size>0||l.node._value!==O)break}for(const S of N(T))S._value!==O&&(this.b--,yield S._value)}find(m){let E=this.a;for(const T of m){const S=E.children?.get(T);if(!S)return;E=S}return E._value===O?void 0:E._value}hasKeyOrParent(m){let E=this.a;for(const T of m){const S=E.children?.get(T);if(!S)return!1;if(S._value!==O)return!0;E=S}return!1}hasKeyOrChildren(m){let E=this.a;for(const T of m){const S=E.children?.get(T);if(!S)return!1;E=S}return!0}hasKey(m){let E=this.a;for(const T of m){const S=E.children?.get(T);if(!S)return!1;E=S}return E._value!==O}c(m){const E=[{part:"",node:this.a}];let T=0;for(const S of m){const l=E[T].node.children?.get(S);if(!l)return;E.push({part:S,node:l}),T++}return E}d(m,E,T){let S=this.a;for(const g of m){if(S.children)if(S.children.has(g))S=S.children.get(g);else{const r=new R;S.children.set(g,r),S=r}else{const r=new R;S.children=new Map([[g,r]]),S=r}T?.(S)}const l=S._value===O?0:1;E(S);const b=S._value===O?0:1;this.b+=b-l}*values(){for(const{_value:m}of N(this.a))m!==O&&(yield m)}}e.$BO=M;function*N(w){const m=[w];for(;m.length>0;){const E=m.pop();if(yield E,E.children)for(const T of E.children.values())m.push(T)}}class R{constructor(){this._value=O}get value(){return this._value===O?void 0:this._value}set value(m){this._value=m===void 0?O:m}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var O in C)(typeof exports=="object"?exports:le)[O]=C[O]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function C(O){if(e[O])return e[O].exports;var M=e[O]={i:O,l:!1,exports:{}};return le[O].call(M.exports,M,M.exports,C),M.l=!0,M.exports}return C.m=le,C.c=e,C.d=function(O,M,N){C.o(O,M)||Object.defineProperty(O,M,{enumerable:!0,get:N})},C.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},C.t=function(O,M){if(1&M&&(O=C(O)),8&M||4&M&&typeof O=="object"&&O&&O.__esModule)return O;var N=Object.create(null);if(C.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:O}),2&M&&typeof O!="string")for(var R in O)C.d(N,R,function(w){return O[w]}.bind(null,R));return N},C.n=function(O){var M=O&&O.__esModule?function(){return O.default}:function(){return O};return C.d(M,"a",M),M},C.o=function(O,M){return Object.prototype.hasOwnProperty.call(O,M)},C.p="",C(C.s=0)}([function(le,e,C){(function(O){var M;e=le.exports=Oe,M=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var L=Array.prototype.slice.call(arguments,0);L.unshift("SEMVER"),console.log.apply(console,L)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],m=e.src=[],E=0,T=E++;m[T]="0|[1-9]\\d*";var S=E++;m[S]="[0-9]+";var l=E++;m[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=E++;m[b]="("+m[T]+")\\.("+m[T]+")\\.("+m[T]+")";var g=E++;m[g]="("+m[S]+")\\.("+m[S]+")\\.("+m[S]+")";var r=E++;m[r]="(?:"+m[T]+"|"+m[l]+")";var s=E++;m[s]="(?:"+m[S]+"|"+m[l]+")";var o=E++;m[o]="(?:-("+m[r]+"(?:\\."+m[r]+")*))";var i=E++;m[i]="(?:-?("+m[s]+"(?:\\."+m[s]+")*))";var n=E++;m[n]="[0-9A-Za-z-]+";var c=E++;m[c]="(?:\\+("+m[n]+"(?:\\."+m[n]+")*))";var u=E++,t="v?"+m[b]+m[o]+"?"+m[c]+"?";m[u]="^"+t+"$";var f="[v=\\s]*"+m[g]+m[i]+"?"+m[c]+"?",a=E++;m[a]="^"+f+"$";var d=E++;m[d]="((?:<|>)?=?)";var $=E++;m[$]=m[S]+"|x|X|\\*";var p=E++;m[p]=m[T]+"|x|X|\\*";var v=E++;m[v]="[v=\\s]*("+m[p]+")(?:\\.("+m[p]+")(?:\\.("+m[p]+")(?:"+m[o]+")?"+m[c]+"?)?)?";var y=E++;m[y]="[v=\\s]*("+m[$]+")(?:\\.("+m[$]+")(?:\\.("+m[$]+")(?:"+m[i]+")?"+m[c]+"?)?)?";var h=E++;m[h]="^"+m[d]+"\\s*"+m[v]+"$";var D=E++;m[D]="^"+m[d]+"\\s*"+m[y]+"$";var k=E++;m[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=E++;m[I]="(?:~>?)";var P=E++;m[P]="(\\s*)"+m[I]+"\\s+",w[P]=new RegExp(m[P],"g");var V=E++;m[V]="^"+m[I]+m[v]+"$";var W=E++;m[W]="^"+m[I]+m[y]+"$";var q=E++;m[q]="(?:\\^)";var A=E++;m[A]="(\\s*)"+m[q]+"\\s+",w[A]=new RegExp(m[A],"g");var z=E++;m[z]="^"+m[q]+m[v]+"$";var G=E++;m[G]="^"+m[q]+m[y]+"$";var ie=E++;m[ie]="^"+m[d]+"\\s*("+f+")$|^$";var de=E++;m[de]="^"+m[d]+"\\s*("+t+")$|^$";var ye=E++;m[ye]="(\\s*)"+m[d]+"\\s*("+f+"|"+m[v]+")",w[ye]=new RegExp(m[ye],"g");var Ee=E++;m[Ee]="^\\s*("+m[v]+")\\s+-\\s+("+m[v]+")\\s*$";var ge=E++;m[ge]="^\\s*("+m[y]+")\\s+-\\s+("+m[y]+")\\s*$";var ue=E++;m[ue]="(<|>)?=?\\s*\\*";for(var Ce=0;Ce<35;Ce++)M(Ce,m[Ce]),w[Ce]||(w[Ce]=new RegExp(m[Ce]));function se(L,K){if(L instanceof Oe)return L;if(typeof L!="string"||L.length>N||!(K?w[a]:w[u]).test(L))return null;try{return new Oe(L,K)}catch{return null}}function Oe(L,K){if(L instanceof Oe){if(L.loose===K)return L;L=L.version}else if(typeof L!="string")throw new TypeError("Invalid Version: "+L);if(L.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof Oe))return new Oe(L,K);M("SemVer",L,K),this.loose=K;var H=L.trim().match(K?w[a]:w[u]);if(!H)throw new TypeError("Invalid Version: "+L);if(this.raw=L,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var re=+ee;if(re>=0&&re<R)return re}return ee}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=se,e.valid=function(L,K){var H=se(L,K);return H?H.version:null},e.clean=function(L,K){var H=se(L.trim().replace(/^[=v]+/,""),K);return H?H.version:null},e.SemVer=Oe,Oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Oe.prototype.toString=function(){return this.version},Oe.prototype.compare=function(L){return M("SemVer.compare",this.version,this.loose,L),L instanceof Oe||(L=new Oe(L,this.loose)),this.compareMain(L)||this.comparePre(L)},Oe.prototype.compareMain=function(L){return L instanceof Oe||(L=new Oe(L,this.loose)),j(this.major,L.major)||j(this.minor,L.minor)||j(this.patch,L.patch)},Oe.prototype.comparePre=function(L){if(L instanceof Oe||(L=new Oe(L,this.loose)),this.prerelease.length&&!L.prerelease.length)return-1;if(!this.prerelease.length&&L.prerelease.length)return 1;if(!this.prerelease.length&&!L.prerelease.length)return 0;var K=0;do{var H=this.prerelease[K],ee=L.prerelease[K];if(M("prerelease compare",K,H,ee),H===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(H===void 0)return-1;if(H!==ee)return j(H,ee)}while(++K)},Oe.prototype.inc=function(L,K){switch(L){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+L)}return this.format(),this.raw=this.version,this},e.inc=function(L,K,H,ee){typeof H=="string"&&(ee=H,H=void 0);try{return new Oe(L,H).inc(K,ee).version}catch{return null}},e.diff=function(L,K){if(ke(L,K))return null;var H=se(L),ee=se(K);if(H.prerelease.length||ee.prerelease.length){for(var re in H)if((re==="major"||re==="minor"||re==="patch")&&H[re]!==ee[re])return"pre"+re;return"prerelease"}for(var re in H)if((re==="major"||re==="minor"||re==="patch")&&H[re]!==ee[re])return re},e.compareIdentifiers=j;var ne=/^[0-9]+$/;function j(L,K){var H=ne.test(L),ee=ne.test(K);return H&&ee&&(L=+L,K=+K),H&&!ee?-1:ee&&!H?1:L<K?-1:L>K?1:0}function x(L,K,H){return new Oe(L,H).compare(new Oe(K,H))}function ve(L,K,H){return x(L,K,H)>0}function Fe(L,K,H){return x(L,K,H)<0}function ke(L,K,H){return x(L,K,H)===0}function we(L,K,H){return x(L,K,H)!==0}function me(L,K,H){return x(L,K,H)>=0}function Q(L,K,H){return x(L,K,H)<=0}function Y(L,K,H,ee){var re;switch(K){case"===":typeof L=="object"&&(L=L.version),typeof H=="object"&&(H=H.version),re=L===H;break;case"!==":typeof L=="object"&&(L=L.version),typeof H=="object"&&(H=H.version),re=L!==H;break;case"":case"=":case"==":re=ke(L,H,ee);break;case"!=":re=we(L,H,ee);break;case">":re=ve(L,H,ee);break;case">=":re=me(L,H,ee);break;case"<":re=Fe(L,H,ee);break;case"<=":re=Q(L,H,ee);break;default:throw new TypeError("Invalid operator: "+K)}return re}function he(L,K){if(L instanceof he){if(L.loose===K)return L;L=L.value}if(!(this instanceof he))return new he(L,K);M("comparator",L,K),this.loose=K,this.parse(L),this.semver===ce?this.value="":this.value=this.operator+this.semver.version,M("comp",this)}e.rcompareIdentifiers=function(L,K){return j(K,L)},e.major=function(L,K){return new Oe(L,K).major},e.minor=function(L,K){return new Oe(L,K).minor},e.patch=function(L,K){return new Oe(L,K).patch},e.compare=x,e.compareLoose=function(L,K){return x(L,K,!0)},e.rcompare=function(L,K,H){return x(K,L,H)},e.sort=function(L,K){return L.sort(function(H,ee){return e.compare(H,ee,K)})},e.rsort=function(L,K){return L.sort(function(H,ee){return e.rcompare(H,ee,K)})},e.gt=ve,e.lt=Fe,e.eq=ke,e.neq=we,e.gte=me,e.lte=Q,e.cmp=Y,e.Comparator=he;var ce={};function Ne(L,K){if(L instanceof Ne)return L.loose===K?L:new Ne(L.raw,K);if(L instanceof he)return new Ne(L.value,K);if(!(this instanceof Ne))return new Ne(L,K);if(this.loose=K,this.raw=L,this.set=L.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+L);this.format()}function fe(L){return!L||L.toLowerCase()==="x"||L==="*"}function Pe(L,K,H,ee,re,Te,Be,He,_e,xe,et,tt,it){return((K=fe(H)?"":fe(ee)?">="+H+".0.0":fe(re)?">="+H+"."+ee+".0":">="+K)+" "+(He=fe(_e)?"":fe(xe)?"<"+(+_e+1)+".0.0":fe(et)?"<"+_e+"."+(+xe+1)+".0":tt?"<="+_e+"."+xe+"."+et+"-"+tt:"<="+He)).trim()}function Ae(L,K){for(var H=0;H<L.length;H++)if(!L[H].test(K))return!1;if(K.prerelease.length){for(H=0;H<L.length;H++)if(M(L[H].semver),L[H].semver!==ce&&L[H].semver.prerelease.length>0){var ee=L[H].semver;if(ee.major===K.major&&ee.minor===K.minor&&ee.patch===K.patch)return!0}return!1}return!0}function Ue(L,K,H){try{K=new Ne(K,H)}catch{return!1}return K.test(L)}function B(L,K,H,ee){var re,Te,Be,He,_e;switch(L=new Oe(L,ee),K=new Ne(K,ee),H){case">":re=ve,Te=Q,Be=Fe,He=">",_e=">=";break;case"<":re=Fe,Te=me,Be=ve,He="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(L,K,ee))return!1;for(var xe=0;xe<K.set.length;++xe){var et=K.set[xe],tt=null,it=null;if(et.forEach(function(ot){ot.semver===ce&&(ot=new he(">=0.0.0")),tt=tt||ot,it=it||ot,re(ot.semver,tt.semver,ee)?tt=ot:Be(ot.semver,it.semver,ee)&&(it=ot)}),tt.operator===He||tt.operator===_e||(!it.operator||it.operator===He)&&Te(L,it.semver)||it.operator===_e&&Be(L,it.semver))return!1}return!0}he.prototype.parse=function(L){var K=this.loose?w[ie]:w[de],H=L.match(K);if(!H)throw new TypeError("Invalid comparator: "+L);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new Oe(H[2],this.loose):this.semver=ce},he.prototype.toString=function(){return this.value},he.prototype.test=function(L){return M("Comparator.test",L,this.loose),this.semver===ce||(typeof L=="string"&&(L=new Oe(L,this.loose)),Y(L,this.operator,this.semver,this.loose))},he.prototype.intersects=function(L,K){if(!(L instanceof he))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Ne(L.value,K),Ue(this.value,H,K);if(L.operator==="")return H=new Ne(this.value,K),Ue(L.semver,H,K);var ee=!(this.operator!==">="&&this.operator!==">"||L.operator!==">="&&L.operator!==">"),re=!(this.operator!=="<="&&this.operator!=="<"||L.operator!=="<="&&L.operator!=="<"),Te=this.semver.version===L.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||L.operator!==">="&&L.operator!=="<="),He=Y(this.semver,"<",L.semver,K)&&(this.operator===">="||this.operator===">")&&(L.operator==="<="||L.operator==="<"),_e=Y(this.semver,">",L.semver,K)&&(this.operator==="<="||this.operator==="<")&&(L.operator===">="||L.operator===">");return ee||re||Te&&Be||He||_e},e.Range=Ne,Ne.prototype.format=function(){return this.range=this.set.map(function(L){return L.join(" ").trim()}).join("||").trim(),this.range},Ne.prototype.toString=function(){return this.range},Ne.prototype.parseRange=function(L){var K=this.loose;L=L.trim(),M("range",L,K);var H=K?w[ge]:w[Ee];L=L.replace(H,Pe),M("hyphen replace",L),L=L.replace(w[ye],"$1$2$3"),M("comparator trim",L,w[ye]),L=(L=(L=L.replace(w[P],"$1~")).replace(w[A],"$1^")).split(/\s+/).join(" ");var ee=K?w[ie]:w[de],re=L.split(" ").map(function(Te){return function(Be,He){return M("comp",Be),Be=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,it){M("caret",tt,it);var ot=it?w[G]:w[z];return tt.replace(ot,function(gt,je,rt,Z,X){var $e;return M("caret",tt,gt,je,rt,Z,X),fe(je)?$e="":fe(rt)?$e=">="+je+".0.0 <"+(+je+1)+".0.0":fe(Z)?$e=je==="0"?">="+je+"."+rt+".0 <"+je+"."+(+rt+1)+".0":">="+je+"."+rt+".0 <"+(+je+1)+".0.0":X?(M("replaceCaret pr",X),X.charAt(0)!=="-"&&(X="-"+X),$e=je==="0"?rt==="0"?">="+je+"."+rt+"."+Z+X+" <"+je+"."+rt+"."+(+Z+1):">="+je+"."+rt+"."+Z+X+" <"+je+"."+(+rt+1)+".0":">="+je+"."+rt+"."+Z+X+" <"+(+je+1)+".0.0"):(M("no pr"),$e=je==="0"?rt==="0"?">="+je+"."+rt+"."+Z+" <"+je+"."+rt+"."+(+Z+1):">="+je+"."+rt+"."+Z+" <"+je+"."+(+rt+1)+".0":">="+je+"."+rt+"."+Z+" <"+(+je+1)+".0.0"),M("caret return",$e),$e})}(et,xe)}).join(" ")}(Be,He),M("caret",Be),Be=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,it){var ot=it?w[W]:w[V];return tt.replace(ot,function(gt,je,rt,Z,X){var $e;return M("tilde",tt,gt,je,rt,Z,X),fe(je)?$e="":fe(rt)?$e=">="+je+".0.0 <"+(+je+1)+".0.0":fe(Z)?$e=">="+je+"."+rt+".0 <"+je+"."+(+rt+1)+".0":X?(M("replaceTilde pr",X),X.charAt(0)!=="-"&&(X="-"+X),$e=">="+je+"."+rt+"."+Z+X+" <"+je+"."+(+rt+1)+".0"):$e=">="+je+"."+rt+"."+Z+" <"+je+"."+(+rt+1)+".0",M("tilde return",$e),$e})}(et,xe)}).join(" ")}(Be,He),M("tildes",Be),Be=function(_e,xe){return M("replaceXRanges",_e,xe),_e.split(/\s+/).map(function(et){return function(tt,it){tt=tt.trim();var ot=it?w[D]:w[h];return tt.replace(ot,function(gt,je,rt,Z,X,$e){M("xRange",tt,gt,je,rt,Z,X,$e);var Ke=fe(rt),be=Ke||fe(Z),st=be||fe(X);return je==="="&&st&&(je=""),Ke?gt=je===">"||je==="<"?"<0.0.0":"*":je&&st?(be&&(Z=0),st&&(X=0),je===">"?(je=">=",be?(rt=+rt+1,Z=0,X=0):st&&(Z=+Z+1,X=0)):je==="<="&&(je="<",be?rt=+rt+1:Z=+Z+1),gt=je+rt+"."+Z+"."+X):be?gt=">="+rt+".0.0 <"+(+rt+1)+".0.0":st&&(gt=">="+rt+"."+Z+".0 <"+rt+"."+(+Z+1)+".0"),M("xRange return",gt),gt})}(et,xe)}).join(" ")}(Be,He),M("xrange",Be),Be=function(_e,xe){return M("replaceStars",_e,xe),_e.trim().replace(w[ue],"")}(Be,He),M("stars",Be),Be}(Te,K)}).join(" ").split(/\s+/);return this.loose&&(re=re.filter(function(Te){return!!Te.match(ee)})),re=re.map(function(Te){return new he(Te,K)})},Ne.prototype.intersects=function(L,K){if(!(L instanceof Ne))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ee){return L.set.some(function(re){return re.every(function(Te){return ee.intersects(Te,K)})})})})},e.toComparators=function(L,K){return new Ne(L,K).set.map(function(H){return H.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Ne.prototype.test=function(L){if(!L)return!1;typeof L=="string"&&(L=new Oe(L,this.loose));for(var K=0;K<this.set.length;K++)if(Ae(this.set[K],L))return!0;return!1},e.satisfies=Ue,e.maxSatisfying=function(L,K,H){var ee=null,re=null;try{var Te=new Ne(K,H)}catch{return null}return L.forEach(function(Be){Te.test(Be)&&(ee&&re.compare(Be)!==-1||(re=new Oe(ee=Be,H)))}),ee},e.minSatisfying=function(L,K,H){var ee=null,re=null;try{var Te=new Ne(K,H)}catch{return null}return L.forEach(function(Be){Te.test(Be)&&(ee&&re.compare(Be)!==1||(re=new Oe(ee=Be,H)))}),ee},e.validRange=function(L,K){try{return new Ne(L,K).range||"*"}catch{return null}},e.ltr=function(L,K,H){return B(L,K,"<",H)},e.gtr=function(L,K,H){return B(L,K,">",H)},e.outside=B,e.prerelease=function(L,K){var H=se(L,K);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(L,K,H){return L=new Ne(L,H),K=new Ne(K,H),L.intersects(K)},e.coerce=function(L){if(L instanceof Oe)return L;if(typeof L!="string")return null;var K=L.match(w[k]);return K==null?null:se((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,C(1))},function(le,e){var C,O,M=le.exports={};function N(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function w(s){if(C===setTimeout)return setTimeout(s,0);if((C===N||!C)&&setTimeout)return C=setTimeout,setTimeout(s,0);try{return C(s,0)}catch{try{return C.call(null,s,0)}catch{return C.call(this,s,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:N}catch{C=N}try{O=typeof clearTimeout=="function"?clearTimeout:R}catch{O=R}})();var m,E=[],T=!1,S=-1;function l(){T&&m&&(T=!1,m.length?E=m.concat(E):S=-1,E.length&&b())}function b(){if(!T){var s=w(l);T=!0;for(var o=E.length;o;){for(m=E,E=[];++S<o;)m&&m[S].run();S=-1,o=E.length}m=null,T=!1,function(i){if(O===clearTimeout)return clearTimeout(i);if((O===R||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(i);try{O(i)}catch{try{return O.call(null,i)}catch{return O.call(this,i)}}}(s)}}function g(s,o){this.fun=s,this.array=o}function r(){}M.nextTick=function(s){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];E.push(new g(s,o)),E.length!==1||T||w(b)},g.prototype.run=function(){this.fun.apply(null,this.array)},M.title="browser",M.browser=!0,M.env={},M.argv=[],M.version="",M.versions={},M.on=r,M.addListener=r,M.once=r,M.off=r,M.removeListener=r,M.removeAllListeners=r,M.emit=r,M.prependListener=r,M.prependOnceListener=r,M.listeners=function(s){return[]},M.binding=function(s){throw new Error("process.binding is not supported")},M.cwd=function(){return"/"},M.chdir=function(s){throw new Error("process.chdir is not supported")},M.umask=function(){return 0}}])}),define(Se[134],Ie([1,0,14,6]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=M,e.$te=N,e.$ue=R,e.$ve=w,e.$we=E,e.$xe=T,e.$ye=S,e.$ze=l,e.$Ae=b,e.$Be=g,e.$Ce=r,e.$De=s,e.$Ee=o,e.$Fe=i,e.$Ge=n;function M(c){const u=c;return u?typeof u.read=="function":!1}function N(c){const u=c;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}function R(c){const u=c;return u?N(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}function w(c,u){return new m(c,u)}class m{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,C.$1)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let f;switch(u){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const a=f.indexOf(t);a>=0&&f.splice(a,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(c,u){const t=[];let f;for(;(f=c.read())!==null;)t.push(f);return u(t)}function T(c,u,t){const f=[];let a;for(;(a=c.read())!==null&&f.length<t;)f.push(a);return a===null&&f.length>0?u(f):{read:()=>{if(f.length>0)return f.shift();if(typeof a<"u"){const d=a;return a=void 0,d}return c.read()}}}function S(c,u){return new Promise((t,f)=>{const a=[];l(c,{onData:d=>{u&&a.push(d)},onError:d=>{u?f(d):t(void 0)},onEnd:()=>{t(u?u(a):void 0)}})})}function l(c,u,t){c.on("error",f=>{t?.isCancellationRequested||u.onError(f)}),c.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),c.on("data",f=>{t?.isCancellationRequested||u.onData(f)})}function b(c,u){return new Promise((t,f)=>{const a=new O.$Tc,d=[],$=y=>{if(d.push(y),d.length>u)return a.dispose(),c.pause(),t({stream:c,buffer:d,ended:!1})},p=y=>(a.dispose(),f(y)),v=()=>(a.dispose(),t({stream:c,buffer:d,ended:!0}));a.add((0,O.$Sc)(()=>c.removeListener("error",p))),c.on("error",p),a.add((0,O.$Sc)(()=>c.removeListener("end",v))),c.on("end",v),a.add((0,O.$Sc)(()=>c.removeListener("data",$))),c.on("data",$)})}function g(c,u){const t=w(u);return t.end(c),t}function r(){const c=w(()=>{throw new Error("not supported")});return c.end(),c}function s(c){let u=!1;return{read:()=>u?null:(u=!0,c)}}function o(c,u,t){const f=w(t);return l(c,{onData:a=>f.write(u.data(a)),onError:a=>f.error(u.error?u.error(a):a),onEnd:()=>f.end()}),f}function i(c,u,t){let f=!1;return{read:()=>{const a=u.read();return f?a:(f=!0,a!==null?t([c,a]):c)}}}function n(c,u,t){let f=!1;const a=w(t);return l(u,{onData:d=>f?a.write(d):(f=!0,a.write(t([c,d]))),onError:d=>a.error(d),onEnd:()=>{f||(f=!0,a.write(c)),a.end()}}),a}}),define(Se[22],Ie([1,0,43,134]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=void 0,e.$Ie=E,e.$Je=T,e.$Ke=S,e.$Le=l,e.$Me=b,e.$Ne=g,e.$Oe=r,e.$Pe=s,e.$Qe=o,e.$Re=i,e.$Se=n,e.$Te=c,e.$Ue=u,e.$Ve=t,e.$We=f,e.$Xe=a,e.$Ye=d,e.$Ze=$,e.$1e=p,e.$2e=h;const M=typeof Buffer<"u",N=new C.$V(()=>new Uint8Array(256));let R,w;class m{static alloc(k){return M?new m(Buffer.allocUnsafe(k)):new m(new Uint8Array(k))}static wrap(k){return M&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new m(k)}static fromString(k,I){return!(I?.dontUseNodeBuffer||!1)&&M?new m(Buffer.from(k)):(R||(R=new TextEncoder),new m(R.encode(k)))}static fromByteArray(k){const I=m.alloc(k.length);for(let P=0,V=k.length;P<V;P++)I.buffer[P]=k[P];return I}static concat(k,I){if(typeof I>"u"){I=0;for(let W=0,q=k.length;W<q;W++)I+=k[W].byteLength}const P=m.alloc(I);let V=0;for(let W=0,q=k.length;W<q;W++){const A=k[W];P.set(A,V),V+=A.byteLength}return P}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=m.alloc(this.byteLength);return k.set(this),k}toString(){return M?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(k,I){return new m(this.buffer.subarray(k,I))}set(k,I){if(k instanceof m)this.buffer.set(k.buffer,I);else if(k instanceof Uint8Array)this.buffer.set(k,I);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),I);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return l(this.buffer,k)}writeUInt32BE(k,I){b(this.buffer,k,I)}readUInt32LE(k){return g(this.buffer,k)}writeUInt32LE(k,I){r(this.buffer,k,I)}readUInt8(k){return s(this.buffer,k)}writeUInt8(k,I){o(this.buffer,k,I)}indexOf(k,I=0){return E(this.buffer,k instanceof m?k.buffer:k,I)}}e.$He=m;function E(D,k,I=0){const P=k.byteLength,V=D.byteLength;if(P===0)return 0;if(P===1)return D.indexOf(k[0]);if(P>V-I)return-1;const W=N.value;W.fill(k.length);for(let G=0;G<k.length;G++)W[k[G]]=k.length-G-1;let q=I+k.length-1,A=q,z=-1;for(;q<V;)if(D[q]===k[A]){if(A===0){z=q;break}q--,A--}else q+=Math.max(k.length-A,W[D[q]]),A=k.length-1;return z}function T(D,k){return D[k+0]<<0>>>0|D[k+1]<<8>>>0}function S(D,k,I){D[I+0]=k&255,k=k>>>8,D[I+1]=k&255}function l(D,k){return D[k]*2**24+D[k+1]*2**16+D[k+2]*2**8+D[k+3]}function b(D,k,I){D[I+3]=k,k=k>>>8,D[I+2]=k,k=k>>>8,D[I+1]=k,k=k>>>8,D[I]=k}function g(D,k){return D[k+0]<<0>>>0|D[k+1]<<8>>>0|D[k+2]<<16>>>0|D[k+3]<<24>>>0}function r(D,k,I){D[I+0]=k&255,k=k>>>8,D[I+1]=k&255,k=k>>>8,D[I+2]=k&255,k=k>>>8,D[I+3]=k&255}function s(D,k){return D[k]}function o(D,k,I){D[I]=k}function i(D){return O.$we(D,k=>m.concat(k))}function n(D){return O.$De(D)}function c(D){return O.$ye(D,k=>m.concat(k))}async function u(D){return D.ended?m.concat(D.buffer):m.concat([...D.buffer,await c(D.stream)])}function t(D){return O.$Be(D,k=>m.concat(k))}function f(D){return O.$Ee(D,{data:k=>typeof k=="string"?m.fromString(k):m.wrap(k)},k=>m.concat(k))}function a(D){return O.$ve(k=>m.concat(k),D)}function d(D,k){return O.$Fe(D,k,I=>m.concat(I))}function $(D,k){return O.$Ge(D,k,I=>m.concat(I))}function p(D){let k=0,I=0,P=0;const V=new Uint8Array(Math.floor(D.length/4*3)),W=A=>{switch(I){case 3:V[P++]=k|A,I=0;break;case 2:V[P++]=k|A>>>2,k=A<<6,I=3;break;case 1:V[P++]=k|A>>>4,k=A<<4,I=2;break;default:k=A<<2,I=1}};for(let A=0;A<D.length;A++){const z=D.charCodeAt(A);if(z>=65&&z<=90)W(z-65);else if(z>=97&&z<=122)W(z-97+26);else if(z>=48&&z<=57)W(z-48+52);else if(z===43||z===45)W(62);else if(z===47||z===95)W(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${D[A]}`)}}const q=P;for(;I>0;)W(0);return m.wrap(V).slice(0,q)}const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:D},k=!0,I=!1){const P=I?y:v;let V="";const W=D.byteLength%3;let q=0;for(;q<D.byteLength-W;q+=3){const A=D[q+0],z=D[q+1],G=D[q+2];V+=P[A>>>2],V+=P[(A<<4|z>>>4)&63],V+=P[(z<<2|G>>>6)&63],V+=P[G&63]}if(W===1){const A=D[q+0];V+=P[A>>>2],V+=P[A<<4&63],k&&(V+="==")}else if(W===2){const A=D[q+0],z=D[q+1];V+=P[A>>>2],V+=P[(A<<4|z>>>4)&63],V+=P[z<<2&63],k&&(V+="=")}return V}}),define(Se[135],Ie([1,0,28,128,13]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.FuzzyScore=e.$Ak=e.$zk=void 0,e.or=N,e.$Bk=w,e.$Ck=m,e.$Dk=S,e.$Ek=p,e.$Fk=v,e.$Gk=P,e.$Hk=V,e.$Ik=W,e.$Jk=q,e.$Kk=x,e.$Mk=we,e.$Nk=Y,e.$Ok=he;function N(...fe){return function(Pe,Ae){for(let Ue=0,B=fe.length;Ue<B;Ue++){const L=fe[Ue](Pe,Ae);if(L)return L}return null}}e.$zk=R.bind(void 0,!1),e.$Ak=R.bind(void 0,!0);function R(fe,Pe,Ae){if(!Ae||Ae.length<Pe.length)return null;let Ue;return fe?Ue=M.$Af(Ae,Pe):Ue=Ae.indexOf(Pe)===0,Ue?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function w(fe,Pe){const Ae=Pe.toLowerCase().indexOf(fe.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+fe.length}]}function m(fe,Pe){return E(fe.toLowerCase(),Pe.toLowerCase(),0,0)}function E(fe,Pe,Ae,Ue){if(Ae===fe.length)return[];if(Ue===Pe.length)return null;if(fe[Ae]===Pe[Ue]){let B=null;return(B=E(fe,Pe,Ae+1,Ue+1))?c({start:Ue,end:Ue+1},B):null}return E(fe,Pe,Ae,Ue+1)}function T(fe){return 97<=fe&&fe<=122}function S(fe){return 65<=fe&&fe<=90}function l(fe){return 48<=fe&&fe<=57}function b(fe){return fe===32||fe===9||fe===10||fe===13}const g=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(fe=>g.add(fe.charCodeAt(0)));function r(fe){return b(fe)||g.has(fe)}function s(fe,Pe){return fe===Pe||r(fe)&&r(Pe)}const o=new Map;function i(fe){if(o.has(fe))return o.get(fe);let Pe;const Ae=(0,O.$xk)(fe);return Ae&&(Pe=Ae),o.set(fe,Pe),Pe}function n(fe){return T(fe)||S(fe)||l(fe)}function c(fe,Pe){return Pe.length===0?Pe=[fe]:fe.end===Pe[0].start?Pe[0].start=fe.start:Pe.unshift(fe),Pe}function u(fe,Pe){for(let Ae=Pe;Ae<fe.length;Ae++){const Ue=fe.charCodeAt(Ae);if(S(Ue)||l(Ue)||Ae>0&&!n(fe.charCodeAt(Ae-1)))return Ae}return fe.length}function t(fe,Pe,Ae,Ue){if(Ae===fe.length)return[];if(Ue===Pe.length)return null;if(fe[Ae]!==Pe[Ue].toLowerCase())return null;{let B=null,L=Ue+1;for(B=t(fe,Pe,Ae+1,Ue+1);!B&&(L=u(Pe,L))<Pe.length;)B=t(fe,Pe,Ae+1,L),L++;return B===null?null:c({start:Ue,end:Ue+1},B)}}function f(fe){let Pe=0,Ae=0,Ue=0,B=0,L=0;for(let Te=0;Te<fe.length;Te++)L=fe.charCodeAt(Te),S(L)&&Pe++,T(L)&&Ae++,n(L)&&Ue++,l(L)&&B++;const K=Pe/fe.length,H=Ae/fe.length,ee=Ue/fe.length,re=B/fe.length;return{upperPercent:K,lowerPercent:H,alphaPercent:ee,numericPercent:re}}function a(fe){const{upperPercent:Pe,lowerPercent:Ae}=fe;return Ae===0&&Pe>.6}function d(fe){const{upperPercent:Pe,lowerPercent:Ae,alphaPercent:Ue,numericPercent:B}=fe;return Ae>.2&&Pe<.8&&Ue>.6&&B<.2}function $(fe){let Pe=0,Ae=0,Ue=0,B=0;for(let L=0;L<fe.length;L++)Ue=fe.charCodeAt(L),S(Ue)&&Pe++,T(Ue)&&Ae++,b(Ue)&&B++;return(Pe===0||Ae===0)&&B===0?fe.length<=30:Pe<=5}function p(fe,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!$(fe))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Ae=f(Pe);if(!d(Ae)){if(!a(Ae))return null;Pe=Pe.toLowerCase()}let Ue=null,B=0;for(fe=fe.toLowerCase();B<Pe.length&&(Ue=t(fe,Pe,0,B))===null;)B=u(Pe,B+1);return Ue}function v(fe,Pe,Ae=!1){if(!Pe||Pe.length===0)return null;let Ue=null,B=0;for(fe=fe.toLowerCase(),Pe=Pe.toLowerCase();B<Pe.length&&(Ue=y(fe,Pe,0,B,Ae),Ue===null);)B=h(Pe,B+1);return Ue}function y(fe,Pe,Ae,Ue,B){let L=0;if(Ae===fe.length)return[];if(Ue===Pe.length)return null;if(!s(fe.charCodeAt(Ae),Pe.charCodeAt(Ue))){const ee=i(fe.charCodeAt(Ae));if(!ee)return null;for(let re=0;re<ee.length;re++)if(!s(ee[re],Pe.charCodeAt(Ue+re)))return null;L+=ee.length-1}let K=null,H=Ue+L+1;if(K=y(fe,Pe,Ae+1,H,B),!B)for(;!K&&(H=h(Pe,H))<Pe.length;)K=y(fe,Pe,Ae+1,H,B),H++;if(!K)return null;if(fe.charCodeAt(Ae)!==Pe.charCodeAt(Ue)){const ee=i(fe.charCodeAt(Ae));if(!ee)return K;for(let re=0;re<ee.length;re++)if(ee[re]!==Pe.charCodeAt(Ue+re))return K}return c({start:Ue,end:Ue+L+1},K)}function h(fe,Pe){for(let Ae=Pe;Ae<fe.length;Ae++)if(r(fe.charCodeAt(Ae))||Ae>0&&r(fe.charCodeAt(Ae-1)))return Ae;return fe.length}const D=N(e.$Ak,p,w),k=N(e.$Ak,p,m),I=new C.$Dc(1e4);function P(fe,Pe,Ae=!1){if(typeof fe!="string"||typeof Pe!="string")return null;let Ue=I.get(fe);Ue||(Ue=new RegExp(M.$if(fe),"i"),I.set(fe,Ue));const B=Ue.exec(Pe);return B?[{start:B.index,end:B.index+B[0].length}]:Ae?k(fe,Pe):D(fe,Pe)}function V(fe,Pe){const Ae=we(fe,fe.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?q(Ae):null}function W(fe,Pe,Ae,Ue,B,L){const K=Math.min(13,fe.length);for(;Ae<K;Ae++){const H=we(fe,Pe,Ae,Ue,B,L,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,L]}function q(fe){if(typeof fe>"u")return[];const Pe=[],Ae=fe[1];for(let Ue=fe.length-1;Ue>1;Ue--){const B=fe[Ue]+Ae,L=Pe[Pe.length-1];L&&L.end===B?L.end=B+1:Pe.push({start:B,end:B+1})}return Pe}const A=128;function z(){const fe=[],Pe=[];for(let Ae=0;Ae<=A;Ae++)Pe[Ae]=0;for(let Ae=0;Ae<=A;Ae++)fe.push(Pe.slice(0));return fe}function G(fe){const Pe=[];for(let Ae=0;Ae<=fe;Ae++)Pe[Ae]=0;return Pe}const ie=G(2*A),de=G(2*A),ye=z(),Ee=z(),ge=z(),ue=!1;function Ce(fe,Pe,Ae,Ue,B){function L(H,ee,re=" "){for(;H.length<ee;)H=re+H;return H}let K=` |   |${Ue.split("").map(H=>L(H,3)).join("|")}
`;for(let H=0;H<=Ae;H++)H===0?K+=" |":K+=`${Pe[H-1]}|`,K+=fe[H].slice(0,B+1).map(ee=>L(ee.toString(),3)).join("|")+`
`;return K}function se(fe,Pe,Ae,Ue){fe=fe.substr(Pe),Ae=Ae.substr(Ue),console.log(Ce(Ee,fe,fe.length,Ae,Ae.length)),console.log(Ce(ge,fe,fe.length,Ae,Ae.length)),console.log(Ce(ye,fe,fe.length,Ae,Ae.length))}function Oe(fe,Pe){if(Pe<0||Pe>=fe.length)return!1;const Ae=fe.codePointAt(Pe);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$Sf(Ae)}}function ne(fe,Pe){if(Pe<0||Pe>=fe.length)return!1;switch(fe.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function j(fe,Pe,Ae){return Pe[fe]!==Ae[fe]}function x(fe,Pe,Ae,Ue,B,L,K=!1){for(;Pe<Ae&&B<L;)fe[Pe]===Ue[B]&&(K&&(ie[Pe]=B),Pe+=1),B+=1;return Pe===Ae}var ve;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Fe;(function(fe){fe.Default=[-100,0];function Pe(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}fe.isDefault=Pe})(Fe||(e.FuzzyScore=Fe={}));class ke{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Ae){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Ae}}e.$Lk=ke;function we(fe,Pe,Ae,Ue,B,L,K=ke.default){const H=fe.length>A?A:fe.length,ee=Ue.length>A?A:Ue.length;if(Ae>=H||L>=ee||H-Ae>ee-L||!x(Pe,Ae,H,B,L,ee,!0))return;me(H,ee,Ae,L,Pe,B);let re=1,Te=1,Be=Ae,He=L;const _e=[!1];for(re=1,Be=Ae;Be<H;re++,Be++){const ot=ie[Be],gt=de[Be],je=Be+1<H?de[Be+1]:ee;for(Te=ot-L+1,He=ot;He<je;Te++,He++){let rt=Number.MIN_SAFE_INTEGER,Z=!1;He<=gt&&(rt=Q(fe,Pe,Be,Ae,Ue,B,He,ee,L,ye[re-1][Te-1]===0,_e));let X=0;rt!==Number.MAX_SAFE_INTEGER&&(Z=!0,X=rt+Ee[re-1][Te-1]);const $e=He>ot,Ke=$e?Ee[re][Te-1]+(ye[re][Te-1]>0?-5:0):0,be=He>ot+1&&ye[re][Te-1]>0,st=be?Ee[re][Te-2]+(ye[re][Te-2]>0?-5:0):0;if(be&&(!$e||st>=Ke)&&(!Z||st>=X))Ee[re][Te]=st,ge[re][Te]=3,ye[re][Te]=0;else if($e&&(!Z||Ke>=X))Ee[re][Te]=Ke,ge[re][Te]=2,ye[re][Te]=0;else if(Z)Ee[re][Te]=X,ge[re][Te]=1,ye[re][Te]=ye[re-1][Te-1]+1;else throw new Error("not possible")}}if(ue&&se(fe,Ae,Ue,L),!_e[0]&&!K.firstMatchCanBeWeak)return;re--,Te--;const xe=[Ee[re][Te],L];let et=0,tt=0;for(;re>=1;){let ot=Te;do{const gt=ge[re][ot];if(gt===3)ot=ot-2;else if(gt===2)ot=ot-1;else break}while(ot>=1);et>1&&Pe[Ae+re-1]===B[L+Te-1]&&!j(ot+L-1,Ue,B)&&et+1>ye[re][ot]&&(ot=Te),ot===Te?et++:et=1,tt||(tt=ot),re--,Te=ot-1,xe.push(Te)}ee-L===H&&K.boostFullMatch&&(xe[0]+=2);const it=tt-H;return xe[0]-=it,xe}function me(fe,Pe,Ae,Ue,B,L){let K=fe-1,H=Pe-1;for(;K>=Ae&&H>=Ue;)B[K]===L[H]&&(de[K]=H,K--),H--}function Q(fe,Pe,Ae,Ue,B,L,K,H,ee,re,Te){if(Pe[Ae]!==L[K])return Number.MIN_SAFE_INTEGER;let Be=1,He=!1;return K===Ae-Ue?Be=fe[Ae]===B[K]?7:5:j(K,B,L)&&(K===0||!j(K-1,B,L))?(Be=fe[Ae]===B[K]?7:5,He=!0):Oe(L,K)&&(K===0||!Oe(L,K-1))?Be=5:(Oe(L,K-1)||ne(L,K-1))&&(Be=5,He=!0),Be>1&&Ae===Ue&&(Te[0]=!0),He||(He=j(K,B,L)||Oe(L,K-1)||ne(L,K-1)),Ae===Ue?K>ee&&(Be-=He?3:5):re?Be+=He?2:0:Be+=He?0:1,K+1===H&&(Be-=He?3:5),Be}function Y(fe,Pe,Ae,Ue,B,L,K){return ce(fe,Pe,Ae,Ue,B,L,!0,K)}function he(fe,Pe,Ae,Ue,B,L,K){return ce(fe,Pe,Ae,Ue,B,L,!1,K)}function ce(fe,Pe,Ae,Ue,B,L,K,H){let ee=we(fe,Pe,Ae,Ue,B,L,H);if(ee&&!K)return ee;if(fe.length>=3){const re=Math.min(7,fe.length-1);for(let Te=Ae+1;Te<re;Te++){const Be=Ne(fe,Te);if(Be){const He=we(Be,Be.toLowerCase(),Ae,Ue,B,L,H);He&&(He[0]-=3,(!ee||He[0]>ee[0])&&(ee=He))}}}return ee}function Ne(fe,Pe){if(Pe+1>=fe.length)return;const Ae=fe[Pe],Ue=fe[Pe+1];if(Ae!==Ue)return fe.slice(0,Pe)+Ue+Ae+fe.slice(Pe+2)}}),define(Se[32],Ie([1,0,13]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(M){M[M.Ignore=0]="Ignore",M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(O||(O={})),function(M){const N="error",R="warning",w="warn",m="info",E="ignore";function T(l){return l?C.$zf(N,l)?M.Error:C.$zf(R,l)||C.$zf(w,l)?M.Warning:C.$zf(m,l)?M.Info:M.Ignore:M.Ignore}M.fromValue=T;function S(l){switch(l){case M.Error:return N;case M.Warning:return R;case M.Info:return m;default:return E}}M.toString=S}(O||(O={})),e.default=O}),define(Se[136],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(Se[54],Ie([1,0,18,13]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class M{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const g=b.charCodeAt(0),r=this.b.charCodeAt(this.c);return g-r}value(){return this.b[this.c]}}e.$Ai=M;class N{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,O.$tf)(b,this.b,0,b.length,this.c,this.d):(0,O.$vf)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Bi=N;class R{constructor(b=!0,g=!0){this.f=b,this.g=g}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let g=b.length-1;g>=0;g--,this.c--){const r=this.b.charCodeAt(g);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,O.$tf)(b,this.b,0,b.length,this.d,this.e):(0,O.$vf)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ci=R;var w;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(w||(w={}));class m{constructor(b,g){this.f=b,this.g=g,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,O.$uf)(b,this.c.scheme);if(this.d[this.e]===2)return(0,O.$uf)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,O.$sf)(b,this.c.query);if(this.d[this.e]===5)return(0,O.$sf)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Di=m;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(T||(T={}));class S{static forUris(b=()=>!1,g=()=>!1){return new S(new m(b,g))}static forPaths(b=!1){return new S(new R(void 0,!b))}static forStrings(){return new S(new M)}static forConfigKeys(){return new S(new N)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,g){if(g){const r=g.slice(0);(0,C.$Wb)(r);for(const s of r)this.set(s,b)}else{const r=b.slice(0);(0,C.$Wb)(r);for(const s of r)this.set(s[0],s[1])}}set(b,g){const r=this.b.reset(b);let s;this.c||(this.c=new E,this.c.segment=r.value());const o=[];for(s=this.c;;){const n=r.cmp(s.segment);if(n>0)s.left||(s.left=new E,s.left.segment=r.value()),o.push([-1,s]),s=s.left;else if(n<0)s.right||(s.right=new E,s.right.segment=r.value()),o.push([1,s]),s=s.right;else if(r.hasNext())r.next(),s.mid||(s.mid=new E,s.mid.segment=r.value()),o.push([0,s]),s=s.mid;else break}const i=s.value;s.value=g,s.key=b;for(let n=o.length-1;n>=0;n--){const c=o[n][1];c.updateHeight();const u=c.balanceFactor();if(u<-1||u>1){const t=o[n][0],f=o[n+1][0];if(t===1&&f===1)o[n][1]=c.rotateLeft();else if(t===-1&&f===-1)o[n][1]=c.rotateRight();else if(t===1&&f===-1)c.right=o[n+1][1]=o[n+1][1].rotateRight(),o[n][1]=c.rotateLeft();else if(t===-1&&f===1)c.left=o[n+1][1]=o[n+1][1].rotateLeft(),o[n][1]=c.rotateRight();else throw new Error;if(n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}return i}get(b){return this.d(b)?.value}d(b){const g=this.b.reset(b);let r=this.c;for(;r;){const s=g.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(g.hasNext())g.next(),r=r.mid;else break}return r}has(b){const g=this.d(b);return!(g?.value===void 0&&g?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,g){const r=this.b.reset(b),s=[];let o=this.c;for(;o;){const i=r.cmp(o.segment);if(i>0)s.push([-1,o]),o=o.left;else if(i<0)s.push([1,o]),o=o.right;else if(r.hasNext())r.next(),s.push([0,o]),o=o.mid;else break}if(o){if(g?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this.f(o.right);if(i.key){const{key:n,value:c,segment:u}=i;this.e(i.key,!1),o.key=n,o.value=c,o.segment=u}}else{const i=o.left??o.right;if(s.length>0){const[n,c]=s[s.length-1];switch(n){case-1:c.left=i;break;case 0:c.mid=i;break;case 1:c.right=i;break}}else this.c=i}for(let i=s.length-1;i>=0;i--){const n=s[i][1];n.updateHeight();const c=n.balanceFactor();if(c>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),s[i][1]=n.rotateLeft()):c<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),s[i][1]=n.rotateRight()),i>0)switch(s[i-1][0]){case-1:s[i-1][1].left=s[i][1];break;case 1:s[i-1][1].right=s[i][1];break;case 0:s[i-1][1].mid=s[i][1];break}else this.c=s[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const g=this.b.reset(b);let r=this.c,s;for(;r;){const o=g.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(g.hasNext())g.next(),s=r.value||s,r=r.mid;else break}return r&&r.value||s}findSuperstr(b){return this.g(b,!1)}g(b,g){const r=this.b.reset(b);let s=this.c;for(;s;){const o=r.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else return s.mid?this.h(s.mid):g?s.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[g,r]of this)b(r,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const g=[];return this.j(b,g),g[Symbol.iterator]()}j(b,g){b&&(b.left&&this.j(b.left,g),b.value&&g.push([b.key,b.value]),b.mid&&this.j(b.mid,g),b.right&&this.j(b.right,g))}_isBalanced(){const b=g=>{if(!g)return!0;const r=g.balanceFactor();return r<-1||r>1?!1:b(g.left)&&b(g.right)};return b(this.c)}}e.$Ei=S}),define(Se[36],Ie([1,0,92]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Yj=M;var O;(function(R){function w(m){return m&&typeof m=="object"&&typeof m.id=="string"}R.isThemeColor=w})(O||(e.ThemeColor=O={}));function M(R){return{id:R}}var N;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function m(i){const n=w.exec(i.id);if(!n)return m(C.$Xj.error);const[,c,u]=n,t=["codicon","codicon-"+c];return u&&t.push("codicon-modifier-"+u.substring(1)),t}R.asClassNameArray=m;function E(i){return m(i).join(" ")}R.asClassName=E;function T(i){return"."+m(i).join(".")}R.asCSSSelector=T;function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||O.isThemeColor(i.color))}R.isThemeIcon=S;const l=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function b(i){const n=l.exec(i);if(!n)return;const[,c]=n;return{id:c}}R.fromString=b;function g(i){return{id:i}}R.fromId=g;function r(i,n){let c=i.id;const u=c.lastIndexOf("~");return u!==-1&&(c=c.substring(0,u)),n&&(c=`${c}~${n}`),{id:c}}R.modify=r;function s(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=s;function o(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=o})(N||(e.ThemeIcon=N={}))}),define(Se[137],Ie([1,0,135,13,36]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=m,e.$Qk=T,e.$Rk=l,e.$Sk=b,e.$Tk=r,e.$Uk=s;const N="$(",R=new RegExp(`\\$\\(${M.ThemeIcon.iconNameExpression}(?:${M.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${R.source}`,"g");function m(o){return o.replace(w,(i,n)=>n?i:`\\${i}`)}const E=new RegExp(`\\\\${R.source}`,"g");function T(o){return o.replace(E,i=>`\\${i}`)}const S=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function l(o){return o.indexOf(N)===-1?o:o.replace(S,(i,n,c,u)=>c?i:n||u||"")}function b(o){return o?o.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}const g=new RegExp(`\\$\\(${M.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(o){g.lastIndex=0;let i="";const n=[];let c=0;for(;;){const u=g.lastIndex,t=g.exec(o),f=o.substring(u,t?.index);if(f.length>0){i+=f;for(let a=0;a<f.length;a++)n.push(c)}if(!t)break;c+=t[0].length}return{text:i,iconOffsets:n}}function s(o,i,n=!1){const{text:c,iconOffsets:u}=i;if(!u||u.length===0)return(0,C.$Gk)(o,c,n);const t=(0,O.$gf)(c," "),f=c.length-t.length,a=(0,C.$Gk)(o,t,n);if(a)for(const d of a){const $=u[d.start+f]+f;d.start+=$,d.end+=$}return a}}),define(Se[33],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=void 0,e.$Tg=O;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(M){return C.test(M)}e.$Ug=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(w){for(let m=0;m<w.length;m++)w[m]=Math.floor(Math.random()*256);return w};const N=new Uint8Array(16),R=[];for(let w=0;w<256;w++)R.push(w.toString(16).padStart(2,"0"));return function(){M(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let m=0,E="";return E+=R[N[m++]],E+=R[N[m++]],E+=R[N[m++]],E+=R[N[m++]],E+="-",E+=R[N[m++]],E+=R[N[m++]],E+="-",E+=R[N[m++]],E+=R[N[m++]],E+="-",E+=R[N[m++]],E+=R[N[m++]],E+="-",E+=R[N[m++]],E+=R[N[m++]],E+=R[N[m++]],E+=R[N[m++]],E+=R[N[m++]],E+=R[N[m++]],E}}()}),define(Se[138],Ie([1,0,18,42,33]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xt=e.$Vt=void 0,e.$Tt=N,e.$Ut=R,e.$Wt=E;function N(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}function R(S,l,b){const g={id:(0,M.$Ug)(),name:S,uri:l,data:b};return{asString:async()=>"",asFile:()=>g,value:void 0}}class w{constructor(){this.a=new Map}get size(){let l=0;for(const b of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const b=[...this.a.keys()];return O.Iterable.some(this,([g,r])=>r.asFile())&&b.push("files"),T(m(l),b)}get(l){return this.a.get(this.b(l))?.[0]}append(l,b){const g=this.a.get(l);g?g.push(b):this.a.set(this.b(l),[b])}replace(l,b){this.a.set(this.b(l),[b])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,b]of this.a)for(const g of b)yield[l,g]}b(l){return m(l)}}e.$Vt=w;function m(S){return S.toLowerCase()}function E(S,l){return T(m(S),l.map(m))}function T(S,l){if(S==="*/*")return l.length>0;if(l.includes(S))return!0;const b=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[g,r,s]=b;return s==="*"?l.some(o=>o.startsWith(r+"/")):!1}e.$Xt=Object.freeze({create:S=>(0,C.$Mb)(S.map(l=>l.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$Xt.split(S).filter(l=>!l.startsWith("#"))})}),define(Se[139],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$4t=O;var C;(function(M){M[M.Unknown=0]="Unknown",M[M.Invalid=3]="Invalid",M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(C||(e.StringEOL=C={}));function O(M){let N=0,R=0,w=0,m=0;for(let E=0,T=M.length;E<T;E++){const S=M.charCodeAt(E);S===13?(N===0&&(R=E),N++,E+1<T&&M.charCodeAt(E+1)===10?(m|=2,E++):m|=3,w=E+1):S===10&&(m|=1,N===0&&(R=E),N++,w=E+1)}return N===0&&(R=M.length),[N,R,M.length-w,m]}}),define(Se[140],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=void 0,e.$7s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[141],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=e.$nu=e.IndentAction=void 0;var C;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class O{constructor(w){if(this.e=null,this.f=!1,this.open=w.open,this.close=w.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(w.notIn))for(let m=0,E=w.notIn.length;m<E;m++)switch(w.notIn[m]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(w){switch(w){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(w,m){if(w.getTokenCount()===0)return!0;const E=w.findTokenIndexAtOffset(m-2),T=w.getStandardTokenType(E);return this.isOK(T)}g(w,m){for(let E=w;E<=m;E++){const T=String.fromCharCode(E);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$nu=O;class M{constructor(w){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const m of w)N(this.autoClosingPairsOpenByStart,m.open.charAt(0),m),N(this.autoClosingPairsOpenByEnd,m.open.charAt(m.open.length-1),m),N(this.autoClosingPairsCloseByStart,m.close.charAt(0),m),N(this.autoClosingPairsCloseByEnd,m.close.charAt(m.close.length-1),m),m.close.length===1&&m.open.length===1&&N(this.autoClosingPairsCloseSingleChar,m.close,m)}}e.$ou=M;function N(R,w,m){R.has(w)?R.get(w).push(m):R.set(w,[m])}}),define(Se[142],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=e.NodeColor=e.$IC=void 0,e.$KC=M,e.$LC=N,e.$MC=E,e.$NC=T,e.$OC=S,e.$PC=l,e.$QC=b,e.$RC=g;class C{constructor(s,o){this.piece=s,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$JC)return M(this.right);let s=this;for(;s.parent!==e.$JC&&s.parent.left!==s;)s=s.parent;return s.parent===e.$JC?e.$JC:s.parent}prev(){if(this.left!==e.$JC)return N(this.left);let s=this;for(;s.parent!==e.$JC&&s.parent.right!==s;)s=s.parent;return s.parent===e.$JC?e.$JC:s.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$IC=C;var O;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$JC=new C(null,0),e.$JC.parent=e.$JC,e.$JC.left=e.$JC,e.$JC.right=e.$JC,e.$JC.color=0;function M(r){for(;r.left!==e.$JC;)r=r.left;return r}function N(r){for(;r.right!==e.$JC;)r=r.right;return r}function R(r){return r===e.$JC?0:r.size_left+r.piece.length+R(r.right)}function w(r){return r===e.$JC?0:r.lf_left+r.piece.lineFeedCnt+w(r.right)}function m(){e.$JC.parent=e.$JC}function E(r,s){const o=s.right;o.size_left+=s.size_left+(s.piece?s.piece.length:0),o.lf_left+=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),s.right=o.left,o.left!==e.$JC&&(o.left.parent=s),o.parent=s.parent,s.parent===e.$JC?r.root=o:s.parent.left===s?s.parent.left=o:s.parent.right=o,o.left=s,s.parent=o}function T(r,s){const o=s.left;s.left=o.right,o.right!==e.$JC&&(o.right.parent=s),o.parent=s.parent,s.size_left-=o.size_left+(o.piece?o.piece.length:0),s.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),s.parent===e.$JC?r.root=o:s===s.parent.right?s.parent.right=o:s.parent.left=o,o.right=s,s.parent=o}function S(r,s){let o,i;if(s.left===e.$JC?(i=s,o=i.right):s.right===e.$JC?(i=s,o=i.left):(i=M(s.right),o=i.right),i===r.root){r.root=o,o.color=0,s.detach(),m(),r.root.parent=e.$JC;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===s?(o.parent=i.parent,g(r,o)):(i.parent===s?o.parent=i:o.parent=i.parent,g(r,o),i.left=s.left,i.right=s.right,i.parent=s.parent,i.color=s.color,s===r.root?r.root=i:s===s.parent.left?s.parent.left=i:s.parent.right=i,i.left!==e.$JC&&(i.left.parent=i),i.right!==e.$JC&&(i.right.parent=i),i.size_left=s.size_left,i.lf_left=s.lf_left,g(r,i)),s.detach(),o.parent.left===o){const u=R(o),t=w(o);if(u!==o.parent.size_left||t!==o.parent.lf_left){const f=u-o.parent.size_left,a=t-o.parent.lf_left;o.parent.size_left=u,o.parent.lf_left=t,b(r,o.parent,f,a)}}if(g(r,o.parent),n){m();return}let c;for(;o!==r.root&&o.color===0;)o===o.parent.left?(c=o.parent.right,c.color===1&&(c.color=0,o.parent.color=1,E(r,o.parent),c=o.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,o=o.parent):(c.right.color===0&&(c.left.color=0,c.color=1,T(r,c),c=o.parent.right),c.color=o.parent.color,o.parent.color=0,c.right.color=0,E(r,o.parent),o=r.root)):(c=o.parent.left,c.color===1&&(c.color=0,o.parent.color=1,T(r,o.parent),c=o.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,o=o.parent):(c.left.color===0&&(c.right.color=0,c.color=1,E(r,c),c=o.parent.left),c.color=o.parent.color,o.parent.color=0,c.left.color=0,T(r,o.parent),o=r.root));o.color=0,m()}function l(r,s){for(g(r,s);s!==r.root&&s.parent.color===1;)if(s.parent===s.parent.parent.left){const o=s.parent.parent.right;o.color===1?(s.parent.color=0,o.color=0,s.parent.parent.color=1,s=s.parent.parent):(s===s.parent.right&&(s=s.parent,E(r,s)),s.parent.color=0,s.parent.parent.color=1,T(r,s.parent.parent))}else{const o=s.parent.parent.left;o.color===1?(s.parent.color=0,o.color=0,s.parent.parent.color=1,s=s.parent.parent):(s===s.parent.left&&(s=s.parent,T(r,s)),s.parent.color=0,s.parent.parent.color=1,E(r,s.parent.parent))}r.root.color=0}function b(r,s,o,i){for(;s!==r.root&&s!==e.$JC;)s.parent.left===s&&(s.parent.size_left+=o,s.parent.lf_left+=i),s=s.parent}function g(r,s){let o=0,i=0;if(s!==r.root){for(;s!==r.root&&s===s.parent.right;)s=s.parent;if(s!==r.root)for(s=s.parent,o=R(s.left)-s.size_left,i=w(s.left)-s.lf_left,s.size_left+=o,s.lf_left+=i;s!==r.root&&(o!==0||i!==0);)s.parent.left===s&&(s.parent.size_left+=o,s.parent.lf_left+=i),s=s.parent}}}),define(Se[93],Ie([1,0,94,30,95,142,96]),function(le,e,C,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3C=e.$2C=e.$1C=void 0,e.$YC=T,e.$ZC=S;const w=65535;function m(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class E{constructor(i,n,c,u,t){this.lineStarts=i,this.cr=n,this.lf=c,this.crlf=u,this.isBasicASCII=t}}function T(o,i=!0){const n=[0];let c=1;for(let u=0,t=o.length;u<t;u++){const f=o.charCodeAt(u);f===13?u+1<t&&o.charCodeAt(u+1)===10?(n[c++]=u+2,u++):n[c++]=u+1:f===10&&(n[c++]=u+1)}return i?m(n):n}function S(o,i){o.length=0,o[0]=0;let n=1,c=0,u=0,t=0,f=!0;for(let d=0,$=i.length;d<$;d++){const p=i.charCodeAt(d);p===13?d+1<$&&i.charCodeAt(d+1)===10?(t++,o[n++]=d+2,d++):(c++,o[n++]=d+1):p===10?(u++,o[n++]=d+1):f&&p!==9&&(p<32||p>126)&&(f=!1)}const a=new E(m(o),c,u,t,f);return o.length=0,a}class l{constructor(i,n,c,u,t){this.bufferIndex=i,this.start=n,this.end=c,this.lineFeedCnt=u,this.length=t}}e.$1C=l;class b{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$2C=b;class g{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==N.$JC&&i.iterate(i.root,c=>(c!==N.$JC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartOffset<=i&&c.nodeStartOffset+c.node.piece.length>=i)return c}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<i&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=i)return c}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const c=this.b;for(let u=0;u<c.length;u++){const t=c[u];if(t.node.parent===null||t.nodeStartOffset>=i){c[u]=null,n=!0;continue}}if(n){const u=[];for(const t of c)t!==null&&u.push(t);this.b=u}}}class s{constructor(i,n,c){this.create(i,n,c)}create(i,n,c){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=N.$JC,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=c;let u=null;for(let t=0,f=i.length;t<f;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=T(i[t].buffer));const a=new l(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),u=this.S(u,a)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=w,c=n-Math.floor(n/3),u=c*2;let t="",f=0;const a=[];if(this.iterate(this.root,d=>{const $=this.R(d),p=$.length;if(f<=c||f+p<u)return t+=$,f+=p,!0;const v=t.replace(/\r\n|\r|\n/g,i);return a.push(new b(v,T(v))),t=$,f=p,!0}),f>0){const d=t.replace(/\r\n|\r|\n/g,i);a.push(new b(d,T(d)))}this.create(a,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new g(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,u=>{if(u===N.$JC)return!0;const t=this.R(u),f=t.length,a=i.G(n),d=i.G(n+f),$=i.getValueInRange2(a,d);return n+=f,t===$})}getOffsetAt(i,n){let c=0,u=this.root;for(;u!==N.$JC;)if(u.left!==N.$JC&&u.lf_left+1>=i)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt+1>=i){c+=u.size_left;const t=this.B(u,i-u.lf_left-2);return c+=t+n-1}else i-=u.lf_left+u.piece.lineFeedCnt,c+=u.size_left+u.piece.length,u=u.right;return c}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,c=0;const u=i;for(;n!==N.$JC;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(c+=n.lf_left+t.index,t.index===0){const f=this.getOffsetAt(c+1,1),a=u-f;return new C.$wt(c+1,a+1)}return new C.$wt(c+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,c+=n.lf_left+n.piece.lineFeedCnt,n.right===N.$JC){const t=this.getOffsetAt(c+1,1),f=u-i-t;return new C.$wt(c+1,f+1)}else n=n.right;return new C.$wt(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const c=this.H(i.startLineNumber,i.startColumn),u=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(c,u);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const a=i.node,d=this.a[a.piece.bufferIndex].buffer,$=this.u(a.piece.bufferIndex,a.piece.start);return d.substring($+i.remainder,$+n.remainder)}let c=i.node;const u=this.a[c.piece.bufferIndex].buffer,t=this.u(c.piece.bufferIndex,c.piece.start);let f=u.substring(t+i.remainder,t+c.piece.length);for(c=c.next();c!==N.$JC;){const a=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(c===n.node){f+=a.substring(d,d+n.remainder);break}else f+=a.substr(d,c.piece.length);c=c.next()}return f}getLinesContent(){const i=[];let n=0,c="",u=!1;return this.iterate(this.root,t=>{if(t===N.$JC)return!0;const f=t.piece;let a=f.length;if(a===0)return!0;const d=this.a[f.bufferIndex].buffer,$=this.a[f.bufferIndex].lineStarts,p=f.start.line,v=f.end.line;let y=$[p]+f.start.column;if(u&&(d.charCodeAt(y)===10&&(y++,a--),i[n++]=c,c="",u=!1,a===0))return!0;if(p===v)return!this.f&&d.charCodeAt(y+a-1)===13?(u=!0,c+=d.substr(y,a-1)):c+=d.substr(y,a),!0;c+=this.f?d.substring(y,Math.max(y,$[p+1]-this.e)):d.substring(y,$[p+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=c;for(let h=p+1;h<v;h++)c=this.f?d.substring($[h],$[h+1]-this.e):d.substring($[h],$[h+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=c;return!this.f&&d.charCodeAt($[v]+f.end.column-1)===13?(u=!0,f.end.column===0?n--:c=d.substr($[v],f.end.column-1)):c=d.substr($[v],f.end.column),!0}),u&&(i[n++]=c,c=""),i[n++]=c,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const c=this.a[n.piece.bufferIndex],u=this.u(n.piece.bufferIndex,n.piece.start);return c.buffer.charCodeAt(u)}else{const n=this.a[i.node.piece.bufferIndex],u=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(u)}}getLineCharCode(i,n){const c=this.H(i,n+1);return this.l(c)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,c,u,t,f,a,d,$,p,v){const y=this.a[i.piece.bufferIndex],h=this.u(i.piece.bufferIndex,i.piece.start),D=this.u(i.piece.bufferIndex,t),k=this.u(i.piece.bufferIndex,f);let I;const P={line:0,column:0};let V,W;n._wordSeparators?(V=y.buffer.substring(D,k),W=q=>q+D,n.reset(0)):(V=y.buffer,W=q=>q,n.reset(D));do if(I=n.next(V),I){if(W(I.index)>=k)return p;this.s(i,W(I.index)-h,P);const q=this.t(i.piece.bufferIndex,t,P),A=P.line===t.line?P.column-t.column+u:P.column+1,z=A+I[0].length;if(v[p++]=(0,R.$UC)(new O.$xt(c+q,A,c+q,z),I,d),W(I.index)+I[0].length>=k||p>=$)return p}while(I);return p}findMatchesLineByLine(i,n,c,u){const t=[];let f=0;const a=new R.$XC(n.wordSeparators,n.regex);let d=this.H(i.startLineNumber,i.startColumn);if(d===null)return[];const $=this.H(i.endLineNumber,i.endColumn);if($===null)return[];let p=this.s(d.node,d.remainder);const v=this.s($.node,$.remainder);if(d.node===$.node)return this.findMatchesInNode(d.node,a,i.startLineNumber,i.startColumn,p,v,n,c,u,f,t),t;let y=i.startLineNumber,h=d.node;for(;h!==$.node;){const k=this.t(h.piece.bufferIndex,p,h.piece.end);if(k>=1){const P=this.a[h.piece.bufferIndex].lineStarts,V=this.u(h.piece.bufferIndex,h.piece.start),W=P[p.line+k],q=y===i.startLineNumber?i.startColumn:1;if(f=this.findMatchesInNode(h,a,y,q,p,this.s(h,W-V),n,c,u,f,t),f>=u)return t;y+=k}const I=y===i.startLineNumber?i.startColumn-1:0;if(y===i.endLineNumber){const P=this.getLineContent(y).substring(I,i.endColumn-1);return f=this.n(n,a,P,i.endLineNumber,I,f,t,c,u),t}if(f=this.n(n,a,this.getLineContent(y).substr(I),y,I,f,t,c,u),f>=u)return t;y++,d=this.H(y,1),h=d.node,p=this.s(d.node,d.remainder)}if(y===i.endLineNumber){const k=y===i.startLineNumber?i.startColumn-1:0,I=this.getLineContent(y).substring(k,i.endColumn-1);return f=this.n(n,a,I,i.endLineNumber,k,f,t,c,u),t}const D=y===i.startLineNumber?i.startColumn:1;return f=this.findMatchesInNode($.node,a,y,D,p,v,n,c,u,f,t),t}n(i,n,c,u,t,f,a,d,$){const p=i.wordSeparators;if(!d&&i.simpleSearch){const y=i.simpleSearch,h=y.length,D=c.length;let k=-h;for(;(k=c.indexOf(y,k+h))!==-1;)if((!p||(0,R.$WC)(p,c,D,k,h))&&(a[f++]=new M.$Iv(new O.$xt(u,k+1+t,u,k+1+h+t),null),f>=$))return f;return f}let v;n.reset(0);do if(v=n.next(c),v&&(a[f++]=(0,R.$UC)(new O.$xt(u,v.index+1+t,u,v.index+1+v[0].length+t),v,d),f>=$))return f;while(v);return f}insert(i,n,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==N.$JC){const{node:u,remainder:t,nodeStartOffset:f}=this.G(i),a=u.piece,d=a.bufferIndex,$=this.s(u,t);if(u.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&f+a.length===i&&n.length<w){this.F(u,n),this.y();return}if(f===i)this.o(n,u),this.h.validate(i);else if(f+u.piece.length>i){const p=[];let v=new l(a.bufferIndex,$,a.end,this.t(a.bufferIndex,$,a.end),this.u(d,a.end)-this.u(d,$));if(this.K()&&this.M(n)&&this.I(u,t)===10){const k={line:v.start.line+1,column:0};v=new l(v.bufferIndex,k,v.end,this.t(v.bufferIndex,k,v.end),v.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(u,t-1)===13){const k=this.s(u,t-1);this.C(u,k),n="\r"+n,u.piece.length===0&&p.push(u)}else this.C(u,$);else this.C(u,$);const y=this.w(n);v.length>0&&this.S(u,v);let h=u;for(let D=0;D<y.length;D++)h=this.S(h,y[D]);this.v(p)}else this.q(n,u)}else{const u=this.w(n);let t=this.T(null,u[0]);for(let f=1;f<u.length;f++)t=this.S(t,u[f])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===N.$JC)return;const c=this.G(i),u=this.G(i+n),t=c.node,f=u.node;if(t===f){const y=this.s(t,c.remainder),h=this.s(t,u.remainder);if(c.nodeStartOffset===i){if(n===t.piece.length){const D=t.next();(0,N.$OC)(this,t),this.N(D),this.y();return}this.D(t,h),this.h.validate(i),this.N(t),this.y();return}if(c.nodeStartOffset+t.piece.length===i+n){this.C(t,y),this.O(t),this.y();return}this.E(t,y,h),this.y();return}const a=[],d=this.s(t,c.remainder);this.C(t,d),this.h.validate(i),t.piece.length===0&&a.push(t);const $=this.s(f,u.remainder);this.D(f,$),f.piece.length===0&&a.push(f);const p=t.next();for(let y=p;y!==N.$JC&&y!==f;y=y.next())a.push(y);const v=t.piece.length===0?t.prev():t;this.v(a),this.O(v),this.y()}o(i,n){const c=[];if(this.K()&&this.M(i)&&this.L(n)){const f=n.piece,a={line:f.start.line+1,column:0},d=new l(f.bufferIndex,a,f.end,this.t(f.bufferIndex,a,f.end),f.length-1);n.piece=d,i+=`
`,(0,N.$QC)(this,n,-1,-1),n.piece.length===0&&c.push(n)}const u=this.w(i);let t=this.T(n,u[u.length-1]);for(let f=u.length-2;f>=0;f--)t=this.T(t,u[f]);this.N(t),this.v(c)}q(i,n){this.Q(i,n)&&(i+=`
`);const c=this.w(i),u=this.S(n,c[0]);let t=u;for(let f=1;f<c.length;f++)t=this.S(t,c[f]);this.N(u)}s(i,n,c){const u=i.piece,t=i.piece.bufferIndex,f=this.a[t].lineStarts,d=f[u.start.line]+u.start.column+n;let $=u.start.line,p=u.end.line,v=0,y=0,h=0;for(;$<=p&&(v=$+(p-$)/2|0,h=f[v],v!==p);)if(y=f[v+1],d<h)p=v-1;else if(d>=y)$=v+1;else break;return c?(c.line=v,c.column=d-h,null):{line:v,column:d-h}}t(i,n,c){if(c.column===0)return c.line-n.line;const u=this.a[i].lineStarts;if(c.line===u.length-1)return c.line-n.line;const t=u[c.line+1],f=u[c.line]+c.column;if(t>f+1)return c.line-n.line;const a=f-1;return this.a[i].buffer.charCodeAt(a)===13?c.line-n.line+1:c.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,N.$OC)(this,i[n])}w(i){if(i.length>w){const p=[];for(;i.length>w;){const y=i.charCodeAt(w-1);let h;y===13||y>=55296&&y<=56319?(h=i.substring(0,w-1),i=i.substring(w-1)):(h=i.substring(0,w),i=i.substring(w));const D=T(h);p.push(new l(this.a.length,{line:0,column:0},{line:D.length-1,column:h.length-D[D.length-1]},D.length-1,h.length)),this.a.push(new b(h,D))}const v=T(i);return p.push(new l(this.a.length,{line:0,column:0},{line:v.length-1,column:i.length-v[v.length-1]},v.length-1,i.length)),this.a.push(new b(i,v)),p}let n=this.a[0].buffer.length;const c=T(i,!1);let u=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},u=this.g;for(let p=0;p<c.length;p++)c[p]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let p=0;p<c.length;p++)c[p]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,a=t-this.a[0].lineStarts[f],d={line:f,column:a},$=new l(0,u,d,this.t(0,u,d),t-n);return this.g=d,[$]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let c=this.root,u="";const t=this.h.get2(i);if(t){c=t.node;const f=this.B(c,i-t.nodeStartLineNumber-1),a=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===i)u=a.substring(d+f,d+c.piece.length);else{const $=this.B(c,i-t.nodeStartLineNumber);return a.substring(d+f,d+$-n)}}else{let f=0;const a=i;for(;c!==N.$JC;)if(c.left!==N.$JC&&c.lf_left>=i-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>i-1){const d=this.B(c,i-c.lf_left-2),$=this.B(c,i-c.lf_left-1),p=this.a[c.piece.bufferIndex].buffer,v=this.u(c.piece.bufferIndex,c.piece.start);return f+=c.size_left,this.h.set({node:c,nodeStartOffset:f,nodeStartLineNumber:a-(i-1-c.lf_left)}),p.substring(v+d,v+$-n)}else if(c.lf_left+c.piece.lineFeedCnt===i-1){const d=this.B(c,i-c.lf_left-2),$=this.a[c.piece.bufferIndex].buffer,p=this.u(c.piece.bufferIndex,c.piece.start);u=$.substring(p+d,p+c.piece.length);break}else i-=c.lf_left+c.piece.lineFeedCnt,f+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==N.$JC;){const f=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const a=this.B(c,0),d=this.u(c.piece.bufferIndex,c.piece.start);return u+=f.substring(d,d+a-n),u}else{const a=this.u(c.piece.bufferIndex,c.piece.start);u+=f.substr(a,c.piece.length)}c=c.next()}return u}y(){let i=this.root,n=1,c=0;for(;i!==N.$JC;)n+=i.lf_left+i.piece.lineFeedCnt,c+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=c,this.h.validate(this.c)}A(i,n){const c=i.piece,u=this.s(i,n),t=u.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===n){const f=this.t(i.piece.bufferIndex,c.start,u);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:u.column}}B(i,n){if(n<0)return 0;const c=i.piece,u=this.a[c.bufferIndex].lineStarts,t=c.start.line+n+1;return t>c.end.line?u[c.end.line]+c.end.column-u[c.start.line]-c.start.column:u[t]-u[c.start.line]-c.start.column}C(i,n){const c=i.piece,u=c.lineFeedCnt,t=this.u(c.bufferIndex,c.end),f=n,a=this.u(c.bufferIndex,f),d=this.t(c.bufferIndex,c.start,f),$=d-u,p=a-t,v=c.length+p;i.piece=new l(c.bufferIndex,c.start,f,d,v),(0,N.$QC)(this,i,p,$)}D(i,n){const c=i.piece,u=c.lineFeedCnt,t=this.u(c.bufferIndex,c.start),f=n,a=this.t(c.bufferIndex,f,c.end),d=this.u(c.bufferIndex,f),$=a-u,p=t-d,v=c.length+p;i.piece=new l(c.bufferIndex,f,c.end,a,v),(0,N.$QC)(this,i,p,$)}E(i,n,c){const u=i.piece,t=u.start,f=u.end,a=u.length,d=u.lineFeedCnt,$=n,p=this.t(u.bufferIndex,u.start,$),v=this.u(u.bufferIndex,n)-this.u(u.bufferIndex,t);i.piece=new l(u.bufferIndex,u.start,$,p,v),(0,N.$QC)(this,i,v-a,p-d);const y=new l(u.bufferIndex,c,f,this.t(u.bufferIndex,c,f),this.u(u.bufferIndex,f)-this.u(u.bufferIndex,c)),h=this.S(i,y);this.N(h)}F(i,n){this.Q(n,i)&&(n+=`
`);const c=this.K()&&this.L(n)&&this.M(i),u=this.a[0].buffer.length;this.a[0].buffer+=n;const t=T(n,!1);for(let h=0;h<t.length;h++)t[h]+=u;if(c){const h=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:u-h}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const f=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[f],d={line:f,column:a},$=i.piece.length+n.length,p=i.piece.lineFeedCnt,v=this.t(0,i.piece.start,d),y=v-p;i.piece=new l(i.piece.bufferIndex,i.piece.start,d,v,$),this.g=d,(0,N.$QC)(this,i,n.length,y)}G(i){let n=this.root;const c=this.h.get(i);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:i-c.nodeStartOffset};let u=0;for(;n!==N.$JC;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){u+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:u};return this.h.set(t),t}else i-=n.size_left+n.piece.length,u+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let c=this.root,u=0;for(;c!==N.$JC;)if(c.left!==N.$JC&&c.lf_left>=i-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>i-1){const t=this.B(c,i-c.lf_left-2),f=this.B(c,i-c.lf_left-1);return u+=c.size_left,{node:c,remainder:Math.min(t+n-1,f),nodeStartOffset:u}}else if(c.lf_left+c.piece.lineFeedCnt===i-1){const t=this.B(c,i-c.lf_left-2);if(t+n-1<=c.piece.length)return{node:c,remainder:t+n-1,nodeStartOffset:u};n-=c.piece.length-t;break}else i-=c.lf_left+c.piece.lineFeedCnt,u+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==N.$JC;){if(c.piece.lineFeedCnt>0){const t=this.B(c,0),f=this.J(c);return{node:c,remainder:Math.min(n-1,t),nodeStartOffset:f}}else if(c.piece.length>=n-1){const t=this.J(c);return{node:c,remainder:n-1,nodeStartOffset:t}}else n-=c.piece.length;c=c.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const c=this.a[i.piece.bufferIndex],u=this.u(i.piece.bufferIndex,i.piece.start)+n;return c.buffer.charCodeAt(u)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===N.$JC||i.piece.lineFeedCnt===0)return!1;const n=i.piece,c=this.a[n.bufferIndex].lineStarts,u=n.start.line,t=c[u]+n.start.column;return u===c.length-1||c[u+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===N.$JC||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const c=[],u=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:u[i.piece.end.line]-u[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const f=i.piece.length-1,a=i.piece.lineFeedCnt-1;i.piece=new l(i.piece.bufferIndex,i.piece.start,t,a,f),(0,N.$QC)(this,i,-1,-1),i.piece.length===0&&c.push(i);const d={line:n.piece.start.line+1,column:0},$=n.piece.length-1,p=this.t(n.piece.bufferIndex,d,n.piece.end);n.piece=new l(n.piece.bufferIndex,d,n.piece.end,p,$),(0,N.$QC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const v=this.w(`\r
`);this.S(i,v[0]);for(let y=0;y<c.length;y++)(0,N.$OC)(this,c[y])}Q(i,n){if(this.K()&&this.M(i)){const c=n.next();if(this.L(c)){if(i+=`
`,c.piece.length===1)(0,N.$OC)(this,c);else{const u=c.piece,t={line:u.start.line+1,column:0},f=u.length-1,a=this.t(u.bufferIndex,t,u.end);c.piece=new l(u.bufferIndex,t,u.end,a,f),(0,N.$QC)(this,c,-1,-1)}return!0}}return!1}iterate(i,n){if(i===N.$JC)return n(N.$JC);const c=this.iterate(i.left,n);return c&&n(i)&&this.iterate(i.right,n)}R(i){if(i===N.$JC)return"";const n=this.a[i.piece.bufferIndex],c=i.piece,u=this.u(c.bufferIndex,c.start),t=this.u(c.bufferIndex,c.end);return n.buffer.substring(u,t)}getPieceContent(i){const n=this.a[i.bufferIndex],c=this.u(i.bufferIndex,i.start),u=this.u(i.bufferIndex,i.end);return n.buffer.substring(c,u)}S(i,n){const c=new N.$IC(n,1);if(c.left=N.$JC,c.right=N.$JC,c.parent=N.$JC,c.size_left=0,c.lf_left=0,this.root===N.$JC)this.root=c,c.color=0;else if(i.right===N.$JC)i.right=c,c.parent=i;else{const t=(0,N.$KC)(i.right);t.left=c,c.parent=t}return(0,N.$PC)(this,c),c}T(i,n){const c=new N.$IC(n,1);if(c.left=N.$JC,c.right=N.$JC,c.parent=N.$JC,c.size_left=0,c.lf_left=0,this.root===N.$JC)this.root=c,c.color=0;else if(i.left===N.$JC)i.left=c,c.parent=i;else{const u=(0,N.$LC)(i.left);u.right=c,c.parent=u}return(0,N.$PC)(this,c),c}U(i){let n="";return this.iterate(i,c=>(n+=this.R(c),!0)),n}}e.$3C=s}),define(Se[143],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K0=e.$J0=void 0;class C{constructor(){this.a=new Map}removeDragOperationTransfer(N){if(N&&this.a.has(N)){const R=this.a.get(N);return this.a.delete(N),R}}addDragOperationTransfer(N,R){this.a.set(N,R)}}e.$J0=C;class O{constructor(N){this.identifier=N}}e.$K0=O}),define(Se[144],Ie([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(Se[145],Ie([1,0,5,6,144]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=void 0,e.$ij=T;class N extends O.$Uc{constructor(l,b="",g="",r=!0,s){super(),this.h=this.B(new C.$fe),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=b,this.u=g,this.w=r,this.C=s}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,b){this.C&&await this.C(l)}}e.$dj=N;class R extends O.$Uc{constructor(){super(...arguments),this.f=this.B(new C.$fe),this.onWillRun=this.f.event,this.m=this.B(new C.$fe),this.onDidRun=this.m.event}async run(l,b){if(!l.enabled)return;this.f.fire({action:l});let g;try{await this.u(l,b)}catch(r){g=r}this.m.fire({action:l,error:g})}async u(l,b){await l.run(b)}}e.$ej=R;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let b=[];for(const g of l)g.length&&(b.length?b=[...b,new w,...g]:b=g);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$fj=w;class m{get actions(){return this.a}constructor(l,b,g,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=b,this.class=r,this.a=g}async run(){}}e.$gj=m;class E extends N{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,M.localize(0,null),void 0,!1)}}e.$hj=E;function T(S){return{id:S.id,label:S.label,class:S.class,enabled:S.enabled??!0,checked:S.checked,run:async(...l)=>S.run(...l),tooltip:S.label}}}),define(Se[146],Ie([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(Se[147],Ie([1,0,146]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=E,e.$5m=T,e.$6m=S;const O=60,M=O*60,N=M*24,R=N*7,w=N*30,m=N*365;function E(l,b,g,r){typeof l!="number"&&(l=l.getTime());const s=Math.round((new Date().getTime()-l)/1e3);if(s<-30)return(0,C.localize)(0,null,E(new Date().getTime()+s*1e3,!1));if(!r&&s<30)return(0,C.localize)(1,null);let o;return s<O?(o=s,b?o===1?g?(0,C.localize)(2,null,o):(0,C.localize)(3,null,o):g?(0,C.localize)(4,null,o):(0,C.localize)(5,null,o):o===1?g?(0,C.localize)(6,null,o):(0,C.localize)(7,null,o):g?(0,C.localize)(8,null,o):(0,C.localize)(9,null,o)):s<M?(o=Math.floor(s/O),b?o===1?g?(0,C.localize)(10,null,o):(0,C.localize)(11,null,o):g?(0,C.localize)(12,null,o):(0,C.localize)(13,null,o):o===1?g?(0,C.localize)(14,null,o):(0,C.localize)(15,null,o):g?(0,C.localize)(16,null,o):(0,C.localize)(17,null,o)):s<N?(o=Math.floor(s/M),b?o===1?g?(0,C.localize)(18,null,o):(0,C.localize)(19,null,o):g?(0,C.localize)(20,null,o):(0,C.localize)(21,null,o):o===1?g?(0,C.localize)(22,null,o):(0,C.localize)(23,null,o):g?(0,C.localize)(24,null,o):(0,C.localize)(25,null,o)):s<R?(o=Math.floor(s/N),b?o===1?(0,C.localize)(26,null,o):(0,C.localize)(27,null,o):o===1?(0,C.localize)(28,null,o):(0,C.localize)(29,null,o)):s<w?(o=Math.floor(s/R),b?o===1?g?(0,C.localize)(30,null,o):(0,C.localize)(31,null,o):g?(0,C.localize)(32,null,o):(0,C.localize)(33,null,o):o===1?g?(0,C.localize)(34,null,o):(0,C.localize)(35,null,o):g?(0,C.localize)(36,null,o):(0,C.localize)(37,null,o)):s<m?(o=Math.floor(s/w),b?o===1?g?(0,C.localize)(38,null,o):(0,C.localize)(39,null,o):g?(0,C.localize)(40,null,o):(0,C.localize)(41,null,o):o===1?g?(0,C.localize)(42,null,o):(0,C.localize)(43,null,o):g?(0,C.localize)(44,null,o):(0,C.localize)(45,null,o)):(o=Math.floor(s/m),b?o===1?g?(0,C.localize)(46,null,o):(0,C.localize)(47,null,o):g?(0,C.localize)(48,null,o):(0,C.localize)(49,null,o):o===1?g?(0,C.localize)(50,null,o):(0,C.localize)(51,null,o):g?(0,C.localize)(52,null,o):(0,C.localize)(53,null,o))}function T(l,b){const g=Math.abs(l/1e3);return g<1?b?(0,C.localize)(54,null,l):(0,C.localize)(55,null,l):g<O?b?(0,C.localize)(56,null,Math.round(l)/1e3):(0,C.localize)(57,null,Math.round(l)/1e3):g<M?b?(0,C.localize)(58,null,Math.round(l/(1e3*O))):(0,C.localize)(59,null,Math.round(l/(1e3*O))):g<N?b?(0,C.localize)(60,null,Math.round(l/(1e3*M))):(0,C.localize)(61,null,Math.round(l/(1e3*M))):(0,C.localize)(62,null,Math.round(l/(1e3*N)))}function S(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Se[148],Ie([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(Se[44],Ie([1,0,18,15,148]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=m,e.$kj=E,e.$lj=T;function N(S,l){return l&&(S.stack||S.stacktrace)?M.localize(0,null,w(S),R(S.stack)||R(S.stacktrace)):w(S)}function R(S){return Array.isArray(S)?S.join(`
`):S}function w(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?M.localize(1,null,S.message):S.message||M.localize(2,null)}function m(S=null,l=!1){if(!S)return M.localize(3,null);if(Array.isArray(S)){const b=C.$Hb(S),g=m(b[0],l);return b.length>1?M.localize(4,null,g,b.length):g}if(O.$$f(S))return S;if(S.detail){const b=S.detail;if(b.error)return N(b.error,l);if(b.exception)return N(b.exception,l)}return S.stack?N(S,l):S.message?S.message:M.localize(5,null)}function E(S){const l=S;return l instanceof Error&&Array.isArray(l.actions)}function T(S,l){let b;return typeof S=="string"?b=new Error(S):b=S,b.actions=l,b}}),define(Se[149],Ie([1,0,43,19]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=w,e.$kr=m,e.$lr=E,e.$mr=T,e.$nr=S,e.$or=l,e.$pr=b,e.$qr=g,e.$rr=r,e.$sr=s,e.$tr=$,e.$ur=p,e.$vr=v;const M=new C.$V(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),N=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function w(y,h,D=!1){const k=y||"",I=h||"",P=M.value.collator.compare(k,I);return M.value.collatorIsNumeric&&P===0&&k!==I?k<I?-1:1:P}function m(y,h){const D=N.value.collator;return y=y||"",h=h||"",c(D,y,h)}function E(y,h){const D=N.value.collator;return y=y||"",h=h||"",a(y,h)||c(D,y,h)}function T(y,h){const D=N.value.collator;return y=y||"",h=h||"",f(y,h)||c(D,y,h)}function S(y,h){return y=y||"",h=h||"",y===h?0:y<h?-1:1}function l(y,h){const[D,k]=i(y),[I,P]=i(h);let V=M.value.collator.compare(k,P);if(V===0){if(M.value.collatorIsNumeric&&k!==P)return k<P?-1:1;if(V=M.value.collator.compare(D,I),M.value.collatorIsNumeric&&V===0&&D!==I)return D<I?-1:1}return V}function b(y,h){y=y||"",h=h||"";const D=n(y),k=n(h),I=N.value.collator,P=R.value.collator;return c(P,D,k)||c(I,y,h)}function g(y,h){y=y||"",h=h||"";const D=n(y),k=n(h),I=N.value.collator,P=R.value.collator;return c(P,D,k)||a(y,h)||c(I,y,h)}function r(y,h){y=y||"",h=h||"";const D=n(y),k=n(h),I=N.value.collator,P=R.value.collator;return c(P,D,k)||f(y,h)||c(I,y,h)}function s(y,h){y=y||"",h=h||"";const D=n(y).toLowerCase(),k=n(h).toLowerCase();return D!==k?D<k?-1:1:y!==h?y<h?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function i(y,h=!1){const D=y?o.exec(y):[];let k=[D&&D[1]||"",D&&D[3]||""];return h&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function n(y){const h=y?o.exec(y):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function c(y,h,D){const k=y.compare(h,D);return k!==0?k:h.length!==D.length?h.length<D.length?-1:1:0}function u(y){const h=y.charAt(0);return h.toLocaleUpperCase()!==h}function t(y){const h=y.charAt(0);return h.toLocaleLowerCase()!==h}function f(y,h){return u(y)&&t(h)?-1:t(y)&&u(h)?1:0}function a(y,h){return t(y)&&u(h)?-1:u(y)&&t(h)?1:0}function d(y,h,D=!1){return D||(y=y&&y.toLowerCase(),h=h&&h.toLowerCase()),y===h?0:y<h?-1:1}function $(y,h,D=!1){const k=y.split(O.sep),I=h.split(O.sep),P=k.length-1,V=I.length-1;let W,q;for(let A=0;;A++){if(W=P===A,q=V===A,W&&q)return w(k[A],I[A],D);if(W)return-1;if(q)return 1;const z=d(k[A],I[A],D);if(z!==0)return z}}function p(y,h,D){const k=y.toLowerCase(),I=h.toLowerCase(),P=v(y,h,D);if(P)return P;const V=k.endsWith(D),W=I.endsWith(D);if(V!==W)return V?-1:1;const q=w(k,I);return q!==0?q:k.localeCompare(I)}function v(y,h,D){const k=y.toLowerCase(),I=h.toLowerCase(),P=k.startsWith(D),V=I.startsWith(D);if(P!==V)return P?-1:1;if(P&&V){if(k.length<I.length)return-1;if(k.length>I.length)return 1}return 0}}),define(Se[48],Ie([1,0,19,23,13,15]),function(le,e,C,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=R,e.$rg=w,e.$sg=m,e.$tg=E,e.$ug=T,e.$vg=g,e.$wg=r,e.$xg=s,e.$yg=o,e.$zg=i,e.$Ag=n,e.$Bg=c,e.$Cg=u,e.$Dg=t,e.$Eg=f,e.$Fg=a,e.$Gg=p;function R(v){return v===47||v===92}function w(v){return v.replace(/[\\/]/g,C.$gc.sep)}function m(v){return v.indexOf("/")===-1&&(v=w(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}function E(v,y=C.$gc.sep){if(!v)return"";const h=v.length,D=v.charCodeAt(0);if(R(D)){if(R(v.charCodeAt(1))&&!R(v.charCodeAt(2))){let I=3;const P=I;for(;I<h&&!R(v.charCodeAt(I));I++);if(P!==I&&!R(v.charCodeAt(I+1))){for(I+=1;I<h;I++)if(R(v.charCodeAt(I)))return v.slice(0,I+1).replace(/[\\/]/g,y)}}return y}else if(o(D)&&v.charCodeAt(1)===58)return R(v.charCodeAt(2))?v.slice(0,2)+y:v.slice(0,2);let k=v.indexOf("://");if(k!==-1){for(k+=3;k<h;k++)if(R(v.charCodeAt(k)))return v.slice(0,k+1)}return""}function T(v){if(!O.$i||!v||v.length<5)return!1;let y=v.charCodeAt(0);if(y!==92||(y=v.charCodeAt(1),y!==92))return!1;let h=2;const D=h;for(;h<v.length&&(y=v.charCodeAt(h),y!==92);h++);return!(D===h||(y=v.charCodeAt(h+1),isNaN(y)||y===92))}const S=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(v,y=O.$i){const h=y?S:l;return!(!v||v.length===0||/^\s+$/.test(v)||(h.lastIndex=0,h.test(v))||y&&b.test(v)||v==="."||v===".."||y&&v[v.length-1]==="."||y&&v.length!==v.trim().length||v.length>255)}function r(v,y,h){const D=v===y;return!h||D?D:!v||!y?!1:(0,M.$zf)(v,y)}function s(v,y,h,D=C.sep){if(v===y)return!0;if(!v||!y||y.length>v.length)return!1;if(h){if(!(0,M.$Af)(v,y))return!1;if(y.length===v.length)return!0;let I=y.length;return y.charAt(y.length-1)===D&&I--,v.charAt(I)===D}return y.charAt(y.length-1)!==D&&(y+=D),v.indexOf(y)===0}function o(v){return v>=65&&v<=90||v>=97&&v<=122}function i(v,y){return O.$i&&v.endsWith(":")&&(v+=C.sep),(0,C.$ic)(v)||(v=(0,C.$jc)(y,v)),v=(0,C.$hc)(v),n(v)}function n(v){return O.$i?(v=(0,M.$hf)(v,C.sep),v.endsWith(":")&&(v+=C.sep)):(v=(0,M.$hf)(v,C.sep),v||(v=C.sep)),v}function c(v){const y=(0,C.$hc)(v);return O.$i?v.length>3?!1:u(y)&&(v.length===2||y.charCodeAt(2)===92):y===C.$gc.sep}function u(v,y=O.$i){return y?o(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}function t(v,y=O.$i){return u(v,y)?v[0]:void 0}function f(v,y,h){return y.length>v.length?-1:v===y?0:(h&&(v=v.toLowerCase(),y=y.toLowerCase()),v.indexOf(y))}function a(v){const y=v.split(":");let h,D,k;for(const I of y){const P=Number(I);(0,N.$cg)(P)?D===void 0?D=P:k===void 0&&(k=P):h=h?[h,I].join(":"):I}if(!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:D!==void 0?D:void 0,column:k!==void 0?k:D!==void 0?1:void 0}}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",$="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function p(v,y,h=8){let D="";for(let I=0;I<h;I++){let P;I===0&&O.$i&&!y&&(h===3||h===4)?P=$:P=d,D+=P.charAt(Math.floor(Math.random()*P.length))}let k;return y?k=`${y}-${D}`:k=D,v?(0,C.$jc)(v,k):k}}),define(Se[70],Ie([1,0,19]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0,e.$Us=N,e.$Vs=R,e.$Ws=w,e.$Xs=E,e.$Ts=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},M={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(T){const S=(0,C.$oc)(T),l=O[S.toLowerCase()];return l!==void 0?l:R(T)}function R(T){const S=(0,C.$oc)(T);return M[S.toLowerCase()]}function w(T){for(const S in M)if(M[S]===T)return S}const m=/^(.+)\/(.+?)(;.+)?$/;function E(T,S){const l=m.exec(T);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:S?void 0:T}}),define(Se[49],Ie([1,0,22,2]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=M,e.$7h=N,e.$8h=w;function M(m){return JSON.stringify(m,R)}function N(m){let E=JSON.parse(m);return E=w(E),E}function R(m,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function w(m,E=0){if(!m||E>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return O.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof C.$He||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let T=0;T<m.length;++T)m[T]=w(m[T],E+1);else for(const T in m)Object.hasOwnProperty.call(m,T)&&(m[T]=w(m[T],E+1))}return m}}),define(Se[16],Ie([1,0,14,23,13,2,19]),function(le,e,C,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Lg=e.$Kg=e.$Jg=e.Schemas=void 0,e.$Hg=m,e.$Ig=E,e.$Mg=S;var w;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatCodeBlock="vscode-chat-code-block",g.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm",g.commentsInput="comment",g.codeSetting="code-setting"})(w||(e.Schemas=w={}));function m(g,r){return N.URI.isUri(g)?(0,M.$zf)(g.scheme,r):(0,M.$Af)(g,r+":")}function E(g,...r){return r.some(s=>m(g,s))}e.$Jg="vscode-tkn",e.$Kg="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,s){this.f=S(r,s)}getServerRootPath(){return this.f}get g(){return R.$gc.join(this.f,w.vscodeRemoteResource)}set(r,s,o){this.a[r]=s,this.b[r]=o}setConnectionToken(r,s){this.c[r]=s}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(u){return C.$1(u),r}const s=r.authority;let o=this.a[s];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const i=this.b[s],n=this.c[s];let c=`path=${encodeURIComponent(r.path)}`;return typeof n=="string"&&(c+=`&${e.$Kg}=${encodeURIComponent(n)}`),N.URI.from({scheme:O.$o?this.d:w.vscodeRemoteResource,authority:`${o}:${i}`,path:this.g,query:c})}}e.$Lg=new T;function S(g,r){return R.$gc.join(r??"/",`${g.quality??"oss"}-${g.commit??"dev"}`)}e.$Ng="vs/../../extensions",e.$Og="vs/../../node_modules",e.$Pg="vs/../../node_modules.asar",e.$Qg="vs/../../node_modules.asar.unpacked",e.$Rg="vscode-app";class l{static{this.a=e.$Rg}asBrowserUri(r){const s=this.b(r,le);return this.uriToBrowserUri(s)}uriToBrowserUri(r){return r.scheme===w.vscodeRemote?e.$Lg.rewrite(r):r.scheme===w.file&&(O.$m||O.$q===`${w.vscodeFileResource}://${l.a}`)?r.with({scheme:w.vscodeFileResource,authority:r.authority||l.a,query:null,fragment:null}):r}asFileUri(r){const s=this.b(r,le);return this.uriToFileUri(s)}uriToFileUri(r){return r.scheme===w.vscodeFileResource?r.with({scheme:w.file,authority:r.authority!==l.a?r.authority:null,query:null,fragment:null}):r}b(r,s){return N.URI.isUri(r)?r:N.URI.parse(s.toUrl(r))}}e.$Sg=new l;var b;(function(g){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(r.get("3"));const s="vscode-coi";function o(n){let c;typeof n=="string"?c=new URL(n).searchParams:n instanceof URL?c=n.searchParams:N.URI.isUri(n)&&(c=new URL(n.toString(!0)).searchParams);const u=c?.get(s);if(u)return r.get(u)}g.getHeadersFromQuery=o;function i(n,c,u){if(!globalThis.crossOriginIsolated)return;const t=c&&u?"3":u?"2":"1";n instanceof URLSearchParams?n.set(s,t):n[s]=t}g.addSearchParam=i})(b||(e.COI=b={}))}),define(Se[24],Ie([1,0,48,16,19,23,13,2]),function(le,e,C,O,M,N,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=void 0,e.$Zg=m,e.$ih=T,e.$jh=l;function m(b){return(0,w.$wc)(b,!0)}class E{constructor(g){this.a=g}compare(g,r,s=!1){return g===r?0:(0,R.$sf)(this.getComparisonKey(g,s),this.getComparisonKey(r,s))}isEqual(g,r,s=!1){return g===r?!0:!g||!r?!1:this.getComparisonKey(g,s)===this.getComparisonKey(r,s)}getComparisonKey(g,r=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,r,s=!1){if(g.scheme===r.scheme){if(g.scheme===O.Schemas.file)return C.$xg(m(g),m(r),this.a(g))&&g.query===r.query&&(s||g.fragment===r.fragment);if((0,e.$eh)(g.authority,r.authority))return C.$xg(g.path,r.path,this.a(g),"/")&&g.query===r.query&&(s||g.fragment===r.fragment)}return!1}joinPath(g,...r){return w.URI.joinPath(g,...r)}basenameOrAuthority(g){return(0,e.$9g)(g)||g.authority}basename(g){return M.$gc.basename(g.path)}extname(g){return M.$gc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let r;return g.scheme===O.Schemas.file?r=w.URI.file(M.$mc(m(g))).path:(r=M.$gc.dirname(g.path),g.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),r="/")),g.with({path:r})}normalizePath(g){if(!g.path.length)return g;let r;return g.scheme===O.Schemas.file?r=w.URI.file(M.$hc(m(g))).path:r=M.$gc.normalize(g.path),g.with({path:r})}relativePath(g,r){if(g.scheme!==r.scheme||!(0,e.$eh)(g.authority,r.authority))return;if(g.scheme===O.Schemas.file){const i=M.$lc(m(g),m(r));return N.$i?C.$rg(i):i}let s=g.path||"/";const o=r.path||"/";if(this.a(g)){let i=0;for(const n=Math.min(s.length,o.length);i<n&&!(s.charCodeAt(i)!==o.charCodeAt(i)&&s.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);s=o.substr(0,i)+s.substr(i)}return M.$gc.relative(s,o)}resolvePath(g,r){if(g.scheme===O.Schemas.file){const s=w.URI.file(M.$kc(m(g),r));return g.with({authority:s.authority,path:s.path})}return r=C.$sg(r),g.with({path:M.$gc.resolve(g.path,r)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,r){return g===r||g!==void 0&&r!==void 0&&(0,R.$zf)(g,r)}hasTrailingPathSeparator(g,r=M.sep){if(g.scheme===O.Schemas.file){const s=m(g);return s.length>C.$tg(s).length&&s[s.length-1]===r}else{const s=g.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,r=M.sep){return(0,e.$fh)(g,r)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,r=M.sep){let s=!1;if(g.scheme===O.Schemas.file){const o=m(g);s=o!==void 0&&o.length===C.$tg(o).length&&o[o.length-1]===r}else{r="/";const o=g.path;s=o.length===1&&o.charCodeAt(o.length-1)===47}return!s&&!(0,e.$fh)(g,r)?g.with({path:g.path+"/"}):g}}e.$1g=E,e.$2g=new E(()=>!1),e.$3g=new E(b=>b.scheme===O.Schemas.file?!N.$k:!0),e.$4g=new E(b=>!0),e.$5g=e.$2g.isEqual.bind(e.$2g),e.$6g=e.$2g.isEqualOrParent.bind(e.$2g),e.$7g=e.$2g.getComparisonKey.bind(e.$2g),e.$8g=e.$2g.basenameOrAuthority.bind(e.$2g),e.$9g=e.$2g.basename.bind(e.$2g),e.$0g=e.$2g.extname.bind(e.$2g),e.$$g=e.$2g.dirname.bind(e.$2g),e.$_g=e.$2g.joinPath.bind(e.$2g),e.$ah=e.$2g.normalizePath.bind(e.$2g),e.$bh=e.$2g.relativePath.bind(e.$2g),e.$ch=e.$2g.resolvePath.bind(e.$2g),e.$dh=e.$2g.isAbsolutePath.bind(e.$2g),e.$eh=e.$2g.isEqualAuthority.bind(e.$2g),e.$fh=e.$2g.hasTrailingPathSeparator.bind(e.$2g),e.$gh=e.$2g.removeTrailingPathSeparator.bind(e.$2g),e.$hh=e.$2g.addTrailingPathSeparator.bind(e.$2g);function T(b,g){const r=[];for(let s=0;s<b.length;s++){const o=g(b[s]);b.some((i,n)=>n===s?!1:(0,e.$6g)(o,g(i)))||r.push(b[s])}return r}var S;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function g(r){const s=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(n=>{const[c,u]=n.split(":");c&&u&&s.set(c,u)});const i=r.path.substring(0,r.path.indexOf(";"));return i&&s.set(b.META_DATA_MIME,i),s}b.parseMetaData=g})(S||(e.DataUri=S={}));function l(b,g,r){if(g){let s=b.path;return s&&s[0]!==M.$gc.sep&&(s=M.$gc.sep+s),b.with({scheme:r,authority:g,path:s})}return b.with({scheme:r})}}),define(Se[11],Ie([1,0,20,14,5,6,24,23,136,43]),function(le,e,C,O,M,N,R,w,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.Promises=e.$Vh=e.$Uh=e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=void 0,e.$kh=T,e.$lh=S,e.$mh=l,e.$nh=b,e.$oh=g,e.$ph=r,e.$qh=s,e.$rh=o,e.$zh=p,e.$Ah=v,e.$Bh=y,e.$Ch=h,e.$Dh=D,e.$Sh=Ee,e.$1h=ke;function T(me){return!!me&&typeof me.then=="function"}function S(me){const Q=new C.$qe,Y=me(Q.token),he=new Promise((ce,Ne)=>{const fe=Q.token.onCancellationRequested(()=>{fe.dispose(),Ne(new O.$5)});Promise.resolve(Y).then(Pe=>{fe.dispose(),Q.dispose(),ce(Pe)},Pe=>{fe.dispose(),Q.dispose(),Ne(Pe)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(ce,Ne){return he.then(ce,Ne)}catch(ce){return this.then(void 0,ce)}finally(ce){return he.finally(ce)}}}function l(me,Q,Y){return new Promise((he,ce)=>{const Ne=Q.onCancellationRequested(()=>{Ne.dispose(),he(Y)});me.then(he,ce).finally(()=>Ne.dispose())})}function b(me,Q){return new Promise((Y,he)=>{const ce=Q.onCancellationRequested(()=>{ce.dispose(),he(new O.$5)});me.then(Y,he).finally(()=>ce.dispose())})}async function g(me){let Q=-1;const Y=me.map((he,ce)=>he.then(Ne=>(Q=ce,Ne)));try{return await Promise.race(Y)}finally{me.forEach((he,ce)=>{ce!==Q&&he.cancel()})}}function r(me,Q,Y){let he;const ce=setTimeout(()=>{he?.(void 0),Y?.()},Q);return Promise.race([me.finally(()=>clearTimeout(ce)),new Promise(Ne=>he=Ne)])}function s(me){return new Promise((Q,Y)=>{const he=me();T(he)?he.then(Q,Y):Q(he)})}function o(){let me,Q;return{promise:new Promise((he,ce)=>{me=he,Q=ce}),resolve:me,reject:Q}}class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const Y=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Y,Y).then(he)})}return new Promise((Y,he)=>{this.b.then(Y,he)})}return this.a=Q(),new Promise((Y,he)=>{this.a.then(ce=>{this.a=null,Y(ce)},ce=>{this.a=null,he(ce)})})}dispose(){this.f=!0}}e.$sh=i;class n{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$th=n;class c{constructor(){this.a=new Map}queue(Q,Y){const ce=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(Q)===ce&&this.a.delete(Q)});return this.a.set(Q,ce),ce}}e.$uh=c;const u=(me,Q)=>{let Y=!0;const he=setTimeout(()=>{Y=!1,Q()},me);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(he),Y=!1}}},t=me=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,me())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class f{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,Y=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((ce,Ne)=>{this.d=ce,this.f=Ne}).then(()=>{if(this.b=null,this.d=null,this.g){const ce=this.g;return this.g=null,ce()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Y===m.$ce?t(he):u(Y,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$vh=f;class a{constructor(Q){this.a=new f(Q),this.b=new i}trigger(Q,Y){return this.a.trigger(()=>this.b.queue(Q),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$wh=a;class d{constructor(){this.a=!1,this.b=new Promise((Q,Y)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$xh=d;class $ extends d{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$yh=$;function p(me,Q){return Q?new Promise((Y,he)=>{const ce=setTimeout(()=>{Ne.dispose(),Y()},me),Ne=Q.onCancellationRequested(()=>{clearTimeout(ce),Ne.dispose(),he(new O.$5)})}):S(Y=>p(me,Y))}function v(me,Q=0,Y){const he=setTimeout(()=>{me(),Y&&ce.dispose()},Q),ce=(0,N.$Sc)(()=>{clearTimeout(he),Y?.deleteAndLeak(ce)});return Y?.add(ce),ce}function y(me){const Q=[];let Y=0;const he=me.length;function ce(){return Y<he?me[Y++]():null}function Ne(fe){fe!=null&&Q.push(fe);const Pe=ce();return Pe?Pe.then(Ne):Promise.resolve(Q)}return Promise.resolve(null).then(Ne)}function h(me,Q=he=>!!he,Y=null){let he=0;const ce=me.length,Ne=()=>{if(he>=ce)return Promise.resolve(Y);const fe=me[he++];return Promise.resolve(fe()).then(Ae=>Q(Ae)?Promise.resolve(Ae):Ne())};return Ne()}function D(me,Q=he=>!!he,Y=null){if(me.length===0)return Promise.resolve(Y);let he=me.length;const ce=()=>{he=-1;for(const Ne of me)Ne.cancel?.()};return new Promise((Ne,fe)=>{for(const Pe of me)Pe.then(Ae=>{--he>=0&&Q(Ae)?(ce(),Ne(Ae)):he===0&&Ne(Y)}).catch(Ae=>{--he>=0&&(ce(),fe(Ae))})})}class k{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new M.$fe}whenIdle(){return this.size>0?M.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,he)=>{this.g.push({factory:Q,c:Y,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const Y=Q.factory();Y.then(Q.c,Q.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Eh=k;class I extends k{constructor(){super(1)}}e.$Fh=I;class P{constructor(){this.a=new ge,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$Gh=P;class V{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new se;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,Y=R.$2g){const he=Y.getComparisonKey(Q);return this.a.get(he)?.size??0}queueFor(Q,Y,he=R.$2g){const ce=he.getComparisonKey(Q);let Ne=this.a.get(ce);if(!Ne){Ne=new I;const fe=this.f++,Pe=M.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(ce),this.h(),this.d?.deleteAndDispose(fe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$4c),this.d.set(fe,Pe),this.a.set(ce,Ne)}return Ne.queue(Y)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Hh=V;class W{constructor(Q,Y){this.a=-1,typeof Q=="function"&&typeof Y=="number"&&this.setIfNotSet(Q,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},Y)}setIfNotSet(Q,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},Y))}}e.$Ih=W;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,Y,he=globalThis){this.cancel();const ce=he.setInterval(()=>{Q()},Y);this.d=(0,N.$Sc)(()=>{he.clearInterval(ce),this.d=void 0})}dispose(){this.cancel()}}e.$Jh=q;class A{constructor(Q,Y){this.b=-1,this.a=Q,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Kh=A;class z{constructor(Q,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=Q,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Lh=z;class G extends A{constructor(Q,Y){super(Q,Y),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Mh=G;class ie extends N.$Uc{constructor(Q,Y){super(),this.g=Q,this.h=Y,this.a=[],this.b=this.B(new N.$Vc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of Q)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new A(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Nh=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Ph=(me,Q)=>{(0,w.$B)(()=>{if(Y)return;const he=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$Ph=(me,Q,Y)=>{const he=me.requestIdleCallback(Q,typeof Y=="number"?{timeout:Y}:void 0);let ce=!1;return{dispose(){ce||(ce=!0,me.cancelIdleCallback(he))}}},e.$Oh=me=>(0,e.$Ph)(globalThis,me)}();class de{constructor(Q,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Ph)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Qh=de;class ye extends de{constructor(Q){super(globalThis,Q)}}e.$Rh=ye;async function Ee(me,Q,Y){let he;for(let ce=0;ce<Y;ce++)try{return await me()}catch(Ne){he=Ne,await p(Q)}throw he}class ge{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,Y,he){return this.a={taskId:Q,cancel:()=>he?.(),promise:Y},Y.then(()=>this.d(Q),()=>this.d(Q)),Y}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:Y,resolve:he,reject:ce}=o();this.b={run:Q,promise:Y,promiseResolve:he,promiseReject:ce}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Th=ge;class ue{constructor(Q,Y=()=>Date.now()){this.d=Q,this.f=Y,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Uh=ue;var Ce;(function(me){me[me.Resolved=0]="Resolved",me[me.Rejected=1]="Rejected"})(Ce||(Ce={}));class se{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,Y)=>{this.a=Q,this.b=Y})}complete(Q){return new Promise(Y=>{this.a(Q),this.d={outcome:0,value:Q},Y()})}error(Q){return new Promise(Y=>{this.b(Q),this.d={outcome:1,value:Q},Y()})}cancel(){return this.error(new O.$5)}}e.$Vh=se;var Oe;(function(me){async function Q(he){let ce;const Ne=await Promise.all(he.map(fe=>fe.then(Pe=>Pe,Pe=>{ce||(ce=Pe)})));if(typeof ce<"u")throw ce;return Ne}me.settled=Q;function Y(he){return new Promise(async(ce,Ne)=>{try{await he(ce,Ne)}catch(fe){Ne(fe)}})}me.withAsyncBody=Y})(Oe||(e.Promises=Oe={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Wh=ne;class j{constructor(Q){this.b=Q,this.a=new E.$V(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Xh=j;var x;(function(me){me[me.Initial=0]="Initial",me[me.DoneOK=1]="DoneOK",me[me.DoneError=2]="DoneError"})(x||(x={}));class ve{static fromArray(Q){return new ve(Y=>{Y.emitMany(Q)})}static fromPromise(Q){return new ve(async Y=>{Y.emitMany(await Q)})}static fromPromises(Q){return new ve(async Y=>{await Promise.all(Q.map(async he=>Y.emitOne(await he)))})}static merge(Q){return new ve(async Y=>{await Promise.all(Q.map(async he=>{for await(const ce of he)Y.emitOne(ce)}))})}static{this.EMPTY=ve.fromArray([])}constructor(Q,Y){this.a=0,this.b=[],this.d=null,this.f=Y,this.g=new M.$fe,queueMicrotask(async()=>{const he={emitOne:ce=>this.h(ce),emitMany:ce=>this.j(ce),reject:ce=>this.l(ce)};try{await Promise.resolve(Q(he)),this.k()}catch(ce){this.l(ce)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await M.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Q,Y){return new ve(async he=>{for await(const ce of Q)he.emitOne(Y(ce))})}map(Q){return ve.map(this,Q)}static filter(Q,Y){return new ve(async he=>{for await(const ce of Q)Y(ce)&&he.emitOne(ce)})}filter(Q){return ve.filter(this,Q)}static coalesce(Q){return ve.filter(Q,Y=>!!Y)}coalesce(){return ve.coalesce(this)}static async toPromise(Q){const Y=[];for await(const he of Q)Y.push(he);return Y}toPromise(){return ve.toPromise(this)}h(Q){this.a===0&&(this.b.push(Q),this.g.fire())}j(Q){this.a===0&&(this.b=this.b.concat(Q),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Q){this.a===0&&(this.a=2,this.d=Q,this.g.fire())}}e.$Yh=ve;class Fe extends ve{constructor(Q,Y){super(Y),this.m=Q}cancel(){this.m.cancel()}}e.$Zh=Fe;function ke(me){const Q=new C.$qe,Y=me(Q.token);return new Fe(Q,async he=>{const ce=Q.token.onCancellationRequested(()=>{ce.dispose(),Q.dispose(),he.reject(new O.$5)});try{for await(const Ne of Y){if(Q.token.isCancellationRequested)return;he.emitOne(Ne)}ce.dispose(),Q.dispose()}catch(Ne){ce.dispose(),Q.dispose(),he.reject(Ne)}})}class we{constructor(Q){this.a=new se,this.b=new ve(ce=>{if(Y){ce.reject(Y);return}return he&&ce.emitMany(he),this.d=Ne=>ce.reject(Ne),this.f=Ne=>ce.emitOne(Ne),this.a.p},Q);let Y,he;this.f=ce=>{he||(he=[]),he.push(ce)},this.d=ce=>{Y||(Y=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$2h=we}),define(Se[37],Ie([1,0,18,11,48,28,19,23,13]),function(le,e,C,O,M,N,R,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=void 0,e.$nk=E,e.$qk=g,e.$rk=I,e.$sk=P,e.$tk=V,e.$uk=W,e.$vk=q,e.$wk=ie;function E(){return Object.create(null)}e.$ok="**",e.$pk="/";const T="[/\\\\]",S="[^/\\\\]",l=/\//g;function b(de,ye){switch(de){case 0:return"";case 1:return`${S}*?`;default:return`(?:${T}|${S}+${T}${ye?`|${T}${S}+`:""})*?`}}function g(de,ye){if(!de)return[];const Ee=[];let ge=!1,ue=!1,Ce="";for(const se of de){switch(se){case ye:if(!ge&&!ue){Ee.push(Ce),Ce="";continue}break;case"{":ge=!0;break;case"}":ge=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}Ce+=se}return Ce&&Ee.push(Ce),Ee}function r(de){if(!de)return"";let ye="";const Ee=g(de,e.$pk);if(Ee.every(ge=>ge===e.$ok))ye=".*";else{let ge=!1;Ee.forEach((ue,Ce)=>{if(ue===e.$ok){if(ge)return;ye+=b(2,Ce===Ee.length-1)}else{let se=!1,Oe="",ne=!1,j="";for(const x of ue){if(x!=="}"&&se){Oe+=x;continue}if(ne&&(x!=="]"||!j)){let ve;x==="-"?ve=x:(x==="^"||x==="!")&&!j?ve="^":x===e.$pk?ve="":ve=(0,m.$bf)(x),j+=ve;continue}switch(x){case"{":se=!0;continue;case"[":ne=!0;continue;case"}":{const Fe=`(?:${g(Oe,",").map(ke=>r(ke)).join("|")})`;ye+=Fe,se=!1,Oe="";break}case"]":{ye+="["+j+"]",ne=!1,j="";break}case"?":ye+=S;continue;case"*":ye+=b(1);continue;default:ye+=(0,m.$bf)(x)}}Ce<Ee.length-1&&(Ee[Ce+1]!==e.$ok||Ce+2<Ee.length)&&(ye+=T)}ge=ue===e.$ok})}return ye}const s=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new N.$Dc(1e4),f=function(){return!1},a=function(){return null};function d(de,ye){if(!de)return a;let Ee;typeof de!="string"?Ee=de.pattern:Ee=de,Ee=Ee.trim();const ge=`${Ee}_${!!ye.trimForExclusions}`;let ue=t.get(ge);if(ue)return $(ue,de);let Ce;return s.test(Ee)?ue=v(Ee.substr(4),Ee):(Ce=o.exec(p(Ee,ye)))?ue=y(Ce[1],Ee):(ye.trimForExclusions?n:i).test(Ee)?ue=h(Ee,ye):(Ce=c.exec(p(Ee,ye)))?ue=D(Ce[1].substr(1),Ee,!0):(Ce=u.exec(p(Ee,ye)))?ue=D(Ce[1],Ee,!1):ue=k(Ee),t.set(ge,ue),$(ue,de)}function $(de,ye){if(typeof ye=="string")return de;const Ee=function(ge,ue){return(0,M.$xg)(ge,ye.base,!w.$k)?de((0,m.$gf)(ge.substr(ye.base.length),R.sep),ue):null};return Ee.allBasenames=de.allBasenames,Ee.allPaths=de.allPaths,Ee.basenames=de.basenames,Ee.patterns=de.patterns,Ee}function p(de,ye){return ye.trimForExclusions&&de.endsWith("/**")?de.substr(0,de.length-2):de}function v(de,ye){return function(Ee,ge){return typeof Ee=="string"&&Ee.endsWith(de)?ye:null}}function y(de,ye){const Ee=`/${de}`,ge=`\\${de}`,ue=function(se,Oe){return typeof se!="string"?null:Oe?Oe===de?ye:null:se===de||se.endsWith(Ee)||se.endsWith(ge)?ye:null},Ce=[de];return ue.basenames=Ce,ue.patterns=[ye],ue.allBasenames=Ce,ue}function h(de,ye){const Ee=G(de.slice(1,-1).split(",").map(Oe=>d(Oe,ye)).filter(Oe=>Oe!==a),de),ge=Ee.length;if(!ge)return a;if(ge===1)return Ee[0];const ue=function(Oe,ne){for(let j=0,x=Ee.length;j<x;j++)if(Ee[j](Oe,ne))return de;return null},Ce=Ee.find(Oe=>!!Oe.allBasenames);Ce&&(ue.allBasenames=Ce.allBasenames);const se=Ee.reduce((Oe,ne)=>ne.allPaths?Oe.concat(ne.allPaths):Oe,[]);return se.length&&(ue.allPaths=se),ue}function D(de,ye,Ee){const ge=R.sep===R.$gc.sep,ue=ge?de:de.replace(l,R.sep),Ce=R.sep+ue,se=R.$gc.sep+de;let Oe;return Ee?Oe=function(ne,j){return typeof ne=="string"&&(ne===ue||ne.endsWith(Ce)||!ge&&(ne===de||ne.endsWith(se)))?ye:null}:Oe=function(ne,j){return typeof ne=="string"&&(ne===ue||!ge&&ne===de)?ye:null},Oe.allPaths=[(Ee?"*/":"./")+de],Oe}function k(de){try{const ye=new RegExp(`^${r(de)}$`);return function(Ee){return ye.lastIndex=0,typeof Ee=="string"&&ye.test(Ee)?de:null}}catch{return a}}function I(de,ye,Ee){return!de||typeof ye!="string"?!1:P(de)(ye,void 0,Ee)}function P(de,ye={}){if(!de)return f;if(typeof de=="string"||V(de)){const Ee=d(de,ye);if(Ee===a)return f;const ge=function(ue,Ce){return!!Ee(ue,Ce)};return Ee.allBasenames&&(ge.allBasenames=Ee.allBasenames),Ee.allPaths&&(ge.allPaths=Ee.allPaths),ge}return A(de,ye)}function V(de){const ye=de;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}function W(de){return de.allBasenames||[]}function q(de){return de.allPaths||[]}function A(de,ye){const Ee=G(Object.getOwnPropertyNames(de).map(Oe=>z(Oe,de[Oe],ye)).filter(Oe=>Oe!==a)),ge=Ee.length;if(!ge)return a;if(!Ee.some(Oe=>!!Oe.requiresSiblings)){if(ge===1)return Ee[0];const Oe=function(x,ve){let Fe;for(let ke=0,we=Ee.length;ke<we;ke++){const me=Ee[ke](x,ve);if(typeof me=="string")return me;(0,O.$kh)(me)&&(Fe||(Fe=[]),Fe.push(me))}return Fe?(async()=>{for(const ke of Fe){const we=await ke;if(typeof we=="string")return we}return null})():null},ne=Ee.find(x=>!!x.allBasenames);ne&&(Oe.allBasenames=ne.allBasenames);const j=Ee.reduce((x,ve)=>ve.allPaths?x.concat(ve.allPaths):x,[]);return j.length&&(Oe.allPaths=j),Oe}const ue=function(Oe,ne,j){let x,ve;for(let Fe=0,ke=Ee.length;Fe<ke;Fe++){const we=Ee[Fe];we.requiresSiblings&&j&&(ne||(ne=(0,R.$nc)(Oe)),x||(x=ne.substr(0,ne.length-(0,R.$oc)(Oe).length)));const me=we(Oe,ne,x,j);if(typeof me=="string")return me;(0,O.$kh)(me)&&(ve||(ve=[]),ve.push(me))}return ve?(async()=>{for(const Fe of ve){const ke=await Fe;if(typeof ke=="string")return ke}return null})():null},Ce=Ee.find(Oe=>!!Oe.allBasenames);Ce&&(ue.allBasenames=Ce.allBasenames);const se=Ee.reduce((Oe,ne)=>ne.allPaths?Oe.concat(ne.allPaths):Oe,[]);return se.length&&(ue.allPaths=se),ue}function z(de,ye,Ee){if(ye===!1)return a;const ge=d(de,Ee);if(ge===a)return a;if(typeof ye=="boolean")return ge;if(ye){const ue=ye.when;if(typeof ue=="string"){const Ce=(se,Oe,ne,j)=>{if(!j||!ge(se,Oe))return null;const x=ue.replace("$(basename)",()=>ne),ve=j(x);return(0,O.$kh)(ve)?ve.then(Fe=>Fe?de:null):ve?de:null};return Ce.requiresSiblings=!0,Ce}}return ge}function G(de,ye){const Ee=de.filter(Oe=>!!Oe.basenames);if(Ee.length<2)return de;const ge=Ee.reduce((Oe,ne)=>{const j=ne.basenames;return j?Oe.concat(j):Oe},[]);let ue;if(ye){ue=[];for(let Oe=0,ne=ge.length;Oe<ne;Oe++)ue.push(ye)}else ue=Ee.reduce((Oe,ne)=>{const j=ne.patterns;return j?Oe.concat(j):Oe},[]);const Ce=function(Oe,ne){if(typeof Oe!="string")return null;if(!ne){let x;for(x=Oe.length;x>0;x--){const ve=Oe.charCodeAt(x-1);if(ve===47||ve===92)break}ne=Oe.substr(x)}const j=ge.indexOf(ne);return j!==-1?ue[j]:null};Ce.basenames=ge,Ce.patterns=ue,Ce.allBasenames=ge;const se=de.filter(Oe=>!Oe.basenames);return se.push(Ce),se}function ie(de,ye){return(0,C.$ub)(de,ye,(Ee,ge)=>typeof Ee=="string"&&typeof ge=="string"?Ee===ge:typeof Ee!="string"&&typeof ge!="string"?Ee.base===ge.base&&Ee.pattern===ge.pattern:!1)}}),define(Se[55],Ie([1,0,14,137,24,13,2]),function(le,e,C,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.MarkdownStringTextNewlineStyle=void 0,e.$Wk=E,e.$Xk=T,e.$Yk=S,e.$Zk=l,e.$1k=b,e.$2k=g,e.$3k=r,e.$4k=s;var w;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(w||(e.MarkdownStringTextNewlineStyle=w={}));class m{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,C.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=l(this.supportThemeIcons?(0,O.$Pk)(i):i).replace(/([ \t]+)/g,(c,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${b(n,i)}
`,this}appendLink(i,n,c){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(i,n){const c=new RegExp((0,N.$bf)(n),"g");return i.replace(c,(u,t)=>i.charAt(t-1)!=="\\"?`\\${u}`:u)}}e.$Vk=m;function E(o){return T(o)?!o.value:Array.isArray(o)?o.every(E):!0}function T(o){return o instanceof m?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function S(o,i){return o===i?!0:!o||!i?!1:o.value===i.value&&o.isTrusted===i.isTrusted&&o.supportThemeIcons===i.supportThemeIcons&&o.supportHtml===i.supportHtml&&(o.baseUri===i.baseUri||!!o.baseUri&&!!i.baseUri&&(0,M.$5g)(R.URI.from(o.baseUri),R.URI.from(i.baseUri)))}function l(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function b(o,i){const n=o.match(/^`+/gm)?.reduce((u,t)=>u.length>t.length?u:t).length??0,c=n>=3?n+1:3;return[`${"`".repeat(c)}${i}`,o,`${"`".repeat(c)}`].join(`
`)}function g(o){return o.replace(/"/g,"&quot;")}function r(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function s(o){const i=[],n=o.split("|").map(u=>u.trim());o=n[0];const c=n[1];if(c){const u=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),f=u?u[1]:"",a=t?t[1]:"",d=isFinite(parseInt(a)),$=isFinite(parseInt(f));d&&i.push(`width="${a}"`),$&&i.push(`height="${f}"`)}return{href:o,dimensions:i}}}),define(Se[97],Ie([1,0,18,48,19,23,24,13]),function(le,e,C,O,M,N,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gw=m,e.$Hw=T,e.$Iw=l,e.$Jw=b,e.$Kw=o,e.$Lw=n,e.$Mw=c,e.$Nw=u,e.$Ow=t,e.$Pw=f;function m(d,$){const{os:p,tildify:v,relative:y}=$;if(y){const k=E(d,y,p);if(typeof k=="string")return k}let h=d.fsPath;if(p===1&&!N.$i?h=h.replace(/\//g,"\\"):p!==1&&N.$i&&(h=h.replace(/\\/g,"/")),p!==1&&v?.userHome){const k=v.userHome.fsPath;let I;d.scheme!==v.userHome.scheme&&d.path[0]===M.$gc.sep&&d.path[1]!==M.$gc.sep?I=v.userHome.with({path:d.path}).fsPath:I=h,h=l(I,k,p)}return(p===1?M.$fc:M.$gc).normalize(T(h,p===1))}function E(d,$,p){const v=p===1?M.$fc:M.$gc,y=p===3?R.$2g:R.$4g,h=$.getWorkspace(),D=(0,C.$Ob)(h.folders);if(!D)return;d.scheme!==D.uri.scheme&&d.path[0]===M.$gc.sep&&d.path[1]!==M.$gc.sep&&(d=D.uri.with({path:d.path}));const k=$.getWorkspaceFolder(d);if(!k)return;let I;if(y.isEqual(k.uri,d)?I="":I=y.relativePath(k.uri,d)??"",I&&(I=v.normalize(I)),h.folders.length>1&&!$.noPrefix){const P=k.name?k.name:y.basenameOrAuthority(k.uri);I=I?`${P} \u2022 ${I}`:P}return I}function T(d,$=N.$i){return(0,O.$Cg)(d,$)?d.charAt(0).toUpperCase()+d.slice(1):d}let S=Object.create(null);function l(d,$,p=N.OS){if(p===1||!d||!$)return d;let v=S.original===$?S.normalized:void 0;v||(v=$,N.$i&&(v=(0,O.$rg)(v)),v=`${(0,w.$hf)(v,M.$gc.sep)}${M.$gc.sep}`,S={original:$,normalized:v});let y=d;return N.$i&&(y=(0,O.$rg)(y)),(p===3?y.startsWith(v):(0,w.$Af)(y,v))?`~/${y.substr(v.length)}`:d}function b(d,$){return d.replace(/^~($|\/|\\)/,`${$}$1`)}const g="\u2026",r="\\\\",s="~";function o(d,$=M.sep){const p=new Array(d.length);let v=!1;for(let y=0;y<d.length;y++){const h=d[y];if(h===""){p[y]=`.${$}`;continue}if(!h){p[y]=h;continue}v=!0;let D="",k=h;k.indexOf(r)===0?(D=k.substr(0,k.indexOf(r)+r.length),k=k.substr(k.indexOf(r)+r.length)):k.indexOf($)===0?(D=k.substr(0,k.indexOf($)+$.length),k=k.substr(k.indexOf($)+$.length)):k.indexOf(s)===0&&(D=k.substr(0,k.indexOf(s)+s.length),k=k.substr(k.indexOf(s)+s.length));const I=k.split($);for(let P=1;v&&P<=I.length;P++)for(let V=I.length-P;v&&V>=0;V--){v=!1;let W=I.slice(V,V+P).join($);for(let q=0;!v&&q<d.length;q++)if(q!==y&&d[q]&&d[q].indexOf(W)>-1){const A=V+P===I.length,z=V>0&&d[q].indexOf($)>-1?$+W:W,G=d[q].endsWith(z);v=!A||G}if(!v){let q="";(I[0].endsWith(":")||D!=="")&&(V===1&&(V=0,P++,W=I[0]+$+W),V>0&&(q=I[0]+$),q=D+q),V>0&&(q=q+g+$),q=q+W,V+P<I.length&&(q=q+$+g),p[y]=q}}v&&(p[y]=h)}return p}var i;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(d,$=Object.create(null)){const p=[];let v=!1,y="";for(const h of d)if(h==="$"||v&&h==="{")y&&p.push({value:y,type:i.TEXT}),y="",v=!0;else if(h==="}"&&v){const D=$[y];if(typeof D=="string")D.length&&p.push({value:D,type:i.VARIABLE});else if(D){const k=p[p.length-1];(!k||k.type!==i.SEPARATOR)&&p.push({value:D.label,type:i.SEPARATOR})}y="",v=!1}else y+=h;return y&&!v&&p.push({value:y,type:i.TEXT}),p.filter((h,D)=>{if(h.type===i.SEPARATOR){const k=p[D-1],I=p[D+1];return[k,I].every(P=>P&&(P.type===i.VARIABLE||P.type===i.TEXT)&&P.value.length>0)}return!0}).map(h=>h.value).join("")}function c(d,$){return N.$j||$?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.$j?"&":"&&"):d.replace(/&&|&/g,p=>p==="&"?"&&":"&")}function u(d,$){return N.$j||$?d.replace(/\(&&\w\)|&&/g,""):N.$i?d.replace(/&&|&/g,p=>p==="&"?"&&":"&"):d.replace(/&&/g,"_")}function t(d){return d.replace(/&/g,"&&")}function f(d){if(d.endsWith("]")){const $=d.lastIndexOf(" [",d.length-2);if($!==-1){const p=a(d.substring(0,$)),v=d.substring($);return{name:p.name+v,parentPath:p.parentPath}}}return a(d)}function a(d){const $=d.indexOf("/")!==-1?M.$gc:M.$fc,p=$.basename(d),v=$.dirname(d);return p.length?{name:p,parentPath:v}:{name:v,parentPath:""}}}),define(Se[150],Ie([1,0,22,2]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=void 0,e.$Cn=w,e.$Dn=E,e.$En=T;function M(S){return S.toJSON()}class N{constructor(l){this.a=l}transformIncoming(l){const b=this.a.transformIncoming(l);return b===l?l:M(O.URI.from(b))}transformOutgoing(l){const b=this.a.transformOutgoing(l);return b===l?l:M(O.URI.from(b))}transformOutgoingURI(l){const b=this.a.transformOutgoing(l);return b===l?l:O.URI.from(b)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$An=N,e.$Bn=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function R(S,l,b){if(!S||b>200)return null;if(typeof S=="object"){if(S instanceof O.URI)return l.transformOutgoing(S);for(const g in S)if(Object.hasOwnProperty.call(S,g)){const r=R(S[g],l,b+1);r!==null&&(S[g]=r)}}return null}function w(S,l){const b=R(S,l,0);return b===null?S:b}function m(S,l,b,g){if(!S||g>200)return null;if(typeof S=="object"){if(S.$mid===1)return b?O.URI.revive(l.transformIncoming(S)):l.transformIncoming(S);if(S instanceof C.$He)return null;for(const r in S)if(Object.hasOwnProperty.call(S,r)){const s=m(S[r],l,b,g+1);s!==null&&(S[r]=s)}}return null}function E(S,l){const b=m(S,l,!1,0);return b===null?S:b}function T(S,l){const b=m(S,l,!0,0);return b===null?S:b}}),define(Se[151],Ie([1,0,11,5,6,49,15]),function(le,e,C,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=e.StorageState=e.StorageHint=void 0,e.$Yp=m;var w;(function(l){l[l.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",l[l.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(w||(e.StorageHint=w={}));function m(l){const b=l;return b?.changed instanceof Map||b?.deleted instanceof Set}var E;(function(l){l[l.None=0]="None",l[l.Initialized=1]="Initialized",l[l.Closed=2]="Closed"})(E||(e.StorageState=E={}));class T extends M.$Uc{static{this.a=100}constructor(b,g=Object.create(null)){super(),this.r=b,this.s=g,this.b=this.B(new O.$ie),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new C.$wh(T.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(b=>this.u(b)))}u(b){this.b.pause();try{b.changed?.forEach((g,r)=>this.w(r,g)),b.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(b,g){if(this.c===E.Closed)return;let r=!1;(0,R.$hg)(g)?r=this.f.delete(b):this.f.get(b)!==g&&(this.f.set(b,g),r=!0),r&&this.b.fire({key:b,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==w.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(b,g){const r=this.f.get(b);return(0,R.$hg)(r)?g:r}getBoolean(b,g){const r=this.get(b);return(0,R.$hg)(r)?g:r==="true"}getNumber(b,g){const r=this.get(b);return(0,R.$hg)(r)?g:parseInt(r,10)}getObject(b,g){const r=this.get(b);return(0,R.$hg)(r)?g:(0,N.$7h)(r)}async set(b,g,r=!1){if(this.c===E.Closed)return;if((0,R.$hg)(g))return this.delete(b,r);const s=(0,R.$ag)(g)||Array.isArray(g)?(0,N.$6h)(g):String(g);if(this.f.get(b)!==s)return this.f.set(b,s),this.j.set(b,s),this.h.delete(b),this.b.fire({key:b,external:r}),this.D()}async delete(b,g=!1){if(!(this.c===E.Closed||!this.f.delete(b)))return this.h.has(b)||this.h.add(b),this.j.delete(b),this.b.fire({key:b,external:g}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const b={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(b).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(b){if(!(this.c===E.Closed||this.m))return this.D(b)}async D(b){return this.s.hint===w.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),b)}async whenFlushed(){if(this.z)return new Promise(b=>this.n.push(b))}isInMemory(){return this.s.hint===w.STORAGE_IN_MEMORY}}e.$Zp=T;class S{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(b){b.insert?.forEach((g,r)=>this.a.set(r,g)),b.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$1p=S}),define(Se[152],Ie([1,0,13,23,22]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$It=void 0,e.$Gt=T,e.$Ht=S;let N;function R(){return N||(N=new TextDecoder("UTF-16LE")),N}let w;function m(){return w||(w=new TextDecoder("UTF-16BE")),w}let E;function T(){return E||(E=O.$D()?R():m()),E}function S(g,r,s){const o=new Uint16Array(g.buffer,r,s);return s>0&&(o[0]===65279||o[0]===65534)?l(g,r,s):R().decode(o)}function l(g,r,s){const o=[];let i=0;for(let n=0;n<s;n++){const c=M.$Je(g,r);r+=2,o[i++]=String.fromCharCode(c)}return o.join("")}class b{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return T().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const s=this.a-this.d;s<=1&&(s===0||C.$Df(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const s=r.length;if(this.d+s>=this.a){this.f(),this.c[this.c.length]=r;return}for(let o=0;o<s;o++)this.b[this.d++]=r.charCodeAt(o)}}e.$It=b}),define(Se[153],Ie([1,0,22,152]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=void 0,e.$Kt=R;function M(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class N{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,T,S,l){this.oldPosition=E,this.oldText=T,this.newPosition=S,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${M(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${M(this.oldText)}")`:`(replace@${this.oldPosition} "${M(this.oldText)}" with "${M(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,T,S){const l=T.length;C.$Me(E,l,S),S+=4;for(let b=0;b<l;b++)C.$Ke(E,T.charCodeAt(b),S),S+=2;return S}static d(E,T){const S=C.$Le(E,T);return T+=4,(0,O.$Ht)(E,T,S)}writeSize(){return 8+N.a(this.oldText)+N.a(this.newText)}write(E,T){return C.$Me(E,this.oldPosition,T),T+=4,C.$Me(E,this.newPosition,T),T+=4,T=N.c(E,this.oldText,T),T=N.c(E,this.newText,T),T}static read(E,T,S){const l=C.$Le(E,T);T+=4;const b=C.$Le(E,T);T+=4;const g=N.d(E,T);T+=N.a(g);const r=N.d(E,T);return T+=N.a(r),S.push(new N(l,g,b,r)),T}}e.$Jt=N;function R(m,E){return m===null||m.length===0?E:new w(m,E).compress()}class w{constructor(E,T){this.a=E,this.c=T,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,T=0,S=this.n(E),l=this.l(T);for(;E<this.f||T<this.h;){if(S===null){this.k(l),l=this.l(++T);continue}if(l===null){this.m(S),S=this.n(++E);continue}if(l.oldEnd<=S.newPosition){this.k(l),l=this.l(++T);continue}if(S.newEnd<=l.oldPosition){this.m(S),S=this.n(++E);continue}if(l.oldPosition<S.newPosition){const[o,i]=w.r(l,S.newPosition-l.oldPosition);this.k(o),l=i;continue}if(S.newPosition<l.oldPosition){const[o,i]=w.q(S,l.oldPosition-S.newPosition);this.m(o),S=i;continue}let r,s;if(l.oldEnd===S.newEnd)r=S,s=l,S=this.n(++E),l=this.l(++T);else if(l.oldEnd<S.newEnd){const[o,i]=w.q(S,l.oldLength);r=o,s=l,S=i,l=this.l(++T)}else{const[o,i]=w.r(l,S.newLength);r=S,s=o,S=this.n(++E),l=i}this.d[this.e++]=new N(r.oldPosition,r.oldText,s.newPosition,s.newText),this.g+=r.newLength-r.oldLength,this.j+=s.newLength-s.oldLength}const b=w.s(this.d);return w.t(b)}k(E){this.d[this.e++]=w.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=w.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,T){return new N(T.oldPosition-E,T.oldText,T.newPosition,T.newText)}static p(E,T){return new N(T.oldPosition,T.oldText,T.newPosition+E,T.newText)}static q(E,T){const S=E.newText.substr(0,T),l=E.newText.substr(T);return[new N(E.oldPosition,E.oldText,E.newPosition,S),new N(E.oldEnd,"",E.newPosition+T,l)]}static r(E,T){const S=E.oldText.substr(0,T),l=E.oldText.substr(T);return[new N(E.oldPosition,S,E.newPosition,E.newText),new N(E.oldPosition+T,l,E.newEnd,"")]}static s(E){if(E.length===0)return E;const T=[];let S=0,l=E[0];for(let b=1;b<E.length;b++){const g=E[b];l.oldEnd===g.oldPosition?l=new N(l.oldPosition,l.oldText+g.oldText,l.newPosition,l.newText+g.newText):(T[S++]=l,l=g)}return T[S++]=l,T}static t(E){if(E.length===0)return E;const T=[];let S=0;for(let l=0;l<E.length;l++){const b=E[l];b.oldText!==b.newText&&(T[S++]=b)}return T}}}),define(Se[154],Ie([1,0,37,19]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1t=M,e.$2t=N;function M(R,w,m,E,T,S){if(Array.isArray(R)){let l=0;for(const b of R){const g=M(b,w,m,E,T,S);if(g===10)return g;g>l&&(l=g)}return l}else{if(typeof R=="string")return E?R==="*"?5:R===m?10:0:0;if(R){const{language:l,pattern:b,scheme:g,hasAccessToAllModels:r,notebookType:s}=R;if(!E&&!r)return 0;s&&T&&(w=T);let o=0;if(g)if(g===w.scheme)o=10;else if(g==="*")o=5;else return 0;if(l)if(l===m)o=10;else if(l==="*")o=Math.max(o,5);else return 0;if(s)if(s===S)o=10;else if(s==="*"&&S!==void 0)o=Math.max(o,5);else return 0;if(b){let i;if(typeof b=="string"?i=b:i={...b,base:(0,O.$hc)(b.base)},i===w.fsPath||(0,C.$rk)(i,w.fsPath))o=10;else return 0}return o}else return 0}}function N(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(N):!!R.notebookType}}),define(Se[155],Ie([1,0,5,13,30,95,93,139,153,6]),function(le,e,C,O,M,N,R,w,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4C=void 0;class T extends E.$Uc{constructor(l,b,g,r,s,o,i){super(),this.m=this.B(new C.$fe),this.onDidChangeContent=this.m.event,this.f=b,this.j=!o,this.g=r,this.h=s,this.c=new R.$3C(l,g,i)}equals(l){return!(l instanceof T)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,b){return this.c.getOffsetAt(l,b)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,b){const g=l+b,r=this.getPositionAt(l),s=this.getPositionAt(g);return new M.$xt(r.lineNumber,r.column,s.lineNumber,s.column)}getValueInRange(l,b=0){if(l.isEmpty())return"";const g=this.n(b);return this.c.getValueInRange(l,g)}getValueLengthInRange(l,b=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const g=this.getOffsetAt(l.startLineNumber,l.startColumn),r=this.getOffsetAt(l.endLineNumber,l.endColumn);let s=0;const o=this.n(b),i=this.getEOL();if(o.length!==i.length){const n=o.length-i.length,c=l.endLineNumber-l.startLineNumber;s=n*c}return r-g+s}getCharacterCountInRange(l,b=0){if(this.j){let g=0;const r=l.startLineNumber,s=l.endLineNumber;for(let o=r;o<=s;o++){const i=this.getLineContent(o),n=o===r?l.startColumn-1:0,c=o===s?l.endColumn-1:i.length;for(let u=n;u<c;u++)O.$Df(i.charCodeAt(u))?(g=g+1,u=u+1):g=g+1}return g+=this.n(b).length*(s-r),g}return this.getValueLengthInRange(l,b)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,b){return this.c.getLineCharCode(l,b)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const b=O.$of(this.getLineContent(l));return b===-1?0:b+1}getLineLastNonWhitespaceColumn(l){const b=O.$qf(this.getLineContent(l));return b===-1?0:b+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,b,g){let r=this.g,s=this.h,o=this.j,i=!0,n=[];for(let $=0;$<l.length;$++){const p=l[$];i&&p._isTracked&&(i=!1);const v=p.range;if(p.text){let I=!0;o||(I=!O.$Of(p.text),o=I),!r&&I&&(r=O.$Nf(p.text)),!s&&I&&(s=O.$Qf(p.text))}let y="",h=0,D=0,k=0;if(p.text){let I;[h,D,k,I]=(0,w.$4t)(p.text);const P=this.getEOL();I===0||I===(P===`\r
`?2:1)?y=p.text:y=p.text.replace(/\r\n|\r|\n/g,P)}n[$]={sortIndex:$,identifier:p.identifier||null,range:v,rangeOffset:this.getOffsetAt(v.startLineNumber,v.startColumn),rangeLength:this.getValueLengthInRange(v),text:y,eolCount:h,firstLineLength:D,lastLineLength:k,forceMoveMarkers:!!p.forceMoveMarkers,isAutoWhitespaceEdit:p.isAutoWhitespaceEdit||!1}}n.sort(T.u);let c=!1;for(let $=0,p=n.length-1;$<p;$++){const v=n[$].range.getEndPosition(),y=n[$+1].range.getStartPosition();if(y.isBeforeOrEqual(v)){if(y.isBefore(v))throw new Error("Overlapping ranges are not allowed!");c=!0}}i&&(n=this.s(n));const u=g||b?T._getInverseEditRanges(n):[],t=[];if(b)for(let $=0;$<n.length;$++){const p=n[$],v=u[$];if(p.isAutoWhitespaceEdit&&p.range.isEmpty())for(let y=v.startLineNumber;y<=v.endLineNumber;y++){let h="";y===v.startLineNumber&&(h=this.getLineContent(p.range.startLineNumber),O.$of(h)!==-1)||t.push({lineNumber:y,oldContent:h})}}let f=null;if(g){let $=0;f=[];for(let p=0;p<n.length;p++){const v=n[p],y=u[p],h=this.getValueInRange(v.range),D=v.rangeOffset+$;$+=v.text.length-h.length,f[p]={sortIndex:v.sortIndex,identifier:v.identifier,range:y,text:h,textChange:new m.$Jt(v.rangeOffset,h,D,v.text)}}c||f.sort((p,v)=>p.sortIndex-v.sortIndex)}this.g=r,this.h=s,this.j=o;const a=this.t(n);let d=null;if(b&&t.length>0){t.sort(($,p)=>p.lineNumber-$.lineNumber),d=[];for(let $=0,p=t.length;$<p;$++){const v=t[$].lineNumber;if($>0&&t[$-1].lineNumber===v)continue;const y=t[$].oldContent,h=this.getLineContent(v);h.length===0||h===y||O.$of(h)!==-1||d.push(v)}}return this.m.fire(),new N.$Mv(f,a,d)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let b=!1;const g=l[0].range,r=l[l.length-1].range,s=new M.$xt(g.startLineNumber,g.startColumn,r.endLineNumber,r.endColumn);let o=g.startLineNumber,i=g.startColumn;const n=[];for(let a=0,d=l.length;a<d;a++){const $=l[a],p=$.range;b=b||$.forceMoveMarkers,n.push(this.getValueInRange(new M.$xt(o,i,p.startLineNumber,p.startColumn))),$.text.length>0&&n.push($.text),o=p.endLineNumber,i=p.endColumn}const c=n.join(""),[u,t,f]=(0,w.$4t)(c);return{sortIndex:0,identifier:l[0].identifier,range:s,rangeOffset:this.getOffsetAt(s.startLineNumber,s.startColumn),rangeLength:this.getValueLengthInRange(s,0),text:c,eolCount:u,firstLineLength:t,lastLineLength:f,forceMoveMarkers:b,isAutoWhitespaceEdit:!1}}t(l){l.sort(T.w);const b=[];for(let g=0;g<l.length;g++){const r=l[g],s=r.range.startLineNumber,o=r.range.startColumn,i=r.range.endLineNumber,n=r.range.endColumn;if(s===i&&o===n&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const c=new M.$xt(s,o,i,n);b.push({range:c,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return b}findMatchesLineByLine(l,b,g,r){return this.c.findMatchesLineByLine(l,b,g,r)}getPieceTree(){return this.c}static _getInverseEditRange(l,b){const g=l.startLineNumber,r=l.startColumn,[s,o,i]=(0,w.$4t)(b);let n;if(b.length>0){const c=s+1;c===1?n=new M.$xt(g,r,g,r+o):n=new M.$xt(g,r,g+c-1,i+1)}else n=new M.$xt(g,r,g,r);return n}static _getInverseEditRanges(l){const b=[];let g=0,r=0,s=null;for(let o=0,i=l.length;o<i;o++){const n=l[o];let c,u;s?s.range.endLineNumber===n.range.startLineNumber?(c=g,u=r+(n.range.startColumn-s.range.endColumn)):(c=g+(n.range.startLineNumber-s.range.endLineNumber),u=n.range.startColumn):(c=n.range.startLineNumber,u=n.range.startColumn);let t;if(n.text.length>0){const f=n.eolCount+1;f===1?t=new M.$xt(c,u,c,u+n.firstLineLength):t=new M.$xt(c,u,c+f-1,n.lastLineLength+1)}else t=new M.$xt(c,u,c,u);g=t.endLineNumber,r=t.endColumn,b.push(t),s=n}return b}static u(l,b){const g=M.$xt.compareRangesUsingEnds(l.range,b.range);return g===0?l.sortIndex-b.sortIndex:g}static w(l,b){const g=M.$xt.compareRangesUsingEnds(l.range,b.range);return g===0?b.sortIndex-l.sortIndex:-g}}e.$4C=T}),define(Se[156],Ie([1,0,13,93,155]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5C=void 0;class N{constructor(m,E,T,S,l,b,g,r,s){this.a=m,this.b=E,this.c=T,this.d=S,this.e=l,this.f=b,this.g=g,this.h=r,this.j=s}k(m){const E=this.c+this.d+this.e,T=this.c+this.e;return E===0?m===1?`
`:`\r
`:T>E/2?`\r
`:`
`}create(m){const E=this.k(m),T=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let l=0,b=T.length;l<b;l++){const g=T[l].buffer.replace(/\r\n|\r|\n/g,E),r=(0,O.$YC)(g);T[l]=new O.$2C(g,r)}const S=new M.$4C(T,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(m){return this.a[0].buffer.substr(0,m).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(m){if(m.length===0)return;this.a.length===0&&C.$Yf(m)&&(this.b=C.$Xf,m=m.substr(1));const E=m.charCodeAt(m.length-1);E===13||E>=55296&&E<=56319?(this.m(m.substr(0,m.length-1),!1),this.c=!0,this.d=E):(this.m(m,!1),this.c=!1,this.d=E)}m(m,E){!E&&m.length===0||(this.c?this.n(String.fromCharCode(this.d)+m):this.n(m))}n(m){const E=(0,O.$ZC)(this.e,m);this.a.push(new O.$2C(m,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=C.$Nf(m)),this.k||(this.k=C.$Qf(m)))}finish(m=!0){return this.o(),new N(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,m)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const m=this.a[this.a.length-1];m.buffer+=String.fromCharCode(this.d);const E=(0,O.$YC)(m.buffer);m.lineStarts=E,this.d===13&&this.f++}}}e.$5C=R}),define(Se[98],Ie([1,0,22,23]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abb=m,e.$Bbb=T;var M;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(M||(M={}));function N(S){for(let l=0,b=S.length;l<b;l+=4){const g=S[l+0],r=S[l+1],s=S[l+2],o=S[l+3];S[l+0]=o,S[l+1]=s,S[l+2]=r,S[l+3]=g}}function R(S){const l=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return O.$D()||N(l),C.$He.wrap(l)}function w(S){const l=S.buffer;if(O.$D()||N(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const b=new Uint8Array(l.byteLength);return b.set(l),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function m(S){const l=new Uint32Array(E(S));let b=0;if(l[b++]=S.id,S.type==="full")l[b++]=1,l[b++]=S.data.length,l.set(S.data,b),b+=S.data.length;else{l[b++]=2,l[b++]=S.deltas.length;for(const g of S.deltas)l[b++]=g.start,l[b++]=g.deleteCount,g.data?(l[b++]=g.data.length,l.set(g.data,b),b+=g.data.length):l[b++]=0}return R(l)}function E(S){let l=0;if(l+=2,S.type==="full")l+=1+S.data.length;else{l+=1,l+=3*S.deltas.length;for(const b of S.deltas)b.data&&(l+=b.data.length)}return l}function T(S){const l=w(S);let b=0;const g=l[b++];if(l[b++]===1){const i=l[b++],n=l.subarray(b,b+i);return b+=i,{id:g,type:"full",data:n}}const s=l[b++],o=[];for(let i=0;i<s;i++){const n=l[b++],c=l[b++],u=l[b++];let t;u>0&&(t=l.subarray(b,b+u),b+=u),o[i]={start:n,deleteCount:c,data:t}}return{id:g,type:"delta",deltas:o}}}),define(Se[157],Ie([9,10]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(Se[158],Ie([1,0,18,26,23,140,159,157]),function(le,e,C,O,M,N,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=s,e.clampedInt=i,e.clampedFloat=c,e.stringSet=f,e.cursorStyleToString=k,e.filterValidationDecorations=ce;var m;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(m||(e.EditorAutoIndentStrategy=m={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=E;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class S{constructor(X,$e,Ke,be){this.id=X,this.name=$e,this.defaultValue=Ke,this.schema=be}applyUpdate(X,$e){return b(X,$e)}compute(X,$e,Ke){return Ke}}class l{constructor(X,$e){this.newValue=X,this.didChange=$e}}e.ApplyUpdateResult=l;function b(Z,X){if(typeof Z!="object"||typeof X!="object"||!Z||!X)return new l(X,Z!==X);if(Array.isArray(Z)||Array.isArray(X)){const Ke=Array.isArray(Z)&&Array.isArray(X)&&C.$ub(Z,X);return new l(X,!Ke)}let $e=!1;for(const Ke in X)if(X.hasOwnProperty(Ke)){const be=b(Z[Ke],X[Ke]);be.didChange&&(Z[Ke]=be.newValue,$e=!0)}return new l(Z,$e)}class g{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,$e){return b(X,$e)}validate(X){return this.defaultValue}}class r{constructor(X,$e,Ke,be){this.id=X,this.name=$e,this.defaultValue=Ke,this.schema=be}applyUpdate(X,$e){return b(X,$e)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,$e,Ke){return Ke}}function s(Z,X){return typeof Z>"u"?X:Z==="false"?!1:!!Z}class o extends r{constructor(X,$e,Ke,be=void 0){typeof be<"u"&&(be.type="boolean",be.default=Ke),super(X,$e,Ke,be)}validate(X){return s(X,this.defaultValue)}}function i(Z,X,$e,Ke){if(typeof Z>"u")return X;let be=parseInt(Z,10);return isNaN(be)?X:(be=Math.max($e,be),be=Math.min(Ke,be),be|0)}class n extends r{static clampedInt(X,$e,Ke,be){return i(X,$e,Ke,be)}constructor(X,$e,Ke,be,st,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=Ke,dt.minimum=be,dt.maximum=st),super(X,$e,Ke,dt),this.minimum=be,this.maximum=st}validate(X){return n.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function c(Z,X,$e,Ke){if(typeof Z>"u")return X;const be=u.float(Z,X);return u.clamp(be,$e,Ke)}class u extends r{static clamp(X,$e,Ke){return X<$e?$e:X>Ke?Ke:X}static float(X,$e){if(typeof X=="number")return X;if(typeof X>"u")return $e;const Ke=parseFloat(X);return isNaN(Ke)?$e:Ke}constructor(X,$e,Ke,be,st){typeof st<"u"&&(st.type="number",st.default=Ke),super(X,$e,Ke,st),this.validationFn=be}validate(X){return this.validationFn(u.float(X,this.defaultValue))}}class t extends r{static string(X,$e){return typeof X!="string"?$e:X}constructor(X,$e,Ke,be=void 0){typeof be<"u"&&(be.type="string",be.default=Ke),super(X,$e,Ke,be)}validate(X){return t.string(X,this.defaultValue)}}function f(Z,X,$e,Ke){return typeof Z!="string"?X:Ke&&Z in Ke?Ke[Z]:$e.indexOf(Z)===-1?X:Z}class a extends r{constructor(X,$e,Ke,be,st=void 0){typeof st<"u"&&(st.type="string",st.enum=be,st.default=Ke),super(X,$e,Ke,st),this.c=be}validate(X){return f(X,this.defaultValue,this.c)}}class d extends S{constructor(X,$e,Ke,be,st,dt,Ct=void 0){typeof Ct<"u"&&(Ct.type="string",Ct.enum=st,Ct.default=be),super(X,$e,Ke,Ct),this.c=st,this.d=dt}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function $(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",tags:["accessibility"],description:w.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,$e,Ke){return Ke===0?X.accessibilitySupport:Ke}}class v extends S{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:w.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{insertSpace:s($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:s($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var y;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(y||(e.TextEditorCursorBlinkingStyle=y={}));function h(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var D;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(D||(e.TextEditorCursorStyle=D={}));function k(Z){switch(Z){case D.Line:return"line";case D.Block:return"block";case D.Underline:return"underline";case D.LineThin:return"line-thin";case D.BlockOutline:return"block-outline";case D.UnderlineThin:return"underline-thin"}}function I(Z){switch(Z){case"line":return D.Line;case"block":return D.Block;case"underline":return D.Underline;case"line-thin":return D.LineThin;case"block-outline":return D.BlockOutline;case"underline-thin":return D.UnderlineThin}}class P extends g{constructor(){super(142)}compute(X,$e,Ke){const be=["monaco-editor"];return $e.get(39)&&be.push($e.get(39)),X.extraEditorClassName&&be.push(X.extraEditorClassName),$e.get(74)==="default"?be.push("mouse-default"):$e.get(74)==="copy"&&be.push("mouse-copy"),$e.get(111)&&be.push("showUnused"),$e.get(140)&&be.push("showDeprecated"),be.join(" ")}}class V extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(X,$e,Ke){return Ke&&X.emptySelectionClipboard}}class W extends S{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[w.localize(8,null),w.localize(9,null),w.localize(10,null)],description:w.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[w.localize(12,null),w.localize(13,null),w.localize(14,null)],description:w.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:w.localize(16,null),included:M.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:w.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:w.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{cursorMoveOnType:s($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":f($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":f($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:s($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:s($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:s($e.loop,this.defaultValue.loop)}}}class q extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:w.localize(19,null)},{type:"string",description:w.localize(20,null)}],description:w.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"||X.length===0?q.OFF:X==="true"?q.ON:X:X?q.ON:q.OFF}}e.EditorFontLigatures=q;class A extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",A.OFF,{anyOf:[{type:"boolean",description:w.localize(22,null)},{type:"string",description:w.localize(23,null)}],description:w.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?A.OFF:X==="true"?A.TRANSLATE:X:X?A.TRANSLATE:A.OFF}compute(X,$e,Ke){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=A;class z extends g{constructor(){super(50)}compute(X,$e,Ke){return X.fontInfo}}class G extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(25,null)})}validate(X){const $e=u.float(X,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp($e,6,100)}compute(X,$e,Ke){return X.fontInfo.fontSize}}class ie extends S{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ie.d,maximum:ie.e,errorMessage:w.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ie.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(n.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,ie.d,ie.e))}}class de extends S{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[w.localize(28,null),w.localize(29,null),w.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:w.localize(32,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:w.localize(33,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:w.localize(34,null),...$e},"editor.gotoLocation.multipleImplementations":{description:w.localize(35,null),...$e},"editor.gotoLocation.multipleReferences":{description:w.localize(36,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Ke,description:w.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Ke,description:w.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Ke,description:w.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Ke,description:w.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Ke,description:w.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{multiple:f($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??f($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??f($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??f($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??f($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??f($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends S{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:w.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:w.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:w.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:w.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:w.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:s($e.enabled,this.defaultValue.enabled),delay:n.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:s($e.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt($e.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:s($e.above,this.defaultValue.above)}}}var Ee;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(Ee||(e.RenderMinimap=Ee={}));class ge extends g{constructor(){super(145)}compute(X,$e,Ke){return ge.computeLayout($e,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const $e=X.height/X.lineHeight,Ke=Math.floor(X.paddingTop/X.lineHeight);let be=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(be=Math.max(be,$e-1));const st=(Ke+X.viewLineCount+be)/(X.pixelRatio*X.height),dt=Math.floor(X.viewLineCount/st);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:be,desiredRatio:st,minimapLineCount:dt}}static c(X,$e){const Ke=X.outerWidth,be=X.outerHeight,st=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:be};const dt=$e.stableMinimapLayoutInput,Ct=dt&&X.outerHeight===dt.outerHeight&&X.lineHeight===dt.lineHeight&&X.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&X.pixelRatio===dt.pixelRatio&&X.scrollBeyondLastLine===dt.scrollBeyondLastLine&&X.paddingTop===dt.paddingTop&&X.paddingBottom===dt.paddingBottom&&X.minimap.enabled===dt.minimap.enabled&&X.minimap.side===dt.minimap.side&&X.minimap.size===dt.minimap.size&&X.minimap.showSlider===dt.minimap.showSlider&&X.minimap.renderCharacters===dt.minimap.renderCharacters&&X.minimap.maxColumn===dt.minimap.maxColumn&&X.minimap.scale===dt.minimap.scale&&X.verticalScrollbarWidth===dt.verticalScrollbarWidth&&X.isViewportWrapping===dt.isViewportWrapping,Vt=X.lineHeight,Qt=X.typicalHalfwidthCharacterWidth,ii=X.scrollBeyondLastLine,Xt=X.minimap.renderCharacters;let Et=st>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Zt=X.minimap.maxColumn,Yt=X.minimap.size,Ze=X.minimap.side,si=X.verticalScrollbarWidth,Ht=X.viewLineCount,ht=X.remainingWidth,mt=X.isViewportWrapping,xt=Xt?2:3;let Gt=Math.floor(st*be);const Nt=Gt/st;let ft=!1,Bt=!1,_t=xt*Et,zt=Et/st,Qe=1;if(Yt==="fill"||Yt==="fit"){const{typicalViewportLineCount:Rt,extraLinesBeforeFirstLine:ei,extraLinesBeyondLastLine:Wt,desiredRatio:oi,minimapLineCount:Ot}=ge.computeContainedMinimapLineCount({viewLineCount:Ht,scrollBeyondLastLine:ii,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:be,lineHeight:Vt,pixelRatio:st});if(Ht/Ot>1)ft=!0,Bt=!0,Et=1,_t=1,zt=Et/st;else{let At=!1,St=Et+1;if(Yt==="fit"){const $t=Math.ceil((ei+Ht+Wt)*_t);mt&&Ct&&ht<=$e.stableFitRemainingWidth?(At=!0,St=$e.stableFitMaxMinimapScale):At=$t>Gt}if(Yt==="fill"||At){ft=!0;const $t=Et;_t=Math.min(Vt*st,Math.max(1,Math.floor(1/oi))),mt&&Ct&&ht<=$e.stableFitRemainingWidth&&(St=$e.stableFitMaxMinimapScale),Et=Math.min(St,Math.max(1,Math.floor(_t/xt))),Et>$t&&(Qe=Math.min(2,Et/$t)),zt=Et/st/Qe,Gt=Math.ceil(Math.max(Rt,ei+Ht+Wt)*_t),mt?($e.stableMinimapLayoutInput=X,$e.stableFitRemainingWidth=ht,$e.stableFitMaxMinimapScale=Et):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const ui=Math.floor(Zt*zt),Jt=Math.min(ui,Math.max(0,Math.floor((ht-si-2)*zt/(Qt+zt)))+e.MINIMAP_GUTTER_WIDTH);let jt=Math.floor(st*Jt);const wt=jt/st;jt=Math.floor(jt*Qe);const Ut=Xt?1:2,Mt=Ze==="left"?0:Ke-Jt-si;return{renderMinimap:Ut,minimapLeft:Mt,minimapWidth:Jt,minimapHeightIsEditorHeight:ft,minimapIsSampling:Bt,minimapScale:Et,minimapLineHeight:_t,minimapCanvasInnerWidth:jt,minimapCanvasInnerHeight:Gt,minimapCanvasOuterWidth:wt,minimapCanvasOuterHeight:Nt}}static computeLayout(X,$e){const Ke=$e.outerWidth|0,be=$e.outerHeight|0,st=$e.lineHeight|0,dt=$e.lineNumbersDigitCount|0,Ct=$e.typicalHalfwidthCharacterWidth,Vt=$e.maxDigitWidth,Qt=$e.pixelRatio,ii=$e.viewLineCount,Xt=X.get(137),Et=Xt==="inherit"?X.get(136):Xt,Zt=Et==="inherit"?X.get(132):Et,Yt=X.get(135),Ze=$e.isDominatedByLongLines,si=X.get(57),Ht=X.get(68).renderType!==0,ht=X.get(69),mt=X.get(105),xt=X.get(84),Gt=X.get(73),Nt=X.get(103),ft=Nt.verticalScrollbarSize,Bt=Nt.verticalHasArrows,_t=Nt.arrowSize,zt=Nt.horizontalScrollbarSize,Qe=X.get(43),ui=X.get(110)!=="never";let Jt=X.get(66);Qe&&ui&&(Jt+=16);let jt=0;if(Ht){const ai=Math.max(dt,ht);jt=Math.round(ai*Vt)}let wt=0;si&&(wt=st*$e.glyphMarginDecorationLaneCount);let Ut=0,Mt=Ut+wt,Rt=Mt+jt,ei=Rt+Jt;const Wt=Ke-wt-jt-Jt;let oi=!1,Ot=!1,qt=-1;Et==="inherit"&&Ze?(oi=!0,Ot=!0):Zt==="on"||Zt==="bounded"?Ot=!0:Zt==="wordWrapColumn"&&(qt=Yt);const At=ge.c({outerWidth:Ke,outerHeight:be,lineHeight:st,typicalHalfwidthCharacterWidth:Ct,pixelRatio:Qt,scrollBeyondLastLine:mt,paddingTop:xt.top,paddingBottom:xt.bottom,minimap:Gt,verticalScrollbarWidth:ft,viewLineCount:ii,remainingWidth:Wt,isViewportWrapping:Ot},$e.memory||new T);At.renderMinimap!==0&&At.minimapLeft===0&&(Ut+=At.minimapWidth,Mt+=At.minimapWidth,Rt+=At.minimapWidth,ei+=At.minimapWidth);const St=Wt-At.minimapWidth,$t=Math.max(1,Math.floor((St-ft-2)/Ct)),Dt=Bt?_t:0;return Ot&&(qt=Math.max(1,$t),Zt==="bounded"&&(qt=Math.min(qt,Yt))),{width:Ke,height:be,glyphMarginLeft:Ut,glyphMarginWidth:wt,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:Mt,lineNumbersWidth:jt,decorationsLeft:Rt,decorationsWidth:Jt,contentLeft:ei,contentWidth:St,minimap:At,viewportColumn:$t,isWordWrapMinified:oi,isViewportWrapping:Ot,wrappingColumn:qt,verticalScrollbarWidth:ft,horizontalScrollbarHeight:zt,overviewRuler:{top:Dt,width:ft,height:be-2*Dt,right:0}}}}e.EditorLayoutInfoComputer=ge;class ue extends S{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[w.localize(47,null),w.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:w.localize(49,null)}})}validate(X){return f(X,"simple",["simple","advanced"])}compute(X,$e,Ke){return $e.get(2)===2?"advanced":Ke}}var Ce;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(Ce||(e.ShowLightbulbIconMode=Ce={}));class se extends S{constructor(){const X={enabled:Ce.On};super(65,"lightbulb",X,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Ce.Off,Ce.OnCode,Ce.On],default:X.enabled,enumDescriptions:[w.localize(50,null),w.localize(51,null),w.localize(52,null)],description:w.localize(53,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:f(X.enabled,this.defaultValue.enabled,[Ce.Off,Ce.OnCode,Ce.On])}}}class Oe extends S{constructor(){const X={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:w.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:20,description:w.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:w.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:w.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:s($e.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:s($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends S{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:w.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[w.localize(59,null),w.localize(60,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),w.localize(61,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),w.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:w.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:w.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:w.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:f($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string($e.fontFamily,this.defaultValue.fontFamily),padding:s($e.padding,this.defaultValue.padding)}}}class j extends S{constructor(){super(66,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):n.clampedInt(X,this.defaultValue,0,1e3)}compute(X,$e,Ke){return Ke<0?n.clampedInt(-Ke*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class x extends u{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>u.clamp(X,0,150),{markdownDescription:w.localize(66,null)})}compute(X,$e,Ke){return X.fontInfo.lineHeight}}class ve extends S{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:w.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:w.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(69,null),w.localize(70,null),w.localize(71,null)],default:X.size,description:w.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:w.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:w.localize(74,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:w.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:w.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:X.showRegionSectionHeaders,description:w.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:X.showMarkSectionHeaders,description:w.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:X.sectionHeaderFontSize,description:w.localize(80,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:s($e.enabled,this.defaultValue.enabled),autohide:s($e.autohide,this.defaultValue.autohide),size:f($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:f($e.side,this.defaultValue.side,["right","left"]),showSlider:f($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:s($e.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt($e.scale,1,1,3),maxColumn:n.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:s($e.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:s($e.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:u.clamp($e.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Fe(Z){return Z==="ctrlCmd"?M.$j?"metaKey":"ctrlKey":"altKey"}class ke extends S{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(82,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{top:n.clampedInt($e.top,0,0,1e3),bottom:n.clampedInt($e.bottom,0,0,1e3)}}}class we extends S{constructor(){const X={enabled:!0,cycle:!0};super(86,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:w.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:w.localize(84,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:s($e.enabled,this.defaultValue.enabled),cycle:s($e.cycle,this.defaultValue.cycle)}}}class me extends g{constructor(){super(143)}compute(X,$e,Ke){return X.pixelRatio}}class Q extends S{constructor(){const X={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[w.localize(85,null),w.localize(86,null),w.localize(87,null)]}];super(89,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:X.strings,description:w.localize(88,null)},comments:{anyOf:$e,default:X.comments,description:w.localize(89,null)},other:{anyOf:$e,default:X.other,description:w.localize(90,null)}},default:X,markdownDescription:w.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Qt=X?"on":"off";return{comments:Qt,strings:Qt,other:Qt}}if(!X||typeof X!="object")return this.defaultValue;const{other:$e,comments:Ke,strings:be}=X,st=["on","inline","off"];let dt,Ct,Vt;return typeof $e=="boolean"?dt=$e?"on":"off":dt=f($e,this.defaultValue.other,st),typeof Ke=="boolean"?Ct=Ke?"on":"off":Ct=f(Ke,this.defaultValue.comments,st),typeof be=="boolean"?Vt=be?"on":"off":Vt=f(be,this.defaultValue.strings,st),{other:dt,comments:Ct,strings:Vt}}}var Y;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class he extends S{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(92,null),w.localize(93,null),w.localize(94,null),w.localize(95,null)],default:"on",description:w.localize(96,null)})}validate(X){let $e=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?($e=4,Ke=X):X==="interval"?$e=3:X==="relative"?$e=2:X==="on"?$e=1:$e=0),{renderType:$e,renderFn:Ke}}}function ce(Z){const X=Z.get(98);return X==="editable"?Z.get(91):X!=="on"}class Ne extends S{constructor(){const X=[],$e={type:"number",description:w.localize(97,null)};super(102,"rulers",X,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:w.localize(98,null),format:"color-hex"}}}]},default:X,description:w.localize(99,null)})}validate(X){if(Array.isArray(X)){const $e=[];for(const Ke of X)if(typeof Ke=="number")$e.push({column:n.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const be=Ke;$e.push({column:n.clampedInt(be.column,0,0,1e4),color:be.color})}return $e.sort((Ke,be)=>Ke.column-be.column),$e}return this.defaultValue}}class fe extends S{constructor(){super(92,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function Pe(Z,X){if(typeof Z!="string")return X;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends S{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(100,null),w.localize(101,null),w.localize(102,null)],default:"auto",description:w.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(104,null),w.localize(105,null),w.localize(106,null)],default:"auto",description:w.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:w.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:w.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:w.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:X.ignoreHorizontalScrollbarInContentHeight,description:w.localize(111,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X,Ke=n.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),be=n.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe($e.vertical,this.defaultValue.vertical),horizontal:Pe($e.horizontal,this.defaultValue.horizontal),useShadows:s($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:s($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:s($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:s($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:s($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:n.clampedInt($e.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:be,verticalSliderSize:n.clampedInt($e.verticalSliderSize,be,0,1e3),scrollByPage:s($e.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:s($e.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Ue extends S{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:w.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:w.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:w.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:w.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:w.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:w.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:w.localize(118,null)}})}applyUpdate(X,$e){let Ke=!1;$e.allowedCharacters&&X&&(O.$9n(X.allowedCharacters,$e.allowedCharacters)||(X={...X,allowedCharacters:$e.allowedCharacters},Ke=!0)),$e.allowedLocales&&X&&(O.$9n(X.allowedLocales,$e.allowedLocales)||(X={...X,allowedLocales:$e.allowedLocales},Ke=!0));const be=super.applyUpdate(X,$e);return Ke?new l(be.newValue,!0):be}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{nonBasicASCII:ee($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:s($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:s($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,$e){if(typeof X!="object"||!X)return $e;const Ke={};for(const[be,st]of Object.entries(X))st===!0&&(Ke[be]=!0);return Ke}}class B extends S{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:w.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[w.localize(120,null),w.localize(121,null),w.localize(122,null)],description:w.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:w.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:X.fontFamily,description:w.localize(125,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:s($e.enabled,this.defaultValue.enabled),mode:f($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:s($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:s($e.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string($e.fontFamily,this.defaultValue.fontFamily)}}}class L extends S{constructor(){const X={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",X,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:X.enabled,description:w.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[w.localize(127,null),w.localize(128,null),w.localize(129,null)],description:w.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:X.fontFamily,description:w.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:X.backgroundColoring,description:w.localize(132,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:s($e.enabled,this.defaultValue.enabled),showToolbar:f($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string($e.fontFamily,this.defaultValue.fontFamily),keepOnBlur:s($e.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:s($e.backgroundColoring,this.defaultValue.backgroundColoring)}}}class K extends S{constructor(){const X={enabled:N.$7s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:N.$7s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:w.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:w.localize(134,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:s($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:s($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends S{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(135,null),w.localize(136,null),w.localize(137,null)],default:X.bracketPairs,description:w.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(139,null),w.localize(140,null),w.localize(141,null)],default:X.bracketPairsHorizontal,description:w.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:w.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:w.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[w.localize(145,null),w.localize(146,null),w.localize(147,null)],default:X.highlightActiveIndentation,description:w.localize(148,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{bracketPairs:ee($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:s($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:s($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(Z,X,$e){const Ke=$e.indexOf(Z);return Ke===-1?X:$e[Ke]}class re extends S{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(149,null),w.localize(150,null)],default:X.insertMode,description:w.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:w.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:w.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:w.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[w.localize(155,null),w.localize(156,null),w.localize(157,null),w.localize(158,null)],default:X.selectionMode,markdownDescription:w.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:w.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:w.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:w.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:w.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:w.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:w.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:w.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(196,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{insertMode:f($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:s($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:s($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:s($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:s($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:s($e.showIcons,this.defaultValue.showIcons),showStatusBar:s($e.showStatusBar,this.defaultValue.showStatusBar),preview:s($e.preview,this.defaultValue.preview),previewMode:f($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:s($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:s($e.showMethods,this.defaultValue.showMethods),showFunctions:s($e.showFunctions,this.defaultValue.showFunctions),showConstructors:s($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:s($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:s($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:s($e.showFields,this.defaultValue.showFields),showVariables:s($e.showVariables,this.defaultValue.showVariables),showClasses:s($e.showClasses,this.defaultValue.showClasses),showStructs:s($e.showStructs,this.defaultValue.showStructs),showInterfaces:s($e.showInterfaces,this.defaultValue.showInterfaces),showModules:s($e.showModules,this.defaultValue.showModules),showProperties:s($e.showProperties,this.defaultValue.showProperties),showEvents:s($e.showEvents,this.defaultValue.showEvents),showOperators:s($e.showOperators,this.defaultValue.showOperators),showUnits:s($e.showUnits,this.defaultValue.showUnits),showValues:s($e.showValues,this.defaultValue.showValues),showConstants:s($e.showConstants,this.defaultValue.showConstants),showEnums:s($e.showEnums,this.defaultValue.showEnums),showEnumMembers:s($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:s($e.showKeywords,this.defaultValue.showKeywords),showWords:s($e.showWords,this.defaultValue.showWords),showColors:s($e.showColors,this.defaultValue.showColors),showFiles:s($e.showFiles,this.defaultValue.showFiles),showReferences:s($e.showReferences,this.defaultValue.showReferences),showFolders:s($e.showFolders,this.defaultValue.showFolders),showTypeParameters:s($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:s($e.showSnippets,this.defaultValue.showSnippets),showUsers:s($e.showUsers,this.defaultValue.showUsers),showIssues:s($e.showIssues,this.defaultValue.showIssues)}}}class Te extends S{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:w.localize(198,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:s(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:s(X.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends S{constructor(){const X=[];super(130,"wordSegmenterLocales",X,{anyOf:[{description:w.localize(199,null),type:"string"},{description:w.localize(200,null),type:"array",items:{type:"string"}}]})}validate(X){if(typeof X=="string"&&(X=[X]),Array.isArray(X)){const $e=[];for(const Ke of X)if(typeof Ke=="string")try{Intl.Segmenter.supportedLocalesOf(Ke).length>0&&$e.push(Ke)}catch{}return $e}return this.defaultValue}}var He;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class _e extends S{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[w.localize(201,null),w.localize(202,null),w.localize(203,null),w.localize(204,null)],description:w.localize(205,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,$e,Ke){return $e.get(2)===2?0:Ke}}class xe extends g{constructor(){super(146)}compute(X,$e,Ke){const be=$e.get(145);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:be.isWordWrapMinified,isViewportWrapping:be.isViewportWrapping,wrappingColumn:be.wrappingColumn}}}class et extends S{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:w.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:w.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[w.localize(208,null),w.localize(209,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:s($e.enabled,this.defaultValue.enabled),showDropSelector:f($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends S{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:w.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:w.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[w.localize(212,null),w.localize(213,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:s($e.enabled,this.defaultValue.enabled),showPasteSelector:f($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const it="Consolas, 'Courier New', monospace",ot="Menlo, Monaco, 'Courier New', monospace",gt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:M.$j?ot:M.$k?gt:it,fontWeight:"normal",fontSize:M.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var rt;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.inlineEdit=63]="inlineEdit",Z[Z.letterSpacing=64]="letterSpacing",Z[Z.lightbulb=65]="lightbulb",Z[Z.lineDecorationsWidth=66]="lineDecorationsWidth",Z[Z.lineHeight=67]="lineHeight",Z[Z.lineNumbers=68]="lineNumbers",Z[Z.lineNumbersMinChars=69]="lineNumbersMinChars",Z[Z.linkedEditing=70]="linkedEditing",Z[Z.links=71]="links",Z[Z.matchBrackets=72]="matchBrackets",Z[Z.minimap=73]="minimap",Z[Z.mouseStyle=74]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=76]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=78]="multiCursorModifier",Z[Z.multiCursorPaste=79]="multiCursorPaste",Z[Z.multiCursorLimit=80]="multiCursorLimit",Z[Z.occurrencesHighlight=81]="occurrencesHighlight",Z[Z.overviewRulerBorder=82]="overviewRulerBorder",Z[Z.overviewRulerLanes=83]="overviewRulerLanes",Z[Z.padding=84]="padding",Z[Z.pasteAs=85]="pasteAs",Z[Z.parameterHints=86]="parameterHints",Z[Z.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=89]="quickSuggestions",Z[Z.quickSuggestionsDelay=90]="quickSuggestionsDelay",Z[Z.readOnly=91]="readOnly",Z[Z.readOnlyMessage=92]="readOnlyMessage",Z[Z.renameOnType=93]="renameOnType",Z[Z.renderControlCharacters=94]="renderControlCharacters",Z[Z.renderFinalNewline=95]="renderFinalNewline",Z[Z.renderLineHighlight=96]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=98]="renderValidationDecorations",Z[Z.renderWhitespace=99]="renderWhitespace",Z[Z.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Z[Z.roundedSelection=101]="roundedSelection",Z[Z.rulers=102]="rulers",Z[Z.scrollbar=103]="scrollbar",Z[Z.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=105]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=106]="scrollPredominantAxis",Z[Z.selectionClipboard=107]="selectionClipboard",Z[Z.selectionHighlight=108]="selectionHighlight",Z[Z.selectOnLineNumbers=109]="selectOnLineNumbers",Z[Z.showFoldingControls=110]="showFoldingControls",Z[Z.showUnused=111]="showUnused",Z[Z.snippetSuggestions=112]="snippetSuggestions",Z[Z.smartSelect=113]="smartSelect",Z[Z.smoothScrolling=114]="smoothScrolling",Z[Z.stickyScroll=115]="stickyScroll",Z[Z.stickyTabStops=116]="stickyTabStops",Z[Z.stopRenderingLineAfter=117]="stopRenderingLineAfter",Z[Z.suggest=118]="suggest",Z[Z.suggestFontSize=119]="suggestFontSize",Z[Z.suggestLineHeight=120]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Z[Z.suggestSelection=122]="suggestSelection",Z[Z.tabCompletion=123]="tabCompletion",Z[Z.tabIndex=124]="tabIndex",Z[Z.unicodeHighlighting=125]="unicodeHighlighting",Z[Z.unusualLineTerminators=126]="unusualLineTerminators",Z[Z.useShadowDOM=127]="useShadowDOM",Z[Z.useTabStops=128]="useTabStops",Z[Z.wordBreak=129]="wordBreak",Z[Z.wordSegmenterLocales=130]="wordSegmenterLocales",Z[Z.wordSeparators=131]="wordSeparators",Z[Z.wordWrap=132]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=135]="wordWrapColumn",Z[Z.wordWrapOverride1=136]="wordWrapOverride1",Z[Z.wordWrapOverride2=137]="wordWrapOverride2",Z[Z.wrappingIndent=138]="wrappingIndent",Z[Z.wrappingStrategy=139]="wrappingStrategy",Z[Z.showDeprecated=140]="showDeprecated",Z[Z.inlayHints=141]="inlayHints",Z[Z.editorClassName=142]="editorClassName",Z[Z.pixelRatio=143]="pixelRatio",Z[Z.tabFocusMode=144]="tabFocusMode",Z[Z.layoutInfo=145]="layoutInfo",Z[Z.wrappingInfo=146]="wrappingInfo",Z[Z.defaultColorDecorators=147]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(rt||(e.EditorOption=rt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(214,null)})),acceptSuggestionOnEnter:je(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(215,null),""],markdownDescription:w.localize(216,null)})),accessibilitySupport:je(new p),accessibilityPageSize:je(new n(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(217,null),tags:["accessibility"]})),ariaLabel:je(new t(4,"ariaLabel",w.localize(218,null))),ariaRequired:je(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:w.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:je(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(220,null),w.localize(221,null),""],description:w.localize(222,null)})),autoClosingComments:je(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(223,null),w.localize(224,null),""],description:w.localize(225,null)})),autoClosingDelete:je(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(226,null),""],description:w.localize(227,null)})),autoClosingOvertype:je(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(228,null),""],description:w.localize(229,null)})),autoClosingQuotes:je(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(230,null),w.localize(231,null),""],description:w.localize(232,null)})),autoIndent:je(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],$,{enumDescriptions:[w.localize(233,null),w.localize(234,null),w.localize(235,null),w.localize(236,null),w.localize(237,null)],description:w.localize(238,null)})),automaticLayout:je(new o(13,"automaticLayout",!1)),autoSurround:je(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(239,null),w.localize(240,null),w.localize(241,null),""],description:w.localize(242,null)})),bracketPairColorization:je(new K),bracketPairGuides:je(new H),stickyTabStops:je(new o(116,"stickyTabStops",!1,{description:w.localize(243,null)})),codeLens:je(new o(17,"codeLens",!0,{description:w.localize(244,null)})),codeLensFontFamily:je(new t(18,"codeLensFontFamily","",{description:w.localize(245,null)})),codeLensFontSize:je(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:w.localize(246,null)})),colorDecorators:je(new o(20,"colorDecorators",!0,{description:w.localize(247,null)})),colorDecoratorActivatedOn:je(new a(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[w.localize(248,null),w.localize(249,null),w.localize(250,null)],description:w.localize(251,null)})),colorDecoratorsLimit:je(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:w.localize(252,null)})),columnSelection:je(new o(22,"columnSelection",!1,{description:w.localize(253,null)})),comments:je(new v),contextmenu:je(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new o(25,"copyWithSyntaxHighlighting",!0,{description:w.localize(254,null)})),cursorBlinking:je(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:w.localize(255,null)})),cursorSmoothCaretAnimation:je(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[w.localize(256,null),w.localize(257,null),w.localize(258,null)],description:w.localize(259,null)})),cursorStyle:je(new d(28,"cursorStyle",D.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],I,{description:w.localize(260,null)})),cursorSurroundingLines:je(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(261,null)})),cursorSurroundingLinesStyle:je(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(262,null),w.localize(263,null)],markdownDescription:w.localize(264,null)})),cursorWidth:je(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(265,null)})),disableLayerHinting:je(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new o(34,"domReadOnly",!1)),dragAndDrop:je(new o(35,"dragAndDrop",!0,{description:w.localize(266,null)})),emptySelectionClipboard:je(new V),dropIntoEditor:je(new et),stickyScroll:je(new Oe),experimentalWhitespaceRendering:je(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[w.localize(267,null),w.localize(268,null),w.localize(269,null)],description:w.localize(270,null)})),extraEditorClassName:je(new t(39,"extraEditorClassName","")),fastScrollSensitivity:je(new u(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:w.localize(271,null)})),find:je(new W),fixedOverflowWidgets:je(new o(42,"fixedOverflowWidgets",!1)),folding:je(new o(43,"folding",!0,{description:w.localize(272,null)})),foldingStrategy:je(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(273,null),w.localize(274,null)],description:w.localize(275,null)})),foldingHighlight:je(new o(45,"foldingHighlight",!0,{description:w.localize(276,null)})),foldingImportsByDefault:je(new o(46,"foldingImportsByDefault",!1,{description:w.localize(277,null)})),foldingMaximumRegions:je(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:w.localize(278,null)})),unfoldOnClickAfterEndOfLine:je(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(279,null)})),fontFamily:je(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(280,null)})),fontInfo:je(new z),fontLigatures2:je(new q),fontSize:je(new G),fontWeight:je(new ie),fontVariations:je(new A),formatOnPaste:je(new o(55,"formatOnPaste",!1,{description:w.localize(281,null)})),formatOnType:je(new o(56,"formatOnType",!1,{description:w.localize(282,null)})),glyphMargin:je(new o(57,"glyphMargin",!0,{description:w.localize(283,null)})),gotoLocation:je(new de),hideCursorInOverviewRuler:je(new o(59,"hideCursorInOverviewRuler",!1,{description:w.localize(284,null)})),hover:je(new ye),inDiffEditor:je(new o(61,"inDiffEditor",!1)),letterSpacing:je(new u(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>u.clamp(Z,-5,20),{description:w.localize(285,null)})),lightbulb:je(new se),lineDecorationsWidth:je(new j),lineHeight:je(new x),lineNumbers:je(new he),lineNumbersMinChars:je(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new o(70,"linkedEditing",!1,{description:w.localize(286,null)})),links:je(new o(71,"links",!0,{description:w.localize(287,null)})),matchBrackets:je(new a(72,"matchBrackets","always",["always","near","never"],{description:w.localize(288,null)})),minimap:je(new ve),mouseStyle:je(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new u(75,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:w.localize(289,null)})),mouseWheelZoom:je(new o(76,"mouseWheelZoom",!1,{markdownDescription:M.$j?w.localize(290,null):w.localize(291,null)})),multiCursorMergeOverlapping:je(new o(77,"multiCursorMergeOverlapping",!0,{description:w.localize(292,null)})),multiCursorModifier:je(new d(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Fe,{markdownEnumDescriptions:[w.localize(293,null),w.localize(294,null)],markdownDescription:w.localize(295,null)})),multiCursorPaste:je(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(296,null),w.localize(297,null)],markdownDescription:w.localize(298,null)})),multiCursorLimit:je(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:w.localize(299,null)})),occurrencesHighlight:je(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[w.localize(300,null),w.localize(301,null),w.localize(302,null)],markdownDescription:w.localize(303,null)})),overviewRulerBorder:je(new o(82,"overviewRulerBorder",!0,{description:w.localize(304,null)})),overviewRulerLanes:je(new n(83,"overviewRulerLanes",3,0,3)),padding:je(new ke),pasteAs:je(new tt),parameterHints:je(new we),peekWidgetDefaultFocus:je(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(305,null),w.localize(306,null)],description:w.localize(307,null)})),definitionLinkOpensInPeek:je(new o(88,"definitionLinkOpensInPeek",!1,{description:w.localize(308,null)})),quickSuggestions:je(new Q),quickSuggestionsDelay:je(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(309,null)})),readOnly:je(new o(91,"readOnly",!1)),readOnlyMessage:je(new fe),renameOnType:je(new o(93,"renameOnType",!1,{description:w.localize(310,null),markdownDeprecationMessage:w.localize(311,null)})),renderControlCharacters:je(new o(94,"renderControlCharacters",!0,{description:w.localize(312,null),restricted:!0})),renderFinalNewline:je(new a(95,"renderFinalNewline",M.$k?"dimmed":"on",["off","on","dimmed"],{description:w.localize(313,null)})),renderLineHighlight:je(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(314,null)],description:w.localize(315,null)})),renderLineHighlightOnlyWhenFocus:je(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(316,null)})),renderValidationDecorations:je(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(317,null),w.localize(318,null),w.localize(319,null),""],description:w.localize(320,null)})),revealHorizontalRightPadding:je(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new o(101,"roundedSelection",!0,{description:w.localize(321,null)})),rulers:je(new Ne),scrollbar:je(new Ae),scrollBeyondLastColumn:je(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:w.localize(322,null)})),scrollBeyondLastLine:je(new o(105,"scrollBeyondLastLine",!0,{description:w.localize(323,null)})),scrollPredominantAxis:je(new o(106,"scrollPredominantAxis",!0,{description:w.localize(324,null)})),selectionClipboard:je(new o(107,"selectionClipboard",!0,{description:w.localize(325,null),included:M.$k})),selectionHighlight:je(new o(108,"selectionHighlight",!0,{description:w.localize(326,null)})),selectOnLineNumbers:je(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:je(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[w.localize(327,null),w.localize(328,null),w.localize(329,null)],description:w.localize(330,null)})),showUnused:je(new o(111,"showUnused",!0,{description:w.localize(331,null)})),showDeprecated:je(new o(140,"showDeprecated",!0,{description:w.localize(332,null)})),inlayHints:je(new ne),snippetSuggestions:je(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(333,null),w.localize(334,null),w.localize(335,null),w.localize(336,null)],description:w.localize(337,null)})),smartSelect:je(new Te),smoothScrolling:je(new o(114,"smoothScrolling",!1,{description:w.localize(338,null)})),stopRenderingLineAfter:je(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new re),inlineSuggest:je(new B),inlineEdit:je(new L),inlineCompletionsAccessibilityVerbose:je(new o(149,"inlineCompletionsAccessibilityVerbose",!1,{description:w.localize(339,null)})),suggestFontSize:je(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new o(121,"suggestOnTriggerCharacters",!0,{description:w.localize(342,null)})),suggestSelection:je(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(343,null),w.localize(344,null),w.localize(345,null)],description:w.localize(346,null)})),tabCompletion:je(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(347,null),w.localize(348,null),w.localize(349,null)],description:w.localize(350,null)})),tabIndex:je(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new Ue),unusualLineTerminators:je(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(351,null),w.localize(352,null),w.localize(353,null)],description:w.localize(354,null)})),useShadowDOM:je(new o(127,"useShadowDOM",!0)),useTabStops:je(new o(128,"useTabStops",!0,{description:w.localize(355,null)})),wordBreak:je(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[w.localize(356,null),w.localize(357,null)],description:w.localize(358,null)})),wordSegmenterLocales:je(new Be),wordSeparators:je(new t(131,"wordSeparators",R.$8s,{description:w.localize(359,null)})),wordWrap:je(new a(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(360,null),w.localize(361,null),w.localize(362,null),w.localize(363,null)],description:w.localize(364,null)})),wordWrapBreakAfterCharacters:je(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new n(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(365,null)})),wordWrapOverride1:je(new a(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new a(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new P),defaultColorDecorators:je(new o(147,"defaultColorDecorators",!1,{markdownDescription:w.localize(366,null)})),pixelRatio:je(new me),tabFocusMode:je(new o(144,"tabFocusMode",!1,{markdownDescription:w.localize(367,null)})),layoutInfo:je(new ge),wrappingInfo:je(new xe),wrappingIndent:je(new _e),wrappingStrategy:je(new ue)}}),define(Se[160],Ie([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[161],Ie([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[162],Ie([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(Se[163],Ie([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[164],Ie([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[165],Ie([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(Se[166],Ie([9,10]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(Se[167],Ie([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(Se[168],Ie([9,10]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(Se[169],Ie([9,10]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[170],Ie([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[171],Ie([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(Se[172],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[173],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[174],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[175],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Se[176],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[177],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[178],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[179],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[180],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[181],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[182],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[183],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[184],Ie([9,10]),function(le,e){return le.create("vs/workbench/common/configuration",e)}),define(Se[185],Ie([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(Se[186],Ie([9,10]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(Se[187],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Se[188],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[189],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[190],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[191],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[192],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[193],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[194],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[195],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[196],Ie([1,0,14,162]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.TokenType=void 0;var M;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(M||(e.TokenType=M={}));function N(...E){switch(E.length){case 1:return(0,O.localize)(0,null,E[0]);case 2:return(0,O.localize)(1,null,E[0],E[1]);case 3:return(0,O.localize)(2,null,E[0],E[1],E[2]);default:return}}const R=(0,O.localize)(3,null),w=(0,O.localize)(4,null);class m{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,C.$8)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(T=>T.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(T){return this.c=T,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(T){return this.r()||this.c.charCodeAt(this.e)!==T?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(T){this.f.push({type:T,offset:this.d})}l(T){const S=this.d,l=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:l};this.g.push({offset:S,lexeme:l,additionalInfo:T}),this.f.push(b)}n(){this.m.lastIndex=this.d;const T=this.m.exec(this.c);if(T){this.e=this.d+T[0].length;const S=this.c.substring(this.d,this.e),l=m.b.get(S);l?this.k(l):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let T=this.e,S=!1,l=!1;for(;;){if(T>=this.c.length){this.e=T,this.l(w);return}const g=this.c.charCodeAt(T);if(S)S=!1;else if(g===47&&!l){T++;break}else g===91?l=!0:g===92?S=!0:g===93&&(l=!1);T++}for(;T<this.c.length&&m.a.has(this.c.charCodeAt(T));)T++;this.e=T;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$tj=m}),define(Se[197],Ie([1,0,24,32,164,311]),function(le,e,C,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=m,e.$Kp=E,e.$Lp=T,e.$Mp=S,e.$Np=l,e.$Op=b,e.$Pp=g;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function m(o){return o=o.trim(),o==="*"||R.test(o)}function E(o){if(!m(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function T(o){if(!o)return null;const i=o.majorBase,n=o.majorMustEqual,c=o.minorBase;let u=o.minorMustEqual;const t=o.patchBase;let f=o.patchMustEqual;o.hasCaret&&(i===0||(u=!1),f=!1);let a=0;if(o.preRelease){const d=w.exec(o.preRelease);if(d){const[,$,p,v]=d;a=Date.UTC(Number($),Number(p)-1,Number(v))}}return{majorBase:i,majorMustEqual:n,minorBase:c,minorMustEqual:u,patchBase:t,patchMustEqual:f,isMinimum:o.hasGreaterEquals,notBefore:a}}function S(o,i,n){let c;typeof o=="string"?c=T(E(o)):c=o;let u;i instanceof Date?u=i.getTime():typeof i=="string"&&(u=new Date(i).getTime());let t;if(typeof n=="string"?t=T(E(n)):t=n,!c||!t)return!1;const f=c.majorBase,a=c.minorBase,d=c.patchBase;let $=t.majorBase,p=t.minorBase,v=t.patchBase;const y=t.notBefore;let h=t.majorMustEqual,D=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?f>$?!0:f<$?!1:a>p?!0:a<p||u&&u<y?!1:d>=v:(f===1&&$===0&&(!h||!D||!k)&&($=1,p=0,v=0,h=!0,D=!1,k=!1),f<$?!1:f>$?!h:a<p?!1:a>p?!D:d<v?!1:d>v?!k:!(u&&u<y))}function l(o,i,n,c,u){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([O.default.Error,M.localize(0,null)]),t;if(typeof c.name!="string")return t.push([O.default.Error,M.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([O.default.Error,M.localize(2,null,"version")]),t;if(!c.engines)return t.push([O.default.Error,M.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([O.default.Error,M.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!s(c.extensionDependencies))return t.push([O.default.Error,M.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!s(c.activationEvents))return t.push([O.default.Error,M.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([O.default.Error,M.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([O.default.Warning,M.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([O.default.Error,M.localize(9,null,"main")]),t;{const d=(0,C.$_g)(n,c.main);(0,C.$6g)(d,n)||t.push([O.default.Warning,M.localize(10,null,d.path,n.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([O.default.Error,M.localize(11,null,"browser")]),t;{const d=(0,C.$_g)(n,c.browser);(0,C.$6g)(d,n)||t.push([O.default.Warning,M.localize(12,null,d.path,n.path)])}}if(!N.valid(c.version))return t.push([O.default.Error,M.localize(13,null)]),t;const f=[];if(!b(o,i,c,u,f))for(const d of f)t.push([O.default.Error,d]);return t}function b(o,i,n,c,u){return c||typeof n.main>"u"&&typeof n.browser>"u"?!0:r(o,i,n.engines.vscode,u)}function g(o,i,n){return o==="*"||r(i,n,o)}function r(o,i,n,c=[]){const u=T(E(n));if(!u)return c.push(M.localize(14,null,n)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return c.push(M.localize(15,null,n)),!1}else if(!u.majorMustEqual)return c.push(M.localize(16,null,n)),!1;return S(o,i,u)?!0:(c.push(M.localize(17,null,o,n)),!1)}function s(o){if(!Array.isArray(o))return!1;for(let i=0,n=o.length;i<n;i++)if(typeof o[i]!="string")return!1;return!0}}),define(Se[71],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=void 0;class C{constructor(M,N=[],R=!1){this.ctor=M,this.staticArguments=N,this.supportsDelayedInstantiation=R}}e.$vi=C}),define(Se[56],Ie([1,0,71]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$As=N,e.$Bs=R;const O=[];var M;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(M||(e.InstantiationType=M={}));function N(w,m,E){m instanceof C.$vi||(m=new C.$vi(m,[],!!E)),O.push([w,m])}function R(){return O}}),define(Se[198],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=void 0;class C{constructor(N,R){this.key=N,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$dr=C;class O{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const R of this.a.values())R.outgoing.size===0&&N.push(R);return N}insertEdge(N,R){const w=this.lookupOrInsertNode(N),m=this.lookupOrInsertNode(R);w.outgoing.set(m.key,m),m.incoming.set(w.key,w)}removeNode(N){const R=this.b(N);this.a.delete(R);for(const w of this.a.values())w.outgoing.delete(R),w.incoming.delete(R)}lookupOrInsertNode(N){const R=this.b(N);let w=this.a.get(R);return w||(w=new C(R,N),this.a.set(R,w)),w}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[R,w]of this.a)N.push(`${R}
	(-> incoming)[${[...w.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...w.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,R]of this.a){const w=new Set([N]),m=this.c(R,w);if(m)return m}}c(N,R){for(const[w,m]of N.outgoing){if(R.has(w))return[...R,w].join(" -> ");R.add(w);const E=this.c(m,R);if(E)return E;R.delete(w)}}}e.$er=O}),define(Se[3],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e._util=void 0,e.$yi=M,e.$zi=N;var C;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function w(m){return m[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=w})(C||(e._util=C={})),e.$xi=M("instantiationService");function O(R,w,m){w[C.DI_TARGET]===w?w[C.DI_DEPENDENCIES].push({id:R,index:m}):(w[C.DI_DEPENDENCIES]=[{id:R,index:m}],w[C.DI_TARGET]=w)}function M(R){if(C.serviceIds.has(R))return C.serviceIds.get(R);const w=function(m,E,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(w,m,T)};return w.toString=()=>R,C.serviceIds.set(R,w),w}function N(R){return R}}),define(Se[50],Ie([1,0,15,2,3]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$5i=void 0,e.$6i=N,e.$7i=R,e.$8i=m,e.$9i=E,e.$0i=T,e.$$i=S,e.$_i=l,e.$aj=g,e.$bj=r,e.$cj=s,e.$5i=(0,M.$yi)("configurationService");function N(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof O.URI)}function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof O.URI)}var w;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(w||(e.ConfigurationTarget=w={}));function m(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function T(o,i){const n=Object.create(null);for(const c in o)S(n,c,o[c],i);return n}function S(o,i,n,c){const u=i.split("."),t=u.pop();let f=o;for(let a=0;a<u.length;a++){const d=u[a];let $=f[d];switch(typeof $){case"undefined":$=f[d]=Object.create(null);break;case"object":if($===null){c(`Ignoring ${i} as ${u.slice(0,a+1).join(".")} is null`);return}break;default:c(`Ignoring ${i} as ${u.slice(0,a+1).join(".")} is ${JSON.stringify($)}`);return}f=$}if(typeof f=="object"&&f!==null)try{f[t]=n}catch{c(`Ignoring ${i} as ${u.join(".")} is ${JSON.stringify(f)}`)}else c(`Ignoring ${i} as ${u.join(".")} is ${JSON.stringify(f)}`)}function l(o,i){const n=i.split(".");b(o,n)}function b(o,i){const n=i.shift();if(i.length===0){delete o[n];return}if(Object.keys(o).indexOf(n)!==-1){const c=o[n];typeof c=="object"&&!Array.isArray(c)&&(b(c,i),Object.keys(c).length===0&&delete o[n])}}function g(o,i,n){function c(f,a){let d=f;for(const $ of a){if(typeof d!="object"||d===null)return;d=d[$]}return d}const u=i.split("."),t=c(o,u);return typeof t>"u"?n:t}function r(o,i,n){Object.keys(i).forEach(c=>{c!=="__proto__"&&(c in o?C.$ag(o[c])&&C.$ag(i[c])?r(o[c],i[c],n):n&&(o[c]=i[c]):o[c]=i[c])})}function s(o){return o.replace(/[\[\]]/g,"")}}),define(Se[31],Ie([1,0,23,13,196,3,161,14]),function(le,e,C,O,M,N,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$wj=e.$vj=e.ContextKeyExprType=void 0,e.$uj=E,e.$xj=f,e.$yj=a,e.$Rj=Ce;const m=new Map;m.set("false",!1),m.set("true",!0),m.set("isMac",C.$j),m.set("isLinux",C.$k),m.set("isWindows",C.$i),m.set("isWeb",C.$o),m.set("isMacNative",C.$j&&!C.$o),m.set("isEdge",C.$H),m.set("isFirefox",C.$F),m.set("isChrome",C.$E),m.set("isSafari",C.$G);function E(ne,j){if(m.get(ne)!==void 0)throw(0,w.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");m.set(ne,j)}const T=Object.prototype.hasOwnProperty;var S;(function(ne){ne[ne.False=0]="False",ne[ne.True=1]="True",ne[ne.Defined=2]="Defined",ne[ne.Not=3]="Not",ne[ne.Equals=4]="Equals",ne[ne.NotEquals=5]="NotEquals",ne[ne.And=6]="And",ne[ne.Regex=7]="Regex",ne[ne.NotRegex=8]="NotRegex",ne[ne.Or=9]="Or",ne[ne.In=10]="In",ne[ne.NotIn=11]="NotIn",ne[ne.Greater=12]="Greater",ne[ne.GreaterEquals=13]="GreaterEquals",ne[ne.Smaller=14]="Smaller",ne[ne.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const l={regexParsingWithErrorRecovery:!0},b=(0,R.localize)(0,null),g=(0,R.localize)(1,null),r=(0,R.localize)(2,null),s=(0,R.localize)(3,null),o=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),c=(0,R.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(j=l){this.k=j,this.d=new M.$tj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(j){if(j===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(j).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const ve=this.D(),Fe=ve.type===17?i:void 0;throw this.h.push({message:o,offset:ve.offset,lexeme:M.$tj.getLexeme(ve),additionalInfo:Fe}),u.c}return x}catch(x){if(x!==u.c)throw x;return}}l(){return this.m()}m(){const j=[this.o()];for(;this.y(16);){const x=this.o();j.push(x)}return j.length===1?j[0]:t.or(...j)}o(){const j=[this.s()];for(;this.y(15);){const x=this.s();j.push(x)}return j.length===1?j[0]:t.and(...j)}s(){if(this.y(2)){const j=this.D();switch(j.type){case 11:return this.z(),$.INSTANCE;case 12:return this.z(),p.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,s),x?.negate()}case 17:return this.z(),I.create(j.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",j)}}return this.t()}t(){const j=this.D();switch(j.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const x=this.l();return this.A(1,s),x}case 17:{const x=j.lexeme;if(this.z(),this.y(9)){const Fe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Fe.type!==10)throw this.B("REGEX",Fe);const ke=Fe.lexeme,we=ke.lastIndexOf("/"),me=we===ke.length-1?void 0:this.w(ke.substring(we+1));let Q;try{Q=new RegExp(ke.substring(1,we),me)}catch{throw this.B("REGEX",Fe)}return z.create(x,Q)}switch(Fe.type){case 10:case 19:{const ke=[Fe.lexeme];this.z();let we=this.D(),me=0;for(let Ne=0;Ne<Fe.lexeme.length;Ne++)Fe.lexeme.charCodeAt(Ne)===40?me++:Fe.lexeme.charCodeAt(Ne)===41&&me--;for(;!this.E()&&we.type!==15&&we.type!==16;){switch(we.type){case 0:me++;break;case 1:me--;break;case 10:case 18:for(let Ne=0;Ne<we.lexeme.length;Ne++)we.lexeme.charCodeAt(Ne)===40?me++:Fe.lexeme.charCodeAt(Ne)===41&&me--}if(me<0)break;ke.push(M.$tj.getLexeme(we)),this.z(),we=this.D()}const Q=ke.join(""),Y=Q.lastIndexOf("/"),he=Y===Q.length-1?void 0:this.w(Q.substring(Y+1));let ce;try{ce=new RegExp(Q.substring(1,Y),he)}catch{throw this.B("REGEX",Fe)}return t.regex(x,ce)}case 18:{const ke=Fe.lexeme;this.z();let we=null;if(!(0,O.$9e)(ke)){const me=ke.indexOf("/"),Q=ke.lastIndexOf("/");if(me!==Q&&me>=0){const Y=ke.slice(me+1,Q),he=ke[Q+1]==="i"?"i":"";try{we=new RegExp(Y,he)}catch{throw this.B("REGEX",Fe)}}}if(we===null)throw this.B("REGEX",Fe);return z.create(x,we)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Fe=this.u();return t.notIn(x,Fe)}switch(this.D().type){case 3:{this.z();const Fe=this.u();if(this.x().type===18)return t.equals(x,Fe);switch(Fe){case"true":return t.has(x);case"false":return t.not(x);default:return t.equals(x,Fe)}}case 4:{this.z();const Fe=this.u();if(this.x().type===18)return t.notEquals(x,Fe);switch(Fe){case"true":return t.not(x);case"false":return t.has(x);default:return t.notEquals(x,Fe)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),A.create(x,this.u());case 7:return this.z(),V.create(x,this.u());case 8:return this.z(),W.create(x,this.u());case 13:return this.z(),t.in(x,this.u());default:return t.has(x)}}case 20:throw this.h.push({message:n,offset:j.offset,lexeme:"",additionalInfo:c}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const j=this.D();switch(j.type){case 17:case 18:return this.z(),j.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(j){return j.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(j){return this.C(j)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(j,x){if(this.C(j))return this.z();throw this.B(x,this.D())}B(j,x,ve){const Fe=(0,R.localize)(8,null,j,M.$tj.getLexeme(x)),ke=x.offset,we=M.$tj.getLexeme(x);return this.h.push({message:Fe,offset:ke,lexeme:we,additionalInfo:ve}),u.c}C(j){return this.D().type===j}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$vj=u;class t{static false(){return $.INSTANCE}static true(){return p.INSTANCE}static has(j){return v.create(j)}static equals(j,x){return y.create(j,x)}static notEquals(j,x){return k.create(j,x)}static regex(j,x){return z.create(j,x)}static in(j,x){return h.create(j,x)}static notIn(j,x){return D.create(j,x)}static not(j){return I.create(j)}static and(...j){return de.create(j,null,!0)}static or(...j){return ye.create(j,null,!0)}static greater(j,x){return V.create(j,x)}static greaterEquals(j,x){return W.create(j,x)}static smaller(j,x){return q.create(j,x)}static smallerEquals(j,x){return A.create(j,x)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(j){return j==null?void 0:this.c.parse(j)}}e.$wj=t;function f(ne){const j=new u({regexParsingWithErrorRecovery:!1});return ne.map(x=>(j.parse(x),j.lexingErrors.length>0?j.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,R.localize)(9,null,ve.additionalInfo):(0,R.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):j.parsingErrors.length>0?j.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function a(ne,j){const x=ne?ne.substituteConstants():void 0,ve=j?j.substituteConstants():void 0;return!x&&!ve?!0:!x||!ve?!1:x.equals(ve)}function d(ne,j){return ne.cmp(j)}class ${static{this.INSTANCE=new $}constructor(){this.type=0}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!1}serialize(){return"false"}keys(){return[]}map(j){return this}negate(){return p.INSTANCE}}e.$zj=$;class p{static{this.INSTANCE=new p}constructor(){this.type=1}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!0}serialize(){return"true"}keys(){return[]}map(j){return this}negate(){return $.INSTANCE}}e.$Aj=p;class v{static create(j,x=null){const ve=m.get(j);return typeof ve=="boolean"?ve?p.INSTANCE:$.INSTANCE:new v(j,x)}constructor(j,x){this.key=j,this.c=x,this.type=2}cmp(j){return j.type!==this.type?this.type-j.type:ge(this.key,j.key)}equals(j){return j.type===this.type?this.key===j.key:!1}substituteConstants(){const j=m.get(this.key);return typeof j=="boolean"?j?p.INSTANCE:$.INSTANCE:this}evaluate(j){return!!j.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(j){return j.mapDefined(this.key)}negate(){return this.c||(this.c=I.create(this.key,this)),this.c}}e.$Bj=v;class y{static create(j,x,ve=null){if(typeof x=="boolean")return x?v.create(j,ve):I.create(j,ve);const Fe=m.get(j);return typeof Fe=="boolean"?x===(Fe?"true":"false")?p.INSTANCE:$.INSTANCE:new y(j,x,ve)}constructor(j,x,ve){this.c=j,this.d=x,this.f=ve,this.type=4}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=m.get(this.c);if(typeof j=="boolean"){const x=j?"true":"false";return this.d===x?p.INSTANCE:$.INSTANCE}return this}evaluate(j){return j.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(j){return j.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Cj=y;class h{static create(j,x){return new h(j,x)}constructor(j,x){this.d=j,this.f=x,this.type=10,this.c=null}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.d,this.f,j.d,j.f)}equals(j){return j.type===this.type?this.d===j.d&&this.f===j.f:!1}substituteConstants(){return this}evaluate(j){const x=j.getValue(this.f),ve=j.getValue(this.d);return Array.isArray(x)?x.includes(ve):typeof ve=="string"&&typeof x=="object"&&x!==null?T.call(x,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(j){return j.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$Dj=h;class D{static create(j,x){return new D(j,x)}constructor(j,x){this.d=j,this.f=x,this.type=11,this.c=h.create(j,x)}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(j){return j.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ej=D;class k{static create(j,x,ve=null){if(typeof x=="boolean")return x?I.create(j,ve):v.create(j,ve);const Fe=m.get(j);return typeof Fe=="boolean"?x===(Fe?"true":"false")?$.INSTANCE:p.INSTANCE:new k(j,x,ve)}constructor(j,x,ve){this.c=j,this.d=x,this.f=ve,this.type=5}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=m.get(this.c);if(typeof j=="boolean"){const x=j?"true":"false";return this.d===x?$.INSTANCE:p.INSTANCE}return this}evaluate(j){return j.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(j){return j.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Fj=k;class I{static create(j,x=null){const ve=m.get(j);return typeof ve=="boolean"?ve?$.INSTANCE:p.INSTANCE:new I(j,x)}constructor(j,x){this.c=j,this.d=x,this.type=3}cmp(j){return j.type!==this.type?this.type-j.type:ge(this.c,j.c)}equals(j){return j.type===this.type?this.c===j.c:!1}substituteConstants(){const j=m.get(this.c);return typeof j=="boolean"?j?$.INSTANCE:p.INSTANCE:this}evaluate(j){return!j.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(j){return j.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$Gj=I;function P(ne,j){if(typeof ne=="string"){const x=parseFloat(ne);isNaN(x)||(ne=x)}return typeof ne=="string"||typeof ne=="number"?j(ne):$.INSTANCE}class V{static create(j,x,ve=null){return P(x,Fe=>new V(j,Fe,ve))}constructor(j,x,ve){this.c=j,this.d=x,this.f=ve,this.type=12}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Hj=V;class W{static create(j,x,ve=null){return P(x,Fe=>new W(j,Fe,ve))}constructor(j,x,ve){this.c=j,this.d=x,this.f=ve,this.type=13}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Ij=W;class q{static create(j,x,ve=null){return P(x,Fe=>new q(j,Fe,ve))}constructor(j,x,ve){this.c=j,this.d=x,this.f=ve,this.type=14}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Jj=q;class A{static create(j,x,ve=null){return P(x,Fe=>new A(j,Fe,ve))}constructor(j,x,ve){this.c=j,this.d=x,this.f=ve,this.type=15}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Kj=A;class z{static create(j,x){return new z(j,x)}constructor(j,x){this.d=j,this.f=x,this.type=7,this.c=null}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.d<j.d)return-1;if(this.d>j.d)return 1;const x=this.f?this.f.source:"",ve=j.f?j.f.source:"";return x<ve?-1:x>ve?1:0}equals(j){if(j.type===this.type){const x=this.f?this.f.source:"",ve=j.f?j.f.source:"";return this.d===j.d&&x===ve}return!1}substituteConstants(){return this}evaluate(j){const x=j.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const j=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${j}`}keys(){return[this.d]}map(j){return j.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=G.create(this)),this.c}}e.$Lj=z;class G{static create(j){return new G(j)}constructor(j){this.c=j,this.type=8}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(j){return new G(this.c.map(j))}negate(){return this.c}}e.$Mj=G;function ie(ne){let j=null;for(let x=0,ve=ne.length;x<ve;x++){const Fe=ne[x].substituteConstants();if(ne[x]!==Fe&&j===null){j=[];for(let ke=0;ke<x;ke++)j[ke]=ne[ke]}j!==null&&(j[x]=Fe)}return j===null?ne:j}class de{static create(j,x,ve){return de.d(j,x,ve)}constructor(j,x){this.expr=j,this.c=x,this.type=6}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Fe=d(this.expr[x],j.expr[x]);if(Fe!==0)return Fe}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(j.expr[x]))return!1;return!0}return!1}substituteConstants(){const j=ie(this.expr);return j===this.expr?this:de.create(j,this.c,!1)}evaluate(j){for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].evaluate(j))return!1;return!0}static d(j,x,ve){const Fe=[];let ke=!1;for(const we of j)if(we){if(we.type===1){ke=!0;continue}if(we.type===0)return $.INSTANCE;if(we.type===6){Fe.push(...we.expr);continue}Fe.push(we)}if(Fe.length===0&&ke)return p.INSTANCE;if(Fe.length!==0){if(Fe.length===1)return Fe[0];Fe.sort(d);for(let we=1;we<Fe.length;we++)Fe[we-1].equals(Fe[we])&&(Fe.splice(we,1),we--);if(Fe.length===1)return Fe[0];for(;Fe.length>1;){const we=Fe[Fe.length-1];if(we.type!==9)break;Fe.pop();const me=Fe.pop(),Q=Fe.length===0,Y=ye.create(we.expr.map(he=>de.create([he,me],null,ve)),null,Q);Y&&(Fe.push(Y),Fe.sort(d))}if(Fe.length===1)return Fe[0];if(ve){for(let we=0;we<Fe.length;we++)for(let me=we+1;me<Fe.length;me++)if(Fe[we].negate().equals(Fe[me]))return $.INSTANCE;if(Fe.length===1)return Fe[0]}return new de(Fe,x)}}serialize(){return this.expr.map(j=>j.serialize()).join(" && ")}keys(){const j=[];for(const x of this.expr)j.push(...x.keys());return j}map(j){return new de(this.expr.map(x=>x.map(j)),null)}negate(){if(!this.c){const j=[];for(const x of this.expr)j.push(x.negate());this.c=ye.create(j,this,!0)}return this.c}}e.$Nj=de;class ye{static create(j,x,ve){return ye.d(j,x,ve)}constructor(j,x){this.expr=j,this.c=x,this.type=9}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Fe=d(this.expr[x],j.expr[x]);if(Fe!==0)return Fe}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(j.expr[x]))return!1;return!0}return!1}substituteConstants(){const j=ie(this.expr);return j===this.expr?this:ye.create(j,this.c,!1)}evaluate(j){for(let x=0,ve=this.expr.length;x<ve;x++)if(this.expr[x].evaluate(j))return!0;return!1}static d(j,x,ve){let Fe=[],ke=!1;if(j){for(let we=0,me=j.length;we<me;we++){const Q=j[we];if(Q){if(Q.type===0){ke=!0;continue}if(Q.type===1)return p.INSTANCE;if(Q.type===9){Fe=Fe.concat(Q.expr);continue}Fe.push(Q)}}if(Fe.length===0&&ke)return $.INSTANCE;Fe.sort(d)}if(Fe.length!==0){if(Fe.length===1)return Fe[0];for(let we=1;we<Fe.length;we++)Fe[we-1].equals(Fe[we])&&(Fe.splice(we,1),we--);if(Fe.length===1)return Fe[0];if(ve){for(let we=0;we<Fe.length;we++)for(let me=we+1;me<Fe.length;me++)if(Fe[we].negate().equals(Fe[me]))return p.INSTANCE;if(Fe.length===1)return Fe[0]}return new ye(Fe,x)}}serialize(){return this.expr.map(j=>j.serialize()).join(" || ")}keys(){const j=[];for(const x of this.expr)j.push(...x.keys());return j}map(j){return new ye(this.expr.map(x=>x.map(j)),null)}negate(){if(!this.c){const j=[];for(const x of this.expr)j.push(x.negate());for(;j.length>1;){const x=j.shift(),ve=j.shift(),Fe=[];for(const ke of Oe(x))for(const we of Oe(ve))Fe.push(de.create([ke,we],null,!1));j.unshift(ye.create(Fe,null,!1))}this.c=ye.create(j,this,!0)}return this.c}}e.$Oj=ye;class Ee extends v{static{this.d=[]}static all(){return Ee.d.values()}constructor(j,x,ve){super(j,null),this.f=x,typeof ve=="object"?Ee.d.push({...ve,key:j}):ve!==!0&&Ee.d.push({key:j,description:ve,type:x!=null?typeof x:void 0})}bindTo(j){return j.createKey(this.key,this.f)}getValue(j){return j.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(j){return y.create(this.key,j)}notEqualsTo(j){return k.create(this.key,j)}}e.$Pj=Ee,e.$Qj=(0,N.$yi)("contextKeyService");function ge(ne,j){return ne<j?-1:ne>j?1:0}function ue(ne,j,x,ve){return ne<x?-1:ne>x?1:j<ve?-1:j>ve?1:0}function Ce(ne,j){if(ne.type===0||j.type===1)return!0;if(ne.type===9)return j.type===9?se(ne.expr,j.expr):!1;if(j.type===9){for(const x of j.expr)if(Ce(ne,x))return!0;return!1}if(ne.type===6){if(j.type===6)return se(j.expr,ne.expr);for(const x of ne.expr)if(Ce(x,j))return!0;return!1}return ne.equals(j)}function se(ne,j){let x=0,ve=0;for(;x<ne.length&&ve<j.length;){const Fe=ne[x].cmp(j[ve]);if(Fe<0)return!1;Fe===0&&x++,ve++}return x===ne.length}function Oe(ne){return ne.type===9?ne.expr:[ne]}}),define(Se[99],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=void 0,e.$Fi=(0,C.$yi)("environmentService"),e.$Gi=(0,C.$zi)(e.$Fi)}),define(Se[100],Ie([1,0,163,3]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.ExtensionManagementErrorCode=e.$0o=e.ExtensionGalleryErrorCode=e.$9o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$3o=M,e.$4o=N,e.$5o=R,e.$6o=w,e.$7o=m,e.$8o=E,e.$Wo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Xo=new RegExp(e.$Wo),e.$Yo="__web_extension",e.$Zo="skipWalkthrough",e.$1o="extensionsSync",e.$2o="dependecyOrPackExtensionInstall";function M(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function N(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function R(i,n){switch(i){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function w(i,n){return n==="web"&&!i.includes("web")}function m(i,n,c){return w(n,c)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===c}function E(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var T;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(T||(e.SortBy=T={}));var S;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var l;(function(i){i.Install="install",i.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$9o=(0,O.$yi)("extensionGalleryService");var g;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(g||(e.ExtensionGalleryErrorCode=g={}));class r extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$0o=r;var s;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(s||(e.ExtensionManagementErrorCode=s={}));class o extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$$o=o,e.$_o=(0,O.$yi)("extensionManagementService"),e.$ap="extensionsIdentifiers/disabled",e.$bp="extensionsIdentifiers/enabled",e.$cp=(0,O.$yi)("IGlobalExtensionEnablementService"),e.$dp=(0,O.$yi)("IExtensionTipsService"),e.$ep=(0,C.localize2)(0,"Extensions"),e.$fp=(0,C.localize2)(1,"Preferences")}),define(Se[38],Ie([1,0,54,19,13,15,2,165,3,23,16,43]),function(le,e,C,O,M,N,R,w,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$xl=e.FileKind=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.FileOperationResult=e.$pl=e.$ol=e.$nl=e.$ll=e.FileChangeType=e.$kl=e.FileOperation=e.$el=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$5k=void 0,e.$6k=l,e.$7k=s,e.$8k=i,e.$9k=n,e.$0k=c,e.$$k=u,e.$_k=t,e.$al=f,e.$bl=a,e.$cl=d,e.$dl=$,e.$fl=y,e.$gl=h,e.$hl=D,e.$il=k,e.$jl=I,e.$ml=A,e.$yl=Ee,e.$zl=ge,e.$Bl=Ce,e.$5k=(0,m.$yi)("fileService");function l(se){return se.create===!0}var b;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var g;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(g||(e.FilePermission=g={}));var r;(function(se){se[se.UPDATED=2]="UPDATED",se[se.ADDED=4]="ADDED",se[se.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function s(se){const Oe=se;return!!Oe&&typeof Oe.onDidChange=="function"}var o;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function i(se){return!!(se.capabilities&2)}function n(se){return!!(se.capabilities&8)}function c(se){return!!(se.capabilities&131072)}function u(se){return!!(se.capabilities&4)}function t(se){return!!(se.capabilities&16)}function f(se){return i(se)?!!(se.capabilities&16384):!1}function a(se){return i(se)?!!(se.capabilities&32768):!1}function d(se){return!!(se.capabilities&65536)}function $(se){return!!(se.capabilities&2048)}var p;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(p||(e.FileSystemProviderErrorCode=p={}));class v extends Error{static create(Oe,ne){const j=new v(Oe.toString(),ne);return D(j,ne),j}constructor(Oe,ne){super(Oe),this.code=ne}}e.$el=v;function y(se,Oe){return v.create(se,Oe)}function h(se){return se||y((0,w.localize)(0,null),p.Unknown)}function D(se,Oe){return se.name=Oe?`${Oe} (FileSystemError)`:"FileSystemError",se}function k(se){if(!se)return p.Unknown;if(se instanceof v)return se.code;const Oe=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!Oe)return p.Unknown;switch(Oe[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}function I(se){if(se instanceof z)return se.fileOperationResult;switch(k(se)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 9;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileTooLarge:return 7;default:return 10}}var P;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class V{constructor(Oe,ne,j){this.resource=Oe,this.operation=ne,this.target=j}isOperation(Oe){return this.operation===Oe}}e.$kl=V;var W;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(W||(e.FileChangeType=W={}));class q{static{this.a=null}constructor(Oe,ne){this.c=ne,this.b=void 0,this.d=new S.$V(()=>{const j=C.$Ei.forUris(()=>this.c);return j.fill(this.rawAdded.map(x=>[x,!0])),j}),this.f=new S.$V(()=>{const j=C.$Ei.forUris(()=>this.c);return j.fill(this.rawUpdated.map(x=>[x,!0])),j}),this.g=new S.$V(()=>{const j=C.$Ei.forUris(()=>this.c);return j.fill(this.rawDeleted.map(x=>[x,!0])),j}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const j of Oe){switch(j.type){case 1:this.rawAdded.push(j.resource);break;case 0:this.rawUpdated.push(j.resource);break;case 2:this.rawDeleted.push(j.resource);break}this.b!==q.a&&(typeof j.cId=="number"?this.b===void 0?this.b=j.cId:this.b!==j.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(Oe,...ne){return this.h(Oe,{includeChildren:!1},...ne)}affects(Oe,...ne){return this.h(Oe,{includeChildren:!0},...ne)}h(Oe,ne,...j){if(!Oe)return!1;const x=j.length>0;return!!((!x||j.includes(1))&&(this.d.value.get(Oe)||ne.includeChildren&&this.d.value.findSuperstr(Oe))||(!x||j.includes(0))&&(this.f.value.get(Oe)||ne.includeChildren&&this.f.value.findSuperstr(Oe))||(!x||j.includes(2))&&(this.g.value.findSubstr(Oe)||ne.includeChildren&&this.g.value.findSuperstr(Oe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Oe){return this.b===Oe}hasCorrelation(){return typeof this.b=="number"}}e.$ll=q;function A(se,Oe,ne){return!se||!Oe||se===Oe||Oe.length>se.length?!1:(Oe.charAt(Oe.length-1)!==O.sep&&(Oe+=O.sep),ne?(0,M.$Af)(se,Oe):se.indexOf(Oe)===0)}class z extends Error{constructor(Oe,ne,j){super(Oe),this.fileOperationResult=ne,this.options=j}}e.$nl=z;class G extends z{constructor(Oe,ne,j,x){super(Oe,ne,x),this.fileOperationResult=ne,this.size=j}}e.$ol=G;class ie extends z{constructor(Oe,ne,j){super(Oe,2,j),this.stat=ne}}e.$pl=ie;var de;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(de||(e.FileOperationResult=de={})),e.$ql={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sl="files.associations",e.$tl="files.exclude",e.$ul="files.readonlyInclude",e.$vl="files.readonlyExclude",e.$wl="files.readonlyFromPermissions";var ye;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(ye||(e.FileKind=ye={})),e.$xl="";function Ee(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}async function ge(se,Oe){if(!Oe.hasProvider(R.URI.from({scheme:se.scheme})))return new Promise(ne=>{const j=Oe.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===se.scheme&&x.added&&(j.dispose(),ne())})})}class ue{static{this.KB=1024}static{this.MB=ue.KB*ue.KB}static{this.GB=ue.MB*ue.KB}static{this.TB=ue.GB*ue.KB}static formatSize(Oe){return(0,N.$cg)(Oe)||(Oe=0),Oe<ue.KB?(0,w.localize)(1,null,Oe.toFixed(0)):Oe<ue.MB?(0,w.localize)(2,null,(Oe/ue.KB).toFixed(2)):Oe<ue.GB?(0,w.localize)(3,null,(Oe/ue.MB).toFixed(2)):Oe<ue.TB?(0,w.localize)(4,null,(Oe/ue.GB).toFixed(2)):(0,w.localize)(5,null,(Oe/ue.TB).toFixed(2))}}e.$Al=ue;function Ce(se){const Oe=typeof se=="string"||se?.scheme===T.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===T.Schemas.file?1024*ue.MB:Oe?10*ue.MB:E.$o?50*ue.MB:1024*ue.MB}}),define(Se[72],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=void 0;class C{constructor(...M){this.a=new Map;for(const[N,R]of M)this.set(N,R)}set(M,N){const R=this.a.get(M);return this.a.set(M,N),R}has(M){return this.a.has(M)}get(M){return this.a.get(M)}}e.$wi=C}),define(Se[199],Ie([1,0,11,14,6,71,198,3,72,200]),function(le,e,C,O,M,N,R,w,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=void 0;const T=!1;class S extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class l{constructor(s=new m.$wi,o=!1,i,n=T){this.i=s,this.j=o,this.k=i,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(w.$xi,this),this._globalGraph=n?i?._globalGraph??new R.$er(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,M.$Pc)(this.h),this.h.clear();for(const s of this.g)(0,M.$Oc)(s)&&s.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(s){this.m();const o=new class extends l{dispose(){this.h.delete(o),super.dispose()}}(s,this.j,this,this.l);return this.h.add(o),o}invokeFunction(s,...o){this.m();const i=g.traceInvocation(this.l,s);let n=!1;try{return s({get:u=>{if(n)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(u,i);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...o)}finally{n=!0,i.stop()}}createInstance(s,...o){this.m();let i,n;return s instanceof N.$vi?(i=g.traceCreation(this.l,s.ctor),n=this.o(s.ctor,s.staticArguments.concat(o),i)):(i=g.traceCreation(this.l,s),n=this.o(s,o,i)),i.stop(),n}o(s,o=[],i){const n=w._util.getServiceDependencies(s).sort((t,f)=>t.index-f.index),c=[];for(const t of n){const f=this.s(t.id,i);f||this.y(`[createInstance] ${s.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(f)}const u=n.length>0?n[0].index:o.length;if(o.length!==u){console.trace(`[createInstance] First service dependency of ${s.name} at position ${u+1} conflicts with ${o.length} static arguments`);const t=u-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,u)}return Reflect.construct(s,o.concat(c))}q(s,o){if(this.i.get(s)instanceof N.$vi)this.i.set(s,o);else if(this.k)this.k.q(s,o);else throw new Error("illegalState - setting UNKNOWN service instance")}r(s){const o=this.i.get(s);return!o&&this.k?this.k.r(s):o}s(s,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const i=this.r(s);return i instanceof N.$vi?this.u(s,i,o.branch(s,!0)):(o.branch(s,!1),i)}u(s,o,i){if(this.t.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.t.add(s);try{return this.v(s,o,i)}finally{this.t.delete(s)}}v(s,o,i){const n=new R.$er(t=>t.id.toString());let c=0;const u=[{id:s,desc:o,_trace:i}];for(;u.length;){const t=u.pop();if(n.lookupOrInsertNode(t),c++>1e3)throw new S(n);for(const f of w._util.getServiceDependencies(t.desc.ctor)){const a=this.r(f.id);if(a||this.y(`[createInstance] ${s} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),a instanceof N.$vi){const d={id:f.id,desc:a,_trace:t._trace.branch(f.id,!0)};n.insertEdge(t,d),u.push(d)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new S(n);break}for(const{data:f}of t){if(this.r(f.id)instanceof N.$vi){const d=this.w(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this.q(f.id,d)}n.removeNode(f)}}return this.r(s)}w(s,o,i=[],n,c){if(this.i.get(s)instanceof N.$vi)return this.x(s,o,i,n,c,this.g);if(this.k)return this.k.w(s,o,i,n,c);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}x(s,o,i=[],n,c,u){if(n){const t=new l(void 0,this.j,this,this.l);t.c=String(s);const f=new Map,a=new C.$Rh(()=>{const d=t.o(o,i,c);for(const[$,p]of f){const v=d[$];if(typeof v=="function")for(const y of p)y.disposable=v.apply(d,y.listener)}return f.clear(),u.add(d),d});return new Proxy(Object.create(null),{get(d,$){if(!a.isInitialized&&typeof $=="string"&&($.startsWith("onDid")||$.startsWith("onWill"))){let y=f.get($);return y||(y=new E.$5c,f.set($,y)),(D,k,I)=>{if(a.isInitialized)return a.value[$](D,k,I);{const P={listener:[D,k,I],disposable:void 0},V=y.push(P);return(0,M.$Sc)(()=>{V(),P.disposable?.dispose()})}}}if($ in d)return d[$];const p=a.value;let v=p[$];return typeof v!="function"||(v=v.bind(p),d[$]=v),v},set(d,$,p){return a.value[$]=p,!0},getPrototypeOf(d){return o.prototype}})}else{const t=this.o(o,i,c);return u.add(t),t}}y(s,o){if(o&&console.warn(s),this.j)throw new Error(s)}}e.$fr=l;var b;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(b||(b={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(s,o){return s?new g(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(s,o){return s?new g(1,o.name):g.c}static{this.f=0}constructor(s,o){this.type=s,this.name=o,this.g=Date.now(),this.h=[]}branch(s,o){const i=new g(3,s.toString());return this.h.push([s,o,i]),i}stop(){const s=Date.now()-this.g;g.f+=s;let o=!1;function i(c,u){const t=[],f=new Array(c+1).join("	");for(const[a,d,$]of u.h)if(d&&$){o=!0,t.push(`${f}CREATES -> ${a}`);const p=i(c+1,$);p&&t.push(p)}else t.push(`${f}uses -> ${a}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(s>2||o)&&g.all.add(n.join(`
`))}}e.$gr=g}),define(Se[12],Ie([1,0,166,44,5,73,6,28,23,24,15,2,31,3]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$8j=e.LogLevel=e.$6j=e.$5j=void 0,e.$7j=r,e.log=o,e.$gk=v,e.$hk=y,e.$ik=h,e.$jk=D,e.$5j=(0,b.$yi)("logService"),e.$6j=(0,b.$yi)("loggerService");function g(){return new Date().toISOString()}function r(k){return(0,T.$cg)(k)}var s;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$8j=s.Info;function o(k,I,P){switch(I){case s.Trace:k.trace(P);break;case s.Debug:k.debug(P);break;case s.Info:k.info(P);break;case s.Warning:k.warn(P);break;case s.Error:k.error(P);break;case s.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function i(k,I=!1){let P="";for(let V=0;V<k.length;V++){let W=k[V];if(W instanceof Error&&(W=(0,O.$jj)(W,I)),typeof W=="object")try{W=JSON.stringify(W)}catch{}P+=(V>0?" ":"")+W}return P}class n extends R.$Uc{constructor(){super(...arguments),this.b=e.$8j,this.c=this.B(new M.$fe),this.onDidChangeLogLevel=this.c.event}setLevel(I){this.b!==I&&(this.b=I,this.c.fire(this.b))}getLevel(){return this.b}f(I){return this.b!==s.Off&&this.b<=I}}e.$0j=n;class c extends n{constructor(I){super(),this.h=I}f(I){return this.h||super.f(I)}trace(I,...P){this.f(s.Trace)&&this.g(s.Trace,i([I,...P],!0))}debug(I,...P){this.f(s.Debug)&&this.g(s.Debug,i([I,...P]))}info(I,...P){this.f(s.Info)&&this.g(s.Info,i([I,...P]))}warn(I,...P){this.f(s.Warning)&&this.g(s.Warning,i([I,...P]))}error(I,...P){if(this.f(s.Error))if(I instanceof Error){const V=Array.prototype.slice.call(arguments);V[0]=I.stack,this.g(s.Error,i(V))}else this.g(s.Error,i([I,...P]))}flush(){}}e.$$j=c;class u extends n{constructor(I=e.$8j){super(),this.setLevel(I),this.g=!m.$i}trace(I,...P){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,I,...P):console.log(`[main ${g()}]`,I,...P))}debug(I,...P){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,I,...P):console.log(`[main ${g()}]`,I,...P))}info(I,...P){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,I,...P):console.log(`[main ${g()}]`,I,...P))}warn(I,...P){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,I,...P):console.warn(`[main ${g()}]`,I,...P))}error(I,...P){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,I,...P):console.error(`[main ${g()}]`,I,...P))}flush(){}}e.$_j=u;class t extends n{constructor(I=e.$8j,P=!0){super(),this.g=P,this.setLevel(I)}trace(I,...P){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",I,...P):console.log(I,...P))}debug(I,...P){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",I,...P):console.log(I,...P))}info(I,...P){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",I,...P):console.log(I,...P))}warn(I,...P){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",I,...P):console.log(I,...P))}error(I,...P){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",I,...P):console.error(I,...P))}flush(){}}e.$ak=t;class f extends n{constructor(I,P=e.$8j){super(),this.g=I,this.setLevel(P)}trace(I,...P){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(I),...P])}debug(I,...P){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(I),...P])}info(I,...P){this.f(s.Info)&&this.g.log(s.Info,[this.h(I),...P])}warn(I,...P){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(I),...P])}error(I,...P){this.f(s.Error)&&this.g.log(s.Error,[this.h(I),...P])}h(I){return typeof I=="string"?I:(0,O.$jj)(I,this.f(s.Trace))}flush(){}}e.$bk=f;class a extends n{constructor(I){super(),this.g=I,I.length&&this.setLevel(I[0].getLevel())}setLevel(I){for(const P of this.g)P.setLevel(I);super.setLevel(I)}trace(I,...P){for(const V of this.g)V.trace(I,...P)}debug(I,...P){for(const V of this.g)V.debug(I,...P)}info(I,...P){for(const V of this.g)V.info(I,...P)}warn(I,...P){for(const V of this.g)V.warn(I,...P)}error(I,...P){for(const V of this.g)V.error(I,...P)}flush(){for(const I of this.g)I.flush()}dispose(){for(const I of this.g)I.dispose();super.dispose()}}e.$ck=a;class d extends R.$Uc{constructor(I,P,V){if(super(),this.h=I,this.j=P,this.b=new w.$Ac,this.c=this.B(new M.$fe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$fe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$fe),this.onDidChangeVisibility=this.g.event,V)for(const W of V)this.b.set(W.resource,{logger:void 0,info:W})}m(I){return(0,T.$$f)(I)?[...this.b.values()].find(P=>P.info.id===I):this.b.get(I)}getLogger(I){return this.m(I)?.logger}createLogger(I,P){const V=this.n(I),W=(0,T.$$f)(I)?I:P?.id??(0,N.$mj)(V.toString()).toString(16);let q=this.b.get(V)?.logger;const A=P?.logLevel==="always"?s.Trace:P?.logLevel;q||(q=this.s(V,A??this.getLogLevel(V)??this.h,{...P,id:W}));const z={logger:q,info:{resource:V,id:W,logLevel:A,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(z.info),this.b.set(V,z),q}n(I){return(0,T.$$f)(I)?(0,E.$_g)(this.j,`${I}.log`):I}setLogLevel(I,P){if(S.URI.isUri(I)){const V=I,W=P,q=this.b.get(V);q&&W!==q.info.logLevel&&(q.info.logLevel=W===this.h?void 0:W,q.logger?.setLevel(W),this.b.set(q.info.resource,q),this.f.fire([V,W]))}else{this.h=I;for(const[V,W]of this.b.entries())this.b.get(V)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(I,P){const V=this.m(I);V&&P!==!V.info.hidden&&(V.info.hidden=!P,this.b.set(V.info.resource,V),this.g.fire([V.info.resource,P]))}getLogLevel(I){let P;return I&&(P=this.b.get(I)?.info.logLevel),P??this.h}registerLogger(I){const P=this.b.get(I.resource);P?P.info.hidden!==I.hidden&&this.setVisibility(I.resource,!I.hidden):(this.b.set(I.resource,{info:I,logger:void 0}),this.c.fire({added:[I],removed:[]}))}deregisterLogger(I){const P=this.b.get(I);P&&(P.logger&&P.logger.dispose(),this.b.delete(I),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const I of this.b.values())yield I.info}getRegisteredLogger(I){return this.b.get(I)?.info}dispose(){this.b.forEach(I=>I.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dk=d;class ${constructor(){this.onDidChangeLogLevel=new M.$fe().event}setLevel(I){}getLevel(){return s.Info}trace(I,...P){}debug(I,...P){}info(I,...P){}warn(I,...P){}error(I,...P){}critical(I,...P){}dispose(){}flush(){}}e.$ek=$;class p extends ${}e.$fk=p;function v(k){if(k.verbose)return s.Trace;if(typeof k.logLevel=="string"){const I=D(k.logLevel.toLowerCase());if(I!==void 0)return I}return e.$8j}function y(k){switch(k){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}function h(k){switch(k){case s.Trace:return{original:"Trace",value:C.localize(0,null)};case s.Debug:return{original:"Debug",value:C.localize(1,null)};case s.Info:return{original:"Info",value:C.localize(2,null)};case s.Warning:return{original:"Warning",value:C.localize(3,null)};case s.Error:return{original:"Error",value:C.localize(4,null)};case s.Off:return{original:"Off",value:C.localize(5,null)}}}function D(k){switch(k){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$kk=new l.$Pj("logLevel",y(s.Info))}),define(Se[201],Ie([1,0,6,12]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=void 0;class M extends C.$Uc{constructor(R,w=[]){super(),this.a=new O.$ck([R,...w]),this.B(R.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...w){this.a.trace(R,...w)}debug(R,...w){this.a.debug(R,...w)}info(R,...w){this.a.info(R,...w)}warn(R,...w){this.a.warn(R,...w)}error(R,...w){this.a.error(R,...w)}flush(){this.a.flush()}}e.$aQ=M}),define(Se[101],Ie([1,0,32,167,3]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0t=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(N||(e.MarkerTag=N={}));var R;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(m){function E(g,r){return r-g}m.compare=E;const T=Object.create(null);T[m.Error]=(0,O.localize)(0,null),T[m.Warning]=(0,O.localize)(1,null),T[m.Info]=(0,O.localize)(2,null);function S(g){return T[g]||""}m.toString=S;function l(g){switch(g){case C.default.Error:return m.Error;case C.default.Warning:return m.Warning;case C.default.Info:return m.Info;case C.default.Ignore:return m.Hint}}m.fromSeverity=l;function b(g){switch(g){case m.Error:return C.default.Error;case m.Warning:return C.default.Warning;case m.Info:return C.default.Info;case m.Hint:return C.default.Ignore}}m.toSeverity=b}(R||(e.MarkerSeverity=R={}));var w;(function(m){const E="";function T(l){return S(l,!0)}m.makeKey=T;function S(l,b){const g=[E];return l.source?g.push(l.source.replace("\xA6","\\\xA6")):g.push(E),l.code?typeof l.code=="string"?g.push(l.code.replace("\xA6","\\\xA6")):g.push(l.code.value.replace("\xA6","\\\xA6")):g.push(E),l.severity!==void 0&&l.severity!==null?g.push(R.toString(l.severity)):g.push(E),l.message&&b?g.push(l.message.replace("\xA6","\\\xA6")):g.push(E),l.startLineNumber!==void 0&&l.startLineNumber!==null?g.push(l.startLineNumber.toString()):g.push(E),l.startColumn!==void 0&&l.startColumn!==null?g.push(l.startColumn.toString()):g.push(E),l.endLineNumber!==void 0&&l.endLineNumber!==null?g.push(l.endLineNumber.toString()):g.push(E),l.endColumn!==void 0&&l.endColumn!==null?g.push(l.endColumn.toString()):g.push(E),g.push(E),g.join("\xA6")}m.makeKeyOptionalMessage=S})(w||(e.IMarkerData=w={})),e.$0t=(0,M.$yi)("markerService")}),define(Se[202],Ie([1,0,5,32,3]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$aw=e.Severity=void 0,e.$bw=w,e.Severity=O.default,e.$aw=(0,M.$yi)("notificationService");var N;(function(S){S[S.DEFAULT=0]="DEFAULT",S[S.SILENT=1]="SILENT",S[S.URGENT=2]="URGENT"})(N||(e.NotificationPriority=N={}));var R;(function(S){S[S.WORKSPACE=0]="WORKSPACE",S[S.PROFILE=1]="PROFILE",S[S.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function w(S){if(S){const l=S;return typeof l.id=="string"&&typeof l.label=="string"}return!1}var m;(function(S){S[S.OFF=0]="OFF",S[S.ERROR=1]="ERROR"})(m||(e.NotificationsFilter=m={}));class E{constructor(){this.progress=new T,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$cw=E;class T{infinite(){}done(){}total(l){}worked(l){}}e.$dw=T}),define(Se[102],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$lk=(0,C.$yi)("productService"),e.$mk="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(le,e,C,O){var M=arguments.length,N=M<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,C):O,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(le,e,C,O);else for(var w=le.length-1;w>=0;w--)(R=le[w])&&(N=(M<3?R(N):M>3?R(e,C,N):R(e,C))||N);return M>3&&N&&Object.defineProperty(e,C,N),N},We=this&&this.__param||function(le,e){return function(C,O){e(C,O,le)}};define(Se[103],Ie([1,0,11,20,6,3]),function(le,e,C,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kw=e.$jw=e.$iw=e.$hw=e.$gw=e.$fw=e.ProgressLocation=e.$ew=void 0,e.$ew=(0,N.$yi)("progressService");var R;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$fw=Object.freeze({total(){},worked(){},done(){}});class w{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$gw=w;class m{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const b=this.d;this.d=()=>{b?.(),l()}}):Promise.resolve()}}e.$hw=m;let E=class extends M.$Uc{constructor(l,b){super(),this.a=new C.$Vh,b.withProgress(l,g=>(this.b=g,this.c&&g.report(this.c),this.a.p)),this.B((0,M.$Sc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$iw=E,e.$iw=E=Je([We(1,e.$ew)],E);class T extends M.$Uc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new M.$Tc)}start(l){this.stop();const b=++this.a,g=new O.$qe;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,M.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,M.$Sc)(()=>g.cancel())),this.b.add((0,M.$Sc)(()=>this.c?this.c.done():void 0)),{id:b,token:g.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$jw=T,e.$kw=(0,N.$yi)("editorProgressService")}),define(Se[29],Ie([1,0,57,15]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=void 0;class M{constructor(){this.a=new Map}add(R,w){C.ok(O.$$f(R)),C.ok(O.$ag(w)),C.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,w)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$fo=new M}),define(Se[74],Ie([1,0,5,29]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=void 0,e.$go={JSONContribution:"base.contributions.json"};function M(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class N{constructor(){this.b=new C.$fe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,E){this.a[M(m)]=E,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const R=new N;O.$fo.add(e.$go.JSONContribution,R)}),define(Se[51],Ie([1,0,18,5,15,160,50,74,29]),function(le,e,C,O,M,N,R,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.ConfigurationScope=e.$ko=e.EditPresentationTypes=void 0,e.$vo=r,e.$wo=s,e.$xo=o,e.$yo=n,e.$zo=c;var E;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$ko={Configuration:"base.contributions.configuration"};var T;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro="vscode://schemas/settings/resourceLanguage",e.$so="vscode://schemas/settings/configurationDefaults";const S=m.$fo.as(w.$go.JSONContribution);class l{constructor(){this.h=new Set,this.i=new O.$fe,this.onDidSchemaChange=this.i.event,this.j=new O.$fe,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$ro,this.g),this.v()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const a=new Set;this.n(t,f,a),S.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const f=new Set;this.o(t,f),S.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:f})}updateConfigurations({add:t,remove:f}){const a=new Set;this.o(f,a),this.n(t,!1,a),S.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const f=new Set;this.k(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}k(t,f){const a=[];for(const{overrides:d,source:$}of t)for(const p in d)if(f.add(p),e.$uo.test(p)){const v=this.a.get(p),y=v?.valuesSources??new Map;if($)for(const I of Object.keys(d[p]))y.set(I,$);const h={...v?.value||{},...d[p]};this.a.set(p,{source:$,value:h,valuesSources:y});const D=(0,R.$cj)(p),k={type:"object",default:h,description:N.localize(1,null,D),$ref:e.$ro,defaultDefaultValue:h,source:M.$$f($)?void 0:$,defaultValueSource:$};a.push(...r(p)),this.d[p]=k,this.b.properties[p]=k}else{this.a.set(p,{value:d[p],source:$});const v=this.d[p];v&&(this.w(p,v),this.r(p,v))}this.m(a)}deregisterDefaultConfigurations(t){const f=new Set;this.l(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}l(t,f){for(const{overrides:a,source:d}of t)for(const $ in a){const p=this.a.get($),v=M.$$f(d)?d:d?.id,y=M.$$f(p?.source)?p?.source:p?.source?.id;if(v===y)if(f.add($),this.a.delete($),e.$uo.test($))delete this.d[$],delete this.b.properties[$];else{const h=this.d[$];h&&(this.w($,h),this.r($,h))}}this.u()}deltaConfiguration(t){let f=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),f=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),f=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const f of t)this.h.add(f);this.u()}n(t,f,a){t.forEach(d=>{this.p(d,f,d.extensionInfo,d.restrictedProperties,void 0,a),this.c.push(d),this.q(d)})}o(t,f){const a=d=>{if(d.properties)for(const $ in d.properties){f.add($);const p=this.d[$];p?.policy?.name&&this.e.delete(p.policy.name),delete this.d[$],this.s($,d.properties[$])}d.allOf?.forEach($=>a($))};for(const d of t){a(d);const $=this.c.indexOf(d);$!==-1&&this.c.splice($,1)}}p(t,f=!0,a,d,$=3,p){$=M.$hg(t.scope)?$:t.scope;const v=t.properties;if(v)for(const h in v){const D=v[h];if(f&&n(h,D)){delete v[h];continue}if(D.source=a,D.defaultDefaultValue=v[h].default,this.w(h,D),e.$uo.test(h)?D.scope=void 0:(D.scope=M.$hg(D.scope)?$:D.scope,D.restricted=M.$hg(D.restricted)?!!d?.includes(h):D.restricted),v[h].hasOwnProperty("included")&&!v[h].included){this.f[h]=v[h],delete v[h];continue}else this.d[h]=v[h],v[h].policy?.name&&this.e.set(v[h].policy.name,h);!v[h].deprecationMessage&&v[h].markdownDeprecationMessage&&(v[h].deprecationMessage=v[h].markdownDeprecationMessage),p.add(h)}const y=t.allOf;if(y)for(const h of y)this.p(h,f,a,d,$,p)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const f=a=>{const d=a.properties;if(d)for(const p in d)this.r(p,d[p]);a.allOf?.forEach(f)};f(t)}r(t,f){switch(e.$lo.properties[t]=f,f.scope){case 1:e.$mo.properties[t]=f;break;case 2:e.$no.properties[t]=f;break;case 6:e.$oo.properties[t]=f;break;case 3:e.$po.properties[t]=f;break;case 4:e.$qo.properties[t]=f;break;case 5:e.$qo.properties[t]=f,this.g.properties[t]=f;break}}s(t,f){switch(delete e.$lo.properties[t],f.scope){case 1:delete e.$mo.properties[t];break;case 2:delete e.$no.properties[t];break;case 6:delete e.$oo.properties[t];break;case 3:delete e.$po.properties[t];break;case 4:case 5:delete e.$qo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const f=`[${t}]`,a={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$ro};this.w(f,a),e.$lo.properties[f]=a,e.$mo.properties[f]=a,e.$no.properties[f]=a,e.$oo.properties[f]=a,e.$po.properties[f]=a,e.$qo.properties[f]=a}}v(){const t={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$ro};e.$lo.patternProperties[e.$to]=t,e.$mo.patternProperties[e.$to]=t,e.$no.patternProperties[e.$to]=t,e.$oo.patternProperties[e.$to]=t,e.$po.patternProperties[e.$to]=t,e.$qo.patternProperties[e.$to]=t,this.i.fire()}w(t,f){const a=this.a.get(t);let d=a?.value,$=a?.source;M.$fg(d)&&(d=f.defaultDefaultValue,$=void 0),M.$fg(d)&&(d=o(f.type)),f.default=d,f.defaultValueSource=$}}const b="\\[([^\\]]+)\\]",g=new RegExp(b,"g");e.$to=`^(${b})+$`,e.$uo=new RegExp(e.$to);function r(u){const t=[];if(e.$uo.test(u)){let f=g.exec(u);for(;f?.length;){const a=f[1].trim();a&&t.push(a),f=g.exec(u)}}return(0,C.$Mb)(t)}function s(u){return u.reduce((t,f)=>`${t}[${f}]`,"")}function o(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const i=new l;m.$fo.add(e.$ko.Configuration,i);function n(u,t){return u.trim()?e.$uo.test(u)?N.localize(7,null,u):i.getConfigurationProperties()[u]!==void 0?N.localize(8,null,u):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?N.localize(9,null,u,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:N.localize(6,null)}function c(){const u=[],t=i.getConfigurationProperties();for(const f of Object.keys(t))u.push([f,t[f].scope]);return u.push(["launch",4]),u.push(["task",4]),u}}),define(Se[203],Ie([1,0,18,5,126,6,28,26,15,2,50,51,29]),function(le,e,C,O,M,N,R,w,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0,e.$Eo=n;function b(f){return Object.isFrozen(f)?f:w.$6n(f)}class g{static createEmptyModel(a){return new g({},[],[],void 0,a)}constructor(a,d,$,p,v){this.b=a,this.c=d,this.d=$,this.raw=p,this.f=v,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map(d=>{if(d instanceof g)return d;const $=new r("",this.f);return $.parseRaw(d),$.configurationModel});this.g=a.reduce((d,$)=>$===d?$:d.merge($),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,T.$aj)(this.contents,a):this.contents}inspect(a,d){const $=this;return{get value(){return b($.rawConfiguration.getValue(a))},get override(){return d?b($.rawConfiguration.getOverrideValue(a,d)):void 0},get merged(){return b(d?$.rawConfiguration.override(d).getValue(a):$.rawConfiguration.getValue(a))},get overrides(){const p=[];for(const{contents:v,identifiers:y,keys:h}of $.rawConfiguration.overrides){const D=new g(v,h,[],void 0,$.f).getValue(a);D!==void 0&&p.push({identifiers:y,value:D})}return p.length?b(p):void 0}}}getOverrideValue(a,d){const $=this.j(d);return $?a?(0,T.$aj)($,a):$:void 0}getKeysForOverrideIdentifier(a){const d=[];for(const $ of this.overrides)$.identifiers.includes(a)&&d.push(...$.keys);return C.$Mb(d)}getAllOverrideIdentifiers(){const a=[];for(const d of this.overrides)a.push(...d.identifiers);return C.$Mb(a)}override(a){let d=this.a.get(a);return d||(d=this.h(a),this.a.set(a,d)),d}merge(...a){const d=w.$5n(this.contents),$=w.$5n(this.overrides),p=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const y of a)if(v.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.i(d,y.contents);for(const h of y.overrides){const[D]=$.filter(k=>C.$ub(k.identifiers,h.identifiers));D?(this.i(D.contents,h.contents),D.keys.push(...h.keys),D.keys=C.$Mb(D.keys)):$.push(w.$5n(h))}for(const h of y.keys)p.indexOf(h)===-1&&p.push(h)}return new g(d,p,$,v.every(y=>y instanceof g)?void 0:v,this.f)}h(a){const d=this.j(a);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const $={};for(const p of C.$Mb([...Object.keys(this.contents),...Object.keys(d)])){let v=this.contents[p];const y=d[p];y&&(typeof v=="object"&&typeof y=="object"?(v=w.$5n(v),this.i(v,y)):v=y),$[p]=v}return new g($,this.keys,this.overrides,void 0,this.f)}i(a,d){for(const $ of Object.keys(d)){if($ in a&&m.$ag(a[$])&&m.$ag(d[$])){this.i(a[$],d[$]);continue}a[$]=w.$5n(d[$])}}j(a){let d=null,$=null;const p=v=>{v&&($?this.i($,v):$=w.$5n(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===a?d=v.contents:v.identifiers.includes(a)&&p(v.contents);return p(d),$}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,d){this.k(a,d,!0)}setValue(a,d){this.k(a,d,!1)}removeValue(a){const d=this.keys.indexOf(a);d!==-1&&(this.keys.splice(d,1),(0,T.$_i)(this.contents,a),S.$uo.test(a)&&this.overrides.splice(this.overrides.findIndex($=>C.$ub($.identifiers,(0,S.$vo)(a))),1))}k(a,d,$){(0,T.$$i)(this.contents,a,d,p=>this.f.error(p)),$=$||this.keys.indexOf(a)===-1,$&&this.keys.push(a),S.$uo.test(a)&&this.overrides.push({identifiers:(0,S.$vo)(a),keys:Object.keys(this.contents[a]),contents:(0,T.$0i)(this.contents[a],p=>this.f.error(p))})}}e.$Ao=g;class r{constructor(a,d){this.f=a,this.g=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||g.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,d){if(!m.$hg(a)){const $=this.h(a);this.parseRaw($,d)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,d){this.a=a;const{contents:$,keys:p,overrides:v,restricted:y,hasExcludedProperties:h}=this.i(a,d);this.b=new g($,p,v,h?[a]:void 0,this.g),this.c=y||[]}h(a){let d={},$=null,p=[];const v=[],y=[];function h(k){Array.isArray(p)?p.push(k):$!==null&&(p[$]=k)}const D={onObjectBegin:()=>{const k={};h(k),v.push(p),p=k,$=null},onObjectProperty:k=>{$=k},onObjectEnd:()=>{p=v.pop()},onArrayBegin:()=>{const k=[];h(k),v.push(p),p=k,$=null},onArrayEnd:()=>{p=v.pop()},onLiteralValue:h,onError:(k,I,P)=>{y.push({error:k,offset:I,length:P})}};if(a)try{M.$Sn(a,D),d=p[0]||{}}catch(k){this.g.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return d}i(a,d){const $=l.$fo.as(S.$ko.Configuration).getConfigurationProperties(),p=this.j(a,$,!0,d);a=p.raw;const v=(0,T.$0i)(a,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`)),y=Object.keys(a),h=this.l(a,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:v,keys:y,overrides:h,restricted:p.restricted,hasExcludedProperties:p.hasExcludedProperties}}j(a,d,$,p){let v=!1;if(!p?.scopes&&!p?.skipRestricted&&!p?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:v};const y={},h=[];for(const D in a)if(S.$uo.test(D)&&$){const k=this.j(a[D],d,!1,p);y[D]=k.raw,v=v||k.hasExcludedProperties,h.push(...k.restricted)}else{const k=d[D],I=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&h.push(D),!p.exclude?.includes(D)&&(p.include?.includes(D)||(I===void 0||p.scopes===void 0||p.scopes.includes(I))&&!(p.skipRestricted&&k?.restricted))?y[D]=a[D]:v=!0}return{raw:y,restricted:h,hasExcludedProperties:v}}l(a,d){const $=[];for(const p of Object.keys(a))if(S.$uo.test(p)){const v={};for(const y in a[p])v[y]=a[p][y];$.push({identifiers:(0,S.$vo)(p),keys:Object.keys(v),contents:(0,T.$0i)(v,d)})}return $}}e.$Bo=r;class s extends N.$Uc{constructor(a,d,$,p,v){super(),this.c=a,this.f=d,this.g=p,this.h=v,this.b=this.B(new O.$fe),this.onDidChange=this.b.event,this.a=new r(this.c.toString(),v),this.B(this.g.watch($.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(0)||y.isOperation(3)||y.isOperation(1)||y.isOperation(4))&&$.isEqual(y.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return g.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Co=s;class o{constructor(a,d,$,p,v,y,h,D,k,I,P,V,W){this.a=a,this.b=d,this.c=$,this.overrideIdentifiers=p,this.d=v,this.f=y,this.g=h,this.h=D,this.i=k,this.j=I,this.k=P,this.l=V,this.m=W}get value(){return b(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(a,d,$,p,v,y,h,D,k,I){this.j=a,this.l=d,this.m=$,this.n=p,this.p=v,this.q=y,this.r=h,this.s=D,this.t=k,this.u=I,this.h=null,this.i=new R.$Ac,this.v=null}getValue(a,d,$){return this.w(a,d,$).getValue(a)}updateValue(a,d,$={}){let p;$.resource?(p=this.t.get($.resource),p||(p=g.createEmptyModel(this.u),this.t.set($.resource,p))):p=this.s,d===void 0?p.removeValue(a):p.setValue(a,d),$.resource||(this.h=null)}inspect(a,d,$){const p=this.w(a,d,$),v=this.A(d.resource,$),y=d.resource?this.t.get(d.resource)||this.s:this.s,h=new Set;for(const D of p.overrides)for(const k of D.identifiers)p.getOverrideValue(a,k)!==void 0&&h.add(k);return new o(a,d,p.getValue(a),h.size?[...h]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,$?this.q:void 0,v||void 0,y)}keys(a){const d=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,d){this.r.set(a,d),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,d){const $=[];if(!d){const{added:p,updated:v,removed:y}=u(this.j,a);d=[...p,...v,...y]}for(const p of d)for(const v of(0,S.$vo)(p)){const y=this.j.getKeysForOverrideIdentifier(v),h=a.getKeysForOverrideIdentifier(v),D=[...h.filter(k=>y.indexOf(k)===-1),...y.filter(k=>h.indexOf(k)===-1),...y.filter(k=>!w.$9n(this.j.override(v).getValue(k),a.override(v).getValue(k)))];$.push([v,D])}return this.updateDefaultConfiguration(a),{keys:d,overrides:$}}compareAndUpdatePolicyConfiguration(a){const{added:d,updated:$,removed:p}=u(this.l,a),v=[...d,...$,...p];return v.length&&this.updatePolicyConfiguration(a),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:d,updated:$,removed:p,overrides:v}=u(this.applicationConfiguration,a),y=[...d,...$,...p];return y.length&&this.updateApplicationConfiguration(a),{keys:y,overrides:v}}compareAndUpdateLocalUserConfiguration(a){const{added:d,updated:$,removed:p,overrides:v}=u(this.localUserConfiguration,a),y=[...d,...$,...p];return y.length&&this.updateLocalUserConfiguration(a),{keys:y,overrides:v}}compareAndUpdateRemoteUserConfiguration(a){const{added:d,updated:$,removed:p,overrides:v}=u(this.remoteUserConfiguration,a),y=[...d,...$,...p];return y.length&&this.updateRemoteUserConfiguration(a),{keys:y,overrides:v}}compareAndUpdateWorkspaceConfiguration(a){const{added:d,updated:$,removed:p,overrides:v}=u(this.workspaceConfiguration,a),y=[...d,...$,...p];return y.length&&this.updateWorkspaceConfiguration(a),{keys:y,overrides:v}}compareAndUpdateFolderConfiguration(a,d){const $=this.folderConfigurations.get(a),{added:p,updated:v,removed:y,overrides:h}=u($,d),D=[...p,...v,...y];return(D.length||!$)&&this.updateFolderConfiguration(a,d),{keys:D,overrides:h}}compareAndDeleteFolderConfiguration(a){const d=this.folderConfigurations.get(a);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:$,updated:p,removed:v,overrides:y}=u(d,void 0);return{keys:[...$,...p,...v],overrides:y}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,d,$){let p=this.x(d,$);return d.overrideIdentifier&&(p=p.override(d.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&(p=p.merge(this.l)),p}x({resource:a},d){let $=this.y();if(d&&a){const p=d.getFolder(a);p&&($=this.z(p.uri)||$);const v=this.t.get(a);v&&($=$.merge(v))}return $}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let d=this.i.get(a);if(!d){const $=this.y(),p=this.r.get(a);p?(d=$.merge(p),this.i.set(a,d)):d=$}return d}A(a,d){if(d&&a){const $=d.getFolder(a);if($)return this.r.get($.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,d)=>{const{contents:$,overrides:p,keys:v}=this.r.get(d);return a.push([d,{contents:$,overrides:p,keys:v}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach(d=>a.add(d)),this.userConfiguration.keys.forEach(d=>a.add(d)),this.q.keys.forEach(d=>a.add(d)),this.r.forEach(d=>d.keys.forEach($=>a.add($))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.q.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.r.forEach(d=>d.getAllOverrideIdentifiers().forEach($=>a.add($))),[...a.values()]}D(a){const d=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach($=>d.add($)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach($=>d.add($)),this.q.getKeysForOverrideIdentifier(a).forEach($=>d.add($)),this.r.forEach($=>$.getKeysForOverrideIdentifier(a).forEach(p=>d.add(p))),[...d.values()]}static parse(a,d){const $=this.E(a.defaults,d),p=this.E(a.policy,d),v=this.E(a.application,d),y=this.E(a.user,d),h=this.E(a.workspace,d),D=a.folders.reduce((k,I)=>(k.set(E.URI.revive(I[0]),this.E(I[1],d)),k),new R.$Ac);return new i($,p,v,y,g.createEmptyModel(d),h,D,g.createEmptyModel(d),new R.$Ac,d)}static E(a,d){return new g(a.contents,a.keys,a.overrides,void 0,d)}}e.$Do=i;function n(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const a=new Set,d=new Map;for(const p of f)p.keys.forEach(v=>a.add(v)),p.overrides.forEach(([v,y])=>{const h=(0,R.$xc)(d,v,new Set);y.forEach(D=>h.add(D))});const $=[];return d.forEach((p,v)=>$.push([v,[...p.values()]])),{keys:[...a.values()],overrides:$}}class c{constructor(a,d,$,p,v){this.change=a,this.f=d,this.g=$,this.h=p,this.i=v,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const y of a.keys)this.affectedKeys.add(y);for(const[,y]of a.overrides)for(const h of y)this.affectedKeys.add(h);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,d){const $=this.a+a,p=this.d.indexOf($);if(p<0)return!1;const v=p+$.length;if(v>=this.d.length)return!1;const y=this.d.charCodeAt(v);if(y!==this.b&&y!==this.c)return!1;if(d){const h=this.previousConfiguration?this.previousConfiguration.getValue(a,d,this.f?.workspace):void 0,D=this.g.getValue(a,d,this.h);return!w.$9n(h,D)}return!0}}e.$Fo=c;function u(f,a){const{added:d,removed:$,updated:p}=t(a?.rawConfiguration,f?.rawConfiguration),v=[],y=f?.getAllOverrideIdentifiers()||[],h=a?.getAllOverrideIdentifiers()||[];if(a){const D=h.filter(k=>!y.includes(k));for(const k of D)v.push([k,a.getKeysForOverrideIdentifier(k)])}if(f){const D=y.filter(k=>!h.includes(k));for(const k of D)v.push([k,f.getKeysForOverrideIdentifier(k)])}if(a&&f){for(const D of y)if(h.includes(D)){const k=t({contents:f.getOverrideValue(void 0,D)||{},keys:f.getKeysForOverrideIdentifier(D)},{contents:a.getOverrideValue(void 0,D)||{},keys:a.getKeysForOverrideIdentifier(D)});v.push([D,[...k.added,...k.removed,...k.updated]])}}return{added:d,removed:$,updated:p,overrides:v}}function t(f,a){const d=f?a?f.keys.filter(v=>a.keys.indexOf(v)===-1):[...f.keys]:[],$=a?f?a.keys.filter(v=>f.keys.indexOf(v)===-1):[...a.keys]:[],p=[];if(f&&a){for(const v of a.keys)if(f.keys.indexOf(v)!==-1){const y=(0,T.$aj)(a.contents,v),h=(0,T.$aj)(f.contents,v);w.$9n(y,h)||p.push(v)}}return{added:d,removed:$,updated:p}}}),define(Se[104],Ie([1,0,14,3]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.RemoteAuthorityResolverErrorCode=e.$Ll=e.$Kl=e.RemoteConnectionType=e.$Jl=void 0,e.$Nl=E,e.$Jl=(0,O.$yi)("remoteAuthorityResolverService");var M;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(M||(e.RemoteConnectionType=M={}));class N{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$Kl=N;class R{constructor(S,l){this.host=S,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ll=R;var w;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound",T.InvalidAuthority="InvalidAuthority"})(w||(e.RemoteAuthorityResolverErrorCode=w={}));class m extends C.$bb{static isNotAvailable(S){return S instanceof m&&S._code===w.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof m&&S._code===w.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof m&&S._code===w.NoResolverFound}static isInvalidAuthority(S){return S instanceof m&&S._code===w.InvalidAuthority}static isHandled(S){return S instanceof m&&S.isHandled}constructor(S,l=w.Unknown,b){super(S),this._message=S,this._code=l,this._detail=b,this.isHandled=l===w.NotAvailable&&b===!0,Object.setPrototypeOf(this,m.prototype)}}e.$Ml=m;function E(T){const S=T.indexOf("+");return S===-1?T:T.substring(0,S)}}),define(Se[58],Ie([1,0,16]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=O,e.$Km=M,e.$Lm=N,e.$Mm=R;function O(m){return m.scheme===C.Schemas.vscodeRemote?m.authority:void 0}function M(m){if(!m)return;const E=m.indexOf("+");return E<0?m:m.substr(0,E)}function N(m){const{host:E,port:T}=w(m);if(typeof T>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:T}}function R(m,E){let{host:T,port:S}=w(m);return typeof S>"u"&&(S=E),{host:T,port:S}}function w(m){const E=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const T=m.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const S=m.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:m,port:void 0}}}),define(Se[21],Ie([1,0,13,3,58]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Vm=e.$Um=e.$Tm=e.TargetPlatform=e.ExtensionType=e.$Sm=e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0,e.$Rm=N,e.$Wm=S,e.$Xm=l,e.$Ym=b,e.$Zm=g,e.$Nm="extensions.user.cache",e.$Om="extensions.builtin.cache",e.$Pm="undefined_publisher",e.$Qm=["ui","workspace","web"];function N(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$Sm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(R||(e.ExtensionType=R={}));var w;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(w||(e.TargetPlatform=w={}));class m{constructor(s){this.value=s,this._lower=s.toLowerCase()}static equals(s,o){if(typeof s>"u"||s===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof s=="string"||typeof o=="string"){const i=typeof s=="string"?s:s.value,n=typeof o=="string"?o:o.value;return C.$zf(i,n)}return s._lower===o._lower}static toKey(s){return typeof s=="string"?s.toLowerCase():s._lower}}e.$Tm=m;class E{get size(){return this.c.size}constructor(s){if(this.c=new Set,s)for(const o of s)this.add(o)}add(s){this.c.add(m.toKey(s))}delete(s){return this.c.delete(m.toKey(s))}has(s){return this.c.has(m.toKey(s))}}e.$Um=E;class T{constructor(){this.c=new Map}clear(){this.c.clear()}delete(s){this.c.delete(m.toKey(s))}get(s){return this.c.get(m.toKey(s))}has(s){return this.c.has(m.toKey(s))}set(s,o){this.c.set(m.toKey(s),o)}values(){return this.c.values()}forEach(s){this.c.forEach(s)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vm=T;function S(r){return l(r)}function l(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function b(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function g(r,s){if(s){const o=`onResolveRemoteAuthority:${(0,M.$Km)(s)}`;return!!r.activationEvents?.includes(o)}return!1}e.$1m=(0,O.$yi)("IBuiltinExtensionsScannerService")}),define(Se[105],Ie([1,0,14,21]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pG=e.$oG=void 0;class M{constructor(){this.a=new Map,this.b=new WeakMap}register(R,w){this.a.set(R,w)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const w=Object.create(null);for(const m of R){const E=this.readActivationEvents(m);E.length>0&&(w[O.$Tm.toKey(m.identifier)]=E)}return w}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const w=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let m=0;m<w.length;m++)w[m]==="onUri"&&(w[m]=`onUri:${O.$Tm.toKey(R.identifier)}`);if(!R.contributes)return w;for(const m in R.contributes){const E=this.a.get(m);if(!E)continue;const T=R.contributes[m],S=Array.isArray(T)?T:[T];try{E(S,w)}catch(l){(0,C.$1)(l)}}return w}}e.$oG=M,e.$pG=new M}),define(Se[204],Ie([1,0,22,14,6,168,51,3,12,29]),function(le,e,C,O,M,N,R,w,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0,e.$Sp=l,e.$Tp=b,e.$Up=g,e.$Vp=r,e.$Wp=s,e.$Xp=o,e.$Qp=(0,w.$yi)("requestService");class T{constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?u[t]="*****":u[t]=this.b[t];this.a=u}return this.a}}class S extends M.$Uc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,N.localize)(0,null),when:m.$kk.isEqualTo((0,m.$hk)(m.LogLevel.Trace)).serialize()})}async c(u,t,f){const a=`${u} #${++this.b}: ${t.url}`;this.a.trace(`${a} - begin`,t.type,new T(t.headers??{}));try{const d=await f();return this.a.trace(`${a} - end`,t.type,d.res.statusCode,d.res.headers),d}catch(d){throw this.a.error(`${a} - error`,t.type,(0,O.$0)(d)),d}}}e.$Rp=S;function l(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function b(c){return c.res.statusCode===204}async function g(c){return b(c)?null:(await(0,C.$Te)(c.stream)).toString()}async function r(c){if(!l(c))throw new Error("Server returned "+c.res.statusCode);return g(c)}async function s(c){if(!l(c))throw new Error("Server returned "+c.res.statusCode);if(b(c))return null;const t=(await(0,C.$Te)(c.stream)).toString();try{return JSON.parse(t)}catch(f){throw f.message+=`:
`+t,f}}function o(c){n(c)}let i;function n(c){const u=E.$fo.as(R.$ko.Configuration),t=i;i={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null)],default:"override",description:(0,N.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[i],remove:t?[t]:[]})}n(1)}),define(Se[205],Ie([1,0,23,75,33]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=R,e.$hp=w;function N(m){if(C.$u===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}function R(m,E,T,S,l,b,g,r,s){const o=Object.create(null);o["common.machineId"]=b,o["common.sqmId"]=g,o.sessionID=(0,M.$Ug)()+Date.now(),o.commitHash=S,o.version=l,o["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,C.$h)(C.$u),o["common.nodePlatform"]=O.$dc,o["common.nodeArch"]=T,o["common.product"]=s||"desktop",r&&(o["common.msftInternal"]=r);let i=0;const n=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),C.$l&&(o["common.snap"]="true");const c=N(E);return c&&(o["common.platformDetail"]=c),o}function w(m){const E=O.env.USERDNSDOMAIN;if(!E)return!1;const T=E.toLowerCase();return m.some(S=>T===S)}}),define(Se[206],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=void 0,e.$4l=(0,C.$yi)("telemetryService"),e.$5l=(0,C.$yi)("customEndpointTelemetryService"),e.$6l="telemetry.currentSessionDate",e.$7l="telemetry.firstSessionDate",e.$8l="telemetry.lastSessionDate",e.$9l="telemetry.machineId",e.$0l="telemetry.sqmId",e.$$l="telemetry",e.$_l="telemetry.telemetryLevel",e.$am="telemetry.enableCrashReporter",e.$bm="telemetry.enableTelemetry";var O;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var M;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(M||(e.TelemetryConfiguration=M={}))}),define(Se[59],Ie([1,0,26,15,58,205,206]),function(le,e,C,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=void 0,e.$pp=T,e.$qp=S,e.$rp=l,e.$sp=b,e.$tp=r,e.$up=o,e.$vp=i,e.$wp=u;class w{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.$ip=w;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$jp=m,e.$kp=new m;class E{async publicLog(f,a,d){}async publicLogError(f,a,d){}}e.$lp=E,e.$mp="telemetry",e.$np="extensionTelemetryLog",e.$op={log:()=>null,flush:()=>Promise.resolve(null)};function T(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}function S(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function l(t){const f=t.getValue(R.$_l),a=t.getValue(R.$am);if(t.getValue(R.$bm)===!1||a===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function b(t){const f={},a={},d={};s(t,d);for(let $ in d){$=$.length>150?$.substr($.length-149):$;const p=d[$];typeof p=="number"?a[$]=p:typeof p=="boolean"?a[$]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${$} has been trimmed to 8192, the original length is ${p.length}`),f[$]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(f[$]=p)}return{properties:f,measurements:a}}const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const f=(0,M.$Km)(t);return g.has(f)?f:"other"}function s(t,f,a=0,d){if(t)for(const $ of Object.getOwnPropertyNames(t)){const p=t[$],v=d?d+$:$;Array.isArray(p)?f[v]=(0,C.$0n)(p):p instanceof Date?f[v]=p.toISOString():(0,O.$ag)(p)?a<2?s(p,f,a+1,v+"."):f[v]=(0,C.$0n)(p):f[v]=p}}function o(t,f){const a=t.msftInternalDomains||[],d=f.getValue("telemetry.internalTesting");return(0,N.$hp)(a)||d}function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let a=t;const d=[];for(const y of f)for(;;){const h=y.exec(t);if(!h)break;d.push([h.index,y.lastIndex])}const $=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(a="";;){const y=p.exec(t);if(!y)break;const h=d.some(([D,k])=>y.index<k&&D<p.lastIndex);!$.test(y[0])&&!h&&(a+=t.substring(v,y.index)+"<REDACTED: user-file-path>",v=p.lastIndex)}return v<t.length&&(a+=t.substr(v)),a}function c(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of f)if(a.regex.test(t))return`<REDACTED: ${a.label}>`;return t}function u(t,f){return(0,C.$7n)(t,a=>{if(a instanceof w||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let d=a.replaceAll("%20"," ");d=n(d,f);for(const $ of f)d=d.replace($,"");return d=c(d),d}})}}),define(Se[207],Ie([1,0,13,100,21,23,2,14,75,59]),function(le,e,C,O,M,N,R,w,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$yp=void 0,e.$xp=T,e.$zp=g,e.$Ap=r,e.$Bp=s,e.$Cp=o,e.$Dp=i,e.$Ep=n,e.$Fp=c,e.$Hp=u,e.$Ip=f;function T(a,d){return a.uuid&&d.uuid?a.uuid===d.uuid:a.id===d.id?!0:(0,C.$uf)(a.id,d.id)===0}const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(d){const $=d.manifest?d.manifest.version:d.version,p=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new l(d.identifier,$,p)}static parse(d){const $=S.exec(d);return $&&$[1]&&$[2]?new l({id:$[1]},$[2],$[4]||void 0):null}constructor(d,$,p="undefined"){this.version=$,this.targetPlatform=p,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof l?T(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$yp=l;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(a){const d=b.exec(a);return d&&d[1]?[s(d[1]),d[2]]:[s(a),void 0]}function r(a,d){return`${a}.${d}`}function s(a){return a.toLowerCase()}function o(a,d){return s(r(a??M.$Pm,d))}function i(a,d){const $=[],p=v=>{for(const y of $)if(y.some(h=>T(d(h),d(v))))return y;return null};for(const v of a){const y=p(v);y?y.push(v):$.push([v])}return $}function n(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function c(a){return{id:new E.$ip(a.identifier.id),name:new E.$ip(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Gp=new M.$Tm("pprice.better-merge");function u(a,d){const $=[],p=d.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const v=p.shift();if(v&&$.every(y=>!T(y.identifier,{id:v}))){const y=a.filter(h=>T(h.identifier,{id:v}));y.length===1&&($.push(y[0]),p.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return $}async function t(a,d){if(!N.$k)return!1;let $;try{$=(await a.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{$=(await a.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){d.debug("Error while getting the os-release file.",(0,w.$0)(v))}}return!!$&&($.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(a,d){const $=await t(a,d),p=(0,O.$5o)($?"alpine":N.$u,m.$ec);return d.debug("ComputeTargetPlatform:",p),p}}),define(Se[208],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=C,e.$ps=O,e.$qs=M,e.$rs=N,e.$ss=R,e.$ts=w;function C(m){return[...m.entries()]}function O(m){return m?[...m.entries()]:[]}function M(m){return new Map(m)}function N(m){return new Map(m??[])}function R(m){return Array.from(m.entries()).map(E=>[E[0],C(E[1].map),O(E[1].descriptionMap)])}function w(m){return new Map(m.map(E=>[E[0],{map:M(E[1]),descriptionMap:N(E[2])}]))}}),define(Se[209],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0vb=void 0;class C{constructor(M){this.b=M,this.a=new Map}dispose(){for(const M of this.a.values())M.dispose()}startBuffering(M,N,R=5){const w=N(m=>{const E=typeof m=="string"?m:m.data;let T=this.a.get(M);if(T){T.data.push(E);return}const S=setTimeout(()=>this.flushBuffer(M),R);T={data:[E],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(M),w.dispose()}},this.a.set(M,T)});return w}stopBuffering(M){this.a.get(M)?.dispose()}flushBuffer(M){const N=this.a.get(M);N&&(this.a.delete(M),this.b(M,N.data.join("")))}}e.$0vb=C}),define(Se[210],Ie([1,0,11,92,312,36,5,15,2,169,74,29]),function(le,e,C,O,M,N,R,w,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$px=e.$ox=e.$nx=e.$mx=e.$lx=e.$kx=e.IconFontDefinition=e.IconContribution=e.$hx=void 0,e.$ix=s,e.$jx=o,e.$hx={IconContribution:"base.contributions.icons"};var l;(function(u){function t(f,a){let d=f.defaults;for(;N.ThemeIcon.isThemeIcon(d);){const $=r.getIcon(d.id);if(!$)return;d=$.defaults}return d}u.getDefinition=t})(l||(e.IconContribution=l={}));var b;(function(u){function t(a){return{weight:a.weight,style:a.style,src:a.src.map(d=>({format:d.format,location:d.location.toString()}))}}u.toJSONObject=t;function f(a){const d=$=>(0,w.$$f)($)?$:void 0;if(a&&Array.isArray(a.src)&&a.src.every($=>(0,w.$$f)($.format)&&(0,w.$$f)($.location)))return{weight:d(a.weight),style:d(a.style),src:a.src.map($=>({format:$.format,location:m.URI.parse($.location)}))}}u.fromJSONObject=f})(b||(e.IconFontDefinition=b={}));class g{constructor(){this.a=new R.$fe,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${N.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,f,a,d){const $=this.b[t];if($){if(a&&!$.description){$.description=a,this.d.properties[t].markdownDescription=`${a} $(${t})`;const y=this.e.enum.indexOf(t);y!==-1&&(this.e.enumDescriptions[y]=a),this.a.fire()}return $}const p={id:t,description:a,defaults:f,deprecationMessage:d};this.b[t]=p;const v={$ref:"#/definitions/icons"};return d&&(v.deprecationMessage=d),a&&(v.markdownDescription=`${a}: $(${t})`),this.d.properties[t]=v,this.e.enum.push(t),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const f=this.e.enum.indexOf(t);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,f){const a=this.f[t];return a||(this.f[t]=f,this.a.fire(),f)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=($,p)=>$.id.localeCompare(p.id),f=$=>{for(;N.ThemeIcon.isThemeIcon($.defaults);)$=this.b[$.defaults.id];return`codicon codicon-${$?$.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.b).map($=>this.b[$]);for(const $ of d.filter(p=>!!p.description).sort(t))a.push(`|<i class="${f($)}"></i>|${$.id}|${N.ThemeIcon.isThemeIcon($.defaults)?$.defaults.id:$.id}|${$.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const $ of d.filter(p=>!N.ThemeIcon.isThemeIcon(p.defaults)).sort(t))a.push(`|<i class="${f($)}"></i>|${$.id}|`);return a.join(`
`)}}const r=new g;S.$fo.add(e.$hx.IconContribution,r);function s(u,t,f,a){return r.registerIcon(u,t,f,a)}function o(){return r}function i(){const u=(0,M.$Tj)();for(const t in u){const f="\\"+u[t].toString(16);r.registerIcon(t,{fontCharacter:f})}}i(),e.$kx="vscode://schemas/icons";const n=S.$fo.as(T.$go.JSONContribution);n.registerSchema(e.$kx,r.getIconSchema());const c=new C.$Kh(()=>n.notifySchemaChanged(e.$kx),200);r.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$lx=s("widget-close",O.$Xj.close,(0,E.localize)(2,null)),e.$mx=s("goto-previous-location",O.$Xj.arrowUp,(0,E.localize)(3,null)),e.$nx=s("goto-next-location",O.$Xj.arrowDown,(0,E.localize)(4,null)),e.$ox=N.ThemeIcon.modify(O.$Xj.sync,"spin"),e.$px=N.ThemeIcon.modify(O.$Xj.loading,"spin")}),define(Se[211],Ie([1,0,5,2,50,3,12]),function(le,e,C,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ww=e.$vw=e.$sw=e.$qw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$mw=e.$lw=void 0,e.$nw=E,e.$ow=S,e.$pw=l,e.$rw=b,e.$tw=g,e.$uw=r,e.$lw=(0,N.$yi)("tunnelService"),e.$mw=(0,N.$yi)("sharedTunnelsService");var w;(function(i){i.Http="http",i.Https="https"})(w||(e.TunnelProtocol=w={}));var m;(function(i){i.ConstantPrivate="constantPrivate",i.Private="private",i.Public="public"})(m||(e.TunnelPrivacyId=m={}));function E(i){return!!i.forwardPort}var T;(function(i){i[i.Notify=1]="Notify",i[i.OpenBrowser=2]="OpenBrowser",i[i.OpenPreview=3]="OpenPreview",i[i.Silent=4]="Silent",i[i.Ignore=5]="Ignore",i[i.OpenBrowserOnce=6]="OpenBrowserOnce"})(T||(e.ProvidedOnAutoForward=T={}));function S(i){if(i.scheme!=="http"&&i.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(i.authority);if(n)return{address:n[1],port:+n[2]}}function l(i){if(i.scheme!=="http"&&i.scheme!=="https"||!i.query)return;const n=i.query.split("&");for(const c of n){const u=c.split("=")[1];if(/^https?:/.exec(u)){const t=S(O.URI.parse(u));if(t)return t}}}e.$qw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(i){return e.$qw.indexOf(i)>=0}e.$sw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(i){return e.$sw.indexOf(i)>=0}function r(i,n,c,u){if(c===1)return!1;if(c===2&&g(n)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(t?.length===4&&parseInt(t[1])>=18)return!1}return i<1024}class s{constructor(n,c,u){this.remoteAddress=n,this.localAddress=c,this.b=u,this.a=new C.$fe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$vw=s;let o=class{constructor(n,c){this.k=n,this.l=c,this.a=new C.$fe,this.onTunnelOpened=this.a.event,this.b=new C.$fe,this.onTunnelClosed=this.b.event,this.c=new C.$fe,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const n=this.l.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.f=n,n?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.g=n.elevation,this.i=n.privacyOptions,this.h=n.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const n=[],c=Array.from(this.e.values());for(const u of c){const t=Array.from(u.values());for(const f of t){const a=await f.value;a&&typeof a!="string"&&n.push(a)}}return n}async dispose(){for(const n of this.e.values()){for(const{value:c}of n.values())await c.then(u=>typeof u!="string"?u?.dispose():void 0);n.clear()}this.e.clear()}setEnvironmentTunnel(n,c,u,t,f){this.q(n,c,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:c,localAddress:u,privacy:t,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,c){(g(n)||b(n))&&(n=e.$qw[0]);const u=this.s(n,c);if(u)return++u.refcount,u.value}openTunnel(n,c,u,t,f,a=!1,d,$){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${u} on local port ${f}.`);const p=this.f??n;if(!p)return;if(c||(c="localhost"),t||(t=this.m),this.f&&this.j.has(u)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.t(p,c,u,t,f,a,d,$);return v?v.then(y=>{if(y){if(typeof y=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,u),y}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,u);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const h=this.o(y);return(y.tunnelRemoteHost!==c||y.tunnelRemotePort!==u)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),d&&y.privacy!==d&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(h),h}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}o(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const c=this.e.get(n.tunnelRemoteHost);if(c){const u=c.get(n.tunnelRemotePort);u&&(u.refcount--,await this.p(n.tunnelRemoteHost,n.tunnelRemotePort,u))}}}}async p(n,c,u){if(u.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${c}.`);const t=u.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.e.has(n)&&this.e.get(n).delete(c),t}}async closeTunnel(n,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${c} `);const u=this.e.get(n);if(u&&u.has(c)){const t=u.get(c);t.refcount=0,await this.p(n,c,t)}}q(n,c,u){this.e.has(n)||this.e.set(n,new Map),this.e.get(n).set(c,{refcount:1,value:u})}async r(n,c){const u=this.e.get(n);if(u){const t=u.get(c),f=t?await t.value:void 0;(!f||typeof f=="string")&&u.delete(c),u.size===0&&this.e.delete(n)}}s(n,c){const u=[n];b(n)?(u.push(...e.$qw),u.push(...e.$sw)):g(n)&&u.push(...e.$sw);const t=u.map(f=>this.e.get(f));for(const f of t){const a=f?.get(c);if(a)return a}}canTunnel(n){return!!S(n)}u(n,c,u,t,f,a,d){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${u} on local port ${t}.`);const $=u;this.j.add($);const p=t===void 0?u:t,v={elevationRequired:f?this.isPortPrivileged(p):!1},y={remoteAddress:{host:c,port:u},localAddressPort:t,privacy:a,public:a?a!==m.Private:void 0,protocol:d},h=n.forwardPort(y,v);return h?(this.q(c,u,h),h.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete($)})):this.j.delete($),h}};e.$ww=o,e.$ww=o=Je([We(0,R.$5j),We(1,M.$5i)],o)}),define(Se[212],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=void 0,e.$Cl=(0,C.$yi)("IUriIdentityService")}),define(Se[213],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$xw=void 0,e.$xw=(0,C.$yi)("editSessionIdentityService");var O;(function(M){M[M.Complete=100]="Complete",M[M.Partial=50]="Partial",M[M.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(Se[214],Ie([1,0,16]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RL=O,e.$SL=M,e.$TL=N,e.$UL=R,e.$VL=w;function O(m){return m.scheme!==C.Schemas.file&&m.scheme!==C.Schemas.vscodeRemote}function M(m){if(m.folders.length)return m.folders.every(E=>O(E.uri))?m.folders[0].uri:void 0;if(m.configuration&&O(m.configuration))return m.configuration}function N(m){return M(m)?.scheme}function R(m){return M(m)?.authority}function w(m){return M(m)!==void 0}}),define(Se[45],Ie([1,0,171,19,54,24,2,3,16]),function(le,e,C,O,M,N,R,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Si=e.$Ri=e.WorkbenchState=e.$Li=e.$Ki=e.$Hi=void 0,e.$Ii=E,e.$Ji=T,e.$Mi=S,e.$Ni=l,e.$Oi=b,e.$Pi=r,e.$Qi=s,e.$Ti=n,e.$Yi=c,e.$Zi=u,e.$2i=t,e.$3i=f,e.$4i=a,e.$Hi=(0,w.$yi)("contextService");function E(d){const $=d;return typeof $?.id=="string"&&R.URI.isUri($.uri)}function T(d){return typeof d?.id=="string"&&!E(d)&&!l(d)}e.$Ki={id:"ext-dev"},e.$Li={id:"empty-window"};function S(d,$){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,O.$nc)(d)}:$?e.$Ki:e.$Li;const p=d;return p.configuration?{id:p.id,configPath:p.configuration}:p.folders.length===1?{id:p.id,uri:p.folders[0].uri}:{id:p.id}}function l(d){const $=d;return typeof $?.id=="string"&&R.URI.isUri($.configPath)}function b(d){const $=d;if($?.uri)return{id:$.id,uri:R.URI.revive($.uri)};const p=d;if(p?.configPath)return{id:p.id,configPath:R.URI.revive(p.configPath)};if(d?.id)return{id:d.id}}var g;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function r(d){const $=d;return!!($&&typeof $=="object"&&typeof $.id=="string"&&Array.isArray($.folders))}function s(d){const $=d;return!!($&&typeof $=="object"&&R.URI.isUri($.uri)&&typeof $.name=="string"&&typeof $.toResource=="function")}class o{constructor($,p,v,y,h){this.h=$,this.j=v,this.k=y,this.l=h,this.c=M.$Ei.forUris(this.l,()=>!0),this.folders=p}update($){this.h=$.id,this.k=$.configuration,this.j=$.transient,this.l=$.l,this.folders=$.folders}get folders(){return this.g}set folders($){this.g=$,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration($){this.k=$}getFolder($){return $&&this.c.findSubstr($)||null}n(){this.c=M.$Ei.forUris(this.l,()=>!0);for(const $ of this.folders)this.c.set($.uri,$)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ri=o;class i{constructor($,p){this.raw=p,this.uri=$.uri,this.index=$.index,this.name=$.name}toResource($){return(0,N.$_g)(this.uri,$)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Si=i;function n(d){return new i({uri:d,index:0,name:(0,N.$8g)(d)},{uri:d.toString()})}e.$Ui="code-workspace",e.$Vi=`.${e.$Ui}`,e.$Wi=[{name:(0,C.localize)(0,null),extensions:[e.$Ui]}],e.$Xi="workspace.json";function c(d,$){return N.$3g.isEqualOrParent(d,$.untitledWorkspacesHome)}function u(d){let $;return R.URI.isUri(d)?$=d:$=d.configuration,$?.scheme===m.Schemas.tmp}e.$1i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(d){return d.id===e.$1i}function f(d,$){return!c(d,$)&&!u(d)}function a(d){return(typeof d=="string"?(0,O.$oc)(d):(0,N.$0g)(d))===e.$Vi}}),define(Se[215],Ie([1,0,73,5,6,24,2,170,99,38,3,12,45,28,212,11,33,13,15]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$El=e.ProfileResourceType=void 0,e.$Dl=c,e.$Fl=u,e.$Gl=t;var n;(function(d){d.Settings="settings",d.Keybindings="keybindings",d.Snippets="snippets",d.Tasks="tasks",d.Extensions="extensions",d.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function c(d){const $=d;return!!($&&typeof $=="object"&&typeof $.id=="string"&&typeof $.isDefault=="boolean"&&typeof $.name=="string"&&R.URI.isUri($.location)&&R.URI.isUri($.globalStorageHome)&&R.URI.isUri($.settingsResource)&&R.URI.isUri($.keybindingsResource)&&R.URI.isUri($.tasksResource)&&R.URI.isUri($.snippetsHome)&&R.URI.isUri($.extensionsResource))}e.$El=(0,T.$yi)("IUserDataProfilesService");function u(d,$){return{id:d.id,isDefault:d.isDefault,name:d.name,shortName:d.shortName,icon:d.icon,location:R.URI.revive(d.location).with({scheme:$}),globalStorageHome:R.URI.revive(d.globalStorageHome).with({scheme:$}),settingsResource:R.URI.revive(d.settingsResource).with({scheme:$}),keybindingsResource:R.URI.revive(d.keybindingsResource).with({scheme:$}),tasksResource:R.URI.revive(d.tasksResource).with({scheme:$}),snippetsHome:R.URI.revive(d.snippetsHome).with({scheme:$}),extensionsResource:R.URI.revive(d.extensionsResource).with({scheme:$}),cacheHome:R.URI.revive(d.cacheHome).with({scheme:$}),useDefaultFlags:d.useDefaultFlags,isTransient:d.isTransient}}function t(d,$,p,v,y,h){return{id:d,name:$,location:p,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:h&&y?.useDefaultFlags?.globalState?h.globalStorageHome:(0,N.$_g)(p,"globalStorage"),settingsResource:h&&y?.useDefaultFlags?.settings?h.settingsResource:(0,N.$_g)(p,"settings.json"),keybindingsResource:h&&y?.useDefaultFlags?.keybindings?h.keybindingsResource:(0,N.$_g)(p,"keybindings.json"),tasksResource:h&&y?.useDefaultFlags?.tasks?h.tasksResource:(0,N.$_g)(p,"tasks.json"),snippetsHome:h&&y?.useDefaultFlags?.snippets?h.snippetsHome:(0,N.$_g)(p,"snippets"),extensionsResource:h&&y?.useDefaultFlags?.extensions?h.extensionsResource:(0,N.$_g)(p,"extensions.json"),cacheHome:(0,N.$_g)(v,d),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let f=class extends M.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor($,p,v,y){super(),this.t=$,this.u=p,this.w=v,this.y=y,this.f=!0,this.h=this.B(new O.$fe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$fe),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$fe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$fe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new b.$Ac,emptyWindows:new Map},this.profilesHome=(0,N.$_g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$_g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement($){this.f!==$&&(this.z=void 0,this.f=$)}isEnabled(){return this.f}get C(){if(!this.z){const $=this.D(),p=[$];if(this.f)try{for(const h of this.O()){if(!h.name||!(0,i.$$f)(h.name)||!h.location){this.y.warn("Skipping the invalid stored profile",h.location||h.name);continue}p.push(t((0,N.$9g)(h.location),h.name,h.location,this.g,{shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags},$))}}catch(h){this.y.error(h)}const v=new b.$Ac,y=new Map;if(p.length)try{const h=this.Q();if(h.workspaces)for(const[D,k]of Object.entries(h.workspaces)){const I=R.URI.parse(D),P=p.find(V=>V.id===k);P&&v.set(I,P)}if(h.emptyWindows)for(const[D,k]of Object.entries(h.emptyWindows)){const I=p.find(P=>P.id===k);I&&y.set(D,I)}}catch(h){this.y.error(h)}this.z={profiles:p,workspaces:v,emptyWindows:y}}return this.z}D(){const $=t("__default__profile__",(0,w.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...$,extensionsResource:this.S()??$.extensionsResource,isDefault:!0}}async createTransientProfile($){const p="Temp",v=new RegExp(`${(0,o.$bf)(p)}\\s(\\d+)`);let y=0;for(const D of this.profiles){const k=v.exec(D.name),I=k?parseInt(k[1]):0;y=I>y?I:y}const h=`${p} ${y+1}`;return this.createProfile((0,C.$mj)((0,s.$Ug)()).toString(16),h,{transient:!0},$)}async createNamedProfile($,p,v){return this.createProfile((0,C.$mj)((0,s.$Ug)()).toString(16),$,p,v)}async createProfile($,p,v,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=await this.F($,p,v);return y&&await this.setProfileForWorkspace(y,h),h}async F($,p,v){if(!(0,i.$$f)(p)||!p)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(p);return y||(y=(async()=>{try{if(this.profiles.find(I=>I.name===p||I.id===$))throw new Error(`Profile with ${p} name already exists`);const D=t($,p,(0,N.$_g)(this.profilesHome,$),this.g,v,this.defaultProfile);await this.u.createFolder(D.location);const k=[];return this.j.fire({profile:D,join(I){k.push(I)}}),await r.Promises.settled(k),this.I([D],[],[]),D}finally{this.r.delete(p)}})(),this.r.set(p,y)),y}async updateProfile($,p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let v=this.profiles.find(y=>y.id===$.id);if(!v)throw new Error(`Profile '${$.name}' does not exist`);return v=t(v.id,p.name??v.name,v.location,this.g,{shortName:p.shortName??v.shortName,icon:p.icon===null?void 0:p.icon??v.icon,transient:p.transient??v.isTransient,useDefaultFlags:p.useDefaultFlags??v.useDefaultFlags},this.defaultProfile),this.I([],[],[v]),v}async removeProfile($){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if($.isDefault)throw new Error("Cannot remove default profile");const p=this.profiles.find(y=>y.id===$.id);if(!p)throw new Error(`Profile '${$.name}' does not exist`);const v=[];this.m.fire({profile:p,join(y){v.push(y)}});try{await Promise.allSettled(v)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])p.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])p.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[p],[]);try{await this.u.del(p.cacheHome,{recursive:!0})}catch(y){(0,E.$jl)(y)!==1&&this.y.error(y)}}async setProfileForWorkspace($,p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=this.profiles.find(y=>y.id===p.id);if(!v)throw new Error(`Profile '${p.name}' does not exist`);this.L($,v)}unsetWorkspace($,p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L($,void 0,p)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const $=await this.u.resolve(this.profilesHome);await Promise.all(($.children||[]).filter(p=>p.isDirectory&&this.profiles.every(v=>!this.w.extUri.isEqual(v.location,p.resource))).map(p=>this.u.del(p.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const $=this.s.profiles.filter(p=>!this.H(p));await Promise.allSettled($.map(p=>this.removeProfile(p)))}getProfileForWorkspace($){const p=this.G($);return R.URI.isUri(p)?this.s.workspaces.get(p)??this.C.workspaces.get(p):this.s.emptyWindows.get(p)??this.C.emptyWindows.get(p)}G($){return(0,l.$Ii)($)?$.uri:(0,l.$Ni)($)?$.configPath:$.id}H($){return!!([...this.s.emptyWindows.values()].some(p=>this.w.extUri.isEqual(p.location,$.location))||[...this.s.workspaces.values()].some(p=>this.w.extUri.isEqual(p.location,$.location))||[...this.C.emptyWindows.values()].some(p=>this.w.extUri.isEqual(p.location,$.location))||[...this.C.workspaces.values()].some(p=>this.w.extUri.isEqual(p.location,$.location)))}I($,p,v){const y=[...this.profiles,...$],h=[];this.s.profiles=[];for(let D of y)D.isDefault||p.some(k=>D.id===k.id)||(D=v.find(k=>D.id===k.id)??D,D.isTransient?this.s.profiles.push(D):h.push({location:D.location,name:D.name,shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags}));this.P(h),this.z=void 0,this.J($,p,v)}J($,p,v){this.h.fire({added:$,removed:p,updated:v,all:this.profiles})}L($,p,v){v=p?.isTransient?!0:v,v||this.L($,void 0,!0);const y=this.G($),h=v?this.s:this.C;R.URI.isUri(y)?(h.workspaces.delete(y),p&&h.workspaces.set(y,p)):(h.emptyWindows.delete(y),p&&h.emptyWindows.set(y,p)),v||this.M()}M(){const $={};for(const[v,y]of this.C.workspaces.entries())$[v.toString()]=y.id;const p={};for(const[v,y]of this.C.emptyWindows.entries())p[v.toString()]=y.id;this.R({workspaces:$,emptyWindows:p}),this.z=void 0}N($){const p={},v=this.D();if($.workspaces)for(const[h,D]of Object.entries($.workspaces)){const k=R.URI.parse(D);p[h]=this.w.extUri.isEqual(k,v.location)?v.id:this.w.extUri.basename(k)}const y={};if($.emptyWindows)for(const[h,D]of Object.entries($.emptyWindows)){const k=R.URI.parse(D);y[h]=this.w.extUri.isEqual(k,v.location)?v.id:this.w.extUri.basename(k)}return{workspaces:p,emptyWindows:y}}O(){return[]}P($){throw new Error("not implemented")}Q(){return{}}R($){throw new Error("not implemented")}S(){}};e.$Hl=f,e.$Hl=f=Je([We(0,m.$Fi),We(1,E.$5k),We(2,g.$Cl),We(3,S.$5j)],f);class a extends f{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P($){this.a=$}Q(){return this.X}R($){this.X=$}}e.$Il=a}),define(Se[216],Ie([1,0,11,5,6,60,15,151,3,215]),function(le,e,C,O,M,N,R,w,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$6p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$4p=e.$3p=e.$2p=void 0,e.$5p=b,e.$7p=r,e.$9p=o,e.$2p="__$__isNewStorageMarker",e.$3p="__$__targetStorageMarker",e.$4p=(0,m.$yi)("storageService");var T;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(T||(e.WillSaveStateReason=T={}));var S;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var l;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(l||(e.StorageTarget=l={}));function b(i){const n=i.get(e.$3p);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class g extends M.$Uc{static{this.a=60*1e3}constructor(n={flushInterval:g.a}){super(),this.m=n,this.b=this.B(new O.$ie),this.c=this.B(new O.$ie),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$fe),this.onWillSaveState=this.f.event,this.h=this.B(new C.$Kh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new M.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,c,u){return O.Event.filter(this.b.event,t=>t.scope===n&&(c===void 0||t.key===c),u)}n(){this.j.value=(0,C.$Oh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,M.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,c){const{key:u,external:t}=c;if(u===e.$3p){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:u,target:this.J(n)[u],external:t})}w(n){this.f.fire({reason:n})}get(n,c,u){return this.P(c)?.get(n,u)}getBoolean(n,c,u){return this.P(c)?.getBoolean(n,u)}getNumber(n,c,u){return this.P(c)?.getNumber(n,u)}getObject(n,c,u){return this.P(c)?.getObject(n,u)}storeAll(n,c){this.y(()=>{for(const u of n)this.store(u.key,u.value,u.scope,u.target,c)})}store(n,c,u,t,f=!1){if((0,R.$hg)(c)){this.remove(n,u,f);return}this.y(()=>{this.z(n,u,t),this.P(u)?.set(n,c,f)})}remove(n,c,u=!1){this.y(()=>{this.z(n,c,void 0),this.P(c)?.delete(n,u)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,c){const u=[],t=this.J(n);for(const f of Object.keys(t))t[f]===c&&u.push(f);return u}z(n,c,u,t=!1){const f=this.J(c);typeof u=="number"?f[n]!==u&&(f[n]=u,this.P(c)?.set(e.$3p,JSON.stringify(f),t)):typeof f[n]=="number"&&(delete f[n],this.P(c)?.set(e.$3p,JSON.stringify(f),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const c=this.P(n);return c?b(c):Object.create(null)}isNew(n){return this.getBoolean(e.$2p,n)===!0}async flush(n=T.NONE){this.f.fire({reason:n});const c=this.P(-1),u=this.P(0),t=this.P(1);switch(n){case T.NONE:await C.Promises.settled([c?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await C.Promises.settled([c?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,u=this.P(1)?.items??new Map;return o(n,c,u,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,c){return this.w(T.NONE),(0,E.$Dl)(n)?this.R(n,c):this.S(n,c)}M(n,c){return!(n.id===c.id||r(c)&&r(n))}N(n,c,u){this.y(()=>{const t=new Set;for(const[f,a]of n)t.add(f),c.get(f)!==a&&this.u(u,{key:f,external:!0});for(const[f]of c.items)t.has(f)||this.u(u,{key:f,external:!0})})}}e.$6p=g;function r(i){return i.isDefault||!!i.useDefaultFlags?.globalState}class s extends g{constructor(){super(),this.U=this.B(new w.$Zp(new w.$1p,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new w.$Zp(new w.$1p,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new w.$Zp(new w.$1p,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$8p=s;async function o(i,n,c,u,t,f){const a=I=>{try{return JSON.parse(I)}catch{return I}},d=new Map,$=new Map;i.forEach((I,P)=>{d.set(P,I),$.set(P,a(I))});const p=new Map,v=new Map;n.forEach((I,P)=>{p.set(P,I),v.set(P,a(I))});const y=new Map,h=new Map;c.forEach((I,P)=>{y.set(P,I),h.set(P,a(I))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const D=[];if(d.forEach((I,P)=>{D.push({key:P,value:I})}),console.table(D),console.groupEnd(),console.log($),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const I=[];p.forEach((P,V)=>{I.push({key:V,value:P})}),console.table(I),console.groupEnd(),console.log(v)}console.group(`Storage: Workspace (path: ${f})`);const k=[];y.forEach((I,P)=>{k.push({key:P,value:I})}),console.table(k),console.groupEnd(),console.log(h)}}),define(Se[76],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=void 0;class C{static{this.a=!1}constructor(M){this.d=M,this.b=new Map,this.c=1}add(M){const N=this.c++;return this.b.set(N,M),this.e(),N}get(M,N){return this.b.has(M)?this.b.get(M)[N]:void 0}delete(M){this.b.delete(M),this.e()}e(){C.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Xlc=C}),define(Se[46],Ie([1,0,16,24,3]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=e.$3lc=void 0;class N{constructor(){this.a=new Set(Object.keys(C.Schemas)),this.b=new Map,this.extUri=new O.$1g(w=>{const m=this.b.get(w.scheme);return!(m===void 0||m&1024)})}$acceptProviderInfos(w,m){m===null?this.b.delete(w.scheme):this.b.set(w.scheme,m)}isFreeScheme(w){return!this.b.has(w)&&!this.a.has(w)}getCapabilities(w){return this.b.get(w)}}e.$3lc=N,e.$4lc=(0,M.$yi)("IExtHostFileSystemInfo")}),define(Se[27],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3O=void 0,e.$3O=(0,C.$yi)("IExtHostInitDataService")}),define(Se[217],Ie([1,0,176,12,201,27]),function(le,e,C,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0nc=void 0;let R=class extends M.$aQ{constructor(m,E,T){const S=T.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",l=T.remote.isRemote?(0,C.localize)(0,null):m?(0,C.localize)(1,null):(0,C.localize)(2,null);super(E.createLogger(S,{name:l}))}};e.$0nc=R,e.$0nc=R=Je([We(1,O.$6j),We(2,N.$3O)],R)}),define(Se[218],Ie([1,0,11]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=e.$Imc=void 0;class O{constructor(R,w,m){this.h=new Map,this.a=R,this.b=w,this.c=m,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new C.$Kh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const T of E.values())T.complete()}catch(T){for(const S of E.values())S.error(T)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,w){let m=this.f[R];return typeof m>"u"&&(m=w),m}update(R,w){this.f[R]=w;const m=this.h.get(R);if(m!==void 0)return m.p;const E=new C.$Vh;return this.h.set(R,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$Imc=O;class M extends O{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,w){super(R.identifier.value,!0,w),this.j=R}}e.$Jmc=M}),define(Se[219],Ie([1,0,5,2]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xnc=void 0;class M{constructor(R){this.c=R,this.a=new C.$fe,this.onDidSaveNotebookDocument=this.a.event,this.b=new C.$fe,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,w,m,E){const S=this.c.getNotebookDocument(O.URI.revive(R)).acceptModelChanged(w.value,m,E);this.b.fire(S)}$acceptDirtyStateChanged(R,w){this.c.getNotebookDocument(O.URI.revive(R)).acceptDirty(w)}$acceptModelSaved(R){const w=this.c.getNotebookDocument(O.URI.revive(R));this.a.fire(w.apiNotebook)}}e.$xnc=M}),define(Se[17],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NO=e.$MO=void 0,e.$MO=(0,C.$yi)("IExtHostRpcService");class O{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.$NO=O}),define(Se[220],Ie([1,0,21,5]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=void 0;class M{#e;constructor(R,w){this.b=new O.$fe,this.onDidChange=this.b.event,this.a=C.$Tm.toKey(R.identifier),this.#e=w,this.#e.onDidChangePassword(m=>{m.extensionId===this.a&&this.b.fire({key:m.key})})}get(R){return this.#e.get(this.a,R)}store(R,w){return this.#e.store(this.a,R,w)}delete(R){return this.#e.delete(this.a,R)}}e.$Smc=M}),define(Se[61],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=e.$gmc=void 0,e.$gmc=(0,C.$yi)("IURITransformerService");class O{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$hmc=O}),define(Se[221],Ie([1,0,22]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9rb=M,e.$0rb=R;class O{constructor(){this.buffers=[]}add(m){let E=this.buffers.indexOf(m);return E<0&&(E=this.buffers.length,this.buffers.push(m)),E}}function M(w,m){if(m.serializeBuffersForPostMessage){const E=new O,S=JSON.stringify(w,(b,g)=>{if(g instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(g)};if(ArrayBuffer.isView(g)){const r=N(g);if(r)return{$$vscode_array_buffer_reference$$:!0,index:E.add(g.buffer),view:{type:r,byteLength:g.byteLength,byteOffset:g.byteOffset}}}return g}),l=E.buffers.map(b=>{const g=new Uint8Array(b);return C.$He.wrap(g)});return{message:S,buffers:l}}else return{message:JSON.stringify(w),buffers:[]}}function N(w){switch(w.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(w,m){const E=m.map(l=>{const b=new ArrayBuffer(l.byteLength);return new Uint8Array(b).set(l.buffer),b}),T=m.length?(l,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const g=b,{index:r}=g,s=E[r];if(g.view)switch(g.view.type){case 1:return new Int8Array(s,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(s,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(s,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(s,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(s,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(s,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(s,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(s,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(s,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(s,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(s,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return s}return b}:void 0;return{message:JSON.parse(w,T),arrayBuffers:E}}}),define(Se[106],Ie([1,0,185,15,2,6,3,29,38,16,44,145,32]),function(le,e,C,O,M,N,R,w,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$UF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$LF=e.EditorInputCapabilities=e.$KF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$AF=e.$zF=e.$yF=e.$xF=e.$wF=void 0,e.$BF=r,e.$CF=s,e.$DF=o,e.$EF=i,e.$FF=n,e.$GF=c,e.$HF=u,e.$IF=t,e.$JF=f,e.$MF=y,e.$NF=D,e.$OF=k,e.$PF=I,e.$QF=P,e.$RF=V,e.$SF=W,e.$TF=de,e.$VF=ge,e.$WF=Ce,e.$XF=se,e.$YF=Oe,e.$wF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$xF={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.$yF="workbench.editor.sidebysideEditor",e.$zF="workbench.editors.textDiffEditor",e.$AF="workbench.editors.binaryResourceDiffEditor";var b;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var g;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function r(ne){const j=ne;return!!j&&typeof j.getSelection=="function"&&!!j.onDidChangeSelection}function s(ne){const j=ne;return!!j&&typeof j.getScrollPosition=="function"&&typeof j.setScrollPosition=="function"&&!!j.onDidChangeScroll}function o(ne,j,x){for(const ve of x.visibleEditorPanes)if(ve.group.id===j&&ne.matches(ve.input))return ve.getViewState()}function i(ne){if(y(ne))return!1;const j=ne;return M.URI.isUri(j?.resource)}function n(ne){if(y(ne))return!1;const j=ne;return j?.original!==void 0&&j.modified!==void 0}function c(ne){if(y(ne))return!1;const j=ne;return!j||j.resources&&!Array.isArray(j.resources)?!1:!!j.resources||!!j.multiDiffSource}function u(ne){if(y(ne)||n(ne))return!1;const j=ne;return j?.primary!==void 0&&j.secondary!==void 0}function t(ne){if(y(ne))return!1;const j=ne;return j?j.resource===void 0||j.resource.scheme===E.Schemas.untitled||j.forceUntitled===!0:!1}function f(ne){if(y(ne))return!1;const j=ne;return M.URI.isUri(j?.base?.resource)&&M.URI.isUri(j?.input1?.resource)&&M.URI.isUri(j?.input2?.resource)&&M.URI.isUri(j?.result?.resource)}var a;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var d;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d||(e.SaveReason=d={}));class ${constructor(){this.a=new Map}registerSource(j,x){let ve=this.a.get(j);return ve||(ve={source:j,label:x},this.a.set(j,ve)),ve.source}getSourceLabel(j){return this.a.get(j)?.label??j}}e.$KF=new $;var p;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad"})(p||(e.EditorInputCapabilities=p={}));class v extends N.$Uc{}e.$LF=v;function y(ne){return ne instanceof v}function h(ne){const j=ne;return M.URI.isUri(j?.preferredResource)}function D(ne){const j=ne;return y(j?.primary)&&y(j?.secondary)}function k(ne){const j=ne;return y(j?.modified)&&y(j?.original)}function I(ne,j,x,ve,Fe){return Oe(ve,[(0,S.$ij)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const ke={...x,limits:{size:Number.MAX_VALUE}};ne.openEditor(j,ke)}}),(0,S.$ij)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>Fe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}function P(ne){return y(ne?.editor)}function V(ne){const j=ne;return P(ne)&&j?.group!==void 0}function W(ne){const j=ne;return typeof j?.groupId=="number"&&y(j.editor)}var q;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var A;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ne[ne.EDITOR_STICKY=12]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=13]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(A||(e.GroupModelChangeKind=A={}));var z;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class G{getOriginalUri(j,x){if(!j)return;if(f(j))return e.$UF.getOriginalUri(j.result,x);if(x?.supportSideBySide){const{primary:Fe,secondary:ke}=this.a(j);if(Fe&&ke){if(x?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(Fe,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(ke,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===z.ANY)return this.getOriginalUri(Fe,{filterByScheme:x.filterByScheme})??this.getOriginalUri(ke,{filterByScheme:x.filterByScheme});j=x.supportSideBySide===z.PRIMARY?Fe:ke}}if(n(j)||c(j)||u(j)||f(j))return;const ve=h(j)?j.preferredResource:j.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}a(j){return D(j)||u(j)?{primary:j.primary,secondary:j.secondary}:k(j)||n(j)?{primary:j.modified,secondary:j.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(j,x){if(!j)return;if(f(j))return e.$UF.getCanonicalUri(j.result,x);if(x?.supportSideBySide){const{primary:Fe,secondary:ke}=this.a(j);if(Fe&&ke){if(x?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(Fe,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(ke,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===z.ANY)return this.getCanonicalUri(Fe,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(ke,{filterByScheme:x.filterByScheme});j=x.supportSideBySide===z.PRIMARY?Fe:ke}}if(n(j)||c(j)||u(j)||f(j))return;const ve=j.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}b(j,x){if(Array.isArray(x)){if(x.some(ve=>j.scheme===ve))return j}else if(x===j.scheme)return j}}var ie;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function de(ne,j,x,ve){if(!ne.isSticky(j))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return x===ie.MOUSE||x===ie.KEYBOARD;case"mouse":return x===ie.MOUSE;case"keyboard":return x===ie.KEYBOARD}return!1}e.$UF=new G;var ye;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(ye||(e.CloseDirection=ye={}));class Ee{constructor(){this.c=new Map,this.d=new Map}start(j){const x=this.a=j.get(R.$xi);for(const[ve,Fe]of this.c)this.e(ve,Fe,x);this.c.clear()}e(j,x,ve){const Fe=ve.createInstance(x);this.d.set(j,Fe)}registerFileEditorFactory(j){if(this.b)throw new Error("Can only register one file editor factory.");this.b=j}getFileEditorFactory(){return(0,O.$jg)(this.b)}registerEditorSerializer(j,x){if(this.c.has(j)||this.d.has(j))throw new Error(`A editor serializer with type ID '${j}' was already registered.`);return this.a?this.e(j,x,this.a):this.c.set(j,x),(0,N.$Sc)(()=>{this.c.delete(j),this.d.delete(j)})}getEditorSerializer(j){return this.d.get(typeof j=="string"?j:j.typeId)}}w.$fo.add(e.$wF.EditorFactory,new Ee);async function ge(ne,j,x){return!ne||!ne.length?[]:await Promise.all(ne.map(async ve=>{const Fe=M.URI.revive(ve.fileUri);if(!Fe){x.info("Cannot resolve the path because it is not valid.",ve);return}if(!await j.canHandleResource(Fe)){x.info("Cannot resolve the path because it cannot be handled",ve);return}let we=ve.exists,me=ve.type;if(typeof we!="boolean"||typeof me!="number")try{me=(await j.stat(Fe)).isDirectory?m.FileType.Directory:m.FileType.Unknown,we=!0}catch(Y){x.error(Y),we=!1}if(!we&&ve.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",ve);return}if(me===m.FileType.Directory){x.info("Cannot resolve the path because it is a directory",ve);return}const Q={...ve.options,pinned:!0};return we?{resource:Fe,options:Q}:{resource:Fe,options:Q,forceUntitled:!0}}))}var ue;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function Ce(ne){const j=ne;if(!j)return!1;const x=j;if(x.modified)return Ce(x.modified);const ve=j;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function se(ne){return(0,T.$kj)(ne)}function Oe(ne,j,x){const ve=(0,T.$lj)(ne,j);return ve.forceMessage=x?.forceMessage,ve.forceSeverity=x?.forceSeverity,ve.allowDialog=x?.allowDialog,ve}}),define(Se[222],Ie([1,0,5,186,3,6,28,29,26,92,210]),function(le,e,C,O,M,N,R,w,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7F=e.$6F=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$5F=e.ViewContentGroups=e.$3F=e.ViewContainerLocation=e.Extensions=e.$2F=e.$1F=e.$ZF=void 0,e.$4F=b,e.$ZF="views",e.$1F=(0,O.localize)(0,null),e.$2F=(0,T.$ix)("default-view-icon",E.$Xj.window,(0,O.localize)(1,null));var S;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(S||(e.Extensions=S={}));var l;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(l||(e.ViewContainerLocation=l={})),e.$3F=[0,1,2];function b(t){switch(t){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class g extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new C.$fe),this.onDidRegister=this.c.event,this.f=this.B(new C.$fe),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(f,a,d){const $=this.get(f.id);if($)return $;const p=f;return p.openCommandActionDescriptor=d?.doNotRegisterOpenCommand?void 0:p.openCommandActionDescriptor??{id:p.id},(0,R.$xc)(this.g,a,[]).push(p),d?.isDefault&&this.h.push(p),this.c.fire({viewContainer:p,viewContainerLocation:a}),p}deregisterViewContainer(f){for(const a of this.g.keys()){const d=this.g.get(a),$=d?.indexOf(f);if($!==-1){d?.splice($,1),d.length===0&&this.g.delete(a),this.f.fire({viewContainer:f,viewContainerLocation:a});return}}}get(f){return this.all.filter(a=>a.id===f)[0]}getViewContainers(f){return[...this.g.get(f)||[]]}getViewContainerLocation(f){return[...this.g.keys()].filter(a=>this.getViewContainers(a).filter(d=>d?.id===f.id).length>0)[0]}getDefaultViewContainer(f){return this.h.find(a=>this.getViewContainerLocation(a)===f)}}w.$fo.add(S.ViewContainersRegistry,new g);var r;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(r||(e.ViewContentGroups=r={}));function s(t,f){const a=t.group??r.More,d=f.group??r.More;return a!==d?a.localeCompare(d):(t.order??5)-(f.order??5)}class o extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new C.$fe),this.onViewsRegistered=this.c.event,this.f=this.B(new C.$fe),this.onViewsDeregistered=this.f.event,this.g=this.B(new C.$fe),this.onDidChangeContainer=this.g.event,this.h=this.B(new C.$fe),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Hc}registerViews(f,a){this.registerViews2([{views:f,viewContainer:a}])}registerViews2(f){f.forEach(({views:a,viewContainer:d})=>this.r(a,d)),this.c.fire(f)}deregisterViews(f,a){const d=this.s(f,a);d.length&&this.f.fire({views:d,viewContainer:a})}moveViews(f,a){for(const d of this.m.keys())if(d!==a){const $=this.s(f,d);$.length&&(this.r($,a),this.g.fire({views:$,from:d,to:a}))}}getViews(f){return this.m.get(f)||[]}getView(f){for(const a of this.j){const d=(this.m.get(a)||[]).filter($=>$.id===f)[0];if(d)return d}return null}getViewContainer(f){for(const a of this.j)if((this.m.get(a)||[]).filter($=>$.id===f)[0])return a;return null}registerViewWelcomeContent(f,a){return this.n.add(f,a),this.h.fire(f),(0,N.$Sc)(()=>{this.n.delete(f,a),this.h.fire(f)})}registerViewWelcomeContent2(f,a){const d=new Map;for(const[$,p]of a)this.n.add(f,p),d.set($,(0,N.$Sc)(()=>{this.n.delete(f,p),this.h.fire(f)}));return this.h.fire(f),d}getViewWelcomeContent(f){const a=[];return this.n.forEach(f,d=>a.push(d)),a.sort(s)}r(f,a){let d=this.m.get(a);d||(d=[],this.m.set(a,d),this.j.push(a));for(const $ of f){if(this.getView($.id)!==null)throw new Error((0,O.localize)(2,null,$.id));d.push($)}}s(f,a){const d=this.m.get(a);if(!d)return[];const $=[],p=[];for(const v of d)f.includes(v)?$.push(v):p.push(v);return $.length&&(p.length?this.m.set(a,p):(this.m.delete(a),this.j.splice(this.j.indexOf(a),1))),$}}w.$fo.add(S.ViewsRegistry,new o),e.$5F=(0,M.$yi)("viewDescriptorService");var i;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var n;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class c{constructor(f,a){this.c=!1,this.d=!1,(0,m.$8n)(this,f),this.d=!!a,this.resolve=async d=>{if(a&&!this.c){const $=await a(d);$&&(this.tooltip=this.tooltip??$.tooltip,this.command=this.command??$.command)}d.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$6F=c;class u extends Error{constructor(f){super((0,O.localize)(3,null,f)),this.name="NoTreeViewError"}static is(f){return f.name==="NoTreeViewError"}}e.$7F=u}),define(Se[223],Ie([1,0,187,31]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=void 0,e.$$F=new O.$Pj("chatSessionResponseVote","",{type:"string",description:(0,C.localize)(0,null)}),e.$_F=new O.$Pj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,C.localize)(1,null)}),e.$aG=new O.$Pj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,C.localize)(2,null)}),e.$bG=new O.$Pj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,C.localize)(3,null)}),e.$cG=new O.$Pj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,C.localize)(4,null)}),e.$dG=new O.$Pj("chatResponse",!1,{type:"boolean",description:(0,C.localize)(5,null)}),e.$eG=new O.$Pj("chatRequest",!1,{type:"boolean",description:(0,C.localize)(6,null)}),e.$fG=new O.$Pj("chatEditApplied",!1,{type:"boolean",description:(0,C.localize)(7,null)}),e.$gG=new O.$Pj("chatInputHasText",!1,{type:"boolean",description:(0,C.localize)(8,null)}),e.$hG=new O.$Pj("chatInputHasFocus",!1,{type:"boolean",description:(0,C.localize)(9,null)}),e.$iG=new O.$Pj("inChatInput",!1,{type:"boolean",description:(0,C.localize)(10,null)}),e.$jG=new O.$Pj("inChat",!1,{type:"boolean",description:(0,C.localize)(11,null)}),e.$kG=new O.$Pj("chatIsEnabled",!1,{type:"boolean",description:(0,C.localize)(12,null)}),e.$lG=new O.$Pj("chatCursorAtTop",!1),e.$mG=new O.$Pj("chatInputHasAgent",!1),e.$nG=new O.$Pj("chatLocation",void 0)}),define(Se[224],Ie([1,0,11,20,5,42,6,132,13,31,3,12,102,204,216,223]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.ChatAgentLocation=void 0,e.$rH=u;var o;(function(t){t.Panel="panel",t.Terminal="terminal",t.Notebook="notebook",t.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(t){function f(a){switch(a){case"panel":return t.Panel;case"terminal":return t.Terminal;case"notebook":return t.Notebook;case"editor":return t.Editor}return t.Panel}t.fromRaw=f}(o||(e.ChatAgentLocation=o={})),e.$mH=(0,T.$yi)("chatAgentService");let i=class{static{this.AGENT_LEADER="@"}constructor(f){this.f=f,this.b=[],this.d=new M.$fe,this.onDidChangeAgents=this.d.event,this.e=r.$kG.bindTo(this.f)}registerAgent(f,a){if(this.getAgent(f))throw new Error(`Agent already registered: ${JSON.stringify(f)}`);const $=this,p=a.slashCommands;a={...a,get slashCommands(){return p.filter(y=>!y.when||$.f.contextMatchesRules(E.$wj.deserialize(y.when)))}};const v={data:a};return this.b.push(v),(0,R.$Sc)(()=>{this.b=this.b.filter(y=>y!==v),this.d.fire(void 0)})}registerAgentImplementation(f,a){const d=this.g(f);if(!d)throw new Error(`Unknown agent: ${JSON.stringify(f)}`);if(d.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(f)}`);return d.data.isDefault&&this.e.set(!0),d.impl=a,this.d.fire(new n(d.data,a)),(0,R.$Sc)(()=>{d.impl=void 0,this.d.fire(void 0),d.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(f,a){f.isDynamic=!0;const d={data:f,impl:a};return this.b.push(d),this.d.fire(new n(f,a)),(0,R.$Sc)(()=>{this.b=this.b.filter($=>$!==d),this.d.fire(void 0)})}updateAgent(f,a){const d=this.g(f);if(!d?.impl)throw new Error(`No activated agent with id ${JSON.stringify(f)} registered`);d.data.metadata={...d.data.metadata,...a},this.d.fire(new n(d.data,d.impl))}getDefaultAgent(f){return this.getActivatedAgents().find(a=>!!a.isDefault&&a.locations.includes(f))}getContributedDefaultAgent(f){return this.getAgents().find(a=>!!a.isDefault&&a.locations.includes(f))}getSecondaryAgent(){return N.Iterable.find(this.b.values(),f=>!!f.data.metadata.isSecondary)?.data}g(f){return this.b.find(a=>a.data.id===f)}getAgent(f){return this.g(f)?.data}getAgentByFullyQualifiedId(f){return this.b.find(a=>u(a.data)===f)?.data}getAgents(){return this.b.map(f=>f.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(f=>!!f.impl).map(f=>new n(f.data,f.impl))}getAgentsByName(f){return this.getAgents().filter(a=>a.name===f)}async invokeAgent(f,a,d,$,p){const v=this.g(f);if(!v?.impl)throw new Error(`No activated agent with id ${f}`);return await v.impl.invoke(a,d,$,p)}async getFollowups(f,a,d,$,p){const v=this.g(f);if(!v?.impl)throw new Error(`No activated agent with id ${f}`);return v.impl?.provideFollowups?v.impl.provideFollowups(a,d,$,p):[]}};e.$nH=i,e.$nH=i=Je([We(0,E.$Qj)],i);class n{constructor(f,a){this.b=f,this.d=a}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(f,a,d,$){return this.d.invoke(f,a,d,$)}async provideFollowups(f,a,d,$){return this.d.provideFollowups?this.d.provideFollowups(f,a,d,$):[]}provideWelcomeMessage(f,a){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(f,a)}provideSampleQuestions(f,a){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(f,a)}}e.$oH=n,e.$pH=(0,T.$yi)("chatAgentNameService");let c=class{static{s=this}static{this.b="chat.participantNameRegistry"}constructor(f,a,d,$){if(this.g=a,this.h=d,this.i=$,this.e=(0,w.$3d)(this,Object.create(null)),this.f=!1,!f.chatParticipantRegistry)return;this.d=f.chatParticipantRegistry;const p=$.get(s.b,-1);try{this.e.set(JSON.parse(p??"{}"),void 0)}catch{$.remove(s.b,-1)}this.j()}j(){this.f||this.k().catch(f=>this.h.warn("Failed to fetch chat participant registry",f)).then(()=>(0,C.$zh)(5*60*1e3)).then(()=>this.j())}async k(){const f=await this.g.request({type:"GET",url:this.d},O.CancellationToken.None);if(f.res.statusCode!==200)throw new Error("Could not get extensions report.");const a=await(0,b.$Wp)(f);if(!a||a.version!==1)throw new Error("Unexpected chat participant registry response.");const d=a.restrictedChatParticipants;this.e.set(d,void 0),this.i.store(s.b,JSON.stringify(d),-1,1)}getAgentNameRestriction(f){return this.e.map(d=>d[f.name.toLowerCase()]).map(d=>d?d.some($=>(0,m.$zf)($,$.includes(".")?f.extensionId.value:f.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$qH=c,e.$qH=c=s=Je([We(0,l.$lk),We(1,b.$Qp),We(2,S.$5j),We(3,g.$4p)],c);function u(t){return`${t.extensionId.value}.${t.id}`}}),define(Se[225],Ie([1,0,2,30,3]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YG=e.$XG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$VG=N,e.$WG=R;function N(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof C.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(O.$xt.isIRange)}function R(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(N)}var w;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(w||(e.InteractiveSessionVoteDirection=w={}));var m;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(m||(e.ChatCopyKind=m={})),e.$XG=(0,M.$yi)("IChatService"),e.$YG="accessibility.voice.keywordActivation"}),define(Se[226],Ie([1,0,5,11,188]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jsb=void 0;class N{constructor(){this.f=new Map,this.m=[],this.n=new C.$fe,this.o=new C.$fe,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(w){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=w}onEvent(w){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=w}onRequest(w){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=w}sendResponse(w){w.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${w.command}`)):this.u("response",w)}sendRequest(w,m,E,T){const S={command:w};if(m&&Object.keys(m).length>0&&(S.arguments=m),this.u("request",S),typeof T=="number"){const l=setTimeout(()=>{clearTimeout(l);const b=this.f.get(S.seq);if(b){this.f.delete(S.seq);const g={type:"response",seq:0,request_seq:S.seq,success:!1,command:w,message:(0,M.localize)(0,null,T,w)};b(g)}},T)}return E&&this.f.set(S.seq,E),S.seq}acceptMessage(w){this.k?this.k(w):(this.m.push(w),this.m.length===1&&this.s())}q(w,m){return w.type!=="event"||m.type!=="event"}async s(){let w;for(;this.m.length;){if((!w||this.q(this.m[0],w))&&await(0,O.$zh)(0),w=this.m.shift(),!w)return;switch(w.type){case"event":this.j?.(w);break;case"request":this.g?.(w);break;case"response":{const m=w,E=this.f.get(m.request_seq);E&&(this.f.delete(m.request_seq),E(m));break}}}}u(w,m){m.type=w,m.seq=this.d++,this.sendMessage(m)}async w(){if(this.f.size===0)return Promise.resolve();const w=new Map;this.f.forEach((m,E)=>w.set(E,m)),await(0,O.$zh)(500),w.forEach((m,E)=>{m({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$jsb=N}),define(Se[227],Ie([1,0,2,189,31,3]),function(le,e,C,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$HJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$FJ=e.MemoryRangeType=e.State=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=void 0,e.$EJ=m,e.$GJ=T,e.$sI="workbench.view.debug",e.$tI="workbench.debug.variablesView",e.$uI="workbench.debug.watchExpressionsView",e.$vI="workbench.debug.callStackView",e.$wI="workbench.debug.loadedScriptsView",e.$xI="workbench.debug.breakPointsView",e.$yI="workbench.debug.disassemblyView",e.$zI="workbench.panel.repl",e.$AI="workbench.panel.repl.view",e.$BI=new M.$Pj("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.$CI=new M.$Pj("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.$DI=new M.$Pj("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.$EI="debugUx",e.$FI=new M.$Pj(e.$EI,"default",{type:"string",description:O.localize(3,null)}),e.$GI=new M.$Pj("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.$HI=new M.$Pj("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.$II=new M.$Pj("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.$JI=new M.$Pj("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.$KI=new M.$Pj("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.$LI=new M.$Pj("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.$MI=new M.$Pj("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.$NI=new M.$Pj("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.$OI=new M.$Pj("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.$PI=new M.$Pj("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.$QI=new M.$Pj("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.$RI=new M.$Pj("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.$SI=new M.$Pj("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.$TI=new M.$Pj("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.$UI=new M.$Pj("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.$VI=new M.$Pj("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.$WI=new M.$Pj("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.$XI=new M.$Pj("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.$YI=new M.$Pj("breakpointItemBytes",void 0,{type:"boolean",description:O.localize(22,null)}),e.$ZI=new M.$Pj("breakpointHasModes",!1,{type:"boolean",description:O.localize(23,null)}),e.$1I=new M.$Pj("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(24,null)}),e.$2I=new M.$Pj("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(25,null)}),e.$3I=new M.$Pj("loadedScriptsItemType",void 0,{type:"string",description:O.localize(26,null)}),e.$4I=new M.$Pj("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(27,null)}),e.$5I=new M.$Pj("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(28,null)}),e.$6I=new M.$Pj("stepBackSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.$7I=new M.$Pj("restartFrameSupported",!1,{type:"boolean",description:O.localize(30,null)}),e.$8I=new M.$Pj("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(31,null)}),e.$9I=new M.$Pj("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.$0I=new M.$Pj("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(33,null)}),e.$$I=new M.$Pj("breakpointsExist",!1,{type:"boolean",description:O.localize(34,null)}),e.$_I=new M.$Pj("debuggersAvailable",!1,{type:"boolean",description:O.localize(35,null)}),e.$aJ=new M.$Pj("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(36,null)}),e.$bJ=new M.$Pj("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(37,null)}),e.$cJ=new M.$Pj("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.$dJ=new M.$Pj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.$eJ=new M.$Pj("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.$fJ=new M.$Pj("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.$gJ=new M.$Pj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.$hJ=new M.$Pj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.$iJ=new M.$Pj("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(44,null)}),e.$jJ=new M.$Pj("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(45,null)}),e.$kJ=new M.$Pj("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(46,null)}),e.$lJ=new M.$Pj("variableIsReadonly",!1,{type:"boolean",description:O.localize(47,null)}),e.$mJ=new M.$Pj("variableValue",!1,{type:"string",description:O.localize(48,null)}),e.$nJ=new M.$Pj("variableType",!1,{type:"string",description:O.localize(49,null)}),e.$oJ=new M.$Pj("variableInterfaces",!1,{type:"array",description:O.localize(50,null)}),e.$pJ=new M.$Pj("variableName",!1,{type:"string",description:O.localize(51,null)}),e.$qJ=new M.$Pj("variableLanguage",!1,{type:"string",description:O.localize(52,null)}),e.$rJ=new M.$Pj("variableExtensionId",!1,{type:"string",description:O.localize(53,null)}),e.$sJ=new M.$Pj("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(54,null)}),e.$tJ=new M.$Pj("multiSessionRepl",!1,{type:"boolean",description:O.localize(55,null)}),e.$uJ=new M.$Pj("multiSessionDebug",!1,{type:"boolean",description:O.localize(56,null)}),e.$vJ=new M.$Pj("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(57,null)}),e.$wJ=new M.$Pj("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(58,null)}),e.$xJ=new M.$Pj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(59,null)}),e.$yJ=new M.$Pj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(60,null)});const R=n=>O.localize(61,null,n);e.$zJ=R,e.$AJ="editor.contrib.debug",e.$BJ="editor.contrib.breakpoint",e.$CJ="debug",e.$DJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(62,null)};var w;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(w||(e.State=w={}));function m(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$FJ="vscode-debug-memory";function T(n){return n.source.presentationHint==="deemphasize"||n.presentationHint==="deemphasize"||n.presentationHint==="subtle"}var S;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(S||(e.DataBreakpointSetType=S={}));var l;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(l||(e.DebugConfigurationProviderTriggerKind=l={}));var b;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(b||(e.DebuggerString=b={})),e.$HJ=(0,N.$yi)("debugService");var g;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(g||(e.BreakpointWidgetContext=g={}));var r;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var s;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(s||(e.DebugTreeItemCollapsibleState=s={}));var o;(function(n){n.deserialize=c=>c,n.serialize=c=>c})(o||(e.IDebugVisualizationTreeItem=o={}));var i;(function(n){n.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:C.URI.revive(c.iconPath.light),dark:C.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),n.serialize=c=>c})(i||(e.IDebugVisualization=i={}))}),define(Se[228],Ie([1,0,13,2,19,26,16,30,20,18]),function(le,e,C,O,M,N,R,w,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GH=void 0,e.$uH=S,e.$vH=l,e.$wH=b,e.$xH=g,e.$yH=r,e.$zH=s,e.$AH=o,e.$BH=n,e.$CH=t,e.$DH=f,e.$EH=d,e.$FH=p;const T=/{([^}]+)}/g;function S(y,h,D){return y.replace(T,function(k,I){return h&&I.length>0&&I[0]!=="_"?k:D&&D.hasOwnProperty(I)?D[I]:k})}function l(y){const h={};for(const D of Object.keys(y))D.startsWith("!")||(h[D]=y[D]);return h}function b(y){return y.configuration.request==="attach"&&!g(y)&&(!y.parentSession||b(y.parentSession))}function g(y){let h=y.configuration.type;if(h)return h==="vslsShare"&&(h=y.configuration.adapterProxy.configuration.type),(0,C.$zf)(h,"extensionhost")||(0,C.$zf)(h,"pwa-extensionhost")?y:y.parentSession?g(y.parentSession):void 0}function r(y){return y.type&&(y.label||y.program||y.runtime)}function s(y,h,D){let k,I=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=P.exec(y);){const W=V.index+1,q=W+V[0].length;if(W<=h&&q>=D){k=V[0],I=W;break}}if(k){const W=/\w+/g;let q=null;for(;(q=W.exec(k))&&!(q.index+1+I+q[0].length>=D););q&&(k=k.substring(0,W.lastIndex))}return k?{start:I,end:I+k.length-1}:{start:0,end:0}}async function o(y,h,D,k){if(y.evaluatableExpressionProvider.has(h)){const I=y.evaluatableExpressionProvider.ordered(h),P=(0,E.$Hb)(await Promise.all(I.map(async V=>{try{return await V.provideEvaluatableExpression(h,D,k??m.CancellationToken.None)}catch{return}})));if(P.length>0){let V=P[0].expression;const W=P[0].range;return V||(V=h.getLineContent(D.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:V}}}else{const I=h.getLineContent(D.lineNumber),{start:P,end:V}=s(I,D.column,D.column),W=I.substring(P-1,V);return{matchingExpression:W,range:new w.$xt(D.lineNumber,P,D.lineNumber,P+W.length)}}return null}const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(y){return!!(y&&y.match(i))}function c(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(n(y.path))return O.URI.parse(y.path);if((0,M.$ic)(y.path))return O.URI.file(y.path)}return y.path}function u(y){if(typeof y.path=="object"){const h=O.URI.revive(y.path);if(h)return h.scheme===R.Schemas.file?h.fsPath:h.toString()}return y.path}function t(y,h){const D=h?c:u,k=(0,N.$5n)(y);return a(k,(I,P)=>{I&&P&&(P.path=D(P))}),k}function f(y,h){const D=h?c:u,k=(0,N.$5n)(y);return a(k,(I,P)=>{!I&&P&&(P.path=D(P))}),k}function a(y,h){switch(y.type){case"event":{const D=y;switch(D.event){case"output":h(!1,D.body.source);break;case"loadedSource":h(!1,D.body.source);break;case"breakpoint":h(!1,D.body.breakpoint.source);break;default:break}break}case"request":{const D=y;switch(D.command){case"setBreakpoints":h(!0,D.arguments.source);break;case"breakpointLocations":h(!0,D.arguments.source);break;case"source":h(!0,D.arguments.source);break;case"gotoTargets":h(!0,D.arguments.source);break;case"launchVSCode":D.arguments.args.forEach(k=>h(!1,k));break;default:break}break}case"response":{const D=y;if(D.success&&D.body)switch(D.command){case"stackTrace":D.body.stackFrames.forEach(k=>h(!1,k.source));break;case"loadedSources":D.body.sources.forEach(k=>h(!1,k));break;case"scopes":D.body.scopes.forEach(k=>h(!1,k.source));break;case"setFunctionBreakpoints":D.body.breakpoints.forEach(k=>h(!1,k.source));break;case"setBreakpoints":D.body.breakpoints.forEach(k=>h(!1,k.source));break;case"disassemble":D.body?.instructions.forEach(I=>h(!1,I.location));break;default:break}break}}}function d(y){return y.filter(h=>!h.presentation?.hidden).sort((h,D)=>h.presentation?D.presentation?h.presentation.group?D.presentation.group?h.presentation.group!==D.presentation.group?h.presentation.group.localeCompare(D.presentation.group):$(h.presentation.order,D.presentation.order):-1:D.presentation.group?1:$(h.presentation.order,D.presentation.order):-1:D.presentation?1:0)}function $(y,h){return typeof y!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:y-h}async function p(y,h){const D=y.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(D!=="none"&&(await h.saveAll(),D==="allEditorsInActiveGroup")){const k=h.activeEditorPane;k&&k.input.resource?.scheme===R.Schemas.untitled&&await h.save({editor:k.input,groupId:k.group.id})}await y.reloadConfiguration()}const v=(y,h)=>!y||!h?y===h:y.name===h.name&&y.path===h.path&&y.sourceReference===h.sourceReference;e.$GH=v}),define(Se[229],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZJ=e.CellExecutionUpdateType=void 0;var O;(function(M){M[M.Output=1]="Output",M[M.OutputItems=2]="OutputItems",M[M.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$ZJ=(0,C.$yi)("INotebookExecutionService")}),define(Se[230],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vib=e.$Uib=e.ProxyKernelState=e.$Tib=void 0,e.$Tib=100;var O;(function(M){M[M.Disconnected=1]="Disconnected",M[M.Connected=2]="Connected",M[M.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.$Uib=(0,C.$yi)("INotebookKernelService"),e.$Vib=(0,C.$yi)("INotebookKernelHistoryService")}),define(Se[231],Ie([1,0,6,30,156,96]),function(le,e,C,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CXb=void 0;class R extends C.$Uc{constructor(m,E,T){super(),this._source=m,this.b=E,this.c=T,this.a=void 0}f(m){const E=m.getLineCount();return new O.$xt(1,1,E,this.g(m,E))}g(m,E){if(E<1||E>m.getLineCount())throw new Error("Illegal value for lineNumber");return m.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const m=new M.$5C;m.acceptChunk(this._source);const E=m.finish(!0),{textBuffer:T,disposable:S}=E.create(1);this.b=T,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(m=>{const E=new M.$5C;E.acceptChunk(m);const T=E.finish(!0),{textBuffer:S,disposable:l}=T.create(1);return this.B(l),S})),this.a}findInInputs(m){const T=new N.$SC(m,!1,!1,null).parseSearchRequest();if(!T)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,T,!0,5e3)}findInOutputs(m){const T=new N.$SC(m,!1,!1,null).parseSearchRequest();return T?this.outputTextBuffers.map(S=>{const l=S.findMatchesLineByLine(this.f(S),T,!0,5e3);if(l.length!==0)return{textBuffer:S,matches:l}}).filter(S=>!!S):[]}}e.$CXb=R}),define(Se[52],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7K=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(N){N.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var O;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class M{static fromExtHostTestItem(R,w,m=R.parent){if(R._isRoot)return new M([w]);const E=[R.id];for(let T=m;T&&T.id!==w;T=T.parent)E.push(T.id);return E.push(w),new M(E.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const w=R.indexOf("\0");return w===-1?R:R.slice(0,w)}static fromString(R){return new M(R.split("\0"))}static join(R,w){return new M([...R.path,w])}static joinToString(R,w){return R.toString()+"\0"+w}static parentId(R){const w=R.lastIndexOf("\0");return w===-1?void 0:R.slice(0,w)}static localId(R){const w=R.lastIndexOf("\0");return w===-1?R:R.slice(w+1)}static isChild(R,w){return w.startsWith(R)&&w[R.length]==="\0"}static compare(R,w){return R===w?0:M.isChild(R,w)?2:M.isChild(w,R)?3:1}static getLengthOfCommonPrefix(R,w){if(R===0)return 0;let m=0;for(;m<R-1;){for(let E=1;E<R;E++){const T=w(E-1),S=w(E);if(T.path[m]!==S.path[m])return m}m++}return m}constructor(R,w=R.length){if(this.path=R,this.d=w,R.length===0||w<1)throw new Error("cannot create test with empty path")}get rootId(){return new M(this.path,1)}get parentId(){return this.d>1?new M(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new M(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new M(this.path,R)}compare(R){if(typeof R=="string")return M.compare(this.toString(),R);for(let w=0;w<R.d&&w<this.d;w++)if(R.path[w]!==this.path[w])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$7K=M}),define(Se[62],Ie([1,0,2,94,30,52]),function(le,e,C,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$cL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$bL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$aL=e.$_K=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$$K=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$0K=e.$9K=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$8K=e.TestResultState=void 0;var R;(function(A){A[A.Unset=0]="Unset",A[A.Queued=1]="Queued",A[A.Running=2]="Running",A[A.Passed=3]="Passed",A[A.Failed=4]="Failed",A[A.Skipped=5]="Skipped",A[A.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$8K={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var w;(function(A){A[A.Run=1]="Run",A[A.Debug=2]="Debug",A[A.Coverage=3]="Coverage"})(w||(e.ExtTestRunProfileKind=w={}));var m;(function(A){A[A.Run=2]="Run",A[A.Debug=4]="Debug",A[A.Coverage=8]="Coverage",A[A.HasNonDefaultProfile=16]="HasNonDefaultProfile",A[A.HasConfigurable=32]="HasConfigurable",A[A.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$9K=[2,4,8,16,32,64];const E=A=>"runId"in A;e.$0K=E;var T;(function(A){A.serialize=z=>({range:z.range.toJSON(),uri:z.uri.toJSON()}),A.deserialize=(z,G)=>({range:M.$xt.lift(G.range),uri:z.asCanonicalUri(C.URI.revive(G.uri))})})(T||(e.IRichLocation=T={}));var S;(function(A){A[A.Error=0]="Error",A[A.Output=1]="Output"})(S||(e.TestMessageType=S={}));var l;(function(A){A.serialize=z=>({message:z.message,type:0,expected:z.expected,actual:z.actual,contextValue:z.contextValue,location:z.location&&T.serialize(z.location)}),A.deserialize=(z,G)=>({message:G.message,type:0,expected:G.expected,actual:G.actual,contextValue:G.contextValue,location:G.location&&T.deserialize(z,G.location)})})(l||(e.ITestErrorMessage=l={}));const b=(A,z)=>`${z?"s":"e"}${A}`;e.$$K=b;var g;(function(A){A.serialize=z=>({message:z.message,type:1,offset:z.offset,length:z.length,location:z.location&&T.serialize(z.location)}),A.deserialize=(z,G)=>({message:G.message,type:1,offset:G.offset,length:G.length,location:G.location&&T.deserialize(z,G.location)})})(g||(e.ITestOutputMessage=g={}));var r;(function(A){A.serialize=z=>z.type===0?l.serialize(z):g.serialize(z),A.deserialize=(z,G)=>G.type===0?l.deserialize(z,G):g.deserialize(z,G)})(r||(e.ITestMessage=r={}));var s;(function(A){A.serializeWithoutMessages=z=>({state:z.state,duration:z.duration,messages:[]}),A.serialize=z=>({state:z.state,duration:z.duration,messages:z.messages.map(r.serialize)}),A.deserialize=(z,G)=>({state:G.state,duration:G.duration,messages:G.messages.map(ie=>r.deserialize(z,ie))})})(s||(e.ITestTaskState=s={}));const o="\0",i=(A,z)=>A+o+z;e.$_K=i;const n=A=>{const z=A.indexOf(o);return{ctrlId:A.slice(0,z),tagId:A.slice(z+1)}};e.$aL=n;var c;(function(A){A.serialize=z=>({extId:z.extId,label:z.label,tags:z.tags,busy:z.busy,children:void 0,uri:z.uri?.toJSON(),range:z.range?.toJSON()||null,description:z.description,error:z.error,sortText:z.sortText}),A.deserialize=(z,G)=>({extId:G.extId,label:G.label,tags:G.tags,busy:G.busy,children:void 0,uri:G.uri?z.asCanonicalUri(C.URI.revive(G.uri)):void 0,range:G.range?M.$xt.lift(G.range):null,description:G.description,error:G.error,sortText:G.sortText})})(c||(e.ITestItem=c={}));var u;(function(A){A[A.NotExpandable=0]="NotExpandable",A[A.Expandable=1]="Expandable",A[A.BusyExpanding=2]="BusyExpanding",A[A.Expanded=3]="Expanded"})(u||(e.TestItemExpandState=u={}));var t;(function(A){A.serialize=z=>({expand:z.expand,item:c.serialize(z.item)}),A.deserialize=(z,G)=>({controllerId:N.$7K.root(G.item.extId),expand:G.expand,item:c.deserialize(z,G.item)})})(t||(e.InternalTestItem=t={}));var f;(function(A){A.serialize=z=>{let G;return z.item&&(G={},z.item.label!==void 0&&(G.label=z.item.label),z.item.tags!==void 0&&(G.tags=z.item.tags),z.item.busy!==void 0&&(G.busy=z.item.busy),z.item.uri!==void 0&&(G.uri=z.item.uri?.toJSON()),z.item.range!==void 0&&(G.range=z.item.range?.toJSON()),z.item.description!==void 0&&(G.description=z.item.description),z.item.error!==void 0&&(G.error=z.item.error),z.item.sortText!==void 0&&(G.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:G}},A.deserialize=z=>{let G;return z.item&&(G={},z.item.label!==void 0&&(G.label=z.item.label),z.item.tags!==void 0&&(G.tags=z.item.tags),z.item.busy!==void 0&&(G.busy=z.item.busy),z.item.range!==void 0&&(G.range=z.item.range?M.$xt.lift(z.item.range):null),z.item.description!==void 0&&(G.description=z.item.description),z.item.error!==void 0&&(G.error=z.item.error),z.item.sortText!==void 0&&(G.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:G}}})(f||(e.ITestItemUpdate=f={}));const a=(A,z)=>{z.expand!==void 0&&(A.expand=z.expand),z.item!==void 0&&(A.item=A.item?Object.assign(A.item,z.item):z.item)};e.$bL=a;var d;(function(A){A.serializeWithoutMessages=z=>({...t.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(s.serializeWithoutMessages)}),A.serialize=z=>({...t.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(s.serialize)}),A.deserialize=(z,G)=>({...t.deserialize(z,G),ownComputedState:G.ownComputedState,computedState:G.computedState,tasks:G.tasks.map(ie=>s.deserialize(z,ie)),retired:!0})})(d||(e.TestResultItem=d={}));var $;(function(A){A.empty=()=>({covered:0,total:0}),A.sum=(z,G)=>{z.covered+=G.covered,z.total+=G.total}})($||(e.ICoverageCount=$={}));var p;(function(A){A.serialize=z=>({id:z.id,statement:z.statement,branch:z.branch,declaration:z.declaration,testId:z.testId?.toString(),uri:z.uri.toJSON()}),A.deserialize=(z,G)=>({id:G.id,statement:G.statement,branch:G.branch,declaration:G.declaration,testId:G.testId?N.$7K.fromString(G.testId):void 0,uri:z.asCanonicalUri(C.URI.revive(G.uri))}),A.empty=(z,G)=>({id:z,uri:G,testId:void 0,statement:$.empty()})})(p||(e.IFileCoverage=p={}));function v(A){return{...A,location:A.location?.toJSON()}}function y(A){return A.location=A.location?O.$wt.isIPosition(A.location)?O.$wt.lift(A.location):M.$xt.lift(A.location):void 0,A}e.$cL=3;var h;(function(A){A[A.Declaration=0]="Declaration",A[A.Statement=1]="Statement",A[A.Branch=2]="Branch"})(h||(e.DetailType=h={}));var D;(function(A){A.serialize=z=>z.type===0?I.serialize(z):P.serialize(z),A.deserialize=z=>z.type===0?I.deserialize(z):P.deserialize(z)})(D||(e.CoverageDetails=D={}));var k;(function(A){A.serialize=v,A.deserialize=y})(k||(e.IBranchCoverage=k={}));var I;(function(A){A.serialize=v,A.deserialize=y})(I||(e.IDeclarationCoverage=I={}));var P;(function(A){A.serialize=z=>({...v(z),branches:z.branches?.map(k.serialize)}),A.deserialize=z=>({...y(z),branches:z.branches?.map(k.deserialize)})})(P||(e.IStatementCoverage=P={}));var V;(function(A){A[A.Add=0]="Add",A[A.Update=1]="Update",A[A.DocumentSynced=2]="DocumentSynced",A[A.Remove=3]="Remove",A[A.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",A[A.Retire=5]="Retire",A[A.AddTag=6]="AddTag",A[A.RemoveTag=7]="RemoveTag"})(V||(e.TestDiffOpType=V={}));var W;(function(A){A.deserialize=(z,G)=>G.op===0?{op:G.op,item:t.deserialize(z,G.item)}:G.op===1?{op:G.op,item:f.deserialize(G.item)}:G.op===2?{op:G.op,uri:z.asCanonicalUri(C.URI.revive(G.uri)),docv:G.docv}:G,A.serialize=z=>z.op===0?{op:z.op,item:t.serialize(z.item)}:z.op===1?{op:z.op,item:f.serialize(z.item)}:z})(W||(e.TestsDiffOp=W={}));class q{constructor(z){this.k=z,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(z){const G=this.v();for(const ie of z)switch(ie.op){case 0:this.l(t.deserialize(this.k,ie.item),G);break;case 1:this.o(f.deserialize(ie.item),G);break;case 3:this.p(ie.itemId,G);break;case 5:this.q(ie.itemId);break;case 4:this.updatePendingRoots(ie.amount);break;case 6:this.c.set(ie.tag.id,ie.tag);break;case 7:this.c.delete(ie.id);break}G.complete?.()}l(z,G){const ie=N.$7K.parentId(z.item.extId)?.toString();let de;if(!ie)de=this.w(z),this.g.add(de),this.f.set(z.item.extId,de);else if(this.f.has(ie)){const ye=this.f.get(ie);ye.children.add(z.item.extId),de=this.w(z,ye),this.f.set(z.item.extId,de)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(z)}`);return}return G.add?.(de),z.expand===2&&this.h++,de}o(z,G){const ie=this.f.get(z.extId);if(ie)return z.expand!==void 0&&(ie.expand===2&&this.h--,z.expand===2&&this.h++),(0,e.$bL)(ie,z),G.update?.(ie),ie}p(z,G){const ie=this.f.get(z);if(!ie)return;const de=N.$7K.parentId(ie.item.extId)?.toString();de?this.f.get(de).children.delete(ie.item.extId):this.g.delete(ie);const ye=[[z]];for(;ye.length;)for(const Ee of ye.pop()){const ge=this.f.get(Ee);ge&&(ye.push(ge.children),this.f.delete(Ee),G.remove?.(ge,ge!==ie),ge.expand===2&&this.h--)}}q(z){}updatePendingRoots(z){this.j+=z}v(){return{}}}e.$dL=q}),define(Se[77],Ie([1,0,11,5,6,57,62,52]),function(le,e,C,O,M,N,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.TestItemEventOp=void 0;var m;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const E=(i,n)=>i===n,S=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:E,label:E,description:E,error:E,sortText:E,tags:(i,n)=>!(i.length!==n.length||i.some(c=>!n.includes(c)))}),l=(i,n)=>{let c;for(const[u,t]of S)t(i[u],n[u])||(c?c[u]=n[u]:c={[u]:n[u]});return c};class b extends M.$Uc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new C.$Kh(()=>this.flushDiff(),200)),this.g=this.B(new O.$fe),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===n.uri){c.docv=n.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===n.item.extId){(0,R.$bL)(c.item,n.item);return}if(c.op===0&&c.item.item.extId===n.item.extId){(0,R.$bL)(c.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,c){const u=this.tree.get(n);if(u){if((u.expandLevels===void 0||c>u.expandLevels)&&(u.expandLevels=c),u.expand===1){const t=this.M(u);return t.isOpen()?this.L(u,c-1):t.wait().then(()=>this.L(u,c-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.L(u,c-1)):this.L(u,c-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,c){switch(c.op){case 3:this.O(w.$7K.joinToString(n.fullId,c.id));break;case 0:this.z(c.item,n);break;case 5:for(const u of c.ops)this.w(n,u);break;case 1:this.C(c.new,c.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:c.update}});break;case 6:this.y(n.actual.uri);break;default:(0,N.$ed)(c)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,c){const u=w.$7K.fromExtHostTestItem(n,this.root.id,c?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==c?.actual&&this.s.getChildren(t.parent).delete(n.id);let f=this.tree.get(u.toString());if(!f){f={fullId:u,actual:n,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(f.fullId.toString(),f),this.G(n,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:f.expand,item:this.s.toITestItem(n)}}),this.I(n,f,c);return}if(f.actual===n){this.H(n,f,c);return}if(f.actual.uri?.toString()!==n.uri?.toString())return this.O(u.toString()),this.z(n,c);const a=this.s.getChildren(f.actual),d=f.actual,$=l(this.s.toITestItem(d),this.s.toITestItem(n));this.s.getApiFor(d).listener=void 0,f.actual=n,f.resolveBarrier=void 0,f.expand=0,$&&($.hasOwnProperty("tags")&&(this.C(n.tags,d.tags,u.toString()),delete $.tags),this.w(f,{op:4,update:$})),this.I(n,f,c);for(const[v,y]of a)this.s.getChildren(n).get(y.id)||this.O(w.$7K.joinToString(u,y.id));const p=f.expandLevels;p!==void 0&&queueMicrotask(()=>{f.expand===1&&(f.expandLevels=void 0,this.expand(u.toString(),p))}),this.y(f.actual.uri)}C(n,c,u){const t=new Set(c.map(f=>f.id));for(const f of n)t.delete(f.id)||this.D(f);this.pushDiff({op:1,item:{extId:u,item:{tags:n.map(f=>(0,R.$_K)(this.s.controllerId,f.id))}}}),t.forEach(this.F,this)}D(n){const c=this.j.get(n.id);c?c.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$_K)(this.s.controllerId,n.id)}}))}F(n){const c=this.j.get(n);c&&!--c.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,R.$_K)(this.s.controllerId,n)}))}G(n,c){this.s.getApiFor(n).parent=c&&c.actual!==this.root?c.actual:void 0}H(n,c,u){this.G(n,u);const t=this.s.getApiFor(n);t.parent=u?.actual,t.listener=f=>this.w(c,f),this.J(c)}I(n,c,u){this.H(n,c,u);for(const[t,f]of this.s.getChildren(n))this.z(f,c)}J(n){let c;this.h?n.resolveBarrier?c=n.resolveBarrier.isOpen()?3:2:c=n.actual.canResolveChildren?1:0:c=0,c!==n.expand&&(n.expand=c,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:c}}),c===1&&n.expandLevels!==void 0&&this.M(n))}L(n,c){if(c<0)return;const u=[];for(const[t,f]of this.s.getChildren(n.actual)){const a=this.expand(w.$7K.joinToString(n.fullId,f.id),c);(0,C.$kh)(a)&&u.push(a)}if(u.length)return Promise.all(u).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const f=new C.$xh;return f.open(),f}n.expand=2,this.N(n);const c=n.resolveBarrier=new C.$xh,u=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,f)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(f){u(f)}return(0,C.$kh)(t)?t.catch(u).then(()=>{c.open(),this.J(n)}):(c.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const c=this.tree.get(n);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const u=[c];for(;u.length;){const t=u.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.F(f.id);this.tree.delete(t.fullId.toString());for(const[f,a]of this.s.getChildren(t.actual))u.push(this.tree.get(w.$7K.joinToString(t.fullId,a.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$CO=b;class g extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$DO=g;class r extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$EO=r;class s extends Error{constructor(n,c,u){super(`TestItem with ID "${n}" is from controller "${c}" and cannot be added as a child of an item from controller "${u}".`)}}e.$FO=s;const o=(i,n,c)=>{let u=new Map;return{get size(){return u.size},forEach(t,f){for(const a of u.values())t.call(f,a,this)},[Symbol.iterator](){return u.entries()},replace(t){const f=new Map,a=new Set(u.keys()),d={op:5,ops:[]};for(const $ of t){if(!($ instanceof c))throw new r($.id);const p=n($).controllerId;if(p!==i.controllerId)throw new s($.id,p,i.controllerId);if(f.has($.id))throw new g($.id);f.set($.id,$),a.delete($.id),d.ops.push({op:0,item:$})}for(const $ of a.keys())d.ops.push({op:3,id:$});i.listener?.(d),u=f},add(t){if(!(t instanceof c))throw new r(t.id);u.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){u.delete(t)&&i.listener?.({op:3,id:t})},get(t){return u.get(t)},toJSON(){return Array.from(u.values())}}};e.$GO=o}),define(Se[107],Ie([1,0,77]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IO=e.$HO=void 0;const O=new WeakMap,M=(R,w)=>{const m={controllerId:w};return O.set(R,m),m};e.$HO=M;const N=R=>{const w=O.get(R);if(!w)throw new C.$EO(R?.id||"<unknown>");return w};e.$IO=N}),define(Se[78],Ie([1,0,16,2]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Ab=e.$0Ab=e.$9Ab=void 0,e.$_Ab=M,e.$aBb=R,e.$9Ab="vscode-cdn.net",e.$0Ab=`vscode-resource.${e.$9Ab}`,e.$$Ab=`'self' https://*.${e.$9Ab}`;function M(w,m){return w.scheme===C.Schemas.http||w.scheme===C.Schemas.https?w:(m&&m.authority&&m.isRemote&&w.scheme===C.Schemas.file&&(w=O.URI.from({scheme:C.Schemas.vscodeRemote,authority:m.authority,path:w.path})),O.URI.from({scheme:C.Schemas.https,authority:`${w.scheme}+${N(w.authority)}.${e.$0Ab}`,path:w.path,fragment:w.fragment,query:w.query}))}function N(w){return w.replace(/./g,m=>{const E=m.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?m:"-"+E.toString(16).padStart(4,"0")})}function R(w){return w.replace(/-([0-9a-f]{4})/g,(m,E)=>String.fromCharCode(parseInt(E,16)))}}),define(Se[232],Ie([1,0,5,6,78]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=void 0;class N{constructor(w,m,E){this.d=w,this.e=m,this.f=E,this.a=0,this.b=new O.$Tc,this.c=new Map,this.b.add(m.onDidChangeVisibleTextEditors(()=>{const T=m.getVisibleTextEditors();for(const S of this.c.values())T.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(w=>w.inset.dispose()),this.b.dispose()}createWebviewEditorInset(w,m,E,T,S){let l;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===w){l=n;break}if(!l)throw new Error("not a visible editor");const b=this,g=this.a++,r=new C.$fe,s=new C.$fe,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,M.$_Ab)(n,b.f)}get cspSource(){return M.$$Ab}set options(n){this.b=n,b.d.$setOptions(g,n)}get options(){return this.b}set html(n){this.a=n,b.d.$setHtml(g,n)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(n){return b.d.$postMessage(g,n)}},i=new class{constructor(){this.editor=w,this.line=m,this.height=E,this.webview=o,this.onDidDispose=s.event}dispose(){b.c.has(g)&&(b.c.delete(g),b.d.$disposeEditorInset(g),s.fire(),s.dispose(),r.dispose())}};return this.d.$createEditorInset(g,l.id,l.value.document.uri,m+1,E,T||{},S.identifier,S.extensionLocation),this.c.set(g,{editor:w,inset:i,onDidReceiveMessage:r}),i}$onDidDispose(w){const m=this.c.get(w);m&&m.inset.dispose()}$onDidReceiveMessage(w,m){this.c.get(w)?.onDidReceiveMessage.fire(m)}}e.$emc=N}),define(Se[108],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mL=e.$lL=e.$kL=void 0,e.$kL="__",e.$lL=(0,C.$yi)("IAuthenticationService"),e.$mL=(0,C.$yi)("IAuthenticationExtensionsService")}),define(Se[233],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BP=e.VariableKind=e.$AP=void 0,e.$AP=(0,C.$yi)("configurationResolverService");var O;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator",N.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class M extends Error{constructor(R,w){super(w),this.variable=R}}e.$BP=M}),define(Se[234],Ie([1,0,19,75,15,26,23,97,192,233,13]),function(le,e,C,O,M,N,R,w,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QP=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,g,r,s){this.h=new Map,this.a=b,this.b=g,this.g=r,s&&(this.c=s.then(o=>this.i(o)))}i(b){if(R.$i){const g=Object.create(null);return Object.keys(b).forEach(r=>{g[r.toLowerCase()]=b[r]}),g}return b}resolveWithEnvironment(b,g,r){return this.l({env:this.i(b),userHome:void 0},g?g.uri:void 0,r)}async resolveAsync(b,g){const r={env:await this.c,userHome:await this.g};return this.l(r,b?b.uri:void 0,g)}async j(b,g,r,s){const o=N.$5n(g);R.$i&&o.windows?Object.keys(o.windows).forEach(n=>o[n]=o.windows[n]):R.$j&&o.osx?Object.keys(o.osx).forEach(n=>o[n]=o.osx[n]):R.$k&&o.linux&&Object.keys(o.linux).forEach(n=>o[n]=o.linux[n]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,b?b.uri:void 0,o,r,s)}async resolveAnyAsync(b,g,r){return this.j(b,g,r)}async resolveAnyMap(b,g,r){const s=new Map;return{newConfig:await this.j(b,g,r,s),resolvedVariables:s}}resolveWithInteractionReplace(b,g,r,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,g,r,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,g){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,g)}async l(b,g,r,s,o){if(M.$$f(r))return this.m(b,g,r,s,o);if(Array.isArray(r))return Promise.all(r.map(i=>this.l(b,g,i,s,o)));if(M.$ag(r)){const i=Object.create(null),n=await Promise.all(Object.keys(r).map(async c=>[await this.m(b,g,c,s,o),await this.l(b,g,r[c],s,o)]));for(const[c,u]of n)i[c]=u;return i}return r}m(b,g,r,s,o){return(0,T.$rf)(r,S.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(S.VARIABLE_LHS))return i;let c=await this.o(b,i,n,g,s);return o?.set(n,c),c!==i&&M.$$f(c)&&c.match(S.VARIABLE_REGEXP)&&(c=await this.m(b,g,c,s,o)),c})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,g,r,s,o){let i;const n=r.split(":");n.length>1&&(r=n[0],i=n[1]);const c=f=>{const a=this.a.getFilePath();if(a)return(0,w.$Hw)(a);throw new E.$BP(f,(0,m.localize)(0,null,g))},u=f=>{const a=c(f);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,w.$Hw)(d)}throw new E.$BP(f,(0,m.localize)(1,null,g,C.$nc(a)))},t=f=>{if(i){const a=this.a.getFolderUri(i);if(a)return a;throw new E.$BP(f,(0,m.localize)(2,null,g,i))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new E.$BP(f,(0,m.localize)(3,null,g)):new E.$BP(f,(0,m.localize)(4,null,g))};switch(r){case"env":if(i){if(b.env){const f=b.env[R.$i?i.toLowerCase():i];if(M.$$f(f))return f}return""}throw new E.$BP(E.VariableKind.Env,(0,m.localize)(5,null,g));case"config":if(i){const f=this.a.getConfigurationValue(s,i);if(M.$hg(f))throw new E.$BP(E.VariableKind.Config,(0,m.localize)(6,null,g,i));if(M.$ag(f))throw new E.$BP(E.VariableKind.Config,(0,m.localize)(7,null,g,i));return f}throw new E.$BP(E.VariableKind.Config,(0,m.localize)(8,null,g));case"command":return this.p(E.VariableKind.Command,g,i,o,"command");case"input":return this.p(E.VariableKind.Input,g,i,o,"input");case"extensionInstallFolder":if(i){const f=await this.a.getExtension(i);if(!f)throw new E.$BP(E.VariableKind.ExtensionInstallFolder,(0,m.localize)(9,null,g,i));return this.n(f.extensionLocation)}throw new E.$BP(E.VariableKind.ExtensionInstallFolder,(0,m.localize)(10,null,g));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,w.$Hw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return s||i?(0,w.$Hw)(this.n(t(E.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,w.$Hw)(C.$nc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new E.$BP(E.VariableKind.UserHome,(0,m.localize)(11,null,g))}case"lineNumber":{const f=this.a.getLineNumber();if(f)return f;throw new E.$BP(E.VariableKind.LineNumber,(0,m.localize)(12,null,g))}case"selectedText":{const f=this.a.getSelectedText();if(f)return f;throw new E.$BP(E.VariableKind.SelectedText,(0,m.localize)(13,null,g))}case"file":return c(E.VariableKind.File);case"fileWorkspaceFolder":return u(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return C.$nc(u(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return s||i?C.$lc(this.n(t(E.VariableKind.RelativeFile)),c(E.VariableKind.RelativeFile)):c(E.VariableKind.RelativeFile);case"relativeFileDirname":{const f=C.$mc(c(E.VariableKind.RelativeFileDirname));if(s||i){const a=C.$lc(this.n(t(E.VariableKind.RelativeFileDirname)),f);return a.length===0?".":a}return f}case"fileDirname":return C.$mc(c(E.VariableKind.FileDirname));case"fileExtname":return C.$oc(c(E.VariableKind.FileExtname));case"fileBasename":return C.$nc(c(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=C.$nc(c(E.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-C.$oc(f).length)}case"fileDirnameBasename":return C.$nc(C.$mc(c(E.VariableKind.FileDirnameBasename)));case"execPath":{const f=this.a.getExecPath();return f||g}case"execInstallFolder":{const f=this.a.getAppRoot();return f||g}case"pathSeparator":case"/":return C.sep;default:try{const f=i?`${r}:${i}`:r;return this.p(E.VariableKind.Unknown,g,f,o,void 0)}catch{return g}}}}p(b,g,r,s,o){if(r&&s){const i=o===void 0?s[r]:s[o+":"+r];if(typeof i=="string")return i;throw new E.$BP(b,(0,m.localize)(14,null,g))}return g}}e.$QP=S}),define(Se[109],Ie([1,0,3,106]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$2D=void 0,e.$3D=E,e.$4D=l,e.$5D=b,e.$2D=(0,C.$yi)("editorGroupsService");var M;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(M||(e.GroupDirection=M={}));var N;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(N||(e.GroupOrientation=N={}));var R;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var w;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EXPAND=1]="EXPAND",g[g.EVEN=2]="EVEN"})(w||(e.GroupsArrangement=w={}));var m;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function E(g){const r=g;return(0,O.$MF)(r?.editor)&&(0,O.$MF)(r?.replacement)}var T;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var S;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function l(g){const r=g;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function b(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Se[235],Ie([1,0,3,109]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9D=e.$8D=e.$7D=e.$6D=void 0,e.$0D=M,e.$6D=(0,C.$yi)("editorService"),e.$7D=-1,e.$8D=-2,e.$9D=-3;function M(N){const R=N;return typeof N=="number"||(0,O.$4D)(R)}}),define(Se[236],Ie([1,0,3,99]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FL=void 0,e.$FL=(0,C.$zi)(O.$Fi)}),define(Se[110],Ie([1,0,21,5,19,6,11]),function(le,e,C,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yac=e.$xac=e.$wac=e.$vac=e.$uac=void 0;class w{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$uac=w;class m{static isHostExtension(i,n,c){if(n.getExtensionDescription(i))return!1;const u=c.getExtensionDescription(i);return u?!!((u.main||u.browser)&&u.api==="none"):!1}constructor(i,n){this.j=i,this.c=new O.$fe,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(r),this.f=new C.$Vm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const c of n)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=s(this.e,n),this.e=this.e.concat(i);const c=m.l(this.e);return this.e=s(this.e,c.map(u=>u.identifier)),this.k(),this.d++,this.c.fire(void 0),new w(this.d,c)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,d){this.addNode(a),this.addNode(d),this.c.has(a)?this.c.get(a).push(d):this.c.set(a,[d])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,d){const $=n.getArcs(a);for(let p=0;p<$.length;p++)if(!d.has($[p]))return!1;return!0}getNodes(){return this.e}},c=new C.$Vm;for(const a of i)if(c.set(a.identifier,a),a.extensionDependencies)for(const d of a.extensionDependencies)n.addArc(C.$Tm.toKey(a.identifier),C.$Tm.toKey(d));const u=new Set;n.getNodes().filter(a=>n.getArcs(a).length===0).forEach(a=>u.add(a));const t=n.getNodes().filter(a=>!u.has(a));let f;do{f=!1;for(let a=0;a<t.length;a++){const d=t[a];n.hasOnlyGoodArcs(d,u)&&(t.splice(a,1),a--,u.add(d),f=!0)}}while(f);return t.map(a=>c.get(a))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$vac=m;class E{constructor(i,n){this.versionId=i,this.extensions=n}}e.$wac=E;class T{constructor(i){this.d=new b,this.c=new m(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new S(this,n)}deltaExtensions(i,n,c){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,c)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$xac=T;class S extends N.$Uc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$yac=S;class l{constructor(i){this.name=i;const n=(0,R.$rh)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class b{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new l(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const c=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),u=()=>{n&&(clearTimeout(c),n=!1,this.d=!1,this.e())};i.resolve((0,N.$Sc)(u))}}var g;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(g||(g={}));function r(o,i){const n=o.isBuiltin?0:o.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==c)return n-c;const u=M.$gc.basename(o.extensionLocation.path),t=M.$gc.basename(i.extensionLocation.path);return u<t?-1:u>t?1:0}function s(o,i){const n=new C.$Um(i);return o.filter(c=>!n.has(c.identifier))}}),define(Se[79],Ie([1,0,22]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$2m=R,e.$3m=w;var O;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(O||(e.UIKind=O={}));var M;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(M||(e.ExtensionHostExitCode=M={}));var N;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(N||(e.MessageType=N={}));function R(E){const T=C.$He.alloc(1);switch(E){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}function w(E,T){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}var m;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(Se[63],Ie([1,0,3,5,12,27,79,58,59,26,2,6,179]),function(le,e,C,O,M,N,R,w,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7O=e.$5O=e.$4O=void 0,e.$6O=r;let b=class extends S.$Uc{constructor(o,i){super(),this.s=o,this.t=i,this.a=this.B(new O.$fe),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$fe),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=T.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:m.$np,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,M.$7j)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===M.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,i,n){const c=this.getTelemetryDetails(),u=new g(i,n,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,u]),u.apiTelemetryLogger}$initializeTelemetryLevel(o,i,n){this.f=o,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,w.$Km)((0,m.$tp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const i=this.getTelemetryDetails();this.r.forEach((n,c)=>{const u=n.filter(t=>!t.isDisposed);u.length===0?this.r.delete(c):this.r.set(c,u)}),this.r.forEach(n=>{for(const c of n)c.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,i){const c=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!c)return this.r.delete(o.value),!1;let u=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(i),u=!0);return u}};e.$4O=b,e.$4O=b=Je([We(0,N.$3O),We(1,M.$6j)],b);class g{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,n,c,u,t,f){this.g=n,this.h=c,this.i=u,this.j=t,this.a=new O.$fe,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(o,i){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,m.$wp)(i,[]),this.c&&(i=(0,E.$8n)(i,this.c)),this.b||(i=(0,E.$8n)(i,this.j)),"properties"in o?o.properties=i:o=i,o}k(o,i){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(o,i),this.h.trace(o,i))}logUsage(o,i){this.d.isUsageEnabled&&this.k(o,i)}logError(o,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,i);else{const n={name:o.name,message:o.message,stack:o.stack,cause:o.cause},c=(0,m.$wp)(n,[]),u=new Error(c.message,{cause:c.cause});u.stack=c.stack,u.name=c.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(u,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$5O=g;function r(s){const o=Date.now()-new Date(s).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$7O=(0,C.$yi)("IExtHostTelemetry")}),define(Se[25],Ie([1,0,5,2,207,105,21,3]),function(le,e,C,O,M,N,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PG=e.ActivationKind=e.$MG=e.$LG=e.$IG=e.ExtensionHostStartup=e.$HG=e.$GG=e.$FG=e.$EG=void 0,e.$JG=l,e.$KG=b,e.$NG=o,e.$OG=i,e.$EG=Object.freeze({identifier:new R.$Tm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$FG="extensions.webWorker",e.$GG=(0,w.$yi)("extensionService");class m{constructor(u){this.dependency=u}}e.$HG=m;var E;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class T{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(u,t,f){this.c=u,this.d=t.slice(0),this.e=f.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:N.$pG.createActivationEventsMap(this.d)}}set(u,t,f){if(this.c>u)throw new Error(`ExtensionHostExtensions: invalid versionId ${u} (current: ${this.c})`);const a=[],d=[],$=[],p=[],v=S(this.d),y=S(t),h=(V,W)=>V.extensionLocation.toString()===W.extensionLocation.toString()||V.isBuiltin===W.isBuiltin||V.isUserBuiltin===W.isUserBuiltin||V.isUnderDevelopment===W.isUnderDevelopment;for(const V of this.d){const W=y.get(V.identifier);if(!W){a.push(V.identifier),v.delete(V.identifier);continue}if(!h(V,W)){a.push(V.identifier),v.delete(V.identifier);continue}}for(const V of t){const W=v.get(V.identifier);if(!W){d.push(V);continue}if(!h(W,V)){a.push(W.identifier),v.delete(W.identifier);continue}}const D=new R.$Um(this.e),k=new R.$Um(f);for(const V of this.e)k.has(V)||$.push(V);for(const V of f)D.has(V)||p.push(V);const I=N.$pG.createActivationEventsMap(d),P={versionId:u,toRemove:a,toAdd:d,addActivationEvents:I,myToRemove:$,myToAdd:p};return this.delta(P),P}delta(u){if(this.c>=u.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:a,myToAdd:d}=u,$=new R.$Um(t),p=new R.$Um(a);for(let v=0;v<this.d.length;v++)$.has(this.d[v].identifier)&&(this.d.splice(v,1),v--);for(let v=0;v<this.e.length;v++)p.has(this.e[v])&&(this.e.splice(v,1),v--);for(const v of f)this.d.push(v);for(const v of d)this.e.push(v);return this.f=null,u}containsExtension(u){for(const t of this.e)if(R.$Tm.equals(t,u))return!0;return!1}containsActivationEvent(u){return this.f||(this.f=this.g()),this.f.has(u)}g(){const u=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const f=N.$pG.readActivationEvents(t);for(const a of f)u.add(a)}return u}}e.$IG=T;function S(c){const u=new R.$Vm;for(const t of c)u.set(t.identifier,t);return u}function l(c,u){return c.enabledApiProposals?c.enabledApiProposals.includes(u):!1}function b(c,u){if(!l(c,u))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class g{constructor(u,t,f,a){this.codeLoadingTime=u,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=a}}e.$LG=g;class r{constructor(u,t){this.description=u,this.value=t}}e.$MG=r;var s;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function o(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,M.$Cp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function i(c,u){return{identifier:new R.$Tm((0,M.$Ap)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!u,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,publisherDisplayName:c.publisherDisplayName}}class n{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activateById(u,t){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(u,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$PG=n}),define(Se[237],Ie([1,0,14,110,21,25,12,11]),function(le,e,C,O,M,N,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=e.$Emc=e.$Dmc=e.$Cmc=e.$Bmc=e.$Amc=void 0;class m{static{this.NONE=new m(!1,-1,-1,-1)}constructor(o,i,n,c){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=c}}e.$Amc=m;class E{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,i){return o===-1||i===-1?-1:i-o}build(){return new m(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Bmc=E;class T{constructor(o,i,n,c,u,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=n,this.module=c,this.exports=u,this.subscriptions=t}}e.$Cmc=T;class S extends T{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Dmc=S;class l extends T{constructor(){super(!1,null,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Emc=l;class b extends T{constructor(o){super(!0,o,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let g=class{constructor(o,i,n,c){this.g=c,this.a=o,this.b=i,this.c=n,this.d=new M.$Vm,this.f=Object.create(null)}dispose(){for(const[o,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,n]of this.d)o.push(n.wait());await Promise.all(o)}isActivated(o){const i=this.d.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this.d.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this.f[o])return;const n=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(n.map(c=>({id:c.identifier,reason:{startup:i,extensionId:c.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,i){const n=this.a.getExtensionDescription(o);if(!n)throw new Error(`Extension '${o.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(o){const i=o.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const i=this.a.getExtensionDescription(o.id);if(!i){const u=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new b(u));return this.c.onExtensionActivationError(o.id,u,new N.$HG(o.id.value)),t}const n=[],c=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const u of c){if(this.m(u))continue;const t=this.d.get(u);if(t){n.push(t);continue}if(this.l(u)){n.push(this.j({id:this.b.getExtensionDescription(u).identifier,reason:o.reason}));continue}const f=this.a.getExtensionDescription(u);if(f){if(!f.main&&!f.browser)continue;n.push(this.j({id:f.identifier,reason:o.reason}));continue}const a=i.displayName||i.identifier.value,d=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${u}'`),$=this.k(o,i.displayName,[],new b(d));return this.c.onExtensionActivationError(i.identifier,d,new N.$HG(u)),$}return this.k(o,i.displayName,n,null)}k(o,i,n,c){const u=new r(o.id,i,o.reason,n,c,this.c,this.g);return this.d.set(o.id,u),u}l(o){return O.$vac.isHostExtension(o,this.a,this.b)}m(o){const i=this.b.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.$Fmc=g,e.$Fmc=g=Je([We(3,R.$5j)],g);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,i,n,c,u,t,f){this.c=o,this.d=i,this.f=n,this.g=c,this.h=u,this.j=t,this.k=f,this.a=new w.$xh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const i=this.g[o];if(i.value&&!i.value.activationFailed){this.g.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new b(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this.h=new b(i),this.b&&C.$4(o))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};r=Je([We(6,R.$5j)],r)}),define(Se[238],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[239],Ie([1,0,194,14,32,100,74,29,21,238,102,105]),function(le,e,C,O,M,N,R,w,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=void 0;const l=w.$fo.as(R.$go.JSONContribution);class b{constructor(u,t,f){this.a=u,this.b=t,this.c=f}d(u,t){this.a({type:u,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(u){this.d(M.default.Error,u)}warn(u){this.d(M.default.Warning,u)}info(u){this.d(M.default.Info,u)}}e.$yG=b;class g{static a(u){const t=new m.$Um;for(let f=0,a=u.length;f<a;f++)t.add(u[f].description.identifier);return t}static compute(u,t){if(!u||!u.length)return new g(t,[]);if(!t||!t.length)return new g([],u);const f=this.a(u),a=this.a(t),d=t.filter(p=>!f.has(p.description.identifier)),$=u.filter(p=>!a.has(p.description.identifier));return new g(d,$)}constructor(u,t){this.added=u,this.removed=t}}e.$zG=g;class r{constructor(u,t){this.name=u,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(u){if(this.a!==null)throw new Error("Handler already set!");this.a=u,this.d()}acceptUsers(u){this.c=g.compute(this.b,u),this.b=u,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(u){(0,O.$1)(u)}}}e.$AG=r;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$BG={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.$Sm},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:C.localize(42,null)},{label:"*",description:C.localize(43,null),body:"*"}]}},badges:{type:"array",description:C.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(45,null)},href:{type:"string",description:C.localize(46,null)},description:{type:"string",description:C.localize(47,null)}}}},markdown:{type:"string",description:C.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Wo}},extensionPack:{description:C.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Wo}},extensionKind:{description:C.localize(52,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(53,null)},{body:["workspace"],description:C.localize(54,null)},{body:["ui","workspace"],description:C.localize(55,null)},{body:["workspace","ui"],description:C.localize(56,null)},{body:[],description:C.localize(57,null)}]},capabilities:{description:C.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(61,null),C.localize(62,null),C.localize(63,null)]},description:{type:"string",markdownDescription:C.localize(64,null)}}},untrustedWorkspaces:{description:C.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(67,null),C.localize(68,null),C.localize(69,null)]},restrictedConfigurations:{description:C.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(71,null)}}}}},sponsor:{description:C.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(74,null),type:"string"},"vscode:uninstall":{description:C.localize(75,null),type:"string"}}},icon:{type:"string",description:C.localize(76,null)},l10n:{type:"string",description:C.localize(77,null)},pricing:{type:"string",markdownDescription:C.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(u){if(this.a.has(u.extensionPoint))throw new Error("Duplicate extension point: "+u.extensionPoint);const t=new r(u.extensionPoint,u.defaultExtensionKind);return this.a.set(u.extensionPoint,t),u.activationEventsGenerator&&S.$pG.register(u.extensionPoint,u.activationEventsGenerator),e.$BG.properties.contributes.properties[u.extensionPoint]=u.jsonSchema,l.registerSchema(o,e.$BG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$CG=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};w.$fo.add(n.ExtensionsRegistry,new i),e.$DG=w.$fo.as(n.ExtensionsRegistry),l.registerSchema(o,e.$BG),l.registerSchema(T.$mk,{properties:{extensionEnabledApiProposals:{description:C.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Se[240],Ie([1,0,190,15,26,239,31,5]),function(le,e,C,O,M,N,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hI=void 0;const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var E;(function(l){function b(g,r,s){if(!g)return;const o=O.$$f(g.type)?g.type:void 0;if(!o||o.length===0){s.error(C.localize(3,null));return}const i=[];if(Array.isArray(g.required))for(const n of g.required)O.$$f(n)&&i.push(n);return{extensionId:r.value,taskType:o,required:i,properties:g.properties?M.$5n(g.properties):{},when:g.when?R.$wj.deserialize(g.when):void 0}}l.from=b})(E||(E={}));const T=N.$DG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,b)=>{for(const g of l)g.type&&b.push(`onTaskType:${g.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:m}});class S{constructor(){this.d=new w.$fe,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,g)=>{T.setHandler((r,s)=>{this.c=void 0;try{for(const o of s.removed){const i=o.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const o of s.added){const i=o.value;for(const n of i){const c=E.from(n,o.description.identifier,o.collector);c&&(this.a[c.taskType]=c)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const g of this.all()){const r={type:"object",additionalProperties:!1};g.required.length>0&&(r.required=g.required.slice(0)),g.properties!==void 0?r.properties=M.$5n(g.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[g.taskType]},b.push(r)}this.c={oneOf:b}}return this.c}}e.$hI=new S}),define(Se[241],Ie([1,0,191,15,24,26,31,240]),function(le,e,C,O,M,N,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$rI=e.JsonSchemaVersion=e.ExecutionEngine=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$lI=e.ShellQuoting=e.$kI=e.$jI=e.$iI=void 0,e.$iI="settings",e.$jI=new R.$Pj("taskRunning",!1,C.localize(0,null)),e.$kI=C.localize2(2,"Tasks");var m;(function(A){A[A.Escape=1]="Escape",A[A.Strong=2]="Strong",A[A.Weak=3]="Weak"})(m||(e.ShellQuoting=m={})),e.$lI="$customized",function(A){function z(G){if(!G)return A.Strong;switch(G.toLowerCase()){case"escape":return A.Escape;case"strong":return A.Strong;case"weak":return A.Weak;default:return A.Strong}}A.from=z}(m||(e.ShellQuoting=m={}));var E;(function(A){A.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var T;(function(A){A[A.Always=1]="Always",A[A.Silent=2]="Silent",A[A.Never=3]="Never"})(T||(e.RevealKind=T={})),function(A){function z(G){switch(G.toLowerCase()){case"always":return A.Always;case"silent":return A.Silent;case"never":return A.Never;default:return A.Always}}A.fromString=z}(T||(e.RevealKind=T={}));var S;(function(A){A[A.Never=1]="Never",A[A.OnProblem=2]="OnProblem",A[A.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(A){function z(G){switch(G.toLowerCase()){case"always":return A.Always;case"never":return A.Never;case"onproblem":return A.OnProblem;default:return A.OnProblem}}A.fromString=z}(S||(e.RevealProblemKind=S={}));var l;(function(A){A[A.Shared=1]="Shared",A[A.Dedicated=2]="Dedicated",A[A.New=3]="New"})(l||(e.PanelKind=l={})),function(A){function z(G){switch(G.toLowerCase()){case"shared":return A.Shared;case"dedicated":return A.Dedicated;case"new":return A.New;default:return A.Shared}}A.fromString=z}(l||(e.PanelKind=l={}));var b;(function(A){A.defaults={echo:!0,reveal:T.Always,revealProblems:S.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var g;(function(A){A[A.Shell=1]="Shell",A[A.Process=2]="Process",A[A.CustomExecution=3]="CustomExecution"})(g||(e.RuntimeType=g={})),function(A){function z(ie){switch(ie.toLowerCase()){case"shell":return A.Shell;case"process":return A.Process;case"customExecution":return A.CustomExecution;default:return A.Process}}A.fromString=z;function G(ie){switch(ie){case A.Shell:return"shell";case A.Process:return"process";case A.CustomExecution:return"customExecution";default:return"process"}}A.toString=G}(g||(e.RuntimeType=g={}));var r;(function(A){function z(G){return O.$$f(G)?G:G.value}A.value=z})(r||(e.CommandString=r={}));var s;(function(A){A.Clean={_id:"clean",isDefault:!1},A.Build={_id:"build",isDefault:!1},A.Rebuild={_id:"rebuild",isDefault:!1},A.Test={_id:"test",isDefault:!1};function z(ie){return ie===A.Clean._id||ie===A.Build._id||ie===A.Rebuild._id||ie===A.Test._id}A.is=z;function G(ie){if(ie!==void 0)return O.$$f(ie)?z(ie)?{_id:ie,isDefault:!1}:void 0:ie}A.from=G})(s||(e.TaskGroup=s={}));var o;(function(A){A[A.Global=1]="Global",A[A.Workspace=2]="Workspace",A[A.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(A){A.Workspace="workspace",A.Extension="extension",A.InMemory="inMemory",A.WorkspaceFile="workspaceFile",A.User="user";function z(G){switch(G){case A.User:return 2;case A.WorkspaceFile:return 5;default:return 6}}A.toConfigurationTarget=z})(i||(e.TaskSourceKind=i={}));var n;(function(A){A.parallel="parallel",A.sequence="sequence"})(n||(e.DependsOrder=n={}));var c;(function(A){A[A.default=1]="default",A[A.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var u;(function(A){A.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(u||(e.RunOptions=u={}));class t{constructor(z,G,ie,de,ye,Ee){this._label="",this._id=z,G&&(this._label=G),ie&&(this.type=ie),this.runOptions=de,this.configurationProperties=ye,this._source=Ee}getDefinition(z){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,G=!1){if(z===void 0)return!1;if(O.$$f(z))return z===this._label||z===this.configurationProperties.identifier||G&&z===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.$mI=t;class f extends t{constructor(z,G,ie,de,ye,Ee,ge,ue){super(z,ie,void 0,ge,ue,G),this.command={},this._source=G,this.hasDefinedMatchers=Ee,ye&&(this.command=ye)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let G;switch(this.command?this.command.runtime:void 0){case g.Shell:G="shell";break;case g.Process:G="process";break;case g.CustomExecution:G="customExecution";break;case void 0:G="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:G,_key:this._id,id:this._id}}}static is(z){return z instanceof f}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$iI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const z=this.d();if(!z)return;let G=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(G+=this._source.kind);const ie={type:e.$lI,folder:z,id:G};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$9g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new f(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$nI=f;class a extends t{constructor(z,G,ie,de,ye,Ee,ge){super(z,ie,de,Ee,ge,G),this._source=G,this.configures=ye}static is(z){return z instanceof a}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$9g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$iI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const z=this.d();if(!z)return;let G=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(G+=this._source.kind);const ie={type:e.$lI,folder:z,id:G};return JSON.stringify(ie)}}e.$oI=a;class d extends t{constructor(z,G,ie,de,ye,Ee,ge,ue,Ce){super(z,ie,de,ue,Ce,G),this.defines=ye,this.hasDefinedMatchers=ge,this.command=Ee,this.icon=Ce.icon,this.hide=Ce.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof d}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new d(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$pI=d;class $ extends t{constructor(z,G,ie,de,ye,Ee){super(z,ie,de,ye,Ee,G),this._source=G}clone(){return new $(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof $}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new $(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.$qI=$;var p;(function(A){A[A.Process=1]="Process",A[A.Terminal=2]="Terminal"})(p||(e.ExecutionEngine=p={})),function(A){A._default=A.Terminal}(p||(e.ExecutionEngine=p={}));var v;(function(A){A[A.V0_1_0=1]="V0_1_0",A[A.V2_0_0=2]="V2_0_0"})(v||(e.JsonSchemaVersion=v={}));class y{constructor(z){this.c=new Map;for(let G=0;G<z.length;G++)this.c.set(z[G].uri.toString(),G)}compare(z,G){const ie=z.getWorkspaceFolder(),de=G.getWorkspaceFolder();if(ie&&de){let ye=this.c.get(ie.uri.toString());ye=ye===void 0?0:ye+1;let Ee=this.c.get(de.uri.toString());return Ee=Ee===void 0?0:Ee+1,ye===Ee?z._label.localeCompare(G._label):ye-Ee}else return!ie&&de?-1:ie&&!de?1:0}}e.$rI=y;var h;(function(A){A.DependsOnStarted="dependsOnStarted",A.AcquiredInput="acquiredInput",A.Start="start",A.ProcessStarted="processStarted",A.Active="active",A.Inactive="inactive",A.Changed="changed",A.Terminated="terminated",A.ProcessEnded="processEnded",A.End="end"})(h||(e.TaskEventKind=h={}));var D;(function(A){A.SingleRun="singleRun",A.Background="background"})(D||(e.TaskRunType=D={}));var k;(function(A){A[A.System=0]="System",A[A.User=1]="User",A[A.FolderOpen=2]="FolderOpen",A[A.ConfigurationChange=3]="ConfigurationChange",A[A.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var I;(function(A){function z(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?"background":"singleRun",group:ue.configurationProperties.group,__task:ue}}function G(ue,Ce,se){return{...z(ue),kind:"start",terminalId:Ce,resolvedVariables:se}}A.start=G;function ie(ue,Ce,se){return{...z(ue),kind:"processStarted",terminalId:Ce,processId:se}}A.processStarted=ie;function de(ue,Ce,se){return{...z(ue),kind:"processEnded",terminalId:Ce,exitCode:se}}A.processEnded=de;function ye(ue,Ce,se){return{...z(ue),kind:"terminated",exitReason:se,terminalId:Ce}}A.terminated=ye;function Ee(ue,Ce,se){return{...z(Ce),kind:ue,terminalId:se}}A.general=Ee;function ge(){return{kind:"changed"}}A.changed=ge})(I||(e.TaskEvent=I={}));var P;(function(A){function z(ie){const de=Object.keys(ie).sort();let ye="";for(const Ee of de){let ge=ie[Ee];ge instanceof Object?ge=z(ge):typeof ge=="string"&&(ge=ge.replace(/,/g,",,")),ye+=Ee+","+ge+","}return ye}function G(ie){const ye={_key:z(ie),type:ie.taskType};return Object.assign(ye,ie),ye}A.create=G})(P||(e.KeyedTaskIdentifier=P={}));var V;(function(A){A.AutoDetect="task.autoDetect",A.SaveBeforeRun="task.saveBeforeRun",A.ShowDecorations="task.showDecorations",A.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",A.SlowProviderWarning="task.slowProviderWarning",A.QuickOpenHistory="task.quickOpen.history",A.QuickOpenDetail="task.quickOpen.detail",A.QuickOpenSkip="task.quickOpen.skip",A.QuickOpenShowAll="task.quickOpen.showAll",A.AllowAutomaticTasks="task.allowAutomaticTasks",A.Reconnection="task.reconnection",A.VerboseLogging="task.verboseLogging"})(V||(e.TaskSettingId=V={}));var W;(function(A){A.Tasks="tasks",A.SuppressTaskName="tasks.suppressTaskName",A.Windows="tasks.windows",A.Osx="tasks.osx",A.Linux="tasks.linux",A.ShowOutput="tasks.showOutput",A.IsShellCommand="tasks.isShellCommand",A.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var q;(function(A){function z(G,ie){const de=w.$hI.get(G.type);if(de===void 0){const ue=N.$5n(G);return delete ue._key,P.create(ue)}const ye=Object.create(null);ye.type=de.taskType;const Ee=new Set;de.required.forEach(ue=>Ee.add(ue));const ge=de.properties;for(const ue of Object.keys(ge)){const Ce=G[ue];if(Ce!=null)ye[ue]=Ce;else if(Ee.has(ue)){const se=ge[ue];if(se.default!==void 0)ye[ue]=N.$5n(se.default);else switch(se.type){case"boolean":ye[ue]=!1;break;case"number":case"integer":ye[ue]=0;break;case"string":ye[ue]="";break;default:ie.error(C.localize(1,null,JSON.stringify(G,void 0,0),ue));return}}}return P.create(ye)}A.createTaskIdentifier=z})(q||(e.TaskDefinition=q={}))}),define(Se[242],Ie([1,0,14]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aac=e.$zac=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,w)=>{this.b=R,this.d=w,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,C.$1)(R))}then(R,w){return this.j().then(R,w)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$zac=O;class M extends O{constructor(){super(),this.h=!0,this.i=new C.$5}}e.$Aac=M}),define(Se[34],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ew=e.$Bw=void 0,e.$Cw=M,e.$Dw=N;class C{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++C.count}}e.$Bw=C;const O=[];function M(w){const m=new C(w);return O[m.nid]=m,m}function N(w){return O[w].sid}class R{constructor(m){this.value=m}}e.$Ew=R}),define(Se[4],Ie([1,0,34]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=e.$iM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$hM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var M;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(M||(e.TabInputKind=M={}));var N;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(N||(e.TabModelOperationKind=N={}));var R;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var w;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(w||(e.WebviewMessageArrayBufferViewType=w={}));var m;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var E;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var T;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(T||(e.CandidatePortSource=T={}));class S{static{this.a=0}static mixin(s){return s._id=S.a++,s}}e.$hM=S;var l;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var b;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var g;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.$iM={MainThreadAuthentication:(0,C.$Cw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.$Cw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,C.$Cw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,C.$Cw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,C.$Cw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,C.$Cw)("MainThreadChatVariables"),MainThreadClipboard:(0,C.$Cw)("MainThreadClipboard"),MainThreadCommands:(0,C.$Cw)("MainThreadCommands"),MainThreadComments:(0,C.$Cw)("MainThreadComments"),MainThreadConfiguration:(0,C.$Cw)("MainThreadConfiguration"),MainThreadConsole:(0,C.$Cw)("MainThreadConsole"),MainThreadDebugService:(0,C.$Cw)("MainThreadDebugService"),MainThreadDecorations:(0,C.$Cw)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.$Cw)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.$Cw)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.$Cw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.$Cw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.$Cw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.$Cw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.$Cw)("MainThreadEditorTabs"),MainThreadErrors:(0,C.$Cw)("MainThreadErrors"),MainThreadTreeViews:(0,C.$Cw)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.$Cw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,C.$Cw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.$Cw)("MainThreadLanguages"),MainThreadLogger:(0,C.$Cw)("MainThreadLogger"),MainThreadMessageService:(0,C.$Cw)("MainThreadMessageService"),MainThreadOutputService:(0,C.$Cw)("MainThreadOutputService"),MainThreadProgress:(0,C.$Cw)("MainThreadProgress"),MainThreadQuickDiff:(0,C.$Cw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.$Cw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.$Cw)("MainThreadStatusBar"),MainThreadSecretState:(0,C.$Cw)("MainThreadSecretState"),MainThreadStorage:(0,C.$Cw)("MainThreadStorage"),MainThreadSpeech:(0,C.$Cw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,C.$Cw)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.$Cw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,C.$Cw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,C.$Cw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.$Cw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.$Cw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.$Cw)("MainThreadCustomEditors"),MainThreadUrls:(0,C.$Cw)("MainThreadUrls"),MainThreadUriOpeners:(0,C.$Cw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.$Cw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.$Cw)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.$Cw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,C.$Cw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,C.$Cw)("MainThreadExtensionService"),MainThreadSCM:(0,C.$Cw)("MainThreadSCM"),MainThreadSearch:(0,C.$Cw)("MainThreadSearch"),MainThreadShare:(0,C.$Cw)("MainThreadShare"),MainThreadTask:(0,C.$Cw)("MainThreadTask"),MainThreadWindow:(0,C.$Cw)("MainThreadWindow"),MainThreadLabelService:(0,C.$Cw)("MainThreadLabelService"),MainThreadNotebook:(0,C.$Cw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.$Cw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.$Cw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.$Cw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.$Cw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.$Cw)("MainThreadInteractive"),MainThreadTheming:(0,C.$Cw)("MainThreadTheming"),MainThreadTunnelService:(0,C.$Cw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.$Cw)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.$Cw)("MainThreadTimeline"),MainThreadTesting:(0,C.$Cw)("MainThreadTesting"),MainThreadLocalization:(0,C.$Cw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.$Cw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.$Cw)("MainThreadAiEmbeddingVector")},e.$jM={ExtHostCommands:(0,C.$Cw)("ExtHostCommands"),ExtHostConfiguration:(0,C.$Cw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.$Cw)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.$Cw)("ExtHostDebugService"),ExtHostDecorations:(0,C.$Cw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.$Cw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.$Cw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.$Cw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.$Cw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.$Cw)("ExtHostEditors"),ExtHostTreeViews:(0,C.$Cw)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.$Cw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.$Cw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.$Cw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.$Cw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.$Cw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.$Cw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.$Cw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.$Cw)("ExtHostStatusBar"),ExtHostShare:(0,C.$Cw)("ExtHostShare"),ExtHostExtensionService:(0,C.$Cw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.$Cw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.$Cw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,C.$Cw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,C.$Cw)("ExtHostSCM"),ExtHostSearch:(0,C.$Cw)("ExtHostSearch"),ExtHostTask:(0,C.$Cw)("ExtHostTask"),ExtHostWorkspace:(0,C.$Cw)("ExtHostWorkspace"),ExtHostWindow:(0,C.$Cw)("ExtHostWindow"),ExtHostWebviews:(0,C.$Cw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.$Cw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.$Cw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.$Cw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.$Cw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.$Cw)("ExtHostEditorTabs"),ExtHostProgress:(0,C.$Cw)("ExtHostProgress"),ExtHostComments:(0,C.$Cw)("ExtHostComments"),ExtHostSecretState:(0,C.$Cw)("ExtHostSecretState"),ExtHostStorage:(0,C.$Cw)("ExtHostStorage"),ExtHostUrls:(0,C.$Cw)("ExtHostUrls"),ExtHostUriOpeners:(0,C.$Cw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.$Cw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.$Cw)("ExtHostOutputService"),ExtHostLabelService:(0,C.$Cw)("ExtHostLabelService"),ExtHostNotebook:(0,C.$Cw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.$Cw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.$Cw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.$Cw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.$Cw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.$Cw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.$Cw)("ExtHostInteractive"),ExtHostChatAgents2:(0,C.$Cw)("ExtHostChatAgents"),ExtHostChatVariables:(0,C.$Cw)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.$Cw)("ExtHostChatProvider"),ExtHostSpeech:(0,C.$Cw)("ExtHostSpeech"),ExtHostEmbeddings:(0,C.$Cw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,C.$Cw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.$Cw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.$Cw)("ExtHostTheming"),ExtHostTunnelService:(0,C.$Cw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.$Cw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.$Cw)("ExtHostAuthentication"),ExtHostTimeline:(0,C.$Cw)("ExtHostTimeline"),ExtHostTesting:(0,C.$Cw)("ExtHostTesting"),ExtHostTelemetry:(0,C.$Cw)("ExtHostTelemetry"),ExtHostLocalization:(0,C.$Cw)("ExtHostLocalization")}}),define(Se[80],Ie([1,0,3,12,4,17]),function(le,e,C,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=e.$1lc=e.$Zlc=void 0,e.$Zlc=(0,C.$yi)("IExtHostApiDeprecationService");let R=class{constructor(m,E){this.c=E,this.a=new Set,this.b=m.getProxy(M.$iM.MainThreadTelemetry)}report(m,E,T){const S=this.d(m,E);this.a.has(S)||(this.a.add(S),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${m}' is deprecated. ${T}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:m}))}d(m,E){return`${m}-${E.identifier.value}`}};e.$1lc=R,e.$1lc=R=Je([We(0,N.$MO),We(1,O.$5j)],R),e.$2lc=Object.freeze(new class{report(w,m,E){}})}),define(Se[243],Ie([1,0,4]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=void 0;class O{constructor(N){const R=N.getProxy(C.$iM.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(w){return R.$writeText(w)}})}}e.$cmc=O}),define(Se[244],Ie([1,0,26,4,27,17]),function(le,e,C,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9nc=void 0;let R=class{constructor(T,S){this.a=T.getProxy(O.$iM.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(T,S){const l=this,b=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){l.e(T,S,b,arguments)}})}e(T,S,l,b){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:m(b,this.b)}),this.c&&this.f(T,l,b)}};e.$9nc=R,e.$9nc=R=Je([We(0,N.$MO),We(1,M.$3O)],R);const w=1e5;function m(E,T){const S=[];if(E.length)for(let l=0;l<E.length;l++){let b=E[l];if(typeof b>"u")b="undefined";else if(b instanceof Error){const g=b;g.stack?b=g.stack:b=g.toString()}S.push(b)}if(T){const l=new Error().stack;l&&S.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,C.$0n)(S);return l.length>w?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Se[245],Ie([1,0,2,4,25]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=void 0;class N{constructor(w){this.a=w.getProxy(O.$iM.MainThreadDialogs)}showOpenDialog(w,m){return m?.allowUIResources&&(0,M.$KG)(w,"showLocal"),this.a.$showOpenDialog(m).then(E=>E?E.map(T=>C.URI.revive(T)):void 0)}showSaveDialog(w){return this.a.$showSaveDialog(w).then(m=>m?C.URI.revive(m):void 0)}}e.$_mc=N}),define(Se[246],Ie([1,0,20,5,6,4]),function(le,e,C,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=void 0;class R{constructor(m){this.b=new Map,this.c=new O.$fe,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=m.getProxy(N.$iM.MainThreadEmbeddings)}registerEmbeddingsProvider(m,E,T){if(this.d.has(E))throw new Error("An embeddings provider for this model is already registered");const S=this.e++;return this.a.$registerEmbeddingProvider(S,E),this.b.set(S,{id:E,provider:T}),(0,M.$Sc)(()=>{this.a.$unregisterEmbeddingProvider(S),this.b.delete(S)})}async computeEmbeddings(m,E,T){T??=C.CancellationToken.None;let S=!1;typeof E=="string"&&(E=[E],S=!0);const l=await this.a.$computeEmbeddings(m,E,T);if(l.length!==E.length)throw new Error;if(S){if(l.length!==1)throw new Error;return l[0]}return l}async $provideEmbeddings(m,E,T){const S=this.b.get(m);if(!S)return[];const l=await S.provider.provideEmbeddings(E,T);return l||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(m){this.d=new Set(m),this.c.fire()}}e.$cnc=R}),define(Se[247],Ie([1,0,6,4]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tnc=void 0;class M{constructor(R){this.b=0,this.a=R.getProxy(O.$iM.MainThreadLabelService)}$registerResourceLabelFormatter(R){const w=this.b++;return this.a.$registerResourceLabelFormatter(w,R),(0,C.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(w)})}}e.$tnc=M}),define(Se[81],Ie([1,0,23,13,2,3,12,4,27,17]),function(le,e,C,O,M,N,R,w,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=e.$Tmc=void 0;let T=class{constructor(l,b,g){this.f=g,this.d=new Map,this.a=b.getProxy(w.$iM.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===C.$g}getMessage(l,b){const{message:g,args:r,comment:s}=b;if(this.c)return(0,O.$$e)(g,r??{});let o=g;s&&s.length>0&&(o+=`/${Array.isArray(s)?s.join(""):s}`);const i=this.d.get(l)?.contents[o];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,O.$$e)(i??g,r??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let b;const g=await this.g(l);if(!g){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(g),s=JSON.parse(r);b=l.isBuiltin?s.contents?.bundle:s}catch(r){this.f.error(`Failed to load translations for ${l.identifier.value} from ${g}: ${r.message}`);return}b&&this.d.set(l.identifier.value,{contents:b,uri:g})}async g(l){if(l.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return M.URI.revive(b)}return l.l10n?M.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Tmc=T,e.$Tmc=T=Je([We(0,m.$3O),We(1,E.$MO),We(2,R.$5j)],T),e.$Umc=(0,N.$yi)("IExtHostLocalizationService")}),define(Se[248],Ie([1,0,12,4,27,17,2,49]),function(le,e,C,O,M,N,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8nc=void 0;let m=class extends C.$dk{constructor(S,l){super(l.logLevel,l.logsLocation,l.loggers.map(b=>(0,w.$8h)(b))),this.r=S.getProxy(O.$iM.MainThreadLogger)}$setLogLevel(S,l){l?this.setLogLevel(R.URI.revive(l),S):this.setLogLevel(S)}setVisibility(S,l){super.setVisibility(S,l),this.r.$setVisibility(S,l)}s(S,l,b){return new E(this.r,S,l,b)}};e.$8nc=m,e.$8nc=m=Je([We(0,N.$MO),We(1,M.$3O)],m);class E extends C.$$j{constructor(S,l,b,g){super(g?.logLevel==="always"),this.r=S,this.s=l,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(l,g).then(()=>{this.u(this.n),this.m=!0})}g(S,l){const b=[[S,l]];this.m?this.u(b):this.n.push(...b)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Se[82],Ie([1,0,4,3,6,17,22]),function(le,e,C,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wmc=e.$Vmc=void 0,e.$Vmc=(0,O.$yi)("IExtHostManagedSockets");let w=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(C.$iM.MainThreadManagedSockets)}setFactory(S,l){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new m(S,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const l=++this.b,b=await this.c.makeConnection(),g=new M.$Tc;return this.d.set(l,new E(l,b,g)),g.add((0,M.$Sc)(()=>this.d.delete(l))),g.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),g.dispose()})),g.add(b.onDidClose(r=>{this.a.$onDidManagedSocketClose(l,r?.stack??r?.message),g.dispose()})),g.add(b.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(l,R.$He.wrap(r)))),l}$remoteSocketWrite(S,l){this.d.get(S)?.actual.send(l.buffer)}$remoteSocketEnd(S){const l=this.d.get(S);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$Wmc=w,e.$Wmc=w=Je([We(0,N.$MO)],w);class m{constructor(S,l){this.socketFactoryId=S,this.makeConnection=l}}class E extends M.$Uc{constructor(S,l,b){super(),this.socketId=S,this.actual=l,this.B(b)}}}),define(Se[249],Ie([1,0,4,12,25]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vnc=void 0;function N(w){return w&&w.title}let R=class{constructor(m,E){this.b=E,this.a=m.getProxy(C.$iM.MainThreadMessageService)}showMessage(m,E,T,S,l){const b={source:{identifier:m.identifier,label:m.displayName||m.name}};let g;typeof S=="string"||N(S)?g=[S,...l]:(b.modal=S?.modal,b.useCustom=S?.useCustom,b.detail=S?.detail,g=l),b.useCustom&&(0,M.$KG)(m,"resolvers");const r=[];let s=!1;for(let o=0;o<g.length;o++){const i=g[o];if(typeof i=="string")r.push({title:i,handle:o,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:c}=i;r.push({title:n,isCloseAffordance:!!c,handle:o}),c&&(s?this.b.warn(`[${m.identifier}] Only one message item can have 'isCloseAffordance':`,i):s=!0)}else this.b.warn(`[${m.identifier}] Invalid message item:`,i)}return this.a.$showMessage(E,T,b,r).then(o=>{if(typeof o=="number")return g[o]})}};e.$vnc=R,e.$vnc=R=Je([We(1,O.$5j)],R)}),define(Se[250],Ie([1,0,6,15,2,25,4]),function(le,e,C,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enc=void 0;class w{constructor(E){this.b=new Map,this.a=E.getProxy(R.$iM.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,T,S){if((0,N.$KG)(E,"profileContentHandlers"),this.b.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.b.set(T,S),this.a.$registerProfileContentHandler(T,S.name,S.description,E.identifier.value),(0,C.$Sc)(()=>{this.b.delete(T),this.a.$unregisterProfileContentHandler(T)})}async $saveProfile(E,T,S,l){const b=this.b.get(E);if(!b)throw new Error(`Unknown handler with id: ${E}`);return b.saveProfile(T,S,l)}async $readProfile(E,T,S){const l=this.b.get(E);if(!l)throw new Error(`Unknown handler with id: ${E}`);return l.readProfile((0,O.$$f)(T)?T:M.URI.revive(T),S)}}e.$Enc=w}),define(Se[83],Ie([1,0,4,5,3]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=e.$Qmc=void 0;class N{constructor(w){this.b=new O.$fe,this.onDidChangePassword=this.b.event,this.a=w.getProxy(C.$iM.MainThreadSecretState)}async $onDidChangePassword(w){this.b.fire(w)}get(w,m){return this.a.$getPassword(w,m)}store(w,m,E){return this.a.$setPassword(w,m,E)}delete(w,m){return this.a.$deletePassword(w,m)}}e.$Qmc=N,e.$Rmc=(0,M.$yi)("IExtHostSecretState")}),define(Se[251],Ie([1,0,20,6,4]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lnc=void 0;class N{static{this.a=1}constructor(w){this.c=new Map,this.d=new Map,this.f=new Map,this.b=w.getProxy(M.$iM.MainThreadSpeech)}async $createSpeechToTextSession(w,m,E){const T=this.c.get(w);if(!T)return;const S=new O.$Tc,l=new C.$qe;this.d.set(m,l);const b=await T.provideSpeechToTextSession(l.token,E?{language:E}:void 0);b&&(S.add(b.onDidChange(g=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(m,g)})),S.add(l.token.onCancellationRequested(()=>S.dispose())))}async $cancelSpeechToTextSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}async $createTextToSpeechSession(w,m,E){const T=this.c.get(w);if(!T)return;const S=new O.$Tc,l=new C.$qe;this.d.set(m,l);const b=await T.provideTextToSpeechSession(l.token,E?{language:E}:void 0);b&&(this.f.set(m,b),S.add(b.onDidChange(g=>{l.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(m,g)})),S.add(l.token.onCancellationRequested(()=>S.dispose())))}async $synthesizeSpeech(w,m){this.f.get(w)?.synthesize(m)}async $cancelTextToSpeechSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w),this.f.delete(w)}async $createKeywordRecognitionSession(w,m){const E=this.c.get(w);if(!E)return;const T=new O.$Tc,S=new C.$qe;this.d.set(m,S);const l=await E.provideKeywordRecognitionSession(S.token);l&&(T.add(l.onDidChange(b=>{S.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(m,b)})),T.add(S.token.onCancellationRequested(()=>T.dispose())))}async $cancelKeywordRecognitionSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}registerProvider(w,m,E){const T=N.a++;return this.c.set(T,E),this.b.$registerProvider(T,m,{extension:w,displayName:w.value}),(0,O.$Sc)(()=>{this.b.$unregisterProvider(T),this.c.delete(T)})}}e.$Lnc=N}),define(Se[84],Ie([1,0,4,5,3]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=e.$Gmc=void 0;class N{constructor(w,m){this.c=m,this.b=new O.$fe,this.onDidChangeStorage=this.b.event,this.a=w.getProxy(C.$iM.MainThreadStorage)}registerExtensionStorageKeysToSync(w,m){this.a.$registerExtensionStorageKeysToSync(w,m)}async initializeExtensionStorage(w,m,E){const T=await this.a.$initializeExtensionStorage(w,m);let S;return T&&(S=this.d(w,m,T)),S||E}setValue(w,m,E){return this.a.$setValue(w,m,E)}$acceptValue(w,m,E){const T=this.d(w,m,E);T&&this.b.fire({shared:w,key:m,value:T})}d(w,m,E){try{return JSON.parse(E)}catch(T){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${w}): ${T}`)}}}e.$Gmc=N,e.$Hmc=(0,M.$yi)("IExtHostStorage")}),define(Se[252],Ie([1,0,6,16,2,4]),function(le,e,C,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2nc=void 0;class R{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor(m){this.c=new Map,this.b=m.getProxy(N.$iM.MainThreadUriOpeners)}registerExternalUriOpener(m,E,T,S){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const l=S.schemes.find(b=>!R.a.has(b));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(E,T),this.b.$registerUriOpener(E,S.schemes,m,S.label),(0,C.$Sc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(m,E,T){const S=this.c.get(m);if(!S)throw new Error(`Unknown opener with id: ${m}`);const l=M.URI.revive(E);return S.canOpenExternalUri(l,T)}async $openUri(m,E,T){const S=this.c.get(m);if(!S)throw new Error(`Unknown opener id: '${m}'`);return S.openExternalUri(M.URI.revive(E.resolvedUri),{sourceUri:M.URI.revive(E.sourceUri)},T)}}e.$2nc=R}),define(Se[253],Ie([1,0,4,2,6,14,21]),function(le,e,C,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=void 0;class w{static{this.a=0}constructor(E){this.c=new R.$Um,this.d=new Map,this.b=E.getProxy(C.$iM.MainThreadUrls)}registerUriHandler(E,T){const S=E.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const l=w.a++;return this.c.add(S),this.d.set(l,T),this.b.$registerUriHandler(l,S,E.displayName||E.name),(0,M.$Sc)(()=>{this.c.delete(S),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(E,T){const S=this.d.get(E);if(!S)return Promise.resolve(void 0);try{S.handleUri(O.URI.revive(T))}catch(l){(0,N.$1)(l)}return Promise.resolve(void 0)}async createAppUri(E){return O.URI.revive(await this.b.$createAppUri(E))}}e.$3nc=w}),define(Se[64],Ie([1,0,5,6,16,26,2,197,221,78,4]),function(le,e,C,O,M,N,R,w,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tmc=e.$rmc=void 0,e.$smc=l,e.$umc=r,e.$vmc=s;class S{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,u,t,f,a,d,$){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new C.$fe,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new C.$fe,this._onDidDispose=this.#h.event,this.#e=c,this.#t=u,this.#o=t,this.#n=f,this.#s=a,this.#r=d,this.#l=l(d),this.#d=b(d),this.#i=$}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,E.$_Ab)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===M.Schemas.https||c.scheme===M.Schemas.http){let u=c.toString();return u.endsWith("/")||(u+="/"),u+" "+E.$$Ab}return E.$$Ab}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),N.$9n(this.#o,c)||this.#t.$setOptions(this.#e,s(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const u=(0,m.$9rb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,u.message,...u.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const u=this.#r.extensionLocation?.scheme===M.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===M.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,a,d,$,p,v)=>{const y=R.URI.from({scheme:$||"file",path:decodeURIComponent(p)}),h=(0,E.$_Ab)(y,{isRemote:u,authority:t}).toString();return`${a}${h}${v}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,a,d,$,p,v)=>{const y=R.URI.from({scheme:$||"file",path:decodeURIComponent(p)}),h=(0,E.$_Ab)(y,{isRemote:u,authority:t}).toString();return`${a}${h}${v}`})}}e.$rmc=S;function l(n){try{const c=(0,w.$Lp)((0,w.$Kp)(n.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function b(n){try{const c=(0,w.$Lp)((0,w.$Kp)(n.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class g extends O.$Uc{constructor(c,u,t,f,a){super(),this.c=u,this.f=t,this.g=f,this.h=a,this.b=new Map,this.a=c.getProxy(T.$iM.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,u,t){const f=this.j(c);if(f){const{message:a}=(0,m.$0rb)(u,t.value);f._onMessageEmitter.fire(a)}}$onMissingCsp(c,u){this.g.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,u,t){const f=new S(c,this.a,o(u),this.c,this.f,t,this.h);this.b.set(c,f);const a=f._onDidDispose(()=>{a.dispose(),this.deleteWebview(c)});return f}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$tmc=g;function r(n){return{id:n.identifier,location:n.extensionLocation}}function s(n,c,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||i(n,c)}}function o(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(c=>R.URI.from(c))}}function i(n,c){return[...(c?.getWorkspaceFolders()||[]).map(u=>u.uri),n.extensionLocation]}}),define(Se[111],Ie([1,0,5,16,13,2,3,17,4]),function(le,e,C,O,M,N,R,w,m){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=e.$5nc=void 0;let T=class{static{E=this}static{this.a={focused:!0,active:!0}}getState(){const l=this.d;return{get focused(){return l.focused},get active(){return l.active}}}constructor(l){this.c=new C.$fe,this.onDidChangeWindowState=this.c.event,this.d=E.a,this.b=l.getProxy(m.$iM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:b,isActive:g})=>{this.onDidChangeWindowProperty("focused",b),this.onDidChangeWindowProperty("active",g)})}$onDidChangeWindowFocus(l){this.onDidChangeWindowProperty("focused",l)}$onDidChangeWindowActive(l){this.onDidChangeWindowProperty("active",l)}onDidChangeWindowProperty(l,b){b!==this.d[l]&&(this.d={...this.d,[l]:b},this.c.fire(this.d))}openUri(l,b){let g;if(typeof l=="string"){g=l;try{l=N.URI.parse(l)}catch{return Promise.reject(`Invalid uri - '${l}'`)}}return(0,M.$9e)(l.scheme)?Promise.reject("Invalid scheme - cannot be empty"):l.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${l.scheme}'`):this.b.$openUri(l,g,b)}async asExternalUri(l,b){if((0,M.$9e)(l.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this.b.$asExternalUri(l,b);return N.URI.from(g)}};e.$5nc=T,e.$5nc=T=E=Je([We(0,w.$MO)],T),e.$6nc=(0,R.$yi)("IExtHostWindow")}),define(Se[254],Ie([1,0,244,27,17]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eqc=void 0;let N=class extends C.$9nc{constructor(w,m){super(w,m)}f(w,m,E){m.apply(console,E)}};e.$eqc=N,e.$eqc=N=Je([We(0,M.$MO),We(1,O.$3O)],N)}),define(Se[255],Ie([1,0,11,22,20,14,5,6,150,242,34]),function(le,e,C,O,M,N,R,w,m,E,T){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dac=e.ResponsiveState=e.RequestInitiator=void 0,e.$Bac=s,e.$Cac=o;function l(k,I){try{return JSON.stringify(k,I)}catch{return"null"}}const b="$$ref$$",g={[b]:-1};class r{constructor(I,P){this.jsonString=I,this.referencedBuffers=P}}function s(k,I=null,P=!1){const V=[];return{jsonString:(P?l:JSON.stringify)(k,(q,A)=>{if(typeof A>"u")return g;if(typeof A=="object"){if(A instanceof O.$He){const z=V.push(A)-1;return{[b]:z}}if(I)return I(q,A)}return A}),referencedBuffers:V}}function o(k,I,P){return JSON.parse(k,(V,W)=>{if(W){const q=W[b];if(typeof q=="number")return I[q];if(P&&W.$mid===1)return P.transformIncoming(W)}return W})}function i(k,I){return JSON.stringify(k,I)}function n(k){return k?(I,P)=>P&&P.$mid===1?k.transformOutgoing(P):P:null}var c;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var u;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const t=()=>{},f=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class d extends w.$Uc{static{S=f}static{this.a=3*1e3}constructor(I,P=null,V=null){super(),this[S]=!0,this.b=this.B(new R.$fe),this.onDidChangeResponsiveState=this.b.event,this.c=I,this.f=P,this.g=V,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,q=T.$Bw.count;W<q;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new C.$Kh(()=>this.H(),1e3)),this.c.onMessage(W=>this.L(W))}dispose(){this.j=!0,Object.keys(this.w).forEach(I=>{const P=this.w[I];delete this.w[I],P.resolveErr(N.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(I){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(I){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(I){this.y!==I&&(this.y=I,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(I){return this.g?(0,m.$Dn)(I,this.g):I}getProxy(I){const{nid:P,sid:V}=I;return this.s[P]||(this.s[P]=this.J(P,V)),this.s[P]}J(I,P){const V={get:(W,q)=>(typeof q=="string"&&!W[q]&&q.charCodeAt(0)===36&&(W[q]=(...A)=>this.U(I,q,A)),q===a?P:W[q])};return new Proxy(Object.create(null),V)}set(I,P){return this.m[I.nid]=P,P}assertRegistered(I){for(let P=0,V=I.length;P<V;P++){const W=I[P];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(I){if(this.j)return;const P=I.byteLength,V=p.read(I,0),W=V.readUInt8(),q=V.readUInt32();switch(W){case 1:case 2:{let{rpcId:A,method:z,args:G}=y.deserializeRequestJSONArgs(V);this.g&&(G=(0,m.$Dn)(G,this.g)),this.M(P,q,A,z,G,W===2);break}case 3:case 4:{let{rpcId:A,method:z,args:G}=y.deserializeRequestMixedArgs(V);this.g&&(G=(0,m.$Dn)(G,this.g)),this.M(P,q,A,z,G,W===4);break}case 5:{this.f?.logIncoming(P,q,0,"ack"),this.G(q);break}case 6:{this.N(P,q);break}case 7:{this.O(P,q,void 0);break}case 9:{let A=y.deserializeReplyOKJSON(V);this.g&&(A=(0,m.$Dn)(A,this.g)),this.O(P,q,A);break}case 10:{const A=y.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(P,q,A);break}case 8:{const A=y.deserializeReplyOKVSBuffer(V);this.O(P,q,A);break}case 11:{let A=y.deserializeReplyErrError(V);this.g&&(A=(0,m.$Dn)(A,this.g)),this.P(P,q,A);break}case 12:{this.P(P,q,void 0);break}default:console.error("received unexpected message"),console.error(I)}}M(I,P,V,W,q,A){this.f?.logIncoming(I,P,1,`receiveRequest ${(0,T.$Dw)(V)}.${W}(`,q);const z=String(P);let G,ie;if(A){const ye=new M.$qe;q.push(ye.token),G=this.Q(V,W,q),ie=()=>ye.cancel()}else G=this.Q(V,W,q),ie=t;this.u[z]=ie;const de=y.serializeAcknowledged(P);this.f?.logOutgoing(de.byteLength,P,1,"ack"),this.c.send(de),G.then(ye=>{delete this.u[z];const Ee=y.serializeReplyOK(P,ye,this.h);this.f?.logOutgoing(Ee.byteLength,P,1,"reply:",ye),this.c.send(Ee)},ye=>{delete this.u[z];const Ee=y.serializeReplyErr(P,ye);this.f?.logOutgoing(Ee.byteLength,P,1,"replyErr:",ye),this.c.send(Ee)})}N(I,P){this.f?.logIncoming(I,P,1,"receiveCancel");const V=String(P);this.u[V]?.()}O(I,P,V){this.f?.logIncoming(I,P,0,"receiveReply:",V);const W=String(P);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W],q.resolveOk(V)}P(I,P,V){this.f?.logIncoming(I,P,0,"receiveReplyErr:",V);const W=String(P);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W];let A;V&&(V.$isError?(A=new Error,A.name=V.name,A.message=V.message,A.stack=V.stack):A=V),q.resolveErr(A)}Q(I,P,V){try{return Promise.resolve(this.S(I,P,V))}catch(W){return Promise.reject(W)}}S(I,P,V){const W=this.m[I];if(!W)throw new Error("Unknown actor "+(0,T.$Dw)(I));const q=W[P];if(typeof q!="function")throw new Error("Unknown method "+P+" on actor "+(0,T.$Dw)(I));return q.apply(W,V)}U(I,P,V){if(this.j)return new E.$Aac;let W=null;if(V.length>0&&M.CancellationToken.isCancellationToken(V[V.length-1])&&(W=V.pop()),W&&W.isCancellationRequested)return Promise.reject(N.$6());const q=y.serializeRequestArguments(V,this.h),A=++this.t,z=String(A),G=new E.$zac,ie=new w.$Tc;W&&ie.add(W.onCancellationRequested(()=>{const ye=y.serializeCancel(A);this.f?.logOutgoing(ye.byteLength,A,0,"cancel"),this.c.send(y.serializeCancel(A))})),this.w[z]=new $(G,ie),this.F(A);const de=y.serializeRequest(A,I,P,q,!!W);return this.f?.logOutgoing(de.byteLength,A,0,`request: ${(0,T.$Dw)(I)}.${P}(`,V),this.c.send(de),G}}e.$Dac=d;class ${constructor(I,P){this.a=I,this.b=P}resolveOk(I){this.a.resolveOk(I),this.b.dispose()}resolveErr(I){this.a.resolveErr(I),this.b.dispose()}}class p{static alloc(I,P,V){const W=new p(O.$He.alloc(V+1+4),0);return W.writeUInt8(I),W.writeUInt32(P),W}static read(I,P){return new p(I,P)}get buffer(){return this.a}constructor(I,P){this.a=I,this.b=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(I){this.a.writeUInt8(I,this.b),this.b+=1}readUInt8(){const I=this.a.readUInt8(this.b);return this.b+=1,I}writeUInt32(I){this.a.writeUInt32BE(I,this.b),this.b+=4}readUInt32(){const I=this.a.readUInt32BE(this.b);return this.b+=4,I}static sizeShortString(I){return 1+I.byteLength}writeShortString(I){this.a.writeUInt8(I.byteLength,this.b),this.b+=1,this.a.set(I,this.b),this.b+=I.byteLength}readShortString(){const I=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+I).toString();return this.b+=I,V}static sizeLongString(I){return 4+I.byteLength}writeLongString(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readLongString(){const I=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+I).toString();return this.b+=I,V}writeBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}static sizeVSBuffer(I){return 4+I.byteLength}writeVSBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readVSBuffer(){const I=this.a.readUInt32BE(this.b);this.b+=4;const P=this.a.slice(this.b,this.b+I);return this.b+=I,P}static sizeMixedArray(I){let P=0;P+=1;for(let V=0,W=I.length;V<W;V++){const q=I[V];switch(P+=1,q.type){case 1:P+=this.sizeLongString(q.value);break;case 2:P+=this.sizeVSBuffer(q.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(q.value);for(let A=0;A<q.buffers.length;++A)P+=this.sizeVSBuffer(q.buffers[A]);break;case 4:break}}return P}writeMixedArray(I){this.a.writeUInt8(I.length,this.b),this.b+=1;for(let P=0,V=I.length;P<V;P++){const W=I[P];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let q=0;q<W.buffers.length;++q)this.writeBuffer(W.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const I=this.a.readUInt8(this.b);this.b+=1;const P=new Array(I);for(let V=0;V<I;V++)switch(this.readUInt8()){case 1:P[V]=this.readLongString();break;case 2:P[V]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),A=this.readLongString(),z=[];for(let G=0;G<q;++G)z.push(this.readVSBuffer());P[V]=new T.$Ew(o(A,z,null));break}case 4:P[V]=void 0;break}return P}}var v;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(v||(v={}));class y{static a(I){for(let P=0,V=I.length;P<V;P++)if(I[P]instanceof O.$He||I[P]instanceof T.$Ew||typeof I[P]>"u")return!0;return!1}static serializeRequestArguments(I,P){if(this.a(I)){const V=[];for(let W=0,q=I.length;W<q;W++){const A=I[W];if(A instanceof O.$He)V[W]={type:2,value:A};else if(typeof A>"u")V[W]={type:4};else if(A instanceof T.$Ew){const{jsonString:z,referencedBuffers:G}=s(A.value,P);V[W]={type:3,value:O.$He.fromString(z),buffers:G}}else V[W]={type:1,value:O.$He.fromString(i(A,P))}}return{type:1,args:V}}return{type:0,args:i(I,P)}}static serializeRequest(I,P,V,W,q){switch(W.type){case 0:return this.b(I,P,V,W.args,q);case 1:return this.c(I,P,V,W.args,q)}}static b(I,P,V,W,q){const A=O.$He.fromString(V),z=O.$He.fromString(W);let G=0;G+=p.sizeUInt8(),G+=p.sizeShortString(A),G+=p.sizeLongString(z);const ie=p.alloc(q?2:1,I,G);return ie.writeUInt8(P),ie.writeShortString(A),ie.writeLongString(z),ie.buffer}static deserializeRequestJSONArgs(I){const P=I.readUInt8(),V=I.readShortString(),W=I.readLongString();return{rpcId:P,method:V,args:JSON.parse(W)}}static c(I,P,V,W,q){const A=O.$He.fromString(V);let z=0;z+=p.sizeUInt8(),z+=p.sizeShortString(A),z+=p.sizeMixedArray(W);const G=p.alloc(q?4:3,I,z);return G.writeUInt8(P),G.writeShortString(A),G.writeMixedArray(W),G.buffer}static deserializeRequestMixedArgs(I){const P=I.readUInt8(),V=I.readShortString(),W=I.readMixedArray(),q=new Array(W.length);for(let A=0,z=W.length;A<z;A++){const G=W[A];typeof G=="string"?q[A]=JSON.parse(G):q[A]=G}return{rpcId:P,method:V,args:q}}static serializeAcknowledged(I){return p.alloc(5,I,0).buffer}static serializeCancel(I){return p.alloc(6,I,0).buffer}static serializeReplyOK(I,P,V){if(typeof P>"u")return this.d(I);if(P instanceof O.$He)return this.e(I,P);if(P instanceof T.$Ew){const{jsonString:W,referencedBuffers:q}=s(P.value,V,!0);return this.g(I,W,q)}else return this.f(I,l(P,V))}static d(I){return p.alloc(7,I,0).buffer}static e(I,P){let V=0;V+=p.sizeVSBuffer(P);const W=p.alloc(8,I,V);return W.writeVSBuffer(P),W.buffer}static deserializeReplyOKVSBuffer(I){return I.readVSBuffer()}static f(I,P){const V=O.$He.fromString(P);let W=0;W+=p.sizeLongString(V);const q=p.alloc(9,I,W);return q.writeLongString(V),q.buffer}static g(I,P,V){const W=O.$He.fromString(P);let q=0;q+=p.sizeUInt32,q+=p.sizeLongString(W);for(const z of V)q+=p.sizeVSBuffer(z);const A=p.alloc(10,I,q);A.writeUInt32(V.length),A.writeLongString(W);for(const z of V)A.writeBuffer(z);return A.buffer}static deserializeReplyOKJSON(I){const P=I.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(I,P){const V=I.readUInt32(),W=I.readLongString(),q=[];for(let A=0;A<V;++A)q.push(I.readVSBuffer());return new T.$Ew(o(W,q,P))}static serializeReplyErr(I,P){const V=P?l(N.$3(P),null):void 0;if(typeof V!="string")return this.h(I);const W=O.$He.fromString(V);let q=0;q+=p.sizeLongString(W);const A=p.alloc(11,I,q);return A.writeLongString(W),A.buffer}static deserializeReplyErrError(I){const P=I.readLongString();return JSON.parse(P)}static h(I){return p.alloc(12,I,0).buffer}}var h;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var D;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(D||(D={}))}),define(Se[256],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gqc=void 0;const C=function(N){const R=w=>{globalThis.removeEventListener("message",R);const m=w.data;Object.defineProperties(globalThis,{postMessage:{value(E,T){m.postMessage(E,T)}},onmessage:{get(){return m.onmessage},set(E){m.onmessage=E}}}),m.addEventListener("message",E=>{globalThis.dispatchEvent(new MessageEvent("message",{data:E.data,ports:E.ports?[...E.ports]:void 0}))}),m.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",R)}.toString();class O extends EventTarget{constructor(N,R,w){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const m=`((${C})('${R}'))`,E=new Blob([m],{type:"application/javascript"}),T=URL.createObjectURL(E),S=new MessageChannel,l=T,b={type:"_newWorker",id:l,port:S.port2,url:T,options:w};N(b,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{N({type:"_terminateWorker",id:l}),URL.revokeObjectURL(T),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(g){S.port1.onmessage=g}},onmessageerror:{get(){return S.port1.onmessageerror},set(g){S.port1.onmessageerror=g}}}),S.port1.addEventListener("messageerror",g=>{const r=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(r)}),S.port1.addEventListener("message",g=>{const r=new MessageEvent("message",{data:g.data});this.dispatchEvent(r)}),S.port1.start()}}e.$gqc=O}),define(Se[257],Ie([1,0,22,28,16,56,3]),function(le,e,C,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YJ=e.$VJ=void 0,e.$WJ=T,e.$XJ=S,e.$VJ=(0,R.$yi)("notebookDocumentService");const w=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${w.join("")}]+`),E=7;function T(b){if(b.scheme!==M.Schemas.vscodeNotebookCell)return;const g=b.fragment.indexOf("s");if(g<0)return;const r=parseInt(b.fragment.substring(0,g).replace(m,""),E),s=(0,C.$1e)(b.fragment.substring(g+1)).toString();if(!isNaN(r))return{handle:r,notebook:b.with({scheme:s,fragment:null})}}function S(b,g){const r=g.toString(E),o=`${r.length<w.length?w[r.length-1]:"z"}${r}s${(0,C.$2e)(C.$He.fromString(b.scheme),!0,!0)}`;return b.with({scheme:M.Schemas.vscodeNotebookCell,fragment:o})}class l{constructor(){this.a=new O.$Ac}getNotebook(g){if(g.scheme===M.Schemas.vscodeNotebookCell){const r=T(g);if(r){const s=this.a.get(r.notebook);if(s)return s}}return this.a.get(g)}addNotebookDocument(g){this.a.set(g.uri,g)}removeNotebookDocument(g){this.a.delete(g.uri)}}e.$YJ=l,(0,N.$As)(e.$VJ,l,1)}),define(Se[85],Ie([1,0,22,37,42,70,16,19,23,31,257]),function(le,e,C,O,M,N,R,w,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gK=e.$dK=e.CellStatusbarAlignment=e.$cK=e.NotebookEditorPriority=e.$_J=e.$$J=e.$9J=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$8J=e.$7J=e.$6J=e.$5J=e.CellKind=e.$4J=e.$3J=e.$2J=void 0,e.$0J=f,e.$aK=d,e.$bK=$,e.$eK=y,e.$fK=D,e.$2J="workbench.editor.notebook",e.$3J="workbench.editor.notebookTextDiffEditor",e.$4J="workbench.editor.interactive";var S;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(S||(e.CellKind=S={})),e.$5J=["application/json","application/javascript","text/html","image/svg+xml",N.$Ts.latex,N.$Ts.markdown,"image/png","image/jpeg",N.$Ts.text],e.$6J=[N.$Ts.latex,N.$Ts.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",N.$Ts.text],e.$7J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$8J="_notAvailable";var l;(function(G){G[G.Running=1]="Running",G[G.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var b;(function(G){G[G.Unconfirmed=1]="Unconfirmed",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(b||(e.NotebookCellExecutionState=b={}));var g;(function(G){G[G.Unconfirmed=1]="Unconfirmed",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(g||(e.NotebookExecutionState=g={}));var r;(function(G){G[G.WithHardKernelDependency=0]="WithHardKernelDependency",G[G.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",G[G.Pure=2]="Pure",G[G.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var s;(function(G){G.Always="always",G.Never="never",G.Optional="optional"})(s||(e.RendererMessagingSpec=s={}));var o;(function(G){G[G.ModelChange=1]="ModelChange",G[G.Move=2]="Move",G[G.ChangeCellLanguage=5]="ChangeCellLanguage",G[G.Initialize=6]="Initialize",G[G.ChangeCellMetadata=7]="ChangeCellMetadata",G[G.Output=8]="Output",G[G.OutputItem=9]="OutputItem",G[G.ChangeCellContent=10]="ChangeCellContent",G[G.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",G[G.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",G[G.ChangeCellMime=13]="ChangeCellMime",G[G.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var i;(function(G){G[G.Handle=0]="Handle",G[G.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(G){G[G.Replace=1]="Replace",G[G.Output=2]="Output",G[G.Metadata=3]="Metadata",G[G.CellLanguage=4]="CellLanguage",G[G.DocumentMetadata=5]="DocumentMetadata",G[G.Move=6]="Move",G[G.OutputItems=7]="OutputItems",G[G.PartialMetadata=8]="PartialMetadata",G[G.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var c;(function(G){G.scheme=R.Schemas.vscodeNotebookCell;function ie(Ce,se){return(0,T.$XJ)(Ce,se)}G.generate=ie;function de(Ce){return(0,T.$WJ)(Ce)}G.parse=de;function ye(Ce,se){return Ce.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${se??""},${Ce.scheme!==R.Schemas.file?Ce.scheme:""}`})}G.generateCellOutputUri=ye;function Ee(Ce){if(Ce.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const se=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Ce.fragment);if(!se)return;const Oe=se[1]&&se[1]!==""?se[1]:void 0,ne=se[2];return{outputId:Oe,notebook:Ce.with({scheme:ne||R.Schemas.file,fragment:null})}}G.parseCellOutputUri=Ee;function ge(Ce,se,Oe){return G.generate(Ce,se).with({scheme:Oe})}G.generateCellPropertyUri=ge;function ue(Ce,se){if(Ce.scheme===se)return G.parse(Ce.with({scheme:G.scheme}))}G.parseCellPropertyUri=ue})(c||(e.CellUri=c={}));const u=G=>m.$i?G.replace(/\//g,"\\"):G;class t{constructor(ie=[],de=e.$5J){this.e=de,this.d=[...new Set(ie)].map(ye=>({pattern:ye,matches:O.$sk(u(ye))}))}sort(ie){const de=new Map(M.Iterable.map(ie,Ee=>[Ee,u(Ee)]));let ye=[];for(const{matches:Ee}of this.d)for(const[ge,ue]of de)if(Ee(ue)){ye.push(ge),de.delete(ge);break}return de.size&&(ye=ye.concat([...de.keys()].sort((Ee,ge)=>this.e.indexOf(Ee)-this.e.indexOf(ge)))),ye}prioritize(ie,de){const ye=this.f(ie);if(ye===-1){this.d.unshift({pattern:ie,matches:O.$sk(u(ie))});return}const Ee=new Set(de.map(ue=>this.f(ue,ye)));Ee.delete(-1);const ge=Array.from(Ee).sort();this.d.splice(ye+1,0,...ge.map(ue=>this.d[ue]));for(let ue=ge.length-1;ue>=0;ue--)this.d.splice(ge[ue],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,de=this.d.length){const ye=u(ie);for(let Ee=0;Ee<de;Ee++)if(this.d[Ee].matches(ye))return Ee;return-1}}e.$9J=t;function f(G,ie,de,ye=(Ee,ge)=>Ee===ge){const Ee=[];function ge(se,Oe,ne){if(Oe===0&&ne.length===0)return;const j=Ee[Ee.length-1];j&&j.start+j.deleteCount===se?(j.deleteCount+=Oe,j.toInsert.push(...ne)):Ee.push({start:se,deleteCount:Oe,toInsert:ne})}let ue=0,Ce=0;for(;;){if(ue===G.length){ge(ue,0,ie.slice(Ce));break}if(Ce===ie.length){ge(ue,G.length-ue,[]);break}const se=G[ue],Oe=ie[Ce];if(ye(se,Oe)){ue+=1,Ce+=1;continue}de(Oe)?(ge(ue,1,[]),ue+=1):(ge(ue,0,[Oe]),Ce+=1)}return Ee}e.$$J=new E.$Pj("notebookEditorCursorAtBoundary","none"),e.$_J=new E.$Pj("notebookEditorCursorAtLineBoundary","none");var a;(function(G){G.default="default",G.option="option"})(a||(e.NotebookEditorPriority=a={}));function d(G){const ie=G;return!!((typeof ie.include=="string"||O.$tk(ie.include))&&(typeof ie.exclude=="string"||O.$tk(ie.exclude)))}function $(G,ie,de){if(Array.isArray(G.viewType)&&G.viewType.indexOf(ie)>=0||G.viewType===ie)return!0;if(G.filenamePattern){const ye=d(G.filenamePattern)?G.filenamePattern.include:G.filenamePattern,Ee=d(G.filenamePattern)?G.filenamePattern.exclude:void 0;if(O.$rk(ye,(0,w.$nc)(de.fsPath).toLowerCase()))return!(Ee&&O.$rk(Ee,(0,w.$nc)(de.fsPath).toLowerCase()))}return!1}e.$cK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var p;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(p||(e.CellStatusbarAlignment=p={}));class v{static{this.d="notebook/"}static create(ie){return`${v.d}${ie}`}static parse(ie){if(ie.startsWith(v.d))return ie.substring(v.d.length)}}e.$dK=v;function y(G){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(G)}const h=new TextDecoder;function D(G){const ie=[];let de=!1;for(const ue of G)(ie.length===0||de)&&(ie.push(ue),de=!0);let ye=P(ie);const Ee=C.$He.concat(ie.map(ue=>C.$He.wrap(ue))),ge=z(Ee);return ye=ye||ge.byteLength!==Ee.byteLength,{data:ge,didCompression:ye}}e.$gK="\x1B[A";const k=e.$gK.split("").map(G=>G.charCodeAt(0)),I=10;function P(G){let ie=!1;return G.forEach((de,ye)=>{if(ye===0||de.length<e.$gK.length)return;const Ee=G[ye-1],ge=de.subarray(0,e.$gK.length);if(ge[0]===k[0]&&ge[1]===k[1]&&ge[2]===k[2]){const ue=Ee.lastIndexOf(I);if(ue===-1)return;ie=!0,G[ye-1]=Ee.subarray(0,ue),G[ye]=de.subarray(e.$gK.length)}}),ie}function V(G){let ie=G;do G=ie,ie=G.replace(/[^\n]\x08/gm,"");while(ie.length<G.length);return G}function W(G){for(G=G.replace(/\r+\n/gm,`
`);G.search(/\r[^$]/g)>-1;){const ie=G.match(/^(.*)\r+/m)[1];let de=G.match(/\r+(.*)$/m)[1];de=de+ie.slice(de.length,ie.length),G=G.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,de)}return G}const q=8,A=13;function z(G){return!G.buffer.includes(q)&&!G.buffer.includes(A)?G:C.$He.fromString(W(V(h.decode(G.buffer))))}}),define(Se[7],Ie([1,0,18,14,55,28,70,13,15,2,33,21,38,104,85]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g){"use strict";var r,s,o,i,n,c,u,t,f,a,d,$,p,v,y,h,D;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$AO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.LanguageModelChatMessageRole=e.ChatLocation=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$gO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$6N=e.$5N=e.$4N=e.$3N=e.$1N=e.$ZN=e.$YN=e.$XN=e.TestRunProfileKind=e.TestResultState=e.$WN=e.$VN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$UN=e.NotebookVariablesRequestKind=e.$TN=e.$SN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$RN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$QN=e.$PN=e.$ON=e.$NN=e.$MN=e.ColorThemeKind=e.$LN=e.$KN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$JN=e.$IN=e.DebugConsoleMode=e.$HN=e.$GN=e.$FN=e.$EN=e.$DN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$CN=e.$BN=e.FileChangeType=e.$AN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$zN=e.$yN=e.$xN=e.$wN=e.InlineCompletionTriggerKind=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$jN=e.ConfigurationTarget=e.$iN=e.$hN=e.$gN=e.$fN=e.DocumentPasteTriggerKind=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$$M=e.ViewBadge=e.ProgressLocation=e.$0M=e.$9M=e.TaskScope=e.ShellQuoting=e.$8M=e.$7M=e.$6M=e.TaskPanelKind=e.TaskRevealKind=e.$5M=e.TerminalLocation=e.$4M=e.$3M=e.$2M=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$1M=e.$ZM=e.$YM=e.$XM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$VM=e.$UM=e.$TM=e.$SM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$RM=e.$QM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=e.LanguageStatusSeverity=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.CodeActionTriggerKind=e.$EM=e.$DM=e.SymbolTag=e.SymbolKind=e.$CM=e.$BM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.DiagnosticSeverity=e.DiagnosticTag=e.$vM=e.$uM=e.FileEditType=e.$tM=e.$sM=e.$rM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$WM=Vt,e.$kN=Me,e.$2N=vn;function k(U){return Object.assign(U,{apply:function(...te){if(te.length===0)return Reflect.construct(U,[]);{const De=te.length===1?[]:te[1];return Reflect.construct(U,De,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(U,[]);{const[De,...Ge]=te;return Reflect.construct(U,Ge,De.constructor)}}})}var I;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(I||(e.TerminalOutputAnchor=I={}));var P;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(P||(e.TerminalQuickFixType=P={}));let V=r=class{static from(...F){let te=F;return new r(function(){if(te){for(const De of te)De&&typeof De.dispose=="function"&&De.dispose();te=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$kM=V,e.$kM=V=r=Je([k],V);let W=s=class{static Min(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let De=1;De<F.length;De++){const Ge=F[De];Ge.isBefore(te)&&(te=Ge)}return te}static Max(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let De=1;De<F.length;De++){const Ge=F[De];Ge.isAfter(te)&&(te=Ge)}return te}static isPosition(F){if(!F)return!1;if(F instanceof s)return!0;const{line:te,character:De}=F;return typeof te=="number"&&typeof De=="number"}static of(F){if(F instanceof s)return F;if(this.isPosition(F))return new s(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,te){if(F<0)throw(0,O.$7)("line must be non-negative");if(te<0)throw(0,O.$7)("character must be non-negative");this.c=F,this.e=te}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,te=0){if(F===null||te===null)throw(0,O.$7)();let De;return typeof F>"u"?De=0:typeof F=="number"?De=F:(De=typeof F.lineDelta=="number"?F.lineDelta:0,te=typeof F.characterDelta=="number"?F.characterDelta:0),De===0&&te===0?this:new s(this.line+De,this.character+te)}with(F,te=this.character){if(F===null||te===null)throw(0,O.$7)();let De;return typeof F>"u"?De=this.line:typeof F=="number"?De=F:(De=typeof F.line=="number"?F.line:this.line,te=typeof F.character=="number"?F.character:this.character),De===this.line&&te===this.character?this:new s(De,te)}toJSON(){return{line:this.line,character:this.character}}};e.$lM=W,e.$lM=W=s=Je([k],W);let q=o=class{static isRange(F){return F instanceof o?!0:F?W.isPosition(F.start)&&W.isPosition(F.end):!1}static of(F){if(F instanceof o)return F;if(this.isRange(F))return new o(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,te,De,Ge){let Ye,lt;if(typeof F=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ge=="number"?(Ye=new W(F,te),lt=new W(De,Ge)):W.isPosition(F)&&W.isPosition(te)&&(Ye=W.of(F),lt=W.of(te)),!Ye||!lt)throw new Error("Invalid arguments");Ye.isBefore(lt)?(this.c=Ye,this.e=lt):(this.c=lt,this.e=Ye)}contains(F){return o.isRange(F)?this.contains(F.start)&&this.contains(F.end):W.isPosition(F)?!(W.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const te=W.Max(F.start,this.c),De=W.Min(F.end,this.e);if(!te.isAfter(De))return new o(te,De)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const te=W.Min(F.start,this.c),De=W.Max(F.end,this.end);return new o(te,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,te=this.end){if(F===null||te===null)throw(0,O.$7)();let De;return F?W.isPosition(F)?De=F:(De=F.start||this.start,te=F.end||this.end):De=this.start,De.isEqual(this.c)&&te.isEqual(this.end)?this:new o(De,te)}toJSON(){return[this.start,this.end]}};e.$mM=q,e.$mM=q=o=Je([k],q);let A=i=class extends q{static isSelection(F){return F instanceof i?!0:F?q.isRange(F)&&W.isPosition(F.anchor)&&W.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,te,De,Ge){let Ye,lt;if(typeof F=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ge=="number"?(Ye=new W(F,te),lt=new W(De,Ge)):W.isPosition(F)&&W.isPosition(te)&&(Ye=W.of(F),lt=W.of(te)),!Ye||!lt)throw new Error("Invalid arguments");super(Ye,lt),this.f=Ye,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$nM=A,e.$nM=A=i=Je([k],A);const z=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,O.$7)("connectionToken")};class G{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te,De){if(typeof F!="string"||F.length===0)throw(0,O.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,O.$7)("port");typeof De<"u"&&z(De),this.host=F,this.port=Math.round(te),this.connectionToken=De}}e.$oM=G;class ie{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te){this.makeConnection=F,this.connectionToken=te,typeof te<"u"&&z(te)}}e.$pM=ie;class de extends Error{static NotAvailable(F,te){return new de(F,b.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(F){return new de(F,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,te=b.RemoteAuthorityResolverErrorCode.Unknown,De){super(F),this._message=F,this._code=te,this._detail=De,Object.setPrototypeOf(this,de.prototype)}}e.$qM=de;var ye;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(ye||(e.EndOfLine=ye={}));var Ee;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(Ee||(e.EnvironmentVariableMutatorType=Ee={}));let ge=n=class{static isTextEdit(F){return F instanceof n?!0:F?q.isRange(F)&&typeof F.newText=="string":!1}static replace(F,te){return new n(F,te)}static insert(F,te){return n.replace(new q(F,F),te)}static delete(F){return n.replace(F,"")}static setEndOfLine(F){const te=new n(new q(new W(0,0),new W(0,0)),"");return te.newEol=F,te}get range(){return this.c}set range(F){if(F&&!q.isRange(F))throw(0,O.$7)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,O.$7)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,O.$7)("newEol");this.f=F}constructor(F,te){this.c=F,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$rM=ge,e.$rM=ge=n=Je([k],ge);let ue=c=class{static isNotebookCellEdit(F){return F instanceof c?!0:F?gi.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,te){return new c(F,te)}static insertCells(F,te){return new c(new gi(F,F),te)}static deleteCells(F){return new c(F,[])}static updateCellMetadata(F,te){const De=new c(new gi(F,F),[]);return De.newCellMetadata=te,De}static updateNotebookMetadata(F){const te=new c(new gi(0,0),[]);return te.newNotebookMetadata=F,te}constructor(F,te){this.range=F,this.newCells=te}};e.$sM=ue,e.$sM=ue=c=Je([k],ue);class Ce{static isSnippetTextEdit(F){return F instanceof Ce?!0:F?q.isRange(F.range)&&ne.isSnippetString(F.snippet):!1}static replace(F,te){return new Ce(F,te)}static insert(F,te){return Ce.replace(new q(F,F),te)}constructor(F,te){this.range=F,this.snippet=te}}e.$tM=Ce;var se;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(se||(e.FileEditType=se={}));let Oe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,te,De,Ge){this.c.push({_type:1,from:F,to:te,options:De,metadata:Ge})}createFile(F,te,De){this.c.push({_type:1,from:void 0,to:F,options:te,metadata:De})}deleteFile(F,te,De){this.c.push({_type:1,from:F,to:void 0,options:te,metadata:De})}e(F,te,De){this.c.push({_type:3,metadata:De,uri:F,edit:{editType:5,metadata:te},notebookMetadata:te})}f(F,te,De,Ge){const Ye=te.start,lt=te.end;(Ye!==lt||De.length>0)&&this.c.push({_type:5,uri:F,index:Ye,count:lt-Ye,cells:De,metadata:Ge})}g(F,te,De,Ge){this.c.push({_type:3,metadata:Ge,uri:F,edit:{editType:3,index:te,metadata:De}})}replace(F,te,De,Ge){this.c.push({_type:2,uri:F,edit:new ge(te,De),metadata:Ge})}insert(F,te,De,Ge){this.replace(F,new q(te,te),De,Ge)}delete(F,te,De){this.replace(F,te,"",De)}has(F){return this.c.some(te=>te._type===2&&te.uri.toString()===F.toString())}set(F,te){if(te)for(const De of te){if(!De)continue;let Ge,Ye;Array.isArray(De)?(Ge=De[0],Ye=De[1]):Ge=De,ue.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(F,Ge.range.start,Ge.newCellMetadata,Ye):Ge.newNotebookMetadata?this.e(F,Ge.newNotebookMetadata,Ye):this.f(F,Ge.range,Ge.newCells,Ye):Ce.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:F,range:Ge.range,edit:Ge.snippet,metadata:Ye}):this.c.push({_type:2,uri:F,edit:Ge,metadata:Ye})}else{for(let De=0;De<this.c.length;De++){const Ge=this.c[De];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===F.toString()&&(this.c[De]=void 0);break}}(0,C.$Ib)(this.c)}}get(F){const te=[];for(const De of this.c)De._type===2&&De.uri.toString()===F.toString()&&te.push(De.edit);return te}entries(){const F=new N.$Ac;for(const te of this.c)if(te._type===2){let De=F.get(te.uri);De||(De=[te.uri,[]],F.set(te.uri,De)),De[1].push(te.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$uM=Oe,e.$uM=Oe=Je([k],Oe);let ne=u=class{static isSnippetString(F){return F instanceof u?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=u.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,te=this.e++){if(typeof F=="function"){const De=new u;De.e=this.e,F(De),this.e=De.e,F=De.value}else F=u.c(F);return this.value+="${",this.value+=te,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,te=this.e++){const De=F.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(F,te){if(typeof te=="function"){const De=new u;De.e=this.e,te(De),this.e=De.e,te=De.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$vM=ne,e.$vM=ne=u=Je([k],ne);var j;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(j||(e.DiagnosticTag=j={}));var x;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let ve=t=class{static isLocation(F){return F instanceof t?!0:F?q.isRange(F.range)&&E.URI.isUri(F.uri):!1}constructor(F,te){if(this.uri=F,te)if(q.isRange(te))this.range=q.of(te);else if(W.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$wM=ve,e.$wM=ve=t=Je([k],ve);let Fe=class{static is(F){return F?typeof F.message=="string"&&F.location&&q.isRange(F.location.range)&&E.URI.isUri(F.location.uri):!1}constructor(F,te){this.location=F,this.message=te}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.location.range.isEqual(te.location.range)&&F.location.uri.toString()===te.location.uri.toString()}};e.$xM=Fe,e.$xM=Fe=Je([k],Fe);let ke=class{constructor(F,te,De=x.Error){if(!q.isRange(F))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=F,this.message=te,this.severity=De}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.severity===te.severity&&F.code===te.code&&F.severity===te.severity&&F.source===te.source&&F.range.isEqual(te.range)&&(0,C.$ub)(F.tags,te.tags)&&(0,C.$ub)(F.relatedInformation,te.relatedInformation,Fe.isEqual)}};e.$yM=ke,e.$yM=ke=Je([k],ke);let we=class{constructor(F,te){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=te}};e.$zM=we,e.$zM=we=Je([k],we);let me=class extends we{constructor(F,te,De,Ge){super(F,te),this.canIncreaseHover=De,this.canDecreaseHover=Ge}};e.$AM=me,e.$AM=me=Je([k],me);var Q;(function(U){U[U.Increase=0]="Increase",U[U.Decrease=1]="Decrease"})(Q||(e.HoverVerbosityAction=Q={}));var Y;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Y||(e.DocumentHighlightKind=Y={}));let he=class{constructor(F,te=Y.Text){this.range=F,this.kind=te}toJSON(){return{range:this.range,kind:Y[this.kind]}}};e.$BM=he,e.$BM=he=Je([k],he);let ce=class{constructor(F,te){this.uri=F,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$CM=ce,e.$CM=ce=Je([k],ce);var Ne;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Ne||(e.SymbolKind=Ne={}));var fe;(function(U){U[U.Deprecated=1]="Deprecated"})(fe||(e.SymbolTag=fe={}));let Pe=f=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,te,De,Ge,Ye){this.name=F,this.kind=te,this.containerName=Ye,typeof De=="string"&&(this.containerName=De),Ge instanceof ve?this.location=Ge:De instanceof q&&(this.location=new ve(Ge,De)),f.validate(this)}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};e.$DM=Pe,e.$DM=Pe=f=Je([k],Pe);let Ae=a=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(a.validate)}constructor(F,te,De,Ge,Ye){this.name=F,this.detail=te,this.kind=De,this.range=Ge,this.selectionRange=Ye,this.children=[],a.validate(this)}};e.$EM=Ae,e.$EM=Ae=a=Je([k],Ae);var Ue;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(Ue||(e.CodeActionTriggerKind=Ue={}));let B=class{constructor(F,te){this.title=F,this.kind=te}};e.$FM=B,e.$FM=B=Je([k],B);let L=class{static{d=this}static{this.c="."}constructor(F){this.value=F}append(F){return new d(this.value?this.value+d.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+d.c)}};e.$GM=L,e.$GM=L=d=Je([k],L),L.Empty=new L(""),L.QuickFix=L.Empty.append("quickfix"),L.Refactor=L.Empty.append("refactor"),L.RefactorExtract=L.Refactor.append("extract"),L.RefactorInline=L.Refactor.append("inline"),L.RefactorMove=L.Refactor.append("move"),L.RefactorRewrite=L.Refactor.append("rewrite"),L.Source=L.Empty.append("source"),L.SourceOrganizeImports=L.Source.append("organizeImports"),L.SourceFixAll=L.Source.append("fixAll"),L.Notebook=L.Empty.append("notebook");let K=class{constructor(F,te){if(this.range=F,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$HM=K,e.$HM=K=Je([k],K);class H{constructor(F,te,De,Ge,Ye,lt){this.kind=F,this.name=te,this.detail=De,this.uri=Ge,this.range=Ye,this.selectionRange=lt}}e.$IM=H;class ee{constructor(F,te){this.fromRanges=te,this.from=F}}e.$JM=ee;class re{constructor(F,te){this.fromRanges=te,this.to=F}}e.$KM=re;var Te;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Te||(e.LanguageStatusSeverity=Te={}));let Be=class{constructor(F,te){this.range=F,this.command=te}get isResolved(){return!!this.command}};e.$LM=Be,e.$LM=Be=Je([k],Be);let He=$=class{#e;static isMarkdownString(F){return F instanceof $?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,te=!1){this.#e=new M.$Vk(F,{supportThemeIcons:te})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,te){return this.#e.appendCodeblock(te??"",F),this}};e.$MM=He,e.$MM=He=$=Je([k],He);let _e=class{constructor(F,te){this.label=F,this.documentation=te}};e.$NM=_e,e.$NM=_e=Je([k],_e);let xe=class{constructor(F,te){this.label=F,this.documentation=te,this.parameters=[]}};e.$OM=xe,e.$OM=xe=Je([k],xe);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$PM=et,e.$PM=et=Je([k],et);var tt;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var it;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let ot=class{constructor(F){this.value=F}};e.$QM=ot,e.$QM=ot=Je([k],ot);let gt=class{constructor(F,te,De){this.position=F,this.label=te,this.kind=De}};e.$RM=gt,e.$RM=gt=Je([k],gt);var je;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je||(e.CompletionTriggerKind=je={}));var rt;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(rt||(e.CompletionItemKind=rt={}));var Z;(function(U){U[U.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let X=class{constructor(F,te){this.label=F,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&rt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$SM=X,e.$SM=X=Je([k],X);let $e=class{constructor(F=[],te=!1){this.items=F,this.isIncomplete=te}};e.$TM=$e,e.$TM=$e=Je([k],$e);let Ke=class{constructor(F,te,De){this.insertText=F,this.range=te,this.command=De}};e.$UM=Ke,e.$UM=Ke=Je([k],Ke);let be=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$VM=be,e.$VM=be=Je([k],be);var st;(function(U){U[U.Unknown=0]="Unknown",U[U.Word=1]="Word",U[U.Line=2]="Line",U[U.Suggest=3]="Suggest"})(st||(e.PartialAcceptTriggerKind=st={}));var dt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(dt||(e.ViewColumn=dt={}));var Ct;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Ct||(e.StatusBarAlignment=Ct={}));function Vt(U,F){return`${S.$Tm.toKey(U)}.${F}`}var Qt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative",U[U.Interval=3]="Interval"})(Qt||(e.TextEditorLineNumbersStyle=Qt={}));var ii;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(ii||(e.TextDocumentSaveReason=ii={}));var Xt;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Xt||(e.TextEditorRevealType=Xt={}));var Et;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(Et||(e.TextEditorSelectionChangeKind=Et={}));var Zt;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(Zt||(e.TextDocumentChangeReason=Zt={}));var Yt;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Yt||(e.DecorationRangeBehavior=Yt={})),function(U){function F(te){switch(te){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=F}(Et||(e.TextEditorSelectionChangeKind=Et={}));var Ze;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Ze||(e.SyntaxTokenType=Ze={})),function(U){function F(te){switch(te){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=F}(Ze||(e.SyntaxTokenType=Ze={}));let si=class{constructor(F,te){if(te&&!E.URI.isUri(te))throw(0,O.$7)("target");if(!q.isRange(F)||F.isEmpty)throw(0,O.$7)("range");this.range=F,this.target=te}};e.$XM=si,e.$XM=si=Je([k],si);let Ht=class{constructor(F,te,De,Ge){this.red=F,this.green=te,this.blue=De,this.alpha=Ge}};e.$YM=Ht,e.$YM=Ht=Je([k],Ht);let ht=class{constructor(F,te){if(te&&!(te instanceof Ht))throw(0,O.$7)("color");if(!q.isRange(F)||F.isEmpty)throw(0,O.$7)("range");this.range=F,this.color=te}};e.$ZM=ht,e.$ZM=ht=Je([k],ht);let mt=class{constructor(F){if(!F||typeof F!="string")throw(0,O.$7)("label");this.label=F}};e.$1M=mt,e.$1M=mt=Je([k],mt);var xt;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(xt||(e.ColorFormat=xt={}));var Gt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Gt||(e.SourceControlInputBoxValidationType=Gt={}));var Nt;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(Nt||(e.TerminalExitReason=Nt={}));var ft;(function(U){U[U.Low=0]="Low",U[U.Medium=1]="Medium",U[U.High=2]="High"})(ft||(e.TerminalShellExecutionCommandLineConfidence=ft={}));class Bt{constructor(F,te,De){if(this.startIndex=F,this.length=te,this.tooltip=De,typeof F!="number"||F<0)throw(0,O.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,O.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,O.$7)("tooltip")}}e.$2M=Bt;class _t{constructor(F){this.uri=F}}e.$3M=_t;class zt{constructor(F){this.terminalCommand=F}}e.$4M=zt;var Qe;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(Qe||(e.TerminalLocation=Qe={}));class ui{constructor(F){if(this.options=F,typeof F!="object")throw(0,O.$7)("options")}}e.$5M=ui;var Jt;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(Jt||(e.TaskRevealKind=Jt={}));var jt;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(jt||(e.TaskPanelKind=jt={}));let wt=class{static{p=this}static{this.Clean=new p("clean","Clean")}static{this.Build=new p("build","Build")}static{this.Rebuild=new p("rebuild","Rebuild")}static{this.Test=new p("test","Test")}static from(F){switch(F){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}constructor(F,te){if(this.label=te,typeof F!="string"||typeof te!="string")throw(0,O.$7)("name");this.c=F}get id(){return this.c}};e.$6M=wt,e.$6M=wt=p=Je([k],wt);function Ut(U){let F="";for(let te=0;te<U.length;te++)F+=U[te].replace(/,/g,",,")+",";return F}let Mt=class{constructor(F,te,De){if(typeof F!="string")throw(0,O.$7)("process");this.e=[],this.c=F,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=De):this.f=te)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,O.$7)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const te of this.e)F.push(te);return Ut(F)}};e.$7M=Mt,e.$7M=Mt=Je([k],Mt);let Rt=class{constructor(F,te,De){if(this.f=[],Array.isArray(te)){if(!F)throw(0,O.$7)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,O.$7)("command");this.e=F,this.f=te,this.g=De}else{if(typeof F!="string")throw(0,O.$7)("commandLine");this.c=F,this.g=te}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,O.$7)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,O.$7)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)F.push(typeof te=="string"?te:te.value);return Ut(F)}};e.$8M=Rt,e.$8M=Rt=Je([k],Rt);var ei;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(ei||(e.ShellQuoting=ei={}));var Wt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Wt||(e.TaskScope=Wt={}));class oi{constructor(F){this.c=F}computeId(){return"customExecution"+(0,T.$Ug)()}set callback(F){this.c=F}get callback(){return this.c}}e.$9M=oi;let Ot=class{static{v=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,te,De,Ge,Ye,lt){this.k=!1,this.l=this.definition=F;let pt;typeof te=="string"?(this.o=this.name=te,this.w=this.source=De,this.execution=Ge,pt=Ye,this.k=!0):te===Wt.Global||te===Wt.Workspace?(this.target=te,this.o=this.name=De,this.w=this.source=Ge,this.execution=Ye,pt=lt):(this.target=te,this.o=this.name=De,this.w=this.source=Ge,this.execution=Ye,pt=lt),typeof pt=="string"?(this.r=[pt],this.t=!0):Array.isArray(pt)?(this.r=pt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Mt?this.l={type:v.e,id:this.q.computeId()}:this.q instanceof Rt?this.l={type:v.f,id:this.q.computeId()}:this.q instanceof oi?this.l={type:v.c,id:this.q.computeId()}:this.l={type:v.g,id:(0,T.$Ug)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,O.$7)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,O.$7)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const te=this.l.type;(v.g===te||v.e===te||v.f===te||v.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,O.$7)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$0M=Ot,e.$0M=Ot=v=Je([k],Ot);var qt;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(qt||(e.ProgressLocation=qt={}));var At;(function(U){function F(te){const De=te;return(0,m.$cg)(De.value)?De.tooltip&&!(0,m.$$f)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}U.isViewBadge=F})(At||(e.ViewBadge=At={}));let St=y=class{static isTreeItem(F,te){const De=F;if(De.checkboxState!==void 0){const Ge=(0,m.$cg)(De.checkboxState)?De.checkboxState:(0,m.$ag)(De.checkboxState)&&(0,m.$cg)(De.checkboxState.state)?De.checkboxState.state:void 0,Ye=!(0,m.$cg)(De.checkboxState)&&(0,m.$ag)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Dt.Checked&&Ge!==Dt.Unchecked||Ye!==void 0&&!(0,m.$$f)(Ye))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(F instanceof y)return!0;if(De.label!==void 0&&!(0,m.$$f)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,m.$$f)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,m.$$f)(De.iconPath)&&!E.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,m.$$f)(De.iconPath.id))){const Ge=De.iconPath;if(!Ge||!(0,m.$$f)(Ge.light)&&!E.URI.isUri(Ge.light)&&!(0,m.$$f)(Ge.dark)&&!E.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,m.$$f)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!E.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,m.$$f)(De.tooltip)&&!(De.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<$t.None&&De.collapsibleState>$t.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,m.$$f)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(F,te=$t.None){this.collapsibleState=te,E.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$$M=St,e.$$M=St=y=Je([k],St);var $t;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})($t||(e.TreeItemCollapsibleState=$t={}));var Dt;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(Dt||(e.TreeItemCheckboxState=Dt={}));let ai=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$_M=ai,e.$_M=ai=Je([k],ai);class kt extends ai{}e.$aN=kt;class fi extends kt{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$bN=fi;class ni{constructor(F,te,De,Ge){this.name=F,this.uri=te,this._itemId=De,this.c=Ge}data(){return this.c()}}e.$cN=ni;let $i=class{#e=new Map;constructor(F){for(const[te,De]of F??[]){const Ge=this.#e.get(this.#t(te));Ge?Ge.push(De):this.#e.set(this.#t(te),[De])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,te){this.#e.set(this.#t(F),[te])}forEach(F,te){for(const[De,Ge]of this.#e)for(const Ye of Ge)F.call(te,Ye,De,this)}*[Symbol.iterator](){for(const[F,te]of this.#e)for(const De of te)yield[F,De]}#t(F){return F.toLowerCase()}};e.$dN=$i,e.$dN=$i=Je([k],$i);let li=class{constructor(F,te,De){this.insertText=F,this.title=te,this.kind=De}};e.$eN=li,e.$eN=li=Je([k],li);var bi;(function(U){U[U.Automatic=0]="Automatic",U[U.PasteAs=1]="PasteAs"})(bi||(e.DocumentPasteTriggerKind=bi={}));class It{static{this.c="."}constructor(F){this.value=F}append(...F){return new It((this.value?[this.value,...F]:F).join(It.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+It.c)}}e.$fN=It,It.Empty=new It("");class Ei{constructor(F,te,De){this.title=te,this.insertText=F,this.kind=De}}e.$gN=Ei;let ri=class{constructor(F,te){this.id=F,this.color=te}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$hN=ri,e.$hN=ri=Je([k],ri),ri.File=new ri("file"),ri.Folder=new ri("folder");let pe=class{constructor(F){this.id=F}};e.$iN=pe,e.$iN=pe=Je([k],pe);var Re;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Re||(e.ConfigurationTarget=Re={}));let ae=class{get base(){return this.c}set base(F){this.c=F,this.e=E.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,te){if(typeof F!="string"&&(!F||!E.URI.isUri(F)&&!E.URI.isUri(F.uri)))throw(0,O.$7)("base");if(typeof te!="string")throw(0,O.$7)("pattern");typeof F=="string"?this.baseUri=E.URI.file(F):E.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$jN=ae,e.$jN=ae=Je([k],ae);const J=new WeakMap;function Me(U,F){J.set(U,F)}let Ve=class{constructor(F,te,De,Ge,Ye){this.enabled=typeof F=="boolean"?F:!0,typeof te=="string"&&(this.condition=te),typeof De=="string"&&(this.hitCondition=De),typeof Ge=="string"&&(this.logMessage=Ge),typeof Ye=="string"&&(this.mode=Ye)}get id(){return this.c||(this.c=J.get(this)??(0,T.$Ug)()),this.c}};e.$lN=Ve,e.$lN=Ve=Je([k],Ve);let Xe=class extends Ve{constructor(F,te,De,Ge,Ye,lt){if(super(te,De,Ge,Ye,lt),F===null)throw(0,O.$7)("location");this.location=F}};e.$mN=Xe,e.$mN=Xe=Je([k],Xe);let qe=class extends Ve{constructor(F,te,De,Ge,Ye,lt){super(te,De,Ge,Ye,lt),this.functionName=F}};e.$nN=qe,e.$nN=qe=Je([k],qe);let ut=class extends Ve{constructor(F,te,De,Ge,Ye,lt,pt,Kt){if(super(Ge,Ye,lt,pt,Kt),!te)throw(0,O.$7)("dataId");this.label=F,this.dataId=te,this.canPersist=De}};e.$oN=ut,e.$oN=ut=Je([k],ut);let yt=class{constructor(F,te,De){this.command=F,this.args=te||[],this.options=De}};e.$pN=yt,e.$pN=yt=Je([k],yt);let Ft=class{constructor(F,te){this.port=F,this.host=te}};e.$qN=Ft,e.$qN=Ft=Je([k],Ft);let ct=class{constructor(F){this.path=F}};e.$rN=ct,e.$rN=ct=Je([k],ct);let Tt=class{constructor(F){this.implementation=F}};e.$sN=Tt,e.$sN=Tt=Je([k],Tt);class Lt{constructor(F,te,De){this.session=F,this.threadId=te,this.frameId=De}}e.$tN=Lt;class Di{constructor(F,te){this.session=F,this.threadId=te}}e.$uN=Di;let Ii=class{constructor(F,te){this.range=F,this.expression=te}};e.$vN=Ii,e.$vN=Ii=Je([k],Ii);var Ji;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let Oi=class{constructor(F,te){this.range=F,this.text=te}};e.$wN=Oi,e.$wN=Oi=Je([k],Oi);let Ti=class{constructor(F,te,De=!0){this.range=F,this.variableName=te,this.caseSensitiveLookup=De}};e.$xN=Ti,e.$xN=Ti=Je([k],Ti);let Ci=class{constructor(F,te){this.range=F,this.expression=te}};e.$yN=Ci,e.$yN=Ci=Je([k],Ci);let Ni=class{constructor(F,te){this.frameId=F,this.stoppedLocation=te}};e.$zN=Ni,e.$zN=Ni=Je([k],Ni);var Fi;(function(U){U[U.AIGenerated=1]="AIGenerated"})(Fi||(e.NewSymbolNameTag=Fi={}));var Qi;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Qi||(e.NewSymbolNameTriggerKind=Qi={}));class Li{constructor(F,te){this.newSymbolName=F,this.tags=te}}e.$AN=Li;var Pi;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Pi||(e.FileChangeType=Pi={}));let zi=h=class extends Error{static FileExists(F){return new h(F,l.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(F){return new h(F,l.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(F){return new h(F,l.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(F){return new h(F,l.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(F){return new h(F,l.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(F){return new h(F,l.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}constructor(F,te=l.FileSystemProviderErrorCode.Unknown,De){super(E.URI.isUri(F)?F.toString(!0):F),this.code=De?.name??"Unknown",(0,l.$hl)(this,te),Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$BN=zi,e.$BN=zi=h=Je([k],zi);let ji=class{constructor(F,te,De){this.start=F,this.end=te,this.kind=De}};e.$CN=ji,e.$CN=ji=Je([k],ji);var vi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(vi||(e.FoldingRangeKind=vi={}));var Xi;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Xi||(e.CommentThreadCollapsibleState=Xi={}));var Zi;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(Zi||(e.CommentMode=Zi={}));var Mi;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Mi||(e.CommentState=Mi={}));var Yi;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(Yi||(e.CommentThreadState=Yi={}));var Ui;(function(U){U[U.Current=0]="Current",U[U.Outdated=1]="Outdated"})(Ui||(e.CommentThreadApplicability=Ui={}));class dn{constructor(F,te=[]){this.tokenTypes=F,this.tokenModifiers=te}}e.$DN=dn;function xi(U){return typeof U>"u"||(0,m.$_f)(U)}class Bi{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let te=0,De=F.tokenTypes.length;te<De;te++)this.k.set(F.tokenTypes[te],te);for(let te=0,De=F.tokenModifiers.length;te<De;te++)this.l.set(F.tokenModifiers[te],te)}}push(F,te,De,Ge,Ye){if(typeof F=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ge=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.q(F,te,De,Ge,Ye);if(q.isRange(F)&&typeof te=="string"&&xi(De))return this.o(F,te,De);throw(0,O.$7)()}o(F,te,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ge=F.start.line,Ye=F.start.character,lt=F.end.character-F.start.character,pt=this.k.get(te);let Kt=0;if(De)for(const ci of De){if(!this.l.has(ci))throw new Error("`tokenModifier` is not in the provided legend");const di=this.l.get(ci);Kt|=1<<di>>>0}this.q(Ge,Ye,lt,pt,Kt)}q(F,te,De,Ge,Ye){if(this.f&&(F<this.c||F===this.c&&te<this.e)){this.f=!1;const Kt=this.g.length/5|0;let ci=0,di=0;for(let mi=0;mi<Kt;mi++){let wi=this.g[5*mi],Hi=this.g[5*mi+1];wi===0?(wi=ci,Hi+=di):wi+=ci,this.g[5*mi]=wi,this.g[5*mi+1]=Hi,ci=wi,di=Hi}}let lt=F,pt=te;this.f&&this.j>0&&(lt-=this.c,lt===0&&(pt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=pt,this.g[this.j++]=De,this.g[this.j++]=Ge,this.g[this.j++]=Ye,this.c=F,this.e=te}static r(F){const te=[],De=F.length/5|0;for(let pt=0;pt<De;pt++)te[pt]=pt;te.sort((pt,Kt)=>{const ci=F[5*pt],di=F[5*Kt];if(ci===di){const mi=F[5*pt+1],wi=F[5*Kt+1];return mi-wi}return ci-di});const Ge=new Uint32Array(F.length);let Ye=0,lt=0;for(let pt=0;pt<De;pt++){const Kt=5*te[pt],ci=F[Kt+0],di=F[Kt+1],mi=F[Kt+2],wi=F[Kt+3],Hi=F[Kt+4],Ln=ci-Ye,wr=Ln===0?di-lt:di,Gi=5*pt;Ge[Gi+0]=Ln,Ge[Gi+1]=wr,Ge[Gi+2]=mi,Ge[Gi+3]=wi,Ge[Gi+4]=Hi,Ye=ci,lt=di}return Ge}build(F){return this.f?new pi(new Uint32Array(this.g),F):new pi(Bi.r(this.g),F)}}e.$EN=Bi;class pi{constructor(F,te){this.resultId=te,this.data=F}}e.$FN=pi;class fn{constructor(F,te,De){this.start=F,this.deleteCount=te,this.data=De}}e.$GN=fn;class gn{constructor(F,te){this.resultId=te,this.edits=F}}e.$HN=gn;var _i;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(_i||(e.DebugConsoleMode=_i={}));class Vi{constructor(F){this.name=F}}e.$IN=Vi;let Ai=class{static{this.Back={iconPath:new ri("arrow-left")}}constructor(){}};e.$JN=Ai,e.$JN=Ai=Je([k],Ai);var ze;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(ze||(e.QuickPickItemKind=ze={}));var hi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(hi||(e.InputBoxValidationSeverity=hi={}));var Wi;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(Wi||(e.ExtensionKind=Wi={}));class nt{static validate(F){if(typeof F.badge=="string"){let te=(0,w.$Jf)(F.badge,0);if(te<F.badge.length&&(te+=(0,w.$Jf)(F.badge,te)),F.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!ri.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,te,De){this.badge=F,this.tooltip=te,this.color=De}}e.$KN=nt;let bt=class{constructor(F){this.kind=F}};e.$LN=bt,e.$LN=bt=Je([k],bt);var en;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(en||(e.ColorThemeKind=en={}));class gi{static isNotebookRange(F){return F instanceof gi?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,te){if(F<0)throw(0,O.$7)("start must be positive");if(te<0)throw(0,O.$7)("end must be positive");F<=te?(this.c=F,this.e=te):(this.c=te,this.e=F)}with(F){let te=this.c,De=this.e;return F.start!==void 0&&(te=F.start),F.end!==void 0&&(De=F.end),te===this.c&&De===this.e?this:new gi(te,De)}}e.$MN=gi;class ki{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(te=>ki.isNotebookCellData(te))}static isNotebookCellData(F){return!0}constructor(F,te,De,Ge,Ye,lt,pt){this.kind=F,this.value=te,this.languageId=De,this.mime=Ge,this.outputs=Ye??[],this.metadata=lt,this.executionSummary=pt,ki.validate(this)}}e.$NN=ki;class mn{constructor(F){this.cells=F}}e.$ON=mn;class ti{static isNotebookCellOutputItem(F){return F instanceof ti?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const te={name:F.name,message:F.message,stack:F.stack};return ti.json(te,"application/vnd.code.notebook.error")}static stdout(F){return ti.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return ti.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,te="application/octet-stream"){return new ti(F,te)}static#e=new TextEncoder;static text(F,te=R.$Ts.text){const De=ti.#e.encode(String(F));return new ti(De,te)}static json(F,te="text/x-json"){const De=JSON.stringify(F,void 0,"	");return ti.text(De,te)}constructor(F,te){this.data=F,this.mime=te;const De=(0,R.$Xs)(te,!0);if(!De)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$PN=ti;class Ri{static isNotebookCellOutput(F){return F instanceof Ri?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,te=!1){const De=new Set,Ge=new Set;for(let Ye=0;Ye<F.length;Ye++){const lt=F[Ye],pt=(0,R.$Xs)(lt.mime);if(!De.has(pt)||(0,g.$eK)(pt)){De.add(pt);continue}Ge.add(Ye),te&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ge.size===0?F:F.filter((Ye,lt)=>!Ge.has(lt))}constructor(F,te,De){this.items=Ri.ensureUniqueMimeTypes(F,!0),typeof te=="string"?(this.id=te,this.metadata=De):(this.id=(0,T.$Ug)(),this.metadata=te??De)}}e.$QN=Ri;var tn;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var qi;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(qi||(e.NotebookCellStatusBarAlignment=qi={}));var rn;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(rn||(e.NotebookEditorRevealType=rn={}));class $n{constructor(F,te){this.text=F,this.alignment=te}}e.$RN=$n;var sn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var on;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(on||(e.NotebookControllerAffinity2=on={}));class pn{constructor(F,te=[]){this.uri=F,this.provides=(0,C.$2b)(te)}}e.$SN=pn;class wn{constructor(F){this.label=F}}e.$TN=wn;var an;(function(U){U[U.Named=1]="Named",U[U.Indexed=2]="Indexed"})(an||(e.NotebookVariablesRequestKind=an={}));let Ki=class{constructor(F,te){this.label=F,this.timestamp=te}};e.$UN=Ki,e.$UN=Ki=Je([k],Ki);var cn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(cn||(e.ExtensionMode=cn={}));var un;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(un||(e.ExtensionRuntime=un={}));var ln;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(ln||(e.StandardTokenType=ln={}));class _{constructor(F,te){this.ranges=F,this.wordPattern=te}}e.$VN=_;class oe{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$WN=oe;var Le;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Le||(e.TestResultState=Le={}));var at;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(at||(e.TestRunProfileKind=at={}));let vt=class{constructor(F=void 0,te=void 0,De=void 0,Ge=!1,Ye=!0){this.include=F,this.exclude=te,this.profile=De,this.continuous=Ge,this.preserveFocus=Ye}};e.$XN=vt,e.$XN=vt=Je([k],vt);let Pt=D=class{static diff(F,te,De){const Ge=new D(F);return Ge.expectedOutput=te,Ge.actualOutput=De,Ge}constructor(F){this.message=F}};e.$YN=Pt,e.$YN=Pt=D=Je([k],Pt);let Si=class{constructor(F){this.id=F}};e.$ZN=Si,e.$ZN=Si=Je([k],Si);class hn{constructor(F,te){this.covered=F,this.total=te,vn(this)}}e.$1N=hn;function vn(U){if(U){if(U.covered>U.total)throw new Error(`The total number of covered items (${U.covered}) cannot be greater than the total (${U.total})`);if(U.total<0)throw new Error(`The number of covered items (${U.total}) cannot be negative`)}}class bn{static fromDetails(F,te){const De=new hn(0,0),Ge=new hn(0,0),Ye=new hn(0,0);for(const pt of te)if("branches"in pt){De.total+=1,De.covered+=pt.executed?1:0;for(const Kt of pt.branches)Ge.total+=1,Ge.covered+=Kt.executed?1:0}else Ye.total+=1,Ye.covered+=pt.executed?1:0;const lt=new bn(F,De,Ge.total>0?Ge:void 0,Ye.total>0?Ye:void 0);return lt.detailedCoverage=te,lt}constructor(F,te,De,Ge,Ye){this.uri=F,this.statementCoverage=te,this.branchCoverage=De,this.declarationCoverage=Ge,this.testItem=Ye}}e.$3N=bn;class zn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,De=[]){this.executed=F,this.location=te,this.branches=De}}e.$4N=zn;class jn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,De){this.executed=F,this.location=te,this.label=De}}e.$5N=jn;class Un{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,De){this.name=F,this.executed=te,this.location=De}}e.$6N=Un;var yn;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(yn||(e.ExternalUriOpenerPriority=yn={}));var En;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(En||(e.WorkspaceTrustState=En={}));var Dn;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(Dn||(e.PortAutoForwardAction=Dn={}));class Bn{constructor(F,te,De,Ge,Ye,lt){this.kind=F,this.name=te,this.detail=De,this.uri=Ge,this.range=Ye,this.selectionRange=lt}}e.$7N=Bn;class Vn{constructor(F){this.uri=F}}e.$8N=Vn;class Wn{constructor(F,te){this.original=F,this.modified=te}}e.$9N=Wn;class qn{constructor(F,te,De,Ge){this.base=F,this.input1=te,this.input2=De,this.result=Ge}}e.$0N=qn;class Kn{constructor(F,te){this.uri=F,this.viewType=te}}e.$$N=Kn;class Hn{constructor(F){this.viewType=F}}e.$_N=Hn;class Gn{constructor(F,te){this.uri=F,this.notebookType=te}}e.$aO=Gn;class Jn{constructor(F,te,De){this.original=F,this.modified=te,this.notebookType=De}}e.$bO=Jn;class Qn{constructor(){}}e.$cO=Qn;class Xn{constructor(F,te){this.uri=F,this.inputBoxUri=te}}e.$dO=Xn;class Zn{constructor(){}}e.$eO=Zn;class Yn{constructor(F){this.textDiffs=F}}e.$fO=Yn;var kn;(function(U){U[U.Down=0]="Down",U[U.Up=1]="Up"})(kn||(e.InteractiveSessionVoteDirection=kn={}));var Sn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(Sn||(e.ChatCopyKind=Sn={}));var In;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(In||(e.ChatVariableLevel=In={}));class xn{constructor(F,te){this.label=F,this.values=te}}e.$gO=xn;var Cn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted",U[U.Bug=4]="Bug"})(Cn||(e.InteractiveEditorResponseFeedbackKind=Cn={}));var Pn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(Pn||(e.ChatResultFeedbackKind=Pn={}));class _n{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new He(F):F}}e.$hO=_n;class er{constructor(F,te){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new He(F):F,this.vulnerabilities=te}}e.$iO=er;class tr{constructor(F,te){this.participant=F,this.command=te}}e.$jO=tr;class ir{constructor(F,te,De){this.title=F,this.message=te,this.data=De}}e.$kO=ir;class nr{constructor(F,te){this.value=F,this.baseUri=te}}e.$lO=nr;class rr{constructor(F,te){this.value=F,this.title=te}}e.$mO=rr;class sr{constructor(F){this.value=F}}e.$nO=sr;class or{constructor(F,te){this.value=F,this.task=te}}e.$oO=or;class ar{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new He(F):F}}e.$pO=ar;class cr{constructor(F){this.value=F}}e.$qO=cr;class ur{constructor(F,te){this.value=F,this.iconPath=te}}e.$rO=ur;class lr{constructor(F,te){this.uri=F,this.edits=Array.isArray(te)?te:[te]}}e.$sO=lr;class hr{constructor(F,te,De,Ge){this.prompt=F,this.command=te,this.variables=De,this.participant=Ge}}e.$tO=hr;class dr{constructor(F,te,De,Ge){this.response=F,this.result=te,this.participant=De,this.command=Ge}}e.$uO=dr;var Mn;(function(U){U[U.Panel=1]="Panel",U[U.Terminal=2]="Terminal",U[U.Notebook=3]="Notebook",U[U.Editor=4]="Editor"})(Mn||(e.ChatLocation=Mn={}));var An;(function(U){U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.System=3]="System"})(An||(e.LanguageModelChatMessageRole=An={}));class fr{constructor(F,te,De){this.role=F,this.content=te,this.name=De}}e.$vO=fr;class gr{constructor(F){this.content=F}}e.$wO=gr;class mr{constructor(F,te){this.content=F,this.name=te}}e.$xO=mr;class $r{constructor(F,te){this.content=F,this.name=te}}e.$yO=$r;class yi extends Error{static NotFound(F){return new yi(F,yi.NotFound.name)}static NoPermissions(F){return new yi(F,yi.NoPermissions.name)}static Blocked(F){return new yi(F,yi.Blocked.name)}constructor(F,te,De){super(F,{cause:De}),this.name="LanguageModelError",this.code=te??""}}e.$zO=yi;var Rn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(Rn||(e.RelatedInformationType=Rn={}));var On;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped",U[U.Error=5]="Error"})(On||(e.SpeechToTextStatus=On={}));var Tn;(function(U){U[U.Started=1]="Started",U[U.Stopped=2]="Stopped",U[U.Error=3]="Error"})(Tn||(e.TextToSpeechStatus=Tn={}));var Nn;(function(U){U[U.Recognized=1]="Recognized",U[U.Stopped=2]="Stopped"})(Nn||(e.KeywordRecognitionStatus=Nn={}));class pr{constructor(F,te){this.text=F,this.range=te}}e.$AO=pr;var Fn;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Fn||(e.InlineEditTriggerKind=Fn={}))}),define(Se[258],Ie([1,0,4,7]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ylc=void 0;class M{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(C.$iM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,w,m){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(R);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(w,m)??[]}getRelatedInformation(R,w,m){return this.c.$getAiRelatedInformation(w,m)}registerRelatedInformationProvider(R,w,m){const E=this.b;return this.b++,this.a.set(E,m),this.c.$registerAiRelatedInformationProvider(E,w),new O.$kM(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$Ylc=M}),define(Se[86],Ie([1,0,5,4,7,21,108,3,17]),function(le,e,C,O,M,N,R,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=e.$0lc=void 0,e.$0lc=(0,w.$yi)("IExtHostAuthentication");let E=class{constructor(l){this.b=new Map,this.c=new C.$fe,this.onDidChangeSessions=this.c.event,this.d=new T,this.f=new T,this.a=l.getProxy(O.$iM.MainThreadAuthentication)}async getSession(l,b,g,r={}){const s=N.$Tm.toKey(l.identifier),o=[...g].sort().join(" ");return await this.d.getOrCreate(`${s} ${b} ${o}`,async()=>{await this.a.$ensureProvider(b);const i=l.displayName||l.name;return this.a.$getSession(b,g,s,i,r)})}async getSessions(l,b,g){const r=N.$Tm.toKey(l.identifier),s=[...g].sort().join(" ");return await this.f.getOrCreate(`${r} ${s}`,async()=>{await this.a.$ensureProvider(b);const o=l.displayName||l.name;return this.a.$getSessions(b,g,r,o)})}async removeSession(l,b){const g=this.b.get(l);return g?g.provider.removeSession(b):this.a.$removeSession(l,b)}registerAuthenticationProvider(l,b,g,r){if(this.b.get(l))throw new Error(`An authentication provider with id '${l}' is already registered.`);this.b.set(l,{label:b,provider:g,options:r??{supportsMultipleAccounts:!1}});const s=g.onDidChangeSessions(o=>this.a.$sendDidChangeSessions(l,o));return this.a.$registerAuthenticationProvider(l,b,r?.supportsMultipleAccounts??!1),new M.$kM(()=>{s.dispose(),this.b.delete(l),this.a.$unregisterAuthenticationProvider(l)})}async $createSession(l,b,g){const r=this.b.get(l);if(r)return await r.provider.createSession(b,g);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $removeSession(l,b){const g=this.b.get(l);if(g)return await g.provider.removeSession(b);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $getSessions(l,b){const g=this.b.get(l);if(g)return await g.provider.getSessions(b);throw new Error(`Unable to find authentication provider with handle: ${l}`)}$onDidChangeAuthenticationSessions(l,b){return l.startsWith(R.$kL)||this.c.fire({provider:{id:l,label:b}}),Promise.resolve()}};e.$$lc=E,e.$$lc=E=Je([We(0,m.$MO)],E);class T{constructor(){this.a=new Map}getOrCreate(l,b){const g=this.a.get(l);if(g)return g;const r=b().finally(()=>this.a.delete(l));return this.a.set(l,r),r}}}),define(Se[112],Ie([1,0,2,4,7,3,17,12,18,13,19,25]),function(le,e,C,O,M,N,R,w,m,E,T,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=e.$0mc=void 0;let b=class{static{l=this}static{this.c=0}static{this.d=250}constructor(r,s){this.h=s,this.f=new Map,this.g=r.getProxy(O.$iM.MainThreadDecorations)}registerFileDecorationProvider(r,s){const o=l.c++;this.f.set(o,{provider:r,extensionDescription:s}),this.g.$registerDecorationProvider(o,s.identifier.value);const i=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(o,null);return}const c=(0,m.$2b)(n);if(c.length<=l.d){this.g.$onDidChange(o,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,c.length);const u=c.map(a=>({uri:a,rank:(0,E.$cf)(a.path,"/")})),t=(0,m.$zb)(u,(a,d)=>a.rank-d.rank||(0,E.$sf)(a.uri.path,d.uri.path)),f=[];e:for(const a of t){let d;for(const $ of a){const p=(0,T.$mc)($.uri.path);if(d!==p&&(d=p,f.push($.uri)>=l.d))break e}}this.g.$onDidChange(o,f)});return new M.$kM(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(r,s,o){if(!this.f.has(r))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:c}=this.f.get(r);return await Promise.all(s.map(async u=>{try{const{uri:t,id:f}=u,a=await Promise.resolve(n.provideFileDecoration(C.URI.revive(t),o));if(!a)return;try{M.$KN.validate(a),a.badge&&typeof a.badge!="string"&&(0,S.$KG)(c,"codiconDecoration"),i[f]=[a.propagate,a.tooltip,a.badge,a.color]}catch(d){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${d}`)}}catch(t){this.h.error(t)}})),i}};e.$0mc=b,e.$0mc=b=l=Je([We(0,R.$MO),We(1,w.$5j)],b),e.$$mc=(0,N.$yi)("IExtHostDecorations")}),define(Se[259],Ie([1,0,14,2,7,4,16,20,13]),function(le,e,C,O,M,N,R,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=void 0;class E{static{this.a=0}constructor(S,l,b){this.d=l,this.e=b,this.b=new Map,this.c=S.getProxy(N.$iM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,l){if(Object.keys(R.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const b=E.a++;this.b.set(b,l),this.c.$registerTextContentProvider(b,S);let g;if(typeof l.onDidChange=="function"){let r;g=l.onDidChange(async s=>{if(s.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(s))return;r&&await r;const o=this.$provideTextDocumentContent(b,s).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(s);if(!n)return;const c=(0,m.$mf)(i);if(!n.equalLines(c))return this.c.$onVirtualDocumentChange(s,i)}).catch(C.$1).finally(()=>{r===o&&(r=void 0)});r=o})}return new M.$kM(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(S,l){const b=this.b.get(S);return b?Promise.resolve(b.provideTextDocumentContent(O.URI.revive(l),w.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$anc=E}),define(Se[113],Ie([1,0,57,16,13,313,159,7,18]),function(le,e,C,O,M,N,R,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QO=e.$PO=void 0,e.$OO=T;const E=new Map;function T(g,r){r?E.set(g,r):E.delete(g)}function S(g){return E.get(g)}class l extends N.$9v{constructor(r,s,o,i,n,c,u){super(s,o,i,n),this.c=r,this.m=c,this.q=u,this.b=!1}dispose(){(0,C.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,m.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===O.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(s){return s?r.s(s):r.getText()},get eol(){return r.g===`
`?w.EndOfLine.LF:w.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(s){return r.t(s)},offsetAt(s){return r.u(s)},positionAt(s){return r.v(s)},validateRange(s){return r.w(s)},validatePosition(s){return r.x(s)},getWordRangeAtPosition(s,o){return r.y(s,o)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,C.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,C.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const s=this.w(r);if(s.isEmpty)return"";if(s.isSingleLine)return this.f[s.start.line].substring(s.start.character,s.end.character);const o=this.g,i=s.start.line,n=s.end.line,c=[];c.push(this.f[i].substring(s.start.character));for(let u=i+1;u<n;u++)c.push(this.f[u]);return c.push(this.f[n].substring(0,s.end.character)),c.join(o)}t(r){let s;if(r instanceof w.$lM?s=r.line:typeof r=="number"&&(s=r),typeof s!="number"||s<0||s>=this.f.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new b(s,this.f[s],s===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const s=this.j.getIndexOf(r),o=this.f[s.index].length;return new w.$lM(s.index,Math.min(s.remainder,o))}w(r){if(!(r instanceof w.$mM))throw new Error("Invalid argument");const s=this.x(r.start),o=this.x(r.end);return s===r.start&&o===r.end?r:new w.$mM(s.line,s.character,o.line,o.character)}x(r){if(!(r instanceof w.$lM))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:s,character:o}=r,i=!1;if(s<0)s=0,o=0,i=!0;else if(s>=this.f.length)s=this.f.length-1,o=this.f[s].length,i=!0;else{const n=this.f[s].length;o<0?(o=0,i=!0):o>n&&(o=n,i=!0)}return i?new w.$lM(s,o):r}y(r,s){const o=this.x(r);if(!s)s=S(this.m);else if((0,M.$lf)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const i=(0,R.$_s)(o.character+1,(0,R.$0s)(s),this.f[o.line],0);if(i)return new w.$mM(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.$PO=l;class b{constructor(r,s,o){this.a=r,this.b=s,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new w.$mM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new w.$mM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$QO=b}),define(Se[260],Ie([1,0,4,7]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dnc=void 0;class M{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(C.$iM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,w,m){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(R);if(!E)throw new Error("Embedding vector provider not found");const T=await E.provideEmbeddingVector(w,m);if(!T)throw new Error("Embedding vector provider returned undefined");return T}registerEmbeddingVectorProvider(R,w,m){const E=this.b;return this.b++,this.a.set(E,m),this.c.$registerAiEmbeddingVectorProvider(w,E),new O.$kM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$dnc=M}),define(Se[65],Ie([1,0,4,38,7,22,3,17,46,6,11,24,16]),function(le,e,C,O,M,N,R,w,m,E,T,S,l){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$omc=e.$nmc=void 0;let g=b=class{constructor(s,o){this.b=new Map,this.c=new T.$Hh,this.a=s.getProxy(C.$iM.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let c;const u=i.b.get(n.scheme);return u?(await i.a.$ensureActivation(n.scheme),c=await u.impl.stat(n)):c=await i.a.$stat(n),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===O.FilePermission.Readonly?1:void 0}}catch(c){b.e(c)}},async readDirectory(n){try{const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),(await c.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(c){return b.e(c)}},async createDirectory(n){try{const c=i.b.get(n.scheme);return c&&!c.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(c.impl,c.extUri,n)):await i.a.$mkdir(n)}catch(c){return b.e(c)}},async readFile(n){try{const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),(await c.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(c){return b.e(c)}},async writeFile(n,c){try{const u=i.b.get(n.scheme);return u&&!u.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(u.impl,u.extUri,u.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(u.impl.writeFile(n,c,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,N.$He.wrap(c))}catch(u){return b.e(u)}},async delete(n,c){try{const u=i.b.get(n.scheme);return u&&!u.isReadonly&&!c?.useTrash?(await i.a.$ensureActivation(n.scheme),await u.impl.delete(n,{recursive:!1,...c})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(u){return b.e(u)}},async rename(n,c,u){try{return await i.a.$rename(n,c,{overwrite:!1,...u})}catch(t){return b.e(t)}},async copy(n,c,u){try{return await i.a.$copy(n,c,{overwrite:!1,...u})}catch(t){return b.e(t)}},isWritableFileSystem(n){const c=o.getCapabilities(n);if(typeof c=="number")return!(c&2048)}})}async d(s,o,i){const n=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await s.stat(i)).type&O.FileType.Directory))throw M.$BN.FileExists(`Unable to create folder '${i.scheme===l.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(O.$il(c)!==O.FileSystemProviderErrorCode.FileNotFound)throw c;n.push(o.basename(i)),i=o.dirname(i)}for(let c=n.length-1;c>=0;c--){i=o.joinPath(i,n[c]);try{await s.createDirectory(i)}catch(u){if(O.$il(u)!==O.FileSystemProviderErrorCode.FileExists)throw u}}}static e(s){if(s instanceof M.$BN)throw s;if(s instanceof O.$el)switch(s.code){case O.FileSystemProviderErrorCode.FileExists:throw M.$BN.FileExists(s.message);case O.FileSystemProviderErrorCode.FileNotFound:throw M.$BN.FileNotFound(s.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw M.$BN.FileNotADirectory(s.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw M.$BN.FileIsADirectory(s.message);case O.FileSystemProviderErrorCode.NoPermissions:throw M.$BN.NoPermissions(s.message);case O.FileSystemProviderErrorCode.Unavailable:throw M.$BN.Unavailable(s.message);default:throw new M.$BN(s.message,s.name)}if(!(s instanceof Error))throw new M.$BN(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw M.$BN.Unavailable(s.message);switch(s.name){case O.FileSystemProviderErrorCode.FileExists:throw M.$BN.FileExists(s.message);case O.FileSystemProviderErrorCode.FileNotFound:throw M.$BN.FileNotFound(s.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw M.$BN.FileNotADirectory(s.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw M.$BN.FileIsADirectory(s.message);case O.FileSystemProviderErrorCode.NoPermissions:throw M.$BN.NoPermissions(s.message);case O.FileSystemProviderErrorCode.Unavailable:throw M.$BN.Unavailable(s.message);default:throw new M.$BN(s.message,s.name)}}addFileSystemProvider(s,o,i){return this.b.set(s,{impl:o,extUri:i?.isCaseSensitive?S.$2g:S.$4g,isReadonly:!!i?.isReadonly}),(0,E.$Sc)(()=>this.b.delete(s))}getFileSystemProviderExtUri(s){return this.b.get(s)?.extUri??S.$2g}};e.$nmc=g,e.$nmc=g=b=Je([We(0,w.$MO),We(1,m.$4lc)],g),e.$omc=(0,R.$yi)("IExtHostConsumerFileSystem")}),define(Se[87],Ie([1,0,3,27,12,65,2]),function(le,e,C,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=e.$pmc=void 0,e.$pmc=(0,C.$yi)("IExtensionStoragePaths");let w=class{constructor(E,T,S){this.d=T,this.f=S,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(E){return R.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,T=await this.g(E);try{return await this.f.value.stat(T),this.d.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",T),await this.f.value.createDirectory(T),await this.f.value.writeFile(R.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),T}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(E){if(this.c)return R.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return R.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$qmc=w,e.$qmc=w=Je([We(0,O.$3O),We(1,M.$5j),We(2,N.$omc)],w)}),define(Se[261],Ie([1,0,7,17,5]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xnc=void 0;let N=class{constructor(w){this.a=new C.$LN(C.ColorThemeKind.Dark),this.b=new M.$fe}get activeColorTheme(){return this.a}$onColorThemeChange(w){let m;switch(w){case"light":m=C.ColorThemeKind.Light;break;case"hcDark":m=C.ColorThemeKind.HighContrast;break;case"hcLight":m=C.ColorThemeKind.HighContrastLight;break;default:m=C.ColorThemeKind.Dark}this.a=new C.$LN(m),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Xnc=N,e.$Xnc=N=Je([We(0,O.$MO)],N)}),define(Se[88],Ie([1,0,20,5,6,182,3,12,211,4,27,17,7]),function(le,e,C,O,M,N,R,w,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TDb=e.$SDb=e.TunnelDtoConverter=void 0;class b extends m.$vw{}var g;(function(s){function o(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:n.protocol}}s.fromApiTunnel=o;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==m.TunnelPrivacyId.ConstantPrivate&&n.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}s.fromServiceTunnel=i})(g||(e.TunnelDtoConverter=g={})),e.$SDb=(0,R.$yi)("IExtHostTunnelService");let r=class extends M.$Uc{constructor(o,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$fe,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(E.$iM.MainThreadTunnelService)}async openTunnel(o,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,o.displayName);if(n){const c=new b(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,i){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:o,provider:i}),this.a.$registerPortsAttributesProvider(o,n),new l.$kM(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(o,i,n,c,u){const t=[];for(const a of o){const d=this.r.get(a);if(!d)return[];t.push(...await Promise.all(i.map(async $=>{let p;try{p=await d.provider.providePortAttributes({port:$,pid:n,commandLine:c},u)}catch{p=await d.provider.providePortAttributes($,n,c,u)}return{providedAttributes:p,port:$}})))}const f=t.filter(a=>!!a.providedAttributes);return f.length>0?f.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,u)=>await o.provideTunnel(c,u,C.CancellationToken.None)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,M.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const n=o.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let c=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:N.localize(0,null),themeIcon:"lock"},{id:"public",label:N.localize(1,null),themeIcon:"eye"}]);const u=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(u)}}else this.b=void 0;return(0,M.$Sc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,i){if(this.g.has(o.host)){const n=this.g.get(o.host);n.has(o.port)&&(i&&n.get(o.port).disposeListener.dispose(),await n.get(o.port).tunnel.dispose(),n.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(o,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const c=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const u=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:c,disposeListener:u}),g.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(c=>this.f(c.host,c.port,c.detail??""))),n=o.filter((c,u)=>i[u]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(c=>c.port).join(", ")} to ${n.map(c=>c.port).join(", ")}`),n}};e.$TDb=r,e.$TDb=r=Je([We(0,S.$MO),We(1,T.$3O),We(2,w.$5j)],r)}),define(Se[8],Ie([1,0,18,22,138,262,55,28,127,49,70,26,133,24,36,15,2,30,89,101,107,106,224,85,52,62,235,7]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s,o,i,n,c,u,t,f,a,d,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$JO=G,e.$KO=de,e.$LO=ye;var v;(function(pe){function Re(J){const{selectionStartLineNumber:Me,selectionStartColumn:Ve,positionLineNumber:Xe,positionColumn:qe}=J,ut=new p.$lM(Me-1,Ve-1),yt=new p.$lM(Xe-1,qe-1);return new p.$nM(ut,yt)}pe.to=Re;function ae(J){const{anchor:Me,active:Ve}=J;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}pe.from=ae})(v||(e.Selection=v={}));var y;(function(pe){function Re(J){if(!J)return;const{start:Me,end:Ve}=J;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}pe.from=Re;function ae(J){if(!J)return;const{startLineNumber:Me,startColumn:Ve,endLineNumber:Xe,endColumn:qe}=J;return new p.$mM(Me-1,Ve-1,Xe-1,qe-1)}pe.to=ae})(y||(e.Range=y={}));var h;(function(pe){function Re(J){return{uri:J.uri,range:y.from(J.range)}}pe.from=Re;function ae(J){return new p.$wM(s.URI.revive(J.uri),y.to(J.range))}pe.to=ae})(h||(e.Location=h={}));var D;(function(pe){function Re(ae){switch(ae){case 1:return p.StandardTokenType.Comment;case 0:return p.StandardTokenType.Other;case 3:return p.StandardTokenType.RegEx;case 2:return p.StandardTokenType.String}}pe.to=Re})(D||(e.TokenType=D={}));var k;(function(pe){function Re(J){return new p.$lM(J.lineNumber-1,J.column-1)}pe.to=Re;function ae(J){return{lineNumber:J.line+1,column:J.character+1}}pe.from=ae})(k||(e.Position=k={}));var I;(function(pe){function Re(Me,Ve,Xe){return(0,C.$Hb)((0,C.$2b)(Me).map(qe=>ae(qe,Ve,Xe)))}pe.from=Re;function ae(Me,Ve,Xe){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Xe?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:J(Me.scheme,Ve),pattern:$e.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Xe?.isBuiltin}}function J(Me,Ve){return Ve&&typeof Me=="string"?Ve.transformOutgoingScheme(Me):Me}})(I||(e.DocumentSelector=I={}));var P;(function(pe){function Re(J){switch(J){case p.DiagnosticTag.Unnecessary:return 1;case p.DiagnosticTag.Deprecated:return 2}}pe.from=Re;function ae(J){switch(J){case 1:return p.DiagnosticTag.Unnecessary;case 2:return p.DiagnosticTag.Deprecated;default:return}}pe.to=ae})(P||(e.DiagnosticTag=P={}));var V;(function(pe){function Re(J){let Me;return J.code&&((0,r.$$f)(J.code)||(0,r.$cg)(J.code)?Me=String(J.code):Me={value:String(J.code.value),target:J.code.target}),{...y.from(J.range),message:J.message,source:J.source,code:Me,severity:q.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(W.from),tags:Array.isArray(J.tags)?(0,C.$Hb)(J.tags.map(P.from)):void 0}}pe.from=Re;function ae(J){const Me=new p.$yM(y.to(J),J.message,q.to(J.severity));return Me.source=J.source,Me.code=(0,r.$$f)(J.code)?J.code:J.code?.value,Me.relatedInformation=J.relatedInformation&&J.relatedInformation.map(W.to),Me.tags=J.tags&&(0,C.$Hb)(J.tags.map(P.to)),Me}pe.to=ae})(V||(e.Diagnostic=V={}));var W;(function(pe){function Re(J){return{...y.from(J.location.range),message:J.message,resource:J.location.uri}}pe.from=Re;function ae(J){return new p.$xM(new p.$wM(J.resource,y.to(J)),J.message)}pe.to=ae})(W||(e.DiagnosticRelatedInformation=W={}));var q;(function(pe){function Re(J){switch(J){case p.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case p.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case p.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case p.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}pe.from=Re;function ae(J){switch(J){case n.MarkerSeverity.Info:return p.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return p.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return p.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return p.DiagnosticSeverity.Hint;default:return p.DiagnosticSeverity.Error}}pe.to=ae})(q||(e.DiagnosticSeverity=q={}));var A;(function(pe){function Re(J){return typeof J=="number"&&J>=p.ViewColumn.One?J-1:J===p.ViewColumn.Beside?$.$8D:$.$7D}pe.from=Re;function ae(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}pe.to=ae})(A||(e.ViewColumn=A={}));function z(pe){return typeof pe.range<"u"}function G(pe){return pe.length===0?!0:!!z(pe[0])}var ie;(function(pe){function Re(qe){return qe.map(pe.from)}pe.fromMany=Re;function ae(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function J(qe){let ut;if(ae(qe)){const{language:Tt,value:Lt}=qe;ut={value:"```"+Tt+`
`+Lt+"\n```\n"}}else p.$MM.isMarkdownString(qe)?ut={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ut={value:qe}:ut={value:""};const yt=Object.create(null);ut.uris=yt;const Ft=Tt=>{try{let Lt=s.URI.parse(Tt,!0);Lt=Lt.with({query:Me(Lt.query,yt)}),yt[Tt]=Lt}catch{}return""},ct=new m.marked.Renderer;return ct.link=Ft,ct.image=Tt=>typeof Tt=="string"?Ft(R.$4k(Tt).href):"",(0,m.marked)(ut.value,{renderer:ct}),ut}pe.from=J;function Me(qe,ut){if(!qe)return qe;let yt;try{yt=(0,E.$7h)(qe)}catch{}if(!yt)return qe;let Ft=!1;return yt=(0,S.$7n)(yt,ct=>{if(s.URI.isUri(ct)){const Tt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Tt]=ct,Ft=!0,Tt}else return}),Ft?JSON.stringify(yt):qe}function Ve(qe){const ut=new p.$MM(qe.value,qe.supportThemeIcons);return ut.isTrusted=qe.isTrusted,ut.supportHtml=qe.supportHtml,ut.baseUri=qe.baseUri?s.URI.from(qe.baseUri):void 0,ut}pe.to=Ve;function Xe(qe){if(qe)return typeof qe=="string"?qe:pe.from(qe)}pe.fromStrict=Xe})(ie||(e.MarkdownString=ie={}));function de(pe){return G(pe)?pe.map(Re=>({range:y.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?ie.fromMany(Re.hoverMessage):Re.hoverMessage?ie.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):pe.map(Re=>({range:y.from(Re)}))}function ye(pe){return typeof pe>"u"?pe:typeof pe=="string"?s.URI.file(pe):pe}var Ee;(function(pe){function Re(ae){return typeof ae>"u"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?ye(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}pe.from=Re})(Ee||(e.ThemableDecorationAttachmentRenderOptions=Ee={}));var ge;(function(pe){function Re(ae){return typeof ae>"u"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ye(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?Ee.from(ae.before):void 0,after:ae.after?Ee.from(ae.after):void 0}}pe.from=Re})(ge||(e.ThemableDecorationRenderOptions=ge={}));var ue;(function(pe){function Re(ae){if(typeof ae>"u")return ae;switch(ae){case p.DecorationRangeBehavior.OpenOpen:return 0;case p.DecorationRangeBehavior.ClosedClosed:return 1;case p.DecorationRangeBehavior.OpenClosed:return 2;case p.DecorationRangeBehavior.ClosedOpen:return 3}}pe.from=Re})(ue||(e.DecorationRangeBehavior=ue={}));var Ce;(function(pe){function Re(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?ue.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?ge.from(ae.light):void 0,dark:ae.dark?ge.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ye(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?Ee.from(ae.before):void 0,after:ae.after?Ee.from(ae.after):void 0}}pe.from=Re})(Ce||(e.DecorationRenderOptions=Ce={}));var se;(function(pe){function Re(J){return{text:J.newText,eol:J.newEol&&gt.from(J.newEol),range:y.from(J.range)}}pe.from=Re;function ae(J){const Me=new p.$rM(y.to(J.range),J.text);return Me.newEol=typeof J.eol>"u"?void 0:gt.to(J.eol),Me}pe.to=ae})(se||(e.TextEdit=se={}));var Oe;(function(pe){function Re(J,Me){const Ve={edits:[]};if(J instanceof p.$uM){const Xe=new w.$Bc;for(const qe of J._allEntries())qe._type===1&&s.URI.isUri(qe.to)&&qe.from===void 0&&Xe.add(qe.to);for(const qe of J._allEntries())if(qe._type===1){let ut;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ut={type:"base64",value:(0,O.$2e)(O.$He.wrap(qe.options.contents))}:ut={type:"dataTransferItem",id:qe.options.contents._itemId}),Ve.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ut},metadata:qe.metadata})}else qe._type===2?Ve.edits.push({resource:qe.uri,textEdit:se.from(qe.edit),versionId:Xe.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Ve.edits.push({resource:qe.uri,textEdit:{range:y.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Xe.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Ve.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Ve.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(ii.from)}})}return Ve}pe.from=Re;function ae(J){const Me=new p.$uM,Ve=new w.$Ac;for(const Xe of J.edits)if(Xe.textEdit){const qe=Xe,ut=s.URI.revive(qe.resource),yt=y.to(qe.textEdit.range),Ft=qe.textEdit.text,ct=qe.textEdit.insertAsSnippet;let Tt;ct?Tt=p.$tM.replace(yt,new p.$vM(Ft)):Tt=p.$rM.replace(yt,Ft);const Lt=Ve.get(ut);Lt?Lt.push(Tt):Ve.set(ut,[Tt])}else Me.renameFile(s.URI.revive(Xe.oldResource),s.URI.revive(Xe.newResource),Xe.options);for(const[Xe,qe]of Ve)Me.set(Xe,qe);return Me}pe.to=ae})(Oe||(e.WorkspaceEdit=Oe={}));var ne;(function(pe){const Re=Object.create(null);Re[p.SymbolKind.File]=0,Re[p.SymbolKind.Module]=1,Re[p.SymbolKind.Namespace]=2,Re[p.SymbolKind.Package]=3,Re[p.SymbolKind.Class]=4,Re[p.SymbolKind.Method]=5,Re[p.SymbolKind.Property]=6,Re[p.SymbolKind.Field]=7,Re[p.SymbolKind.Constructor]=8,Re[p.SymbolKind.Enum]=9,Re[p.SymbolKind.Interface]=10,Re[p.SymbolKind.Function]=11,Re[p.SymbolKind.Variable]=12,Re[p.SymbolKind.Constant]=13,Re[p.SymbolKind.String]=14,Re[p.SymbolKind.Number]=15,Re[p.SymbolKind.Boolean]=16,Re[p.SymbolKind.Array]=17,Re[p.SymbolKind.Object]=18,Re[p.SymbolKind.Key]=19,Re[p.SymbolKind.Null]=20,Re[p.SymbolKind.EnumMember]=21,Re[p.SymbolKind.Struct]=22,Re[p.SymbolKind.Event]=23,Re[p.SymbolKind.Operator]=24,Re[p.SymbolKind.TypeParameter]=25;function ae(Me){return typeof Re[Me]=="number"?Re[Me]:6}pe.from=ae;function J(Me){for(const Ve in Re)if(Re[Ve]===Me)return Number(Ve);return p.SymbolKind.Property}pe.to=J})(ne||(e.SymbolKind=ne={}));var j;(function(pe){function Re(J){switch(J){case p.SymbolTag.Deprecated:return 1}}pe.from=Re;function ae(J){switch(J){case 1:return p.SymbolTag.Deprecated}}pe.to=ae})(j||(e.SymbolTag=j={}));var x;(function(pe){function Re(J){return{name:J.name,kind:ne.from(J.kind),tags:J.tags&&J.tags.map(j.from),containerName:J.containerName,location:me.from(J.location)}}pe.from=Re;function ae(J){const Me=new p.$DM(J.name,ne.to(J.kind),J.containerName,me.to(J.location));return Me.tags=J.tags&&J.tags.map(j.to),Me}pe.to=ae})(x||(e.WorkspaceSymbol=x={}));var ve;(function(pe){function Re(J){const Me={name:J.name||"!!MISSING: name!!",detail:J.detail,range:y.from(J.range),selectionRange:y.from(J.selectionRange),kind:ne.from(J.kind),tags:J.tags?.map(j.from)??[]};return J.children&&(Me.children=J.children.map(Re)),Me}pe.from=Re;function ae(J){const Me=new p.$EM(J.name,J.detail,ne.to(J.kind),y.to(J.range),y.to(J.selectionRange));return(0,C.$Lb)(J.tags)&&(Me.tags=J.tags.map(j.to)),J.children&&(Me.children=J.children.map(ae)),Me}pe.to=ae})(ve||(e.DocumentSymbol=ve={}));var Fe;(function(pe){function Re(J){const Me=new p.$IM(ne.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return Me._sessionId=J._sessionId,Me._itemId=J._itemId,Me}pe.to=Re;function ae(J,Me,Ve){if(Me=Me??J._sessionId,Ve=Ve??J._itemId,Me===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ve,name:J.name,detail:J.detail,kind:ne.from(J.kind),uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(j.from)}}pe.from=ae})(Fe||(e.CallHierarchyItem=Fe={}));var ke;(function(pe){function Re(ae){return new p.$JM(Fe.to(ae.from),ae.fromRanges.map(J=>y.to(J)))}pe.to=Re})(ke||(e.CallHierarchyIncomingCall=ke={}));var we;(function(pe){function Re(ae){return new p.$KM(Fe.to(ae.to),ae.fromRanges.map(J=>y.to(J)))}pe.to=Re})(we||(e.CallHierarchyOutgoingCall=we={}));var me;(function(pe){function Re(J){return{range:J.range&&y.from(J.range),uri:J.uri}}pe.from=Re;function ae(J){return new p.$wM(s.URI.revive(J.uri),y.to(J.range))}pe.to=ae})(me||(e.location=me={}));var Q;(function(pe){function Re(J){const Me=J,Ve=J;return{originSelectionRange:Me.originSelectionRange?y.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Ve.uri,range:y.from(Me.targetRange?Me.targetRange:Ve.range),targetSelectionRange:Me.targetSelectionRange?y.from(Me.targetSelectionRange):void 0}}pe.from=Re;function ae(J){return{targetUri:s.URI.revive(J.uri),targetRange:y.to(J.range),targetSelectionRange:J.targetSelectionRange?y.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?y.to(J.originSelectionRange):void 0}}pe.to=ae})(Q||(e.DefinitionLink=Q={}));var Y;(function(pe){function Re(J){return{range:y.from(J.range),contents:ie.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}pe.from=Re;function ae(J){const Me=J.contents.map(ie.to),Ve=y.to(J.range),Xe=J.canIncreaseVerbosity,qe=J.canDecreaseVerbosity;return new p.$AM(Me,Ve,Xe,qe)}pe.to=ae})(Y||(e.Hover=Y={}));var he;(function(pe){function Re(J){return{range:y.from(J.range),expression:J.expression}}pe.from=Re;function ae(J){return new p.$vN(y.to(J.range),J.expression)}pe.to=ae})(he||(e.EvaluatableExpression=he={}));var ce;(function(pe){function Re(J){if(J instanceof p.$wN)return{type:"text",range:y.from(J.range),text:J.text};if(J instanceof p.$xN)return{type:"variable",range:y.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof p.$yN)return{type:"expression",range:y.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}pe.from=Re;function ae(J){switch(J.type){case"text":return{range:y.to(J.range),text:J.text};case"variable":return{range:y.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:y.to(J.range),expression:J.expression}}}pe.to=ae})(ce||(e.InlineValue=ce={}));var Ne;(function(pe){function Re(J){return{frameId:J.frameId,stoppedLocation:y.from(J.stoppedLocation)}}pe.from=Re;function ae(J){return new p.$zN(J.frameId,y.to(J.stoppedLocation))}pe.to=ae})(Ne||(e.InlineValueContext=Ne={}));var fe;(function(pe){function Re(J){return{range:y.from(J.range),kind:J.kind}}pe.from=Re;function ae(J){return new p.$BM(y.to(J.range),J.kind)}pe.to=ae})(fe||(e.DocumentHighlight=fe={}));var Pe;(function(pe){function Re(J){return{uri:J.uri,highlights:J.highlights.map(fe.from)}}pe.from=Re;function ae(J){return new p.$CM(s.URI.revive(J.uri),J.highlights.map(fe.to))}pe.to=ae})(Pe||(e.MultiDocumentHighlight=Pe={}));var Ae;(function(pe){function Re(ae){switch(ae){case 1:return p.CompletionTriggerKind.TriggerCharacter;case 2:return p.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return p.CompletionTriggerKind.Invoke}}pe.to=Re})(Ae||(e.CompletionTriggerKind=Ae={}));var Ue;(function(pe){function Re(ae){return{triggerKind:Ae.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}pe.to=Re})(Ue||(e.CompletionContext=Ue={}));var B;(function(pe){function Re(J){switch(J){case p.CompletionItemTag.Deprecated:return 1}}pe.from=Re;function ae(J){switch(J){case 1:return p.CompletionItemTag.Deprecated}}pe.to=ae})(B||(e.CompletionItemTag=B={}));var L;(function(pe){const Re=new Map([[p.CompletionItemKind.Method,0],[p.CompletionItemKind.Function,1],[p.CompletionItemKind.Constructor,2],[p.CompletionItemKind.Field,3],[p.CompletionItemKind.Variable,4],[p.CompletionItemKind.Class,5],[p.CompletionItemKind.Interface,7],[p.CompletionItemKind.Struct,6],[p.CompletionItemKind.Module,8],[p.CompletionItemKind.Property,9],[p.CompletionItemKind.Unit,12],[p.CompletionItemKind.Value,13],[p.CompletionItemKind.Constant,14],[p.CompletionItemKind.Enum,15],[p.CompletionItemKind.EnumMember,16],[p.CompletionItemKind.Keyword,17],[p.CompletionItemKind.Snippet,27],[p.CompletionItemKind.Text,18],[p.CompletionItemKind.Color,19],[p.CompletionItemKind.File,20],[p.CompletionItemKind.Reference,21],[p.CompletionItemKind.Folder,23],[p.CompletionItemKind.Event,10],[p.CompletionItemKind.Operator,11],[p.CompletionItemKind.TypeParameter,24],[p.CompletionItemKind.Issue,26],[p.CompletionItemKind.User,25]]);function ae(Ve){return Re.get(Ve)??9}pe.from=ae;const J=new Map([[0,p.CompletionItemKind.Method],[1,p.CompletionItemKind.Function],[2,p.CompletionItemKind.Constructor],[3,p.CompletionItemKind.Field],[4,p.CompletionItemKind.Variable],[5,p.CompletionItemKind.Class],[7,p.CompletionItemKind.Interface],[6,p.CompletionItemKind.Struct],[8,p.CompletionItemKind.Module],[9,p.CompletionItemKind.Property],[12,p.CompletionItemKind.Unit],[13,p.CompletionItemKind.Value],[14,p.CompletionItemKind.Constant],[15,p.CompletionItemKind.Enum],[16,p.CompletionItemKind.EnumMember],[17,p.CompletionItemKind.Keyword],[27,p.CompletionItemKind.Snippet],[18,p.CompletionItemKind.Text],[19,p.CompletionItemKind.Color],[20,p.CompletionItemKind.File],[21,p.CompletionItemKind.Reference],[23,p.CompletionItemKind.Folder],[10,p.CompletionItemKind.Event],[11,p.CompletionItemKind.Operator],[24,p.CompletionItemKind.TypeParameter],[25,p.CompletionItemKind.User],[26,p.CompletionItemKind.Issue]]);function Me(Ve){return J.get(Ve)??p.CompletionItemKind.Property}pe.to=Me})(L||(e.CompletionItemKind=L={}));var K;(function(pe){function Re(ae,J){const Me=new p.$SM(ae.label);return Me.insertText=ae.insertText,Me.kind=L.to(ae.kind),Me.tags=ae.tags?.map(B.to),Me.detail=ae.detail,Me.documentation=R.$Xk(ae.documentation)?ie.to(ae.documentation):ae.documentation,Me.sortText=ae.sortText,Me.filterText=ae.filterText,Me.preselect=ae.preselect,Me.commitCharacters=ae.commitCharacters,o.$xt.isIRange(ae.range)?Me.range=y.to(ae.range):typeof ae.range=="object"&&(Me.range={inserting:y.to(ae.range.insert),replacing:y.to(ae.range.replace)}),Me.keepWhitespace=typeof ae.insertTextRules>"u"?!1:!!(ae.insertTextRules&1),typeof ae.insertTextRules<"u"&&ae.insertTextRules&4?Me.insertText=new p.$vM(ae.insertText):(Me.insertText=ae.insertText,Me.textEdit=Me.range instanceof p.$mM?new p.$rM(Me.range,Me.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Me.additionalTextEdits=ae.additionalTextEdits.map(Ve=>se.to(Ve))),Me.command=J&&ae.command?J.fromInternal(ae.command):void 0,Me}pe.to=Re})(K||(e.CompletionItem=K={}));var H;(function(pe){function Re(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:ie.fromStrict(J.documentation)}}pe.from=Re;function ae(J){return{label:J.label,documentation:R.$Xk(J.documentation)?ie.to(J.documentation):J.documentation}}pe.to=ae})(H||(e.ParameterInformation=H={}));var ee;(function(pe){function Re(J){return{label:J.label,documentation:ie.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(H.from):[],activeParameter:J.activeParameter}}pe.from=Re;function ae(J){return{label:J.label,documentation:R.$Xk(J.documentation)?ie.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(H.to):[],activeParameter:J.activeParameter}}pe.to=ae})(ee||(e.SignatureInformation=ee={}));var re;(function(pe){function Re(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.from):[]}}pe.from=Re;function ae(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.to):[]}}pe.to=ae})(re||(e.SignatureHelp=re={}));var Te;(function(pe){function Re(ae,J){const Me=new p.$RM(k.to(J.position),typeof J.label=="string"?J.label:J.label.map(Be.to.bind(void 0,ae)),J.kind&&He.to(J.kind));return Me.textEdits=J.textEdits&&J.textEdits.map(se.to),Me.tooltip=R.$Xk(J.tooltip)?ie.to(J.tooltip):J.tooltip,Me.paddingLeft=J.paddingLeft,Me.paddingRight=J.paddingRight,Me}pe.to=Re})(Te||(e.InlayHint=Te={}));var Be;(function(pe){function Re(ae,J){const Me=new p.$QM(J.label);return Me.tooltip=R.$Xk(J.tooltip)?ie.to(J.tooltip):J.tooltip,i.Command.is(J.command)&&(Me.command=ae.fromInternal(J.command)),J.location&&(Me.location=me.to(J.location)),Me}pe.to=Re})(Be||(e.InlayHintLabelPart=Be={}));var He;(function(pe){function Re(J){return J}pe.from=Re;function ae(J){return J}pe.to=ae})(He||(e.InlayHintKind=He={}));var _e;(function(pe){function Re(J){return{range:y.from(J.range),url:J.target,tooltip:J.tooltip}}pe.from=Re;function ae(J){let Me;if(J.url)try{Me=typeof J.url=="string"?s.URI.parse(J.url,!0):s.URI.revive(J.url)}catch{}return new p.$XM(y.to(J.range),Me)}pe.to=ae})(_e||(e.DocumentLink=_e={}));var xe;(function(pe){function Re(J){const Me=new p.$1M(J.label);return J.textEdit&&(Me.textEdit=se.to(J.textEdit)),J.additionalTextEdits&&(Me.additionalTextEdits=J.additionalTextEdits.map(Ve=>se.to(Ve))),Me}pe.to=Re;function ae(J){return{label:J.label,textEdit:J.textEdit?se.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Me=>se.from(Me)):void 0}}pe.from=ae})(xe||(e.ColorPresentation=xe={}));var et;(function(pe){function Re(J){return new p.$YM(J[0],J[1],J[2],J[3])}pe.to=Re;function ae(J){return[J.red,J.green,J.blue,J.alpha]}pe.from=ae})(et||(e.Color=et={}));var tt;(function(pe){function Re(J){return{range:y.from(J.range)}}pe.from=Re;function ae(J){return new p.$HM(y.to(J.range))}pe.to=ae})(tt||(e.SelectionRange=tt={}));var it;(function(pe){function Re(ae){switch(ae){case 2:return p.TextDocumentSaveReason.AfterDelay;case 1:return p.TextDocumentSaveReason.Manual;case 3:case 4:return p.TextDocumentSaveReason.FocusOut}}pe.to=Re})(it||(e.TextDocumentSaveReason=it={}));var ot;(function(pe){function Re(J){switch(J){case p.TextEditorLineNumbersStyle.Off:return 0;case p.TextEditorLineNumbersStyle.Relative:return 2;case p.TextEditorLineNumbersStyle.Interval:return 3;case p.TextEditorLineNumbersStyle.On:default:return 1}}pe.from=Re;function ae(J){switch(J){case 0:return p.TextEditorLineNumbersStyle.Off;case 2:return p.TextEditorLineNumbersStyle.Relative;case 3:return p.TextEditorLineNumbersStyle.Interval;case 1:default:return p.TextEditorLineNumbersStyle.On}}pe.to=ae})(ot||(e.TextEditorLineNumbersStyle=ot={}));var gt;(function(pe){function Re(J){if(J===p.EndOfLine.CRLF)return 1;if(J===p.EndOfLine.LF)return 0}pe.from=Re;function ae(J){if(J===1)return p.EndOfLine.CRLF;if(J===0)return p.EndOfLine.LF}pe.to=ae})(gt||(e.EndOfLine=gt={}));var je;(function(pe){function Re(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case p.ProgressLocation.SourceControl:return 3;case p.ProgressLocation.Window:return 10;case p.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}pe.from=Re})(je||(e.ProgressLocation=je={}));var rt;(function(pe){function Re(J){const Me={start:J.start+1,end:J.end+1};return J.kind&&(Me.kind=Z.from(J.kind)),Me}pe.from=Re;function ae(J){const Me={start:J.start-1,end:J.end-1};return J.kind&&(Me.kind=Z.to(J.kind)),Me}pe.to=ae})(rt||(e.FoldingRange=rt={}));var Z;(function(pe){function Re(J){if(J)switch(J){case p.FoldingRangeKind.Comment:return i.$gu.Comment;case p.FoldingRangeKind.Imports:return i.$gu.Imports;case p.FoldingRangeKind.Region:return i.$gu.Region}}pe.from=Re;function ae(J){if(J)switch(J.value){case i.$gu.Comment.value:return p.FoldingRangeKind.Comment;case i.$gu.Imports.value:return p.FoldingRangeKind.Imports;case i.$gu.Region.value:return p.FoldingRangeKind.Region}}pe.to=ae})(Z||(e.FoldingRangeKind=Z={}));var X;(function(pe){function Re(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?y.from(ae.selection):void 0,override:typeof ae.override=="boolean"?u.$xF.id:void 0}}pe.from=Re})(X||(e.TextEditorOpenOptions=X={}));var $e;(function(pe){function Re(Ve){return Ve instanceof p.$jN?Ve.toJSON():typeof Ve=="string"?Ve:ae(Ve)||J(Ve)?new p.$jN(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}pe.from=Re;function ae(Ve){const Xe=Ve;return Xe?s.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function J(Ve){const Xe=Ve;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Me(Ve){return typeof Ve=="string"?Ve:new p.$jN(s.URI.revive(Ve.baseUri),Ve.pattern)}pe.to=Me})($e||(e.GlobPattern=$e={}));var Ke;(function(pe){function Re(ae){if(ae){if(Array.isArray(ae))return ae.map(Re);if(typeof ae=="string")return ae;{const J=ae;return{language:J.language,scheme:J.scheme,pattern:$e.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}pe.from=Re})(Ke||(e.LanguageSelector=Ke={}));var be;(function(pe){function Re(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Me=>Array.isArray(Me)&&Me.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&s.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(Xe=>Xe instanceof p.$mM)))}pe.is=Re;function ae(J){return{documents:J.documents.map(Me=>Me.map(Ve=>({uri:s.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(Xe=>y.from(Xe))})))}}pe.from=ae})(be||(e.MappedEditsContext=be={}));var st;(function(pe){function Re(J){return{start:J.start,end:J.end}}pe.from=Re;function ae(J){return new p.$MN(J.start,J.end)}pe.to=ae})(st||(e.NotebookRange=st={}));var dt;(function(pe){function Re(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}pe.to=Re;function ae(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}pe.from=ae})(dt||(e.NotebookCellExecutionSummary=dt={}));var Ct;(function(pe){function Re(ae){if(ae===f.NotebookCellExecutionState.Unconfirmed)return p.NotebookCellExecutionState.Pending;if(ae===f.NotebookCellExecutionState.Pending)return;if(ae===f.NotebookCellExecutionState.Executing)return p.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ae}`)}pe.to=Re})(Ct||(e.NotebookCellExecutionState=Ct={}));var Vt;(function(pe){function Re(J){switch(J){case p.NotebookCellKind.Markup:return f.CellKind.Markup;case p.NotebookCellKind.Code:default:return f.CellKind.Code}}pe.from=Re;function ae(J){switch(J){case f.CellKind.Markup:return p.NotebookCellKind.Markup;case f.CellKind.Code:default:return p.NotebookCellKind.Code}}pe.to=ae})(Vt||(e.NotebookCellKind=Vt={}));var Qt;(function(pe){function Re(J){const Me={metadata:J.metadata??Object.create(null),cells:[]};for(const Ve of J.cells)p.$NN.validate(Ve),Me.cells.push(ii.from(Ve));return Me}pe.from=Re;function ae(J){const Me=new p.$ON(J.cells.map(ii.to));return(0,r.$lg)(J.metadata)||(Me.metadata=J.metadata),Me}pe.to=ae})(Qt||(e.NotebookData=Qt={}));var ii;(function(pe){function Re(J){return{cellKind:Vt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:dt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Et.from):[]}}pe.from=Re;function ae(J){return new p.$NN(Vt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Et.to):void 0,J.metadata,J.internalMetadata?dt.to(J.internalMetadata):void 0)}pe.to=ae})(ii||(e.NotebookCellData=ii={}));var Xt;(function(pe){function Re(J){return{mime:J.mime,valueBytes:O.$He.wrap(J.data)}}pe.from=Re;function ae(J){return new p.$PN(J.valueBytes.buffer,J.mime)}pe.to=ae})(Xt||(e.NotebookCellOutputItem=Xt={}));var Et;(function(pe){function Re(J){return{outputId:J.id,items:J.items.map(Xt.from),metadata:J.metadata}}pe.from=Re;function ae(J){const Me=J.items.map(Xt.to);return new p.$QN(Me,J.outputId,J.metadata)}pe.to=ae})(Et||(e.NotebookCellOutput=Et={}));var Zt;(function(pe){function Re(Me){return J(Me)?{include:$e.from(Me.include)??void 0,exclude:$e.from(Me.exclude)??void 0}:$e.from(Me)??void 0}pe.from=Re;function ae(Me){return J(Me)?{include:$e.to(Me.include),exclude:$e.to(Me.exclude)}:$e.to(Me)}pe.to=ae;function J(Me){const Ve=Me;return Ve?!(0,r.$hg)(Ve.include)&&!(0,r.$hg)(Ve.exclude):!1}})(Zt||(e.NotebookExclusiveDocumentPattern=Zt={}));var Yt;(function(pe){function Re(ae,J,Me){const Ve=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===p.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ve,Me),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}pe.from=Re})(Yt||(e.NotebookStatusBarItem=Yt={}));var Ze;(function(pe){function Re(ae,J,Me){const Ve=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{command:J.toInternal(Ve,Me),label:ae.label,description:ae.description,detail:ae.detail,documentation:ae.documentation}}pe.from=Re})(Ze||(e.NotebookKernelSourceAction=Ze={}));var si;(function(pe){function Re(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{},cellContentMetadata:ae?.cellContentMetadata??{}}}pe.from=Re})(si||(e.NotebookDocumentContentOptions=si={}));var Ht;(function(pe){function Re(J){return{uri:J.uri,provides:J.provides}}pe.from=Re;function ae(J){return new p.$SN(s.URI.revive(J.uri),J.provides)}pe.to=ae})(Ht||(e.NotebookRendererScript=Ht={}));var ht;(function(pe){function Re(J){return{message:ie.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:y.from(J.location.range),uri:J.location.uri}}}pe.from=Re;function ae(J){const Me=new p.$YN(typeof J.message=="string"?J.message:ie.to(J.message));return Me.actualOutput=J.actual,Me.expectedOutput=J.expected,Me.contextValue=J.contextValue,Me.location=J.location?me.to(J.location):void 0,Me}pe.to=ae})(ht||(e.TestMessage=ht={}));var mt;(function(pe){pe.namespace=d.$_K,pe.denamespace=d.$aL})(mt||(e.TestTag=mt={}));var xt;(function(pe){function Re(J){const Me=(0,c.$IO)(J).controllerId;return{extId:a.$7K.fromExtHostTestItem(J,Me).toString(),label:J.label,uri:s.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ve=>mt.namespace(Me,Ve.id)),range:o.$xt.lift(y.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&ie.fromStrict(J.error)||null}}pe.from=Re;function ae(J){return{parent:void 0,error:void 0,id:a.$7K.fromString(J.extId).localId,label:J.label,uri:s.URI.revive(J.uri),tags:(J.tags||[]).map(Me=>{const{tagId:Ve}=mt.denamespace(Me);return new p.$ZN(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:y.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}pe.toPlain=ae})(xt||(e.TestItem=xt={})),function(pe){function Re(J){return{id:J.id}}pe.from=Re;function ae(J){return new p.$ZN(J.id)}pe.to=ae}(mt||(e.TestTag=mt={}));var Gt;(function(pe){const Re=(J,Me)=>{const Ve=J.value;if(!Ve)return;const Xe={...xt.toPlain(Ve.item),parent:Me,taskStates:Ve.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ut=>ut.type===0).map(ht.to)})),children:[]};if(J.children)for(const qe of J.children.values()){const ut=Re(qe,Xe);ut&&Xe.children.push(ut)}return Xe};function ae(J){const Me=new l.$BO;for(const qe of J.items)Me.insert(a.$7K.fromString(qe.item.extId).path,qe);const Ve=[Me.nodes],Xe=[];for(;Ve.length;)for(const qe of Ve.pop())qe.value?Xe.push(qe):qe.children&&Ve.push(qe.children.values());return{completedAt:J.completedAt,results:Xe.map(qe=>Re(qe)).filter(r.$gg)}}pe.to=ae})(Gt||(e.TestResults=Gt={}));var Nt;(function(pe){function Re(Ve){return{covered:Ve.covered,total:Ve.total}}function ae(Ve){return"line"in Ve?k.from(Ve):y.from(Ve)}function J(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:ae(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&ae(Xe.location),label:Xe.label})):void 0}:{type:0,name:Ve.name,count:Ve.executed,location:ae(Ve.location)}}pe.fromDetails=J;function Me(Ve,Xe,qe){return p.$2N(qe.statementCoverage),p.$2N(qe.branchCoverage),p.$2N(qe.declarationCoverage),{id:Xe,uri:qe.uri,statement:Re(qe.statementCoverage),branch:qe.branchCoverage&&Re(qe.branchCoverage),declaration:qe.declarationCoverage&&Re(qe.declarationCoverage),testId:qe instanceof p.$3N&&qe.testItem?a.$7K.fromExtHostTestItem(qe.testItem,Ve).toString():void 0}}pe.fromFile=Me})(Nt||(e.TestCoverage=Nt={}));var ft;(function(pe){function Re(ae){switch(ae){case 1:return p.CodeActionTriggerKind.Invoke;case 2:return p.CodeActionTriggerKind.Automatic}}pe.to=Re})(ft||(e.CodeActionTriggerKind=ft={}));var Bt;(function(pe){function Re(J){const Me=new p.$7N(ne.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return Me._sessionId=J._sessionId,Me._itemId=J._itemId,Me}pe.to=Re;function ae(J,Me,Ve){if(Me=Me??J._sessionId,Ve=Ve??J._itemId,Me===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ve,kind:ne.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(j.from)}}pe.from=ae})(Bt||(e.TypeHierarchyItem=Bt={}));var _t;(function(pe){function Re(ae){if(ae)return{value:ae.value,tooltip:ae.tooltip}}pe.from=Re})(_t||(e.ViewBadge=_t={}));var zt;(function(pe){function Re(Ve,Xe,qe){const ut=Xe.fileData;return ut?new p.$bN(new p.$cN(ut.name,s.URI.revive(ut.uri),ut.id,(0,N.$db)(()=>qe(ut.id)))):Ve===T.$Ts.uriList&&Xe.uriListData?new p.$aN(Me(Xe.uriListData)):new p.$aN(Xe.asString)}pe.to=Re;async function ae(Ve,Xe){const qe=await Xe.asString();if(Ve===T.$Ts.uriList)return{asString:qe,fileData:void 0,uriListData:J(qe)};const ut=Xe.asFile();return{asString:qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}pe.from=ae;function J(Ve){return M.$Xt.split(Ve).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return s.URI.parse(Xe)}catch{}return Xe})}function Me(Ve){return M.$Xt.create(Ve.map(Xe=>typeof Xe=="string"?Xe:s.URI.revive(Xe)))}})(zt||(e.DataTransferItem=zt={}));var Qe;(function(pe){function Re(J,Me){const Ve=J.items.map(([Xe,qe])=>[Xe,zt.to(Xe,qe,Me)]);return new p.$dN(Ve)}pe.toDataTransfer=Re;async function ae(J){const Me={items:[]},Ve=[];for(const[Xe,qe]of J)Ve.push((async()=>{Me.items.push([Xe,await zt.from(Xe,qe)])})());return await Promise.all(Ve),Me}pe.from=ae})(Qe||(e.DataTransfer=Qe={}));var ui;(function(pe){function Re(J,Me){return{kind:"reply",agentId:J.participant??Me?.agentId??"",subCommand:J.command??Me?.command,message:J.prompt,title:J.label}}pe.from=Re;function ae(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}pe.to=ae})(ui||(e.ChatFollowup=ui={}));var Jt;(function(pe){function Re(J){switch(J.role){case 0:return new p.$vO(p.LanguageModelChatMessageRole.System,J.content);case 1:return new p.$vO(p.LanguageModelChatMessageRole.User,J.content);case 2:return new p.$vO(p.LanguageModelChatMessageRole.Assistant,J.content)}}pe.to=Re;function ae(J){switch(J.role){case p.LanguageModelChatMessageRole.System:return{role:0,content:J.content};case p.LanguageModelChatMessageRole.User:return{role:1,content:J.content};case p.LanguageModelChatMessageRole.Assistant:return{role:2,content:J.content}}}pe.from=ae})(Jt||(e.LanguageModelChatMessage=Jt={}));var jt;(function(pe){function Re(J){return{kind:"markdownContent",content:ie.from(J.value)}}pe.from=Re;function ae(J){return new p.$hO(ie.to(J.content))}pe.to=ae})(jt||(e.ChatResponseMarkdownPart=jt={}));var wt;(function(pe){function Re(J){return{kind:"markdownVuln",content:ie.from(J.value),vulnerabilities:J.vulnerabilities}}pe.from=Re;function ae(J){return new p.$iO(ie.to(J.content),J.vulnerabilities)}pe.to=ae})(wt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=wt={}));var Ut;(function(pe){function Re(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}pe.from=Re;function ae(J){return new p.$jO(J.agentId,J.command)}pe.to=ae})(Ut||(e.ChatResponseDetectedParticipantPart=Ut={}));var Mt;(function(pe){function Re(ae){return{kind:"confirmation",title:ae.title,message:ae.message,data:ae.data}}pe.from=Re})(Mt||(e.ChatResponseConfirmationPart=Mt={}));var Rt;(function(pe){function Re(J){const{value:Me,baseUri:Ve}=J;function Xe(qe,ut){return qe.map(yt=>{const Ft=s.URI.joinPath(ut,yt.name);return{label:yt.name,uri:Ft,children:yt.children&&Xe(yt.children,Ft)}})}return{kind:"treeData",treeData:{label:(0,b.$9g)(Ve),uri:Ve,children:Xe(Me,Ve)}}}pe.from=Re;function ae(J){const Me=(0,E.$8h)(J.treeData);function Ve(ut){return ut.map(yt=>({name:yt.label,children:yt.children&&Ve(yt.children)}))}const Xe=Me.uri,qe=Me.children?Ve(Me.children):[];return new p.$lO(qe,Xe)}pe.to=ae})(Rt||(e.ChatResponseFilesPart=Rt={}));var ei;(function(pe){function Re(J){return{kind:"inlineReference",name:J.title,inlineReference:s.URI.isUri(J.value)?J.value:h.from(J.value)}}pe.from=Re;function ae(J){const Me=(0,E.$8h)(J);return new p.$mO(s.URI.isUri(Me.inlineReference)?Me.inlineReference:h.to(Me.inlineReference),J.name)}pe.to=ae})(ei||(e.ChatResponseAnchorPart=ei={}));var Wt;(function(pe){function Re(J){return{kind:"progressMessage",content:ie.from(J.value)}}pe.from=Re;function ae(J){return new p.$nO(J.content.value)}pe.to=ae})(Wt||(e.ChatResponseProgressPart=Wt={}));var oi;(function(pe){function Re(J){return{kind:"warning",content:ie.from(J.value)}}pe.from=Re;function ae(J){return new p.$pO(J.content.value)}pe.to=ae})(oi||(e.ChatResponseWarningPart=oi={}));var Ot;(function(pe){function Re(ae){return{kind:"progressTask",content:ie.from(ae.value)}}pe.from=Re})(Ot||(e.ChatTask=Ot={}));var qt;(function(pe){function Re(ae){return{kind:"progressTaskResult",content:typeof ae=="string"?ie.from(ae):void 0}}pe.from=Re})(qt||(e.ChatTaskResult=qt={}));var At;(function(pe){function Re(J,Me,Ve){return{kind:"command",command:Me.toInternal(J.value,Ve)??{command:J.value.command,title:J.value.title}}}pe.from=Re;function ae(J,Me){return new p.$qO(Me.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}pe.to=ae})(At||(e.ChatResponseCommandButtonPart=At={}));var St;(function(pe){function Re(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(Me=>se.from(Me))}}pe.from=Re;function ae(J){return new p.$sO(s.URI.revive(J.uri),J.edits.map(Me=>se.to(Me)))}pe.to=ae})(St||(e.ChatResponseTextEditPart=St={}));var $t;(function(pe){function Re(J){const Me=g.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:J.iconPath&&"light"in J.iconPath&&"dark"in J.iconPath&&s.URI.isUri(J.iconPath.light)&&s.URI.isUri(J.iconPath.dark)?{light:s.URI.revive(J.iconPath.light),dark:s.URI.revive(J.iconPath.dark)}:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:s.URI.isUri(J.value.value)||!J.value.value?J.value.value:h.from(J.value.value)},iconPath:Me}:{kind:"reference",reference:s.URI.isUri(J.value)?J.value:h.from(J.value),iconPath:Me}}pe.from=Re;function ae(J){const Me=(0,E.$8h)(J),Ve=Xe=>s.URI.isUri(Xe)?Xe:h.to(Xe);return new p.$rO("variableName"in Me.reference?{variableName:Me.reference.variableName,value:Me.reference.value&&Ve(Me.reference.value)}:Ve(Me.reference))}pe.to=ae})($t||(e.ChatResponseReferencePart=$t={}));var Dt;(function(pe){function Re(Me,Ve,Xe){return Me instanceof p.$hO?jt.from(Me):Me instanceof p.$mO?ei.from(Me):Me instanceof p.$rO?$t.from(Me):Me instanceof p.$nO?Wt.from(Me):Me instanceof p.$lO?Rt.from(Me):Me instanceof p.$qO?At.from(Me,Ve,Xe):Me instanceof p.$sO?St.from(Me):Me instanceof p.$iO?wt.from(Me):Me instanceof p.$jO?Ut.from(Me):Me instanceof p.$pO?oi.from(Me):{kind:"markdownContent",content:ie.from("")}}pe.from=Re;function ae(Me,Ve){switch(Me.kind){case"reference":return $t.to(Me);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(Me,Ve)}}pe.to=ae;function J(Me,Ve){switch(Me.kind){case"markdownContent":return jt.to(Me);case"inlineReference":return ei.to(Me);case"progressMessage":return;case"treeData":return Rt.to(Me);case"command":return At.to(Me,Ve)}}pe.toContent=J})(Dt||(e.ChatResponsePart=Dt={}));var ai;(function(pe){function Re(ae){return{prompt:ae.message,command:ae.command,attempt:ae.attempt??0,enableCommandDetection:ae.enableCommandDetection??!0,variables:ae.variables.variables.map(fi.to),location:kt.to(ae.location),acceptedConfirmationData:ae.acceptedConfirmationData,rejectedConfirmationData:ae.rejectedConfirmationData}}pe.to=Re})(ai||(e.ChatAgentRequest=ai={}));var kt;(function(pe){function Re(ae){switch(ae){case t.ChatAgentLocation.Notebook:return p.ChatLocation.Notebook;case t.ChatAgentLocation.Terminal:return p.ChatLocation.Terminal;case t.ChatAgentLocation.Panel:return p.ChatLocation.Panel;case t.ChatAgentLocation.Editor:return p.ChatLocation.Editor}}pe.to=Re})(kt||(e.ChatLocation=kt={}));var fi;(function(pe){function Re(ae){const J=ae.value;if(!J)throw new Error("Invalid value reference");return{name:ae.name,range:ae.range&&[ae.range.start,ae.range.endExclusive],value:(0,s.$vc)(J)?s.URI.revive(J):J}}pe.to=Re})(fi||(e.ChatAgentValueReference=fi={}));var ni;(function(pe){function Re(ae,J,Me){return{label:ae.label,value:ae.values[0].value,insertText:ae.insertText,detail:ae.detail,documentation:ae.documentation,command:J.toInternal(ae.command,Me)}}pe.from=Re})(ni||(e.ChatAgentCompletionItem=ni={}));var $i;(function(pe){function Re(ae){return{errorDetails:ae.errorDetails,metadata:ae.metadata}}pe.to=Re})($i||(e.ChatAgentResult=$i={}));var li;(function(pe){function Re(ae,J,Me){if(J.action.kind==="vote")return;const Ve=$i.to(ae);if(J.action.kind==="command"){const Xe=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Me.fromInternal(Xe)??{command:Xe.id,title:Xe.title}}},result:Ve}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:ui.to(J.action.followup)},result:Ve}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Ve}:{action:J.action,result:Ve}}pe.to=Re})(li||(e.ChatAgentUserActionEvent=li={}));var bi;(function(pe){function Re(ae,J,Me){return"terminalCommand"in ae?{terminalCommand:ae.terminalCommand,shouldExecute:ae.shouldExecute}:"uri"in ae?{uri:ae.uri}:J.toInternal(ae,Me)}pe.from=Re})(bi||(e.TerminalQuickFix=bi={}));var It;(function(pe){function Re(ae){return{kind:Ei.to(ae.kind)}}pe.to=Re})(It||(e.PartialAcceptInfo=It={}));var Ei;(function(pe){function Re(ae){switch(ae){case 0:return p.PartialAcceptTriggerKind.Word;case 1:return p.PartialAcceptTriggerKind.Line;case 2:return p.PartialAcceptTriggerKind.Suggest;default:return p.PartialAcceptTriggerKind.Unknown}}pe.to=Re})(Ei||(e.PartialAcceptTriggerKind=Ei={}));var ri;(function(pe){function Re(ae,J){return{id:J,label:ae.label,description:ae.description,canEdit:ae.canEdit,collapsibleState:ae.collapsibleState||0,contextValue:ae.contextValue}}pe.from=Re})(ri||(e.DebugTreeItem=ri={}))}),define(Se[263],Ie([1,0,4,17,8,34]),function(le,e,C,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=void 0;let R=class{constructor(m,E){this.a=m.getProxy(C.$iM.MainThreadBulkEdits),this.b={getTextDocumentVersion:T=>E.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,E,T){const S=new N.$Ew(M.WorkspaceEdit.from(m,this.b));return this.a.$tryApplyWorkspaceEdit(S,void 0,T?.isRefactoring??!1)}};e.$_lc=R,e.$_lc=R=Je([We(0,O.$MO)],R)}),define(Se[264],Ie([1,0,18,11,44,5,42,6,66,15,2,21,4,8,7,225,25]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$amc=void 0;class o{constructor(u,t,f,a,d){this.j=u,this.k=t,this.l=f,this.m=a,this.n=d,this.b=m.$be.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(a){if(u.c){const d=new Error("Response stream has been closed");throw Error.captureStackTrace(d,a),d}};const u=this;this.b.reset();const f=(a,d)=>{typeof this.d>"u"&&"content"in a&&(this.d=this.b.elapsed()),Promise.all([this.l.$handleProgressChunk(this.k.requestId,a),d?d():void 0]).then(([$,p])=>{typeof $=="number"&&d&&this.l.$handleProgressChunk(this.k.requestId,b.ChatTaskResult.from(p),$)})};this.g={markdown(a){t(this.markdown);const d=new g.$hO(a),$=b.ChatResponseMarkdownPart.from(d);return f($),this},markdownWithVulnerabilities(a,d){t(this.markdown),d&&(0,s.$KG)(u.j,"chatParticipantAdditions");const $=new g.$iO(a,d),p=b.ChatResponseMarkdownWithVulnerabilitiesPart.from($);return f(p),this},filetree(a,d){t(this.filetree);const $=new g.$lO(a,d),p=b.ChatResponseFilesPart.from($);return f(p),this},anchor(a,d){t(this.anchor);const $=new g.$mO(a,d),p=b.ChatResponseAnchorPart.from($);return f(p),this},button(a){t(this.anchor);const d=new g.$qO(a),$=b.ChatResponseCommandButtonPart.from(d,u.m,u.n);return f($),this},progress(a,d){t(this.progress);const $=new g.$oO(a,d),p=d?b.ChatTask.from($):b.ChatResponseProgressPart.from($);return f(p,d),this},warning(a){t(this.progress),(0,s.$KG)(u.j,"chatParticipantAdditions");const d=new g.$pO(a),$=b.ChatResponseWarningPart.from(d);return f($),this},reference(a,d){if(t(this.reference),"variableName"in a&&!a.value){const $=u.k.variables.variables.find(p=>p.name===a.variableName);if($){let p;if($.references?.length)p=$.references.map(v=>({kind:"reference",reference:{variableName:a.variableName,value:v.reference}}));else{const v=new g.$rO(a,d);p=[b.ChatResponseReferencePart.from(v)]}return p.forEach(v=>f(v)),this}}else{const $=new g.$rO(a,d),p=b.ChatResponseReferencePart.from($);f(p)}return this},textEdit(a,d){t(this.textEdit),(0,s.$KG)(u.j,"chatParticipantAdditions");const $=new g.$sO(a,d),p=b.ChatResponseTextEditPart.from($);return f(p),this},detectedParticipant(a,d){t(this.detectedParticipant),(0,s.$KG)(u.j,"chatParticipantAdditions");const $=new g.$jO(a,d),p=b.ChatResponseDetectedParticipantPart.from($);return f(p),this},confirmation(a,d,$){t(this.confirmation),(0,s.$KG)(u.j,"chatParticipantAdditions");const p=new g.$kO(a,d,$),v=b.ChatResponseConfirmationPart.from(p);return f(v),this},push(a){if(t(this.push),(a instanceof g.$sO||a instanceof g.$iO||a instanceof g.$jO||a instanceof g.$pO||a instanceof g.$kO)&&(0,s.$KG)(u.j,"chatParticipantAdditions"),a instanceof g.$rO)this.reference(a.value,a.iconPath);else{const d=b.ChatResponsePart.from(a,u.m,u.n);f(d)}return this}}}return this.g}}class i extends w.$Uc{static{this.b=0}constructor(u,t,f){super(),this.n=t,this.s=f,this.c=new Map,this.j=this.B(new w.$4c),this.m=this.B(new w.$4c),this.g=u.getProxy(l.$iM.MainThreadChatAgents2)}transferActiveChat(u){this.g.$transferActiveChatSession(u)}createChatAgent(u,t,f){const a=i.b++,d=new n(u,t,this.g,a,f);return this.c.set(a,d),this.g.$registerAgent(a,u.identifier,t,{},void 0),d.apiAgent}createDynamicChatAgent(u,t,f,a){const d=i.b++,$=new n(u,t,this.g,d,a);return this.c.set(d,$),this.g.$registerAgent(d,u.identifier,t,{isSticky:!0},f),$.apiAgent}async $invokeAgent(u,t,f,a){const d=this.c.get(u);if(!d)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);let $=this.j.get(t.sessionId);$||($=new w.$Tc,this.j.set(t.sessionId,$));const p=new o(d.extension,t,this.g,this.s.converter,$);try{const v=await this.t(t.agentId,f),y=d.invoke(b.ChatAgentRequest.to(t),{history:v},p.apiObject,a);return await(0,O.$mh)(Promise.resolve(y).then(h=>{if(h?.metadata)try{JSON.stringify(h.metadata)}catch(D){const k=`result.metadata MUST be JSON.stringify-able. Got error: ${D.message}`;return this.n.error(`[${d.extension.identifier.value}] [@${d.id}] ${k}`,d.extension),{errorDetails:{message:k},timings:p.timings}}return{errorDetails:h?.errorDetails,timings:p.timings,metadata:h?.metadata}}),a)}catch(v){return this.n.error(v,d.extension),{errorDetails:{message:(0,M.$jj)(v),responseIsIncomplete:!0}}}finally{p.close()}}async t(u,t){const f=[];for(const a of t.history){const d=b.ChatAgentResult.to(a.result),$=u===a.request.agentId?d:{...d,metadata:void 0};f.push(new g.$tO(a.request.message,a.request.command,a.request.variables.variables.map(b.ChatAgentValueReference.to),a.request.agentId));const p=(0,C.$Hb)(a.response.map(v=>b.ChatResponsePart.toContent(v,this.s.converter)));f.push(new g.$uO(p,$,a.request.agentId,a.request.command))}return f}$releaseSession(u){this.j.deleteAndDispose(u)}async $provideFollowups(u,t,f,a,d){const $=this.c.get(t);if(!$)return Promise.resolve([]);const p=await this.t($.id,a),v=b.ChatAgentResult.to(f);return(await $.provideFollowups(v,{history:p},d)).filter(y=>{const h=!y.participant||R.Iterable.some(this.c.values(),D=>D.id===y.participant&&S.$Tm.equals(D.extension.identifier,$.extension.identifier));return h||this.n.warn(`[@${$.id}] ChatFollowup refers to an unknown participant: ${y.participant}`),h}).map(y=>b.ChatFollowup.from(y,u))}$acceptFeedback(u,t,f,a){const d=this.c.get(u);if(!d)return;const $=b.ChatAgentResult.to(t);let p;switch(f){case r.InteractiveSessionVoteDirection.Down:p=g.ChatResultFeedbackKind.Unhelpful;break;case r.InteractiveSessionVoteDirection.Up:p=g.ChatResultFeedbackKind.Helpful;break}d.acceptFeedback(Object.freeze(a?{result:$,kind:p,reportIssue:a}:{result:$,kind:p}))}$acceptAction(u,t,f){const a=this.c.get(u);if(!a||f.action.kind==="vote")return;const d=b.ChatAgentUserActionEvent.to(t,f,this.s.converter);d&&a.acceptAction(Object.freeze(d))}async $invokeCompletionProvider(u,t,f){const a=this.c.get(u);if(!a)return[];let d=this.m.get(u);return d?d.clear():(d=new w.$Tc,this.m.set(u,d)),(await a.invokeCompletionProvider(t,f)).map(p=>b.ChatAgentCompletionItem.from(p,this.s.converter,d))}async $provideWelcomeMessage(u,t,f){const a=this.c.get(u);if(a)return await a.provideWelcomeMessage(b.ChatLocation.to(t),f)}async $provideSampleQuestions(u,t,f){const a=this.c.get(u);if(a)return(await a.provideSampleQuestions(b.ChatLocation.to(t),f)).map(d=>b.ChatFollowup.from(d,void 0))}}e.$amc=i;class n{constructor(u,t,f,a,d){this.extension=u,this.id=t,this.t=f,this.u=a,this.w=d,this.m=new N.$fe,this.n=new N.$fe}acceptFeedback(u){this.m.fire(u)}acceptAction(u){this.n.fire(u)}async invokeCompletionProvider(u,t){return this.p?await this.p.provider.provideCompletionItems(u,t)??[]:[]}async provideFollowups(u,t,f){if(!this.b)return[];const a=await this.b.provideFollowups(u,t,f);return a?a.filter(d=>!(d&&"commandId"in d)).filter(d=>!(d&&"message"in d)):[]}async provideWelcomeMessage(u,t){if(!this.q)return[];const f=await this.q.provideWelcomeMessage(u,t);return f?f.map(a=>typeof a=="string"?a:b.MarkdownString.from(a)):[]}async provideSampleQuestions(u,t){if(!this.q||!this.q.provideSampleQuestions)return[];const f=await this.q.provideSampleQuestions(u,t);return f||[]}get apiAgent(){let u=!1,t=!1;const f=()=>{u||t||(t=!0,queueMicrotask(()=>{this.t.$updateAgent(this.u,{icon:this.c?this.c instanceof T.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof g.$hN?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:b.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:b.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:b.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.s}),t=!1}))},a=this;return{get id(){return a.id},get iconPath(){return a.c},set iconPath(d){a.c=d,f()},get requestHandler(){return a.w},set requestHandler(d){(0,E.$ig)(typeof d=="function","Invalid request handler"),a.w=d},get followupProvider(){return a.b},set followupProvider(d){a.b=d,f()},get isDefault(){return(0,s.$KG)(a.extension,"defaultChatParticipant"),a.d},set isDefault(d){(0,s.$KG)(a.extension,"defaultChatParticipant"),a.d=d,f()},get helpTextPrefix(){return(0,s.$KG)(a.extension,"defaultChatParticipant"),a.g},set helpTextPrefix(d){(0,s.$KG)(a.extension,"defaultChatParticipant"),a.g=d,f()},get helpTextVariablesPrefix(){return(0,s.$KG)(a.extension,"defaultChatParticipant"),a.j},set helpTextVariablesPrefix(d){(0,s.$KG)(a.extension,"defaultChatParticipant"),a.j=d,f()},get helpTextPostfix(){return(0,s.$KG)(a.extension,"defaultChatParticipant"),a.k},set helpTextPostfix(d){(0,s.$KG)(a.extension,"defaultChatParticipant"),a.k=d,f()},get isSecondary(){return(0,s.$KG)(a.extension,"defaultChatParticipant"),a.l},set isSecondary(d){(0,s.$KG)(a.extension,"defaultChatParticipant"),a.l=d,f()},get supportIssueReporting(){return(0,s.$KG)(a.extension,"chatParticipantAdditions"),a.o},set supportIssueReporting(d){(0,s.$KG)(a.extension,"chatParticipantAdditions"),a.o=d,f()},get onDidReceiveFeedback(){return a.m.event},set participantVariableProvider(d){if((0,s.$KG)(a.extension,"chatParticipantAdditions"),a.p=d,d){if(!d.triggerCharacters.length)throw new Error("triggerCharacters are required");a.t.$registerAgentCompletionsProvider(a.u,d.triggerCharacters)}else a.t.$unregisterAgentCompletionsProvider(a.u)},get participantVariableProvider(){return(0,s.$KG)(a.extension,"chatParticipantAdditions"),a.p},set welcomeMessageProvider(d){(0,s.$KG)(a.extension,"defaultChatParticipant"),a.q=d,f()},get welcomeMessageProvider(){return(0,s.$KG)(a.extension,"defaultChatParticipant"),a.q},onDidPerformAction:(0,s.$JG)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(d){a.s=d,f()},get requester(){return a.s},dispose(){u=!0,a.b=void 0,a.m.dispose(),a.t.$unregisterAgent(a.u)}}}invoke(u,t,f,a){return this.w(u,t,f,a)}}}),define(Se[265],Ie([1,0,14,6,4,8,7,25]),function(le,e,C,O,M,N,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=void 0;class m{static{this.a=0}constructor(S){this.b=new Map,this.c=S.getProxy(M.$iM.MainThreadChatVariables)}async $resolveVariable(S,l,b,g){const r=this.b.get(S);if(r)try{if(r.resolver.resolve2){(0,w.$KG)(r.extension,"chatParticipantAdditions");const s=new E(l,this.c),o=await r.resolver.resolve2(r.data.name,{prompt:b},s.apiObject,g);if(o&&o[0])return o[0].value}else{const s=await r.resolver.resolve(r.data.name,{prompt:b},g);if(s&&s[0])return s[0].value}}catch(s){(0,C.$2)(s)}}registerVariableResolver(S,l,b,g){const r=m.a++;return this.b.set(r,{extension:S,data:{name:l,description:b},resolver:g}),this.c.$registerVariable(r,{name:l,description:b}),(0,O.$Sc)(()=>{this.b.delete(r),this.c.$unregisterVariable(r)})}}e.$bmc=m;class E{constructor(S,l){this.c=S,this.d=l,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let l=function(g){if(S.a){const r=new Error("Response stream has been closed");throw Error.captureStackTrace(r,g),r}};const S=this,b=g=>{this.d.$handleProgressChunk(this.c,g)};this.b={progress(g){l(this.progress);const r=new R.$nO(g),s=N.ChatResponseProgressPart.from(r);return b(s),this},reference(g){l(this.reference);const r=new R.$rO(g),s=N.ChatResponseReferencePart.from(r);return b(s),this},push(g){return l(this.push),g instanceof R.$rO?b(N.ChatResponseReferencePart.from(g)):g instanceof R.$nO&&b(N.ChatResponseProgressPart.from(g)),this}}}return this.b}}}),define(Se[266],Ie([1,0,11,69,5,6,2,89,21,8,7,4,25]),function(le,e,C,O,M,N,R,w,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmc=b;function b(g,r,s){const o=g.getProxy(S.$iM.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new m.$Vm,r.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===6){const y=this.b.get(v.handle);return y?y.value:v}else if(v&&v.$mid===7){const y=v,h=this.b.get(y.commentControlHandle);if(!h)return y;const D=h.getCommentThread(y.commentThreadHandle);return D?D.value:y}else if(v&&(v.$mid===9||v.$mid===8)){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);return h?v.$mid===8?h.value:{thread:h.value,text:v.text}:v}else if(v&&v.$mid===10){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);if(!h)return v;const D=v.commentUniqueId,k=h.getCommentByUniqueId(D);return k||v}else if(v&&v.$mid===11){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);if(!h)return v;const D=v.text,k=v.commentUniqueId,I=h.getCommentByUniqueId(k);return I?(typeof I.body=="string"?I.body=D:I.body=new T.$MM(D),I):v}return v}})}createCommentController(v,y,h){const D=i.a++,k=new c(v,D,y,h);this.b.set(k.handle,k);const I=this.c.get(v.identifier)||[];return I.push(k),this.c.set(v.identifier,I),k.value}async $createCommentThreadTemplate(v,y,h,D){const k=this.b.get(v);k&&k.$createCommentThreadTemplate(y,h,D)}async $setActiveComment(v,y){const h=this.b.get(v);h&&h.$setActiveComment(y??void 0)}async $updateCommentThreadTemplate(v,y,h){const D=this.b.get(v);D&&D.$updateCommentThreadTemplate(y,h)}$deleteCommentThread(v,y){this.b.get(v)?.$deleteCommentThread(y)}async $provideCommentingRanges(v,y,h){const D=this.b.get(v);if(!D||!D.commentingRangeProvider)return Promise.resolve(void 0);const k=await s.ensureDocumentData(R.URI.revive(y));return(0,C.$qh)(async()=>{const I=await D.commentingRangeProvider.provideCommentingRanges(k.document,h);let P;return Array.isArray(I)?P={ranges:I,fileComments:!1}:I?P={ranges:I.ranges||[],fileComments:I.fileComments||!1}:P=I??void 0,P}).then(I=>{let P;return I&&(P={ranges:I.ranges.map(V=>E.Range.from(V)),fileComments:I.fileComments}),P})}$toggleReaction(v,y,h,D,k){const I=this.b.get(v);return!I||!I.reactionHandler?Promise.resolve(void 0):(0,C.$qh)(()=>{const P=I.getCommentThread(y);if(P){const V=P.getCommentByUniqueId(D.uniqueIdInThread);if(I!==void 0&&V&&I.reactionHandler)return I.reactionHandler(V,f(k))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(v){this.n=v}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(v){(v===void 0!=(this.p===void 0)||!v||!this.p||!v.isEqual(this.p))&&(this.p=v,this.b.range=v,this.c.fire())}get range(){return this.p}set canReply(v){this.d!==v&&(this.d=v,this.b.canReply=v,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(v){this.e=v,this.b.label=v,this.c.fire()}get contextValue(){return this.f}set contextValue(v){this.f=v,this.b.contextValue=v,this.c.fire()}get comments(){return this.q}set comments(v){this.q=v,this.b.comments=v,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(v){this.g=v,this.b.collapsibleState=v,this.c.fire()}get state(){return this.h}set state(v){this.h=v,typeof v=="object"?((0,l.$KG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=v.resolved,this.b.applicability=v.applicability):this.b.state=v,this.c.fire()}get isDisposed(){return this.j}constructor(v,y,h,D,k,I,P,V,W){this.m=y,this.n=h,this.o=D,this.p=k,this.q=I,this.extensionDescription=P,this.r=V,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new M.$fe,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.$Vc,this.l.value=new N.$Tc,this.n===void 0&&(this.n=`${v}.${this.handle}`),o.$createCommentThread(y,this.handle,this.n,this.o,E.Range.from(this.p),P.identifier,this.r,W),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=I,this.i.push({dispose:()=>{o.$deleteCommentThread(y,this.handle)}});const q=this;this.value={get uri(){return q.uri},get range(){return q.range},set range(A){q.range=A},get comments(){return q.comments},set comments(A){q.comments=A},get collapsibleState(){return q.collapsibleState},set collapsibleState(A){q.collapsibleState=A},get canReply(){return q.canReply},set canReply(A){q.canReply=A},get contextValue(){return q.contextValue},set contextValue(A){q.contextValue=A},get label(){return q.label},set label(A){q.label=A},get state(){return q.state},set state(A){q.state=A},dispose:()=>{q.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.$Tc);const v=h=>Object.prototype.hasOwnProperty.call(this.b,h),y={};v("range")&&(y.range=E.Range.from(this.p)),v("label")&&(y.label=this.label),v("contextValue")&&(y.contextValue=this.contextValue??null),v("comments")&&(y.comments=this.q.map(h=>u(this,h,this.k,this.extensionDescription))),v("collapsibleState")&&(y.collapseState=a(this.g)),v("canReply")&&(y.canReply=this.canReply),v("state")&&(y.state=d(this.h)),v("applicability")&&(y.applicability=$(this.h)),v("isTemplate")&&(y.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,y)}getCommentByUniqueId(v){for(const y of this.k){const h=y[0],D=y[1];if(v===D)return h}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(v=>v.dispose())}}Je([(0,O.$4h)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(v){this.b=v,v?.resourceHints&&(0,l.$KG)(this.h,"commentingRangeHint"),o.$updateCommentingRanges(this.handle,v?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(v){this.c=v,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!v})}get options(){return this.d}set options(v){this.d=v,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,l.$KG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,l.$KG)(this.h,"activeComment"),this.f}constructor(v,y,h,D){this.h=v,this.i=y,this.j=h,this.k=D,this.a=new Map,o.$registerCommentController(this.handle,h,D,this.h.identifier.value);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(I){k.options=I},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(I){k.commentingRangeProvider=I},get reactionHandler(){return k.reactionHandler},set reactionHandler(I){k.reactionHandler=I},get activeCommentThread(){return k.activeCommentThread},createCommentThread(I,P,V){return k.createCommentThread(I,P,V).value},dispose:()=>{k.dispose()}}),this.g=[],this.g.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(v,y,h){y===void 0&&(0,l.$KG)(this.h,"fileComments");const D=new n(this.id,this.handle,void 0,v,y,h,this.h,!1);return this.a.set(D.handle,D),D}$setActiveComment(v){if(!v){this.e=void 0,this.f=void 0;return}const y=this.a.get(v.commentThreadHandle);y&&(this.e=v.uniqueIdInThread?y.getCommentByUniqueId(v.uniqueIdInThread):void 0,this.f=y)}$createCommentThreadTemplate(v,y,h){const D=new n(this.id,this.handle,void 0,R.URI.revive(v),E.Range.to(y),[],this.h,!0,h);return D.collapsibleState=w.CommentThreadCollapsibleState.Expanded,this.a.set(D.handle,D),D}$updateCommentThreadTemplate(v,y){const h=this.a.get(v);h&&(h.range=E.Range.to(y))}$deleteCommentThread(v){this.a.get(v)?.dispose(),this.a.delete(v)}getCommentThread(v){return this.a.get(v)}dispose(){this.a.forEach(v=>{v.dispose()}),this.g.forEach(v=>v.dispose())}}function u(p,v,y,h){let D=y.get(v);return D||(D=++p.commentHandle,y.set(v,D)),v.state!==void 0&&(0,l.$KG)(h,"commentsDraftState"),v.reactions?.some(k=>k.reactors!==void 0)&&(0,l.$KG)(h,"commentReactor"),{mode:v.mode,contextValue:v.contextValue,uniqueIdInThread:D,body:typeof v.body=="string"?v.body:E.MarkdownString.from(v.body),userName:v.author.name,userIconPath:v.author.iconPath,label:v.label,commentReactions:v.reactions?v.reactions.map(k=>t(k)):void 0,state:v.state,timestamp:v.timestamp?.toJSON()}}function t(p){return{label:p.label,iconPath:p.iconPath?E.$LO(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted,reactors:p.reactors&&p.reactors.length>0&&typeof p.reactors[0]!="string"?p.reactors.map(v=>v.name):p.reactors}}function f(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?R.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1,reactors:p.reactors?.map(v=>({name:v}))}}function a(p){if(p!==void 0)switch(p){case T.CommentThreadCollapsibleState.Expanded:return w.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return w.CommentThreadCollapsibleState.Collapsed}return w.CommentThreadCollapsibleState.Collapsed}function d(p){let v;if(typeof p=="object"?v=p.resolved:v=p,v!==void 0)switch(v){case T.CommentThreadState.Unresolved:return w.CommentThreadState.Unresolved;case T.CommentThreadState.Resolved:return w.CommentThreadState.Resolved}return w.CommentThreadState.Unresolved}function $(p){let v;if(typeof p=="object"&&(v=p.applicability),v!==void 0)switch(v){case T.CommentThreadApplicability.Current:return w.CommentThreadApplicability.Current;case T.CommentThreadApplicability.Outdated:return w.CommentThreadApplicability.Outdated}return w.CommentThreadApplicability.Current}return new i}}),define(Se[267],Ie([1,0,20,73,6,16,24,2,8,64,76,4,7]),function(le,e,C,O,M,N,R,w,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xmc=void 0;class b{constructor(f,a){this.document=f,this.b=a,this.a=1,this.c=new T.$Xlc("custom documents")}addEdit(f){return this.c.add([f])}async undo(f,a){await this.f(f).undo(),a||this.disposeBackup()}async redo(f,a){await this.f(f).redo(),a||this.disposeBackup()}disposeEdits(f){for(const a of f)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const f=u(this.document.uri)+this.a++;return(0,R.$_g)(this.b,f)}updateBackup(f){this.d?.delete(),this.d=f}disposeBackup(){this.d?.delete(),this.d=void 0}f(f){const a=this.c.get(f,0);if(!a)throw new Error("No edit found");return a}}class g{constructor(){this.a=new Map}get(f,a){return this.a.get(this.b(f,a))}add(f,a,d){const $=this.b(f,a.uri);if(this.a.has($))throw new Error(`Document already exists for viewType:${f} resource:${a.uri}`);const p=new b(a,d);return this.a.set($,p),p}delete(f,a){const d=this.b(f,a.uri);this.a.delete(d)}b(f,a){return`${f}@@@${a}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class s{constructor(){this.a=new Map}addTextProvider(f,a,d){return this.b(f,{type:0,extension:a,provider:d})}addCustomProvider(f,a,d){return this.b(f,{type:1,extension:a,provider:d})}get(f){return this.a.get(f)}b(f,a){if(this.a.has(f))throw new Error(`Provider for viewType:${f} already registered`);return this.a.set(f,a),new l.$kM(()=>this.a.delete(f))}}class o{constructor(f,a,d,$,p){this.d=a,this.f=d,this.g=$,this.h=p,this.b=new s,this.c=new g,this.a=f.getProxy(S.$iM.MainThreadCustomEditors)}registerCustomEditorProvider(f,a,d,$){const p=new M.$Tc;return n(d)?(p.add(this.b.addTextProvider(a,f,d)),this.a.$registerTextEditorProvider((0,E.$umc)(f),a,$.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,E.$smc)(f))):(p.add(this.b.addCustomProvider(a,f,d)),i(d)&&p.add(d.onDidChangeCustomDocument(v=>{const y=this.i(a,v.document.uri);if(c(v)){const h=y.addEdit(v);this.a.$onDidEdit(v.document.uri,a,h,v.label)}else this.a.$onContentChange(v.document.uri,a)})),this.a.$registerCustomEditorProvider((0,E.$umc)(f),a,$.webviewOptions||{},!!$.supportsMultipleEditorsPerDocument,(0,E.$smc)(f))),l.$kM.from(p,new l.$kM(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(f,a,d,$,p){const v=this.b.get(a);if(!v)throw new Error(`No provider found for '${a}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${a}'`);const y=w.URI.revive(f),h=await v.provider.openCustomDocument(y,{backupId:d,untitledDocumentData:$?.buffer},p);let D;return i(v.provider)&&this.f&&(D=this.f.workspaceValue(v.extension)??this.f.globalValue(v.extension)),this.c.add(a,h,D),{editable:i(v.provider)}}async $disposeCustomDocument(f,a){const d=this.b.get(a);if(!d)throw new Error(`No provider found for '${a}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${a}'`);const $=w.URI.revive(f),{document:p}=this.i(a,$);this.c.delete(a,p),p.dispose()}async $resolveCustomEditor(f,a,d,$,p,v){const y=this.b.get(d);if(!y)throw new Error(`No provider found for '${d}'`);const h=m.ViewColumn.to(p),D=this.g.createNewWebview(a,$.contentOptions,y.extension),k=this.h.createNewWebviewPanel(a,d,$.title,h,$.options,D,$.active),I=w.URI.revive(f);switch(y.type){case 1:{const{document:P}=this.i(d,I);return y.provider.resolveCustomEditor(P,k,v)}case 0:{const P=this.d.getDocument(I);return y.provider.resolveCustomTextEditor(P,k,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,a,d){this.i(a,f).disposeEdits(d)}async $onMoveCustomEditor(f,a,d){const $=this.b.get(d);if(!$)throw new Error(`No provider found for '${d}'`);if(!$.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const p=this.h.getWebviewPanel(f);if(!p)throw new Error("No webview found");const v=w.URI.revive(a),y=this.d.getDocument(v);await $.provider.moveCustomTextEditor(y,p,C.CancellationToken.None)}async $undo(f,a,d,$){return this.i(a,f).undo(d,$)}async $redo(f,a,d,$){return this.i(a,f).redo(d,$)}async $revert(f,a,d){const $=this.i(a,f);await this.j(a).revertCustomDocument($.document,d),$.disposeBackup()}async $onSave(f,a,d){const $=this.i(a,f);await this.j(a).saveCustomDocument($.document,d),$.disposeBackup()}async $onSaveAs(f,a,d,$){const p=this.i(a,f);return this.j(a).saveCustomDocumentAs(p.document,w.URI.revive(d),$)}async $backup(f,a,d){const $=this.i(a,f),v=await this.j(a).backupCustomDocument($.document,{destination:$.getNewBackupUri()},d);return $.updateBackup(v),v.id}i(f,a){const d=this.c.get(f,w.URI.revive(a));if(!d)throw new Error("No custom document found");return d}j(f){const d=this.b.get(f)?.provider;if(!d||!i(d))throw new Error("Custom document is not editable");return d}}e.$xmc=o;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function u(t){const f=t.scheme===N.Schemas.file||t.scheme===N.Schemas.untitled?t.fsPath:t.toString();return(0,O.$mj)(f)+""}}),define(Se[268],Ie([1,0,172,101,2,4,7,8,5,12,28,46]),function(le,e,C,O,M,N,R,w,m,E,T,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=e.$5lc=void 0;class b{#e;#t;#i;constructor(s,o,i,n,c,u,t,f){this.d=s,this.e=o,this.f=i,this.g=n,this.h=c,this.c=!1,this.f=Math.max(n,i),this.#i=new T.$Ac(a=>u.getComparisonKey(a)),this.#e=t,this.#t=f}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(s,o){if(!s){this.clear();return}this.j();let i=[];if(M.URI.isUri(s)){if(!o){this.delete(s);return}this.#i.set(s,o.slice()),i=[s]}else if(Array.isArray(s)){i=[];let u;s=[...s].sort(b.k);for(const t of s){const[f,a]=t;if((!u||f.toString()!==u.toString())&&(u&&this.#i.get(u).length===0&&this.#i.delete(u),u=f,i.push(f),this.#i.set(f,[])),a)this.#i.get(f)?.push(...a);else{const d=this.#i.get(f);d&&(d.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let c=0;for(const u of i){let t=[];const f=this.#i.get(u);if(f)if(f.length>this.g){t=[];const a=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const $ of f)if($.severity===a[d]&&t.push({...w.Diagnostic.from($),modelVersionId:this.h(u)})===this.g)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,C.localize)(0,null,f.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(a=>({...w.Diagnostic.from(a),modelVersionId:this.h(u)}));if(n.push([u,t]),c+=t.length,c>this.f)break}this.#e.$changeMany(this.e,n)}delete(s){this.j(),this.#t.fire([s]),this.#i.delete(s),this.#e?.$changeMany(this.e,[[s,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(s,o){this.j();for(const[i,n]of this)s.call(o,i,n,this)}*[Symbol.iterator](){this.j();for(const s of this.#i.keys())yield[s,this.get(s)]}get(s){this.j();const o=this.#i.get(s);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(s){return this.j(),Array.isArray(this.#i.get(s))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(s,o){return s[0].toString()<o[0].toString()?-1:s[0].toString()>o[0].toString()?1:0}}e.$5lc=b;let g=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(s){const o=new T.$Ac;for(const i of s)o.set(i,i);return{uris:Object.freeze(Array.from(o.values()))}}constructor(s,o,i,n){this.j=o,this.k=i,this.l=n,this.g=new Map,this.h=new m.$je({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this.h.event,l._mapper),this.f=s.getProxy(N.$iM.MainThreadDiagnostics)}createDiagnosticCollection(s,o){const{g:i,f:n,h:c,j:u,k:t,l:f}=this,a=new class{$changeMany(p,v){n.$changeMany(p,v),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,p,v.length===0?"CLEARING":v)}$clear(p){n.$clear(p),u.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,p)}dispose(){n.dispose()}};let d;if(!o)o="_generated_diagnostic_collection_name_#"+l.c++,d=o;else if(!i.has(o))d=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do d=o+l.c++;while(i.has(d))}return new class extends b{constructor(){super(o,d,l.e,l.d,p=>f.getDocument(p)?.version,t.extUri,a,c),i.set(d,this)}dispose(){super.dispose(),i.delete(d)}}}getDiagnostics(s){if(s)return this.m(s);{const o=new Map,i=[];for(const n of this.g.values())n.forEach((c,u)=>{let t=o.get(c.toString());typeof t>"u"&&(t=i.length,o.set(c.toString(),t),i.push([c,[]])),i[t][1]=i[t][1].concat(...u)});return i}}m(s){let o=[];for(const i of this.g.values())i.has(s)&&(o=o.concat(i.get(s)));return o}$acceptMarkersChange(s){if(!this.n){const o="_generated_mirror",i=new b(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(o,i),this.n=i}for(const[o,i]of s)this.n.set(M.URI.revive(o),i.map(w.Diagnostic.to))}};e.$6lc=g,e.$6lc=g=l=Je([We(1,E.$5j),We(2,S.$4lc)],g)}),define(Se[269],Ie([1,0,2,14,7,8,200,34]),function(le,e,C,O,M,N,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bnc=void 0;class m{constructor(T,S,l,b={timeout:1500,errors:3}){this.c=T,this.d=S,this.f=l,this.g=b,this.a=new R.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(T){return(S,l,b)=>{const r={dispose:this.a.push([S,l,T])};return Array.isArray(b)&&b.push(r),r}}async $participateInSave(T,S){const l=C.URI.revive(T);let b=!1;const g=setTimeout(()=>b=!0,this.g.timeout),r=[];try{for(const s of[...this.a]){if(b)break;const o=this.d.getDocument(l),i=await this.h(s,{document:o,reason:N.TextDocumentSaveReason.to(S)});r.push(i)}}finally{clearTimeout(g)}return r}h([T,S,l],b){const g=this.b.get(T);return typeof g=="number"&&g>this.g.errors?Promise.resolve(!1):this.i(l,T,S,b).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const s=this.b.get(T);this.b.set(T,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(T,S,l,b){const g=[],r=Date.now(),{document:s,reason:o}=b,{version:i}=s,n=Object.freeze({document:s,reason:o,waitUntil(c){if(Object.isFrozen(g))throw(0,O.$8)("waitUntil can not be called async");g.push(Promise.resolve(c))}});try{S.apply(l,[n])}catch(c){return Promise.reject(c)}return Object.freeze(g),new Promise((c,u)=>{const t=setTimeout(()=>u(new Error("timeout")),this.g.timeout);return Promise.all(g).then(f=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(t),c(f)}).catch(f=>{clearTimeout(t),u(f)})}).then(c=>{const u={edits:[]};for(const t of c)if(Array.isArray(t)&&t.every(f=>f instanceof M.$rM))for(const{newText:f,newEol:a,range:d}of t)u.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:d&&N.Range.from(d),text:f,eol:a&&N.EndOfLine.from(a)}});if(u.edits.length!==0)return i===s.version?this.f.$tryApplyWorkspaceEdit(new w.$Ew(u)):Promise.reject(new Error("concurrent_edits"))})}}e.$bnc=m}),define(Se[270],Ie([1,0,5,6,2,4,113,8,15,26,7]),function(le,e,C,O,M,N,R,w,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=void 0;class S{constructor(b,g){this.a=new C.$fe,this.b=new C.$fe,this.c=new C.$fe,this.d=new C.$fe,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Tc,this.h=new Map,this.f=b.getProxy(N.$iM.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(r=>{for(const s of r)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const s of r)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const g=this.g.getDocument(b);if(g)return g}getDocument(b){const g=this.getDocumentData(b);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return g.document}ensureDocumentData(b){const g=this.g.getDocument(b);if(g)return Promise.resolve(g);let r=this.h.get(b.toString());return r||(r=this.f.$tryOpenDocument(b).then(s=>{this.h.delete(b.toString());const o=M.URI.revive(s);return(0,m.$jg)(this.g.getDocument(o))},s=>(this.h.delete(b.toString()),Promise.reject(s))),this.h.set(b.toString(),r)),r}createDocumentData(b){return this.f.$tryCreateDocument(b).then(g=>M.URI.revive(g))}$acceptModelLanguageChanged(b,g){const r=M.URI.revive(b),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(g),this.a.fire(s.document)}$acceptModelSaved(b){const g=M.URI.revive(b),r=this.g.getDocument(g);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(b,g){const r=M.URI.revive(b),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");s._acceptIsDirty(g),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,g,r){const s=M.URI.revive(b),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(r),o.onEvents(g);let i;g.isUndoing?i=T.TextDocumentChangeReason.Undo:g.isRedoing&&(i=T.TextDocumentChangeReason.Redo),this.c.fire((0,E.$6n)({document:o.document,contentChanges:g.changes.map(n=>({range:w.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(b,g){(0,R.$OO)(b,g)}}e.$7lc=S}),define(Se[67],Ie([1,0,271,5,15,2,3,4,17,8,7]),function(le,e,C,O,M,N,R,w,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=e.$ymc=void 0,e.$ymc=(0,R.$yi)("IExtHostEditorTabs");class S{constructor(s,o,i){this.e=i,this.d=o,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,o={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.$8N(N.URI.revive(this.b.input.uri));case 2:return new T.$9N(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified));case 3:return new T.$0N(N.URI.revive(this.b.input.base),N.URI.revive(this.b.input.input1),N.URI.revive(this.b.input.input2),N.URI.revive(this.b.input.result));case 6:return new T.$$N(N.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.$_N(this.b.input.viewType);case 4:return new T.$aO(N.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.$bO(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.$cO;case 9:return new T.$dO(N.URI.revive(this.b.input.uri),N.URI.revive(this.b.input.inputBoxUri));case 10:return new T.$eO;case 11:return new T.$fO(this.b.input.diffEditors.map(s=>new T.$9N(N.URI.revive(s.original),N.URI.revive(s.modified))));default:return}}}class l{constructor(s,o){this.c=[],this.d="",this.b=s,this.e=o;for(const i of s.tabs)i.isActive&&(this.d=i.id),this.c.push(new S(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,o={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return E.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(i=>i.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(i=>i.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===0){const i=new S(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,i),s.tabDto.isActive&&(this.d=i.tabId),i}else if(s.kind===1){const i=this.c.splice(s.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(s.kind===3){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(s.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,i),i}const o=this.c.find(i=>i.tabId===s.tabDto.id);if(!o)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(s.tabDto),o}activeTabId(){return this.d}}let b=class{constructor(s){this.b=new O.$fe,this.c=new O.$fe,this.e=[],this.a=s.getProxy(w.$iM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,o={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(i=>i.apiObject))},get activeTabGroup(){const i=s.d;return(0,M.$jg)(s.e.find(c=>c.groupId===i)?.apiObject)},close:async(i,n)=>{const c=Array.isArray(i)?i:[i];return c.length?g(c[0])?this.j(c,n):this.i(c,n):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(s){const o=new Set(this.e.map(a=>a.groupId)),i=new Set(s.map(a=>a.groupId)),n=(0,C.$L)(o,i),c=this.e.filter(a=>n.removed.includes(a.groupId)).map(a=>a.apiObject),u=[],t=[];this.e=s.map(a=>{const d=new l(a,()=>this.d);return n.added.includes(d.groupId)?u.push(d.apiObject):t.push(d.apiObject),d});const f=(0,M.$jg)(s.find(a=>a.isActive===!0)?.groupId);f!==void 0&&this.d!==f&&(this.d=f),this.c.fire(Object.freeze({opened:u,closed:c,changed:t}))}$acceptTabGroupUpdate(s){const o=this.e.find(i=>i.groupId===s.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const o=this.e.find(n=>n.groupId===s.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(s);switch(s.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(s){for(const o of this.e)for(const i of o.tabs)if(i.apiObject===s)return i}h(s){return this.e.find(o=>o.apiObject===s)}async i(s,o){const i=[];for(const n of s){const c=this.g(n);if(!c)throw new Error("Tab close: Invalid tab not found!");i.push(c.tabId)}return this.a.$closeTab(i,o)}async j(s,o){const i=[];for(const n of s){const c=this.h(n);if(!c)throw new Error("Group close: Invalid group not found!");i.push(c.groupId)}return this.a.$closeGroup(i,o)}};e.$zmc=b,e.$zmc=b=Je([We(0,m.$MO)],b);function g(r){return r.tabs!==void 0}}),define(Se[272],Ie([1,0,2,4,6,7,8,314,13,22,25,55]),function(le,e,C,O,M,N,R,w,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=void 0;class l{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const s=this.a.indexOf(r);s>=0&&(this.a.splice(s,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),s=[];let o,i,n=14,c=14;for(const u of r){let t=o?(0,m.$Bf)(o,u):0;for(t===0?i=1:i=c;t<u.length;t++)t+1===u.length?(n=c,c=9):c+=1,s.push([i,u.toUpperCase().charCodeAt(t),c]),s.push([i,u.toLowerCase().charCodeAt(t),c]),i=c;o=u,c=n}s.push([9,58,10]),s.push([10,47,12]),this.b=new w.$J2(s)}}provideDocumentLinks(r){this.c();const s=[],o=w.$K2.computeLinks({getLineContent(i){return r.lineAt(i-1).text},getLineCount(){return r.lineCount}},this.b);for(const i of o){const n=R.DocumentLink.to(i);n.target&&s.push(n)}return s}}class b{constructor(r,s){this.i=s,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(O.$iM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,s,o,i={}){if(b.j(o),this.d.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const n=this.h++;this.b.add(s),this.d.add(s),this.c.set(n,o);let c=2;i.isCaseSensitive&&(c+=1024),i.isReadonly&&(c+=2048),typeof o.copy=="function"&&(c+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,T.$KG)(r,"fsChunks"),c+=4);let u;i.isReadonly&&(0,S.$Xk)(i.isReadonly)&&i.isReadonly.value!==""&&(u={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,s,c,u).catch(f=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${s}`),console.error(f)});const t=o.onDidChangeFile(f=>{const a=[];for(const d of f){const{uri:$,type:p}=d;if($.scheme!==s)continue;let v;switch(p){case N.FileChangeType.Changed:v=0;break;case N.FileChangeType.Created:v=1;break;case N.FileChangeType.Deleted:v=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:$,type:v})}this.a.$onFileSystemChange(n,a)});return(0,M.$Sc)(()=>{t.dispose(),this.b.delete(s),this.d.delete(s),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:s,ctime:o,mtime:i,size:n,permissions:c}=r;return{type:s,ctime:o,mtime:i,size:n,permissions:c}}$stat(r,s){return Promise.resolve(this.l(r).stat(C.URI.revive(s))).then(o=>b.k(o))}$readdir(r,s){return Promise.resolve(this.l(r).readDirectory(C.URI.revive(s)))}$readFile(r,s){return Promise.resolve(this.l(r).readFile(C.URI.revive(s))).then(o=>E.$He.wrap(o))}$writeFile(r,s,o,i){return Promise.resolve(this.l(r).writeFile(C.URI.revive(s),o.buffer,i))}$delete(r,s,o){return Promise.resolve(this.l(r).delete(C.URI.revive(s),o))}$rename(r,s,o,i){return Promise.resolve(this.l(r).rename(C.URI.revive(s),C.URI.revive(o),i))}$copy(r,s,o,i){const n=this.l(r);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(C.URI.revive(s),C.URI.revive(o),i))}$mkdir(r,s){return Promise.resolve(this.l(r).createDirectory(C.URI.revive(s)))}$watch(r,s,o,i){const n=this.l(r).watch(C.URI.revive(o),i);this.f.set(s,n)}$unwatch(r,s){const o=this.f.get(s);o&&(o.dispose(),this.f.delete(s))}$open(r,s,o){const i=this.l(r);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(C.URI.revive(s),o))}$close(r,s){const o=this.l(r);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(s))}$read(r,s,o,i){const n=this.l(r);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const c=E.$He.alloc(i);return Promise.resolve(n.read(s,o,c.buffer,0,i)).then(u=>c.slice(0,u))}$write(r,s,o,i){const n=this.l(r);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(s,o,i.buffer,0,i.byteLength))}l(r){const s=this.c.get(r);if(!s){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return s}}e.$enc=b}),define(Se[273],Ie([1,0,5,37,2,4,8,7,43]),function(le,e,C,O,M,N,R,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fnc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,g,r,s,o,i){this.a=Math.random(),this.b=new C.$fe,this.c=new C.$fe,this.d=new C.$fe,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,O.$sk)(o),c=typeof o=="string",u=i?.correlate,t=s(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(u&&typeof f.session>"u")){if(!i?.ignoreCreateEvents)for(const a of f.created){const d=M.URI.revive(a);n(d.fsPath)&&(!c||g.getWorkspaceFolder(d))&&this.b.fire(d)}if(!i?.ignoreChangeEvents)for(const a of f.changed){const d=M.URI.revive(a);n(d.fsPath)&&(!c||g.getWorkspaceFolder(d))&&this.c.fire(d)}if(!i?.ignoreDeleteEvents)for(const a of f.deleted){const d=M.URI.revive(a);n(d.fsPath)&&(!c||g.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=w.$kM.from(this.i(b,r,o,i,i?.correlate),this.b,this.c,this.d,t)}i(b,g,r,s,o){const i=w.$kM.from();if(typeof r=="string"||s?.ignoreChangeEvents&&s?.ignoreCreateEvents&&s?.ignoreDeleteEvents)return i;const n=b.getProxy(N.$iM.MainThreadFileSystemEventService);let c=!1;(r.pattern.includes(O.$ok)||r.pattern.includes(O.$pk))&&(c=!0);let u;return o&&(s?.ignoreChangeEvents||s?.ignoreCreateEvents||s?.ignoreDeleteEvents)&&(u=14,s?.ignoreChangeEvents&&(u&=-3),s?.ignoreCreateEvents&&(u&=-5),s?.ignoreDeleteEvents&&(u&=-9)),n.$watch(g.identifier.value,this.a,r.baseUri,{recursive:c,excludes:s?.excludes??[],filter:u},!!o),w.$kM.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class T{constructor(b){this.a=b,this.session=this.a.session,this.b=new m.$V(()=>this.a.created.map(M.URI.revive)),this.c=new m.$V(()=>this.a.changed.map(M.URI.revive)),this.d=new m.$V(()=>this.a.deleted.map(M.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor(b,g,r){this.j=b,this.k=g,this.l=r,this.a=new C.$fe,this.b=new C.$fe,this.c=new C.$fe,this.d=new C.$fe,this.g=new C.$he,this.h=new C.$he,this.i=new C.$he,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,g,r,s){return new E(this.j,b,g,this.a.event,R.GlobPattern.from(r),s)}$onFileEvent(b){this.a.fire(new T(b))}$onDidRunFileOperation(b,g){switch(b){case 2:this.b.fire(Object.freeze({files:g.map(r=>({oldUri:M.URI.revive(r.source),newUri:M.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:g.map(r=>M.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:g.map(r=>M.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,g){return(r,s,o)=>{const i=function(c){r.call(s,c)};return i.extension=b,g.event(i,void 0,o)}}async $onWillRunFileOperation(b,g,r,s){switch(b){case 2:return await this.n(this.g,{files:g.map(o=>({oldUri:M.URI.revive(o.source),newUri:M.URI.revive(o.target)}))},r,s);case 1:return await this.n(this.i,{files:g.map(o=>M.URI.revive(o.target))},r,s);case 0:case 3:return await this.n(this.h,{files:g.map(o=>M.URI.revive(o.target))},r,s)}}async n(b,g,r,s){const o=new Set,i=[];if(await b.fireAsync(g,s,async(c,u)=>{const t=Date.now(),f=await Promise.resolve(c);f instanceof w.$uM&&(i.push([u.extension,f]),o.add(u.extension.displayName??u.extension.identifier.value)),Date.now()-t>r&&this.k.warn("SLOW file-participant",u.extension.identifier)}),s.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,c]of i){const{edits:u}=R.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(u)}return{edit:n,extensionNames:Array.from(o)}}}e.$fnc=S}),define(Se[274],Ie([1,0,18,11,20,14,91,6,26,66,13,15,2,30,315,89,98,174,21,8,7,25,76,4]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s,o,i,n,c,u,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=void 0;class a{constructor(B,L){this.d=B,this.e=L}async provideDocumentSymbols(B,L){const K=this.d.getDocument(B),H=await this.e.provideDocumentSymbols(K,L);if(!(0,C.$Kb)(H))return H[0]instanceof c.$EM?H.map(n.DocumentSymbol.from):a.f(H)}static f(B){B=B.slice(0).sort((H,ee)=>{let re=H.location.range.start.compareTo(ee.location.range.start);return re===0&&(re=ee.location.range.end.compareTo(H.location.range.end)),re});const L=[],K=[];for(const H of B){const ee={name:H.name||"!!MISSING: name!!",kind:n.SymbolKind.from(H.kind),tags:H.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:n.Range.from(H.location.range),selectionRange:n.Range.from(H.location.range),children:[]};for(;;){if(K.length===0){K.push(ee),L.push(ee);break}const re=K[K.length-1];if(b.$xt.containsRange(re.range,ee.range)&&!b.$xt.equalsRange(re.range,ee.range)){re.children?.push(ee),K.push(ee);break}K.pop()}}return L}}class d{constructor(B,L,K,H,ee,re){this.f=B,this.g=L,this.h=K,this.j=H,this.k=ee,this.l=re,this.d=new t.$Xlc("CodeLens"),this.e=new Map}async provideCodeLenses(B,L){const K=this.f.getDocument(B),H=await this.h.provideCodeLenses(K,L);if(!H||L.isCancellationRequested)return;const ee=this.d.add(H),re=new w.$Tc;this.e.set(ee,re);const Te={cacheId:ee,lenses:[]};for(let Be=0;Be<H.length;Be++)Te.lenses.push({cacheId:[ee,Be],range:n.Range.from(H[Be].range),command:this.g.toInternal(H[Be].command,re)});return Te}async resolveCodeLens(B,L){const K=B.cacheId&&this.d.get(...B.cacheId);if(!K)return;let H;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?H=K:H=await this.h.resolveCodeLens(K,L),H||(H=K),L.isCancellationRequested)return;const ee=B.cacheId&&this.e.get(B.cacheId[0]);if(ee){if(!H.command){const re=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,re),this.l.error(re);return}return B.command=this.g.toInternal(H.command,ee),B}}releaseCodeLenses(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}}function $(Ue){return Array.isArray(Ue)?Ue.map(n.DefinitionLink.from):Ue?[n.DefinitionLink.from(Ue)]:[]}class p{constructor(B,L){this.d=B,this.e=L}async provideDefinition(B,L,K){const H=this.d.getDocument(B),ee=n.Position.to(L),re=await this.e.provideDefinition(H,ee,K);return $(re)}}class v{constructor(B,L){this.d=B,this.e=L}async provideDeclaration(B,L,K){const H=this.d.getDocument(B),ee=n.Position.to(L),re=await this.e.provideDeclaration(H,ee,K);return $(re)}}class y{constructor(B,L){this.d=B,this.e=L}async provideImplementation(B,L,K){const H=this.d.getDocument(B),ee=n.Position.to(L),re=await this.e.provideImplementation(H,ee,K);return $(re)}}class h{constructor(B,L){this.d=B,this.e=L}async provideTypeDefinition(B,L,K){const H=this.d.getDocument(B),ee=n.Position.to(L),re=await this.e.provideTypeDefinition(H,ee,K);return $(re)}}class D{static{this.f=10}constructor(B,L){this.g=B,this.h=L,this.d=0,this.e=new Map}async provideHover(B,L,K,H){const ee=this.g.getDocument(B),re=n.Position.to(L);let Te;if(K&&K.verbosityRequest){const xe=K.verbosityRequest.previousHover.id,et=this.e.get(xe);if(!et)throw new Error(`Hover with id ${xe} not found`);const tt={action:K.verbosityRequest.action,previousHover:et};Te=await this.h.provideHover(ee,re,H,tt)}else Te=await this.h.provideHover(ee,re,H);if(!Te||(0,C.$Kb)(Te.contents))return;Te.range||(Te.range=ee.getWordRangeAtPosition(re)),Te.range||(Te.range=new c.$mM(re,re));const Be=n.Hover.from(Te),He=this.d;if(this.e.size===D.f){const xe=Math.min(...this.e.keys());this.e.delete(xe)}return this.e.set(He,Te),this.d+=1,{...Be,id:He}}releaseHover(B){this.e.delete(B)}}class k{constructor(B,L){this.d=B,this.e=L}async provideEvaluatableExpression(B,L,K){const H=this.d.getDocument(B),ee=n.Position.to(L),re=await this.e.provideEvaluatableExpression(H,ee,K);if(re)return n.EvaluatableExpression.from(re)}}class I{constructor(B,L){this.d=B,this.e=L}async provideInlineValues(B,L,K,H){const ee=this.d.getDocument(B),re=await this.e.provideInlineValues(ee,n.Range.to(L),n.InlineValueContext.to(K),H);if(Array.isArray(re))return re.map(Te=>n.InlineValue.from(Te))}}class P{constructor(B,L){this.d=B,this.e=L}async provideDocumentHighlights(B,L,K){const H=this.d.getDocument(B),ee=n.Position.to(L),re=await this.e.provideDocumentHighlights(H,ee,K);if(Array.isArray(re))return re.map(n.DocumentHighlight.from)}}class V{constructor(B,L){this.d=B,this.e=L}async provideMultiDocumentHighlights(B,L,K,H){const ee=this.d.getDocument(B),re=K.map(He=>this.d.getDocument(He)),Te=n.Position.to(L),Be=await this.e.provideMultiDocumentHighlights(ee,Te,re,H);if(Array.isArray(Be))return Be.map(n.MultiDocumentHighlight.from)}}class W{constructor(B,L){this.d=B,this.e=L}async provideLinkedEditingRanges(B,L,K){const H=this.d.getDocument(B),ee=n.Position.to(L),re=await this.e.provideLinkedEditingRanges(H,ee,K);if(re&&Array.isArray(re.ranges))return{ranges:(0,C.$Hb)(re.ranges.map(n.Range.from)),wordPattern:re.wordPattern}}}class q{constructor(B,L){this.d=B,this.e=L}async provideReferences(B,L,K,H){const ee=this.d.getDocument(B),re=n.Position.to(L),Te=await this.e.provideReferences(ee,re,K,H);if(Array.isArray(Te))return Te.map(n.location.from)}}class A{static{this.d=1e3}constructor(B,L,K,H,ee,re,Te){this.g=B,this.h=L,this.j=K,this.k=H,this.l=ee,this.m=re,this.n=Te,this.e=new t.$Xlc("CodeAction"),this.f=new Map}async provideCodeActions(B,L,K,H){const ee=this.g.getDocument(B),re=g.$zt.isISelection(L)?n.Selection.to(L):n.Range.to(L),Te=[];for(const tt of this.j.getDiagnostics(B))if(re.intersection(tt.range)&&Te.push(tt)>A.d)break;const Be={diagnostics:Te,only:K.only?new c.$GM(K.only):void 0,triggerKind:n.CodeActionTriggerKind.to(K.trigger)},He=await this.k.provideCodeActions(ee,re,Be,H);if(!(0,C.$Lb)(He)||H.isCancellationRequested)return;const _e=this.e.add(He),xe=new w.$Tc;this.f.set(_e,xe);const et=[];for(let tt=0;tt<He.length;tt++){const it=He[tt];if(it)if(A.o(it))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:it.title,command:this.h.toInternal(it,xe)});else{Be.only&&(it.kind?Be.only.contains(it.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ot=it.ranges??[];et.push({cacheId:[_e,tt],title:it.title,command:it.command&&this.h.toInternal(it.command,xe),diagnostics:it.diagnostics&&it.diagnostics.map(n.Diagnostic.from),edit:it.edit&&n.WorkspaceEdit.from(it.edit,void 0),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,isAI:(0,u.$JG)(this.m,"codeActionAI")?it.isAI:!1,ranges:(0,u.$JG)(this.m,"codeActionRanges")?(0,C.$Hb)(ot.map(n.Range.from)):void 0,disabled:it.disabled?.reason})}}return{cacheId:_e,actions:et}}async resolveCodeAction(B,L){const[K,H]=B,ee=this.e.get(K,H);if(!ee||A.o(ee))return{};if(!this.k.resolveCodeAction)return{};const re=await this.k.resolveCodeAction(ee,L)??ee;let Te;re.edit&&(Te=n.WorkspaceEdit.from(re.edit,void 0));let Be;if(re.command){const He=this.f.get(K);He&&(Be=this.h.toInternal(re.command,He))}return{edit:Te,command:Be}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class z{constructor(B,L,K,H,ee){this.e=B,this.f=L,this.g=K,this.h=H,this.j=ee,this.d=new t.$Xlc("DocumentPasteEdit")}async prepareDocumentPaste(B,L,K,H){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(B),re=L.map(He=>n.Range.to(He)),Te=n.DataTransfer.toDataTransfer(K,()=>{throw new N.$$});if(await this.g.prepareDocumentPaste(ee,re,Te,H),H.isCancellationRequested)return;const Be=Array.from(Te).filter(([,He])=>!(He instanceof c.$aN));return n.DataTransfer.from(Be)}async providePasteEdits(B,L,K,H,ee,re){if(!this.g.provideDocumentPasteEdits)return[];const Te=this.f.getDocument(L),Be=K.map(et=>n.Range.to(et)),He=n.DataTransfer.toDataTransfer(H,async et=>(await this.e.$resolvePasteFileData(this.h,B,et)).buffer),_e=await this.g.provideDocumentPasteEdits(Te,Be,He,{only:ee.only?new c.$fN(ee.only):void 0,triggerKind:ee.triggerKind},re);if(!_e||re.isCancellationRequested)return[];const xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,o.localize)(0,null,this.j.displayName||this.j.name),kind:et.kind,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?n.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolvePasteEdit(B,L){const[K,H]=B,ee=this.d.get(K,H);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const re=await this.g.resolveDocumentPasteEdit(ee,L)??ee;return{additionalEdit:re.additionalEdit?n.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releasePasteEdits(B){this.d.delete(B)}}class G{constructor(B,L){this.d=B,this.e=L}async provideDocumentFormattingEdits(B,L,K){const H=this.d.getDocument(B),ee=await this.e.provideDocumentFormattingEdits(H,L,K);if(Array.isArray(ee))return ee.map(n.TextEdit.from)}}class ie{constructor(B,L){this.d=B,this.e=L}async provideDocumentRangeFormattingEdits(B,L,K,H){const ee=this.d.getDocument(B),re=n.Range.to(L),Te=await this.e.provideDocumentRangeFormattingEdits(ee,re,K,H);if(Array.isArray(Te))return Te.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,L,K,H){(0,S.$ig)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(B),re=L.map(n.Range.to),Te=await this.e.provideDocumentRangesFormattingEdits(ee,re,K,H);if(Array.isArray(Te))return Te.map(n.TextEdit.from)}}class de{constructor(B,L){this.d=B,this.e=L,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,L,K,H,ee){const re=this.d.getDocument(B),Te=n.Position.to(L),Be=await this.e.provideOnTypeFormattingEdits(re,Te,K,H,ee);if(Array.isArray(Be))return Be.map(n.TextEdit.from)}}class ye{constructor(B,L){this.e=B,this.f=L,this.d=new t.$Xlc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,L){const K=await this.e.provideWorkspaceSymbols(B,L);if(!(0,C.$Lb)(K))return{symbols:[]};const H=this.d.add(K),ee={cacheId:H,symbols:[]};for(let re=0;re<K.length;re++){const Te=K[re];if(!Te||!Te.name){this.f.warn("INVALID SymbolInformation",Te);continue}ee.symbols.push({...n.WorkspaceSymbol.from(Te),cacheId:[H,re]})}return ee}async resolveWorkspaceSymbol(B,L){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const K=this.d.get(...B.cacheId);if(K){const H=await this.e.resolveWorkspaceSymbol(K,L);return H&&(0,m.$8n)(B,n.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class Ee{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,L,K){this.d=B,this.e=L,this.f=K}async provideRenameEdits(B,L,K,H){const ee=this.d.getDocument(B),re=n.Position.to(L);try{const Te=await this.e.provideRenameEdits(ee,re,K,H);return Te?n.WorkspaceEdit.from(Te):void 0}catch(Te){const Be=Ee.g(Te);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(B,L,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(B),ee=n.Position.to(L);try{const re=await this.e.prepareRename(H,ee,K);let Te,Be;if(c.$mM.isRange(re)?(Te=re,Be=H.getText(re)):(0,S.$ag)(re)&&(Te=re.range,Be=re.placeholder),!Te||!Be)return;if(Te.start.line>ee.line||Te.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Te),text:Be}}catch(re){const Te=Ee.g(re);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(re)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class ge{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:c.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:c.NewSymbolNameTriggerKind.Automatic}}constructor(B,L,K){this.e=B,this.f=L,this.g=K}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(B,L,K,H){const ee=this.e.getDocument(B),re=n.Range.to(L);try{const Te=ge.d[K],Be=await this.f.provideNewSymbolNames(ee,re,Te,H);return Be?Be.map(He=>typeof He=="string"?{newSymbolName:He}:{newSymbolName:He.newSymbolName,tags:He.tags}):void 0}catch(Te){this.g.error(ge.h(Te)??JSON.stringify(Te,null,"	"));return}}static h(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class ue{constructor(B,L){this.resultId=B,this.tokens=L}}class Ce{constructor(B,L){this.f=B,this.g=L,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,L,K){const H=this.f.getDocument(B),ee=L!==0?this.d.get(L):null;let re=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ee.resultId,K):await this.g.provideDocumentSemanticTokens(H,K);return ee&&this.d.delete(L),re?(re=Ce.h(re),this.o(Ce.n(ee,re),re)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return Ce.j(B)?Ce.k(B)?B:new c.$FN(new Uint32Array(B.data),B.resultId):Ce.l(B)?Ce.m(B)?B:new c.$HN(B.edits.map(L=>new c.$GN(L.start,L.deleteCount,L.data?new Uint32Array(L.data):L.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const L of B.edits)if(!(L.data instanceof Uint32Array))return!1;return!0}static n(B,L){if(!Ce.j(L)||!B||!B.tokens)return L;const K=B.tokens,H=K.length,ee=L.data,re=ee.length;let Te=0;const Be=Math.min(H,re);for(;Te<Be&&K[Te]===ee[Te];)Te++;if(Te===H&&Te===re)return new c.$HN([],L.resultId);let He=0;const _e=Be-Te;for(;He<_e&&K[H-He-1]===ee[re-He-1];)He++;return new c.$HN([{start:Te,deleteCount:H-Te-He,data:ee.subarray(Te,re-He)}],L.resultId)}o(B,L){if(Ce.j(B)){const K=this.e++;return this.d.set(K,new ue(B.resultId,B.data)),(0,s.$Abb)({id:K,type:"full",data:B.data})}if(Ce.l(B)){const K=this.e++;return Ce.j(L)?this.d.set(K,new ue(L.resultId,L.data)):this.d.set(K,new ue(B.resultId)),(0,s.$Abb)({id:K,type:"delta",deltas:(B.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class se{constructor(B,L){this.d=B,this.e=L}async provideDocumentRangeSemanticTokens(B,L,K){const H=this.d.getDocument(B),ee=await this.e.provideDocumentRangeSemanticTokens(H,n.Range.to(L),K);return ee?this.f(ee):null}f(B){return(0,s.$Abb)({id:0,type:"full",data:B.data})}}class Oe{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,L,K,H,ee){this.f=B,this.g=L,this.h=K,this.j=H,this.k=ee,this.d=new t.$Xlc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,L,K,H){const ee=this.f.getDocument(B),re=n.Position.to(L),Te=ee.getWordRangeAtPosition(re)||new c.$mM(re,re),Be=Te.with({end:re}),He=new E.$be,_e=await this.h.provideCompletionItems(ee,re,H,n.CompletionContext.to(K));if(!_e||H.isCancellationRequested)return;const xe=Array.isArray(_e)?new c.$TM(_e):_e,et=Oe.supportsResolving(this.h)?this.d.add(xe.items):this.d.add([]),tt=new w.$Tc;this.e.set(et,tt);const it=[],ot={x:et,b:it,a:{replace:n.Range.from(Te),insert:n.Range.from(Be)},c:xe.isIncomplete||void 0,d:He.elapsed()};for(let gt=0;gt<xe.items.length;gt++){const je=xe.items[gt],rt=this.l(je,[et,gt],Be,Te);it.push(rt)}return ot}async resolveCompletionItem(B,L){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...B);if(!K)return;const H=this.l(K,B),ee=await this.h.resolveCompletionItem(K,L);if(!ee)return;const re=this.l(ee,B);return(H.h!==re.h||H.i!==re.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==re.n||H.o!==re.o||!(0,m.$9n)(H.p,re.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:re.d,c:re.c,l:re.l,h:re.h,i:re.i,n:re.n,o:re.o,p:re.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,L,K,H){const ee=this.e.get(L[0]);if(!ee)throw Error("DisposableStore is missing...");const re=this.g.toInternal(B.command,ee),Te={x:L,a:B.label,b:B.kind!==void 0?n.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(n.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:n.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(n.TextEdit.from),n:re?.$ident,o:re?.id,p:re?.$ident?void 0:re?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=B.textEdit.newText):typeof B.insertText=="string"?Te.h=B.insertText:B.insertText instanceof c.$vM&&(Te.h=B.insertText.value,Te.i|=4);let Be;return B.textEdit?Be=B.textEdit.range:B.range&&(Be=B.range),c.$mM.isRange(Be)?Te.j=n.Range.from(Be):Be&&(!K?.isEqual(Be.inserting)||!H?.isEqual(Be.replacing))&&(Te.j={insert:n.Range.from(Be.inserting),replace:n.Range.from(Be.replacing)}),Te}}class ne{async provideInlineCompletions(B,L,K,H){}disposeCompletions(B){}handleDidShowCompletionItem(B,L,K){}handlePartialAccept(B,L,K,H){}}class j extends ne{constructor(B,L,K,H){super(),this.f=B,this.g=L,this.h=K,this.j=H,this.d=new ve,this.e=(0,u.$JG)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,u.$JG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,L,K,H){const ee=this.g.getDocument(B),re=n.Position.to(L),Te=await this.h.provideInlineCompletionItems(ee,re,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:n.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},H);if(!Te||H.isCancellationRequested)return;const Be=Array.isArray(Te)?Te:Te.items,He=this.e?Array.isArray(Te)?[]:Te.commands||[]:[],_e=this.e&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let xe;return{pid:this.d.createReferenceId({dispose(){xe?.dispose()},items:Be}),items:Be.map((tt,it)=>{let ot;tt.command&&(xe||(xe=new w.$Tc),ot=this.j.toInternal(tt.command,xe));const gt=tt.insertText;return{insertText:typeof gt=="string"?gt:{snippet:gt.value},filterText:tt.filterText,range:tt.range?n.Range.from(tt.range):void 0,command:ot,idx:it,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:He.map(tt=>(xe||(xe=new w.$Tc),this.j.toInternal(tt,xe))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,L,K){const H=this.d.get(B)?.items[L];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,K)}handlePartialAccept(B,L,K,H){const ee=this.d.get(B)?.items[L];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,K),this.h.handleDidPartiallyAcceptCompletionItem(ee,n.PartialAcceptInfo.to(H)))}}class x{async provideInlineEdits(B,L,K){const H=this.f.getDocument(B),ee=await this.g.provideInlineEdit(H,{triggerKind:this.e[L.triggerKind]},K);if(!ee||K.isCancellationRequested)return;let re;const Te=this.d.createReferenceId({dispose(){re?.dispose()},item:ee});let Be;ee.accepted&&(re||(re=new w.$Tc),Be=this.h.toInternal(ee.accepted,re));let He;return ee.rejected&&(re||(re=new w.$Tc),He=this.h.toInternal(ee.rejected,re)),{pid:Te,text:ee.text,range:n.Range.from(ee.range),accepted:Be,rejected:He}}disposeEdit(B){this.d.disposeReferenceId(B)?.dispose()}constructor(B,L,K,H){this.f=L,this.g=K,this.h=H,this.d=new ve,this.e={[r.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class ve{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const L=this.e++;return this.d.set(L,B),L}disposeReferenceId(B){const L=this.d.get(B);return this.d.delete(B),L}get(B){return this.d.get(B)}}class Fe{constructor(B,L){this.e=B,this.f=L,this.d=new t.$Xlc("SignatureHelp")}async provideSignatureHelp(B,L,K,H){const ee=this.e.getDocument(B),re=n.Position.to(L),Te=this.g(K),Be=await this.f.provideSignatureHelp(ee,re,H,Te);if(Be){const He=this.d.add([Be]);return{...n.SignatureHelp.from(Be),id:He}}}g(B){let L;if(B.activeSignatureHelp){const K=n.SignatureHelp.to(B.activeSignatureHelp),H=this.d.get(B.activeSignatureHelp.id,0);H?(L=H,L.activeSignature=K.activeSignature,L.activeParameter=K.activeParameter):L=K}return{...B,activeSignatureHelp:L}}releaseSignatureHelp(B){this.d.delete(B)}}class ke{constructor(B,L,K,H,ee){this.f=B,this.g=L,this.h=K,this.j=H,this.k=ee,this.d=new t.$Xlc("InlayHints"),this.e=new Map}async provideInlayHints(B,L,K){const H=this.f.getDocument(B),ee=n.Range.to(L),re=await this.h.provideInlayHints(H,ee,K);if(!Array.isArray(re)||re.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(L)}`);return}if(K.isCancellationRequested)return;const Te=this.d.add(re);this.e.set(Te,new w.$Tc);const Be={hints:[],cacheId:Te};for(let He=0;He<re.length;He++)this.l(re[He],ee)&&Be.hints.push(this.m(re[He],[Te,He]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(L)}`),Be}async resolveInlayHint(B,L){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...B);if(!K)return;const H=await this.h.resolveInlayHint(K,L);if(H&&this.l(H))return this.m(H,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,L){return B.label.length===0||Array.isArray(B.label)&&B.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(L&&!L.contains(B.position))}m(B,L){const K=this.e.get(L[0]);if(!K)throw Error("DisposableStore is missing...");const H={label:"",cacheId:L,tooltip:n.MarkdownString.fromStrict(B.tooltip),position:n.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(n.TextEdit.from),kind:B.kind&&n.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")H.label=B.label;else{const ee=[];H.label=ee;for(const re of B.label){if(!re.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Te={label:re.value,tooltip:n.MarkdownString.fromStrict(re.tooltip)};c.$wM.isLocation(re.location)&&(Te.location=n.location.from(re.location)),re.command&&(Te.command=this.g.toInternal(re.command,K)),ee.push(Te)}}return H}}class we{constructor(B,L){this.e=B,this.f=L,this.d=new t.$Xlc("DocumentLink")}async provideLinks(B,L){const K=this.e.getDocument(B),H=await this.f.provideDocumentLinks(K,L);if(!(!Array.isArray(H)||H.length===0)&&!L.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(we.g).map(n.DocumentLink.from)};{const ee=this.d.add(H),re={links:[],cacheId:ee};for(let Te=0;Te<H.length;Te++){if(!we.g(H[Te]))continue;const Be=n.DocumentLink.from(H[Te]);Be.cacheId=[ee,Te],re.links.push(Be)}return re}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,L){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...B);if(!K)return;const H=await this.f.resolveDocumentLink(K,L);if(!(!H||!we.g(H)))return n.DocumentLink.from(H)}releaseLinks(B){this.d.delete(B)}}class me{constructor(B,L){this.d=B,this.e=L}async provideColors(B,L){const K=this.d.getDocument(B),H=await this.e.provideDocumentColors(K,L);return Array.isArray(H)?H.map(re=>({color:n.Color.from(re.color),range:n.Range.from(re.range)})):[]}async provideColorPresentations(B,L,K){const H=this.d.getDocument(B),ee=n.Range.to(L.range),re=n.Color.to(L.color),Te=await this.e.provideColorPresentations(re,{document:H,range:ee},K);if(Array.isArray(Te))return Te.map(n.ColorPresentation.from)}}class Q{constructor(B,L){this.d=B,this.e=L}async provideFoldingRanges(B,L,K){const H=this.d.getDocument(B),ee=await this.e.provideFoldingRanges(H,L,K);if(Array.isArray(ee))return ee.map(n.FoldingRange.from)}}class Y{constructor(B,L,K){this.d=B,this.e=L,this.f=K}async provideSelectionRanges(B,L,K){const H=this.d.getDocument(B),ee=L.map(n.Position.to),re=await this.e.provideSelectionRanges(H,ee,K);if(!(0,C.$Lb)(re))return[];if(re.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let Be=0;Be<ee.length;Be++){const He=[];Te.push(He);let _e=ee[Be],xe=re[Be];for(;;){if(!xe.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(He.push(n.SelectionRange.from(xe)),!xe.parent)break;_e=xe.range,xe=xe.parent}}return Te}}class he{constructor(B,L){this.f=B,this.g=L,this.d=new R.$RO(""),this.e=new Map}async prepareSession(B,L,K){const H=this.f.getDocument(B),ee=n.Position.to(L),re=await this.g.prepareCallHierarchy(H,ee,K);if(!re)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(re)?re.map(Be=>this.h(Te,Be)):[this.h(Te,re)]}async provideCallsTo(B,L,K){const H=this.j(B,L);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(H,K);if(ee)return ee.map(re=>({from:this.h(B,re.from),fromRanges:re.fromRanges.map(Te=>n.Range.from(Te))}))}async provideCallsFrom(B,L,K){const H=this.j(B,L);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(H,K);if(ee)return ee.map(re=>({to:this.h(B,re.to),fromRanges:re.fromRanges.map(Te=>n.Range.from(Te))}))}releaseSession(B){this.e.delete(B)}h(B,L){const K=this.e.get(B),H=n.CallHierarchyItem.from(L,B,K.size.toString(36));return K.set(H._itemId,L),H}j(B,L){return this.e.get(B)?.get(L)}}class ce{constructor(B,L){this.f=B,this.g=L,this.d=new R.$RO(""),this.e=new Map}async prepareSession(B,L,K){const H=this.f.getDocument(B),ee=n.Position.to(L),re=await this.g.prepareTypeHierarchy(H,ee,K);if(!re)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(re)?re.map(Be=>this.h(Te,Be)):[this.h(Te,re)]}async provideSupertypes(B,L,K){const H=this.j(B,L);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(H,K);if(ee)return ee.map(re=>this.h(B,re))}async provideSubtypes(B,L,K){const H=this.j(B,L);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(H,K);if(ee)return ee.map(re=>this.h(B,re))}releaseSession(B){this.e.delete(B)}h(B,L){const K=this.e.get(B),H=n.TypeHierarchyItem.from(L,B,K.size.toString(36));return K.set(H._itemId,L),H}j(B,L){return this.e.get(B)?.get(L)}}class Ne{constructor(B,L,K,H,ee){this.e=B,this.f=L,this.g=K,this.h=H,this.j=ee,this.d=new t.$Xlc("DocumentDropEdit")}async provideDocumentOnDropEdits(B,L,K,H,ee){const re=this.f.getDocument(L),Te=n.Position.to(K),Be=n.DataTransfer.toDataTransfer(H,async et=>(await this.e.$resolveDocumentOnDropFileData(this.h,B,et)).buffer),He=await this.g.provideDocumentDropEdits(re,Te,Be,ee);if(!He)return;const _e=(0,C.$2b)(He),xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,o.localize)(1,null,this.j.displayName||this.j.name),kind:et.kind?.value,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?n.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolveDropEdit(B,L){const[K,H]=B,ee=this.d.get(K,H);if(!ee||!this.g.resolveDocumentDropEdit)return{};const re=await this.g.resolveDocumentDropEdit(ee,L)??ee;return{additionalEdit:re.additionalEdit?n.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releaseDropEdits(B){this.d.delete(B)}}class fe{constructor(B,L){this.d=B,this.e=L}async provideMappedEdits(B,L,K,H){const ee=l.URI.revive(B),re=this.d.getDocument(ee),Te=K.documents.map(_e=>_e.map(xe=>({uri:l.URI.revive(xe.uri),version:xe.version,ranges:xe.ranges.map(et=>n.Range.to(et))}))),Be={documents:Te,selections:Te[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(re,L,Be,H);return He?n.WorkspaceEdit.from(He):null}}class Pe{constructor(B,L){this.adapter=B,this.extension=L}}class Ae{static{this.d=0}constructor(B,L,K,H,ee,re,Te,Be){this.g=L,this.h=K,this.j=H,this.k=ee,this.l=re,this.m=Te,this.n=Be,this.f=new Map,this.e=B.getProxy(f.$iM.MainThreadLanguageFeatures)}o(B,L){return n.DocumentSelector.from(B,this.g,L)}p(B){return new c.$kM(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return Ae.d++}async s(B,L,K,H,ee,re=!1){const Te=this.f.get(B);if(!Te||!(Te.adapter instanceof L))return H;const Be=Date.now();re||this.l.trace(`[${Te.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const He=K(Te.adapter,Te.extension);return Promise.resolve(He).catch(_e=>{(0,N.$4)(_e)||(this.l.error(`[${Te.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Te.extension.identifier,_e))}).finally(()=>{re||this.l.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),M.CancellationToken.isCancellationToken(ee)?(0,O.$nh)(He,ee):He}t(B,L){const K=this.q();return this.f.set(K,new Pe(B,L)),K}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,L,K,H){const ee=this.t(new a(this.h,K),B),re=H&&H.label||Ae.u(B);return this.e.$registerDocumentSymbolProvider(ee,this.o(L,B),re),this.p(ee)}$provideDocumentSymbols(B,L,K){return this.s(B,a,H=>H.provideDocumentSymbols(l.URI.revive(L),K),void 0,K)}registerCodeLensProvider(B,L,K){const H=this.q(),ee=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Pe(new d(this.h,this.j.converter,K,B,this.n,this.l),B)),this.e.$registerCodeLensSupport(H,this.o(L,B),ee);let re=this.p(H);if(ee!==void 0){const Te=K.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(ee));re=c.$kM.from(re,Te)}return re}$provideCodeLenses(B,L,K){return this.s(B,d,H=>H.provideCodeLenses(l.URI.revive(L),K),void 0,K)}$resolveCodeLens(B,L,K){return this.s(B,d,H=>H.resolveCodeLens(L,K),void 0,void 0)}$releaseCodeLenses(B,L){this.s(B,d,K=>Promise.resolve(K.releaseCodeLenses(L)),void 0,void 0)}registerDefinitionProvider(B,L,K){const H=this.t(new p(this.h,K),B);return this.e.$registerDefinitionSupport(H,this.o(L,B)),this.p(H)}$provideDefinition(B,L,K,H){return this.s(B,p,ee=>ee.provideDefinition(l.URI.revive(L),K,H),[],H)}registerDeclarationProvider(B,L,K){const H=this.t(new v(this.h,K),B);return this.e.$registerDeclarationSupport(H,this.o(L,B)),this.p(H)}$provideDeclaration(B,L,K,H){return this.s(B,v,ee=>ee.provideDeclaration(l.URI.revive(L),K,H),[],H)}registerImplementationProvider(B,L,K){const H=this.t(new y(this.h,K),B);return this.e.$registerImplementationSupport(H,this.o(L,B)),this.p(H)}$provideImplementation(B,L,K,H){return this.s(B,y,ee=>ee.provideImplementation(l.URI.revive(L),K,H),[],H)}registerTypeDefinitionProvider(B,L,K){const H=this.t(new h(this.h,K),B);return this.e.$registerTypeDefinitionSupport(H,this.o(L,B)),this.p(H)}$provideTypeDefinition(B,L,K,H){return this.s(B,h,ee=>ee.provideTypeDefinition(l.URI.revive(L),K,H),[],H)}registerHoverProvider(B,L,K,H){const ee=this.t(new D(this.h,K),B);return this.e.$registerHoverProvider(ee,this.o(L,B)),this.p(ee)}$provideHover(B,L,K,H,ee){return this.s(B,D,re=>re.provideHover(l.URI.revive(L),K,H,ee),void 0,ee)}$releaseHover(B,L){this.s(B,D,K=>Promise.resolve(K.releaseHover(L)),void 0,void 0)}registerEvaluatableExpressionProvider(B,L,K,H){const ee=this.t(new k(this.h,K),B);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(L,B)),this.p(ee)}$provideEvaluatableExpression(B,L,K,H){return this.s(B,k,ee=>ee.provideEvaluatableExpression(l.URI.revive(L),K,H),void 0,H)}registerInlineValuesProvider(B,L,K,H){const ee=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,re=this.t(new I(this.h,K),B);this.e.$registerInlineValuesProvider(re,this.o(L,B),ee);let Te=this.p(re);if(ee!==void 0){const Be=K.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(ee));Te=c.$kM.from(Te,Be)}return Te}$provideInlineValues(B,L,K,H,ee){return this.s(B,I,re=>re.provideInlineValues(l.URI.revive(L),K,H,ee),void 0,ee)}registerDocumentHighlightProvider(B,L,K){const H=this.t(new P(this.h,K),B);return this.e.$registerDocumentHighlightProvider(H,this.o(L,B)),this.p(H)}registerMultiDocumentHighlightProvider(B,L,K){const H=this.t(new V(this.h,K),B);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(L,B)),this.p(H)}$provideDocumentHighlights(B,L,K,H){return this.s(B,P,ee=>ee.provideDocumentHighlights(l.URI.revive(L),K,H),void 0,H)}$provideMultiDocumentHighlights(B,L,K,H,ee){return this.s(B,V,re=>re.provideMultiDocumentHighlights(l.URI.revive(L),K,H.map(Te=>l.URI.revive(Te)),ee),void 0,ee)}registerLinkedEditingRangeProvider(B,L,K){const H=this.t(new W(this.h,K),B);return this.e.$registerLinkedEditingRangeProvider(H,this.o(L,B)),this.p(H)}$provideLinkedEditingRanges(B,L,K,H){return this.s(B,W,async ee=>{const re=await ee.provideLinkedEditingRanges(l.URI.revive(L),K,H);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?Ae.w(re.wordPattern):void 0}},void 0,H)}registerReferenceProvider(B,L,K){const H=this.t(new q(this.h,K),B);return this.e.$registerReferenceSupport(H,this.o(L,B)),this.p(H)}$provideReferences(B,L,K,H,ee){return this.s(B,q,re=>re.provideReferences(l.URI.revive(L),K,H,ee),void 0,ee)}registerCodeActionProvider(B,L,K,H){const ee=new w.$Tc,re=this.t(new A(this.h,this.j.converter,this.k,K,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(re,this.o(L,B),{providedKinds:H?.providedCodeActionKinds?.map(Te=>Te.value),documentation:H?.documentation?.map(Te=>({kind:Te.kind.value,command:this.j.converter.toInternal(Te.command,ee)}))},Ae.u(B),!!K.resolveCodeAction),ee.add(this.p(re)),ee}$provideCodeActions(B,L,K,H,ee){return this.s(B,A,re=>re.provideCodeActions(l.URI.revive(L),K,H,ee),void 0,ee)}$resolveCodeAction(B,L,K){return this.s(B,A,H=>H.resolveCodeAction(L,K),{},void 0)}$releaseCodeActions(B,L){this.s(B,A,K=>Promise.resolve(K.releaseCodeActions(L)),void 0,void 0)}registerDocumentFormattingEditProvider(B,L,K){const H=this.t(new G(this.h,K),B);return this.e.$registerDocumentFormattingSupport(H,this.o(L,B),B.identifier,B.displayName||B.name),this.p(H)}$provideDocumentFormattingEdits(B,L,K,H){return this.s(B,G,ee=>ee.provideDocumentFormattingEdits(l.URI.revive(L),K,H),void 0,H)}registerDocumentRangeFormattingEditProvider(B,L,K){const H=typeof K.provideDocumentRangesFormattingEdits=="function",ee=this.t(new ie(this.h,K),B);return this.e.$registerRangeFormattingSupport(ee,this.o(L,B),B.identifier,B.displayName||B.name,H),this.p(ee)}$provideDocumentRangeFormattingEdits(B,L,K,H,ee){return this.s(B,ie,re=>re.provideDocumentRangeFormattingEdits(l.URI.revive(L),K,H,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(B,L,K,H,ee){return this.s(B,ie,re=>re.provideDocumentRangesFormattingEdits(l.URI.revive(L),K,H,ee),void 0,ee)}registerOnTypeFormattingEditProvider(B,L,K,H){const ee=this.t(new de(this.h,K),B);return this.e.$registerOnTypeFormattingSupport(ee,this.o(L,B),H,B.identifier),this.p(ee)}$provideOnTypeFormattingEdits(B,L,K,H,ee,re){return this.s(B,de,Te=>Te.provideOnTypeFormattingEdits(l.URI.revive(L),K,H,ee,re),void 0,re)}registerWorkspaceSymbolProvider(B,L){const K=this.t(new ye(L,this.l),B);return this.e.$registerNavigateTypeSupport(K,typeof L.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(B,L,K){return this.s(B,ye,H=>H.provideWorkspaceSymbols(L,K),{symbols:[]},K)}$resolveWorkspaceSymbol(B,L,K){return this.s(B,ye,H=>H.resolveWorkspaceSymbol(L,K),void 0,void 0)}$releaseWorkspaceSymbols(B,L){this.s(B,ye,K=>K.releaseWorkspaceSymbols(L),void 0,void 0)}registerRenameProvider(B,L,K){const H=this.t(new Ee(this.h,K,this.l),B);return this.e.$registerRenameSupport(H,this.o(L,B),Ee.supportsResolving(K)),this.p(H)}$provideRenameEdits(B,L,K,H,ee){return this.s(B,Ee,re=>re.provideRenameEdits(l.URI.revive(L),K,H,ee),void 0,ee)}$resolveRenameLocation(B,L,K,H){return this.s(B,Ee,ee=>ee.resolveRenameLocation(l.URI.revive(L),K,H),void 0,H)}registerNewSymbolNamesProvider(B,L,K){const H=this.t(new ge(this.h,K,this.l),B);return this.e.$registerNewSymbolNamesProvider(H,this.o(L,B)),this.p(H)}$supportsAutomaticNewSymbolNamesTriggerKind(B){return this.s(B,ge,L=>L.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(B,L,K,H,ee){return this.s(B,ge,re=>re.provideNewSymbolNames(l.URI.revive(L),K,H,ee),void 0,ee)}registerDocumentSemanticTokensProvider(B,L,K,H){const ee=this.t(new Ce(this.h,K),B),re=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(L,B),H,re);let Te=this.p(ee);if(re){const Be=K.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(re));Te=c.$kM.from(Te,Be)}return Te}$provideDocumentSemanticTokens(B,L,K,H){return this.s(B,Ce,ee=>ee.provideDocumentSemanticTokens(l.URI.revive(L),K,H),null,H)}$releaseDocumentSemanticTokens(B,L){this.s(B,Ce,K=>K.releaseDocumentSemanticColoring(L),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,L,K,H){const ee=this.t(new se(this.h,K),B);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(L,B),H),this.p(ee)}$provideDocumentRangeSemanticTokens(B,L,K,H){return this.s(B,se,ee=>ee.provideDocumentRangeSemanticTokens(l.URI.revive(L),K,H),null,H)}registerCompletionItemProvider(B,L,K,H){const ee=this.t(new Oe(this.h,this.j.converter,K,this.m,B),B);return this.e.$registerCompletionsProvider(ee,this.o(L,B),H,Oe.supportsResolving(K),B.identifier),this.p(ee)}$provideCompletionItems(B,L,K,H,ee){return this.s(B,Oe,re=>re.provideCompletionItems(l.URI.revive(L),K,H,ee),void 0,ee)}$resolveCompletionItem(B,L,K){return this.s(B,Oe,H=>H.resolveCompletionItem(L,K),void 0,K)}$releaseCompletionItems(B,L){this.s(B,Oe,K=>K.releaseCompletionItems(L),void 0,void 0)}registerInlineCompletionsProvider(B,L,K,H){const ee=new j(B,this.h,K,this.j.converter),re=this.t(ee,B);return this.e.$registerInlineCompletionsSupport(re,this.o(L,B),ee.supportsHandleEvents,i.$Tm.toKey(B.identifier.value),H?.yieldTo?.map(Te=>i.$Tm.toKey(Te))||[]),this.p(re)}$provideInlineCompletions(B,L,K,H,ee){return this.s(B,ne,re=>re.provideInlineCompletions(l.URI.revive(L),K,H,ee),void 0,ee)}$handleInlineCompletionDidShow(B,L,K,H){this.s(B,ne,async ee=>{ee.handleDidShowCompletionItem(L,K,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,L,K,H,ee){this.s(B,ne,async re=>{re.handlePartialAccept(L,K,H,ee)},void 0,void 0)}$freeInlineCompletionsList(B,L){this.s(B,ne,async K=>{K.disposeCompletions(L)},void 0,void 0)}registerInlineEditProvider(B,L,K){const H=new x(B,this.h,K,this.j.converter),ee=this.t(H,B);return this.e.$registerInlineEditProvider(ee,this.o(L,B),B.identifier),this.p(ee)}$provideInlineEdit(B,L,K,H){return this.s(B,x,ee=>ee.provideInlineEdits(l.URI.revive(L),K,H),void 0,H)}$freeInlineEdit(B,L){this.s(B,x,async K=>{K.disposeEdit(L)},void 0,void 0)}registerSignatureHelpProvider(B,L,K,H){const ee=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,re=this.t(new Fe(this.h,K),B);return this.e.$registerSignatureHelpProvider(re,this.o(L,B),ee),this.p(re)}$provideSignatureHelp(B,L,K,H,ee){return this.s(B,Fe,re=>re.provideSignatureHelp(l.URI.revive(L),K,H,ee),void 0,ee)}$releaseSignatureHelp(B,L){this.s(B,Fe,K=>K.releaseSignatureHelp(L),void 0,void 0)}registerInlayHintsProvider(B,L,K){const H=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new ke(this.h,this.j.converter,K,this.l,B),B);this.e.$registerInlayHintsProvider(ee,this.o(L,B),typeof K.resolveInlayHint=="function",H,Ae.u(B));let re=this.p(ee);if(H!==void 0){const Te=K.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(H));re=c.$kM.from(re,Te)}return re}$provideInlayHints(B,L,K,H){return this.s(B,ke,ee=>ee.provideInlayHints(l.URI.revive(L),K,H),void 0,H)}$resolveInlayHint(B,L,K){return this.s(B,ke,H=>H.resolveInlayHint(L,K),void 0,K)}$releaseInlayHints(B,L){this.s(B,ke,K=>K.releaseHints(L),void 0,void 0)}registerDocumentLinkProvider(B,L,K){const H=this.t(new we(this.h,K),B);return this.e.$registerDocumentLinkProvider(H,this.o(L,B),typeof K.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(B,L,K){return this.s(B,we,H=>H.provideLinks(l.URI.revive(L),K),void 0,K,L.scheme==="output")}$resolveDocumentLink(B,L,K){return this.s(B,we,H=>H.resolveLink(L,K),void 0,void 0,!0)}$releaseDocumentLinks(B,L){this.s(B,we,K=>K.releaseLinks(L),void 0,void 0,!0)}registerColorProvider(B,L,K){const H=this.t(new me(this.h,K),B);return this.e.$registerDocumentColorProvider(H,this.o(L,B)),this.p(H)}$provideDocumentColors(B,L,K){return this.s(B,me,H=>H.provideColors(l.URI.revive(L),K),[],K)}$provideColorPresentations(B,L,K,H){return this.s(B,me,ee=>ee.provideColorPresentations(l.URI.revive(L),K,H),void 0,H)}registerFoldingRangeProvider(B,L,K){const H=this.q(),ee=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Pe(new Q(this.h,K),B)),this.e.$registerFoldingRangeProvider(H,this.o(L,B),B.identifier,ee);let re=this.p(H);if(ee!==void 0){const Te=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));re=c.$kM.from(re,Te)}return re}$provideFoldingRanges(B,L,K,H){return this.s(B,Q,ee=>ee.provideFoldingRanges(l.URI.revive(L),K,H),void 0,H)}registerSelectionRangeProvider(B,L,K){const H=this.t(new Y(this.h,K,this.l),B);return this.e.$registerSelectionRangeProvider(H,this.o(L,B)),this.p(H)}$provideSelectionRanges(B,L,K,H){return this.s(B,Y,ee=>ee.provideSelectionRanges(l.URI.revive(L),K,H),[],H)}registerCallHierarchyProvider(B,L,K){const H=this.t(new he(this.h,K),B);return this.e.$registerCallHierarchyProvider(H,this.o(L,B)),this.p(H)}$prepareCallHierarchy(B,L,K,H){return this.s(B,he,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(L),K,H)),void 0,H)}$provideCallHierarchyIncomingCalls(B,L,K,H){return this.s(B,he,ee=>ee.provideCallsTo(L,K,H),void 0,H)}$provideCallHierarchyOutgoingCalls(B,L,K,H){return this.s(B,he,ee=>ee.provideCallsFrom(L,K,H),void 0,H)}$releaseCallHierarchy(B,L){this.s(B,he,K=>Promise.resolve(K.releaseSession(L)),void 0,void 0)}registerTypeHierarchyProvider(B,L,K){const H=this.t(new ce(this.h,K),B);return this.e.$registerTypeHierarchyProvider(H,this.o(L,B)),this.p(H)}$prepareTypeHierarchy(B,L,K,H){return this.s(B,ce,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(L),K,H)),void 0,H)}$provideTypeHierarchySupertypes(B,L,K,H){return this.s(B,ce,ee=>ee.provideSupertypes(L,K,H),void 0,H)}$provideTypeHierarchySubtypes(B,L,K,H){return this.s(B,ce,ee=>ee.provideSubtypes(L,K,H),void 0,H)}$releaseTypeHierarchy(B,L){this.s(B,ce,K=>Promise.resolve(K.releaseSession(L)),void 0,void 0)}registerDocumentOnDropEditProvider(B,L,K,H){const ee=this.q();return this.f.set(ee,new Pe(new Ne(this.e,this.h,K,ee,B),B)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(L,B),(0,u.$JG)(B,"documentPaste")&&H?{supportsResolve:!!K.resolveDocumentDropEdit,dropMimeTypes:H.dropMimeTypes}:void 0),this.p(ee)}$provideDocumentOnDropEdits(B,L,K,H,ee,re){return this.s(B,Ne,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(L,l.URI.revive(K),H,ee,re)),void 0,void 0)}$resolveDropEdit(B,L,K){return this.s(B,Ne,H=>H.resolveDropEdit(L,K),{},void 0)}$releaseDropEdits(B,L){this.s(B,Ne,K=>Promise.resolve(K.releaseDropEdits(L)),void 0,void 0)}registerMappedEditsProvider(B,L,K){const H=this.t(new fe(this.h,K),B);return this.e.$registerMappedEditsProvider(H,this.o(L,B)),this.p(H)}$provideMappedEdits(B,L,K,H,ee){return this.s(B,fe,re=>Promise.resolve(re.provideMappedEdits(L,K,H,ee)),null,ee)}registerDocumentPasteEditProvider(B,L,K,H){const ee=this.q();return this.f.set(ee,new Pe(new z(this.e,this.h,K,ee,B),B)),this.e.$registerPasteEditProvider(ee,this.o(L,B),{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,supportsResolve:!!K.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(re=>re.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(B,L,K,H,ee){return this.s(B,z,re=>re.prepareDocumentPaste(l.URI.revive(L),K,H,ee),void 0,ee)}$providePasteEdits(B,L,K,H,ee,re,Te){return this.s(B,z,Be=>Be.providePasteEdits(L,l.URI.revive(K),H,ee,re,Te),void 0,Te)}$resolvePasteEdit(B,L,K){return this.s(B,z,H=>H.resolvePasteEdit(L,K),{},void 0)}$releasePasteEdits(B,L){this.s(B,z,K=>Promise.resolve(K.releasePasteEdits(L)),void 0,void 0)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:Ae.w(B.decreaseIndentPattern),increaseIndentPattern:Ae.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?Ae.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?Ae.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:Ae.w(B.beforeText),afterText:B.afterText?Ae.w(B.afterText):void 0,previousLineText:B.previousLineText?Ae.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(Ae.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(L=>c.SyntaxTokenType.toString(L)):void 0}}static D(B){return B.map(Ae.C)}setLanguageConfiguration(B,L,K){const{wordPattern:H}=K;if(H&&(0,T.$lf)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(L,H):this.h.setWordDefinitionFor(L,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const ee=this.q(),re={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Ae.w(K.wordPattern):void 0,indentationRules:K.indentationRules?Ae.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Ae.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Ae.D(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,L,re),this.p(ee)}$setWordDefinitions(B){for(const L of B)this.h.setWordDefinitionFor(L.languageId,new RegExp(L.regexSource,L.regexFlags))}}e.$8lc=Ae}),define(Se[90],Ie([1,0,11,20,14,5,42,6,175,21,3,12,103,4,86,17,8,7,108,25]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s,o,i,n){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pmc=e.$Omc=void 0,e.$Omc=(0,T.$yi)("IExtHostLanguageModels");class u{constructor(d,$){this.option=d,this.stream=new C.$2h,this.stream=$??new C.$2h}}class t{constructor(){this.a=new Map,this.b=new C.$2h,this.c=!1,this.d=!1;const d=this;this.apiObject={stream:d.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,d]of this.a)yield d.stream;else yield this.b}handleFragment(d){if(this.c)return;this.d=!0;let $=this.a.get(d.index);$||(this.a.size===0?$=new u(d.index,this.b):$=new u(d.index),this.a.set(d.index,$)),$.stream.emitOne(d.part)}get isStreaming(){return this.d}reject(d){this.c=!0;for(const $ of this.f())$.reject(d)}resolve(){this.c=!0;for(const d of this.f())d.resolve()}}let f=class{static{c=this}static{this.a=1}constructor(d,$,p){this.j=$,this.k=p,this.c=new N.$fe,this.d=new N.$fe,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new E.$Vm,this.i=new Map,this.r=new Set,this.b=d.getProxy(b.$iM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(d,$,p,v){const y=c.a++;this.f.set(y,{extension:d.identifier,provider:p,languageModelId:$});let h;v.auth&&(h={providerLabel:d.displayName||d.name,accountLabel:typeof v.auth=="object"?v.auth.label:void 0}),this.b.$registerLanguageModelProvider(y,`${E.$Tm.toKey(d.identifier)}/${y}/${$}`,{extension:d.identifier,id:$,vendor:v.vendor??E.$Tm.toKey(d.identifier),name:v.name??"",family:v.family??"",version:v.version,tokens:v.tokens,auth:h,targetExtensions:v.extensions});const D=p.onDidReceiveLanguageModelResponse2?.(({extensionId:k,participant:I,tokenCount:P})=>{this.b.$whenLanguageModelChatRequestMade($,new E.$Tm(k),I,P)});return(0,w.$Sc)(()=>{this.f.delete(y),this.b.$unregisterProvider(y),D?.dispose()})}async $provideLanguageModelResponse(d,$,p,v,y,h){const D=this.f.get(d);if(!D)return;const k=new l.$gw(async I=>{if(h.isCancellationRequested){this.j.warn(`[CHAT](${D.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk($,{index:I.index,part:I.part})});return D.provider.provideLanguageModelResponse(v.map(s.LanguageModelChatMessage.to),y,E.$Tm.toKey(p),k,h)}$provideTokenLength(d,$,p){const v=this.f.get(d);return v?Promise.resolve(v.provider.provideTokenCount($,p)):Promise.resolve(0)}$acceptChatModelMetadata(d){if(d.added)for(const{identifier:$,metadata:p}of d.added)this.g.set($,{metadata:p,apiObjects:new E.$Vm});if(d.removed)for(const $ of d.removed){this.g.delete($);for(const[p,v]of this.i)v.languageModelId===$&&(v.res.reject(new M.$5),this.i.delete(p))}d.added?.forEach($=>this.p($.metadata)),this.d.fire(void 0)}async selectLanguageModels(d,$){const p=await this.b.$selectChatModels({...$,extension:d.identifier}),v=[],y=this;for(const h of p){const D=this.g.get(h);if(!D)continue;let k=D.apiObjects.get(d.identifier);k||(k={id:h,vendor:D.metadata.vendor,family:D.metadata.family,version:D.metadata.version,name:D.metadata.name,contextSize:D.metadata.tokens,computeTokenLength(I,P){if(!y.g.has(h))throw o.$zO.NotFound(h);return y.q(h,I,P??O.CancellationToken.None)},sendRequest(I,P,V){if(!y.g.has(h))throw o.$zO.NotFound(h);return y.l(d,h,I,P??{},V??O.CancellationToken.None)}},Object.freeze(k),D.apiObjects.set(d.identifier,k)),v.push(k)}if(v.length!==0)return v}async l(d,$,p,v,y){const h=this.m(d,p),D=d.identifier,k=this.g.get($)?.metadata;if(!k||!this.g.has($))throw o.$zO.NotFound(`Language model '${$}' is unknown.`);if(this.o(D,k)&&(!await this.n(d,{identifier:k.extension,displayName:k.auth.providerLabel},v.justification,!1)||!this.h.get(D)?.has(k.extension)))throw o.$zO.NoPermissions(`Language model '${$}' cannot be used by '${D.value}'.`);const I=Math.random()*1e6|0,P=this.b.$fetchResponse(D,$,I,h,v.modelOptions??{},y),V=new C.$xh,W=new t;this.i.set(I,{languageModelId:$,res:W});let q;if(P.catch(A=>{V.isOpen()?W.reject(A):q=A}).finally(()=>{this.i.delete(I),W.resolve(),V.open()}),await V.wait(),q)throw q.name===o.$zO.name?q:new o.$zO(`Language model '${$}' errored, check cause for more details`,"Unknown",q);return W.apiObject}m(d,$){const p=[];for(const v of $)v.role===o.LanguageModelChatMessageRole.System&&(0,n.$KG)(d,"languageModelSystem"),p.push(s.LanguageModelChatMessage.from(v));return p}async $handleResponseFragment(d,$){const p=this.i.get(d);p&&p.res.handleFragment($)}async n(d,$,p,v){const y=i.$kL+$.identifier.value;if(await this.k.getSession(d,y,[],{silent:!0}))return this.$updateModelAccesslist([{from:d.identifier,to:$.identifier,enabled:!0}]),!0;if(v)return!1;try{const D=p?(0,m.localize)(0,null,$.displayName,p):(0,m.localize)(1,null,$.displayName);return await this.k.getSession(d,y,[],{forceNewSession:{detail:D}}),this.$updateModelAccesslist([{from:d.identifier,to:$.identifier,enabled:!0}]),!0}catch{return!1}}o(d,$){return!!$.auth&&!E.$Tm.equals($.extension,d)}async p(d){for(const $ of this.r)try{await this.n($,{identifier:d.extension,displayName:""},void 0,!0)}catch(p){this.j.error("Fake Auth request failed"),this.j.error(p)}}async q(d,$,p){if(!this.g.get(d))throw o.$zO.NotFound(`Language model '${d}' is unknown.`);const y=R.Iterable.find(this.f.values(),h=>h.languageModelId===d);return y?y.provider.provideTokenCount($,p):this.b.$countTokens(d,typeof $=="string"?$:s.LanguageModelChatMessage.from($),p)}$updateModelAccesslist(d){const $=new Array;for(const{from:p,to:v,enabled:y}of d){const h=this.h.get(p)??new E.$Um;if(h.has(v)!==y){y?h.add(v):h.delete(v),this.h.set(p,h);const k={from:p,to:v};$.push(k),this.c.fire(k)}}}createLanguageModelAccessInformation(d){this.r.add(d);const $=this,p=N.Event.signal(N.Event.filter(this.c.event,y=>E.$Tm.equals(y.from,d.identifier))),v=N.Event.signal(this.d.event);return{get onDidChange(){return N.Event.any(p,v)},canSendRequest(y){const h=$.g.get(y);if(!h)return;if(!$.o(d.identifier,h.metadata))return!0;const D=$.h.get(d.identifier);if(D)return D.has(h.metadata.extension)}}}};e.$Pmc=f,e.$Pmc=f=c=Je([We(0,r.$MO),We(1,S.$5j),We(2,g.$0lc)],f)}),define(Se[275],Ie([1,0,4,8,7,32,11,6,25]),function(le,e,C,O,M,N,R,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=void 0;class E{constructor(S,l,b,g){this.c=l,this.d=b,this.e=g,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(C.$iM.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,l){await this.a.$changeLanguage(S,l);const b=this.c.getDocumentData(S);if(!b)throw new Error(`document '${S.toString()}' NOT found`);return b.document}async tokenAtPosition(S,l){const b=S.version,g=O.Position.from(l),r=await this.a.$tokensAtPosition(S.uri,g),s={type:M.StandardTokenType.Other,range:S.getWordRangeAtPosition(l)??new M.$mM(l.line,l.character,l.line,l.character)};if(!r)return s;const o={range:O.Range.to(r.range),type:O.TokenType.to(r.type)};return!o.range.contains(l)||b!==S.version?s:o}createLanguageStatusItem(S,l,b){const g=this.f++,r=this.a,s=this.g,o=`${S.identifier.value}/${l}`;if(s.has(o))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);s.add(o);const i={selector:b,id:l,name:S.displayName??S.name,severity:M.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const c=new w.$Tc,u=()=>{if(n?.dispose(),!s.has(o)){console.warn(`LanguageStatusItem (${l}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$Ah)(()=>{c.clear(),this.a.$setLanguageStatus(g,{id:o,name:i.name??S.displayName??S.name,source:S.displayName??S.name,selector:O.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===M.LanguageStatusSeverity.Error?N.default.Error:i.severity===M.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:i.command&&this.d.toInternal(i.command,c),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){c.dispose(),n?.dispose(),r.$removeLanguageStatus(g),s.delete(o)},get id(){return i.id},get name(){return i.name},set name(f){i.name=f,u()},get selector(){return i.selector},set selector(f){i.selector=f,u()},get text(){return i.text},set text(f){i.text=f,u()},set text2(f){(0,m.$KG)(S,"languageStatusText"),i.text=f,u()},get text2(){return(0,m.$KG)(S,"languageStatusText"),i.text},get detail(){return i.detail},set detail(f){i.detail=f,u()},get severity(){return i.severity},set severity(f){i.severity=f,u()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(f){i.accessibilityInformation=f,u()},get command(){return i.command},set command(f){i.command=f,u()},get busy(){return i.busy},set busy(f){i.busy=f,u()}};return u(),t}}e.$unc=E}),define(Se[276],Ie([1,0,16,2,8,7,85]),function(le,e,C,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=e.$gnc=void 0;class w{constructor(S,l,b,g){this.start=S,this.deletedCount=l,this.deletedItems=b,this.items=g}asApiEvent(){return{range:new N.$MN(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1}}constructor(S,l,b){this.notebook=S,this.h=l,this.j=b,this.handle=b.handle,this.uri=O.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(M.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(M.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:M.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return S.g},set mime(g){S.g=g},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(b)}return this.f}setOutputs(S){this.a=S.map(M.NotebookCellOutput.to)}setOutputItems(S,l,b){const g=b.map(M.NotebookCellOutputItem.to),r=this.a.find(s=>s.id===S);if(r&&(l||(r.items.length=0),r.items.push(...g),r.items.length>1&&r.items.every(s=>R.$eK(s.mime)))){const s=new Map,o=[];r.items.forEach(i=>{let n;s.has(i.mime)?n=s.get(i.mime):(n=[],s.set(i.mime,n),o.push(i.mime)),n.push(i.data)}),r.items.length=0,o.forEach(i=>{const n=R.$fK(s.get(i));r.items.push({mime:i,data:n.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(M.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$gnc=m;class E{static{this.a=0}constructor(S,l,b,g,r){this.k=S,this.l=l,this.m=b,this.uri=g,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,l={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===C.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(b){return b=S.n(b),S.b[b].apiCell},getCells(b){return(b?S.p(b):S.b).map(r=>r.apiCell)},save(){return S.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,l,b){this.g=S.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:b});const g={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},r=[];for(const o of S.rawEvents)o.kind===R.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,g.contentChanges):o.kind===R.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,g.contentChanges):o.kind===R.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),r.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),r.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),r.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===R.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),r.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),r.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const s=new Map;for(let o=0;o<r.length;o++){const i=r[o],n=s.get(i.cell);if(n===void 0){const c=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});s.set(i.cell,c-1)}else g.cellChanges[n]={...g.cellChanges[n],...i}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let l=S.start|0,b=S.end|0;return l<0&&(l=0),b>this.b.length&&(b=this.b.length),S.with({start:l,end:b})}p(S){S=this.o(S);const l=[];for(let b=S.start;b<S.end;b++)l.push(this.b[b]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,l,b){if(this.j)return;const g=[],r=[],s=[];if(S.reverse().forEach(o=>{const n=o[2].map(t=>{const f=new m(this,this.l,t);return l||r.push(m.asModelAddData(t)),f}),c=new w(o[0],o[1],[],n),u=this.b.splice(o[0],o[1],...n);for(const t of u)s.push(t.uri),c.deletedItems.push(t.apiCell);g.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:s}),b)for(const o of g)b.push(o.asApiEvent())}s(S,l,b,g){const r=this.b.splice(S,l);this.b.splice(b,0,...r);const s=[new w(S,l,r.map(o=>o.apiCell),[]),new w(b,0,[],r)];for(const o of s)g.push(o.asApiEvent())}t(S,l){this.b[S].setOutputs(l)}u(S,l,b,g){this.b[S].setOutputItems(l,b,g)}v(S,l){const b=this.b[S];b.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(b.uri,l)}w(S,l){const b=this.b[S];b.apiCell.mime=l}x(S,l){this.b[S].setMetadata(l)}y(S,l){this.b[S].setInternalMetadata(l)}getCellFromApiCell(S){return this.b.find(l=>l.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(l=>l.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$hnc=E}),define(Se[277],Ie([1,0,5,2,8,7,34]),function(le,e,C,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wnc=void 0;class w{constructor(E,T,S,l={timeout:1500,errors:3}){this.b=E,this.c=T,this.d=S,this.f=l,this.a=new C.$he}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(T,S,l)=>{const b=function(r){T.call(S,r)};return b.extension=E,this.a.event(b,void 0,l)}}async $participateInSave(E,T,S){const l=O.URI.revive(E),b=this.c.getNotebookDocument(l);if(!b)throw new Error("Unable to resolve notebook document");const g=[];if(await this.a.fireAsync({notebook:b.apiNotebook,reason:M.TextDocumentSaveReason.to(T)},S,async(s,o)=>{const i=Date.now(),n=await await Promise.resolve(s);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!S.isCancellationRequested&&n&&(n instanceof N.$uM?g.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),S.isCancellationRequested)return!1;if(g.length===0)return!0;const r={edits:[]};for(const s of g){const{edits:o}=M.WorkspaceEdit.from(s);r.edits=r.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(new R.$Ew(r))}}e.$wnc=w}),define(Se[114],Ie([1,0,14,8,7]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=void 0;class N{static{this.apiEditorsToExtHost=new WeakMap}constructor(w,m,E,T,S,l){this.id=w,this.f=m,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=T,this.c=l}get apiEditor(){if(!this.e){const w=this;this.e={get notebook(){return w.notebookData.apiNotebook},get selection(){return w.a[0]},set selection(m){this.selections=[m]},get selections(){return w.a},set selections(m){if(!Array.isArray(m)||!m.every(M.$MN.isNotebookRange))throw(0,C.$7)("selections");w.a=m,w.g(m)},get visibleRanges(){return w.b},revealRange(m,E){w.f.$tryRevealRange(w.id,O.NotebookRange.from(m),E??M.NotebookEditorRevealType.Default)},get viewColumn(){return w.c}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(w){this.d=w}_acceptVisibleRanges(w){this.b=w}_acceptSelections(w){this.a=w}g(w){this.f.$trySetSelections(this.id,w.map(O.NotebookRange.from))}_acceptViewColumn(w){this.c=w}}e.$inc=N}),define(Se[278],Ie([1,0,5,12,8]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=void 0;let N=class{constructor(w,m){this.c=w,this.d=m,this.a=new C.$fe,this.b=new C.$fe,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(w,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,m);const E=this.d.getEditorById(w);m.visibleRanges&&E._acceptVisibleRanges(m.visibleRanges.ranges.map(M.NotebookRange.to)),m.selections&&E._acceptSelections(m.selections.selections.map(M.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(w){for(const m in w)this.d.getEditorById(m)._acceptViewColumn(M.ViewColumn.to(w[m]))}};e.$ync=N,e.$ync=N=Je([We(0,O.$5j)],N)}),define(Se[279],Ie([1,0,5,4,114]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bnc=void 0;class N{constructor(w,m){this.c=m,this.a=new Map,this.b=w.getProxy(O.$iM.MainThreadNotebookRenderers)}$postRendererMessage(w,m,E){const T=this.c.getEditorById(w);this.a.get(m)?.fire({editor:T.apiEditor,message:E})}createRendererMessaging(w,m){if(!w.contributes?.notebookRenderer?.some(T=>T.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(T,S,l)=>this.d(m).event(T,S,l),postMessage:(T,S)=>{M.$inc.apiEditorsToExtHost.has(T)&&([T,S]=[S,T]);const l=S&&M.$inc.apiEditorsToExtHost.get(S);return this.b.$postMessage(l?.id,m,T)}}}d(w){let m=this.a.get(w);return m||(m=new C.$fe({onDidRemoveLastListener:()=>{m?.dispose(),this.a.delete(w)}}),this.a.set(w,m),m)}}e.$Bnc=N}),define(Se[280],Ie([1,0,8,103,20,69,14]),function(le,e,C,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fnc=void 0;class w{constructor(S){this.b=0,this.c=new Map,this.a=S}async withProgress(S,l,b){const g=this.b++,{title:r,location:s,cancellable:o}=l,i={label:S.displayName||S.name,id:S.identifier.value};return this.a.$startProgress(g,{location:C.ProgressLocation.from(s),title:r,source:i,cancellable:o},S.isUnderDevelopment?void 0:S.identifier.value).catch(R.$2),this.d(g,b,!!o)}d(S,l,b){let g;b&&(g=new M.$qe,this.c.set(S,g));const r=o=>{this.a.$progressEnd(o),this.c.delete(o),g?.dispose()};let s;try{s=l(new E(this.a,S),b&&g?g.token:M.CancellationToken.None)}catch(o){throw r(S),o}return s.then(o=>r(S),o=>r(S)),s}$acceptProgressCanceled(S){const l=this.c.get(S);l&&(l.cancel(),this.c.delete(S))}}e.$Fnc=w;function m(T,S){return T.message=S.message,typeof S.increment=="number"&&(typeof T.increment=="number"?T.increment+=S.increment:T.increment=S.increment),T}class E extends O.$gw{constructor(S,l){super(b=>this.throttledReport(b)),this.c=S,this.d=l}throttledReport(S){this.c.$progressReport(this.d,S)}}Je([(0,N.$5h)(100,(T,S)=>m(T,S),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Se[281],Ie([1,0,2,4,11,8]),function(le,e,C,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gnc=void 0;class R{static{this.a=0}constructor(m,E){this.d=E,this.c=new Map,this.b=m.getProxy(O.$iM.MainThreadQuickDiff)}$provideOriginalResource(m,E,T){const S=C.URI.revive(E),l=this.c.get(m);return l?(0,M.$qh)(()=>l.provideOriginalResource(S,T)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(m,E,T,S){const l=R.a++;return this.c.set(l,E),this.b.$registerQuickDiffProvider(l,N.DocumentSelector.from(m,this.d),T,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Gnc=R}),define(Se[282],Ie([1,0,20,5,6,4,2,7,14,18,32,36,25,8]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=g;function g(r,s,o){const i=r.getProxy(N.$iM.MainThreadQuickOpen);class n{constructor(v,y){this.e=new Map,this.f=0,this.a=v,this.b=y}showQuickPick(v,y,h,D=C.CancellationToken.None){this.c=void 0;const k=Promise.resolve(y),I=++this.f,P=i.$show(I,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},D),V={},W=P.then(()=>V);return Promise.race([W,k]).then(q=>{if(q===V)return;const A=(0,l.$JG)(v,"quickPickItemTooltip");return k.then(z=>{const G=[];for(let ie=0;ie<z.length;ie++){const de=z[ie];if(typeof de=="string")G.push({label:de,handle:ie});else if(de.kind===w.QuickPickItemKind.Separator)G.push({type:"separator",label:de.label});else{de.tooltip&&!A&&console.warn(`Extension '${v.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`);const ye=de.iconPath?a(de.iconPath):void 0;G.push({label:de.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:de.description,detail:de.detail,picked:de.picked,alwaysShow:de.alwaysShow,tooltip:A?b.MarkdownString.fromStrict(de.tooltip):void 0,handle:ie})}}return h&&typeof h.onDidSelectItem=="function"&&(this.c=ie=>{h.onDidSelectItem(z[ie])}),i.$setItems(I,G),P.then(ie=>{if(typeof ie=="number")return z[ie];if(Array.isArray(ie))return ie.map(de=>z[de])})})}).then(void 0,q=>{if(!(0,m.$4)(q))return i.$setError(I,q),Promise.reject(q)})}$onItemSelected(v){this.c?.(v)}showInput(v,y=C.CancellationToken.None){return this.d=v?.validateInput,i.$input(v,typeof this.d=="function",y).then(void 0,h=>{if(!(0,m.$4)(h))return Promise.reject(h)})}async $validateInput(v){if(!this.d)return;const y=await this.d(v);if(!y||typeof y=="string")return y;let h;switch(y.severity){case w.InputBoxValidationSeverity.Info:h=T.default.Info;break;case w.InputBoxValidationSeverity.Warning:h=T.default.Warning;break;case w.InputBoxValidationSeverity.Error:h=T.default.Error;break;default:h=y.message?T.default.Error:T.default.Ignore;break}return{content:y.message,severity:h}}async showWorkspaceFolderPick(v,y=C.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[v]);if(!h)return;const D=await this.a.getWorkspaceFolders2();if(D)return D.find(k=>k.uri.toString()===h.uri.toString())}createQuickPick(v){const y=new d(v,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(v){const y=new $(v,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(v,y){this.e.get(v)?._fireDidChangeValue(y)}$onDidAccept(v){this.e.get(v)?._fireDidAccept()}$onDidChangeActive(v,y){const h=this.e.get(v);h instanceof d&&h._fireDidChangeActive(y)}$onDidChangeSelection(v,y){const h=this.e.get(v);h instanceof d&&h._fireDidChangeSelection(y)}$onDidTriggerButton(v,y){this.e.get(v)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(v,y,h){const D=this.e.get(v);D instanceof d&&D._fireDidTriggerItemButton(y,h)}$onDidHide(v){this.e.get(v)?._fireDidHide()}}class c{static{this.a=1}constructor(v,y){this.x=v,this.y=y,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$fe,this.q=new O.$fe,this.r=new O.$fe,this.s=new O.$fe,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(v){this.b=v,this.z({title:v})}get step(){return this.c}set step(v){this.c=v,this.z({step:v})}get totalSteps(){return this.d}set totalSteps(v){this.d=v,this.z({totalSteps:v})}get enabled(){return this.g}set enabled(v){this.g=v,this.z({enabled:v})}get busy(){return this.j}set busy(v){this.j=v,this.z({busy:v})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(v){this.k=v,this.z({ignoreFocusOut:v})}get value(){return this.l}set value(v){this.l=v,this.z({value:v})}get placeholder(){return this.m}set placeholder(v){this.m=v,this.z({placeholder:v})}get buttons(){return this.n}set buttons(v){this.n=v.slice(),this.o.clear(),v.forEach((y,h)=>{const D=y===w.$JN.Back?-1:h;this.o.set(D,y)}),this.z({buttons:v.map((y,h)=>({...a(y.iconPath),tooltip:y.tooltip,handle:y===w.$JN.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(v){this.l=v,this.q.fire(v)}_fireDidTriggerButton(v){const y=this.o.get(v);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,M.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(v){if(!this.v){for(const y of Object.keys(v)){const h=v[y];this.u[y]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function u(p){if(p instanceof w.$hN)return{id:p.id};const v=f(p),y=t(p);return{dark:typeof v=="string"?R.URI.file(v):v,light:typeof y=="string"?R.URI.file(y):y}}function t(p){return typeof p=="object"&&"light"in p?p.light:p}function f(p){return typeof p=="object"&&"dark"in p?p.dark:p}function a(p){const v=u(p);let y,h;return"id"in v?h=S.ThemeIcon.asClassName(v):y=v,{iconPath:y,iconClass:h}}class d extends c{constructor(v,y){super(v.identifier,y),this.O=v,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$fe,this.L=[],this.M=new O.$fe,this.N=new O.$fe,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(v){this.B=v.slice(),this.C.clear(),this.D.clear(),v.forEach((D,k)=>{this.C.set(k,D),this.D.set(D,k)});const y=(0,l.$JG)(this.O,"quickPickItemTooltip"),h=[];for(let D=0;D<v.length;D++){const k=v[D];if(k.kind===w.QuickPickItemKind.Separator)h.push({type:"separator",label:k.label});else{k.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const I=k.iconPath?a(k.iconPath):void 0;h.push({handle:D,label:k.label,iconPath:I?.iconPath,iconClass:I?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:y?b.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((P,V)=>({...a(P.iconPath),tooltip:P.tooltip,handle:V}))})}}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(v){this.E=v,this.z({canSelectMany:v})}get matchOnDescription(){return this.F}set matchOnDescription(v){this.F=v,this.z({matchOnDescription:v})}get matchOnDetail(){return this.G}set matchOnDetail(v){this.G=v,this.z({matchOnDetail:v})}get sortByLabel(){return this.H}set sortByLabel(v){this.H=v,this.z({sortByLabel:v})}get keepScrollPosition(){return this.I}set keepScrollPosition(v){this.I=v,this.z({keepScrollPosition:v})}get activeItems(){return this.J}set activeItems(v){this.J=v.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(v){this.L=v.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(v){const y=(0,E.$Hb)(v.map(h=>this.C.get(h)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(v){const y=(0,E.$Hb)(v.map(h=>this.C.get(h)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(v,y){const h=this.C.get(v);if(!h||!h.buttons||!h.buttons.length)return;const D=h.buttons[y];D&&this.N.fire({button:D,item:h})}}class $ extends c{constructor(v,y){super(v.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(v){this.B=v,this.z({password:v})}get prompt(){return this.C}set prompt(v){this.C=v,this.z({prompt:v})}get valueSelection(){return this.D}set valueSelection(v){this.D=v,this.z({valueSelection:v})}get validationMessage(){return this.E}set validationMessage(v){this.E=v,v?typeof v=="string"?this.z({validationMessage:v,severity:T.default.Error}):this.z({validationMessage:v.message,severity:v.severity??T.default.Error}):this.z({validationMessage:void 0,severity:T.default.Ignore})}}return new n(s,o)}}),define(Se[283],Ie([1,0,2,5,69,6,11,4,18,149,12,21,36,8,25,16,23]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jnc=e.$Inc=void 0;function i(I){return I instanceof C.URI}function n(I,P){return I.scheme===r.Schemas.file&&P.scheme===r.Schemas.file&&s.$k?I.toString()===P.toString():I.toString().toLowerCase()===P.toString().toLowerCase()}function c(I){if(I)return typeof I.iconPath=="string"?C.URI.file(I.iconPath):C.URI.isUri(I.iconPath)||l.ThemeIcon.isThemeIcon(I.iconPath)?I.iconPath:void 0}function u(I){if(I.icon){if(C.URI.isUri(I.icon))return I.icon;if(l.ThemeIcon.isThemeIcon(I.icon))return I.icon;{const P=I.icon;return{light:P.light,dark:P.dark}}}else return}function t(I,P){if(!I.iconPath&&!P.iconPath)return 0;if(I.iconPath){if(!P.iconPath)return 1}else return-1;const V=typeof I.iconPath=="string"?I.iconPath:C.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id,W=typeof P.iconPath=="string"?P.iconPath:C.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,E.$tr)(V,W)}function f(I,P){let V=0;if(I.strikeThrough!==P.strikeThrough)return I.strikeThrough?1:-1;if(I.faded!==P.faded)return I.faded?1:-1;if(I.tooltip!==P.tooltip)return(I.tooltip||"").localeCompare(P.tooltip||"");if(V=t(I,P),V!==0)return V;if(I.light&&P.light)V=t(I.light,P.light);else{if(I.light)return 1;if(P.light)return-1}if(V!==0)return V;if(I.dark&&P.dark)V=t(I.dark,P.dark);else{if(I.dark)return 1;if(P.dark)return-1}return V}function a(I,P){if(I.command!==P.command)return I.command<P.command?-1:1;if(I.title!==P.title)return I.title<P.title?-1:1;if(I.tooltip!==P.tooltip){if(I.tooltip!==void 0&&P.tooltip!==void 0)return I.tooltip<P.tooltip?-1:1;if(I.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(I.arguments===P.arguments)return 0;if(I.arguments)if(P.arguments){if(I.arguments.length!==P.arguments.length)return I.arguments.length-P.arguments.length}else return 1;else return-1;for(let V=0;V<I.arguments.length;V++){const W=I.arguments[V],q=P.arguments[V];if(W!==q&&!(i(W)&&i(q)&&n(W,q)))return W<q?-1:1}return 0}function d(I,P){let V=(0,E.$tr)(I.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(V!==0)return V;if(I.command&&P.command)V=a(I.command,P.command);else{if(I.command)return 1;if(P.command)return-1}if(V!==0)return V;if(I.decorations&&P.decorations)V=f(I.decorations,P.decorations);else{if(I.decorations)return 1;if(P.decorations)return-1}if(I.multiFileDiffEditorModifiedUri&&P.multiFileDiffEditorModifiedUri)V=(0,E.$tr)(I.multiFileDiffEditorModifiedUri.fsPath,P.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(I.multiFileDiffEditorModifiedUri)return 1;if(P.multiFileDiffEditorModifiedUri)return-1}if(I.multiDiffEditorOriginalUri&&P.multiDiffEditorOriginalUri)V=(0,E.$tr)(I.multiDiffEditorOriginalUri.fsPath,P.multiDiffEditorOriginalUri.fsPath,!0);else{if(I.multiDiffEditorOriginalUri)return 1;if(P.multiDiffEditorOriginalUri)return-1}return V}function $(I,P){for(let V=0;V<I.length;V++)if(I[V]!==P[V])return!1;return!0}function p(I,P){return I.command===P.command&&I.title===P.title&&I.tooltip===P.tooltip&&(I.arguments&&P.arguments?$(I.arguments,P.arguments):I.arguments===P.arguments)}function v(I,P){return(0,m.$ub)(I,P,p)}class y{#e;#t;get value(){return this.d}set value(P){P=P??"",this.#e.$setInputBoxValue(this.l,P),this.n(P)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(P){this.#e.$setInputBoxPlaceholder(this.l,P),this.f=P}get validateInput(){return(0,g.$KG)(this.k,"scmValidation"),this.g}set validateInput(P){if((0,g.$KG)(this.k,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=P,this.#e.$setValidationProviderIsEnabled(this.l,!!P)}get enabled(){return this.h}set enabled(P){P=!!P,this.h!==P&&(this.h=P,this.#e.$setInputBoxEnablement(this.l,P))}get visible(){return this.j}set visible(P){P=!!P,this.j!==P&&(this.j=P,this.#e.$setInputBoxVisibility(this.l,P))}get document(){return(0,g.$KG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(P,V,W,q,A){this.k=P,this.l=q,this.m=A,this.d="",this.e=new O.$fe,this.f="",this.h=!0,this.j=!0,this.#t=V,this.#e=W}showValidationMessage(P,V){(0,g.$KG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,P,V)}$onInputBoxValueChange(P){this.n(P)}n(P){this.d=P,this.e.fire(P)}}e.$Inc=y;class h{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(P){this.v=P,this.q.$updateGroupLabel(this.t,this.handle,P)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(P){this.p=P,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(P){this.f=[...P],this.k.fire()}constructor(P,V,W,q,A,z,G){this.q=P,this.s=V,this.t=W,this.u=q,this.v=A,this.multiDiffEditorEnableViewChanges=z,this.w=G,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$fe,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$fe,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=h.d++}getResourceState(P){return this.g.get(P)}$executeResourceCommand(P,V){const W=this.h.get(P);return W?(0,R.$qh)(()=>this.s.executeCommand(W.command,...W.arguments||[],V)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this.f].sort(d),W=(0,m.$Db)(this.o,P,d).map(z=>{const G=z.toInsert.map(ie=>{const de=this.e++;this.g.set(de,ie);const ye=ie.resourceUri;let Ee;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"||ie.command.command==="vscode.changes"){const me=new N.$Tc;Ee=this.s.converter.toInternal(ie.command,me),this.j.set(de,me)}else this.h.set(de,ie.command);const ge=(0,g.$JG)(this.w,"scmMultiDiffEditor"),ue=ge?ie.multiDiffEditorOriginalUri:void 0,Ce=ge?ie.multiFileDiffEditorModifiedUri:void 0,se=c(ie.decorations),Oe=ie.decorations&&c(ie.decorations.light)||se,ne=ie.decorations&&c(ie.decorations.dark)||se,j=[Oe,ne],x=ie.decorations&&ie.decorations.tooltip||"",ve=ie.decorations&&!!ie.decorations.strikeThrough,Fe=ie.decorations&&!!ie.decorations.faded,ke=ie.contextValue||"";return{rawResource:[de,ye,j,x,ve,Fe,ke,Ee,ue,Ce],handle:de}});return{start:z.start,deleteCount:z.deleteCount,toInsert:G}}),q=W.map(({start:z,deleteCount:G,toInsert:ie})=>[z,G,ie.map(de=>de.rawResource)]),A=W.reverse();for(const{start:z,deleteCount:G,toInsert:ie}of A){const de=ie.map(Ee=>Ee.handle),ye=this.n.splice(z,G,...de);for(const Ee of ye)this.g.delete(Ee),this.h.delete(Ee),this.j.get(Ee)?.dispose(),this.j.delete(Ee)}return this.o=P,q}dispose(){this.l=!0,this.m.fire()}}class D{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(P){this.g!==P&&(this.g=P,this.#e.$updateSourceControl(this.w,{count:P}))}get quickDiffProvider(){return this.h}set quickDiffProvider(P){this.h=P;let V;(0,g.$JG)(this.x,"quickDiffProvider")&&(V=P?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!P,quickDiffLabel:V})}get historyProvider(){return(0,g.$KG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(P){(0,g.$KG)(this.x,"scmHistoryProvider"),this.j=P,this.k.value=new N.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!P}),P&&this.k.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this.l=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(P){P!==this.m&&(this.m=P,this.#e.$updateSourceControl(this.w,{commitTemplate:P}))}get acceptInputCommand(){return this.o}set acceptInputCommand(P){this.n.value=new N.$Tc,this.o=P;const V=this.y.converter.toInternal(P,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:V})}get actionButton(){return(0,g.$KG)(this.x,"scmActionButton"),this.q}set actionButton(P){(0,g.$KG)(this.x,"scmActionButton"),this.p.value=new N.$Tc,this.q=P;const V=P!==void 0?{command:this.y.converter.toInternal(P.command,this.p.value),secondaryCommands:P.secondaryCommands?.map(W=>W.map(q=>this.y.converter.toInternal(q,this.p.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:V??null})}get statusBarCommands(){return this.t}set statusBarCommands(P){if(this.t&&P&&v(this.t,P))return;this.s.value=new N.$Tc,this.t=P;const V=(P||[]).map(W=>this.y.converter.toInternal(W,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:V})}get selected(){return this.u}constructor(P,V,W,q,A,z,G){this.x=P,this.y=q,this.z=A,this.A=z,this.B=G,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new N.$Vc,this.m=void 0,this.n=new N.$Vc,this.o=void 0,this.p=new N.$Vc,this.s=new N.$Vc,this.t=void 0,this.u=!1,this.v=new O.$fe,this.onDidChangeSelection=this.v.event,this.w=D.d++,this.C=new Map,this.D=new Set,this.#e=W;const ie=C.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${A}/scm${this.w}/input`,query:G?`rootUri=${encodeURIComponent(G.toString())}`:void 0});this.f=new y(P,V,this.#e,this.w,ie),this.#e.$registerSourceControl(this.w,A,z,G,ie)}createResourceGroup(P,V,W){const q=(0,g.$JG)(this.x,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,A=new h(this.#e,this.y,this.w,P,V,q,this.x),z=O.Event.once(A.onDidDispose)(()=>this.C.delete(A));return this.C.set(A,z),this.eventuallyAddResourceGroups(),A}eventuallyAddResourceGroups(){const P=[],V=[];for(const[W,q]of this.C){q.dispose();const A=W.onDidUpdateResourceStates(()=>{this.D.add(W),this.eventuallyUpdateResourceStates()});O.Event.once(W.onDidDispose)(()=>{this.D.delete(W),A.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.w,W.handle)}),P.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const z=W._takeResourceStateSnapshot();z.length>0&&V.push([W.handle,z]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.w,P,V),this.C.clear()}eventuallyUpdateResourceStates(){const P=[];this.D.forEach(V=>{const W=V._takeResourceStateSnapshot();W.length!==0&&P.push([V.handle,W])}),P.length>0&&this.#e.$spliceResourceStates(this.w,P),this.D.clear()}getResourceGroup(P){return this.e.get(P)}setSelectionState(P){this.u=P,this.v.fire(P)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,M.$4h)(100)],D.prototype,"eventuallyAddResourceGroups",null),Je([(0,M.$4h)(100)],D.prototype,"eventuallyUpdateResourceStates",null);let k=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(P,V,W,q){this.l=V,this.m=W,this.n=q,this.g=new Map,this.h=new S.$Vm,this.j=new O.$fe,this.e=P.getProxy(w.$iM.MainThreadSCM),this.f=P.getProxy(w.$iM.MainThreadTelemetry),V.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const z=this.g.get(A.sourceControlHandle);if(!z)return A;const G=z.getResourceGroup(A.groupHandle);return G?G.getResourceState(A.handle):A}else if(A&&A.$mid===4){const z=this.g.get(A.sourceControlHandle);return z?z.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const z=this.g.get(A.handle);return z||A}return A}})}createSourceControl(P,V,W,q){this.n.trace("ExtHostSCM#createSourceControl",P.identifier.value,V,W,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const A=o.d++,z=new D(P,this.m,this.e,this.l,V,W,q);this.g.set(A,z);const G=this.h.get(P.identifier)||[];return G.push(z),this.h.set(P.identifier,G),z}getLastInputBox(P){this.n.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const V=this.h.get(P.identifier),W=V&&V[V.length-1];return W&&W.inputBox}$provideOriginalResource(P,V,W){const q=C.URI.revive(V);this.n.trace("ExtHostSCM#$provideOriginalResource",P,q.toString());const A=this.g.get(P);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$qh)(()=>A.quickDiffProvider.provideOriginalResource(q,W)).then(z=>z||null)}$onInputBoxValueChange(P,V){this.n.trace("ExtHostSCM#$onInputBoxValueChange",P);const W=this.g.get(P);return W&&W.inputBox.$onInputBoxValueChange(V),Promise.resolve(void 0)}$executeResourceCommand(P,V,W,q){this.n.trace("ExtHostSCM#$executeResourceCommand",P,V,W);const A=this.g.get(P);if(!A)return Promise.resolve(void 0);const z=A.getResourceGroup(V);return z?z.$executeResourceCommand(W,q):Promise.resolve(void 0)}$validateInput(P,V,W){this.n.trace("ExtHostSCM#$validateInput",P);const q=this.g.get(P);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,R.$qh)(()=>q.inputBox.validateInput(V,W)).then(A=>{if(!A)return Promise.resolve(void 0);const z=b.MarkdownString.fromStrict(A.message);return z?Promise.resolve([z,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this.g.get(P)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(P,V,W,q){return await this.g.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(V,W,q)??void 0}async $provideHistoryItems(P,V,W,q){return(await this.g.get(P)?.historyProvider?.provideHistoryItems(V,W,q))?.map(G=>({...G,icon:u(G)}))??void 0}async $provideHistoryItemSummary(P,V,W,q){const A=this.g.get(P)?.historyProvider;if(typeof A?.provideHistoryItemSummary!="function")return;const z=await A.provideHistoryItemSummary(V,W,q);return z?{...z,icon:u(z)}:void 0}async $provideHistoryItemChanges(P,V,W,q){return await this.g.get(P)?.historyProvider?.provideHistoryItemChanges(V,W,q)??void 0}};e.$Jnc=k,e.$Jnc=k=o=Je([We(3,T.$5j)],k)}),define(Se[284],Ie([1,0,4,8,2]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Knc=void 0;class N{static{this.a=0}constructor(w,m){this.d=m,this.c=new Map,this.b=w.getProxy(C.$iM.MainThreadShare)}async $provideShare(w,m,E){return await this.c.get(w)?.provideShare({selection:O.Range.to(m.selection),resourceUri:M.URI.revive(m.resourceUri)},E)??void 0}registerShareProvider(w,m){const E=N.a++;return this.c.set(E,m),this.b.$registerShareProvider(E,O.DocumentSelector.from(w,this.d),m.id,m.label,m.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$Knc=N}),define(Se[285],Ie([1,0,7,4,178,6,8,15]),function(le,e,C,O,M,N,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nnc=e.$Mnc=void 0;class m{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new C.$iN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.$iN("statusBarItem.warningForeground")]])}#e;#t;constructor(l,b,g,r,s,o=C.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new N.$Tc,this.#e=l,this.#t=b,s&&r){this.c=(0,C.$WM)(r.identifier,s);const n=g.get(this.c);n&&(o=n.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(m.a++);this.e=r,this.f=s,this.g=o,this.h=this.u(i)}u(l){if((0,w.$cg)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!m.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new N.$Tc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let b;this.m?b=this.m:b=(0,M.localize)(0,null,this.e.displayName||this.e.name);let g=this.n;this.o&&(g=m.b.get(this.o.id));const r=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,b,this.k,r,this.r?.internal,g,this.o,this.g===C.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Mnc=m;class E{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,M.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const b={message:l};return this.b.unshift(b),this.c(),new C.$kM(()=>{const g=this.b.indexOf(b);g>=0&&(this.b.splice(g,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class T{constructor(l,b){this.e=new Map,this.a=l.getProxy(O.$iM.MainThreadStatusBar),this.b=b,this.c=new E(this)}$acceptStaticEntries(l){for(const b of l)this.e.set(b.entryId,b)}createStatusBarEntry(l,b,g,r){return new m(this.a,this.b,this.e,l,b,g,r)}setStatusBarMessage(l,b){const g=this.c.setMessage(l);let r;return typeof b=="number"?r=setTimeout(()=>g.dispose(),b):typeof b<"u"&&b.then(()=>g.dispose(),()=>g.dispose()),new C.$kM(()=>{g.dispose(),clearTimeout(r)})}}e.$Nnc=T}),define(Se[115],Ie([1,0,30,107,52,77,62,8,2]),function(le,e,C,O,M,N,R,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2O=e.$1O=e.$ZO=e.$YO=void 0;const E=(n,c,u,t)=>{let f=c;return{enumerable:!0,configurable:!1,get(){return f},set(a){if(!u(f,a)){const d=f;f=a,n.listener?.(t(a,d))}}}},T=(n,c)=>n===c,S={range:(n,c)=>n===c?!0:!n||!c?!1:n.isEqual(c),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(n,c)=>!(n.length!==c.length||n.some(u=>!c.find(t=>u.id===t.id)))},l=n=>c=>({op:4,update:n(c)}),b=(n,c)=>({range:(()=>{let u;const t=l(f=>({range:C.$xt.lift(w.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return u},set(f){n.listener?.({op:6}),S.range(u,f)||(u=f,n.listener?.(t(f)))}}})(),label:E(n,c,S.label,l(u=>({label:u}))),description:E(n,void 0,S.description,l(u=>({description:u}))),sortText:E(n,void 0,S.sortText,l(u=>({sortText:u}))),canResolveChildren:E(n,!1,S.canResolveChildren,u=>({op:2,state:u})),busy:E(n,!1,S.busy,l(u=>({busy:u}))),error:E(n,void 0,S.error,l(u=>({error:w.MarkdownString.fromStrict(u)||null}))),tags:E(n,[],S.tags,(u,t)=>({op:1,new:u.map(w.TestTag.from),old:t.map(w.TestTag.from)}))}),g=n=>{const c=M.$7K.fromString(n.extId),u=new s(c.controllerId,c.localId,n.label,m.URI.revive(n.uri)||void 0);return u.range=w.Range.to(n.range||void 0),u.description=n.description||void 0,u.sortText=n.sortText||void 0,u.tags=n.tags.map(t=>w.TestTag.to({id:(0,R.$aL)(t).tagId})),u},r=n=>{let c;for(const u of n.tests){const t=g(u.item);(0,O.$IO)(t).parent=c,c=t}return c};e.$YO=r;class s{constructor(c,u,t,f){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const a=(0,O.$HO)(this,c);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof o?void 0:a.parent}},children:{value:(0,N.$GO)(a,O.$IO,s),enumerable:!0,writable:!1},...b(a,t)})}}e.$ZO=s;class o extends s{constructor(c,u){super(c,c,u,void 0),this._isRoot=!0}}e.$1O=o;class i extends N.$CO{constructor(c,u,t){super({controllerId:c,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:O.$IO,getChildren:f=>f.children,root:new o(c,u),toITestItem:w.TestItem.from})}}e.$2O=i}),define(Se[35],Ie([1,0,15,7,8,26,4,18,12,49,30,94,2,6,3,17,115,22,34,44,66,59,63,33]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s,o,i,n,c,u,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aP=e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=void 0;let a=class{#e;#t;#i;constructor(h,D,k){this.b=new Map,this.c=new Map,this.#e=h.getProxy(R.$iM.MainThreadCommands),this.d=D,this.#i=k,this.#t=h.getProxy(R.$iM.MainThreadTelemetry),this.converter=new d(this,I=>{const P=this.c.get(I);return P?.result===p.Void?P:void 0},D),this.f=[{processArgument(I){return(0,E.$8h)(I)}},{processArgument(I){return(0,N.$7n)(I,function(P){if(T.$xt.isIRange(P))return M.Range.to(P);if(S.$wt.isIPosition(P))return M.Position.to(P);if(T.$xt.isIRange(P.range)&&l.URI.isUri(P.uri))return M.location.to(P);if(P instanceof o.$He)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(h){this.f.push(h)}registerApiCommand(h){const D=this.registerCommand(!1,h.id,async(...k)=>{const I=h.args.map((V,W)=>{if(!V.validate(k[W]))throw new Error(`Invalid argument '${V.name}' when running '${h.id}', received: ${typeof k[W]=="object"?JSON.stringify(k[W],null,"	"):k[W]} `);return V.convert(k[W])}),P=await this.executeCommand(h.internalId,...I);return h.result.convert(P,k,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this.c.set(h.id,h),new O.$kM(()=>{D.dispose(),this.c.delete(h.id)})}registerCommand(h,D,k,I,P,V){if(this.d.trace("ExtHostCommands#registerCommand",D),!D.trim().length)throw new Error("invalid id");if(this.b.has(D))throw new Error(`command '${D}' already exists`);return this.b.set(D,{callback:k,thisArg:I,metadata:P,extension:V}),h&&this.#e.$registerCommand(D),new O.$kM(()=>{this.b.delete(D)&&h&&this.#e.$unregisterCommand(D)})}executeCommand(h,...D){return this.d.trace("ExtHostCommands#executeCommand",h),this.g(h,D,!0)}async g(h,D,k){if(this.b.has(h))return this.#e.$fireCommandActivationEvent(h),this.h(h,D,!1);{let I=!1;const P=(0,N.$7n)(D,function(V){if(V instanceof O.$lM)return M.Position.from(V);if(V instanceof O.$mM)return M.Range.from(V);if(V instanceof O.$wM)return M.location.from(V);if(O.$MN.isNotebookRange(V))return M.NotebookRange.from(V);if(V instanceof ArrayBuffer)return I=!0,o.$He.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return I=!0,o.$He.wrap(V);if(V instanceof o.$He)return I=!0,V;if(!Array.isArray(V))return V});try{const V=await this.#e.$executeCommand(h,I?new i.$Ew(P):P,k);return(0,E.$8h)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(h,D,!1);throw V}}}async h(h,D,k){const I=this.b.get(h);if(!I)throw new Error("Unknown command");const{callback:P,thisArg:V,metadata:W}=I;if(W?.args)for(let A=0;A<W.args.length;A++)try{(0,C.$pg)(D[A],W.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${W.args[A].name}' - ${W.args[A].description}`)}const q=c.$be.create();try{return await P.apply(V,D)}catch(A){if(h===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...D);z&&(h=z.command)}if(this.d.error(A,h,I.extension?.identifier),!k)throw A;if(I.extension?.identifier){const z=this.#i.onExtensionError(I.extension.identifier,A);this.d.trace("forwarded error to extension?",z,I.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$jj)(A)),this.id=h,this.source=I.extension?.displayName??I.extension?.name}}}finally{this.j(I,h,q.elapsed())}}j(h,D,k){h.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:h.extension.identifier.value,id:new u.$ip(D),duration:k})}$executeContributedCommand(h,...D){this.d.trace("ExtHostCommands#$executeContributedCommand",h);const k=this.b.get(h);return k?(D=D.map(I=>this.f.reduce((P,V)=>V.processArgument(P,k.extension?.identifier),I)),this.h(h,D,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this.d.trace("ExtHostCommands#getCommands",h),this.#e.$getCommands().then(D=>(h&&(D=D.filter(k=>k[0]!=="_")),D))}$getContributedCommandMetadata(){const h=Object.create(null);for(const[D,k]of this.b){const{metadata:I}=k;I&&(h[D]=I)}return Promise.resolve(h)}};e.$8O=a,e.$8O=a=Je([We(0,r.$MO),We(1,m.$5j),We(2,t.$7O)],a),e.$9O=(0,g.$yi)("IExtHostCommands");class d{constructor(h,D,k){this.d=h,this.f=D,this.g=k,this.delegatingCommandId=`__vsc${(0,f.$Ug)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(h,D){if(!h)return;const k={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return k;const I=this.f(h.command);if(I)k.id=I.internalId,k.arguments=I.args.map((P,V)=>P.convert(h.arguments&&h.arguments[V]));else if((0,w.$Lb)(h.arguments)){const P=`${h.command} /${++this.c}`;this.b.set(P,h),D.add((0,b.$Sc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),k.$ident=P,k.id=this.delegatingCommandId,k.arguments=[P],this.g.trace("CommandsConverter#CREATE",h.command,P)}return k}fromInternal(h){return typeof h.$ident=="string"?this.b.get(h.$ident):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this.b.get(h[0])}h(...h){const D=this.getActualCommand(...h);return this.g.trace("CommandsConverter#EXECUTE",h[0],D?D.command:"MISSING"),D?this.d.executeCommand(D.command,...D.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${h[0]}`)}}e.$0O=d;class ${static{this.Uri=new $("uri","Uri of a text document",h=>l.URI.isUri(h),h=>h)}static{this.Position=new $("position","A position in a text document",h=>O.$lM.isPosition(h),M.Position.from)}static{this.Range=new $("range","A range in a text document",h=>O.$mM.isRange(h),M.Range.from)}static{this.Selection=new $("selection","A selection in a text document",h=>O.$nM.isSelection(h),M.Selection.from)}static{this.Number=new $("number","",h=>typeof h=="number",h=>h)}static{this.String=new $("string","",h=>typeof h=="string",h=>h)}static{this.StringArray=$.Arr($.String)}static Arr(h){return new $(`${h.name}_array`,`Array of ${h.name}, ${h.description}`,D=>Array.isArray(D)&&D.every(k=>h.validate(k)),D=>D.map(k=>h.convert(k)))}static{this.CallHierarchyItem=new $("item","A call hierarchy item",h=>h instanceof O.$IM,M.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new $("item","A type hierarchy item",h=>h instanceof O.$7N,M.TypeHierarchyItem.from)}static{this.TestItem=new $("testItem","A VS Code TestItem",h=>h instanceof s.$ZO,M.TestItem.from)}constructor(h,D,k,I){this.name=h,this.description=D,this.validate=k,this.convert=I}optional(){return new $(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,D){return new $(h??this.name,D??this.description,this.validate,this.convert)}}e.$$O=$;class p{static{this.Void=new p("no result",h=>h)}constructor(h,D){this.description=h,this.convert=D}}e.$_O=p;class v{constructor(h,D,k,I,P){this.id=h,this.internalId=D,this.description=k,this.args=I,this.result=P}}e.$aP=v}),define(Se[286],Ie([1,0,18,16,2,89,98,31,35,8,7]),function(le,e,C,O,M,N,R,w,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=void 0;const S=[new m.$aP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$$O.Uri,m.$$O.Position],new m.$_O("A promise that resolves to an array of DocumentHighlight-instances.",b(E.DocumentHighlight.to))),new m.$aP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$$O.Uri],new m.$_O("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,s)=>{if((0,C.$Kb)(r))return;class o extends T.$DM{static to(n){const c=new o(n.name,E.SymbolKind.to(n.kind),n.containerName||"",new T.$wM(s[0],E.Range.to(n.range)));return c.detail=n.detail,c.range=c.location.range,c.selectionRange=E.Range.to(n.selectionRange),c.children=n.children?n.children.map(o.to):[],c}}return r.map(o.to)})),new m.$aP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$$O.Uri,new m.$$O("options","Formatting options",r=>!0,r=>r)],new m.$_O("A promise that resolves to an array of TextEdits.",b(E.TextEdit.to))),new m.$aP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$$O.Uri,m.$$O.Range,new m.$$O("options","Formatting options",r=>!0,r=>r)],new m.$_O("A promise that resolves to an array of TextEdits.",b(E.TextEdit.to))),new m.$aP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$$O.Uri,m.$$O.Position,new m.$$O("ch","Trigger character",r=>typeof r=="string",r=>r),new m.$$O("options","Formatting options",r=>!0,r=>r)],new m.$_O("A promise that resolves to an array of TextEdits.",b(E.TextEdit.to))),new m.$aP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$$O.Uri,m.$$O.Position],new m.$_O("A promise that resolves to an array of Location or LocationLink instances.",g)),new m.$aP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$$O.Uri,m.$$O.Position],new m.$_O("A promise that resolves to an array of Location or LocationLink instances.",g)),new m.$aP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$$O.Uri,m.$$O.Position],new m.$_O("A promise that resolves to an array of Location or LocationLink instances.",g)),new m.$aP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$$O.Uri,m.$$O.Position],new m.$_O("A promise that resolves to an array of Location or LocationLink instances.",g)),new m.$aP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$$O.Uri,m.$$O.Position],new m.$_O("A promise that resolves to an array of Location-instances.",b(E.location.to))),new m.$aP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$$O.Uri,m.$$O.Position],new m.$_O("A promise that resolves to an array of Hover-instances.",b(E.Hover.to))),new m.$aP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$$O.Uri,new m.$$O("position","A position in a text document",r=>Array.isArray(r)&&r.every(s=>T.$lM.isPosition(s)),r=>r.map(E.Position.from))],new m.$_O("A promise that resolves to an array of ranges.",r=>r.map(s=>{let o;for(const i of s.reverse())o=new T.$HM(E.Range.to(i),o);return o}))),new m.$aP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$$O.String.with("query","Search string")],new m.$_O("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(E.WorkspaceSymbol.to))),new m.$aP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$$O.Uri,m.$$O.Position],new m.$_O("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(E.CallHierarchyItem.to))),new m.$aP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$$O.CallHierarchyItem],new m.$_O("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(E.CallHierarchyIncomingCall.to))),new m.$aP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$$O.CallHierarchyItem],new m.$_O("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(E.CallHierarchyOutgoingCall.to))),new m.$aP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$$O.Uri,m.$$O.Position],new m.$_O("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:E.Range.to(r.range),placeholder:r.text}})),new m.$aP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$$O.Uri,m.$$O.Position,m.$$O.String.with("newName","The new symbol name")],new m.$_O("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return E.WorkspaceEdit.to(r)}})),new m.$aP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$$O.Uri,m.$$O.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$_O("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(E.DocumentLink.to))),new m.$aP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$$O.Uri],new m.$_O("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new T.$DN(r.tokenTypes,r.tokenModifiers)})),new m.$aP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$$O.Uri],new m.$_O("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,R.$Bbb)(r);if(s.type==="full")return new T.$FN(s.data,void 0)})),new m.$aP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$$O.Uri,m.$$O.Range.optional()],new m.$_O("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new T.$DN(r.tokenTypes,r.tokenModifiers)})),new m.$aP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$$O.Uri,m.$$O.Range],new m.$_O("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,R.$Bbb)(r);if(s.type==="full")return new T.$FN(s.data,void 0)})),new m.$aP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$$O.Uri,m.$$O.Position,m.$$O.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$$O.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$_O("A promise that resolves to a CompletionList-instance.",(r,s,o)=>{if(!r)return new T.$TM([]);const i=r.suggestions.map(n=>E.CompletionItem.to(n,o));return new T.$TM(i,r.incomplete)})),new m.$aP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$$O.Uri,m.$$O.Position,m.$$O.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$_O("A promise that resolves to SignatureHelp.",r=>{if(r)return E.SignatureHelp.to(r)})),new m.$aP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$$O.Uri,m.$$O.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$_O("A promise that resolves to an array of CodeLens-instances.",(r,s,o)=>b(i=>new T.$LM(E.Range.to(i.range),i.command&&o.fromInternal(i.command)))(r))),new m.$aP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$$O.Uri,new m.$$O("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>T.$mM.isRange(r),r=>T.$nM.isSelection(r)?E.Selection.from(r):E.Range.from(r)),m.$$O.String.with("kind","Code action kind to return code actions for").optional(),m.$$O.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$_O("A promise that resolves to an array of Command-instances.",(r,s,o)=>b(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(i.command)}else{const n=new T.$FM(i.title,i.kind?new T.$GM(i.kind):void 0);return i.edit&&(n.edit=E.WorkspaceEdit.to(i.edit)),i.command&&(n.command=o.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(r))),new m.$aP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$$O.Uri],new m.$_O("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(s=>new T.$ZM(E.Range.to(s.range),E.Color.to(s.color))):[])),new m.$aP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$$O("color","The color to show and insert",r=>r instanceof T.$YM,E.Color.from),new m.$$O("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:E.Range.from(r.range)}))],new m.$_O("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(E.ColorPresentation.to):[])),new m.$aP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$$O.Uri,m.$$O.Range],new m.$_O("A promise that resolves to an array of Inlay objects",(r,s,o)=>r.map(E.InlayHint.to.bind(void 0,o)))),new m.$aP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$$O.Uri],new m.$_O("A promise that resolves to an array of FoldingRange objects",(r,s)=>{if(r)return r.map(E.FoldingRange.to)})),new m.$aP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$_O("A promise that resolves to an array of NotebookContentProvider static info objects.",b(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(s=>E.NotebookExclusiveDocumentPattern.to(s))})))),new m.$aP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$$O.Uri,m.$$O.Range,new m.$$O("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof T.$mM,r=>E.InlineValueContext.from(r))],new m.$_O("A promise that resolves to an array of InlineValue objects",r=>r.map(E.InlineValue.to))),new m.$aP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$$O("uriOrString","Uri-instance or string (only http/https)",r=>M.URI.isUri(r)||typeof r=="string"&&(0,O.$Ig)(r,O.Schemas.http,O.Schemas.https),r=>r),new m.$$O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[E.ViewColumn.from(r),void 0]:[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)])).optional(),m.$$O.String.with("label","").optional()],m.$_O.Void),new m.$aP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$$O.Uri.with("resource","Resource to open"),m.$$O.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$$O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[E.ViewColumn.from(r),void 0]:[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)])).optional()],m.$_O.Void),new m.$aP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$$O.Uri.with("left","Left-hand side resource of the diff editor"),m.$$O.Uri.with("right","Right-hand side resource of the diff editor"),m.$$O.String.with("title","Human readable title for the diff editor").optional(),new m.$$O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)]).optional()],m.$_O.Void),new m.$aP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$$O.String.with("title","Human readable title for the changes editor"),new m.$$O("resourceList","List of resources to compare",r=>{for(const s of r){if(s.length!==3)return!1;const[o,i,n]=s;if(!M.URI.isUri(o)||!M.URI.isUri(i)&&i!==void 0&&i!==null||!M.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},r=>r)],m.$_O.Void),new m.$aP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$$O.Uri,m.$$O.Position],new m.$_O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new m.$aP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$$O.TypeHierarchyItem],new m.$_O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new m.$aP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$$O.TypeHierarchyItem],new m.$_O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new m.$aP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$$O.TestItem],m.$_O.Void),new m.$aP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$$O.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$_O.Void),new m.$aP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$$O.String.with("name","The context key name"),new m.$$O("value","The context key value",()=>!0,r=>r)],m.$_O.Void),new m.$aP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$$O.Uri,m.$$O.StringArray,new m.$$O("MappedEditsContext","Mapped Edits Context",r=>E.MappedEditsContext.is(r),r=>E.MappedEditsContext.from(r))],new m.$_O("A promise that resolves to a workspace edit or null",r=>r?E.WorkspaceEdit.to(r):null)),new m.$aP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$$O("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?E.Range.from(r.initialRange):void 0,initialSelection:T.$nM.isSelection(r.initialSelection)?E.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?E.Position.from(r.position):void 0}})],m.$_O.Void)];class l{static register(s){S.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",w.$xj)}}e.$9lc=l;function b(r){return s=>{if(Array.isArray(s))return s.map(r)}}function g(r){if(!Array.isArray(r))return;const s=[];for(const o of r)N.$cu(o)?s.push(E.DefinitionLink.to(o)):s.push(E.location.to(o));return s}}),define(Se[287],Ie([1,0,2,35]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=void 0;class M{constructor(R,w,m,E,T){this.a=w,this.b=m,this.c=E;const S=new O.$aP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$$O("showOptions","Show Options",l=>!0,l=>l),new O.$$O("resource","Interactive resource Uri",l=>!0,l=>l),new O.$$O("controllerId","Notebook controller Id",l=>!0,l=>l),new O.$$O("title","Interactive editor title",l=>!0,l=>l)],new O.$_O("Notebook and input URI",l=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const b=this.a.getEditorById(l.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:C.URI.revive(l.notebookUri),inputUri:C.URI.revive(l.inputUri),notebookEditor:b.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:C.URI.revive(l.notebookUri),inputUri:C.URI.revive(l.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(R,w,m,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:w,lines:[""],languageId:m,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,w){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$snc=M}),define(Se[288],Ie([1,0,18,11,20,5,6,28,2,21,12,4,35,8,7,78,229,25,34,230]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s,o,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$znc=void 0,e.$Anc=$;let c=class{constructor(v,y,h,D,k){this.m=y,this.n=h,this.o=D,this.q=k,this.b=new w.$Ac,this.c=new w.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new N.$fe,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=v.getProxy(S.$iM.MainThreadNotebookKernels);const I=new l.$aP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$$O("options","Select kernel options",V=>!0,V=>{if(V&&"notebookEditor"in V&&"id"in V){const W=this.n.getIdByEditor(V.notebookEditor);return{id:V.id,extension:V.extension,notebookEditorId:W}}else if(V&&"notebookEditor"in V){const W=this.n.getIdByEditor(V.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${V.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return V})],l.$_O.Void),P=new l.$aP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$$O.Uri],new l.$_O("A promise that resolves to an array of variables",(V,W)=>V.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(I),this.o.registerApiCommand(P)}createNotebookController(v,y,h,D,k,I){for(const se of this.j.values())if(se.controller.id===y&&E.$Tm.equals(v.identifier,se.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const P=this.k++,V=this;this.q.trace(`NotebookController[${P}], CREATED by ${v.identifier.value}, ${y}`);const W=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${v.identifier}'`);let q=!1;const A=new N.$fe,z=new N.$fe,G={id:$(v.identifier,y),notebookType:h,extensionId:v.identifier,extensionLocation:v.extensionLocation,label:D||v.identifier.value,preloads:I?I.map(b.NotebookRendererScript.from):[]};let ie=k??W,de,ye;this.a.$addKernel(P,G).catch(se=>{console.log(se),q=!0});let Ee=0;const ge=()=>{if(q)return;const se=++Ee;Promise.resolve().then(()=>{se===Ee&&this.a.$updateKernel(P,G)})},ue=new w.$Ac,Ce={get id(){return y},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return G.label},set label(se){G.label=se??v.displayName??v.name,ge()},get detail(){return G.detail??""},set detail(se){G.detail=se,ge()},get description(){return G.description??""},set description(se){G.description=se,ge()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(se){G.supportedLanguages=se,ge()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(se){G.supportsExecutionOrder=se,ge()},get rendererScripts(){return G.preloads?G.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(se){ie=se??W},get interruptHandler(){return de},set interruptHandler(se){de=se,G.supportsInterrupt=!!se,ge()},set variableProvider(se){(0,o.$KG)(v,"notebookVariableProvider"),ye=se,G.hasVariableProvider=!!se,se?.onDidChangeVariables(Oe=>V.a.$variablesUpdated(Oe.uri)),ge()},get variableProvider(){return ye},createNotebookCellExecution(se){if(q)throw new Error("notebook controller is DISPOSED");if(!ue.has(se.notebook.uri))throw V.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(Oe=>Oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.notebook.uri.toString()}`);return V._createNotebookCellExecution(se,$(v.identifier,this.id))},createNotebookExecution(se){if((0,o.$KG)(v,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!ue.has(se.uri))throw V.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(Oe=>Oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.uri.toString()}`);return V._createNotebookExecution(se,$(v.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${P}], DISPOSED`),q=!0,this.j.delete(P),A.dispose(),z.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(se,Oe){Oe===g.NotebookControllerAffinity2.Hidden&&(0,o.$KG)(v,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(P,se.uri,Oe)},onDidReceiveMessage:z.event,postMessage(se,Oe){return(0,o.$KG)(v,"notebookMessaging"),V.a.$postMessage(P,Oe&&V.n.getIdByEditor(Oe),se)},asWebviewUri(se){return(0,o.$KG)(v,"notebookMessaging"),(0,r.$_Ab)(se,V.m.remote)}};return this.j.set(P,{extensionId:v.identifier,controller:Ce,onDidReceiveMessage:z,onDidChangeSelection:A,associatedNotebooks:ue}),Ce}getIdByController(v){for(const[y,h]of this.j)if(h.controller===v)return $(h.extensionId,v.id);return null}createNotebookControllerDetectionTask(v,y){const h=this.g++,D=this;this.q.trace(`NotebookControllerDetectionTask[${h}], CREATED by ${v.identifier.value}`),this.a.$addKernelDetectionTask(h,y);const k={dispose:()=>{this.f.delete(h),D.a.$removeKernelDetectionTask(h)}};return this.f.set(h,k),k}registerKernelSourceActionProvider(v,y,h){const D=this.i++,k=typeof h.onDidChangeNotebookKernelSourceActions=="function"?D:void 0,I=this;this.h.set(D,h),this.q.trace(`NotebookKernelSourceActionProvider[${D}], CREATED by ${v.identifier.value}`),this.a.$addKernelSourceActionProvider(D,D,y);let P;return k!==void 0&&(P=h.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(D),I.a.$removeKernelSourceActionProvider(D,D),P?.dispose()}}}async $provideKernelSourceActions(v,y){const h=this.h.get(v);if(h){const D=new R.$Tc;return(await h.provideNotebookKernelSourceActions(y)??[]).map(I=>b.NotebookKernelSourceAction.from(I,this.o.converter,D))}return[]}$acceptNotebookAssociation(v,y,h){const D=this.j.get(v);if(D){const k=this.n.getNotebookDocument(m.URI.revive(y));h?D.associatedNotebooks.set(k.uri,!0):D.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${v}] ASSOCIATE notebook`,k.uri.toString(),h),D.onDidChangeSelection.fire({selected:h,notebook:k.apiNotebook})}}async $executeCells(v,y,h){const D=this.j.get(v);if(!D)return;const k=this.n.getNotebookDocument(m.URI.revive(y)),I=[];for(const P of h){const V=k.getCell(P);V&&I.push(V.apiCell)}try{this.q.trace(`NotebookController[${v}] EXECUTE cells`,k.uri.toString(),I.length),await D.controller.executeHandler.call(D.controller,I,k.apiNotebook,D.controller)}catch(P){this.q.error(`NotebookController[${v}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(v,y,h){const D=this.j.get(v);if(!D)return;const k=this.n.getNotebookDocument(m.URI.revive(y));if(D.controller.interruptHandler)await D.controller.interruptHandler.call(D.controller,k.apiNotebook);else for(const I of h){const P=k.getCell(I);P&&this.b.get(P.uri)?.cancel()}if(D.controller.interruptHandler){const I=this.c.get(k.uri);this.c.delete(k.uri),h.length&&Array.isArray(I)&&I.length&&I.forEach(P=>P.dispose())}}async $provideVariables(v,y,h,D,k,I,P){const V=this.j.get(v);if(!V)return;const W=this.n.getNotebookDocument(m.URI.revive(h)),q=V.controller.variableProvider;if(!q)return;let A;if(D!==void 0){if(A=this.s[D],!A)return}else this.s={};const z=k==="named"?g.NotebookVariablesRequestKind.Named:g.NotebookVariablesRequestKind.Indexed,G=q.provideVariables(W.apiNotebook,A,z,I,P);let ie=0;for await(const de of G){if(P.isCancellationRequested)return;const ye={id:this.r++,name:de.variable.name,value:de.variable.value,type:de.variable.type,interfaces:de.variable.interfaces,language:de.variable.language,expression:de.variable.expression,hasNamedChildren:de.hasNamedChildren,indexedChildrenCount:de.indexedChildrenCount,extensionId:V.extensionId.value};if(this.s[ye.id]=de.variable,this.a.$receiveVariable(y,ye),ie++>=n.$Tib)return}}$acceptKernelMessageFromRenderer(v,y,h){const D=this.j.get(v);if(!D)return;const k=this.n.getEditorById(y);D.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:h}))}$cellExecutionChanged(v,y,h){const k=this.n.getNotebookDocument(m.URI.revive(v)).getCell(y);if(k){const I=h?b.NotebookCellExecutionState.to(h):g.NotebookCellExecutionState.Idle;I!==void 0&&this.l.fire({cell:k.apiCell,state:I})}}_createNotebookCellExecution(v,y){if(v.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const D=this.n.getNotebookDocument(v.notebook.uri).getCellFromApiCell(v);if(!D)throw new Error("invalid cell");if(this.b.has(D.uri))throw new Error(`duplicate execution for ${D.uri}`);const k=new t(y,D,this.a);this.b.set(D.uri,k);const I=k.onDidChangeState(()=>{k.state===u.Resolved&&(k.dispose(),I.dispose(),this.b.delete(D.uri))});return k.asApiObject()}_createNotebookExecution(v,y){const h=this.n.getNotebookDocument(v.uri),D=v.getCells().find(P=>{const V=h.getCellFromApiCell(P);return V&&this.b.has(V.uri)});if(D)throw new Error(`duplicate cell execution for ${D.document.uri}`);if(this.c.has(h.uri))throw new Error(`duplicate notebook execution for ${h.uri}`);const k=new a(y,h,this.a),I=k.onDidChangeState(()=>{k.state===f.Resolved&&(k.dispose(),I.dispose(),this.c.delete(h.uri))});return this.c.set(h.uri,[k,I]),k.asApiObject()}};e.$znc=c,e.$znc=c=Je([We(4,T.$5j)],c);var u;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(u||(u={}));class t extends R.$Uc{static{this.a=0}get state(){return this.f}constructor(v,y,h){super(),this.m=y,this.n=h,this.b=t.a++,this.c=new N.$fe,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new M.$qe),this.h=new d(10,D=>this.s(D)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,v,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(v){await this.h.addItem(v)}async s(v){const y=Array.isArray(v)?v:[v];return this.n.$updateExecution(this.b,new i.$Ew(y))}t(){if(this.f===u.Init)throw new Error("Must call start before modifying cell output");if(this.f===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(v){let y=this.m;if(v&&(y=this.m.notebook.getCellFromApiCell(v)),!y)throw new Error("INVALID cell");return y.handle}y(v){return v.map(y=>{const h=g.$QN.ensureUniqueMimeTypes(y.items,!0);return h===y.items?b.NotebookCellOutput.from(y):b.NotebookCellOutput.from({items:h,id:y.id,metadata:y.metadata})})}async z(v,y,h){const D=this.w(y),k=this.y((0,C.$2b)(v));return this.r({editType:s.CellExecutionUpdateType.Output,cellHandle:D,append:h,outputs:k})}async C(v,y,h){return v=g.$QN.ensureUniqueMimeTypes((0,C.$2b)(v),!0),this.r({editType:s.CellExecutionUpdateType.OutputItems,items:v.map(b.NotebookCellOutputItem.from),outputId:y.id,append:h})}asApiObject(){const v=this;return Object.freeze({get token(){return v.g.token},get cell(){return v.m.apiCell},get executionOrder(){return v.j},set executionOrder(h){v.j=h,v.s([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:v.j}])},start(h){if(v.f===u.Resolved||v.f===u.Started)throw new Error("Cannot call start again");v.f=u.Started,v.c.fire(),v.s({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:h})},end(h,D,k){if(v.f===u.Resolved)throw new Error("Cannot call resolve twice");v.f=u.Resolved,v.c.fire(),v.h.flush();const I=k?{message:k.message,stack:k.stack,location:k?.location?{startLineNumber:k.location.start.line,startColumn:k.location.start.character,endLineNumber:k.location.end.line,endColumn:k.location.end.character}:void 0,uri:k.uri}:void 0;v.n.$completeExecution(v.b,new i.$Ew({runEndTime:D,lastRunSuccess:h,error:I}))},clearOutput(h){return v.t(),v.z([],h,!1)},appendOutput(h,D){return v.t(),v.z(h,D,!0)},replaceOutput(h,D){return v.t(),v.z(h,D,!1)},appendOutputItems(h,D){return v.t(),v.C(h,D,!0)},replaceOutputItems(h,D){return v.t(),v.C(h,D,!1)}})}}var f;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(f||(f={}));class a extends R.$Uc{static{this.a=0}get state(){return this.f}constructor(v,y,h){super(),this.h=y,this.j=h,this.b=a.a++,this.c=new N.$fe,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new M.$qe),this.j.$createNotebookExecution(this.b,v,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===f.Resolved||this.f===f.Started)throw new Error("Cannot call start again");this.f=f.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===f.Resolved)throw new Error("Cannot call resolve twice");this.f=f.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(v,y){this.f=v,this.g=y,this.a=[],this.b=Date.now()}addItem(v){return this.a.push(v),this.c||(this.c=new O.$Vh,this.b=Date.now(),(0,O.$zh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const v=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>v.complete())}}function $(p,v){return`${p.value}/${v}`}}),define(Se[53],Ie([1,0,5,4,3,2,17,6,7,180,14,208,20,33,209,36,11,8,35]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nmc=e.$Mmc=e.$Lmc=e.$Kmc=void 0,e.$Kmc=(0,M.$yi)("IExtHostTerminalService");class n extends w.$Uc{constructor(h,D,k,I){super(),this.u=h,this._id=D,this.w=k,this.y=I,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new C.$fe),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(V=>this.g=V);const P=this;this.value={get name(){return P.y||""},get processId(){return P.b},get creationOptions(){return P.w},get exitStatus(){return P.j},get state(){return P.m},get selection(){return P.n},get shellIntegration(){return P.shellIntegration},sendText(V,W=!0){P.C(),P.u.$sendText(P._id,V,W)},show(V){P.C(),P.u.$show(P._id,V)},hide(){P.C(),P.u.$hide(P._id)},dispose(){P.a||(P.a=!0,P.u.$dispose(P._id))},get dimensions(){if(!(P.f===void 0||P.h===void 0))return{columns:P.f,rows:P.h}}}}dispose(){this.s.fire(),super.dispose()}async create(h,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??D?.cwd??void 0,env:h.env??void 0,icon:$(h.iconPath)??void 0,color:r.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,forceShellIntegration:D?.forceShellIntegration??void 0,isFeatureTerminal:D?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:D?.useShellEnvironment??void 0,location:D?.location||this.z(h.location,D?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,D,k,I,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:I,color:r.ThemeColor.isThemeColor(P)?P.id:void 0,location:D?.location||this.z(h,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(h,D){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&D?{parentTerminal:D}:"viewColumn"in h?{viewColumn:o.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(h){this.y=h}setExitStatus(h,D){this.j=Object.freeze({code:h,reason:D})}setDimensions(h,D){return h===this.f&&D===this.h||h===0||D===0?!1:(this.f=h,this.h=D,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(h){this.n=h}_setProcessId(h){this.g?(this.g(h),this.g=void 0):this.b.then(D=>{D!==h&&(this.b=Promise.resolve(h))})}}e.$Lmc=n;class c{get onProcessReady(){return this.b.event}constructor(h){this.g=h,this.id=0,this.shouldPersist=!1,this.a=new C.$fe,this.onProcessData=this.a.event,this.b=new C.$fe,this.d=new C.$fe,this.onDidChangeProperty=this.d.event,this.f=new C.$fe,this.onProcessExit=this.f.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,D){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${D}`)}async start(){}shutdown(){this.g.close()}input(h){this.g.handleInput?.(h)}resize(h,D){this.g.setDimensions?.({columns:h,rows:D})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this.g.onDidWrite(D=>this.a.fire(D)),this.g.onDidClose?.((D=void 0)=>{this.f.fire(D===void 0?void 0:D)}),this.g.onDidOverrideDimensions?.(D=>{D&&this.d.fire({type:"overrideDimensions",value:{cols:D.columns,rows:D.rows}})}),this.g.onDidChangeName?.(D=>{this.d.fire({type:"title",value:D})}),this.g.open(h||void 0),h&&this.g.setDimensions?.(h),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,t=class extends w.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(h=>h.value)}constructor(h,D,k){super(),this.Q=D,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new w.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new C.$fe,this.onDidCloseTerminal=this.H.event,this.I=new C.$fe,this.onDidOpenTerminal=this.I.event,this.J=new C.$fe,this.onDidChangeActiveTerminal=this.J.event,this.L=new C.$fe,this.onDidChangeTerminalDimensions=this.L.event,this.M=new C.$fe,this.onDidChangeTerminalState=this.M.event,this.N=new C.$fe,this.onDidChangeShell=this.N.event,this.O=new C.$fe({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new C.$fe({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(O.$iM.MainThreadTerminalService),this.y=new g.$0vb(this.a.$sendProcessData),this.a.$registerProcessSupport(h),this.Q.registerArgumentProcessor({processArgument:I=>{const P=V=>{const W=V;return this.getTerminalById(W.instanceId)?.value};switch(I?.$mid){case 15:return P(I);default:{if(Array.isArray(I))for(let V=0;V<I.length&&I[V].$mid===15;V++)I[V]=P(I[V]);return I}}}}),this.B({dispose:()=>{for(const[I,P]of this.g)P.shutdown(!0)}})}getDefaultShell(h){return(h?this.u:this.s)?.path||""}getDefaultShellArgs(h){return(h?this.u:this.s)?.args||[]}createExtensionTerminal(h,D){const k=new n(this.a,(0,b.$Ug)(),h,h.name),I=new c(h.pty);return k.createExtensionTerminal(h.location,D,this.R(h,D).resolvedExtHostIdentifier,$(h.iconPath),p(h.color)).then(P=>{const V=this.S(P,I);this.h[P]=V}),this.f.push(k),k.value}R(h,D){if(D=D||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const k=h.location.parentTerminal;if(k){const I=this.f.find(P=>P.value===k);I&&(D.resolvedExtHostIdentifier=I._id)}}else h.location&&typeof h.location!="object"?D.location=h.location:D.location&&typeof D.location=="object"&&"splitActiveTerminal"in D.location&&(D.location={splitActiveTerminal:!0});return D}attachPtyToTerminal(h,D){if(!this.getTerminalById(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const I=new c(D),P=this.S(h,I);this.h[h]=P}async $acceptActiveTerminalChanged(h){const D=this.b;if(h===null){this.b=void 0,D!==this.b&&this.J.fire(this.b);return}const k=this.getTerminalById(h);k&&(this.b=k,D!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(h,D){const k=this.getTerminalById(h);k&&this.O.fire({terminal:k.value,data:D})}async $acceptTerminalDimensions(h,D,k){const I=this.getTerminalById(h);I&&I.setDimensions(D,k)&&this.L.fire({terminal:I.value,dimensions:I.value.dimensions})}async $acceptDidExecuteCommand(h,D){const k=this.getTerminalById(h);k&&this.P.fire({terminal:k.value,...D})}async $acceptTerminalMaximumDimensions(h,D,k){this.g.get(h)?.resize(D,k)}async $acceptTerminalTitleChange(h,D){const k=this.getTerminalById(h);k&&(k.name=D)}async $acceptTerminalClosed(h,D,k){const I=this.X(this.f,h);if(I!==null){const P=this.f.splice(I,1)[0];P.setExitStatus(D,k),this.H.fire(P.value)}}$acceptTerminalOpened(h,D,k,I){if(D){const W=this.X(this.f,D);if(W!==null){this.f[W]._id=h,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const P={name:I.name,shellPath:I.executable,shellArgs:I.args,cwd:typeof I.cwd=="string"?I.cwd:N.URI.revive(I.cwd),env:I.env,hideFromUser:I.hideFromUser},V=new n(this.a,h,P,k);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(h,D){this.getTerminalById(h)?._setProcessId(D)}async $startExtensionTerminal(h,D){const k=this.getTerminalById(h);if(!k)return{message:(0,E.localize)(0,null,h)};k.isOpen||await new Promise(P=>{const V=this.onDidOpenTerminal(async W=>{W===k.value&&(V.dispose(),P())})});const I=this.g.get(h);I?I.startSendingEvents(D):this.j[h]={initialDimensions:D}}S(h,D){const k=new w.$Tc;k.add(D.onProcessReady(P=>this.a.$sendProcessReady(h,P.pid,P.cwd,P.windowsPty))),k.add(D.onDidChangeProperty(P=>this.a.$sendProcessProperty(h,P))),this.y.startBuffering(h,D.onProcessData),k.add(D.onProcessExit(P=>this.U(h,P))),this.g.set(h,D);const I=this.j[h];return I&&D instanceof c&&(D.startSendingEvents(I.initialDimensions),delete this.j[h]),k}$acceptProcessAckDataEvent(h,D){this.g.get(h)?.acknowledgeDataEvent(D)}$acceptProcessInput(h,D){this.g.get(h)?.input(D)}$acceptTerminalInteraction(h){const D=this.getTerminalById(h);D?.setInteractedWith()&&this.M.fire(D.value)}$acceptTerminalSelection(h,D){this.getTerminalById(h)?.setSelection(D)}$acceptProcessResize(h,D,k){try{this.g.get(h)?.resize(D,k)}catch(I){if(I.code!=="EPIPE"&&I.code!=="ERR_IPC_CHANNEL_CLOSED")throw I}}$acceptProcessShutdown(h,D){this.g.get(h)?.shutdown(D)}$acceptProcessRequestInitialCwd(h){this.g.get(h)?.getInitialCwd().then(D=>this.a.$sendProcessProperty(h,{type:"initialCwd",value:D}))}$acceptProcessRequestCwd(h){this.g.get(h)?.getCwd().then(D=>this.a.$sendProcessProperty(h,{type:"cwd",value:D}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this.z.add(h),this.z.size===1&&this.a.$startLinkProvider(),new m.$kM(()=>{this.z.delete(h),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(h,D,k){if(this.C.has(D))throw new Error(`Terminal profile provider "${D}" already registered`);return this.C.set(D,k),this.a.$registerProfileProvider(D,h.identifier.value),new m.$kM(()=>{this.C.delete(D),this.a.$unregisterProfileProvider(D)})}registerTerminalQuickFixProvider(h,D,k){if(this.D.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this.D.set(h,k),this.a.$registerQuickFixProvider(h,D),new m.$kM(()=>{this.D.delete(h),this.a.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,D){const k=new l.$qe().token;if(k.isCancellationRequested)return;const I=this.D.get(h);if(!I)return;const P=await I.provideTerminalQuickFixes(D,k);if(P===null||Array.isArray(P)&&P.length===0)return;const V=new w.$Tc;if(this.w.value=V,!Array.isArray(P))return P?o.TerminalQuickFix.from(P,this.Q.converter,V):void 0;const W=[];for(const q of P){const A=o.TerminalQuickFix.from(q,this.Q.converter,V);A&&W.push(A)}return W}async $createContributedProfileTerminal(h,D){const k=new l.$qe().token;let I=await this.C.get(h)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(I&&!("options"in I)&&(I={options:I}),!I||!("options"in I))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in I.options){this.createExtensionTerminal(I.options,D);return}this.createTerminalFromOptions(I.options,D)}}async $provideLinks(h,D){const k=this.getTerminalById(h);if(!k)return[];this.F.delete(h),this.G.get(h)?.dispose(!0);const P=new l.$qe;this.G.set(h,P);const V=[],W={terminal:k.value,line:D},q=[];for(const G of this.z)q.push(s.Promises.withAsyncBody(async ie=>{P.token.onCancellationRequested(()=>ie({provider:G,links:[]}));const de=await G.provideTerminalLinks(W,P.token)||[];P.token.isCancellationRequested||ie({provider:G,links:de})}));const A=await Promise.all(q);if(P.token.isCancellationRequested)return[];const z=new Map;for(const G of A)G&&G.links.length>0&&V.push(...G.links.map(ie=>{const de={id:u++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return z.set(de.id,{provider:G.provider,link:ie}),de}));return this.F.set(h,z),V}$activateLink(h,D){const k=this.F.get(h)?.get(D);k&&k.provider.handleTerminalLink(k.link)}U(h,D){this.y.stopBuffering(h),this.g.delete(h),delete this.j[h];const k=this.h[h];k&&(k.dispose(),delete this.h[h]),this.a.$sendProcessExit(h,D)}getTerminalById(h){return this.W(this.f,h)}getTerminalIdByApiObject(h){const D=this.f.findIndex(k=>k.value===h);return D>=0?D:null}W(h,D){const k=this.X(h,D);return k!==null?h[k]:null}X(h,D){const k=h.findIndex(I=>I._id===D);return k>=0?k:null}getEnvironmentVariableCollection(h){let D=this.n.get(h.identifier.value);return D||(D=new f,this.Z(h.identifier.value,D)),D.getScopedEnvironmentVariableCollection(void 0)}Y(h,D){const k=(0,S.$os)(D.map),I=(0,S.$ps)(D.descriptionMap);this.a.$setEnvironmentVariableCollection(h,D.persistent,k.length===0?void 0:k,I)}$initEnvironmentVariableCollections(h){h.forEach(D=>{const k=D[0],I=new f(D[1]);this.Z(k,I)})}$acceptDefaultProfile(h,D){const k=this.s;this.s=h,this.u=D,k?.path!==h.path&&this.N.fire(h.path)}Z(h,D){this.n.set(h,D),D.onDidChangeCollection(()=>{this.Y(h,D)})}};e.$Mmc=t,e.$Mmc=t=Je([We(1,i.$9O),We(2,R.$MO)],t);class f{get persistent(){return this.b}set persistent(h){this.b=h,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(h){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new C.$fe,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const D=this.h(h);let k=this.a.get(D);return k||(k=new a(this,h),this.a.set(D,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(h,D,k,I){this.f(h,{value:D,type:m.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:I})}append(h,D,k,I){this.f(h,{value:D,type:m.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:I})}prepend(h,D,k,I){this.f(h,{value:D,type:m.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:I})}f(h,D){if(D.options&&D.options.applyAtProcessCreation===!1&&!D.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(h,D.scope),I=this.map.get(k),P=D.options?{applyAtProcessCreation:D.options.applyAtProcessCreation??!1,applyAtShellIntegration:D.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!I||I.value!==D.value||I.type!==D.type||I.options?.applyAtProcessCreation!==P.applyAtProcessCreation||I.options?.applyAtShellIntegration!==P.applyAtShellIntegration||I.scope?.workspaceFolder?.index!==D.scope?.workspaceFolder?.index){const V=this.g(h,D.scope),W={variable:h,...D,options:P};this.map.set(V,W),this.d.fire()}}get(h,D){const k=this.g(h,D),I=this.map.get(k);return I?v(I):void 0}g(h,D){const k=this.h(D);return k.length?`${h}:::${k}`:h}h(h){return this.j(h?.workspaceFolder)??""}j(h){return h?h.uri.toString():void 0}getVariableMap(h){const D=new Map;for(const[k,I]of this.map)this.h(I.scope)===this.h(h)&&D.set(I.variable,v(I));return D}delete(h,D){const k=this.g(h,D);this.map.delete(k),this.d.fire()}clear(h){if(h?.workspaceFolder){for(const[D,k]of this.map)k.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(D);this.k(h)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(h,D){const k=this.h(D),I=this.descriptionMap.get(k);if(!I||I.description!==h){let P;typeof h=="string"?P=h:P=h?.value.split(`

`)[0];const V={description:P,scope:D};this.descriptionMap.set(k,V),this.d.fire()}}getDescription(h){const D=this.h(h);return this.descriptionMap.get(D)?.description}k(h){const D=this.h(h);this.descriptionMap.delete(D)}}class a{get persistent(){return this.b.persistent}set persistent(h){this.b.persistent=h}get onDidChangeCollection(){return this.a&&this.a.event}constructor(h,D){this.b=h,this.d=D,this.a=new C.$fe}getScoped(h){return this.b.getScopedEnvironmentVariableCollection(h)}replace(h,D,k){this.b.replace(h,D,k,this.d)}append(h,D,k){this.b.append(h,D,k,this.d)}prepend(h,D,k){this.b.prepend(h,D,k,this.d)}get(h){return this.b.get(h,this.d)}forEach(h,D){this.b.getVariableMap(this.d).forEach((k,I)=>h.call(D,I,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(h){this.b.delete(h,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(h){this.b.setDescription(h,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends t{constructor(h,D){super(!1,h,D)}createTerminal(h,D,k){throw new T.$_}createTerminalFromOptions(h,D){throw new T.$_}};e.$Nmc=d,e.$Nmc=d=Je([We(0,i.$9O),We(1,R.$MO)],d);function $(y){if(!(!y||typeof y=="string"))return"id"in y?{id:y.id,color:y.color}:y}function p(y){return r.ThemeColor.isThemeColor(y)?y:void 0}function v(y){const h={...y};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}}),define(Se[116],Ie([1,0,7,6,3,4,17,53,5,2,11]),function(le,e,C,O,M,N,R,w,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Snc=e.$Rnc=void 0,e.$Rnc=(0,M.$yi)("IExtHostTerminalShellIntegration");let S=class extends O.$Uc{constructor(s,o){super(),this.h=o,this.b=new Map,this.c=new m.$fe,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new m.$fe,this.onDidStartTerminalShellExecution=this.f.event,this.g=new m.$fe,this.onDidEndTerminalShellExecution=this.g.event,this.a=s.getProxy(N.$iM.MainThreadTerminalShellIntegration),this.B((0,O.$Sc)(()=>{for(const[i,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(s){const o=this.h.getTerminalById(s);if(!o)return;const i=o.value;let n=this.b.get(s);n||(n=new l(o.value,this.f),this.b.set(s,n),n.store.add(o.onWillDispose(()=>this.b.get(s)?.dispose())),n.store.add(n.onDidRequestShellExecution(c=>this.a.$executeCommand(s,c))),n.store.add(n.onDidRequestEndExecution(c=>this.g.fire(c))),n.store.add(n.onDidRequestChangeShellIntegration(c=>this.c.fire(c))),o.shellIntegration=n.value),this.c.fire({terminal:i,shellIntegration:n.value})}$shellExecutionStart(s,o,i,n,c){this.b.has(s)||this.$shellIntegrationChange(s);const u={value:o,confidence:i,isTrusted:n};this.b.get(s)?.startShellExecution(u,c)}$shellExecutionEnd(s,o,i,n,c){const u={value:o,confidence:i,isTrusted:n};this.b.get(s)?.endShellExecution(u,c)}$shellExecutionData(s,o){this.b.get(s)?.emitData(o)}$cwdChange(s,o){this.b.get(s)?.setCwd((0,E.$vc)(o)?E.URI.revive(o):o)}$closeTerminal(s){this.b.get(s)?.dispose(),this.b.delete(s)}};e.$Snc=S,e.$Snc=S=Je([We(0,R.$MO),We(1,w.$Kmc)],S);class l extends O.$Uc{get currentExecution(){return this.a}constructor(s,o){super(),this.j=s,this.m=o,this.b=!1,this.store=this.B(new O.$Tc),this.f=this.B(new m.$fe),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new m.$fe),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new m.$fe),this.onDidRequestEndExecution=this.h.event;const i=this;this.value={get cwd(){return i.c},executeCommand(n,c){let u=n;c&&(u+=` "${c.map(a=>`${a.replaceAll('"','\\"')}`).join('" "')}"`),i.g.fire(u);const t={value:u,confidence:C.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},f=i.startShellExecution(t,i.c,!0).value;return i.b=!0,f}}}startShellExecution(s,o,i){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new b(s,o);i?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(s){this.currentExecution?.emitData(s)}endShellExecution(s,o){this.a&&(this.a.endExecution(s),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:o}),this.a=void 0)}setCwd(s){let o=!1;E.URI.isUri(this.c)?o=!E.URI.isUri(s)||this.c.toString()!==s.toString():this.c!==s&&(o=!0),o&&(this.c=s,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class b{constructor(s,o){this.c=s,this.cwd=o,this.b=!1;const i=this;this.value={get commandLine(){return i.c},get cwd(){return i.cwd},read(){return i.d()}}}d(){if(!this.a){if(this.b)return T.$Yh.EMPTY;this.a=new g}return this.a.createIterable()}emitData(s){this.a?.emitData(s)}endExecution(s){s&&(this.c=s),this.a?.endExecution(),this.a=void 0,this.b=!0}}class g extends O.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new T.$xh);const s=this.a;return new T.$Yh(async i=>{this.b.push(i),await s.wait()})}emitData(s){for(const o of this.b)o.emitOne(s)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Se[289],Ie([1,0,11,22,20,5,262,73,6,15,33,12,4,17,115,8,7,52,77,62,25]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s,o,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=e.$Vnc=e.$Unc=e.$Tnc=void 0;let u=class extends m.$Uc{constructor(V,W,q,A){super(),this.w=A,this.f=this.B(new N.$fe),this.g=new Map,this.s=this.B(new N.$fe),this.onResultsChanged=this.f.event,this.results=[],this.h=V.getProxy(l.$iM.MainThreadTesting),this.m=new h(this.h),this.j=new d(this.h,W),q.registerArgumentProcessor({processArgument:z=>{switch(z?.$mid){case 16:{const G=z,ie=G.tests[G.tests.length-1].item.extId;return this.g.get(o.$7K.root(ie))?.collection.tree.get(ie)?.actual??(0,g.$YO)(z)}case 18:{const{test:G,message:ie}=z,de=G.item.extId;return{test:this.g.get(o.$7K.root(de))?.collection.tree.get(de)?.actual??(0,g.$YO)({$mid:16,tests:[G]}),message:r.TestMessage.to(ie)}}default:return z}}}),q.registerCommand(!1,"testing.getExplorerSelection",async()=>{const z=await q.executeCommand("_testing.getExplorerSelection"),G=ie=>{const de=this.g.get(o.$7K.root(ie));if(de)return o.$7K.isRoot(ie)?de.controller:de.collection.tree.get(ie)?.actual};return{include:z?.include.map(G).filter(E.$gg)||[],exclude:z?.exclude.map(G).filter(E.$gg)||[]}})}createTestController(V,W,q,A){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const z=new m.$Tc,G=z.add(new g.$2O(W,q,this.w));G.root.label=q;const ie=new Map,de=new Set,ye=this.h,Ee={items:G.root.children,get label(){return q},set label(ue){q=ue,G.root.label=ue,ye.$updateController(W,{label:q})},get refreshHandler(){return A},set refreshHandler(ue){A=ue,ye.$updateController(W,{canRefresh:!!ue})},get id(){return W},createRunProfile:(ue,Ce,se,Oe,ne,j)=>{let x=(0,w.$mj)(ue);for(;ie.has(x);)x++;return new k(this.h,ie,de,this.s.event,W,x,ue,Ce,se,Oe,ne,j)},createTestItem(ue,Ce,se){return new g.$ZO(W,ue,Ce,se)},createTestRun:(ue,Ce,se=!0)=>this.j.createTestRun(V,W,G,ue,Ce,se),invalidateTestResults:ue=>{if(ue===void 0)this.h.$markTestRetired(void 0);else{const Ce=ue instanceof Array?ue:[ue];this.h.$markTestRetired(Ce.map(se=>o.$7K.fromExtHostTestItem(se,W).toString()))}},set resolveHandler(ue){G.resolveHandler=ue},get resolveHandler(){return G.resolveHandler},dispose:()=>{z.dispose()}};ye.$registerTestController(W,q,!!A),z.add((0,m.$Sc)(()=>ye.$unregisterTestController(W)));const ge={controller:Ee,collection:G,profiles:ie,extension:V,activeProfiles:de};return this.g.set(W,ge),z.add((0,m.$Sc)(()=>this.g.delete(W))),z.add(G.onDidGenerateDiff(ue=>ye.$publishDiff(W,ue.map(n.TestsDiffOp.serialize)))),Ee}createTestObserver(){return this.m.checkout()}async runTests(V,W=M.CancellationToken.None){const q=$(V);if(!q)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const A=this.g.get(q.controllerId);if(!A)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:V.preserveFocus??!0,targets:[{testIds:V.include?.map(z=>o.$7K.fromExtHostTestItem(z,A.collection.root.id).toString())??[A.collection.root.id],profileGroup:I[q.kind],profileId:q.profileId,controllerId:q.controllerId}],exclude:V.exclude?.map(z=>z.id)},W)}$syncTests(){for(const{collection:V}of this.g.values())V.flushDiff();return Promise.resolve()}async $getCoverageDetails(V,W){return(await this.j.getCoverageDetails(V,W))?.map(r.TestCoverage.fromDetails)}async $disposeRun(V){this.j.disposeTestRun(V)}$configureRunProfile(V,W){this.g.get(V)?.profiles.get(W)?.configureHandler?.()}$setDefaultRunProfiles(V){const W=new Map;for(const[q,A]of Object.entries(V)){const z=this.g.get(q);if(!z)continue;const G=new Map,ie=A.filter(ye=>!z.activeProfiles.has(ye)),de=[...z.activeProfiles].filter(ye=>!A.includes(ye));for(const ye of ie)G.set(ye,!0),z.activeProfiles.add(ye);for(const ye of de)G.set(ye,!1),z.activeProfiles.delete(ye);G.size&&W.set(q,G)}this.s.fire(W)}async $refreshTests(V,W){await this.g.get(V)?.controller.refreshHandler?.(W)}$publishTestResults(V){this.results=Object.freeze(V.map(r.TestResults.to).concat(this.results).sort((W,q)=>q.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(V,W){const q=this.g.get(o.$7K.fromString(V).controllerId)?.collection;q&&(await q.expand(V,W<0?1/0:W),q.flushDiff())}$acceptDiff(V){this.m.applyDiff(V.map(W=>n.TestsDiffOp.deserialize({asCanonicalUri:q=>q},W)))}async $runControllerTests(V,W){return Promise.all(V.map(q=>this.y(q,!1,W)))}async $startContinuousRun(V,W){const q=new M.$qe(W),A=await Promise.all(V.map(z=>this.y(z,!0,q.token)));return!W.isCancellationRequested&&!A.some(z=>z.error)&&await new Promise(z=>W.onCancellationRequested(z)),q.dispose(!0),A}async y(V,W,q){const A=this.g.get(V.controllerId);if(!A)return{};const{collection:z,profiles:G,extension:ie}=A,de=G.get(V.profileId);if(!de)return{};const ye=V.testIds.map(Ce=>z.tree.get(Ce)).filter(E.$gg),Ee=V.excludeExtIds.map(Ce=>A.collection.tree.get(Ce)).filter(E.$gg).filter(Ce=>ye.some(se=>se.fullId.compare(Ce.fullId)===2));if(!ye.length)return{};const ge=new s.$XN(ye.some(Ce=>Ce.actual instanceof g.$1O)?void 0:ye.map(Ce=>Ce.actual),Ee.map(Ce=>Ce.actual),de,W),ue=(0,n.$0K)(V)&&this.j.prepareForMainThreadTestRun(ie,ge,p.fromInternal(V,A.collection),de,q);try{return await de.runHandler(ge,q),{}}catch(Ce){return{error:String(Ce)}}finally{ue&&ue.hasRunningTasks&&!q.isCancellationRequested&&await N.Event.toPromise(ue.onEnd)}}$cancelExtensionTestRun(V){V===void 0?this.j.cancelAllRuns():this.j.cancelRunById(V)}};e.$Tnc=u,e.$Tnc=u=Je([We(0,b.$MO),We(1,S.$5j)],u);const t=1e4;var f;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(f||(f={}));class a extends m.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(V,W,q,A,z,G){super(),this.y=V,this.z=W,this.C=q,this.D=A,this.F=z,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new N.$fe),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new M.$qe(G));const ie=this.B(new C.$Kh(()=>this.G(),t));this.B(this.j.token.onCancellationRequested(()=>ie.schedule()));const de=new N.$fe;this.s=de.event,this.B((0,m.$Sc)(()=>{de.fire(),de.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.G()}getCoverageDetails(V,W){const[,q]=o.$7K.fromString(V).path,A=this.w.get(V);if(!A)return[];const z=this.g.get(q);if(!z)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(z.run,A,W)??[]}createRun(V){const W=this.y.id,q=this.y.controllerId,A=(0,T.$Ug)(),z=Ee=>(ge,...ue)=>{if(ie){this.C.warn(`Setting the state of test "${ge.id}" is a no-op after the run ends.`);return}this.y.isIncluded(ge)&&(this.I(ge),Ee(ge,...ue))},G=(Ee,ge)=>{const ue=ge instanceof Array?ge.map(r.TestMessage.from):[r.TestMessage.from(ge)];if(Ee.uri&&Ee.range){const Ce={range:r.Range.from(Ee.range),uri:Ee.uri};for(const se of ue)se.location=se.location||Ce}this.z.$appendTestMessagesInRun(W,A,o.$7K.fromExtHostTestItem(Ee,q).toString(),ue)};let ie=!1;const de=new Map,ye={isPersisted:this.y.isPersisted,token:this.j.token,name:V,onDidDispose:this.s,addCoverage:Ee=>{if(ie)return;const ge=Ee instanceof s.$3N?Ee.testItem:void 0;let ue;if(ge){if((0,c.$KG)(this.F,"attributableCoverage"),!this.y.isIncluded(ge))throw new Error("Attempted to `addCoverage` for a test item not included in the run");this.I(ge),ue=de.get(ge),ue===void 0&&(ue=de.size,de.set(ge,ue))}const Ce=Ee.uri.toString(),se=new o.$7K(ue!==void 0?[W,A,Ce,String(ue)]:[W,A,Ce]).toString();this.w.set(se,Ee),this.z.$appendCoverage(W,A,r.TestCoverage.fromFile(q,se,Ee))},enqueued:z(Ee=>{this.z.$updateTestStateInRun(W,A,o.$7K.fromExtHostTestItem(Ee,q).toString(),1)}),skipped:z(Ee=>{this.z.$updateTestStateInRun(W,A,o.$7K.fromExtHostTestItem(Ee,q).toString(),5)}),started:z(Ee=>{this.z.$updateTestStateInRun(W,A,o.$7K.fromExtHostTestItem(Ee,q).toString(),2)}),errored:z((Ee,ge,ue)=>{G(Ee,ge),this.z.$updateTestStateInRun(W,A,o.$7K.fromExtHostTestItem(Ee,q).toString(),6,ue)}),failed:z((Ee,ge,ue)=>{G(Ee,ge),this.z.$updateTestStateInRun(W,A,o.$7K.fromExtHostTestItem(Ee,q).toString(),4,ue)}),passed:z((Ee,ge)=>{this.z.$updateTestStateInRun(W,A,o.$7K.fromExtHostTestItem(Ee,this.y.controllerId).toString(),3,ge)}),appendOutput:(Ee,ge,ue)=>{ie||(ue&&(this.y.isIncluded(ue)?this.I(ue):ue=void 0),this.z.$appendOutputToRun(W,A,O.$He.fromString(Ee),ge&&r.location.from(ge),ue&&o.$7K.fromExtHostTestItem(ue,q).toString()))},end:()=>{ie||(ie=!0,de.clear(),this.z.$finishedTestRunTask(W,A),--this.f||this.H())}};return this.f++,this.g.set(A,{run:ye}),this.z.$startedTestRunTask(W,{id:A,name:V,running:!0}),ye}G(){for(const{run:V}of this.g.values())V.end()}H(){this.c!==2&&(this.c=2,this.m.fire())}I(V){if(!(V instanceof g.$ZO))throw new i.$EO(V.id);if(this.h.has(o.$7K.fromExtHostTestItem(V,this.y.controllerId).toString()))return;const W=[],q=this.y.colllection.root;for(;;){const A=r.TestItem.from(V);if(W.unshift(A),this.h.has(A.extId)||(this.h.add(A.extId),V===q))break;V=V.parent||q}this.z.$addTestsToRun(this.y.controllerId,this.y.id,W)}dispose(){this.H(),super.dispose()}}class d{get trackers(){return this.c.values()}constructor(V,W){this.g=V,this.h=W,this.c=new Map,this.f=new Map}getCoverageDetails(V,W){const q=o.$7K.root(V);return this.f.get(q)?.getCoverageDetails(V,W)||[]}disposeTestRun(V){this.f.get(V)?.dispose(),this.f.delete(V);for(const[W,{id:q}]of this.c)q===V&&this.c.delete(W)}prepareForMainThreadTestRun(V,W,q,A,z){return this.j(W,q,A,V,z)}cancelRunById(V){this.f.get(V)?.cancel()}cancelAllRuns(){for(const V of this.c.values())V.cancel()}createTestRun(V,W,q,A,z,G){const ie=this.c.get(A);if(ie)return ie.createRun(z);const de=p.fromPublic(W,q,A,G),ye=$(A);this.g.$startedExtensionTestRun({controllerId:W,continuous:!!A.continuous,profile:ye&&{group:I[ye.kind],id:ye.profileId},exclude:A.exclude?.map(ge=>o.$7K.fromExtHostTestItem(ge,q.root.id).toString())??[],id:de.id,include:A.include?.map(ge=>o.$7K.fromExtHostTestItem(ge,q.root.id).toString())??[q.root.id],preserveFocus:A.preserveFocus??!0,persist:G});const Ee=this.j(A,de,A.profile,V);return N.Event.once(Ee.onEnd)(()=>{this.g.$finishedExtensionTestRun(de.id)}),Ee.createRun(z)}j(V,W,q,A,z){const G=new a(W,this.g,this.h,q,A,z);return this.c.set(V,G),this.f.set(G.id,G),G}}e.$Unc=d;const $=P=>{if(P.profile){if(!(P.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class p{static fromPublic(V,W,q,A){return new p(V,(0,T.$Ug)(),q.include?.map(z=>o.$7K.fromExtHostTestItem(z,V).toString())??[V],q.exclude?.map(z=>o.$7K.fromExtHostTestItem(z,V).toString())??[],A,W)}static fromInternal(V,W){return new p(V.controllerId,V.runId,V.testIds,V.excludeExtIds,!0,W)}constructor(V,W,q,A,z,G){this.controllerId=V,this.id=W,this.isPersisted=z,this.colllection=G,this.c=q.map(ie=>ie+"\0"),this.f=A.map(ie=>ie+"\0")}isIncluded(V){const W=o.$7K.fromExtHostTestItem(V,this.controllerId).toString()+"\0";for(const q of this.f)if(W===q||W.startsWith(q))return!1;for(const q of this.c)if(W===q||W.startsWith(q))return!0;return!1}}e.$Vnc=p;class v{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(V){this.j=V,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(V){this.c.add(V)}update(V){Object.assign(V.revived,r.TestItem.toPlain(V.item)),this.c.has(V)||this.f.add(V)}remove(V){if(this.c.has(V)){this.c.delete(V);return}this.f.delete(V);const W=o.$7K.parentId(V.item.extId);if(W&&this.h.has(W.toString())){this.h.add(V.item.extId);return}this.g.add(V)}getChangeEvent(){const{c:V,f:W,g:q}=this;return{get added(){return[...V].map(A=>A.revived)},get updated(){return[...W].map(A=>A.revived)},get removed(){return[...q].map(A=>A.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class y extends n.$dL{constructor(){super(...arguments),this.s=new N.$fe,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(V){return this.f.get(V)}getMirroredTestDataByReference(V){return this.f.get(V.id)}w(V,W){return{...V,revived:r.TestItem.toPlain(V.item),depth:W?W.depth+1:0,children:new Set}}v(){return new v(this.s)}}class h{constructor(V){this.f=V}checkout(){this.c||(this.c=this.g());const V=this.c;return V.observers++,{onDidChangeTest:V.tests.onDidChangeTests,get tests(){return[...V.tests.rootTests].map(W=>W.revived)},dispose:(0,R.$db)(()=>{--V.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(V){return this.c?.tests.getMirroredTestDataByReference(V)}applyDiff(V){this.c?.tests.apply(V)}g(){const V=new y({asCanonicalUri:W=>W});return this.f.$subscribeToDiffs(),{observers:0,tests:V}}}const D=(P,V,W,q)=>{W?Object.assign(W,q):V.$updateTestRunConfig(P.controllerId,P.profileId,q)};class k{#e;#t;#i;#n;#s;get label(){return this.f}set label(V){V!==this.f&&(this.f=V,D(this,this.#e,this.#n,{label:V}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(V){V!==this.g&&(this.g=V,D(this,this.#e,this.#n,{supportsContinuousRun:V}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(V){V!==this.isDefault&&(V?this.#t.add(this.profileId):this.#t.delete(this.profileId),D(this,this.#e,this.#n,{isDefault:V}))}get tag(){return this._tag}set tag(V){V?.id!==this._tag?.id&&(this._tag=V,D(this,this.#e,this.#n,{tag:V?r.TestTag.namespace(this.controllerId,V.id):null}))}get configureHandler(){return this.c}set configureHandler(V){V!==this.c&&(this.c=V,D(this,this.#e,this.#n,{hasConfigurationHandler:!!V}))}get onDidChangeDefault(){return N.Event.chain(this.#i,V=>V.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(E.$gg))}constructor(V,W,q,A,z,G,ie,de,ye,Ee=!1,ge=void 0,ue=!1){this.controllerId=z,this.profileId=G,this.f=ie,this.kind=de,this.runHandler=ye,this._tag=ge,this.g=ue,this.#e=V,this.#s=W,this.#t=q,this.#i=A,W.set(G,this);const Ce=I[de];if(typeof Ce!="number")throw new Error(`Unknown TestRunProfile.group ${de}`);Ee&&q.add(G),this.#n={profileId:G,controllerId:z,tag:ge?r.TestTag.namespace(this.controllerId,ge.id):null,label:ie,group:Ce,isDefault:Ee,hasConfigurationHandler:!1,supportsContinuousRun:ue},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Wnc=k;const I={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(Se[117],Ie([1,0,57,14,91,8,7]),function(le,e,C,O,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VO=e.$UO=e.$TO=void 0;class w{static{this.c=new M.$RO("TextEditorDecorationType")}constructor(l,b,g){const r=w.c.nextId();l.$registerTextEditorDecorationType(b.identifier,r,N.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:r,dispose(){l.$removeTextEditorDecorationType(r)}})}}e.$TO=w;class m{constructor(l,b){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,b){this.k();let g=null;if(l instanceof R.$lM)g=new R.$mM(l,l);else if(l instanceof R.$mM)g=l;else throw new Error("Unrecognized location");this.l(g,b,!1)}insert(l,b){this.k(),this.l(new R.$mM(l,l),b,!0)}delete(l){this.k();let b=null;if(l instanceof R.$mM)b=l;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(l,b,g){const r=this.c.validateRange(l);this.g.push({range:r,text:b,forceMoveMarkers:g})}setEndOfLine(l){if(this.k(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=l}}class E{constructor(l,b,g,r){this.c=l,this.d=b,this._accept(g),this.e=r;const s=this;this.value={get tabSize(){return s.f},set tabSize(o){s.n(o)},get indentSize(){return s.g},set indentSize(o){s.p(o)},get insertSpaces(){return s.j},set insertSpaces(o){s.s(o)},get cursorStyle(){return s.k},set cursorStyle(o){s.t(o)},get lineNumbers(){return s.l},set lineNumbers(o){s.u(o)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=N.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const b=Math.floor(l);return b>0?b:null}if(typeof l=="string"){const b=parseInt(l,10);return isNaN(b)?null:b>0?b:null}return null}n(l){const b=this.m(l);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const b=Math.floor(l);return b>0?b:null}if(typeof l=="string"){const b=parseInt(l,10);return isNaN(b)?null:b>0?b:null}return null}p(l){const b=this.o(l);if(b!==null){if(typeof b=="number"){if(this.h===b)return;this.g=b,this.h=b}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const b=this.q(l);if(typeof b=="boolean"){if(this.j===b)return;this.j=b}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(l)})))}assign(l){const b={};let g=!1;if(typeof l.tabSize<"u"){const r=this.m(l.tabSize);r==="auto"?(g=!0,b.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,g=!0,b.tabSize=r)}if(typeof l.indentSize<"u"){const r=this.o(l.indentSize);r==="tabSize"?(g=!0,b.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,g=!0,b.indentSize=r)}if(typeof l.insertSpaces<"u"){const r=this.q(l.insertSpaces);r==="auto"?(g=!0,b.insertSpaces=r):this.j!==r&&(this.j=r,g=!0,b.insertSpaces=r)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,g=!0,b.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,g=!0,b.lineNumbers=N.TextEditorLineNumbersStyle.from(l.lineNumbers)),g&&this.v("setOptions",this.c.$trySetOptions(this.d,b))}v(l,b){b.catch(g=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(g)})}}e.$UO=E;class T{constructor(l,b,g,r,s,o,i,n){this.id=l,this.j=b,this.k=g,this.g=!1,this.h=new Set,this.c=s,this.d=new E(this.j,this.id,o,g),this.e=i,this.f=n;const c=this;this.value=Object.freeze({get document(){return r.value},set document(u){throw new O.$9("document")},get selection(){return c.c&&c.c[0]},set selection(u){if(!(u instanceof R.$nM))throw(0,O.$7)("selection");c.c=[u],c.l()},get selections(){return c.c},set selections(u){if(!Array.isArray(u)||u.some(t=>!(t instanceof R.$nM)))throw(0,O.$7)("selections");c.c=u,c.l()},get visibleRanges(){return c.e},set visibleRanges(u){throw new O.$9("visibleRanges")},get options(){return c.d.value},set options(u){c.g||c.d.assign(u)},get viewColumn(){return c.f},set viewColumn(u){throw new O.$9("viewColumn")},edit(u,t={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new m(r.value,t);return u(f),c.m(f)},insertSnippet(u,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=c.c.map(d=>N.Range.from(d));else if(t instanceof R.$lM){const{lineNumber:d,column:$}=N.Position.from(t);a=[{startLineNumber:d,startColumn:$,endLineNumber:d,endColumn:$}]}else if(t instanceof R.$mM)a=[N.Range.from(t)];else{a=[];for(const d of t)if(d instanceof R.$mM)a.push(N.Range.from(d));else{const{lineNumber:$,column:p}=N.Position.from(d);a.push({startLineNumber:$,startColumn:p,endLineNumber:$,endColumn:p})}}return b.$tryInsertSnippet(l,r.value.version,u.value,a,f)},setDecorations(u,t){const f=t.length===0;f&&!c.h.has(u.key)||(f?c.h.delete(u.key):c.h.add(u.key),c.n(()=>{if(N.$JO(t))return b.$trySetDecorations(l,u.key,N.$KO(t));{const a=new Array(4*t.length);for(let d=0,$=t.length;d<$;d++){const p=t[d];a[4*d]=p.start.line+1,a[4*d+1]=p.start.character+1,a[4*d+2]=p.end.line+1,a[4*d+3]=p.end.character+1}return b.$trySetDecorationsFast(l,u.key,a)}}))},revealRange(u,t){c.n(()=>b.$tryRevealRange(l,N.Range.from(u),t||R.TextEditorRevealType.Default))},show(u){b.$tryShowEditor(l,N.ViewColumn.from(u))},hide(){b.$tryHideEditor(l)}})}dispose(){(0,C.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,C.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,C.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,C.ok)(!this.g),this.f=l}_acceptSelections(l){(0,C.ok)(!this.g),this.c=l}async l(){const l=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const b=l.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const g=b.edits.map(s=>s.range);g.sort((s,o)=>s.end.line===o.end.line?s.end.character===o.end.character?s.start.line===o.start.line?s.start.character-o.start.character:s.start.line-o.start.line:s.end.character-o.end.character:s.end.line-o.end.line);for(let s=0,o=g.length-1;s<o;s++){const i=g[s].end;if(g[s+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=b.edits.map(s=>({range:N.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,r,{setEndOfLine:typeof b.setEndOfLine=="number"?N.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$VO=T}),define(Se[68],Ie([1,0,57,5,6,2,3,4,113,17,117,8,12,28,16,42,43]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XO=e.$WO=void 0;class o{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(c,u){this.h=c,this.i=u,this.a=null,this.b=new Map,this.c=new b.$Ac,this.d=new O.$fe,this.e=new O.$fe,this.f=new O.$fe,this.g=new O.$fe,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const u=[],t=[],f=[];if(c.removedDocuments)for(const a of c.removedDocuments){const d=N.URI.revive(a),$=this.c.get(d);$?.unref()&&(this.c.delete(d),u.push($.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const d=N.URI.revive(a.uri);let $=this.c.get(d);if($&&d.scheme!==g.Schemas.vscodeNotebookCell&&d.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);$||($=new o(new m.$PO(this.h.getProxy(w.$iM.MainThreadDocuments),d,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this.c.set(d,$),t.push($.value)),$.ref()}if(c.removedEditors)for(const a of c.removedEditors){const d=this.b.get(a);this.b.delete(a),d&&f.push(d)}if(c.addedEditors)for(const a of c.addedEditors){const d=N.URI.revive(a.documentUri);C.ok(this.c.has(d),`document '${d}' does not exist`),C.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const $=this.c.get(d).value,p=new T.$VO(a.id,this.h.getProxy(w.$iM.MainThreadTextEditors),this.i,new s.$V(()=>$.document),a.selections.map(S.Selection.to),a.options,a.visibleRanges.map(v=>S.Range.to(v)),typeof a.editorPosition=="number"?S.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,p)}c.newActiveEditor!==void 0&&(C.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,M.$Pc)(u),(0,M.$Pc)(f),c.removedDocuments&&this.e.fire(u),c.addedDocuments&&this.d.fire(t),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return r.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const u=this.b.get(this.a);return c?u:u?.value}allEditors(){return[...this.b.values()]}};e.$WO=i,e.$WO=i=Je([We(0,E.$MO),We(1,l.$5j)],i),e.$XO=(0,R.$yi)("IExtHostDocumentsAndEditors")}),define(Se[290],Ie([1,0,18,5,4,117,8,7]),function(le,e,C,O,M,N,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;class m{constructor(T,S){this.i=S,this.a=new O.$fe,this.b=new O.$fe,this.c=new O.$fe,this.d=new O.$fe,this.f=new O.$fe,this.g=new O.$fe,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=T.getProxy(M.$iM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(T){const S=this.i.allEditors();return T?S:S.map(l=>l.value)}async showTextDocument(T,S,l){let b;typeof S=="number"?b={position:R.ViewColumn.from(S),preserveFocus:l}:typeof S=="object"?b={position:R.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?R.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:b={preserveFocus:!1};const g=await this.h.$tryShowTextDocument(T.uri,b),r=g&&this.i.getEditor(g);if(r)return r.value;throw g?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,S){return new N.$TO(this.h,T,S).value}$acceptEditorPropertiesChanged(T,S){const l=this.i.getEditor(T);if(!l)throw new Error("unknown text editor");if(S.options&&l._acceptOptions(S.options),S.selections){const b=S.selections.selections.map(R.Selection.to);l._acceptSelections(b)}if(S.visibleRanges){const b=C.$Hb(S.visibleRanges.map(R.Range.to));l._acceptVisibleRanges(b)}if(S.options&&this.b.fire({textEditor:l.value,options:{...S.options,lineNumbers:R.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const b=w.TextEditorSelectionChangeKind.fromValue(S.selections.source),g=S.selections.selections.map(R.Selection.to);this.a.fire({textEditor:l.value,selections:g,kind:b})}if(S.visibleRanges){const b=C.$Hb(S.visibleRanges.map(R.Range.to));this.c.fire({textEditor:l.value,visibleRanges:b})}}$acceptEditorPositionData(T){for(const S in T){const l=this.i.getEditor(S);if(!l)throw new Error("Unknown text editor");const b=R.ViewColumn.to(T[S]);l.value.viewColumn!==b&&(l._acceptViewColumn(b),this.d.fire({textEditor:l.value,viewColumn:b}))}}getDiffInformation(T){return Promise.resolve(this.h.$getDiffInformation(T))}}e.$dmc=m}),define(Se[291],Ie([1,0,2,3,4,6,7,8,21,15]),function(le,e,C,O,M,N,R,w,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Znc=e.$Ync=void 0,e.$Ync=(0,O.$yi)("IExtHostTimeline");class T{constructor(b,g){this.b=new Map,this.c=new Map,this.a=b.getProxy(M.$iM.MainThreadTimeline),g.registerArgumentProcessor({processArgument:(r,s)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&m.$Tm.equals(s,this.b.get(r.source)?.extension)){const o=r.uri===void 0?void 0:C.URI.revive(r.uri);return this.c.get(r.source)?.get(S(o))?.get(r.handle)}else return;return r}})}async $getTimeline(b,g,r,s){return this.b.get(b)?.provider.provideTimeline(C.URI.revive(g),r,s)}registerTimelineProvider(b,g,r,s){const o=new N.$Tc,i=this.d(g.id,s,o).bind(this);let n;g.onDidChange&&(n=g.onDidChange(u=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...u,id:g.id}),this));const c=this.c;return this.f({...g,scheme:b,onDidChange:void 0,async provideTimeline(u,t,f){t?.resetCache&&(o.clear(),c.get(g.id)?.clear());const a=await g.provideTimeline(u,t,f);if(a==null)return;const d=i(u,t);return{...a,source:g.id,items:a.items.map(d)}},dispose(){for(const u of c.values())u.get(g.id)?.clear();n?.dispose(),o.dispose()}},r)}d(b,g,r){return(s,o)=>{let i;if(o?.cacheResults){let n=this.c.get(b);n===void 0&&(n=new Map,this.c.set(b,n));const c=S(s);i=n.get(c),i===void 0&&(i=new Map,n.set(c,i))}return n=>{const{iconPath:c,...u}=n,t=`${b}|${n.id??n.timestamp}`;i?.set(t,n);let f,a,d;n.iconPath&&(c instanceof R.$hN?d={id:c.id,color:c.color}:C.URI.isUri(c)?(f=c,a=c):{light:f,dark:a}=c);let $;return R.$MM.isMarkdownString(u.tooltip)?$=w.MarkdownString.from(u.tooltip):(0,E.$$f)(u.tooltip)?$=u.tooltip:R.$MM.isMarkdownString(u.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),$=w.MarkdownString.from(u.detail)):(0,E.$$f)(u.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),$=u.detail),{...u,id:u.id??void 0,handle:t,source:b,command:n.command?g.toInternal(n.command,r):void 0,icon:f,iconDark:a,themeIcon:d,tooltip:$,accessibilityInformation:n.accessibilityInformation}}}}f(b,g){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:g}),(0,N.$Sc)(()=>{for(const s of this.c.values())s.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$Znc=T;function S(l){return l?.toString()}}),define(Se[292],Ie([1,0,181,24,2,5,6,222,11,7,15,18,8,55,20,143,25]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1nc=void 0;function o(c,u){if((0,T.$$f)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class i extends R.$Uc{constructor(u,t,f){super(),this.f=u,this.g=t,this.h=f,this.a=new Map,this.b=new r.$J0;function a(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:d=>a(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map($=>a($)?this.r($):$):d})}registerTreeDataProvider(u,t,f){const a=this.createTreeView(u,{treeDataProvider:t},f);return{dispose:()=>a.dispose()}}createTreeView(u,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=t.dragAndDropController?.dropMimeTypes??[],d=t.dragAndDropController?.dragMimeTypes??[],$=!!t.dragAndDropController?.handleDrag,p=!!t.dragAndDropController?.handleDrop,v=this.m(u,t,f),y={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:a,dragMimeTypes:d,hasHandleDrag:$,hasHandleDrop:p,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},h=this.f.$registerTreeViewDataProvider(u,y),D={get onDidCollapseElement(){return v.onDidCollapseElement},get onDidExpandElement(){return v.onDidExpandElement},get selection(){return v.selectedElements},get onDidChangeSelection(){return v.onDidChangeSelection},get activeItem(){return(0,s.$KG)(f,"treeViewActiveItem"),v.focusedElement},get onDidChangeActiveItem(){return(0,s.$KG)(f,"treeViewActiveItem"),v.onDidChangeActiveItem},get visible(){return v.visible},get onDidChangeVisibility(){return v.onDidChangeVisibility},get onDidChangeCheckboxState(){return v.onDidChangeCheckboxState},get message(){return v.message},set message(k){(0,b.$Xk)(k)&&(0,s.$KG)(f,"treeViewMarkdownMessage"),v.message=k},get title(){return v.title},set title(k){v.title=k},get description(){return v.description},set description(k){v.description=k},get badge(){return v.badge},set badge(k){k!==void 0&&E.ViewBadge.isViewBadge(k)?v.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(v.badge=void 0)},reveal:(k,I)=>v.reveal(k,I),dispose:async()=>{await h,this.a.delete(u),v.dispose()}};return this.B(D),D}$getChildren(u,t){const f=this.a.get(u);return f?f.getChildren(t):Promise.reject(new w.$7F(u))}async $handleDrop(u,t,f,a,d,$,p,v){const y=this.a.get(u);if(!y)return Promise.reject(new w.$7F(u));const h=l.DataTransfer.toDataTransfer(f,async D=>(await this.f.$resolveDropFileData(u,t,D)).buffer);return p===u&&v&&await this.j(h,y,v,d,$),y.onDrop(h,a,d)}async j(u,t,f,a,d){const $=this.b.removeDragOperationTransfer(d);if($)(await $)?.forEach((p,v)=>{p&&u.set(v,p)});else if(d&&t.handleDrag){const p=t.handleDrag(f,u,a);this.b.addDragOperationTransfer(d,p),await p}return u}async $handleDrag(u,t,f,a){const d=this.a.get(u);if(!d)return Promise.reject(new w.$7F(u));const $=await this.j(new E.$dN,d,t,a,f);if(!(!$||a.isCancellationRequested))return l.DataTransfer.from($)}async $hasResolve(u){const t=this.a.get(u);if(!t)throw new w.$7F(u);return t.hasResolve}$resolve(u,t,f){const a=this.a.get(u);if(!a)throw new w.$7F(u);return a.resolveTreeItem(t,f)}$setExpanded(u,t,f){const a=this.a.get(u);if(!a)throw new w.$7F(u);a.setExpanded(t,f)}$setSelectionAndFocus(u,t,f){const a=this.a.get(u);if(!a)throw new w.$7F(u);a.setSelectionAndFocus(t,f)}$setVisible(u,t){const f=this.a.get(u);if(!f){if(!t)return;throw new w.$7F(u)}f.setVisible(t)}$changeCheckboxState(u,t){const f=this.a.get(u);if(!f)throw new w.$7F(u);f.setCheckboxState(t)}m(u,t,f){const a=this.B(new n(u,t,this.f,this.g.converter,this.h,f));return this.a.set(u,a),a}r(u){const t=this.a.get(u.$treeViewId);return t&&"$treeItemHandle"in u?t.getExtensionElement(u.$treeItemHandle):t&&"$focusedTreeItem"in u&&u.$focusedTreeItem?t.focusedElement:null}}e.$1nc=i;class n extends R.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(u=>this.getExtensionElement(u)).filter(u=>!(0,T.$hg)(u))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(u,t,f,a,d,$){if(super(),this.I=u,this.J=f,this.L=a,this.M=d,this.N=$,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new N.$fe),this.onDidExpandElement=this.u.event,this.w=this.B(new N.$fe),this.onDidCollapseElement=this.w.event,this.y=this.B(new N.$fe),this.onDidChangeSelection=this.y.event,this.z=this.B(new N.$fe),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new N.$fe),this.onDidChangeVisibility=this.C.event,this.D=this.B(new N.$fe),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new N.$fe),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new g.$qe,$.contributes&&$.contributes.views)for(const h in $.contributes.views)for(const D of $.contributes.views[h])D.id===u&&(this.P=D.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(h=>{Array.isArray(h)&&h.length===0||this.F.fire({message:!1,element:h})}));let p,v;const y=N.Event.debounce(this.F.event,(h,D)=>(h||(h={message:!1,elements:[]}),D.element!==!1&&(p||(p=new Promise(k=>v=k),this.G=this.G.then(()=>p)),Array.isArray(D.element)?h.elements.push(...D.element):h.elements.push(D.element)),D.message&&(h.message=!0),h),200,!0);this.B(y(({message:h,elements:D})=>{D.length&&(this.H=this.H.then(()=>{const k=v;return p=null,this.$(D).then(()=>k())})),h&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(u){const t=u?this.getExtensionElement(u):void 0;if(u&&!t)return this.M.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let f=this.X(u);return f||(f=await this.Y(t)),f?f.map(a=>a.item):void 0}getExtensionElement(u){return this.j.get(u)}reveal(u,t){t=t||{select:!0,focus:!1};const f=(0,T.$hg)(t.select)?!0:t.select,a=(0,T.$hg)(t.focus)?!1:t.focus,d=(0,T.$hg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.G.then(()=>this.S(u)).then($=>this.W(u,$[$.length-1]).then(p=>this.J.$reveal(this.I,{item:p.item,parentChain:$.map(v=>v.item)},{select:f,focus:a,expand:d})),$=>this.M.error($)):this.J.$reveal(this.I,void 0,{select:f,focus:a,expand:d})}get message(){return this.O}set message(u){this.O=u,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(u){this.P=u,this.J.$setTitle(this.I,u,this.Q)}get description(){return this.Q}set description(u){this.Q=u,this.J.$setTitle(this.I,this.P,u)}get badge(){return this.R}set badge(u){this.R?.value===u?.value&&this.R?.tooltip===u?.tooltip||(this.R=l.ViewBadge.from(u),this.J.$setBadge(this.I,u))}setExpanded(u,t){const f=this.getExtensionElement(u);f&&(t?this.u.fire(Object.freeze({element:f})):this.w.fire(Object.freeze({element:f})))}setSelectionAndFocus(u,t){const f=!(0,S.$ub)(this.s,u);this.s=u;const a=this.t!==t;this.t=t,f&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(u){u!==this.r&&(this.r=u,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(u){const t=(await Promise.all(u.map(async f=>{const a=this.getExtensionElement(f.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:f.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(u,t,f){const a=[];for(const d of u){const $=this.getExtensionElement(d);$&&a.push($)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,t,f),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(u,t,f){const a=t?this.getExtensionElement(t):void 0;if(!(!a&&t||!this.g?.handleDrop))return(0,m.$qh)(()=>this.g?.handleDrop?this.g.handleDrop(a,u,f):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(u,t){if(!this.f.resolveTreeItem)return;const f=this.j.get(u);if(f){const a=this.m.get(f);if(a){const d=await this.f.resolveTreeItem(a.extensionItem,f,t)??a.extensionItem;return this.hb(d),a.item.tooltip=this.eb(d.tooltip),a.item.command=this.fb(a.disposableStore,d.command),a.item}}}S(u){return this.U(u).then(t=>t?this.S(t).then(f=>this.W(t,f[f.length-1]).then(a=>(f.push(a),f))):Promise.resolve([]))}U(u){const t=this.m.get(u);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,m.$qh)(()=>this.f.getParent(u))}W(u,t){const f=this.m.get(u);return f?Promise.resolve(f):(0,m.$qh)(()=>this.f.getTreeItem(u)).then(a=>this.kb(u,a,t,!0)).then(a=>this.getChildren(t?t.item.handle:void 0).then(()=>{const d=this.getExtensionElement(a);if(d){const $=this.m.get(d);if($)return Promise.resolve($)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(u){if(u){let t;if(typeof u=="string"){const f=this.getExtensionElement(u);t=f?this.m.get(f):void 0}else t=u;return t&&t.children||void 0}return this.h}async Y(u){this.rb(u);const t=new g.$qe(this.Z.token);try{const f=u?this.m.get(u):void 0,a=await this.f.getChildren(u);if(t.token.isCancellationRequested)return;const d=(0,S.$Hb)(a||[]),$=await Promise.all((0,S.$Hb)(d).map(v=>this.f.getTreeItem(v)));if(t.token.isCancellationRequested)return;const p=$.map((v,y)=>v?this.db(d[y],v,f):null);return(0,S.$Hb)(p)}finally{t.dispose()}}$(u){if(u.some(f=>!f))return this.Z.dispose(!0),this.Z=new g.$qe,this.tb(),this.J.$refresh(this.I);{const f=this.ab(u);if(f.length)return this.bb(f)}return Promise.resolve(void 0)}ab(u){const t=new Set,f=u.map(d=>this.m.get(d));for(const d of f)if(d&&!t.has(d.item.handle)){let $=d;for(;$&&$.parent&&f.findIndex(p=>$&&$.parent&&p&&p.item.handle===$.parent.item.handle)===-1;){const p=this.j.get($.parent.item.handle);$=p?this.m.get(p):void 0}$&&!$.parent&&t.add(d.item.handle)}const a=[];return t.forEach(d=>{const $=this.j.get(d);if($){const p=this.m.get($);p&&(!p.parent||!t.has(p.parent.item.handle))&&a.push(d)}}),a}bb(u){const t={};return Promise.all(u.map(f=>this.cb(f).then(a=>{a&&(t[f]=a.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(u){const t=this.getExtensionElement(u);if(t){const f=this.m.get(t);if(f)return this.rb(t),(0,m.$qh)(()=>this.f.getTreeItem(t)).then(a=>{if(a){const d=this.ib(t,a,f.parent);return this.pb(t,d,f,f.parent),f.dispose(),d}return null})}return Promise.resolve(null)}db(u,t,f){const a=this.ib(u,t,f);if(t.id&&this.j.has(a.item.handle))throw new Error((0,C.localize)(0,null,t.id));return this.ob(u,a),this.qb(a,f),a}eb(u){return E.$MM.isMarkdownString(u)?l.MarkdownString.from(u):u}fb(u,t){return t?{...this.L.toInternal(t,u),originalId:t.command}:void 0}gb(u){if(u.checkboxState===void 0)return;let t,f,a;return typeof u.checkboxState=="number"?t=u.checkboxState:(t=u.checkboxState.state,f=u.checkboxState.tooltip,a=u.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:a}}hb(u){if(!E.$$M.isTreeItem(u,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(u,t,f){this.hb(t);const a=this.B(new R.$Tc),d=this.kb(u,t,f),$=this.lb(t);return{item:{handle:d,parentHandle:f?f.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(a,t.command),contextValue:t.contextValue,icon:$,iconDark:this.mb(t)||$,themeIcon:this.jb(t),collapsibleState:(0,T.$hg)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:f,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(u){return u.iconPath instanceof E.$hN?u.iconPath:void 0}kb(u,{id:t,label:f,resourceUri:a},d,$){if(t)return`${n.b}/${t}`;const p=o(f,this.N),v=d?d.item.handle:n.a;let y=p?p.label:a?(0,O.$9g)(a):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const h=this.m.has(u)?this.m.get(u).item.handle:void 0,D=this.X(d)||[];let k,I=0;do{if(k=`${v}/${I}:${y}`,$||!this.j.has(k)||h===k)break;I++}while(I<=D.length);return k}lb(u){if(u.iconPath&&!(u.iconPath instanceof E.$hN))return typeof u.iconPath=="string"||M.URI.isUri(u.iconPath)?this.nb(u.iconPath):this.nb(u.iconPath.light)}mb(u){if(u.iconPath&&!(u.iconPath instanceof E.$hN)&&u.iconPath.dark)return this.nb(u.iconPath.dark)}nb(u){return M.URI.isUri(u)?u:M.URI.file(u)}ob(u,t){this.j.set(t.item.handle,u),this.m.set(u,t)}pb(u,t,f,a){this.j.delete(t.item.handle),this.m.delete(u),t.item.handle!==f.item.handle&&this.j.delete(f.item.handle),this.ob(u,t);const d=this.X(a)||[],$=d.filter(p=>p.item.handle===f.item.handle)[0];$&&d.splice(d.indexOf($),1,t)}qb(u,t){t?(t.children||(t.children=[]),t.children.push(u)):(this.h||(this.h=[]),this.h.push(u))}rb(u){if(u){const t=this.m.get(u);if(t){if(t.children)for(const f of t.children){const a=this.j.get(f.item.handle);a&&this.sb(a)}t.children=void 0}}else this.tb()}sb(u){const t=this.m.get(u);if(t){if(t.children)for(const f of t.children){const a=this.j.get(f.item.handle);a&&this.sb(a)}this.m.delete(u),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(u=>u.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[293],Ie([1,0,5,6,2,33,8,64,4,7]),function(le,e,C,O,M,N,R,w,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=void 0;class T extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(g,r,s,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new C.$fe),this.onDidDispose=this.#d.event,this.#h=this.B(new C.$fe),this.onDidChangeViewState=this.#h.event,this.#e=g,this.#t=r,this.#n=s,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(g){this.c(),this.#r!==g&&(this.#r=g,this.#t.$setTitle(this.#e,g))}get iconPath(){return this.c(),this.#a}set iconPath(g){this.c(),this.#a!==g&&(this.#a=g,this.#t.$setIconPath(this.#e,M.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(g){this.#l||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(this.#u=g.active,this.#c=g.visible,this.#o=g.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(g,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof g>"u"?void 0:R.ViewColumn.from(g),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class S extends O.$Uc{static c(){return(0,N.$Ug)()}constructor(g,r,s){super(),this.j=r,this.m=s,this.g=new Map,this.h=new Map,this.f=g.getProxy(m.$iM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(g=>g.dispose()),this.g.clear()}createWebviewPanel(g,r,s,o,i={}){const n=typeof o=="object"?o.viewColumn:o,c={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof o=="object"&&!!o.preserveFocus},u=(0,w.$smc)(g),t=S.c();this.f.$createWebviewPanel((0,w.$umc)(g),t,r,{title:s,panelOptions:l(i),webviewOptions:(0,w.$vmc)(g,this.m,i),serializeBuffersForPostMessage:u},c);const f=this.j.createNewWebview(t,i,g);return this.createNewWebviewPanel(t,r,s,n,i,f,!0)}$onDidChangeWebviewPanelViewStates(g){const r=Object.keys(g);r.sort((s,o)=>{const i=g[s],n=g[o];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const s of r){const o=this.getWebviewPanel(s);if(!o)continue;const i=g[s];o._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this.g.delete(g),this.j.deleteWebview(g)}registerWebviewPanelSerializer(g,r,s){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:s,extension:g}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,w.$smc)(g)}),new E.$kM(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(g,r,s,o){const i=this.h.get(r);if(!i)throw new Error(`No serializer found for '${r}'`);const{serializer:n,extension:c}=i,u=this.j.createNewWebview(g,s.webviewOptions,c),t=this.createNewWebviewPanel(g,r,s.title,o,s.panelOptions,u,s.active);await n.deserializeWebviewPanel(t,s.state)}createNewWebviewPanel(g,r,s,o,i,n,c){const u=new T(g,this.f,n,{viewType:r,title:s,viewColumn:o,panelOptions:i,active:c});return this.g.set(g,u),u}getWebviewPanel(g){return this.g.get(g)}}e.$wmc=S;function l(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Se[294],Ie([1,0,5,6,64,8,4,7]),function(le,e,C,O,M,N,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4nc=void 0;class m extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(S,l,b,g,r,s){super(),this.#s=!1,this.#u=this.B(new C.$fe),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new C.$fe),this.onDidDispose=this.#l.event,this.#i=b,this.#a=g,this.#e=S,this.#t=l,this.#n=r,this.#r=s}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#o}set description(S){this.a(),this.#o!==S&&(this.#o=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(S){S===this.#r||this.#s||(this.#r=S,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=N.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(S,l){this.d=l,this.b=new Map,this.c=new Map,this.a=S.getProxy(R.$iM.MainThreadWebviewViews)}registerWebviewViewProvider(S,l,b,g){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:b,extension:S}),this.a.$registerWebviewViewProvider((0,M.$umc)(S),l,{retainContextWhenHidden:g?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,M.$smc)(S)}),new w.$kM(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(S,l,b,g,r){const s=this.b.get(l);if(!s)throw new Error(`No view provider found for '${l}'`);const{provider:o,extension:i}=s,n=this.d.createNewWebview(S,{},i),c=new m(S,this.a,l,b,n,!0);this.c.set(S,c),await o.resolveWebviewView(c,{state:g},r)}async $onDidChangeWebviewViewVisibility(S,l){this.e(S)._setVisible(l)}async $disposeWebviewView(S){const l=this.e(S);this.c.delete(S),l.dispose(),this.d.deleteWebview(S)}e(S){const l=this.c.get(S);if(!l)throw new Error("No webview found");return l}}e.$4nc=E}),define(Se[295],Ie([1,0,5,29,31,3]),function(le,e,C,O,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.$DL=e.OutputChannelUpdateMode=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=void 0,e.$qL="text/x-code-output",e.$rL="output",e.$sL="Log",e.$tL="text/x-code-log-output",e.$uL="log",e.$vL="workbench.panel.output",e.$wL=new M.$Pj("inOutput",!1),e.$xL=new M.$Pj("activeLogOutput",!1),e.$yL=new M.$Pj("activeLogOutput.levelSettable",!1),e.$zL=new M.$Pj("activeLogOutput.level",""),e.$AL=new M.$Pj("activeLogOutput.levelIsDefault",!1),e.$BL=new M.$Pj("outputView.scrollLock",!1),e.$CL=(0,N.$yi)("outputService");var R;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$DL={OutputChannels:"workbench.contributions.outputChannels"};class w{constructor(){this.a=new Map,this.b=new C.$fe,this.onDidRegisterChannel=this.b.event,this.c=new C.$fe,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(T=>E.push(T)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}O.$fo.add(e.$DL.OutputChannels,new w),e.$EL=new M.$Pj("activeOutputChannel","")}),define(Se[118],Ie([1,0,4,3,17,21,12,295,65,27,46,147,22,15,38,5,6]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dnc=e.$Cnc=void 0;class o extends R.$$j{get disposed(){return this.n}constructor(u,t,f,a,d){super(),this.id=u,this.name=t,this.r=f,this.s=a,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(f.getLevel()),this.B(f.onDidChangeLogLevel($=>this.setLevel($)))}get logLevel(){return this.getLevel()}appendLine(u){this.append(u+`
`)}append(u){this.info(u)}clear(){const u=this.m;this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Clear,u)}replace(u){const t=this.m;this.info(u),this.s.$update(this.id,w.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(u,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof u=="boolean"?u:t))}hide(){this.s.$close(this.id)}g(u,t){this.m+=l.$He.fromString(t).byteLength,(0,R.log)(this.r,u,t),this.visible&&(this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends o{appendLine(u){this.append(u)}}let n=class{constructor(u,t,f,a,d,$){this.i=t,this.j=f,this.k=a,this.l=d,this.m=$,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=u.getProxy(C.$iM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,S.$6m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.h=u;for(const[t,f]of this.g)f.visible=t===this.h}createOutputChannel(u,t,f){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");const a=typeof t=="object"&&t.log,d=(0,b.$$f)(t)?t:void 0;if((0,b.$$f)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let $;const p=this.i.environment.extensionLogLevel?.find(([y])=>N.$Tm.equals(f.identifier,y))?.[1];p&&($=(0,R.$jk)(p));const v=a?this.o(u,$,f):this.n(u,d,f);return v.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),a?this.r(u,$??this.m.getLevel(),v):this.q(u,v)}async n(u,t,f){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,d=this.k.extUri.joinPath(a,`${this.f++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),$=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),p=await this.a.$register(u,d,t,f.identifier.value);return new o(p,u,$,this.a,f)}async o(u,t,f){const a=await this.p(f),d=u.replace(/[\\/:\*\?"<>\|]/g,""),$=this.k.extUri.joinPath(a,`${d}.log`),p=`${f.identifier.value}.${d}`,v=this.l.createLogger($,{id:p,name:u,logLevel:t,extensionId:f.identifier.value});return new i(p,u,v,this.a,f)}p(u){let t=this.d.get(u.identifier.value);if(!t){const f=this.k.extUri.joinPath(this.i.logsLocation,u.identifier.value);this.d.set(u.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(f)}catch(a){if((0,g.$il)(a)!==g.FileSystemProviderErrorCode.FileExists)throw a}return f})())}return t}q(u,t){let f=!1;const a=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return u},append(d){a(),t.then($=>$.append(d))},appendLine(d){a(),t.then($=>$.appendLine(d))},clear(){a(),t.then(d=>d.clear())},replace(d){a(),t.then($=>$.replace(d))},show(d,$){a(),t.then(p=>p.show(d,$))},hide(){a(),t.then(d=>d.hide())},dispose(){f=!0,t.then(d=>d.dispose())}}}r(u,t,f){const a=new s.$Tc,d=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},$=a.add(new r.$fe);function p(v){t=v,$.fire(v)}return f.then(v=>{a.add(v),v.logLevel!==t&&p(v.logLevel),a.add(v.onDidChangeLogLevel(y=>p(y)))}),{...this.q(u,f),get logLevel(){return t},onDidChangeLogLevel:$.event,trace(v,...y){d(),f.then(h=>h.trace(v,...y))},debug(v,...y){d(),f.then(h=>h.debug(v,...y))},info(v,...y){d(),f.then(h=>h.info(v,...y))},warn(v,...y){d(),f.then(h=>h.warn(v,...y))},error(v,...y){d(),f.then(h=>h.error(v,...y))},dispose(){a.dispose()}}}};e.$Cnc=n,e.$Cnc=n=Je([We(0,M.$MO),We(1,E.$3O),We(2,m.$omc),We(3,T.$4lc),We(4,R.$6j),We(5,R.$5j)],n),e.$Dnc=(0,O.$yi)("IExtHostOutputService")}),define(Se[119],Ie([1,0,3,11]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=void 0,e.$in=(0,C.$yi)("remoteAgentService"),e.$jn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(M){let N=1/0;for(let w=0;w<this.maxSampleCount;w++){const m=await M.getRoundTripTime();if(m===void 0)return;N=Math.min(N,m/2),await(0,O.$zh)(this.sampleDelay)}this.average.push(N),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(N):R=this.initial.reduce((w,m)=>w+m,0)/this.initial.length,this.lastMeasurement={initial:R,current:N,average:this.average.reduce((w,m)=>w+m,0)/this.average.length,high:typeof R>"u"?!1:N>this.highLatencyMaxThreshold||N>this.highLatencyMinThreshold&&N>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Se[296],Ie([1,0,184,51,29,45,50,6,5,119,23,26,11]),function(le,e,C,O,M,N,R,w,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rgb=e.$Qgb=e.$Pgb=e.$Ogb=e.$Ngb=e.$Mgb=e.$Lgb=void 0,e.$Lgb=Object.freeze({id:"application",order:100,title:(0,C.localize)(0,null),type:"object"}),e.$Mgb=Object.freeze({id:"workbench",order:7,title:(0,C.localize)(1,null),type:"object"}),e.$Ngb=Object.freeze({id:"security",scope:1,title:(0,C.localize)(2,null),type:"object",order:7}),e.$Ogb=Object.freeze({id:"problems",title:(0,C.localize)(3,null),type:"object",order:101}),e.$Pgb={ConfigurationMigration:"base.contributions.configuration.migration"};class b{constructor(){this.migrations=[],this.a=new m.$fe,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const g=new b;M.$fo.add(e.$Pgb.ConfigurationMigration,g);let r=class extends w.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,n){super(),this.a=i,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const u of c.added)await this.f(u,g.migrations)})),this.c(g.migrations),this.B(g.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(i){await this.f(void 0,i);for(const n of this.b.getWorkspace().folders)await this.f(n,i)}async f(i,n){await Promise.all([n.map(c=>this.g(c,i?.uri))])}async g(i,n){const c=this.a.inspect(i.key,{resource:n}),u=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of u){const a=c[t];if(!a)continue;const d=[];if(a.value!==void 0){const $=await this.h(i,t,a.value,n,void 0);for(const p of $??[])d.push([p,[]])}for(const{identifiers:$,value:p}of a.overrides??[])if(p!==void 0){const v=await this.h(i,t,p,n,$);for(const y of v??[])d.push([y,$])}d.length&&await Promise.allSettled(d.map(async([[$,p],v])=>this.a.updateValue($,p.value,{resource:n,overrideIdentifiers:v},f)))}}async h(i,n,c,u,t){const f=d=>{const p=this.a.inspect(d,{resource:u})[n];if(p)return t?p.overrides?.find(({identifiers:v})=>(0,S.$9n)(v,t))?.value:p.value},a=await i.migrateFn(c,f);return Array.isArray(a)?a:[[i.key,a]]}};e.$Qgb=r,e.$Qgb=r=Je([We(0,R.$5i),We(1,N.$Hi)],r);let s=class extends w.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new l.$Vh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!T.$i&&(await this.b.getEnvironment())?.os!==1)return;M.$fo.as(O.$ko.Configuration).registerConfiguration({...e.$Ngb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,C.localize)(4,null)},default:[],markdownDescription:(0,C.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,C.localize)(6,null),scope:2}}})}};e.$Rgb=s,e.$Rgb=s=Je([We(0,E.$in)],s)}),define(Se[297],Ie([1,0,37,16,19,24,193,296,51,3,29]),function(le,e,C,O,M,N,R,w,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Tgb=e.$Sgb=void 0,e.$Ugb=r,e.$Vgb=s,e.$Sgb=(0,E.$yi)("editorResolverService"),e.$Tgb="workbench.editorAssociations";const S=T.$fo.as(m.$ko.Configuration),l={...w.$Mgb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(l);var b;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(b||(e.RegisteredEditorPriority=b={}));var g;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(g||(e.ResolvedStatus=g={}));function r(o){switch(o){case b.exclusive:return 5;case b.default:return 4;case b.builtin:return 3;case b.option:default:return 1}}function s(o,i){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(i.scheme))return!1;const u=typeof o=="string"&&o.indexOf(M.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,N.$9g)(i);return C.$rk(typeof o=="string"?o.toLowerCase():o,u.toLowerCase())}}),define(Se[298],Ie([1,0,48,16,19,23,24,2,3,214,45,236,119]),function(le,e,C,O,M,N,R,w,m,E,T,S,l){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$XL=e.$WL=void 0,e.$WL=(0,m.$yi)("pathService");let g=b=class{constructor(s,o,i,n){this.d=s,this.e=o,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??s})()}hasValidBasename(s,o,i){return typeof o=="string"||typeof o>"u"?this.a.then(n=>this.h(s,n,o)):this.h(s,o,i)}h(s,o,i){return s.scheme===O.Schemas.file||s.scheme===O.Schemas.vscodeRemote?(0,C.$vg)(i??(0,R.$9g)(s),o===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,o){if(s.remoteAuthority)return O.Schemas.vscodeRemote;const i=(0,E.$TL)(o.getWorkspace());if(i)return i;const n=o.getWorkspace().folders[0];if(n)return n.uri.scheme;const c=o.getWorkspace().configuration;return c?c.scheme:O.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===1?M.$fc:M.$gc)}async fileURI(s){let o="";if(await this.a===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const n=s.indexOf("/",2);n===-1?(o=s.substring(2),s="/"):(o=s.substring(2,n),s=s.substring(n)||"/")}return w.URI.from({scheme:O.Schemas.file,authority:o,path:s,query:"",fragment:""})}};e.$XL=g,e.$XL=g=b=Je([We(1,l.$in),We(2,S.$FL),We(3,T.$Hi)],g)}),define(Se[120],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$pK=e.$oK=void 0;class C{constructor(R,w){this.line=R,this.character=w}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,w){return new C(0,0)}with(R){return new C(0,0)}}e.$oK=C;class O{constructor(R,w,m,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(R,w),this.end=new C(m,E)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new O(0,0,0,0)}with(R){return new O(0,0,0,0)}}e.$pK=O;var M;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(M||(e.TextSearchCompleteMessageType=M={}))}),define(Se[47],Ie([1,0,18,37,26,48,13,3,19,14,120,11]),function(le,e,C,O,M,N,R,w,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$MK=e.$FK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$CK=e.$BK=e.$AK=e.$zK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.TextSearchCompleteMessageType=void 0,e.$wK=o,e.$xK=i,e.$yK=n,e.$DK=v,e.$EK=y,e.$GK=k,e.$HK=I,e.$IK=P,e.$JK=V,e.$KK=W,e.$LK=q,e.$NK=z,e.$PK=de,e.$QK=ye,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.$qK="workbench.view.search",e.$rK="workbench.panel.search",e.$sK="workbench.view.search",e.$tK="search-result",e.$uK="search.exclude";const l="\u27EA ",b=" characters skipped \u27EB",g=(l.length+b.length+5)*2;e.$vK=(0,w.$yi)("searchService");var r;(function(ge){ge[ge.file=0]="file",ge[ge.text=1]="text",ge[ge.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var s;(function(ge){ge[ge.File=1]="File",ge[ge.Text=2]="Text",ge[ge.aiText=3]="aiText"})(s||(e.QueryType=s={}));function o(ge){return!!ge.preview}function i(ge){return!!ge.resource}function n(ge){return!!ge.message}var c;(function(ge){ge[ge.Normal=0]="Normal",ge[ge.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class u{constructor(ue){this.resource=ue,this.results=[]}}e.$zK=u;class t{constructor(ue,Ce,se,Oe){this.ranges=Ce,this.webviewIndex=Oe;const ne=Array.isArray(Ce)?Ce:[Ce];if(se&&se.matchLines===1&&f(ne)){ue=(0,R.$4f)(ue,se.matchLines);let j="",x=0,ve=0;const Fe=Math.floor(se.charsPerLine/5),ke=[];for(const we of ne){const me=Math.max(we.startColumn-Fe,0),Q=we.startColumn+se.charsPerLine;if(me>ve+Fe+g){const Y=l+(me-ve)+b;j+=Y+ue.slice(me,Q),x+=me-(ve+Y.length)}else j+=ue.slice(ve,Q);ke.push(new d(0,we.startColumn-x,we.endColumn-x)),ve=Q}this.preview={text:j,matches:Array.isArray(this.ranges)?ke:ke[0]}}else{const j=Array.isArray(Ce)?Ce[0].startLineNumber:Ce.startLineNumber;this.preview={text:ue,matches:(0,C.$1b)(Ce,x=>new a(x.startLineNumber-j,x.startColumn,x.endLineNumber-j,x.endColumn))}}}}e.$AK=t;function f(ge){const ue=ge[0].startLineNumber;for(const Ce of ge)if(Ce.startLineNumber!==ue||Ce.endLineNumber!==ue)return!1;return!0}class a{constructor(ue,Ce,se,Oe){this.startLineNumber=ue,this.startColumn=Ce,this.endLineNumber=se,this.endColumn=Oe}}e.$BK=a;class d extends a{constructor(ue,Ce,se){super(ue,Ce,ue,se)}}e.$CK=d;var $;(function(ge){ge.List="list",ge.Tree="tree"})($||(e.ViewMode=$={}));var p;(function(ge){ge.Default="default",ge.FileNames="fileNames",ge.Type="type",ge.Modified="modified",ge.CountDescending="countDescending",ge.CountAscending="countAscending"})(p||(e.SearchSortOrder=p={}));function v(ge,ue=!0){const Ce=ge&&ge.files&&ge.files.exclude,se=ue&&ge&&ge.search&&ge.search.exclude;if(!Ce&&!se)return;if(!Ce||!se)return Ce||se;let Oe=Object.create(null);return Oe=M.$8n(Oe,M.$5n(Ce)),Oe=M.$8n(Oe,M.$5n(se),!0),Oe}function y(ge,ue){return ge.excludePattern&&O.$rk(ge.excludePattern,ue)?!1:ge.includePattern||ge.usingSearchPaths?ge.includePattern&&O.$rk(ge.includePattern,ue)?!0:ge.usingSearchPaths?!!ge.folderQueries&&ge.folderQueries.some(Ce=>{const se=Ce.folder.fsPath;if(N.$xg(ue,se)){const Oe=m.$lc(se,ue);return!Ce.includePattern||!!O.$rk(Ce.includePattern,Oe)}else return!1}):!1:!0}var h;(function(ge){ge[ge.unknownEncoding=1]="unknownEncoding",ge[ge.regexParseError=2]="regexParseError",ge[ge.globParseError=3]="globParseError",ge[ge.invalidLiteral=4]="invalidLiteral",ge[ge.rgProcessError=5]="rgProcessError",ge[ge.other=6]="other",ge[ge.canceled=7]="canceled"})(h||(e.SearchErrorCode=h={}));class D extends Error{constructor(ue,Ce){super(ue),this.code=Ce}}e.$FK=D;function k(ge){const ue=ge.message;if((0,E.$4)(ge))return new D(ue,h.canceled);try{const Ce=JSON.parse(ue);return new D(Ce.message,Ce.code)}catch{return new D(ue,h.other)}}function I(ge){const ue={message:ge.message,code:ge.code};return new Error(JSON.stringify(ue))}function P(ge){return ge.type==="error"?!0:ge.type==="success"}function V(ge){return ge.type==="success"}function W(ge){return!!ge.path}function q(ge,ue,Ce=!0){const se=ge.searchPath?ge.searchPath:ge.relativePath;return Ce?(0,R.$1f)(se,ue):O.$rk(ue,se)}class A{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$MK=A;function z(ge,ue){const Ce={...ge||{},...ue||{}};return Object.keys(Ce).filter(se=>{const Oe=Ce[se];return typeof Oe=="boolean"&&Oe})}class G{constructor(ue,Ce){this.c=null,this.a={...ue.excludePattern||{},...Ce.excludePattern||{}},this.b=O.$sk(this.a);let se=ue.includePattern;Ce.includePattern&&(se?se={...se,...Ce.includePattern}:se=Ce.includePattern),se&&(this.c=O.$sk(se))}matchesExcludesSync(ue,Ce,se){return!!(this.b&&this.b(ue,Ce,se))}includedInQuerySync(ue,Ce,se){return!(this.b&&this.b(ue,Ce,se)||this.c&&!this.c(ue,Ce,se))}includedInQuery(ue,Ce,se){const Oe=this.b(ue,Ce,se),ne=()=>this.c?!!this.c(ue,Ce,se):!0;return(0,S.$kh)(Oe)?Oe.then(j=>j?!1:ne()):ne()}hasSiblingExcludeClauses(){return ie(this.a)}}e.$OK=G;function ie(ge){for(const ue in ge)if(typeof ge[ue]!="boolean")return!0;return!1}function de(ge){if(!ge)return;let ue;return Ce=>(ue||(ue=(ge()||Promise.resolve([])).then(se=>se?Ee(se):{})),ue.then(se=>!!se[Ce]))}function ye(ge){if(!ge)return;let ue;return Ce=>{if(!ue){const se=ge();ue=se?Ee(se):{}}return!!ue[Ce]}}function Ee(ge){const ue={};for(const Ce of ge)ue[Ce]=!0;return ue}}),define(Se[39],Ie([1,0,18,11,20,5,6,54,16,129,24,13,2,183,3,12,202,45,46,27,17,8,7,61,47,4,49]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s,o,i,n,c,u,t,f,a,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=e.$imc=void 0;function p(V,W,q){return new T.$1g(A=>D(A,q)).isEqual(V,W)}function v(V,W,q){return p(V.uri,W.uri,q)?0:(0,S.$sf)(V.uri.toString(),W.uri.toString())}function y(V,W,q){return V.index!==W.index?V.index<W.index?-1:1:p(V.uri,W.uri,q)?(0,S.$sf)(V.name,W.name):(0,S.$sf)(V.uri.toString(),W.uri.toString())}function h(V,W,q,A){const z=V.slice(0).sort((ie,de)=>q(ie,de,A)),G=W.slice(0).sort((ie,de)=>q(ie,de,A));return(0,C.$Eb)(z,G,(ie,de)=>q(ie,de,A))}function D(V,W){const q=W.getCapabilities(V.scheme);return!(q&&q&1024)}class k extends o.$Ri{static toExtHostWorkspace(W,q,A,z){if(!W)return{workspace:null,added:[],removed:[]};const{id:G,name:ie,folders:de,configuration:ye,transient:Ee,isUntitled:ge}=W,ue=[],Ce=q;q?de.forEach((j,x)=>{const ve=l.URI.revive(j.uri),Fe=k.o(A||q,ve,z);Fe?(Fe.name=j.name,Fe.index=j.index,ue.push(Fe)):ue.push({uri:ve,name:j.name,index:x})}):ue.push(...de.map(({uri:j,name:x,index:ve})=>({uri:l.URI.revive(j),name:x,index:ve}))),ue.sort((j,x)=>j.index<x.index?-1:1);const se=new k(G,ie,ue,!!Ee,ye?l.URI.revive(ye):null,!!ge,j=>D(j,z)),{added:Oe,removed:ne}=h(Ce?Ce.workspaceFolders:[],se.workspaceFolders,v,z);return{workspace:se,added:Oe,removed:ne}}static o(W,q,A){for(let z=0;z<W.folders.length;z++){const G=W.workspaceFolders[z];if(p(G.uri,q,A))return G}}constructor(W,q,A,z,G,ie,de){super(W,A.map(ye=>new o.$Si(ye)),z,G,de),this.t=q,this.u=ie,this.q=[],this.s=w.$Ei.forUris(de),A.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,q){return q&&this.s.get(W)&&(W=(0,T.$$g)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let I=class{constructor(W,q,A,z,G){this.c=new N.$fe,this.onDidChangeWorkspace=this.c.event,this.g=new N.$fe,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new N.$he,this.C=new Map,this.h=z,this.s=A,this.t=G,this.j=new E.$Fm,this.k=new O.$xh,this.o=W.getProxy(d.$iM.MainThreadWorkspace),this.q=W.getProxy(d.$iM.MainThreadMessageService);const ie=q.workspace;this.l=ie?new k(ie.id,ie.name,[],!!ie.transient,ie.configuration?l.URI.revive(ie.configuration):null,!!ie.isUntitled,de=>D(de,A)):void 0}$initializeWorkspace(W,q){this.v=q,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:m.Schemas.untitled,path:(0,T.$9g)((0,T.$$g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,q,A,...z){const G=[];if(Array.isArray(z)&&z.forEach(ge=>{l.URI.isUri(ge.uri)&&!G.some(ue=>p(ue.uri,ge.uri,this.s))&&G.push({uri:ge.uri,name:ge.name||(0,T.$8g)(ge.uri)})}),this.n||[q,A].some(ge=>typeof ge!="number"||ge<0)||A===0&&G.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(q+A>ie.length)return!1;const de=ie.slice(0);de.splice(q,A,...G.map(ge=>({uri:ge.uri,name:ge.name||(0,T.$8g)(ge.uri),index:void 0})));for(let ge=0;ge<de.length;ge++){const ue=de[ge];if(de.some((Ce,se)=>se!==ge&&p(ue.uri,Ce.uri,this.s)))return!1}de.forEach((ge,ue)=>ge.index=ue);const{added:ye,removed:Ee}=h(ie,de,y,this.s);if(ye.length===0&&Ee.length===0)return!1;if(this.o){const ge=W.displayName||W.name;this.o.$updateWorkspaceFolders(ge,q,A,G).then(void 0,ue=>{this.n=void 0;const Ce={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(s.Severity.Error,(0,b.localize)(0,null,ge,ue.toString()),Ce,[])})}return this.y(de),!0}getWorkspaceFolder(W,q){if(this.x)return this.x.getWorkspaceFolder(W,q)}async getWorkspaceFolder2(W,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,q)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,q){let A,z="";if(typeof W=="string"?(A=l.URI.file(W),z=W):typeof W<"u"&&(A=W,z=W.fsPath),!A)return z;const G=this.getWorkspaceFolder(A,!0);if(!G)return z;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let ie=(0,T.$bh)(G.uri,A);return q&&G.name&&(ie=`${G.name}/${ie}`),ie}y(W){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:q,added:A,removed:z}=k.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:A,removed:z}))}findFiles(W,q,A,z,G=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let ie="",de=!0;return q===null?de=!1:q!==void 0&&(typeof q=="string"?ie=q:ie=q.pattern),this.z(W,void 0,{exclude:ie,maxResults:A,useDefaultExcludes:de,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},G)}findFiles2(W,q={},A,z=M.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${A.value}, entryPoint: findFiles2`),this.z(void 0,W,q,z)}async z(W,q,A,z=M.CancellationToken.None){if(z&&z.isCancellationRequested)return Promise.resolve([]);const G=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,ie={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof A.useDefaultSearchExcludes=="boolean"?!A.useDefaultSearchExcludes:!1,maxResults:A.maxResults,excludePattern:G,shouldGlobSearch:typeof A.fuzzy=="boolean"?!A.fuzzy:!0,_reason:"startFileSearch"};let de;if(W){const{includePattern:ye,folder:Ee}=P(u.GlobPattern.from(W));de=Ee,ie.includePattern=ye}else{const{includePattern:ye,folder:Ee}=P(u.GlobPattern.from(q));de=Ee,ie.filePattern=ye}return this.o.$startFileSearch(de??null,ie,z).then(ye=>Array.isArray(ye)?ye.map(Ee=>l.URI.revive(Ee)):[])}async findTextInFiles(W,q,A,z,G=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),de=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:ye,folder:Ee}=P(u.GlobPattern.from(q.include)),ge=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,ue={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:de,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:ye,excludePattern:ge},Ce=!1;if(this.u[ie]=se=>{if(Ce)return;const Oe=l.URI.revive(se.resource);se.results.forEach(ne=>{const j=(0,$.$8h)(ne);(0,a.$wK)(j)?A({uri:Oe,preview:{text:j.preview.text,matches:(0,C.$1b)(j.preview.matches,x=>new t.$mM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,C.$1b)(j.ranges,x=>new t.$mM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):A({uri:Oe,text:j.text,lineNumber:j.lineNumber})})},G.isCancellationRequested)return{};try{const se=await this.o.$startTextSearch(W,Ee??null,ue,ie,G);return delete this.u[ie],se||{}}catch(se){throw delete this.u[ie],se}}$handleTextSearchResult(W,q){this.u[q]?.(W)}async save(W){const q=await this.o.$save(W,{saveAs:!1});return l.URI.revive(q)}async saveAs(W){const q=await this.o.$save(W,{saveAs:!0});return l.URI.revive(q)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,q){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,q);const A=this.t.transformOutgoingScheme(W),z=this.A++;return this.o.$registerEditSessionIdentityProvider(z,A),(0,R.$Sc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(W,q){this.h.info("Getting edit session identifier for workspaceFolder",W);const A=await this.resolveWorkspaceFolder(l.URI.revive(W));if(!A){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",A);const z=this.w.get(A.uri.scheme);if(this.h.info(`Provider for scheme ${A.uri.scheme} is defined: `,!!z),!z)return;const G=await z.provideEditSessionIdentity(A,q);if(this.h.info("Provider returned edit session identifier: ",G),!!G)return G}async $provideEditSessionIdentityMatch(W,q,A,z){this.h.info("Getting edit session identifier for workspaceFolder",W);const G=await this.resolveWorkspaceFolder(l.URI.revive(W));if(!G){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",G);const ie=this.w.get(G.uri.scheme);if(this.h.info(`Provider for scheme ${G.uri.scheme} is defined: `,!!ie),!ie)return;const de=await ie.provideEditSessionIdentityMatch?.(q,A,z);if(this.h.info("Provider returned edit session identifier match result: ",de),!!de)return de}getOnWillCreateEditSessionIdentityEvent(W){return(q,A,z)=>{const G=function(de){q.call(A,de)};return G.extension=W,this.B.event(G,void 0,z)}}async $onWillCreateEditSessionIdentity(W,q,A){const z=await this.resolveWorkspaceFolder(l.URI.revive(W));if(z===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:z},q,async(G,ie)=>{const de=Date.now();await Promise.resolve(G),Date.now()-de>A&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(W,q){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,q);const A=this.t.transformOutgoingScheme(W),z=this.A++;return this.o.$registerCanonicalUriProvider(z,A),(0,R.$Sc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(z)})}async provideCanonicalUri(W,q,A){const z=this.C.get(W.scheme);if(!z)return;const G=await z.provideCanonicalUri?.(l.URI.revive(W),q,A);if(G)return G}async $provideCanonicalUri(W,q,A){return this.provideCanonicalUri(l.URI.revive(W),{targetScheme:q},A)}};e.$imc=I,e.$imc=I=Je([We(0,c.$MO),We(1,n.$3O),We(2,i.$4lc),We(3,r.$5j),We(4,f.$gmc)],I),e.$jmc=(0,g.$yi)("IExtHostWorkspace");function P(V){let W,q;return V&&(typeof V=="string"?W=V:(W=V.pattern,q=l.URI.revive(V.baseUri))),{includePattern:W,folder:q}}}),define(Se[40],Ie([1,0,26,5,39,4,7,203,51,15,11,3,17,12,2]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=e.$lmc=e.$kmc=void 0;function r(f,a){if(a){const d=a.split(".");let $=f;for(let p=0;$&&p<d.length;p++)$=$[d[p]];return $}}function s(f){return f instanceof g.URI}function o(f){return f&&f.uri instanceof g.URI&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&f.uri instanceof g.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function c(f){if(s(f))return{resource:f};if(o(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(i(f))return{overrideIdentifier:f.languageId};if(n(f))return{resource:f.uri};if(f===null)return{resource:null}}let u=class{constructor(a,d,$){this.a=a.getProxy(N.$iM.MainThreadConfiguration),this.c=d,this.b=$,this.d=new T.$xh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new t(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,d){this.getConfigProvider().then($=>$.$acceptConfigurationChanged(a,d))}};e.$kmc=u,e.$kmc=u=Je([We(0,l.$MO),We(1,M.$jmc),We(2,b.$5j)],u);class t{constructor(a,d,$,p){this.a=new O.$fe,this.b=a,this.f=p,this.c=d,this.e=w.$Do.parse($,p),this.d=this.k($.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,d){const $={data:this.e.toData(),workspace:this.c.workspace};this.e=w.$Do.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j(d,$))}getConfiguration(a,d,$){const p=c(d)||{},v=this.g(a?r(this.e.getValue(void 0,p,this.c.workspace),a):this.e.getValue(void 0,p,this.c.workspace));a&&this.h(a,p,$?.identifier);function y(D){if(D==null)return null;if(typeof D=="boolean")return D?2:5;switch(D){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(D){return typeof r(v,D)<"u"},get:(D,k)=>{this.h(a?`${a}.${D}`:D,p,$?.identifier);let I=r(v,D);if(typeof I>"u")I=k;else{let P;const V=(W,q)=>{if((0,E.$ag)(W)){let A;const z=()=>{P=P||(0,C.$5n)(v),A=A||r(P,q)};return new Proxy(W,{get:(G,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return z(),()=>A;if(P)return A=A||r(P,q),A[ie];const de=G[ie];return typeof ie=="string"?V(de,`${q}.${ie}`):de},set:(G,ie,de)=>(z(),A&&(A[ie]=de),!0),deleteProperty:(G,ie)=>(z(),A&&delete A[ie],!0),defineProperty:(G,ie,de)=>(z(),A&&Object.defineProperty(A,ie,de),!0)})}return Array.isArray(W)?(0,C.$5n)(W):W};I=V(I,D)}return I},update:(D,k,I,P)=>{D=a?`${a}.${D}`:D;const V=y(I);return k!==void 0?this.b.$updateConfigurationOption(V,D,k,p,P):this.b.$removeConfigurationOption(V,D,p,P)},inspect:D=>{D=a?`${a}.${D}`:D;const k=this.e.inspect(D,p,this.c.workspace);if(k)return{key:D,defaultValue:(0,C.$5n)(k.policy?.value??k.default?.value),globalValue:(0,C.$5n)(k.user?.value??k.application?.value),workspaceValue:(0,C.$5n)(k.workspace?.value),workspaceFolderValue:(0,C.$5n)(k.workspaceFolder?.value),defaultLanguageValue:(0,C.$5n)(k.default?.override),globalLanguageValue:(0,C.$5n)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,C.$5n)(k.workspace?.override),workspaceFolderLanguageValue:(0,C.$5n)(k.workspaceFolder?.override),languageIds:(0,C.$5n)(k.overrideIdentifiers)}}};return typeof v=="object"&&(0,C.$8n)(h,v,!1),Object.freeze(h)}g(a){const d=$=>(0,E.$ag)($)?new Proxy($,{get:(p,v)=>d(p[v]),set:(p,v,y)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(p,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(p,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):$;return d(a)}h(a,d,$){const p=m.$uo.test(a)?4:this.d.get(a),v=$?`[${$.value}] `:"";if(p===4){typeof d?.resource>"u"&&this.f.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){d?.resource&&this.f.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,d){const $=new w.$Fo(a,d,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(p,v)=>$.affectsConfiguration(p,c(v))})}k(a){return a.reduce((d,$)=>(d.set($[0],$[1]),d),new Map)}}e.$lmc=t,e.$mmc=(0,S.$yi)("IExtHostConfiguration")}),define(Se[121],Ie([1,0,2,11,5,4,7,39,68,40,20,53,17,27,3,16,23,12,80,241,14]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s,o,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qnc=e.$Pnc=e.$Onc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var u;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})(u||(u={}));var t;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})(t||(t={}));var f;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})(f||(f={}));var a;(function(V){function W(z){if(z){const G=z;return G&&!!G.process}else return!1}V.is=W;function q(z){if(z==null)return;const G={process:z.process,args:z.args};return z.options&&(G.options=f.from(z.options)),G}V.from=q;function A(z){if(z!=null)return new R.$7M(z.process,z.args,z.options)}V.to=A})(a||(a={}));var d;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})(d||(d={}));var $;(function(V){function W(z){if(z){const G=z;return G&&(!!G.commandLine||!!G.command)}else return!1}V.is=W;function q(z){if(z==null)return;const G={};return z.commandLine!==void 0?G.commandLine=z.commandLine:(G.command=z.command,G.args=z.args),z.options&&(G.options=d.from(z.options)),G}V.from=q;function A(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new R.$8M(z.commandLine,z.options):new R.$8M(z.command,z.args?z.args:[],z.options)}V.to=A})($||($={}));var p;(function(V){function W(z){if(z){const G=z;return G&&G.customExecution==="customExecution"}else return!1}V.is=W;function q(z){return{customExecution:"customExecution"}}V.from=q;function A(z,G){return G.get(z)}V.to=A})(p||(e.CustomExecutionDTO=p={}));var v;(function(V){function W(q,A){let z;return q.scope!==void 0&&typeof q.scope!="number"?z=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===R.TaskScope.Workspace&&A&&A.workspaceFile?z=A.workspaceFile:z=n.$iI),{id:q._id,workspaceFolder:z}}V.from=W})(v||(e.TaskHandleDTO=v={}));var y;(function(V){function W(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}V.from=W})(y||(y={}));var h;(function(V){function W(z,G){if(z==null)return[];const ie=[];for(const de of z){const ye=q(de,G);ye&&ie.push(ye)}return ie}V.fromMany=W;function q(z,G){if(z==null)return;let ie;z.execution instanceof R.$7M?ie=a.from(z.execution):z.execution instanceof R.$8M?ie=$.from(z.execution):z.execution&&z.execution instanceof R.$9M&&(ie=p.from(z.execution));const de=u.from(z.definition);let ye;return z.scope?typeof z.scope=="number"?ye=z.scope:ye=z.scope.uri:ye=R.TaskScope.Workspace,!de||!ye?void 0:{_id:z._id,definition:de,name:z.name,source:{extensionId:G.identifier.value,label:z.source,scope:ye},execution:ie,isBackground:z.isBackground,group:y.from(z.group),presentationOptions:t.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}V.from=q;async function A(z,G,ie){if(z==null)return;let de;a.is(z.execution)?de=a.to(z.execution):$.is(z.execution)?de=$.to(z.execution):p.is(z.execution)&&(de=p.to(z._id,ie));const ye=u.to(z.definition);let Ee;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?Ee=z.source.scope:Ee=await G.resolveWorkspaceFolder(C.URI.revive(z.source.scope)):Ee=R.TaskScope.Workspace),!ye||!Ee)return;const ge=new R.$0M(ye,Ee,z.name,z.source.label,de,z.problemMatchers);return z.isBackground!==void 0&&(ge.isBackground=z.isBackground),z.group!==void 0&&(ge.group=R.$6M.from(z.group._id),ge.group&&z.group.isDefault&&(ge.group=new R.$6M(ge.group.id,ge.group.label),z.group.isDefault===!0&&(ge.group.isDefault=z.group.isDefault))),z.presentationOptions&&(ge.presentationOptions=t.to(z.presentationOptions)),z._id&&(ge._id=z._id),z.detail&&(ge.detail=z.detail),ge}V.to=A})(h||(e.TaskDTO=h={}));var D;(function(V){function W(A){return A}V.from=W;function q(A){if(A)return Object.assign(Object.create(null),A)}V.to=q})(D||(D={}));class k{#e;constructor(W,q,A){this._id=q,this.a=A,this.#e=W}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let I=class{constructor(W,q,A,z,G,ie,de,ye){this.q=new M.$fe,this.r=new M.$fe,this.s=new M.$fe,this.u=new M.$fe,this.a=W.getProxy(N.$iM.MainThreadTask),this.b=A,this.c=z,this.d=G,this.e=ie,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=de,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,q,A){if(!A)return new R.$kM(()=>{});const z=this.x();return this.j.set(z,{type:q,provider:A,extension:W}),this.a.$registerTaskProvider(z,q),new R.$kM(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(W,q){this.a.$registerTaskSystem(W,q)}fetchTasks(W){return this.a.$fetchTasks(D.from(W)).then(async q=>{const A=[];for(const z of q){const G=await h.to(z,this.b,this.m);G&&A.push(G)}return A})}get taskExecutions(){const W=[];return this.k.forEach(q=>W.push(q)),W}terminateTask(W){if(!(W instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,q,A){const z=this.m.get(W.id);z&&(this.o.set(W.id,z),this.e.attachPtyToTerminal(q,await z.callback(A))),this.p=W.id,this.q.fire({execution:await this.z(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){if(!this.l.has(W.id))return;const q=await this.z(W);this.l.delete(W.id),this.k.delete(W.id),this.B(W),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const q=await this.z(W.id);this.s.fire({execution:q,processId:W.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(W){const q=await this.z(W.id);this.u.fire({execution:q,exitCode:W.exitCode})}$provideTasks(W,q){const A=this.j.get(W);if(!A)return Promise.reject(new Error("no handler found"));const z=[],G=(0,O.$qh)(()=>A.provider.provideTasks(T.CancellationToken.None)).then(ie=>this.v(q,z,A,ie));return new Promise(ie=>{G.then(de=>{Promise.all(z).then(()=>{ie(de)})})})}async $resolveTask(W,q){const A=this.j.get(W);if(!A)return Promise.reject(new Error("no handler found"));if(q.definition.type!==A.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${A.type}].`);const z=await h.to(q,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const G=await A.provider.resolveTask(z,T.CancellationToken.None);if(!G)return;this.A(G,A);const ie=h.from(G,A.extension);if(!ie)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(ie.execution)&&await this.y(ie,G,!0),await this.w(ie)}x(){return this.h++}async y(W,q,A){const z=await this.a.$createTaskId(W);!A&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,q.execution)),this.m.set(z,q.execution)}async z(W,q){if(typeof W=="string"){const G=this.l.get(W);if(!G)throw new c.$bb("Unexpected: The specified task is missing an execution");return G}const A=this.l.get(W.id);if(A)return A;let z;return q?z=Promise.resolve(new k(this,W.id,q)):z=h.to(W.task,this.b,this.m).then(G=>{if(!G)throw new c.$bb("Unexpected: Task does not exist.");return new k(this,W.id,G)}),this.l.set(W.id,z),z.then(G=>(this.k.set(W.id,G),G))}A(W,q){W._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const A=this.n.values();let z=A.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=A.next()}};e.$Onc=I,e.$Onc=I=Je([We(0,l.$MO),We(1,b.$3O),We(2,w.$jmc),We(3,m.$XO),We(4,E.$mmc),We(5,S.$Kmc),We(6,o.$5j),We(7,i.$Zlc)],I);let P=class extends I{constructor(W,q,A,z,G,ie,de,ye){super(W,q,A,z,G,ie,de,ye),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:s.$h(0)})}async executeTask(W,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const A=h.from(q,W);if(A===void 0)throw new Error("Task is not valid");if(p.is(A.execution))await this.y(A,q,!1);else throw new c.$_;const z=await this.z(await this.a.$getTaskExecution(A),q);return this.a.$executeTask(A).catch(G=>{throw new Error(G)}),z}v(W,q,A,z){const G=[];if(z)for(const ie of z){if(this.A(ie,A),!ie.definition||!W[ie.definition.type]){const ye=ie.source?ie.source:"No task source";this.f.warn(`The task [${ye}, ${ie.name}] uses an undefined task type. The task will be ignored in the future.`)}const de=h.from(ie,A.extension);de&&p.is(de.execution)?(G.push(de),q.push(this.y(de,ie,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:G,extension:A.extension}}async w(W){if(p.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,q,A){}};e.$Pnc=P,e.$Pnc=P=Je([We(0,l.$MO),We(1,b.$3O),We(2,w.$jmc),We(3,m.$XO),We(4,E.$mmc),We(5,S.$Kmc),We(6,o.$5j),We(7,i.$Zlc)],P),e.$Qnc=(0,g.$yi)("IExtHostTask")}),define(Se[299],Ie([1,0,47,30]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XK=void 0,e.$WK=M,e.$YK=N;function M(R){return"cellResults"in R}e.$XK="rawCell#";function N(R,w){let m=-1;const E=[];let T=[];return R.forEach(l=>{l.range.startLineNumber!==m&&T.length>0&&(E.push([...T]),T=[]),T.push(l),m=l.range.endLineNumber}),T.length>0&&E.push([...T]),E.map(l=>{const b=[],g=l[0].range.startLineNumber,r=l[l.length-1].range.endLineNumber;for(let s=g;s<=r;s++)b.push(w.getLineContent(s));return new C.$AK(b.join(`
`)+`
`,l.map(s=>new O.$xt(s.range.startLineNumber-1,s.range.startColumn-1,s.range.endLineNumber-1,s.range.endColumn-1)))})}}),define(Se[300],Ie([1,0,177,22,5,6,28,13,15,2,38,76,4,35,8,7,34,276,114,26,16,231,299,297]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s,o,i,n,c,u,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rnc=void 0;class a{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map($=>$.apiEditor)}constructor($,p,v,y,h,D){this.q=v,this.r=y,this.s=h,this.t=D,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new M.$fe,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new M.$fe,this.onDidOpenNotebookDocument=this.m.event,this.n=new M.$fe,this.onDidCloseNotebookDocument=this.n.event,this.o=new M.$fe,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$Xlc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=$.getProxy(l.$iM.MainThreadNotebook),this.c=$.getProxy(l.$iM.MainThreadNotebookDocuments),this.d=$.getProxy(l.$iM.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const I=k.notebookEditor?.notebookUri,P=k.cell.handle,W=this.g.get(I)?.getCell(P);if(W)return W.apiCell}if(k&&k.$mid===14){const I=k.uri,P=this.g.get(I);if(P)return P.apiNotebook}return k}}),a.B(p)}getEditorById($){const p=this.h.get($);if(!p)throw new Error(`unknown text editor: ${$}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor($){for(const[p,v]of this.h)if(v.apiEditor===$)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument($,p){const v=this.g.get($);if(!v&&!p)throw new Error(`NO notebook document for '${$}'`);return v}static u($,p){if(!p)return;const v=p.filenamePattern.map(y=>g.NotebookExclusiveDocumentPattern.from(y)).filter(y=>y!==void 0);if(p.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:$.identifier,providerDisplayName:$.displayName||$.name,displayName:p.displayName,filenamePattern:v,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider($,p,v){const y=a.a++,h=typeof v.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(y,v),this.b.$registerNotebookCellStatusBarItemProvider(y,h,p);let D;return h!==void 0&&(D=v.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(h))),new r.$kM(()=>{this.f.delete(y),this.b.$unregisterNotebookCellStatusBarItemProvider(y,h),D?.dispose()})}async createNotebookDocument($){const p=await this.c.$tryCreateNotebook({viewType:$.viewType,content:$.content&&g.NotebookData.from($.content)});return E.URI.revive(p)}async openNotebookDocument($){const p=this.g.get($);if(p)return p.apiNotebook;const v=await this.c.$tryOpenNotebook($),y=this.g.get(E.URI.revive(v));return(0,m.$jg)(y?.apiNotebook)}async showNotebookDocument($,p){E.URI.isUri($)&&($=await this.openNotebookDocument($));let v;typeof p=="object"?v={position:g.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(g.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:v={preserveFocus:!1};const y=await this.d.$tryShowNotebookDocument($.uri,$.notebookType,v),h=y&&this.h.get(y)?.apiEditor;if(h)return h;throw y?new Error(`Could NOT open editor for "${$.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${$.uri.toString()}".`)}async $provideNotebookCellStatusBarItems($,p,v,y){const h=this.f.get($),D=E.URI.revive(p),k=this.g.get(D);if(!k||!h)return;const I=k.getCellFromIndex(v);if(!I)return;const P=await h.provideCellStatusBarItems(I.apiCell,y);if(!P)return;const V=new N.$Tc,W=this.p.add([V]),A=(Array.isArray(P)?P:[P]).map(z=>g.NotebookStatusBarItem.from(z,this.i,V));return{cacheId:W,items:A}}$releaseNotebookCellStatusBarItems($){this.p.delete($)}registerNotebookSerializer($,p,v,y,h){if((0,w.$9e)(p))throw new Error("viewType cannot be empty or just whitespace");const D=this.w++;return this.x.set(D,{viewType:p,serializer:v,options:y}),this.b.$registerNotebookSerializer(D,{id:$.identifier,location:$.extensionLocation},p,g.NotebookDocumentContentOptions.from(y),a.u($,h)),(0,N.$Sc)(()=>{this.b.$unregisterNotebookSerializer(D)})}async $dataToNotebook($,p,v){const y=this.x.get($);if(!y)throw new Error("NO serializer found");const h=await y.serializer.deserializeNotebook(p.buffer,v);return new s.$Ew(g.NotebookData.from(h))}async $notebookToData($,p,v){const y=this.x.get($);if(!y)throw new Error("NO serializer found");const h=await y.serializer.serializeNotebook(g.NotebookData.to(p.value),v);return O.$He.wrap(h)}async $saveNotebook($,p,v,y,h){const D=E.URI.revive(p),k=this.x.get($);if(!k)throw new Error("NO serializer found");const I=this.g.get(D);if(!I)throw new Error("Document NOT found");if(I.versionId!==v)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(D.scheme))throw new T.$nl((0,C.localize)(0,null,this.z(D)),6);const P={metadata:(0,n.$ao)(I.apiNotebook.metadata,z=>!(k.options?.transientDocumentMetadata??{})[z]),cells:[]};for(const z of I.apiNotebook.getCells()){const G=new r.$NN(z.kind,z.document.getText(),z.document.languageId,z.mime,k.options?.transientOutputs?[]:[...z.outputs],z.metadata,z.executionSummary);G.metadata=(0,n.$ao)(z.metadata,ie=>!(k.options?.transientCellMetadata??{})[ie]),P.cells.push(G)}await this.y(D,y);const V=await k.serializer.serializeNotebook(P,h);await this.s.value.writeFile(D,V);const W=this.s.getFileSystemProviderExtUri(D.scheme),q=await this.s.value.stat(D);return{name:W.basename(D),isFile:(q.type&T.FileType.File)!==0,isDirectory:(q.type&T.FileType.Directory)!==0,isSymbolicLink:(q.type&T.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&T.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(D.scheme),locked:!!((q.permissions??0)&T.FilePermission.Locked),etag:T.$yl({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks($,p,v,y,h){const D=this.x.get($)?.serializer;if(!D)return{limitHit:!1,results:[]};const k=new R.$Bc;await(async(q,A,z)=>{await Promise.all(q.map(async G=>await Promise.all(G.filenamePatterns.map(ie=>{const de={_reason:z._reason,folderQueries:z.folderQueries,includePattern:z.includePattern,excludePattern:z.excludePattern,maxResults:z.maxResults,type:1,filePattern:ie};return this.t.doInternalFileSearchWithCustomCallback(de,A,ye=>{ye.forEach(Ee=>{k.has(Ee)||y.some(ue=>G.isFromSettings&&!ue.isFromSettings?!1:ue.filenamePatterns.some(Ce=>(0,f.$Vgb)(Ce,Ee)))||k.add(Ee)})}).catch(ye=>{if(ye.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ye})}))))})(v,h,p);const P=new R.$Ac;let V=!1;const W=Array.from(k).map(async q=>{const A=[];try{if(h.isCancellationRequested)return;if(p.maxResults&&[...P.values()].reduce((de,ye)=>de+ye.cellResults.length,0)>p.maxResults){V=!0;return}const z=[],G=this.g.get(q);if(G)G.apiNotebook.getCells().forEach(ye=>z.push({input:ye.document.getText(),outputs:ye.outputs.flatMap(Ee=>Ee.items.map(ge=>ge.data.toString()))}));else{const de=await this.s.value.readFile(q),ye=O.$He.fromString(de.toString()),Ee=await D.deserializeNotebook(ye.buffer,h);if(h.isCancellationRequested)return;g.NotebookData.from(Ee).cells.forEach(ue=>z.push({input:ue.source,outputs:ue.outputs.flatMap(Ce=>Ce.items.map(se=>se.valueBytes.toString()))}))}if(h.isCancellationRequested)return;z.forEach((de,ye)=>{const Ee=p.contentPattern.pattern,ge=new u.$CXb(de.input,void 0,de.outputs),ue=ge.findInInputs(Ee),Ce=ge.findInOutputs(Ee),se=Ce.flatMap(Oe=>(0,t.$YK)(Oe.matches,Oe.textBuffer)).map((Oe,ne)=>(Oe.webviewIndex=ne,Oe));if(ue.length>0||Ce.length>0){const Oe={index:ye,contentResults:(0,t.$YK)(ue,ge.inputTextBuffer),webviewResults:se};A.push(Oe)}});const ie={resource:q,cellResults:A};P.set(q,ie);return}catch{return}});return await Promise.all(W),{limitHit:V,results:[...P.values()]}}async y($,p){const v=await this.s.value.stat($);if(typeof p?.mtime=="number"&&typeof p.etag=="string"&&p.etag!==T.$xl&&typeof v.mtime=="number"&&typeof v.size=="number"&&p.mtime<v.mtime&&p.etag!==T.$yl({mtime:p.mtime,size:v.size}))throw new T.$nl((0,C.localize)(1,null),3,p)}z($){return $.scheme===c.Schemas.file?$.fsPath:$.toString()}A($,p,v){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const y=new i.$inc(p,this.d,$,v.visibleRanges.map(g.NotebookRange.to),v.selections.map(g.NotebookRange.to),typeof v.viewColumn=="number"?g.ViewColumn.to(v.viewColumn):void 0);this.h.set(p,y)}$acceptDocumentAndEditorsDelta($){if($.value.removedDocuments)for(const v of $.value.removedDocuments){const y=E.URI.revive(v),h=this.g.get(y);h&&(h.dispose(),this.g.delete(y),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(D=>D.document.uri)}),this.n.fire(h.apiNotebook));for(const D of this.h.values())D.notebookData.uri.toString()===y.toString()&&this.h.delete(D.id)}if($.value.addedDocuments){const v=[];for(const y of $.value.addedDocuments){const h=E.URI.revive(y.uri);if(this.g.has(h))throw new Error(`adding EXISTING notebook ${h} `);const D=new o.$hnc(this.c,this.q,this.r,h,y);v.push(...y.cells.map(k=>o.$gnc.asModelAddData(k))),this.g.get(h)?.dispose(),this.g.set(h,D),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(D.apiNotebook)}}if($.value.addedEditors)for(const v of $.value.addedEditors){if(this.h.has(v.id))return;const y=E.URI.revive(v.documentUri),h=this.g.get(y);h&&this.A(h,v.id,v)}const p=[];if($.value.removedEditors)for(const v of $.value.removedEditors){const y=this.h.get(v);y&&(this.h.delete(v),this.k?.id===y.id&&(this.k=void 0),p.push(y))}if($.value.visibleEditors){this.l=$.value.visibleEditors.map(y=>this.h.get(y)).filter(y=>!!y);const v=new Set;this.l.forEach(y=>v.add(y.id));for(const y of this.h.values()){const h=v.has(y.id);y._acceptVisibility(h)}this.l=[...this.h.values()].map(y=>y).filter(y=>y.visible),this.o.fire(this.visibleNotebookEditors)}$.value.newActiveEditor===null?this.k=void 0:$.value.newActiveEditor&&(this.h.get($.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${$.value.newActiveEditor}`),this.k=this.h.get($.value.newActiveEditor)),$.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B($){const p=b.$$O.String.with("notebookType","A notebook type"),v=new b.$aP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new b.$$O("data","Bytes to convert to data",h=>h instanceof Uint8Array,h=>O.$He.wrap(h))],new b.$_O("Notebook Data",h=>g.NotebookData.to(h.value))),y=new b.$aP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new b.$$O("NotebookData","Notebook data to convert to bytes",h=>!0,h=>new s.$Ew(g.NotebookData.from(h)))],new b.$_O("Bytes",h=>h.buffer));$.registerApiCommand(v),$.registerApiCommand(y)}}e.$rnc=a}),define(Se[301],Ie([1,0,19,20,44,37,24,66,47]),function(le,e,C,O,M,N,R,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=void 0;class E{constructor(l,b,g){this.k=l,this.l=b,this.o=g,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&N.$sk(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&N.$sk(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const b=this.k.folderQueries||[];return new Promise((g,r)=>{const s=o=>{this.f++,l(o)};if(this.g)return g({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const i=o.toString(),n=C.$nc(i);this.j&&this.j(i,n)||this.v(s,{base:o,basename:n})}),Promise.all(b.map(o=>this.p(o,s))).then(o=>{g({limitHit:this.e,stats:o[0]||void 0})},o=>{r(new Error((0,M.$jj)(o)))})})}async p(l,b){const g=new O.$qe,r=this.q(l),s=this.r(),o=new m.$OK(this.k,l),i=!o.hasSiblingExcludeClauses();let n;try{this.h.add(g),n=w.$be.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,g.token),u=n.elapsed(),t=w.$be.create();return this.g&&!this.e||(c&&c.forEach(f=>{const a=C.$gc.relative(l.folder.path,f.path);if(i){const d=C.$nc(f.path);this.v(b,{base:l.folder,relativePath:a,basename:d});return}this.s(s,l.folder,a,b)}),this.g&&!this.e)?null:(this.u(s,o,b),{providerTime:u,postProcessTime:t.elapsed()})}finally{g.dispose(),this.h.delete(g)}}q(l){const b=(0,m.$NK)(this.k.includePattern,l.includePattern),g=(0,m.$NK)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:g,includes:b,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},b,g,r){if(g===this.a){const o=C.$nc(this.a);this.v(r,{base:b,relativePath:this.a,basename:o})}function s(o){const i=C.$nc(o),n=C.$mc(o);let c=l[n];c||(c=l[n]=[],s(n)),c.push({base:b,relativePath:o,basename:i})}s(g)}u({rootEntries:l,pathToEntries:b},g,r){const s=this,o=this.a;function i(n){const c=(0,m.$QK)(()=>n.map(u=>u.basename));for(let u=0,t=n.length;u<t;u++){const f=n[u],{relativePath:a,basename:d}=f;if(g.matchesExcludesSync(a,d,o!==d?c:void 0))continue;const $=b[a];if($)i($);else{if(a===o)continue;s.v(r,f)}if(s.e)break}}i(l)}v(l,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(b))}}class T{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,b,g,r){const s=this.c(l.cacheKey),o=new E(l,b,s&&s.token);let i=0;const n=c=>{i+=c.length,g(c.map(u=>this.d(u)))};return this.e(o,T.a,n,r).then(c=>({limitHit:c.limitHit,stats:c.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:c.stats}:void 0,messages:[]}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new O.$qe),this.b.get(l)}d(l){return l.relativePath?{resource:R.$_g(l.base,l.relativePath)}:{resource:l.base}}e(l,b,g,r){const s=r.onCancellationRequested(()=>{l.cancel()}),o=n=>{n&&(i.push(n),b>0&&i.length>=b&&(g(i),i=[]))};let i=[];return l.search(o).then(n=>(i.length&&g(i),s.dispose(),n),n=>(i.length&&g(i),s.dispose(),Promise.reject(n)))}}e.$jnc=T}),define(Se[302],Ie([1,0,18,271,37,97,28,16,19,24,13,15,2,96,195,50,12,45,109,298,47]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s,o,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YL=void 0,e.$ZL=y;let u=class{constructor(D,k,I,P,V){this.a=D,this.b=k,this.c=I,this.d=P,this.e=V}text(D,k,I={}){D=this.f(D,I);const P=this.a.getValue(),V=k&&k.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(k?.map(o.$Ti),I),type:2,contentPattern:D,previewOptions:I.previewOptions,maxFileSize:I.maxFileSize,usePCRE2:P.search.usePCRE2||V||!1,beforeContext:I.beforeContext,afterContext:I.afterContext,userDisabledExcludesAndIgnoreFiles:I.disregardExcludeSettings&&I.disregardIgnoreFiles}}f(D,k){const I=this.a.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const P={...D,wordSeparators:I.editor.wordSeparators};return this.j(D,k)&&(P.isCaseSensitive=!0),this.k(D)&&(P.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),P}file(D,k={}){return{...this.h(D,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey,shouldGlobMatchFilePattern:k.shouldGlobSearch}}g(D,k){return D?(D=Array.isArray(D)?D.map($):$(D),k?this.parseSearchPaths(D):{pattern:f(...Array.isArray(D)?D:[D])}):{}}h(D=[],k={}){const I=this.g(k.includePattern,k.expandPatterns),P=this.g(k.excludePattern,k.expandPatterns),V=D.length>1,W=(I.searchPaths&&I.searchPaths.length?I.searchPaths.map(z=>this.q(z,k,P)):D.map(z=>this.r(z,k,P,V))).filter(z=>!!z),q={_reason:k._reason,folderQueries:W,usingSearchPaths:!!(I.searchPaths&&I.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:P.pattern,includePattern:I.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const z=C.$Hb(this.c.groups.flatMap(de=>de.editors.map(ye=>ye.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const G=z.filter(de=>(0,c.$EK)(q,de.fsPath)),ie=this.i(G);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...q,...ie}}const A=k.extraFileResources&&k.extraFileResources.filter(z=>(0,c.$EK)(q,z.fsPath));return q.extraFileResources=A&&A.length?A:void 0,q}i(D){const k=[],I=new R.$Ac,P={};let V=!1;return D.forEach(W=>{if(W.scheme===w.Schemas.walkThrough)return;if((0,E.$dh)(W)){const A=this.b.getWorkspaceFolder(W)?.uri??W.with({path:m.$mc(W.fsPath)});let z=I.get(A);z||(V=!0,z={folder:A,includePattern:{}},k.push(z),I.set(A,z));const G=m.$lc(A.fsPath,W.fsPath);(0,S.$jg)(z.includePattern)[G.replace(/\\/g,"/")]=!0}else W.fsPath&&(V=!0,P[W.fsPath]=!0)}),{folderQueries:k,includePattern:P,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(D,k){if(k.isSmartCase){if(D.isRegExp){if(T.$2f(D.pattern,!0))return!0}else if(T.$2f(D.pattern))return!0}return!!D.isCaseSensitive}k(D){return D.isMultiline||D.isRegExp&&(0,b.$TC)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const k=ie=>m.$ic(ie)||/^\.\.?([\/\\]|$)/.test(ie),P=(Array.isArray(D)?D:a(D)).map(ie=>{const de=this.e.resolvedUserHome;return de?(0,N.$Jw)(ie,de.scheme===w.Schemas.file?de.fsPath:de.path):ie}),V=O.$K(P,ie=>k(ie)?"searchPaths":"exprSegments"),W=(V.exprSegments||[]).map(ie=>T.$hf(ie,"/")).map(ie=>T.$hf(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),d(ie))),q={},A=this.m(V.searchPaths||[]);A&&A.length&&(q.searchPaths=A);const z=W.flat(),G=f(...z);return G&&(q.pattern=G),q}l(D,k){return k.disregardExcludeSettings?void 0:(0,c.$DK)(D,!k.disregardSearchExcludeSettings)}m(D){if(!D||!D.length)return[];const k=D.flatMap(P=>{let{pathPortion:V,globPortion:W}=t(P);return W&&(W=p(W)),this.n(V).flatMap(A=>this.o(A,W))}),I=new Map;return k.forEach(P=>{const V=P.searchPath.toString(),W=I.get(V);W?P.pattern&&(W.pattern=W.pattern||{},W.pattern[P.pattern]=!0):I.set(V,{searchPath:P.searchPath,pattern:P.pattern?f(P.pattern):void 0})}),Array.from(I.values())}n(D){if(m.$ic(D)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==w.Schemas.file?[{searchPath:k[0].uri.with({path:D})}]:[{searchPath:l.URI.file(m.$hc(D))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(D=$(D),D.startsWith("../")||D===".."){const P=m.$gc.resolve(k.path,D);return[{searchPath:k.with({path:P})}]}const I=p(D);return[{searchPath:k,pattern:I}]}else{if(D==="./"||D===".\\")return[];{const k=D.replace(/^\.[\/\\]/,""),P=this.b.getWorkspace().folders.map(V=>{const W=k.match(new RegExp(`^${T.$bf(V.name)}(?:/(.*)|$)`));return W?{match:W,folder:V}:null}).filter(S.$gg);if(P.length)return P.map(V=>{const W=V.match[1];return{searchPath:V.folder.uri,pattern:W&&p(W)}});{const V=D.match(/\.[\/\\](.+)[\/\\]?/),W=V?V[1]:D,q=g.localize(0,null,W);throw new Error(q)}}}}o(D,k){const I=D.pattern&&k?`${D.pattern}/${k}`:D.pattern||k,P=[{searchPath:D.searchPath,pattern:I}];return I&&!I.endsWith("**")&&P.push({searchPath:D.searchPath,pattern:I+"/**"}),P}q(D,k,I){const P=this.r((0,o.$Ti)(D.searchPath),k,I,!1);return P?{...P,includePattern:D.pattern}:null}r(D,k,I,P){let V;const W=l.URI.isUri(D)?D:D.uri;if(I.searchPaths){const ie=I.searchPaths.filter(de=>(0,E.$5g)(de.searchPath,W))[0];if(ie&&!ie.pattern)return null;ie&&(V=ie.pattern)}const q=this.a.getValue({resource:W}),z={...this.l(q,k)||{},...V||{}},G=l.URI.isUri(D)?(0,E.$9g)(D):D.name;return{folder:W,folderName:P?G:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!q.search.followSymlinks}}};e.$YL=u,e.$YL=u=Je([We(0,r.$5i),We(1,o.$Hi),We(2,i.$2D),We(3,s.$5j),We(4,n.$WL)],u);function t(h){const D=h.match(/[\*\{\}\(\)\[\]\?]/);if(D){const k=D.index,I=h.substr(0,k).match(/[/|\\][^/\\]*$/);if(I){let P=h.substr(0,I.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:h.substr((I.index||0)+1)}}}return{pathPortion:h}}function f(...h){return h.length?h.reduce((D,k)=>(D[k]=!0,D),Object.create(null)):void 0}function a(h){return M.$qk(h,",").map(D=>D.trim()).filter(D=>!!D.length)}function d(h){return[`**/${h}/**`,`**/${h}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function $(h){return h.replace(/\\/g,"/")}function p(h){return $(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(h){return h.replace(/([?*[\]])/g,"[$1]")}function y(h,D){h=C.$Mb(h,P=>P.toString());const k=[],I=D.getWorkspace();return h&&h.forEach(P=>{let V;if(D.getWorkbenchState()===2)V=(0,E.$bh)(I.folders[0].uri,P),V&&V!=="."&&(V="./"+V);else{const W=D.getWorkspaceFolder(P);if(W){const q=W.name;if(I.folders.filter(z=>z.name===q).length===1){const z=(0,E.$bh)(W.uri,P);z===""?V=`./${W.name}`:V=`./${W.name}/${z}`}else V=P.fsPath}}V&&k.push(v(V))}),k}}),define(Se[303],Ie([1,0,24,2,20,14,3,302,47,45,11]),function(le,e,C,O,M,N,R,w,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pwb=l,e.$Qwb=r;const S=7e3;function l(s,o){const i=o.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],c=[];for(const $ of i)if(/^workspaceContains:/.test($)){const p=$.substr(18);p.indexOf("*")>=0||p.indexOf("?")>=0||s.forceUsingSearch?c.push(p):n.push(p)}if(n.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:u,resolve:t}=(0,T.$rh)(),f=$=>t({activationEvent:$}),a=Promise.all(n.map($=>b(s,$,f))).then(()=>{}),d=g(s,o.identifier,c,f);return Promise.all([a,d]).then(()=>{t(void 0)}),u}async function b(s,o,i){for(const n of s.folders)if(await s.exists(C.$_g(O.URI.revive(n),o))){i(`workspaceContains:${o}`);return}}async function g(s,o,i,n){if(i.length===0)return Promise.resolve(void 0);const c=new M.$qe,u=s.checkExists(s.folders,i,c.token),t=setTimeout(async()=>{c.cancel(),s.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},S);let f=!1;try{f=await u}catch(a){N.$4(a)||N.$1(a)}c.dispose(),clearTimeout(t),f&&n(`workspaceContains:${i.join(",")}`)}function r(s,o,i,n){const c=s.get(R.$xi),u=s.get(m.$vK),f=c.createInstance(w.$YL).file(o.map(a=>(0,E.$Ti)(O.URI.revive(a))),{_reason:"checkExists",includePattern:i,exists:!0});return u.fileSearch(f,n).then(a=>!!a.limitHit,a=>N.$4(a)?!1:Promise.reject(a))}}),define(Se[41],Ie([1,0,173,19,60,24,11,6,54,2,12,4,40,237,84,39,25,110,14,21,22,218,7,104,3,27,87,17,72,88,53,90,5,303,83,220,16,81,66,23,82]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s,o,i,n,c,u,t,f,a,d,$,p,v,y,h,D,k,I,P,V,W,q,A,z,G){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=e.$1mc=e.$Zmc=e.$Ymc=e.$Xmc=void 0,e.$Xmc=(0,a.$yi)("IHostUtils");let de=ie=class extends w.$Uc{constructor(j,x,ve,Fe,ke,we,me,Q,Y,he,ce,Ne,fe){super(),this.Y=Ne,this.Z=fe,this.a=this.B(new k.$fe),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=ve,this.f=me,this.j=Fe,this.m=ke,this.s=we,this.t=Y,this.u=he,this.w=ce,this.y=this.g.getProxy(S.$iM.MainThreadWorkspace),this.z=this.g.getProxy(S.$iM.MainThreadTelemetry),this.C=this.g.getProxy(S.$iM.MainThreadExtensionService),this.D=new R.$xh,this.F=new R.$xh,this.G=new R.$xh,this.H=new R.$xh,this.I=new Oe(this.f.extensions.activationEvents),this.L=new o.$vac(this.I,this.f.extensions.allExtensions);const Pe=new n.$Um(this.f.extensions.myExtensions);this.J=new o.$vac(this.I,Ce(this.L,Pe)),z.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ge(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ge(this.J)}`)),this.M=new g.$Gmc(this.g,this.s),this.N=new P.$Qmc(this.g),this.O=Q,this.h=j.createChild(new v.$wi([g.$Hmc,this.M],[P.$Rmc,this.N])),this.P=this.B(new b.$Fmc(this.J,this.L,{onExtensionActivationError:(Ae,Ue,B)=>{this.C.$onExtensionActivationError(Ae,i.$3(Ue),B)},actualActivateExtension:async(Ae,Ue)=>{if(o.$vac.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,Ue),new b.$Emc;const B=this.J.getExtensionDescription(Ae);return this.fb(B,Ue)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),M.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(j){i.$1(j)}}async $(){this.O.onWillDeactivateAll();let j=[];try{j=this.J.getAllExtensionDescriptions().map(ke=>ke.identifier).filter(ke=>this.isActivated(ke)).map(ke=>this.eb(ke))}catch{}await Promise.all(j)}terminate(j,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${j}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(Fe=>{this.s.error(Fe)}),this.g.dispose();const ve=this.$();Promise.race([(0,R.$zh)(5e3),ve]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(j){return this.G.isOpen()?this.P.isActivated(j):!1}async getExtension(j){const x=await this.C.$getExtension(j);return x&&{...x,identifier:new n.$Tm(x.identifier.value),extensionLocation:E.URI.revive(x.extensionLocation)}}ab(j,x){return this.P.activateByEvent(j,x)}bb(j,x){return this.P.activateById(j,x)}activateByIdWithErrors(j,x){return this.bb(j,x).then(()=>{const ve=this.P.getActivatedExtension(j);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(j=>this.J)}getExtensionExports(j){if(this.G.isOpen())return this.P.getActivatedExtension(j).exports;try{return this.P.getActivatedExtension(j).exports}catch{return null}}async cb(j){if(j.scheme===W.Schemas.file&&this.c.fsRealpath){const x=j.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const ve=await this.R.get(x);return E.URI.file(ve)}return j}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(j=>new se(j))),this.Q}async db(j){const x=m.$Ei.forUris(ve=>N.$3g.ignorePathCasing(ve));return await Promise.all(j.map(async ve=>{if(this.wb(ve)){const Fe=await this.cb(ve.extensionLocation);x.set(Fe,ve)}})),x}eb(j){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(j))return x;const ve=this.P.getActivatedExtension(j);if(!ve)return x;try{typeof ve.module.deactivate=="function"&&(x=Promise.resolve(ve.module.deactivate()).then(void 0,Fe=>(this.s.error(Fe),Promise.resolve(void 0))))}catch(Fe){this.s.error(`An error occurred when deactivating the extension '${j.value}':`),this.s.error(Fe)}try{(0,w.$Pc)(ve.subscriptions)}catch(Fe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${j.value}':`),this.s.error(Fe)}return x}async fb(j,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(j.identifier):await this.C.$onWillActivateExtension(j.identifier),this.hb(j,x).then(ve=>{const Fe=ve.activationTimes;return this.C.$onDidActivateExtension(j.identifier,Fe.codeLoadingTime,Fe.activateCallTime,Fe.activateResolvedTime,x),this.gb(j,x,"success",Fe),ve},ve=>{throw this.gb(j,x,"failure"),ve})}gb(j,x,ve,Fe){const ke=Ee(j,x);this.z.$publicLog2("extensionActivationTimes",{...ke,...Fe||{},outcome:ve})}hb(j,x){const ve=Ee(j,x);this.z.$publicLog2("activatePlugin",ve);const Fe=this.wb(j);if(!Fe)return Promise.resolve(new b.$Dmc(b.$Amc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${j.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${j.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const ke=new b.$Bmc(x.startup);return Promise.all([this.xb(j,(0,N.$_g)(j.extensionLocation,Fe),ke),this.ib(j)]).then(we=>(M.mark(`code/extHost/willActivateExtension/${j.identifier.value}`),ie.jb(this.s,j.identifier,we[0],we[1],ke))).then(we=>(M.mark(`code/extHost/didActivateExtension/${j.identifier.value}`),we))}ib(j){const x=this.Z.createLanguageModelAccessInformation(j),ve=new u.$Jmc(j,this.M),Fe=new u.$Imc(j.identifier.value,!1,this.M),ke=new V.$Smc(j,this.N),we=j.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,me=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${j.identifier.value}`),Promise.all([ve.whenReady,Fe.whenReady,this.O.whenReady]).then(()=>{const Q=this;let Y,he;const ce=(0,s.$JG)(j,"ipc")?this.f.messagePorts?.get(n.$Tm.toKey(j.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:Fe,secrets:ke,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return j.extensionLocation},get extensionPath(){return j.extensionLocation.fsPath},asAbsolutePath(Ne){return O.$jc(j.extensionLocation.fsPath,Ne)},get storagePath(){return Q.O.workspaceValue(j)?.fsPath},get globalStoragePath(){return Q.O.globalValue(j).fsPath},get logPath(){return O.$jc(Q.f.logsLocation.fsPath,j.identifier.value)},get logUri(){return E.URI.joinPath(Q.f.logsLocation,j.identifier.value)},get storageUri(){return Q.O.workspaceValue(j)},get globalStorageUri(){return Q.O.globalValue(j)},get extensionMode(){return we},get extension(){return Y===void 0&&(Y=new ue(Q,j.identifier,j,me,!1)),Y},get extensionRuntime(){return(0,s.$KG)(j,"extensionRuntime"),Q.extensionRuntime},get environmentVariableCollection(){return Q.u.getEnvironmentVariableCollection(j)},get messagePassingProtocol(){if(!he){if(!ce)return;const Ne=k.Event.buffer(k.Event.fromDOMEventEmitter(ce,"message",fe=>fe.data));ce.start(),he={onDidReceiveMessage:Ne,postMessage:ce.postMessage.bind(ce)}}return he}})})}static jb(j,x,ve,Fe,ke){return ve=ve||{activate:void 0,deactivate:void 0},this.kb(j,x,ve,Fe,ke).then(we=>new b.$Cmc(!1,null,ke.build(),ve,we,Fe.subscriptions))}static kb(j,x,ve,Fe,ke){if(typeof ve.activate=="function")try{ke.activateCallStart(),j.trace(`ExtensionService#_callActivateOptional ${x.value}`);const we=typeof global=="object"?global:self,me=ve.activate.apply(we,[Fe]);return ke.activateCallStop(),ke.activateResolveStart(),Promise.resolve(me).then(Q=>(ke.activateResolveStop(),Q))}catch(we){return Promise.reject(we)}else return Promise.resolve(ve)}lb(j,x){this.bb(j.identifier,{startup:!1,extensionId:j.identifier,activationEvent:x}).then(void 0,ve=>{this.s.error(ve)})}mb(j,x=0){const Fe=Date.now();(0,z.$B)(()=>{for(let ke=x;ke<j.length;ke+=1){const we=j[ke];for(const me of we.activationEvents??[])if(me==="onStartupFinished")if(Date.now()-Fe>50){this.mb(j,ke);break}else this.lb(we,me)}})}nb(){this.C.$setPerformanceMarks(M.getMarks()),this.m.getConfigProvider().then(j=>{const x=j.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ve=this.J.getAllExtensionDescriptions();if(x)this.mb(ve);else for(const Fe of ve)if(Fe.activationEvents)for(const ke of Fe.activationEvents)ke==="onStartupFinished"&&this.lb(Fe,ke)})}ob(){const j=this.ab("*",!0).then(void 0,we=>{this.s.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.pb(we.added)));const x=this.j.workspace?this.j.workspace.folders:[],ve=this.pb(x),Fe=this.rb(),ke=Promise.all([Fe,j,ve]).then(()=>{});return Promise.race([ke,(0,R.$zh)(1e4)]).then(()=>{this.nb()}),ke}pb(j){return j.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(j,x))).then(()=>{})}async qb(j,x){if(this.isActivated(x.identifier))return;const ve=!this.f.remote.isRemote&&!!this.f.remote.authority,Fe={logService:this.s,folders:j.map(we=>we.uri),forceUsingSearch:ve||!this.c.fsExists,exists:we=>this.c.fsExists(we.fsPath),checkExists:(we,me,Q)=>this.y.$checkExists(we,me,Q)},ke=await(0,I.$Pwb)(Fe,x);if(ke)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:ke.activationEvent}).then(void 0,we=>this.s.error(we))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(j){throw console.error(j),j}}async sb(){const{extensionDevelopmentLocationURI:j,extensionTestsLocationURI:x}=this.f.environment;if(!j||!x)throw new Error(C.localize(0,null));const ve=await this.xb(null,x,new b.$Bmc(!1));if(!ve||typeof ve.run!="function")throw new Error(C.localize(1,null,x.toString()));return new Promise((Fe,ke)=>{const we=(Y,he)=>{Y?(z.$t&&this.s.error("Test runner called back with error",Y),ke(Y)):(z.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),Fe(typeof he=="number"&&he>0?1:0))},me=(0,N.$Zg)(x),Q=ve.run(me,we);Q&&Q.then&&Q.then(()=>{z.$t&&this.s.info("Test runner finished successfully."),Fe(0)}).catch(Y=>{z.$t&&this.s.error("Test runner finished with error",Y),ke(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$zh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(j,x){return this.S[j]=x,(0,w.$Sc)(()=>{delete this.S[j]})}async getRemoteExecServer(j){const{resolver:x}=await this.ub(j);return x?.resolveExecServer?.(j,{resolveAttempt:0})}async ub(j){const x=j.indexOf("+");if(x===-1)throw new t.$qM("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ve=j.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this.S[ve]}}async $resolveAuthority(j,x){const ve=A.$be.create(!1),Fe=()=>`[resolveAuthority(${(0,f.$Nl)(j)},${x})][${ve.elapsed()}ms] `,ke=L=>this.s.info(`${Fe()}${L}`),we=L=>this.s.warn(`${Fe()}${L}`),me=(L,K=void 0)=>this.s.error(`${Fe()}${L}`,K),Q=L=>{if(L instanceof t.$qM)return{type:"error",error:{code:L._code,message:L._message,detail:L._detail}};throw L},Y=async L=>{ke(`activating resolver for ${L}...`);const{resolver:K,authorityPrefix:H}=await this.ub(L);if(!K)throw me(`no resolver for ${H}`),new t.$qM(`No remote extension installed to resolve ${H}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:H,remoteAuthority:L}},he=j.split(/@|%40/g).reverse();ke(`activating remote resolvers ${he.join(" -> ")}`);let ce;try{ce=await Promise.all(he.map(Y)).catch(async L=>{if(!(L instanceof t.$qM)||L._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw L;return we(`resolving nested authorities failed: ${L.message}`),[await Y(j)]})}catch(L){return Q(L)}const Ne=new R.$Jh;Ne.cancelAndSet(()=>ke("waiting..."),1e3);let fe,Pe;for(const[L,{authorityPrefix:K,resolver:H,remoteAuthority:ee}]of ce.entries())try{if(L===ce.length-1)ke("invoking final resolve()..."),M.mark(`code/extHost/willResolveAuthority/${K}`),fe=await H.resolve(ee,{resolveAttempt:x,execServer:Pe}),M.mark(`code/extHost/didResolveAuthorityOK/${K}`),ke("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$pM.isManagedResolvedAuthority(fe)?fe:void 0));else{if(ke(`invoking resolveExecServer() for ${ee}`),M.mark(`code/extHost/willResolveExecServer/${K}`),Pe=await H.resolveExecServer?.(ee,{resolveAttempt:x,execServer:Pe}),!Pe)throw new t.$qM(`Exec server was not available for ${ee}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);M.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(re){return M.mark(`code/extHost/didResolveAuthorityError/${K}`),me("returned an error",re),Ne.dispose(),Q(re)}Ne.dispose();const Ae={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures?{elevation:fe.tunnelFeatures.elevation,privacyOptions:fe.tunnelFeatures.privacyOptions,protocol:fe.tunnelFeatures.protocol===void 0?!0:fe.tunnelFeatures.protocol}:void 0},Ue={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};ke(`returned ${t.$pM.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let B;if(t.$pM.isManagedResolvedAuthority(fe)){const L=x;this.Y.setFactory(L,fe.makeConnection),B={authority:j,connectTo:new f.$Kl(L),connectionToken:fe.connectionToken}}else B={authority:j,connectTo:new f.$Ll(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:B,options:Ue,tunnelInformation:Ae}}}async $getCanonicalURI(j,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,f.$Nl)(j)})`);const{resolver:ve}=await this.ub(j);if(!ve)return null;const Fe=E.URI.revive(x);if(typeof ve.getCanonicalURI>"u")return Fe;const ke=await(0,R.$qh)(()=>ve.getCanonicalURI(Fe));return ke||Fe}async $startExtensionHost(j){j.toAdd.forEach(we=>we.extensionLocation=E.URI.revive(we.extensionLocation));const{globalRegistry:x,myExtensions:ve}=ye(this.I,this.L,this.J,j),Fe=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Fe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),z.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ge(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ge(this.J)}`)),this.tb()}$activateByEvent(j,x){return x===1?this.D.wait().then(ve=>this.ab(j,!1)):this.G.wait().then(ve=>this.ab(j,!1))}async $activate(j,x){return await this.G.wait(),this.J.getExtensionDescription(j)?(await this.bb(j,x),!0):!1}async $deltaExtensions(j){j.toAdd.forEach(we=>we.extensionLocation=E.URI.revive(we.extensionLocation));const{globalRegistry:x,myExtensions:ve}=ye(this.I,this.L,this.J,j),Fe=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Fe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),z.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ge(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ge(this.J)}`)),Promise.resolve(void 0)}async $test_latency(j){return j}async $test_up(j){return j.byteLength}async $test_down(j){const x=c.$He.alloc(j),ve=Math.random()%256;for(let Fe=0;Fe<j;Fe++)x.writeUInt8(ve,Fe);return x}async $updateRemoteConnectionData(j){this.X=j,this.a.fire()}};e.$Ymc=de,e.$Ymc=de=ie=Je([We(0,a.$xi),We(1,e.$Xmc),We(2,p.$MO),We(3,r.$jmc),We(4,l.$mmc),We(5,T.$5j),We(6,d.$3O),We(7,$.$pmc),We(8,y.$SDb),We(9,h.$Kmc),We(10,q.$Umc),We(11,G.$Vmc),We(12,D.$Omc)],de);function ye(ne,j,x,ve){ne.addActivationEvents(ve.addActivationEvents);const Fe=new o.$vac(ne,j.getAllExtensionDescriptions());Fe.deltaExtensions(ve.toAdd,ve.toRemove);const ke=new n.$Um(x.getAllExtensionDescriptions().map(me=>me.identifier));for(const me of ve.myToRemove)ke.delete(me);for(const me of ve.myToAdd)ke.add(me);const we=Ce(Fe,ke);return{globalRegistry:Fe,myExtensions:we}}function Ee(ne,j){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:j.activationEvent,reasonId:j.extensionId.value}}function ge(ne){return ne.getAllExtensionDescriptions().map(j=>j.identifier.value).join(",")}e.$Zmc=(0,a.$yi)("IExtHostExtensionService");class ue{#e;#t;#i;constructor(j,x,ve,Fe,ke){this.#e=j,this.#t=x,this.#i=ve.identifier,this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=O.$hc((0,N.$Zg)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=Fe,this.isFromDifferentExtensionHost=ke}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$1mc=ue;function Ce(ne,j){return ne.getAllExtensionDescriptions().filter(x=>j.has(x.identifier))}class se{constructor(j){this.a=j}setSearchTree(j){this.a=j}findSubstr(j){return this.a.findSubstr(j)}forEach(j){return this.a.forEach(j)}}e.$2mc=se;class Oe{constructor(j){this.a=new n.$Vm,this.addActivationEvents(j)}readActivationEvents(j){return this.a.get(j.identifier)??[]}addActivationEvents(j){for(const x of Object.keys(j))this.a.set(x,j[x])}}}),define(Se[304],Ie([1,0,60,2,4,40,25,21,17,27,3,41,12,13]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$$nc=void 0;let r=class{constructor(c,u,t,f,a,d,$){this.c=c,this.d=u,this.e=t,this.f=f,this.g=a,this.h=d,this.i=$,this.a=new Map,this.b=[]}async install(){this.j(),C.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const u=await this.g.getExtensionPathIndex();this.register(new o(this.c,u,this.d,c,this.i)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,u,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const u of c.nodeModuleName)this.a.set(u,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(u=>c.alternativeModuleName(u))}};e.$$nc=r,e.$$nc=r=Je([We(2,T.$xi),We(3,N.$mmc),We(4,S.$Zmc),We(5,E.$3O),We(6,l.$5j)],r);let s=class{static{g=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&g.a.size){const u=(0,b.$bf)(this.c(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${u}/${a}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const u=this.b.exec(this.c(c));if(!u)return;const[,t,f,a]=u,d=g.a.get(f);if(d!==void 0)return console.warn(`${f} as been renamed to ${d}, please update your imports`),t+d+a}c(c){return c.replace(/\\/g,"/")}};s=g=Je([We(0,E.$3O)],s);class o{constructor(c,u,t,f,a){this.c=c,this.d=u,this.e=t,this.f=f,this.g=a,this.nodeModuleName="vscode",this.a=new w.$Vm}load(c,u){const t=this.d.findSubstr(u);if(t){let f=this.a.get(t.identifier);return f||(f=this.c(t,this.e,this.f),this.a.set(t.identifier,f)),f}if(!this.b){let f="";this.d.forEach((a,d)=>f+=`	${d} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${u}. These are the extension path mappings: 
${f}`),this.b=this.c(R.$EG,this.e,this.f)}return this.b}}let i=class{constructor(c,u,t){this.e=c,this.f=u,this.nodeModuleName=["open","opn"],this.d=t.getProxy(M.$iM.MainThreadTelemetry);const f=t.getProxy(M.$iM.MainThreadWindow);this.c=(a,d)=>{const $=O.URI.parse(a);return d?this.g(a,d):$.scheme==="http"||$.scheme==="https"?f.$openUri($,a,{allowTunneling:!0}):$.scheme==="mailto"||$.scheme===this.f?f.$openUri($,a,{}):this.g(a,d)}}load(c,u,t){const f=this.e.findSubstr(u);return f&&(this.a=f.identifier.value,this.h()),this.b=t(c),this.c}g(c,u){return this.i(),this.b(c,u)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Je([We(2,m.$MO)],i)}),define(Se[122],Ie([1,0,43,6,19,75,3,68,67,41,7,39,234,40]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=e.$3mc=void 0,e.$3mc=(0,R.$yi)("IExtHostVariableResolverProvider");class g extends l.$QP{constructor(o,i,n,c,u,t,f){function a(){if(n){const d=n.activeEditor();if(d)return d.document.uri;const $=c.tabGroups.all.find(p=>p.isActive)?.activeTab;if($!==void 0){if($.input instanceof T.$9N||$.input instanceof T.$bO)return $.input.modified;if($.input instanceof T.$8N||$.input instanceof T.$aO||$.input instanceof T.$$N)return $.input.uri}}}super({getFolderUri:d=>{const $=t.folders.filter(p=>p.name===d);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(d,$)=>u.getConfiguration(void 0,d).get($),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=a();if(d)return M.$hc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const d=a();if(d){const $=i.getWorkspaceFolder(d);if($)return M.$hc($.uri.fsPath)}}},getSelectedText:()=>{if(n){const d=n.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(n){const d=n.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>o.getExtension(d)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(N.env))}}let r=class extends O.$Uc{constructor(o,i,n,c,u){super(),this.b=o,this.c=i,this.g=n,this.h=c,this.j=u,this.a=new C.$V(async()=>{const t=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new g(this.b,this.c,this.g,this.j,t,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$4mc=r,e.$4mc=r=Je([We(0,E.$Zmc),We(1,S.$jmc),We(2,w.$XO),We(3,b.$mmc),We(4,m.$ymc)],r)}),define(Se[123],Ie([1,0,11,5,2,21,3,4,67,41,17,7,39,226,228,40,122,6,36,35,8,18]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s,o,i,n,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9mc=e.$8mc=e.$7mc=e.$6mc=e.$5mc=void 0,e.$5mc=(0,R.$yi)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(y,h,D,k,I,P,V){this.N=h,this.O=D,this.P=k,this.Q=I,this.R=P,this.S=V,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new O.$fe,this.o=new O.$fe,this.q=new O.$fe,this.w=new O.$fe,this.l=y.getProxy(w.$iM.MainThreadDebugService),this.A=new O.$fe,this.C=new O.$fe,this.y=new a(this.l),this.z=new Map,this.O.getExtensionRegistry().then(W=>{W.onDidChange(q=>{this.V(W)}),this.V(W)})}async $getVisualizerTreeItem(y,h){const D=this.W(h);if(!D)return;const k=await this.H.get(y)?.getTreeItem?.(D);return k?this.U(y,k):void 0}registerDebugVisualizationTree(y,h,D){const k=N.$Tm.toKey(y.identifier),I=this.jb(k,h);if(this.G.has(I))throw new Error(`A debug visualization provider with id '${h}' is already registered`);return this.H.set(I,D),this.l.$registerDebugVisualizerTree(I,!!D.editItem),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(I),this.H.delete(h)})}async $getVisualizerTreeItemChildren(y,h){const D=this.J.get(h)?.item;return D?(await this.H.get(y)?.getChildren?.(D))?.map(I=>this.U(y,I))||[]:[]}async $editVisualizerTreeItem(y,h){const D=this.J.get(y);if(!D)return;const k=await this.H.get(D.provider)?.editItem?.(D.item,h);return this.U(D.provider,k||D.item)}$disposeVisualizedTree(y){const h=this.J.get(y);if(!h)return;const D=[h.children];for(const k of D)if(k)for(const I of k)D.push(this.J.get(I)?.children),this.J.delete(I)}U(y,h){let D=this.I.get(h);return D||(D=this.F++,this.I.set(h,D),this.J.set(D,{provider:y,item:h})),c.DebugTreeItem.from(h,D)}asDebugSourceUri(y,h){const D=y;if(typeof D.sourceReference=="number"&&D.sourceReference>0){let k=`debug:${encodeURIComponent(D.path||"")}`,I="?";return h&&(k+=`${I}session=${encodeURIComponent(h.id)}`,I="&"),k+=`${I}ref=${D.sourceReference}`,M.URI.parse(k)}else{if(D.path)return M.URI.file(D.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(y){const h=[];for(const D of y.getAllExtensionDescriptions())if(D.contributes){const k=D.contributes.debuggers;if(k&&k.length>0)for(const I of k)(0,g.$yH)(I)&&h.push(I.type)}this.l.$registerDebugTypes(h)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const y=[];return this.z.forEach(h=>y.push(h)),y}async $resolveDebugVisualizer(y,h){const D=this.L.get(y);if(!D)throw new Error(`No debug visualizer found with id '${y}'`);let{v:k,provider:I,extensionId:P}=D;if(k.visualization||(k=await I.resolveDebugVisualization?.(k,h)||k,D.v=k),!k.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${I}'`);return this.kb(P,k.visualization)}async $executeDebugVisualizerCommand(y){const h=this.L.get(y);if(!h)throw new Error(`No debug visualizer found with id '${y}'`);const D=h.v.visualization;D&&"command"in D&&this.S.executeCommand(D.command,...D.arguments||[])}W(y){const h=this.m.get(y.sessionId);return h&&{session:h.api,variable:y.variable,containerId:y.containerId,frameId:y.frameId,threadId:y.threadId}}async $provideDebugVisualizers(y,h,D,k){const I=this.W(D),P=this.jb(y,h),V=this.G.get(P);if(!I||!V)return[];const W=await V.provideDebugVisualization(I,k);return W?W.map(q=>{const A=++this.M;this.L.set(A,{v:q,provider:V,extensionId:y});const z=q.iconPath?this.lb(q.iconPath):void 0;return{id:A,name:q.name,iconClass:z?.iconClass,iconPath:z?.iconPath,visualization:this.kb(y,q.visualization)}}):[]}$disposeDebugVisualizers(y){for(const h of y)this.L.delete(h)}registerDebugVisualizationProvider(y,h,D){if(!y.contributes?.debugVisualizers?.some(P=>P.id===h))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${h})`);const k=N.$Tm.toKey(y.identifier),I=this.jb(k,h);if(this.G.has(I))throw new Error(`A debug visualization provider with id '${h}' is already registered`);return this.G.set(I,D),this.l.$registerDebugVisualizer(k,h),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizer(k,h),this.G.delete(h)})}addBreakpoints(y){const h=y.filter(I=>{const P=I.id;return this.z.has(P)?!1:(this.z.set(P,I),!0)});this.gb(h,[],[]);const D=[],k=new Map;for(const I of h)if(I instanceof S.$mN){let P=k.get(I.location.uri.toString());P||(P={type:"sourceMulti",uri:I.location.uri,lines:[]},k.set(I.location.uri.toString(),P),D.push(P)),P.lines.push({id:I.id,enabled:I.enabled,condition:I.condition,hitCondition:I.hitCondition,logMessage:I.logMessage,line:I.location.range.start.line,character:I.location.range.start.character,mode:I.mode})}else I instanceof S.$nN&&D.push({type:"function",id:I.id,enabled:I.enabled,hitCondition:I.hitCondition,logMessage:I.logMessage,condition:I.condition,functionName:I.functionName,mode:I.mode});return this.l.$registerBreakpoints(D)}removeBreakpoints(y){const h=y.filter(P=>this.z.delete(P.id));this.gb([],h,[]);const D=h.filter(P=>P instanceof S.$mN).map(P=>P.id),k=h.filter(P=>P instanceof S.$nN).map(P=>P.id),I=h.filter(P=>P instanceof S.$oN).map(P=>P.id);return this.l.$unregisterBreakpoints(D,k,I)}startDebugging(y,h,D){return this.l.$startDebugging(y?y.uri:void 0,h,{parentSessionID:D.parentSession?D.parentSession.id:void 0,lifecycleManagedByParent:D.lifecycleManagedByParent,repl:D.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:D.noDebug,compact:D.compact,suppressSaveBeforeStart:D.suppressSaveBeforeStart,suppressDebugStatusbar:D.suppressDebugStatusbar??D.debugUI?.simple,suppressDebugToolbar:D.suppressDebugToolbar??D.debugUI?.simple,suppressDebugView:D.suppressDebugView??D.debugUI?.simple})}stopDebugging(y){return this.l.$stopDebugging(y?y.id:void 0)}registerDebugConfigurationProvider(y,h,D){if(!h)return new S.$kM(()=>{});const k=this.d++;return this.f.push({type:y,handle:k,provider:h}),this.l.$registerDebugConfigurationProvider(y,D,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,k),new S.$kM(()=>{this.f=this.f.filter(I=>I.provider!==h),this.l.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(y,h,D){if(!D)return new S.$kM(()=>{});if(!this.cb(y,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.$(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:h,handle:k,factory:D}),this.l.$registerDebugAdapterDescriptorFactory(h,k),new S.$kM(()=>{this.h=this.h.filter(I=>I.factory!==D),this.l.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(y,h){if(!h)return new S.$kM(()=>{});const D=this.j++;return this.k.push({type:y,handle:D,factory:h}),new S.$kM(()=>{this.k=this.k.filter(k=>k.factory!==h)})}async $runInTerminal(y,h){return Promise.resolve(void 0)}async $substituteVariables(y,h){let D;const k=await this.ib(y);return k&&(D={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(D,h)}X(y,h){if(y.type==="implementation")return new $(y.implementation)}Y(){}async $startDASession(y,h){const D=this,k=await this.hb(h);return this.eb(this.$(k.type),k).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const P=this.Z(I),V=this.X(P,k);if(!V)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const W=V;return this.D.set(y,W),this.db(k).then(q=>(q&&this.E.set(y,q),W.onMessage(async A=>{if(A.type==="request"&&A.command==="handshake"){const z=A,G={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const ie=await this.K.sign(z.arguments.value);G.body={signature:ie},W.sendResponse(G)}else throw new Error("no signer")}catch(ie){G.success=!1,G.message=ie.message,W.sendResponse(G)}}else q&&q.onDidSendMessage&&q.onDidSendMessage(A),A=(0,g.$DH)(A,!0),D.l.$acceptDAMessage(y,A)}),W.onError(A=>{q&&q.onError&&q.onError(A),this.l.$acceptDAError(y,A.name,A.message,A.stack)}),W.onExit(A=>{q&&q.onExit&&q.onExit(A??void 0,void 0),this.l.$acceptDAExit(y,A??void 0,void 0)}),q&&q.onWillStartSession&&q.onWillStartSession(),W.startSession()))})}$sendDAMessage(y,h){h=(0,g.$CH)(h,!1);const D=this.E.get(y);D&&D.onWillReceiveMessage&&D.onWillReceiveMessage(h),this.D.get(y)?.sendMessage(h)}$stopDASession(y){const h=this.E.get(y);this.E.delete(y),h&&h.onWillStopSession&&h.onWillStopSession();const D=this.D.get(y);return this.D.delete(y),D?D.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(y){const h=[],D=[],k=[];if(y.added)for(const I of y.added){const P=I.id;if(P&&!this.z.has(P)){let V;if(I.type==="function")V=new S.$nN(I.functionName,I.enabled,I.condition,I.hitCondition,I.logMessage,I.mode);else if(I.type==="data")V=new S.$oN(I.label,I.dataId,I.canPersist,I.enabled,I.hitCondition,I.condition,I.logMessage,I.mode);else{const W=M.URI.revive(I.uri);V=new S.$mN(new S.$wM(W,new S.$lM(I.line,I.character)),I.enabled,I.condition,I.hitCondition,I.logMessage,I.mode)}(0,S.$kN)(V,P),this.z.set(P,V),h.push(V)}}if(y.removed)for(const I of y.removed){const P=this.z.get(I);P&&(this.z.delete(I),D.push(P))}if(y.changed){for(const I of y.changed)if(I.id){const P=this.z.get(I.id);if(P){if(P instanceof S.$nN&&I.type==="function"){const V=P;V.enabled=I.enabled,V.condition=I.condition,V.hitCondition=I.hitCondition,V.logMessage=I.logMessage,V.functionName=I.functionName}else if(P instanceof S.$mN&&I.type==="source"){const V=P;V.enabled=I.enabled,V.condition=I.condition,V.hitCondition=I.hitCondition,V.logMessage=I.logMessage,V.location=new S.$wM(M.URI.revive(I.uri),new S.$lM(I.line,I.character))}k.push(P)}}}this.gb(h,D,k)}async $acceptStackFrameFocus(y){let h;if(y){const D=await this.hb(y.sessionId);y.kind==="thread"?h=new S.$uN(D.api,y.threadId):h=new S.$tN(D.api,y.threadId,y.frameId)}this.B=h,this.C.fire(this.B)}$provideDebugConfigurations(y,h,D){return(0,C.$qh)(async()=>{const k=this.bb(y);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const I=await this.ib(h);return k.provideDebugConfigurations(I,D)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(y,h,D,k){return(0,C.$qh)(async()=>{const I=this.bb(y);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(h);return I.resolveDebugConfiguration(P,D,k)})}$resolveDebugConfigurationWithSubstitutedVariables(y,h,D,k){return(0,C.$qh)(async()=>{const I=this.bb(y);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(h);return I.resolveDebugConfigurationWithSubstitutedVariables(P,D,k)})}async $provideDebugAdapter(y,h){const D=this.ab(y);if(!D)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.hb(h);return this.eb(D,k).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.Z(I)})}async $acceptDebugSessionStarted(y){const h=await this.hb(y);this.n.fire(h.api)}async $acceptDebugSessionTerminated(y){const h=await this.hb(y);h&&(this.o.fire(h.api),this.m.delete(h.id))}async $acceptDebugSessionActiveChanged(y){this.u=y?await this.hb(y):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(y,h){(await this.hb(y))?._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(y,h){const k={session:(await this.hb(y)).api,event:h.event,body:h.body};this.w.fire(k)}Z(y){if(y instanceof S.$pN)return{type:"executable",command:y.command,args:y.args,options:y.options};if(y instanceof S.$qN)return{type:"server",port:y.port,host:y.host};if(y instanceof S.$rN)return{type:"pipeServer",path:y.path};if(y instanceof S.$sN)return{type:"implementation",implementation:y.implementation};throw new Error("convertToDto unexpected type")}$(y){const h=this.h.filter(D=>D.type===y);if(h.length>0)return h[0].factory}ab(y){const h=this.h.filter(D=>D.handle===y);if(h.length>0)return h[0].factory}bb(y){const h=this.f.filter(D=>D.handle===y);if(h.length>0)return h[0].provider}cb(y,h){if(y.contributes){const D=y.contributes.debuggers;if(D&&D.length>0){for(const k of D)if(k.label&&k.type&&k.type===h)return!0}}return!1}db(y){const D=y.configuration.type,k=this.k.filter(I=>I.type===D||I.type==="*").map(I=>(0,C.$qh)(()=>I.factory.createDebugAdapterTracker(y.api)).then(P=>P,P=>null));return Promise.race([Promise.all(k).then(I=>{const P=(0,u.$Hb)(I);if(P.length>0)return new d(P)}),new Promise(I=>setTimeout(()=>I(void 0),1e3))]).catch(I=>{})}async eb(y,h){const D=h.configuration.debugServer;if(typeof D=="number")return Promise.resolve(new S.$qN(D));if(y){const I=await this.O.getExtensionRegistry();return(0,C.$qh)(()=>y.createDebugAdapterDescriptor(h.api,this.fb(h,I))).then(P=>{if(P)return P})}const k=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(h,k))}fb(y,h){}gb(y,h,D){(y.length>0||h.length>0||D.length>0)&&this.A.fire(Object.freeze({added:y,removed:h,changed:D}))}async hb(y){if(y)if(typeof y=="string"){const h=this.m.get(y);if(h)return h}else{let h=this.m.get(y.id);if(!h){const D=await this.ib(y.folderUri),k=y.parent?this.m.get(y.parent):void 0;h=new f(this.l,y.id,y.type,y.name,D,y.configuration,k?.api),this.m.set(h.id,h),this.l.$sessionCached(h.id)}return h}throw new Error("cannot find session")}ib(y){if(y){const h=M.URI.revive(y);return this.N.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}jb(y,h){return`${y}\0${h}`}kb(y,h){if(h){if("title"in h&&"command"in h)return{type:0};if("treeId"in h)return{type:1,id:`${y}\0${h.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(y){const h=this.mb(y);let D,k;return"id"in h?k=i.ThemeIcon.asClassName(h):D=h,{iconPath:D,iconClass:k}}mb(y){if(y instanceof S.$hN)return{id:y.id};const h=typeof y=="object"&&"dark"in y?y.dark:y,D=typeof y=="object"&&"light"in y?y.light:y;return{dark:typeof h=="string"?M.URI.file(h):h,light:typeof D=="string"?M.URI.file(D):D}}};e.$6mc=t,e.$6mc=t=Je([We(0,T.$MO),We(1,l.$jmc),We(2,E.$Zmc),We(3,r.$mmc),We(4,m.$ymc),We(5,s.$3mc),We(6,n.$9O)],t);class f{constructor(y,h,D,k,I,P,V){this.f=y,this.g=h,this.h=D,this.j=k,this.k=I,this.l=P,this.m=V}get api(){const y=this;return this.d??=Object.freeze({id:y.g,type:y.h,get name(){return y.j},set name(h){y.j=h,y.f.$setDebugSessionName(y.g,h)},parentSession:y.m,workspaceFolder:y.k,configuration:y.l,customRequest(h,D){return y.f.$customDebugAdapterRequest(y.g,h,D)},getDebugProtocolBreakpoint(h){return y.f.$getDebugProtocolBreakpoint(y.g,h.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(y){this.j=y}get configuration(){return this.l}}e.$7mc=f;class a{constructor(y){this.value=Object.freeze({append(h){y.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.$8mc=a;class d{constructor(y){this.d=y}onWillStartSession(){this.d.forEach(y=>y.onWillStartSession?y.onWillStartSession():void 0)}onWillReceiveMessage(y){this.d.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(y):void 0)}onDidSendMessage(y){this.d.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(y):void 0)}onWillStopSession(){this.d.forEach(y=>y.onWillStopSession?y.onWillStopSession():void 0)}onError(y){this.d.forEach(h=>h.onError?h.onError(y):void 0)}onExit(y,h){this.d.forEach(D=>D.onExit?D.onExit(y,h):void 0)}}class $ extends b.$jsb{constructor(y){super(),this.h=y,y.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(y){this.h.handleMessage(y)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let p=class extends t{constructor(y,h,D,k,I,P,V){super(y,h,D,k,I,P,V)}};e.$9mc=p,e.$9mc=p=Je([We(0,T.$MO),We(1,l.$jmc),We(2,E.$Zmc),We(3,r.$mmc),We(4,m.$ymc),We(5,s.$3mc),We(6,n.$9O)],p)}),define(Se[305],Ie([1,0,14,60,2,4,255,12,56,72,27,199,17,61,41,63]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aoc=e.$_nc=void 0;class s{static async installEarlyHandler(n){Error.stackTraceLimit=100;const c=n.get(w.$5j),t=n.get(l.$MO).getProxy(N.$iM.MainThreadErrors);C.setUnexpectedErrorHandler(f=>{c.error(f);const a=C.$3(f);t.$onUnexpectedError(a)})}static async installFullHandler(n){const c=n.get(w.$5j),u=n.get(l.$MO),t=n.get(g.$Zmc),f=n.get(r.$7O),a=u.getProxy(N.$iM.MainThreadExtensionService),d=u.getProxy(N.$iM.MainThreadErrors),$=await t.getExtensionPathIndex(),p=new WeakMap;function v(D,k){if(p.has(D))return p.get(D).stack;let I="",P,V;for(const q of k)I+=`
	at ${q.toString()}`,V=q.getFileName(),!P&&V&&(P=$.findSubstr(M.URI.file(V)));const W=`${D.name||"Error"}: ${D.message||""}${I}`;return p.set(D,{extensionIdentifier:P?.identifier,stack:W}),W}const y=Symbol("prepareStackTrace wrapped");let h=v;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return h},set(D){if(D===v||!D||D[y]){h=D||v;return}h=function(k,I){return v(k,I),D.call(Error,k,I)},Object.assign(h,{[y]:!0})}}),C.setUnexpectedErrorHandler(D=>{c.error(D);const k=C.$3(D),I=p.get(D);if(!I?.extensionIdentifier){d.$onUnexpectedError(k);return}a.$onExtensionRuntimeError(I.extensionIdentifier,k);const P=f.onExtensionError(I.extensionIdentifier,D);c.trace("forwarded error to extension?",P,I)})}}e.$_nc=s;class o{constructor(n,c,u,t,f){this.a=u,this.b=new R.$Dac(n,null,t),c=o.e(c,this.b);const a=new E.$wi(...(0,m.$Bs)());a.set(T.$3O,{_serviceBrand:void 0,...c,messagePorts:f}),a.set(l.$MO,new l.$NO(this.b)),a.set(b.$gmc,new b.$hmc(t)),a.set(g.$Xmc,u);const d=new S.$fr(a,!0);d.invokeFunction(s.installEarlyHandler),this.d=d.invokeFunction($=>$.get(w.$5j)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=d.invokeFunction($=>$.get(g.$Zmc)),this.c.initialize(),d.invokeFunction(s.installFullHandler)}async asBrowserUri(n){const c=this.b.getProxy(N.$iM.MainThreadExtensionService);return M.URI.revive(await c.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,c){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=M.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=M.URI.revive(c.transformIncomingURIs(n.environment.appRoot));const u=n.environment.extensionDevelopmentLocationURI;return u&&(n.environment.extensionDevelopmentLocationURI=u.map(t=>M.URI.revive(c.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=M.URI.revive(c.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=M.URI.revive(c.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=M.URI.revive(c.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=M.URI.revive(c.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=M.URI.revive(c.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=M.URI.revive(c.transformIncomingURIs(n.logsLocation)),n.workspace=c.transformIncomingURIs(n.workspace),n}}e.$aoc=o}),define(Se[306],Ie([1,0,18,11,20,44,16,19,24,2,47]),function(le,e,C,O,M,N,R,w,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=e.$lnc=e.$knc=void 0,e.$mnc=r;class S{constructor(i,n,c){this.d=i,this.e=n,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(i,n){const c=this.g.folderQueries||[],u=new M.$qe(n);return new Promise((t,f)=>{this.a=new b(i);let a=!1;const d=($,p)=>{if(!a&&!this.b){const v=this.h($);r($)&&typeof this.g.maxResults=="number"&&this.c+v>this.g.maxResults&&(this.b=!0,a=!0,u.cancel(),$=this.j($,this.g.maxResults-this.c));const y=this.h($);this.c+=y,(y>0||!r($))&&this.a.add($,p)}};Promise.all(c.map(($,p)=>this.k($,v=>d(v,p),u.token))).then($=>{u.dispose(),this.a.flush();const p=$.some(v=>!!v&&!!v.limitHit);t({limitHit:this.b||p,messages:$.flatMap(v=>v?.message?Array.isArray(v.message)?v.message:[v.message]:[]),stats:{type:this.f}})},$=>{u.dispose();const p=(0,N.$jj)($);f(new Error(p))})})}h(i){return r(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const c=Array.isArray(i.ranges)?i.ranges:[i.ranges],u=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:c.slice(0,n),preview:{matches:u.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,c){const u=new T.$OK(this.g,i),t=[],f={report:$=>{if(!this.l($))return;const p=i.folder.scheme===R.Schemas.file?(0,T.$PK)(()=>this.e.readdir(m.$$g($.uri))):void 0,v=m.$bh(i.folder,$.uri);if(v){const y=u.includedInQuery(v,w.$nc(v),p);(0,O.$kh)(y)?t.push(y.then(h=>{h&&n($)})):y&&n($)}}},a=this.n(i);let d;return this.d.query.type===3?d=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,a,f,c):d=await this.d.provider.provideTextSearchResults(l(this.d.query.contentPattern),a,f,c),t.length&&await Promise.all(t),d}l(i){if(r(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,T.$NK)(this.g.includePattern,i.includePattern),c=(0,T.$NK)(this.g.excludePattern,i.excludePattern),u={folder:E.URI.from(i.folder),excludes:c,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.e.toCanonicalName(i.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??Number.MAX_SAFE_INTEGER,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(u.usePCRE2=this.g.usePCRE2),u}}e.$knc=S;function l(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class b{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new s(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!m.$5g(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(g(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$lnc=b;function g(o){return r(o)?{preview:{matches:(0,C.$1b)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,C.$1b)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function r(o){return!!o.preview}class s{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$nnc=s}),define(Se[124],Ie([1,0,6,4,3,301,17,61,12,2,306]),function(le,e,C,O,M,N,R,w,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pnc=e.$onc=void 0,e.$qnc=l,e.$onc=(0,M.$yi)("IExtHostSearch");let S=class{constructor(r,s,o){this.n=r,this.o=s,this.q=o,this.c=this.n.getProxy(O.$iM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new N.$jnc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,s){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const o=this.d++;return this.e.set(o,s),this.c.$registerTextSearchProvider(o,this.s(r)),(0,C.$Sc)(()=>{this.g.delete(r),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(r,s){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const o=this.d++;return this.h.set(o,s),this.c.$registerAITextSearchProvider(o,this.s(r)),(0,C.$Sc)(()=>{this.i.delete(r),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(r,s){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const o=this.d++;return this.j.set(o,s),this.c.$registerFileSearchProvider(o,this.s(r)),(0,C.$Sc)(()=>{this.k.delete(r),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(r,s,o,i){const n=l(o),c=this.j.get(r);if(c)return this.l.fileSearch(n,c,u=>{this.c.$handleFileMatch(r,s,u.map(t=>t.resource))},i);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,s,o){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,s,o,i){const n=this.e.get(r);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${r}`);const c=l(o);return this.t(c,n).search(t=>this.c.$handleTextMatch(r,s,t),i)}$provideAITextSearchResults(r,s,o,i){const n=this.h.get(r);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${r}`);const c=l(o);return this.v(c,n).search(t=>this.c.$handleTextMatch(r,s,t),i)}$enableExtensionHostSearch(){}t(r,s){return new T.$knc({query:r,provider:s},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(r,s){return new T.$knc({query:r,provider:s},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$pnc=S,e.$pnc=S=Je([We(0,R.$MO),We(1,w.$gmc),We(2,m.$5j)],S);function l(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(b),extraFileResources:g.extraFileResources&&g.extraFileResources.map(r=>E.URI.revive(r))}}function b(g){return{...g,folder:E.URI.revive(g.folder)}}}),define(Se[307],Ie([1,0,20,14,5,6,16,32,2,158,154,141,95,21,38,12,58,59,213,4,258,286,80,86,263,264,265,243,232,35,266,40,267,123,112,268,245,259,269,270,68,67,246,260,41,272,65,273,46,27,287,247,274,90,275,81,82,249,300,277,219,278,288,279,118,250,280,281,282,17,283,124,83,284,251,285,84,87,121,63,53,116,289,290,261,291,292,88,8,7,252,61,253,64,293,294,111,39,227,79,25,120]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s,o,i,n,c,u,t,f,a,d,$,p,v,y,h,D,k,I,P,V,W,q,A,z,G,ie,de,ye,Ee,ge,ue,Ce,se,Oe,ne,j,x,ve,Fe,ke,we,me,Q,Y,he,ce,Ne,fe,Pe,Ae,Ue,B,L,K,H,ee,re,Te,Be,He,_e,xe,et,tt,it,ot,gt,je,rt,Z,X,$e,Ke,be,st,dt,Ct,Vt,Qt,ii,Xt,Et,Zt,Yt,Ze,si){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7nc=Ht;function Ht(ht){const mt=ht.get(Oe.$3O),xt=ht.get(se.$4lc),Gt=ht.get(ue.$omc),Nt=ht.get(Ee.$Zmc),ft=ht.get(Et.$jmc),Bt=ht.get(tt.$7O),_t=ht.get(D.$mmc),zt=ht.get(dt.$gmc),Qe=ht.get(K.$MO),ui=ht.get(_e.$Hmc),Jt=ht.get(xe.$pmc),jt=ht.get(r.$6j),wt=ht.get(r.$5j),Ut=ht.get($e.$SDb),Mt=ht.get(t.$Zlc),Rt=ht.get(Xt.$6nc),ei=ht.get(re.$Rmc),Wt=ht.get(ie.$ymc),oi=ht.get(we.$Vmc),Ot=ht.get(f.$0lc),qt=ht.get(ve.$Omc);Qe.set(n.$jM.ExtHostFileSystemInfo,xt),Qe.set(n.$jM.ExtHostLogLevelServiceShape,jt),Qe.set(n.$jM.ExtHostWorkspace,ft),Qe.set(n.$jM.ExtHostConfiguration,_t),Qe.set(n.$jM.ExtHostExtensionService,Nt),Qe.set(n.$jM.ExtHostStorage,ui),Qe.set(n.$jM.ExtHostTunnelService,Ut),Qe.set(n.$jM.ExtHostWindow,Rt),Qe.set(n.$jM.ExtHostSecretState,ei),Qe.set(n.$jM.ExtHostTelemetry,Bt),Qe.set(n.$jM.ExtHostEditorTabs,Wt),Qe.set(n.$jM.ExtHostManagedSockets,oi),Qe.set(n.$jM.ExtHostAuthentication,Ot),Qe.set(n.$jM.ExtHostChatProvider,qt);const At=Qe.set(n.$jM.ExtHostDecorations,ht.get(P.$$mc)),St=Qe.set(n.$jM.ExtHostDocumentsAndEditors,ht.get(G.$XO)),$t=Qe.set(n.$jM.ExtHostCommands,ht.get(y.$9O)),Dt=Qe.set(n.$jM.ExtHostTerminalService,ht.get(it.$Kmc)),ai=Qe.set(n.$jM.ExtHostTerminalShellIntegration,ht.get(ot.$Rnc)),kt=Qe.set(n.$jM.ExtHostDebugService,ht.get(I.$5mc)),fi=Qe.set(n.$jM.ExtHostSearch,ht.get(ee.$onc)),ni=Qe.set(n.$jM.ExtHostTask,ht.get(et.$Qnc)),$i=Qe.set(n.$jM.ExtHostOutputService,ht.get(Pe.$Dnc)),li=Qe.set(n.$jM.ExtHostLocalization,ht.get(ke.$Umc)),bi=Qe.set(n.$jM.ExtHostUrls,new Ct.$3nc(Qe)),It=Qe.set(n.$jM.ExtHostDocuments,new z.$7lc(Qe,St)),Ei=Qe.set(n.$jM.ExtHostDocumentContentProviders,new q.$anc(Qe,St,wt)),ri=Qe.set(n.$jM.ExtHostDocumentSaveParticipant,new A.$bnc(wt,It,Qe.getProxy(n.$iM.MainThreadBulkEdits))),pe=Qe.set(n.$jM.ExtHostNotebook,new Q.$rnc(Qe,$t,St,It,Gt,fi)),Re=Qe.set(n.$jM.ExtHostNotebookDocuments,new he.$xnc(pe)),ae=Qe.set(n.$jM.ExtHostNotebookEditors,new ce.$ync(wt,pe)),J=Qe.set(n.$jM.ExtHostNotebookKernels,new Ne.$znc(Qe,mt,pe,$t,wt)),Me=Qe.set(n.$jM.ExtHostNotebookRenderers,new fe.$Bnc(Qe,pe)),Ve=Qe.set(n.$jM.ExtHostNotebookDocumentSaveParticipant,new Y.$wnc(wt,pe,Qe.getProxy(n.$iM.MainThreadBulkEdits))),Xe=Qe.set(n.$jM.ExtHostEditors,new je.$dmc(Qe,St)),qe=Qe.set(n.$jM.ExtHostTreeViews,new X.$1nc(Qe.getProxy(n.$iM.MainThreadTreeViews),$t,wt)),ut=Qe.set(n.$jM.ExtHostEditorInsets,new v.$emc(Qe.getProxy(n.$iM.MainThreadEditorInsets),Xe,mt.remote)),yt=Qe.set(n.$jM.ExtHostDiagnostics,new V.$6lc(Qe,wt,xt,St)),Ft=Qe.set(n.$jM.ExtHostLanguages,new Fe.$unc(Qe,It,$t.converter,zt)),ct=Qe.set(n.$jM.ExtHostLanguageFeatures,new x.$8lc(Qe,zt,It,$t,yt,wt,Mt,Bt)),Tt=Qe.set(n.$jM.ExtHostFileSystem,new ge.$enc(Qe,ct)),Lt=Qe.set(n.$jM.ExtHostFileSystemEventService,new Ce.$fnc(Qe,wt,St)),Di=Qe.set(n.$jM.ExtHostQuickOpen,(0,L.$Hnc)(Qe,ft,$t)),Ii=Qe.set(n.$jM.ExtHostSCM,new H.$Jnc(Qe,$t,It,wt)),Ji=Qe.set(n.$jM.ExtHostQuickDiff,new B.$Gnc(Qe,zt)),Oi=Qe.set(n.$jM.ExtHostShare,new Te.$Knc(Qe,zt)),Ti=Qe.set(n.$jM.ExtHostComments,(0,h.$fmc)(Qe,$t,It)),Ci=Qe.set(n.$jM.ExtHostProgress,new Ue.$Fnc(Qe.getProxy(n.$iM.MainThreadProgress))),Ni=Qe.set(n.$jM.ExtHostLabelService,new j.$tnc(Qe)),Fi=Qe.set(n.$jM.ExtHostTheming,new rt.$Xnc(Qe)),Qi=Qe.set(n.$jM.ExtHostTimeline,new Z.$Znc(Qe,$t)),Li=Qe.set(n.$jM.ExtHostWebviews,new Vt.$tmc(Qe,mt.remote,ft,wt,Mt)),Pi=Qe.set(n.$jM.ExtHostWebviewPanels,new Qt.$wmc(Qe,Li,ft)),zi=Qe.set(n.$jM.ExtHostCustomEditors,new k.$xmc(Qe,It,Jt,Li,Pi)),ji=Qe.set(n.$jM.ExtHostWebviewViews,new ii.$4nc(Qe,Li)),vi=Qe.set(n.$jM.ExtHostTesting,new gt.$Tnc(Qe,wt,$t,St)),Xi=Qe.set(n.$jM.ExtHostUriOpeners,new st.$2nc(Qe)),Zi=Qe.set(n.$jM.ExtHostProfileContentHandlers,new Ae.$Enc(Qe));Qe.set(n.$jM.ExtHostInteractive,new ne.$snc(Qe,pe,St,$t,wt));const Mi=Qe.set(n.$jM.ExtHostChatAgents2,new d.$amc(Qe,wt,$t)),Yi=Qe.set(n.$jM.ExtHostChatVariables,new $.$bmc(Qe)),Ui=Qe.set(n.$jM.ExtHostAiRelatedInformation,new c.$Ylc(Qe)),dn=Qe.set(n.$jM.ExtHostAiEmbeddingVector,new ye.$dnc(Qe)),xi=Qe.set(n.$jM.ExtHostStatusBar,new He.$Nnc(Qe,$t.converter)),Bi=Qe.set(n.$jM.ExtHostSpeech,new Be.$Lnc(Qe)),pi=Qe.set(n.$jM.ExtHostEmbeddings,new de.$cnc(Qe)),fn=Object.values(n.$jM);Qe.assertRegistered(fn);const gn=new a.$_lc(Qe,St),_i=new p.$cmc(Qe),Vi=new me.$vnc(Qe,wt),Ai=new W.$_mc(Qe);return u.$9lc.register($t),function(ze,hi,Wi){function nt(_){return(oe,Le,at)=>{const vt=_(Pt=>{try{oe.call(Le,Pt)}catch(Si){O.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${Si.toString()}`,{cause:Si})),Bt.onExtensionError(ze.identifier,Si)}});return at?.push(vt),vt}}const bt=function(){let _=!ze.isUnderDevelopment;function oe(){_||(wt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Le(at){if(Array.isArray(at))at.forEach(Le);else if(typeof at=="string")oe();else{const vt=at;typeof vt.scheme>"u"&&oe(),typeof vt.exclusive=="boolean"&&(0,Ze.$KG)(ze,"documentFiltersExclusive")}return at}}(),en={getSession(_,oe,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Ze.$KG)(ze,"authLearnMore"),Ot.getSession(ze,_,oe,Le)},getSessions(_,oe){return(0,Ze.$KG)(ze,"authGetSessions"),Ot.getSessions(ze,_,oe)},async hasSession(_,oe){return(0,Ze.$KG)(ze,"authSession"),!!await Ot.getSession(ze,_,oe,{silent:!0})},get onDidChangeSessions(){return nt(Ot.onDidChangeSessions)},registerAuthenticationProvider(_,oe,Le,at){return Ot.registerAuthenticationProvider(_,oe,Le,at)}},gi={registerCommand(_,oe,Le){return $t.registerCommand(!0,_,oe,Le,void 0,ze)},registerTextEditorCommand(_,oe,Le){return $t.registerCommand(!0,_,(...at)=>{const vt=Xe.getActiveTextEditor();if(!vt){wt.warn("Cannot execute "+_+" because there is no active text editor.");return}return vt.edit(Pt=>{oe.apply(Le,[vt,Pt,...at])}).then(Pt=>{Pt||wt.warn("Edits from command "+_+" were not applied.")},Pt=>{wt.warn("An error occurred while running command "+_,Pt)})},void 0,void 0,ze)},registerDiffInformationCommand:(_,oe,Le)=>((0,Ze.$KG)(ze,"diffCommand"),$t.registerCommand(!0,_,async(...at)=>{const vt=St.activeEditor(!0);if(!vt){wt.warn("Cannot execute "+_+" because there is no active text editor.");return}const Pt=await Xe.getDiffInformation(vt.id);oe.apply(Le,[Pt,...at])},void 0,void 0,ze)),executeCommand(_,...oe){return $t.executeCommand(_,...oe)},getCommands(_=!1){return $t.getCommands(_)}},ki={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return _i.value},get shell(){return Dt.getDefaultShell(!1)},get onDidChangeShell(){return nt(Dt.onDidChangeShell)},get isTelemetryEnabled(){return Bt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return nt(Bt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$KG)(ze,"telemetry"),Bt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$KG)(ze,"telemetry"),nt(Bt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,tt.$6O)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,oe){return tt.$5O.validateSender(_),Bt.instantiateLogger(ze,_,oe)},openExternal(_,oe){return Rt.openUri(_,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===mt.environment.appUriScheme)return bi.createAppUri(_);try{return await Rt.asExternalUri(_,{allowTunneling:!!mt.remote.authority})}catch(oe){if((0,R.$Hg)(_,R.Schemas.http)||(0,R.$Hg)(_,R.Schemas.https))return _;throw oe}},get remoteName(){return(0,s.$Km)(mt.remote.authority)},get remoteAuthority(){return(0,Ze.$KG)(ze,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return wt.getLevel()},get onDidChangeLogLevel(){return nt(wt.onDidChangeLogLevel)},get appQuality(){return(0,Ze.$KG)(ze,"resolvers"),mt.quality},get appCommit(){return(0,Ze.$KG)(ze,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(ki);const mn={createTestController(_,oe,Le){return vi.createTestController(ze,_,oe,Le)},createTestObserver(){return(0,Ze.$KG)(ze,"testObserver"),vi.createTestObserver()},runTests(_){return(0,Ze.$KG)(ze,"testObserver"),vi.runTests(_)},get onDidChangeTestResults(){return(0,Ze.$KG)(ze,"testObserver"),nt(vi.onResultsChanged)},get testResults(){return(0,Ze.$KG)(ze,"testObserver"),vi.results}},ti=mt.remote.isRemote?be.ExtensionKind.Workspace:be.ExtensionKind.UI,Ri={getExtension(_,oe){(0,Ze.$JG)(ze,"extensionsAny")||(oe=!1);const Le=hi.mine.getExtensionDescription(_);if(Le)return new Ee.$1mc(Nt,ze.identifier,Le,ti,!1);if(oe){const at=hi.all.getExtensionDescription(_);if(at)return new Ee.$1mc(Nt,ze.identifier,at,ti,!0)}},get all(){const _=[];for(const oe of hi.mine.getAllExtensionDescriptions())_.push(new Ee.$1mc(Nt,ze.identifier,oe,ti,!1));return _},get allAcrossExtensionHosts(){(0,Ze.$KG)(ze,"extensionsAny");const _=new b.$Um(hi.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),oe=[];for(const Le of hi.all.getAllExtensionDescriptions()){const at=!_.has(Le.identifier);oe.push(new Ee.$1mc(Nt,ze.identifier,Le,ti,at))}return oe},get onDidChange(){return(0,Ze.$JG)(ze,"extensionsAny")?nt(M.Event.any(hi.mine.onDidChange,hi.all.onDidChange)):nt(hi.mine.onDidChange)}},tn={createDiagnosticCollection(_){return yt.createDiagnosticCollection(ze.identifier,_)},get onDidChangeDiagnostics(){return nt(yt.onDidChangeDiagnostics)},getDiagnostics:_=>yt.getDiagnostics(_),getLanguages(){return Ft.getLanguages()},setTextDocumentLanguage(_,oe){return Ft.changeLanguage(_.uri,oe)},match(_,oe){const Le=Ke.LanguageSelector.from(_);let at;return(0,T.$2t)(Le)&&(at=pe.notebookDocuments.find(vt=>vt.apiNotebook.getCells().find(Pt=>Pt.document===oe))?.apiNotebook),(0,T.$1t)(Le,oe.uri,oe.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(_,oe,Le){return ct.registerCodeActionProvider(ze,bt(_),oe,Le)},registerDocumentPasteEditProvider(_,oe,Le){return(0,Ze.$KG)(ze,"documentPaste"),ct.registerDocumentPasteEditProvider(ze,bt(_),oe,Le)},registerCodeLensProvider(_,oe){return ct.registerCodeLensProvider(ze,bt(_),oe)},registerDefinitionProvider(_,oe){return ct.registerDefinitionProvider(ze,bt(_),oe)},registerDeclarationProvider(_,oe){return ct.registerDeclarationProvider(ze,bt(_),oe)},registerImplementationProvider(_,oe){return ct.registerImplementationProvider(ze,bt(_),oe)},registerTypeDefinitionProvider(_,oe){return ct.registerTypeDefinitionProvider(ze,bt(_),oe)},registerHoverProvider(_,oe){return ct.registerHoverProvider(ze,bt(_),oe,ze.identifier)},registerEvaluatableExpressionProvider(_,oe){return ct.registerEvaluatableExpressionProvider(ze,bt(_),oe,ze.identifier)},registerInlineValuesProvider(_,oe){return ct.registerInlineValuesProvider(ze,bt(_),oe,ze.identifier)},registerDocumentHighlightProvider(_,oe){return ct.registerDocumentHighlightProvider(ze,bt(_),oe)},registerMultiDocumentHighlightProvider(_,oe){return ct.registerMultiDocumentHighlightProvider(ze,bt(_),oe)},registerLinkedEditingRangeProvider(_,oe){return ct.registerLinkedEditingRangeProvider(ze,bt(_),oe)},registerReferenceProvider(_,oe){return ct.registerReferenceProvider(ze,bt(_),oe)},registerRenameProvider(_,oe){return ct.registerRenameProvider(ze,bt(_),oe)},registerNewSymbolNamesProvider(_,oe){return(0,Ze.$KG)(ze,"newSymbolNamesProvider"),ct.registerNewSymbolNamesProvider(ze,bt(_),oe)},registerDocumentSymbolProvider(_,oe,Le){return ct.registerDocumentSymbolProvider(ze,bt(_),oe,Le)},registerWorkspaceSymbolProvider(_){return ct.registerWorkspaceSymbolProvider(ze,_)},registerDocumentFormattingEditProvider(_,oe){return ct.registerDocumentFormattingEditProvider(ze,bt(_),oe)},registerDocumentRangeFormattingEditProvider(_,oe){return ct.registerDocumentRangeFormattingEditProvider(ze,bt(_),oe)},registerOnTypeFormattingEditProvider(_,oe,Le,...at){return ct.registerOnTypeFormattingEditProvider(ze,bt(_),oe,[Le].concat(at))},registerDocumentSemanticTokensProvider(_,oe,Le){return ct.registerDocumentSemanticTokensProvider(ze,bt(_),oe,Le)},registerDocumentRangeSemanticTokensProvider(_,oe,Le){return ct.registerDocumentRangeSemanticTokensProvider(ze,bt(_),oe,Le)},registerSignatureHelpProvider(_,oe,Le,...at){return typeof Le=="object"?ct.registerSignatureHelpProvider(ze,bt(_),oe,Le):ct.registerSignatureHelpProvider(ze,bt(_),oe,typeof Le>"u"?[]:[Le,...at])},registerCompletionItemProvider(_,oe,...Le){return ct.registerCompletionItemProvider(ze,bt(_),oe,Le)},registerInlineCompletionItemProvider(_,oe,Le){return oe.handleDidShowCompletionItem&&(0,Ze.$KG)(ze,"inlineCompletionsAdditions"),oe.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$KG)(ze,"inlineCompletionsAdditions"),Le&&(0,Ze.$KG)(ze,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(ze,bt(_),oe,Le)},registerInlineEditProvider(_,oe){return(0,Ze.$KG)(ze,"inlineEdit"),ct.registerInlineEditProvider(ze,bt(_),oe)},registerDocumentLinkProvider(_,oe){return ct.registerDocumentLinkProvider(ze,bt(_),oe)},registerColorProvider(_,oe){return ct.registerColorProvider(ze,bt(_),oe)},registerFoldingRangeProvider(_,oe){return ct.registerFoldingRangeProvider(ze,bt(_),oe)},registerSelectionRangeProvider(_,oe){return ct.registerSelectionRangeProvider(ze,_,oe)},registerCallHierarchyProvider(_,oe){return ct.registerCallHierarchyProvider(ze,_,oe)},registerTypeHierarchyProvider(_,oe){return ct.registerTypeHierarchyProvider(ze,_,oe)},setLanguageConfiguration:(_,oe)=>ct.setLanguageConfiguration(ze,_,oe),getTokenInformationAtPosition(_,oe){return(0,Ze.$KG)(ze,"tokenInformation"),Ft.tokenAtPosition(_,oe)},registerInlayHintsProvider(_,oe){return ct.registerInlayHintsProvider(ze,_,oe)},createLanguageStatusItem(_,oe){return Ft.createLanguageStatusItem(ze,_,oe)},registerDocumentDropEditProvider(_,oe,Le){return ct.registerDocumentOnDropEditProvider(ze,_,oe,(0,Ze.$JG)(ze,"documentPaste")?Le:void 0)}},nn={get activeTextEditor(){return Xe.getActiveTextEditor()},get visibleTextEditors(){return Xe.getVisibleTextEditors()},get activeTerminal(){return Dt.activeTerminal},get terminals(){return Dt.terminals},async showTextDocument(_,oe,Le){m.URI.isUri(_)&&_.scheme===R.Schemas.vscodeRemote&&!_.authority&&Mt.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(m.URI.isUri(_)?Promise.resolve(qi.openTextDocument(_)):Promise.resolve(_));return Xe.showTextDocument(at,oe,Le)},createTextEditorDecorationType(_){return Xe.createTextEditorDecorationType(ze,_)},onDidChangeActiveTextEditor(_,oe,Le){return nt(Xe.onDidChangeActiveTextEditor)(_,oe,Le)},onDidChangeVisibleTextEditors(_,oe,Le){return nt(Xe.onDidChangeVisibleTextEditors)(_,oe,Le)},onDidChangeTextEditorSelection(_,oe,Le){return nt(Xe.onDidChangeTextEditorSelection)(_,oe,Le)},onDidChangeTextEditorOptions(_,oe,Le){return nt(Xe.onDidChangeTextEditorOptions)(_,oe,Le)},onDidChangeTextEditorVisibleRanges(_,oe,Le){return nt(Xe.onDidChangeTextEditorVisibleRanges)(_,oe,Le)},onDidChangeTextEditorViewColumn(_,oe,Le){return nt(Xe.onDidChangeTextEditorViewColumn)(_,oe,Le)},onDidCloseTerminal(_,oe,Le){return nt(Dt.onDidCloseTerminal)(_,oe,Le)},onDidOpenTerminal(_,oe,Le){return nt(Dt.onDidOpenTerminal)(_,oe,Le)},onDidChangeActiveTerminal(_,oe,Le){return nt(Dt.onDidChangeActiveTerminal)(_,oe,Le)},onDidChangeTerminalDimensions(_,oe,Le){return(0,Ze.$KG)(ze,"terminalDimensions"),nt(Dt.onDidChangeTerminalDimensions)(_,oe,Le)},onDidChangeTerminalState(_,oe,Le){return nt(Dt.onDidChangeTerminalState)(_,oe,Le)},onDidWriteTerminalData(_,oe,Le){return(0,Ze.$KG)(ze,"terminalDataWriteEvent"),nt(Dt.onDidWriteTerminalData)(_,oe,Le)},onDidExecuteTerminalCommand(_,oe,Le){return(0,Ze.$KG)(ze,"terminalExecuteCommandEvent"),nt(Dt.onDidExecuteTerminalCommand)(_,oe,Le)},onDidChangeTerminalShellIntegration(_,oe,Le){return(0,Ze.$KG)(ze,"terminalShellIntegration"),nt(ai.onDidChangeTerminalShellIntegration)(_,oe,Le)},onDidStartTerminalShellExecution(_,oe,Le){return(0,Ze.$KG)(ze,"terminalShellIntegration"),nt(ai.onDidStartTerminalShellExecution)(_,oe,Le)},onDidEndTerminalShellExecution(_,oe,Le){return(0,Ze.$KG)(ze,"terminalShellIntegration"),nt(ai.onDidEndTerminalShellExecution)(_,oe,Le)},get state(){return Rt.getState()},onDidChangeWindowState(_,oe,Le){return nt(Rt.onDidChangeWindowState)(_,oe,Le)},showInformationMessage(_,...oe){return Vi.showMessage(ze,w.default.Info,_,oe[0],oe.slice(1))},showWarningMessage(_,...oe){return Vi.showMessage(ze,w.default.Warning,_,oe[0],oe.slice(1))},showErrorMessage(_,...oe){return Vi.showMessage(ze,w.default.Error,_,oe[0],oe.slice(1))},showQuickPick(_,oe,Le){return Di.showQuickPick(ze,_,oe,Le)},showWorkspaceFolderPick(_){return Di.showWorkspaceFolderPick(_)},showInputBox(_,oe){return Di.showInput(_,oe)},showOpenDialog(_){return Ai.showOpenDialog(ze,_)},showSaveDialog(_){return Ai.showSaveDialog(_)},createStatusBarItem(_,oe,Le){let at,vt,Pt;return typeof _=="string"?(at=_,vt=oe,Pt=Le):(vt=_,Pt=oe),xi.createStatusBarEntry(ze,at,vt,Pt)},setStatusBarMessage(_,oe){return xi.setStatusBarMessage(_,oe)},withScmProgress(_){return Mt.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Ci.withProgress(ze,{location:be.ProgressLocation.SourceControl},(oe,Le)=>_({report(at){}}))},withProgress(_,oe){return Ci.withProgress(ze,_,oe)},createOutputChannel(_,oe){return $i.createOutputChannel(_,oe,ze)},createWebviewPanel(_,oe,Le,at){return Pi.createWebviewPanel(ze,_,oe,Le,at)},createWebviewTextEditorInset(_,oe,Le,at){return(0,Ze.$KG)(ze,"editorInsets"),ut.createWebviewEditorInset(_,oe,Le,at,ze)},createTerminal(_,oe,Le){return typeof _=="object"?"pty"in _?Dt.createExtensionTerminal(_):Dt.createTerminalFromOptions(_):Dt.createTerminal(_,oe,Le)},registerTerminalLinkProvider(_){return Dt.registerLinkProvider(_)},registerTerminalProfileProvider(_,oe){return Dt.registerProfileProvider(ze,_,oe)},registerTerminalQuickFixProvider(_,oe){return(0,Ze.$KG)(ze,"terminalQuickFixProvider"),Dt.registerTerminalQuickFixProvider(_,ze.identifier.value,oe)},registerTreeDataProvider(_,oe){return qe.registerTreeDataProvider(_,oe,ze)},createTreeView(_,oe){return qe.createTreeView(_,oe,ze)},registerWebviewPanelSerializer:(_,oe)=>Pi.registerWebviewPanelSerializer(ze,_,oe),registerCustomEditorProvider:(_,oe,Le={})=>zi.registerCustomEditorProvider(ze,_,oe,Le),registerFileDecorationProvider(_){return At.registerFileDecorationProvider(_,ze)},registerUriHandler(_){return bi.registerUriHandler(ze,_)},createQuickPick(){return Di.createQuickPick(ze)},createInputBox(){return Di.createInputBox(ze)},get activeColorTheme(){return Fi.activeColorTheme},onDidChangeActiveColorTheme(_,oe,Le){return nt(Fi.onDidChangeActiveColorTheme)(_,oe,Le)},registerWebviewViewProvider(_,oe,Le){return ji.registerWebviewViewProvider(ze,_,oe,Le?.webviewOptions)},get activeNotebookEditor(){return pe.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,oe,Le){return nt(pe.onDidChangeActiveNotebookEditor)(_,oe,Le)},get visibleNotebookEditors(){return pe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return nt(pe.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,oe,Le){return nt(ae.onDidChangeNotebookEditorSelection)(_,oe,Le)},onDidChangeNotebookEditorVisibleRanges(_,oe,Le){return nt(ae.onDidChangeNotebookEditorVisibleRanges)(_,oe,Le)},showNotebookDocument(_,oe){return pe.showNotebookDocument(_,oe)},registerExternalUriOpener(_,oe,Le){return(0,Ze.$KG)(ze,"externalUriOpener"),Xi.registerExternalUriOpener(ze.identifier,_,oe,Le)},registerProfileContentHandler(_,oe){return(0,Ze.$KG)(ze,"profileContentHandlers"),Zi.registerProfileContentHandler(ze,_,oe)},registerQuickDiffProvider(_,oe,Le,at){return(0,Ze.$KG)(ze,"quickDiffProvider"),Ji.registerQuickDiffProvider(bt(_),oe,Le,at)},get tabGroups(){return Wt.tabGroups},registerShareProvider(_,oe){return(0,Ze.$KG)(ze,"shareProvider"),Oi.registerShareProvider(bt(_),oe)}},qi={get rootPath(){return Mt.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(_){throw new O.$9("rootPath")},getWorkspaceFolder(_){return ft.getWorkspaceFolder(_)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(_){throw new O.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(_){throw new O.$9("workspaceFile")},updateWorkspaceFolders:(_,oe,...Le)=>ft.updateWorkspaceFolders(ze,_,oe||0,...Le),onDidChangeWorkspaceFolders:function(_,oe,Le){return nt(ft.onDidChangeWorkspace)(_,oe,Le)},asRelativePath:(_,oe)=>ft.getRelativePath(_,oe),findFiles:(_,oe,Le,at)=>ft.findFiles(_,oe,Le,ze.identifier,at),findFiles2:(_,oe,Le)=>((0,Ze.$KG)(ze,"findFiles2"),ft.findFiles2(_,oe,ze.identifier,Le)),findTextInFiles:(_,oe,Le,at)=>{(0,Ze.$KG)(ze,"findTextInFiles");let vt,Pt;return typeof oe=="object"?(vt=oe,Pt=Le):(vt={},Pt=oe,at=Le),ft.findTextInFiles(_,vt||{},Pt,ze.identifier,at)},save:_=>ft.save(_),saveAs:_=>ft.saveAs(_),saveAll:_=>ft.saveAll(_),applyEdit(_,oe){return gn.applyWorkspaceEdit(_,ze,oe)},createFileSystemWatcher:(_,oe,Le,at)=>{let vt;return typeof oe=="boolean"?vt={ignoreCreateEvents:!!oe,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!at,correlate:!1}:oe&&((0,Ze.$KG)(ze,"createFileSystemWatcher"),vt={...oe,correlate:!0}),Lt.createFileSystemWatcher(ft,ze,_,vt)},get textDocuments(){return It.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new O.$9("textDocuments")},openTextDocument(_){let oe;const Le=_;if(typeof _=="string")oe=Promise.resolve(m.URI.file(_));else if(m.URI.isUri(_))oe=Promise.resolve(_);else if(!Le||typeof Le=="object")oe=It.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(at=>(at.scheme===R.Schemas.vscodeRemote&&!at.authority&&Mt.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),It.ensureDocumentData(at).then(vt=>vt.document)))},onDidOpenTextDocument:(_,oe,Le)=>nt(It.onDidAddDocument)(_,oe,Le),onDidCloseTextDocument:(_,oe,Le)=>nt(It.onDidRemoveDocument)(_,oe,Le),onDidChangeTextDocument:(_,oe,Le)=>nt(It.onDidChangeDocument)(_,oe,Le),onDidSaveTextDocument:(_,oe,Le)=>nt(It.onDidSaveDocument)(_,oe,Le),onWillSaveTextDocument:(_,oe,Le)=>nt(ri.getOnWillSaveTextDocumentEvent(ze))(_,oe,Le),get notebookDocuments(){return pe.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,oe){let Le;if(m.URI.isUri(_))Le=_,await pe.openNotebookDocument(_);else if(typeof _=="string")Le=m.URI.revive(await pe.createNotebookDocument({viewType:_,content:oe}));else throw new Error("Invalid arguments");return pe.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(_,oe,Le){return nt(Re.onDidSaveNotebookDocument)(_,oe,Le)},onDidChangeNotebookDocument(_,oe,Le){return nt(Re.onDidChangeNotebookDocument)(_,oe,Le)},onWillSaveNotebookDocument(_,oe,Le){return nt(Ve.getOnWillSaveNotebookDocumentEvent(ze))(_,oe,Le)},get onDidOpenNotebookDocument(){return nt(pe.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return nt(pe.onDidCloseNotebookDocument)},registerNotebookSerializer(_,oe,Le,at){return pe.registerNotebookSerializer(ze,_,oe,Le,(0,Ze.$JG)(ze,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(_,oe,Le)=>nt(Wi.onDidChangeConfiguration)(_,oe,Le),getConfiguration(_,oe){return oe=arguments.length===1?void 0:oe,Wi.getConfiguration(_,oe,ze)},registerTextDocumentContentProvider(_,oe){return Ei.registerTextDocumentContentProvider(_,oe)},registerTaskProvider:(_,oe)=>(Mt.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),ni.registerTaskProvider(ze,_,oe)),registerFileSystemProvider(_,oe,Le){return(0,N.$Rc)(Tt.registerFileSystemProvider(ze,_,oe,Le),Gt.addFileSystemProvider(_,oe,Le))},get fs(){return Gt.value},registerFileSearchProvider:(_,oe)=>((0,Ze.$KG)(ze,"fileSearchProvider"),fi.registerFileSearchProvider(_,oe)),registerTextSearchProvider:(_,oe)=>((0,Ze.$KG)(ze,"textSearchProvider"),fi.registerTextSearchProvider(_,oe)),registerAITextSearchProvider:(_,oe)=>((0,Ze.$KG)(ze,"aiTextSearchProvider"),(0,Ze.$KG)(ze,"textSearchProvider"),fi.registerAITextSearchProvider(_,oe)),registerRemoteAuthorityResolver:(_,oe)=>((0,Ze.$KG)(ze,"resolvers"),Nt.registerRemoteAuthorityResolver(_,oe)),registerResourceLabelFormatter:_=>((0,Ze.$KG)(ze,"resolvers"),Ni.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Ze.$KG)(ze,"resolvers"),Nt.getRemoteExecServer(_)),onDidCreateFiles:(_,oe,Le)=>nt(Lt.onDidCreateFile)(_,oe,Le),onDidDeleteFiles:(_,oe,Le)=>nt(Lt.onDidDeleteFile)(_,oe,Le),onDidRenameFiles:(_,oe,Le)=>nt(Lt.onDidRenameFile)(_,oe,Le),onWillCreateFiles:(_,oe,Le)=>nt(Lt.getOnWillCreateFileEvent(ze))(_,oe,Le),onWillDeleteFiles:(_,oe,Le)=>nt(Lt.getOnWillDeleteFileEvent(ze))(_,oe,Le),onWillRenameFiles:(_,oe,Le)=>nt(Lt.getOnWillRenameFileEvent(ze))(_,oe,Le),openTunnel:_=>((0,Ze.$KG)(ze,"tunnels"),Ut.openTunnel(ze,_).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,Ze.$KG)(ze,"tunnels"),Ut.getTunnels()},onDidChangeTunnels:(_,oe,Le)=>((0,Ze.$KG)(ze,"tunnels"),nt(Ut.onDidChangeTunnels)(_,oe,Le)),registerPortAttributesProvider:(_,oe)=>((0,Ze.$KG)(ze,"portsAttributes"),Ut.registerPortsAttributesProvider(_,oe)),registerTunnelProvider:(_,oe)=>((0,Ze.$KG)(ze,"tunnelFactory"),Ut.registerTunnelProvider(_,oe)),registerTimelineProvider:(_,oe)=>((0,Ze.$KG)(ze,"timeline"),Qi.registerTimelineProvider(_,oe,ze.identifier,$t.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:_=>((0,Ze.$KG)(ze,"workspaceTrust"),ft.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,oe,Le)=>nt(ft.onDidGrantWorkspaceTrust)(_,oe,Le),registerEditSessionIdentityProvider:(_,oe)=>((0,Ze.$KG)(ze,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(_,oe)),onWillCreateEditSessionIdentity:(_,oe,Le)=>((0,Ze.$KG)(ze,"editSessionIdentityProvider"),nt(ft.getOnWillCreateEditSessionIdentityEvent(ze))(_,oe,Le)),registerCanonicalUriProvider:(_,oe)=>((0,Ze.$KG)(ze,"canonicalUriProvider"),ft.registerCanonicalUriProvider(_,oe)),getCanonicalUri:(_,oe,Le)=>((0,Ze.$KG)(ze,"canonicalUriProvider"),ft.provideCanonicalUri(_,oe,Le))},rn={get inputBox(){return Mt.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),Ii.getLastInputBox(ze)},createSourceControl(_,oe,Le){return Ii.createSourceControl(ze,_,oe,Le)}},$n={createCommentController(_,oe){return Ti.createCommentController(ze,_,oe)}},sn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){return kt.activeStackItem},registerDebugVisualizationProvider(_,oe){return(0,Ze.$KG)(ze,"debugVisualization"),kt.registerDebugVisualizationProvider(ze,_,oe)},registerDebugVisualizationTreeProvider(_,oe){return(0,Ze.$KG)(ze,"debugVisualization"),kt.registerDebugVisualizationTree(ze,_,oe)},onDidStartDebugSession(_,oe,Le){return nt(kt.onDidStartDebugSession)(_,oe,Le)},onDidTerminateDebugSession(_,oe,Le){return nt(kt.onDidTerminateDebugSession)(_,oe,Le)},onDidChangeActiveDebugSession(_,oe,Le){return nt(kt.onDidChangeActiveDebugSession)(_,oe,Le)},onDidReceiveDebugSessionCustomEvent(_,oe,Le){return nt(kt.onDidReceiveDebugSessionCustomEvent)(_,oe,Le)},onDidChangeBreakpoints(_,oe,Le){return nt(kt.onDidChangeBreakpoints)(_,oe,Le)},onDidChangeActiveStackItem(_,oe,Le){return nt(kt.onDidChangeActiveStackItem)(_,oe,Le)},registerDebugConfigurationProvider(_,oe,Le){return kt.registerDebugConfigurationProvider(_,oe,Le||Zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,oe){return kt.registerDebugAdapterDescriptorFactory(ze,_,oe)},registerDebugAdapterTrackerFactory(_,oe){return kt.registerDebugAdapterTrackerFactory(_,oe)},startDebugging(_,oe,Le){return!Le||typeof Le=="object"&&"configuration"in Le?kt.startDebugging(_,oe,{parentSession:Le}):kt.startDebugging(_,oe,Le||{})},stopDebugging(_){return kt.stopDebugging(_)},addBreakpoints(_){return kt.addBreakpoints(_)},removeBreakpoints(_){return kt.removeBreakpoints(_)},asDebugSourceUri(_,oe){return kt.asDebugSourceUri(_,oe)}},on={registerTaskProvider:(_,oe)=>ni.registerTaskProvider(ze,_,oe),fetchTasks:_=>ni.fetchTasks(_),executeTask:_=>ni.executeTask(ze,_),get taskExecutions(){return ni.taskExecutions},onDidStartTask:(_,oe,Le)=>nt(ni.onDidStartTask)(_,oe,Le),onDidEndTask:(_,oe,Le)=>nt(ni.onDidEndTask)(_,oe,Le),onDidStartTaskProcess:(_,oe,Le)=>nt(ni.onDidStartTaskProcess)(_,oe,Le),onDidEndTaskProcess:(_,oe,Le)=>nt(ni.onDidEndTaskProcess)(_,oe,Le)},pn={createNotebookController(_,oe,Le,at,vt){return J.createNotebookController(ze,_,oe,Le,at,(0,Ze.$JG)(ze,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(_,oe)=>pe.registerNotebookCellStatusBarItemProvider(ze,_,oe),createRendererMessaging(_){return Me.createRendererMessaging(ze,_)},createNotebookControllerDetectionTask(_){return(0,Ze.$KG)(ze,"notebookKernelSource"),J.createNotebookControllerDetectionTask(ze,_)},registerKernelSourceActionProvider(_,oe){return(0,Ze.$KG)(ze,"notebookKernelSource"),J.registerKernelSourceActionProvider(ze,_,oe)},onDidChangeNotebookCellExecutionState(_,oe,Le){return(0,Ze.$KG)(ze,"notebookCellExecutionState"),nt(J.onDidChangeNotebookCellExecutionState)(_,oe,Le)}},wn={t(..._){if(typeof _[0]=="string"){const oe=_.shift(),Le=!_||typeof _[0]!="object"?_:_[0];return li.getMessage(ze.identifier.value,{message:oe,args:Le})}return li.getMessage(ze.identifier.value,_[0])},get bundle(){return li.getBundle(ze.identifier.value)},get uri(){return li.getBundleUri(ze.identifier.value)}},an={_version:1,transferActiveChat(_){return(0,Ze.$KG)(ze,"interactive"),Mi.transferActiveChat(_)}},Ki={getRelatedInformation(_,oe){return(0,Ze.$KG)(ze,"aiRelatedInformation"),Ui.getRelatedInformation(ze,_,oe)},registerRelatedInformationProvider(_,oe){return(0,Ze.$KG)(ze,"aiRelatedInformation"),Ui.registerRelatedInformationProvider(ze,_,oe)},registerEmbeddingVectorProvider(_,oe){return(0,Ze.$KG)(ze,"aiRelatedInformation"),dn.registerEmbeddingVectorProvider(ze,_,oe)}},cn={registerChatResponseProvider(_,oe,Le){return(0,Ze.$KG)(ze,"chatProvider"),qt.registerLanguageModel(ze,_,oe,Le)},registerChatVariableResolver(_,oe,Le){return(0,Ze.$KG)(ze,"chatVariableResolver"),Yi.registerVariableResolver(ze,_,oe,Le)},registerMappedEditsProvider(_,oe){return(0,Ze.$KG)(ze,"mappedEditsProvider"),ct.registerMappedEditsProvider(ze,_,oe)},createChatParticipant(_,oe){return(0,Ze.$KG)(ze,"chatParticipant"),Mi.createChatAgent(ze,_,oe)},createDynamicChatParticipant(_,oe,Le){return(0,Ze.$KG)(ze,"chatParticipantAdditions"),Mi.createDynamicChatAgent(ze,_,oe,Le)}},un={selectChatModels:_=>((0,Ze.$KG)(ze,"languageModels"),qt.selectLanguageModels(ze,_??{})),onDidChangeChatModels:(_,oe,Le)=>((0,Ze.$KG)(ze,"languageModels"),qt.onDidChangeProviders(_,oe,Le)),get embeddingModels(){return(0,Ze.$KG)(ze,"embeddings"),pi.embeddingsModels},onDidChangeEmbeddingModels:(_,oe,Le)=>((0,Ze.$KG)(ze,"embeddings"),pi.onDidChange(_,oe,Le)),registerEmbeddingsProvider(_,oe){return(0,Ze.$KG)(ze,"embeddings"),pi.registerEmbeddingsProvider(ze,_,oe)},async computeEmbeddings(_,oe,Le){return(0,Ze.$KG)(ze,"embeddings"),pi.computeEmbeddings(_,oe,Le)}},ln={registerSpeechProvider(_,oe){return(0,Ze.$KG)(ze,"speech"),Bi.registerProvider(ze.identifier,_,oe)}};return{version:mt.version,ai:Ki,authentication:en,commands:gi,comments:$n,chat:cn,debug:sn,env:ki,extensions:Ri,interactive:an,l10n:wn,languages:tn,lm:un,notebooks:pn,scm:rn,speech:ln,tasks:on,tests:mn,window:nn,workspace:qi,Breakpoint:be.$lN,TerminalOutputAnchor:be.TerminalOutputAnchor,ChatResultFeedbackKind:be.ChatResultFeedbackKind,ChatVariableLevel:be.ChatVariableLevel,ChatCompletionItem:be.$gO,CallHierarchyIncomingCall:be.$JM,CallHierarchyItem:be.$IM,CallHierarchyOutgoingCall:be.$KM,CancellationError:O.$5,CancellationTokenSource:C.$qe,CandidatePortSource:n.CandidatePortSource,CodeAction:be.$FM,CodeActionKind:be.$GM,CodeActionTriggerKind:be.CodeActionTriggerKind,CodeLens:be.$LM,Color:be.$YM,ColorInformation:be.$ZM,ColorPresentation:be.$1M,ColorThemeKind:be.ColorThemeKind,CommentMode:be.CommentMode,CommentState:be.CommentState,CommentThreadCollapsibleState:be.CommentThreadCollapsibleState,CommentThreadState:be.CommentThreadState,CommentThreadApplicability:be.CommentThreadApplicability,CompletionItem:be.$SM,CompletionItemKind:be.CompletionItemKind,CompletionItemTag:be.CompletionItemTag,CompletionList:be.$TM,CompletionTriggerKind:be.CompletionTriggerKind,ConfigurationTarget:be.ConfigurationTarget,CustomExecution:be.$9M,DebugAdapterExecutable:be.$pN,DebugAdapterInlineImplementation:be.$sN,DebugAdapterNamedPipeServer:be.$rN,DebugAdapterServer:be.$qN,DebugConfigurationProviderTriggerKind:Zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:be.DebugConsoleMode,DebugVisualization:be.$IN,DecorationRangeBehavior:be.DecorationRangeBehavior,Diagnostic:be.$yM,DiagnosticRelatedInformation:be.$xM,DiagnosticSeverity:be.DiagnosticSeverity,DiagnosticTag:be.DiagnosticTag,Disposable:be.$kM,DocumentHighlight:be.$BM,DocumentHighlightKind:be.DocumentHighlightKind,MultiDocumentHighlight:be.$CM,DocumentLink:be.$XM,DocumentSymbol:be.$EM,EndOfLine:be.EndOfLine,EnvironmentVariableMutatorType:be.EnvironmentVariableMutatorType,EvaluatableExpression:be.$vN,InlineValueText:be.$wN,InlineValueVariableLookup:be.$xN,InlineValueEvaluatableExpression:be.$yN,InlineCompletionTriggerKind:be.InlineCompletionTriggerKind,EventEmitter:M.$fe,ExtensionKind:be.ExtensionKind,ExtensionMode:be.ExtensionMode,ExternalUriOpenerPriority:be.ExternalUriOpenerPriority,FileChangeType:be.FileChangeType,FileDecoration:be.$KN,FileDecoration2:be.$KN,FileSystemError:be.$BN,FileType:g.FileType,FilePermission:g.FilePermission,FoldingRange:be.$CN,FoldingRangeKind:be.FoldingRangeKind,FunctionBreakpoint:be.$nN,InlineCompletionItem:be.$UM,InlineCompletionList:be.$VM,Hover:be.$zM,VerboseHover:be.$AM,HoverVerbosityAction:be.HoverVerbosityAction,IndentAction:S.IndentAction,Location:be.$wM,MarkdownString:be.$MM,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:be.$NM,PortAutoForwardAction:be.PortAutoForwardAction,Position:be.$lM,ProcessExecution:be.$7M,ProgressLocation:be.ProgressLocation,QuickInputButtons:be.$JN,Range:be.$mM,RelativePattern:be.$jN,Selection:be.$nM,SelectionRange:be.$HM,SemanticTokens:be.$FN,SemanticTokensBuilder:be.$EN,SemanticTokensEdit:be.$GN,SemanticTokensEdits:be.$HN,SemanticTokensLegend:be.$DN,ShellExecution:be.$8M,ShellQuoting:be.ShellQuoting,SignatureHelp:be.$PM,SignatureHelpTriggerKind:be.SignatureHelpTriggerKind,SignatureInformation:be.$OM,SnippetString:be.$vM,SourceBreakpoint:be.$mN,StandardTokenType:be.StandardTokenType,StatusBarAlignment:be.StatusBarAlignment,SymbolInformation:be.$DM,SymbolKind:be.SymbolKind,SymbolTag:be.SymbolTag,Task:be.$0M,TaskGroup:be.$6M,TaskPanelKind:be.TaskPanelKind,TaskRevealKind:be.TaskRevealKind,TaskScope:be.TaskScope,TerminalLink:be.$2M,TerminalQuickFixTerminalCommand:be.$4M,TerminalQuickFixOpener:be.$3M,TerminalLocation:be.TerminalLocation,TerminalProfile:be.$5M,TerminalExitReason:be.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:be.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:be.TextDocumentSaveReason,TextEdit:be.$rM,SnippetTextEdit:be.$tM,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:be.TextEditorLineNumbersStyle,TextEditorRevealType:be.TextEditorRevealType,TextEditorSelectionChangeKind:be.TextEditorSelectionChangeKind,SyntaxTokenType:be.SyntaxTokenType,TextDocumentChangeReason:be.TextDocumentChangeReason,ThemeColor:be.$iN,ThemeIcon:be.$hN,TreeItem:be.$$M,TreeItemCheckboxState:be.TreeItemCheckboxState,TreeItemCollapsibleState:be.TreeItemCollapsibleState,TypeHierarchyItem:be.$7N,UIKind:Yt.UIKind,Uri:m.URI,ViewColumn:be.ViewColumn,WorkspaceEdit:be.$uM,DocumentPasteTriggerKind:be.DocumentPasteTriggerKind,DocumentDropEdit:be.$eN,DocumentDropOrPasteEditKind:be.$fN,DocumentPasteEdit:be.$gN,InlayHint:be.$RM,InlayHintLabelPart:be.$QM,InlayHintKind:be.InlayHintKind,RemoteAuthorityResolverError:be.$qM,ResolvedAuthority:be.$oM,ManagedResolvedAuthority:be.$pM,SourceControlInputBoxValidationType:be.SourceControlInputBoxValidationType,ExtensionRuntime:be.ExtensionRuntime,TimelineItem:be.$UN,NotebookRange:be.$MN,NotebookCellKind:be.NotebookCellKind,NotebookCellExecutionState:be.NotebookCellExecutionState,NotebookCellData:be.$NN,NotebookData:be.$ON,NotebookRendererScript:be.$SN,NotebookCellStatusBarAlignment:be.NotebookCellStatusBarAlignment,NotebookEditorRevealType:be.NotebookEditorRevealType,NotebookCellOutput:be.$QN,NotebookCellOutputItem:be.$PN,NotebookCellStatusBarItem:be.$RN,NotebookControllerAffinity:be.NotebookControllerAffinity,NotebookControllerAffinity2:be.NotebookControllerAffinity2,NotebookEdit:be.$sM,NotebookKernelSourceAction:be.$TN,NotebookVariablesRequestKind:be.NotebookVariablesRequestKind,PortAttributes:be.$WN,LinkedEditingRanges:be.$VN,TestResultState:be.TestResultState,TestRunRequest:be.$XN,TestMessage:be.$YN,TestTag:be.$ZN,TestRunProfileKind:be.TestRunProfileKind,TextSearchCompleteMessageType:si.TextSearchCompleteMessageType,DataTransfer:be.$dN,DataTransferItem:be.$_M,TestCoverageCount:be.$1N,FileCoverage:be.$3N,FileCoverage2:be.$3N,StatementCoverage:be.$4N,BranchCoverage:be.$5N,DeclarationCoverage:be.$6N,WorkspaceTrustState:be.WorkspaceTrustState,LanguageStatusSeverity:be.LanguageStatusSeverity,QuickPickItemKind:be.QuickPickItemKind,InputBoxValidationSeverity:be.InputBoxValidationSeverity,TabInputText:be.$8N,TabInputTextDiff:be.$9N,TabInputTextMerge:be.$0N,TabInputCustom:be.$$N,TabInputNotebook:be.$aO,TabInputNotebookDiff:be.$bO,TabInputWebview:be.$_N,TabInputTerminal:be.$cO,TabInputInteractiveWindow:be.$dO,TabInputChat:be.$eO,TabInputTextMultiDiff:be.$fO,TelemetryTrustedValue:o.$ip,LogLevel:r.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:be.InteractiveSessionVoteDirection,ChatCopyKind:be.ChatCopyKind,InteractiveEditorResponseFeedbackKind:be.InteractiveEditorResponseFeedbackKind,DebugStackFrame:be.$tN,DebugThread:be.$uN,RelatedInformationType:be.RelatedInformationType,SpeechToTextStatus:be.SpeechToTextStatus,TextToSpeechStatus:be.TextToSpeechStatus,PartialAcceptTriggerKind:be.PartialAcceptTriggerKind,KeywordRecognitionStatus:be.KeywordRecognitionStatus,ChatResponseMarkdownPart:be.$hO,ChatResponseFileTreePart:be.$lO,ChatResponseAnchorPart:be.$mO,ChatResponseProgressPart:be.$nO,ChatResponseProgressPart2:be.$oO,ChatResponseReferencePart:be.$rO,ChatResponseWarningPart:be.$pO,ChatResponseTextEditPart:be.$sO,ChatResponseMarkdownWithVulnerabilitiesPart:be.$iO,ChatResponseCommandButtonPart:be.$qO,ChatResponseDetectedParticipantPart:be.$jO,ChatResponseConfirmationPart:be.$kO,ChatRequestTurn:be.$tO,ChatResponseTurn:be.$uO,ChatLocation:be.ChatLocation,LanguageModelChatMessageRole:be.LanguageModelChatMessageRole,LanguageModelChatMessage:be.$vO,LanguageModelChatMessage2:be.$vO,LanguageModelChatSystemMessage:be.$wO,LanguageModelChatUserMessage:be.$xO,LanguageModelChatAssistantMessage:be.$yO,LanguageModelError:be.$zO,NewSymbolName:be.$AN,NewSymbolNameTag:be.NewSymbolNameTag,NewSymbolNameTriggerKind:be.NewSymbolNameTriggerKind,InlineEdit:be.$AO,InlineEditTriggerKind:be.InlineEditTriggerKind}}}}),define(Se[308],Ie([1,0,56,118,39,112,40,35,68,53,121,123,124,84,88,80,111,65,46,83,63,67,248,12,122,81,82,86,90,116]),function(le,e,C,O,M,N,R,w,m,E,T,S,l,b,g,r,s,o,i,n,c,u,t,f,a,d,$,p,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$As)(d.$Umc,d.$Tmc,1),(0,C.$As)(f.$6j,t.$8nc,1),(0,C.$As)(r.$Zlc,r.$1lc,1),(0,C.$As)(w.$9O,w.$8O,0),(0,C.$As)(p.$0lc,p.$$lc,0),(0,C.$As)(v.$Omc,v.$Pmc,0),(0,C.$As)(R.$mmc,R.$kmc,0),(0,C.$As)(o.$omc,o.$nmc,0),(0,C.$As)(S.$5mc,S.$9mc,0),(0,C.$As)(N.$$mc,N.$0mc,0),(0,C.$As)(m.$XO,m.$WO,0),(0,C.$As)($.$Vmc,$.$Wmc,0),(0,C.$As)(i.$4lc,i.$3lc,0),(0,C.$As)(O.$Dnc,O.$Cnc,1),(0,C.$As)(l.$onc,l.$pnc,0),(0,C.$As)(b.$Hmc,b.$Gmc,0),(0,C.$As)(T.$Qnc,T.$Pnc,0),(0,C.$As)(E.$Kmc,E.$Nmc,0),(0,C.$As)(y.$Rnc,y.$Snc,0),(0,C.$As)(g.$SDb,g.$TDb,0),(0,C.$As)(s.$6nc,s.$5nc,0),(0,C.$As)(M.$jmc,M.$imc,0),(0,C.$As)(n.$Rmc,n.$Qmc,0),(0,C.$As)(c.$7O,c.$4O,0),(0,C.$As)(u.$ymc,u.$zmc,0),(0,C.$As)(a.$3mc,a.$4mc,0)}),define(Se[309],Ie([1,0,307,41,2,304,7,11,254]),function(le,e,C,O,M,N,R,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fqc=void 0;class E extends N.$$nc{j(){}getModule(b,g){for(const r of this.b){const s=r(b);if(s){b=s;break}}if(this.a.has(b))return this.a.get(b).load(b,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class T extends O.$Ymc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(m.$eqc);const b=this.h.invokeFunction(C.$7nc);this.r=this.h.createInstance(E,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(b){return b.browser}async xb(b,g,r){g=g.with({path:S(g.path,".js")});const s=b?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const o=M.URI.revive(await this.C.$asBrowserUri(g)),i=await fetch(o.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),i.status!==200)throw new Error(i.statusText);const n=await i.text(),c=`${g.toString(!0)}#vscode-extension`,u=`${n}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",u)}catch($){throw console.error(s?`Loading code for extension ${s} failed: ${$.message}`:`Loading code failed: ${$.message}`),console.error(`${g.toString(!0)}${typeof $.line=="number"?` line ${$.line}`:""}${typeof $.column=="number"?` column ${$.column}`:""}`),console.error($),$}b&&await this.w.initializeLocalizedMessages(b);const f={},a={exports:f},d=$=>{const p=this.r.getModule($,g);if(p===void 0)throw new Error(`Cannot load module '${$}'`);return p};try{return r.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),t(a,f,d),a.exports!==f?a.exports:f}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),r.codeLoadingStop()}}async $setRemoteEnvironment(b){}async Bb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+b;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,w.$zh)(10)}}e.$fqc=T;function S(l,b){return l.endsWith(b)?l:l+b}}),define(Se[310],Ie([1,0,71,56,12,41,217,87,309]),function(le,e,C,O,M,N,R,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,O.$As)(M.$5j,new C.$vi(R.$0nc,[!0],!0)),(0,O.$As)(N.$Zmc,m.$fqc,0),(0,O.$As)(w.$pmc,w.$qmc,0)}),define(Se[316],Ie([1,0,22,5,79,305,256,19,60,16,2,308,310]),function(le,e,C,O,M,N,R,w,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=u;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(t){return/^(file|vscode-remote):/i.test(t)}const g=fetch.bind(self);function r(t){self.fetch=async function(f,a){return f instanceof Request||b(String(f))&&(f=(await t(T.URI.parse(String(f)))).toString(!0)),g(f,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(f,a,d,$,p){(async()=>(b(a.toString())&&(a=(await t(T.URI.parse(a.toString()))).toString(!0)),super.open(f,a,d??!0,$,p)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(f,a){if(/^file:/i.test(f.toString()))f=E.$Sg.uriToBrowserUri(T.URI.parse(f.toString())).toString(!0);else if(/^vscode-remote:/i.test(f.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const $=`(${function(h){function D(P){return typeof P=="string"||P instanceof URL?String(P).replace(/^file:\/\//i,"vscode-file://vscode-app"):P}const k=fetch.bind(self);self.fetch=function(P,V){return P instanceof Request?k(P,V):k(D(P),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(P,V,W,q,A){return super.open(P,D(V),W??!0,q,A)}};const I=importScripts.bind(self);self.importScripts=(...P)=>{I(...P.map(D))},I(h)}.toString()}('${f}'))`;a=a||{},a.name=`${name} -> ${a.name||w.$nc(f.toString())}`;const p=new Blob([$],{type:"application/javascript"}),v=URL.createObjectURL(p);return new t(v,a)}}else self.Worker=class extends R.$gqc{constructor(t,f){super(l,t,{name:w.$nc(t.toString()),...f})}};const s=new class{constructor(){this.pid=void 0}exit(t){S()}};class o{constructor(){const f=new MessageChannel,a=new O.$fe;let d=!1;l(f.port2,[f.port2]),f.port1.onmessage=$=>{const{data:p}=$;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const v=C.$He.wrap(new Uint8Array(p,0,p.byteLength));if((0,M.$3m)(v,2)){d=!0,n("received terminate message from renderer");return}a.fire(v)},this.protocol={onMessage:a.event,send:$=>{if(!d){const p=$.buffer.buffer.slice($.buffer.byteOffset,$.buffer.byteOffset+$.buffer.byteLength);f.port1.postMessage(p,[p])}}}}}function i(t){return new Promise(f=>{const a=t.onMessage(d=>{a.dispose();const $=JSON.parse(d.toString());t.send((0,M.$2m)(0)),f({protocol:t,initData:$})});t.send((0,M.$2m)(1))})}let n=t=>S();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function u(){m.mark("code/extHost/willConnectToRenderer");const t=new o;return{onmessage(f){c(f)&&i(t.protocol).then(a=>{m.mark("code/extHost/didWaitForInitData");const d=new N.$aoc(a.protocol,a.initData,s,null,f.data);r($=>d.asBrowserUri($)),n=$=>d.terminate($)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6313b2d7eda4c378748d73274af802a26b8e38ba/core/vs/workbench/api/worker/extensionHostWorker.js.map
